/* A Bison parser, made by GNU Bison 2.4.2.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2006, 2009-2010 Free Software
   Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#include <stdlib.h>

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 16 "hlaparse.bsn"
				 

#define YYERROR_VERBOSE 1
#define YYDEBUG 0
#define YYINITDEPTH 16384
#define YYMAXDEPTH 65536
#define _STDLIB_H
#define YYMALLOC malloc2

#define MAX_PATH 1023


#define yystrlen strlen
static char *yystpcpy (char *yydest, const char *yysrc);

#include "debug.h"


#include <sys/types.h>
#include <sys/timeb.h>
#include <errno.h>
#include "common.h"

/* 
c** Override default RatC _name definition 
*/

#define _nameDefault "HLABison";

#include "ratc.h"


#include "symbol.h"
#include "version.h"
#include "output.h"
#include "asm.h"


// Here we determine the type of HLAPARSE we produce
// (based on -D command-line parameters)
//
// By default, we produce a version for Windows:
#define windows_c	3
#if defined(linux_c) || defined( freeBSD_c ) || defined( macOS_c )

 #undef  windows_c
 
#endif


#ifdef windows_c
	enum OSChoice targetOS = windows_os;
#elif defined( linux_c )
	enum OSChoice targetOS = linux_os;
#elif defined( freeBSD_c )
	enum OSChoice targetOS = freeBSD_os;
#elif defined( macOS_c )
	enum OSChoice targetOS = macOS_os;
#endif 


char *OSChoiceStrs[numOSChoices] =
	{
		"Windows",
		"Linux",
		"FreeBSD",
		"Mac OSX",
	};
	
char *ASMChoiceStrs[numAssemblers] =
	{
		"MASM",
		"FASM",
		"TASM",
		"GAS",
		"NASM",
		"HLA",
		"HLABE",
	};
	



enum    asmLevel langLevel;			// Language level we support.





/*
** Commonly used strings in program:
*/

char	*SizeMismatchStr = 
			"Operand size mismatch";

char	*NeedsInitializerMsg =	
			"Declaration must have initializer in readonly section";
		
char	*NullPointer = "0";



/*
** Assembly time variables.
** This are visible to the programmer via built-in functions and pragmas.
**
** CurLexLevel- 	Current lexical nesting level (read-only in HLA pgm).
** CurOffset-		Current offset in Activation Record (read-only).
** CurOffsetDir-	-1 or 1, determines if adding or subtracting offsets
**					 (read-only).
** AddOffset1st-	Determines whether to associate offset with symbol before
**					 or after adding in the size of an object (read-only).
**
** StartParmOffs-	Starting offset in activation record for parameters
**					 (read/write value).
**
** StartLclOffs-	Starting offset of local variables in activation record
**					 (r/w value).
**
** EnumSize-		Size of an enum variable, in bytes (r/w).
**
** UseVMT-			True if compiler emits a VMT for a class, false if method
**					 pointers are stored as part of the class record (r/w).
**
** CompileBound-	True if HLA compiles the BOUND instruction, false if
**					HLA ignores the bound instruction.
**
** CompileInto-		True if HLA compiles the INTO instruction, false if
**					HLA ignores the into instruction.
**
** AlwaysAlignStk-	Forces stack alignment to an address that is an even
**					multiple of four upon entry into a procedure (if true).
*/

int	 CurLexLevel 	= 0;
int	 CurOffset 		= 0;
int	 CurOffsetDir 	= -1;
int	 AddOffset1st	= 1;	
int	 StartParmOffs	= 8;
int	 StartLclOffs	= 0;
int  EnumSize		= 1;
int	 MinParmSize	= 4;
int	 CompileBound	= 1;
int	 CompileInto	= 1;
int	 AlwaysAlignStk	= 1;
int  TraceFlag		= 0;	/* True if we should emit code to trace instrs	*/
int	 FullExceptions = 0;	/* True if we link in the full exception code.  */
int	 threadSafe		= 0;	/* True if we're generating thread-safe code.	*/

char *CurBaseReg	= "ebp";	/* Base register used for auto vars.		*/

int  UseVMT			= 1;	/* Need to add a built-in function for this */

char *FileName;				/* Current filename we're processing.		*/



/*
** Internal variables
*/

int		yyerrCount	 = 0;	/* # errors in the program */
int		EnumVal 	 = 0;
int		LblCntr 	 = 1;	/* Zero is reserved for use by BreakLbl		    */
int		TrueLabel	 = -1;	/* -1 indicates "true" is not a legal label.    */
int		FalseLabel	 = -1;	/* Ditto.									    */
int		VarMacParms	 = 0;
int		StackSize	 = 16384;
int		HasAbstract	 = 0;	/* True if there is at least one abstract proc  */

int		BreakLbl	 = 0;	/* 0 if not currently in a loop.			    */
int		EndTryLabel	 = 0;	/* Used to hold # to build last lbl in try.     */
int		IgnoreErrors = 0;	/* True if the program is to ignore errors	    */
int		TempIgnoreErrors = 0;

int		RecFieldCnt	= 0;	/* Used to count fields in records & unions		*/
int		testMode 	= 0;	/* True if -test, but false if HLABE			*/
int		testMode2	= 0;	/* True if -test								*/


int		globalMacroLineCnt = 0;
char	*globalMacroFilename = NULL;


char	*CurVar = NULL;

 /*
 ** Variables used to deal with variable alignment.
 **
 **	MinVarAlignment- If a VAR object's size is smaller than this, then
 **					 align the object on this boundary rather than the
 **					 object's size.
 **
 **	MaxVarAlignment- If a VAR object's size is greater than this, then
 **					 align the object on this boundary rather than the
 **					 object's size.
 **
 ** TempVarAlign-	 If non-zero, then align the next object on this
 **					 boundary rather than the object's size.
 **
 ** MinRecAlignment,
 **	MaxRecAlignment,
 ** TempRecAlign-	 As above, but for records rather than auto vars.
 */

int		MinVarAlignment = 1;
int		MaxVarAlignment = 1;
int		TempVarAlign = 1;
int		HoldOffset = 0; 

int		MinRecAlignment = 1; /* Used to control alignment in records.		*/
int		MaxRecAlignment = 1; /* Used to control alignment in records.		*/
int		TempRecAlign = 1;	 /* For ALIGN directive inside a record.		*/


 /*
 ** Variables used to keep track of where we are in the code.
 **
 **	Note: Section is where we assemble all these boolean values to return
 ** them when the program encounters the "@section" built-in function.
 */

unsigned Section= 0;	/*	 Bit #	(in 32-bit "Section" variable		*/
						/*   -----										*/
int inConst		= 0;	/*		 0										*/
int inVal		= 0;	/*		 1										*/
int	inType		= 0;	/*		 2										*/
int	inVar		= 0;	/*		 3										*/
int inStatic	= 0;	/*		 4										*/
int	inReadonly	= 0;	/*		 5										*/
int inStorage	= 0;	/*		 6										*/

int	inMain		= 0;	/*		12										*/
int	inProcedure	= 0;	/*		13										*/
int	inMethod	= 0;	/*		14										*/
int	inIterator	= 0;	/*		15										*/
						/*		16										*/
						/*		17										*/
int	inCTL		= 0;	/*		18										*/
int inThunk		= 0;	/*		19										*/

int	inUnit		= 0;	/*		23										*/
int	inProgram	= 0;	/*		24										*/
int	inRecord	= 0;	/*		25										*/
int	inUnion		= 0;	/*		26										*/
int	inClass		= 0;	/*		27										*/
int inNamespace = 0;	/*		28										*/
int inRegex		= 0;	/*		29										*/
		 

int wasProgram = 0;		// Used to generate a .link file.
int wasCTL	   = 0;		// Used to force no code generation.

 /*
 ** Variable to denote that we're in an @string parameter list:
 */
 
int	InAtString	= 0;
		 
	
 /*
 ** Default Values for procedure options:
 */
 
int	AlignStackDefault = 1;
int	FrameDefault = 1; 	
int	DisplayDefault = 1;
int AlignDefault = 1;
int LeaveDefault = 1;	// "1" means "no leave, use manual"
int EnterDefault = 1;	// "1" means "no enter, use manual"
	 
		
 /*
 ** Access to the environment variables "hlainc" and "hlatmp"
 */
	
char	*hlainc  	= NULL;	/* Path to HLA include directory.				*/
char	*hlaauxinc  = NULL;	/* Path to app-specific include directory.		*/
char 	*outPath 	= NULL;	/* hlatmp:Path prefix used for output files.	*/
char	*objPath 	= NULL;	/* -obj:obj output path for object files.		*/
char	*binName 	= NULL;	/* -b:obj output name for object files.			*/

char	*hlaThreadSafe	= NULL;	/* '1' = thread-safe compilation.			*/


 /*
 ** _initialize_ points at the "_initialize_" constant's symbol
 ** table entry.  This is a string constant that HLA emits at
 ** the beginning of the main program.
 */
 
SymNode_t *_initialize_;
	

 /*
 ** _finalize_ points at the "_finalize_" constant's symbol
 ** table entry.  This is a string constant that HLA emits at
 ** the end of the main program.
 */
 
SymNode_t *_finalize_;


 /*
 ** InvisibleCode contains NULL if we are not processing
 ** the _initialize_ nor the _finalize_ strings.  It contains
 ** a pointer to either string if we are processing one of these.
 ** This is used by the yyerror function if an error occurs
 ** in the initialization or finalization code.
 */
 
char *InvisibleCode;
	

/*
** Internal variables used to process forward references.
*/

struct	StaticListType	*StaticList		= NULL;
struct	MethodListType	*MethodList		= NULL;
struct	PointerListType	*PointerList	= NULL;
struct	PatchListType	*PatchBaseList	= NULL;
struct	FwdRefLabelType	*FwdLabelsList	= NULL;
SymNode_t				**MainLocals	= NULL;
SymNode_t				*ClassPtr 		= NULL;
SymNode_t				*ThisPtr		= NULL;



/*
** Data structures and variables used by the begin..end (context..endcontext)
** statement.
*/


struct contextListType	*contextList = NULL; 
	

/*
** NSGlobal- 	Points at global objects outside a namespace
**				while we are building a namespace.
**
**	currentNS-	Points at the hash table for the current namespace
**				we are processing.
*/

SymNode_t			*NSGlobal		= NULL;
SymNode_t			*currentNS		= NULL;


/*
** RecGlobal-	Points at global objects outside a record's field list.
**
** recNS-		Points at the hash table for the current namespace
**				outside a record, if the record is within a namespace.
*/

SymNode_t			*RecGlobal		= NULL;
SymNode_t			*RecNS			= NULL;


/*
** ParmGlobal-	Points at global objects outside a parameter list.
**
** parmNS-		Points at the hash table for the current namespace
**				outside a parameter list, if the proc is within a namespace.
*/

SymNode_t			*ProcGlobal		= NULL;
SymNode_t			*ProcNS			= NULL;

/*
** fastNamespace-
**	Determines whether certain symbol lookup operations
**	automatically return an undefined symbol (e.g., variable declarations)
**	versus doing a full lookup.
**
** fastLookup-
**	Set when we expect an undefined symbol.  Both fastNamespace and
**	fastLookup must be true to do the short-circuit lookup in the flex code.
*/

int	fastNamespace = 0;
int fastLookup	  = 0;

/*
** ParmLookup-
**	True if we're looking up symbols in a parameter list.
*/

int	parmLookup = 0;


/*
** Variables that track the need for calls to the push_exceptionptr,
** Set_exceptionptr, and _HLA_GET_EXCEPTIONPTREBP function calls and
** usage of the ExceptionPtr variable (for external emission).
*/

int	need_raise						= 0;
int	need_ExceptionPtr				= 0;
int	need_HLA_PUSH_EXCEPTIONPTR		= 0;
int	need_HLA_SET_EXCEPTIONPTR		= 0; 
int	need_HLA_GET_EXCEPTIONPTREBP	= 0; 



/*
** SegmentList- Points at a list of strings containing
** names of user-defined segments.  Must be output
** to a ".LINK" file for use during the linker phase.
*/

struct segmentList_t
{
	struct segmentList_t *next;
	char* name;
};

struct segmentList_t *SegmentList = NULL;


/*
** Special global to hold cset constants.
*/

char GlobalCset[ CSetSizeInBytes ];


/*
** Special global used to build record constants.
*/

union YYSTYPE *RecordValues;


/*
** Pointer to the start of the symbol table.
*/

SymNode_t *SymbolTable 	 = &true_ste;
SymNode_t *CurrentContext = NULL;


/*
** Name of the main program in the assembly language output file:
*/

char	*mainName = "start";


/*
** Assembly Language Output File variables.
*/

FILE	*fOut;
int		StartOfStmt;	// Points into file at start of each stmt.

/*
** Memory buffers to hold intermediate data
*/

outputBuf *asmBuf;
outputBuf preambleBuf;
outputBuf codeBuf;
outputBuf dataBuf;
outputBuf bssBuf;
outputBuf roBuf;
outputBuf constBuf;
outputBuf extBuf;


/*
** Error device output file variable.
*/

FILE *MsgOut  = NULL;


/*
** Output file handle (for #openwrite, #write, #closewrite, #print, #error ):
*/

FILE *writeHandle = NULL;
FILE *readHandle = NULL;
FILE *PrintOut = NULL;


// The following is used by the #includelib statement:

includeLibList_t *includeLibList = NULL; 


/*
** Various prototypes this code uses.
*/

extern SymNode_t *LastRefdObject;

static void ExpectedOrdinalConst( void );


							   
static int shiftSize[5] = {0, 3, 4, 0, 5};
static char *divRETURNS[5] = { "", "al", "ax", "", "eax"}; 
static char *modRETURNS[5] = { "", "ah", "dx", "", "edx"}; 
static char *mulRETURNS[5] = { "", "ax", "dx:ax", "", "edx:eax"}; 
			
//static char *sizenames[16] = 
//		{
//			"byte", 
//			"word", 
//			"byte", 
//			"dword",
//			"byte", 
//			"byte", 
//			"byte", 
//			"qword",			 
//			"byte", 
//			"byte", 
//			"byte", 
//			"byte", 
//			"byte", 
//			"byte", 
//			"byte", 
//			"byte" 
//		};
			
static enum PrimType sizetypes[16] = 
		{
			tByte, 
			tWord, 
			tByte, 
			tDWord,
			tByte, 
			tByte, 
			tByte, 
			tQWord,			 
			tByte, 
			tByte, 
			tByte, 
			tByte, 
			tByte, 
			tByte, 
			tByte, 
			tByte 
		};
							   


static char *relop2Operators[] =
{
	"=",		// eq_astop
	"<>",		// ne_astop
	"<",		// b_astop
	"<=",		// be_astop
	">",		// a_astop
	">=",		// ae_astop
	"<",		// l_astop
	"<=",		// le_astop
	">",		// g_astop
	">=",		// ge_astop
	"=0",		// eq0_astop
	"<>0",		// ne0_astop
	"in", 		// in_astop
	"not in"	// notin_astop
};



static char *uToSTi[] =
{
	"st0",
	"st1",
	"st2",
	"st3",
	"st4",
	"st5",
	"st6",
	"st7"
};

static char *uToXmm[] =
{
	"xmm0",
	"xmm1",
	"xmm2",
	"xmm3",
	"xmm4",
	"xmm5",
	"xmm6",
	"xmm7"
};

static char *uToMmx[] =
{
	"mm0",
	"mm1",
	"mm2",
	"mm3",
	"mm4",
	"mm5",
	"mm6",
	"mm7"
};

static char *uToSeg[numSEGregs] =
{
	"eseg",
	"cseg",
	"sseg",
	"dseg",
	"fseg",
	"gseg"
	
};




// The following table converts an encoded register value
// into the corresponding string.

char *regStrs[] =
{
	"al",
	"cl",
	"dl",
	"bl",
	"ah",

	"ch",
	"dh",
	"bh",
	
	"ax",
	"cx",
	"dx",
	"bx",
	"sp",
	"bp",
	"si",
	"di",
	
	"eax",
	"ecx",
	"edx",
	"ebx",
	"esp",
	"ebp",
	"esi",
	"edi"
	
};

char *segStrs[]=
{
	"es",
	"cs",
	"ss",
	"ds",
	"fs",
	"gs"
};

char *ctrlStrs[]=
{
	"cr0",
	"cr1",
	"cr2",
	"cr3",
	"cr4",
	"cr5",
	"cr6",
	"cr7"
};

char *dbgStrs[]=
{
	"dr0",
	"dr1",
	"dr2",
	"dr3",
	"dr4",
	"dr5",
	"dr6",
	"dr7"
};







static char *uToCmppsd[] =
{
	"cmpeqps",
	"cmpltps",
	"cmpleps",
	"cmpordps",
	"cmpneps",
	"cmpnltps",
	"cmpnleps",
	"cmpunordps",
	"cmpeqpd",
	"cmpltpd",
	"cmplepd",
	"cmpordpd",
	"cmpneqpd",
	"cmpnlepd",
	"cmpnltpd",
	"cmpunordpd"
};


static char *uToCmp2[] =
{
	"cmppd",
	"cmpps",
	"cmpss"
};

static char *xshiftStrs[]=
{
	"psllw",
	"pslld",
	"psllq",
	"psraw",
	"psrad",
	"psrlw",
	"psrld",
	"psrlq"
};


// Table to translate fp_instrs to fpp_instrs values:

static enum fpp_instrs fp_fpp_xlat[num_fp_instrs] =
	{
		fadd_instr,
		fmul_instr,
		fcom_instr,
		fcomp_instr,
		fsub_instr,
		fsubr_instr,
		fdiv_instr,
		fdivr_instr,
	};



/*
** Variables used to process the command line.
*/

int		CurArg;

int		DumpSymbols = 0;	/* -d option (dump symbol table).		*/
int		Verbose = 0;		/* -v option (verbose compile).			*/
char	*SourceFile = NULL;	/* Filename provided on cmd line.		*/

int		Suffix;
char	AsmName[ 1024 ];
char	LinkName[ 1024 ];
char	csname[ 256 ];
char	dataname[ 256 ];
char	bssname[ 256 ];
char	roname[ 256 ];
char	constname[ 256 ];



// assembler determines which assembler we're writing source code for.

enum	AsmChoice	assembler = masm;
enum	gasChoice	gasSyntax = stdGas;

// useHLABE controls whether to use the internal HLA back engine for code
// generation.

int	useHLABE = 0;


// sourceOutput is zero for hexadecimal instruction encoding output,
// one for source code instruction output.

int sourceOutput = 0;	// Default is hex opcode output.


// If OptimizeStrings is true, then HLA merges (folds)
// identical string constants;  otherwise it emits separate
// data for each identical string in the program.

int			OptimizeStrings = 1;


// Moved here from hlautils.

static char*
getFileStr( int startPosn )
_begin( getFileStr )

	char	*t;
	int		CurPosn;
	int		size;
	
	_here;
	CurPosn = asmBuf->offset;
	size = CurPosn - startPosn + 1;
	t = malloc2( size+2 );
	strncpy( t, asmBuf->base + startPosn, size );
	t[ size ] = '\0';
	asmBuf->offset = startPosn;
	_return t;
				
_end( getFileStr )






																	 




/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/

#ifndef __STDC__

	#define __STDC__ 1

#endif

//extern int yylex( union YYSTYPE *yylval );		




/* Line 189 of yacc.c  */
#line 1000 "hlaparse.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     dupTkn = 258,
     lorTkn = 259,
     orTkn = 260,
     landTkn = 261,
     andTkn = 262,
     inTkn = 263,
     neTkn = 264,
     geTkn = 265,
     leTkn = 266,
     shropTkn = 267,
     shlopTkn = 268,
     modTkn = 269,
     divTkn = 270,
     notTkn = 271,
     UMINUS = 272,
     intconst = 273,
     hexconst = 274,
     binconst = 275,
     fltconst = 276,
     charconst = 277,
     wcharconst = 278,
     strconst = 279,
     wstrconst = 280,
     regexconst = 281,
     assignTkn = 282,
     addassignTkn = 283,
     subassignTkn = 284,
     DotDot = 285,
     coloncolonTkn = 286,
     matchTkn = 287,
     match2Tkn = 288,
     stmtsTkn = 289,
     endstmtsTkn = 290,
     UndefID = 291,
     RegexID = 292,
     atTkn = 293,
     posTkn = 294,
     tabTkn = 295,
     arbTkn = 296,
     LocalID = 297,
     LocalConstID = 298,
     LocalVarID = 299,
     LocalStaticID = 300,
     LocalProcID = 301,
     LocalIterID = 302,
     LocalMethodID = 303,
     LocalLabelID = 304,
     NonLocalID = 305,
     NonLocalConstID = 306,
     NonLocalVarID = 307,
     NonLocalStaticID = 308,
     NonLocalProcID = 309,
     NonLocalIterID = 310,
     NonLocalMethodID = 311,
     NonLocalLabelID = 312,
     OverloadedID = 313,
     ovldClassTkn = 314,
     ClassVarID = 315,
     ClassStaticID = 316,
     ClassProcID = 317,
     ClassIterID = 318,
     ClassMethodID = 319,
     MacroParmTkn = 320,
     LastMacroParmTkn = 321,
     MacroID = 322,
     DoMacroDclTkn = 323,
     DoRegexDclTkn = 324,
     compileRegexTkn = 325,
     TextParameters = 326,
     DoOneValStmt = 327,
     DoOneConstExpr = 328,
     ctforTkn = 329,
     textblockTkn = 330,
     endtextTkn = 331,
     stringblockTkn = 332,
     endstringTkn = 333,
     scanblockTkn = 334,
     endscanTkn = 335,
     matchblockTkn = 336,
     endmatchTkn = 337,
     beginTkn = 338,
     endTkn = 339,
     procTkn = 340,
     endprocTkn = 341,
     procedureTkn = 342,
     iteratorTkn = 343,
     methodTkn = 344,
     programTkn = 345,
     unitTkn = 346,
     macroTkn = 347,
     keywordTkn = 348,
     terminatorTkn = 349,
     endmacroTkn = 350,
     endMacDefTkn = 351,
     regexMacroTkn = 352,
     endregexTkn = 353,
     endRegexDefTkn = 354,
     regexReturnTkn = 355,
     labelTkn = 356,
     endlabelTkn = 357,
     constTkn = 358,
     endconstTkn = 359,
     valTkn = 360,
     endvalTkn = 361,
     typeTkn = 362,
     endtypeTkn = 363,
     alignTkn = 364,
     varTkn = 365,
     endvarTkn = 366,
     staticTkn = 367,
     endstaticTkn = 368,
     uninitializedTkn = 369,
     endstorageTkn = 370,
     readonlyTkn = 371,
     endreadonlyTkn = 372,
     recordTkn = 373,
     endrecordTkn = 374,
     unionTkn = 375,
     endunionTkn = 376,
     classTkn = 377,
     vmtTkn = 378,
     endclassTkn = 379,
     enumTkn = 380,
     inheritsTkn = 381,
     pointerTkn = 382,
     toTkn = 383,
     downtoTkn = 384,
     externalTkn = 385,
     abstractTkn = 386,
     overloadsTkn = 387,
     overrideTkn = 388,
     overridesTkn = 389,
     forwardTkn = 390,
     returnsTkn = 391,
     atreturnsTkn = 392,
     noframeTkn = 393,
     frameTkn = 394,
     nodisplayTkn = 395,
     displayTkn = 396,
     noalignstkTkn = 397,
     alignstkTkn = 398,
     alignprocTkn = 399,
     useTkn = 400,
     useenterTkn = 401,
     noenterTkn = 402,
     useleaveTkn = 403,
     noleaveTkn = 404,
     pascalTkn = 405,
     cdeclTkn = 406,
     stdcallTkn = 407,
     nostorageTkn = 408,
     volatileTkn = 409,
     namespaceTkn = 410,
     fastTkn = 411,
     segmentTkn = 412,
     hereTkn = 413,
     atlabelTkn = 414,
     nameTkn = 415,
     valresTkn = 416,
     resultTkn = 417,
     lazyTkn = 418,
     thunkTkn = 419,
     jtTkn = 420,
     jfTkn = 421,
     ifTkn = 422,
     thenTkn = 423,
     elseifTkn = 424,
     elseTkn = 425,
     endifTkn = 426,
     switchTkn = 427,
     caseTkn = 428,
     defaultTkn = 429,
     endswitchTkn = 430,
     whileTkn = 431,
     doTkn = 432,
     endwhileTkn = 433,
     welseTkn = 434,
     repeatTkn = 435,
     untilTkn = 436,
     forTkn = 437,
     foreverTkn = 438,
     foreachTkn = 439,
     endforTkn = 440,
     felseTkn = 441,
     exitTkn = 442,
     exitifTkn = 443,
     breakTkn = 444,
     breakifTkn = 445,
     continueTkn = 446,
     continueifTkn = 447,
     tryTkn = 448,
     alwaysTkn = 449,
     unprotectedTkn = 450,
     exceptionTkn = 451,
     anyexceptionTkn = 452,
     endtryTkn = 453,
     raiseTkn = 454,
     reraiseTkn = 455,
     booleanTkn = 456,
     int8Tkn = 457,
     int16Tkn = 458,
     int32Tkn = 459,
     int64Tkn = 460,
     int128Tkn = 461,
     charTkn = 462,
     wcharTkn = 463,
     real32Tkn = 464,
     real64Tkn = 465,
     real80Tkn = 466,
     real128Tkn = 467,
     uns8Tkn = 468,
     uns16Tkn = 469,
     uns32Tkn = 470,
     uns64Tkn = 471,
     uns128Tkn = 472,
     stringTkn = 473,
     wstringTkn = 474,
     zstringTkn = 475,
     csetTkn = 476,
     regexTkn = 477,
     textTkn = 478,
     byteTkn = 479,
     wordTkn = 480,
     dwordTkn = 481,
     qwordTkn = 482,
     tbyteTkn = 483,
     lwordTkn = 484,
     atint8Tkn = 485,
     atint16Tkn = 486,
     atint32Tkn = 487,
     atint64Tkn = 488,
     atint128Tkn = 489,
     atcharTkn = 490,
     atwcharTkn = 491,
     atreal32Tkn = 492,
     atreal64Tkn = 493,
     atreal80Tkn = 494,
     atuns8Tkn = 495,
     atuns16Tkn = 496,
     atuns32Tkn = 497,
     atuns64Tkn = 498,
     atuns128Tkn = 499,
     atstringTkn = 500,
     atwstringTkn = 501,
     atcsetTkn = 502,
     atbyteTkn = 503,
     atwordTkn = 504,
     atdwordTkn = 505,
     atqwordTkn = 506,
     attbyteTkn = 507,
     atlwordTkn = 508,
     atpointerTkn = 509,
     ctlTkn = 510,
     endctlTkn = 511,
     nullTkn = 512,
     absTkn = 513,
     ceilTkn = 514,
     cosTkn = 515,
     dateTkn = 516,
     envTkn = 517,
     expTkn = 518,
     extractTkn = 519,
     floorTkn = 520,
     isalphaTkn = 521,
     isalphanumTkn = 522,
     isdigitTkn = 523,
     islowerTkn = 524,
     isspaceTkn = 525,
     isupperTkn = 526,
     isxdigitTkn = 527,
     logTkn = 528,
     log10Tkn = 529,
     maxTkn = 530,
     minTkn = 531,
     modregrmTkn = 532,
     oddTkn = 533,
     randomTkn = 534,
     randomizeTkn = 535,
     readTkn = 536,
     sinTkn = 537,
     sortTkn = 538,
     sqrtTkn = 539,
     systemTkn = 540,
     system2Tkn = 541,
     tanTkn = 542,
     threadTkn = 543,
     timeTkn = 544,
     peekcsetTkn = 545,
     onecsetTkn = 546,
     uptocsetTkn = 547,
     zerooronecsetTkn = 548,
     zeroormorecsetTkn = 549,
     oneormorecsetTkn = 550,
     exactlyncsetTkn = 551,
     firstncsetTkn = 552,
     norlesscsetTkn = 553,
     normorecsetTkn = 554,
     ntomcsetTkn = 555,
     exactlyntomcsetTkn = 556,
     peekcharTkn = 557,
     onecharTkn = 558,
     uptocharTkn = 559,
     zerooronecharTkn = 560,
     zeroormorecharTkn = 561,
     oneormorecharTkn = 562,
     exactlyncharTkn = 563,
     firstncharTkn = 564,
     norlesscharTkn = 565,
     normorecharTkn = 566,
     ntomcharTkn = 567,
     exactlyntomcharTkn = 568,
     peekicharTkn = 569,
     oneicharTkn = 570,
     uptoicharTkn = 571,
     zerooroneicharTkn = 572,
     zeroormoreicharTkn = 573,
     oneormoreicharTkn = 574,
     exactlynicharTkn = 575,
     firstnicharTkn = 576,
     norlessicharTkn = 577,
     normoreicharTkn = 578,
     ntomicharTkn = 579,
     exactlyntomicharTkn = 580,
     matchstrTkn = 581,
     matchistrTkn = 582,
     uptostrTkn = 583,
     uptoistrTkn = 584,
     matchtostrTkn = 585,
     matchtoistrTkn = 586,
     zeroormorewsTkn = 587,
     oneormorewsTkn = 588,
     wsoreosTkn = 589,
     wstheneosTkn = 590,
     peekwsTkn = 591,
     eosTkn = 592,
     wsTkn = 593,
     peekstrTkn = 594,
     peekistrTkn = 595,
     matchidTkn = 596,
     matchwordTkn = 597,
     matchiwordTkn = 598,
     matchintconstTkn = 599,
     matchrealconstTkn = 600,
     matchnumericconstTkn = 601,
     matchstrconstTkn = 602,
     matchregTkn = 603,
     matchreg8Tkn = 604,
     matchreg16Tkn = 605,
     matchreg32Tkn = 606,
     matchfpuregTkn = 607,
     matchmmxregTkn = 608,
     matchxmmregTkn = 609,
     deleteTkn = 610,
     indexTkn = 611,
     insertTkn = 612,
     lengthTkn = 613,
     lowercaseTkn = 614,
     replaceTkn = 615,
     rindexTkn = 616,
     strbrkTkn = 617,
     strsetTkn = 618,
     strspanTkn = 619,
     substrTkn = 620,
     leftTkn = 621,
     leftdelTkn = 622,
     rightTkn = 623,
     rightdelTkn = 624,
     tokenizeTkn = 625,
     trimTkn = 626,
     delspacesTkn = 627,
     uppercaseTkn = 628,
     fileexistsTkn = 629,
     filemodifiedtimeTkn = 630,
     symNameTkn = 631,
     symTypeTkn = 632,
     sympTypeTkn = 633,
     symBasepTypeTkn = 634,
     symClassTkn = 635,
     symSizeTkn = 636,
     symOffsetTkn = 637,
     symLocalsymsTkn = 638,
     symParmsTkn = 639,
     symLexTkn = 640,
     symArityTkn = 641,
     symDimTkn = 642,
     symNumelementsTkn = 643,
     symDefinedTkn = 644,
     symTypeNameTkn = 645,
     symBaseTypeNameTkn = 646,
     sympClassTkn = 647,
     symStaticNameTkn = 648,
     symIsExternalTkn = 649,
     symIsConstTkn = 650,
     symIsClassTkn = 651,
     symElementSizeTkn = 652,
     symIsRegTkn = 653,
     symIsReg8Tkn = 654,
     symIsReg16Tkn = 655,
     symIsReg32Tkn = 656,
     symIsfRegTkn = 657,
     symIsMemTkn = 658,
     symIsTypeTkn = 659,
     curLexTkn = 660,
     curOffsetTkn = 661,
     curDirTkn = 662,
     addOffset1stTkn = 663,
     lineNumberTkn = 664,
     lineNumberStkTkn = 665,
     errorPrefixTkn = 666,
     filenameTkn = 667,
     fileNameStkTkn = 668,
     startParmOfsTkn = 669,
     startLclOfsTkn = 670,
     enumSizeTkn = 671,
     lastMacroObjectTkn = 672,
     curObjectNameTkn = 673,
     curVarTkn = 674,
     sectionTkn = 675,
     boundvarTkn = 676,
     intovarTkn = 677,
     traceTkn = 678,
     exceptsTkn = 679,
     optstringsTkn = 680,
     baseregTkn = 681,
     st0Tkn = 682,
     st1Tkn = 683,
     st2Tkn = 684,
     st3Tkn = 685,
     st4Tkn = 686,
     st5Tkn = 687,
     st6Tkn = 688,
     st7Tkn = 689,
     alTkn = 690,
     ahTkn = 691,
     axTkn = 692,
     eaxTkn = 693,
     blTkn = 694,
     bhTkn = 695,
     bxTkn = 696,
     ebxTkn = 697,
     clTkn = 698,
     chTkn = 699,
     cxTkn = 700,
     ecxTkn = 701,
     dlTkn = 702,
     dhTkn = 703,
     dxTkn = 704,
     edxTkn = 705,
     siTkn = 706,
     esiTkn = 707,
     diTkn = 708,
     ediTkn = 709,
     bpTkn = 710,
     ebpTkn = 711,
     spTkn = 712,
     espTkn = 713,
     mm0Tkn = 714,
     mm1Tkn = 715,
     mm2Tkn = 716,
     mm3Tkn = 717,
     mm4Tkn = 718,
     mm5Tkn = 719,
     mm6Tkn = 720,
     mm7Tkn = 721,
     xmm0Tkn = 722,
     xmm1Tkn = 723,
     xmm2Tkn = 724,
     xmm3Tkn = 725,
     xmm4Tkn = 726,
     xmm5Tkn = 727,
     xmm6Tkn = 728,
     xmm7Tkn = 729,
     csTkn = 730,
     dsTkn = 731,
     esTkn = 732,
     fsTkn = 733,
     gsTkn = 734,
     ssTkn = 735,
     cr0Tkn = 736,
     cr1Tkn = 737,
     cr2Tkn = 738,
     cr3Tkn = 739,
     cr4Tkn = 740,
     cr5Tkn = 741,
     cr6Tkn = 742,
     cr7Tkn = 743,
     dr0Tkn = 744,
     dr1Tkn = 745,
     dr2Tkn = 746,
     dr3Tkn = 747,
     dr4Tkn = 748,
     dr5Tkn = 749,
     dr6Tkn = 750,
     dr7Tkn = 751,
     dxaxTkn = 752,
     edxeaxTkn = 753,
     thisTkn = 754,
     superTkn = 755,
     cTkn = 756,
     ncTkn = 757,
     oTkn = 758,
     noTkn = 759,
     sTkn = 760,
     nsTkn = 761,
     zTkn = 762,
     nzTkn = 763,
     aTkn = 764,
     naTkn = 765,
     aeTkn = 766,
     naeTkn = 767,
     bTkn = 768,
     nbTkn = 769,
     beTkn = 770,
     nbeTkn = 771,
     eTkn = 772,
     gTkn = 773,
     ngTkn = 774,
     ngeTkn = 775,
     lTkn = 776,
     nlTkn = 777,
     nleTkn = 778,
     peTkn = 779,
     poTkn = 780,
     npTkn = 781,
     pTkn = 782,
     aaaTkn = 783,
     aadTkn = 784,
     aamTkn = 785,
     aasTkn = 786,
     adcTkn = 787,
     lockadcTkn = 788,
     addTkn = 789,
     lockaddTkn = 790,
     lockandTkn = 791,
     arplTkn = 792,
     boundTkn = 793,
     bsfTkn = 794,
     bsrTkn = 795,
     bswapTkn = 796,
     btTkn = 797,
     btcTkn = 798,
     lockbtcTkn = 799,
     btrTkn = 800,
     lockbtrTkn = 801,
     btsTkn = 802,
     lockbtsTkn = 803,
     callTkn = 804,
     cbwTkn = 805,
     cdqTkn = 806,
     clcTkn = 807,
     cldTkn = 808,
     cliTkn = 809,
     cltsTkn = 810,
     cmcTkn = 811,
     cmovoTkn = 812,
     cmovnoTkn = 813,
     cmovbTkn = 814,
     cmovnbTkn = 815,
     cmoveTkn = 816,
     cmovneTkn = 817,
     cmovbeTkn = 818,
     cmovnbeTkn = 819,
     cmovsTkn = 820,
     cmovnsTkn = 821,
     cmovpTkn = 822,
     cmovnpTkn = 823,
     cmovlTkn = 824,
     cmovnlTkn = 825,
     cmovleTkn = 826,
     cmovnleTkn = 827,
     cmpTkn = 828,
     cmpsbTkn = 829,
     cmpsdTkn = 830,
     cmpswTkn = 831,
     cmpxchgTkn = 832,
     lockcmpxchgTkn = 833,
     cmpxchg8bTkn = 834,
     cpuidTkn = 835,
     cwdTkn = 836,
     cwdeTkn = 837,
     daaTkn = 838,
     dasTkn = 839,
     decTkn = 840,
     lockdecTkn = 841,
     enterTkn = 842,
     hltTkn = 843,
     idivTkn = 844,
     imodTkn = 845,
     imulTkn = 846,
     intmulTkn = 847,
     incTkn = 848,
     lockincTkn = 849,
     insbTkn = 850,
     insdTkn = 851,
     inswTkn = 852,
     intTkn = 853,
     intoTkn = 854,
     invdTkn = 855,
     invlpgTkn = 856,
     iretTkn = 857,
     iretdTkn = 858,
     jaTkn = 859,
     jaeTkn = 860,
     jbTkn = 861,
     jbeTkn = 862,
     jcTkn = 863,
     jeTkn = 864,
     jgTkn = 865,
     jgeTkn = 866,
     jlTkn = 867,
     jleTkn = 868,
     jnaTkn = 869,
     jnaeTkn = 870,
     jnbTkn = 871,
     jnbeTkn = 872,
     jncTkn = 873,
     jneTkn = 874,
     jngTkn = 875,
     jngeTkn = 876,
     jnlTkn = 877,
     jnleTkn = 878,
     jnoTkn = 879,
     joTkn = 880,
     jnpTkn = 881,
     jnsTkn = 882,
     jnzTkn = 883,
     jpTkn = 884,
     jpeTkn = 885,
     jpoTkn = 886,
     jsTkn = 887,
     jzTkn = 888,
     jcxzTkn = 889,
     jecxzTkn = 890,
     jmpTkn = 891,
     lahfTkn = 892,
     larTkn = 893,
     leaTkn = 894,
     ldsTkn = 895,
     lesTkn = 896,
     lfsTkn = 897,
     lgsTkn = 898,
     lssTkn = 899,
     lslTkn = 900,
     lgdtTkn = 901,
     lidtTkn = 902,
     lldtTkn = 903,
     sgdtTkn = 904,
     sidtTkn = 905,
     sldtTkn = 906,
     leaveTkn = 907,
     lodsbTkn = 908,
     lodsdTkn = 909,
     lodswTkn = 910,
     loopTkn = 911,
     loopeTkn = 912,
     loopzTkn = 913,
     loopneTkn = 914,
     loopnzTkn = 915,
     lmswTkn = 916,
     ltrTkn = 917,
     strTkn = 918,
     movTkn = 919,
     movsbTkn = 920,
     movsdTkn = 921,
     movswTkn = 922,
     movsxTkn = 923,
     movzxTkn = 924,
     mulTkn = 925,
     negTkn = 926,
     locknegTkn = 927,
     nopTkn = 928,
     locknotTkn = 929,
     lockorTkn = 930,
     outTkn = 931,
     outsbTkn = 932,
     outsdTkn = 933,
     outswTkn = 934,
     popTkn = 935,
     popaTkn = 936,
     popadTkn = 937,
     popfTkn = 938,
     popfdTkn = 939,
     pushTkn = 940,
     pushaTkn = 941,
     pushadTkn = 942,
     pushdTkn = 943,
     pushfTkn = 944,
     pushfdTkn = 945,
     pushwTkn = 946,
     rclTkn = 947,
     rcrTkn = 948,
     rdmsrTkn = 949,
     rdpmcTkn = 950,
     rdtscTkn = 951,
     rsmTkn = 952,
     repmovsbTkn = 953,
     repmovswTkn = 954,
     repmovsdTkn = 955,
     repinsbTkn = 956,
     repinswTkn = 957,
     repinsdTkn = 958,
     repoutsbTkn = 959,
     repoutswTkn = 960,
     repoutsdTkn = 961,
     repstosbTkn = 962,
     repstoswTkn = 963,
     repstosdTkn = 964,
     repecmpsbTkn = 965,
     repecmpswTkn = 966,
     repecmpsdTkn = 967,
     repzcmpsbTkn = 968,
     repzcmpswTkn = 969,
     repzcmpsdTkn = 970,
     repnecmpsbTkn = 971,
     repnecmpswTkn = 972,
     repnecmpsdTkn = 973,
     repnzcmpsbTkn = 974,
     repnzcmpswTkn = 975,
     repnzcmpsdTkn = 976,
     repescasbTkn = 977,
     repescaswTkn = 978,
     repescasdTkn = 979,
     repnescasbTkn = 980,
     repnescaswTkn = 981,
     repnescasdTkn = 982,
     repzscasbTkn = 983,
     repzscaswTkn = 984,
     repzscasdTkn = 985,
     repnzscasbTkn = 986,
     repnzscaswTkn = 987,
     repnzscasdTkn = 988,
     retTkn = 989,
     rolTkn = 990,
     rorTkn = 991,
     sahfTkn = 992,
     salTkn = 993,
     sarTkn = 994,
     sbbTkn = 995,
     locksbbTkn = 996,
     scasbTkn = 997,
     scasdTkn = 998,
     scaswTkn = 999,
     setbTkn = 1000,
     setnbTkn = 1001,
     setzTkn = 1002,
     setnzTkn = 1003,
     setbeTkn = 1004,
     setnbeTkn = 1005,
     setoTkn = 1006,
     setnoTkn = 1007,
     setsTkn = 1008,
     setnsTkn = 1009,
     setpTkn = 1010,
     setnpTkn = 1011,
     setlTkn = 1012,
     setleTkn = 1013,
     setnlTkn = 1014,
     setnleTkn = 1015,
     shlTkn = 1016,
     shldTkn = 1017,
     shrTkn = 1018,
     shrdTkn = 1019,
     smswTkn = 1020,
     stcTkn = 1021,
     stdTkn = 1022,
     stiTkn = 1023,
     stosbTkn = 1024,
     stosdTkn = 1025,
     stoswTkn = 1026,
     subTkn = 1027,
     sysenterTkn = 1028,
     sysexitTkn = 1029,
     locksubTkn = 1030,
     testTkn = 1031,
     ud2Tkn = 1032,
     verrTkn = 1033,
     verwTkn = 1034,
     waitTkn = 1035,
     wbinvdTkn = 1036,
     wrmsrTkn = 1037,
     xaddTkn = 1038,
     lockxaddTkn = 1039,
     xchgTkn = 1040,
     lockxchgTkn = 1041,
     xlatTkn = 1042,
     xorTkn = 1043,
     lockxorTkn = 1044,
     fldTkn = 1045,
     fildTkn = 1046,
     fbldTkn = 1047,
     fstTkn = 1048,
     fstpTkn = 1049,
     fistTkn = 1050,
     fistpTkn = 1051,
     fisttpTkn = 1052,
     fbstpTkn = 1053,
     fxchTkn = 1054,
     fxamTkn = 1055,
     faddTkn = 1056,
     faddpTkn = 1057,
     fiaddTkn = 1058,
     fmulTkn = 1059,
     fmulpTkn = 1060,
     fimulTkn = 1061,
     fsubTkn = 1062,
     fsubpTkn = 1063,
     fsubrTkn = 1064,
     fsubrpTkn = 1065,
     fisubTkn = 1066,
     fisubrTkn = 1067,
     fdivTkn = 1068,
     fdivpTkn = 1069,
     fdivrTkn = 1070,
     fdivrpTkn = 1071,
     fidivTkn = 1072,
     fidivrTkn = 1073,
     fcomTkn = 1074,
     fcompTkn = 1075,
     fcomppTkn = 1076,
     ficomTkn = 1077,
     ficompTkn = 1078,
     fucomTkn = 1079,
     fucompTkn = 1080,
     fucomppTkn = 1081,
     fsqrtTkn = 1082,
     fabsTkn = 1083,
     fchsTkn = 1084,
     ftstTkn = 1085,
     fscaleTkn = 1086,
     fpremTkn = 1087,
     fprem1Tkn = 1088,
     frndintTkn = 1089,
     fxtractTkn = 1090,
     fldzTkn = 1091,
     fld1Tkn = 1092,
     fldpiTkn = 1093,
     fldl2tTkn = 1094,
     fldl2eTkn = 1095,
     fldlg2Tkn = 1096,
     fldln2Tkn = 1097,
     f2xm1Tkn = 1098,
     fsinTkn = 1099,
     fcosTkn = 1100,
     fsincosTkn = 1101,
     fptanTkn = 1102,
     fpatanTkn = 1103,
     fyl2xTkn = 1104,
     fyl2xp1Tkn = 1105,
     finitTkn = 1106,
     fninitTkn = 1107,
     fwaitTkn = 1108,
     fldcwTkn = 1109,
     fstcwTkn = 1110,
     fnstcwTkn = 1111,
     fclexTkn = 1112,
     fnclexTkn = 1113,
     fldenvTkn = 1114,
     fstenvTkn = 1115,
     fnstenvTkn = 1116,
     fsaveTkn = 1117,
     fnsaveTkn = 1118,
     frstorTkn = 1119,
     fstswTkn = 1120,
     fnstswTkn = 1121,
     fincstpTkn = 1122,
     fdecstpTkn = 1123,
     fnopTkn = 1124,
     ffreeTkn = 1125,
     fcmovaTkn = 1126,
     fcmovaeTkn = 1127,
     fcmovbTkn = 1128,
     fcmovbeTkn = 1129,
     fcmoveTkn = 1130,
     fcmovnaTkn = 1131,
     fcmovnaeTkn = 1132,
     fcmovnbTkn = 1133,
     fcmovnbeTkn = 1134,
     fcmovneTkn = 1135,
     fcmovnuTkn = 1136,
     fcmovuTkn = 1137,
     fcomiTkn = 1138,
     fcomipTkn = 1139,
     fucomiTkn = 1140,
     fucomipTkn = 1141,
     paddbTkn = 1142,
     paddwTkn = 1143,
     padddTkn = 1144,
     paddqTkn = 1145,
     paddsbTkn = 1146,
     paddswTkn = 1147,
     paddusbTkn = 1148,
     padduswTkn = 1149,
     psubbTkn = 1150,
     psubwTkn = 1151,
     psubdTkn = 1152,
     psubqTkn = 1153,
     psubsbTkn = 1154,
     psubswTkn = 1155,
     psubusbTkn = 1156,
     psubuswTkn = 1157,
     pmullwTkn = 1158,
     pmulhwTkn = 1159,
     pmulhuwTkn = 1160,
     pmuludqTkn = 1161,
     pmaddwdTkn = 1162,
     pmaxswTkn = 1163,
     pmaxubTkn = 1164,
     pminswTkn = 1165,
     pminubTkn = 1166,
     psadbwTkn = 1167,
     pextrwTkn = 1168,
     pinsrwTkn = 1169,
     pmovmskbTkn = 1170,
     pshufwTkn = 1171,
     pshufdTkn = 1172,
     pavgbTkn = 1173,
     pavgwTkn = 1174,
     pcmpeqbTkn = 1175,
     pcmpeqwTkn = 1176,
     pcmpeqdTkn = 1177,
     pcmpgtbTkn = 1178,
     pcmpgtwTkn = 1179,
     pcmpgtdTkn = 1180,
     packsswbTkn = 1181,
     packuswbTkn = 1182,
     packssdwTkn = 1183,
     punpcklbwTkn = 1184,
     punpcklwdTkn = 1185,
     punpckldqTkn = 1186,
     punpcklqdqTkn = 1187,
     punpckhbwTkn = 1188,
     punpckhwdTkn = 1189,
     punpckhdqTkn = 1190,
     punpckhqdqTkn = 1191,
     pandTkn = 1192,
     pandnTkn = 1193,
     porTkn = 1194,
     pxorTkn = 1195,
     psllwTkn = 1196,
     pslldTkn = 1197,
     psllqTkn = 1198,
     psrlwTkn = 1199,
     psrldTkn = 1200,
     psrlqTkn = 1201,
     psrawTkn = 1202,
     psradTkn = 1203,
     movdTkn = 1204,
     movqTkn = 1205,
     emmsTkn = 1206,
     addpdTkn = 1207,
     addsdTkn = 1208,
     addpsTkn = 1209,
     addssTkn = 1210,
     addsubpsTkn = 1211,
     addsubpdTkn = 1212,
     andnpdTkn = 1213,
     andnpsTkn = 1214,
     andpdTkn = 1215,
     andpsTkn = 1216,
     clflushTkn = 1217,
     cmppdTkn = 1218,
     cmppsTkn = 1219,
     cmpssTkn = 1220,
     cmpeqssTkn = 1221,
     cmplessTkn = 1222,
     cmpltssTkn = 1223,
     cmpneqssTkn = 1224,
     cmpnltssTkn = 1225,
     cmpnlessTkn = 1226,
     cmpordssTkn = 1227,
     cmpunordssTkn = 1228,
     cmpeqsdTkn = 1229,
     cmplesdTkn = 1230,
     cmpltsdTkn = 1231,
     cmpneqsdTkn = 1232,
     cmpnltsdTkn = 1233,
     cmpnlesdTkn = 1234,
     cmpordsdTkn = 1235,
     cmpunordsdTkn = 1236,
     cmpeqpsTkn = 1237,
     cmplepsTkn = 1238,
     cmpltpsTkn = 1239,
     cmpneqpsTkn = 1240,
     cmpnltpsTkn = 1241,
     cmpnlepsTkn = 1242,
     cmpordpsTkn = 1243,
     cmpunordpsTkn = 1244,
     cmpeqpdTkn = 1245,
     cmplepdTkn = 1246,
     cmpltpdTkn = 1247,
     cmpneqpdTkn = 1248,
     cmpnltpdTkn = 1249,
     cmpnlepdTkn = 1250,
     cmpordpdTkn = 1251,
     cmpunordpdTkn = 1252,
     comisdTkn = 1253,
     comissTkn = 1254,
     cvtdq2pdTkn = 1255,
     cvtdq2psTkn = 1256,
     cvtpd2dqTkn = 1257,
     cvtpd2piTkn = 1258,
     cvtpd2psTkn = 1259,
     cvtpi2pdTkn = 1260,
     cvtpi2psTkn = 1261,
     cvtps2dqTkn = 1262,
     cvtps2pdTkn = 1263,
     cvtps2piTkn = 1264,
     cvtsd2siTkn = 1265,
     cvtsi2sdTkn = 1266,
     cvtsi2ssTkn = 1267,
     cvtsd2ssTkn = 1268,
     cvtss2sdTkn = 1269,
     cvtss2siTkn = 1270,
     cvttpd2piTkn = 1271,
     cvttpd2dqTkn = 1272,
     cvttps2dqTkn = 1273,
     cvttps2piTkn = 1274,
     cvttsd2siTkn = 1275,
     cvttss2siTkn = 1276,
     divpdTkn = 1277,
     divpsTkn = 1278,
     divssTkn = 1279,
     divsdTkn = 1280,
     fxsaveTkn = 1281,
     fxrstorTkn = 1282,
     haddpdTkn = 1283,
     haddpsTkn = 1284,
     hsubpdTkn = 1285,
     hsubpsTkn = 1286,
     lddquTkn = 1287,
     ldmxcsrTkn = 1288,
     lfenceTkn = 1289,
     maskmovdquTkn = 1290,
     maskmovqTkn = 1291,
     maxpdTkn = 1292,
     maxpsTkn = 1293,
     maxsdTkn = 1294,
     maxssTkn = 1295,
     mfenceTkn = 1296,
     minpdTkn = 1297,
     minpsTkn = 1298,
     minsdTkn = 1299,
     minssTkn = 1300,
     monitorTkn = 1301,
     movapdTkn = 1302,
     movapsTkn = 1303,
     movddupTkn = 1304,
     movdqaTkn = 1305,
     movdquTkn = 1306,
     movdq2qTkn = 1307,
     movhlpsTkn = 1308,
     movhpdTkn = 1309,
     movhpsTkn = 1310,
     movlpdTkn = 1311,
     movlpsTkn = 1312,
     movlhpsTkn = 1313,
     movmskpdTkn = 1314,
     movmskpsTkn = 1315,
     movntpdTkn = 1316,
     movntiTkn = 1317,
     movntpsTkn = 1318,
     movntdqTkn = 1319,
     movntqTkn = 1320,
     movq2dqTkn = 1321,
     movshdupTkn = 1322,
     movsldupTkn = 1323,
     movssTkn = 1324,
     movupdTkn = 1325,
     movupsTkn = 1326,
     mulpdTkn = 1327,
     mulpsTkn = 1328,
     mulssTkn = 1329,
     mulsdTkn = 1330,
     mwaitTkn = 1331,
     orpdTkn = 1332,
     orpsTkn = 1333,
     pauseTkn = 1334,
     prefetcht0Tkn = 1335,
     prefetcht1Tkn = 1336,
     prefetcht2Tkn = 1337,
     prefetchntaTkn = 1338,
     pshufhwTkn = 1339,
     pshuflwTkn = 1340,
     psrldqTkn = 1341,
     pslldqTkn = 1342,
     rcppsTkn = 1343,
     rcpssTkn = 1344,
     rsqrtpsTkn = 1345,
     rsqrtssTkn = 1346,
     sfenceTkn = 1347,
     shufpdTkn = 1348,
     shufpsTkn = 1349,
     sqrtpdTkn = 1350,
     sqrtpsTkn = 1351,
     sqrtsdTkn = 1352,
     sqrtssTkn = 1353,
     stmxcsrTkn = 1354,
     subpsTkn = 1355,
     subpdTkn = 1356,
     subsdTkn = 1357,
     subssTkn = 1358,
     ucomisdTkn = 1359,
     ucomissTkn = 1360,
     unpckhpdTkn = 1361,
     unpckhpsTkn = 1362,
     unpcklpdTkn = 1363,
     unpcklpsTkn = 1364,
     xorpdTkn = 1365,
     xorpsTkn = 1366,
     parsePrintTkn = 1367,
     parseHLAIDTkn = 1368,
     parseClassIDTkn = 1369
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 950 "hlaparse.bsn"

	unsigned				u;
	int						i;
	char					*idStr;
	char					*returns;
	SymNode_t				*s;
	SymNode_t				v;
	MacroType_t				m;
	struct	adrsYYS			adrs;
	struct	memYYS			mem;
	struct	adrsYYS			*adrsPtr;
	struct	regYYS			reg;
	struct	opnodeYYS		*opnode;
	struct	operandYYS		*operand;
	struct	PointerListType	*plist;
	
	struct
	{
				char	*idStr;		// Must be first!
		SymNode_t *s;
	} neID;  // For anyID ("n" "e" ID :-) )
	
	struct
	{
		int					parmCnt;
		SymNode_t			**types;
		char				*parms;
		enum	ParmForm	*pForms;
	} collectedParms;
	
	struct
	{
		int l;
		int r;
	} rr;
	
	struct
	{
		struct adrsYYS m;
		int r;
	} mr;
	
	struct
	{
		int r;
		struct adrsYYS m;
	} rm;
	

	struct
	{
		SymNode_t *s;
		SymNode_t *cns;
	}en;
	
	struct
	{
		SymNode_t 		*type;
		char			*idStr;
	}nameAndType;
	
	struct
	{
		int				ints[4];
		unsigned		unss[4];
		SymNode_t 		*syms[4];
	}save;
	
		
		
	
	// Attributes for record and unions where we can save important data.
	
	struct
	{
		SymNode_t *endFields;
		SymNode_t *base;
		SymNode_t *saveCurNS;
		SymNode_t *saveRecNS;
		SymNode_t *saveRecGlobal;
		SymNode_t *saveProcNS;
		SymNode_t *saveProcGlobal;
		int MinRecAlignment;
		int MaxRecAlignment;
		int TempRecAlign;
		int RecFieldCnt;
		int CurOffset;
		int SaveOffset;
		int SaveDir;
		int SaveAdd1st;
		int SaveLex;
		char inSave;
		char newOffset;
		
	}ru;
	
	struct
	{
		short			SpecifiedOptions;
		short			UseFrame;
		short			UseDisplay;
		short			AlignStk;
		short			Alignment;
		short			NoStorage;
		short			NoEnter;
		short			NoLeave;
		short			IsVolatile;
		enum CallSeq	CallingSequence;
		char			*returns;
		char			*use;
	}options;


	struct
	{
		int				Disp;
		char			*FullName;
		SymNode_t		*Sym;
		char			*StaticName;
	}dotName;

	struct
	{
		SymNode_t			*sym;
		SymNode_t			*type;
		unsigned			ObjectSize;
		unsigned			cls;
		unsigned			arity;
	}cls;


	struct
	{
		union
		{
			int				label1;
			int				trueTarget;
		}l1;
		union
		{
			int				label2;
			int				falseTarget;
		}l2;
		union
		{
			int				label3;
			int				exitTarget;
		}l3;
		int					label4;
		int					saveTrue;
		int					saveFalse;
		
	}labels;
	
	// The following is used when parsing #for loops.
	
	struct
	{
				SymNode_t	*ControlVar;
		union	YYSTYPE		*inVal;
				int			endVal;
				int			byVal;
		enum	PrimType	pType;
	}forInfo;
	
	struct
	{
		int		cnt;
		int		size;
		char	bytes[8];
	}opcodes;
	
	struct
	{
		int		minRange;
		int		maxRange;
		int		lazy;
	}ranges;
	
	// The following is used to process switch/case/default/endswitch statements:
	
	struct
	{
		unsigned	cnt;
		int			minval;
		int			startOfCases;
		int			defaultLbl;
		int			exitLbl;
		int			*cases;
		int			*caseLbls;
	}cases;
	
	struct
	{
		unsigned	cnt;
		int			*cases;
	} caseVals;
	
	struct
	{
		int			LineCnt;
		char		*FileName;
	} macroInvocation;
	



/* Line 214 of yacc.c  */
#line 2358 "hlaparse.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */

/* Line 264 of yacc.c  */
#line 1159 "hlaparse.bsn"

/*
** Variable that holds ConstExpr return values for the lexer.
*/

		SymNode_t	d1ceReturnVal;
union	YYSTYPE		d1dnReturnVal;
union	YYSTYPE		forReturnVal;


/* Line 264 of yacc.c  */
#line 2381 "hlaparse.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  64
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   146708

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  1137
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  816
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3331
/* YYNRULES -- Number of states.  */
#define YYNSTATES  7731

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   1369

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,  1135,     2,     2,     2,     2,     8,     2,
    1125,  1128,    20,    18,  1133,    19,  1134,    21,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,  1127,  1126,
      12,    14,    13,     2,  1136,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,  1130,     2,  1129,     5,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,  1132,     4,  1131,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     6,
       7,     9,    10,    11,    15,    16,    17,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,  1122,  1123,  1124
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    35,    37,
      39,    48,    57,    64,    66,    68,    70,    75,    79,    80,
      83,    86,    89,    94,   101,   108,   109,   116,   123,   124,
     131,   132,   134,   136,   145,   150,   152,   156,   159,   162,
     163,   164,   169,   174,   179,   184,   186,   187,   194,   196,
     198,   199,   205,   206,   207,   209,   212,   214,   217,   219,
     222,   224,   227,   229,   232,   234,   237,   239,   242,   244,
     247,   249,   252,   254,   257,   258,   260,   262,   264,   266,
     268,   270,   272,   274,   276,   278,   280,   282,   284,   286,
     288,   290,   292,   294,   296,   298,   300,   302,   304,   306,
     308,   311,   317,   324,   326,   332,   334,   340,   342,   345,
     351,   358,   360,   366,   368,   371,   377,   384,   386,   388,
     390,   392,   394,   396,   398,   400,   402,   405,   407,   409,
     411,   413,   415,   417,   419,   421,   423,   425,   427,   429,
     431,   433,   435,   438,   440,   442,   444,   446,   448,   451,
     453,   455,   457,   459,   461,   463,   465,   468,   470,   473,
     475,   477,   479,   481,   483,   485,   487,   489,   490,   495,
     498,   499,   505,   511,   517,   522,   532,   543,   553,   564,
     567,   569,   574,   579,   584,   585,   594,   597,   598,   604,
     610,   616,   622,   628,   634,   640,   646,   651,   656,   657,
     658,   661,   662,   665,   666,   669,   670,   673,   674,   677,
     678,   681,   682,   685,   686,   689,   690,   693,   694,   695,
     696,   697,   716,   717,   720,   721,   727,   733,   739,   745,
     751,   757,   763,   769,   775,   780,   785,   786,   788,   790,
     793,   794,   795,   799,   809,   820,   830,   841,   842,   843,
     844,   854,   855,   864,   866,   868,   870,   872,   874,   876,
     878,   881,   883,   888,   893,   898,   902,   907,   912,   917,
     922,   926,   930,   931,   933,   935,   937,   939,   941,   943,
     945,   947,   949,   951,   953,   955,   957,   959,   961,   963,
     965,   967,   969,   971,   973,   975,   977,   979,   981,   983,
     985,   987,   989,   991,   993,   995,   997,   999,  1001,  1003,
    1005,  1007,  1009,  1011,  1013,  1015,  1017,  1019,  1021,  1023,
    1025,  1027,  1029,  1031,  1033,  1035,  1037,  1039,  1041,  1043,
    1045,  1047,  1049,  1051,  1053,  1055,  1057,  1059,  1061,  1063,
    1065,  1067,  1070,  1071,  1073,  1075,  1077,  1079,  1081,  1083,
    1085,  1087,  1089,  1091,  1093,  1095,  1097,  1099,  1101,  1103,
    1105,  1107,  1109,  1111,  1113,  1115,  1117,  1119,  1121,  1123,
    1125,  1127,  1129,  1131,  1133,  1135,  1137,  1139,  1141,  1143,
    1145,  1147,  1149,  1153,  1155,  1161,  1164,  1165,  1166,  1168,
    1170,  1174,  1179,  1181,  1185,  1187,  1191,  1193,  1195,  1197,
    1202,  1206,  1208,  1210,  1212,  1216,  1221,  1223,  1225,  1233,
    1234,  1239,  1240,  1251,  1253,  1254,  1259,  1261,  1262,  1267,
    1271,  1275,  1276,  1277,  1278,  1279,  1280,  1281,  1282,  1284,
    1289,  1294,  1296,  1301,  1306,  1308,  1310,  1312,  1316,  1318,
    1323,  1327,  1333,  1335,  1336,  1337,  1346,  1348,  1349,  1350,
    1360,  1361,  1364,  1366,  1369,  1372,  1374,  1382,  1388,  1389,
    1399,  1400,  1410,  1411,  1420,  1421,  1430,  1431,  1438,  1439,
    1449,  1458,  1465,  1472,  1480,  1485,  1493,  1501,  1506,  1509,
    1511,  1513,  1517,  1519,  1523,  1524,  1525,  1526,  1538,  1539,
    1540,  1545,  1553,  1557,  1564,  1565,  1567,  1568,  1571,  1575,
    1577,  1580,  1583,  1585,  1591,  1598,  1605,  1610,  1617,  1621,
    1625,  1629,  1633,  1637,  1642,  1648,  1653,  1659,  1663,  1668,
    1673,  1679,  1685,  1690,  1695,  1700,  1706,  1710,  1715,  1720,
    1725,  1730,  1734,  1739,  1743,  1748,  1753,  1758,  1763,  1768,
    1774,  1778,  1783,  1787,  1792,  1797,  1802,  1805,  1809,  1813,
    1821,  1829,  1834,  1839,  1844,  1847,  1850,  1853,  1856,  1859,
    1862,  1865,  1868,  1871,  1874,  1877,  1880,  1884,  1888,  1889,
    1893,  1899,  1904,  1906,  1908,  1910,  1916,  1922,  1924,  1926,
    1928,  1930,  1933,  1936,  1948,  1949,  1950,  1975,  1977,  1979,
    1981,  1983,  1985,  1997,  1998,  1999,  2001,  2002,  2007,  2009,
    2013,  2016,  2020,  2022,  2025,  2027,  2030,  2032,  2034,  2036,
    2038,  2040,  2042,  2044,  2046,  2048,  2050,  2058,  2066,  2067,
    2068,  2069,  2092,  2100,  2103,  2104,  2105,  2106,  2128,  2129,
    2130,  2131,  2132,  2155,  2156,  2157,  2158,  2181,  2182,  2183,
    2184,  2206,  2207,  2208,  2209,  2210,  2211,  2238,  2239,  2240,
    2241,  2242,  2243,  2270,  2271,  2272,  2273,  2274,  2275,  2302,
    2303,  2304,  2305,  2306,  2307,  2334,  2335,  2336,  2337,  2338,
    2339,  2366,  2369,  2370,  2371,  2372,  2373,  2374,  2400,  2401,
    2415,  2416,  2429,  2430,  2444,  2445,  2459,  2460,  2473,  2485,
    2496,  2508,  2520,  2531,  2532,  2546,  2549,  2550,  2563,  2564,
    2565,  2566,  2567,  2592,  2593,  2594,  2595,  2619,  2621,  2622,
    2623,  2624,  2625,  2650,  2651,  2665,  2668,  2669,  2682,  2683,
    2684,  2685,  2686,  2711,  2712,  2713,  2714,  2738,  2739,  2740,
    2759,  2760,  2761,  2768,  2769,  2776,  2777,  2784,  2785,  2792,
    2793,  2800,  2801,  2808,  2809,  2816,  2817,  2818,  2826,  2827,
    2828,  2837,  2838,  2844,  2845,  2851,  2852,  2854,  2855,  2856,
    2861,  2863,  2864,  2865,  2870,  2881,  2884,  2894,  2907,  2919,
    2927,  2935,  2939,  2943,  2946,  2950,  2954,  2957,  2958,  2964,
    2965,  2971,  2972,  2986,  2987,  3001,  3002,  3012,  3022,  3026,
    3030,  3034,  3037,  3040,  3044,  3048,  3051,  3052,  3058,  3059,
    3065,  3066,  3080,  3081,  3096,  3097,  3098,  3109,  3119,  3120,
    3134,  3135,  3149,  3157,  3162,  3166,  3167,  3175,  3176,  3184,
    3185,  3187,  3188,  3193,  3194,  3196,  3199,  3206,  3207,  3217,
    3219,  3226,  3227,  3237,  3238,  3246,  3247,  3258,  3259,  3261,
    3265,  3267,  3269,  3271,  3273,  3275,  3277,  3279,  3286,  3291,
    3295,  3299,  3303,  3307,  3311,  3315,  3319,  3323,  3327,  3331,
    3335,  3339,  3343,  3350,  3353,  3356,  3358,  3363,  3367,  3369,
    3372,  3378,  3382,  3385,  3388,  3391,  3394,  3397,  3400,  3403,
    3406,  3409,  3412,  3415,  3418,  3421,  3427,  3430,  3433,  3434,
    3438,  3440,  3441,  3446,  3448,  3450,  3452,  3457,  3464,  3465,
    3466,  3475,  3476,  3477,  3486,  3491,  3492,  3493,  3504,  3511,
    3512,  3513,  3524,  3533,  3534,  3535,  3548,  3549,  3551,  3553,
    3555,  3557,  3559,  3562,  3565,  3566,  3568,  3572,  3573,  3574,
    3575,  3576,  3577,  3580,  3581,  3583,  3586,  3588,  3596,  3597,
    3598,  3608,  3615,  3622,  3624,  3626,  3628,  3630,  3632,  3634,
    3636,  3638,  3640,  3642,  3644,  3646,  3648,  3650,  3652,  3654,
    3656,  3658,  3660,  3662,  3664,  3666,  3668,  3670,  3672,  3674,
    3676,  3678,  3679,  3689,  3699,  3707,  3712,  3720,  3729,  3736,
    3737,  3738,  3754,  3756,  3763,  3772,  3780,  3785,  3793,  3801,
    3806,  3809,  3810,  3815,  3818,  3819,  3821,  3824,  3826,  3828,
    3833,  3840,  3841,  3852,  3853,  3863,  3865,  3868,  3871,  3874,
    3875,  3877,  3880,  3882,  3884,  3889,  3894,  3899,  3904,  3909,
    3914,  3919,  3924,  3929,  3934,  3939,  3944,  3949,  3954,  3959,
    3964,  3969,  3974,  3979,  3984,  3989,  3994,  3999,  4004,  4013,
    4018,  4023,  4028,  4033,  4038,  4043,  4050,  4057,  4064,  4071,
    4072,  4083,  4084,  4095,  4096,  4106,  4107,  4117,  4125,  4133,
    4138,  4143,  4146,  4148,  4153,  4158,  4163,  4168,  4173,  4178,
    4183,  4188,  4193,  4198,  4203,  4208,  4213,  4218,  4223,  4228,
    4233,  4238,  4243,  4248,  4253,  4258,  4263,  4268,  4276,  4281,
    4286,  4291,  4296,  4299,  4302,  4307,  4312,  4317,  4322,  4329,
    4336,  4343,  4350,  4351,  4362,  4363,  4374,  4375,  4385,  4386,
    4396,  4404,  4412,  4417,  4422,  4425,  4429,  4430,  4432,  4436,
    4440,  4447,  4453,  4462,  4464,  4467,  4469,  4471,  4477,  4478,
    4488,  4489,  4499,  4500,  4501,  4511,  4512,  4521,  4522,  4531,
    4532,  4539,  4540,  4550,  4559,  4560,  4572,  4574,  4581,  4590,
    4595,  4603,  4611,  4616,  4619,  4620,  4629,  4635,  4636,  4647,
    4658,  4666,  4675,  4676,  4677,  4690,  4691,  4703,  4712,  4722,
    4733,  4734,  4747,  4748,  4759,  4760,  4771,  4772,  4783,  4784,
    4795,  4803,  4804,  4813,  4814,  4823,  4824,  4836,  4837,  4848,
    4849,  4861,  4862,  4872,  4880,  4881,  4891,  4892,  4900,  4906,
    4907,  4918,  4927,  4936,  4937,  4949,  4955,  4956,  4957,  4958,
    4960,  4964,  4965,  4968,  4975,  4984,  4992,  4999,  5001,  5003,
    5005,  5007,  5009,  5011,  5013,  5015,  5017,  5019,  5021,  5023,
    5025,  5027,  5029,  5031,  5033,  5035,  5037,  5039,  5041,  5043,
    5045,  5047,  5049,  5051,  5053,  5055,  5057,  5059,  5061,  5062,
    5067,  5069,  5075,  5076,  5077,  5078,  5080,  5084,  5085,  5088,
    5090,  5092,  5099,  5108,  5116,  5118,  5120,  5122,  5133,  5134,
    5145,  5155,  5157,  5159,  5167,  5176,  5178,  5179,  5191,  5193,
    5194,  5203,  5213,  5215,  5223,  5225,  5226,  5235,  5245,  5247,
    5249,  5251,  5252,  5259,  5267,  5269,  5275,  5277,  5278,  5288,
    5299,  5301,  5310,  5311,  5316,  5318,  5324,  5325,  5326,  5327,
    5328,  5331,  5333,  5335,  5337,  5339,  5341,  5343,  5345,  5347,
    5349,  5351,  5353,  5361,  5363,  5365,  5367,  5369,  5371,  5373,
    5375,  5377,  5378,  5383,  5385,  5388,  5394,  5397,  5403,  5408,
    5416,  5418,  5420,  5422,  5424,  5426,  5428,  5430,  5432,  5434,
    5436,  5438,  5440,  5442,  5444,  5446,  5448,  5449,  5451,  5453,
    5455,  5458,  5462,  5464,  5466,  5468,  5470,  5472,  5474,  5476,
    5478,  5480,  5482,  5484,  5486,  5488,  5490,  5491,  5499,  5507,
    5508,  5510,  5512,  5514,  5517,  5520,  5523,  5526,  5528,  5531,
    5534,  5537,  5540,  5545,  5547,  5549,  5551,  5555,  5556,  5558,
    5560,  5566,  5567,  5569,  5573,  5576,  5581,  5582,  5583,  5584,
    5585,  5588,  5591,  5595,  5599,  5603,  5607,  5611,  5615,  5619,
    5623,  5627,  5631,  5635,  5639,  5643,  5647,  5651,  5655,  5659,
    5663,  5668,  5674,  5675,  5681,  5686,  5693,  5698,  5700,  5702,
    5704,  5706,  5708,  5710,  5712,  5714,  5716,  5718,  5720,  5722,
    5724,  5726,  5728,  5730,  5732,  5734,  5736,  5738,  5740,  5742,
    5747,  5752,  5757,  5762,  5767,  5772,  5777,  5782,  5787,  5792,
    5797,  5802,  5807,  5812,  5817,  5822,  5827,  5832,  5837,  5842,
    5847,  5852,  5857,  5862,  5863,  5871,  5876,  5881,  5883,  5888,
    5893,  5898,  5903,  5908,  5913,  5915,  5920,  5925,  5930,  5935,
    5940,  5945,  5950,  5955,  5960,  5965,  5970,  5975,  5980,  5985,
    5990,  5995,  6000,  6005,  6010,  6015,  6020,  6025,  6030,  6035,
    6040,  6045,  6050,  6055,  6060,  6065,  6070,  6072,  6076,  6081,
    6086,  6088,  6092,  6094,  6096,  6103,  6108,  6113,  6118,  6123,
    6128,  6133,  6138,  6143,  6156,  6161,  6166,  6171,  6176,  6181,
    6186,  6188,  6190,  6199,  6204,  6213,  6218,  6227,  6232,  6237,
    6242,  6249,  6254,  6263,  6270,  6279,  6284,  6293,  6298,  6305,
    6310,  6319,  6324,  6333,  6338,  6345,  6350,  6357,  6362,  6369,
    6374,  6381,  6386,  6397,  6402,  6409,  6416,  6421,  6428,  6433,
    6440,  6449,  6460,  6467,  6476,  6487,  6494,  6503,  6514,  6521,
    6530,  6541,  6548,  6557,  6568,  6575,  6584,  6595,  6604,  6615,
    6628,  6637,  6648,  6661,  6670,  6681,  6694,  6703,  6714,  6727,
    6738,  6751,  6766,  6777,  6790,  6805,  6812,  6821,  6832,  6839,
    6848,  6859,  6866,  6875,  6886,  6893,  6902,  6913,  6920,  6929,
    6940,  6947,  6956,  6967,  6974,  6983,  6994,  7001,  7010,  7021,
    7028,  7037,  7048,  7055,  7064,  7075,  7082,  7091,  7102,  7109,
    7118,  7129,  7138,  7149,  7162,  7171,  7182,  7195,  7204,  7215,
    7228,  7237,  7248,  7261,  7270,  7281,  7294,  7303,  7314,  7327,
    7336,  7347,  7360,  7369,  7380,  7393,  7404,  7417,  7432,  7443,
    7456,  7471,  7482,  7495,  7510,  7521,  7534,  7549,  7556,  7565,
    7576,  7589,  7596,  7605,  7616,  7629,  7631,  7633,  7640,  7649,
    7660,  7673,  7680,  7689,  7700,  7713,  7720,  7729,  7740,  7747,
    7756,  7767,  7774,  7783,  7794,  7801,  7810,  7821,  7828,  7837,
    7848,  7855,  7864,  7875,  7880,  7887,  7892,  7899,  7904,  7911,
    7916,  7923,  7928,  7935,  7940,  7947,  7952,  7959,  7968,  7973,
    7980,  7989,  7994,  8001,  8010,  8015,  8022,  8031,  8036,  8043,
    8052,  8057,  8064,  8073,  8078,  8085,  8094,  8099,  8106,  8115,
    8120,  8127,  8136,  8141,  8146,  8148,  8150,  8152,  8154,  8156,
    8158,  8160,  8162,  8164,  8166,  8168,  8170,  8172,  8174,  8176,
    8178,  8180,  8182,  8184,  8186,  8188,  8190,  8192,  8194,  8196,
    8198,  8200,  8202,  8204,  8206,  8208,  8210,  8212,  8217,  8222,
    8227,  8232,  8237,  8242,  8247,  8252,  8257,  8262,  8267,  8272,
    8277,  8282,  8287,  8292,  8297,  8302,  8307,  8315,  8320,  8325,
    8330,  8335,  8340,  8345,  8350,  8355,  8360,  8365,  8366,  8368,
    8374,  8378,  8379,  8380,  8381,  8385,  8386,  8392,  8394,  8397,
    8401,  8405,  8409,  8413,  8416,  8419,  8422,  8425,  8428,  8431,
    8433,  8437,  8438,  8439,  8441,  8445,  8447,  8449,  8452,  8454,
    8457,  8459,  8462,  8464,  8467,  8469,  8472,  8474,  8476,  8478,
    8480,  8482,  8484,  8486,  8488,  8490,  8492,  8494,  8496,  8498,
    8500,  8502,  8505,  8507,  8510,  8516,  8520,  8526,  8532,  8538,
    8547,  8551,  8555,  8559,  8562,  8567,  8568,  8576,  8577,  8579,
    8581,  8583,  8585,  8589,  8591,  8593,  8595,  8597,  8600,  8602,
    8605,  8607,  8609,  8611,  8613,  8615,  8617,  8619,  8622,  8625,
    8628,  8630,  8632,  8634,  8636,  8638,  8640,  8642,  8648,  8652,
    8656,  8661,  8666,  8668,  8669,  8679,  8685,  8691,  8692,  8693,
    8694,  8700,  8701,  8707,  8709,  8713,  8714,  8715,  8716,  8717,
    8718,  8721,  8722,  8723,  8732,  8734,  8737,  8739,  8741,  8743,
    8746,  8748,  8751,  8753,  8756,  8762,  8764,  8765,  8766,  8771,
    8773,  8776,  8778,  8781,  8783,  8786,  8788,  8791,  8793,  8796,
    8798,  8800,  8802,  8804,  8806,  8808,  8810,  8812,  8814,  8816,
    8818,  8820,  8822,  8825,  8828,  8833,  8837,  8843,  8848,  8853,
    8856,  8858,  8861,  8864,  8867,  8870,  8873,  8876,  8879,  8882,
    8885,  8888,  8891,  8894,  8897,  8900,  8903,  8906,  8909,  8912,
    8915,  8918,  8921,  8924,  8927,  8930,  8933,  8936,  8939,  8942,
    8945,  8948,  8951,  8954,  8957,  8960,  8963,  8966,  8969,  8972,
    8975,  8978,  8981,  8984,  8987,  8990,  8993,  8996,  8999,  9004,
    9009,  9014,  9019,  9024,  9029,  9034,  9039,  9044,  9049,  9054,
    9059,  9064,  9070,  9075,  9081,  9086,  9091,  9096,  9101,  9103,
    9105,  9107,  9110,  9112,  9114,  9116,  9118,  9120,  9122,  9124,
    9127,  9130,  9133,  9136,  9139,  9142,  9145,  9147,  9149,  9151,
    9153,  9155,  9157,  9159,  9161,  9163,  9165,  9167,  9169,  9171,
    9173,  9175,  9178,  9181,  9188,  9195,  9202,  9207,  9212,  9217,
    9222,  9227,  9232,  9234,  9236,  9238,  9240,  9242,  9244,  9246,
    9248,  9251,  9254,  9257,  9260,  9263,  9266,  9269,  9272,  9275,
    9278,  9281,  9284,  9287,  9290,  9293,  9296,  9299,  9302,  9305,
    9308,  9311,  9314,  9317,  9320,  9323,  9326,  9329,  9332,  9335,
    9338,  9341,  9344,  9347,  9350,  9355,  9360,  9365,  9370,  9375,
    9380,  9385,  9388,  9393,  9398,  9403,  9408,  9413,  9418,  9423,
    9428,  9430,  9432,  9434,  9436,  9438,  9440,  9442,  9444,  9446,
    9448,  9450,  9452,  9457,  9464,  9466,  9468,  9470,  9472,  9477,
    9484,  9487,  9492,  9499,  9502,  9507,  9514,  9519,  9524,  9529,
    9534,  9539,  9544,  9549,  9554,  9559,  9564,  9569,  9574,  9579,
    9584,  9589,  9594,  9600,  9605,  9610,  9616,  9619,  9626,  9633,
    9640,  9647,  9654,  9661,  9668,  9675,  9682,  9689,  9696,  9703,
    9706,  9709,  9711,  9713,  9715,  9717,  9719,  9721,  9723,  9725,
    9727,  9729,  9731,  9733,  9735,  9737,  9739,  9741,  9743,  9745,
    9747,  9749,  9751,  9753,  9755,  9757,  9759,  9761,  9763,  9765,
    9767,  9769,  9771,  9773,  9775,  9777,  9779,  9781,  9783,  9785,
    9787,  9789,  9791,  9793,  9795,  9797,  9799,  9801,  9803,  9805,
    9807,  9809,  9811,  9813,  9815,  9817,  9820,  9827,  9829,  9831,
    9833,  9835,  9837,  9839,  9842,  9845,  9848,  9851,  9854,  9861,
    9868,  9875,  9882,  9889,  9896,  9898,  9900,  9902,  9907,  9912,
    9914,  9916,  9918,  9920,  9922,  9927,  9932,  9934,  9936,  9938,
    9940,  9945,  9950,  9952,  9954,  9961,  9968,  9975,  9982,  9984,
    9986,  9988,  9990,  9997, 10004, 10007, 10014, 10021, 10023, 10025,
   10028, 10035, 10037, 10039, 10046, 10053, 10055, 10057, 10059, 10062,
   10069, 10071, 10073, 10075, 10077, 10079, 10081, 10083, 10085, 10087,
   10089, 10091, 10093, 10095, 10097, 10099, 10101, 10103, 10105, 10112,
   10119, 10126, 10128, 10130, 10137, 10139, 10141, 10143, 10145, 10147,
   10149, 10151, 10153, 10155, 10157, 10159, 10161, 10163, 10165, 10167,
   10169, 10171, 10173, 10175, 10177, 10179, 10181, 10183, 10185, 10187,
   10189, 10191, 10193, 10195, 10197, 10199, 10201, 10203, 10205, 10207,
   10209, 10211, 10213, 10215, 10217, 10219, 10222, 10229, 10232, 10239,
   10241, 10243, 10245, 10247, 10249, 10251, 10254, 10257, 10260, 10263,
   10266, 10269, 10276, 10283, 10290, 10297, 10300, 10303, 10306, 10308,
   10310, 10312, 10314, 10323, 10332, 10339, 10348, 10350, 10352, 10354,
   10356, 10358, 10360, 10362, 10364, 10366, 10368, 10375, 10382, 10385,
   10392, 10395, 10402, 10404, 10406, 10408, 10410, 10412, 10414, 10416,
   10418, 10420, 10422, 10424, 10426, 10428, 10430, 10432, 10434, 10439,
   10444, 10446, 10448, 10450, 10452, 10454, 10456, 10458, 10465, 10472,
   10479, 10486, 10493, 10495, 10497, 10506, 10515, 10524, 10533, 10540,
   10547, 10549, 10551, 10553, 10555, 10557, 10564, 10571, 10579, 10587,
   10594, 10601, 10608, 10615, 10623, 10631, 10639, 10647, 10649, 10651,
   10658, 10665, 10672, 10679, 10686, 10693, 10700, 10702, 10704, 10706,
   10708, 10710, 10712, 10714, 10716, 10723, 10726, 10735, 10742, 10744,
   10746, 10748, 10750, 10752, 10754, 10756, 10758, 10767, 10774, 10783,
   10790, 10792, 10794, 10796, 10798, 10800, 10802, 10804, 10806, 10813,
   10816, 10825, 10828, 10830, 10832, 10834, 10836, 10838, 10840, 10842,
   10844, 10851, 10854, 10863, 10866, 10873, 10882, 10891, 10900, 10909,
   10918, 10927, 10929, 10931, 10938, 10947, 10952, 10957, 10964, 10971,
   10978, 10985, 10992, 10999, 11002, 11005, 11007, 11009, 11011, 11013,
   11016, 11023, 11025, 11027, 11034, 11041, 11048, 11055, 11062, 11069,
   11071, 11073, 11080, 11087, 11089, 11091, 11098, 11105, 11107, 11109,
   11116, 11123, 11125, 11127, 11134, 11141, 11143, 11145, 11152, 11159,
   11166, 11173, 11175, 11177, 11179, 11181, 11183, 11188, 11191, 11194,
   11197, 11200, 11203, 11206, 11208, 11210, 11215, 11217, 11219, 11221,
   11223, 11225, 11227, 11229, 11231, 11233, 11235, 11237, 11239, 11241,
   11243, 11250, 11257, 11264, 11271, 11278, 11285, 11292, 11299, 11306,
   11313, 11320, 11327, 11334, 11336, 11338, 11340, 11342, 11344, 11346,
   11348, 11350, 11355, 11360, 11365, 11368, 11371, 11374, 11378, 11382,
   11386, 11388, 11390, 11392, 11394, 11399, 11405, 11410, 11416, 11422,
   11427, 11430, 11433, 11436, 11440, 11444, 11448, 11450, 11452, 11457,
   11463, 11468, 11474, 11480, 11485, 11492, 11501, 11508, 11515, 11522,
   11529, 11534, 11536, 11538, 11540, 11542, 11544, 11546, 11548, 11550,
   11552, 11554, 11556, 11558, 11560, 11562, 11564, 11566, 11568, 11570,
   11572, 11574, 11576, 11578, 11580, 11582, 11584, 11586, 11588, 11590,
   11592, 11594, 11596, 11598, 11600, 11602, 11604, 11606, 11608, 11611,
   11616, 11620, 11626, 11633, 11640, 11647, 11654, 11661, 11663, 11665,
   11672, 11679, 11686, 11689, 11691, 11693, 11695, 11697, 11700, 11703,
   11705, 11707, 11709, 11711, 11713, 11715, 11717, 11719, 11721, 11723,
   11725, 11727, 11729, 11731, 11733, 11735, 11737, 11739, 11741, 11743,
   11745, 11747, 11749, 11751, 11753, 11755, 11757, 11759, 11761, 11763,
   11765, 11767, 11769, 11771, 11773, 11775, 11777, 11779, 11781, 11783,
   11785, 11787, 11789, 11791, 11793, 11795, 11797, 11799, 11801, 11803,
   11805, 11807, 11809, 11811, 11813, 11815, 11817, 11819, 11821, 11823,
   11825, 11828, 11835, 11842, 11849, 11856, 11863, 11870, 11875, 11878,
   11880, 11882, 11884, 11886, 11888, 11895, 11902, 11909, 11916, 11923,
   11930, 11937, 11944, 11951, 11958, 11965, 11972, 11979, 11986, 11993,
   12000, 12007, 12014, 12021, 12023, 12025, 12027, 12029, 12032, 12034,
   12037, 12044, 12051, 12058, 12065, 12072, 12079, 12086, 12095, 12104,
   12111, 12116, 12119, 12122, 12126, 12132, 12137, 12142, 12144, 12146,
   12148, 12150, 12152, 12154, 12156, 12158, 12160, 12162, 12164, 12166,
   12171, 12176, 12181, 12188, 12195, 12202, 12209, 12218, 12219, 12220,
   12221, 12222, 12228, 12236, 12237, 12246, 12247, 12256, 12257, 12268,
   12269, 12270, 12284, 12285, 12286, 12302, 12304, 12306, 12308, 12311,
   12313, 12314, 12318, 12319, 12326, 12331, 12336, 12341, 12346, 12351,
   12356, 12372, 12373, 12392, 12393, 12394, 12395, 12396, 12406, 12407,
   12420, 12421, 12422, 12435, 12436, 12452, 12453, 12454, 12456, 12458,
   12470, 12471, 12472, 12473, 12487, 12488, 12489, 12491, 12493, 12495,
   12497, 12499, 12501, 12502, 12511, 12512, 12521, 12522, 12534, 12535,
   12546, 12547, 12559, 12561, 12563, 12564, 12570, 12571, 12579, 12582,
   12589, 12590, 12599, 12600, 12602, 12608, 12616, 12617, 12619, 12625,
   12633, 12634, 12635, 12636, 12644, 12652, 12661, 12670, 12671, 12672,
   12682, 12683, 12684, 12697, 12709, 12710, 12724, 12725, 12737, 12738,
   12739, 12755, 12769, 12770, 12786, 12789, 12801, 12802, 12812, 12825,
   12826, 12827, 12838, 12850, 12860, 12873, 12884, 12885, 12886, 12887,
   12889, 12891, 12901, 12903, 12904, 12908, 12910, 12911, 12918, 12919,
   12928, 12929, 12931, 12935, 12939, 12943, 12947, 12952, 12956, 12960,
   12964, 12968, 12972, 12976, 12980, 12982, 12985, 12989, 12993, 12999,
   13005, 13007, 13010, 13012, 13015, 13017, 13020, 13023, 13027, 13031,
   13035, 13039, 13043, 13047, 13051, 13053, 13055, 13057, 13059, 13061,
   13063, 13065, 13067, 13069, 13071, 13073, 13075, 13077, 13079, 13081,
   13083, 13085, 13087, 13089, 13091, 13093, 13095, 13097, 13099, 13101,
   13103, 13105, 13107, 13109, 13111, 13113, 13115, 13117, 13119, 13121,
   13123, 13125, 13128, 13130, 13133, 13135, 13138, 13140, 13143, 13146,
   13149, 13153, 13157, 13160, 13163, 13167, 13171, 13173, 13175, 13177,
   13179, 13181, 13183, 13185, 13187, 13190, 13191, 13195, 13197, 13200,
   13203, 13208, 13214, 13218, 13222, 13228, 13235, 13240, 13244, 13249,
   13250, 13252, 13256, 13261, 13266, 13268, 13270, 13272, 13276, 13278,
   13284, 13291, 13298, 13306, 13313, 13321, 13329, 13338, 13344, 13346,
   13350, 13354, 13356, 13358, 13360, 13361, 13362, 13366, 13372, 13376,
   13378, 13379, 13380, 13382, 13384, 13386, 13388, 13390, 13392, 13394,
   13396, 13400, 13405, 13409, 13414, 13418, 13423, 13427, 13432, 13440,
   13449, 13453, 13458, 13466, 13475, 13479, 13484, 13492, 13501, 13505,
   13510, 13514, 13519, 13520, 13521, 13524, 13527, 13531, 13534, 13536,
   13543, 13550, 13559, 13568, 13575, 13584, 13585, 13587, 13589, 13591,
   13594, 13597, 13600, 13604, 13608, 13612, 13618, 13626, 13634, 13638,
   13644, 13650, 13658, 13660, 13663, 13665, 13668, 13671, 13675, 13680,
   13686, 13689, 13693, 13695, 13699, 13702, 13704, 13706, 13708, 13710,
   13712, 13714, 13716, 13718, 13720, 13728, 13732, 13737, 13744, 13750,
   13753, 13756, 13760, 13764, 13768, 13772, 13776, 13780, 13784, 13788,
   13792, 13796, 13800, 13804, 13808, 13812, 13816, 13820, 13824, 13829,
   13833, 13840
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
    1138,     0,    -1,  1226,    -1,  1212,    -1,  1205,    -1,  1142,
      -1,  1166,    -1,  1145,    -1,  1146,    -1,  1143,    -1,  1148,
      -1,  1159,    -1,  1160,    -1,  1157,    -1,  1149,    -1,  1151,
      -1,  1156,    -1,  1153,    -1,  1139,    -1,  1147,    -1,    84,
    1175,  1141,    37,  1664,   138,  1664,  1176,    -1,    84,  1175,
    1141,    37,  1664,   139,  1664,  1176,    -1,    84,  1175,  1141,
      11,  1664,  1176,    -1,    46,    -1,  1140,    -1,  1256,    -1,
      81,  1125,  1662,  1176,    -1,  1144,    82,  1557,    -1,    -1,
      78,  1344,    -1,    79,  1323,    -1,    80,  1326,    -1,    83,
    1125,  1662,  1176,    -1,    85,  1175,  1140,  1176,  1150,    86,
      -1,    85,  1175,  1256,  1176,  1150,    86,    -1,    -1,    87,
    1175,  1140,  1176,  1152,    88,    -1,    87,  1175,  1256,  1176,
    1152,    88,    -1,    -1,    91,  1175,  1256,  1176,  1154,    92,
      -1,    -1,  1140,    -1,  1256,    -1,    89,  1175,  1662,  1181,
    1155,  1181,  1155,  1176,    -1,  1122,  1175,  1158,  1176,    -1,
    1662,    -1,  1158,  1181,  1662,    -1,  1123,  1163,    -1,  1124,
    1164,    -1,    -1,    -1,  1161,  1162,  1690,  1691,    -1,  1161,
    1162,  1690,  1290,    -1,  1161,  1162,  1690,  1290,    -1,  1161,
    1162,  1690,  1692,    -1,  1125,    -1,    -1,    77,  1165,  1171,
    1167,  1168,  1176,    -1,  1170,    -1,    76,    -1,    -1,    75,
    1181,  1171,  1169,  1168,    -1,    -1,    -1,  1126,    -1,  1182,
       1,    -1,  1127,    -1,  1182,     1,    -1,    37,    -1,  1182,
       1,    -1,  1125,    -1,  1182,     1,    -1,  1128,    -1,  1182,
       1,    -1,  1129,    -1,  1182,     1,    -1,  1130,    -1,  1182,
       1,    -1,  1131,    -1,  1182,     1,    -1,  1132,    -1,  1182,
       1,    -1,  1133,    -1,  1182,     1,    -1,    -1,   445,    -1,
     446,    -1,   449,    -1,   450,    -1,   453,    -1,   454,    -1,
     457,    -1,   458,    -1,   447,    -1,   451,    -1,   455,    -1,
     459,    -1,   467,    -1,   465,    -1,   461,    -1,   463,    -1,
     448,    -1,   452,    -1,   456,    -1,   460,    -1,   466,    -1,
     462,    -1,   464,    -1,   468,    -1,  1183,    -1,  1702,  1183,
      -1,  1125,   117,  1249,  1186,  1176,    -1,  1702,  1125,   117,
    1249,  1186,  1176,    -1,  1183,    -1,  1125,   117,  1249,  1186,
    1176,    -1,  1184,    -1,  1125,   117,  1249,  1189,  1176,    -1,
    1184,    -1,  1702,  1184,    -1,  1125,   117,  1249,  1189,  1176,
      -1,  1702,  1125,   117,  1249,  1189,  1176,    -1,  1185,    -1,
    1125,   117,  1249,  1191,  1176,    -1,  1185,    -1,  1702,  1185,
      -1,  1125,   117,  1249,  1191,  1176,    -1,  1702,  1125,   117,
    1249,  1191,  1176,    -1,  1187,    -1,  1188,    -1,  1190,    -1,
    1186,    -1,  1189,    -1,  1191,    -1,  1189,    -1,  1191,    -1,
    1196,    -1,  1702,  1196,    -1,   469,    -1,   470,    -1,   471,
      -1,   472,    -1,   473,    -1,   474,    -1,   475,    -1,   476,
      -1,   487,    -1,   485,    -1,   490,    -1,   486,    -1,   488,
      -1,   489,    -1,  1197,    -1,  1702,  1197,    -1,   491,    -1,
     493,    -1,   494,    -1,   495,    -1,  1199,    -1,  1702,  1199,
      -1,   499,    -1,   500,    -1,   501,    -1,   502,    -1,   505,
      -1,   506,    -1,  1201,    -1,  1702,  1201,    -1,  1204,    -1,
    1702,  1204,    -1,   477,    -1,   478,    -1,   479,    -1,   480,
      -1,   481,    -1,   482,    -1,   483,    -1,   484,    -1,    -1,
     265,  1206,  1207,   266,    -1,  1234,  1208,    -1,    -1,  1208,
    1216,   113,  1543,  1219,    -1,  1208,  1216,   115,  1549,  1218,
      -1,  1208,  1216,   117,  1531,  1221,    -1,  1208,  1216,  1209,
    1234,    -1,   165,  1259,  1240,  1172,  1236,  1210,    94,  1260,
    1172,    -1,   165,  1259,  1240,  1172,  1237,  1236,  1210,    94,
    1260,  1172,    -1,   165,    52,  1241,  1172,  1236,  1210,    94,
    1260,  1172,    -1,   165,    52,  1241,  1172,  1237,  1236,  1210,
      94,  1260,  1172,    -1,  1234,  1211,    -1,  1290,    -1,  1211,
     113,  1543,  1219,    -1,  1211,   115,  1549,  1220,    -1,  1211,
     117,  1531,  1221,    -1,    -1,   101,    46,  1213,  1172,  1214,
      94,  1260,  1172,    -1,  1234,  1215,    -1,    -1,  1215,  1216,
     111,  1542,  1217,    -1,  1215,  1216,   113,  1543,  1219,    -1,
    1215,  1216,   115,  1549,  1218,    -1,  1215,  1216,   117,  1531,
    1221,    -1,  1215,  1216,   122,  1627,  1222,    -1,  1215,  1216,
     124,  1649,  1223,    -1,  1215,  1216,   126,  1635,  1224,    -1,
    1215,  1216,    95,  1358,  1225,    -1,  1215,  1216,  1361,  1234,
      -1,  1215,  1216,  1239,  1234,    -1,    -1,    -1,   112,  1235,
      -1,    -1,   121,  1235,    -1,    -1,   114,  1235,    -1,    -1,
     116,  1235,    -1,    -1,   118,  1235,    -1,    -1,   123,  1235,
      -1,    -1,   125,  1235,    -1,    -1,   127,  1235,    -1,    -1,
      96,  1235,    -1,    -1,    -1,    -1,    -1,   100,    46,  1227,
    1231,  1172,  1232,    93,  1260,  1228,  1172,  1229,  1695,    94,
    1260,  1172,  1230,  1695,    94,    -1,    -1,  1234,  1233,    -1,
      -1,  1233,  1216,   111,  1542,  1217,    -1,  1233,  1216,   113,
    1543,  1219,    -1,  1233,  1216,   115,  1549,  1220,    -1,  1233,
    1216,   117,  1531,  1221,    -1,  1233,  1216,   120,  1562,  1218,
      -1,  1233,  1216,   122,  1627,  1222,    -1,  1233,  1216,   124,
    1649,  1223,    -1,  1233,  1216,   126,  1635,  1224,    -1,  1233,
    1216,    95,  1358,  1225,    -1,  1233,  1216,  1361,  1234,    -1,
    1233,  1216,  1239,  1234,    -1,    -1,  1235,    -1,  1126,    -1,
    1235,  1126,    -1,    -1,    -1,   166,  1238,  1172,    -1,   165,
    1259,  1240,  1172,  1236,  1245,    94,  1260,  1172,    -1,   165,
    1259,  1240,  1172,  1237,  1236,  1245,    94,  1260,  1172,    -1,
     165,    52,  1241,  1172,  1236,  1245,    94,  1260,  1172,    -1,
     165,    52,  1241,  1172,  1237,  1236,  1245,    94,  1260,  1172,
      -1,    -1,    -1,    -1,   165,  1244,  1172,  1237,  1242,  1245,
      94,  1260,  1172,    -1,    -1,   165,  1244,  1172,  1243,  1245,
      94,  1260,  1172,    -1,    53,    -1,    54,    -1,    55,    -1,
      56,    -1,    57,    -1,    58,    -1,    59,    -1,  1234,  1246,
      -1,  1290,    -1,  1246,   113,  1543,  1219,    -1,  1246,   115,
    1549,  1220,    -1,  1246,   117,  1531,  1221,    -1,  1246,  1247,
    1218,    -1,  1246,   122,  1627,  1222,    -1,  1246,   124,  1649,
    1223,    -1,  1246,   126,  1635,  1224,    -1,  1246,    95,  1358,
    1225,    -1,  1246,  1361,  1234,    -1,   120,  1248,  1562,    -1,
      -1,  1252,    -1,  1250,    -1,  1251,    -1,   174,    -1,   211,
      -1,   212,    -1,   213,    -1,   214,    -1,   215,    -1,   216,
      -1,   223,    -1,   224,    -1,   225,    -1,   226,    -1,   227,
      -1,   234,    -1,   235,    -1,   236,    -1,   237,    -1,   238,
      -1,   239,    -1,   217,    -1,   218,    -1,   219,    -1,   220,
      -1,   221,    -1,   222,    -1,   228,    -1,   230,    -1,   229,
      -1,   231,    -1,   233,    -1,   232,    -1,    52,    -1,    60,
      -1,    59,    -1,    67,    -1,  1252,    -1,  1251,    -1,    52,
      -1,    54,    -1,    55,    -1,    56,    -1,    57,    -1,    58,
      -1,    59,    -1,    53,    -1,    60,    -1,    62,    -1,    63,
      -1,    64,    -1,    65,    -1,    66,    -1,    67,    -1,    61,
      -1,  1254,    -1,  1255,    -1,    53,    -1,    61,    -1,    55,
      -1,    63,    -1,  1255,    -1,  1140,    -1,    46,    -1,  1254,
      -1,  1255,    -1,    67,    -1,    59,    -1,  1263,    46,    -1,
      -1,  1260,    -1,  1265,    -1,   211,    -1,   212,    -1,   213,
      -1,   214,    -1,   215,    -1,   216,    -1,   217,    -1,   218,
      -1,   219,    -1,   220,    -1,   221,    -1,   222,    -1,   223,
      -1,   224,    -1,   225,    -1,   226,    -1,   227,    -1,   228,
      -1,   229,    -1,   230,    -1,   232,    -1,   231,    -1,   233,
      -1,   234,    -1,   235,    -1,   236,    -1,   237,    -1,   238,
      -1,   239,    -1,   174,    -1,    52,    -1,    54,    -1,    55,
      -1,    59,    -1,    56,    -1,    57,    -1,    58,    -1,  1130,
    1269,  1177,    -1,  1268,    -1,  1664,     3,  1178,  1269,  1177,
      -1,  1270,  1273,    -1,    -1,    -1,  1290,    -1,  1133,    -1,
    1662,  1272,  1271,    -1,  1662,  1133,  1271,  1273,    -1,  1662,
      -1,  1274,  1181,  1662,    -1,  1662,    -1,  1275,  1133,  1662,
      -1,  1257,    -1,  1278,    -1,  1277,    -1,  1276,  1130,  1275,
    1177,    -1,  1276,  1134,  1260,    -1,  1256,    -1,  1280,    -1,
    1281,    -1,  1279,  1134,  1260,    -1,  1279,  1130,  1275,  1177,
      -1,  1283,    -1,  1662,    -1,   130,  1134,  1260,  1173,  1178,
    1662,  1177,    -1,    -1,  1662,  1133,  1284,  1283,    -1,    -1,
     130,  1134,  1260,  1173,  1178,  1662,  1177,  1133,  1285,  1283,
      -1,  1259,    -1,    -1,  1259,  1133,  1287,  1286,    -1,  1254,
      -1,    -1,  1254,  1133,  1288,  1286,    -1,  1289,     1,  1131,
      -1,  1289,     1,  1126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1290,    -1,   136,  1175,  1249,  1176,    -1,   136,
    1175,    46,  1176,    -1,  1290,    -1,   136,  1175,  1256,  1176,
      -1,   136,  1175,    46,  1176,    -1,   130,    -1,   128,    -1,
    1290,    -1,    37,  1664,  1172,    -1,  1301,    -1,  1301,    37,
    1664,  1172,    -1,  1130,  1664,  1177,    -1,  1130,  1664,  1127,
    1664,  1177,    -1,  1308,    -1,    -1,    -1,  1302,  1298,  1303,
    1305,   131,  1172,  1304,  1308,    -1,  1308,    -1,    -1,    -1,
    1305,  1299,  1300,  1306,  1302,   129,  1172,  1307,  1308,    -1,
      -1,  1308,  1310,    -1,  1259,    -1,   144,  1254,    -1,   144,
    1259,    -1,  1126,    -1,  1309,  1173,   145,  1175,  1259,  1176,
    1172,    -1,   119,  1175,  1664,  1176,  1172,    -1,    -1,  1309,
    1173,    97,  1291,  1292,  1311,  1505,  1172,  1501,    -1,    -1,
    1309,  1173,   137,   138,    97,  1256,  1312,  1172,  1501,    -1,
      -1,  1309,  1173,   137,   138,  1260,  1313,  1172,  1501,    -1,
      -1,  1309,  1173,   137,   138,  1537,  1314,  1172,  1501,    -1,
      -1,  1309,  1173,  1249,  1315,  1172,  1501,    -1,    -1,  1309,
    1173,  1249,  1130,  1274,  1177,  1316,  1172,  1501,    -1,  1309,
    1173,  1299,  1300,  1297,  1302,   129,  1172,    -1,  1309,  1173,
    1298,  1305,   131,  1172,    -1,  1254,  1173,   130,  1305,   131,
    1172,    -1,  1254,  1173,   128,  1300,  1302,   129,  1172,    -1,
    1254,  1127,     1,  1126,    -1,  1254,  1173,   135,  1180,  1286,
    1179,  1172,    -1,  1309,  1173,    46,  1130,  1274,  1177,  1172,
      -1,  1309,  1173,    46,  1172,    -1,     1,  1126,    -1,  1290,
      -1,  1318,    -1,   140,  1319,  1172,    -1,  1290,    -1,  1125,
    1664,  1176,    -1,    -1,    -1,    -1,   107,  1259,  1352,  1354,
    1352,  1357,  1352,  1350,  1324,   109,   108,    -1,    -1,    -1,
    1327,  1328,  1330,   108,    -1,  1327,  1328,  1330,   110,  1325,
    1662,   108,    -1,  1327,  1328,   108,    -1,  1327,  1328,   110,
    1325,  1662,   108,    -1,    -1,  1329,    -1,    -1,  1332,  1331,
      -1,     4,  1329,  1330,    -1,  1290,    -1,  1334,  1333,    -1,
    1133,  1332,    -1,  1290,    -1,  1175,  1329,  1330,  1176,  1341,
      -1,    42,  1175,  1329,  1330,  1176,  1341,    -1,    43,  1175,
    1329,  1330,  1176,  1341,    -1,  1130,  1269,  1177,  1329,    -1,
      12,  1329,  1330,    13,  1127,  1260,    -1,  1134,  1341,  1329,
      -1,  1175,  1662,  1176,    -1,    49,  1335,  1329,    -1,    50,
    1335,  1329,    -1,  1175,  1662,  1176,    -1,   313,  1336,  1341,
    1329,    -1,    19,   313,  1336,  1341,  1329,    -1,   325,  1336,
    1341,  1329,    -1,    19,   325,  1336,  1341,  1329,    -1,    32,
    1341,  1329,    -1,    19,    32,  1341,  1329,    -1,  1135,    32,
    1341,  1329,    -1,  1135,    19,    32,  1341,  1329,    -1,    19,
    1135,    32,  1341,  1329,    -1,   312,  1336,  1341,  1329,    -1,
      21,    32,  1341,  1329,    -1,   324,  1336,  1341,  1329,    -1,
      21,  1135,    32,  1341,  1329,    -1,  1175,  1662,  1176,    -1,
     352,  1337,  1341,  1329,    -1,   353,  1337,  1341,  1329,    -1,
     336,  1337,  1341,  1329,    -1,   337,  1337,  1341,  1329,    -1,
    1668,  1341,  1329,    -1,  1135,  1668,  1341,  1329,    -1,    19,
    1668,  1329,    -1,  1135,    19,  1668,  1329,    -1,    19,  1135,
    1668,  1329,    -1,   349,  1337,  1341,  1329,    -1,    21,  1668,
    1341,  1329,    -1,   350,  1337,  1341,  1329,    -1,    21,  1135,
    1668,  1341,  1329,    -1,  1175,  1662,  1176,    -1,   301,  1338,
    1341,  1329,    -1,  1674,  1341,  1329,    -1,    19,  1674,  1341,
    1329,    -1,   300,  1338,  1341,  1329,    -1,    21,  1674,  1341,
    1329,    -1,  1340,  1329,    -1,  1340,    20,  1329,    -1,  1340,
      18,  1329,    -1,  1340,  1127,  1130,  1342,  1343,  1177,  1329,
      -1,  1340,    41,  1130,  1342,  1343,  1177,  1329,    -1,  1340,
      41,    20,  1329,    -1,  1340,    41,    18,  1329,    -1,  1340,
    1127,  1260,  1329,    -1,   347,  1329,    -1,   358,  1329,    -1,
     351,  1329,    -1,   354,  1329,    -1,   355,  1329,    -1,   357,
    1329,    -1,   359,  1329,    -1,   360,  1329,    -1,   361,  1329,
      -1,   362,  1329,    -1,   363,  1329,    -1,   364,  1329,    -1,
     348,  1341,  1329,    -1,    51,  1341,  1329,    -1,    -1,    47,
    1339,  1329,    -1,    47,  1339,  1127,  1260,  1329,    -1,    48,
    1127,  1260,  1329,    -1,    53,    -1,    61,    -1,  1290,    -1,
    1127,  1130,  1342,  1343,  1177,    -1,    41,  1130,  1342,  1343,
    1177,    -1,    20,    -1,    18,    -1,  1664,    -1,  1290,    -1,
    1133,  1342,    -1,  1133,    20,    -1,  1347,  1259,  1352,  1354,
    1352,  1357,  1352,  1350,  1353,   106,   105,    -1,    -1,    -1,
    1347,  1259,  1352,  1354,  1352,  1357,  1352,  1350,  1353,   106,
    1345,  1351,  1352,  1346,  1348,  1259,  1354,  1352,  1357,  1352,
    1350,  1353,   106,   105,    -1,   102,    -1,   104,    -1,   103,
      -1,  1172,    -1,  1290,    -1,  1351,  1349,  1259,  1352,  1354,
    1352,  1357,  1352,  1350,  1353,   106,    -1,    -1,    -1,  1290,
      -1,    -1,  1125,  1355,  1356,  1176,    -1,  1260,    -1,  1260,
    1130,  1177,    -1,   228,  1260,    -1,  1260,  1133,  1356,    -1,
    1290,    -1,  1127,  1356,    -1,  1290,    -1,  1358,  1359,    -1,
    1126,    -1,    56,    -1,    57,    -1,    58,    -1,    64,    -1,
      65,    -1,    66,    -1,    72,    -1,    73,    -1,    74,    -1,
    1259,  1127,   142,  1724,  1360,  1319,  1172,    -1,    68,  1127,
     142,  1724,  1360,  1319,  1172,    -1,    -1,    -1,    -1,    97,
    1259,  1291,  1292,  1530,  1526,  1505,  1172,  1501,  1362,  1232,
      93,  1260,  1172,  1363,  1695,    94,  1260,  1172,  1364,  1695,
      94,    -1,  1259,  1173,   145,  1175,  1259,  1176,  1172,    -1,
    1127,    97,    -1,    -1,    -1,    -1,  1259,  1365,  1291,  1292,
    1530,  1526,  1505,  1502,  1366,  1232,    93,  1260,  1172,  1367,
    1695,    94,  1260,  1172,  1368,  1695,    94,    -1,    -1,    -1,
      -1,    -1,  1259,  1127,  1249,  1369,  1291,  1292,  1530,  1526,
    1502,  1370,  1232,    93,  1260,  1172,  1371,  1695,    94,  1260,
    1172,  1372,  1695,    94,    -1,    -1,    -1,    -1,    98,  1259,
    1291,  1292,  1530,  1528,  1505,  1172,  1501,  1373,  1232,    93,
    1260,  1172,  1374,  1695,    94,  1260,  1172,  1375,  1695,    94,
      -1,    -1,    -1,    -1,  1259,  1404,  1291,  1292,  1530,  1528,
    1505,  1502,  1376,  1232,    93,  1260,  1172,  1377,  1695,    94,
    1260,  1172,  1378,  1695,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    97,    72,  1291,  1292,  1530,  1481,  1379,  1488,  1380,
    1172,  1501,  1381,  1487,  1216,  1232,    93,  1260,  1172,  1382,
    1695,    94,  1260,  1172,  1383,  1695,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    72,  1127,    97,  1291,  1292,  1530,  1481,
    1384,  1488,  1385,  1502,  1386,  1487,  1216,  1232,    93,  1260,
    1172,  1387,  1695,    94,  1260,  1172,  1388,  1695,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    99,    74,  1291,  1292,  1530,
    1481,  1389,  1488,  1390,  1172,  1501,  1391,  1487,  1216,  1232,
      93,  1260,  1172,  1392,  1695,    94,  1260,  1172,  1393,  1695,
      94,    -1,    -1,    -1,    -1,    -1,    -1,    74,  1173,    99,
    1291,  1292,  1530,  1481,  1394,  1488,  1395,  1502,  1396,  1487,
    1216,  1232,    93,  1260,  1172,  1397,  1695,    94,  1260,  1172,
    1398,  1695,    94,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      73,  1291,  1292,  1530,  1481,  1399,  1488,  1400,  1172,  1501,
    1401,  1487,  1216,  1232,    93,  1260,  1172,  1402,  1695,    94,
    1260,  1172,  1403,  1695,    94,    -1,  1127,    98,    -1,    -1,
      -1,    -1,    -1,    -1,    73,  1404,  1291,  1292,  1530,  1481,
    1405,  1488,  1406,  1502,  1407,  1487,  1216,  1232,    93,  1260,
    1172,  1408,  1695,    94,  1260,  1172,  1409,  1695,    94,    -1,
      -1,    97,  1259,  1291,  1292,  1530,  1526,  1505,  1172,  1501,
     140,  1410,  1499,  1172,    -1,    -1,  1259,  1365,  1291,  1292,
    1530,  1526,  1505,  1502,   140,  1411,  1499,  1172,    -1,    -1,
    1259,  1127,  1249,  1369,  1291,  1292,  1530,  1526,  1502,   140,
    1412,  1499,  1172,    -1,    -1,    98,  1259,  1291,  1292,  1530,
    1528,  1505,  1172,  1501,   140,  1413,  1499,  1172,    -1,    -1,
    1259,  1404,  1291,  1292,  1530,  1528,  1505,  1502,   140,  1414,
    1499,  1172,    -1,    97,  1259,  1291,  1292,  1530,  1526,  1505,
    1172,  1501,   145,  1172,    -1,  1259,  1365,  1291,  1292,  1530,
    1526,  1505,  1502,   145,  1172,    -1,  1259,  1127,  1249,  1369,
    1291,  1292,  1530,  1526,  1502,   145,  1172,    -1,    98,  1259,
    1291,  1292,  1530,  1528,  1505,  1172,  1501,   145,  1172,    -1,
    1259,  1404,  1291,  1292,  1530,  1528,  1505,  1502,   145,  1172,
      -1,    -1,    97,  1291,  1292,  1530,    56,  1488,  1418,  1172,
    1501,   140,  1415,  1499,  1172,    -1,  1127,    97,    -1,    -1,
      56,  1291,  1292,  1530,  1416,  1488,  1418,  1502,   140,  1417,
    1499,  1172,    -1,    -1,    -1,    -1,    -1,    97,  1291,  1292,
    1530,    56,  1488,  1418,  1172,  1501,  1419,  1487,  1216,  1232,
      93,  1260,  1172,  1420,  1695,    94,  1260,  1172,  1421,  1695,
      94,    -1,    -1,    -1,    -1,    56,  1291,  1292,  1530,  1416,
    1488,  1418,  1502,  1422,  1487,  1216,  1232,    93,  1260,  1172,
    1423,  1695,    94,  1260,  1172,  1424,  1695,    94,    -1,  1249,
      -1,    -1,    -1,    -1,    -1,    56,  1291,  1292,  1530,  1127,
    1426,  1425,  1418,  1502,  1427,  1487,  1216,  1232,    93,  1260,
    1172,  1428,  1695,    94,  1260,  1172,  1429,  1695,    94,    -1,
      -1,    98,  1291,  1292,  1530,    57,  1488,  1433,  1172,  1501,
     140,  1430,  1499,  1172,    -1,  1127,    98,    -1,    -1,    57,
    1291,  1292,  1530,  1431,  1488,  1433,  1502,   140,  1432,  1499,
    1172,    -1,    -1,    -1,    -1,    -1,    98,  1291,  1292,  1530,
      57,  1488,  1433,  1172,  1501,  1434,  1487,  1216,  1232,    93,
    1260,  1172,  1435,  1695,    94,  1260,  1172,  1436,  1695,    94,
      -1,    -1,    -1,    -1,    57,  1291,  1292,  1530,  1431,  1488,
    1433,  1502,  1437,  1487,  1216,  1232,    93,  1260,  1172,  1438,
    1695,    94,  1260,  1172,  1439,  1695,    94,    -1,    -1,    -1,
      99,    66,  1291,  1292,  1530,  1481,  1172,  1501,  1440,  1232,
      93,  1260,  1172,  1441,  1695,    94,  1260,  1172,    -1,    -1,
      -1,  1456,   113,  1543,  1219,  1443,  1442,    -1,    -1,  1456,
     115,  1549,  1220,  1444,  1442,    -1,    -1,  1456,   117,  1531,
    1221,  1445,  1442,    -1,    -1,  1456,   120,  1308,  1218,  1446,
    1442,    -1,    -1,  1456,   122,  1627,  1222,  1447,  1442,    -1,
      -1,  1456,   124,  1649,  1223,  1448,  1442,    -1,    -1,  1456,
     126,  1635,  1224,  1449,  1442,    -1,    -1,    -1,  1456,    95,
    1450,  1457,  1225,  1451,  1442,    -1,    -1,    -1,  1456,   143,
      95,  1452,  1460,  1225,  1453,  1442,    -1,    -1,  1456,  1482,
    1234,  1454,  1442,    -1,    -1,  1456,  1463,  1234,  1455,  1442,
      -1,    -1,  1290,    -1,    -1,    -1,  1458,  1465,  1459,  1457,
      -1,  1290,    -1,    -1,    -1,  1461,  1468,  1462,  1460,    -1,
      99,  1259,  1291,  1292,  1530,  1473,  1527,  1505,  1172,  1501,
      -1,  1127,    99,    -1,  1259,  1464,  1291,  1292,  1530,  1473,
    1527,  1505,  1502,    -1,    99,  1259,  1291,  1292,  1530,  1473,
    1527,  1505,  1172,  1501,   141,  1172,    -1,  1259,  1464,  1291,
    1292,  1530,  1473,  1527,  1505,  1502,   141,  1172,    -1,  1259,
    1127,   142,  1724,  1360,  1319,  1172,    -1,    68,  1127,   142,
    1724,  1360,  1319,  1172,    -1,   143,    99,    58,    -1,   143,
      99,    66,    -1,  1466,  1172,    -1,    58,  1127,    99,    -1,
      66,  1127,    99,    -1,  1467,  1172,    -1,    -1,  1466,  1172,
     140,  1469,  1499,    -1,    -1,  1467,  1172,   140,  1470,  1499,
      -1,    -1,    99,  1259,  1291,  1292,  1530,  1473,  1527,  1505,
    1172,  1501,   140,  1471,  1499,    -1,    -1,  1259,  1464,  1291,
    1292,  1530,  1473,  1527,  1505,  1502,   140,  1472,  1499,  1172,
      -1,    -1,    98,  1259,  1291,  1292,  1530,  1473,  1529,  1505,
    1172,    -1,  1259,  1404,  1291,  1292,  1530,  1473,  1529,  1505,
    1172,    -1,   143,    98,    57,    -1,   143,    98,    65,    -1,
     143,    98,    73,    -1,  1474,  1172,    -1,    57,    98,    -1,
      65,  1127,    98,    -1,    73,  1127,    98,    -1,  1475,  1172,
      -1,    -1,  1474,  1172,   140,  1476,  1499,    -1,    -1,  1475,
    1172,   140,  1477,  1499,    -1,    -1,    98,  1259,  1291,  1292,
    1530,  1473,  1529,  1505,  1172,  1290,   140,  1478,  1499,    -1,
      -1,  1259,  1404,  1291,  1292,  1530,  1473,  1529,  1505,  1502,
    1290,   140,  1479,  1499,  1172,    -1,    -1,    -1,    97,  1259,
    1291,  1292,  1530,  1473,  1527,  1505,  1172,  1501,    -1,  1259,
    1365,  1291,  1292,  1530,  1473,  1527,  1505,  1502,    -1,    -1,
      97,  1259,  1291,  1292,  1530,  1473,  1527,  1505,  1172,  1501,
     140,  1483,  1499,    -1,    -1,  1259,  1365,  1291,  1292,  1530,
    1473,  1527,  1505,  1502,   140,  1484,  1499,  1172,    -1,  1259,
    1173,   145,  1175,  1259,  1176,  1172,    -1,   143,    97,    72,
    1172,    -1,    72,  1365,  1172,    -1,    -1,   143,    97,    72,
    1172,   140,  1485,  1499,    -1,    -1,    72,  1365,  1172,   140,
    1486,  1499,  1172,    -1,    -1,  1290,    -1,    -1,  1125,  1489,
    1492,  1176,    -1,    -1,  1290,    -1,    11,  1193,    -1,  1523,
    1260,  1173,  1249,  1491,  1490,    -1,    -1,  1523,  1260,  1173,
    1249,  1491,  1490,  1126,  1493,  1492,    -1,   120,    -1,  1523,
    1260,  1173,  1494,  1491,  1490,    -1,    -1,  1523,  1260,  1173,
    1494,  1491,  1490,  1126,  1495,  1492,    -1,    -1,  1523,  1260,
    1173,    97,  1498,  1488,  1496,    -1,    -1,  1523,  1260,  1173,
      97,  1498,  1488,  1496,  1126,  1497,  1492,    -1,    -1,  1290,
      -1,  1125,  1662,  1176,    -1,   448,    -1,   452,    -1,   456,
      -1,   460,    -1,   462,    -1,   464,    -1,  1290,    -1,  1501,
     147,  1175,  1662,  1176,  1172,    -1,  1501,   155,  1500,  1172,
      -1,  1501,   148,  1172,    -1,  1501,   149,  1172,    -1,  1501,
     150,  1172,    -1,  1501,   151,  1172,    -1,  1501,   152,  1172,
      -1,  1501,   153,  1172,    -1,  1501,   157,  1172,    -1,  1501,
     156,  1172,    -1,  1501,   159,  1172,    -1,  1501,   158,  1172,
      -1,  1501,   160,  1172,    -1,  1501,   162,  1172,    -1,  1501,
     161,  1172,    -1,  1501,   154,  1175,  1664,  1176,  1172,    -1,
    1501,   163,    -1,  1501,   164,    -1,  1126,    -1,  1180,  1504,
    1179,  1172,    -1,  1180,  1504,  1179,    -1,  1290,    -1,  1504,
    1133,    -1,  1504,   147,  1175,  1662,  1176,    -1,  1504,   155,
    1500,    -1,  1504,   148,    -1,  1504,   149,    -1,  1504,   150,
      -1,  1504,   151,    -1,  1504,   152,    -1,  1504,   153,    -1,
    1504,   157,    -1,  1504,   156,    -1,  1504,   159,    -1,  1504,
     158,    -1,  1504,   160,    -1,  1504,   162,    -1,  1504,   161,
      -1,  1504,   154,  1175,  1664,  1176,    -1,  1504,   163,    -1,
    1504,   164,    -1,    -1,  1216,  1506,  1507,    -1,  1290,    -1,
      -1,  1125,  1508,  1511,  1176,    -1,  1249,    -1,    46,    -1,
    1173,    -1,  1523,  1259,  1510,  1509,    -1,  1523,  1259,  1510,
    1509,    11,  1193,    -1,    -1,    -1,  1523,  1259,  1510,  1509,
    1512,  1126,  1513,  1511,    -1,    -1,    -1,  1523,  1259,  1510,
     120,  1514,  1126,  1515,  1511,    -1,  1523,  1259,  1510,   120,
      -1,    -1,    -1,  1523,  1259,  1510,   120,    11,  1193,  1516,
    1126,  1517,  1511,    -1,  1523,  1259,  1510,   120,    11,  1193,
      -1,    -1,    -1,  1523,  1259,  1510,  1509,    11,  1193,  1518,
    1126,  1519,  1511,    -1,  1523,  1259,  1510,    97,  1291,  1292,
    1522,  1505,    -1,    -1,    -1,  1523,  1259,  1510,    97,  1291,
    1292,  1522,  1505,  1520,  1126,  1521,  1511,    -1,    -1,  1524,
      -1,   115,    -1,   120,    -1,   171,    -1,   172,    -1,   170,
    1525,    -1,   173,  1525,    -1,    -1,  1290,    -1,  1125,    34,
    1176,    -1,    -1,    -1,    -1,    -1,    -1,  1532,  1533,    -1,
      -1,  1290,    -1,  1533,  1534,    -1,  1126,    -1,  1259,  1173,
     145,  1175,  1259,  1176,  1172,    -1,    -1,    -1,  1259,  1173,
     135,  1535,  1180,  1536,  1286,  1179,  1172,    -1,  1259,  1173,
     137,   138,  1260,  1172,    -1,  1259,  1173,   137,   138,  1537,
    1172,    -1,   211,    -1,   212,    -1,   213,    -1,   214,    -1,
     215,    -1,   216,    -1,   217,    -1,   218,    -1,   219,    -1,
     220,    -1,   221,    -1,   222,    -1,   223,    -1,   224,    -1,
     225,    -1,   226,    -1,   227,    -1,   228,    -1,   230,    -1,
     229,    -1,   231,    -1,   234,    -1,   235,    -1,   236,    -1,
     237,    -1,   238,    -1,   239,    -1,   174,    -1,    -1,  1259,
    1173,    97,  1291,  1292,  1538,  1505,  1126,  1501,    -1,  1259,
    1173,    97,  1291,  1292,  1538,  1505,  1503,  1126,    -1,  1259,
    1173,   137,   138,    97,  1256,  1172,    -1,  1259,  1173,  1249,
    1172,    -1,  1259,  1173,  1249,  1130,  1274,  1177,  1172,    -1,
    1259,  1173,  1299,  1300,  1297,  1302,   129,  1172,    -1,  1259,
    1173,  1298,  1305,   131,  1172,    -1,    -1,    -1,  1259,  1173,
    1291,  1292,  1293,  1294,  1480,  1541,  1296,  1539,  1234,  1540,
    1442,   134,  1172,    -1,   132,    -1,  1254,  1173,   130,  1305,
     131,  1172,    -1,  1254,  1173,  1299,  1300,  1297,  1302,   129,
    1172,    -1,  1254,  1173,  1264,  1130,  1274,  1177,  1172,    -1,
    1254,  1173,  1264,  1172,    -1,  1254,  1173,   135,  1180,  1286,
    1179,  1172,    -1,  1259,  1173,    46,  1130,  1274,  1177,  1172,
      -1,  1259,  1173,    46,  1172,    -1,     1,  1126,    -1,    -1,
    1542,  1259,  1172,  1317,    -1,  1544,  1545,    -1,    -1,  1290,
      -1,  1545,  1546,    -1,  1126,    -1,  1577,    -1,  1259,    37,
    1662,  1172,    -1,  1259,  1173,  1249,    37,  1662,  1172,    -1,
      -1,  1259,  1173,  1249,  1130,  1274,  1177,  1547,    37,  1662,
    1172,    -1,    -1,  1259,  1173,  1249,  1130,  1177,  1548,    37,
    1662,  1172,    -1,  1254,    -1,    46,  1126,    -1,     1,  1126,
      -1,  1550,  1551,    -1,    -1,  1290,    -1,  1551,  1552,    -1,
    1126,    -1,  1577,    -1,   421,    37,  1662,  1172,    -1,   424,
      37,  1662,  1172,    -1,   425,    37,  1662,  1172,    -1,   426,
      37,  1662,  1172,    -1,   169,    37,  1662,  1172,    -1,   431,
      37,  1662,  1172,    -1,   436,    37,   466,  1172,    -1,   436,
      37,   468,  1172,    -1,   436,    37,     1,  1172,    -1,   432,
      37,  1662,  1172,    -1,   433,    37,  1662,  1172,    -1,   434,
      37,  1662,  1172,    -1,   151,    37,  1662,  1172,    -1,   150,
      37,  1662,  1172,    -1,   149,    37,  1662,  1172,    -1,   148,
      37,  1662,  1172,    -1,   153,    37,  1662,  1172,    -1,   152,
      37,  1662,  1172,    -1,   156,    37,  1662,  1172,    -1,   157,
      37,  1662,  1172,    -1,   158,    37,  1662,  1172,    -1,   159,
      37,  1662,  1172,    -1,   154,    37,  1662,  1172,    -1,   435,
      37,  1662,  1172,    -1,   392,  1175,  1290,  1937,  1176,    37,
    1662,  1172,    -1,  1259,    37,  1662,  1172,    -1,  1259,    37,
      36,  1172,    -1,  1254,    37,  1662,  1172,    -1,  1254,    37,
      36,  1172,    -1,  1259,  1173,  1249,  1172,    -1,  1254,  1173,
    1249,  1172,    -1,  1259,  1173,  1249,    37,  1662,  1172,    -1,
    1259,  1173,  1249,    37,    36,  1172,    -1,  1254,  1173,  1249,
      37,  1662,  1172,    -1,  1254,  1173,  1249,    37,    36,  1172,
      -1,    -1,  1259,  1173,  1249,  1130,  1274,  1177,  1553,    37,
    1662,  1172,    -1,    -1,  1254,  1173,  1249,  1130,  1274,  1177,
    1554,    37,  1662,  1172,    -1,    -1,  1259,  1173,  1249,  1130,
    1177,  1555,    37,  1662,  1172,    -1,    -1,  1254,  1173,  1249,
    1130,  1177,  1556,    37,  1662,  1172,    -1,  1259,  1173,  1249,
    1130,  1274,  1177,  1172,    -1,  1254,  1173,  1249,  1130,  1274,
    1177,  1172,    -1,  1281,    37,  1662,  1172,    -1,  1280,    37,
    1662,  1172,    -1,     1,  1126,    -1,  1126,    -1,   421,    37,
    1662,  1172,    -1,   424,    37,  1662,  1172,    -1,   425,    37,
    1662,  1172,    -1,   426,    37,  1662,  1172,    -1,   169,    37,
    1662,  1172,    -1,   436,    37,   466,  1172,    -1,   436,    37,
     468,  1172,    -1,   436,    37,     1,  1172,    -1,   431,    37,
    1662,  1172,    -1,   432,    37,  1662,  1172,    -1,   433,    37,
    1662,  1172,    -1,   434,    37,  1662,  1172,    -1,   151,    37,
    1662,  1172,    -1,   150,    37,  1662,  1172,    -1,   149,    37,
    1662,  1172,    -1,   148,    37,  1662,  1172,    -1,   153,    37,
    1662,  1172,    -1,   152,    37,  1662,  1172,    -1,   156,    37,
    1662,  1172,    -1,   157,    37,  1662,  1172,    -1,   158,    37,
    1662,  1172,    -1,   159,    37,  1662,  1172,    -1,   154,    37,
    1662,  1172,    -1,   435,    37,  1662,  1172,    -1,   392,  1175,
    1937,  1176,    37,  1662,  1172,    -1,  1140,    37,  1662,  1172,
      -1,  1140,    37,    36,  1172,    -1,  1257,    37,  1662,  1172,
      -1,  1257,    37,    36,  1172,    -1,  1257,    38,    -1,  1257,
      39,    -1,    46,    38,  1662,  1172,    -1,    46,    39,  1662,
    1172,    -1,  1140,  1173,  1249,  1172,    -1,  1257,  1173,  1249,
    1172,    -1,  1140,  1173,  1249,    37,  1662,  1172,    -1,  1140,
    1173,  1249,    37,    36,  1172,    -1,  1257,  1173,  1249,    37,
    1662,  1172,    -1,  1257,  1173,  1249,    37,    36,  1172,    -1,
      -1,  1140,  1173,  1249,  1130,  1274,  1177,  1558,    37,  1662,
    1172,    -1,    -1,  1257,  1173,  1249,  1130,  1274,  1177,  1559,
      37,  1662,  1172,    -1,    -1,  1140,  1173,  1249,  1130,  1177,
    1560,    37,  1662,  1172,    -1,    -1,  1257,  1173,  1249,  1130,
    1177,  1561,    37,  1662,  1172,    -1,  1140,  1173,  1249,  1130,
    1274,  1177,  1172,    -1,  1257,  1173,  1249,  1130,  1274,  1177,
    1172,    -1,  1281,    37,  1662,  1172,    -1,  1280,    37,  1662,
    1172,    -1,     1,  1126,    -1,  1563,  1564,  1565,    -1,    -1,
    1290,    -1,    37,  1664,  1172,    -1,  1130,  1664,  1177,    -1,
    1130,  1664,  1177,    37,  1664,  1172,    -1,  1130,  1664,  1127,
    1664,  1177,    -1,  1130,  1664,  1127,  1664,  1177,    37,  1664,
    1172,    -1,  1290,    -1,  1565,  1566,    -1,  1126,    -1,  1577,
      -1,   119,  1175,  1664,  1176,  1172,    -1,    -1,  1259,  1173,
      97,  1291,  1292,  1567,  1505,  1172,  1501,    -1,    -1,  1259,
    1173,   137,   138,    97,  1256,  1568,  1172,  1501,    -1,    -1,
      -1,  1259,  1173,   135,  1569,  1180,  1570,  1286,  1179,  1172,
      -1,    -1,  1259,  1173,   137,   138,  1260,  1571,  1172,  1501,
      -1,    -1,  1259,  1173,   137,   138,  1537,  1572,  1172,  1501,
      -1,    -1,  1259,  1173,  1249,  1573,  1172,  1501,    -1,    -1,
    1259,  1173,  1249,  1130,  1274,  1177,  1574,  1172,  1501,    -1,
    1259,  1173,  1299,  1300,  1297,  1302,   129,  1172,    -1,    -1,
    1259,  1173,  1291,  1292,  1293,  1295,   130,  1575,  1305,   131,
    1172,    -1,  1576,    -1,  1254,  1173,   130,  1305,   131,  1172,
      -1,  1254,  1173,  1299,  1300,  1297,  1302,   129,  1172,    -1,
    1254,  1127,     1,  1126,    -1,  1254,  1173,   135,  1180,  1286,
    1179,  1172,    -1,  1259,  1173,    46,  1130,  1274,  1177,  1172,
      -1,  1259,  1173,    46,  1172,    -1,     1,  1126,    -1,    -1,
    1259,  1173,   145,  1175,  1259,  1176,  1578,  1172,    -1,   119,
    1175,  1664,  1176,  1172,    -1,    -1,  1259,  1173,   137,   138,
      97,  1256,  1581,  1172,  1501,  1317,    -1,  1259,  1173,    97,
    1291,  1292,  1320,  1505,  1172,  1501,  1317,    -1,  1254,  1173,
      97,  1585,  1488,  1172,  1501,    -1,  1254,  1173,   137,   138,
      97,  1256,  1172,  1501,    -1,    -1,    -1,  1259,  1173,    97,
    1291,  1292,  1320,  1505,    37,  1587,  1662,  1172,  1501,    -1,
      -1,  1259,  1173,   137,   138,    97,  1256,    37,  1662,  1589,
    1172,  1501,    -1,  1254,  1173,    97,  1585,  1488,    37,  1662,
    1172,    -1,  1254,  1173,   137,   138,    97,  1256,    37,  1662,
    1172,    -1,  1259,  1173,   135,  1321,  1180,  1322,  1286,  1179,
    1172,  1501,    -1,    -1,  1259,  1173,   135,  1321,  1180,  1322,
    1286,  1179,  1594,    37,  1662,  1172,    -1,    -1,  1259,  1173,
     137,   138,  1260,    37,  1664,  1596,  1172,  1501,    -1,    -1,
    1254,  1173,   137,   138,  1260,    37,  1664,  1598,  1172,  1501,
      -1,    -1,  1259,  1173,   137,   138,  1537,    37,  1664,  1600,
    1172,  1501,    -1,    -1,  1254,  1173,   137,   138,  1537,    37,
    1664,  1602,  1172,  1501,    -1,  1254,  1173,   137,   138,  1537,
    1172,  1501,    -1,    -1,  1259,  1173,  1249,    37,  1662,  1605,
    1172,  1501,    -1,    -1,  1254,  1173,  1249,    37,  1662,  1607,
    1172,  1501,    -1,    -1,  1259,  1173,  1249,  1130,  1274,  1177,
      37,  1662,  1609,  1172,  1501,    -1,    -1,  1259,  1173,  1249,
    1130,  1177,    37,  1662,  1610,  1172,  1501,    -1,    -1,  1254,
    1173,  1249,  1130,  1274,  1177,    37,  1662,  1612,  1172,  1501,
      -1,    -1,  1259,  1173,   137,   138,  1260,  1614,  1172,  1501,
    1317,    -1,  1254,  1173,   137,   138,  1260,  1172,  1501,    -1,
      -1,  1259,  1173,   137,   138,  1537,  1617,  1172,  1501,  1317,
      -1,    -1,  1259,  1173,  1249,  1619,  1172,  1501,  1317,    -1,
    1254,  1173,  1249,  1172,  1501,    -1,    -1,  1259,  1173,  1249,
    1130,  1274,  1177,  1622,  1172,  1501,  1317,    -1,  1254,  1173,
    1249,  1130,  1274,  1177,  1172,  1501,    -1,  1259,  1173,  1299,
    1300,  1297,  1302,   129,  1172,    -1,    -1,  1259,  1173,  1291,
    1292,  1293,  1295,   130,  1626,  1305,   131,  1172,    -1,  1628,
    1629,  1631,  1632,  1630,    -1,    -1,    -1,    -1,  1290,    -1,
    1125,  1664,  1176,    -1,    -1,  1632,  1633,    -1,   133,  1175,
    1249,  1176,  1172,  1317,    -1,  1259,  1173,   133,  1175,  1249,
    1176,  1172,  1317,    -1,  1254,  1173,   133,  1175,  1249,  1176,
    1172,    -1,   133,  1175,    46,  1176,  1172,  1317,    -1,  1126,
      -1,  1577,    -1,  1579,    -1,  1580,    -1,  1582,    -1,  1584,
      -1,  1583,    -1,  1588,    -1,  1586,    -1,  1591,    -1,  1590,
      -1,  1592,    -1,  1593,    -1,  1613,    -1,  1615,    -1,  1595,
      -1,  1597,    -1,  1616,    -1,  1603,    -1,  1599,    -1,  1601,
      -1,  1618,    -1,  1620,    -1,  1604,    -1,  1606,    -1,  1621,
      -1,  1623,    -1,  1608,    -1,  1611,    -1,  1624,    -1,  1625,
      -1,    -1,  1249,  1634,  1655,  1172,    -1,  1576,    -1,  1636,
    1637,  1639,  1640,  1638,    -1,    -1,    -1,    -1,  1290,    -1,
    1125,  1664,  1176,    -1,    -1,  1640,  1641,    -1,  1126,    -1,
    1577,    -1,   133,  1175,  1249,  1176,  1172,  1317,    -1,  1259,
    1173,   133,  1175,  1249,  1176,  1172,  1317,    -1,  1254,  1173,
     133,  1175,  1249,  1176,  1172,    -1,  1579,    -1,  1588,    -1,
    1586,    -1,  1259,  1173,    97,  1291,  1292,  1320,  1505,  1172,
    1501,  1317,    -1,    -1,  1259,  1173,   137,   138,    97,  1256,
    1172,  1642,  1501,  1318,    -1,  1259,  1173,   137,   138,    97,
    1256,  1172,  1642,  1501,    -1,  1591,    -1,  1590,    -1,  1254,
    1173,    97,  1585,  1488,  1172,  1501,    -1,  1254,  1173,   137,
     138,    97,  1256,  1172,  1501,    -1,  1593,    -1,    -1,  1259,
    1173,   135,  1321,  1180,  1322,  1286,  1179,  1643,  1172,  1501,
      -1,  1595,    -1,    -1,  1259,  1173,   137,   138,  1260,  1644,
    1172,  1501,    -1,  1259,  1173,   137,   138,  1260,  1644,  1172,
    1501,  1318,    -1,  1597,    -1,  1254,  1173,   137,   138,  1260,
    1172,  1501,    -1,  1599,    -1,    -1,  1259,  1173,   137,   138,
    1537,  1645,  1172,  1501,    -1,  1259,  1173,   137,   138,  1537,
    1645,  1172,  1501,  1318,    -1,  1601,    -1,  1603,    -1,  1604,
      -1,    -1,  1259,  1173,  1249,  1646,  1172,  1501,    -1,  1259,
    1173,  1249,  1646,  1172,  1501,  1318,    -1,  1606,    -1,  1254,
    1173,  1249,  1172,  1501,    -1,  1608,    -1,    -1,  1259,  1173,
    1249,  1130,  1274,  1177,  1647,  1172,  1501,    -1,  1259,  1173,
    1249,  1130,  1274,  1177,  1647,  1172,  1501,  1318,    -1,  1611,
      -1,  1254,  1173,  1249,  1130,  1274,  1177,  1172,  1501,    -1,
      -1,  1249,  1648,  1655,  1172,    -1,  1576,    -1,  1650,  1651,
    1631,  1653,  1652,    -1,    -1,    -1,    -1,    -1,  1653,  1654,
      -1,  1126,    -1,  1577,    -1,  1579,    -1,  1580,    -1,  1582,
      -1,  1584,    -1,  1583,    -1,  1592,    -1,  1613,    -1,  1615,
      -1,  1616,    -1,  1254,  1173,   137,   138,  1537,  1172,  1501,
      -1,  1618,    -1,  1620,    -1,  1621,    -1,  1623,    -1,  1624,
      -1,  1625,    -1,  1576,    -1,  1657,    -1,    -1,  1657,  1133,
    1656,  1655,    -1,  1662,    -1,     8,    46,    -1,     8,    46,
    1130,  1664,  1177,    -1,     8,  1659,    -1,     8,  1659,  1130,
    1664,  1177,    -1,     8,  1660,  1661,  1691,    -1,     8,  1660,
    1661,  1691,  1130,  1664,  1177,    -1,    73,    -1,    74,    -1,
      72,    -1,    71,    -1,    55,    -1,    56,    -1,    57,    -1,
      58,    -1,    59,    -1,    63,    -1,    64,    -1,    65,    -1,
      66,    -1,    67,    -1,    55,    -1,    63,    -1,    -1,  1664,
      -1,  1266,    -1,  1662,    -1,  1702,  1662,    -1,  1125,  1662,
    1176,    -1,  1665,    -1,  1658,    -1,   267,    -1,    28,    -1,
      30,    -1,    29,    -1,    31,    -1,    32,    -1,    33,    -1,
    1257,    -1,    46,    -1,  1277,    -1,  1278,    -1,  1267,    -1,
      -1,  1249,  1127,  1178,  1667,  1666,  1282,  1177,    -1,  1249,
    1134,  1260,  1127,  1178,  1662,  1177,    -1,    -1,  1668,    -1,
    1669,    -1,    34,    -1,    32,    32,    -1,    34,    32,    -1,
      32,  1668,    -1,    34,  1668,    -1,    35,    -1,    33,    33,
      -1,    35,    33,    -1,    33,  1669,    -1,    35,  1669,    -1,
    1136,  1132,  1670,  1179,    -1,  1672,    -1,  1671,    -1,  1673,
      -1,  1670,  1133,  1673,    -1,    -1,  1662,    -1,  1674,    -1,
    1132,  1680,  1679,  1675,  1179,    -1,    -1,  1676,    -1,  1675,
    1133,  1676,    -1,  1662,  1677,    -1,  1662,    40,  1662,  1678,
      -1,    -1,    -1,    -1,    -1,    19,  1664,    -1,  1135,  1664,
      -1,  1664,    18,  1664,    -1,  1664,    19,  1664,    -1,  1664,
      20,  1664,    -1,  1664,    21,  1664,    -1,  1664,    25,  1664,
      -1,  1664,    24,  1664,    -1,  1664,     8,  1664,    -1,  1664,
       4,  1664,    -1,  1664,     5,  1664,    -1,  1664,    23,  1664,
      -1,  1664,    22,  1664,    -1,  1664,    14,  1664,    -1,  1664,
      15,  1664,    -1,  1664,    12,  1664,    -1,  1664,    17,  1664,
      -1,  1664,    13,  1664,    -1,  1664,    16,  1664,    -1,  1664,
      11,  1664,    -1,  1683,  1175,  1664,  1176,    -1,  1125,   117,
    1249,  1664,  1176,    -1,    -1,   255,  1681,  1175,  1664,  1176,
      -1,   256,  1175,  1664,  1176,    -1,   258,  1175,  1662,  1133,
    1662,  1176,    -1,   258,  1175,  1662,  1176,    -1,   240,    -1,
     241,    -1,   242,    -1,   243,    -1,   244,    -1,   245,    -1,
     246,    -1,   247,    -1,   248,    -1,   249,    -1,   250,    -1,
     251,    -1,   252,    -1,   253,    -1,   254,    -1,   257,    -1,
     259,    -1,   260,    -1,   261,    -1,   262,    -1,   263,    -1,
     264,    -1,   211,  1175,  1662,  1176,    -1,   212,  1175,  1662,
    1176,    -1,   213,  1175,  1662,  1176,    -1,   214,  1175,  1662,
    1176,    -1,   215,  1175,  1662,  1176,    -1,   216,  1175,  1662,
    1176,    -1,   223,  1175,  1662,  1176,    -1,   224,  1175,  1662,
    1176,    -1,   225,  1175,  1662,  1176,    -1,   226,  1175,  1662,
    1176,    -1,   227,  1175,  1662,  1176,    -1,   234,  1175,  1662,
    1176,    -1,   235,  1175,  1662,  1176,    -1,   236,  1175,  1662,
    1176,    -1,   237,  1175,  1662,  1176,    -1,   238,  1175,  1662,
    1176,    -1,   239,  1175,  1662,  1176,    -1,   219,  1175,  1662,
    1176,    -1,   220,  1175,  1662,  1176,    -1,   221,  1175,  1662,
    1176,    -1,   217,  1175,  1662,  1176,    -1,   228,  1175,  1662,
    1176,    -1,   230,  1175,  1662,  1176,    -1,   231,  1175,  1662,
    1176,    -1,    -1,   233,  1175,  1662,  1176,  1684,  1664,  1176,
      -1,   291,  1175,  1256,  1176,    -1,   291,  1175,    46,  1176,
      -1,  1682,    -1,   268,  1175,  1662,  1176,    -1,   268,  1175,
       1,  1176,    -1,   269,  1175,  1662,  1176,    -1,   269,  1175,
       1,  1176,    -1,   270,  1175,  1662,  1176,    -1,   270,  1175,
       1,  1176,    -1,   271,    -1,   272,  1175,  1662,  1176,    -1,
     273,  1175,  1662,  1176,    -1,   273,  1175,     1,  1176,    -1,
     274,  1175,  1662,  1176,    -1,   274,  1175,     1,  1176,    -1,
     275,  1175,  1662,  1176,    -1,   275,  1175,     1,  1176,    -1,
     384,  1175,  1662,  1176,    -1,   384,  1175,     1,  1176,    -1,
     385,  1175,  1662,  1176,    -1,   385,  1175,     1,  1176,    -1,
     276,  1175,  1662,  1176,    -1,   276,  1175,     1,  1176,    -1,
     277,  1175,  1662,  1176,    -1,   277,  1175,     1,  1176,    -1,
     278,  1175,  1662,  1176,    -1,   278,  1175,     1,  1176,    -1,
     279,  1175,  1662,  1176,    -1,   279,  1175,     1,  1176,    -1,
     280,  1175,  1662,  1176,    -1,   280,  1175,     1,  1176,    -1,
     281,  1175,  1662,  1176,    -1,   281,  1175,     1,  1176,    -1,
     282,  1175,  1662,  1176,    -1,   282,  1175,     1,  1176,    -1,
     283,  1175,  1662,  1176,    -1,   283,  1175,     1,  1176,    -1,
     284,  1175,  1662,  1176,    -1,   284,  1175,     1,  1176,    -1,
     285,  1175,  1685,  1176,    -1,   285,  1175,     1,  1176,    -1,
    1662,    -1,  1685,  1133,  1662,    -1,   286,  1175,  1686,  1176,
      -1,   286,  1175,     1,  1176,    -1,  1662,    -1,  1686,  1133,
    1662,    -1,  1705,    -1,  1707,    -1,   287,  1175,  1664,  1181,
    1687,  1176,    -1,   288,  1175,  1662,  1176,    -1,   288,  1175,
       1,  1176,    -1,   289,  1175,  1662,  1176,    -1,   289,  1175,
       1,  1176,    -1,   290,  1175,  1662,  1176,    -1,   290,  1175,
       1,  1176,    -1,   292,  1175,  1662,  1176,    -1,   292,  1175,
       1,  1176,    -1,   293,  1175,  1662,  1181,  1662,  1181,  1937,
    1181,  1937,  1181,  1662,  1176,    -1,   294,  1175,  1662,  1176,
      -1,   294,  1175,     1,  1176,    -1,   295,  1175,  1662,  1176,
      -1,   296,  1175,  1662,  1176,    -1,   297,  1175,  1662,  1176,
      -1,   297,  1175,     1,  1176,    -1,   299,    -1,   298,    -1,
     365,  1175,  1662,  1181,  1662,  1181,  1662,  1176,    -1,   365,
    1175,     1,  1176,    -1,   366,  1175,  1662,  1181,  1662,  1181,
    1662,  1176,    -1,   366,  1175,     1,  1176,    -1,   367,  1175,
    1662,  1181,  1662,  1181,  1662,  1176,    -1,   367,  1175,     1,
    1176,    -1,   368,  1175,  1662,  1176,    -1,   368,  1175,     1,
    1176,    -1,   369,  1175,  1662,  1181,  1662,  1176,    -1,   369,
    1175,     1,  1176,    -1,   370,  1175,  1662,  1181,  1662,  1133,
    1662,  1176,    -1,   370,  1175,  1662,  1181,  1662,  1176,    -1,
     371,  1175,  1662,  1181,  1662,  1181,  1662,  1176,    -1,   371,
    1175,     1,  1176,    -1,   372,  1175,  1662,  1181,  1662,  1181,
    1662,  1176,    -1,   372,  1175,     1,  1176,    -1,   373,  1175,
    1662,  1181,  1662,  1176,    -1,   373,  1175,     1,  1176,    -1,
     374,  1175,  1662,  1181,  1662,  1133,  1662,  1176,    -1,   374,
    1175,     1,  1176,    -1,   375,  1175,  1662,  1181,  1662,  1181,
    1662,  1176,    -1,   375,  1175,     1,  1176,    -1,   376,  1175,
    1662,  1181,  1662,  1176,    -1,   376,  1175,     1,  1176,    -1,
     377,  1175,  1662,  1181,  1662,  1176,    -1,   377,  1175,     1,
    1176,    -1,   378,  1175,  1662,  1181,  1662,  1176,    -1,   378,
    1175,     1,  1176,    -1,   379,  1175,  1662,  1181,  1662,  1176,
      -1,   379,  1175,     1,  1176,    -1,   380,  1175,  1662,  1181,
    1662,  1181,  1662,  1181,  1662,  1176,    -1,   380,  1175,     1,
    1176,    -1,   381,  1175,  1662,  1181,  1662,  1176,    -1,   382,
    1175,  1662,  1181,  1662,  1176,    -1,   381,  1175,     1,  1176,
      -1,   383,  1175,  1662,  1181,  1662,  1176,    -1,   383,  1175,
       1,  1176,    -1,   300,  1175,  1662,  1181,  1662,  1176,    -1,
     300,  1175,  1662,  1181,  1662,  1133,  1256,  1176,    -1,   300,
    1175,  1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,
     301,  1175,  1662,  1181,  1662,  1176,    -1,   301,  1175,  1662,
    1181,  1662,  1133,  1256,  1176,    -1,   301,  1175,  1662,  1181,
    1662,  1133,  1256,  1133,  1256,  1176,    -1,   302,  1175,  1662,
    1181,  1662,  1176,    -1,   302,  1175,  1662,  1181,  1662,  1133,
    1256,  1176,    -1,   302,  1175,  1662,  1181,  1662,  1133,  1256,
    1133,  1256,  1176,    -1,   303,  1175,  1662,  1181,  1662,  1176,
      -1,   303,  1175,  1662,  1181,  1662,  1133,  1256,  1176,    -1,
     303,  1175,  1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,
      -1,   304,  1175,  1662,  1181,  1662,  1176,    -1,   304,  1175,
    1662,  1181,  1662,  1133,  1256,  1176,    -1,   304,  1175,  1662,
    1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,   305,  1175,
    1662,  1181,  1662,  1176,    -1,   305,  1175,  1662,  1181,  1662,
    1133,  1256,  1176,    -1,   305,  1175,  1662,  1181,  1662,  1133,
    1256,  1133,  1256,  1176,    -1,   306,  1175,  1662,  1181,  1662,
    1133,  1662,  1176,    -1,   306,  1175,  1662,  1181,  1662,  1133,
    1662,  1133,  1256,  1176,    -1,   306,  1175,  1662,  1181,  1662,
    1133,  1662,  1133,  1256,  1133,  1256,  1176,    -1,   307,  1175,
    1662,  1181,  1662,  1133,  1662,  1176,    -1,   307,  1175,  1662,
    1181,  1662,  1133,  1662,  1133,  1256,  1176,    -1,   307,  1175,
    1662,  1181,  1662,  1133,  1662,  1133,  1256,  1133,  1256,  1176,
      -1,   308,  1175,  1662,  1181,  1662,  1133,  1662,  1176,    -1,
     308,  1175,  1662,  1181,  1662,  1133,  1662,  1133,  1256,  1176,
      -1,   308,  1175,  1662,  1181,  1662,  1133,  1662,  1133,  1256,
    1133,  1256,  1176,    -1,   309,  1175,  1662,  1181,  1662,  1133,
    1662,  1176,    -1,   309,  1175,  1662,  1181,  1662,  1133,  1662,
    1133,  1256,  1176,    -1,   309,  1175,  1662,  1181,  1662,  1133,
    1662,  1133,  1256,  1133,  1256,  1176,    -1,   310,  1175,  1662,
    1181,  1662,  1133,  1662,  1133,  1662,  1176,    -1,   310,  1175,
    1662,  1181,  1662,  1133,  1662,  1133,  1662,  1133,  1256,  1176,
      -1,   310,  1175,  1662,  1181,  1662,  1133,  1662,  1133,  1662,
    1133,  1256,  1133,  1256,  1176,    -1,   311,  1175,  1662,  1181,
    1662,  1133,  1662,  1133,  1662,  1176,    -1,   311,  1175,  1662,
    1181,  1662,  1133,  1662,  1133,  1662,  1133,  1256,  1176,    -1,
     311,  1175,  1662,  1181,  1662,  1133,  1662,  1133,  1662,  1133,
    1256,  1133,  1256,  1176,    -1,   312,  1175,  1662,  1181,  1662,
    1176,    -1,   312,  1175,  1662,  1181,  1662,  1133,  1256,  1176,
      -1,   312,  1175,  1662,  1181,  1662,  1133,  1256,  1133,  1256,
    1176,    -1,   324,  1175,  1662,  1181,  1662,  1176,    -1,   324,
    1175,  1662,  1181,  1662,  1133,  1256,  1176,    -1,   324,  1175,
    1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,   313,
    1175,  1662,  1181,  1662,  1176,    -1,   313,  1175,  1662,  1181,
    1662,  1133,  1256,  1176,    -1,   313,  1175,  1662,  1181,  1662,
    1133,  1256,  1133,  1256,  1176,    -1,   325,  1175,  1662,  1181,
    1662,  1176,    -1,   325,  1175,  1662,  1181,  1662,  1133,  1256,
    1176,    -1,   325,  1175,  1662,  1181,  1662,  1133,  1256,  1133,
    1256,  1176,    -1,   314,  1175,  1662,  1181,  1662,  1176,    -1,
     314,  1175,  1662,  1181,  1662,  1133,  1256,  1176,    -1,   314,
    1175,  1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,
     326,  1175,  1662,  1181,  1662,  1176,    -1,   326,  1175,  1662,
    1181,  1662,  1133,  1256,  1176,    -1,   326,  1175,  1662,  1181,
    1662,  1133,  1256,  1133,  1256,  1176,    -1,   315,  1175,  1662,
    1181,  1662,  1176,    -1,   315,  1175,  1662,  1181,  1662,  1133,
    1256,  1176,    -1,   315,  1175,  1662,  1181,  1662,  1133,  1256,
    1133,  1256,  1176,    -1,   327,  1175,  1662,  1181,  1662,  1176,
      -1,   327,  1175,  1662,  1181,  1662,  1133,  1256,  1176,    -1,
     327,  1175,  1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,
      -1,   316,  1175,  1662,  1181,  1662,  1176,    -1,   316,  1175,
    1662,  1181,  1662,  1133,  1256,  1176,    -1,   316,  1175,  1662,
    1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,   328,  1175,
    1662,  1181,  1662,  1176,    -1,   328,  1175,  1662,  1181,  1662,
    1133,  1256,  1176,    -1,   328,  1175,  1662,  1181,  1662,  1133,
    1256,  1133,  1256,  1176,    -1,   317,  1175,  1662,  1181,  1662,
    1176,    -1,   317,  1175,  1662,  1181,  1662,  1133,  1256,  1176,
      -1,   317,  1175,  1662,  1181,  1662,  1133,  1256,  1133,  1256,
    1176,    -1,   329,  1175,  1662,  1181,  1662,  1176,    -1,   329,
    1175,  1662,  1181,  1662,  1133,  1256,  1176,    -1,   329,  1175,
    1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,   318,
    1175,  1662,  1181,  1662,  1133,  1662,  1176,    -1,   318,  1175,
    1662,  1181,  1662,  1133,  1662,  1133,  1256,  1176,    -1,   318,
    1175,  1662,  1181,  1662,  1133,  1662,  1133,  1256,  1133,  1256,
    1176,    -1,   330,  1175,  1662,  1181,  1662,  1133,  1662,  1176,
      -1,   330,  1175,  1662,  1181,  1662,  1133,  1662,  1133,  1256,
    1176,    -1,   330,  1175,  1662,  1181,  1662,  1133,  1662,  1133,
    1256,  1133,  1256,  1176,    -1,   319,  1175,  1662,  1181,  1662,
    1133,  1662,  1176,    -1,   319,  1175,  1662,  1181,  1662,  1133,
    1662,  1133,  1256,  1176,    -1,   319,  1175,  1662,  1181,  1662,
    1133,  1662,  1133,  1256,  1133,  1256,  1176,    -1,   331,  1175,
    1662,  1181,  1662,  1133,  1662,  1176,    -1,   331,  1175,  1662,
    1181,  1662,  1133,  1662,  1133,  1256,  1176,    -1,   331,  1175,
    1662,  1181,  1662,  1133,  1662,  1133,  1256,  1133,  1256,  1176,
      -1,   320,  1175,  1662,  1181,  1662,  1133,  1662,  1176,    -1,
     320,  1175,  1662,  1181,  1662,  1133,  1662,  1133,  1256,  1176,
      -1,   320,  1175,  1662,  1181,  1662,  1133,  1662,  1133,  1256,
    1133,  1256,  1176,    -1,   332,  1175,  1662,  1181,  1662,  1181,
    1662,  1176,    -1,   332,  1175,  1662,  1181,  1662,  1181,  1662,
    1133,  1256,  1176,    -1,   332,  1175,  1662,  1181,  1662,  1181,
    1662,  1133,  1256,  1133,  1256,  1176,    -1,   321,  1175,  1662,
    1181,  1662,  1181,  1662,  1176,    -1,   321,  1175,  1662,  1181,
    1662,  1181,  1662,  1133,  1256,  1176,    -1,   321,  1175,  1662,
    1181,  1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,
     333,  1175,  1662,  1181,  1662,  1181,  1662,  1176,    -1,   333,
    1175,  1662,  1181,  1662,  1181,  1662,  1133,  1256,  1176,    -1,
     333,  1175,  1662,  1181,  1662,  1181,  1662,  1133,  1256,  1133,
    1256,  1176,    -1,   322,  1175,  1662,  1181,  1662,  1181,  1662,
    1181,  1662,  1176,    -1,   322,  1175,  1662,  1181,  1662,  1181,
    1662,  1181,  1662,  1133,  1256,  1176,    -1,   322,  1175,  1662,
    1181,  1662,  1181,  1662,  1181,  1662,  1133,  1256,  1133,  1256,
    1176,    -1,   334,  1175,  1662,  1181,  1662,  1181,  1662,  1181,
    1662,  1176,    -1,   334,  1175,  1662,  1181,  1662,  1181,  1662,
    1181,  1662,  1133,  1256,  1176,    -1,   334,  1175,  1662,  1181,
    1662,  1181,  1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,
      -1,   323,  1175,  1662,  1181,  1662,  1181,  1662,  1181,  1662,
    1176,    -1,   323,  1175,  1662,  1181,  1662,  1181,  1662,  1181,
    1662,  1133,  1256,  1176,    -1,   323,  1175,  1662,  1181,  1662,
    1181,  1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,
     335,  1175,  1662,  1181,  1662,  1181,  1662,  1181,  1662,  1176,
      -1,   335,  1175,  1662,  1181,  1662,  1181,  1662,  1181,  1662,
    1133,  1256,  1176,    -1,   335,  1175,  1662,  1181,  1662,  1181,
    1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,    42,
    1175,  1662,  1181,    36,  1176,    -1,    42,  1175,  1662,  1181,
      36,  1133,  1256,  1176,    -1,    42,  1175,  1662,  1181,    36,
    1133,  1256,  1133,  1256,  1176,    -1,    42,  1175,  1662,  1181,
      36,  1133,  1256,  1133,  1256,  1133,  1256,  1176,    -1,    43,
    1175,  1662,  1181,    36,  1176,    -1,    43,  1175,  1662,  1181,
      36,  1133,  1256,  1176,    -1,    43,  1175,  1662,  1181,    36,
    1133,  1256,  1133,  1256,  1176,    -1,    43,  1175,  1662,  1181,
      36,  1133,  1256,  1133,  1256,  1133,  1256,  1176,    -1,    53,
      -1,    61,    -1,    42,  1175,  1662,  1181,  1688,  1176,    -1,
      42,  1175,  1662,  1181,  1688,  1133,  1256,  1176,    -1,    42,
    1175,  1662,  1181,  1688,  1133,  1256,  1133,  1256,  1176,    -1,
      42,  1175,  1662,  1181,  1688,  1133,  1256,  1133,  1256,  1133,
    1256,  1176,    -1,    43,  1175,  1662,  1181,  1688,  1176,    -1,
      43,  1175,  1662,  1181,  1688,  1133,  1256,  1176,    -1,    43,
    1175,  1662,  1181,  1688,  1133,  1256,  1133,  1256,  1176,    -1,
      43,  1175,  1662,  1181,  1688,  1133,  1256,  1133,  1256,  1133,
    1256,  1176,    -1,   336,  1175,  1662,  1181,  1662,  1176,    -1,
     336,  1175,  1662,  1181,  1662,  1133,  1256,  1176,    -1,   336,
    1175,  1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,
     337,  1175,  1662,  1181,  1662,  1176,    -1,   337,  1175,  1662,
    1181,  1662,  1133,  1256,  1176,    -1,   337,  1175,  1662,  1181,
    1662,  1133,  1256,  1133,  1256,  1176,    -1,   338,  1175,  1662,
    1181,  1662,  1176,    -1,   338,  1175,  1662,  1181,  1662,  1133,
    1256,  1176,    -1,   338,  1175,  1662,  1181,  1662,  1133,  1256,
    1133,  1256,  1176,    -1,   339,  1175,  1662,  1181,  1662,  1176,
      -1,   339,  1175,  1662,  1181,  1662,  1133,  1256,  1176,    -1,
     339,  1175,  1662,  1181,  1662,  1133,  1256,  1133,  1256,  1176,
      -1,   340,  1175,  1662,  1181,  1662,  1176,    -1,   340,  1175,
    1662,  1181,  1662,  1133,  1256,  1176,    -1,   340,  1175,  1662,
    1181,  1662,  1133,  1256,  1133,  1256,  1176,    -1,   341,  1175,
    1662,  1181,  1662,  1176,    -1,   341,  1175,  1662,  1181,  1662,
    1133,  1256,  1176,    -1,   341,  1175,  1662,  1181,  1662,  1133,
    1256,  1133,  1256,  1176,    -1,   342,  1175,  1662,  1176,    -1,
     342,  1175,  1662,  1133,  1256,  1176,    -1,   343,  1175,  1662,
    1176,    -1,   343,  1175,  1662,  1133,  1256,  1176,    -1,   344,
    1175,  1662,  1176,    -1,   344,  1175,  1662,  1133,  1256,  1176,
      -1,   345,  1175,  1662,  1176,    -1,   345,  1175,  1662,  1133,
    1256,  1176,    -1,   346,  1175,  1662,  1176,    -1,   346,  1175,
    1662,  1133,  1256,  1176,    -1,   347,  1175,  1662,  1176,    -1,
     347,  1175,  1662,  1133,  1256,  1176,    -1,   351,  1175,  1662,
    1176,    -1,   351,  1175,  1662,  1133,  1256,  1176,    -1,   351,
    1175,  1662,  1133,  1256,  1133,  1256,  1176,    -1,   354,  1175,
    1662,  1176,    -1,   354,  1175,  1662,  1133,  1256,  1176,    -1,
     354,  1175,  1662,  1133,  1256,  1133,  1256,  1176,    -1,   355,
    1175,  1662,  1176,    -1,   355,  1175,  1662,  1133,  1256,  1176,
      -1,   355,  1175,  1662,  1133,  1256,  1133,  1256,  1176,    -1,
     356,  1175,  1662,  1176,    -1,   356,  1175,  1662,  1133,  1256,
    1176,    -1,   356,  1175,  1662,  1133,  1256,  1133,  1256,  1176,
      -1,   357,  1175,  1662,  1176,    -1,   357,  1175,  1662,  1133,
    1256,  1176,    -1,   357,  1175,  1662,  1133,  1256,  1133,  1256,
    1176,    -1,   358,  1175,  1662,  1176,    -1,   358,  1175,  1662,
    1133,  1256,  1176,    -1,   358,  1175,  1662,  1133,  1256,  1133,
    1256,  1176,    -1,   359,  1175,  1662,  1176,    -1,   359,  1175,
    1662,  1133,  1256,  1176,    -1,   359,  1175,  1662,  1133,  1256,
    1133,  1256,  1176,    -1,   360,  1175,  1662,  1176,    -1,   360,
    1175,  1662,  1133,  1256,  1176,    -1,   360,  1175,  1662,  1133,
    1256,  1133,  1256,  1176,    -1,   361,  1175,  1662,  1176,    -1,
     361,  1175,  1662,  1133,  1256,  1176,    -1,   361,  1175,  1662,
    1133,  1256,  1133,  1256,  1176,    -1,   420,  1175,  1664,  1176,
      -1,   423,  1175,  1664,  1176,    -1,   419,    -1,   422,    -1,
     421,    -1,   415,    -1,   416,    -1,   417,    -1,   418,    -1,
     424,    -1,   425,    -1,   426,    -1,   169,    -1,   433,    -1,
     434,    -1,   435,    -1,   431,    -1,   432,    -1,   148,    -1,
     149,    -1,   150,    -1,   151,    -1,   152,    -1,   153,    -1,
     157,    -1,   156,    -1,   159,    -1,   158,    -1,   154,    -1,
     427,    -1,   436,    -1,   428,    -1,   429,    -1,   430,    -1,
    1689,    -1,   399,  1175,  1937,  1176,    -1,   386,  1175,  1937,
    1176,    -1,   393,  1175,  1937,  1176,    -1,   394,  1175,  1937,
    1176,    -1,   387,  1175,  1937,  1176,    -1,   400,  1175,  1937,
    1176,    -1,   401,  1175,  1937,  1176,    -1,   388,  1175,  1937,
    1176,    -1,   389,  1175,  1937,  1176,    -1,   390,  1175,  1937,
    1176,    -1,   402,  1175,  1937,  1176,    -1,   391,  1175,  1937,
    1176,    -1,   407,  1175,  1937,  1176,    -1,   392,  1175,  1937,
    1176,    -1,   403,  1175,  1937,  1176,    -1,   395,  1175,  1937,
    1176,    -1,   404,  1175,  1937,  1176,    -1,   396,  1175,  1937,
    1176,    -1,   397,  1175,  1937,  1176,    -1,   397,  1175,  1937,
    1176,  1130,  1662,  1177,    -1,   398,  1175,  1937,  1176,    -1,
     405,  1175,  1937,  1176,    -1,   408,  1175,  1937,  1176,    -1,
     409,  1175,  1937,  1176,    -1,   410,  1175,  1937,  1176,    -1,
     411,  1175,  1937,  1176,    -1,   412,  1175,  1937,  1176,    -1,
     406,  1175,  1937,  1176,    -1,   413,  1175,  1937,  1176,    -1,
     414,  1175,  1937,  1176,    -1,    -1,  1692,    -1,  1693,  1134,
    1262,  1694,  1691,    -1,  1693,  1134,  1262,    -1,    -1,    -1,
      -1,  1695,  1700,  1696,    -1,    -1,  1699,  1253,  1697,  1655,
    1172,    -1,  1127,    -1,  1182,     1,    -1,  1699,  1259,  1698,
      -1,  1699,    46,    41,    -1,  1699,  1261,    41,    -1,  1699,
      59,  1173,    -1,   485,  1127,    -1,   486,  1127,    -1,   487,
    1127,    -1,   488,  1127,    -1,   489,  1127,    -1,   490,  1127,
      -1,  1126,    -1,  1699,  1722,  1172,    -1,    -1,    -1,  1696,
      -1,  1701,  1700,  1696,    -1,  1722,    -1,   508,    -1,  1702,
     508,    -1,   507,    -1,  1702,   507,    -1,  1915,    -1,  1702,
    1915,    -1,  1916,    -1,  1702,  1916,    -1,  1926,    -1,  1702,
    1926,    -1,  1706,    -1,  1707,    -1,  1705,    -1,  1707,    -1,
    1706,    -1,  1707,    -1,  1706,    -1,  1707,    -1,  1706,    -1,
    1707,    -1,  1706,    -1,  1707,    -1,  1706,    -1,  1707,    -1,
    1664,    -1,  1702,  1664,    -1,    46,    -1,  1702,    46,    -1,
    1175,  1195,  1181,  1195,  1176,    -1,  1203,  1181,  1203,    -1,
    1175,  1203,  1181,  1203,  1176,    -1,  1175,  1713,  1181,  1203,
    1176,    -1,  1175,  1203,  1181,  1713,  1176,    -1,   146,  1175,
    1180,  1695,  1179,  1181,  1662,  1176,    -1,   122,  1627,   123,
      -1,   126,  1635,   127,    -1,   124,  1649,   125,    -1,  1361,
      96,    -1,   119,  1175,  1664,  1176,    -1,    -1,    68,  1125,
    1724,  1725,  1128,  1723,  1729,    -1,    -1,  1726,    -1,  1290,
      -1,  1727,    -1,  1728,    -1,  1728,  1133,  1727,    -1,  1715,
      -1,  1193,    -1,   508,    -1,   507,    -1,   115,  1193,    -1,
    1705,    -1,   115,  1705,    -1,  1730,    -1,  1731,    -1,  1732,
      -1,  1734,    -1,  1735,    -1,  1737,    -1,  1739,    -1,    56,
    1742,    -1,    64,  1742,    -1,    72,  1742,    -1,  1730,    -1,
    1731,    -1,  1732,    -1,  1734,    -1,  1735,    -1,  1737,    -1,
    1739,    -1,  1125,   117,  1249,  1191,  1176,    -1,  1927,  1741,
    1744,    -1,  1733,  1741,  1744,    -1,  1927,  1925,  1740,  1744,
      -1,  1733,  1925,  1740,  1744,    -1,  1125,    -1,    -1,  1927,
    1931,  1736,    69,  1724,  1725,  1128,  1738,  1729,    -1,  1927,
    1931,  1736,  1740,  1744,    -1,  1927,  1931,  1925,  1740,  1744,
      -1,    -1,    -1,    -1,  1125,  1699,  1743,  1746,  1176,    -1,
      -1,  1125,  1699,  1745,  1746,  1176,    -1,  1290,    -1,  1747,
    1749,  1752,    -1,    -1,    -1,    -1,    -1,    -1,  1750,  1755,
      -1,    -1,    -1,  1750,  1755,  1133,  1753,  1751,  1748,  1754,
    1752,    -1,  1715,    -1,   115,  1715,    -1,  1193,    -1,   508,
      -1,   507,    -1,   115,  1193,    -1,  1705,    -1,   115,  1705,
      -1,  1707,    -1,   115,  1707,    -1,  1756,  1757,    44,  1695,
      45,    -1,   174,    -1,    -1,    -1,    44,  1758,  1701,    45,
      -1,    56,    -1,  1702,    56,    -1,    64,    -1,  1702,    64,
      -1,    57,    -1,  1702,    57,    -1,    65,    -1,  1702,    65,
      -1,    72,    -1,  1702,    72,    -1,    59,    -1,    67,    -1,
      56,    -1,    57,    -1,    64,    -1,    65,    -1,    72,    -1,
      60,    -1,    62,    -1,    63,    -1,    46,    -1,    61,    -1,
    1761,    -1,   559,  1762,    -1,   559,  1760,    -1,   559,  1175,
    1759,  1176,    -1,   559,   168,  1126,    -1,   559,   168,  1130,
    1663,  1177,    -1,   559,  1175,  1708,  1176,    -1,   559,  1175,
    1191,  1176,    -1,  1125,  1128,    -1,  1126,    -1,   538,  1763,
      -1,   539,  1763,    -1,   540,  1763,    -1,   541,  1763,    -1,
     560,  1763,    -1,   561,  1763,    -1,   562,  1763,    -1,   563,
    1763,    -1,   564,  1763,    -1,   565,  1763,    -1,   566,  1763,
      -1,   590,  1763,    -1,   591,  1763,    -1,   592,  1763,    -1,
     593,  1763,    -1,   594,  1763,    -1,   598,  1763,    -1,   609,
    1763,    -1,   610,  1763,    -1,   612,  1763,    -1,   613,  1763,
      -1,   647,  1763,    -1,   662,  1763,    -1,   683,  1763,    -1,
     692,  1763,    -1,   691,  1763,    -1,   693,  1763,    -1,   694,
    1763,    -1,   696,  1763,    -1,   697,  1763,    -1,   699,  1763,
      -1,   700,  1763,    -1,   706,  1763,    -1,   783,  1763,    -1,
     784,  1763,    -1,   787,  1763,    -1,   791,  1763,    -1,   792,
    1763,    -1,   704,  1763,    -1,   705,  1763,    -1,   707,  1763,
      -1,   747,  1763,    -1,   776,  1763,    -1,   777,  1763,    -1,
     778,  1763,    -1,   790,  1763,    -1,   797,  1763,    -1,   690,
    1175,  1193,  1176,    -1,   690,  1175,  1198,  1176,    -1,   690,
    1175,  1706,  1176,    -1,   701,  1175,  1193,  1176,    -1,   701,
    1175,  1705,  1176,    -1,   701,  1175,  1715,  1176,    -1,   701,
    1175,  1707,  1176,    -1,   698,  1175,  1193,  1176,    -1,   698,
    1175,  1705,  1176,    -1,   698,  1175,  1715,  1176,    -1,   698,
    1175,  1707,  1176,    -1,   695,  1175,  1193,  1176,    -1,   695,
    1175,   508,  1176,    -1,   695,  1175,  1702,   508,  1176,    -1,
     695,  1175,   507,  1176,    -1,   695,  1175,  1702,   507,  1176,
      -1,   695,  1175,  1198,  1176,    -1,   695,  1175,  1705,  1176,
      -1,   695,  1175,  1716,  1176,    -1,   695,  1175,  1707,  1176,
      -1,  1765,    -1,  1766,    -1,   437,    -1,  1702,   437,    -1,
     438,    -1,   439,    -1,   440,    -1,   441,    -1,   442,    -1,
     443,    -1,   444,    -1,  1702,   438,    -1,  1702,   439,    -1,
    1702,   440,    -1,  1702,   441,    -1,  1702,   442,    -1,  1702,
     443,    -1,  1702,   444,    -1,   811,    -1,   814,    -1,   829,
      -1,   830,    -1,   819,    -1,   817,    -1,   825,    -1,   823,
      -1,   812,    -1,   815,    -1,   831,    -1,   820,    -1,   818,
      -1,   826,    -1,   824,    -1,  1767,  1763,    -1,  1768,  1763,
      -1,  1767,  1175,  1766,  1181,  1765,  1176,    -1,  1767,  1175,
    1765,  1181,  1764,  1176,    -1,  1768,  1175,  1765,  1181,  1764,
    1128,    -1,  1767,  1175,  1764,  1128,    -1,  1768,  1175,  1764,
    1128,    -1,  1767,  1175,  1705,  1176,    -1,  1767,  1175,  1715,
    1176,    -1,  1769,  1175,  1705,  1176,    -1,  1769,  1175,  1715,
    1176,    -1,   813,    -1,   816,    -1,   832,    -1,   833,    -1,
     822,    -1,   821,    -1,   828,    -1,   827,    -1,   837,  1763,
      -1,   841,  1763,    -1,   842,  1763,    -1,   843,  1763,    -1,
     844,  1763,    -1,   845,  1763,    -1,   838,  1763,    -1,   839,
    1763,    -1,   840,  1763,    -1,   810,  1763,    -1,   846,  1763,
      -1,   847,  1763,    -1,   848,  1763,    -1,   849,  1763,    -1,
     850,  1763,    -1,   851,  1763,    -1,   852,  1763,    -1,   853,
    1763,    -1,   854,  1763,    -1,   855,  1763,    -1,   856,  1763,
      -1,   857,  1763,    -1,   858,  1763,    -1,   859,  1763,    -1,
     860,  1763,    -1,   861,  1763,    -1,   862,  1763,    -1,   863,
    1763,    -1,   867,  1763,    -1,   868,  1763,    -1,   877,  1763,
      -1,   878,  1763,    -1,   879,  1763,    -1,   836,  1763,    -1,
     800,  1175,  1764,  1176,    -1,   800,  1175,  1705,  1176,    -1,
     800,  1175,  1715,  1176,    -1,   803,  1175,  1764,  1176,    -1,
     803,  1175,  1706,  1176,    -1,   804,  1175,  1764,  1176,    -1,
     804,  1175,  1706,  1176,    -1,   809,  1763,    -1,   809,  1175,
    1764,  1176,    -1,   805,  1175,  1706,  1176,    -1,   806,  1175,
    1706,  1176,    -1,   801,  1175,  1705,  1176,    -1,   807,  1175,
    1708,  1176,    -1,   808,  1175,  1708,  1176,    -1,   802,  1175,
    1708,  1176,    -1,   880,  1175,  1764,  1176,    -1,   883,    -1,
     887,    -1,   885,    -1,   884,    -1,   886,    -1,   892,    -1,
     888,    -1,   882,    -1,   890,    -1,   889,    -1,   881,    -1,
     891,    -1,  1770,  1175,  1764,  1176,    -1,  1770,  1175,  1764,
    1133,  1765,  1176,    -1,   895,    -1,   893,    -1,   896,    -1,
     894,    -1,  1771,  1175,  1764,  1176,    -1,  1771,  1175,  1765,
    1133,  1764,  1176,    -1,   835,  1763,    -1,   835,  1175,  1764,
    1176,    -1,   835,  1175,  1765,  1133,  1764,  1176,    -1,   834,
    1763,    -1,   834,  1175,  1764,  1176,    -1,   834,  1175,  1765,
    1133,  1764,  1176,    -1,   869,  1175,  1708,  1176,    -1,   870,
    1175,  1708,  1176,    -1,   871,  1175,  1708,  1176,    -1,   872,
    1175,  1708,  1176,    -1,   873,  1175,  1708,  1176,    -1,   874,
    1175,  1708,  1176,    -1,  1037,  1175,  1708,  1176,    -1,  1036,
    1175,  1708,  1176,    -1,   864,  1175,  1706,  1176,    -1,   864,
    1175,  1707,  1176,    -1,   865,  1175,  1706,  1176,    -1,   865,
    1175,  1707,  1176,    -1,   866,  1175,  1706,  1176,    -1,   866,
    1175,  1707,  1176,    -1,   875,  1175,  1708,  1176,    -1,   875,
    1175,   447,  1176,    -1,   875,  1175,  1702,   447,  1176,    -1,
     876,  1175,  1708,  1176,    -1,   876,  1175,   447,  1176,    -1,
     876,  1175,  1702,   447,  1176,    -1,   961,  1763,    -1,   959,
    1175,  1711,  1181,  1195,  1176,    -1,   959,  1175,  1195,  1181,
    1711,  1176,    -1,   959,  1175,  1711,  1181,  1203,  1176,    -1,
     959,  1175,  1203,  1181,  1711,  1176,    -1,   959,  1175,  1191,
    1181,  1195,  1176,    -1,   959,  1175,  1195,  1181,  1191,  1176,
      -1,   959,  1175,  1191,  1181,  1203,  1176,    -1,   959,  1175,
    1203,  1181,  1191,  1176,    -1,   960,  1175,  1712,  1181,  1195,
    1176,    -1,   960,  1175,  1712,  1181,  1203,  1176,    -1,   960,
    1175,  1195,  1181,  1712,  1176,    -1,   960,  1175,  1203,  1181,
    1712,  1176,    -1,   960,  1719,    -1,   960,  1717,    -1,   964,
      -1,   969,    -1,   971,    -1,  1033,    -1,  1048,    -1,  1053,
      -1,  1083,    -1,  1088,    -1,  1098,    -1,  1100,    -1,  1106,
      -1,  1110,    -1,  1121,    -1,   965,    -1,  1034,    -1,  1050,
      -1,  1055,    -1,  1084,    -1,  1099,    -1,  1101,    -1,  1108,
      -1,  1113,    -1,   962,    -1,   968,    -1,   970,    -1,  1032,
      -1,  1047,    -1,  1052,    -1,  1082,    -1,  1087,    -1,  1105,
      -1,  1111,    -1,  1120,    -1,   963,    -1,  1035,    -1,  1049,
      -1,  1054,    -1,  1085,    -1,  1107,    -1,  1112,    -1,   967,
      -1,   966,    -1,  1011,    -1,  1012,    -1,  1014,    -1,  1017,
      -1,  1027,    -1,  1028,    -1,  1039,    -1,  1038,    -1,  1041,
      -1,  1040,    -1,  1077,    -1,  1078,    -1,  1772,  1719,    -1,
    1772,  1175,  1708,  1181,  1203,  1176,    -1,  1058,    -1,  1081,
      -1,  1057,    -1,  1080,    -1,  1060,    -1,  1061,    -1,  1773,
    1719,    -1,  1773,  1720,    -1,  1773,  1721,    -1,  1071,  1721,
      -1,  1073,  1721,    -1,   676,  1175,  1203,  1181,  1203,  1176,
      -1,   676,  1175,  1712,  1181,  1203,  1176,    -1,   676,  1175,
    1203,  1181,  1712,  1176,    -1,  1079,  1175,  1203,  1181,  1203,
    1176,    -1,  1079,  1175,  1711,  1181,  1203,  1176,    -1,  1079,
    1175,  1203,  1181,  1711,  1176,    -1,   661,    -1,   775,    -1,
     673,    -1,  1774,  1175,  1710,  1176,    -1,  1774,  1175,  1194,
    1176,    -1,   658,    -1,   671,    -1,   672,    -1,   788,    -1,
     789,    -1,  1775,  1175,  1708,  1176,    -1,  1775,  1175,  1189,
    1176,    -1,   659,    -1,   657,    -1,   656,    -1,   660,    -1,
    1776,  1175,  1708,  1176,    -1,   611,  1175,  1708,  1176,    -1,
     648,    -1,   655,    -1,  1777,  1175,  1189,  1181,  1189,  1176,
      -1,  1777,  1175,  1189,  1181,  1710,  1176,    -1,  1777,  1175,
    1191,  1181,  1191,  1176,    -1,  1777,  1175,  1191,  1181,  1711,
    1176,    -1,  1067,    -1,  1065,    -1,  1063,    -1,  1068,    -1,
    1778,  1175,  1712,  1181,  1203,  1176,    -1,  1778,  1175,  1203,
    1181,  1712,  1176,    -1,  1779,  1719,    -1,  1059,  1175,  1203,
    1181,  1203,  1176,    -1,  1059,  1175,  1712,  1181,  1203,  1176,
      -1,  1119,    -1,  1117,    -1,  1780,  1719,    -1,  1780,  1175,
    1713,  1181,  1203,  1176,    -1,  1066,    -1,  1064,    -1,  1781,
    1175,  1712,  1181,  1203,  1176,    -1,  1781,  1175,  1203,  1181,
    1712,  1176,    -1,  1118,    -1,  1116,    -1,  1010,    -1,  1782,
    1719,    -1,  1782,  1175,  1714,  1181,  1203,  1176,    -1,   567,
      -1,   568,    -1,   569,    -1,   570,    -1,   571,    -1,   572,
      -1,   573,    -1,   574,    -1,   575,    -1,   576,    -1,   579,
      -1,   580,    -1,   581,    -1,   582,    -1,   577,    -1,   578,
      -1,   549,    -1,   550,    -1,  1783,  1175,  1189,  1181,  1189,
    1176,    -1,  1783,  1175,  1191,  1181,  1191,  1176,    -1,  1783,
    1175,  1708,  1181,  1194,  1176,    -1,  1070,    -1,  1069,    -1,
    1784,  1175,  1203,  1181,  1191,  1176,    -1,   936,    -1,   933,
      -1,   934,    -1,   935,    -1,   937,    -1,   930,    -1,   931,
      -1,   932,    -1,   900,    -1,   913,    -1,   928,    -1,   929,
      -1,   915,    -1,   914,    -1,   916,    -1,   917,    -1,   922,
      -1,   938,    -1,   911,    -1,   912,    -1,   921,    -1,   947,
      -1,   903,    -1,   904,    -1,   919,    -1,   948,    -1,   909,
      -1,   910,    -1,   920,    -1,   949,    -1,   901,    -1,   902,
      -1,   918,    -1,   950,    -1,   905,    -1,   906,    -1,   907,
      -1,   908,    -1,   897,    -1,   898,    -1,   899,    -1,  1785,
    1717,    -1,  1785,  1175,  1708,  1181,  1195,  1176,    -1,  1785,
    1719,    -1,  1785,  1175,  1708,  1181,  1203,  1176,    -1,   939,
      -1,   940,    -1,   941,    -1,   943,    -1,   944,    -1,   945,
      -1,  1787,  1717,    -1,  1787,  1719,    -1,  1786,  1717,    -1,
    1786,  1719,    -1,   942,  1719,    -1,   946,  1719,    -1,  1787,
    1175,  1708,  1181,  1195,  1176,    -1,  1786,  1175,  1708,  1181,
    1195,  1176,    -1,  1787,  1175,  1708,  1181,  1203,  1176,    -1,
    1786,  1175,  1708,  1181,  1203,  1176,    -1,  1042,  1721,    -1,
     942,  1720,    -1,   946,  1720,    -1,  1664,    -1,  1094,    -1,
     927,    -1,  1095,    -1,   926,  1175,  1788,  1181,  1195,  1181,
    1195,  1176,    -1,   926,  1175,  1788,  1181,  1712,  1181,  1195,
    1176,    -1,  1789,  1175,  1788,  1181,  1718,  1176,    -1,  1789,
    1175,  1788,  1181,  1713,  1181,  1203,  1176,    -1,   954,    -1,
     957,    -1,   951,    -1,   955,    -1,   958,    -1,   952,    -1,
     956,    -1,   953,    -1,  1097,    -1,  1096,    -1,  1790,  1175,
    1788,  1181,  1195,  1176,    -1,  1790,  1175,  1788,  1181,  1203,
    1176,    -1,  1790,  1717,    -1,  1790,  1175,  1709,  1181,  1195,
    1176,    -1,  1790,  1719,    -1,  1790,  1175,  1709,  1181,  1203,
    1176,    -1,   761,    -1,   762,    -1,   755,    -1,   756,    -1,
     757,    -1,   758,    -1,   759,    -1,   760,    -1,   763,    -1,
     764,    -1,   765,    -1,   766,    -1,   767,    -1,   769,    -1,
     768,    -1,   770,    -1,  1791,  1175,  1186,  1176,    -1,  1791,
    1175,  1709,  1176,    -1,   552,    -1,   553,    -1,   555,    -1,
     557,    -1,   554,    -1,   556,    -1,   558,    -1,  1792,  1175,
    1715,  1181,  1194,  1176,    -1,  1792,  1175,  1715,  1181,  1709,
    1176,    -1,  1792,  1175,  1194,  1181,  1194,  1176,    -1,  1792,
    1175,  1194,  1181,  1709,  1176,    -1,  1792,  1175,  1194,  1181,
    1715,  1176,    -1,   772,    -1,   774,    -1,  1793,  1175,  1715,
    1181,  1194,  1181,  1194,  1176,    -1,  1793,  1175,  1821,  1181,
    1194,  1181,  1194,  1176,    -1,  1793,  1175,  1715,  1181,  1194,
    1181,  1708,  1176,    -1,  1793,  1175,  1821,  1181,  1194,  1181,
    1708,  1176,    -1,   649,  1175,  1191,  1181,  1709,  1176,    -1,
     649,  1175,  1709,  1181,  1191,  1176,    -1,    56,    -1,    64,
      -1,    57,    -1,    65,    -1,    59,    -1,   649,  1175,  1191,
    1181,  1794,  1176,    -1,   649,  1175,  1794,  1181,  1191,  1176,
      -1,   649,  1175,  1702,  1794,  1181,  1191,  1176,    -1,   649,
    1175,  1191,  1181,  1702,  1794,  1176,    -1,   649,  1175,  1191,
    1181,  1716,  1176,    -1,   649,  1175,  1716,  1181,  1191,  1176,
      -1,   649,  1175,  1191,  1181,  1668,  1176,    -1,   649,  1175,
    1668,  1181,  1191,  1176,    -1,   649,  1175,  1702,  1668,  1181,
    1191,  1176,    -1,   649,  1175,  1191,  1181,  1702,  1668,  1176,
      -1,   649,  1175,  1191,  1181,   113,  1715,  1176,    -1,   649,
    1175,   113,  1715,  1181,  1191,  1176,    -1,   678,    -1,   679,
      -1,  1795,  1175,  1193,  1181,  1193,  1176,    -1,  1795,  1175,
    1706,  1181,  1193,  1176,    -1,  1795,  1175,  1707,  1181,  1193,
    1176,    -1,   793,  1175,  1193,  1181,  1193,  1176,    -1,   793,
    1175,  1193,  1181,  1708,  1176,    -1,   794,  1175,  1193,  1181,
    1708,  1176,    -1,   794,  1175,  1193,  1181,  1193,  1176,    -1,
     976,    -1,   979,    -1,   978,    -1,   980,    -1,   977,    -1,
     981,    -1,   982,    -1,   983,    -1,   975,  1175,  1662,  1181,
    1718,  1176,    -1,  1796,  1719,    -1,   975,  1175,  1662,  1181,
    1711,  1181,  1203,  1176,    -1,  1796,  1175,  1711,  1181,  1203,
    1176,    -1,   984,    -1,   987,    -1,   986,    -1,   988,    -1,
     985,    -1,   989,    -1,   990,    -1,   991,    -1,   585,  1175,
    1662,  1181,  1203,  1181,  1203,  1176,    -1,  1797,  1175,  1203,
    1181,  1203,  1176,    -1,   585,  1175,  1662,  1181,  1712,  1181,
    1203,  1176,    -1,  1797,  1175,  1712,  1181,  1203,  1176,    -1,
     992,    -1,   995,    -1,   994,    -1,   996,    -1,   993,    -1,
     997,    -1,   998,    -1,   999,    -1,   974,  1175,  1662,  1181,
    1718,  1176,    -1,  1798,  1719,    -1,   974,  1175,  1662,  1181,
    1713,  1181,  1203,  1176,    -1,  1798,  1720,    -1,  1000,    -1,
    1003,    -1,  1002,    -1,  1004,    -1,  1001,    -1,  1005,    -1,
    1006,    -1,  1007,    -1,   973,  1175,  1662,  1181,  1718,  1176,
      -1,  1799,  1719,    -1,   973,  1175,  1662,  1181,  1713,  1181,
    1203,  1176,    -1,  1799,  1720,    -1,  1072,  1175,  1191,  1181,
    1711,  1176,    -1,   924,  1175,  1662,  1181,  1194,  1181,  1195,
    1176,    -1,   924,  1175,  1662,  1181,  1194,  1181,  1203,  1176,
      -1,   924,  1175,  1662,  1181,  1710,  1181,  1195,  1176,    -1,
     924,  1175,  1662,  1181,  1710,  1181,  1203,  1176,    -1,   923,
    1175,  1662,  1181,  1195,  1181,  1191,  1176,    -1,   923,  1175,
    1662,  1181,  1203,  1181,  1191,  1176,    -1,  1104,    -1,  1103,
      -1,  1800,  1175,  1662,  1181,  1718,  1176,    -1,  1800,  1175,
    1662,  1181,  1713,  1181,  1203,  1176,    -1,   589,  1175,  1708,
    1176,    -1,   589,  1175,     1,  1176,    -1,  1076,  1175,  1195,
    1181,  1203,  1176,    -1,  1062,  1175,  1203,  1181,  1195,  1176,
      -1,   925,  1175,  1195,  1181,  1191,  1176,    -1,   925,  1175,
    1203,  1181,  1191,  1176,    -1,  1075,  1175,  1195,  1181,  1712,
    1176,    -1,  1074,  1175,  1203,  1181,  1713,  1176,    -1,  1046,
    1717,    -1,  1045,  1719,    -1,  1115,    -1,  1114,    -1,  1009,
      -1,  1008,    -1,  1801,  1719,    -1,  1801,  1175,  1709,  1181,
    1203,  1176,    -1,  1013,    -1,  1026,    -1,  1802,  1175,  1203,
    1181,  1195,  1176,    -1,  1802,  1175,  1713,  1181,  1195,  1176,
      -1,  1018,  1175,  1203,  1181,  1203,  1176,    -1,  1023,  1175,
    1203,  1181,  1203,  1176,    -1,  1018,  1175,  1712,  1181,  1203,
    1176,    -1,  1023,  1175,  1712,  1181,  1203,  1176,    -1,  1015,
      -1,  1016,    -1,  1803,  1175,  1195,  1181,  1203,  1176,    -1,
    1803,  1175,  1712,  1181,  1203,  1176,    -1,  1019,    -1,  1029,
      -1,  1804,  1175,  1203,  1181,  1195,  1176,    -1,  1804,  1175,
    1712,  1181,  1195,  1176,    -1,  1020,    -1,  1030,    -1,  1805,
    1175,  1203,  1181,  1191,  1176,    -1,  1805,  1175,  1712,  1181,
    1191,  1176,    -1,  1025,    -1,  1031,    -1,  1806,  1175,  1203,
    1181,  1191,  1176,    -1,  1806,  1175,  1711,  1181,  1191,  1176,
      -1,  1021,    -1,  1022,    -1,  1807,  1175,  1191,  1181,  1203,
    1176,    -1,  1807,  1175,  1711,  1181,  1203,  1176,    -1,  1024,
    1175,  1203,  1181,  1203,  1176,    -1,  1024,  1175,  1711,  1181,
    1203,  1176,    -1,   972,    -1,  1090,    -1,  1091,    -1,  1092,
      -1,  1093,    -1,  1808,  1175,  1708,  1176,    -1,  1089,  1763,
      -1,  1044,  1763,    -1,  1051,  1763,    -1,  1102,  1763,    -1,
    1056,  1763,    -1,  1086,  1763,    -1,  1043,    -1,  1109,    -1,
    1809,  1175,  1711,  1176,    -1,   544,    -1,   545,    -1,   542,
      -1,   543,    -1,    10,    -1,   546,    -1,   798,    -1,   799,
      -1,     7,    -1,   685,    -1,   750,    -1,   751,    -1,   782,
      -1,   785,    -1,  1810,  1175,  1193,  1181,  1193,  1176,    -1,
    1810,  1175,  1193,  1181,  1708,  1176,    -1,  1810,  1175,  1709,
    1181,  1193,  1176,    -1,  1810,  1175,  1715,  1181,  1193,  1176,
      -1,  1810,  1175,  1715,  1181,  1705,  1176,    -1,  1810,  1175,
    1715,  1181,  1707,  1176,    -1,   583,  1175,  1193,  1181,  1193,
    1176,    -1,   583,  1175,  1193,  1181,  1709,  1176,    -1,   583,
    1175,  1705,  1181,  1193,  1176,    -1,   583,  1175,  1707,  1181,
    1193,  1176,    -1,   583,  1175,  1193,  1181,  1715,  1176,    -1,
     583,  1175,  1705,  1181,  1715,  1176,    -1,   583,  1175,  1707,
    1181,  1715,  1176,    -1,   595,    -1,   603,    -1,   681,    -1,
      26,    -1,   596,    -1,   604,    -1,   682,    -1,   684,    -1,
    1811,  1175,  1193,  1176,    -1,  1811,  1175,  1706,  1176,    -1,
    1811,  1175,  1707,  1176,    -1,  1133,   447,    -1,  1133,   507,
      -1,  1133,   508,    -1,  1133,  1702,   447,    -1,  1133,  1702,
     507,    -1,  1133,  1702,   508,    -1,    25,    -1,    24,    -1,
     599,    -1,   600,    -1,  1813,  1175,  1193,  1176,    -1,  1813,
    1175,  1193,  1812,  1176,    -1,  1813,  1175,  1709,  1176,    -1,
    1813,  1175,  1709,  1812,  1176,    -1,  1813,  1175,  1715,  1812,
    1176,    -1,  1813,  1175,  1715,  1176,    -1,  1133,   445,    -1,
    1133,   447,    -1,  1133,   448,    -1,  1133,  1702,   445,    -1,
    1133,  1702,   447,    -1,  1133,  1702,   448,    -1,   680,    -1,
     601,    -1,  1815,  1175,  1193,  1176,    -1,  1815,  1175,  1193,
    1814,  1176,    -1,  1815,  1175,  1709,  1176,    -1,  1815,  1175,
    1709,  1814,  1176,    -1,  1815,  1175,  1715,  1814,  1176,    -1,
    1815,  1175,  1715,  1176,    -1,   548,  1175,  1193,  1181,  1706,
    1176,    -1,   548,  1175,  1193,  1181,  1715,  1133,  1715,  1176,
      -1,   548,  1175,  1193,  1181,  1707,  1176,    -1,   547,  1175,
    1189,  1181,  1189,  1176,    -1,   547,  1175,  1189,  1181,  1706,
    1176,    -1,   547,  1175,  1189,  1181,  1707,  1176,    -1,   547,
    1175,     1,  1176,    -1,   614,    -1,   615,    -1,   616,    -1,
     617,    -1,   618,    -1,   619,    -1,   620,    -1,   621,    -1,
     622,    -1,   623,    -1,   624,    -1,   625,    -1,   626,    -1,
     627,    -1,   628,    -1,   629,    -1,   630,    -1,   631,    -1,
     632,    -1,   633,    -1,   634,    -1,   636,    -1,   637,    -1,
     638,    -1,   635,    -1,   639,    -1,   640,    -1,   641,    -1,
     642,    -1,   643,    -1,   644,    -1,   645,    -1,   666,    -1,
     667,    -1,   669,    -1,   668,    -1,   670,    -1,  1816,  1260,
      -1,  1816,  1175,  1260,  1176,    -1,  1816,   168,  1126,    -1,
    1816,   168,  1130,  1663,  1177,    -1,   786,  1175,  1193,  1181,
    1193,  1176,    -1,   786,  1175,  1193,  1181,  1708,  1176,    -1,
     786,  1175,  1709,  1181,  1193,  1176,    -1,   786,  1175,  1715,
    1181,  1193,  1176,    -1,   786,  1175,  1715,  1181,  1706,  1176,
      -1,   795,    -1,   796,    -1,  1817,  1175,  1193,  1181,  1193,
    1176,    -1,  1817,  1175,  1709,  1181,  1193,  1176,    -1,  1817,
    1175,  1193,  1181,  1709,  1176,    -1,  1818,  1763,    -1,   663,
      -1,   664,    -1,   665,    -1,  1819,    -1,   585,  1763,    -1,
     676,  1763,    -1,   720,    -1,   721,    -1,   722,    -1,   723,
      -1,   724,    -1,   725,    -1,   732,    -1,   733,    -1,   734,
      -1,   738,    -1,   739,    -1,   740,    -1,   726,    -1,   727,
      -1,   728,    -1,   729,    -1,   730,    -1,   731,    -1,   735,
      -1,   736,    -1,   737,    -1,   741,    -1,   742,    -1,   743,
      -1,   708,    -1,   709,    -1,   710,    -1,   717,    -1,   718,
      -1,   719,    -1,   711,    -1,   712,    -1,   713,    -1,   714,
      -1,   715,    -1,   716,    -1,   584,    -1,   586,    -1,   752,
      -1,   754,    -1,   753,    -1,   675,    -1,   677,    -1,   779,
      -1,   781,    -1,   780,    -1,   605,    -1,   607,    -1,   606,
      -1,   687,    -1,   689,    -1,   688,    -1,   745,    -1,   746,
      -1,   702,    -1,   703,    -1,   771,    -1,   748,    -1,   773,
      -1,   749,    -1,   453,    -1,  1702,   453,    -1,  1820,  1175,
    1715,  1181,  1193,  1176,    -1,  1820,  1175,  1715,  1181,  1706,
    1176,    -1,  1820,  1175,  1821,  1181,  1193,  1176,    -1,  1820,
    1175,  1821,  1181,  1706,  1176,    -1,  1820,  1175,  1715,  1181,
    1707,  1176,    -1,  1820,  1175,  1821,  1181,  1707,  1176,    -1,
     744,  1175,  1715,  1176,    -1,   744,  1763,    -1,   650,    -1,
     651,    -1,   652,    -1,   653,    -1,   654,    -1,  1822,  1175,
    1191,  1181,  1708,  1176,    -1,   674,  1175,  1193,  1181,  1193,
    1176,    -1,   674,  1175,  1715,  1181,  1193,  1176,    -1,   674,
    1175,  1715,  1181,  1703,  1176,    -1,   674,  1175,  1715,  1181,
    1704,  1176,    -1,   674,  1175,  1715,  1181,  1706,  1176,    -1,
     674,  1175,  1198,  1181,  1193,  1176,    -1,   674,  1175,  1193,
    1181,  1198,  1176,    -1,   674,  1175,  1198,  1181,  1708,  1176,
      -1,   674,  1175,  1709,  1181,  1198,  1176,    -1,   674,  1175,
    1200,  1181,  1193,  1176,    -1,   674,  1175,  1193,  1181,  1200,
    1176,    -1,   674,  1175,  1202,  1181,  1193,  1176,    -1,   674,
    1175,  1193,  1181,  1202,  1176,    -1,   674,  1175,  1709,  1181,
    1708,  1176,    -1,   674,  1175,  1193,  1181,  1708,  1176,    -1,
     674,  1175,  1703,  1181,  1708,  1176,    -1,   674,  1175,  1709,
    1181,  1193,  1176,    -1,   674,  1175,  1709,  1181,  1703,  1176,
      -1,   445,    -1,   447,    -1,   448,    -1,  1823,    -1,  1702,
    1823,    -1,   459,    -1,  1702,   459,    -1,    11,  1175,  1715,
    1181,  1824,  1176,    -1,    11,  1175,  1825,  1181,  1824,  1176,
      -1,   686,  1175,  1824,  1181,  1715,  1176,    -1,   686,  1175,
    1824,  1181,  1825,  1176,    -1,   602,  1175,  1193,  1181,  1193,
    1176,    -1,   602,  1175,  1709,  1181,  1193,  1176,    -1,   602,
    1175,  1715,  1181,  1193,  1176,    -1,   602,  1175,  1715,  1181,
    1193,  1133,  1193,  1176,    -1,   602,  1175,  1715,  1181,  1708,
    1133,  1193,  1176,    -1,   597,  1175,  1715,  1181,  1715,  1176,
      -1,   608,  1175,  1715,  1176,    -1,   646,  1827,    -1,   646,
    1826,    -1,   646,   168,  1126,    -1,   646,   168,  1130,  1663,
    1177,    -1,   646,  1175,  1708,  1176,    -1,   646,  1175,  1191,
    1176,    -1,    59,    -1,    67,    -1,    56,    -1,    57,    -1,
      64,    -1,    65,    -1,    72,    -1,    60,    -1,    62,    -1,
      63,    -1,    46,    -1,    61,    -1,   551,  1175,  1191,  1176,
      -1,   551,  1175,  1709,  1176,    -1,   551,  1175,  1715,  1176,
      -1,   587,  1175,  1193,  1181,  1193,  1176,    -1,   588,  1175,
    1193,  1181,  1193,  1176,    -1,   587,  1175,  1708,  1181,  1193,
    1176,    -1,   588,  1175,  1706,  1181,  1193,  1176,    -1,   174,
    1828,  1706,  1174,  1829,    44,  1695,    45,    -1,    -1,    -1,
      -1,    -1,   203,  1830,  1695,   208,  1831,    -1,   203,  1830,
    1695,   205,  1831,  1695,   208,    -1,    -1,   203,  1830,  1695,
     204,  1831,  1832,  1695,   208,    -1,    -1,   203,  1830,  1695,
     207,  1831,  1833,  1695,   208,    -1,    -1,   203,  1830,  1695,
     205,  1831,  1695,   207,  1834,  1695,   208,    -1,    -1,    -1,
     203,  1830,  1695,   206,  1175,  1715,  1176,  1831,  1835,  1695,
    1836,  1839,   208,    -1,    -1,    -1,   203,  1830,  1695,   205,
    1831,  1695,   206,  1175,  1715,  1176,  1837,  1695,  1838,  1839,
     208,    -1,  1290,    -1,  1840,    -1,  1841,    -1,  1843,  1840,
      -1,  1843,    -1,    -1,   207,  1842,  1695,    -1,    -1,   206,
    1175,  1715,  1176,  1844,  1695,    -1,   209,  1175,  1715,  1176,
      -1,   209,  1175,  1193,  1176,    -1,   209,  1175,  1705,  1176,
      -1,   210,  1175,  1715,  1176,    -1,   210,  1175,  1193,  1176,
      -1,   210,  1175,  1705,  1176,    -1,   192,  1175,  1722,  1172,
    1849,  1907,  1172,  1846,  1722,  1176,  1847,  1856,  1848,  1695,
     195,    -1,    -1,   192,  1175,  1722,  1172,  1849,  1907,  1172,
    1846,  1722,  1176,  1847,  1856,  1848,  1695,   196,  1845,  1695,
     195,    -1,    -1,    -1,    -1,    -1,   186,  1175,  1851,  1907,
    1176,  1856,  1852,  1695,   188,    -1,    -1,   186,  1175,  1851,
    1907,  1176,  1856,  1852,  1695,   189,  1850,  1695,   188,    -1,
      -1,    -1,   186,  1175,    44,  1854,  1695,    45,  1176,  1856,
    1895,  1855,  1695,   188,    -1,    -1,   186,  1175,    44,  1854,
    1695,    45,  1176,  1856,  1895,  1855,  1695,   189,  1853,  1695,
     188,    -1,    -1,    -1,  1290,    -1,   187,    -1,   190,  1857,
    1858,  1859,  1860,  1695,   191,  1861,  1175,  1907,  1176,    -1,
      -1,    -1,    -1,   190,  1857,  1858,  1859,  1860,  1695,   191,
    1861,  1175,    44,  1695,    45,  1176,    -1,    -1,    -1,  1863,
      -1,  1866,    -1,  1869,    -1,  1863,    -1,  1866,    -1,  1869,
      -1,    -1,   194,  1871,  1742,  1864,  1860,  1856,  1695,   195,
      -1,    -1,   194,    68,  1125,  1724,  1725,  1128,  1865,  1862,
      -1,    -1,   194,  1927,  1931,  1736,  1740,  1744,  1867,  1860,
    1856,  1695,   195,    -1,    -1,   194,  1927,  1931,  1736,    69,
    1724,  1725,  1128,  1868,  1862,    -1,    -1,   194,  1927,  1931,
    1925,  1740,  1744,  1870,  1860,  1856,  1695,   195,    -1,    57,
      -1,    65,    -1,    -1,   193,  1872,  1860,  1695,   195,    -1,
      -1,    93,  1260,  1172,  1873,  1695,    94,  1260,    -1,   197,
    1260,    -1,   198,  1175,  1874,  1907,  1176,  1260,    -1,    -1,
     198,  1175,    44,  1875,  1695,    45,  1176,  1260,    -1,    -1,
     199,    -1,   200,  1175,  1874,  1907,  1176,    -1,   200,  1175,
      44,  1876,  1695,    45,  1176,    -1,    -1,   201,    -1,   202,
    1175,  1874,  1907,  1176,    -1,   202,  1175,    44,  1877,  1695,
      45,  1176,    -1,    -1,    -1,    -1,   176,  1175,  1907,  1176,
    1260,  1878,  1881,    -1,   175,  1175,  1907,  1176,  1260,  1879,
    1881,    -1,   175,  1175,    44,  1880,  1695,    45,  1176,  1260,
      -1,   176,  1175,    44,  1880,  1695,    45,  1176,  1260,    -1,
      -1,    -1,   177,  1175,  1874,  1907,  1176,  1898,  1882,  1695,
     181,    -1,    -1,    -1,   177,  1175,  1874,  1907,  1176,  1898,
    1882,  1695,   180,  1883,  1695,   181,    -1,   177,  1175,  1874,
    1907,  1176,  1898,  1882,  1695,  1884,  1890,   181,    -1,    -1,
     177,  1175,  1874,  1907,  1176,  1898,  1882,  1695,  1884,  1894,
     180,  1695,   181,    -1,    -1,   177,  1175,    44,  1885,  1695,
      45,  1176,  1898,  1886,  1695,   181,    -1,    -1,    -1,   177,
    1175,    44,  1885,  1695,    45,  1176,  1898,  1886,  1695,   180,
    1887,  1896,  1695,   181,    -1,   177,  1175,    44,  1885,  1695,
      45,  1176,  1898,  1886,  1695,  1888,  1890,   181,    -1,    -1,
     177,  1175,    44,  1885,  1695,    45,  1176,  1898,  1886,  1695,
    1888,  1894,   180,  1695,   181,    -1,   179,  1699,    -1,  1889,
    1175,  1897,  1874,  1907,  1176,  1898,  1882,  1695,  1891,  1890,
      -1,    -1,  1889,  1175,  1897,  1874,  1907,  1176,  1898,  1882,
    1695,    -1,  1889,  1175,    44,  1892,  1695,    45,  1176,  1898,
    1886,  1695,  1893,  1890,    -1,    -1,    -1,  1889,  1175,    44,
    1892,  1695,    45,  1176,  1898,  1886,  1695,    -1,  1889,  1175,
    1897,  1874,  1907,  1176,  1898,  1882,  1695,  1891,  1894,    -1,
    1889,  1175,  1897,  1874,  1907,  1176,  1898,  1882,  1695,    -1,
    1889,  1175,    44,  1892,  1695,    45,  1176,  1898,  1886,  1695,
    1893,  1894,    -1,  1889,  1175,    44,  1892,  1695,    45,  1176,
    1898,  1886,  1695,    -1,    -1,    -1,    -1,  1290,    -1,   178,
      -1,   182,  1175,  1191,  1176,  1901,  1902,  1903,  1899,   185,
      -1,  1290,    -1,    -1,   184,  1900,  1695,    -1,  1234,    -1,
      -1,   183,  1175,  1906,  1905,  1176,  1695,    -1,    -1,  1903,
     183,  1904,  1175,  1906,  1905,  1176,  1695,    -1,    -1,  1662,
      -1,  1906,  1133,  1662,    -1,  1907,     9,  1907,    -1,  1907,
       6,  1907,    -1,  1175,  1907,  1176,    -1,  1135,  1175,  1907,
    1176,    -1,  1911,  1909,  1911,    -1,  1912,  1909,  1911,    -1,
    1913,  1909,  1911,    -1,  1911,  1909,  1912,    -1,  1911,  1909,
    1913,    -1,  1911,  1909,  1914,    -1,  1912,  1909,  1914,    -1,
      11,    -1,    26,    11,    -1,  1911,  1908,  1912,    -1,  1911,
    1908,  1914,    -1,  1911,  1908,  1914,    40,  1914,    -1,  1912,
    1908,  1914,    40,  1914,    -1,  1911,    -1,  1135,  1911,    -1,
    1912,    -1,  1135,  1912,    -1,  1910,    -1,  1702,  1910,    -1,
    1135,  1910,    -1,  1702,  1135,  1910,    -1,  1135,  1702,  1910,
      -1,  1912,  1909,  1912,    -1,  1913,  1909,  1913,    -1,  1913,
    1909,  1912,    -1,  1913,  1909,  1914,    -1,  1912,  1909,  1913,
      -1,    14,    -1,    15,    -1,    12,    -1,    17,    -1,    13,
      -1,    16,    -1,   511,    -1,   512,    -1,   515,    -1,   516,
      -1,   513,    -1,   514,    -1,   517,    -1,   518,    -1,   519,
      -1,   520,    -1,   521,    -1,   522,    -1,   523,    -1,   524,
      -1,   525,    -1,   526,    -1,   531,    -1,   532,    -1,    17,
      -1,   533,    -1,   528,    -1,   529,    -1,    16,    -1,   530,
      -1,   527,    -1,    15,    -1,   534,    -1,   535,    -1,   537,
      -1,   536,    -1,  1192,    -1,  1702,  1192,    -1,  1915,    -1,
    1702,  1915,    -1,  1926,    -1,  1702,  1926,    -1,  1664,    -1,
    1702,  1664,    -1,  1927,  1925,    -1,  1927,  1290,    -1,  1927,
    1931,  1925,    -1,  1927,  1931,  1290,    -1,  1927,  1925,    -1,
    1927,  1290,    -1,  1927,  1931,  1925,    -1,  1927,  1931,  1290,
      -1,    46,    -1,  1917,    -1,    53,    -1,    59,    -1,    52,
      -1,    61,    -1,    67,    -1,    60,    -1,    18,  1662,    -1,
      -1,    19,  1919,  1662,    -1,  1662,    -1,    20,    28,    -1,
    1924,  1177,    -1,  1924,    18,  1924,  1177,    -1,  1924,    18,
    1924,  1921,  1177,    -1,  1924,  1921,  1177,    -1,  1924,  1918,
    1177,    -1,  1924,    18,  1924,  1918,  1177,    -1,  1924,    18,
    1924,  1921,  1918,  1177,    -1,  1924,  1921,  1918,  1177,    -1,
    1130,  1922,  1923,    -1,  1130,  1920,  1177,  1923,    -1,    -1,
    1193,    -1,  1130,  1922,  1923,    -1,  1130,  1920,  1177,  1923,
      -1,  1130,  1270,  1922,  1923,    -1,    54,    -1,    70,    -1,
      71,    -1,  1192,    41,    62,    -1,  1258,    -1,  1125,   117,
    1249,  1927,  1128,    -1,  1125,   117,  1249,  1702,  1927,  1128,
      -1,  1125,   117,  1249,  1927,  1925,  1176,    -1,  1125,   117,
    1249,  1702,  1927,  1925,  1176,    -1,  1125,   117,  1249,  1927,
    1931,  1176,    -1,  1125,   117,  1249,  1702,  1927,  1931,  1176,
      -1,  1125,   117,  1249,  1927,  1931,  1925,  1176,    -1,  1125,
     117,  1249,  1702,  1927,  1931,  1925,  1176,    -1,  1125,   117,
    1249,  1707,  1176,    -1,    62,    -1,  1192,    41,  1928,    -1,
    1192,    41,    46,    -1,    54,    -1,    55,    -1,    63,    -1,
      -1,    -1,  1929,  1930,  1932,    -1,  1935,  1933,  1260,  1934,
    1932,    -1,  1935,  1933,  1260,    -1,  1134,    -1,    -1,    -1,
     437,    -1,   438,    -1,   439,    -1,   440,    -1,   441,    -1,
     442,    -1,   443,    -1,   444,    -1,  1938,  1951,  1939,    -1,
    1938,  1702,  1951,  1939,    -1,  1938,  1940,  1939,    -1,  1938,
    1702,  1940,  1939,    -1,  1938,  1941,  1939,    -1,  1938,  1702,
    1941,  1939,    -1,  1938,  1183,  1939,    -1,  1938,  1702,  1183,
    1939,    -1,  1938,  1125,   117,    46,  1183,  1176,  1939,    -1,
    1938,  1702,  1125,   117,    46,  1183,  1176,  1939,    -1,  1938,
    1184,  1939,    -1,  1938,  1702,  1184,  1939,    -1,  1938,  1125,
     117,    46,  1189,  1176,  1939,    -1,  1938,  1702,  1125,   117,
      46,  1189,  1176,  1939,    -1,  1938,  1185,  1939,    -1,  1938,
    1702,  1185,  1939,    -1,  1938,  1125,   117,    46,  1185,  1176,
    1939,    -1,  1938,  1702,  1125,   117,    46,  1185,  1176,  1939,
      -1,  1938,  1936,  1939,    -1,  1938,  1702,  1936,  1939,    -1,
    1938,  1196,  1939,    -1,  1938,  1702,  1196,  1939,    -1,    -1,
      -1,    46,  1943,    -1,    46,  1945,    -1,    46,  1945,  1950,
      -1,    46,  1946,    -1,  1943,    -1,  1125,   117,    46,  1940,
    1128,  1942,    -1,  1125,   117,    46,  1941,  1128,  1942,    -1,
    1125,   117,    46,  1940,  1128,  1134,    46,  1942,    -1,  1125,
     117,    46,  1941,  1128,  1134,    46,  1942,    -1,  1125,   117,
      46,  1951,  1128,  1942,    -1,  1125,   117,    46,  1951,  1128,
    1134,    46,  1942,    -1,    -1,  1943,    -1,  1950,    -1,  1947,
      -1,  1944,  1944,    -1,  1944,  1945,    -1,  1944,  1950,    -1,
    1944,  1944,  1950,    -1,  1944,  1945,  1950,    -1,  1130,  1191,
    1129,    -1,  1130,  1191,    20,    28,  1129,    -1,  1130,  1191,
      20,    28,    18,  1951,  1129,    -1,  1130,  1191,    20,    28,
      19,  1951,  1129,    -1,  1130,  1191,  1129,    -1,  1130,  1191,
      18,  1951,  1129,    -1,  1130,  1191,    19,  1951,  1129,    -1,
    1130,  1191,    18,  1191,  1948,  1949,  1129,    -1,  1290,    -1,
      20,    28,    -1,  1290,    -1,    18,  1951,    -1,    19,  1951,
      -1,  1130,  1951,  1129,    -1,    46,  1130,  1951,  1129,    -1,
      46,  1130,  1951,  1952,  1129,    -1,  1133,  1951,    -1,  1133,
    1951,  1952,    -1,    46,    -1,  1175,  1951,  1176,    -1,     8,
      46,    -1,    28,    -1,    30,    -1,    29,    -1,    31,    -1,
      32,    -1,    33,    -1,  1668,    -1,  1669,    -1,   267,    -1,
    1132,  1680,  1679,  1939,  1675,  1131,  1938,    -1,  1130,  1951,
    1129,    -1,  1130,  1951,  1952,  1129,    -1,    46,  1127,  1130,
    1951,  1952,  1129,    -1,    46,  1127,  1130,  1951,  1129,    -1,
      19,  1951,    -1,  1135,  1951,    -1,  1951,    18,  1951,    -1,
    1951,    19,  1951,    -1,  1951,    20,  1951,    -1,  1951,    21,
    1951,    -1,  1951,    25,  1951,    -1,  1951,    24,  1951,    -1,
    1951,     8,  1951,    -1,  1951,     4,  1951,    -1,  1951,    23,
    1951,    -1,  1951,    22,  1951,    -1,  1951,    14,  1951,    -1,
    1951,    15,  1951,    -1,  1951,    12,  1951,    -1,  1951,    17,
    1951,    -1,  1951,    13,  1951,    -1,  1951,    16,  1951,    -1,
    1951,    11,  1951,    -1,    46,  1125,  1951,  1128,    -1,  1939,
    1682,  1938,    -1,  1939,  1683,  1175,  1664,  1176,  1938,    -1,
    1939,  1689,  1938,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned int yyrline[] =
{
       0,  2437,  2437,  2438,  2439,  2446,  2452,  2458,  2464,  2470,
    2478,  2486,  2487,  2494,  2503,  2511,  2518,  2526,  2533,  2539,
    2551,  2575,  2593,  2610,  2619,  2646,  2682,  2712,  2724,  2741,
    2762,  2785,  2807,  2845,  2859,  2874,  2910,  2924,  2939,  2970,
    2985,  3009,  3043,  3051,  3077,  3100,  3112,  3145,  3156,  3173,
    3181,  3203,  3300,  3332,  3345,  3453,  3466,  3463,  3504,  3527,
    3880,  3877,  4058,  4189,  4209,  4211,  4232,  4234,  4255,  4257,
    4278,  4280,  4301,  4303,  4324,  4326,  4348,  4350,  4374,  4376,
    4402,  4404,  4428,  4430,  4450,  4468,  4474,  4480,  4486,  4492,
    4498,  4504,  4510,  4518,  4524,  4530,  4536,  4542,  4548,  4554,
    4560,  4568,  4574,  4580,  4586,  4592,  4598,  4604,  4610,  4620,
    4630,  4642,  4667,  4697,  4708,  4737,  4747,  4776,  4785,  4796,
    4821,  4851,  4861,  4890,  4899,  4909,  4934,  4963,  4970,  4977,
    4986,  4993,  5000,  5011,  5016,  5024,  5029,  5037,  5043,  5049,
    5055,  5061,  5067,  5073,  5079,  5091,  5097,  5103,  5108,  5114,
    5120,  5128,  5133,  5146,  5152,  5158,  5164,  5173,  5178,  5189,
    5195,  5201,  5207,  5213,  5219,  5227,  5232,  5245,  5250,  5259,
    5265,  5271,  5277,  5283,  5289,  5295,  5301,  5326,  5325,  5343,
    5347,  5350,  5359,  5368,  5377,  5388,  5513,  5648,  5723,  5806,
    5811,  5812,  5813,  5814,  5829,  5827,  5984,  5988,  5991,  6000,
    6009,  6018,  6027,  6036,  6045,  6054,  6063,  6072,  6083,  6091,
    6095,  6100,  6104,  6109,  6113,  6118,  6122,  6127,  6131,  6136,
    6140,  6145,  6149,  6154,  6158,  6163,  6167,  6186,  6290,  6333,
    6428,  6184,  6553,  6621,  6626,  6628,  6637,  6646,  6655,  6664,
    6673,  6682,  6691,  6700,  6710,  6718,  6727,  6729,  6734,  6735,
    6758,  6762,  6761,  6770,  6895,  7030,  7105,  7187,  7262,  7316,
    7312,  7327,  7324,  7337,  7338,  7339,  7340,  7341,  7342,  7343,
    7349,  7354,  7355,  7356,  7357,  7358,  7359,  7360,  7361,  7362,
    7363,  7369,  7375,  7478,  7528,  7545,  7550,  7558,  7563,  7568,
    7573,  7579,  7585,  7591,  7596,  7601,  7607,  7613,  7619,  7624,
    7629,  7635,  7641,  7647,  7653,  7658,  7663,  7668,  7673,  7679,
    7685,  7690,  7695,  7700,  7705,  7710,  7719,  7728,  7742,  7750,
    7767,  7823,  7847,  7856,  7864,  7872,  7880,  7888,  7896,  7904,
    7914,  7922,  7930,  7938,  7946,  7954,  7962,  7970,  7981,  7990,
    8003,  8011,  8027,  8035,  8060,  8068,  8089,  8098,  8106,  8117,
    8125,  8136,  8148,  8164,  8170,  8181,  8181,  8181,  8181,  8181,
    8181,  8182,  8182,  8182,  8182,  8182,  8182,  8183,  8183,  8183,
    8183,  8183,  8184,  8184,  8184,  8184,  8185,  8185,  8185,  8185,
    8186,  8186,  8186,  8186,  8186,  8194,  8204,  8212,  8221,  8229,
    8237,  8245,  8291,  8330,  8349,  8460,  8496,  8502,  8553,  8557,
    8578,  8718,  8882,  8928,  9042,  9072,  9139,  9140,  9141,  9159,
    9336,  9533,  9560,  9561,  9583,  9776,  9944,  9992, 10285, 10526,
   10524, 10821, 10813, 11107, 11148, 11146, 11190, 11203, 11201, 11215,
   11228, 11244, 11267, 11271, 11278, 11285, 11292, 11300, 11337, 11351,
   11373, 11419, 11432, 11530, 11548, 11629, 11704, 11709, 11739, 11752,
   11779, 11807, 11873, 11883, 11939, 11881, 12131, 12142, 12213, 12139,
   12369, 12372, 12389, 12395, 12401, 12437, 12451, 12494, 12546, 12524,
   12725, 12719, 12779, 12774, 12871, 12866, 12938, 12935, 13069, 13063,
   13331, 13511, 13653, 13673, 13694, 13712, 13733, 13754, 13772, 13806,
   13812, 13820, 13831, 13839, 13874, 13953, 14006, 14056, 14152, 14166,
   14177, 14194, 14226, 14242, 14260, 14267, 14276, 14304, 14336, 14355,
   14371, 14393, 14400, 14413, 14437, 14462, 14485, 14515, 14594, 14624,
   14652, 14685, 14718, 14741, 14777, 14814, 14850, 14886, 14920, 14958,
   14996, 15025, 15063, 15091, 15128, 15156, 15193, 15218, 15252, 15287,
   15320, 15355, 15388, 15424, 15455, 15482, 15518, 15546, 15583, 15611,
   15644, 15671, 15708, 15742, 15776, 15807, 15845, 15976, 16095, 16213,
   16354, 16490, 16623, 16762, 16958, 16989, 17020, 17049, 17078, 17107,
   17136, 17165, 17194, 17223, 17252, 17281, 17313, 17349, 17388, 17400,
   17447, 17550, 17637, 17642, 17654, 17662, 17674, 17686, 17694, 17706,
   17731, 17740, 17751, 17794, 17922, 17931, 17911, 18086, 18100, 18114,
   18130, 18147, 18149, 18235, 18246, 18263, 18271, 18270, 18296, 18332,
   18376, 18416, 18459, 18461, 18513, 18520, 18529, 18540, 18548, 18556,
   18564, 18572, 18580, 18588, 18596, 18604, 18615, 18674, 18809, 19005,
   19380, 18752, 19549, 19595, 19661, 19857, 20230, 19605, 20406, 20468,
   20723, 21096, 20415, 21334, 21525, 21909, 21277, 22149, 22340, 22724,
   22093, 22903, 22905, 23029, 23143, 23535, 22897, 23727, 23729, 23852,
   23966, 24358, 23720, 24551, 24553, 24679, 24796, 25186, 24545, 25369,
   25371, 25495, 25612, 26002, 25362, 26189, 26191, 26346, 26462, 26846,
   26183, 27020, 27035, 27037, 27191, 27307, 27691, 27029, 27884, 27874,
   28117, 28108, 28347, 28337, 28616, 28606, 28801, 28792, 28977, 29167,
   29345, 29546, 29694, 29852, 29842, 29884, 29903, 29894, 29937, 30038,
   30147, 30532, 30029, 30722, 30831, 31216, 30714, 31405, 31622, 31626,
   31736, 32121, 31617, 32322, 32312, 32364, 32382, 32373, 32419, 32517,
   32665, 33041, 32508, 33231, 33379, 33755, 33223, 33949, 33958, 33941,
   34003, 34010, 34006, 34025, 34021, 34040, 34036, 34055, 34051, 34070,
   34066, 34084, 34080, 34099, 34095, 34112, 34117, 34110, 34132, 34138,
   34129, 34153, 34150, 34166, 34163, 34179, 34191, 34198, 34200, 34198,
   34210, 34217, 34219, 34217, 34235, 34437, 34453, 34659, 34887, 35108,
   35167, 35233, 35241, 35252, 35343, 35351, 35362, 35458, 35455, 35574,
   35571, 35698, 35687, 35941, 35931, 36181, 36203, 36404, 36605, 36613,
   36621, 36634, 36724, 36731, 36739, 36752, 36849, 36846, 36971, 36968,
   37102, 37091, 37353, 37342, 37600, 37601, 37617, 37814, 38020, 38009,
   38267, 38257, 38501, 38564, 38644, 38738, 38733, 38858, 38854, 38994,
   39034, 39081, 39080, 39142, 39323, 39329, 39354, 39384, 39377, 39412,
   39422, 39443, 39436, 39477, 39559, 39599, 39591, 39625, 39677, 39680,
   39704, 39710, 39716, 39722, 39728, 39734, 39759, 39778, 39811, 39825,
   39838, 39851, 39864, 39877, 39890, 39903, 39916, 39930, 39944, 39957,
   39972, 39987, 40003, 40053, 40063, 40078, 40097, 40112, 40126, 40143,
   40150, 40180, 40194, 40203, 40212, 40223, 40234, 40244, 40255, 40266,
   40277, 40288, 40299, 40311, 40322, 40333, 40379, 40389, 40420, 40419,
   40443, 40452, 40451, 40468, 40474, 40483, 40492, 40629, 40794, 40800,
   40790, 40955, 40961, 40951, 41024, 41089, 41095, 41083, 41168, 41261,
   41267, 41255, 41396, 41522, 41528, 41504, 41660, 41739, 41747, 41755,
   41763, 41771, 41779, 41788, 41800, 41803, 41809, 41826, 41932, 42042,
   42152, 42262, 42308, 42318, 42342, 42347, 42370, 42378, 42432, 42468,
   42429, 42514, 42572, 42613, 42619, 42625, 42630, 42636, 42641, 42647,
   42653, 42659, 42665, 42671, 42677, 42683, 42689, 42695, 42701, 42707,
   42713, 42719, 42725, 42731, 42737, 42743, 42749, 42755, 42761, 42767,
   42773, 42788, 42857, 42987, 43131, 43165, 43297, 43616, 43798, 43964,
   44136, 43955, 44232, 44258, 44275, 44300, 44318, 44334, 44353, 44371,
   44387, 44406, 44410, 44561, 44570, 44589, 44594, 44625, 44638, 44665,
   44717, 44893, 44887, 45122, 45117, 45423, 45441, 45447, 45496, 45508,
   45516, 45518, 45583, 45591, 45597, 45629, 45650, 45670, 45690, 45711,
   45730, 45740, 45749, 45757, 45776, 45795, 45815, 45838, 45857, 45887,
   45917, 45946, 45975, 46004, 46033, 46062, 46091, 46140, 46168, 46224,
   46269, 46315, 46354, 46397, 46477, 46547, 46784, 46833, 47071, 47127,
   47121, 47336, 47333, 47548, 47543, 47858, 47852, 48165, 48288, 48402,
   48549, 48683, 48765, 48772, 48803, 48824, 48842, 48861, 48879, 48887,
   48894, 48902, 48919, 48935, 48953, 48972, 48990, 49007, 49034, 49061,
   49088, 49115, 49142, 49169, 49196, 49224, 49278, 49305, 49366, 49411,
   49456, 49492, 49529, 49541, 49558, 49569, 49589, 49662, 49727, 49961,
   50008, 50248, 50303, 50297, 50514, 50508, 50728, 50723, 51037, 51032,
   51347, 51469, 51587, 51738, 51928, 51983, 51994, 52013, 52023, 52051,
   52081, 52128, 52181, 52259, 52264, 52283, 52293, 52297, 52353, 52331,
   52584, 52578, 52642, 52707, 52639, 52739, 52734, 52832, 52827, 52905,
   52902, 53060, 53054, 53339, 53528, 53521, 53662, 53672, 53689, 53714,
   53725, 53739, 53751, 53764, 53799, 53793, 53839, 53876, 53870, 53943,
   54138, 54194, 54277, 54305, 54297, 54475, 54467, 54531, 54595, 54682,
   54753, 54745, 54821, 54814, 54925, 54918, 55040, 55033, 55133, 55126,
   55199, 55267, 55262, 55503, 55498, 55751, 55743, 55955, 55948, 56159,
   56151, 56332, 56327, 56447, 56538, 56533, 56649, 56646, 56842, 56934,
   56928, 57452, 57564, 57734, 57727, 57845, 57859, 57867, 57874, 57882,
   57884, 57919, 57922, 57937, 58001, 58110, 58156, 58187, 58197, 58203,
   58210, 58211, 58219, 58220, 58227, 58228, 58237, 58238, 58250, 58266,
   58275, 58282, 58290, 58297, 58306, 58314, 58321, 58331, 58345, 58355,
   58367, 58379, 58388, 58397, 58407, 58413, 58423, 58433, 58444, 58443,
   58459, 58497, 58511, 58519, 58526, 58533, 58536, 58566, 58569, 58583,
   58592, 58602, 58671, 58788, 58845, 58851, 58852, 58862, 59030, 59050,
   59102, 59146, 59147, 59153, 59200, 59275, 59289, 59281, 59330, 59338,
   59389, 59435, 59498, 59509, 59600, 59608, 59655, 59695, 59752, 59759,
   59769, 59777, 59866, 59918, 59976, 59987, 60075, 60082, 60279, 60322,
   60368, 60377, 60481, 60480, 60496, 60519, 60532, 60540, 60546, 60555,
   60558, 60572, 60583, 60592, 60599, 60600, 60611, 60612, 60627, 60636,
   60640, 60648, 60658, 60722, 60733, 60742, 60751, 60760, 60770, 60780,
   60803, 60807, 60805, 60817, 60990, 61071, 61184, 61196, 61230, 61311,
   61402, 61410, 61418, 61426, 61434, 61442, 61450, 61458, 61466, 61474,
   61482, 61490, 61498, 61506, 61517, 61526, 61537, 61588, 61596, 61626,
   61633, 61666, 61677, 61697, 61722, 61746, 61753, 61760, 61767, 61774,
   61781, 61803, 61843, 61880, 61897, 61918, 61970, 61966, 62101, 62342,
   62370, 62380, 62395, 62409, 62426, 62446, 62465, 62493, 62507, 62527,
   62549, 62573, 62605, 62622, 62628, 62636, 62642, 62651, 62655, 62687,
   62695, 62731, 62733, 62734, 62737, 62738, 62752, 62787, 62829, 62854,
   62878, 62907, 62943, 63184, 63321, 63418, 63518, 63604, 63685, 63774,
   63867, 63972, 64028, 64088, 64258, 64407, 64566, 64725, 64891, 65048,
   65103, 65267, 65469, 65468, 65525, 65541, 65557, 65583, 65591, 65599,
   65607, 65615, 65623, 65631, 65639, 65647, 65655, 65663, 65671, 65679,
   65687, 65695, 65704, 65712, 65720, 65728, 65736, 65744, 65752, 65768,
   65784, 65797, 65810, 65824, 65838, 65858, 65872, 65886, 65900, 65914,
   65931, 65945, 65959, 65973, 65987, 66001, 66022, 66036, 66051, 66069,
   66085, 66104, 66123, 66154, 66153, 66222, 66344, 66475, 66484, 66496,
   66514, 66526, 66544, 66556, 66574, 66584, 66593, 66601, 66619, 66631,
   66649, 66657, 66678, 66690, 66708, 66720, 66745, 66757, 66775, 66787,
   66805, 66817, 66835, 66847, 66864, 66876, 66894, 66906, 66925, 66937,
   66957, 66969, 66989, 67002, 67021, 67035, 67052, 67066, 67249, 67263,
   67285, 67298, 67462, 67468, 67476, 67586, 67598, 67619, 67636, 67657,
   67673, 67695, 67713, 67735, 67824, 67840, 67864, 67878, 67891, 67907,
   67929, 67940, 67992, 68014, 68038, 68059, 68080, 68102, 68124, 68136,
   68154, 68169, 68193, 68215, 68234, 68255, 68278, 68300, 68325, 68343,
   68370, 68392, 68416, 68438, 68456, 68475, 68493, 68512, 68534, 68553,
   68571, 68590, 68612, 68638, 68690, 68710, 68729, 68748, 68767, 68809,
   68828, 68849, 68888, 68907, 68928, 68973, 68992, 69013, 69053, 69072,
   69093, 69132, 69151, 69172, 69212, 69231, 69252, 69296, 69318, 69342,
   69388, 69410, 69434, 69482, 69504, 69528, 69574, 69596, 69620, 69669,
   69694, 69721, 69773, 69799, 69826, 69879, 69898, 69919, 69951, 69970,
   69991, 70037, 70056, 70077, 70109, 70128, 70149, 70197, 70216, 70237,
   70269, 70288, 70309, 70352, 70371, 70392, 70424, 70443, 70464, 70506,
   70525, 70546, 70578, 70597, 70618, 70661, 70680, 70701, 70733, 70752,
   70773, 70816, 70838, 70862, 70894, 70916, 70940, 70986, 71008, 71032,
   71065, 71087, 71111, 71157, 71179, 71203, 71236, 71258, 71282, 71328,
   71350, 71374, 71407, 71429, 71453, 71501, 71526, 71553, 71589, 71614,
   71641, 71692, 71717, 71744, 71780, 71805, 71832, 71872, 71922, 72022,
   72118, 72220, 72271, 72365, 72461, 72570, 72576, 72587, 72650, 72754,
   72860, 72973, 73036, 73140, 73246, 73371, 73390, 73411, 73450, 73469,
   73490, 73527, 73546, 73567, 73600, 73619, 73640, 73678, 73697, 73718,
   73751, 73770, 73791, 73831, 73846, 73877, 73892, 73924, 73939, 73969,
   73984, 74014, 74029, 74057, 74072, 74106, 74122, 74140, 74181, 74197,
   74215, 74253, 74269, 74287, 74328, 74344, 74362, 74405, 74421, 74439,
   74474, 74490, 74508, 74543, 74559, 74577, 74614, 74630, 74648, 74684,
   74700, 74718, 74758, 74804, 74852, 74867, 74882, 74905, 74918, 74932,
   74946, 74961, 74975, 74989, 75003, 75017, 75031, 75045, 75059, 75075,
   75091, 75107, 75124, 75140, 75158, 75174, 75192, 75208, 75225, 75241,
   75257, 75273, 75303, 75329, 75368, 75437, 75502, 75520, 75561, 75617,
   76002, 76110, 76218, 76367, 76469, 76577, 76693, 76746, 76802, 76851,
   76902, 76973, 77023, 77083, 77147, 77205, 77364, 77500, 77583, 77630,
   77662, 77695, 77728, 77760, 77800, 77862, 77898, 77949, 77969, 77983,
   78115, 78198, 78236, 78308, 78309, 78332, 78330, 78350, 78353, 78381,
   78514, 78655, 78703, 78750, 78761, 78772, 78783, 78794, 78805, 78824,
   78832, 78844, 78860, 78939, 78945, 78973, 79009, 79019, 79032, 79042,
   79056, 79062, 79072, 79078, 79087, 79092, 79101, 79107, 79120, 79126,
   79142, 79153, 79166, 79177, 79191, 79202, 79218, 79229, 79242, 79253,
   79279, 79285, 79295, 79301, 79317, 79331, 79342, 79355, 79369, 79396,
   79440, 79452, 79464, 79476, 79493, 79538, 79533, 79625, 79636, 79672,
   79681, 79690, 79696, 79741, 79770, 79785, 79801, 79819, 79845, 79864,
   79894, 79900, 79906, 79912, 79918, 79924, 79930, 79945, 79970, 79995,
   80028, 80036, 80045, 80054, 80063, 80072, 80081, 80091, 80184, 80373,
   80450, 80640, 80733, 80766, 80759, 80852, 81461, 82060, 82076, 82101,
   82099, 82139, 82137, 82220, 82234, 82243, 82250, 82257, 82279, 82287,
   82309, 82328, 82334, 82325, 82392, 82495, 82610, 82736, 82764, 82794,
   82870, 82894, 82910, 82939, 82972, 83025, 83035, 83075, 83074, 83123,
   83130, 83138, 83145, 83154, 83161, 83169, 83177, 83186, 83193, 83203,
   83210, 83217, 83224, 83231, 83239, 83246, 83256, 83262, 83268, 83274,
   83280, 83293, 83309, 83321, 83333, 83348, 83365, 83398, 83426, 83463,
   83466, 83485, 83493, 83501, 83509, 83518, 83527, 83536, 83545, 83554,
   83563, 83572, 83581, 83590, 83599, 83608, 83616, 83624, 83632, 83644,
   83652, 83660, 83668, 83676, 83684, 83692, 83700, 83708, 83716, 83724,
   83732, 83740, 83748, 83756, 83764, 83772, 83781, 83790, 83799, 83808,
   83816, 83824, 83832, 83840, 83848, 83856, 83864, 83872, 83905, 83921,
   83937, 83987, 84005, 84030, 84049, 84075, 84093, 84121, 84162, 84193,
   84214, 84229, 84246, 84261, 84279, 84295, 84334, 84346, 84376, 84382,
   84390, 84396, 84405, 84411, 84417, 84423, 84429, 84435, 84441, 84447,
   84454, 84461, 84468, 84475, 84482, 84489, 84510, 84518, 84526, 84534,
   84542, 84550, 84558, 84566, 84578, 84586, 84594, 84602, 84610, 84618,
   84626, 84642, 84657, 84678, 84710, 84730, 84757, 84776, 84801, 84823,
   84868, 84887, 84923, 84931, 84939, 84947, 84955, 84963, 84971, 84979,
   84995, 85011, 85027, 85043, 85059, 85075, 85091, 85107, 85123, 85139,
   85155, 85171, 85187, 85203, 85219, 85235, 85251, 85267, 85283, 85299,
   85315, 85331, 85347, 85363, 85379, 85395, 85407, 85423, 85439, 85450,
   85465, 85480, 85495, 85506, 85521, 85534, 85548, 85590, 85603, 85619,
   85632, 85651, 85663, 85681, 85697, 85716, 85736, 85757, 85776, 85791,
   85806, 85812, 85818, 85824, 85830, 85836, 85842, 85848, 85854, 85860,
   85866, 85872, 85880, 85892, 85909, 85915, 85921, 85927, 85935, 85945,
   85964, 85975, 85988, 86003, 86014, 86027, 86053, 86067, 86081, 86095,
   86108, 86122, 86140, 86155, 86177, 86201, 86219, 86240, 86260, 86283,
   86309, 86333, 86347, 86369, 86391, 86405, 86441, 86455, 86473, 86490,
   86505, 86519, 86534, 86549, 86563, 86579, 86594, 86610, 86625, 86639,
   86650, 86665, 86671, 86677, 86683, 86689, 86696, 86703, 86710, 86717,
   86723, 86729, 86735, 86741, 86747, 86753, 86759, 86766, 86773, 86780,
   86786, 86792, 86798, 86804, 86810, 86816, 86822, 86828, 86835, 86842,
   86849, 86856, 86862, 86868, 86874, 86880, 86886, 86893, 86900, 86907,
   86913, 86919, 86925, 86931, 86937, 86943, 86949, 86955, 86961, 86967,
   86973, 86979, 86985, 86991, 86997, 87005, 87015, 87033, 87040, 87047,
   87054, 87061, 87068, 87079, 87089, 87100, 87110, 87120, 87142, 87156,
   87171, 87185, 87199, 87214, 87236, 87242, 87248, 87257, 87271, 87291,
   87297, 87303, 87309, 87315, 87324, 87338, 87358, 87364, 87370, 87376,
   87386, 87400, 87413, 87419, 87427, 87441, 87456, 87470, 87487, 87493,
   87501, 87507, 87515, 87531, 87547, 87559, 87576, 87594, 87600, 87608,
   87619, 87637, 87643, 87651, 87667, 87684, 87690, 87696, 87704, 87715,
   87735, 87741, 87747, 87753, 87759, 87765, 87771, 87777, 87783, 87789,
   87795, 87801, 87807, 87813, 87819, 87825, 87831, 87837, 87845, 87860,
   87875, 87900, 87906, 87915, 87935, 87941, 87947, 87953, 87959, 87965,
   87971, 87977, 87983, 87989, 87995, 88001, 88007, 88013, 88019, 88025,
   88031, 88037, 88043, 88049, 88055, 88061, 88067, 88073, 88079, 88085,
   88091, 88097, 88103, 88109, 88115, 88121, 88127, 88133, 88139, 88145,
   88151, 88157, 88163, 88169, 88175, 88183, 88194, 88222, 88233, 88263,
   88268, 88273, 88281, 88286, 88291, 88300, 88312, 88326, 88338, 88350,
   88362, 88373, 88400, 88429, 88445, 88461, 88473, 88485, 88498, 88520,
   88526, 88532, 88541, 88559, 88578, 88594, 88615, 88621, 88627, 88633,
   88639, 88645, 88651, 88657, 88663, 88669, 88678, 88699, 88715, 88732,
   88755, 88772, 88789, 88795, 88801, 88807, 88813, 88819, 88825, 88831,
   88837, 88843, 88849, 88855, 88861, 88867, 88873, 88879, 88888, 88901,
   88920, 88926, 88932, 88938, 88944, 88950, 88956, 88965, 89024, 89082,
   89111, 89145, 89185, 89191, 89200, 89252, 89271, 89330, 89391, 89409,
   89427, 89433, 89439, 89445, 89451, 89460, 89478, 89496, 89515, 89536,
   89628, 89727, 89758, 89789, 89821, 89855, 89907, 89978, 89984, 89992,
   90016, 90047, 90084, 90105, 90125, 90146, 90171, 90176, 90181, 90186,
   90191, 90196, 90201, 90206, 90215, 90244, 90257, 90289, 90316, 90321,
   90326, 90331, 90336, 90341, 90346, 90350, 90359, 90390, 90407, 90439,
   90461, 90466, 90471, 90476, 90481, 90486, 90491, 90496, 90504, 90533,
   90546, 90578, 90596, 90601, 90606, 90611, 90616, 90621, 90626, 90631,
   90639, 90668, 90681, 90713, 90729, 90747, 90774, 90803, 90831, 90862,
   90889, 90921, 90927, 90935, 90960, 90989, 91013, 91030, 91051, 91070,
   91086, 91105, 91122, 91141, 91154, 91170, 91176, 91182, 91188, 91197,
   91208, 91248, 91254, 91262, 91278, 91297, 91313, 91329, 91346, 91368,
   91374, 91383, 91399, 91419, 91425, 91433, 91449, 91468, 91474, 91482,
   91501, 91522, 91528, 91536, 91555, 91578, 91584, 91592, 91611, 91635,
   91654, 91671, 91677, 91683, 91689, 91695, 91703, 91718, 91732, 91743,
   91754, 91768, 91780, 91794, 91800, 91809, 91828, 91834, 91840, 91846,
   91852, 91858, 91864, 91870, 91876, 91882, 91888, 91894, 91900, 91906,
   91915, 91937, 91960, 91989, 92034, 92071, 92093, 92115, 92137, 92165,
   92183, 92228, 92266, 92298, 92304, 92310, 92316, 92322, 92328, 92334,
   92340, 92349, 92363, 92376, 92426, 92433, 92440, 92447, 92455, 92463,
   92473, 92479, 92485, 92491, 92502, 92523, 92551, 92578, 92612, 92687,
   92733, 92740, 92747, 92754, 92762, 92770, 92781, 92787, 92797, 92814,
   92836, 92860, 92896, 92958, 92992, 93025, 93066, 93097, 93112, 93132,
   93148, 93189, 93195, 93201, 93207, 93213, 93219, 93225, 93231, 93237,
   93243, 93249, 93255, 93261, 93267, 93273, 93279, 93285, 93291, 93297,
   93303, 93309, 93315, 93321, 93327, 93333, 93339, 93345, 93351, 93357,
   93363, 93369, 93375, 93381, 93387, 93393, 93399, 93405, 93416, 93428,
   93441, 93459, 93491, 93511, 93538, 93564, 93597, 93638, 93644, 93652,
   93675, 93698, 93766, 93777, 93784, 93791, 93801, 93816, 93828, 93839,
   93840, 93841, 93843, 93844, 93845, 93847, 93848, 93849, 93851, 93852,
   93853, 93855, 93856, 93857, 93859, 93860, 93861, 93863, 93864, 93865,
   93867, 93868, 93869, 93871, 93872, 93873, 93875, 93876, 93877, 93879,
   93880, 93881, 93883, 93884, 93885, 93887, 93888, 93890, 93891, 93892,
   93894, 93895, 93897, 93898, 93899, 93901, 93902, 93903, 93905, 93906,
   93907, 93937, 93943, 93949, 93955, 93961, 93967, 93973, 93979, 93988,
   93990, 93997, 94023, 94048, 94069, 94093, 94110, 94133, 94162, 94175,
   94181, 94187, 94193, 94199, 94207, 94231, 94250, 94284, 94325, 94372,
   94414, 94433, 94456, 94486, 94522, 94541, 94562, 94581, 94600, 94668,
   94706, 94737, 94775, 94823, 94829, 94835, 94845, 94851, 94860, 94862,
   94869, 94889, 94906, 94926, 94975, 95001, 95030, 95059, 95092, 95127,
   95160, 95191, 95203, 95215, 95233, 95264, 95288, 95302, 95309, 95316,
   95323, 95330, 95338, 95345, 95357, 95364, 95371, 95378, 95383, 95403,
   95416, 95425, 95458, 95478, 95500, 95516, 95549, 95601, 95610, 95650,
   95741, 95792, 95819, 95856, 95851, 95906, 95901, 95946, 95939, 95987,
   96019, 95978, 96063, 96096, 96052, 96134, 96140, 96149, 96155, 96165,
   96172, 96171, 96195, 96191, 96235, 96284, 96329, 96384, 96423, 96458,
   96515, 96593, 96578, 96634, 96642, 96664, 96680, 96715, 96783, 96774,
   96831, 96854, 96891, 96964, 96952, 97004, 97021, 97045, 97050, 97067,
   97119, 97126, 97133, 97161, 97208, 97217, 97243, 97250, 97258, 97266,
   97272, 97278, 97292, 97289, 97341, 97335, 97440, 97434, 97704, 97696,
   97803, 97797, 98079, 98086, 98113, 98112, 98166, 98163, 98297, 98432,
   98559, 98573, 98693, 98709, 98754, 98818, 98879, 98895, 98917, 98947,
   98984, 99006, 99014, 99021, 99035, 99052, 99255, 99458, 99489, 99711,
   99745, 99791, 99782, 99838, 99866, 99916, 99964, 99979,100003,100056,
  100045,100100,100130,100168,100210,100219,100235,100253,100282,100300,
  100316,100342,100385,100406,100442,100465,100500,100523,100544,100555,
  100560,100571,100820,100827,100826,100856,100867,100883,100922,100920,
  101008,101025,101048,101102,101122,101142,101153,101176,101214,101253,
  101286,101327,101362,101402,101440,101441,101445,101478,101556,101661,
  101786,101804,101823,101856,101894,101914,101944,101965,101993,102028,
  102039,102050,102061,102073,102094,102095,102096,102097,102098,102099,
  102103,102105,102106,102107,102108,102109,102110,102111,102112,102113,
  102114,102115,102116,102117,102118,102119,102120,102121,102122,102123,
  102124,102125,102126,102127,102128,102129,102130,102131,102132,102133,
  102139,102158,102189,102206,102234,102249,102276,102307,102375,102419,
  102430,102504,102548,102589,102600,102673,102716,102731,102755,102761,
  102767,102785,102791,102797,102819,102836,102835,102865,102890,102927,
  102938,102951,102964,102976,102987,103001,103015,103034,103043,103054,
  103075,103088,103127,103160,103257,103350,103409,103478,103564,103620,
  103721,103821,103927,104035,104112,104191,104279,104374,104471,104508,
  104536,104590,104591,104592,104619,104625,104631,104732,104941,105140,
  105171,105262,105371,105372,105373,105374,105375,105376,105377,105378,
  105407,105422,105438,105452,105467,105481,105496,105510,105525,105560,
  105595,105609,105624,105658,105693,105707,105722,105756,105791,105805,
  105820,105834,105864,105878,105896,105906,105916,105927,105937,105952,
  106006,106060,106128,106196,106258,106332,106334,106335,106354,106364,
  106375,106386,106397,106409,106421,106430,106459,106496,106542,106550,
  106565,106580,106593,106595,106621,106623,106636,106654,106687,106748,
  106812,106828,106848,106885,106905,106945,106958,106973,106987,107002,
  107017,107032,107048,107064,107079,107101,107128,107163,107208,107251,
  107355,107377,107390,107403,107416,107429,107442,107455,107469,107482,
  107495,107510,107553,107596,107637,107678,107719,107761,107810,107868,
  107895,107916
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "dupTkn", "'|'", "'^'", "lorTkn",
  "orTkn", "'&'", "landTkn", "andTkn", "inTkn", "'<'", "'>'", "'='",
  "neTkn", "geTkn", "leTkn", "'+'", "'-'", "'*'", "'/'", "shropTkn",
  "shlopTkn", "modTkn", "divTkn", "notTkn", "UMINUS", "intconst",
  "hexconst", "binconst", "fltconst", "charconst", "wcharconst",
  "strconst", "wstrconst", "regexconst", "assignTkn", "addassignTkn",
  "subassignTkn", "DotDot", "coloncolonTkn", "matchTkn", "match2Tkn",
  "stmtsTkn", "endstmtsTkn", "UndefID", "RegexID", "atTkn", "posTkn",
  "tabTkn", "arbTkn", "LocalID", "LocalConstID", "LocalVarID",
  "LocalStaticID", "LocalProcID", "LocalIterID", "LocalMethodID",
  "LocalLabelID", "NonLocalID", "NonLocalConstID", "NonLocalVarID",
  "NonLocalStaticID", "NonLocalProcID", "NonLocalIterID",
  "NonLocalMethodID", "NonLocalLabelID", "OverloadedID", "ovldClassTkn",
  "ClassVarID", "ClassStaticID", "ClassProcID", "ClassIterID",
  "ClassMethodID", "MacroParmTkn", "LastMacroParmTkn", "MacroID",
  "DoMacroDclTkn", "DoRegexDclTkn", "compileRegexTkn", "TextParameters",
  "DoOneValStmt", "DoOneConstExpr", "ctforTkn", "textblockTkn",
  "endtextTkn", "stringblockTkn", "endstringTkn", "scanblockTkn",
  "endscanTkn", "matchblockTkn", "endmatchTkn", "beginTkn", "endTkn",
  "procTkn", "endprocTkn", "procedureTkn", "iteratorTkn", "methodTkn",
  "programTkn", "unitTkn", "macroTkn", "keywordTkn", "terminatorTkn",
  "endmacroTkn", "endMacDefTkn", "regexMacroTkn", "endregexTkn",
  "endRegexDefTkn", "regexReturnTkn", "labelTkn", "endlabelTkn",
  "constTkn", "endconstTkn", "valTkn", "endvalTkn", "typeTkn",
  "endtypeTkn", "alignTkn", "varTkn", "endvarTkn", "staticTkn",
  "endstaticTkn", "uninitializedTkn", "endstorageTkn", "readonlyTkn",
  "endreadonlyTkn", "recordTkn", "endrecordTkn", "unionTkn", "endunionTkn",
  "classTkn", "vmtTkn", "endclassTkn", "enumTkn", "inheritsTkn",
  "pointerTkn", "toTkn", "downtoTkn", "externalTkn", "abstractTkn",
  "overloadsTkn", "overrideTkn", "overridesTkn", "forwardTkn",
  "returnsTkn", "atreturnsTkn", "noframeTkn", "frameTkn", "nodisplayTkn",
  "displayTkn", "noalignstkTkn", "alignstkTkn", "alignprocTkn", "useTkn",
  "useenterTkn", "noenterTkn", "useleaveTkn", "noleaveTkn", "pascalTkn",
  "cdeclTkn", "stdcallTkn", "nostorageTkn", "volatileTkn", "namespaceTkn",
  "fastTkn", "segmentTkn", "hereTkn", "atlabelTkn", "nameTkn", "valresTkn",
  "resultTkn", "lazyTkn", "thunkTkn", "jtTkn", "jfTkn", "ifTkn", "thenTkn",
  "elseifTkn", "elseTkn", "endifTkn", "switchTkn", "caseTkn", "defaultTkn",
  "endswitchTkn", "whileTkn", "doTkn", "endwhileTkn", "welseTkn",
  "repeatTkn", "untilTkn", "forTkn", "foreverTkn", "foreachTkn",
  "endforTkn", "felseTkn", "exitTkn", "exitifTkn", "breakTkn",
  "breakifTkn", "continueTkn", "continueifTkn", "tryTkn", "alwaysTkn",
  "unprotectedTkn", "exceptionTkn", "anyexceptionTkn", "endtryTkn",
  "raiseTkn", "reraiseTkn", "booleanTkn", "int8Tkn", "int16Tkn",
  "int32Tkn", "int64Tkn", "int128Tkn", "charTkn", "wcharTkn", "real32Tkn",
  "real64Tkn", "real80Tkn", "real128Tkn", "uns8Tkn", "uns16Tkn",
  "uns32Tkn", "uns64Tkn", "uns128Tkn", "stringTkn", "wstringTkn",
  "zstringTkn", "csetTkn", "regexTkn", "textTkn", "byteTkn", "wordTkn",
  "dwordTkn", "qwordTkn", "tbyteTkn", "lwordTkn", "atint8Tkn",
  "atint16Tkn", "atint32Tkn", "atint64Tkn", "atint128Tkn", "atcharTkn",
  "atwcharTkn", "atreal32Tkn", "atreal64Tkn", "atreal80Tkn", "atuns8Tkn",
  "atuns16Tkn", "atuns32Tkn", "atuns64Tkn", "atuns128Tkn", "atstringTkn",
  "atwstringTkn", "atcsetTkn", "atbyteTkn", "atwordTkn", "atdwordTkn",
  "atqwordTkn", "attbyteTkn", "atlwordTkn", "atpointerTkn", "ctlTkn",
  "endctlTkn", "nullTkn", "absTkn", "ceilTkn", "cosTkn", "dateTkn",
  "envTkn", "expTkn", "extractTkn", "floorTkn", "isalphaTkn",
  "isalphanumTkn", "isdigitTkn", "islowerTkn", "isspaceTkn", "isupperTkn",
  "isxdigitTkn", "logTkn", "log10Tkn", "maxTkn", "minTkn", "modregrmTkn",
  "oddTkn", "randomTkn", "randomizeTkn", "readTkn", "sinTkn", "sortTkn",
  "sqrtTkn", "systemTkn", "system2Tkn", "tanTkn", "threadTkn", "timeTkn",
  "peekcsetTkn", "onecsetTkn", "uptocsetTkn", "zerooronecsetTkn",
  "zeroormorecsetTkn", "oneormorecsetTkn", "exactlyncsetTkn",
  "firstncsetTkn", "norlesscsetTkn", "normorecsetTkn", "ntomcsetTkn",
  "exactlyntomcsetTkn", "peekcharTkn", "onecharTkn", "uptocharTkn",
  "zerooronecharTkn", "zeroormorecharTkn", "oneormorecharTkn",
  "exactlyncharTkn", "firstncharTkn", "norlesscharTkn", "normorecharTkn",
  "ntomcharTkn", "exactlyntomcharTkn", "peekicharTkn", "oneicharTkn",
  "uptoicharTkn", "zerooroneicharTkn", "zeroormoreicharTkn",
  "oneormoreicharTkn", "exactlynicharTkn", "firstnicharTkn",
  "norlessicharTkn", "normoreicharTkn", "ntomicharTkn",
  "exactlyntomicharTkn", "matchstrTkn", "matchistrTkn", "uptostrTkn",
  "uptoistrTkn", "matchtostrTkn", "matchtoistrTkn", "zeroormorewsTkn",
  "oneormorewsTkn", "wsoreosTkn", "wstheneosTkn", "peekwsTkn", "eosTkn",
  "wsTkn", "peekstrTkn", "peekistrTkn", "matchidTkn", "matchwordTkn",
  "matchiwordTkn", "matchintconstTkn", "matchrealconstTkn",
  "matchnumericconstTkn", "matchstrconstTkn", "matchregTkn",
  "matchreg8Tkn", "matchreg16Tkn", "matchreg32Tkn", "matchfpuregTkn",
  "matchmmxregTkn", "matchxmmregTkn", "deleteTkn", "indexTkn", "insertTkn",
  "lengthTkn", "lowercaseTkn", "replaceTkn", "rindexTkn", "strbrkTkn",
  "strsetTkn", "strspanTkn", "substrTkn", "leftTkn", "leftdelTkn",
  "rightTkn", "rightdelTkn", "tokenizeTkn", "trimTkn", "delspacesTkn",
  "uppercaseTkn", "fileexistsTkn", "filemodifiedtimeTkn", "symNameTkn",
  "symTypeTkn", "sympTypeTkn", "symBasepTypeTkn", "symClassTkn",
  "symSizeTkn", "symOffsetTkn", "symLocalsymsTkn", "symParmsTkn",
  "symLexTkn", "symArityTkn", "symDimTkn", "symNumelementsTkn",
  "symDefinedTkn", "symTypeNameTkn", "symBaseTypeNameTkn", "sympClassTkn",
  "symStaticNameTkn", "symIsExternalTkn", "symIsConstTkn", "symIsClassTkn",
  "symElementSizeTkn", "symIsRegTkn", "symIsReg8Tkn", "symIsReg16Tkn",
  "symIsReg32Tkn", "symIsfRegTkn", "symIsMemTkn", "symIsTypeTkn",
  "curLexTkn", "curOffsetTkn", "curDirTkn", "addOffset1stTkn",
  "lineNumberTkn", "lineNumberStkTkn", "errorPrefixTkn", "filenameTkn",
  "fileNameStkTkn", "startParmOfsTkn", "startLclOfsTkn", "enumSizeTkn",
  "lastMacroObjectTkn", "curObjectNameTkn", "curVarTkn", "sectionTkn",
  "boundvarTkn", "intovarTkn", "traceTkn", "exceptsTkn", "optstringsTkn",
  "baseregTkn", "st0Tkn", "st1Tkn", "st2Tkn", "st3Tkn", "st4Tkn", "st5Tkn",
  "st6Tkn", "st7Tkn", "alTkn", "ahTkn", "axTkn", "eaxTkn", "blTkn",
  "bhTkn", "bxTkn", "ebxTkn", "clTkn", "chTkn", "cxTkn", "ecxTkn", "dlTkn",
  "dhTkn", "dxTkn", "edxTkn", "siTkn", "esiTkn", "diTkn", "ediTkn",
  "bpTkn", "ebpTkn", "spTkn", "espTkn", "mm0Tkn", "mm1Tkn", "mm2Tkn",
  "mm3Tkn", "mm4Tkn", "mm5Tkn", "mm6Tkn", "mm7Tkn", "xmm0Tkn", "xmm1Tkn",
  "xmm2Tkn", "xmm3Tkn", "xmm4Tkn", "xmm5Tkn", "xmm6Tkn", "xmm7Tkn",
  "csTkn", "dsTkn", "esTkn", "fsTkn", "gsTkn", "ssTkn", "cr0Tkn", "cr1Tkn",
  "cr2Tkn", "cr3Tkn", "cr4Tkn", "cr5Tkn", "cr6Tkn", "cr7Tkn", "dr0Tkn",
  "dr1Tkn", "dr2Tkn", "dr3Tkn", "dr4Tkn", "dr5Tkn", "dr6Tkn", "dr7Tkn",
  "dxaxTkn", "edxeaxTkn", "thisTkn", "superTkn", "cTkn", "ncTkn", "oTkn",
  "noTkn", "sTkn", "nsTkn", "zTkn", "nzTkn", "aTkn", "naTkn", "aeTkn",
  "naeTkn", "bTkn", "nbTkn", "beTkn", "nbeTkn", "eTkn", "gTkn", "ngTkn",
  "ngeTkn", "lTkn", "nlTkn", "nleTkn", "peTkn", "poTkn", "npTkn", "pTkn",
  "aaaTkn", "aadTkn", "aamTkn", "aasTkn", "adcTkn", "lockadcTkn", "addTkn",
  "lockaddTkn", "lockandTkn", "arplTkn", "boundTkn", "bsfTkn", "bsrTkn",
  "bswapTkn", "btTkn", "btcTkn", "lockbtcTkn", "btrTkn", "lockbtrTkn",
  "btsTkn", "lockbtsTkn", "callTkn", "cbwTkn", "cdqTkn", "clcTkn",
  "cldTkn", "cliTkn", "cltsTkn", "cmcTkn", "cmovoTkn", "cmovnoTkn",
  "cmovbTkn", "cmovnbTkn", "cmoveTkn", "cmovneTkn", "cmovbeTkn",
  "cmovnbeTkn", "cmovsTkn", "cmovnsTkn", "cmovpTkn", "cmovnpTkn",
  "cmovlTkn", "cmovnlTkn", "cmovleTkn", "cmovnleTkn", "cmpTkn", "cmpsbTkn",
  "cmpsdTkn", "cmpswTkn", "cmpxchgTkn", "lockcmpxchgTkn", "cmpxchg8bTkn",
  "cpuidTkn", "cwdTkn", "cwdeTkn", "daaTkn", "dasTkn", "decTkn",
  "lockdecTkn", "enterTkn", "hltTkn", "idivTkn", "imodTkn", "imulTkn",
  "intmulTkn", "incTkn", "lockincTkn", "insbTkn", "insdTkn", "inswTkn",
  "intTkn", "intoTkn", "invdTkn", "invlpgTkn", "iretTkn", "iretdTkn",
  "jaTkn", "jaeTkn", "jbTkn", "jbeTkn", "jcTkn", "jeTkn", "jgTkn",
  "jgeTkn", "jlTkn", "jleTkn", "jnaTkn", "jnaeTkn", "jnbTkn", "jnbeTkn",
  "jncTkn", "jneTkn", "jngTkn", "jngeTkn", "jnlTkn", "jnleTkn", "jnoTkn",
  "joTkn", "jnpTkn", "jnsTkn", "jnzTkn", "jpTkn", "jpeTkn", "jpoTkn",
  "jsTkn", "jzTkn", "jcxzTkn", "jecxzTkn", "jmpTkn", "lahfTkn", "larTkn",
  "leaTkn", "ldsTkn", "lesTkn", "lfsTkn", "lgsTkn", "lssTkn", "lslTkn",
  "lgdtTkn", "lidtTkn", "lldtTkn", "sgdtTkn", "sidtTkn", "sldtTkn",
  "leaveTkn", "lodsbTkn", "lodsdTkn", "lodswTkn", "loopTkn", "loopeTkn",
  "loopzTkn", "loopneTkn", "loopnzTkn", "lmswTkn", "ltrTkn", "strTkn",
  "movTkn", "movsbTkn", "movsdTkn", "movswTkn", "movsxTkn", "movzxTkn",
  "mulTkn", "negTkn", "locknegTkn", "nopTkn", "locknotTkn", "lockorTkn",
  "outTkn", "outsbTkn", "outsdTkn", "outswTkn", "popTkn", "popaTkn",
  "popadTkn", "popfTkn", "popfdTkn", "pushTkn", "pushaTkn", "pushadTkn",
  "pushdTkn", "pushfTkn", "pushfdTkn", "pushwTkn", "rclTkn", "rcrTkn",
  "rdmsrTkn", "rdpmcTkn", "rdtscTkn", "rsmTkn", "repmovsbTkn",
  "repmovswTkn", "repmovsdTkn", "repinsbTkn", "repinswTkn", "repinsdTkn",
  "repoutsbTkn", "repoutswTkn", "repoutsdTkn", "repstosbTkn",
  "repstoswTkn", "repstosdTkn", "repecmpsbTkn", "repecmpswTkn",
  "repecmpsdTkn", "repzcmpsbTkn", "repzcmpswTkn", "repzcmpsdTkn",
  "repnecmpsbTkn", "repnecmpswTkn", "repnecmpsdTkn", "repnzcmpsbTkn",
  "repnzcmpswTkn", "repnzcmpsdTkn", "repescasbTkn", "repescaswTkn",
  "repescasdTkn", "repnescasbTkn", "repnescaswTkn", "repnescasdTkn",
  "repzscasbTkn", "repzscaswTkn", "repzscasdTkn", "repnzscasbTkn",
  "repnzscaswTkn", "repnzscasdTkn", "retTkn", "rolTkn", "rorTkn",
  "sahfTkn", "salTkn", "sarTkn", "sbbTkn", "locksbbTkn", "scasbTkn",
  "scasdTkn", "scaswTkn", "setbTkn", "setnbTkn", "setzTkn", "setnzTkn",
  "setbeTkn", "setnbeTkn", "setoTkn", "setnoTkn", "setsTkn", "setnsTkn",
  "setpTkn", "setnpTkn", "setlTkn", "setleTkn", "setnlTkn", "setnleTkn",
  "shlTkn", "shldTkn", "shrTkn", "shrdTkn", "smswTkn", "stcTkn", "stdTkn",
  "stiTkn", "stosbTkn", "stosdTkn", "stoswTkn", "subTkn", "sysenterTkn",
  "sysexitTkn", "locksubTkn", "testTkn", "ud2Tkn", "verrTkn", "verwTkn",
  "waitTkn", "wbinvdTkn", "wrmsrTkn", "xaddTkn", "lockxaddTkn", "xchgTkn",
  "lockxchgTkn", "xlatTkn", "xorTkn", "lockxorTkn", "fldTkn", "fildTkn",
  "fbldTkn", "fstTkn", "fstpTkn", "fistTkn", "fistpTkn", "fisttpTkn",
  "fbstpTkn", "fxchTkn", "fxamTkn", "faddTkn", "faddpTkn", "fiaddTkn",
  "fmulTkn", "fmulpTkn", "fimulTkn", "fsubTkn", "fsubpTkn", "fsubrTkn",
  "fsubrpTkn", "fisubTkn", "fisubrTkn", "fdivTkn", "fdivpTkn", "fdivrTkn",
  "fdivrpTkn", "fidivTkn", "fidivrTkn", "fcomTkn", "fcompTkn", "fcomppTkn",
  "ficomTkn", "ficompTkn", "fucomTkn", "fucompTkn", "fucomppTkn",
  "fsqrtTkn", "fabsTkn", "fchsTkn", "ftstTkn", "fscaleTkn", "fpremTkn",
  "fprem1Tkn", "frndintTkn", "fxtractTkn", "fldzTkn", "fld1Tkn",
  "fldpiTkn", "fldl2tTkn", "fldl2eTkn", "fldlg2Tkn", "fldln2Tkn",
  "f2xm1Tkn", "fsinTkn", "fcosTkn", "fsincosTkn", "fptanTkn", "fpatanTkn",
  "fyl2xTkn", "fyl2xp1Tkn", "finitTkn", "fninitTkn", "fwaitTkn",
  "fldcwTkn", "fstcwTkn", "fnstcwTkn", "fclexTkn", "fnclexTkn",
  "fldenvTkn", "fstenvTkn", "fnstenvTkn", "fsaveTkn", "fnsaveTkn",
  "frstorTkn", "fstswTkn", "fnstswTkn", "fincstpTkn", "fdecstpTkn",
  "fnopTkn", "ffreeTkn", "fcmovaTkn", "fcmovaeTkn", "fcmovbTkn",
  "fcmovbeTkn", "fcmoveTkn", "fcmovnaTkn", "fcmovnaeTkn", "fcmovnbTkn",
  "fcmovnbeTkn", "fcmovneTkn", "fcmovnuTkn", "fcmovuTkn", "fcomiTkn",
  "fcomipTkn", "fucomiTkn", "fucomipTkn", "paddbTkn", "paddwTkn",
  "padddTkn", "paddqTkn", "paddsbTkn", "paddswTkn", "paddusbTkn",
  "padduswTkn", "psubbTkn", "psubwTkn", "psubdTkn", "psubqTkn",
  "psubsbTkn", "psubswTkn", "psubusbTkn", "psubuswTkn", "pmullwTkn",
  "pmulhwTkn", "pmulhuwTkn", "pmuludqTkn", "pmaddwdTkn", "pmaxswTkn",
  "pmaxubTkn", "pminswTkn", "pminubTkn", "psadbwTkn", "pextrwTkn",
  "pinsrwTkn", "pmovmskbTkn", "pshufwTkn", "pshufdTkn", "pavgbTkn",
  "pavgwTkn", "pcmpeqbTkn", "pcmpeqwTkn", "pcmpeqdTkn", "pcmpgtbTkn",
  "pcmpgtwTkn", "pcmpgtdTkn", "packsswbTkn", "packuswbTkn", "packssdwTkn",
  "punpcklbwTkn", "punpcklwdTkn", "punpckldqTkn", "punpcklqdqTkn",
  "punpckhbwTkn", "punpckhwdTkn", "punpckhdqTkn", "punpckhqdqTkn",
  "pandTkn", "pandnTkn", "porTkn", "pxorTkn", "psllwTkn", "pslldTkn",
  "psllqTkn", "psrlwTkn", "psrldTkn", "psrlqTkn", "psrawTkn", "psradTkn",
  "movdTkn", "movqTkn", "emmsTkn", "addpdTkn", "addsdTkn", "addpsTkn",
  "addssTkn", "addsubpsTkn", "addsubpdTkn", "andnpdTkn", "andnpsTkn",
  "andpdTkn", "andpsTkn", "clflushTkn", "cmppdTkn", "cmppsTkn", "cmpssTkn",
  "cmpeqssTkn", "cmplessTkn", "cmpltssTkn", "cmpneqssTkn", "cmpnltssTkn",
  "cmpnlessTkn", "cmpordssTkn", "cmpunordssTkn", "cmpeqsdTkn",
  "cmplesdTkn", "cmpltsdTkn", "cmpneqsdTkn", "cmpnltsdTkn", "cmpnlesdTkn",
  "cmpordsdTkn", "cmpunordsdTkn", "cmpeqpsTkn", "cmplepsTkn", "cmpltpsTkn",
  "cmpneqpsTkn", "cmpnltpsTkn", "cmpnlepsTkn", "cmpordpsTkn",
  "cmpunordpsTkn", "cmpeqpdTkn", "cmplepdTkn", "cmpltpdTkn", "cmpneqpdTkn",
  "cmpnltpdTkn", "cmpnlepdTkn", "cmpordpdTkn", "cmpunordpdTkn",
  "comisdTkn", "comissTkn", "cvtdq2pdTkn", "cvtdq2psTkn", "cvtpd2dqTkn",
  "cvtpd2piTkn", "cvtpd2psTkn", "cvtpi2pdTkn", "cvtpi2psTkn",
  "cvtps2dqTkn", "cvtps2pdTkn", "cvtps2piTkn", "cvtsd2siTkn",
  "cvtsi2sdTkn", "cvtsi2ssTkn", "cvtsd2ssTkn", "cvtss2sdTkn",
  "cvtss2siTkn", "cvttpd2piTkn", "cvttpd2dqTkn", "cvttps2dqTkn",
  "cvttps2piTkn", "cvttsd2siTkn", "cvttss2siTkn", "divpdTkn", "divpsTkn",
  "divssTkn", "divsdTkn", "fxsaveTkn", "fxrstorTkn", "haddpdTkn",
  "haddpsTkn", "hsubpdTkn", "hsubpsTkn", "lddquTkn", "ldmxcsrTkn",
  "lfenceTkn", "maskmovdquTkn", "maskmovqTkn", "maxpdTkn", "maxpsTkn",
  "maxsdTkn", "maxssTkn", "mfenceTkn", "minpdTkn", "minpsTkn", "minsdTkn",
  "minssTkn", "monitorTkn", "movapdTkn", "movapsTkn", "movddupTkn",
  "movdqaTkn", "movdquTkn", "movdq2qTkn", "movhlpsTkn", "movhpdTkn",
  "movhpsTkn", "movlpdTkn", "movlpsTkn", "movlhpsTkn", "movmskpdTkn",
  "movmskpsTkn", "movntpdTkn", "movntiTkn", "movntpsTkn", "movntdqTkn",
  "movntqTkn", "movq2dqTkn", "movshdupTkn", "movsldupTkn", "movssTkn",
  "movupdTkn", "movupsTkn", "mulpdTkn", "mulpsTkn", "mulssTkn", "mulsdTkn",
  "mwaitTkn", "orpdTkn", "orpsTkn", "pauseTkn", "prefetcht0Tkn",
  "prefetcht1Tkn", "prefetcht2Tkn", "prefetchntaTkn", "pshufhwTkn",
  "pshuflwTkn", "psrldqTkn", "pslldqTkn", "rcppsTkn", "rcpssTkn",
  "rsqrtpsTkn", "rsqrtssTkn", "sfenceTkn", "shufpdTkn", "shufpsTkn",
  "sqrtpdTkn", "sqrtpsTkn", "sqrtsdTkn", "sqrtssTkn", "stmxcsrTkn",
  "subpsTkn", "subpdTkn", "subsdTkn", "subssTkn", "ucomisdTkn",
  "ucomissTkn", "unpckhpdTkn", "unpckhpsTkn", "unpcklpdTkn", "unpcklpsTkn",
  "xorpdTkn", "xorpsTkn", "parsePrintTkn", "parseHLAIDTkn",
  "parseClassIDTkn", "'('", "';'", "':'", "')'", "']'", "'['", "'}'",
  "'{'", "','", "'.'", "'!'", "'@'", "$accept", "ParserEntry",
  "doCTForLoop", "lclUndefID", "ValID", "doTextParameters", "doOneValStmt",
  "SetValTrue", "doMacroDcl", "doRegexDcl", "doCompileRegexTkn",
  "doOneConstExpr", "doTextBlock", "GetText", "doStringBlock", "GetString",
  "doMatchBlock", "GetMatch", "makeValID", "doScanBlock", "doPrint",
  "PrintList", "doParseObjID", "doParseClassID", "GetObjectBaseName",
  "SaveObjBaseName", "ObjFieldNames", "ClassFieldName", "macroLParen",
  "doMacroParameters", "@1", "OptMacroParms", "@2", "EmptyParmList",
  "doMacParm", "Semicolon", "Colon", "Assign", "Lparen", "Rparen",
  "Rbrack", "Lbrack", "Rbrace", "Lbrace", "comma", "SetTempNoErrors",
  "Reg8a", "Reg16a", "Reg32a", "fReg8", "Reg8", "Reg16", "fReg16", "Reg32",
  "fReg32", "Register", "fRegister", "fReg16or32", "fmmxReg", "mmxReg_a",
  "segReg", "fSegReg", "ctrlReg", "fCtrlRegister", "dbgReg",
  "fDbgRegister", "fXmmReg", "xmmReg_a", "ctl", "$@3", "CTLDeclarations",
  "CTLDecls", "CTLNameSpace", "CTLNameSpaceDCLs", "CTLNSDcls", "unit",
  "@4", "UnitDeclarations", "UnitDecls", "saveCurNS", "optionalEndLabel",
  "optionalEndVar", "optionalEndConst", "optionalEndVal",
  "optionalEndType", "optionalEndStatic", "optionalEndStorage",
  "optionalEndRO", "optionalEndProc", "pgm", "@5", "$@6", "$@7", "$@8",
  "SetInitAndFinal", "Declarations", "Decls", "optionalSemicolon",
  "OneOrMoreSemicolons", "SavePointerList", "doFast", "$@9", "NameSpace",
  "EnterNSName", "SetNSName", "$@10", "$@11", "BadLocalID",
  "NameSpaceDCLs", "NSDcls", "NameSpaceVars", "SeeIfInUnit", "TypeID",
  "BuiltInType", "BuiltInTypeNotThunk", "DefinedTypeID", "TypeIDNotThunk",
  "AnyLocalID", "AnyNonLocalID", "DefinedID", "DefinedConstID",
  "AnyStaticID", "UndefinedID", "AnyID", "AnyLabelID", "SimpleID",
  "DontLookUpID", "ArbID", "ReservedIDs", "NonConstLocalID", "ArrayValues",
  "DupArrayConst", "ArrayList", "SetElementCnt", "IncElementCnt",
  "optionalComma", "DoArrayList", "DimList", "IndexList", "AryRecVal",
  "ArrayRef", "RecordRef", "AryRecObj", "RecordAdrs", "ArrayAdrs",
  "RecordList", "RecList", "@12", "@13", "EnumList", "@14", "$@15",
  "CopyLexeme", "Empty", "SaveOffset", "SaveDirection", "SaveAdd1st",
  "SaveLex256", "SaveLex3", "OptionalInherit", "OptInherits", "doUnionTkn",
  "dorecordTkn", "recordOpts", "RecAlignment", "RecordStuff", "@16",
  "$@17", "UnionStuff", "@18", "$@19", "RecVars", "RecID", "RecDef", "@20",
  "$@21", "$@22", "$@23", "$@24", "@25", "OptionalExternal",
  "RequiredExternal", "OptionalStr", "InsertProcSym", "InsertEnum",
  "SaveEnumSym", "regexs", "RecordTheRegex", "recordReturn",
  "compileRegex", "saveInRegex", "initializeRegexList",
  "allocateRegexNode", "regexExpr", "optionalAlternation", "regexItems",
  "optionalConcat", "regexElement", "intExpression", "charExpression",
  "strExpression", "csetExpression", "processOptionalParms", "SomeConstID",
  "optionalRanges", "oneRange", "optionalSecondRange", "macros", "@26",
  "$@27", "doMacroTkn", "doTerminatorTkn", "doKeywordTkn",
  "MatchSemicolon", "optionalKeywords", "SaveSymTbl", "RecordTheMacro",
  "optionalMacParms", "@28", "MacroParmList", "optionalLocalIDs",
  "procDcls", "newProcs", "procID", "procs", "$@29", "@30", "$@31",
  "colonProcedure", "$@32", "@33", "$@34", "saveUID", "$@35", "@36",
  "$@37", "$@38", "@39", "$@40", "$@41", "@42", "$@43", "@44", "@45",
  "@46", "@47", "$@48", "@49", "@50", "@51", "@52", "$@53", "@54", "@55",
  "@56", "@57", "$@58", "@59", "@60", "@61", "@62", "$@63", "@64", "@65",
  "@66", "@67", "$@68", "colonIterator", "@69", "@70", "@71", "@72",
  "$@73", "@74", "@75", "@76", "@77", "@78", "@79", "colonProcedure2",
  "@80", "PatchLocals", "@81", "@82", "$@83", "@84", "@85", "$@86",
  "MatchProcTypeID", "@87", "@88", "@89", "$@90", "@91", "colonIterator2",
  "@92", "PatchLclIter", "@93", "@94", "$@95", "@96", "@97", "$@98", "@99",
  "$@100", "ClassStuff", "@101", "@102", "@103", "@104", "@105", "@106",
  "@107", "@108", "@109", "@110", "@111", "@112", "@113", "GetLexLvl",
  "newClassProcDCLs", "@114", "@115", "newClassOverrideDCLs", "@116",
  "@117", "FwdMethod", "colonMethod", "newClassProc", "omID", "omID2",
  "newClassOverride", "@118", "@119", "@120", "@121", "FMSaveLexLvl",
  "oiID", "oiID2", "@122", "@123", "@124", "@125", "SaveClassPtr",
  "SaveThisPtr", "ClassProc", "@126", "@127", "@128", "@129", "FixSymbols",
  "MatchParms", "@130", "ProcessParameter", "OptionalInReg",
  "MatchOneOrMoreParms", "@131", "variantTkn", "@132", "ProcessProcParm",
  "@133", "SetSM4", "OptionalExtName", "reg32use", "Options",
  "newProcOptionsSemicolon", "newProcOptions", "newOptions",
  "OptionalParms", "@134", "doOptionalParms", "@135", "ParmTypeID",
  "ColonSavePG", "OneOrMoreParms", "$@136", "@137", "$@138", "@139",
  "$@140", "@141", "$@142", "@143", "$@144", "@145", "EnterProcName",
  "PassBy", "PassByValDefault", "OptionalReturns", "EnterName",
  "EnterName4", "EnterIterName", "EnterIterName4", "SaveContext", "Types",
  "SetInType", "doTypes", "TypeDef", "@146", "@147", "ReservedTypeIDs",
  "typeDefNamem4", "@148", "@149", "doClassTkn", "FwdLabels", "Constants",
  "SetInConst", "doConstants", "ConstDef", "@150", "$@151", "Values",
  "SetInValue", "doValues", "ValueDef", "@152", "@153", "$@154", "$@155",
  "ValueRedef", "@156", "@157", "$@158", "$@159", "Variables", "SetInVar",
  "OptionalVarAlign", "doVariables", "VariableDef", "@160", "@161",
  "$@162", "@163", "@164", "@165", "@166", "@167", "@168", "VarErrors",
  "UndefinedForward", "$@169", "StaticAlign", "StaticPtrToProcUninit",
  "$@170", "StaticProcUninit", "StaticProcRedef", "StaticPtrToProcRedef",
  "SaveLocalIDPtr", "StaticProcInit", "$@171", "StaticPtrToProcInit",
  "$@172", "StaticRedefInit", "StaticPtrToProcRedefInit", "StaticEnum",
  "StaticEnumInit", "$@173", "StaticPtrToUser", "$@174",
  "StaticPtrToExtUser", "$@175", "StaticPtrToBuiltIn", "$@176",
  "StaticPtrToBuiltInExt", "$@177", "StaticPtrToBuiltInNS",
  "StaticSingleTypeInit", "$@178", "StaticSingleTypeWasExt", "$@179",
  "StaticArrayInit", "$@180", "$@181", "StaticArrayInitExt", "$@182",
  "StaticPtrToUserNoInit", "@183", "StaticPtrToUserExt",
  "StaticPtrBuiltInNoInit", "@184", "StaticSingleType", "@185",
  "StaticSingleExt", "StaticArray", "@186", "StaticArrayExt",
  "StaticRecord", "StaticUnion", "@187", "StaticVars", "SetInStatic",
  "OutputDSEG", "OutputEndDSEG", "OptionalAlignment", "doStaticVars",
  "StaticDef", "@188", "ReadOnlyVars", "SetInReadOnly", "OutputReadOnly",
  "OutputEndReadOnly", "OptionalROAlignment", "doReadOnlyVars",
  "ReadOnlyDef", "EnterReadOnlyDef", "$@189", "EnterROPDef", "EnterRODef2",
  "EnterRODef3", "EnterRODef4", "@190", "UninitVars", "SetInStorage",
  "OutputBSSSEG", "OutputEndBSSSEG", "doUninitVars", "UninitDef",
  "ConstantList", "@191", "DoConstant", "StaticExpr", "StaticLabelIDs",
  "StaticExprIDs", "SetUp4hlaFields", "ConstOnlyExpr", "fConstOnlyExpr",
  "ConstExpr", "LiteralConst", "@192", "SaveRecArray", "StringConst",
  "WStringConst", "intSet", "intSetItems", "EmptyIntSet", "intSetItem",
  "CSetLiteralConst", "SetItems", "SetItem", "UnionChar", "UnionRange",
  "ClearSet", "PreserveGlobal", "@193", "ConstFunc", "atToken", "$@194",
  "MaxConstList", "MinConstList", "modRegRmMem", "LocalOrNonLocalID",
  "SymTblFunc", "hlaSingleIDSVal", "hlaFields", "SingleFieldName",
  "PtAtHLAFields", "hlaLookup", "Stmts", "OneStmt", "@195", "Colon2",
  "SavePosn", "TraceIt", "StmtSequence", "fstmt", "fedxeax", "fdxax",
  "fMemory", "fMemoryDest", "fAnonMem", "fEitherMemDest", "fEitherMem",
  "fEitherMem16Dest", "fEitherMem32Dest", "fEitherMem64Dest",
  "fEitherMem128Dest", "fEitherMem128or64Dest", "fConstExpr", "fUndefID",
  "ppp", "xx", "pxx", "pmx", "pxm", "SingleStmt", "@196", "saveYYText",
  "CollectParameters", "OptionalCollectParameters",
  "OneOrMoreCollectParameters", "OneCollectParameter", "callFunction",
  "callLocalProc", "callNonLocalProc", "callClassProc", "SimpleRegVar",
  "IndirectCall1", "IndirectCall2", "parenPushBack", "IndirectCall3",
  "@197", "IndirectCall4", "SMVm1", "SMV0", "CallParameters", "@198",
  "IndirectCallParameters", "@199", "OptionalCallParameters", "CopyProc",
  "CopyProc2", "CopyParms", "SaveFilePosn", "SaveParameter",
  "OneorMoreCallParameters", "@200", "@201", "OneCallParameter",
  "doThunkTkn", "PreThunk", "@202", "callParms", "CallTargetID",
  "UndefProc", "CallTarget", "EmptyParens", "fp_reg", "fp_reg_st0",
  "fp_reg_not0", "FP_arith_instr", "FPP_arith_instr", "FPI_arith_instr",
  "fp_op1Or2", "fp_com1Or2", "sseTkns", "sse_mov_tkns", "mw_rv_tkns",
  "Ew_tkns", "Ms_tkns", "Gv_Ew_tkns", "vps_mq_tkns", "vps_vrqTkns",
  "Vps_Wq_tkns", "Vsd_Mq_tkns", "Vpd_Wq_tkns", "Gv_Ev_tkns", "Gd_VRp_tkns",
  "Pq_Qq_Tkns", "Vdq_Wd_Tkns", "Vdq_Wq_Tkns", "uns8ConstExpr", "pshufTkns",
  "psr_psl_tkns", "setccTkns", "btTkns", "shxdTkns", "leaProc", "MovSorX",
  "cmpssTkns", "cmpsdTkns", "cmppsTkns", "cmppdTkns", "shufTkns",
  "comTkns", "pd2piTkns", "pi2pdpsTkns", "ps2piTkns", "sd2siTkns",
  "ss2siTkns", "si2sdsTkns", "m8Tkns", "ldstmxcsrTkns", "genericTkns",
  "unaryTkns", "OptCommaDA", "divmodTkns", "Mul2ndOperand", "mulTkns",
  "jccTkns", "xchgTkns", "StringInstrs", "strMnemonics",
  "shiftAndRotateTkns", "fcl", "ldsegTkns", "accTkn", "facc", "fdx",
  "JmpTargetID", "UndefLabel", "doSetThunkTkn", "PreSetThunk", "StartTry",
  "PopExcepts", "$@203", "$@204", "$@205", "@206", "@207", "@208", "@209",
  "ZeroOrMoreExceptions", "OneOrMoreExceptions", "LastException", "@210",
  "OneException", "@211", "$@212", "SaveForPosn", "SaveForCond",
  "SaveForBreak", "EmitForLabel", "$@213", "EmitWhileLabel", "SetBreakLbl",
  "$@214", "EmitWhileCode", "SetBreakLbl2", "GetDoTkn", "SaveTrueLabel",
  "SaveFalseLabel", "EmitRepeatLabel", "SaveBreakLbl", "PutContinueLbl",
  "callIterators", "callIteratorID", "@215", "@216",
  "callIndirectIterator", "@217", "@218", "callIndexedIterator", "@219",
  "IterID", "@220", "@221", "GetLbl", "exitifCode", "breakifCode",
  "continueifCode", "FalseParm", "TrueParm", "jtfCode", "EmitJmp",
  "EmitSkipThen", "$@222", "ExitIfLabel7", "ifCode", "EmitTrueLabel4",
  "@223", "ExitIfLabel6", "ElseIF", "ElseIFs", "ExitIfLabel5_9",
  "elseifCode4", "ExitIfLabel6_10", "ElseIFs2", "EmitTrueLabel",
  "EmitFalseLabel", "PutElseIfSTL", "GetThen", "OptionalDefault", "$@224",
  "SwitchLabel", "InitCaseCnt", "OneOrMoreCases", "@225", "EmitCaseLbl",
  "OneOrMoreCaseVals", "BoolExpr", "inOrnotin", "relop", "CPUFlag",
  "be_reg", "be_mem", "be_anonmem", "be_const", "Memory", "MemoryDest",
  "NotMemoryID", "Displacement", "$@226", "Displacement2", "ScaledIndex",
  "amGutz", "zeroOrMoreGutz", "iamRegister", "IndexAdrsMode", "AnonMem",
  "SimpleMemoryVar", "NotIntermediateVar", "saveCurVar", "copyAdrs0",
  "FieldStuff", "recFieldStuff", "PeriodAndSaveST", "LookupSym",
  "PointAtFields", "cls_fpReg", "Classify", "UnprocessedID", "ProcessedID",
  "AnyMemory", "CoercedMemory", "optionalIndex", "AnyIndex", "SingleIndex",
  "ScaledIndexMode", "ScaledIndexPlus", "FullIndex", "OptionalScaled",
  "OptDisp", "BracketedExpr", "AnyExpr", "AnyExprList", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   124,    94,   259,   260,    38,   261,
     262,   263,    60,    62,    61,   264,   265,   266,    43,    45,
      42,    47,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,  1122,  1123,  1124,
    1125,  1126,  1127,  1128,  1129,  1130,  1131,  1132,  1133,  1134,
    1135,  1136,  1137,  1138,  1139,  1140,  1141,  1142,  1143,  1144,
    1145,  1146,  1147,  1148,  1149,  1150,  1151,  1152,  1153,  1154,
    1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,
    1165,  1166,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,
    1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,  1204,
    1205,  1206,  1207,  1208,  1209,  1210,  1211,  1212,  1213,  1214,
    1215,  1216,  1217,  1218,  1219,  1220,  1221,  1222,  1223,  1224,
    1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,  1234,
    1235,  1236,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,
    1245,  1246,  1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,  1264,
    1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,  1273,  1274,
    1275,  1276,  1277,  1278,  1279,  1280,  1281,  1282,  1283,  1284,
    1285,  1286,  1287,  1288,  1289,  1290,  1291,  1292,  1293,  1294,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,  1302,  1303,  1304,
    1305,  1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,  1314,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,  1323,  1324,
    1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,
    1345,  1346,  1347,  1348,  1349,  1350,  1351,  1352,  1353,  1354,
    1355,  1356,  1357,  1358,  1359,  1360,  1361,  1362,  1363,  1364,
    1365,  1366,  1367,  1368,  1369,    40,    59,    58,    41,    93,
      91,   125,   123,    44,    46,    33,    64
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,  1137,  1138,  1138,  1138,  1138,  1138,  1138,  1138,  1138,
    1138,  1138,  1138,  1138,  1138,  1138,  1138,  1138,  1138,  1138,
    1139,  1139,  1139,  1140,  1141,  1141,  1142,  1143,  1144,  1145,
    1146,  1147,  1148,  1149,  1149,  1150,  1151,  1151,  1152,  1153,
    1154,  1155,  1155,  1156,  1157,  1158,  1158,  1159,  1160,  1161,
    1162,  1163,  1163,  1164,  1164,  1165,  1167,  1166,  1168,  1168,
    1169,  1168,  1170,  1171,  1172,  1172,  1173,  1173,  1174,  1174,
    1175,  1175,  1176,  1176,  1177,  1177,  1178,  1178,  1179,  1179,
    1180,  1180,  1181,  1181,  1182,  1183,  1183,  1183,  1183,  1183,
    1183,  1183,  1183,  1184,  1184,  1184,  1184,  1184,  1184,  1184,
    1184,  1185,  1185,  1185,  1185,  1185,  1185,  1185,  1185,  1186,
    1186,  1186,  1186,  1187,  1187,  1188,  1188,  1189,  1189,  1189,
    1189,  1190,  1190,  1191,  1191,  1191,  1191,  1192,  1192,  1192,
    1193,  1193,  1193,  1194,  1194,  1195,  1195,  1196,  1196,  1196,
    1196,  1196,  1196,  1196,  1196,  1197,  1197,  1197,  1197,  1197,
    1197,  1198,  1198,  1199,  1199,  1199,  1199,  1200,  1200,  1201,
    1201,  1201,  1201,  1201,  1201,  1202,  1202,  1203,  1203,  1204,
    1204,  1204,  1204,  1204,  1204,  1204,  1204,  1206,  1205,  1207,
    1208,  1208,  1208,  1208,  1208,  1209,  1209,  1209,  1209,  1210,
    1211,  1211,  1211,  1211,  1213,  1212,  1214,  1215,  1215,  1215,
    1215,  1215,  1215,  1215,  1215,  1215,  1215,  1215,  1216,  1217,
    1217,  1218,  1218,  1219,  1219,  1220,  1220,  1221,  1221,  1222,
    1222,  1223,  1223,  1224,  1224,  1225,  1225,  1227,  1228,  1229,
    1230,  1226,  1231,  1232,  1233,  1233,  1233,  1233,  1233,  1233,
    1233,  1233,  1233,  1233,  1233,  1233,  1234,  1234,  1235,  1235,
    1236,  1238,  1237,  1239,  1239,  1239,  1239,  1240,  1241,  1242,
    1239,  1243,  1239,  1244,  1244,  1244,  1244,  1244,  1244,  1244,
    1245,  1246,  1246,  1246,  1246,  1246,  1246,  1246,  1246,  1246,
    1246,  1247,  1248,  1249,  1249,  1250,  1250,  1251,  1251,  1251,
    1251,  1251,  1251,  1251,  1251,  1251,  1251,  1251,  1251,  1251,
    1251,  1251,  1251,  1251,  1251,  1251,  1251,  1251,  1251,  1251,
    1251,  1251,  1251,  1251,  1251,  1251,  1252,  1252,  1252,  1252,
    1253,  1253,  1254,  1254,  1254,  1254,  1254,  1254,  1254,  1254,
    1255,  1255,  1255,  1255,  1255,  1255,  1255,  1255,  1256,  1256,
    1257,  1257,  1258,  1258,  1259,  1259,  1260,  1260,  1260,  1261,
    1261,  1262,  1263,  1264,  1264,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1267,  1267,  1268,  1269,  1270,  1271,  1272,  1272,
    1273,  1273,  1274,  1274,  1275,  1275,  1276,  1276,  1276,  1277,
    1278,  1279,  1279,  1279,  1280,  1281,  1282,  1283,  1283,  1284,
    1283,  1285,  1283,  1286,  1287,  1286,  1286,  1288,  1286,  1286,
    1286,  1289,  1290,  1291,  1292,  1293,  1294,  1295,  1296,  1296,
    1296,  1297,  1297,  1297,  1298,  1299,  1300,  1300,  1300,  1300,
    1301,  1301,  1302,  1303,  1304,  1302,  1305,  1306,  1307,  1305,
    1308,  1308,  1309,  1309,  1309,  1310,  1310,  1310,  1311,  1310,
    1312,  1310,  1313,  1310,  1314,  1310,  1315,  1310,  1316,  1310,
    1310,  1310,  1310,  1310,  1310,  1310,  1310,  1310,  1310,  1317,
    1317,  1318,  1319,  1319,  1320,  1321,  1322,  1323,  1324,  1325,
    1326,  1326,  1326,  1326,  1327,  1328,  1329,  1330,  1331,  1331,
    1332,  1333,  1333,  1334,  1334,  1334,  1334,  1334,  1334,  1335,
    1334,  1334,  1336,  1334,  1334,  1334,  1334,  1334,  1334,  1334,
    1334,  1334,  1334,  1334,  1334,  1334,  1337,  1334,  1334,  1334,
    1334,  1334,  1334,  1334,  1334,  1334,  1334,  1334,  1334,  1334,
    1338,  1334,  1334,  1334,  1334,  1334,  1334,  1334,  1334,  1334,
    1334,  1334,  1334,  1334,  1334,  1334,  1334,  1334,  1334,  1334,
    1334,  1334,  1334,  1334,  1334,  1334,  1334,  1334,  1339,  1334,
    1334,  1334,  1340,  1340,  1341,  1341,  1341,  1341,  1341,  1342,
    1343,  1343,  1343,  1344,  1345,  1346,  1344,  1347,  1348,  1349,
    1350,  1351,  1351,  1352,  1353,  1354,  1355,  1354,  1356,  1356,
    1356,  1356,  1357,  1357,  1358,  1358,  1359,  1360,  1360,  1360,
    1360,  1360,  1360,  1360,  1360,  1360,  1359,  1359,  1362,  1363,
    1364,  1361,  1359,  1365,  1366,  1367,  1368,  1359,  1369,  1370,
    1371,  1372,  1359,  1373,  1374,  1375,  1361,  1376,  1377,  1378,
    1359,  1379,  1380,  1381,  1382,  1383,  1361,  1384,  1385,  1386,
    1387,  1388,  1359,  1389,  1390,  1391,  1392,  1393,  1361,  1394,
    1395,  1396,  1397,  1398,  1359,  1399,  1400,  1401,  1402,  1403,
    1361,  1404,  1405,  1406,  1407,  1408,  1409,  1359,  1410,  1361,
    1411,  1359,  1412,  1359,  1413,  1361,  1414,  1359,  1361,  1359,
    1359,  1361,  1359,  1415,  1361,  1416,  1417,  1359,  1418,  1419,
    1420,  1421,  1361,  1422,  1423,  1424,  1359,  1425,  1426,  1427,
    1428,  1429,  1359,  1430,  1361,  1431,  1432,  1359,  1433,  1434,
    1435,  1436,  1361,  1437,  1438,  1439,  1359,  1440,  1441,  1361,
    1442,  1443,  1442,  1444,  1442,  1445,  1442,  1446,  1442,  1447,
    1442,  1448,  1442,  1449,  1442,  1450,  1451,  1442,  1452,  1453,
    1442,  1454,  1442,  1455,  1442,  1456,  1457,  1458,  1459,  1457,
    1460,  1461,  1462,  1460,  1463,  1464,  1465,  1463,  1465,  1465,
    1465,  1466,  1466,  1463,  1467,  1467,  1468,  1469,  1463,  1470,
    1468,  1471,  1463,  1472,  1465,  1473,  1463,  1465,  1474,  1474,
    1474,  1463,  1475,  1475,  1475,  1468,  1476,  1463,  1477,  1468,
    1478,  1463,  1479,  1465,  1480,  1481,  1482,  1465,  1483,  1482,
    1484,  1465,  1465,  1482,  1468,  1485,  1482,  1486,  1468,  1487,
    1488,  1489,  1488,  1490,  1491,  1491,  1492,  1493,  1492,  1494,
    1492,  1495,  1492,  1496,  1492,  1497,  1492,  1498,  1499,  1499,
    1500,  1500,  1500,  1500,  1500,  1500,  1501,  1501,  1501,  1501,
    1501,  1501,  1501,  1501,  1501,  1501,  1501,  1501,  1501,  1501,
    1501,  1501,  1501,  1501,  1501,  1502,  1502,  1503,  1504,  1504,
    1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,
    1504,  1504,  1504,  1504,  1504,  1504,  1504,  1504,  1506,  1505,
    1507,  1508,  1507,  1509,  1509,  1510,  1511,  1511,  1512,  1513,
    1511,  1514,  1515,  1511,  1511,  1516,  1517,  1511,  1511,  1518,
    1519,  1511,  1511,  1520,  1521,  1511,  1522,  1523,  1523,  1523,
    1523,  1523,  1523,  1523,  1524,  1525,  1525,  1526,  1527,  1528,
    1529,  1530,  1531,  1532,  1533,  1533,  1534,  1534,  1535,  1536,
    1534,  1534,  1534,  1537,  1537,  1537,  1537,  1537,  1537,  1537,
    1537,  1537,  1537,  1537,  1537,  1537,  1537,  1537,  1537,  1537,
    1537,  1537,  1537,  1537,  1537,  1537,  1537,  1537,  1537,  1537,
    1537,  1538,  1534,  1534,  1534,  1534,  1534,  1534,  1534,  1539,
    1540,  1534,  1541,  1534,  1534,  1534,  1534,  1534,  1534,  1534,
    1534,  1542,  1542,  1543,  1544,  1545,  1545,  1546,  1546,  1546,
    1546,  1547,  1546,  1548,  1546,  1546,  1546,  1546,  1549,  1550,
    1551,  1551,  1552,  1552,  1552,  1552,  1552,  1552,  1552,  1552,
    1552,  1552,  1552,  1552,  1552,  1552,  1552,  1552,  1552,  1552,
    1552,  1552,  1552,  1552,  1552,  1552,  1552,  1552,  1552,  1552,
    1552,  1552,  1552,  1552,  1552,  1552,  1552,  1552,  1552,  1553,
    1552,  1554,  1552,  1555,  1552,  1556,  1552,  1552,  1552,  1552,
    1552,  1552,  1557,  1557,  1557,  1557,  1557,  1557,  1557,  1557,
    1557,  1557,  1557,  1557,  1557,  1557,  1557,  1557,  1557,  1557,
    1557,  1557,  1557,  1557,  1557,  1557,  1557,  1557,  1557,  1557,
    1557,  1557,  1557,  1557,  1557,  1557,  1557,  1557,  1557,  1557,
    1557,  1557,  1558,  1557,  1559,  1557,  1560,  1557,  1561,  1557,
    1557,  1557,  1557,  1557,  1557,  1562,  1563,  1564,  1564,  1564,
    1564,  1564,  1564,  1565,  1565,  1566,  1566,  1566,  1567,  1566,
    1568,  1566,  1569,  1570,  1566,  1571,  1566,  1572,  1566,  1573,
    1566,  1574,  1566,  1566,  1575,  1566,  1566,  1576,  1576,  1576,
    1576,  1576,  1576,  1576,  1578,  1577,  1579,  1581,  1580,  1582,
    1583,  1584,  1585,  1587,  1586,  1589,  1588,  1590,  1591,  1592,
    1594,  1593,  1596,  1595,  1598,  1597,  1600,  1599,  1602,  1601,
    1603,  1605,  1604,  1607,  1606,  1609,  1608,  1610,  1608,  1612,
    1611,  1614,  1613,  1615,  1617,  1616,  1619,  1618,  1620,  1622,
    1621,  1623,  1624,  1626,  1625,  1627,  1628,  1629,  1630,  1631,
    1631,  1632,  1632,  1633,  1633,  1633,  1633,  1633,  1633,  1633,
    1633,  1633,  1633,  1633,  1633,  1633,  1633,  1633,  1633,  1633,
    1633,  1633,  1633,  1633,  1633,  1633,  1633,  1633,  1633,  1633,
    1633,  1633,  1633,  1633,  1633,  1633,  1633,  1633,  1634,  1633,
    1633,  1635,  1636,  1637,  1638,  1639,  1639,  1640,  1640,  1641,
    1641,  1641,  1641,  1641,  1641,  1641,  1641,  1641,  1642,  1641,
    1641,  1641,  1641,  1641,  1641,  1641,  1643,  1641,  1641,  1644,
    1641,  1641,  1641,  1641,  1641,  1645,  1641,  1641,  1641,  1641,
    1641,  1646,  1641,  1641,  1641,  1641,  1641,  1647,  1641,  1641,
    1641,  1641,  1648,  1641,  1641,  1649,  1650,  1651,  1652,  1653,
    1653,  1654,  1654,  1654,  1654,  1654,  1654,  1654,  1654,  1654,
    1654,  1654,  1654,  1654,  1654,  1654,  1654,  1654,  1654,  1654,
    1655,  1656,  1655,  1657,  1658,  1658,  1658,  1658,  1658,  1658,
    1659,  1659,  1659,  1659,  1659,  1659,  1659,  1659,  1659,  1659,
    1659,  1659,  1659,  1659,  1660,  1660,  1661,  1662,  1662,  1663,
    1663,  1664,  1664,  1665,  1665,  1665,  1665,  1665,  1665,  1665,
    1665,  1664,  1664,  1664,  1664,  1664,  1666,  1664,  1664,  1667,
    1665,  1665,  1668,  1668,  1668,  1668,  1668,  1669,  1669,  1669,
    1669,  1669,  1665,  1670,  1670,  1671,  1671,  1672,  1673,  1665,
    1674,  1675,  1675,  1675,  1676,  1676,  1677,  1678,  1679,  1680,
    1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,
    1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,
    1664,  1664,  1681,  1664,  1664,  1682,  1682,  1683,  1683,  1683,
    1683,  1683,  1683,  1683,  1683,  1683,  1683,  1683,  1683,  1683,
    1683,  1683,  1683,  1683,  1683,  1683,  1683,  1683,  1683,  1664,
    1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,
    1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,
    1664,  1664,  1664,  1684,  1664,  1682,  1682,  1664,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1685,  1685,  1682,  1682,
    1686,  1686,  1687,  1687,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1688,  1688,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,  1682,
    1682,  1682,  1682,  1682,  1682,  1682,  1664,  1689,  1689,  1689,
    1689,  1689,  1689,  1689,  1689,  1689,  1689,  1689,  1689,  1689,
    1689,  1689,  1689,  1689,  1689,  1689,  1689,  1689,  1689,  1689,
    1689,  1689,  1689,  1689,  1689,  1689,  1689,  1690,  1691,  1691,
    1692,  1693,  1694,  1695,  1695,  1697,  1696,  1698,  1698,  1696,
    1696,  1696,  1696,  1696,  1696,  1696,  1696,  1696,  1696,  1696,
    1696,  1699,  1700,  1701,  1701,  1702,  1703,  1703,  1704,  1704,
    1705,  1705,  1706,  1706,  1707,  1707,  1708,  1708,  1709,  1709,
    1710,  1710,  1711,  1711,  1712,  1712,  1713,  1713,  1714,  1714,
    1715,  1715,  1716,  1716,  1717,  1718,  1719,  1720,  1721,  1722,
    1722,  1722,  1722,  1722,  1722,  1723,  1722,  1724,  1725,  1726,
    1726,  1727,  1727,  1728,  1728,  1728,  1728,  1728,  1728,  1728,
    1729,  1729,  1729,  1729,  1729,  1729,  1729,  1730,  1731,  1732,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1733,  1734,  1734,
    1735,  1735,  1736,  1738,  1737,  1737,  1739,  1740,  1741,  1743,
    1742,  1745,  1744,  1746,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1752,  1755,  1755,  1755,  1755,  1755,  1755,
    1755,  1755,  1755,  1755,  1755,  1756,  1757,  1758,  1755,  1759,
    1759,  1759,  1759,  1759,  1759,  1759,  1759,  1759,  1759,  1760,
    1760,  1760,  1760,  1760,  1760,  1760,  1761,  1761,  1761,  1761,
    1761,  1762,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1763,
    1763,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1764,  1764,
    1765,  1765,  1766,  1766,  1766,  1766,  1766,  1766,  1766,  1766,
    1766,  1766,  1766,  1766,  1766,  1766,  1767,  1767,  1767,  1767,
    1767,  1767,  1767,  1767,  1768,  1768,  1768,  1768,  1768,  1768,
    1768,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1769,  1769,  1769,  1769,  1769,  1769,  1769,  1769,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1770,  1770,  1770,  1770,  1770,  1770,  1770,  1770,  1770,  1770,
    1770,  1770,  1722,  1722,  1771,  1771,  1771,  1771,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,
    1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,
    1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,
    1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,
    1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,  1772,
    1772,  1772,  1772,  1772,  1772,  1722,  1722,  1773,  1773,  1773,
    1773,  1773,  1773,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1774,  1774,  1774,  1722,  1722,  1775,
    1775,  1775,  1775,  1775,  1722,  1722,  1776,  1776,  1776,  1776,
    1722,  1722,  1777,  1777,  1722,  1722,  1722,  1722,  1778,  1778,
    1779,  1779,  1722,  1722,  1722,  1722,  1722,  1780,  1780,  1722,
    1722,  1781,  1781,  1722,  1722,  1782,  1782,  1782,  1722,  1722,
    1783,  1783,  1783,  1783,  1783,  1783,  1783,  1783,  1783,  1783,
    1783,  1783,  1783,  1783,  1783,  1783,  1783,  1783,  1722,  1722,
    1722,  1784,  1784,  1722,  1785,  1785,  1785,  1785,  1785,  1785,
    1785,  1785,  1785,  1785,  1785,  1785,  1785,  1785,  1785,  1785,
    1785,  1785,  1785,  1785,  1785,  1785,  1785,  1785,  1785,  1785,
    1785,  1785,  1785,  1785,  1785,  1785,  1785,  1785,  1785,  1785,
    1785,  1785,  1785,  1785,  1785,  1722,  1722,  1722,  1722,  1786,
    1786,  1786,  1787,  1787,  1787,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1788,  1789,
    1789,  1789,  1722,  1722,  1722,  1722,  1790,  1790,  1790,  1790,
    1790,  1790,  1790,  1790,  1790,  1790,  1722,  1722,  1722,  1722,
    1722,  1722,  1791,  1791,  1791,  1791,  1791,  1791,  1791,  1791,
    1791,  1791,  1791,  1791,  1791,  1791,  1791,  1791,  1722,  1722,
    1792,  1792,  1792,  1792,  1792,  1792,  1792,  1722,  1722,  1722,
    1722,  1722,  1793,  1793,  1722,  1722,  1722,  1722,  1722,  1722,
    1794,  1794,  1794,  1794,  1794,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1795,  1795,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1796,  1796,  1796,  1796,
    1796,  1796,  1796,  1796,  1722,  1722,  1722,  1722,  1797,  1797,
    1797,  1797,  1797,  1797,  1797,  1797,  1722,  1722,  1722,  1722,
    1798,  1798,  1798,  1798,  1798,  1798,  1798,  1798,  1722,  1722,
    1722,  1722,  1799,  1799,  1799,  1799,  1799,  1799,  1799,  1799,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1800,  1800,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1801,  1801,  1801,  1801,  1722,
    1722,  1802,  1802,  1722,  1722,  1722,  1722,  1722,  1722,  1803,
    1803,  1722,  1722,  1804,  1804,  1722,  1722,  1805,  1805,  1722,
    1722,  1806,  1806,  1722,  1722,  1807,  1807,  1722,  1722,  1722,
    1722,  1808,  1808,  1808,  1808,  1808,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1809,  1809,  1722,  1810,  1810,  1810,  1810,
    1810,  1810,  1810,  1810,  1810,  1810,  1810,  1810,  1810,  1810,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1811,  1811,  1811,  1811,  1811,  1811,  1811,
    1811,  1722,  1722,  1722,  1812,  1812,  1812,  1812,  1812,  1812,
    1813,  1813,  1813,  1813,  1722,  1722,  1722,  1722,  1722,  1722,
    1814,  1814,  1814,  1814,  1814,  1814,  1815,  1815,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1816,  1816,  1816,  1816,  1816,  1816,  1816,  1816,  1816,
    1816,  1816,  1816,  1816,  1816,  1816,  1816,  1816,  1816,  1816,
    1816,  1816,  1816,  1816,  1816,  1816,  1816,  1816,  1816,  1816,
    1816,  1816,  1816,  1816,  1816,  1816,  1816,  1816,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1817,  1817,  1722,
    1722,  1722,  1722,  1818,  1818,  1818,  1818,  1722,  1722,  1819,
    1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,
    1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,
    1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,
    1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,
    1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,  1819,
    1819,  1820,  1820,  1820,  1820,  1820,  1820,  1820,  1820,  1821,
    1821,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1822,
    1822,  1822,  1822,  1822,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1823,  1823,  1823,  1824,  1824,  1825,  1825,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1826,  1826,  1826,
    1826,  1826,  1826,  1826,  1827,  1827,  1827,  1827,  1827,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1828,  1829,  1830,
    1831,  1722,  1722,  1832,  1722,  1833,  1722,  1834,  1722,  1835,
    1836,  1722,  1837,  1838,  1722,  1839,  1839,  1840,  1840,  1841,
    1842,  1841,  1844,  1843,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1845,  1722,  1846,  1847,  1848,  1849,  1722,  1850,  1722,
    1851,  1852,  1722,  1853,  1722,  1854,  1855,  1856,  1856,  1722,
    1857,  1858,  1859,  1722,  1860,  1861,  1722,  1722,  1722,  1862,
    1862,  1862,  1864,  1863,  1865,  1863,  1867,  1866,  1868,  1866,
    1870,  1869,  1871,  1871,  1872,  1722,  1873,  1722,  1722,  1722,
    1874,  1722,  1875,  1722,  1722,  1722,  1876,  1722,  1722,  1722,
    1877,  1878,  1879,  1722,  1722,  1722,  1722,  1880,  1881,  1722,
    1882,  1883,  1722,  1722,  1884,  1722,  1885,  1722,  1886,  1887,
    1722,  1722,  1888,  1722,  1889,  1890,  1891,  1890,  1890,  1892,
    1893,  1890,  1894,  1894,  1894,  1894,  1895,  1896,  1897,  1898,
    1898,  1722,  1899,  1900,  1899,  1901,  1902,  1903,  1904,  1903,
    1905,  1906,  1906,  1907,  1907,  1907,  1907,  1907,  1907,  1907,
    1907,  1907,  1907,  1907,  1908,  1908,  1907,  1907,  1907,  1907,
    1907,  1907,  1907,  1907,  1907,  1907,  1907,  1907,  1907,  1907,
    1907,  1907,  1907,  1907,  1909,  1909,  1909,  1909,  1909,  1909,
    1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,
    1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,
    1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,  1910,
    1911,  1911,  1912,  1912,  1913,  1913,  1914,  1914,  1915,  1915,
    1915,  1915,  1916,  1916,  1916,  1916,  1916,  1916,  1917,  1917,
    1917,  1917,  1917,  1917,  1918,  1919,  1918,  1920,  1921,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1923,  1923,  1923,
    1924,  1925,  1925,  1926,  1927,  1927,  1927,  1927,  1927,  1927,
    1927,  1927,  1927,  1927,  1927,  1927,  1927,  1927,  1927,  1927,
    1927,  1928,  1928,  1928,  1929,  1930,  1931,  1932,  1932,  1933,
    1934,  1935,  1936,  1936,  1936,  1936,  1936,  1936,  1936,  1936,
    1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,
    1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,
    1937,  1937,  1938,  1939,  1940,  1940,  1940,  1940,  1940,  1941,
    1941,  1941,  1941,  1941,  1941,  1942,  1942,  1942,  1943,  1943,
    1943,  1943,  1943,  1943,  1944,  1945,  1946,  1946,  1947,  1947,
    1947,  1947,  1948,  1948,  1949,  1949,  1949,  1950,  1951,  1951,
    1952,  1952,  1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,
    1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,
    1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,
    1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,
    1951,  1951
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       8,     8,     6,     1,     1,     1,     4,     3,     0,     2,
       2,     2,     4,     6,     6,     0,     6,     6,     0,     6,
       0,     1,     1,     8,     4,     1,     3,     2,     2,     0,
       0,     4,     4,     4,     4,     1,     0,     6,     1,     1,
       0,     5,     0,     0,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     5,     6,     1,     5,     1,     5,     1,     2,     5,
       6,     1,     5,     1,     2,     5,     6,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     4,     2,
       0,     5,     5,     5,     4,     9,    10,     9,    10,     2,
       1,     4,     4,     4,     0,     8,     2,     0,     5,     5,
       5,     5,     5,     5,     5,     5,     4,     4,     0,     0,
       2,     0,     2,     0,     2,     0,     2,     0,     2,     0,
       2,     0,     2,     0,     2,     0,     2,     0,     0,     0,
       0,    18,     0,     2,     0,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     4,     4,     0,     1,     1,     2,
       0,     0,     3,     9,    10,     9,    10,     0,     0,     0,
       9,     0,     8,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     4,     4,     4,     3,     4,     4,     4,     4,
       3,     3,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     5,     2,     0,     0,     1,     1,
       3,     4,     1,     3,     1,     3,     1,     1,     1,     4,
       3,     1,     1,     1,     3,     4,     1,     1,     7,     0,
       4,     0,    10,     1,     0,     4,     1,     0,     4,     3,
       3,     0,     0,     0,     0,     0,     0,     0,     1,     4,
       4,     1,     4,     4,     1,     1,     1,     3,     1,     4,
       3,     5,     1,     0,     0,     8,     1,     0,     0,     9,
       0,     2,     1,     2,     2,     1,     7,     5,     0,     9,
       0,     9,     0,     8,     0,     8,     0,     6,     0,     9,
       8,     6,     6,     7,     4,     7,     7,     4,     2,     1,
       1,     3,     1,     3,     0,     0,     0,    11,     0,     0,
       4,     7,     3,     6,     0,     1,     0,     2,     3,     1,
       2,     2,     1,     5,     6,     6,     4,     6,     3,     3,
       3,     3,     3,     4,     5,     4,     5,     3,     4,     4,
       5,     5,     4,     4,     4,     5,     3,     4,     4,     4,
       4,     3,     4,     3,     4,     4,     4,     4,     4,     5,
       3,     4,     3,     4,     4,     4,     2,     3,     3,     7,
       7,     4,     4,     4,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     0,     3,
       5,     4,     1,     1,     1,     5,     5,     1,     1,     1,
       1,     2,     2,    11,     0,     0,    24,     1,     1,     1,
       1,     1,    11,     0,     0,     1,     0,     4,     1,     3,
       2,     3,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     7,     7,     0,     0,
       0,    22,     7,     2,     0,     0,     0,    21,     0,     0,
       0,     0,    22,     0,     0,     0,    22,     0,     0,     0,
      21,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,     0,    26,     0,     0,     0,     0,     0,    26,     0,
       0,     0,     0,     0,    26,     0,     0,     0,     0,     0,
      26,     2,     0,     0,     0,     0,     0,    25,     0,    13,
       0,    12,     0,    13,     0,    13,     0,    12,    11,    10,
      11,    11,    10,     0,    13,     2,     0,    12,     0,     0,
       0,     0,    24,     0,     0,     0,    23,     1,     0,     0,
       0,     0,    24,     0,    13,     2,     0,    12,     0,     0,
       0,     0,    24,     0,     0,     0,    23,     0,     0,    18,
       0,     0,     6,     0,     6,     0,     6,     0,     6,     0,
       6,     0,     6,     0,     6,     0,     0,     7,     0,     0,
       8,     0,     5,     0,     5,     0,     1,     0,     0,     4,
       1,     0,     0,     4,    10,     2,     9,    12,    11,     7,
       7,     3,     3,     2,     3,     3,     2,     0,     5,     0,
       5,     0,    13,     0,    13,     0,     9,     9,     3,     3,
       3,     2,     2,     3,     3,     2,     0,     5,     0,     5,
       0,    13,     0,    14,     0,     0,    10,     9,     0,    13,
       0,    13,     7,     4,     3,     0,     7,     0,     7,     0,
       1,     0,     4,     0,     1,     2,     6,     0,     9,     1,
       6,     0,     9,     0,     7,     0,    10,     0,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     6,     4,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     6,     2,     2,     1,     4,     3,     1,     2,
       5,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     5,     2,     2,     0,     3,
       1,     0,     4,     1,     1,     1,     4,     6,     0,     0,
       8,     0,     0,     8,     4,     0,     0,    10,     6,     0,
       0,    10,     8,     0,     0,    12,     0,     1,     1,     1,
       1,     1,     2,     2,     0,     1,     3,     0,     0,     0,
       0,     0,     2,     0,     1,     2,     1,     7,     0,     0,
       9,     6,     6,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     9,     9,     7,     4,     7,     8,     6,     0,
       0,    15,     1,     6,     8,     7,     4,     7,     7,     4,
       2,     0,     4,     2,     0,     1,     2,     1,     1,     4,
       6,     0,    10,     0,     9,     1,     2,     2,     2,     0,
       1,     2,     1,     1,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     8,     4,
       4,     4,     4,     4,     4,     6,     6,     6,     6,     0,
      10,     0,    10,     0,     9,     0,     9,     7,     7,     4,
       4,     2,     1,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     7,     4,     4,
       4,     4,     2,     2,     4,     4,     4,     4,     6,     6,
       6,     6,     0,    10,     0,    10,     0,     9,     0,     9,
       7,     7,     4,     4,     2,     3,     0,     1,     3,     3,
       6,     5,     8,     1,     2,     1,     1,     5,     0,     9,
       0,     9,     0,     0,     9,     0,     8,     0,     8,     0,
       6,     0,     9,     8,     0,    11,     1,     6,     8,     4,
       7,     7,     4,     2,     0,     8,     5,     0,    10,    10,
       7,     8,     0,     0,    12,     0,    11,     8,     9,    10,
       0,    12,     0,    10,     0,    10,     0,    10,     0,    10,
       7,     0,     8,     0,     8,     0,    11,     0,    10,     0,
      11,     0,     9,     7,     0,     9,     0,     7,     5,     0,
      10,     8,     8,     0,    11,     5,     0,     0,     0,     1,
       3,     0,     2,     6,     8,     7,     6,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     4,
       1,     5,     0,     0,     0,     1,     3,     0,     2,     1,
       1,     6,     8,     7,     1,     1,     1,    10,     0,    10,
       9,     1,     1,     7,     8,     1,     0,    11,     1,     0,
       8,     9,     1,     7,     1,     0,     8,     9,     1,     1,
       1,     0,     6,     7,     1,     5,     1,     0,     9,    10,
       1,     8,     0,     4,     1,     5,     0,     0,     0,     0,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     7,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     4,     1,     2,     5,     2,     5,     4,     7,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     1,
       2,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     7,     7,     0,
       1,     1,     1,     2,     2,     2,     2,     1,     2,     2,
       2,     2,     4,     1,     1,     1,     3,     0,     1,     1,
       5,     0,     1,     3,     2,     4,     0,     0,     0,     0,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     5,     0,     5,     4,     6,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     0,     7,     4,     4,     1,     4,     4,
       4,     4,     4,     4,     1,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     1,     3,     4,     4,
       1,     3,     1,     1,     6,     4,     4,     4,     4,     4,
       4,     4,     4,    12,     4,     4,     4,     4,     4,     4,
       1,     1,     8,     4,     8,     4,     8,     4,     4,     4,
       6,     4,     8,     6,     8,     4,     8,     4,     6,     4,
       8,     4,     8,     4,     6,     4,     6,     4,     6,     4,
       6,     4,    10,     4,     6,     6,     4,     6,     4,     6,
       8,    10,     6,     8,    10,     6,     8,    10,     6,     8,
      10,     6,     8,    10,     6,     8,    10,     8,    10,    12,
       8,    10,    12,     8,    10,    12,     8,    10,    12,    10,
      12,    14,    10,    12,    14,     6,     8,    10,     6,     8,
      10,     6,     8,    10,     6,     8,    10,     6,     8,    10,
       6,     8,    10,     6,     8,    10,     6,     8,    10,     6,
       8,    10,     6,     8,    10,     6,     8,    10,     6,     8,
      10,     8,    10,    12,     8,    10,    12,     8,    10,    12,
       8,    10,    12,     8,    10,    12,     8,    10,    12,     8,
      10,    12,     8,    10,    12,    10,    12,    14,    10,    12,
      14,    10,    12,    14,    10,    12,    14,     6,     8,    10,
      12,     6,     8,    10,    12,     1,     1,     6,     8,    10,
      12,     6,     8,    10,    12,     6,     8,    10,     6,     8,
      10,     6,     8,    10,     6,     8,    10,     6,     8,    10,
       6,     8,    10,     4,     6,     4,     6,     4,     6,     4,
       6,     4,     6,     4,     6,     4,     6,     8,     4,     6,
       8,     4,     6,     8,     4,     6,     8,     4,     6,     8,
       4,     6,     8,     4,     6,     8,     4,     6,     8,     4,
       6,     8,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     7,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     0,     1,     5,
       3,     0,     0,     0,     3,     0,     5,     1,     2,     3,
       3,     3,     3,     2,     2,     2,     2,     2,     2,     1,
       3,     0,     0,     1,     3,     1,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     5,     3,     5,     5,     5,     8,
       3,     3,     3,     2,     4,     0,     7,     0,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     5,     3,     3,
       4,     4,     1,     0,     9,     5,     5,     0,     0,     0,
       5,     0,     5,     1,     3,     0,     0,     0,     0,     0,
       2,     0,     0,     8,     1,     2,     1,     1,     1,     2,
       1,     2,     1,     2,     5,     1,     0,     0,     4,     1,
       2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     4,     3,     5,     4,     4,     2,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     5,     4,     5,     4,     4,     4,     4,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     6,     6,     6,     4,     4,     4,     4,
       4,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     4,     4,     4,     4,     4,     4,
       4,     2,     4,     4,     4,     4,     4,     4,     4,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     6,     1,     1,     1,     1,     4,     6,
       2,     4,     6,     2,     4,     6,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     5,     4,     4,     5,     2,     6,     6,     6,
       6,     6,     6,     6,     6,     6,     6,     6,     6,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     6,     1,     1,     1,
       1,     1,     1,     2,     2,     2,     2,     2,     6,     6,
       6,     6,     6,     6,     1,     1,     1,     4,     4,     1,
       1,     1,     1,     1,     4,     4,     1,     1,     1,     1,
       4,     4,     1,     1,     6,     6,     6,     6,     1,     1,
       1,     1,     6,     6,     2,     6,     6,     1,     1,     2,
       6,     1,     1,     6,     6,     1,     1,     1,     2,     6,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     6,     6,
       6,     1,     1,     6,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     6,     2,     6,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     2,
       2,     6,     6,     6,     6,     2,     2,     2,     1,     1,
       1,     1,     8,     8,     6,     8,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     6,     6,     2,     6,
       2,     6,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     4,
       1,     1,     1,     1,     1,     1,     1,     6,     6,     6,
       6,     6,     1,     1,     8,     8,     8,     8,     6,     6,
       1,     1,     1,     1,     1,     6,     6,     7,     7,     6,
       6,     6,     6,     7,     7,     7,     7,     1,     1,     6,
       6,     6,     6,     6,     6,     6,     1,     1,     1,     1,
       1,     1,     1,     1,     6,     2,     8,     6,     1,     1,
       1,     1,     1,     1,     1,     1,     8,     6,     8,     6,
       1,     1,     1,     1,     1,     1,     1,     1,     6,     2,
       8,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       6,     2,     8,     2,     6,     8,     8,     8,     8,     8,
       8,     1,     1,     6,     8,     4,     4,     6,     6,     6,
       6,     6,     6,     2,     2,     1,     1,     1,     1,     2,
       6,     1,     1,     6,     6,     6,     6,     6,     6,     1,
       1,     6,     6,     1,     1,     6,     6,     1,     1,     6,
       6,     1,     1,     6,     6,     1,     1,     6,     6,     6,
       6,     1,     1,     1,     1,     1,     4,     2,     2,     2,
       2,     2,     2,     1,     1,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       6,     6,     6,     6,     6,     6,     6,     6,     6,     6,
       6,     6,     6,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     4,     4,     2,     2,     2,     3,     3,     3,
       1,     1,     1,     1,     4,     5,     4,     5,     5,     4,
       2,     2,     2,     3,     3,     3,     1,     1,     4,     5,
       4,     5,     5,     4,     6,     8,     6,     6,     6,     6,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       3,     5,     6,     6,     6,     6,     6,     1,     1,     6,
       6,     6,     2,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     6,     6,     6,     6,     6,     6,     4,     2,     1,
       1,     1,     1,     1,     6,     6,     6,     6,     6,     6,
       6,     6,     6,     6,     6,     6,     6,     6,     6,     6,
       6,     6,     6,     1,     1,     1,     1,     2,     1,     2,
       6,     6,     6,     6,     6,     6,     6,     8,     8,     6,
       4,     2,     2,     3,     5,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       4,     4,     6,     6,     6,     6,     8,     0,     0,     0,
       0,     5,     7,     0,     8,     0,     8,     0,    10,     0,
       0,    13,     0,     0,    15,     1,     1,     1,     2,     1,
       0,     3,     0,     6,     4,     4,     4,     4,     4,     4,
      15,     0,    18,     0,     0,     0,     0,     9,     0,    12,
       0,     0,    12,     0,    15,     0,     0,     1,     1,    11,
       0,     0,     0,    13,     0,     0,     1,     1,     1,     1,
       1,     1,     0,     8,     0,     8,     0,    11,     0,    10,
       0,    11,     1,     1,     0,     5,     0,     7,     2,     6,
       0,     8,     0,     1,     5,     7,     0,     1,     5,     7,
       0,     0,     0,     7,     7,     8,     8,     0,     0,     9,
       0,     0,    12,    11,     0,    13,     0,    11,     0,     0,
      15,    13,     0,    15,     2,    11,     0,     9,    12,     0,
       0,    10,    11,     9,    12,    10,     0,     0,     0,     1,
       1,     9,     1,     0,     3,     1,     0,     6,     0,     8,
       0,     1,     3,     3,     3,     3,     4,     3,     3,     3,
       3,     3,     3,     3,     1,     2,     3,     3,     5,     5,
       1,     2,     1,     2,     1,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     2,     1,     2,     2,     2,
       3,     3,     2,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     0,     3,     1,     2,     2,
       4,     5,     3,     3,     5,     6,     4,     3,     4,     0,
       1,     3,     4,     4,     1,     1,     1,     3,     1,     5,
       6,     6,     7,     6,     7,     7,     8,     5,     1,     3,
       3,     1,     1,     1,     0,     0,     3,     5,     3,     1,
       0,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     4,     3,     4,     3,     4,     3,     4,     7,     8,
       3,     4,     7,     8,     3,     4,     7,     8,     3,     4,
       3,     4,     0,     0,     2,     2,     3,     2,     1,     6,
       6,     8,     8,     6,     8,     0,     1,     1,     1,     2,
       2,     2,     3,     3,     3,     5,     7,     7,     3,     5,
       5,     7,     1,     2,     1,     2,     2,     3,     4,     5,
       2,     3,     1,     3,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     7,     3,     4,     6,     5,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     3,
       6,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      28,     0,     0,     0,   504,     0,     0,    84,    84,    84,
      84,    84,     0,     0,   177,    84,    49,    49,     0,    18,
       5,     9,     0,     7,     8,    19,    10,    14,    15,    17,
      16,    13,    11,    12,     6,     4,     3,     2,    55,    63,
     597,    29,     0,     0,    30,    31,   506,     0,     0,    70,
       0,     0,     0,     0,     0,     0,   227,   194,   246,     0,
      50,    47,    50,    48,     1,     0,    56,    23,   330,   337,
     331,   332,   333,   334,   335,   336,   345,   344,   603,   603,
      84,   505,     0,     0,  1375,  1377,  1376,  1378,  1379,  1380,
    1392,  1397,    84,    84,  1382,   385,   340,   386,   387,   389,
     390,   391,   388,   317,   341,   319,  1800,  1801,  1802,  1803,
    1804,  1805,  1810,  1807,  1806,  1809,  1808,  1794,   286,   287,
     288,   289,   290,   291,   292,   304,   305,   306,   307,   308,
     309,   293,   294,   295,   296,   297,   310,   312,   311,   313,
     315,   314,   298,   299,   300,   301,   302,   303,  1447,  1448,
    1449,  1450,  1451,  1452,  1453,  1454,  1455,  1456,  1457,  1458,
    1459,  1460,  1461,  1442,    84,  1462,    84,  1463,  1464,  1465,
    1466,  1467,  1468,  1374,    84,    84,    84,  1504,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,  1561,  1560,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,  1787,  1788,  1789,  1790,  1784,    84,  1786,
    1785,    84,  1791,  1792,  1793,  1811,  1813,  1814,  1815,  1798,
    1799,  1795,  1796,  1797,  1812,     0,   396,  1419,     0,     0,
       0,   284,   285,   283,  1381,  1368,  1385,   393,     0,  1383,
    1384,  1373,    84,  1367,  1372,  1390,  1391,  1409,  1497,    84,
    1816,    84,   322,   329,   323,   324,   325,   326,   327,   328,
      24,     0,   338,   339,    25,    71,    84,    84,    84,    84,
      84,    84,   232,    84,   248,     0,   180,   247,    84,    45,
    1847,  1847,     0,    23,   340,   341,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    84,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1072,
      84,   411,    84,     0,   412,   413,    27,    62,   432,   432,
     506,     0,     0,   432,    84,    84,   578,     0,    84,    84,
     432,   582,   583,   502,   499,    84,    84,    84,    84,    84,
      84,    84,    84,   506,   432,    84,    84,   506,    84,    84,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     396,   432,     0,   506,     0,   432,   432,   506,   432,   432,
    1344,  1354,  1355,  1356,  1357,  1358,  1359,  1360,  1361,  1362,
    1363,  1353,  1352,  1350,  1351,  1346,  1366,   316,   318,  1420,
    1393,  1395,  1398,  1400,  1394,  1396,  1399,  1401,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    84,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3252,  3252,  3252,  3252,  3252,
    3252,  3252,  3252,  3252,  3252,  3252,  3252,  3252,  3252,  3252,
    3252,  3252,  3252,  3252,  3252,  3252,  3252,  3252,  3252,  3252,
    3252,  3252,  3252,  3252,     0,     0,     0,    84,    84,     0,
    1418,  1421,  1407,    84,     0,     0,     0,    72,    26,     0,
      84,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      32,     0,     0,    35,    35,    38,    38,    82,     0,     0,
      40,    84,    64,   246,     0,   178,   208,   249,    44,     0,
       0,   432,   432,  1124,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3252,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      66,     0,     0,     0,  1102,  1103,     0,     0,     0,     0,
       0,    84,    59,    84,    58,   606,   605,   603,   603,    84,
     432,    84,    84,     0,   506,   432,   432,     0,   432,   432,
     588,   587,     0,     0,   584,   506,   506,   506,   506,     0,
       0,   506,   506,   506,     0,     0,   432,   432,     0,   432,
     432,   432,   432,     0,   432,   432,   564,   506,   432,   432,
     566,   432,   432,   567,   568,   569,   565,   570,   571,   572,
     573,   574,   575,    84,   506,     0,   432,   432,    84,   500,
     499,   506,   509,   507,    84,   512,   510,   506,   506,     0,
       0,   556,   506,   506,     0,     0,  1851,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,     0,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,  1536,
      84,    84,  1540,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
    3253,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,   287,   288,   289,   290,   291,   292,   304,   306,   307,
     308,   293,   294,   295,   296,   297,   310,   311,   313,   314,
     298,   299,   300,   301,   302,   303,     0,  1371,    74,   392,
       0,   395,   432,  1411,  1408,    84,  1404,  1403,  1405,    76,
    1389,     0,   346,   347,   348,     0,    84,   404,   410,    73,
     396,  1429,  1430,  1428,  1439,  1435,  1437,  1433,  1434,  1438,
    1436,  1422,  1423,  1424,  1425,  1432,  1431,  1427,  1426,    84,
      84,     0,     0,     0,     0,     0,    41,    84,    42,    83,
       0,   246,     0,   197,    65,     0,    46,    83,    52,    51,
    1848,     0,    53,    54,     0,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    67,    84,    84,    84,    84,
     414,    84,    84,    63,    57,     0,   432,   432,     0,   506,
     432,   432,   432,   506,   543,   506,   506,   432,   432,   506,
     506,     0,     0,   527,    84,    84,     0,   579,   506,    84,
     520,   521,   577,     0,    84,   506,   506,    84,   506,   506,
     506,   506,    84,   506,   506,   576,   506,   506,   506,   506,
     506,   518,   432,   506,   506,   506,    84,     0,    84,   511,
     558,   557,   506,   506,     0,     0,   506,   541,   552,    84,
      84,  1348,     0,     0,  1469,  1470,  1471,  1472,  1473,  1474,
    1489,  1486,  1487,  1488,  1475,  1476,  1477,  1478,  1479,  1490,
    1491,  1492,  1493,  1480,  1481,  1482,  1483,  1484,  1485,    84,
    1444,     0,  1446,  1499,  1498,  1501,  1500,  1503,  1502,  1505,
    1507,  1506,  1509,  1508,  1511,  1510,  1517,  1516,  1519,  1518,
    1521,  1520,  1523,  1522,  1525,  1524,  1527,  1526,  1529,  1528,
    1531,  1530,  1533,  1532,  1535,     0,  1534,  1539,     0,  1538,
       0,  1546,  1545,  1548,  1547,  1550,  1549,  1496,  1495,  1552,
    1551,     0,  1555,  1554,  1556,  1557,  1559,  1558,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1743,     0,  1745,     0,  1747,     0,  1749,     0,  1751,
       0,  1753,     0,  1755,     0,  1758,     0,  1761,     0,  1764,
       0,  1767,     0,  1770,     0,  1773,     0,  1776,     0,  1779,
    1563,     0,  1565,     0,  1567,     0,  1569,  1568,  1571,     0,
       0,  1575,     0,  1577,     0,  1579,     0,  1581,     0,  1583,
       0,  1585,     0,  1587,     0,  1589,     0,  1591,     0,  1593,
       0,  1596,     0,     0,  1598,     0,  1513,  1512,  1515,  1514,
    1818,  2674,     0,  2670,    84,  3253,  2711,  2710,  2696,  3295,
    3297,  3296,  3298,  3299,  3300,  3292,  3194,   342,     0,  3208,
     343,     0,     0,  3195,  3196,     0,     0,   433,   433,     0,
      84,  1216,  1316,  1262,    84,  2937,    84,    84,    84,    84,
      84,  2990,    84,  3014,     0,     0,    84,  3023,    84,  3027,
      84,  2939,    84,    84,  3303,  3222,  3223,  3224,  3225,  3226,
    3227,  3228,  3229,    85,    86,    93,   101,    87,    88,    94,
     102,    89,    90,    95,   103,    91,    92,    96,   104,    99,
     106,   100,   107,    98,   105,    97,   108,   137,   138,   139,
     140,   141,   142,   143,   144,     0,     0,     0,     0,  2668,
    2669,  2666,  2667,  2671,    84,    84,  2386,  2387,    84,  2500,
    2501,  2504,  2502,  2505,  2503,  2506,    84,     0,     0,     0,
       0,     0,     0,     0,  2370,  2371,  2372,  2373,  2374,  2375,
    2376,  2377,  2378,  2379,  2384,  2385,  2380,  2381,  2382,  2383,
      84,  2835,    84,  2836,    84,    84,    84,     0,     0,     0,
       0,     0,  2693,  2697,    84,     0,  2712,  2713,  2727,    84,
    2694,  2698,  2845,  2847,  2846,    84,     0,     0,    84,     0,
       0,  2741,  2742,  2743,  2744,  2745,  2746,  2747,  2748,  2749,
    2750,  2751,  2752,  2753,  2754,  2755,  2756,  2757,  2758,  2759,
    2760,  2761,  2765,  2762,  2763,  2764,  2766,  2767,  2768,  2769,
    2770,  2771,  2772,    84,     0,  2342,    84,  2869,  2870,  2871,
    2872,  2873,  2343,  2338,  2337,  2329,  2336,  2339,  2324,     0,
    2793,  2794,  2795,  2773,  2774,  2776,  2775,  2777,  2330,  2331,
    2326,    84,  2840,    84,  2841,  2537,  2538,  2726,  2695,  2699,
       0,  2700,  2675,    84,  2848,  2850,  2849,    84,     0,     0,
       0,     0,    84,     0,     0,    84,     0,     0,    84,  2853,
    2854,     0,     0,     0,     0,  2823,  2824,  2825,  2829,  2830,
    2831,  2832,  2833,  2834,  2826,  2827,  2828,  2799,  2800,  2801,
    2802,  2803,  2804,  2811,  2812,  2813,  2814,  2815,  2816,  2805,
    2806,  2807,  2817,  2818,  2819,  2808,  2809,  2810,  2820,  2821,
    2822,    84,  2851,  2852,     0,  2856,  2858,  2676,  2677,  2837,
    2839,  2838,  2484,  2485,  2486,  2487,  2488,  2489,  2482,  2483,
    2490,  2491,  2492,  2493,  2494,  2496,  2495,  2497,  2855,  2512,
    2857,  2513,  2325,     0,     0,     0,  2842,  2844,  2843,  2678,
       0,     0,  2679,    84,     0,  2332,  2333,     0,     0,     0,
      84,    84,  2787,  2788,     0,  2672,  2673,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,     0,  2106,  2114,
    2132,  2107,  2115,  2133,  2111,  2118,  2110,  2117,  2137,  2136,
    2113,  2120,  2112,  2119,  2139,  2138,  2108,  2109,  2116,  2134,
    2135,    84,    84,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    84,    84,     0,     0,    84,    84,    84,    84,
      84,    84,    84,    84,     0,     0,     0,    84,  2200,  2197,
    2190,  2193,  2192,  2194,  2191,  2196,  2199,  2198,  2201,  2195,
    2205,  2207,  2204,  2206,  2432,  2433,  2434,  2402,  2424,  2425,
    2416,  2417,  2428,  2429,  2430,  2431,  2420,  2421,  2412,  2413,
    2403,  2407,  2406,  2408,  2409,  2426,  2418,  2422,  2414,  2410,
      84,    84,    84,    84,  2460,  2404,  2405,  2399,  2400,  2401,
    2395,  2396,  2397,  2394,  2398,  2411,  2439,  2440,  2441,    84,
    2442,  2443,  2444,    84,  2415,  2419,  2423,  2427,  2468,  2471,
    2473,  2466,  2469,  2472,  2467,  2470,    84,    84,     0,  2273,
    2284,  2251,  2264,  2292,  2291,  2274,  2252,  2275,  2253,  2651,
      84,    84,    84,  2546,  2550,  2548,  2547,  2549,  2551,  2552,
    2553,  2558,  2562,  2560,  2559,  2561,  2563,  2564,  2565,  2570,
    2574,  2572,  2571,  2573,  2575,  2576,  2577,  2582,  2586,  2584,
    2583,  2585,  2587,  2588,  2589,  2618,  2617,  2367,  2293,  2294,
    2621,  2295,  2629,  2630,  2296,    84,  2633,  2637,  2645,  2646,
      84,    84,  2641,  2622,  2297,  2298,  2634,  2638,  2642,  2276,
    2254,  2265,  2285,    84,    84,  2300,  2299,  2302,  2301,    84,
    2663,     0,    84,    84,  2277,  2255,  2286,  2266,     0,  2278,
    2256,  2287,  2267,     0,  2309,  2307,    84,  2311,  2312,    84,
    2350,  2362,  2349,  2361,  2348,  2351,  2392,  2391,    84,    84,
      84,    84,    84,    84,  2303,  2304,    84,  2310,  2308,  2279,
    2257,  2268,  2288,     0,  2280,  2258,     0,  2652,  2653,  2654,
    2655,  2459,  2461,  2475,  2474,  2259,  2269,  2260,  2270,     0,
    2602,  2601,  2281,  2261,  2289,  2271,  2664,  2262,  2282,  2290,
    2272,  2616,  2615,  2366,  2358,  2365,  2357,  2283,  2263,    70,
    3253,  1419,  3253,  3253,  3253,  3253,  3253,   127,   128,   129,
       0,  3253,  3198,     0,  3301,  3302,  3253,  1875,  1940,  1941,
    1942,  1958,  1943,  1944,  1945,  1946,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,     0,  2796,    84,    84,  2996,  2997,  2998,
    1958,  3253,     0,  3253,  3253,  3258,     0,  3268,  3253,  1821,
    1824,  1825,  1826,  1828,  1830,  1819,  1820,  1832,  1834,  1835,
    1837,  1817,  1822,  1823,  1827,  1831,  1833,  1838,  1844,  1829,
    1839,  1840,  1841,  1842,  1843,  1845,  1846,  1782,  1783,    84,
      75,   397,   397,   398,  1416,    84,  1412,    78,     0,  1402,
       0,  1386,    77,    84,     0,   409,    84,  1440,    22,     0,
       0,    33,    34,    36,    37,     0,    39,     0,   234,     0,
     208,  1004,  1019,   943,     0,   246,   352,   352,  1104,  1105,
    1088,  1087,  1086,  1085,  1090,  1089,  1095,  1091,  1092,  1093,
    1094,  1077,     0,  1073,  1074,  1075,  1076,  1081,  1082,  1083,
    1084,  1096,  1080,  1078,  1079,  1099,  1098,     0,    84,  1106,
    1101,  1100,     0,    84,  1107,   415,  1123,  1122,    60,     0,
     608,    84,     0,   612,   603,   603,     0,   528,   506,   506,
     506,   545,   553,   533,   506,   506,   547,   555,   432,   589,
     432,    84,    84,   506,   581,   519,   503,   550,   554,   551,
     522,   532,   523,   534,   525,   536,   539,   540,   546,   548,
     537,   538,   516,   506,   544,   529,   542,   432,     0,   508,
     562,   561,   432,   432,   563,  1345,  1347,     0,    84,  1715,
    1716,    84,    84,    84,     0,  1443,    84,  1537,  1541,     0,
     396,   113,   115,   121,    84,     0,  1542,  1543,  1880,  1884,
     432,    84,    84,    84,    84,    84,    84,    84,     0,     0,
       0,     0,     0,     0,    84,    84,    84,    84,    84,    84,
       0,     0,     0,    84,    84,    84,    84,    84,    84,    84,
      84,    84,     0,     0,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,     0,    84,    84,
      84,    84,    84,    84,    84,    84,    84,  3294,     0,  3292,
    3253,  3309,  3253,     0,  3253,  3254,  3255,  3257,  1871,  1937,
    1938,  1917,  1939,    84,   433,   433,   434,   433,   433,   434,
     433,   433,     0,     0,  1217,     0,  1317,     0,  1263,    84,
       0,    84,    84,  3020,     0,  2980,  2991,     0,  2994,  3012,
    3013,     0,     0,     0,  3214,  3018,  3020,  3020,  3020,  1853,
       0,     0,     0,  2020,  2021,  2022,  2023,  2024,     0,     0,
       0,  2009,  2001,  2002,  1999,  2006,  2010,  2007,  2008,  2003,
    2004,  2000,  2005,     0,     0,  2013,  2011,  2012,  2025,  2026,
    2027,  2028,  2029,  2030,  2031,     0,    70,     0,  2797,     0,
       0,     0,  2032,  2033,  2034,  2035,  2036,     0,  2037,     0,
       0,  2038,  2039,     0,  2040,  2041,  2927,  2919,  2920,  2917,
    2924,  2928,  2925,  2926,  2921,  2922,  2918,  2923,     0,     0,
    2912,  2911,  2042,     0,  2043,     0,     0,  2798,  2044,     0,
       0,  2046,  2045,  2047,  2048,     0,  2049,  2050,     0,  2051,
    2052,     0,  2059,  2060,  2053,  2061,     0,  2868,  2062,  2063,
    2064,  2065,  2054,  2055,     0,  2056,  2066,  2057,  2058,     0,
       0,  2067,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2181,  2149,     0,  2213,     0,  2210,  2173,  2140,
    2146,  2147,  2148,  2141,  2142,  2143,  2144,  2145,  2150,  2151,
    2152,  2153,  2154,  2155,  2156,  2157,  2158,  2159,  2160,  2161,
    2162,  2163,  2164,  2165,  2166,  2167,     0,     0,     0,  2168,
    2169,     0,     0,     0,     0,     0,     0,     0,     0,  2170,
    2171,  2172,     0,     0,     0,     0,     0,     0,  2449,  2456,
    2450,  2457,     0,     0,  2250,  2249,  2236,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2455,  2658,     0,  2614,
       0,  2613,  2659,  2661,     0,     0,  2316,     0,  2317,     0,
       0,     0,     0,  2662,  2657,  2660,     0,    70,   123,     0,
       0,     0,  1418,  3310,    84,  3236,  3240,  3244,     0,  3250,
    1913,    70,  3253,  3253,  3253,  3253,  3253,  3253,  3253,  3253,
       0,     0,  1957,     0,  2121,     0,  2122,     0,     0,     0,
       0,  2305,     0,  2313,  2314,  2315,     0,     0,     0,     0,
       0,  2354,     0,  2359,     0,     0,  2368,     0,     0,     0,
    2435,  2437,     0,  2447,  2448,     0,  2445,  2446,     0,     0,
    2478,  2480,     0,     0,     0,     0,     0,  2555,     0,  2579,
    2581,  2591,  2593,     0,     0,  2619,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2778,     0,  2792,     0,     0,     0,  1957,  3215,     0,  3248,
    3252,    84,  3252,  3232,  3234,  3253,  3269,  3270,  3271,  3253,
    3253,  3253,  3253,  3253,  3253,  3253,  3253,  3253,  3253,  3253,
    3253,  3253,  3253,  3253,  3253,  3253,  3230,     0,  1441,     0,
     400,     0,  1414,     0,  1410,  1406,    79,     0,     0,   405,
     394,    84,    84,    84,     0,   208,    84,     0,   213,   432,
     211,   432,   217,   432,   258,   257,   184,  1850,     0,  1850,
       0,    84,    84,  1116,    84,   402,    84,    84,  1118,    84,
      62,   610,    84,     0,   607,   613,    84,    84,     0,   524,
     526,   531,   535,   549,     0,   590,    84,    84,   432,   432,
     580,   530,   513,   501,    84,    84,    84,     0,  1707,     0,
    1717,     0,  1711,     0,  1721,    84,  1445,     0,     0,  1544,
    1881,  1885,   432,  3159,  3158,   432,  3252,     0,  1599,     0,
    1602,     0,  1605,     0,  1608,     0,  1611,     0,  1614,     0,
       0,     0,     0,     0,     0,     0,  1635,     0,  1641,     0,
    1647,     0,  1653,     0,  1659,     0,  1665,     0,     0,     0,
       0,     0,     0,     0,  1638,     0,  1644,     0,  1650,     0,
    1656,     0,  1662,     0,  1668,     0,     0,     0,     0,     0,
       0,     0,  1725,     0,  1728,     0,  1731,     0,  1734,     0,
    1737,     0,  1740,  1744,  1746,  1748,  1750,  1752,  1754,     0,
    1756,     0,  1759,     0,  1762,     0,  1765,     0,  1768,     0,
    1771,     0,  1774,     0,  1777,     0,  1780,     0,     0,     0,
    1570,     0,  1573,     0,     0,  1578,     0,     0,  1584,  1586,
    1588,  1590,     0,  1594,  1595,  1597,  2937,  2898,     0,  1900,
       0,    84,    84,  3253,     0,  3253,     0,     0,  3253,  3256,
    1959,   432,  3016,   434,   434,   941,   434,   434,   941,   434,
     434,    84,  1910,   432,  1912,   432,  1911,   432,    80,  1853,
       0,  3166,  3170,  3168,  3169,  3173,  3171,  3172,     0,    84,
    1882,  3167,   432,  3145,  3142,  3138,  3037,  3120,  3121,  3124,
    3125,  3122,  3123,  3126,  3127,  3128,  3129,  3130,  3131,  3132,
    3133,  3134,  3135,  3144,  3140,  3141,  3143,  3136,  3137,  3139,
    3146,  3147,  3149,  3148,    70,    84,    84,  3150,     0,    84,
    3104,  3100,  3102,     0,  3152,  3154,  3037,    84,  3046,    84,
       0,    84,  2985,    84,  2992,    84,  1853,  1917,     0,  3002,
       0,  3022,    84,  3026,    84,  3030,    84,  1872,     0,   109,
     117,   130,   131,   132,    84,     0,    84,    84,    84,    84,
      84,  2019,    84,     0,    84,     0,     0,    84,     0,     0,
     396,    84,     0,  1888,  1889,    84,    84,  2015,     0,  1989,
    1993,  1991,  1995,  1997,    84,     0,  1886,  1887,    84,    84,
      84,     0,    84,    84,    84,    84,     0,    84,    84,     0,
      84,    84,     0,    84,     0,    84,    84,     0,    84,    84,
      84,    84,  2913,     0,    84,     0,    84,     0,  1902,  2520,
    2522,  2524,  2521,  2523,     0,    84,    84,     0,    84,    84,
      84,   146,   148,   145,   149,   150,   147,   153,   154,   155,
     156,   159,   160,   161,   162,   163,   164,  1876,    84,   151,
      84,   157,    84,   165,    84,     0,    84,    84,    84,   169,
     170,   171,   172,   173,   174,   175,   176,    84,   167,     0,
    1894,  1895,    84,  2893,  2894,  2895,     0,  2896,    84,    84,
      84,     0,    84,    84,    84,    84,    84,     0,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,  2090,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,     0,    84,    84,    84,  2088,  2089,     0,
      84,    84,     0,    84,    84,    84,    84,    84,    84,    84,
      84,     0,    84,    84,  2088,    84,  2088,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
       0,    84,    84,     0,    84,    84,    84,    84,    84,   135,
      84,     0,  2458,    84,    84,  1896,  1897,    84,    84,    84,
      84,     0,  1892,  1893,    84,    84,    84,     0,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,     0,    84,     0,    84,    84,    84,    84,    84,    84,
      84,    84,    84,  3253,     0,     0,  3253,  3253,  3278,     0,
     124,  3305,  3253,     0,  3253,  3293,  3210,  3211,  3212,  3197,
    3213,  3209,     0,  3237,  3241,  3245,  3251,  3249,  3233,  3235,
    3231,   386,   342,   389,  3190,  3177,    84,  3189,    84,  1871,
    1949,     0,    84,    84,     0,    84,    84,     0,    84,     0,
      84,    84,    84,    84,  2088,    84,    84,     0,   133,   134,
      84,     0,  1890,  1891,    84,    84,     0,    84,    84,    84,
      84,     0,    84,    84,    84,    84,    84,  1898,  1899,    84,
      84,    84,    84,    84,    84,    84,    84,    84,     0,    84,
      84,     0,    84,     0,    84,     0,    84,     0,    84,  2859,
       0,    84,    84,    84,    84,    84,    84,    84,    84,    84,
       0,    84,    84,    84,    84,     0,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,  2780,
       0,    84,    84,    84,    84,    84,    84,  1948,     0,  3221,
    1952,  1957,  1957,  3329,     0,  3331,     0,     0,  3272,  3273,
    3318,  3317,  3327,  3323,  3325,  3321,  3322,  3326,  3324,  3311,
    3312,  3313,  3314,  3320,  3319,  3316,  3315,    84,   401,  1417,
    1413,     0,    84,   416,   417,    84,    20,    21,    43,   228,
       0,   195,   432,  1001,  1004,  1019,   943,  1216,  1316,  1262,
       0,   246,   246,     0,   181,  1005,     0,     0,   182,  1020,
       0,     0,   183,   944,     0,    84,    84,  1851,   351,    84,
    1109,  1108,     0,    84,     0,     0,  1111,  1110,     0,    84,
      61,   609,   611,   600,   604,   498,   517,   592,   591,   586,
     585,   514,   515,   506,   506,  1349,    84,    84,    84,    84,
    1494,  3189,  3158,   432,  3161,  3160,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,     0,     0,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,     0,  2899,  1901,
       0,     0,  3328,     0,     0,  3288,     0,  1965,     0,  1926,
    1925,  1924,  1919,  1928,  1923,     0,  1918,  1920,  1921,  1853,
     941,   941,     0,   941,   941,     0,   941,   941,  1914,     0,
    1219,  1221,  1319,     0,  1265,  1267,  1872,    81,  1883,   432,
      68,  2938,     0,  3163,  3162,   432,  1853,    84,     0,  3106,
    3101,  3103,    84,     0,  3151,  3105,  3153,  3155,    84,    84,
       0,  3094,  3116,  3118,  3114,  3115,  3119,  3117,     0,     0,
       0,     0,     0,     0,  1853,     0,  1853,    84,   246,  1853,
      84,  2994,  2976,  1872,   432,     0,  2994,  1957,  1957,  1853,
      84,  1853,    84,  1853,    84,  2940,  2940,    84,  2940,  2940,
    1871,     0,  2965,     0,   110,   118,   124,  2966,  2964,  2968,
    2969,  2967,  2740,     0,     0,     0,   118,     0,     0,     0,
     110,     0,     0,  2929,     0,  2930,  2931,  1369,    84,     0,
    2018,  1990,  1994,  1992,  1996,  1998,     0,  2017,  2014,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2606,  2605,
       0,     0,     0,     0,  2910,  2341,    84,  2916,  2915,    84,
       0,     0,  1903,  2520,  2521,    84,    84,     0,     0,     0,
       0,     0,     0,     0,  1877,   152,   158,   166,     0,     0,
       0,     0,   168,     0,  2893,  2894,  2895,  2897,     0,  2068,
    2069,  2070,  2082,  2080,  2079,  2084,    84,    84,  2085,  2087,
    2086,  2075,  2076,  2078,  2077,  2071,  2072,  2074,  2073,  2867,
       0,     0,     0,     0,     0,  2091,  2099,  2100,  2101,  2102,
    2103,  2104,  2105,     0,  2175,  2176,  2174,  2185,  2188,  2178,
    2177,  2180,  2179,  2183,  2184,  2186,  2187,  2182,  2214,     0,
    2211,     0,  2224,  2225,  2226,  2227,  2228,  2229,  2216,  2217,
    2218,  2219,  2220,  2221,  2231,    84,  2230,  2234,    84,  2233,
    2189,     0,     0,     0,     0,   136,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2223,  2222,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    70,    84,
      84,    84,     0,     0,     0,    84,    84,    84,     0,    84,
    1958,     0,   432,     0,     0,     0,  3290,  3306,  1411,  3253,
    3189,     0,  3191,     0,  3175,     0,  3179,    84,    84,  1961,
    1951,  2128,  2129,  2126,     0,     0,  2127,     0,  2130,  2131,
       0,  2202,  2208,     0,     0,     0,     0,  2328,     0,  2327,
    2335,     0,  2334,  2340,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2498,     0,  2499,     0,     0,     0,
       0,  2860,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2656,  2665,     0,     0,     0,  2701,
    2702,  2703,     0,  2714,    84,  2716,    84,  2719,    84,     0,
    2728,    84,  2730,    84,  2733,    84,    84,  2779,     0,     0,
       0,     0,     0,  1950,  3216,     0,  1917,     0,     0,    84,
       0,  3274,  3287,  1836,  1415,     0,  1387,   419,  1388,    84,
     432,  1001,  1004,  1019,   943,  1126,  1216,  1316,  1262,   246,
     246,   614,   225,   209,   213,   211,   217,   219,   221,   223,
     258,   263,   264,   265,   266,   267,   268,   269,    84,   257,
     207,   206,   214,     0,    23,  1007,  1015,    84,  1006,  1008,
     212,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    84,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,   338,   344,    84,   412,
     413,  1021,  1023,   218,     0,   946,    84,    84,   945,   250,
     250,  1849,  1097,     0,  1120,     0,   403,    83,     0,  1121,
       0,     0,     0,   560,   559,     0,  1708,     0,  1718,     0,
    1712,     0,  1722,  3193,  3160,  3252,     0,  1600,     0,  1603,
       0,  1606,     0,  1609,     0,  1612,     0,  1615,     0,  1617,
       0,  1620,     0,  1623,     0,  1626,     0,     0,     0,  1636,
       0,  1642,     0,  1648,     0,  1654,     0,  1660,     0,  1666,
       0,  1671,     0,  1677,     0,  1683,     0,  1689,     0,     0,
       0,  1639,     0,  1645,     0,  1651,     0,  1657,     0,  1663,
       0,  1669,     0,  1674,     0,  1680,     0,  1686,     0,  1692,
       0,     0,     0,  1726,     0,  1729,     0,  1732,     0,  1735,
       0,  1738,     0,  1741,  1757,  1760,  1763,  1766,  1769,  1772,
    1775,  1778,  1781,  1562,  1564,  1566,  1572,  1574,  1576,  1580,
    1582,     0,     0,    84,    84,  3308,     0,     0,  3289,  1963,
      84,  1967,  1927,     0,  1929,  1915,     0,  1872,   815,   937,
     432,   815,   939,   432,   815,   815,    84,     0,     0,    84,
       0,    84,  3162,   432,     0,    69,  3165,  3164,  1872,    84,
    3108,  3085,  3107,  3084,  3083,  3032,  3095,  3156,     0,  3096,
    3097,     0,  3087,  3090,  3091,  3092,     0,     0,  3088,  3109,
    3113,  3093,  3089,  3111,  3110,  3112,  1872,  3031,  1872,   432,
    3075,  3076,  1872,   432,  1853,    84,  3015,     0,    84,   432,
    1917,     0,     0,  1872,     0,  1872,  3024,  1872,  3028,  2943,
    1853,     0,  2945,  2941,     0,     0,     0,     0,     0,     0,
    1869,  1854,     0,     0,     0,     0,    84,    84,    84,     0,
       0,  1382,   316,   340,   318,   317,   341,   319,     0,    84,
      84,     0,     0,     0,     0,  2016,  1370,     0,    84,    84,
      84,     0,    84,     0,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,     0,  2914,     0,
       0,    84,     0,    84,    84,    84,    84,     0,     0,    84,
      84,    84,    84,    84,    84,    84,     0,    84,    84,    84,
      84,    84,    84,    84,    84,     0,    84,    84,  1878,    84,
       0,    84,    84,    84,    84,    84,    84,    84,    84,  2083,
    2081,    84,    84,    84,    84,    84,    84,    84,    84,    84,
       0,    84,    84,  2232,  2235,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,     0,  3253,  3253,  3253,  3265,  3265,  3265,   114,
     116,   122,  3214,  3207,  3199,    84,    84,    84,     0,  3282,
     432,  3279,  3280,     0,  3291,     0,    84,    84,    84,  3192,
      84,  3189,  3174,    84,     0,  3178,  3183,     0,  3182,    84,
    1965,    84,     0,    84,     0,    84,    84,    84,     0,     0,
       0,    84,    84,    84,    84,     0,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,     0,     0,
       0,    84,     0,    84,    84,     0,    84,     0,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,  2704,  2705,
    2706,     0,  2715,  2717,  2718,  2720,  2721,  2722,     0,  2729,
    2731,  2732,  2781,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,  3219,     0,   432,  1955,  1956,  3252,     0,
      84,     0,   229,   225,   209,   213,   215,   217,   211,   432,
     219,   221,   223,   245,   244,   433,   433,     0,     0,     0,
      84,     0,   616,   205,    84,   615,     0,   198,    84,   199,
     200,   201,     0,   202,     0,   203,     0,   204,    84,   261,
      84,  1017,  1016,     0,     0,  1071,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   432,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1000,     0,   433,   251,   246,
     250,   246,   250,    84,     0,    84,     0,   594,     0,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,  2900,  2901,  3307,
    3253,  3253,  3275,  1960,  1968,     0,  1922,     0,   651,   208,
     831,   830,   708,   675,   208,   728,    84,   663,  1220,     0,
     316,   318,   317,   319,    84,    84,  1227,  1258,    84,    84,
    1260,  1228,  1229,  1230,  1231,  1233,  1232,  1235,  1234,  1237,
    1236,  1238,  1239,  1242,  1243,  1246,  1247,  1245,  1250,  1251,
    1254,  1255,  1240,  1241,  1244,  1248,  1249,  1252,  1253,  1256,
    1257,  1215,  1222,  1321,    84,    84,  1339,  1322,  1323,  1324,
    1325,  1327,  1326,  1328,  1329,  1330,  1331,  1333,  1334,  1335,
    1336,  1337,  1338,  1315,  1320,  1266,    84,  1269,  1312,    84,
      84,  1314,  1270,  1274,  1276,  1275,  1282,  1281,  1285,  1288,
    1292,  1294,  1298,  1299,  1300,  1304,  1306,  1310,  1261,  1268,
       0,  3164,  1853,    84,  3086,  3038,  3157,     0,     0,    84,
    3038,    84,  3070,  3069,  3040,     0,    84,  2988,  2987,  2981,
    1872,    84,  3004,   122,  1853,   432,  3006,  3010,    84,  3019,
      84,    84,  1853,  1872,    84,  1853,  1863,  1864,  1865,  1866,
    1867,  1868,    23,   318,  3208,   343,   333,   319,   321,   320,
    1855,    84,     0,    84,    84,    84,     0,  2737,  2738,  2739,
       0,  2734,  2736,     0,     0,     0,     0,  2686,  2687,  2690,
       0,  2688,     0,  2691,  2689,  2692,     0,     0,  2932,  2934,
    2933,  2935,  2909,  2904,  2905,     0,  2906,     0,    84,    84,
    2531,    84,    84,  2518,  2529,  2525,  2532,    84,    84,  2519,
    2530,  2526,  2875,  2881,  2885,  2887,  2889,  2880,  2882,  2884,
    2886,  2890,  2891,  2883,  2892,  2888,  2876,  1879,  2877,  2878,
    2879,  2318,  2320,  2319,  2902,  2903,  2782,  2783,  2784,  2785,
    2786,  2542,  2543,  2545,  2544,     0,  2215,  2212,     0,     0,
       0,     0,  2609,  2610,     0,     0,  1906,  1907,  2241,  2243,
    2242,  2238,  2244,  2240,  2237,  2239,  1904,  2247,  2248,  2245,
    2246,     0,     0,  2590,     0,  2578,     0,  2554,  2625,  2627,
    2626,  2628,  2649,  2650,  1908,  2355,  2356,  2608,  2594,  2612,
    2611,  2607,  2321,  2323,  2322,  3253,  3238,  3246,  3242,  3253,
       0,  3259,  3266,  3267,     0,  3260,     0,  3263,  3200,    84,
      84,  3201,  3203,    84,   125,  3283,  3253,  3253,  3284,     0,
      84,  3252,  3253,  3253,  3253,  3189,  3187,  3180,    84,    84,
    3176,  3186,    84,  2124,  2123,  2125,  2203,  2209,  2306,     0,
       0,  2344,  2345,  2346,  2347,     0,  2353,  2352,  2360,  2364,
    2363,  2369,  2388,  2389,  2390,  2393,  2436,  2438,  2452,  2454,
    2451,  2453,     0,  2464,  2479,  2481,  2476,  2477,     0,  2509,
       0,  2510,  2511,     0,  2507,  2508,     0,     0,  2539,  2540,
    2541,  2557,  2567,  2569,     0,  2603,  2620,  2623,  2624,  2631,
    2632,  2635,  2636,  2639,  2640,  2643,  2644,  2647,  2648,  2680,
    2681,  2682,  2683,  2684,  2685,  2707,  2708,  2709,  2723,  2724,
    2725,  2789,  2791,  2790,  2861,  2862,  2865,  2863,  2864,  2866,
    2874,  3218,     0,  3330,    84,   420,  1853,   243,   235,   236,
       0,   237,   238,   239,     0,     0,  1127,   432,   240,   241,
     242,   434,   434,     0,     0,     0,   433,     0,   226,    66,
       0,   433,   433,   210,   432,   220,   222,   224,   250,   259,
     246,   250,    84,    84,     0,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,  3252,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,   445,   460,
      84,   384,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   376,   375,   377,   378,   379,   380,   381,   382,
     383,   353,    84,   354,   432,    84,   433,   444,   948,     0,
      84,    84,   434,   460,   432,    84,     0,   432,   246,     0,
     246,  1117,    84,  1119,    84,   593,   432,   497,     0,  1709,
       0,  1719,     0,  1713,     0,  1723,     0,  1601,  1604,  1607,
    1610,  1613,  1616,     0,  1618,     0,  1621,     0,  1624,     0,
    1627,     0,  1629,     0,  1632,  1637,  1643,  1649,  1655,  1661,
    1667,     0,  1672,     0,  1678,     0,  1684,     0,  1690,     0,
    1695,     0,  1701,  1640,  1646,  1652,  1658,  1664,  1670,     0,
    1675,     0,  1681,     0,  1687,     0,  1693,     0,  1698,     0,
    1704,  1727,  1730,  1733,  1736,  1739,  1742,  1592,     0,     0,
       0,  1964,  1916,  1930,  1931,  1932,  1933,  1934,  1935,  1936,
    3017,   432,   898,    84,   934,    84,   432,    84,    84,   432,
     432,  1163,     0,     0,     0,     0,     0,   433,     0,   433,
       0,     0,     0,     0,    84,  1872,     0,  3034,  3098,  3099,
       0,  3033,   432,  1853,    84,   432,   432,  1853,  2995,  2973,
       0,  1872,     0,  2994,  2994,     0,  3025,  3029,  1872,    84,
    2947,  2942,  2940,  1872,  1860,  1862,     0,  1857,     0,  1859,
    1861,  1870,   111,   119,    84,    84,    84,    84,    84,    84,
       0,    84,    84,    84,    84,  2536,  2535,  2534,  2528,  2533,
    2527,    84,    84,    84,    84,    84,    84,    84,    84,  1905,
      84,    84,    84,    70,  3265,  3265,  3265,  3202,  3204,    84,
    3205,  3285,  3286,  3281,   126,  3304,  3239,  3247,  3243,  3188,
    3184,  3181,    84,  1962,    84,     0,    84,    84,    84,    84,
      84,  3221,  1953,     0,  1872,   216,    84,    84,  1133,     0,
     941,   941,  1917,   433,   681,   434,   433,   633,  1917,   638,
      84,   434,   434,   432,   489,  1002,   490,   246,   250,   246,
     432,     0,   246,   250,  1009,     0,     0,    84,  1039,  1038,
    1037,  1036,  1041,  1040,  1046,  1042,  1043,  1044,  1045,  1028,
      84,  1024,  1025,  1026,  1027,  1029,  1033,  1034,  1035,  1047,
    1032,  1030,  1031,  1052,  1051,     0,    84,  1054,  1050,  1049,
       0,    84,  1053,  1070,  1069,     0,     0,   431,     0,   996,
       0,     0,   446,   432,   448,     0,   999,   434,    84,     0,
       0,     0,   985,   435,     0,   432,   252,     0,   189,   190,
       0,     0,     0,  1113,  1115,   601,   603,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
    3276,  3277,  1987,     0,  2937,  1978,  1977,  1976,  1980,  1982,
    1974,  1970,  1986,   652,   432,   432,   928,   929,   432,   930,
     931,   432,    84,     0,   927,   432,   676,   432,   432,   856,
     737,   664,    84,    84,    84,    84,  1340,  1343,     0,  1172,
     460,    84,    84,     0,    84,   432,    84,   433,    84,   495,
       0,  1206,   434,   432,  1172,     0,    84,   433,   495,     0,
    1206,    84,    84,  1172,    84,     0,    84,   433,    84,   495,
       0,  1301,  1909,  2936,  3035,  3036,  3048,  1872,     0,  3078,
    3073,  3072,     0,  3066,  1872,    84,     0,  3005,  2999,  3000,
    3001,  3003,  3008,   432,   432,  3021,  2944,     0,  1853,  2949,
    2946,    84,  1858,   112,   120,   126,   120,  2735,   112,     0,
    2566,  2568,  2907,  2908,  2599,  2600,  2595,  2596,  2597,  2598,
    2462,  2463,  2592,  2580,  2556,     0,  3261,  3262,  3264,  3206,
    3185,  2465,     0,  2514,  2516,  2515,  2517,  2604,  3217,     0,
      84,     0,  1128,     0,  1129,    84,  1135,    84,    84,  1134,
    1156,  1136,     0,     0,     0,   434,   941,   434,     0,   433,
       0,   941,   941,     0,   492,    84,     0,   246,     0,   270,
     271,     0,     0,   246,    84,    84,  1013,    84,     0,    84,
      84,  1065,    84,    84,    84,  1063,    84,    84,   432,     0,
      84,     0,   465,    84,   462,    84,   461,   426,   423,    84,
       0,    84,    84,    84,    84,   441,   460,     0,    84,   981,
     949,     0,   980,   953,   954,   955,   956,   957,   958,   959,
     960,   961,   962,   963,   964,   965,   966,   967,   968,   969,
     970,   972,   971,   973,   974,   975,   976,   977,   978,   979,
      84,    84,    84,    84,   436,    84,   460,    84,  1004,  1019,
     943,     0,    84,     0,   599,     0,   595,  1710,  1720,  1714,
    1724,  1553,  1619,  1622,  1625,  1628,     0,  1630,     0,  1633,
    1673,  1679,  1685,  1691,     0,  1696,     0,  1702,  1676,  1682,
    1688,  1694,     0,  1699,     0,  1705,  1871,  1979,  1981,  1983,
    1975,  1971,     0,    84,   901,   900,   899,   628,     0,   935,
     932,   933,   832,    84,   709,    84,   643,   729,    84,    84,
      84,    84,    84,    84,    84,    84,     0,    84,    84,    84,
      84,    84,    84,    84,   873,   874,   246,    84,    84,    84,
      84,  1259,  1341,  1159,   432,     0,     0,   431,     0,     0,
       0,   432,   432,     0,  1162,   434,     0,    84,     0,     0,
      84,    84,   435,   432,   432,     0,     0,   434,    84,     0,
       0,    84,  1313,   432,     0,     0,     0,   432,   434,     0,
      84,     0,    84,    84,  1853,  3041,  3039,     0,  3081,  3080,
      84,  1853,  3071,  2986,  2977,  2978,    84,    84,     0,  1853,
    1853,    84,  1872,  1853,  1856,  1954,   418,    84,    84,     0,
       0,     0,   433,   718,   432,     0,   432,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   432,   941,   815,   941,
     432,   434,    84,   937,   939,    84,   491,     0,     0,     0,
     432,  1004,  1019,   943,   282,  1216,  1316,  1262,   211,   246,
      84,     0,     0,  1164,  1010,     0,  1011,     0,  1058,  1057,
       0,    84,  1056,  1055,     0,    84,   993,   457,   488,     0,
     463,   464,     0,     0,     0,   427,   424,    84,     0,    84,
     447,     0,   450,     0,     0,     0,    84,    84,   208,   431,
      84,   951,   952,    84,    84,   814,   988,     0,   187,   213,
     215,   217,    84,   185,    84,   603,     0,    84,    84,    84,
      84,    84,    84,  1873,  1872,  1969,  1853,   432,   934,   688,
      84,   246,    84,     0,   703,   829,   432,   694,    84,   246,
     723,   829,     0,   859,   860,   861,   862,   863,   864,     0,
     850,   851,   852,   853,   854,   855,    84,   866,   865,   868,
     867,   869,   871,   870,     0,   432,  1166,   432,   432,     0,
      84,    84,    84,    84,     0,    84,    84,  1193,    84,  1208,
     460,    84,   494,    84,   496,     0,  1201,  1204,  1191,     0,
      84,   432,   437,   460,    84,     0,    84,    84,    84,   494,
     496,     0,  1201,  1204,    84,   432,    84,    84,     0,    84,
      84,  1305,   494,    84,   496,     0,  1289,  1295,    84,   432,
    1872,  1853,  1871,    84,     0,     0,     0,    84,     0,  1872,
    1853,  1853,  1853,    84,  2974,  3009,  1872,  1872,  2952,  2948,
    1872,   421,   230,  1131,    84,    84,   433,  1142,     0,  1149,
     434,   432,   705,     0,   708,   725,   728,    84,   815,   682,
     815,    84,   941,    84,   208,   208,   493,    84,     0,    84,
     225,   213,   215,   217,  1126,   219,   221,   223,   275,   280,
     262,    84,     0,    84,     0,     0,    84,     0,  1068,     0,
       0,  1067,     0,   460,    84,     0,   432,   460,    84,    84,
     433,     0,    84,   476,   460,   432,   431,   431,   997,   430,
     429,   995,    84,    84,    84,    84,   453,   449,   998,    84,
      84,   984,   947,   986,     0,    84,   191,   192,   193,   188,
     186,   432,   598,     0,  1631,  1634,  1697,  1703,  1700,  1706,
    1988,  1871,  1966,  1872,   653,    84,     0,   432,   698,     0,
     936,   847,   839,   432,   432,   432,   208,   677,   432,   701,
       0,   432,   208,    84,    84,   858,     0,   665,  1226,  1223,
    1342,     0,   432,  1157,    84,    84,    84,     0,   432,     0,
     432,    84,    84,     0,    84,   208,    84,   431,  1167,     0,
      84,     0,    84,    84,     0,  1209,   432,     0,     0,    84,
     432,    84,   208,   431,  1167,  1209,  1271,   432,    84,    84,
     432,    84,   208,    84,   431,    84,    84,    84,  1307,  1302,
    3049,  3047,     0,  1872,  3054,  3068,  3043,  1853,  3082,  1853,
    3080,  1872,  1872,  1872,  2989,   432,  3007,  3011,  1853,   432,
       0,  1853,     0,  1130,    84,   434,    84,     0,     0,    84,
     435,   432,   717,   708,    84,    84,   627,   657,   432,   669,
     626,   937,   632,    84,    84,   255,    84,   260,   279,   272,
     273,   274,   281,   276,   277,   278,   253,    84,  1165,    84,
       0,  1048,    84,     0,    84,     0,     0,    84,   484,   460,
       0,   431,     0,   487,   434,     0,     0,     0,    84,     0,
     432,   428,   425,   451,   443,   442,   994,   460,   432,   432,
       0,    84,   992,   432,   987,   603,   432,  1874,  1972,  1984,
     829,   902,    84,     0,   848,    84,     0,   432,     0,   834,
     833,   833,    84,   246,   829,    84,     0,    84,   246,    84,
      84,    84,   829,    84,  1170,  1225,  1160,     0,   432,  1184,
    1203,  1188,  1190,   432,     0,   432,    84,  1161,    84,   432,
      84,     0,    84,  1182,   432,  1186,   432,   432,  1197,     0,
      84,  1207,  1213,    84,  1332,    84,    84,  1283,  1273,   432,
    1293,   432,    84,   432,    84,  1278,   432,   432,    84,  1303,
    3067,     0,     0,  3042,  3059,  3020,  1872,  1872,    84,  2982,
    2983,  2979,    84,  2975,  1872,    84,  2960,  2955,     0,  2956,
    2957,  2959,   422,  1872,    84,  1137,  1138,  1143,     0,  1145,
    1147,    84,   432,   437,   460,    84,   875,   432,   713,   733,
     432,   683,   432,    84,   634,   647,   256,   254,  1014,    84,
    1066,    84,  1064,    84,    84,   467,     0,    84,    84,    84,
     468,     0,   472,   474,    84,    84,   432,    84,   460,     0,
     982,   878,    84,   983,   950,    84,   438,   989,   432,   603,
    1968,   208,   905,     0,    84,   689,    84,   843,   835,   836,
     840,   704,     0,   208,   695,    84,   724,     0,   857,   872,
     738,   208,  1177,    84,  1171,    84,    84,  1194,  1199,  1211,
    1158,  1173,   432,  1224,    84,  1175,   432,    84,   432,    84,
     432,  1192,    84,  1195,   432,   460,  1212,    84,  1284,  1311,
     432,  1272,  1286,   432,  1290,  1296,   432,  1853,  3051,  1853,
    1853,    84,  3045,  1853,  1853,  2993,  1853,   432,     0,  1853,
    2951,  2958,   231,  1132,   208,   431,  1140,    84,    84,  1151,
    1150,     0,     0,   719,    84,   706,   829,   726,   829,   658,
      84,   670,   639,   690,    84,   246,   696,    84,   246,  1012,
    1062,  1060,   458,    84,   482,    84,    84,   208,   470,    84,
      84,    84,   478,   477,   481,     0,    84,    84,   882,   883,
     884,   885,   886,   887,    84,     0,   889,   888,   891,   890,
     892,   894,   893,   896,   897,   879,   877,     0,   246,   603,
     432,  1973,   246,   904,   433,   914,   903,   906,   849,   629,
     844,   837,   841,     0,   246,   644,     0,  1853,   246,  1178,
     432,   432,    84,     0,   432,   432,     0,    84,   432,   432,
    1202,   432,  1205,   432,    84,   432,     0,   432,    84,  1280,
    1291,  1297,  1308,  1872,  1872,  1872,    84,  1872,  1872,  1872,
       0,    84,  1872,    84,    84,    84,   432,   432,    84,  1154,
      84,   829,    84,   432,   208,   432,   208,    84,   684,    84,
     692,    84,   246,   432,   699,     0,   432,   702,     0,   460,
     483,   485,   486,    84,    84,   432,   432,   466,    84,    84,
     454,     0,     0,   881,    84,    84,   990,    84,   603,     0,
     434,     0,     0,     0,     0,  1853,   845,   934,   934,    84,
       0,  1853,    84,  1872,     0,  1185,  1189,   432,    84,  1169,
    1179,     0,   432,  1168,  1183,  1187,  1198,   432,  1210,    84,
    1277,   432,  1279,  1309,  3050,  3053,    84,   432,  2984,  2970,
    2971,  2954,  2962,   432,    84,   432,  1146,  1148,   432,   460,
    1153,   208,   876,    84,   246,    84,   246,   659,   829,   671,
     432,   700,     0,    84,     0,    84,     0,     0,   432,   432,
     473,   475,   432,   480,   460,    84,    84,   440,   439,   765,
     604,    84,     0,   926,   918,   912,   907,   909,  1872,   934,
     838,   842,   710,     0,  1872,   730,     0,     0,  1200,   432,
      84,  1176,  1196,  1214,  1287,   432,  3040,  1853,  1853,  1139,
    1144,  1141,  1152,     0,   246,   707,     0,   727,     0,   829,
     208,   829,    84,     0,   691,    84,   697,    84,   469,   471,
     479,     0,   880,   895,     0,     0,     0,   604,    84,   208,
       0,   934,     0,   934,     0,   846,  1853,    84,     0,  1853,
      84,    84,  1174,  1181,  3048,  1853,  1872,  1872,    84,     0,
       0,     0,   208,   246,   208,   693,    84,   635,   648,    84,
     755,     0,     0,     0,  1004,  1019,   943,   460,  1216,  1316,
    1262,     0,   246,    84,    84,   246,   602,     0,   654,   922,
     916,   913,   920,   910,    84,  1872,   678,    84,  1872,   739,
     666,  1853,  1872,  2972,  1155,     0,    84,    84,   246,     0,
     246,   640,  1853,  1853,   991,   432,   433,   433,   433,   213,
     215,   217,     0,   219,   221,   223,   758,     0,     0,     0,
     763,   783,   801,   761,     0,  1853,     0,   934,   934,   630,
       0,  1853,   645,     0,  1853,  1872,     0,    84,   714,   734,
       0,     0,     0,  1853,  1872,  1872,   766,   225,     0,   434,
     434,   434,   741,   743,   745,   747,   749,   751,   753,   432,
      84,   798,   799,   800,   781,   782,   765,   787,   806,   765,
     596,  1872,   924,   917,   921,  1853,    84,  1872,  1853,    84,
    1872,     0,  3055,  3062,   720,  1853,  1853,     0,    84,     0,
    1872,     0,     0,   756,     0,    84,   768,   941,   941,   941,
     765,   765,   765,   765,   765,   765,   765,   770,   225,     0,
     823,   764,   432,   432,   762,     0,   934,  1872,   711,     0,
    1872,   731,     0,  3058,  3064,  1853,  1872,  1872,    84,   685,
      84,     0,    84,    84,   765,     0,    66,     0,   433,   433,
     433,   432,   795,   795,   795,   742,   744,   746,   748,   750,
     752,   754,   759,     0,     0,     0,     0,     0,     0,    84,
     772,    84,   825,   788,   807,    84,   925,   631,  1853,    84,
     646,  1853,    84,  1872,     0,     0,   660,  1853,   672,    84,
     636,   649,   757,  1917,   775,  1917,    84,   434,   434,   434,
     769,   938,   940,   938,   765,   802,     0,     0,     0,     0,
      84,     0,   786,   432,   805,   432,   655,  1872,   679,  1872,
     667,     0,    84,    84,  1853,  1872,  1853,   641,  1853,  1853,
       0,     0,     0,   941,   941,   941,   208,   208,   208,   760,
     784,   803,   785,   824,   804,   789,   773,   808,   826,  1853,
     712,  1853,   732,  1853,    84,   715,   735,  1872,     0,  1872,
    1853,  1872,  1872,   432,   432,    84,   795,   795,   795,    84,
      84,    84,   827,   432,   432,  1872,  1872,  1872,   721,  1853,
    1853,     0,    84,     0,  1872,   637,   650,    84,    84,    84,
     938,   940,   938,   432,   796,   432,   432,   790,   809,   656,
     680,   668,  1853,  1872,  1872,    84,   686,    84,   642,   780,
     779,   822,   208,   208,   208,   816,     0,   774,    84,  1872,
     716,   736,   661,  1853,   673,    84,    84,    84,   818,   810,
     791,    84,   828,   722,  1853,  1872,  1853,   817,    64,   797,
       0,   432,   776,   432,   432,   432,   777,  1872,   687,  1872,
     820,    65,     0,   793,    84,   819,   811,   792,   662,   674,
     432,   812,   432,   778,    84,   432,    84,   821,    84,   794,
     813
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    18,    19,    76,   371,    20,    21,    22,    23,    24,
      25,    26,    27,  1142,    28,  1144,    29,  1150,  1147,    30,
      31,   388,    32,    33,    60,   390,    61,    63,    39,    34,
     427,   773,  2950,   774,    66,  3703,   761,  3831,  2153,   688,
    6439,  1110,  2279,  6877,  3694,   689,  2421,  2422,  2423,  3221,
    2157,  2158,  3222,  2159,  3223,  2160,  3504,  3530,  3462,  3429,
    3319,  3320,  3321,  3322,  3323,  3324,  3434,  3338,    35,    58,
     385,   726,  2305,  5526,  5838,    36,   383,  1152,  2300,  5622,
    4867,  3678,  3674,  5411,  3682,  4873,  4875,  4877,  4863,    37,
     382,  4239,  5406,  6691,   721,  2297,  2925,  2298,   387,  4919,
    4920,  5525,  3671,  3686,  3685,  5769,  5440,  4268,  5771,  6039,
    6308,  6524,   340,   341,   342,   343,  5140,   372,   373,   421,
     344,  2162,  6068,  2350,  5142,  2937,  2938,  5512,  5513,   345,
     346,   347,   678,   679,  2909,  2272,  1101,  2944,  1116,   348,
     349,   350,   423,   424,   425,  3652,  3653,  4841,  6690,  6069,
    6557,  6556,  6070,  5899,  5922,  3125,  6114,  6355,  6647,  6917,
    6076,  6566,  6058,  5823,  5824,  6344,  6757,  7234,  5815,  6543,
    7139,  5816,  6065,  6066,  7027,  7144,  7029,  7030,  6748,  7148,
    5765,  5766,  6035,  6635,  6217,  6637,    44,  4332,   804,    45,
      46,    80,    81,   474,   843,   475,   846,   476,   801,   809,
     814,   806,   798,   477,   795,  2368,  2966,    41,  5536,  6366,
      42,  6583,  6125,  3704,  5846,   428,  4331,   777,  1205,  2351,
    2354,  4252,  4865,  6286,  2163,  6381,  7165,  7445,  5431,  7015,
    7372,  7588,  6029,  7132,  7413,  7620,  6389,  7171,  7448,  7018,
    7373,  7589,  5621,  6163,  6770,  7395,  7609,  6880,  7127,  7279,
    7584,  7694,  5630,  6197,  6792,  7404,  7613,  6882,  7129,  7281,
    7586,  7696,  5626,  6175,  6784,  7401,  7611,  5426,  6708,  7010,
    7218,  7547,  7683,  6597,  7133,  7220,  6608,  7136,  6605,  6274,
    7123,  5625,  6385,  7306,  7538,  7006,  7455,  7639,  6703,  6503,
    7121,  7495,  7662,  6611,  6276,  7125,  5628,  6391,  7309,  7541,
    7008,  7456,  7640,  6196,  7077,  7294,  7470,  7471,  7472,  7473,
    7474,  7475,  7476,  7375,  7504,  7429,  7564,  7439,  7436,  7295,
    7417,  7418,  7511,  7478,  7479,  7573,  7342,  7510,  7466,  7343,
    7529,  7530,  7482,  7633,  7705,  7722,  7561,  7344,  7531,  7483,
    7634,  7704,  7725,  6574,  4988,  7345,  7703,  7720,  7575,  7656,
    6606,  4992,  5624,  6929,  6780,  5892,  7167,  6604,  7168,  7070,
    7249,  6777,  6775,  6406,  5900,  6878,  6760,  6912,  5623,  5884,
    6166,  6378,  7067,  6923,  6595,  7164,  7303,  7162,  7301,  7300,
    7397,  7302,  7398,  7396,  7486,  7299,  6596,  5894,  6170,  4989,
    7596,  4994,  7597,  3812,  2932,  2933,  3684,  4318,  5828,  6349,
    6426,  6348,  7058,  7239,  6763,  4253,  2928,  2929,  3676,  4278,
    6535,  6315,  2930,  2931,  3680,  4311,  6542,  6539,  6324,  6320,
     426,  4325,  4330,  3692,  3698,  4848,  4849,  5417,  5749,  6019,
    6994,  7115,  6696,  6995,  6997,  6998,  6699,  7118,  7209,  5010,
    4279,  6533,  5012,  5013,  6812,  5014,  5015,  5016,  6204,  5017,
    7083,  5018,  7087,  5019,  5020,  5021,  5022,  7086,  5023,  6957,
    5024,  6945,  5025,  6959,  5026,  6946,  5027,  5028,  6643,  5029,
    6631,  5030,  7094,  6962,  5031,  7082,  5032,  6640,  5033,  5034,
    6642,  5035,  6221,  5036,  5037,  6820,  5038,  5039,  5040,  6965,
    2533,  2534,  3133,  5041,  3821,  4467,  5042,  5634,  2537,  2538,
    3137,  5088,  3825,  4470,  5089,  6973,  7098,  6666,  6667,  6243,
    6838,  5641,  2535,  2536,  3135,  5063,  4468,  5064,  5905,  6419,
    5906,   351,   495,   496,   856,  2945,  3918,   353,   354,  2917,
    2281,   355,   356,  1105,  1106,  1107,  1108,   357,  2275,  2276,
    2912,  4234,  1103,   680,   535,   358,   359,  2414,   920,   923,
    2424,  2411,   360,   731,  1159,  1160,  1161,  3687,  3217,  4541,
    5676,  5679,  4542,  3890,  6374,  3461,  3326,  4622,  3243,  3256,
    3257,  3258,  3245,  3534,  3444,  3342,  3437,  3549,  3804,  3299,
    2744,  4670,  2738,  2739,  2756,  2167,  4985,  3121,  3805,  3806,
    3807,  3808,  5612,  2168,  2169,  2170,  2171,  2172,  2173,  3621,
    2174,  6009,  2175,  3618,  2875,  2519,  3797,  3510,  4730,  4450,
    4451,  6768,  4984,  5610,  6592,  5611,  6375,  6920,  5881,  5882,
    6162,  6156,  3259,  2585,  2586,  2587,  2564,  3386,  3387,  3388,
    2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,
    2186,  2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
    2196,  3433,  2197,  2198,  2199,  2200,  2201,  3300,  2202,  2203,
    2204,  2205,  2206,  2207,  2208,  2209,  2210,  2211,  2212,  2213,
    2214,  2215,  2216,  2217,  2218,  4204,  2219,  4211,  2220,  2221,
    2222,  2223,  2224,  2225,  3572,  2226,  3347,  3348,  3112,  2630,
    2631,  2540,  4474,  2559,  4529,  5122,  5125,  5968,  6263,  6689,
    6688,  6987,  6858,  6859,  6860,  6989,  6861,  7268,  7267,  5956,
    6685,  6986,  4515,  6481,  3203,  5657,  6984,  3869,  6480,  5109,
    2546,  3204,  3871,  3206,  5955,  5957,  2227,  3876,  5660,  2228,
    5663,  6258,  2229,  5664,  2553,  2548,  3809,  3199,  3879,  3881,
    3883,  5100,  5095,  3836,  5647,  5653,  6471,  6247,  3866,  6244,
    6840,  6672,  6473,  6474,  7406,  6980,  7451,  6475,  6253,  6977,
    6845,  5104,  5952,  6251,  4511,  5105,  5655,  6250,  6477,  6249,
    3189,  3859,  3860,  3190,  3191,  3192,  3193,  4490,  2428,  3150,
    3151,  4117,  4724,  3506,  4118,  3721,  4112,  3508,  2802,  2429,
    2230,  3491,  2877,  3619,  2878,  4224,  4834,  5741,  4225,  2231,
    1039,  1040,  2232,  4092,  4093,  5281,  5282,  2236,  2516,  2517,
    2237,  4710,  5299,  5283,  3627,  3483
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -6993
static const int yypact[] =
{
     963,  -601,   453,   487, -6993,  -499,  -476,  -451,  -451,  -451,
    -451,  -451,   642,   689, -6993,  -451, -6993, -6993,   767, -6993,
   -6993, -6993,   712, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993,  2101,  2101, -6993, -6993, -6993, 96237, 96237, -6993,
    8657,   810,  8657,  8657, 96237,  5823, -6993, -6993,  -293, 96237,
   -6993, -6993, -6993, -6993, -6993,  7323, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
    8338, -6993,  2630, 98089, -6993, -6993, -6993, -6993,   826,   718,
     897,  1087,  -451,  -451, -6993,  -620, -6993, -6993, -6993, -6993,
   -6993, -6993,  -457, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,   164,
     164,   164,   164,   164,   164,   164, -6993,   164,   164,   164,
   -6993,   164,   164,   164,   164,   164,   164, -6993,   164,   164,
   -6993,   164,   164,   164,   164,   164,   164,   164, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993,  -451, -6993,  -451, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993,  -451,  -451,  -451, -6993,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451, -6993, -6993,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451, -6993, -6993, -6993, -6993, -6993,  -451, -6993,
   -6993,  -451, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, 86516, -6993, -6993, 98089,  -280,
    -347, -6993, -6993, -6993,  -622, -6993, -6993, -6993,  -578,  -432,
    -401, -6993,  -289,  7390, -6993, -6993, -6993, -6993, -6993,  -451,
   -6993,  -289, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,   561, -6993, -6993, -6993, -6993,  -289,  -289,  -289,  -289,
    -261,  -289, -6993,  -233, -6993,   648, -6993,  -218,  -247, -6993,
   -6993, -6993,  -205,   678,  -337,  -259,   954,   978,  1000,  1053,
    1135,  1186,  1211,  1219,  1251,  1262,  1274,  1322,  -451,  1335,
    1381,  1401,  1425,  1443,  1458,  1473,  1483,  1489,  1496, -6993,
     313, -6993,   445,  -219,  1507,  1517, -6993,   709,  -147,  -147,
   -6993,   446,   389,   392,  -451,  -451, -6993,  -127,  -451,  -451,
     350, -6993, -6993, -6993, -6993,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451, -6993,   350,  -451,  -451, -6993,  -451,  -451,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,   350,   781, -6993,  1361,  1003,  -104,   396,   350,   350,
       0,   439, -6993, -6993, -6993, -6993,   466, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993,   434, -6993, -6993, -6993, -6993,
     826, -6993,   718, -6993,   826, -6993,   718, -6993, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237,  -451, 98089, 96237, 17999, 32611,
   33551, 96237, 34542, 35531, 35967, 36457, 36893, 37383, 37819, 38309,
   38745, 39235, 39671, 40161, 40597, 41087, 98089, 41523, 42013, 42449,
    9379, 42939, 96237, 43375, 96237, 96237, 43865, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 44301, 44791, 45227, 45717, 46153, 96237,
   46643, 47079, 47569, 48005, 48495, 48931, 49421, 49857, 50347, 50783,
   51273, 96237, 51709, 52199, 52635, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, 98089, 98089, 19842,  -289,   455, 96237,
   -6993, -6993, 96237,   484,  9454, 96237,  9454, -6993, -6993,  1648,
     484, 98089, 98089, 98089, 98089, 98089, 98089, 98089, 98089, 98089,
   98089, 98089, 98089, 98089, 98089, 98089, 98089, 98089, 98089, 98089,
   -6993, 98089, 98089, -6993, -6993, -6993, -6993, -6993,  8657,  1655,
   -6993,  -233, -6993,  -293,  1663, -6993,  1407, -6993, -6993, 96237,
    1679,   574,   574, -6993, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, -6993, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,   391, 86977,
   -6993, 19842,  1734, 87442, -6993, -6993, 19842, 96237,  9454, 96237,
   96237,  -261, -6993,  -289, -6993, -6993, -6993, -6993, -6993,  8532,
     392,  -451,  -451,  1164, -6993,   350,   392,  1836,   350,   350,
   -6993, -6993,   631,   646, -6993, -6993, -6993, -6993,   626,  9454,
   96237, -6993, -6993, -6993, 96237, 96237,   350,   350, 96237,   350,
     350,   350,   350, 96237,   350,   350, -6993, -6993,   350,   350,
   -6993,   350,   350, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993,   455, -6993,  1924,   392,   350,  8532, -6993,
   -6993, -6993, -6993, -6993,  8532, -6993, -6993, -6993, -6993,   134,
     483, -6993, -6993, -6993, 98089, 98089, -6993,  -261,  -261,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289, 98089,  4101,  -228,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289, -6993,
    -203,  -289, -6993,   -98,  2380,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -261,  -289,  -289,  -289,  -289,
    -289,  -289,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,  -261,   -68,    -2,    10,    60,    79,    83,
      87,   104,   121,   125,   169,   181,   182,   185,   191,  -289,
    -261,  -289,  -261,  -289,  -261,  -289,  -289,  -289,  -261,  -261,
    -289,  -261,  -289,  -261,  -289,  -261,  -289,  -261,  -289,  -261,
    -289,  -261,  -289,  -261,  -289,  -261,  -289,  -261,  -289,  -261,
    -289,  -261,  -261,  -289,  -261,  -289,  -289,  -289,  -289,  -289,
   53239,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  4101,
    4101, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, 98089, -6993, -6993, -6993,
    1785, -6993,   661, 96237, -6993,   885, -6993, -6993, -6993, -6993,
   -6993,  1800, -6993, -6993, -6993,   681,  -152, -6993, -6993, -6993,
   -6993,  6061,  6061,  2344,  2344,  2264,  2264,  2264,  2264,  2264,
    2264,  1315,  1315, -6993, -6993, -6993, -6993, -6993, -6993,  4101,
    4101,  7833,  1745,  1775,  1791,  1847, -6993,  -261, -6993, -6993,
    1857,  -293,  1876, -6993, -6993,   565, -6993,  1996, -6993, -6993,
   -6993,   875, -6993, -6993,   888,  -233,  -233,  -233,  -233,  -233,
    -233,  -233,  -233,  -233,  -233,  -233,  -233,  -233,  -233,  -289,
    -233,  -233,  -233,  -233,  -233,  -233,  -233,  -233,  -233,  -233,
    -233,  -233,  -233,  -233,   334, -6993,  -233,  -233,   353,  -152,
   -6993,  -233,  -233, -6993, -6993,  6331,   905,   905,  2042, -6993,
     350,   350,   392, -6993, -6993, -6993, -6993,   392,   350, -6993,
   -6993, 98089, 98089, -6993,  8532,  8532,  9454, -6993, -6993,  -289,
   -6993, -6993, -6993,  1955,  -289, -6993, -6993,  -289, -6993, -6993,
   -6993, -6993,  -289, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993,   392, -6993, -6993, -6993,  -289, 96237,  8532, -6993,
   -6993, -6993, -6993, -6993, 98089, 98089, -6993, -6993, -6993,  3468,
    3468,   950,   755,   759, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  4101,
   -6993, 96237, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, 96237, -6993, -6993, 96237, -6993,
  119915, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, 96237, -6993, -6993, -6993, -6993, -6993, -6993, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,
    5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,
    5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,
    5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,
   -6993, 96237, -6993, 96237, -6993, 96237, -6993, -6993, -6993, 96237,
   96237, -6993, 96237, -6993, 96237, -6993, 96237, -6993, 96237, -6993,
   96237, -6993, 96237, -6993, 96237, -6993, 96237, -6993, 96237, -6993,
   96237, -6993, 96237, 96237, -6993, 96237, -6993, -6993, -6993, -6993,
   -6993, -6993,  2051, -6993,  -451,   622, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993,   826,   718,  -440, -6993, -6993,   999, -6993,
   -6993,   999,  1017, -6993, -6993,   999,  9454,  3121,  2943,   537,
    -451, -6993, -6993, -6993,  -451, -6993,  -451,  -451,  -451,  -451,
    -451, -6993,  -451, -6993,  7826,  9454,  -451, -6993,  -451, -6993,
    -451, -6993,  -451,  -451, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993,   -29,   -29,   -29,   -29, -6993,
   -6993, -6993, -6993, -6993,  -451,  -451, -6993, -6993,  -451, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993,   742,   -29,   -29,   -29,
     -29,   -29,   -29,   -29, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
    -451, -6993,    30, -6993,  -451,  -451,  -451,   -29,   -29,   -29,
     -29,   -29, -6993, -6993,  -451,   -29, -6993, -6993, -6993,  -451,
   -6993, -6993, -6993, -6993, -6993,  -451,   -29,   -29,  -451,   -29,
     -29, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993,  1855,   -29, -6993,  -451, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,   -29,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,  -451, -6993,    30, -6993, -6993, -6993, -6993, -6993, -6993,
     -29, -6993, -6993,  -451, -6993, -6993, -6993,  -451,   -29,   -29,
     -29,   -29,  -451,   -29,   -29,  -451,   -29,   -29,  -451, -6993,
   -6993,   -29,   -29,   -29,   -29, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,    30, -6993, -6993,   -29, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993,   -29,   -29,   -29, -6993, -6993, -6993, -6993,
     -29,   -29, -6993,  -451,   -29, -6993, -6993,   -29,   -29,   -29,
    -451,  -451, -6993, -6993,   -29, -6993, -6993,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,    30,   -29, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,    30,    30,   -29,   -29,   -29,   -29,   -29,   -29,   -29,
     -29,   -29,   -29,   -29,   -29,   -29,   -29,   -29,   -29,   -29,
     -29,   -29,   -29,   -29,   -29,   -29,   -29,   -29,   -29,   -29,
     -29,  -451,  -451,  -451,   -29,   -29,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,   -29,   -29,   -29,  -451, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
    -451,  -451,  -451,  -451, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  -451,
   -6993, -6993, -6993,  -451, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993,  -451,  -451,   -29, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
    -451,  -451,  -451, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993,  -451, -6993, -6993, -6993, -6993,
    -451,  -451, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993,  -451,  -451, -6993, -6993, -6993, -6993,  -451,
   -6993,   -29,  -451,  -451, -6993, -6993, -6993, -6993,   -29, -6993,
   -6993, -6993, -6993,   -29, -6993, -6993,  -451, -6993, -6993,  -451,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  -451,  -451,
    -451,  -451,  -451,  -451, -6993, -6993,  -451, -6993, -6993, -6993,
   -6993, -6993, -6993,   -29, -6993, -6993,   -29, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,   -29,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  1983,
   54365, -6993,   622,   622,  2092,  2107,  2110, -6993, -6993, -6993,
    2199, -6993, -6993,  2152, -6993, -6993,  4866, -6993, -6993, -6993,
   -6993,  1136, -6993, -6993, -6993, -6993,    30,    30,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,  -451,
    -451,  6066,  -451,   -29, -6993,  -451,  -451, -6993, -6993, -6993,
    -146, -6993, 54366, -6993, -6993, -6993,  1144, -6993,  7413, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  1160,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  4101,
   -6993,    92, -6993, -6993,  2212,   990, -6993, -6993, 96237, -6993,
    2262, -6993, -6993,   484, 96237, -6993,   455, -6993, -6993, 98089,
   98089, -6993, -6993, -6993, -6993,  8657, -6993,  2204, -6993,  9454,
    2241, -6993, -6993, -6993,  3460,  -293, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993,  2337, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, 87903, 88368, -6993,
   -6993, -6993, 88829, 88368, -6993, -6993, -6993, -6993, -6993,  9454,
    -469,  -289,  6331, -6993, -6993, -6993,  1255, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  1286,  7390,
    1286,  -289,  -289, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993,   350,  2270, -6993,
   -6993, -6993,  1286,  1286, -6993, -6993, -6993, 98089,   223, -6993,
   -6993,   230,   237,   240, 98089, -6993,  -289, -6993, -6993,  2318,
   -6993, -6993, -6993, -6993,  -289,  6141, -6993, -6993, -6993, -6993,
    -486,  -261,   254,   260,   264,   279,   358,   412,  1312,  1328,
    1330,  1332,  1341,  1343,   441,   462,   463,   464,   488,   490,
    1356,  1362,  1365,  -261,  -261,  -261,   496,   497,   510,   511,
     525,   526,  1375,  1377,  -261,  -261,  -261,  -261,   529,   532,
     535,   546,   553,   567,  -289,  -289,  -289,  -289,  -289,  -289,
     571,   592,   594,   613,   623,   627,   647,   650,   654,  -261,
    -261,  -261,  -289,   657,  -261,  -261,  -289,  1382,  -261,  -289,
    -289,  -289,  -289,  -261,  -289,  -289,  -289, -6993, 64527,  -131,
     622, -6993,   622,  1403, 54365, -6993,  1406, -6993, -6993, -6993,
   -6993, -6993, -6993,  -233, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, 98089,  2415, -6993,  2417, -6993,  2413, -6993,  1412,
  134423, 76940, 78056,  2503,138887,  2507, -6993,140003, -6993, -6993,
   -6993,  1428,  2442,   999, -6993, -6993,  2516,  2517,  2523, -6993,
   65657, 65657,  1442, -6993, -6993, -6993, -6993, -6993, 98711,141119,
   66787, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993,   -81,106523, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993,121031,  1442, 96237, -6993,109871,
  135539, 75824, -6993, -6993, -6993, -6993, -6993, 67917, -6993, 69047,
   67917, -6993, -6993,110987, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,     6,112103,
   -6993, -6993, -6993,113219, -6993, 56617,103175, -6993, -6993,142235,
  128843, -6993, -6993, -6993, -6993,107639, -6993, -6993, 69047, -6993,
   -6993, 69047, -6993, -6993, -6993, -6993, 67917, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, 69047, -6993, -6993, -6993, -6993,141119,
  141119, -6993, 58877,140003,110987,127727,127727,134423,134423,110987,
  110987,131075, -6993, -6993,131075, -6993,131075, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993,110987,110987,110987, -6993,
   -6993,110987,110987,110987,110987,110987,110987,114335,115451, -6993,
   -6993, -6993,131075, 96237, 96237,126611, 98089,103175, -6993, -6993,
   -6993, -6993, 99827,100943, -6993, -6993, -6993, 96237, 96237, 96237,
  103175,103175,103175,110987,110987,132191, -6993, -6993,132191, -6993,
  133307, -6993, -6993, -6993,103175,132191, -6993,138887, -6993,132191,
  133307,133307,103175, -6993, -6993, -6993, 10613,  2455,  2110,   291,
     673,  2755, -6993, -6993,  4568, -6993, -6993, -6993,   727, -6993,
   -6993,  2456, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  7413,
   62267,  1450, -6993, 58877, -6993,131075, -6993, 67917,131075,131075,
  103175, -6993,103175, -6993, -6993, -6993,116567,117683,110987,143351,
  103175, -6993,103175, -6993,103175,103175, -6993,116567,132191,100943,
   -6993, -6993,100943, -6993, -6993,100943, -6993, -6993, 98089, 57747,
   -6993, -6993,122147, 70177, 71307,109871,103175, -6993,103175, -6993,
   -6993, -6993, -6993, 96237,108755, -6993,103175,104291,103175,103175,
  103175,112103,110987,110987, 69047,109871, 69047, 69047,   203,  9454,
   -6993,121031, -6993, 71307,138887,  1450, -6993, -6993,   300, -6993,
   -6993,  -451, -6993, -6993, -6993, 54365,  1406,  1406, -6993,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622, -6993, 96237, -6993, 96237,
   -6993, 96237, -6993, 96237, -6993, -6993, -6993, 89294, 96237, -6993,
   -6993,  4101,  4101,  -289,  9454,  2483,  -233,  2426,  2467, -6993,
    2461, -6993,  2468, -6993, -6993, -6993, -6993,  1455,  2544, -6993,
   96237,  -233,  -233, -6993,   -71, -6993,  -233,  -233, -6993,   -71,
     709, -6993,   455,  6331, -6993, -6993,  -233,  -233,  9454, -6993,
   -6993, -6993, -6993, -6993, 96702, -6993,   455,   455,   350,   350,
   -6993, -6993, -6993, -6993,   455,   455,  3468,  5823, -6993,  5823,
   -6993,  5823, -6993,  5823, -6993,  4101, -6993, 19842,141119, -6993,
   -6993, -6993,  -146, -6993,  1467,   300, -6993,  5823, -6993,  5823,
   -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993, 96237,
   96237, 96237, 96237, 96237, 96237,  5823, -6993,  5823, -6993,  5823,
   -6993,  5823, -6993,  5823, -6993,  5823, -6993, 96237, 96237, 96237,
   96237, 96237, 96237,  5823, -6993,  5823, -6993,  5823, -6993,  5823,
   -6993,  5823, -6993,  5823, -6993, 96237, 96237, 96237, 96237, 96237,
   96237,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823,
   -6993,  5823, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  5823,
   -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823,
   -6993,  5823, -6993,  5823, -6993,  5823, -6993, 96237, 96237, 96237,
   -6993, 96237, -6993, 96237, 96237, -6993, 96237, 96237, -6993, -6993,
   -6993, -6993, 96237, -6993, -6993, -6993,  -271,  2552, 89755,  7390,
   97163,  -261,  -261,   622,  5794,   622,   375,  2783,   622, -6993,
   -6993, 61137, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,  4101, -6993,  1469, -6993,  1469, -6993,  1471, -6993, -6993,
    2605, -6993, -6993, -6993, -6993, -6993, -6993, -6993, 17739,  2571,
   -6993, -6993,  -486, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993,  2318,125495, 80288,  2199, 15832,   348,
   -6993,  2034,  2034,  1755, -6993, -6993, -6993,   348, -6993, 80288,
    2455,  -289, -6993, 80288, -6993,  -233, -6993, -6993, 19842, -6993,
     300, -6993, 80288, -6993, 80288, -6993, 80288,  2226, 90220,  2092,
    2107, -6993, -6993, -6993,  -289, 82347,  -289,  -289,  -289,  -289,
    -289, -6993,  -289,  2492,  -261,   289,  2493,  -261,  7135, 90681,
   -6993,  -289, 82812, -6993, -6993,  -289,  -289, -6993, 63397,   999,
   -6993,   999, -6993,   999,  -289, 12063, -6993, -6993,  -289,  -289,
    -261,  8298,  -261,  -261,  -261,  -261, 12264,  -261,  -261, 18440,
    -261,  -289, 12320,  -289, 98089,  -261,  -261, 83273,  -261,  -261,
    -289,  -289, -6993, 63397,  -289, 12780,  -289,   826, -6993,   999,
   -6993, -6993,   999, -6993, 67917,  -261,  -261, 10119,  -261,  -261,
    -261, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  -261, -6993,
    -261, -6993,  -261, -6993,  -261, 81402,  -261,  -261,  -261, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993,  -261, -6993, 12177,
   -6993, -6993,  -261,  2570,  2572,  2574,   377, -6993,  -261,  -289,
    -289, 17029,  -289,  -289,  -289,  -289,  -289, 14000,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -261,  -261,  -261,  -261,  -261, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, 81886,  -289,  -289,  -289, -6993, -6993, 10876,
    -289,  -289, 17502,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  1882,  -289,  -289,  1479,  -289,  1485,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,   274,
   14314,  -289,   274, 15504,  -289,  -289,  -261,  -261,  -261, -6993,
    -261,  8039,  7390,  -261,  -261, -6993, -6993,  -261,  -261,  -261,
    -261, 11734, -6993, -6993,  -261,  -261,  -261, 11954,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -289,  -289,
    -261,  2422,  -261,  2886,  -261,  -261,  -261,  -261,  -261,  -261,
    -261,  -261,  -261, 55491,121031, 19842, 54365,   622,  1491,  2502,
   -6993, -6993,   622,  1493, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993,  2577, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,  -406,    93,   999, -6993, -6993,   455,  1494,   379, -6993,
   -6993,  1450,  -289,  -289,  1498,   669,   672,  1499,   669, 83738,
    -289,  -289,   679,  -289,  1495,  -261,  -261,  2512, -6993, -6993,
    -289, 15752, -6993, -6993,  -289,  -289, 16031,  -289,  -289,  -261,
    -261,  2784,  -261,  -261,  -261,  -261,  -261, -6993, -6993,  -261,
    -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261, 18107,  -261,
    -261,  2513,  -289, 15000,  -289, 91146,  -261, 86051,  -261,  2590,
   97628,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,  -261,
   13660,  -261,  -261,  -261,  -261, 14122,  -261,  -261,  -261,  -261,
    -261,  -261,  -261,  -261,  -261,  -289,  -289,  -261,  -261,  -261,
    -289,  -289,  -289,   682,   682,   682,   683,   683,   683, -6993,
   63397,  -289,  -261,  -261,  -261,  -261,  -261, -6993,  1450, -6993,
   -6993,  2563, -6993, -6993, 98089, -6993,   123,  4517, -6993, -6993,
    6558,  4963,  4963,  3642,  3642,  3642,  3642,  3642,  3642,  1820,
    1820, -6993, -6993, -6993, -6993, -6993, -6993,   455, -6993, -6993,
   -6993,  1501,   455, -6993,  1503,   455, -6993, -6993, -6993, -6993,
    3003, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
    9724,  -293,  -293,  -293, -6993, -6993,  4704,  -293, -6993, -6993,
   11613,  -293, -6993, -6993,  5573,  -233,  -233, -6993, -6993,  -233,
   -6993, -6993,  2602,   370, 96237,  2639, -6993, -6993,  2604,   427,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993,   723,   724,   732,   736,
   -6993,  1494, -6993,  1136, -6993,  1467,  -261,   743,   747,   749,
     750,   771,   780,   798,   805,   809,   820,  1509,  1510,   832,
     840,   841,   844,   850,   864,   870,   871,   872,   878,  -261,
    -261,   880,   882,   884,   891,   892,   898,   900,   901,   925,
     931,  -261,  -261,   939,   941,   945,   970,   980,   982,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -261, 19842, -6993,  7390,
  142235,142235, -6993,  2805,  2617, -6993,  1518,   101,141119, -6993,
   -6993, -6993, -6993, -6993, -6993,  1520, -6993, -6993,  1513, -6993,
   -6993, -6993,  2593, -6993, -6993,  2594, -6993, -6993, -6993, 98089,
   -6993, -6993, -6993, 98089, -6993, -6993,    88, -6993, -6993,  -146,
   -6993, -6993,  2651, -6993,  1467,   300, -6993, 80288, 16672, -6993,
   -6993, -6993,   348,  7252,  2199, -6993, -6993, -6993, 80288, 80288,
    9454, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  2642, 67917,
   72437, 67917, 72437, 72437, -6993,  9454, -6993,   348,  -293, -6993,
     348, -6993, -6993,  2459, 61137,121031, -6993,  2587, -6993, -6993,
     348, -6993,   348, -6993,   348, -6993, -6993,  -451, -6993, -6993,
      77, 19842, -6993, 91607,  2092,  2107,  2110, -6993, -6993, -6993,
   -6993, -6993, -6993, 19842,117683,  2540, -6993, 19842, 73567,  2542,
   -6993, 19842, 62267, -6993, 92072, -6993, -6993, -6993,   455, 96237,
   -6993, -6993, -6993, -6993, -6993, -6993,  2550, -6993, -6993, 69047,
    2556, 65657, 65657,103175,141119,141119,141119,141119, -6993, -6993,
   67917,141119,141119,109871, -6993, -6993,   455, -6993, -6993,  -261,
  118799,138887, -6993, -6993, -6993,  -261,  -261,138887,138887,138887,
  102059,109871,141119,141119, -6993, -6993, -6993, -6993,110987,105407,
  129959,103175, -6993,132191, -6993, -6993, -6993, -6993, 64527, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993,  -289,  -289, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
  109871,141119,135539,109871,109871, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, 92533, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,131075,
   -6993,131075, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993,   274, -6993, -6993,   274, -6993,
   -6993,126611,116567,138887,138887, -6993,104291,132191,132191,126611,
  112103,112103,126611,104291,103175,126611,103175,103175,103175,132191,
  132191,132191,132191,132191,132191, -6993, -6993,110987,133307,132191,
  132191,133307,110987,110987,110987,132191,103175,132191,  2560,   346,
     419,  -289,  1533,  1550,  5849,  -289,  -289,  -289,  8298,  -289,
    -292,121031,  2659,  5387,  5520, 19842,  2291, -6993, 96237, 55491,
    1494, 62267, -6993, 62267, -6993,  2652, -6993,   455,   361, -6993,
   -6993, -6993, -6993, -6993,131075,137771, -6993,131075, -6993, -6993,
  137771, -6993, -6993,131075,132191,103175, 19842, -6993,  2564, -6993,
   -6993,  2565, -6993, -6993,117683,112103,  2566,110987,132191,132191,
  110987,132191,132191,144467,138887,143351,138887,126611,126611,126611,
  103175,126611,126611, 19842, -6993,  2573, -6993, 19842, 74697, 92998,
  123263, -6993,143351,143351,141119,141119,141119,132191,132191,132191,
  103175,132191,133307,133307,132191,132191,133307,133307,138887,138887,
  138887,138887,132191,132191, -6993, -6993,109871,141119,121031, -6993,
   -6993, -6993,136655, -6993,  -289, -6993,  -289, -6993,  -289,145583,
   -6993,  -289, -6993,  -289, -6993,  -289,   455, -6993,121031,141119,
  109871,109871,110987, -6993, -6993,  1564, -6993,  1450,  1450,  4101,
    2677, -6993, -6993, -6993, -6993,  9454, -6993, -6993, -6993,  -233,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  -293,
    -293, -6993,  3684,  2538,  2467,  2461,  2468,  2583,  2586,  2592,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  -233, -6993,
   -6993, -6993,  -218,  1588,  1594, -6993, -6993,   314, -6993, -6993,
    -218,  1595,  2688,  2690,  2692,  2693,  2695,  2699,  2700,  2701,
    2702,  2703,  2708,  2712,  -451,  2715,  2716,  2717,  2718,  2719,
    2720,  2721,  2723,  2724,  2725, -6993,   160,   241,   319,  2727,
    2728, -6993, -6993,  -218,  1660, -6993,  1661,  1661, -6993,  2623,
    2623, -6993, -6993, 96237, -6993,  2753, -6993,   311, 96237, -6993,
    2756,  2686,  2705, -6993, -6993,  5823, -6993,  5823, -6993,  5823,
   -6993,  5823, -6993, -6993, -6993, -6993,  5823, -6993,  5823, -6993,
    5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,
    5823, -6993,  5823, -6993,  5823, -6993, 96237, 96237,  5823, -6993,
    5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,
    5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993, 96237, 96237,
    5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,
    5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,
   96237, 96237,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,
    5823, -6993,  5823, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, 96237, 69047,  -289,  -289, -6993,  1681,   365, -6993, -6993,
    -289, -6993, -6993, 18464, -6993, -6993, 61137,  2738, -6993, -6993,
    1686, -6993, -6993,  1686, -6993, -6993,  4101,  9900,  5121,  4101,
   11371,  -261, -6993,  1136,  2768, -6993, -6993,  1467,  2770,   348,
   -6993, -6993, -6993,  2824, -6993, -6993, -6993,  7390, 83738, -6993,
    2794, 84199, -6993, -6993, -6993, -6993, 98089,  2795, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993,  2793, -6993,  2814,  2661,
   -6993, -6993,  2816,  2653, -6993, 80288, -6993,  1735,  -289,  2653,
   -6993,  1450,  1450,  2817,  9454,  2820, -6993,  2822, -6993, -6993,
   -6993, 67917, -6993, -6993,  1741,  1743,  1744,  1748,  1749,  1750,
   -6993, -6993,124379, 69047, 19842,121031,  -289,  -289,  -289, 19842,
  121031,   105,   106,   118,   129,   132,   141,   146, 84664,  -289,
    -289,  1739, 19842, 69047, 19842, -6993, -6993, 19842,  -289,  -289,
    -289, 19842,  -289, 85590,  -289,  -289,  -289,  -261,  -261,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,   984,  1746, -6993,138887,
   67917,  -289, 10430,  -289,  -289,  -289,  -289,138887,138887,  -289,
    -289,  -289,  -289,  -289,  -289,  -289, 15940,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289, 10902,  -289,  -289, -6993,  -289,
   18017,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289, -6993,
   -6993,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
   19842,  -289,  -289, -6993, -6993,  -261,  -261,  -261,  -261,  -289,
    -289,  -261,  -261,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -261,  -261,
    -289,  -261,  -289,  -261,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289, 18445, -6993, -6993, -6993,   266,   285,   400, -6993,
   -6993,   989,  1030, -6993, -6993,  -238,   -69,  -289,  2852, -6993,
    1212, -6993, -6993,138887, -6993,  1093,   346,   419,  -289, -6993,
     455,  1494, -6993,   385, 96237, -6993, -6993, 96237, -6993,   455,
     101,  -289,  2444,  -289,  1780,  -289,  -289,  -289,121031, 19842,
   19842,  -289,  -289,  -289,  -289, 19842,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -261,  -289,  -289,  -289,  -289,  -289,121031, 19842,
   69047,  -289, 85125,  -289,  -289, 19842,  -289, 16449,  -289,  -261,
    -261,  -289,  -289,  -289,  -289,  -289,  -289,  -261,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  2572, -6993,
   -6993,   139, -6993, -6993, -6993,  2570,  2572,  2574,   591, -6993,
   -6993, -6993, -6993,  -289,  -289,  -289,  -289,  -289,  -289,  -289,
    -289,  -289,  -289, -6993,  9454, 61137, -6993, -6993, -6993,  1781,
    1661, 89294, -6993,  3684,  2538,  2467,  2791,  2468,  2461,   318,
    2583,  2586,  2592, -6993, -6993, -6993, -6993,  1784,  1786,  1790,
    1661,  -293, -6993, -6993,  1793, -6993,  -293, -6993,  -233, -6993,
   -6993, -6993,  -293, -6993,  -293, -6993,  -293, -6993,  -233,  2623,
    -233, -6993, -6993, 96237, 20530, -6993, 96237, 96237, 96237, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237, -6993, 96237,
   96237, 96237, 96237, 96237, 96237, 96237, 96237, 96237,   521, 93459,
   19842, 93924, 20530, 96237, 96237, -6993, 19035, 20642, -6993,  -293,
   -6993,  -293, -6993,  -233, 96237,  -233, 96237,  2807,  2810,   992,
     994,  1002,  1008,  -261,  -289,  -289,  -289,  -289,  -289,  -289,
    1011,  1021,  1022,  1024,  1088,  1092,  -289,  -289,  -289,  -289,
    -289,  -289,  1094,  1102,  1110,  1113,  1114,  1121,  -289,  -289,
    -289,  -289,  -289,  -289,  1122,  1123,  1131,  1132,  1139,  1145,
    -289,  -289,  -289,  -289,  -289,  -289,  -289, -6993, -6993, -6993,
     622,   622, -6993, -6993, -6993,  9639, -6993,  9454, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993,  -233, -6993, -6993,  1797,
      97,   144,   149,   152,  -451,  -451, -6993, -6993,  1794,  1661,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993,  1794,  1661, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993,  -451, -6993, -6993,  1794,
    1661, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   96237, -6993, -6993,  -289, -6993, -6993,  7390, 67917, 67917,  -289,
   -6993,  -289, -6993, -6993, -6993,  2741,  -289, -6993, -6993, -6993,
    2737,   142, -6993, -6993, -6993, 61137, -6993, -6993,  -289, -6993,
    -289,  -289, -6993,  1481,  -289, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993,  2888,   157,   154,   155,   999,   312, -6993, -6993,
   -6993,  1803,  2891,  -233,  -289,  -289, 69047, -6993, -6993, -6993,
  144467, -6993, -6993, 67917,141119, 69047,121031, -6993, -6993, -6993,
  121031, -6993, 94385, -6993, -6993, -6993,132191,132191, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993,141119, -6993,141119,  -289,  -289,
   -6993,  -289,  -289, -6993, -6993, -6993, -6993,  -289,  -289, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, 69047, -6993, -6993,138887,138887,
  126611,126611, -6993, -6993,133307,133307, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,132191,132191, -6993,132191, -6993,132191, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993,  1956, -6993, -6993, -6993, 54365,
    2887, -6993, -6993, -6993,  2890, -6993,  2892, -6993, -6993,  -289,
    1147, -6993, -6993,  -238,   317, -6993,   622,   622, -6993,  1812,
    -289, -6993, -6993, -6993, -6993,  1494, -6993, -6993,   455,   361,
   -6993, -6993,  -289, -6993, -6993, -6993, -6993, -6993, -6993,121031,
  121031, -6993, -6993, -6993, -6993,143351, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993,132191, -6993, -6993, -6993, -6993, -6993,121031, -6993,
   94850, -6993, -6993, 70177, -6993, -6993,116567,116567, -6993, -6993,
   -6993, -6993, -6993, -6993,132191, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,  1809,  1816, -6993,   484, -6993, -6993, -6993, -6993, -6993,
    -293, -6993, -6993, -6993, 98089, 98089, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993,  2804,  2850,  2853, -6993,  2855,  -218, 19771,
    2813, -6993, -6993,  -218,  2821,  -218,  -218,  -218,  2623, -6993,
    -293,  2623,  -233,  -451,   359,  -233,  -233,  -233,  -233,  -233,
    -233,  -233,  -233,  -233,  -233,  -233,  -233, -6993,  -233,  -233,
    -233,  -233,  -233,  -233,  -233,  -233,  -233,  -233,  -233,  -233,
    -233,  -233,   399,  -233,  -233,   409,  -233,  -233, -6993, -6993,
    1412, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993,   468, -6993,   382,   541, -6993, -6993, -6993,  2825,
    -451,   603, -6993, -6993,   382,  -233,  2868, -6993,  -293,  2870,
    -293, -6993,  -233, -6993,  -233, -6993, -6993, -6993,  5823, -6993,
    5823, -6993,  5823, -6993,  5823, -6993, 96237, -6993, -6993, -6993,
   -6993, -6993, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823,
   -6993,  5823, -6993,  5823, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823,
   -6993,  5823, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  5823,
   -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823, -6993,  5823,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  5564,  5765,
   60007, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,  1686, -6993,  -233,   606,  -233,  1686,  -233,  -233, -6993,
    1686, -6993, 98089, 18477, 96237, 14746, 23099, 22112, 24597, 22545,
   19842, 96237, 24252, 17541,  -289,  2920,  9454, -6993, -6993, -6993,
    9454, -6993,  2661, -6993,  -451,  1056,  2653, -6993, -6993, -6993,
    2776,  2777,  1843, -6993, -6993,  9454, -6993, -6993,  2766,  -451,
   -6993, -6993, -6993,  2782, -6993, -6993, 96237, -6993,  2975, -6993,
   -6993, -6993,  2944,  2950,  -289,  -289,  -289,  -289,  -289,  -289,
   19842,  -289,  -289,  -289,  -289, -6993, -6993, -6993, -6993, -6993,
   -6993,  -289,  -289,  -289,  -289,  -289,  -289,  -289,  -289, -6993,
    -289,  -289,  -289,  2875,  1863,  1863,  1863, -6993, -6993,  -289,
   -6993,  7413,  7413, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993,   455, -6993,  -289, 19842,  -289,  -289,  -289,  -289,
    -289, -6993, -6993, 96237,  2900,  -218,  5962,  3022, -6993,  7870,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
    -451, -6993, -6993,  1871, -6993, -6993, -6993,  -293, -6993,  -293,
   -6993,  2904,  -293, -6993, -6993,  2101, 96237, 88368, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
    -289, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, 95311, 88368, -6993, -6993, -6993,
   95776, 88368, -6993, -6993, -6993,   975,  4140,  8657, 96237, -6993,
   98089, 98089, -6993,  2876,  2974, 96237, -6993, -6993,  1412, 15644,
    2101, 96237, -6993, -6993,  1221,  2876, -6993,  9454,  1599, -6993,
    2923,  9454,  2924, -6993, -6993, -6993,  2916,  -289,  -289,  -289,
    -289,  -289,  -289,  -289,  -289,  -289,  1165,  1168,  -289,  -289,
    -289,  -289,  1199,  1200,  -289,  -289,  -289,  -289,  1201,  1253,
   -6993, -6993, -6993, 69047,   338, -6993, -6993, -6993, -6993, -6993,
   -6993,  1887, -6993, -6993,  1896, -6993, -6993, -6993,  1903, -6993,
   -6993,  1903,  -289,  9454, -6993, -6993, -6993, -6993, -6993, -6993,
   10074, -6993,  4101,  -289,  -289,  -233,  1898, -6993,  1906, -6993,
   -6993,  -451,  1412,  2910,   416,   382,   633, -6993,  -451, -6993,
    2911,   398, -6993,   382, -6993,  2912,   951, -6993, -6993,  2913,
    1899,  -289,  -233, -6993,  -451,  2915,   425, -6993,  -451, -6993,
    2921,   420, -6993, -6993, -6993, -6993, -6993,  1669, 96237, -6993,
   -6993, -6993,  2869, -6993,  1133,  -451,140003, -6993, -6993, -6993,
   -6993, -6993, -6993,  2653,  2653, -6993, -6993, 67917, -6993, -6993,
   -6993,  -233, -6993,  2944,  2950,  3017, -6993, -6993, -6993, 65657,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993,  3014, -6993, -6993, -6993, -6993,
   -6993, -6993, 69047, -6993, -6993, -6993, -6993, -6993, -6993,  9639,
     455,  9454, -6993, 98089,  3024,  -451, -6993,  1794,  1661, -6993,
   -6993, -6993,  1935,  1937,  1619, -6993, -6993, -6993,  1619, -6993,
    2101, -6993, -6993, 98089, -6993,  -233,  2978,  -293,  2980,  3612,
   -6993,  9454,  2981,  -293,  -289,  -233, -6993,   -71,  3031,  -233,
    -233, -6993,   -71,  -233,  -233, -6993,   -71,  -233,   382,  1943,
    -451,  8657, -6993,  1949, -6993,  1661, -6993,  1944,  1947,  1951,
    3082,   -71,  5962,  3369,  -451, -6993, -6993, 98089,   -71, -6993,
   -6993,  5823, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
    -233,  -233,  -289,   -71, -6993,  -233, -6993,  -233, -6993, -6993,
   -6993,  9454,  -233,  9454, -6993,  2101, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993,  5823, -6993,  5823, -6993,
   -6993, -6993, -6993, -6993,  5823, -6993,  5823, -6993, -6993, -6993,
   -6993, -6993,  5823, -6993,  5823, -6993,    77, -6993, -6993, -6993,
   -6993, -6993,  3045,  -233, -6993, -6993, -6993,  8034,  3058, -6993,
   -6993, -6993, -6993,  1661,  8899,  -233,  8632,  8980,  -451,  -233,
    -233,  -233,  -233,  -233,  -233,  -451,   557,  -233,  -233,  -233,
    -233,  -233,  -233,  -233, -6993, -6993,  -293,  -233,  -233,  -233,
    -233, -6993, -6993, -6993,  1686,  1300, 19842,  8657, 17637, 96237,
   96237, -6993,  2876, 96237, -6993, -6993, 19842,  1412, 19451, 96237,
   88368,  -233, -6993,  2876,  1686, 20110, 96237, -6993,  1412, 20389,
   96237,  -233, -6993,  1686, 19842, 20418, 96237, -6993, -6993, 19842,
    1412, 21185, 88368,  -233, -6993, -6993, -6993,  2914, -6993,  1961,
    -451, -6993, -6993, -6993, -6993, -6993, 79172,  -289,  2776, -6993,
   -6993,  -289,  2889, -6993, -6993, -6993,  1962,  -233,  3468, 98089,
   98089,   693, 22776,  2999,  1686,  3009,  1686, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993,  1871, -6993, -6993, -6993,
    1871, -6993,  -289, -6993, -6993,  4101, -6993,  9454,  3015,  9454,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,  2461,  -293,
    -233,  9454,  3018, -6993, -6993,  3080, -6993, 96237, -6993, -6993,
    3084,   430, -6993, -6993,  3087,   433, -6993, -6993, -6993, 98089,
   -6993, -6993,   556,   719, 22811, -6993, -6993,  -233,  1291,  -233,
   -6993, 98089, -6993,  9796,  1249,  3923,  5962,  -233, -6993,  8657,
    -233, -6993, -6993,  -233,  -233, -6993, -6993,  1358, -6993,  2467,
    2791,  2468,  -233, -6993,  -233, -6993,  3026,  -289,  -289,  -289,
    -289,  -289,  -289, -6993,  3074, -6993, -6993, -6993,   606, -6993,
    -233,  -293,  -289,  8002, -6993, -6993, -6993, -6993,  -233,  -293,
   -6993, -6993, 96237, -6993, -6993, -6993, -6993, -6993, -6993, 98089,
   -6993, -6993, -6993, -6993, -6993, -6993,  -233, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993,  3035, -6993, -6993,  2821,  2821, 96237,
     436,  -233,  -289,  1951,  5823,   449,   450, -6993,   -71, 10074,
   -6993,   -71, -6993,  -289, -6993,  5823,  3095,  3096, -6993,  3097,
     -71, -6993, -6993, -6993,  -233,  5823,  -233,  -233,   -71, -6993,
   -6993,  5823, -6993, -6993,   -71,  2821,   436,  -289,  5823,   449,
     -71, 10074, -6993,  -289, -6993,  5823,  3095,  3096,   -71, -6993,
    1860, -6993, -6993,  -451,  2954,  2956, 96237,  -289, 96237,  2952,
   -6993, -6993, -6993,   348, -6993, -6993,  2946,  2948, -6993, -6993,
    2201, -6993, -6993,  3107,  5962,  4101, -6993, -6993,  3007,  2018,
   -6993,   382, -6993, 19842, -6993, -6993, -6993,  -233, -6993, -6993,
   -6993,  -233, -6993,  -233, -6993, -6993, -6993,  -233,  9454,  -233,
    3684,  2467,  2791,  2468, -6993,  2583,  2586,  2592, -6993, -6993,
   -6993,  -233,  9454,  -233, 96237,  3114,  -233, 96237, -6993,  3116,
   96237, -6993,  3117, -6993,  4101,  2029,   382, -6993,  1412,  1245,
   -6993,  3020,  -451,  2026, -6993,   382,  8657,  8657, -6993, -6993,
   -6993, -6993,  3468,  -289,  -289,  -233, -6993, -6993, -6993,  -504,
    1951, -6993, -6993, -6993,  3027,  -233, -6993, -6993, -6993, -6993,
   -6993,  -147, -6993,  2101, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,    77, -6993,  3115, 10074,  -289,  2101,  2036, -6993,  3070,
   -6993, -6993, -6993,  3155,  3155,  2036, -6993, 10074,  2036, -6993,
    3071,  2036, -6993,  -289,  4101, -6993,  9454, 10074, -6993, -6993,
   -6993, 96237, -6993, -6993,  -233,  -233,   451, 98089, -6993, 98089,
   -6993,  -233,   456,  1512,  -233, -6993,  -233,  8657,  3134, 98089,
    -233, 98089,  -233,  -233, 96237,  3136,  9443,  3044,  1568,  -233,
   -6993,  -233, -6993,  8657, -6993, -6993, -6993, -6993,  -233,   451,
   -6993,   456, -6993,  -233,  8657,   457,  -233,  -233,  3136,  9443,
   -6993, -6993,  2914,  2995, -6993,  3133, -6993, -6993, -6993, -6993,
    1961,  1556,  3001,  3145, -6993,  2653, -6993, -6993, -6993,  1691,
   89294, -6993, 98089, -6993,  -233, -6993,  1412, 21382, 96237,  -233,
   -6993,  2876, -6993, -6993,  -501,  -501, -6993, -6993,  1686, -6993,
   -6993, -6993, -6993,  -501,  -501, -6993,  -233, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993,  -233, -6993,  -233,
   96237, -6993,  -233, 96237,  -233, 96237,  1795,  -233, -6993, -6993,
    1504,  8657, 96237, -6993, -6993, 21782,  2101, 96237,  -233,  1778,
    2876, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
    2065,  -233, -6993,  3059, -6993, -6993,  -147, -6993, -6993, -6993,
   -6993, -6993,  1661, 96237, -6993,  -233,  9454,  1686,141119, -6993,
   -6993, -6993,  -233,  -293, -6993,  -233,  9454,  -233,  -293,  -233,
    -233,  -233, -6993,  -233, 10074, -6993, -6993, 96237, -6993,  7390,
   10074,  7390, 10074, -6993, 96237, -6993,  -233, -6993,   459,  2821,
    1951, 96237,  -233,  7390, -6993,  7390, -6993, -6993, -6993, 96237,
    -233, -6993, -6993,  -233, 10074,  -233,  1951, 10074, -6993, -6993,
   10074, -6993,   459,  2821,  1951, -6993, -6993, -6993,  -233, -6993,
   -6993,  3013,  3021, -6993, -6993, -6993,  3019,  1905,  -289, -6993,
   -6993, -6993,  -289, -6993,  2235,  -451, -6993, -6993,  2994, -6993,
   -6993,  1691, -6993,  3109,  5962, -6993, -6993, -6993,  5823, -6993,
   -6993,   -71, -6993, -6993, -6993,  -501, -6993, -6993,  3066,  3068,
    1686, -6993,  1686,  -501,  2278,  2280, -6993, -6993, -6993,  -233,
   -6993,  -233, -6993,  -233,  -233, -6993,  1852,  -233,  1951,   -71,
   -6993,  5823, -6993, -6993,  -289,   -71, -6993,  -233, -6993,  1779,
   10074, -6993,  6321, -6993, -6993,  -451, -6993, -6993,   905, -6993,
   -6993, -6993, -6993,  8385,  -289, -6993,  -233, -6993, -6993,  2085,
    2086, -6993,  3129, -6993, -6993,  -233, -6993,  3130, -6993, -6993,
   -6993, -6993, -6993,  -233, 10074,  -233,  -233, 10074, -6993, 10074,
   -6993, -6993, -6993, -6993,   460, -6993, -6993,  -233,  9443,  -233,
    9443, 10074,  -233, -6993, -6993, -6993, -6993,  -233, 10074, 10074,
   -6993, -6993,  3187, -6993,  9443,  9443, -6993, -6993, -6993, -6993,
   -6993, 80288, -6993, -6993, -6993, -6993, -6993,  1691, 67917, -6993,
   -6993, -6993, -6993, -6993, -6993,  8657, -6993,  -233,  -233, -6993,
   10074,  3099,  1941, -6993,  6321, -6993, -6993, -6993, -6993, -6993,
    -501, -6993,  2281, -6993,  -233,  -293, -6993,  -233,  -293, -6993,
   -6993, -6993, -6993,  -233, -6993,  -233,  -233, -6993, -6993,  -233,
    -233,  -233, -6993, 10074, -6993,  2298,  -233,  -451, -6993, -6993,
   -6993, -6993, -6993, -6993,  -451,   557, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, 19169,  -293, -6993,
     905, -6993,  -293, -6993, -6993,    84, -6993,   297, -6993, -6993,
    2099, -6993, -6993,  9454,  -293, -6993,  9454, -6993,  -293, -6993,
   -6993, -6993,  -233, 96237,  9443, -6993,  3189,  -233,  9443, -6993,
   -6993, -6993, -6993, -6993,  -233,  9443,  1808,  9443,  -233,  9443,
   -6993, -6993,  9443,  3052,  3053,  3197,   348,  2284,  3078,  2255,
    3046,  -289,  3062,  -233,  1951,  -233, -6993, -6993,  -233, -6993,
    -233, -6993,  -233,  2036, -6993,  2036, -6993,  -501, -6993,  -501,
   -6993,  -233,  -293,  2036, -6993,  3174,  2036, -6993,  3180, -6993,
   -6993, -6993, -6993,  -233,  -233, -6993, -6993, -6993,  -233,  -233,
   -6993, 96237, 98089, -6993,  -289,  -289, -6993,  -233, -6993,  3181,
   -6993,141119,  2149,141119,  2150, -6993, -6993,   606,   606,  -233,
    3188, -6993,  -233,  3190,  3192, 10074, 10074, -6993,  -233, -6993,
   10074, 96237, -6993, -6993, 10074, 10074, 10074, -6993, -6993,  -233,
   -6993, -6993, -6993, -6993, -6993, -6993,  -289,  2661, -6993, -6993,
   -6993, -6993, -6993, -6993,  -233, -6993, 10074, 10074, -6993, -6993,
   -6993, -6993, -6993,  -233,  -293,  -233,  -293, -6993, -6993, -6993,
    2036, -6993,  3193,  -233,  9454,  -233,  9454,  4559, -6993, -6993,
   10074, 10074, -6993, -6993, -6993,  -289,  4101, -6993, -6993,  3148,
   -6993,  -233,  9454, -6993,  2157, -6993,  2161, -6993,  3196,   606,
   -6993, -6993, -6993,  9454,  3209, -6993,  9454,  9454, 10074, -6993,
    -233, 10074, 10074, -6993, 10074,  2661, -6993, -6993, -6993, 10074,
   -6993, 10074, 10074,  1819,  -293, -6993,  3211, -6993,  3214, -6993,
   -6993, -6993,  -233,  9454, -6993,  -233, -6993,  -233, 10074, 10074,
   10074,  4965, -6993, -6993,  3178,  4037,  3202, -6993,  -233, -6993,
    2188,   606,  2190,   606,  9454, -6993, -6993,  -233,  9454, -6993,
    -233,  -233, 10074, -6993, -6993, -6993,  3123,  2273,  -233,  3231,
    9454,  9454, -6993,  -293, -6993, -6993,  -233, -6993, -6993,  -233,
   -6993,  2101,  2101,  2101, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,  2341,  -293,  -233,  -233,  -293, -6993,  3219, -6993,  2200,
   -6993, -6993, -6993, -6993,  -233,  3233, -6993,  -233,  3235, -6993,
   -6993, -6993,  2313, -6993, -6993,  9454,  -233,  -233,  -293,  3238,
    -293, -6993, -6993, -6993, -6993,  3153, -6993, -6993, -6993,  2467,
    2791,  2468,  7985,  2583,  2586,  2592, -6993,  3256,   690,   601,
   -6993,  3194,  3198, -6993,  3227, -6993,  2207,   606,   606, -6993,
    9454, -6993, -6993,  9454, -6993,  2333,  2914,  -233, -6993, -6993,
    3243,  9454,  3244, -6993,  3245,  3246, -6993,  3247,  3234, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,   861,
    -233, -6993, -6993, -6993, -6993, -6993,  3148, -6993, -6993,  3148,
   -6993,  3248, -6993, -6993, -6993, -6993,  -233,  3250, -6993,  -233,
    3251,  2914, -6993, -6993, -6993, -6993, -6993,  9454,  -233,  9454,
    3252,  9454,  9454, -6993,  2220,  2221, -6993, -6993, -6993, -6993,
    3148,  3148,  3148,  3148,  3148,  3148,  3148, -6993,  3247,  1029,
    3210, -6993,  2036,  2036, -6993,  9454,   606,  3257, -6993,  9454,
    3258, -6993,  9454, -6993, -6993, -6993,  3259,  3274,  -233, -6993,
    -233,  9454,  -233,  -233,  3148,  3228,   644,  3224, -6993, -6993,
   -6993,  3153, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993,  3277,  2249,  2252,  2269,  2271,  2272,  -233,
   -6993,  -233, -6993, -6993, -6993,  -233, -6993, -6993, -6993,  -233,
   -6993, -6993,  -233,  3303,  9454,  9454, -6993, -6993, -6993,  -233,
   -6993, -6993, -6993, -6993, -6993, -6993,  -451, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993,  3148, -6993,  3301,  3304,  3302,  3307,
    -233,  3308,  3265,   861,  3268,  2036, -6993,  3316, -6993,  3317,
   -6993,  9454,  -233,  -233, -6993,  3318, -6993, -6993, -6993, -6993,
    1619,  1619,  2101, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993,  3273, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993,  -233, -6993, -6993,  3320,  9454,  3321,
   -6993,  3323,  3328,  1871,  1871,  -289, -6993, -6993, -6993,  -233,
    -233,  -233, -6993,  2036,  2036,  3346,  3357,  3358, -6993, -6993,
   -6993,  9454,  -233,  9454,  3360, -6993, -6993,  -233,  -233,  -233,
   -6993, -6993, -6993, -6993,  3327, -6993,  2036, -6993, -6993, -6993,
   -6993, -6993, -6993,  3374,  3380,  -233, -6993,  -233, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993,  9480,  3337,  8817,  -233,  3384,
   -6993, -6993, -6993, -6993, -6993,  -501,  -419,  -501, -6993, -6993,
   -6993,  -233, -6993, -6993, -6993,  3400, -6993,  3355,  3356, -6993,
    3497, -6993,  2361,  2036,  2036,  2036, -6993,  3406, -6993,  3408,
   -6993,   921,  3363, -6993,  -233, -6993, -6993, -6993, -6993, -6993,
    2036, -6993,  2036, -6993,  -233,  2036,  -233, -6993,  -233, -6993,
   -6993
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -6993, -6993, -6993,     5, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993,  2790, -6993,  2789, -6993, -6993,  1220, -6993,
   -6993, -6993, -6993, -6993,  3490,  3452, -6993, -6993, -6993, -6993,
   -6993,   566, -6993, -6993,  2314,  6631,  -413, -6993,  9089, 16370,
    1438,  -677, -2265, -2505, 30792,    -7, 20787, 26376, 24733, -2173,
   -6993, -6993,  4262, -6993, 10762, -2454, -1219, -2769, -1925,  -941,
   -2979, -2499, -3244,  -431, -3242,  -430,  7782, -1699, -6993, -6993,
   -6993, -6993, -6993, -4496, -6993, -6993, -6993, -6993, -6993,  -696,
   -1316, -4232, -4230, -5849, -4229, -4814, -4813, -4808, -4803, -6993,
   -6993, -6993, -6993, -6993, -6993, -3952, -6993,   -13, -3576, -4241,
   -3975, -6993,  -129,  -735,  -720, -6993, -6993, -6993, -5140, -6993,
   -6993, -6993,  3559, -6993, -1001,  -991, -6993,  4159,  2429, 20164,
    3489, -6993,   321,  9528, -6993,  1248, -6993, -6993, -6993, -6993,
   -6993, -6993,    33, -2250,  1284, -6993,   651, -2179,  2796, -6993,
   -6993, -6993, -6993,  -123,  -118, -6993, -4802, -6993, -6993, -4079,
   -6993, -6993, -6993,  9962, -1420, -2144, -5847, -6993, -3300, -6993,
   -5089, -4861, -4754, -5003, -6993, -4873, -6993, -6993, -5400, -6993,
   -6993, -5647, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -4100, -6076, -6190, -5872, -5331, -5889, -6993, -6993,  2748, -6993,
   -6993, -6993,  7690,   -11, -6993,  2734, -6993, -6993,  3150,   120,
     786,  3147, -6993, -6993,    55, -1161, -1633, -6993, -6993, -6993,
   -6993, -6993, -6993, -2943, -6993,   -74, -6652,  -422, -6993, -1950,
   -1201, -4194, -6993, -5957, -2899, -6993, -6993, -6993, -6942, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -4827, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6082, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -2912, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -5060, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -3916, -6993, -6993, -3977, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6748, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -4401, -6993, -6993, -6993, -6993, -6993,
   -4553, -4371, -6993, -3184, -3005, -6587, -6993, -6993, -6993, -6993,
   -6993, -6993, -2768, -3445,  8456, -4630, -6993, -3276, -4926, -6993,
   -6993, -6993, -6993, -6993, -6785, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -5548, -6993, -2289, -5788,
   -6992, -2691, -4047, -3117, -3635, -6993, -6993, -6993, -6993, -6993,
   -4913, -6993, -6993, -6993, -6993,  -631, -3643, -6993, -6993, -6993,
   -6993, -6993, -3633, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -2911, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -4388,
   -3638, -6993, -2014,  -856, -6993,  -854,  -853,  -849, -5333,  -850,
   -6993,  -845, -6993,  -844,  -842,  -847,  -841, -6993,  -840, -6993,
    -839, -6993,  -837, -6993,  -835, -6993,  -834,  -833, -6993,  -832,
   -6993,  -829, -6993, -6993,  -828, -6993,  -825, -6993,  -824,  -819,
   -6993,  -818, -6993,  -817,  -815, -6993,  -814,  -812,  -811, -6993,
   -3645, -6993, -6993, -6993,   512, -6993, -6993, -6993, -3644, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -3642, -6993, -6993, -6993, -6993, -6993, -5116, -6993,
   -6993, -6993, -6993, -6993, -6993, 21176, -2791, 19845, -6993, -6993,
   -6993,  5057,   -48, -6993, -6993, -6993,  1390,    69,  -439,   757,
   -6993, -6993,   889,  1522, -6993,  1444,  1445, -6993, -6993, -6993,
   -6993,  2402,  1448,  3290,  -821,  2953,  2955, -6993,  7246, -5736,
   -6993, -6993, -2498, -2690, -6993, 24287, -1452, -6993, -1325, 11156,
   15274, -1269, -2247, -3548, -2287,  -985, -2343, -6993, -2201, -2576,
   -1558, -3485,  2035, -1467, -1568, -2500, -6993, -3195, -3784, -6993,
    -768, -6993, -2320, -4624, -4618, -4611, -6993, -4596, -4585,   480,
   -4574, -6993, -4487, -2727,  1523, -1462, -6993, -2784, -6993, -1035,
   -6993, -6993, -6993, -6993, -6993, -3222, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, 21991, -2097, -2337,   896,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993,  -319, -6993, -6993, -6993, -6993, -6993, -3225, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -1078, -6993, -1079, -6993, -6993,
   -6993, -6993, -6993, -6993,   827, -6993,   357, -1260,  -274, -6993,
   -6993, -6993, -6993, -6993, -3836, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -3282, -3155, -6993, -6993, -6993, -6993, -6993, -6993,
   -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -6993, -4457,
   -6993, -6993, -6993, -3817, -6993, -2550, -5201, -6993, -6993, -5170,
   -6993, -6993, -5169, -6993, -6993, -6993, -6993, -2539, -6993, -6993,
   -6993, -6993, -6993,   517, -1386, -3551, -6993, -6993, -6993, -3598,
   -6993, -6993, -6993, -6307, -6993, -6993, -6993, -6306, -6993, -6993,
   -6993, -5587, -6993, -6993, -6993, -6993, -6993, -6993, -2963, -2760,
   -2494,   528,  -637, -2686, -2654, -2658, -2714, -3752, -1908,  -182,
   -6993, -4034, -6993,  -390,  -997, -2734, -3654,  -391, -2086,   597,
   28041, -6993, -6993, -6993, -2124, -2013, -6993, -6993, -6993,  1565,
    -330, -2831, -1680,  -880,  -874, -4178, -1024,  1497,  1524, -6993,
   -6993, -6993, -6993, -1759,  -551, -2740
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -3275
static const yytype_int16 yytable[] =
{
      51,    51,    51,    51,    51,   429,  2355,   778,    51,   766,
    2914,  3815,  3874,  1120,  3705,  2426,  2235,  3212,  3214,  3216,
    3120,  4254,  4257,  4870,  4869,  4259,  4258,  4871,  3672,  2520,
    1155,  4256,  4255,  2522,  3139,  1271,  5418,  5432,  5419,  5405,
    5407,   503,  4312,   507,  5420,   386,  4843,  3205,  3197,  3623,
    4530,  3625,  4532,  4533,  4514,   370,  5523,   376,   378,  4519,
    4993,  2370,  5114,  4996,  4997,  5946,  3507,  4343,  5627,  3360,
     420,  6290,  3956,    51,  3566,  3511,  5893,  2526,  2529,  4921,
    5046,  3966,  5071,  3967,  4729,    51,    51,  3187,  3187,   -84,
    4517,  3617,  4995,  -399,  -387,  7161,  6507,  4272,  -322,  2161,
    6511,  4280,  -432,  2402,  2403,  4313, -3166, -3170,  4495,  4497,
    4501,  4505,    51,    51,    51,    51,    51,    51,    51, -3168,
      51,    51,    51,  5834,    51,    51,    51,    51,    51,    51,
   -3169,    51,    51, -3173,    51,    51,    51,    51,    51,    51,
      51,  3350, -3171,  4230,  2876,  -328,  3356, -3172,  3848,   479,
    -330,  3849,  1262,  -336,  1263,  -331,  -332,    51,   -84,    51,
    2233,   -84,  5514,  5524,  2949,   -84,  2234,    51,    51,    51,
    2988,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,  4909,  -350,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,  2995,  3111,  7163,  3476,
    3477,    51,   -75,  -336,    51,   -93,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  2994,  4922,  3965,  3404,   -75,  3406,
     759,  4883,    51,  -349,  3848,  5414,  4911,  3849,  -122,  3227,
    3230,  5613,  3278,    78,    79,  6841,  6842,  5614,   790,  3246,
     791,  2337,  3965,   719,  5615,  6442,   724,  3796,  3965,  4727,
    4114,   730, -1985,  4980,  4981,  3128,  3298,  -113,  3327,  5616,
    2342,   792,  1189,  3476,  3477,  3794,  5776,  4113,  4114,  4115,
    5617,    51,  2955,  4727,  4114,  4115,  3275, -1112,  3279,  3280,
     790,  5618,   791,   762,   847,   762,   848,  3371,  1179,  5820,
    6373,   786,  6704,    90,   500,  5529,    90,    51,    51,  6345,
    3210,    51,    51,   792,  3328,  6219,  5805,   849,    51,    51,
      51,    51,    51,    51,    51,    51,  5810,  3364,    51,    51,
    3368,    51,    51,  6209,   503,  3369,  4719,  6219,   503,  5958,
    -121,  2515,  6209,  3372, -1114,  3457,  3515, -1061,  3518,  6345,
   -1059,  3385,  3524,  6621,  2785,  2786,  2787,  2888,   780,  3544,
      90,  2789,   763,   764,   765,  3472,  6627,  6629,  6797,  2238,
    5959,  5960,  3946,  6804,  6811,   803,  6951, -1180,  5619,  3839,
     785,   789,  3845,   833,  4648,  6514,  2741,  -316,  -406,   817,
    6205,  6577,  -406,  3583,  -316,  2761,  7351,  2990,  7353,  5285,
    5287,  5835,  5467,  7508,    38,  5932,   834,  3841,    51,  1112,
    2766,  3840,  2768,   852,   853,   362,   363,   364,   365,   366,
     367,   368,   369,    68,    69,    70,    71,    72,    73,    74,
      75,  2879,   685,  2883,  2884,    40,   686,  6545,  2906,  3576,
    5971,  6653,  4534,  4535,  4536,  4537,  4538,  4539,   810,   811,
     812,  7598,   711,  3592,  3594,  6664,  3596,  6652,  3394,  3396,
    7250,  7251,  4672,  4674,  3402,  7570,  5385,  3403,  7296,  3405,
    6662,  6224,  3559,  6839,    43,  3564,  4742,  6228,   712,  4845,
    6233,  4850,  3513,  2530,  4852,  4851,  3521,  3581,  6240,  4847,
    4846,  2531,  7443,  7444,  2815,  5409,  5413,  3598,  5412,  3604,
    3607,  6875,  6758,   -84,  3613,  6876,    47,  6036,  3138,  6038,
    1472,  3138,  6042,  3194,  3194,  3425,  2830,  2833,  2836, -1958,
    2840,  1475,  3568,  3571,  2800,  7347,  5386,  5387, -3214,    48,
    1479,  1480,  1481,  1482,  1483,  1484,    90,    91,  7672,  7434,
    7674,  2952,  7305,  3599,  2953,  3605,  3608,  7435,  2509,  3562,
    -318,  1100,  3614,  6720,    49,  4763,  1111,  -318,  2301,  5528,
    2302,  5530,  2303,  1111,   -66,  2512,   -66,  2513,    56,  5308,
    2514,   -66,  3842,  4458,  4459,  4788,  4461,  4462,  -408,  4464,
    4465,  7536,  -408,  1206,  1207,  3867,  3514,  7698,  3517,  3870,
    1153,  3522,  3523,  3138,   724,  2814,   734,   735,  3880, -3194,
    3882,  5886,  3884,  1146, -3194,  4595,  5887,  4120, -3194,  -407,
    2304,  3187,  3187,  -407,  3844,    57,  1535,  2967,  2850,  2852,
    1539,  5757,  5754,  7554,  1543,  3187,  6116,  7431,  1547,  3187,
    1549,   502,  1551,    91,  1553,  7432,  1555,  3119,  3187,   781,
    3187,  4250,  3187,  7433,   719,  7562,  7563,    64,  1208,  2974,
    2975,   782,    51,  3486,    51,    51,  5888,  5889,  5890,  5891,
     683,  3487,  3488,  6345,   771,   772,  7555,   684,  2571,  3489,
    3490,  2408,  3622,  -329,    65,  2412,  6345,  -329,  2572,  2573,
     835,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2409,  2581,
    3428,   375,  2409,   836,  2582,    90,  2410,  3439,  3445,  4216,
    2410,  5478,  3974,  5910,  3975,  3976,  1100,  1256,  5912,  5011,
    5047,    51,  5072,   384,  4223,  1209,  4704,    51,  2800,   687,
    1215,  1216, -3214,  1219,  1220,  3469,  3470,  6546,   479,  6547,
     719,   719,   682,  6873,  6548,  6767,  -286,  1190,   500,  1191,
      90,  1235,  1236,  -286,  1238,  1239,  1240,  1241,  3723,  1243,
    1244,  -337,   717,  1246,  1247,  -337,  1248,  1249,  7650,  7651,
    7652,   687,  5915,  5923,  5915,  5923,   717, -1957,  5915,  1524,
     687,  1254,  1255,   722,  4227,  4228,  6345,  6298,  7100,  7101,
     687,  1210,  1211,  6312,  5439,  1301,  3722,   479,   727,  3725,
    2583,   767,  6212,   479,   725,   768,  6111,   719,  -771,  -771,
    6223,   733,   -81,  6883,  2511,   687,  -771,  -771,   719,   504,
    1335,    90,  3584,  -771,  -771,   719,   719,   719,   719,   719,
     719,   719,   719,   719,   719,   719,   719,   719,   719,   719,
     719,   719,   719,   719,   719,   719,   719,   719,   719,   719,
     719,   719,   719,   719,   719,   719,   719,   719,   719,   719,
     719,   719,   719,   719,   719,   719,   719,  1098,   775,  3810,
    3811,  2284,  3813,  3814,  2800,  3816,  3817,  5468, -3214,  5469,
    3912,   736,  2165,   719,  2512,   719,  2513,   719,  4228,  3113,
     799,   719,   719,  3702,   719,  6400,   719,   841,   719,  6401,
     719,  4119,   719,  6402,   719,   737,   719,  6403,   719,  6404,
     719,  6405,   719,  7192,   719,   719,  7193,   719,  3835,   844,
     687,  4835,  5840,    51,  5842,  1338,  5388,   738,  5389,  5390,
       1,     2,     3,     4,     5,  3247,     6,     7,     8,  3248,
       9,  5402,    10,  4446,    11,  6327,  3620,  5958,  1098,   687,
     687,  2800,   717,    12,    13,  1400,  3834,  5306,   -81,   -81,
     -81,   -81,   -81,   -81,   -81,   -81,   -81,   -81,   -81,   -81,
     -81,   -81,   -81,   -81,   -81,   -81,  7523,  7524,  5959,  5960,
     739,  3209,  6345,  3949,  7525,  7526,  2562,  2563,  2280,  7452,
    7453,  7527,  7528,  5478,  3123,  3124,  6057,  3126,  3127,  1100,
    3129,  3130,  3493,  3494,  3495,  3496,  3497,  3498,  3499,  3500,
     506,  1536,    91,  6430,  3878,  1540,   687,  3628,  3629,  1544,
     854,  1402,  3282,  1548,  6443,  1550,  3283,  1552,   687,  1554,
     719,  1556,  2235,  1404,  7493,  7494,  4494,  6740,  4500,  4504,
    4521,  4522,  4480,  2286,  6749,  2596,  2563,  4482,   724,   724,
     724,   724,   724,   724,   724,   724,   724,   724,   724,   724,
     724,   724,   740,   724,   724,   724,   724,   724,   724,   724,
     724,   724,   724,   724,   724,   724,   724,   724,   687,   724,
     724,   724,  1100,  1406,   724,   724,  1212,  5767,    90,  5953,
    5772,  4489,  4493,  4540,  4499,  4503,  4492,   687,  4498,  4502,
    -911,   687,  1408,  2371,  2372,   687,  1410,    51,    51,  2277,
    1412,  -399,  -387,   741,  -322,  2795,  -387,  6345,    14,  -432,
    5296,  5297,   687, -3166, -3170,  3226,  3229,  1414,   815,  5949,
    5950,   818,   819,  6357,   821,   822, -3168,  2399,   742,   687,
    5883,    51,  4231,   687,  1416,  5896,   743, -3169,  1418,  5901,
   -3173,  6345,  1100,  1100,  1264,  2358,  2359,  2360,   722, -3171,
    3262,  -328,  2364,  2365, -3172,  5732,  -330,  3194,  3194,  -336,
    3846,  -331,  -332,  4647,   760,  5428,  2797,   760,   744,    49,
    5433,  3194,  2798,   479,   479,  3194,  5435,   687,  5436,   745,
    5437,  4095,  1420,  6620,  3194,  6437,  3194,  2393,  3194,   687,
     687,   746,  6447,   687,  1422,  1424,  6453,  2990,  1426,   687,
    3358,  6254,  6255,  3362,  1428,  5115,  3366,   479,  6467,  3609,
    3267,  5662,  3273,  3610,  2990,   703,   704,   705,   706,   707,
     708,  3224,  3228,  4479,  3281,  5648,  5649,  3384,  3390,  5478,
    3237,   687,  6115,  2990,  4483,  4484,  2977,  6909,   687,   747,
    3286,  6020,  3966,  2979,  3967,   687,  4714,  5182,   687,  2990,
    2981,  -339,   749,  2983,  4594,  -339,  3260,  4721,  6565,  5517,
    3265,  3268,   687,  3187,  3844,  5613,  4754,  2997,   687,  2990,
    3276,  5614,   687,  2999,  3187,  3187,  5279,  3001,  5615,  4771,
    5280,  4776,   687,  4779,  4780,  3391,  3187,   687,  3187,  3187,
    3399,  3400,  3003,  5616,  3905,  5279,  3318,  2990,   750,  5284,
    3478,  3349,  6569,  -908,  5617,  3620,  3355,  2165,  5478,  3361,
    2800,  6421,  3365,  7647,  7648,  5618,   503,   -75,   751,  -336,
     760,   760, -1947,  4836,  4837,  3370,   760, -1947,  5415,  2990,
    3373,  3374,  3413,  3414,  3415,  3416,  3417,  3418,  3421,  3424,
     722,  4603,   752,  5768,  2338,  -286,  5773,    51,    51,   839,
    4614,   840,  -286,  6554,   687,  2990,   687,   793,  3512,   722,
     753,  2990,  3520,  2343,  3458,  3459,   687,  6575,  5517,  5777,
    1098,  3005,  7227,    51,  4982,   754,   722,    51,  6701,    51,
      51,    51,    51,    51,  3478,    51,  6259,  6260,  1098,    51,
     755,    51,  5821,    51,  1098,    51,    51,  5915,  6501,   793,
     756,   337,  5619,   850,   787,   722,   757,  6037,  6220,  5806,
    5279,  7423,  6043,   758,  5286,   722,  5996,  5997,  5998,  5811,
     687,  3525,   722,  6739,   769,  3007,  6210,   687,  3537,  3538,
    6242,   722,  6750,   722,   770,  6236,   722,  6633,  3552,   722,
    3554,  4471,   722,  3555,   855,  7096,  3556,    51,    51,   687,
    6648,    51,   760, -1364,  3015,   722,   722,   722,   337,    51,
    6555,   783,   722,   722,  1098,   722,   722,  7291,  6713,  6714,
     687,   687,   687,  3595,   722,  3017,  3019,  3021,  5818,  2781,
   -1365,  2783,  2784,    51,  2927,    51,  2918,    51,    51,    51,
    7266,  2990,  6874,  1265,  1109,  2799,   687,    51,   687,  5893,
    5893,  3023,    51,  3025,   687,   687,  3573,  3965,    51,  3033,
    3035,    51,  5478,  7623,  7624,  6897,  3965,  4344,   687,   687,
    3972,  6806,  5517,  3037,  3039,  3597,  3600,  3603,  3606,  1119,
    2990,  5729,  3612,   687,   687,  2990,  1149,   687,  3041,  3043,
     687,  6908,  3051,   687,  1154,  3053,    51,   722,  3055,    51,
    6736,  5825,  2990,  -179,   687,  6277,  6278,  6279,  7314,  3057,
    1157,   687,  4569,  6280,  6281,  6282,  3059,  5669,  5670,  5671,
    7382,  6283,  6284,  6285,    51,   687,    51,  6823,  5517,   687,
    3061,  5893,  4095,  4593,  3069,  4473,    51,  4561, -1851,  6808,
      51,  6723,  6118,  6724,  6119,    51,  6120,  6718,    51,  6725,
     687,    51,   687,  4669,  4671,  3071,  6825,  3073,  4570,   722,
    4574,  4576,  3972,  5831,  4681,  1195,  6832,  5116,  5117,  4583,
    4686,   687,  3972,  4472,  6849,  6850,  3075,    49,  3972,  4477,
    4228,   687,  2510,  1226,  2151,   687,  3077,  2152,  3448,   722,
    3079,  1221,  3972,  6213,    51,  3453,  3455,  3852,  3853,  3854,
    3855,  3856,  3857,  4658,  4660,   687,  1222,  4627,   687,  3465,
    3081,  4673,   687,  3083,  6870,   687,  2270,  3085,  4733,  2520,
    3091,  2522,  4681,  4735,  2271,  4685,  3803, -2088,  3479,  4690,
   -2089,  2282,   717,  3708,  4108,   717,    51,   687,  2283,  7273,
     687,   687,  4130,    51,    51,  4202,  4209,  4762,  2525,  2528,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
    2520,  2291,  6903,  6420,  5745,  3543,  5969,  4787,  6612,  3546,
    2900,  2901,  2902,  2903,  2904,  2905,  5963,  5964, -3044,  6245,
    6246,   687,   687,  6444,    51,    51,  4335,  4337,  4744,  3972,
     687,  2292,  6456,  3578,   687,  4339,  6896,    49,  1217,  4341,
      90,   687,  3586,  3588,  3590,   687,  4346,   687,   687,  2293,
    4348,  3972,  4350,  4352,    51,    51,    51,  6509,  6862,    51,
      51,    51,    51,    51,    51,    51,    51,  6855,  6856,   687,
      51,  2616,  3801,  6504,  4354,  6506,  5478,  5478,   687,  6907,
    7036,  2617,  2618,  4356,  2619,  2620,  2621,  2622,  2623,  2624,
    2625,  4773,  2626,  4778,  6894,  5517,   687,  2627,  4095,  3194,
    3846,  4358,  4641,   687,  4642,  2294,  5478,   687,  4360,  7189,
    3194,  3194,  4362,    51,    51,    51,    51,  5478,   687,  2296,
    7318,  3194,  3194,  4364,  3194,  3194,  1252,   -84,    90,  2781,
     687,  3114,    51,  3117,  1472,  4368,    51,  4774,   687,   687,
    2299,  4824,   687,  4370,  4372,  1475,  4706,  4374,   687,    51,
      51,  7023,  5517,  4376,  1479,  1480,  1481,  1482,  1483,  1484,
      90,    91,   687,    51,    51,    51,   -73,  4378,   687,   687,
     687,  7002,  1485,  4380,  4382,  4384,   687,  5403,   687,  2306,
     687,  4386,   687,  4390,  4705,  4392,  2277,  4394,  2278,   687,
     687,  5111,  2307,  2628,  4396,  4398,   687,  4731,   687,   687,
    4734,  4400,  2352,  4402,  4404,  7035,  4736,  3844,    51, -3052,
    6670,  6671,  5143,    51,    51,  3851,  3852,  3853,  3854,  3855,
    3856,  3857,   -81,   687,   -81,  2356,    51,    51,  4406,   687,
    3858,  3187,    51,  2376,  4408,    51,    51,   687,  7113,   687,
    7120,  5517,  4412,   687,  4414,  6879,  6528,   722,  4416,    51,
    2407,  6226,    51,  6884,  6885,    15,    16,    17, -3077, -3077,
   -3077,    51,    51,    51,    51,    51,    51,  2507,   687,    51,
    2776,  7143,  2165,  4418,  2165,  2165,  6520,  6707,   687,  6709,
     687,  6021,   687,  4420, -1947,  4422,  1099,  5175,  2165, -1947,
     687,  2277,   687,  2913,  2518,  5538,  4645,  5540,  6423,  6576,
     687,  4651,  6578,  -113,  4655,  5542,   687,  4661,  4663,   687,
    4666,  5544,  2521,    51,  5553,    51,    51,    67,  -115,   687,
     687,  -121,   687,  4663,  5555,  5557,  4684,  5559,  5288,    51,
    2800,    68,    69,    70,    71,    72,    73,    74,    75,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,   687,  6921,    51,    51,
     687,  5561,   687,  1524,  5301,  5563,  2913,  5571,  6853,  3660,
     687,  6933,  4756,  4758,  4760,  5573,  4764,  4766,   687,  6941,
    2788,   687,   687,  5575,  6414,  7003,  5577,  5579,  2790,   687,
     687,   687,  2911,  7012,  5581,  5589,  5591,  4790,  4791,   687,
     687,  4794,  4795,  2916,  5593,  5595,  2800,   687,  2280,  4095,
    6570,  1250,  5597,   687,  2885,   687,  1111,  2800,  5599,  1100,
    2956,  2957,   701,   702,   703,   704,   705,   706,   707,   708,
    2907,  6719,  2936,   687,  6721,  2889,   687,  2924,  6136,  2890,
    1146,  6138,  2891,  2892,  2893,  2894,  2895,  2896,  2897,  2898,
    2899,  2900,  2901,  2902,  2903,  2904,  2905,  6618,  6619,  4005,
    4006,  4007,  4008,  4009,  4010,  4011,  4012,   687,   687,   687,
    5124,  1100,  6144,  6146,  6152,  -196,  1100,  6881,  3630,  3631,
    3632,  3633,  3634,  3635,  3636,  3637,  3638,  3639,  3640,  3641,
    3642,  3643,  3644,  3645,  3646,  6656,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
    5144,   722,  4095,  7349,  2940,  6742,  7481,  5144,  2973,  7484,
    7128,   687,  2958,   690,   691,   692,  6154,  5091,   693,  5179,
    4095,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,  6927, -2950, -2950, -2950,
    7515,  7516,  7517,  7518,  7519,  7520,  7521,  6559,  7013,  2964,
    7016,  7130,  6560,  7014,   719,  7017,  7131,  7149,  5517,  6599,
    3885,  3886,  3887,  3888,  3889,  2987,  7386,  6610,  7387,  7388,
    7389, -2953, -2953, -2953,  7552,  3009,   719,   719,   719,  2235,
    7199,  7200,  2972,  7124,  5048,  7126,  5073,   719,   719,   719,
     719,  3010,  2165,  3011,  2165,  3012,  2165, -3079, -3079, -3079,
    5725,    77,    77,  4454,  3013,  6359,  3014,  6751,  6752, -2963,
   -2963, -2963,   719,   719,   719,  6361,  6360,   719,   719,  3027,
    4055,   719, -3056, -3063, -3057,  3028,   719,  7217,  3029,  7219,
    4055,  7713,  7714,    51,  7599,    51,  4055,    51,  3045,  7009,
    3046,  7011, -3060, -3065, -3061,  3096,   724,  4616,  4621,  3557,
    3560,  3662,  4055,  1497,  1498,  1499,  4206,  4208,  4213,  4215,
    4443,  4444,  3140,  3115,    51,    51,  3118,  3663,  3132,  3664,
    3136,  3665,  3134,  3666,  3138,  2990,  6821,  3198,  3667,  3803,
    3668,  3202,  3669,  3207,  2285,  3862,  3863,  6024,  6810,  3208,
    3211,  3213,  3117,  6028,  3793,  4095,  4228,  3215,  7211,  7426,
    3231,  7427,  3475,  3492,  6826,  3509,  -233,  7428,  5290,  4452,
    3846,  3673,  3677,  3846,    67,  6834,  3681,  5736,  5738, -1852,
    3688,  3670, -1957,   -96,  3819,  5144,  3823,  4095,    68,    69,
      70,    71,    72,    73,    74,    75,  3827,  3194,  3830,  3903,
    3907,   -85,  4029,   -93,  7463,  -101,  5289,  4055,  4031,  4105,
    5293, -3274,  4107,  4109,  4111,  2935,  4123,  4126,  4133,  4136,
    4163,   -89,  4226,  6022,  6023,  4235,  4237,  2345,  7509,  4323,
    4327,  4328,  4366,  4367,  4055,  4447,  4456,  4448,  4455,  4460,
    4866,  4463,  4475,  4486,  4516,  3801,  4520,  4549,  6521,  4562,
    6525,  4696,  6898,  6527,  6526,  7280,  3726,  4567,  6523,  6522,
    7629,  7630,  7631,  4571,  4587,  7522,   480,  4692,  4697,  4708,
    4725,  4739,  4740,  4745,  2990,   481,   482,   483,   484,   485,
    4769,  4607,  4609,   486,   487,   488,   489,   490,  4833,  4612,
    4617,   491,   492,   493,   494,  4839,  4872,  2405,  2406,  6953,
    4568,  4874,  4572,  4575,  4881,  4579,  4580,  4581,  4582,  4876,
    4882,  4885,  4584,  4585,  4586,  4886,  7322,  4887,  7324,  4888,
    4889,  4632,  4890,  6971,  4637,  4639,  4891,  4892,  4893,  4894,
    4895,  4602,  4608,  4610,  4611,  4896,  7685,  7686,  7687,  4897,
    4613,  4619,  4899,  4900,  4901,  4902,  4903,  4904,  4905,  2889,
    4906,  4907,  4908,  2890,  4913,  4914,  2891,  2892,  2893,  2894,
    2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,
    2905,  4631,  4633,  4634,  4636,  4638,  4915,  2889,   760,  4918,
    4924,  2890,  4927,  4926,  2891,  2892,  2893,  2894,  2895,  2896,
    2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,  2889,
    4979,  4990,  5092,  2890,  4928,  5093,  2891,  2892,  2893,  2894,
    2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,
    2905,  6932,  4987,  3849,  5097,  5098,  6937,  2165,  5099,  5102,
    5107,  2165,  2165,  2165,  2165,  2165,  2165,  2165,  2165,  2165,
    2165,  2165,  2165,  2165,  2165,  2165,  2165,  2165,  7090,  5101,
    7092,  5106,  5118,  5112,  2990,  5120,  4321,  5121,  5126,  2990,
    5127,  5128,  5153,  4806,    51,  5129,  5130,  5131,    51,  5177,
    5295,  4005,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,  3329,
    3330,  3331,  3332,  3333,  3334,  3335,  3336,  5410,  5315,  6288,
    4982,  5423,  5535,  5424,  6293,  6294,  7114,  5425,  5537,   724,
    5429,  5635,  4094,  5631,  5654,  4103,  4104,  4803,  5658,  5674,
    5677,  4106,  5680,  5714,   724,   724,  5715,  3695,  5716,   724,
     724,  5723,  3695, -3220,  5742,  1100,  5752,  5753,  4578,   724,
     724,  5754,  5688,  4832,  5756,  4781,  4782,  4783,  5760,  1100,
    1100,  5763,  5837,  5829,  5841,  5943,  3828,  1100,  1100,  1100,
    1514,  5962,  5961,  5684,  5966,  5817,  5972,  4802,  4804,  4805,
      49,  5689,  4095,  4095,  7179,  -114,  4625,  5684,  7183,    67,
    5970,  -116,  5995,  5279,  6011,  7188,  6033,  7190,  6041,  4823,
    4825,  4826,  4829,    68,    69,    70,    71,    72,    73,    74,
      75,  6077,  6074,  5276,  5277,  5278,  2527,  6121,  6123,  6124,
    6161,  6164,  2991,  3711,  3712,   690,   691,   692,  6168,  6230,
     693,  6202,  6203,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,  6208,  6218,
    6225,  6229,  4095,  6235,  6252,  7697,  7701,  7702,  -122,  6241,
    5275,  6269,  6273,  7135,  6275,  2165,  7138,  2165,  6317,  6328,
    2165,  4652,  6297,  3828,  6299,  6311,  6332,  6335,  4664,  4665,
    6336,  5713,  2277,  6338,  3828,  2235,  2150,  3828,  2151,  6376,
    3828,  2152,  6382,  6472,  6476,  6491,  6502,  6489,  4240,  4687,
    1497,  1498,  1499,  3828,   719,   719,    51,  6505,    51,  6518,
    7159,    51,  6532,  1114,  4241,  1114,  4242,  6534,  4243,  6590,
    4244,  6537,  7170,  4245,  6540,  4246,  7174,  4247,  6616,  4248,
    6582,  3803,  6639,  6641,  6644,  6676,  6677, -3074,  3195,  3195,
    6309,  6686,  3832,  6687,  6692,  6697,  4095,  4095,  6698,  7422,
    7425,  6730,  7424,  6733,  6735,  6738,  6747,  3828,  6745,  6762,
    6769,  6773,  4746,  6776,  6786,  4749,  6778,    67,  3670,  3828,
    6508,  6811,  6510,  6819,  6822,  5684,  6843,  6844,    51,    51,
    7222,    68,    69,    70,    71,    72,    73,    74,    75,  6851,
    6852,  6913,    51,  2524,  6978,  6915,    51,  1114,   724,  -767,
    6982,  6979,  6990,  6992,  5719,    51,  7005,    51,  7007,    51,
    3828,  7071,  7072,  -767,  -767,  -767,  -767,  -767,  -767,  -767,
    -767,  -767,  7073,  7076, -1180,  7166,  7181,   719,  1114,  7119,
     719,  1535,  1536,  7194,  7195,  1539,  1540,  3801,  3828,  1543,
    1544,  3828,  7196,  1547,  1548,  1549,  1550,  1551,  1552,  1553,
    1554,  1555,  1556,   719,  7201,   719,   719,   719,   719,  3828,
     719,   719,  7276,   719,  7278,  3828,  7198,  7224,   719,   719,
   -2961,   719,   719,  7226,  7242,  7245,  7247,  5750,  5751,  1114,
      67,  7253,  -740,  -915,  7256,  7257,  7283,  -919,   719,   719,
    7304,   719,   719,   719,    68,    69,    70,    71,    72,    73,
      74,    75,  7464,  7308,  7320,  5703,  5705,  7321,  7346,  5707,
    5708,   719,  7329,   719,  7350,   719,  7352,   719,  7363,   719,
     719,   719,  7319,  6080,  7365,  7394,  -923,  7400,  7430,  7403,
     719,  7411,  7440,  7442,  7437,   719,  7457,  7459,  7438,  7461,
    7462,   719,  7485,  4861,  7489,  7492,  7501,  7505,  7506,  3828,
    7532,  7537,  7540,  7544,  3828,  1557,  1558,  1559,  1560,  1561,
    1562,  1563,  1564,   719,   719,   719,   719,   719,  7545,  7556,
    7553,  7369,   690,   691,   692,  7565,  7566,   693,  5833,  7567,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,  6711,  7568,  7581,  7569,  7571,
    7600,  7602,  7601,  3828,  5757,  7605,  7604,  6207,  7607,  5880,
    7610,  7612,  7618,  7632,  7641,  7643,  7410,  7645,  7412,   719,
     719,   719,  7646,   719,  3482,  2165,   719,   719,  2165,  2165,
     719,   719,   719,   719,  2165,  5421,  5422,   719,   719,   719,
    7659,   719,   719,   719,   719,   719,   719,   719,   719,   719,
     719,  7660,  7661,   719,  7668,   719,  6257,   719,   719,   719,
     719,   719,   719,   719,   719,   719,    51,  -432,  7680,    51,
      51,   690,   691,   692,  7681,    51,   693,  7689,  7693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,  7708,  7710,  -875,  5522,  7711,  1100,
    7718,  1100,  7719,  7721,  1143,  1145,    67,    62,   719,   719,
    3803,   719,  2934,   717,   391,  2923,  3700,  2348,   719,   719,
      68,    69,    70,    71,    72,    73,    74,    75,  5408,  4604,
    4605,  4249,   719,   719,  4880,   719,   719,   719,   719,   719,
    4878,  5138,   719,   719,   719,   719,   719,   719,   719,   719,
     719,  5139,   719,   719,   422,  2939,  2910,  4309,  4094,   719,
    3648,   719,  4310,  1199,   719,   719,   719,   719,   719,   719,
     719,   719,   719,  7001,   719,   719,   719,   719,  1259,   719,
     719,   719,   719,   719,   719,   719,   719,   719,  1257,   802,
     719,   719,   719,   807,  6705,  7560,  7606,  6930,  6047,  6781,
    7153,  7004,  6171,  6515,  7673,   719,   719,   719,   719,   719,
    4844,  6026,  5049,  6722,  5050,  5051,  3801,  6031,  6032,  5052,
    5074,  5053,  5726,  5727,  5728,  5075,  5076,  6052,  5077,  5078,
    5079,  5080,  6056,  5081,  1114,  5082,  5083,  5084,  5085,  6071,
    1100,  5086,  5087,  5054,  5055,  1100,  6078,  3822,  1100,  5056,
    5057,  5058,  6113,  5059,  5060,  1114,  5061,  5062,  4270,  4271,
    2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,  2915,  4715,
    3650,  3484,  6160,  2782,  2520,  2413,  2880,  2881,   724,   724,
    2882,   732,   724,  6079,  6591,  1163,   724,  1164,  4986,  6265,
    3877,  7379,   724,  7383,  2801,  5312,  7385,  7384,  7061,  3516,
    3615,  7381,  7380,  3977,  4628,  7110,  6991,  6300,  6485,  1497,
    1498,  1499,  6434,  3864,  5651,  7315,  7361,  6848,  6680,   719,
    3861,  4720,  4723,  6450,  2920,  6301,  5309,  6302,  6008,  6303,
      67,  2796,  6304,  2886,  6305,  6464,  6306,     0,  6307,     0,
    4855,  4856,   719,   719,    68,    69,    70,    71,    72,    73,
      74,    75,  4857,     0,   719,   719,  4858,  4859,  4860,     0,
    2887,     0,  6483,     0,     0,     0,  6261,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2943,     0,  6222,   719,
    4861,  2948,     0,  3195,     0,  3847,     0,     0,     0,     0,
    3803,     0,     0,     0,     0,     0,  3195,     0,     0,     0,
    3195,     0,  3187,     0,  6337,     0,  5689,     0,     0,  3195,
       0,  3195,     0,  3195,     0,     0,     0,     0,     0,  2280,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4095,
      51,     0,     0,     0,     0,     0,     0,  6782,     0,  2991,
    6785,    51,    51,  6787,     0,     0,     0,     0,     0,     0,
       0,     0,  2991,     0,     0,  4510,     0,     0,  2991,     0,
       0,     0,     0,  2991,  4884,     0,     0,     0,     0,  2991,
       0,     0,     0,     0,  2991,     0,     0,     0,     0,     0,
      51,  6287,  2991,  6289,  3481,     0,     0,     0,  3482,     0,
       0,     0,     0,  4910,  2991,  4912,  3801,     0,     0,     0,
       0,     0,     0,  4916,  4917,     0,     0,     0,     0,  4146,
       0,  1100,  3795,     0,     0,     0,  3482,     0,     0,     0,
       0,     0,  2991,     0,  6059,  1114,    77,    77,     0,     0,
       0,     0,     0,     0,  4445,     0,  2991,     0,  3482,  1100,
       0,     0,   719,     0,  1114,     0,     0,     0,   719,   719,
       0,     0,     0,     0,  2991,     0,  5693,     0,  5694,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    67,
       0,     0,     0,     0,  6674,   362,   363,   364,   365,   366,
     367,   368,   369,    68,    69,    70,    71,    72,    73,    74,
      75,  4269,     0,     0,     0,     0,     0,  4277,     0,     0,
       0,  4308,     0,     0,     0,  4317,  5755,     0,  2740,     0,
       0,  5761,  5762,     0,     0,  4933,     0,  2991,     0,     0,
    2991,     0,  2745,     0,     0,     0,     0,     0,     0,     0,
       0,  6428,     0,     0,  6431,     0,     0,     0,  2991,     0,
       0,  6440,  6060,  6741,  2991,     0,     0,  6448,     0,     0,
       0,  6454,  -452,  -452,     0,     0,     0,  6460,     0,     0,
       0,  2165,     0,  6468,  6759,     0,     0,  6061,     0,     0,
       0,  6432,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6449,     0,     0,     0,  5737,  5739,     0,
       0,     0,     0,     0,  6462,     0,  5827,     0,     0,     0,
       0,     0,    51,     0,   690,   691,   692,  2759,     0,   693,
    1100,  1100,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,     0,  2991,     0,
       0,     0,  7330,  2991,  7331,  7332,  7333,     0,     0,     0,
       0,  6059,     0,     0,     0,     0,     0,  6512,     0,  6013,
    7334,  1098,  7335,     0,  7336,  2991,     0,  7337,  6625,  7338,
    2991,  7339,     0,  7340,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2991,     0,     0,
    7341,     0,  2991,     0,     0,     0,    67,     0,     0,     0,
       0,  6867,   362,   363,   364,   365,   366,   367,   368,   369,
      68,    69,    70,    71,    72,    73,    74,    75,     0,  1100,
       0,     0,     0,     0,  7240,     0,  2811,  2813,     0,     0,
       0,     0,     0,  2821,  2823,     0,  2826,     0,     0,  2831,
    2834,  2837,   724,  2841,     0,  1096,  4853,  4854,  2847,     0,
    2849,  2851,     0,  2855,     0,     0,     0,     0,     0,     0,
       0,  2235,     0,     0,     0,     0,     0,     0,     0,  6060,
       0,   724,     0,     0,     0,     0,     0,     0,  -456,     0,
     762,  -456,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6061,  5878,     0,    51,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  7297,   762,
       0,   762,     0,     0,     0,  6761,  6981,     0,     0,   762,
     762,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1194,     0,     0,     0,     0,  1198,     0,     0,     0,     0,
       0,     0,     0,  6025,     0,     0,  6027,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3194,     0,
    7512,  7513,  7514,     0,     0,  7213,  6700,  7215,  7590,     0,
    7591,     0,     0,     0,     0,  7223,     0,     0,  7225,     0,
       0,     0,     0,     0,     0,     0,  3828,     0,     0,     0,
       0,     0,  3693,     0,     0,     0,     0,  3699,     0,     0,
    3701,  5877,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3709,  3710,     0,     0,     0,     0,
       0,     0,  3713,  3714,  3715,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3828,     0,     0,  5404,     0,  5608,
    5609,     0,     0,  3828,  3195,     0,     0,     0,  3828,     0,
       0,     0,     0,     0,     0,  3195,  3195,  5427,     0,     0,
       0,  5430,  7282,     0,     0,     0,     0,  3195,     0,  3195,
    3195,     0,     0,     0,   719,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  7626,  7627,  7628,     0,
       0,     0,     0,     0,     0,     0,     0,  7106,     0,     0,
       0,     0,     0,     0,     0,     0,  6341,  6215,  1098,     0,
       0,     0,     0,     0,     0,     0,     0,  6227,    51,     0,
       0,     0,     0,     0,     0,     0,     0,  6238,     0,  6871,
       0,  2889,     0,     0,     0,  2890,     0,  3187,  2891,  2892,
    2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,
    2903,  2904,  2905,     0,     0,  6954,     0,     0,  6158,     0,
       0,  6866,     0,     0,     0,     0,     0,     0,     0,     0,
    6059,  6967,     0,  6899,     0,     0,     0,     0,  6905,  6972,
     719,   719,  2889,  4864,  4868,     0,  2890,     0,     0,  2891,
    2892,  2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,
    2902,  2903,  2904,  2905,     0,  5636,  5637,  1098,     0,     0,
    6900,     0,     0,     0,     0,    67,     0,     0,     0,  6291,
       0,   362,   363,   364,   365,   366,   367,   368,   369,    68,
      69,    70,    71,    72,    73,    74,    75,     0,     0,     0,
       0,  5638,  5639,  7025,     0,     0,     0,     0,   719,   719,
     719,   719,     0,     0,   719,   719,     0,  7056,     0,     0,
    1114,     0,     0,     0,  6157,     0,  5642,  5643,     0,     0,
       0,   719,   719,     0,   719,     0,   719,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6060,     0,
       0,     0,     0,     0,     0,     0,     0,  -459,     0,     0,
    -459,     0,     0,     0,     0,  2991,     0,     0,     0,     0,
       0,     0,     0,  6061,     0,  4273,     0,     0,     0,     0,
       0,     0,     0,  1100,  7533,  7534,  1100,     0,     0,     0,
    5675,     0,  1100,     0,  4094,     0,     0,  5743,  1114,     0,
       0,     0,     0,    77,     0,     0,     0,     0,     0,  7122,
       0,     0,     0,     0,     0,  5721,  5722,     0,     0,     0,
    4274,     0,     0,     0,     0,   719,   362,   363,   364,   365,
     366,   367,   368,   369,    68,    69,    70,    71,    72,    73,
      74,    75,   719,   719,     0,     0,     0,     0,  1114,     0,
     719,  1114,     0,     0,     0,     0,     0,  7111,  5009,  5045,
       0,  5070,     0,     0,     0,     0,     0, -1003, -1003, -1003,
       0, -1003, -1003, -1003,     0,     0,     0,  7608,     0,     0,
    4862,     0,     0,     0,     0, -1003,     0, -1003, -1003, -1003,
       0, -1003,     0,     0, -1003,     0, -1003,     0, -1003,     0,
   -1003,     0,     0,   762,     0,     0,     0,     0, -1003,     0,
       0,     0,     0,  1113,     0,  1113,     0, -1003,     0,  7204,
       0,     0,  6500,   762,     0,     0,     0,   762,     0,     0,
       0,   724,     0,  5141,     0,  7657,  7658,   -84,     0, -1003,
       0,   724,     0,   724,  1472,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1475,     0,     0,  7678,     0,
       0,     0,     0,     0,  1479,  1480,  1481,  1482,  1483,  1484,
      90,    91,     0,     0,     0,     0,  5527,     0,  5527,     0,
       0,     0,  1485,     0,     0,     0,   724,     0,   724,     0,
       0,     0,     0,     0,     0,     0,   719,  1113,     0,     0,
       0,     0,  2165,  2165,     0,  7715,  7716,  7717,     0,     0,
       0,     0,     0,     0,  4110,     0,  4116,     0,     0,     0,
       0,     0,  7724,     0,  7726,     0,     0,  7728,  1113,     0,
       0,     0,     0,     0,     0,     0,  6059,     0,     0,     0,
   -1003,     0,     0,    51,    51,  2892,  2893,  2894,  2895,  2896,
    2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,   724,
       0,     0,     0,     0,     0,     0,     0,    51,    51,     0,
       0,   762,   762,     0,     0,     0,     0,     0,     0,  1113,
       0,    67,     0,     0,     0,     0,  7243,   362,   363,   364,
     365,   366,   367,   368,   369,    68,    69,    70,    71,    72,
      73,    74,    75,     0,     0,     0,     0,   762,   762,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6062,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    51,
       0,     0,   762,   762,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3194,     0,     0,  6695,     0,     0,     0,
       0,     0,     0,     0,  6060,  4233,     0,     0,  3847,     0,
    4236,     0,     0,  4238,  -455,  -455,     0,     0,     0,     0,
       0,     0,     0,     0,   724,     0,     0,     0,     0,  6061,
       0,     0,  3195,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4999,     0,     0,     0,   762,  5790,     0,     0,
    6744,     0,     0,  1524,  5678,     0,   724,   478,     0,     0,
       0,     0,     0,     0,     0,   501,     0,   505,     0,     0,
       0,     0,     0,     0,     0,  2991,     0,     0,     0,     0,
       0,     0,     0,     0,  4864,  4868,     0,    67,     0,     0,
       0,     0,     0,   362,   363,   364,   365,   366,   367,   368,
     369,    68,    69,    70,    71,    72,    73,    74,    75,  2991,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2991,     0,     0,     0,     0,     0,     0,
       0,     0,  2991,     0, -1318, -1318, -1318,     0, -1318, -1318,
   -1318,     0,     0,     0,     0,     0,     0,  2165,     0,   687,
       0,  2165, -1318,     0, -1318,     0, -1318,     0, -1318,     0,
    5004, -1318,     0, -1318,     0, -1318, -1318, -1318,  2165,  2165,
       0,     0,     0,     0,     0, -1318,     0,     0,     0,     0,
       0,     0,     0,     0, -1318,     0,  6062,     0,    51,     0,
       0,     0,    51,     0,     0,  7467,  7468,  7469,     0,     0,
       0,     0,     0,     0,     0,     0, -1318,     0,     0,    51,
      51,     0,     0,     0,     0,     0,     0,     0,  1114,     0,
       0,  1100,  1100,  1525,  1526,  1527,  1528,  1529,  1530,  1531,
    1532,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,
    1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,
    1552,  1553,  1554,  1555,  1556,  1557,  1558,  1559,  1560,  1561,
    1562,  1563,  1564,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,  4565,     0,     0,     0,
       0,     0,     0,     0,  1113,     0,     0,     0,     0,  2991,
       0,     0,     0,     0,  2991,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,  4588,  1113,     0,  1114,     0,     0,
       0,  2889,     0,     0,     0,  2890,     0,  1111,  2891,  2892,
    2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,
    2903,  2904,  2905,  7593,  7594,  7595,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5770,     0,     0,
       0,     0,     0,     0,     0,   724,    51,     0,   724,   724,
     724,   724,   724,   724,   724,   724,   724,   724,   724,   724,
       0,   724,   724,   724,   724,   724,   724,   724,   724,   724,
     724,   724,   724,   724,   724,   724,   724,   724,   724,   724,
     724,     0,     0,  3140,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   784,   788,
     501,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   724,     0,     0,   724,     0,
       0,     0,     0,    51,   724,  5527,     0,  5527,   724,     0,
       0,     0,     0,     0,  2889,   724,     0,   724,  2890,   837,
       0,  2891,  2892,  2893,  2894,  2895,  2896,  2897,  2898,  2899,
    2900,  2901,  2902,  2903,  2904,  2905,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4726,  4728,   501,     0,  6928,
       0,   501,     0,     0,     0,     0,     0,     0,  2889,     0,
       0,     0,  2890,     0,  4314,  2891,  2892,  2893,  2894,  2895,
    2896,  2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6271,  6272,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   724,     0,   724,    67,
     724,   724,     0,     0,     0,   362,   363,   364,   365,   366,
     367,   368,   369,    68,    69,    70,    71,    72,    73,    74,
      75,     0,     0,     0,  7160,     0,  4232,    51,     0,     0,
    6333,     0,  6334,     0,  4822,  1113,     0,     0,     0,     0,
       0,     0,    51,     0,     0,     0,  -942,  -942,  -942,     0,
    -942,  -942,  -942,     0,  1113,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -942,  6062,  -942,     0,  -942,     0,
    -942,  -942,     0,  -942,     0,  -942,   687,  -942,     0,  -942,
       0,     0,     0,     0,     0,     0,     0,  -942,     0,     0,
       0,     0,     0,     0,     0,     0,  -942,  7059,     0,     0,
       0,     0,     0,     0,     0,  1100,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -942,   724,
    1100,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    51,  5770,     0,  5770,     0,     0,  5770,
    6383,     0,     0,     0,     0,     0,     0,     0,     0,  2889,
    1100,     0,  6126,  2890,     0,     0,  2891,  2892,  2893,  2894,
    2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,
    2905,     0,     0,     0,     0,     0,     0,     0,  2889,  1100,
       0,     0,  2890,     0,  1100,  2891,  2892,  2893,  2894,  2895,
    2896,  2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,
       0,  3140,     0,     0,     0,     0,     0,     0,     0,     0,
    4275,     0,     0,     0,     0,     0,   478,   501,     0,  -942,
    1213,     0,     0,   501,  1218,     0,     0,     0,     0,     0,
       0,     0,     0,  2889,     0,     0,     0,  2890,     0,  7158,
    2891,  2892,  2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,
    2901,  2902,  2903,  2904,  2905,   362,   363,   364,   365,   366,
     367,   368,   369,    68,    69,    70,    71,    72,    73,    74,
      75,     0,  1253,   501,     0,   478,     0,     0,   724,     0,
       0,   478,     0,     0,    51,  3140,     0,   724,     0,   724,
    6783,    51,     0,     0,     0,     0,  6788,     0,     0,   724,
       0,     0,     0,     0,     0,   724,     0,    51,     0,   724,
       0,    51,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  7244,     0,  7246,     0,     0,     0,    51,     0,
       0,     0,     0,     0,     0,     0,  7419,  7420,  7421,     0,
       0,     0,     0,     0,   724,   690,   691,   692,     0,     0,
     693,     0,     0,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,     0,     0,
       0,  2791,     0,     0,     0,     0,  2150,     0,  2151,     0,
       0,  2152,     0,  1100,     0,     0,     0,     0,    51,     0,
     762,   762,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5770,     0,     0,     0,   724,     0,
    5770,     0,     0,     0,     0,     0,     0,     0,   724,     0,
    3695,     0,   724,   724,     0,  3695,   724,   724,     0,  3695,
     724,     0,     0,    51,     0,     0,   762,     0,   762,     0,
       0,     0,  2280,     0,  3695,   724,  1100,    51,     0,   693,
    6018,  3695,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,     0,  7557,  7558,
    7559,  6062,     0,     0,     0,     0,  6044,  2164,     0,    77,
       0,     0,     0,   724,   724,    77,  3695,     0,   724,  4307,
     724,     0,  1112,    77,     0,   724,     0,     0,   362,   363,
     364,   365,   366,   367,   368,   369,    68,    69,    70,    71,
      72,    73,    74,    75,     0,     0,     0,  6064,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6112,     0,     0,     0,     0,   724,     0,  5305,  6765,
       0,  5307,     0,     0,     0,     0,   762,  5311,   724,     0,
       0,    51,   724,   724,   724,   724,   724,   724,    51,     0,
     724,   724,   724,   724,   724,   724,   724,     0,     0,     0,
     724,   724,   724,   724,     0,  1486,  1487,     0,     0,     0,
       0,     0,     0,  1489,  1490,     0,     0,     0,     0,     0,
    3140,  1493,  1494,  1100,   724,     0,     0,     0,     0,     0,
       0,  3140,     0,     0,   724,  7062,     0,     0,     0,     0,
       0,     0,     0,  3140,  2868,  1100,   724,  7074,     0,     0,
       0,     0,     0,    51,     0,  7078,     0,  5043,     0,    51,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     724,  1100,     0,     0,     0,     0,     0,     0,     0,   501,
       0,     0,     0,     0,   501,     0,     0,     0,     0,  1114,
       0,   478,   478,     0,     0,     0,     0,     0,     0,     0,
       0,  6581,     0,     0,  1114,     0,  6529,     0,     0,     0,
       0,     0,     0,   724,     0,     0,     0,     0,     0,   501,
       0,     0,     0,     0,   724,   478,     0,     0,   724,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     724,     0,   724,     0,     0,  3474,     0,     0,     0,   724,
     724,     0,     0,   724,  6919,     0,   724,   724,     0,     0,
       0,  6292,     0,     0,     0,   724,     0,   724,     0,  6922,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   724,     0,     0,     0,  1112,     0,     0,
    1113,   724,  6331,   362,   363,   364,   365,   366,   367,   368,
     369,    68,    69,    70,    71,    72,    73,    74,    75,   724,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   724,   724,     0,  2280,     0,   724,   724,
       0,  3695,     0,     0,  3695,     0,     0,     0,  7214,     0,
    7216,     0,     0,  3695,     0,     0,     0,   724,     0,   724,
     724,  3695,     0,     0,     0,     0,  6365,  3695,     0,   724,
       0,     0,   724,  3695,     0,     0,     0,     0,  1113,     0,
       0,  3695,     0,     0,     0,     0,    51,     0,  7037,  7038,
    7039,  7040,  7041,  7042,  7043,  7044,  7045,  7046,  7047,  7048,
    7049,  7050,  7051,  7052,  7053,  7054,     0,   724,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     724,     0,     0,     0,   724,     0,   724,     0,  1113,     0,
     724,  1113,   724,     0,     0,  7274,  4711,     0,     0,     0,
       0,     0,     0,     0,   724,     0,   724,     0,     0,   724,
       0,     0,  2164,     0,     0,     0,     0,     0,     0,     0,
     501,  3140,   724,     0,     0,    51,  3474,     0,     0,     0,
       0,     0,     0,     0,     0,  1100,     0,     0,   724,  2349,
       0,     0,  3140,  2280,     0,     0,  2890,     0,   724,  2891,
    2892,  2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,
    2902,  2903,  2904,  2905,  7323,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,     0,     0,     0,     0,   724,   724,   724,
       0,     0,     0,     0,   724,   724,  7368,   724,  7370,   724,
       0,     0,     0,   724,     0,   724,   724,     0,     0,     0,
       0,     0,   724,     0,   724,     0,     0,     0,     0,  4712,
       0,   724,   724,     0,   724,     0,   724,     0,   724,   724,
     724,     0,     0,     0,  1114,     0,  6064,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    77,    77,     0,     0,     0,     0,   724,     0,  3140,
       0,  6918,   724,  5870,     0,     0,     0,  3140,  3140,  4315,
       0,     0,     0,     0,     0,     0,  3140,  3140,     0,   724,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     724,     0,   724,     0,     0,   724,     0,   724,     0,     0,
     724,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   724,     0,     0,     0,     0,  5730,  5731,     0,     0,
       0,     0,     0,     0,   724,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   762,     0,  3875,   724,     0,
       0,     0,     0,     0,     0,   724,     0,     0,   724,     0,
     724,     0,   724,   724,   724,     0,   724,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   724,
       0,   724,     0,  2280,     0,   724,     0,     0,     0,     0,
       0,     0,     0,   724,     0,     0,   724,     0,   724,  2280,
       0,     0,     0,     0,     0,   724,     0,  2280,     0,     0,
    3234,   724,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4864,     0,     0,     0,  7060,     0,     0,    51,     0,
       0,     0,     0,  3195,     0,     0,     0,   724,     0,     0,
       0,     0,     0,     0,  3695,     0,     0,     0,  3140,     0,
       0,     0,     0,     0,     0,     0,  3140,     0,     0,     0,
       0,     0,   724,     0,   724,     0,   724,   724,     0,     0,
     724,  2280,  3695,     0,  5871,     0,    77,    77,  3695,    77,
     724,     0,     0,     0,  6766,  2280,     0,     0,    51,     0,
       0,     0,     0,     0,     0,     0,     0,  6772,     0,   724,
       0,     0,  3792,     0,     0,     0,     0,     0,   724,     0,
       0,     0,     0,     0,     0,     0,   724,     0,   724,   724,
       0,     0,     0,     0,     0,     0,     0,   724,     0,     0,
     724,     0,   724,  1114,     0,   724,     0,     0,     0,     0,
     724,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    77,     0,     0,    51,     0,     0,  4698,     0,     0,
       0,     0,     0,     0,     0,  7157,     0,     0,     0,     0,
     724,   724,     0,     0,     0,     0,     0,  2280,     0,     0,
       0,     0,     0,  3140,     0,     0,     0,   724,     0,     0,
     724,     0,     0,     0,   723,     0,   724,     0,   724,   724,
       0,     0,   724,   724,   724,     0,     0,     0,  1113,   724,
      51,     0,     0,     0,  4101,     0,     0,    51,     0,     0,
       0,     0,     0,     0,     0,  7156,     0,     0,     0,     0,
       0,     0,  7507,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6904,     0,     0,
       0,     0,     0,     0,     0,   724,     0,     0,  3528,  3535,
     724,  3539,     0,  1113,  7241,     0,     0,   724,   722,  3550,
       0,   724,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3528,   724,  2280,   724,     0,
       0,   724,  1113,   724,     0,   724,     0,  1113,     0,     0,
    3140,     0,  3140,     0,   724,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   724,   724,     0,     0,
       0,   724,   724,     0,     0,     0,     0,     0,     0,     0,
     724,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   724,     0,     0,   724,     0,     0,     0,     0,
    6000,   724,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   724,     0,     0,  6014,     0,     0,     0,     0,
       0,    49,     0,     0,     0,     0,     0,   724,     0,     0,
       0,     0,     0,     0,     0,     0,   724,  2164,   724,  2164,
    2164,     0,     0,     0,     0,  6046,   724,     0,   724,     0,
       0,     0,     0,  2164,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   724,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6051,     0,     0,     0,     0,  6055,
       0,     0,     0,   724,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,  2552,  3153,  3154,  3155,
       0,  2420,    77,    77,     0,   724,     0,     0,   724,     0,
     724,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   724,     0,     0,     0,     0,     0,     0,     0,     0,
     724,     0,     0,   724,   724,     0,     0,     0,     0,     0,
       0,   724,     0,     0,     0,     0,     0,     0,     0,   724,
       0,     0,   724,     0,   392,     0,     0,     0,     0,  7390,
       0,     0,  7393,     0,     0,     0,   724,   724,     0,     0,
       0,     0,     0,     0,     0,  1114,  4442,   724,     0,     0,
     724,     0,  1151,     0,     0,     0,     0,     0,     0,   724,
     724,     0,     0,     0,     0,     0,     0,     0,     0,   393,
       0,     0,     0,     0,     0,   362,   394,   364,   365,   366,
     367,   368,   369,    68,   395,    70,    71,    72,    73,    74,
      75,     0,     0,   690,   691,   692,     0,     0,   693,     0,
     724,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,  1114,  2889,     0,     0,
       0,  2890,     0,   724,  2891,  2892,  2893,  2894,  2895,  2896,
    2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,   724,
       0,     0,   724,     0,     0,     0,     0,     0,  6266,     0,
    4543,   724,  2277,     0,  7055,     0,     0,     0,   762,     0,
       0,     0,  4545,     0,     0,     0,  4550,     0,     0,     0,
    4563,   396,   397,   398,   399,   400,   401,   402,     0,   403,
     404,   405,   406,     0,     0,  6316,     0,     0,     0,     0,
    6321,   724,   407,   724,  6325,   724,   724,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6339,
       0,  6342,     0,     0,     0,     0,  6347,     0,     0,     0,
       0,     0,   724,     0,   724,     0,     0,     0,   724,     0,
       0,     0,   724,     0,     0,   724,     0,     0,     0,     0,
       0,     0,   724,     0,     0,     0,     0,     0,  6064,    51,
       0,  6354,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   724,     0,     0,     0,  2164,     0,  2164,
       0,  2164,     0,     0,     0,   724,   724,     0,  3195,     0,
    1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,   724,     0,     0,
       0,     0,  6064,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   724,   724,   724,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   724,     0,     0,     0,     0,
     724,   724,   724,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  7376,  7377,  7378,     0,     0,     0,   724,     0,
     724,     0,     0,     0,  4713,     0,     0,     0,     0,     0,
       0,   724,     0,     0,     0,     0,     0,     0,  3140,  7700,
    3140,     0,     0,     0,   724,     0,     0,     0,     0,     0,
    3296,     0,     0,     0,     0,  4738,     0,     0,     0,     0,
       0,     0,     0,  6064,     0,     0,  6493,   724,     0,     0,
       0,     0,     0,     0,     0,   408,     0,   724,     0,   724,
       0,   724,  4768,     0,     0,     0,  4770,     0,     0,     0,
       0,     0,     0,     0,     0,  4091,  4096,     0,     0,  7465,
       0,     0,     0,     0,   409,     0,     0,   410,   411,   412,
       0,     0,     0,     0,   413,   414,   415,   416,   417,   418,
       0,     0,     0,  3157,  3158,  3159,  3160,  3161,  3162,  3163,
    3164,  3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,
    3174,  3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,
       0,     0,     0,     0,     0,     0,  2308,  2309,  2310,  2311,
    2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,  2321,
       0,  2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,
    2332,  2333,  2334,  2335,  2336,  2339,     0,  2340,  2341,  2344,
       0,     0,  2346,  2347,     0,  4276,   690,   691,   692,  4306,
       0,   693,     0,  4316,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,     0,
       0,     0,     0,     0,     0,     0,  6632,     0,     0,  6634,
       0,  4999,     0,     0,     0,     0,     0,     0,  6645,     0,
    1486,  1487,     0,  2549,     0,     0,  6651,     0,  1489,  1490,
       0,  2550,  6655,     0,  2551,     0,  1493,  1494,  6661,     0,
       0,     0,     0,     0,     0,     0,  6668,     0,     0,     0,
       0,     0,     0,  7625,     0,     0,    67,     0,     0,     0,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
      68,    69,    70,    71,    72,    73,    74,    75,     0,     0,
       0,     0,  2164,     0,     0,     0,  2164,  2164,  2164,  2164,
    2164,  2164,  2164,  2164,  2164,  2164,  2164,  2164,  2164,  2164,
    2164,  2164,  2164, -1125, -1125, -1125,     0, -1125, -1125, -1125,
       0,  2289,  2290,     0,     0,     0,     0,     0,     0,     0,
       0, -1125,     0, -1125,     0, -1125,  6059, -1125,     0,  6015,
   -1125, -1125, -1125,     0, -1125,     0, -1125,     0,     0,     0,
    6753,     0,     0,     0,     0,     0,     0,     0,     0,  1113,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1113,     0,  5007,     0,     0,  5068,
       0,    67,     0,     0,     0, -1125,     0,   362,   363,   364,
     365,   366,   367,   368,   369,    68,    69,    70,    71,    72,
      73,    74,    75,     0,   497,     0,     0,     0,     0,     0,
       0,   498,   103,     0,     0,     0,     0,     0,     0,   105,
       0,     0,     0,     0,     0,  1114,     0,     0,     0,  1114,
    -211,     0,  -211,  -211,  -211,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1114,     0,     0,     0,  -211,  6601,
    -211,     0,  -211,  5146,  6060,  -211,  3677,  -211,  5150,  -211,
       0,  -211,     0,     0,     0,     0,     0,     0,     0,  -211,
     779,  5154,  6602,  5155,     0,     0,  5156,     0,  -211,  6061,
    5160,     0,     0,     0,     0,     0,     0,  4096,     0,     0,
       0,     0,     0,   816,     0,     0,     0,   820,     0,     0,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
       0,     0,     0,   838,     0,     0,  4546,   851,     0,     0,
    2164,     0,  2164,     0,  6379,  2164,   118,     0,    77,  6380,
       0,  6178,  6179,  6180,  6181,  6182,  6183,  6184,  6185,  6186,
    6187,  6188,  6189,  6190,  6191,  6192,  6193,  6194,  6195,  5225,
       0,     0,     0,     0,    77,     0,     0,     0,     0,     0,
       0,     0,     0,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
     126,  1078,  1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,
    1086,   137,  1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,     0,     0,     0,    77,    77,     0,     0,     0,
       0,  4545,     0,     0,     0,     0,     0,     0,  1114,    77,
    3909,     0,     0,     0,     0,     0,  1114,     0,     0,     0,
    1114,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,
    1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,
    1552,  1553,  1554,  1555,  1556,     0,     0,     0,  5319,  5320,
       0,     0,     0,     0,  5325,     0,     0,     0,     0,  6999,
       0,     0,     0,     0,  3528,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,     0,     0,     0,  5348,     0,
       0,     0,     0,     0,  5353,     0,     0,  7026,     0,     0,
       0,     0,     0,  7032,   501,     0,     0,     0,     0,     0,
     430,     0,  1486,  1487,  3955,     0,     0,   431,     0,   432,
    1489,  1490,     0,  4096,     0,     0,     0,     0,  1493,  1494,
     433,  4718,    90,     0,     0,     0,     0,     0,     0,     0,
     434,   435,     0,     0,     0,   436,   437,   438,   439,   440,
       0,   441,     0,     0,  1113,     0,     0,     0,     0,   442,
       0,     0,     0,     0,     0,     0,  4741,     0,     0,     0,
       0,     0,     0,     0,     0,  4752,     0,  3528,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3528,  7063,  3528,     0,  3528,  3528,     0,   497,     0,     0,
    1114,     0,     0,  5444,   498,   103,   443,     0,   444,   419,
       0,     0,   105,     0,     0,     0,     0,     0,     0,    77,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5472,
    1114,  5475,     0,     0,  1214,     0,  5521,     0,     0,     0,
       0,     0,  7064,     0,     0,  1223,  1224,  1225,  1227,     0,
      77,  1230,  1231,  1232,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  7065,     0,  1245,  1557,  1558,
    1559,  1560,  1561,  1562,  1563,  1564,  3329,  3330,  3331,  3332,
    3333,  3334,  3335,  3336,  1251,     0,     0,     0,     0,     0,
    2164,  1258,     0,  2164,  2164,     0,     0,  1260,  1261,  2164,
       0,     0,  1267,  1268,   430,     0,     0,     0,     0,     0,
    1114,   431,  1114,   432,    77,     0,     0,     0,     0,   118,
       0,     0,     0,     0,   433,     0,    90,     0,     0,     0,
       0,     0,     0,     0,   434,   435,     0,     0,     0,   436,
     437,   438,   439,   440,     0,   441,     0,     0,     0,     0,
       0,     0,     0,   442,     0,     0,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,   126,  1078,  1079,  1080,   130,  1081,  1082,
    1083,  1084,  1085,  1086,   137,  1087,  1088,   140,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,     0,  5008,  5044,     0,  5069,
       0,     0,     0,     0,     0,     0,    77,  1114,   445,   446,
       0,     0,     0,     0,     0,     0,     0,  1114,     0,     0,
     447,   448,     0,     0,  1114,     0,     0,     0,  1114,     0,
       0,     0,   449,   450,  1114,     0,     0,     0,     0,     0,
    1114,     0,     0,     0,   451,   452,     0,     0,     0,     0,
       0,     0,     0,  1113,     0,   453,   454,   455,   456,   457,
     458,   459,   460,   461,     0,   462,   463,   464,   465,   466,
     467,   468,   469,    67,  4096,     0,     0,     0,     0,   362,
     363,   364,   365,   366,   367,   368,   369,    68,    69,    70,
      71,    72,    73,    74,    75,     0,  1114,     0,  1114,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,
    1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,
    1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,
       0,     0,  6387,     0,    77,     0,     0,  6388,    77,  6178,
    6179,  6180,  6181,  6182,  6183,  6184,  6185,  6186,  6187,  6188,
    6189,  6190,  6191,  6192,  6193,  6194,  6195,     0,     0,     0,
       0,     0,     0,     0,     0,  5145,     0,  5145,     0,     0,
       0,     0,  5145,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4096,     0,     0,     0,     0,
       0,     0,   445,   446,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   447,   448,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   449,   450,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   451,   452,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   453,
     454,   455,   456,   457,   458,   459,   460,   461,     0,   462,
     463,   464,   465,   466,   467,   468,   469,     0,     0,  2357,
       0,     0,     0,  2361,     0,  2362,  2363,     0,     0,  2366,
    2367,     0,     0,     0,     0,     0,     0,     0,  2374,     0,
       0,     0,     0,     0,     0,  2378,  2379,     0,  2381,  2382,
    2383,  2384,     0,  2386,  2387,     0,  2388,  2389,  2390,  2391,
    2392,     0,     0,  2394,  2395,  2396,     0,  1114,     0,    77,
       0,  2552,  2400,  2401,     0,     0,  2404,  7690,  7691,     0,
       0,  1114,     0,     0,  6178,  6179,  6180,  6181,  6182,  6183,
    6184,  6185,  6186,  6187,  6188,  6189,  6190,  6191,  6192,  6193,
    6194,  6195,     0,     0,     0,    77,    77,     0,  5759,     0,
       0,     0,     0,  1113,     0,     0,  6016,     0,     0,     0,
    5145,     0,     0,     0,     0,     0,     0,  4591,     0,     0,
       0,     0,    77,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    77,     0,     0,     0,     0,
    4096,     0,  5145,     0,     0,     0,     0,     0,     0,  6384,
       0,     0,     0,     0,     0,  1114,  6178,  6179,  6180,  6181,
    6182,  6183,  6184,  6185,  6186,  6187,  6188,  6189,  6190,  6191,
    6192,  6193,  6194,  6195,     0,     0,    77,     0,     0,     0,
       0,     0,     0,     0,     0,  1113,     0,     0,     0,     0,
       0,     0,    77,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    77,     0,     0,    50,    52,    53,    54,
      55,     0,     0,     0,    59,     0,     0,     0,     0,     0,
       0,  6062,     0,     0,     0,     0,     0,     0,     0,     0,
    6390,     0,     0,     0,     0,     0,  1114,  6178,  6179,  6180,
    6181,  6182,  6183,  6184,  6185,  6186,  6187,  6188,  6189,  6190,
    6191,  6192,  6193,  6194,  6195,     0,  1113,     0,     0,     0,
       0,     0,     0,     0,  3122,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2164,     0,     0,   473,
      77,     0,     0,     0,  1114,    77,     0,     0,     0,     0,
       0,   508,   509,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5904,     0,     0,  5914,  5921,  5926,  5930,  5931,
       0,  5936,  5941,     0,     0,  1114,     0,     0,   510,   511,
     512,   513,   514,   515,   516,  1114,   517,   518,   519,     0,
     520,   521,   522,   523,   524,   525,     0,   526,   527,     0,
     528,   529,   530,   531,   532,   533,   534,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5979,
       0,     0,     0,   536,     0,   537,     0,     0,     0,     0,
       0,     0,     0,   538,   539,   540,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,     0,  6002,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,     0,     0,     0,     0,     0,   674,  5685,     0,
     675,     0,  5687,     0,     0,     0,  5687,  4096,  4096,     0,
       0,     0,  5685,  3930,    77,   931,     0,     0,  2420,     0,
       0,   362,   363,   364,   365,   366,   367,   368,   369,    68,
      69,    70,    71,    72,    73,    74,    75,     0,   709,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    49,     0,     0,     0,     0,   470,     0,
     337,     0,   471,   472,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4096,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   748,     0,     0,
    1112,     0,  1114,     0,     0,  1114,   362,   363,   364,   365,
     366,   367,   368,   369,    68,    69,    70,    71,    72,    73,
      74,    75,     0,   796,   797,     0,     0,   800,   800,     0,
       0,     0,     0,     0,   805,   805,   808,   808,   808,   808,
     813,   813,     0,     0,   813,   813,     0,   813,   813,     0,
       0,     0,     0,     0,     0,     0,     0,  3661,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3690,  3691,     0,     0,     0,  3696,  3697,     0,
       0,  5685,  5685,  5763,     0,     0,     0,  5687,     0,     0,
    6178,  6179,  6180,  6181,  6182,  6183,  6184,  6185,  6186,  6187,
    6188,  6189,  6190,  6191,  6192,  6193,  6194,  6195,     0,     0,
    4096,     0,     0,     0,     0,  5687,     0,     0,  3528,  3528,
    7688,     0,     0,     0,   884,     0,     0,  6178,  6179,  6180,
    6181,  6182,  6183,  6184,  6185,  6186,  6187,  6188,  6189,  6190,
    6191,  6192,  6193,  6194,  6195,     0,     0,     0,     0,  5181,
       0,     0,     0,  1114,     0,  1114,    77,    49,     0,     0,
       0,     0,   470,     0,   337,     0,   471,   472,     0,     0,
       0,  1114,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1114,     0,     0,  1114,  1114,     0,     0,     0,
       0,     0,     0,  1486,  1487,  1488,     0,     0,     0,     0,
       0,  1489,  1490,  1491,     0,     0,     0,     0,     0,  1493,
    1494,  1495,  1114,     0,     0,     0,     0,     0,     0,     0,
      77,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1114,     0,     0,     0,  1114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1114,
    1114,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      77,    77,    77,     0,     0,  6422,     0,     0,     0,     0,
      67,     0,     0,     0,     0,  6433,  4260,  4261,  4262,  4263,
    4264,  4265,  4266,  4267,    68,    69,    70,    71,    72,    73,
      74,    75,     0,  6457,  1114,     0,     0,     0,  6463,     0,
       0,     0,     0,     0,     0,  1113,     0,     0,     0,  1113,
       0,    77,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1113,     0,     0,     0,     0,  1114,
       0,  6499,  1114,     0,     0,     0,  3872,     0,     0,     0,
    1114,     0,  6563,     0,     0,     0,     0,    77,   362,   363,
     364,   365,   366,   367,   368,   369,    68,    69,    70,    71,
      72,    73,    74,    75,     0,     0,     0,     0,   473,     0,
     808,   808,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1114,     0,  1114,     0,
    1114,  1114,     0,  6553,     0,     0,     0,     0,     0,     0,
       0,  4999,     0,     0,     0,     0,     0,     0,  6017,     0,
       0,     0,     0,     0,  1114,     0,     0,     0,  1114,     0,
       0,  1114,     0,     0,     0,     0,     0,   473,     0,     0,
    1114,     0,     0,   473,     0,     0,     0,     0,     0,     0,
       0,     0,  6603,     0,     0,     0,    67,     0,     0,     0,
       0,     0,  5000,   363,   364,   365,   366,   367,   368,  5001,
    5002,    69,    70,    71,    72,    73,    74,  5003,     0,     0,
       0,     0,     0,  1114,  1114,  6063,  6067,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1113,     0,
       0,     0,     0, -1218, -1218, -1218,  1113, -1218, -1218, -1218,
    1113,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1114, -1218,     0, -1218,     0, -1218,     0, -1218,     0,  5004,
   -1218,    77, -1218, -1218, -1218,     0, -1218,     0,     0,     0,
       0,     0,     0,  5005, -1218,     0,     0,  2164,  2164,     0,
       0,     0,     0, -1218,     0,     0,     0,  1114,  2959,  2960,
    2961,     0,  1113,     0,  2962,  2963,     0,     0,     0,     0,
       0,     0,  6702,  2970,     0, -1218,     0,     0,     0,     0,
    1114,     0,  1114,     0,   118,     0,     0,     0,     0,     0,
       0,     0,     0,  2971,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,  1071,  1072,  1073,  1074,  1075,  1076,  1077,   126,  1078,
    1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,  1086,   137,
    1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3287,     0,    90,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3952,     0,     0,     0,     0,
    1113,     0,     0,  1486,  1487,  3953,  3290,     0,  3291,     0,
       0,  1489,  1490,  3954,  3293,     0,     0,     0,     0,  1493,
    1494,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1113,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1115,     0,  1118,     0,     0,     0,     0,     0,
    6330,  6178,  6179,  6180,  6181,  6182,  6183,  6184,  6185,  6186,
    6187,  6188,  6189,  6190,  6191,  6192,  6193,  6194,  6195,     0,
       0,  5687,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5685,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1113,     0,  1113,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1200,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   473,   473,     0,  4319,  4320,     0,     0,
    4322,     0,     0,     0,  4324,     0,     0,  1228,     0,     0,
    4329,     0,  2164,     0,     0,     0,  2164,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   473,     0,     0,
       0,     0,     0,  2164,  2164,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6067,  1113,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1113,  1266,     0,
       0,     0,     0,     0,  1113,  3826,     0,     0,  1113,     0,
     776,   776,     0,     0,  1113,   794,     0,     0,     0,     0,
    1113,     0,   794,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   794,     0,  3337,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   794,     0,     0,     0,   842,   845,     0,
     794,   794,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3873,     0,     0,     0,  1113,     0,  1113,     0,
       0,     0,  3287,     0,    90,     0,     0,     0,     0,     0,
    1113,     0,     0,     0,     0,     0,  3952,     0,     0,     0,
       0,     0,  7066,     0,  1486,  1487,  3953,  3290,     0,  3291,
       0,     0,  1489,  1490,  3954,  3293,     0,     0,     0,     0,
    1493,  1494,     0,     0,  6063,     0,     0,     0,  6067,     0,
       0,     0,     0,     0,     0,     0,     0,  3430,     0,     0,
       0,     0,     0,     0,  3440,  3446,     0,     0,     0,     0,
       0,     0,  3452,  3454,  3456,     0,     0,  3460,     0,     0,
       0,     0,     0,     0,     0,     0,  3464,  3466,     0,     0,
       0,  3468,     0,     0,  3471,     0,     0,     0,     0,     0,
       0,     0,     0,  2508,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,  2532,
       0,     0,     0,  2539,  3526,  2541,  2542,  2543,  2544,  2545,
       0,  2547,  3542,     0,     0,  2556,  3545,  2557,     0,  2558,
    3553,  2560,  2561,     0,     0,     0,  7155,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3577,     0,     0,     0,     0,     0,     0,     0,  3582,     0,
    3587,  3589,  3591,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3473,
       0,     0,     0,  2568,  2569,   497,     0,  2570,     0,     0,
       0,     0,   498,   103,     0,  2584,     0,  1113,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1113,     0,  1158,  1162,     0,     0,     0,     0,  2595,
       0,  2597,     0,  2599,  2600,  2601,     0,     0,     0,     0,
       0,     0,     0,  2607,     0,  6067,  6067,     0,  2609,     0,
       0,     0,     0,     0,  2610,     0,     0,  2613,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   794,     0,     0,     0,     0,   794,   794,     0,
     794,   794,     0,     0,  2373,     0,     0,     0,     0,     0,
       0,     0,  2629,     0,  2419,  2633,     0,     0,   794,   794,
       0,   794,   794,   794,   794,  1113,   794,   794,     0,     0,
     794,   794,     0,   794,   794,     0,     0,   118,     0,     0,
    2635,     0,  2636,     0,     0,     0,  6067,     0,   794,   794,
       0,     0,  2639,     0,     0,     0,  2640,     0,     0,     0,
       0,  2645,  6067,     0,  2648,     0,     0,  2651,     0,     0,
       0,     0,     0,  6067,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,   126,  1078,  1079,  1080,   130,  1081,  1082,  1083,  1084,
    1085,  1086,   137,  1087,  1088,   140,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,     0,     0,     0,  1113,     0,     0,     0,
    2656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4842,     0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,
    1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,  4879,
    6067,     0,  2664,     0,  1113,     0,     0,     0,     0,  2669,
    2670,     0,     0,     0,     0,     0,  2672,  2673,  2674,  2675,
    2676,  2677,  2678,  2679,  2680,  2681,     0,     0,     0,     0,
    1486,  1487,     0,     0,     0,  1113,     0,     0,  1489,  1490,
       0,     0,     0,     0,     0,  1113,  1493,  1494,  3141,     0,
    2684,  2686,     0,     0,  3142,  3143,  1486,  1487,     0,     0,
       0,  3144,  3145,  3146,  1489,  1490,     0,     0,     0,  3147,
       0,     0,  1493,  1494,     0,     0,     0,     0,     0,     0,
    2716,  2717,  2718,     0,     0,  2721,  2722,  2723,  2724,  2725,
    2726,  2727,  2728,     0,     0,     0,  2732,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2523,     0,  5006,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2733,
    2734,  2735,  2736,  2555,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4457,     0,     0,  2737,     0,
       0,     0,  2737,     0,  2273,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2742,  2743,     0,     0,     0,
       0,     0,  4478,     0,     0,     0,     0,     0,     0,  2747,
    2748,  2749,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4506,     0,  4508,     0,     0,  4512,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4523,     0,  4525,     0,  4527,
       0,     0,     0,     0,  2750,     0,     0,     0,     0,  2751,
    2752,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2753,  2754,  6067,     0,     0,     0,  2755,     0,
       0,  2758,  2760,     0,     0,     0,     0,     0,  2353,  2353,
       0,     0,   794,   794,   794,  2764,     0,     0,  2765,   794,
     794,     0,     0,     0,     0,     0,     0,  2755,  2767,  2755,
    2769,  2770,  2771,     0,     0,  2772,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   794,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1113,     0,     0,  1113,     0,     0,     0,     0,
       0,     0,     0,     0,  3926,     0,     0,     0,     0,  2420,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2803,  2805,  2807,  2808,  2809,
    2810,  2812,  2816,  2817,  2818,  2819,  2820,  2758,  2822,  2824,
    2825,  2827,  2828,  2829,  2832,  2835,  2838,  2839,  2842,  2843,
    2844,  2845,  2846,  2848,  2737,  2737,  2853,  2854,  2856,  2857,
    2858,  2859,  2860,  2861,  2862,  2863,  2864,  2865,  2866,  2867,
    2869,  2871,     0,     0,  2873,  2874,     0,     0,     0,     0,
       0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,
    1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,
    1552,  1553,  1554,  1555,  1556,     0,     0,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1556,     0,  4999,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1113,     0,  1113,  6063,  3301,  3302,  3303,
    3304,  3305,  3306,     0,     0,     0,     0,     0,     0,     0,
       0,  1113,     0,  4333,  4334,     0,     0,     0,     0,     0,
    3964,     0,  1113,     0,     0,  1113,  1113,    67,     0,     0,
       0,     0,     0,  5000,   363,   364,   365,   366,   367,   368,
    5001,  5002,    69,    70,    71,    72,    73,    74,  5003,     0,
       0,     0,  1113,     0,     0,     0,     0,     0,     0,     0,
    6063,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1113, -1264, -1264, -1264,  1113, -1264, -1264,
   -1264,     0,     0,     0,     0,     0,     0,     0,     0,  1113,
    1113,     0, -1264,     0, -1264,     0, -1264,     0, -1264,     0,
    5004, -1264,     0, -1264,     0, -1264,     0, -1264, -1264,  5434,
       0,     0,     0,     0,  5066, -1264,     0,     0,     0,  5438,
       0,  5441,     0,     0, -1264,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1113,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0, -1264,     0,     0,     0,
       0,  6063,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,  5531,  2552,  5533,     0,     0,  1113,
    2420,     0,  1113,     0,     0,     0,     0,     0,     0,     0,
    1113,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1071,  1072,  1073,  1074,  1075,  1076,  1077,   126,
    1078,  1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,  1086,
     137,  1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,     0,     0,     0,  4281,     0,  1113,     0,  1113,     0,
    1113,  1113,     0,     0,     0,     0,     0,  5629,     0,     0,
    3186,  3186,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1113,     0,     0,     0,  1113,     0,
       0,  1113,     0,     0,     0,     0,     0,     0,     0,    67,
    1113,     0,     0,     0,     0,   362,   363,   364,   365,   366,
     367,   368,   369,    68,    69,    70,    71,    72,    73,    74,
      75,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1113,  1113,     0, -1018, -1018, -1018,     0,
   -1018, -1018, -1018,     0,     0,  4577,     0,     0,     0,     0,
       0,     0,     0,     0, -1018,     0, -1018,     0, -1018, -1018,
   -1018,     0,     0, -1018, -1018, -1018,     0, -1018,     0, -1018,
    1113,     0,  5659,     0,     0,     0,     0, -1018,     0,  2870,
       0,     0,     0,  4624,     0,  4626, -1018,     0,     0,     0,
    5110,  4282,  4283,  4284,  4285,  4286,  4287,  4288,     0,  4289,
    4290,  4291,  4292,     0,  5681,     0,  5123,  1113, -1018,     0,
    3141,     0,  4293,     0,     0,     0,  3142,  3143,  1486,  1487,
       0,     0,     0,  3144,  3145,  3146,  1489,  1490,     0,     0,
    1113,  3147,  1113,     0,  1493,  1494,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2926,     0,     0,
       0,     0,     0,  4646,     0,     0,     0,     0,     0,  4653,
    4654,  4656,     0,     0,  4662,     0,  4653,  4667,  4668,  4668,
    4668,  4675,  4676,  4677,  4678,  4679,  4680,     0,     0,     0,
       0,  4682,  4683,     0,     0,     0,     0,  4688,  4689,  4691,
       0,     0,     0,     0,     0,     0,     0,  2951,     0, -1018,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4737,  4653,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4747,  4748,     0,  4750,  4751,     0,     0,     0,     0,  4757,
    4759,  4761,  4668,  4765,  4767,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4784,
    4785,  4786,  4668,  4789,     0,     0,  4792,  4793,     0,     0,
    3624,     0,     0,     0,  4800,  4801,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3141,  2552,     0,     0,     0,  4294,  3142,  3143,  1486,  1487,
       0,     0,     0,  3144,  3145,  3146,  1489,  1490,     0,     0,
       0,  3147,     0,     0,  1493,  1494,     0,  3930,     0,     0,
       0,     0,  2420,     0,  4295,     0,     0,  4296,  4297,  4298,
       0,     0,     0,     0,  4299,  4300,  4301,  4302,  4303,  4304,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5774,     0,     0,  5778,  5779,  5780,  5781,
    5782,  5783,  5784,  5785,  5786,  5787,  5788,  5789,     0,  5791,
    5792,  5793,  5794,  5795,  5796,  5797,  5798,  5799,  5800,  5801,
    5802,  5803,  5804,  5807,  5808,  5809,  5812,  5813,  5814,  3141,
       0,     0,     0,     0,     0,  3142,  3143,  1486,  1487,  3921,
    3922,     0,  3144,  3145,  3146,  1489,  1490,  3923,  3924,     0,
    3147,     0,     0,  1493,  1494,  3925,     0,     0,     0,     0,
       0,     0,     0,  5819,     0,     0,  5826,     0,     0,     0,
       0,     0,  5832,     0,     0,     0,  5836,     0,     0,     0,
       0,     0,     0,  5843,     0,  5844,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1533,
    1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,
    1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,
    1554,  1555,  1556,  1557,  1558,  1559,  1560,  1561,  1562,  1563,
    1564,  3329,  3330,  3331,  3332,  3333,  3334,  3335,  3336,     0,
       0,     0,     0,  3141,     0,     0,     0,     0,     0,  3142,
    3143,  1486,  1487,     0,     0,     0,  3144,  3145,  3146,  1489,
    1490,     0,     0,     0,  3147,     0,     0,  1493,  1494,     0,
       0,     0,     0,     0,  5885,     0,  5895,     0,  5897,  5898,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3837,  3186,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3186,     0,
       0,     0,  3186,     0,     0,     0,     0,     0,     0,     0,
       0,  3186,     0,  3186,     0,  3186,     0,     0,     0,     0,
    3141,     0,     0,     0,     0,     0,  3142,  3143,  1486,  1487,
       0,     0,     0,  3144,  3145,  3146,  1489,  1490,     0,     0,
    2965,  3147,  2965,     0,  1493,  1494,     0,     0,  5645,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   794,
    5661,     0,     0,     0,  2965,  2965,  3141,     0,  5668,     0,
       0,  5673,  3142,  3143,  1486,  1487,     0,  6012,     0,  3144,
    3145,  3146,  1489,  1490,     0,     0,     0,  3147,     0,     0,
    1493,  1494,  2993,     0,     0,     0,     0,  3611,     0,  1533,
    1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,
    1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,
    1554,  1555,  1556,  1557,  1558,  1559,  1560,  1561,  1562,  1563,
    1564,  3329,  3330,  3331,  3332,  3333,  3334,  3335,  3336,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3659,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3706,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5067,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1533,  1534,
    1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,     0,     0,     0,     0,  6201,     0,     0,     0,
       0,     0,     0,     0,     0,  6211,     0,  6214,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6211,     0,     0,
       0,     0,     0,  6232,     0,     0,     0,  6237,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6264,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,  5744,     0,  3329,  3330,  3331,  3332,  3333,  3334,
    3335,  3336,     0,     0,     0,     0,  6296,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6314,     0,     0,     0,
    6318,  6319,     0,     0,  6322,  6323,     0,     0,  6326,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6340,     0,     0,     0,     0,     0,  1533,
    1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,
    1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,
    1554,  1555,  1556,     0,     0,     0,     0,     0,     0,  4305,
       0,  6351,  6352,     0,     0,     0,  6356,     0,  6358,     0,
       0,     0,     0,  6363,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,
    1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,
       0,     0,     0,     0,  6377,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6386,     0,     0,     0,
    6393,  6394,  6395,  6396,  6397,  6398,     0,     0,  6407,  6408,
    6409,  6410,  6411,  6412,  6413,     0,  3141,     0,  6415,  6416,
    6417,  6418,  3142,  3143,  1486,  1487,     0,     0,     0,  3144,
    3145,  3146,  1489,  1490,     0,     0,     0,  3147,     0,     0,
    1493,  1494,  6441,     0,     0,     0,     0,     0,     0,  3926,
       0,     0,  6455,     0,  2420,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6469,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3675,     0,  3679,     0,  3683,     0,     0,  6492,  5947,
       0,     0,     0,  5954,     0,     0,     0,     0,     0,     0,
       0,     0,  2779,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3186,     0,     0,     0,
     794,   794,     0,     0,     0,     0,     0,  3186,  3186,     0,
       0,  6530,     0,     0,     0,     0,     0,     0,  5691,  5692,
       0,     0,  6538,     0,  2993,     0,  6541,  3724,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6558,     0,
    6561,     0,     0,     0,     0,     0,  4531,  6567,  6568,     0,
       0,  6571,     0,     0,  6572,  6573,     0,     0,     0,     0,
       0,     0,     0,  6579,     0,  6580,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6598,  5704,  5706,     0,     0,     0,     0,     0,  6609,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5709,  5710,     0,  5711,  6615,  5712,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6622,  6623,     0,     0,     0,  6628,  6630,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6622,     0,  6628,  6650,  2552,
       0,     0,     0,  3802,  2420,     0,     0,  6657,     0,     0,
    6660,     0,     0,     0,     0,  3820,     0,  3820,     0,  3824,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3833,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5734,  6693,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6706,     0,
       0,     0,  6710,     0,  6712,     0,  5740,     0,  6715,     0,
    6717,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6726,     0,  6728,     0,     0,  6731,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6743,     0,     0,     0,     0,     0,     0,     0,  3926,     0,
       0,     0,     0,  2420,     0,     0,  6756,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6764,     0,     0,     0,
       0,     0,     0,     0,  6262,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,
    1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,
       0,     0,     0,     0,     0,  6795,  6796,  6798,     0,     0,
       0,     0,  6803,  6805,     0,  6807,     0,  6809,     0,     0,
       0,  6814,     0,  6816,  6817,     0,  3116,     0,     0,     0,
    6798,     0,  6805,     0,     0,     0,     0,     0,     0,  6828,
    6829,     0,  6831,     0,  6833,     0,  6835,  6836,  6837,     0,
       0,     0,  2552,     0,     0,     0,  3201,  2420,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6865,     0,     0,     0,     0,
    6872,     0,  3241,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3254,  6886,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6887,     0,
    6888,     0,     0,  6890,     0,  6892,     0,     0,  6895,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4485,  6906,
       0,     0,     0,  4898,     0,     0,     0,     0,     0,  3930,
       0,  3284,  6914,  4507,  2420,  3295,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6925,     0,     0,     0,
       0,     0,     0,  6931,     0,     0,  6934,     0,  6936,     0,
    6938,  6939,  6940,     0,  6942,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6950,     0,  6952,
       0,     0,     0,  6956,     0,  2552,     0,     0,     0,     0,
    2420,  6964,     0,     0,  6966,     0,  6952,     0,     0,     0,
       0,     0,     0,  6970,     0,     0,     0,     0,     0,  6976,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6470,     0,     0,     0,     0,  6993,     0,  6479,     0,     0,
       0,     0,     0,     0,  3438,  6486,  6487,     0,     0,  6490,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    7019,     0,  7020,     0,  7021,  7022,     0,     0,  7024,  3467,
       0,     0,     0,     0,     0,     0,     0,     0,  7034,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  7069,     0,     0,
       0,     0,     0,     0,     0,     0,  7075,     0,     0,     0,
       0,     0,     0,     0,  7079,     0,  7080,  7081,  3529,     0,
       0,  3540,     0,     0,     0,  7085,     0,     0,  7089,  3551,
    7091,     0,     0,  7093,     0,     0,     0,     0,  7085,     0,
       0,     0,     0,     0,  3186,  3529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6593,  3593,  4251,     0,     0,     0,  7116,  7117,
       0,     0,     0,     0,     0,     0,  3616,     0,     0,     0,
       0,     0,     0,     0,     0,  7134,     0,  3626,  7137,     0,
       0,     0,     0,     0,  7140,     0,  7141,  7142,     0,     0,
    7145,  7146,  7147,     0,     0,     0,     0,  7150,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3724,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3149,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  7177,  1486,  1487,     0,  6673,  7182,     0,
       0,     0,  1489,  1490,     0,  7187,  6681,  6682,  6683,  7191,
    1493,  1494,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  7203,     0,  7205,     0,     0,  7208,
       0,  7210,     0,  7212,     0,     0,  3270,     0,     0,  4449,
       0,     0,  7221,  4840,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  7228,  7229,     0,     0,     0,  7232,
    7233,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3833,  3340,     0,     0,     0,  3352,  4476,     0,     0,
    7252,     0,     0,  7255,     0,     0,     0,     0,     0,  7259,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    7263,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3393,  3395,  3397,  3398,  7270,  3802,     0,     0,     0,
       0,     0,     0,     0,  7275,     0,  7277,     0,     0,     0,
       0,     0,     0,     0,  7284,     0,  7286,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3407,  3409,  3411,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  7313,     0,  3435,     0,     0,     0,     0,  3442,  3340,
       0,     0,     0,     0,     0,  3926,  3340,  3340,  3442,     0,
    2420,     0,     0,  7325,     0,     0,  7327,     0,  7328,     0,
    3340,     0,     0,  6846,     0,  6847,     0,     0,  3442,  7348,
       0,     0,     0,     0,  6854,     0,     0,  6863,  7356,     0,
       0,  7359,  7360,     0,     0,     0,     0,     0,     0,  7364,
       0,     0,     0,     0,     0,     0,     0,  7371,     0,     0,
    7374,     0,     0,     0,     0,     0,     0,     0,  3435,     0,
       0,     0,  3532,     0,  7391,  7392,  3340,     0,  3435,     0,
    3340,  3547,     0,     0,     0,  7399,     0,     0,  7402,     0,
       0,     0,     0,     0,     0,     0,     0,  7408,  7409,     0,
       0,  3574,  3442,     0,  3340,     0,     0,     0,     0,     0,
       0,     0,  3435,  3340,  3340,  3340,  3442,  3442,     0,  3442,
       0,  3601,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  7454,     0,
       0,     0,     0,     0,     0,     0,  3952,     0,     0,     0,
       0,     0,  5119,     0,  1486,  1487,     0,     0,     0,     0,
       0,  7480,  1489,  1490,  4709,     0,     0,     0,     0,     0,
    1493,  1494,     0,     0,     0,     0,     0,  7488,     0,     0,
    7491,     0,     0,     0,     0,     0,     0,     0,     0,  7499,
       0,     0,     0,  5632,  5633,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,
    1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,  7546,
       0,  7548,     0,  7550,  7551,     0,     0,  3329,  3330,  3331,
    3332,  3333,  3334,  3335,  3336,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5640,     0,     0,     0,     0,
    7572,     0,  7574,     0,     0,     0,  7576,     0,  3141,     0,
    7578,     0,     0,  7580,  3142,  3143,  1486,  1487,     0,     0,
    7587,  3144,  3145,  3146,  1489,  1490,     0,     0,     0,  3147,
       0,     0,  1493,  1494,     0,     0,     0,     0,     0,     0,
       0,  7603,  4251,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  7615,  7616,     0,     0,     0,     0,     0,
       0,     0,     0,  7103,     0,  7104,  7105,     0,     0,  7107,
    7108,     0,  7109,     0,     0,  7112,  4097,     0,  4102,     0,
       0,     0,     0,     0,     0,  7638,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    7653,  7654,  7655,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  7666,     0,     0,     0,     0,  7669,  7670,
    7671,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  7682,     0,  7684,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  7692,
       0,     0,     0,     0,     0,     0,     0,  7699,     0,     0,
       0,     0,  7706,  7173,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6167,     0,     0,     0,  7723,     0,     0,     0,     0,
       0,  6174,     0,  6176,  6177,  7727,     0,  7729,     0,  7730,
    3141,     0,  5401,     0,     0,     0,  3142,  3143,  1486,  1487,
       0,     0,     0,  3144,  3145,  3146,  1489,  1490,     0,     0,
       0,  3147,     0,     0,  1493,  1494,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  7248,     0,     0,     0,     0,     0,  7254,     0,     0,
       0,     0,  4991,     0,     0,  4991,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4476,     0,     0,     0,     0,
       0,     0,     0,     0,  5511,  1533,  1534,  1535,  1536,  1537,
    1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,
       0,  5103,     0,     0,     0,  5108,     0,     0,     0,     0,
       0,  5108,     0,     0,     0,  3301,  3302,  3303,  3304,  3305,
    3306,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3986,  3987,     0,
       0,     0,     0,  7316,  7317,  5620,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5775,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  7355,     0,     0,  7358,     0,     0,     0,     0,
       0,  7362,     0,     0,     0,     0,     0,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1556,  1557,  1558,  1559,  1560,  1561,  1562,  1563,  1564,     0,
       0,     0,     0,     0,     0,     0,     0,  7405,     0,  5830,
       0,     0,     0,     0,     0,     0,     0,     0,  7414,  7415,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4518,     0,     0,
       0,  7441,     0,     0,     0,     0,     0,  7447,     0,     0,
    7450,     0,     0,     0,     0,     0,     0,     0,     0,  7460,
       0,     0,     0,     0,     0,     0,     0,  6429,     0,     0,
       0,     0,  5298,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  7487,  4449,  6461,  7490,     0,     0,     0,     0,     0,
       0,  7496,  7497,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4596,     0,     0,     0,     0,     0,  4599,
    4600,  4601,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  7543,     0,  5948,     0,     0,     0,  5908,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5967,  1533,
    1534,  4045,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,
    1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,
    1554,  1555,  1556,     0,  7577,  2552,     0,  7579,     0,     0,
    2420,     0,     0,  7585,     0,     0,     0,  3802,   -66,     0,
       0,     0,     0,     0,     0,   -66,   -66,     0,     0,     0,
       0,  5416,     0,   -66,  3529,  4649,  4650,     0,     0,     0,
       0,     0,  4657,  4659,     0,     0,     0,     0,     0,     0,
    7617,     0,  7619,  6594,  7621,  7622,     0,     0,     0,     0,
       0,     0,  6607,   -66,     0,     0,     0,     0,     0,  6030,
       0,     0,     0,     0,     0,  7635,     0,  7636,     0,  7637,
    5457,     0,     0,  4707,     0,     0,  7644,     0,     0,     0,
       0,  6617,     0,     0,   -66,     0,   -66,     0,     0,   -66,
       0,   -66,     0,   -66,     0,  7663,  7664,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6646,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4743,  7679,     0,
       0,     0,     0,     0,     0,     0,  4753,  3529,  4755,     0,
     -66,     0,     0,     0,     0,  6669,     0,     0,     0,  7695,
    3529,     0,  3529,     0,  3529,  3529,     0,     0,     0,     0,
    7707,     0,  7709,     0,     0,     0,     0,     0,     0,     0,
    4796,  4797,  4798,  4799,     0,     0,     0,   -66,   -66,   -66,
     -66,   -66,   -66,   -66,   -66,   -66,   -66,   -66,   -66,   -66,
     -66,   -66,   -66,   -66,   -66,   -66,   -66,   -66,   -66,   -66,
     -66,   -66,   -66,   -66,   -66,   -66,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6206,     0,     0,     0,     0,     0,     0,  6216,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6234,     0,     0,     0,  6239,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6256,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1486,  1487,     0,     0,     0,     0,
    4547,     0,  1489,  1490,  4559,     0,     0,     0,     0,     0,
    1493,  1494,     0,     0,     0,     0,     0,  3802,  6794,     0,
       0,     0,     0,     0,  6800,     0,  6802,     0,     0,  3340,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6270,     0,  6824,     0,     0,     0,
       0,     0,     0,  6827,     0,     0,  6830,     0,     0,     0,
       0,     0,     0,     0,     0,  3930,  4623,  3340,     0,     0,
    2420,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6329,
       0,     0,     0,     0,     0,     0,     0,     0,  4635,     0,
       0,     0,     0,  6343,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5944,     0,     0,     0,  5945,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5965,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4097,     0,     0,     0,  3532,     0,
       0,     0,  3340,     0,  6910,     0,  3442,  3442,     0,  3340,
    3340,     0,  3435,  3435,  3442,     0,     0,     0,     0,     0,
       0,     0,     0,  3435,     0,     0,     0,     0,  3442,  3435,
    3340,     0,  3442,     0,     0,     0,     0,  2552,     0,     0,
       0,     0,  2420,     0,  6944,     0,     0,     0,     0,  6947,
       0,  6949,     0,     0,     0,     0,     0,  6392,     0,     0,
    6958,     0,  6960,  6961,  6399,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6968,     0,  6969,     0,     0,
       0,  3435,  6974,  6975,     0,     0,     0,     0,     0,     0,
    3532,  3442,     0,  3340,     0,  4707,  3340,  4097,     0,     0,
       0,     0,  4707,     0,     0,     0,  3435,     0,     0,     0,
       0,     0,     0,     0,     0,  4707,     0,     0,  7000,     0,
       0,     0,     0,     0,     0,     0,  3435,     0,     0,  6478,
       0,     0,     0,     0,     0,  3186,     0,     0,     0,     0,
       0,  5178,     0,     0,     0,     0,     0,  6110,     0,  5187,
    5188,     0,  7033,     0,     0,  6117,     0,     0,     0,  6122,
       0,     0,     0,     0,     0,     0,  4827,  4830,     0,  5748,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5764,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  7084,     0,
       0,     0,  7088,     0,     0,     0,     0,     0,     0,     0,
    7095,  6173,     0,     0,     0,     0,  7097,     0,     0,  7099,
       0,     0,  7102,     0,     0,     0,     0,     0,     0,  2552,
       0,     0,     0,     0,  2420,  1533,  1534,  1535,  1536,  1537,
    1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,
       0,     0,     0,     0,     0,  5300,  5822,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5822,     0,     0,  5839,
       0,     0,     0,     0,     0,     0,     0,     0,  5845,     0,
    4707,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4097,     0,  4707,     0,     0,     0,  7175,  7176,     0,  6267,
       0,  7180,     0,     0,     0,  7184,     0,  7185,     0,  7186,
    3141,     0,     0,     0,     0,     0,  3142,  3143,  1486,  1487,
       0,     0,  6675,  3144,  3145,  3146,  1489,  1490,     0,  6310,
       0,  3147,  7206,  7207,  1493,  1494,     0,     0,     0,     0,
       0,     0,     0,  4991,     0,     0,     0,     0,  4991,     0,
       0,     0,  4991,     0,     0,     0,     0,     0,     0,     0,
       0,  7230,  7231,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5103,     0,     0,  5951,  5108,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  7258,     0,     0,     0,     0,  7261,     0,
       0,  6746,     0,  7262,     0,     0,     0,  7264,     0,  6362,
       0,  6364,     0,     0,     0,     0,     0,     0,     0,  7269,
       0,  7271,     0,     0,  7272,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  7288,  7289,     0,     0,  7290,     0,
    1112,     0,     0,     0,     0,     0,   362,   363,   364,   365,
     366,   367,   368,   369,    68,    69,    70,    71,    72,    73,
      74,    75,     0,     0,     0,  7312,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6034,     0,     0,     0,     0,
       0,     0,  6040,     0,     0,     0,  6425,     0,     0,     0,
       0,  6081,     0,     0,     0,     0,  6436,     0,     0,     0,
       0,     0,     0,  6446,     0,     0,     0,  6452,     0,     0,
       0,     0,     0,  6459,     0,     0,     0,     0,     0,  6466,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6075,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6075,  3141,     0,
       0,     0,     0,     0,  3142,  3143,  1486,  1487,     0,     0,
       0,  3144,  3145,  3146,  1489,  1490,     0,     0,  6082,  3147,
       0,     0,  1493,  1494,     0,  6517,     0,  6519,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6531,
       0,     0,     0,     0,     0,     0,  6165,  3153,  3154,  3155,
    6169,     0,     0,  6169,     0,  6083,  6084,  6085,  6086,  6087,
    6088,  6089,  6090,  6091,  6092,  6093,  6094,  6095,  6096,  6097,
    6098,  6099,  6100,  6101,  6102,  6103,     0,  5822,  6104,  6105,
    6106,  6107,  6108,  6109,     0,  5822,  1486,  1487,     0,     0,
       0,     0,     0,     0,  1489,  1490,     0,     0,     0,     0,
       0,     0,  1493,  1494,     0,     0,     0,     0,  5686,     0,
       0,     0,     0,     0,     0,     0,  5300,  5686,  5686,     0,
       0,     0,  5686,     0,     0,  5108,  5108,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6988,     0,     0,     0,     0,  1533,
    1534,  4048,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,
    1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,
    1554,  1555,  1556,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3141,  4518,     0,     0,
    5701,  5702,  3142,  3143,  1486,  1487,     0,     0,     0,  3144,
    3145,  3146,  1489,  1490,  7057,     0,     0,  3147,     0,     0,
    1493,  1494,     0,     0,     0,     0,     0,     0,     0,     0,
    5822,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2779,     0,     0,     0,     0,  6716,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6727,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3186,     0,     0,     0,     0,     0,     0,  3141,     0,     0,
       0,  5686,  4518,  3142,  3143,  1486,  1487,  5300,     0,     0,
    3144,  3145,  3146,  1489,  1490,     0,     0,     0,  3147,     0,
       0,  1493,  1494,     0,     0,     0,     0,     0,     0,  7675,
    4518,  7677,     0,     0,     0,  5300,     0,     0,  3529,  3529,
       0,     0,     0,     0,     0,  4165,  7151,     0,     0,     0,
    2420,     0,     0,  7152,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6791,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4991,     0,     0,     0,
       0,     0,     0,     0,  6075,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6075,  4991,     0,     0,     0,
       0,     0,     0,     0,     0,  4991,     0,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1556,     0,     0,     0,     0,  6869,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4991,     0,  4991,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6034,     0,
       0,     0,  6034,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4251,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6902,     0,     0,     0,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1556,     0,     0,     0,  6926,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6935,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3157,  3158,  3159,  3160,  3161,  3162,  3163,
    3164,  3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,
    3174,  3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5764,
    5764,     0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,
    1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,
       0,     0,     0,     0,     0,     0,     0,  5764,     0,     0,
       0,     0,     0,     0,     0,  3301,  3302,  3303,  3304,  3305,
    3306,  3307,     0,  3308,  3309,  3310,     0,     0,     0,  3311,
    3312,  3313,  3314,     0,     0,  3315,  3316,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5822,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,  1486,  1487,     0,     0,     0,  5822,     0,
       0,  1489,  1490,     0,     0,     0,     0,  5822,     0,  1493,
    1494,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   776,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6774,
       0,     0,     0,     0,     0,  6779,  6779,  6774,     0,     0,
    6774,     0,     0,  6774,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  7169,     0,     0,  7172,     0,     0,     0,  5764,     0,
       0,     0,     0,     0,  2427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2552,
       0,     0,     0,     0,  2420,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  7592,     0,  5108,     0,     0,
       0,  6857,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6075,     0,     0,     0,     0,     0,     0,
    4991,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3153,  3154,  3155,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6075,     0,     0,     0,     0,     0,     0,     0,
       0,  6911,     0,     0,     0,  6916,  1486,  1487,   776,     0,
       0,   710,     0,     0,  1489,  1490,     0,     0,     0,  4991,
       0,  5300,  1493,  1494,     0,     0,   713,   714,   715,   716,
       0,   720,  7285,     0,  7287,     0,     0,     0,   728,     0,
       0,     0,     0,     0,  5686,     0,     0,     0,     0,     0,
    7298,  5764,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  7307,     0,     0,  7310,  7311,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5764,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  7326,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  7354,     0,     0,     0,  7357,     0,     0,  6911,
       0,     0,  4991,     0,  4991,     0,     0,     0,  7366,  7367,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4138,     0,     0,
    2353,     0,  2420,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  7407,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
    5764,     0,  5764,     0,     0,     0,     0,     0,  7446,     0,
       0,  7449,     0,     0,     0,     0,     0,     0,     0,  7458,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6857,
       0,     0,     0,     0,     0,     0,     0,  2552,     0,     0,
       0,     0,  2420,     0,     0,     0,     0,  3843,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  7498,     0,  7500,     0,  7502,
    7503,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  7535,     0,     0,     0,  7539,     0,     0,
    7542,     0,  2353,     0,     0,     0,     0,     0,     0,  7549,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5764,  1097,     0,     0,
    5764,     0,     0,     0,     0,     0,     0,  5764,     0,  5764,
       0,     0,     0,     0,     0,  3930,     0,     0,     0,     0,
    2420,     0,  7582,  7583,     0,  3141,     0,     0,     0,     0,
       0,  3142,  3143,  1486,  1487,  6774,     0,  6774,  3144,  3145,
    3146,  1489,  1490,     0,     0,  6774,  3147,     0,  6774,  1493,
    1494,     0,     0,     0,     0,     0,     0,     0,     0,  7614,
       0,     0,     0,     0,     0,     0,     0,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1556,     0,     0,  1204,     0,     0,  7642,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4141,     0,     0,  5103,
       0,  2420,     0,     0,     0,     0,     0,     0,     0,  7665,
       0,  7667,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6774,  3157,  3158,  3159,  3160,  3161,  3162,  3163,
    3164,  3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,
    3174,  3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5103,     0,  1274,
    1275,  1276,  1277,  1278,  1279,  1280,  1281,  1282,  1283,  1284,
    1285,  1286,  1287,  1288,  1289,  1290,  1291,  1292,  1293,  1294,
    1295,  1296,  1297,  1298,     0,  1300,  1302,  1303,  1304,  1305,
    1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,  1314,  1315,
    1316,  1317,  1318,  1319,  1320,  1321,  1322,  1323,  1324,  1325,
    1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,     0,
    1336,  1337,     0,  1339,     0,  1341,  1342,  1343,  1344,  1345,
    1346,  1347,  1348,  1349,  1350,     0,  1352,  1353,  1354,  1355,
    1356,  1357,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  7416,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1401,  1403,  1405,  1407,  1409,  1411,
    1413,  1415,  1417,  1419,  1421,  1423,  1425,  1427,  1429,  1430,
       0,  1432,     0,  1434,     0,  1436,  1437,  1438,     0,     0,
    1441,     0,  1443,     0,  1445,     0,  1447,     0,  1449,     0,
    1451,  7477,  1453,     0,  1455,     0,  1457,     0,  1459,     0,
    1461,     0,     0,  1464,     0,  1466,  1467,  1468,  1469,  1470,
       0,  2239,  2240,  2241,  2242,  2243,  2244,  2245,  2246,  2247,
    2248,  2249,  2250,  2251,  2252,  2253,  2254,  2255,  2256,  2257,
    2258,  2259,  2260,  2261,  2262,  2263,  2264,  2265,  2266,  2267,
    2268,     0,     0,     0,  6774,  6774,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  7416,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2287,
    2288,     0,     0,     0,  3301,  3302,  3303,  3304,  3305,  3306,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  7477,     0,  6774,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3141,  2322,
       0,     0,     0,     0,  3142,  3143,  1486,  1487,     0,     0,
       0,  3144,  3145,  3146,  1489,  1490,     0,     0,     0,  3147,
       0,     0,  1493,  1494,  4138,     0,     0,     0,     0,  2420,
       0,     0,     0,     0,     0,  6034,  6034,  5916,     0,     0,
       0,     0,     0,   497,     0,  6774,  6774,     0,     0,  2375,
     498,   103,     0,     0,  2377,     0,     0,  2380,   105,     0,
       0,     0,  2385,     0,     0,     0,  7676,     0,  6774,     0,
       0,     0,     0,     0,     0,     0,  2397,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5937,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  7712,     0,  6774,  6774,  6774,     0,  2415,
       0,     0,     0,     0,  5938,     0,  5939,     0,  5940,     0,
       0,     0,  6774,  1112,  6774,     0,  5443,  6774,     0,   362,
     363,   364,   365,   366,   367,   368,   369,    68,    69,    70,
      71,    72,    73,    74,    75,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6424,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1071,  1072,  1073,  1074,  1075,  1076,  1077,   126,
    1078,  1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,  1086,
     137,  1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,     0,     0,     0,     0,  3141,     0,     0,     0,     0,
       0,  3142,  3143,  1486,  1487,     0,     0,  2552,  3144,  3145,
    3146,  1489,  1490,     0,     0,     0,  3147,     0,     0,  1493,
    1494,  6082,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3244,     0,     0,     0,  6083,  6084,
    6085,  6086,  6087,  6088,  6089,  6090,  6091,  6092,  6093,  6094,
    6095,  6096,  6097,  6098,  6099,  6100,  6101,  6102,  6103,  3263,
       0,  6104,  6105,  6106,  6107,  6108,  6109,     0,     0,     0,
       0,     0,     0,  3244,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3244,     0,  3244,
    3341,     0,     0,     0,     0,     0,     0,     0,     0,  3359,
       0,     0,  3363,     0,     0,  3367,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3244,  4005,
    4006,  4007,  4008,  4009,  4010,  4011,  4012,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1556,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3408,  3410,  3412,     0,     0,     0,     0,     0,     0,     0,
     887,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,  3436,     0,     0,     0,     0,  3443,  3341,    83,     0,
       0,     0,     0,     0,  3341,  3341,  3443,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,  3341,     0,
       0,    92,    93,     0,     0,    94,  3443,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,  3141,     0,     0,   105,     0,     0,  3142,
    3143,  1486,  1487,     0,     0,     0,  3144,  3145,  3146,  1489,
    1490,     0,     0,     0,  3147,     0,  3436,  1493,  1494,     0,
    3533,     0,     0,     0,  3341,     0,  3436,     0,  3341,  3548,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3244,     0,     0,  3244,     0,     0,  3575,
    3443,     0,  3341,     0,     0,     0,     0,     0,  3244,     0,
    3436,  3341,  3341,  3341,  3443,  3443,     0,  3443,  3244,  3602,
    3244,  3244,     0,     0,     0,  3244,     0,   106,   107,   108,
     109,   110,   111,   112,  3930,   113,   114,   115,   116,     0,
       0,  1486,  1487,     0,     0,     0,     0,     0,   117,  1489,
    1490,     0,     0,   118,     0,     0,     0,  1493,  1494,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,  3141,     0,     0,     0,
       0,  5275,  3142,  3143,  1486,  1487,     0,   497,     0,  3144,
    3145,  3146,  1489,  1490,   498,   103,     0,  3147,     0,     0,
    1493,  1494,   105,     0,     0,     0,     0,     0,  1486,  1487,
       0,     0,     0,  5903,  5207,  3964,  1489,  1490,     0,   497,
       0,     0,     0,     0,  1493,  1494,   498,   103,     0,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,  1557,  1558,  1559,  1560,
    1561,  1562,  1563,  1564,  3329,  3330,  3331,  3332,  3333,  3334,
    3335,  3336,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,  2552,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2908,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   118,     0,     0,     0,     0,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,   126,  1078,  1079,  1080,   130,  1081,  1082,
    1083,  1084,  1085,  1086,   137,  1087,  1088,   140,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,     0,     0,     0,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,   126,  1078,  1079,  1080,   130,
    1081,  1082,  1083,  1084,  1085,  1086,   137,  1087,  1088,   140,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,     0,     0,     0,
       0,  2954,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2968,  2969,     0,     0,     0,     0,     0,  4099,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2978,     0,
       0,  2980,  2982,  2984,     0,     0,  2986,     0,     0,     0,
       0,     0,     0,     0,  2989,     0,     0,     0,     0,     0,
       0,     0,  2998,  3000,  3002,  3004,  3006,  3008,     0,     0,
       0,     0,     0,     0,  3016,  3018,  3020,  3022,  3024,  3026,
       0,     0,     0,     0,     0,     0,  3034,  3036,  3038,  3040,
    3042,  3044,     0,     0,     0,     0,     0,     0,  3052,  3054,
    3056,  3058,  3060,  3062,  3063,  3064,  3065,  3066,  3067,  3068,
    3070,  3072,  3074,  3076,  3078,  3080,  3082,  3084,  3086,     0,
       0,     0,  3090,  3092,  2552,     0,  3095,     0,     0,  3098,
    3099,  3100,  3101,     0,  3103,  3104,  3105,     0,     0,     0,
       0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,
    1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,  1533,
    1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,
    1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,
    1554,  1555,  1556,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1112,     0,     0,     0,     0,     0,   362,   363,   364,
     365,   366,   367,   368,   369,    68,    69,    70,    71,    72,
      73,    74,    75,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,     0,     0,     0,     0,
       0,     0,  3930,     0,     0,     0,     0,     0,     0,  4099,
       0,     0,     0,     0,  3485,     0,     0,     0,     0,     0,
       0,     0,     0,  5478,     0,  5479,     0,     0,     0,     0,
    5480,     0,     0,     0,     0,     0,     0,     0,  4548,     0,
       0,     0,  4560,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3244,     0,     0,     0,  3341,     0,  5481,
       0,     0,     0,     0,     0,  7154,     0,     0,     0,     0,
       0,   497,     0,     0,  3244,     0,     0,     0,   498,   103,
       0,     0,  2552,     0,     0,     0,   105,  2420,     0,     0,
       0,     0,     0,     0,     0,  3341,  5482,  5483,  5484,  5485,
    5486,  5487,  5488,  5489,  5490,  5491,  5492,  5493,  5494,  5495,
    5496,  5497,  5498,  5499,  5500,  5501,  5502,  5503,  5504,  5505,
    5506,  5507,  5508,  5509,  5510,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3656,  3657,  3658,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3533,     0,     0,     0,
    3341,     0,     0,     0,  3443,  3443,     0,  3341,  3341,     0,
    3436,  3436,  3443,   118,     0,     0,     0,     0,     0,     0,
       0,  3436,     0,     0,     0,  3720,  3443,  3436,  3341,     0,
    3443,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4099,     0,     0,     0,     0,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,   126,  1078,  1079,
    1080,   130,  1081,  1082,  1083,  1084,  1085,  1086,   137,  1087,
    1088,   140,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  3436,
       0,     0,     0,     0,     0,     0,     0,     0,  3533,  3443,
       0,  3341,     0,     0,  3341,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3436,     0,     0,     0,     0,     0,
       0,     0,  3244,     0,  3244,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3436,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4807,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3244,     0,  4828,  4831,     0,  1112,     0,     0,
       0,  3818,     0,   362,   363,   364,   365,   366,   367,   368,
     369,    68,    69,    70,    71,    72,    73,    74,    75,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6435,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3850,
       0,     0,     0,     0,     0,  3930,     0,  3865,     0,     0,
       0,  3868,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3930,
       0,     0,     0,     0,  3892,     0,  3897,  3898,  3899,  3900,
    3901,     0,  3902,     0,     0,     0,     0,     0,     0,     0,
       0,  3913,     0,     0,     0,  3915,  3916,     0,     0,     0,
       0,     0,     0,     0,  3920,  6082,     0,     0,  3927,  3928,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3938,     0,  3939,     0,     0,     0,     0,     0,     0,
    3944,  3945,     0,     0,  3947,     0,  3948,     0,     0,     0,
       0,     0,  6083,  6084,  6085,  6086,  6087,  6088,  6089,  6090,
    6091,  6092,  6093,  6094,  6095,  6096,  6097,  6098,  6099,  6100,
    6101,  6102,  6103,     0,     0,  6104,  6105,  6106,  6107,  6108,
    6109,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4099,     0,     0,  3979,
    3980,     0,  3981,  3982,  3983,  3984,  3985,     0,  3988,  3989,
    3990,  3991,  3992,  3993,  3994,  3995,  3996,  3997,  3998,  3999,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4014,  4015,  4016,     0,     0,     0,
    4017,  4018,     0,  4019,  4020,  4021,  4022,  4023,  4024,  4025,
    4026,     0,  4027,  4028,     0,  4030,     0,  4032,  4033,  4034,
    4035,  4036,  4037,  4038,  4039,  4040,  4041,  4042,  4043,  4044,
       0,  4046,  4047,     0,  4049,  4050,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4099,     0,  4099,
       0,     0,     0,   497,  4099,     0,     0,     0,  4075,  4076,
     498,   103,     0,     0,     0,     0,     0,  4099,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5757,  5754,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4121,  4122,     0,     0,     0,     0,     0,     0,
    4128,  4129,  4131,  4132,   497,     0,     0,     0,     0,     0,
    4137,   498,   103,     0,  4139,  4140,     0,  4142,  4143,   105,
       0,     0,     0,  5758,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   499,     0,
       0,     0,  4164,     0,  4166,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4194,  4195,     0,     0,     0,
    4199,  4200,  4201,  4203,  4205,  4207,  4210,  4212,  4214,     0,
       0,  4217,  1071,  1072,  1073,  1074,  1075,  1076,  1077,   126,
    1078,  1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,  1086,
     137,  1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,     0,  4099,     0,     0,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4099,     0,  4099,     0,     0,     0,     0,     0,
       0,     0,     0,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
     126,  1078,  1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,
    1086,   137,  1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,     0,     0,     0,     0,  4336,  4338,  4340,  4342,
       0,     0,     0,     0,     0,     0,     0,  4347,  4349,  4351,
    4353,  4355,  4357,  4359,  4361,  4363,  4365,     0,     0,  4369,
    4371,  4373,  4375,  4377,  4379,  4381,  4383,  4385,  4387,     0,
       0,  4391,  4393,  4395,  4397,  4399,  4401,  4403,  4405,  4407,
    4409,     0,     0,  4413,  4415,  4417,  4419,  4421,  4423,  4424,
    4425,  4426,  4427,  4428,  4429,  4430,  4431,  4432,  4433,  4434,
    4435,  4436,  4437,  4438,  4439,  4440,  1112,     0,     0,     0,
       0,     0,   362,   363,   364,   365,   366,   367,   368,   369,
      68,    69,    70,    71,    72,    73,    74,    75,     0,     0,
       0,     0,     0,   681,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6445,     0,     0,
       0,     0,  4481,     0,   374,     0,   377,   379,     0,   381,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4509,     0,     0,
    4513,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4524,     0,  4526,     0,  4528,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6082,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6083,  6084,  6085,  6086,  6087,  6088,  6089,  6090,  6091,
    6092,  6093,  6094,  6095,  6096,  6097,  6098,  6099,  6100,  6101,
    6102,  6103,     0,     0,  6104,  6105,  6106,  6107,  6108,  6109,
       0,     0,     0,     0,     0,     0,  4629,  4630,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   885,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   924,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4643,     0,     0,  4644,     0,
    4099,     0,     0,     0,     0,     0,     0,     0,     0,  4099,
    4099,     0,     0,     0,  4099,  1112,     0,     0,     0,     0,
       0,   362,   363,   364,   365,   366,   367,   368,   369,    68,
      69,    70,    71,    72,    73,    74,    75,     0,     0,  4693,
    4694,  4695,     0,     0,  1112,  4699,  4700,  4701,     0,  4703,
     362,   363,   364,   365,   366,   367,   368,   369,    68,    69,
      70,    71,    72,    73,    74,    75,  6451,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4099,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6458,     0,     0,     0,  1069,
    1070,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1121,  1122,  1123,  1124,
    1125,  1126,  1127,  1128,  1129,  1130,  1131,  1132,  1133,  1134,
    1135,  1136,  1137,  1138,  1139,     0,  1140,  1141,     0,     0,
       0,     0,     0,  6082,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4812,     0,  4813,     0,  4814,     0,
       0,  4819,   497,  4820,     0,  4821,     0,     0,     0,   498,
     103,     0,  6082,  4099,  4099,     0,     0,   105,     0,  4838,
    6083,  6084,  6085,  6086,  6087,  6088,  6089,  6090,  6091,  6092,
    6093,  6094,  6095,  6096,  6097,  6098,  6099,  6100,  6101,  6102,
    6103,     0,  4099,  6104,  6105,  6106,  6107,  6108,  6109,  6083,
    6084,  6085,  6086,  6087,  6088,  6089,  6090,  6091,  6092,  6093,
    6094,  6095,  6096,  6097,  6098,  6099,  6100,  6101,  6102,  6103,
       0,     0,  6104,  6105,  6106,  6107,  6108,  6109,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5443,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5515,     0,
       0,     0,     0,     0,   497,     0,     0,     0,     0,  1269,
    1270,   498,   103,     0,   118,     0,     0,     0,     0,   105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   932,     0,     0,     0,     0,  1299,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5516,
       0,  1071,  1072,  1073,  1074,  1075,  1076,  1077,   126,  1078,
    1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,  1086,   137,
    1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    5478,     0,  5517,     0,     0,     0,     0,  5518,     0,  5519,
       0,     0,     0,     0,     0,     0,     0,  5520,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4977,  4978,     0,   118,     0,     0,     0,
    4983,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4998,     0,     0,  5065,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5094,
       0,     0,     0,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
     126,  1078,  1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,
    1086,   137,  1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1148,     0,  5879,     0,     0,     0,  5113,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5147,  5148,  5149,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5151,
    5152,     0,     0,     0,     0,     0,     0,     0,  5157,  5158,
    5159,  2269,  5161,     0,  5163,  5164,  5165,     0,     0,  5168,
    5169,  5170,  5171,  5172,  5173,  5174,  5176,     0,     0,     0,
       0,  5180,     0,  5183,  5184,  5185,  5186,     0,     0,  5189,
    5190,  5191,  5192,  5193,  5194,  5195,     0,  5196,  5197,  5198,
    5199,  5200,  5201,  5202,  5203,     0,  5204,  5205,     0,  5206,
       0,  5208,  5209,  5210,  5211,  5212,  5213,  5214,  5215,     0,
       0,  5216,  5217,  5218,  5219,  5220,  5221,  5222,  5223,  5224,
       0,  5226,  5227,     0,     0,     0,     0,     0,     0,  5232,
    5233,     0,     0,  5236,  5237,  5238,  5239,  5240,  5241,  5242,
    5243,  5244,  5245,  5246,  5247,  5248,  5249,  5250,     0,     0,
    5253,     0,  5255,     0,  5257,  5258,  5259,  5260,  5261,  5262,
    5263,  5264,  5265,  5266,  5267,  5268,  5269,  5270,  5271,  5272,
    5273,  5274,     0,     0,     0,     0,  2369,  2369,     0,     0,
       0,     0,     0,     0,     0,  5291,  5292,  5294,     0,     0,
       0,     0,     0,     0,     0,     0,  5302,  5303,  5304,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5313,     0,  5314,     0,  5316,  5317,  5318,     0,  2369,
    2369,  5321,  5322,  5323,  5324,     0,  5326,  5327,  5328,  5329,
    5330,  5331,  5332,  5333,  5334,  5335,  5336,  5337,  5338,  5339,
    5340,  5341,     0,  5343,  5344,  5345,  5346,  5347,     0,     0,
       0,  5349,     0,  5351,  5352,     0,  5354,  6159,  5355,     0,
       0,  5358,  5359,  5360,  5361,  5362,  5363,     0,  5365,  5366,
    5367,  5368,  5369,  5370,  5371,  5372,  5373,  5374,  5375,  5376,
    5377,  5378,  5379,  5380,  5381,  5382,  5383,  5384,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5391,  5392,  5393,  5394,  5395,  5396,  5397,
    5398,  5399,  5400,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   352,   361,     0,     0,     0,     0,     0,
     380,  1112,     0,     0,     0,   389,     0,   362,   363,   364,
     365,   366,   367,   368,   369,    68,    69,    70,    71,    72,
      73,    74,    75,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4099,     0,     0,     0,
       0,     0,  6465,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5539,
    5541,  5543,  5545,     0,  5547,  5548,  5549,  5550,  5551,  5552,
    5554,  5556,  5558,  5560,  5562,  5564,  5565,  5566,  5567,  5568,
    5569,  5570,  5572,  5574,  5576,  5578,  5580,  5582,  5583,  5584,
    5585,  5586,  5587,  5588,  5590,  5592,  5594,  5596,  5598,  5600,
    5601,  5602,  5603,  5604,  5605,  5606,  5607,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6082,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6083,  6084,  6085,  6086,
    6087,  6088,  6089,  6090,  6091,  6092,  6093,  6094,  6095,  6096,
    6097,  6098,  6099,  6100,  6101,  6102,  6103,     0,     0,  6104,
    6105,  6106,  6107,  6108,  6109,     0,     0,     0,  1112,     0,
       0,     0,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,    68,    69,    70,    71,    72,    73,    74,    75,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5646,     0,     0,     0,     0,     0,  5650,
       0,  5652,     0,     0,     0,     0,  5656,     0,     0,  6868,
       0,     0,     0,     0,     0,     0,     0,     0,  5665,     0,
    5666,  5667,     0,     0,  5672,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   677,     0,     0,  5682,  5683,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5695,  5696,
       0,  5697,  5698,     0,     0,     0,  6082,  5699,  5700,     0,
       0,     0,     0,     0,  2474,     0,  2475,     0,  2476,     0,
    2477,     0,  2478,     0,  2479,     0,  2480,     0,  2481,     0,
    2482,     0,  2483,     0,  2484,     0,  2485,     0,  2486,     0,
    2487,     0,  2488,  6083,  6084,  6085,  6086,  6087,  6088,  6089,
    6090,  6091,  6092,  6093,  6094,  6095,  6096,  6097,  6098,  6099,
    6100,  6101,  6102,  6103,     0,     0,  6104,  6105,  6106,  6107,
    6108,  6109,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5717,
    5718,     0,     0,  5720,     0,     0,     0,     0,     0,     0,
    5724,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5733,     0,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,     0,     0,   886,   888,   890,   892,   893,   895,   897,
     899,   901,   903,   905,   907,   909,   911,   913,   915,   917,
     919,   922,     0,   926,   928,   930,     0,   934,   935,   937,
     938,   939,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
    1000,  1002,  1004,  1006,  1008,  1009,  1011,  1013,  1015,  1017,
    1019,  1021,  1023,  1025,  1027,  1029,  1031,  1032,  1034,  1036,
    1038,     0,     0,     0,     0,     0,     0,  2154,  1112,     0,
       0,     0,     0,     0,   362,   363,   364,   365,   366,   367,
     368,   369,    68,    69,    70,    71,    72,    73,    74,    75,
       0,     0,     0,     0,     0,  1102,     0,     0,  1104,     0,
       0,  1117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6901,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1156,     0,     0,     0,     0,
    1165,  1166,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,
    1175,  1176,  1177,  1178,     0,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,     0,  1193,     0,     0,     0,  1197,
       0,     0,     0,  1117,     0,  1201,  1202,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6082,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1229,     0,     0,     0,
    1233,  1234,     0,     0,  1237,     0,     0,     0,     0,  1242,
       0,     0,     0,  6083,  6084,  6085,  6086,  6087,  6088,  6089,
    6090,  6091,  6092,  6093,  6094,  6095,  6096,  6097,  6098,  6099,
    6100,  6101,  6102,  6103,  5942,     0,  6104,  6105,  6106,  6107,
    6108,  6109,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5973,  5974,  5975,  5976,  5977,  5978,
       0,  5980,  5981,  5982,  5983,     0,     0,     0,     0,     0,
       0,  5984,  5985,  5986,  5987,  5988,  5989,  5990,  5991,     0,
    5992,  5993,  5994,     0,     0,     0,     0,     0,     0,  5999,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6001,     0,  6003,  6004,  6005,  6006,
    6007,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2921,  2922,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5916,     0,
    6048,     0,     0,     0,   497,     0,     0,     0,     0,     0,
       0,   498,   103,     0,     0,     0,     0,     0,     0,   105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5917,
       0,     0,     0,     0,     0,     0,     0,  6127,  6128,  6129,
    6130,  6131,  6132,  6133,  6134,  6135,  6137,  6139,  6140,  6141,
    6142,  6143,  6145,  6147,  6148,  6149,  6150,  6151,  6153,  6155,
    5478,     0,     0,     0,     0,  5918,     0,  5919,     0,  5920,
       0,     0,  2976,     0,     0,     0,     0,  5443,     0,  2985,
       0,     0,  6172,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6198,  6199,  6200,     0,     0,     0,     0,  2274,
       0,     0,     0,     0,     0,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  6231,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
     126,  1078,  1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,
    1086,   137,  1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,     0,  3109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3131,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3109,  3109,     0,     0,     0,
       0,     0,     0,     0,  6313,  3109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2398,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3109,     0,  3109,  3109,     0,     0,     0,  1148,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2416,     0,     0,
    3109,     0,  6353,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3109,     0,     0,  3109,     0,     0,     0,
       0,  3109,     0,     0,     0,     0,     0,     0,     0,  3109,
       0,  2417,     0,     0,  2418,     0,     0,  3109,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2431,     0,     0,
       0,     0,     0,     0,  2432,  2433,  2434,  2435,  2436,  2437,
    2438,  2439,  2440,  2441,  2442,  2443,  2444,  2445,  2446,  2447,
    2448,  2449,  2450,  2451,  2452,  2453,  2454,  2455,  2456,  2457,
    2458,  2459,  2460,  2461,  2462,  2463,  2464,  2465,  2466,  2467,
    2468,  2469,  2470,  2471,  2472,  2473,     0,     0,     0,     0,
       0,  3432,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5916,     0,     0,     0,     0,     0,   497,     0,     0,
       0,     0,     0,     0,   498,   103,     0,  2489,     0,  2490,
       0,  2491,   105,     0,     0,  2492,  2493,     0,  2494,     0,
    2495,     0,  2496,     0,  2497,     0,  2498,  6484,  2499,     0,
    2500,  6488,  2501,     0,  2502,     0,  2503,     0,  2504,  2505,
       0,  2506,  5927,     0,     0,     0,     0,     0,  3109,     0,
       0,     0,  3109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6513,     0,     0,  6516,     0,     0,     0,     0,
       0,     0,     0,  5478,     0,     0,     0,     0,     0,     0,
    5928,     0,  5929,  3432,  3432,     0,     0,     0,  3109,  3109,
    5443,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3109,
       0,  3109,  3109,     0,     0,     0,     0,     0,  3109,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6584,  6585,  6586,
    6587,  6588,  6589,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6600,     0,     0,     0,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,   126,  1078,  1079,  1080,   130,  1081,  1082,
    1083,  1084,  1085,  1086,   137,  1087,  1088,   140,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,     0,     0,     0,     0,     0,
       0,     0,  6624,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6636,     0,     0,     0,     0,     0,  2369,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5916,     0,     0,     0,     0,  6658,   497,     0,
       0,     0,     0,  6663,     0,   498,   103,     0,     0,     0,
       0,     0,     0,   105,     0,     0,     0,  6679,     0,     0,
       0,     0,     0,  6684,     0,     0,     0,  6549,     0,     0,
       0,     0,     0,   497,     0,  6694,     0,     0,     0,     0,
     498,   103,     0,  6496,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5478,     0,     0,     0,  6550,     0,
       0,  6497,     0,  6498,  6737,     0,     0,     0,     0,     0,
       0,  5443,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6754,  6755,     0,     0,     0,     0,  5478,
       0,  5517,     0,     0,     0,     0,     0,     0,  6551,     0,
     118,     0,     0,  2792,     0,  3789,  6552,     0,     0,     0,
       0,     0,     0,     0,     0,  6771,  3109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  6789,  6790,   118,     0,  1071,  1072,  1073,
    1074,  1075,  1076,  1077,   126,  1078,  1079,  1080,   130,  1081,
    1082,  1083,  1084,  1085,  1086,   137,  1087,  1088,   140,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,     0,     0,     0,     0,
       0,     0,  1071,  1072,  1073,  1074,  1075,  1076,  1077,   126,
    1078,  1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,  1086,
     137,  1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3789,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3789,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3789,
       0,     0,  3789,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3109,
       0,  3716,     0,  3717,     0,  3718,     0,  3719,     0,     0,
       0,   497,     0,     0,     0,     0,     0,     0,   498,   103,
       0,  3727,     0,  3728,     0,  3729,   105,  3730,     0,  3731,
    3789,  3732,     0,     0,     0,     0,     0,     0,     0,  3739,
       0,  3740,     0,  3741,     0,  3742,     0,  3743,     0,  3744,
       0,     0,     0,     0,     0,     0,  5909,  3751,     0,  3752,
       0,  3753,     0,  3754,     0,  3755,     0,  3756,     0,     0,
       0,     0,     0,     0,     0,  3763,     0,  3764,  6983,  3765,
       0,  3766,  6985,  3767,     0,  3768,     0,  5478,  3789,  5910,
       0,     0,  5911,  3769,  5912,  3770,  5913,  3771,     0,  3772,
       0,  3773,     0,  3774,     0,  3775,     0,  3776,     0,  3777,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   118,  7031,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  7068,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,   126,  1078,  1079,
    1080,   130,  1081,  1082,  1083,  1084,  1085,  1086,   137,  1087,
    1088,   140,  1089,  1090,  1091,  1092,  1093,  1094,  1095,     0,
       0,     0,     0,     0,     0,     0,     0,  3219,  3219,     0,
       0,     0,     0,     0,     0,     0,  3219,     0,     0,     0,
       0,     0,     0,     0,  3789,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3219,     0,     0,     0,  3219,  3219,     0,     0,
       0,     0,     0,     0,     0,     0,  3219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3789,     0,     0,  3789,     0,     0,     0,     0,
       0,     0,  3219,     0,     0,     0,     0,  3219,     0,     0,
       0,     0,  3219,     0,     0,  3219,     0,     0,  3219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3219,     0,     0,  1104,     0,  3219,  3219,     0,     0,
    2919,     0,     0,     0,     0,     0,     0,     0,     0,  4229,
       0,     0,     0,     0,     0,     0,  7197,     0,     0,     0,
       0,  7202,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2942,     0,     0,     0,     0,  2947,     0,
       0,     0,     0,     0,  7237,  7238,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2565,  2566,  2567,
       0,     0,     0,     0,     0,     0,  7265,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2588,  2589,
    2590,  2591,  2592,  2593,  2594,     0,     0,  3219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2598,     0,  7292,  7293,     0,  2602,  2603,
    2604,  2605,  2606,     0,     0,     0,  2608,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2611,  2612,  3219,
    2614,  2615,  3219,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3219,  3219,  3219,  3219,     0,     0,     0,  3219,     0,
       0,     0,     0,     0,  4466,  2632,     0,     0,  4469,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2634,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2637,     0,     0,     0,     0,     0,
       0,  2638,     0,     0,  4487,  4487,  4487,  4487,  4487,  2641,
    2642,  2643,  2644,     0,  2646,  2647,     0,  2649,  2650,  3109,
       0,     0,  2652,  2653,  2654,  2655,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3109,     0,     0,     0,     0,     0,     0,
       0,     0,  2657,     0,     0,  2658,     0,     0,     0,     0,
       0,     0,     0,  3264,  3109,  3219,  3109,  3109,     0,     0,
       0,     0,     0,     0,     0,  3109,     0,     0,     0,     0,
       0,     0,     0,     0,  2659,  2660,  2661,     0,     0,     0,
       0,  2662,  2663,     0,     0,  2665,     0,     0,  2666,  2667,
    2668,     0,     0,     0,     0,  2671,     0,     0,     0,     0,
       0,     0,     0,  3109,     0,     0,     0,  2682,  2683,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2685,  2687,  2688,  2689,  2690,  2691,  2692,  2693,
    2694,  2695,  2696,  2697,  2698,  2699,  2700,  2701,  2702,  2703,
    2704,  2705,  2706,  2707,  2708,  2709,  2710,  2711,  2712,  2713,
    2714,  2715,     0,     0,     0,  2719,  2720,     0,     0,     0,
       0,     0,     0,     0,     0,  2729,  2730,  2731,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3219,  3426,
    3427,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3449,  3450,  3451,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3505,     0,     0,  2746,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  7649,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3894,  3109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3910,     0,     0,     0,  3579,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3894,     0,
       0,     0,     0,  3894,     0,     0,  3894,     0,     0,     0,
       0,     0,  2757,     0,  3894,     0,     0,     0,     0,  2762,
       0,     0,     0,     0,  2763,     0,     0,     0,     0,     0,
       0,     0,     0,  3647,     0,  1102,     0,  3649,     0,  2274,
       0,     0,     0,  3654,  3655,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2773,     0,     0,  2774,     0,     0,
       0,     0,  3894,     0,     0,     0,  3689,     0,     0,     0,
    2775,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3894,     0,
       0,     0,     0,     0,  3894,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2804,  2806,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3733,  3734,  3735,  3736,  3737,
    3738,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3745,  3746,  3747,  3748,  3749,  3750,     0,
       0,     0,     0,     0,  2872,     0,     0,     0,     0,     0,
       0,  3757,  3758,  3759,  3760,  3761,  3762,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4089,  3219,     0,  3778,  3779,  3780,     0,  3781,     0,  3782,
    3783,     0,  3784,  3785,     0,     0,     0,     0,  3786,     0,
       0,     0,     0,     0,   677,     0,     0,  2269,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3109,     0,     0,   497,     0,     0,     0,     0,     0,
       0,   498,   103,     0,     0,     0,     0,     0,     0,   105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5096,     0,     0,  5096,     0,     0,     0,
       0,  5096,     0,     0,     0,     0,     0,     0,     0,  5933,
    3894,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3109,     0,     0,     0,
    5478,     0,  5910,     0,     0,  5934,     0,  5912,  2269,  5935,
       0,     0,     0,     0,   677,     0,     0,     0,     0,     0,
       0,     0,     0,  3789,     0,     0,     0,     0,  2269,     0,
       0,     0,     0,     0,     0,   677,     0,     0,  3789,     0,
       0,     0,     0,     0,  3917,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,  3109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3917,
       0,     0,     0,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
     126,  1078,  1079,  1080,   130,  1081,  1082,  1083,  1084,  1085,
    1086,   137,  1087,  1088,   140,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,     0,     0,     0,     0,     0,     0,     0,  4929,
       0,  4930,     0,  4931,     0,  4932,     0,     0,     0,     0,
    4934,     0,  4935,     0,  4936,     0,  4937,     0,  4938,     0,
    4939,     0,  4940,     0,  4941,     0,  4942,     0,  4943,     0,
       0,     0,  4946,     0,  4947,     0,  4948,     0,  4949,     0,
    4950,     0,  4951,     0,  4952,     0,  4953,     0,  4954,     0,
    4955,     0,     0,     0,  4958,     0,  4959,     0,  4960,     0,
    4961,     0,  4962,     0,  4963,     0,  4964,     0,  4965,     0,
    4966,     0,  4967,     0,     0,     0,  4970,     0,  4971,     0,
    4972,     0,  4973,     0,  4974,  3219,  4975,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2269,     0,  3789,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   497,
       0,     0,     0,     0,     0,     0,   498,   103,     0,     0,
       0,  3219,  3219,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3109,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5924,     0,     0,     0,     0,  3219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3219,     0,  3219,  3219,
       0,  3219,  3219,  3219,  3219,  5478,     0,  5910,  3219,  3219,
    3219,     0,  5912,     0,  5925,     0,     0,     0,     0,     0,
       0,   677,     0,     0,     0,     0,     0,  3219,  3219,  3219,
    3219,     0,     0,     0,     0,     0,  3219,  3219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3917,  3219,  3219,  3219,
    3219,  3219,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,   126,  1078,  1079,  1080,   130,
    1081,  1082,  1083,  1084,  1085,  1086,   137,  1087,  1088,   140,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4326,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3894,     0,     0,  3219,     0,
       0,     0,     0,     0,     0,     0,  4716,     0,  3219,     0,
    3219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4487,  4487,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3109,  3219,  3219,  3219,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3219,  3219,  3219,     0,     0,     0,     0,
       0,  2269,     0,     0,     0,     0,     0,     0,  3109,     0,
    2269,     0,     0,     0,     0,  3219,  3219,  3219,  3219,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   677,
    2269,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1102,     0,
     677,     0,     0,     0,     0,  4566,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   677,
       0,     0,     0,     0,     0,     0,     0,     0,  2269,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3219,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3894,     0,     0,  3219,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5746,
    5747,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2274,     0,     0,  3505,     0,  4722,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2166,     0,     0,
    3219,     0,  3219,     0,     0,     0,     0,  3219,     0,     0,
       0,     0,     0,     0,     0,   677,     0,     0,     0,     0,
    3219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3910,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3894,     0,     0,     0,     0,     0,     0,
       0,     0,  3894,     0,     0,     0,     0,  3894,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3109,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5902,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4923,
       0,     0,     0,     0,  4925,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3219,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4944,  4945,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3219,     0,  3219,     0,     0,
       0,     0,     0,     0,  4956,  4957,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4968,  4969,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4976,     0,     0,
       0,     0,  3219,     0,     0,     0,     0,  2425,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6072,  6073,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5847,     0,  5848,     0,  5849,     0,  5850,     0,
       0,     0,     0,     0,     0,     0,     0,  5852,  3109,  5853,
       0,  5854,     0,  5855,     0,  5856,     0,  5857,     0,     0,
       0,     0,     0,     0,     0,  5858,     0,  5859,     0,  5860,
       0,  5861,     0,  5862,     0,  5863,     0,     0,     0,     0,
       0,     0,     0,  5864,     0,  5865,     0,  5866,     0,  5867,
       0,  5868,     0,  5869,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2156,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3109,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2269,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2269,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6268,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6295,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5310,     0,  3219,  4722,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6346,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3219,     0,     0,     0,     0,     0,     0,
       0,  3219,  3219,  3219,     0,     0,     0,  3219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3219,     0,  3219,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3219,     0,     0,     0,     0,  3654,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5442,
       0,     0,  5445,  5446,  5447,  5448,  5449,  5450,  5451,  5452,
    5453,  5454,  5455,  5456,     0,  5458,  5459,  5460,  5461,  5462,
    5463,  5464,  5465,  5466,     0,  5471,     0,  5474,     0,  5476,
    5477,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5532,     0,  5534,     0,     0,     0,  3219,  3219,     0,     0,
       0,     0,     0,     0,  6494,  6495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3219,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6544,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6562,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6614,  6350,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5644,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6367,     0,  6368,     0,     0,     0,     0,     0,  6369,     0,
    6370,     0,     0,     0,     0,     0,  6371,     0,  6372,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   677,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3219,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2780,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6799,     0,  6801,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  6813,     0,  6815,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6564,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   677,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6864,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6626,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6638,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6649,
       0,     0,     0,     0,     0,  6654,     0,     0,     0,     0,
       0,     0,  6659,     0,     0,     0,     0,     0,     0,  6665,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3219,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5851,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3219,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3219,
       0,     0,     0,     0,     0,  3110,     0,     0,     0,     0,
       0,  2780,     0,     0,     0,     0,     0,     0,     0,     0,
    5907,     0,     0,     0,     0,     0,     0,  5907,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3148,  3188,  3188,
       0,  2780,     0,  3109,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3225,  3225,     0,
       0,     0,  5907,     0,     0,  3235,  3238,  3242,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3255,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3261,  2778,     0,     0,  3266,  3269,  3272,     0,
       0,     0,     0,     0,  3274,     0,  3277,  3274,     0,  2794,
    3272,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3285,     0,     0,  6010,
    3297,     0,  3325,  3339,     0,     0,  3346,  3351,     0,     0,
       0,     0,  3357,     0,     0,  3277,     0,     0,  3277,     0,
       0,     0,     0,  3274,     0,     0,     0,     0,     0,     0,
       0,  3277,  6045,     0,     0,     0,  3238,  3238,     0,  3383,
    3389,  3272,  3392,  3392,  3148,  3148,  3272,  3272,  3401,     0,
       0,  3401,     0,  3401,     0,     0,     0,     0,     0,     0,
       0,  6050,     0,     0,     0,     0,  6054,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  7236,     0,     0,
       0,     0,     0,  3272,  3272,  3272,     0,     0,  3272,  3272,
    3272,  3272,  3272,  3272,  3420,  3423,     0,     0,     0,  3401,
       0,     0,  3431,     0,  3339,     0,     0,     0,     0,  3441,
    3447,     0,  6996,     0,     0,     0,     0,  3339,  3339,  3339,
    3272,  3272,     0,     0,     0,     0,     0,  3463,     0,     0,
       0,  3339,     0,     0,  2780,     0,     0,  3463,  3463,  3339,
       0,     0,     0,     0,     0,  7028,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3238,     0,     0,
    3383,     0,  3401,     0,  3519,  3401,  3401,  3339,     0,  3339,
       0,     0,     0,  3531,  3536,  3272,  3541,  3339,     0,  3339,
       0,  3339,  3339,     0,  3531,     0,  3447,     0,     0,  3447,
       0,     0,  3447,     0,  6248,     0,  3558,     0,     0,  3563,
    3567,  3570,  3266,  3339,     0,  3339,     0,     0,     0,     0,
       0,  3580,     0,  3339,  3585,  3339,  3339,  3339,  3285,  3272,
    3272,  3277,  3266,  3277,  3277,     0,     0,     0,  3261,     0,
    3570,  2780,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2780,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2778,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3238,     0,  2778,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2778,  2778,     0,     0,     0,     0,     0,
       0,     0,  2778,  2778,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2778,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2778,     0,
       0,     0,  2778,  2778,     0,     0,     0,     0,     0,     0,
       0,     0,  2778,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2778,     0,     0,     0,  2778,     0,  2778,     0,
       0,     0,     0,  2778,     0,     0,     0,     0,  2778,     0,
       0,  2778,     0,     0,  2778,  6427,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6438,     0,  2778,     0,     0,
       0,     0,  2778,  2778,     0,     0,     0,     0,  3225,     0,
       0,     0,     0,     0,     0,     0,  2155,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3838,  3188,     0,  2778,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3188,     0,     0,     0,
    3188,     0,     0,  6536,     0,     0,     0,     0,     0,  3188,
    2778,  3188,     0,  3188,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3480,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2778,     0,  3919,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2778,
       0,     0,  2778,     0,     0,     0,     0,     0,     0,     0,
    2778,     0,     0,     0,     0,  3219,     0,     0,  6613,     0,
    3919,     0,     0,     0,     0,     0,  2778,     0,  2778,     0,
       0,  3274,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2778,  5907,     0,  2778,  2778,  2778,
    2778,     0,     0,     0,  2778,     0,     0,  2778,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2778,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  6678,     0,  6248,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6729,     0,     0,  6732,     0,     0,  6734,     0,     0,     0,
       0,  2778,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3235,  4098,     0,  2780,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6793,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6818,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2778,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3654,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3919,     0,     0,
       0,     0,     0,     0,     0,     0,  6889,     0,     0,  6891,
       0,  6893,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3219,  6924,
    3219,     0,     0,     0,     0,     0,     0,     0,  3896,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3480,     0,  6943,     0,  3896,     0,     0,     0,     0,
    6948,     0,     0,     0,     0,     0,     0,  6955,  3896,     0,
       0,     0,     0,     0,  3896,  6963,     0,     0,     0,  3896,
       0,     0,  3896,     0,     0,     0,     0,     0,     0,     0,
    3896,     0,     0,     0,     0,     0,     0,     0,  3896,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3896,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3896,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3346,  3346,     0,
       0,     0,     0,     0,  3896,  4453,     0,     0,     0,     0,
    3896,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3188,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3188,  3188,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4488,  4491,  4496,  4491,
    4491,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3225,  4098,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3896,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3536,     0,     0,     0,  4558,     0,     0,     0,  3238,
       0,     0,     0,     0,     0,     0,  4090,  2778,     0,  2778,
       0,     0,     0,     0,     0,     0,  3277,     0,  4573,  4573,
    3339,  3238,  3238,  3238,  3238,     0,     0,  3274,  3238,  3238,
    3266,     0,     0,     0,     0,     0,     0,  4592,  2780,     0,
       0,     0,     0,     0,  2780,  2780,  2780,  4606,  3266,  3238,
    3238,     0,     0,     0,     0,  3272,  4615,  4620,  3339,  7178,
       0,     0,     0,     0,  3896,  3110,     0,     0,     0,     0,
       0,     0,     0,     0,  3480,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3266,  3238,  3269,
    3266,  3266,     0,     0,     0,     0,     0,     0,     0,     0,
    3480,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3401,     0,  3401,     0,
       0,     0,     0,     0,     0,     0,     0,  7235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3431,  3531,
    2780,  2780,     0,  3585,     0,     0,  3431,  3285,  3285,  3431,
    3585,  3339,  3431,  3339,  3339,  3339,     0,  7260,     0,     0,
       0,     0,     0,     0,  3272,  3463,     0,     0,  3463,  3272,
    3272,  3272,     0,  3339,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4098,     0,
       0,     0,     0,     0,     0,     0,  3235,     0,  3238,     0,
    3238,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3401,  4732,     0,  3401,     0,     0,  4732,     0,     0,
    3401,     0,  3339,     0,     0,     0,     0,     0,     0,     0,
       0,  3536,  3285,     0,  3272,     0,     0,  3272,     0,     0,
    3235,  2780,  3541,  2780,  3431,  3431,  3431,  3339,  3431,  3431,
       0,     0,     0,     0,     0,  4772,     0,  4777,     0,  3541,
    3541,  3238,  3238,  3238,     0,     0,     0,  3339,     0,  3463,
    3463,     0,     0,  3463,  3463,  2780,  2780,  2780,  2780,     0,
       0,     0,     0,  3266,  3238,  3261,     0,     0,     0,  4811,
       0,     0,     0,     0,     0,     0,  4818,     0,     0,     0,
       0,     0,     0,     0,     0,  3261,  3238,  3266,  3266,  3272,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2778,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2793,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2778,  2778,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2778,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2778,     0,  2778,  2778,     0,  2778,  2778,  2778,
    2778,     0,     0,     0,  2778,  2778,  2778,     0,     0,     0,
       0,     0,     0,     0,  2778,     0,     0,     0,     0,     0,
    2778,  2778,  2778,  2778,  2778,  2778,  2778,     0,     0,     0,
       0,     0,  2778,  2778,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4098,
       0,     0,     0,  2778,  2778,  2778,  2778,  2778,     0,     0,
       0,     0,     0,  3225,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2778,  2778,  2778,     0,     0,
       0,     0,     0,  2778,  2778,     0,     0,     0,     0,     0,
       0,     0,  3188,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3274,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4098,  3896,  4098,     0,  2778,     0,     0,  4098,     0,     0,
       0,     0,  4717,     0,  2778,     0,  2778,     0,     0,     0,
    4098,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2780,  3274,  2778,     0,
       0,     0,     0,     0,  2780,  2780,     0,  2778,  2778,  2778,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2778,     0,  2778,     0,  2778,  2778,  2778,  2778,  2778,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2778,  2778,  2778,  2778,     0,     0,     0,     0,  2778,
    2778,  2778,     0,     0,     0,     0,  3220,  3220,     0,     0,
       0,     0,     0,     0,  3220,  3220,     0,     0,     0,     0,
       0,  2778,  2778,  2778,  2778,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3220,     0,     0,     0,  3220,  3220,     0,     0,     0,
       0,     0,     0,     0,     0,  3220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2780,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3220,     0,     0,     0,     0,  3220,     0,     0,     0,
       0,  3220,     0,     0,  3220,  4098,     0,  3220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3220,     0,     0,     0,     0,  3220,  3220,     0,     0,     0,
       0,     0,     0,     0,     0,  4098,     0,  4098,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3225,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2778,  3220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3896,     0,     0,  2778,
       0,     0,  3220,  3220,     0,  3220,     0,     0,     0,     0,
       0,     0,     0,  3220,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3220,
       0,  3220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3220,  3220,  3220,  3220,     0,     0,     0,  3220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2778,     0,  2778,     0,
       0,     0,     0,  2778,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2778,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3480,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2778,     0,     0,     0,     0,     0,     0,     0,
    2778,  2778,     0,     0,     0,     0,     0,     0,     0,  3896,
       0,     0,     0,     0,     0,     0,     0,     0,  3896,     0,
       0,     0,     0,  3896,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2430,     0,     0,  4496,  4496,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3225,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4098,     0,     0,     0,  3235,     0,     0,
    3274,  3238,  4098,  4098,     0,     0,  2778,  4098,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3238,     0,  3238,     0,     0,     0,     0,     0,
       0,  2778,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3220,     0,     0,
       0,  2778,     0,  2778,     0,  3896,     0,     0,     0,     0,
    3896,     0,  4098,     0,     0,  2780,  2780,  3431,  3431,     0,
       0,  3463,  3463,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2554,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2780,     0,  2778,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3895,     0,     0,     0,     0,  4098,  4098,     0,     0,
       0,  3906,  3541,     0,  3906,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4098,     0,  3895,     0,     0,
    3541,     0,  3895,  3531,  3531,  3895,     0,     0,     0,     0,
       0,     0,     0,  3895,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3895,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3895,     0,     0,
       0,     0,     0,  3895,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2778,  3220,
    3220,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2778,
       0,     0,     0,     0,     0,     0,     0,  2778,  2778,  2778,
       0,     0,     0,  2778,     0,     0,     0,  3277,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3895,  2778,     0,
    2778,     0,  3895,     0,     0,     0,     0,  3906,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3906,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2778,     0,
       0,  2778,  2778,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2778,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2778,  2778,     0,     0,     0,     0,  2778,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2778,     0,     0,     0,     0,  2778,     0,     0,  2778,
    2778,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3277,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3220,  3220,     0,     0,  3274,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3238,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3220,     0,     0,     0,     0,     0,     0,     0,  3220,  4098,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3220,     0,  3220,  3220,     0,
    3220,  3220,  3220,  3220,     0,     0,     0,  3220,  3220,  3220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3220,  3220,  3220,  3220,
       0,     0,     0,  2778,     0,  3220,  3220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3220,  3220,  3220,  3220,
    3220,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2992,     0,     0,     0,
       0,     0,     0,     0,  3895,     0,     0,  3220,     0,     0,
       0,     0,     0,     0,     0,  3220,     0,  3220,     0,  3220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3220,     0,     0,     0,     0,     0,     0,     0,     0,  3220,
       0,  3220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3188,  3220,     0,  3220,     0,  3220,  3220,
    3220,  3220,  3220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3220,  3220,  3220,     0,     0,     0,     0,     0,
       0,  3152,  2430,  2430,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3220,  3220,  3220,  3220,     0,     0,
       0,  2430,  2430,     0,     0,     0,  2778,     0,     0,     0,
       0,  2430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3152,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2430,     0,     0,     0,
    3152,  3152,  3152,     0,     0,     0,     0,     0,     0,     0,
    2430,     0,     0,     0,  3152,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3152,     0,     0,     0,  2430,     0,  2430,  3152,     0,     0,
       0,  3152,     0,     0,     0,     0,  2430,     0,     0,  2430,
       0,     0,  2430,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2430,     0,     0,     0,     0,
       0,     0,  2778,  2430,  2430,  3152,  3152,  3152,  3152,  3152,
    3152,  3152,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2778,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3152,  3152,  3152,
       0,     0,  3152,  3152,  3152,  3152,  3152,  3152,  3152,  3152,
       0,     0,     0,     0,     0,     0,     0,     0,  3152,     0,
       0,     0,     0,  3152,  3152,     0,     0,     0,     0,     0,
       0,  3152,  3152,  3152,  3152,  3152,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3152,     0,     0,     0,     0,
       0,     0,     0,  3152,     0,     0,     0,     0,  3220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3895,
       0,     0,  3220,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2430,     0,     0,     0,  2430,     0,
       0,  3152,     0,  3152,     0,     0,     0,  3152,  3152,  3152,
       0,  3152,     0,  3152,     0,  3152,  3152,     0,  3152,     0,
    3152,     0,     0,  3152,     0,     0,  3152,     0,     0,     0,
    2430,     0,     0,  2430,     0,     0,  3152,  3152,     0,  3152,
       0,     0,     0,     0,     0,  2430,     0,  3152,  3152,  3152,
    3152,  3152,  3152,  3152,  3152,  2430,  3152,  2430,  2430,     0,
       0,     0,  2430,     0,     0,     0,     0,     0,     0,  3220,
       0,  3220,     0,     0,     0,     0,  3220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3906,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3895,     0,     0,     0,     0,     0,     0,     0,
       0,  3895,     0,     0,     0,     0,  3895,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3238,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3220,     0,  3220,     0,  3895,     0,
       0,     0,     0,  3895,     0,     0,     0,     0,     0,     0,
       0,     0,  2430,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   718,     0,     0,     0,     0,     0,     0,     0,
     729,     0,     0,     0,     0,     0,     0,     0,     0,  3829,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2430,  2430,     0,  2992,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2430,     0,     0,     0,  2430,     0,     0,     0,     0,     0,
       0,     0,     0,  2430,     0,  2430,     0,  2430,     0,     0,
       0,     0,     0,     0,     0,     0,  2992,     0,  3188,     0,
       0,     0,     0,     0,     0,  3274,     0,     0,     0,     0,
       0,     0,     0,  2992,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3829,     0,     0,     0,
       0,     0,  2992,     0,     0,     0,     0,  3829,     0,     0,
    3829,     0,     0,  3829,     0,     0,     0,     0,  2992,     0,
       0,     0,     0,     0,     0,     0,  3829,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2992,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2992,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3829,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3829,     0,     0,     0,     0,     0,  2992,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2992,     0,     0,     0,     0,     0,
    2992,     0,     0,  3829,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3238,     0,
    3238,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3829,     0,     0,  3829,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3829,     0,     0,     0,     0,     0,  3829,     0,
       0,  3220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2778,     0,     0,     0,  4100,     0,     0,     0,     0,
       0,     0,  3220,     0,     0,     0,  3220,     0,     0,     0,
    3220,  3220,  3220,     0,     0,     0,  3220,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3220,     0,  3220,     0,     0,     0,     0,     0,     0,
    2992,     0,     0,  1203,     0,     0,     0,     0,     0,     0,
       0,     0,  3829,     0,     0,     0,     0,  3829,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2992,
       0,  3220,     0,     0,  2992,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2992,     0,     0,     0,     0,  3829,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1272,
    1273,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3220,  3220,     0,     0,     0,
       0,  3220,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1340,     0,     0,     0,
       0,     0,     0,     0,  3220,     0,     0,  1351,     0,  3220,
       0,     0,  3220,  3220,  1358,  1359,  1360,  1361,  1362,  1363,
    1364,  1365,  1366,  1367,  1368,  1369,  1370,  1371,  1372,  1373,
    1374,  1375,  1376,  1377,  1378,  1379,  1380,  1381,  1382,  1383,
    1384,  1385,  1386,  1387,  1388,  1389,  1390,  1391,  1392,  1393,
    1394,  1395,  1396,  1397,  1398,  1399,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1431,     0,  1433,     0,  1435,     0,     0,     0,
    1439,  1440,     0,  1442,     0,  1444,     0,  1446,     0,  1448,
       0,  1450,     0,  1452,     0,  1454,     0,  1456,     0,  1458,
       0,  1460,     0,  1462,  1463,     0,  1465,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2430,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2430,  2992,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2430,
    2430,     0,     0,     0,  2778,     0,  2778,     0,     0,     0,
    2430,  2430,     0,  2430,  2430,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2430,  4100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2295,
       0,     0,     0,     0,     0,  3152,     0,     0,     0,  3152,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2430,     0,     0,     0,  3152,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3152,     0,  3220,     0,     0,     0,
       0,  2430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3152,  3152,     0,     0,     0,     0,     0,     0,  3152,
    3152,  3152,  3152,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3152,     0,  3152,  3152,  3152,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3152,     0,     0,     0,  3152,     0,     0,
       0,  3152,  3152,     0,  3152,  3152,     0,  3152,  3152,  3152,
       0,     0,     0,     0,     0,     0,     0,     0,  3152,     0,
       0,     0,     0,  3152,  3152,  3152,     0,  3152,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4702,
       0,     0,  4100,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3152,     0,     0,     0,
       0,     0,     0,     0,     0,  3152,  3152,     0,  3152,     0,
       0,  3152,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3152,     0,     0,     0,     0,     0,     0,     0,  2430,
       0,  2430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3152,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3152,     0,  2430,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2430,
       0,  3152,  3152,  3152,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3220,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3220,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4100,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2992,     0,     0,  2430,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2992,
       0,     0,  2992,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2430,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4100,     0,  4100,     0,     0,     0,
       0,  4100,     0,     0,     0,     0,     0,     0,     0,  3829,
       0,     0,     0,     0,  4100,     0,     0,     0,     0,     0,
       0,     0,   889,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,  2992,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,  3829,     0,     0,
       0,     0,     0,    92,    93,     0,  3829,    94,     0,     0,
       0,  3829,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,  4100,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4100,
       0,  4100,     0,  2992,     0,     0,     0,     0,  2992,     0,
       0,     0,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,  2430,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3220,     0,  2430,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4100,     0,     0,
       0,     0,     0,     0,     0,     0,  4100,  4100,     0,     0,
       0,  4100,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2996,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3030,  3031,  3032,     0,     0,
       0,     0,     0,     0,     0,     0,  3047,  3048,  3049,  3050,
       0,     0,     0,     0,     0,     0,  4100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3087,  3088,  3089,     0,     0,  3093,  3094,     0,     0,
    3097,     0,     0,     0,     0,  3102,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4100,  4100,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4100,
       0,     0,     0,     0,     0,     0,     0,  3152,  3152,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3220,     0,  3220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   891,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,     0,     0,    92,    93,     0,     0,    94,     0,     0,
       0,     0,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2430,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,  3790,  3791,   255,   256,   257,   258,   259,
     260,   261,   262,     0,  2430,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3904,     0,     0,  3908,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4100,     0,     0,     0,     0,     0,     0,
       0,     0,  3929,     0,  3931,  3932,  3933,  3934,     0,  3935,
    3936,     0,  3937,     0,     0,     0,     0,  3940,  3941,     0,
    3942,  3943,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3950,  3951,     0,
    3957,  3958,  3959,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3960,     0,  3961,     0,  3962,     0,  3963,     0,  3968,  3969,
    3970,     0,     0,     0,     0,     0,     0,     0,     0,  3971,
       0,     0,     0,     0,  3973,     0,     0,     0,     0,     0,
    3978,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4000,  4001,  4002,  4003,  4004,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4051,  4052,
    4053,     0,  4054,     0,     0,  4056,  4057,     0,     0,  4058,
    4059,  4060,  4061,     0,     0,     0,  4062,  4063,  4064,     0,
    4065,  4066,  4067,  4068,  4069,  4070,  4071,  4072,  4073,  4074,
       0,     0,  4077,     0,  4078,     0,  4079,  4080,  4081,  4082,
    4083,  4084,  4085,  4086,  4087,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2430,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4124,  4125,     0,
    4127,     0,     0,     0,     0,     0,     0,  4134,  4135,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4144,  4145,     0,  4147,  4148,  4149,  4150,  4151,     0,
       0,  4152,  4153,  4154,  4155,  4156,  4157,  4158,  4159,  4160,
       0,  4161,  4162,     0,     0,     0,     0,     0,  4168,     0,
    4170,     0,     0,  4172,  4173,  4174,  4175,  4176,  4177,  4178,
    4179,  4180,     0,  4181,  4182,  4183,  4184,     0,  4185,  4186,
    4187,  4188,  4189,  4190,  4191,  4192,  4193,     0,     0,  4196,
    4197,  4198,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4218,  4219,  4220,  4221,  4222,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4345,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4388,  4389,   894,     0,     0,     0,     0,     0,     0,
      82,     0,     0,  4410,  4411,     0,     0,     0,     0,     0,
       0,    83,     0,     0,     0,     0,     0,     0,     0,     0,
      84,    85,    86,    87,    88,    89,    90,    91,  4441,     0,
       0,     0,     0,     0,    92,    93,     0,     0,    94,     0,
       0,     0,     0,     0,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,     0,     0,     0,     0,     0,   105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,     0,     0,
     106,   107,   108,   109,   110,   111,   112,     0,   113,   114,
     115,   116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,     0,     0,     0,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4589,     0,     0,     0,     0,     0,  4597,  4598,     0,
       0,     0,     0,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,     0,     0,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,     0,     0,   254,     0,     0,   255,   256,   257,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2430,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5090,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5166,
    5167,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5228,  5229,  5230,
    5231,     0,     0,  5234,  5235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5251,  5252,     0,  5254,     0,  5256,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   896,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,  5342,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,  5356,  5357,    92,    93,     0,     0,    94,     0,  5364,
       0,     0,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   335,     0,     0,
       0,     0,   336,     0,   337,     0,     0,   338,   339,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5546,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   898,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   900,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   902,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   904,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     906,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     908,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   910,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,    92,    93,     0,
       0,    94,     0,     0,     0,     0,     0,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,     0,     0,     0,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
       0,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,     0,     0,   254,     0,     0,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   912,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,    92,    93,     0,
       0,    94,     0,     0,     0,     0,     0,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,     0,     0,     0,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
       0,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,     0,     0,   254,     0,     0,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   914,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,     0,     0,    92,    93,     0,     0,    94,     0,     0,
       0,     0,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     335,     0,     0,     0,     0,   336,     0,   337,     0,     0,
     338,   339,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   916,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,     0,     0,    92,    93,     0,     0,    94,     0,     0,
       0,     0,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     335,     0,     0,     0,     0,   336,     0,   337,     0,     0,
     338,   339,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   918,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   921,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   925,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   927,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     929,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     933,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   936,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,    92,    93,     0,
       0,    94,     0,     0,     0,     0,     0,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,     0,     0,     0,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
       0,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,     0,     0,   254,     0,     0,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   940,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,    92,    93,     0,
       0,    94,     0,     0,     0,     0,     0,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,     0,     0,     0,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
       0,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,     0,     0,   254,     0,     0,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   999,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,     0,     0,    92,    93,     0,     0,    94,     0,     0,
       0,     0,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     335,     0,     0,     0,     0,   336,     0,   337,     0,     0,
     338,   339,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1001,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,     0,     0,    92,    93,     0,     0,    94,     0,     0,
       0,     0,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     335,     0,     0,     0,     0,   336,     0,   337,     0,     0,
     338,   339,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,  1003,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1005,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,  1007,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1010,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
    1012,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1014,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,  1016,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,    92,    93,     0,
       0,    94,     0,     0,     0,     0,     0,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,     0,     0,     0,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
       0,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,     0,     0,   254,     0,     0,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1018,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,    92,    93,     0,
       0,    94,     0,     0,     0,     0,     0,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,     0,     0,     0,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
       0,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,     0,     0,   254,     0,     0,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,  1020,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,     0,     0,    92,    93,     0,     0,    94,     0,     0,
       0,     0,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     335,     0,     0,     0,     0,   336,     0,   337,     0,     0,
     338,   339,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1022,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,     0,     0,    92,    93,     0,     0,    94,     0,     0,
       0,     0,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     335,     0,     0,     0,     0,   336,     0,   337,     0,     0,
     338,   339,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,  1024,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1026,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,  1028,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1030,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
    1033,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1035,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,  1037,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,    92,    93,     0,
       0,    94,     0,     0,     0,     0,     0,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,     0,     0,     0,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
       0,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,     0,     0,   254,     0,     0,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     -84,     0,     0,     0,     0,     0,  1471,  1472,     0,  1473,
    1474,     0,     0,     0,     0,     0,     0,     0,  1475,     0,
       0,     0,     0,  1476,  1477,  1478,     0,  1479,  1480,  1481,
    1482,  1483,  1484,    90,    91,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1485,     0,     0,     0,     0,
       0,     0,     0,  1486,  1487,  1488,     0,     0,     0,     0,
       0,  1489,  1490,  1491,     0,     0,     0,  1492,     0,  1493,
    1494,  1495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,  1496,     0,   338,   339,  1497,  1498,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1500,     0,
       0,  1501,     0,  1502,     0,  1503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1505,  1506,  1507,  1508,     0,     0,     0,
       0,  1509,     0,     0,     0,  1510,     0,     0,     0,  1511,
       0,  1512,  1513,  1514,     0,     0,  1515,  1516,  1517,  1518,
    1519,  1520,  1521,     0,     0,     0,     0,     0,  1522,  1523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1524,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1525,  1526,  1527,  1528,
    1529,  1530,  1531,  1532,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,  1557,  1558,
    1559,  1560,  1561,  1562,  1563,  1564,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     335,     0,     0,     0,     0,   336,     0,   337,     0,     0,
     338,   339,     0,     0,     0,     0,     0,  1565,  1566,  1567,
    1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,
    1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,
    1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,
    1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,
    1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,
    1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,
    1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,
    1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,
    2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,     0,     0,     0,  2149,     0,   -84,     0,     0,  2150,
       0,  2151,  1471,  1472,  2152,  1473,  1474,     0,     0,     0,
       0,     0,     0,     0,  1475,     0,     0,     0,     0,  1476,
    1477,  1478,     0,  1479,  1480,  1481,  1482,  1483,  1484,    90,
      91,     0,     0,     0,     0,     0,     0,     0,    92,    93,
       0,  2509,     0,     0,     0,     0,     0,     0,     0,  1486,
    1487,  1488,     0,     0,     0,     0,     0,  1489,  1490,  1491,
       0,     0,     0,  1492,     0,  1493,  1494,  1495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1496,     0,
       0,     0,  1497,  1498,  1499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1500,     0,     0,  1501,     0,  1502,
       0,  1503,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1504,     0,     0,   106,   107,   108,   109,   110,   111,
     112,     0,   113,   114,   115,   116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   117,     0,     0,     0,  1505,
    1506,  1507,  1508,     0,     0,     0,     0,  1509,     0,     0,
       0,  1510,     0,     0,     0,  1511,     0,  1512,  1513,  1514,
       0,     0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,
       0,     0,     0,     0,  1522,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,     0,     0,   165,   166,   167,   168,   169,   170,   171,
     172,     0,  1524,     0,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,     0,     0,   254,     0,     0,
     255,   256,   257,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,     0,     0,     0,     0,     0,     0,     0,
    1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,
    1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,
    1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,
    1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
    1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,
    1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,
    1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,
    1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,
    1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,
    2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,
    2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,
    2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,
    2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,
    2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,
    2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,
    2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,
    2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,     0,     0,
    2777,     0,   -84,     0,     0,  2510,     0,  2151,  1471,  1472,
    2152,  1473,  1474,     0,     0,     0,     0,     0,     0,     0,
    1475,     0,     0,     0,     0,  1476,  1477,  1478,     0,  1479,
    1480,  1481,  1482,  1483,  1484,    90,    91,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1485,     0,     0,
       0,     0,     0,     0,     0,  1486,  1487,  1488,     0,     0,
       0,     0,     0,  1489,  1490,  1491,     0,     0,     0,  1492,
       0,  1493,  1494,  1495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,     0,  1497,  1498,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,
       0,     0,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1524,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,
    1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,
    1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,     0,     0,     0,  4088,     0,     0,     0,
       0,  2150,     0,  2151,  1471,    82,  2152,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3301,  3302,  3303,  3304,  3305,  3306,  3307,     0,
    3308,  3309,  3310,     0,     0,     0,  3311,  3312,  3313,  3314,
       0,     0,  3315,  3316,     0,  3317,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3218,     0,     0,     0,     0,  3240,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,  1557,  1558,  1559,  1560,
    1561,  1562,  1563,  1564,  3329,  3330,  3331,  3332,  3333,  3334,
    3335,  3336,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3108,     0,     0,     0,     0,  3240,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,  3375,  3376,  3377,  3378,  3379,  3380,
    3381,  3382,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3108,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,  5872,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5873,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  5874,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5875,  5876,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3218,     0,     0,     0,     0,  3240,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3798,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3799,  3800,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3218,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,  3501,  3502,  3503,   100,   101,   102,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3218,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,  3501,  3502,  3503,   100,   101,   102,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3108,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  3107,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3108,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3218,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3239,     0,     0,     0,     0,  3240,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3108,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3218,     0,     0,     0,     0,  3240,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3565,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    3569,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3108,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3108,     0,     0,     0,     0,  3240,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,  4551,     0,     0,     0,     0,     0,  4552,
    4553,  1486,  1487,  1488,     0,     0,  4554,  4555,  4556,  1489,
    1490,  1491,     0,     0,  4557,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3108,     0,     0,     0,     0,  3240,     0,   337,
       0,     0,   338,   339,  1471,    82,     0,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,  1476,  1477,  1478,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,  1488,     0,     0,   498,   103,   104,  1489,
    1490,  1491,     0,     0,   105,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,  3106,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
       0,     0,  3565,     0,     0,  3271,     0,  3240,     0,   337,
       0,  1471,   338,   339,  1473,  1474,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1476,  1477,
    1478,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3141,     0,     0,     0,     0,     0,  3142,  3143,  1486,  1487,
    1488,     0,     0,  3144,  3145,  3146,  1489,  1490,  1491,     0,
       0,  3147,  1492,     0,  1493,  1494,  1495,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1496,     0,     0,
       0,  1497,  1498,  1499,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1500,     0,     0,  1501,     0,  1502,     0,
    1503,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1504,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1505,  1506,
    1507,  1508,     0,     0,     0,     0,  1509,     0,     0,     0,
    1510,     0,     0,     0,  1511,     0,  1512,  1513,  1514,     0,
       0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,     0,
       0,     0,     0,  1522,  1523,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1533,
    1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,
    1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,
    1554,  1555,  1556,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,
    1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,
    1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,
    1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,
    1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,
    1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,
    1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,
    1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,
    1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,
    1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,
    1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,
    1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,
    1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,
    1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,
    1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,
    1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,
    1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,
    1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,
    1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,
    1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,
    1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,
    1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,
    1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,
    1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,
    1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,
    1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,
    1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,
    1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,
    1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,
    1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,
    1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,
    1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,
    1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,
    1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,
    1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,
    1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,
    1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,
    1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,
    1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,
    1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,
    1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,
    1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,
    1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,
    1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,
    2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,
    2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,
    2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,
    2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,
    2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,
    2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,
    2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,
    2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,
    2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,
    2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,
    2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,
    2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,
    2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,
    2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,
    2143,  2144,  2145,  2146,  2147,  2148,     0,  1471,     0,  2419,
    1473,  1474,     0,     0,  2420,  3153,  3154,  3155,     0,     0,
       0,     0,     0,     0,  1476,  1477,  1478,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3156,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1486,  1487,  1488,     0,     0,     0,
       0,     0,  1489,  1490,  1491,     0,     0,     0,  1492,     0,
    1493,  1494,  1495,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1496,     0,     0,     0,  1497,  1498,  1499,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1500,
       0,     0,  1501,     0,  1502,     0,  1503,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1504,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,     0,
       0,     0,  1509,     0,     0,     0,  1510,     0,     0,     0,
    1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,  1517,
    1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,  1522,
    1523,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,
    1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3157,  3158,  3159,  3160,  3161,  3162,  3163,  3164,  3165,
    3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,  3174,  3175,
    3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,  1565,  1566,
    1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,
    1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,
    1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,
    1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,
    1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,
    1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,
    1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,
    1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,
    1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,
    1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,
    1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,
    1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,
    1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,
    1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,
    1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,
    1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,
    1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,
    1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,
    1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,
    1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,
    1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,
    1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,
    1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,
    1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,
    1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,
    1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,
    1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,
    1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,
    1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,
    1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,
    1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,
    1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,
    1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,
    1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,
    1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,
    1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,
    1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,
    1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,
    1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,
    1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,
    1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,
    1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,
    1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,
    1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,
    2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,
    2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,
    2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,
    2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,
    2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,
    2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,
    2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,
    2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,
    2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,
    2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,
    2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,
    2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,
    2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,
    2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,
    2147,  2148,     0,  1471,     0,  3184,  1473,  1474,     0,     0,
    2420,  3153,  3154,  3155,     0,  3185,     0,     0,     0,     0,
    1476,  1477,  1478,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3196,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1486,  1487,  1488,     0,     0,     0,     0,     0,  1489,  1490,
    1491,     0,     0,     0,  1492,     0,  1493,  1494,  1495,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1496,
       0,     0,     0,  1497,  1498,  1499,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1500,     0,     0,  1501,     0,
    1502,     0,  1503,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1504,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1505,  1506,  1507,  1508,     0,     0,     0,     0,  1509,     0,
       0,     0,  1510,     0,     0,     0,  1511,     0,  1512,  1513,
    1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,
       0,     0,     0,     0,     0,  1522,  1523,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,
    1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,
    1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3157,  3158,  3159,
    3160,  3161,  3162,  3163,  3164,  3165,  3166,  3167,  3168,  3169,
    3170,  3171,  3172,  3173,  3174,  3175,  3176,  3177,  3178,  3179,
    3180,  3181,  3182,  3183,  1565,  1566,  1567,  1568,  1569,  1570,
    1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,
    1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,
    1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,
    1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,
    1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,
    1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,
    1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,
    1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,
    1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,
    1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,
    1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,
    1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,
    1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,
    1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,
    1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,
    1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,
    1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,
    1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,
    1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,
    1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,
    1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,
    1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,
    1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,
    1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,
    1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,
    1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,
    1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,
    1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,
    1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,
    1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,
    1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,
    1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,
    1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,
    1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,
    1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,
    1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,
    1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,
    1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,
    1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,
    1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,
    1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,
    1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,
    1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,
    2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,
    2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,
    2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,
    2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,
    2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,
    2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,
    2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,
    2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,
    2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,
    2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,
    2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,
    2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,
    2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,
    2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,
    2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,  1471,
       0,  3184,  1473,  1474,     0,     0,  2420,  3153,  3154,  3155,
       0,  3185,     0,     0,     0,     0,  1476,  1477,  1478,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6482,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1486,  1487,  1488,     0,
       0,     0,     0,     0,  1489,  1490,  1491,     0,     0,     0,
    1492,     0,  1493,  1494,  1495,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1496,     0,     0,     0,  1497,
    1498,  1499,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1504,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,
       0,     0,     0,     0,  1509,     0,     0,     0,  1510,     0,
       0,     0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,
    1516,  1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,
       0,  1522,  1523,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1556,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3157,  3158,  3159,  3160,  3161,  3162,  3163,
    3164,  3165,  3166,  3167,  3168,  3169,  3170,  3171,  3172,  3173,
    3174,  3175,  3176,  3177,  3178,  3179,  3180,  3181,  3182,  3183,
    1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,
    1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,
    1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,
    1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,
    1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,
    1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,
    1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,
    1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,
    1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,
    1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,
    1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,
    1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,
    1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,
    1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,
    1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,
    1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,
    1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,
    1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,
    1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,
    1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,
    1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,
    1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,
    1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,
    1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,
    1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,
    1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,
    1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,
    1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,
    1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,
    1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,
    1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,
    1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,
    1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,
    1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,
    1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,
    1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,
    1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,
    1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,
    1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,
    1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,
    1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,
    1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,
    1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,
    2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,
    2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,
    2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,
    2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,
    2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,
    2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,
    2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,
    2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,
    2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,
    2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,
    2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,
    2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,
    2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,
    2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,
    2145,  2146,  2147,  2148,     0,  1471,     0,  3184,  1473,  1474,
       0,     0,  2420,  3153,  3154,  3155,     0,  3185,     0,     0,
       0,     0,  1476,  1477,  1478,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1486,  1487,  1488,     0,     0,     0,     0,     0,
    1489,  1490,  1491,     0,     0,     0,  1492,     0,  1493,  1494,
    1495,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1500,     0,     0,
    1501,     0,  1502,     0,  1503,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1504,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1505,  1506,  1507,  1508,     0,     0,     0,     0,
    1509,     0,     0,     0,  1510,     0,     0,     0,  1511,     0,
    1512,  1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,
    1520,  1521,     0,     0,     0,     0,     0,  1522,  1523,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,
    1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,
    1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3157,
    3158,  3159,  3160,  3161,  3162,  3163,  3164,  3165,  3166,  3167,
    3168,  3169,  3170,  3171,  3172,  3173,  3174,  3175,  3176,  3177,
    3178,  3179,  3180,  3181,  3182,  3183,  1565,  1566,  1567,  1568,
    1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,
    1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,
    1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,
    1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,
    1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,
    1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,
    1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,
    1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,
    1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,
    1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,
    1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,
    1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,
    1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,
    1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,
    1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,
    1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,
    1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,
    1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,
    1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,
    1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,
    1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,
    1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,
    1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,
    1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,
    1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,
    1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,
    1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,
    1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,
    1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,
    1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,
    1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,
    1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,
    1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,
    1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,
    1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,
    1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,
    1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,
    1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,
    1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,
    1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,
    1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,
    1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,
    1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,
    1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,
    2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,
    2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,
    2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,
    2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,
    2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,
    2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,
    2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,
    2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,
    2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,
    2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,
    2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,
    2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,
    2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,
    2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,
      82,     0,     0,  3184,     0,     0,     0,     0,  2420,     0,
       0,    83,     0,  3185,     0,     0,     0,     0,     0,     0,
      84,    85,    86,    87,    88,    89,    90,    91,     0,     0,
       0,     0,     0,     0,    92,    93,     0,     0,    94,     0,
       0,     0,     0,     0,   497,    96,  1486,  1487,     0,     0,
       0,   498,   103,   104,  1489,  1490,     0,     0,     0,   105,
       0,     0,  1493,  1494,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     106,   107,   108,   109,   110,   111,   112,     0,   113,   114,
     115,   116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,     0,     0,     0,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,     0,     0,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,     0,     0,   254,     0,     0,   255,   256,   257,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,     0,
       0,     0,     0,     0,     0,     0,     0,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1556,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3301,  3302,  3303,
    3304,  3305,  3306,  3307,    82,  3308,  3309,  3310,     0,     0,
       0,  3311,  3312,  3313,  3314,    83,     0,  3315,  3316,     0,
    3964,     0,     0,     0,    84,    85,    86,    87,    88,    89,
      90,    91,     0,     0,     0,     0,     0,     0,    92,    93,
       0,     0,    94,     0,     0,     0,     0,     0,   497,    96,
    1486,  1487,     0,     0,     0,   498,   103,   104,  1489,  1490,
       0,     0,     0,   105,     0,     0,  1493,  1494,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   106,   107,   108,   109,   110,   111,
     112,     0,   113,   114,   115,   116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   117,     0,     0,     0,     0,
     118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,     0,     0,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,     0,     0,   254,     0,     0,
     255,   256,   257,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,  4005,  4006,  4007,  4008,  4009,  4010,  4011,
    4012,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,
    1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,
    1552,  1553,  1554,  1555,  1556,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,   497,
      96,  1486,  1487,     0,     0,     0,   498,   103,   104,  1489,
    1490,     0,     0,     0,   105,     0,     0,  1493,  1494,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,  3893,     0,     0,
       0,     0,  3240,     0,   337,     0,     0,   338,   339,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    83,     0,     0,     0,     0,     0,     0,     0,     0,
      84,    85,    86,    87,    88,    89,    90,    91,     0,     0,
       0,     0,     0,     0,    92,    93,     0,     0,    94,     0,
       0,     0,     0,     0,   497,    96,  1486,  1487,     0,     0,
       0,   498,   103,   104,  1489,  1490,     0,     0,     0,   105,
       0,     0,  1493,  1494,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     106,   107,   108,   109,   110,   111,   112,     0,   113,   114,
     115,   116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,     0,     0,     0,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4013,     0,     0,     0,     0,   336,     0,   337,     0,
       0,   338,   339,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,     0,     0,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,     0,     0,   254,     0,     0,   255,   256,   257,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,     0,
       0,     0,     0,     0,     0,     0,     0,  1533,  1534,  1535,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,
    1556,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,   497,    96,  1486,  1487,     0,
       0,     0,   498,   103,   104,  1489,  1490,     0,     0,     0,
     105,     0,     0,  1493,  1494,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3893,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,     0,     0,     0,     0,     0,     0,     0,  1533,  1534,
    1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    83,     0,     0,
       0,     0,     0,     0,     0,     0,    84,    85,    86,    87,
      88,    89,    90,    91,     0,     0,     0,     0,     0,     0,
      92,    93,     0,     0,    94,     0,     0,     0,     0,     0,
     497,    96,  1486,  1487,     0,     0,     0,   498,   103,   104,
    1489,  1490,     0,     0,     0,   105,     0,     0,  1493,  1494,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   106,   107,   108,   109,
     110,   111,   112,     0,   113,   114,   115,   116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   117,     0,     0,
       0,     0,   118,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3914,     0,     0,
       0,     0,  3240,     0,   337,     0,     0,   338,   339,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,     0,     0,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,     0,     0,   254,
       0,     0,   255,   256,   257,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,     0,     0,     0,     0,     0,
       0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,
    1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,
    1550,  1551,  1552,  1553,  1554,  1555,  1556,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,   497,    96,  1486,  1487,     0,     0,     0,   498,   103,
     104,  1489,  1490,     0,     0,     0,   105,     0,     0,  1493,
    1494,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3893,     0,
       0,     0,     0,  3240,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,     0,     0,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    83,     0,     0,     0,     0,     0,     0,
       0,     0,    84,    85,    86,    87,    88,    89,    90,    91,
       0,     0,     0,     0,     0,     0,    92,    93,     0,     0,
    4551,     0,     0,     0,     0,     0,  4552,  4553,  1486,  1487,
       0,     0,     0,  4554,  4555,  4556,  1489,  1490,     0,     0,
       0,  4557,     0,     0,  1493,  1494,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   106,   107,   108,   109,   110,   111,   112,     0,
     113,   114,   115,   116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   117,     0,     0,     0,     0,   118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4013,     0,     0,     0,     0,   336,     0,
     337,     0,     0,   338,   339,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,     0,
       0,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,     0,     0,   254,     0,     0,   255,   256,
     257,   258,   259,   260,   261,   262,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,     0,     0,     0,     0,     0,     0,     0,     0,  1533,
    1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,
    1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,
    1554,  1555,  1556,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,    92,    93,     0,
       0,    94,     0,     0,     0,     0,     0,   497,    96,  1486,
    1487,     0,     0,     0,   498,   103,   104,  1489,  1490,     0,
       0,     0,   105,     0,     0,  1493,  1494,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
       0,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4013,     0,     0,     0,     0,  3240,
       0,   337,     0,     0,   338,   339,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,     0,     0,   254,     0,     0,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,     0,     0,     0,     0,     0,     0,     0,
    1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    83,
       0,     0,     0,     0,     0,     0,     0,     0,    84,    85,
      86,    87,    88,    89,    90,    91,     0,     0,     0,     0,
       0,     0,    92,    93,     0,     0,    94,     0,     0,     0,
       0,     0,   497,    96,     0,     0,     0,     0,     0,   498,
     103,   104,     0,     0,     0,     0,     0,   105,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   106,   107,
     108,   109,   110,   111,   112,     0,   113,   114,   115,   116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   117,
       0,     0,     0,     0,   118,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4013,
       0,     0,     0,     0,  3240,     0,   337,     0,     0,   338,
     339,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,     0,     0,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,     0,
       0,   254,     0,     0,   255,   256,   257,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,     0,     0,     0,
       0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,
    1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,     0,     0,    92,    93,     0,     0,    94,     0,     0,
       0,     0,     0,   497,    96,     0,     0,     0,     0,     0,
     498,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5350,     0,     0,     0,     0,  3240,     0,   337,     0,     0,
     338,   339,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1535,  1536,
       0,     0,  1539,  1540,     0,     0,  1543,  1544,     0,     0,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    83,     0,     0,     0,     0,
       0,     0,     0,     0,    84,    85,    86,    87,    88,    89,
      90,    91,     0,     0,     0,     0,     0,     0,    92,    93,
       0,     0,    94,     0,     0,     0,     0,     0,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,     0,     0,
       0,     0,     0,   105,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   676,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   106,   107,   108,   109,   110,   111,
     112,     0,   113,   114,   115,   116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   117,     0,     0,     0,     0,
     118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5162,     0,     0,     0,     0,
     336,     0,   337,     0,     0,   338,   339,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,     0,     0,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,     0,     0,   254,     0,     0,
     255,   256,   257,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,  1192,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4169,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    83,     0,     0,     0,     0,     0,     0,     0,     0,
      84,    85,    86,    87,    88,    89,    90,    91,  1196,     0,
       0,     0,     0,     0,    92,    93,     0,     0,    94,     0,
       0,     0,     0,     0,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,     0,     0,     0,     0,     0,   105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     106,   107,   108,   109,   110,   111,   112,     0,   113,   114,
     115,   116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,     0,     0,     0,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   335,     0,     0,     0,     0,   336,     0,   337,     0,
       0,   338,   339,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,     0,     0,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,     0,     0,   254,     0,     0,   255,   256,   257,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,  2941,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    83,     0,     0,
       0,     0,     0,     0,     0,     0,    84,    85,    86,    87,
      88,    89,    90,    91,     0,     0,     0,     0,     0,     0,
      92,    93,     0,     0,    94,     0,     0,     0,     0,     0,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
       0,     0,     0,     0,     0,   105,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   106,   107,   108,   109,
     110,   111,   112,     0,   113,   114,   115,   116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   117,     0,     0,
       0,     0,   118,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   335,     0,     0,
       0,     0,   336,     0,   337,     0,     0,   338,   339,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,     0,     0,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,     0,     0,   254,
       0,     0,   255,   256,   257,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,  2946,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    83,     0,     0,     0,     0,     0,     0,
       0,     0,    84,    85,    86,    87,    88,    89,    90,    91,
       0,     0,     0,     0,     0,     0,    92,    93,     0,     0,
      94,     0,     0,     0,     0,     0,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,     0,     0,     0,     0,
       0,   105,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   106,   107,   108,   109,   110,   111,   112,     0,
     113,   114,   115,   116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   117,     0,     0,     0,     0,   118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   335,     0,     0,     0,  1098,   336,     0,
     337,     0,     0,   338,   339,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,     0,
       0,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,     0,     0,   254,     0,     0,   255,   256,
     257,   258,   259,   260,   261,   262,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,    92,    93,     0,
       0,    94,     0,     0,     0,     0,     0,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,     0,     0,     0,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3787,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
       0,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,     0,     0,   254,     0,     0,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    83,
       0,     0,     0,     0,     0,     0,     0,     0,    84,    85,
      86,    87,    88,    89,    90,    91,     0,     0,     0,     0,
       0,     0,    92,    93,     0,     0,    94,     0,     0,     0,
       0,     0,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,     0,     0,     0,     0,     0,   105,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3891,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   106,   107,
     108,   109,   110,   111,   112,     0,   113,   114,   115,   116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   117,
       0,     0,     0,     0,   118,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   335,
       0,     0,     0,     0,   336,     0,   337,     0,     0,   338,
     339,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,     0,     0,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,     0,
       0,   254,     0,     0,   255,   256,   257,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,     0,     0,    92,    93,     0,     0,    94,     0,     0,
       0,     0,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3911,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     335,     0,     0,     0,     0,   336,     0,   337,     0,     0,
     338,   339,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    83,     0,     0,     0,     0,
       0,     0,     0,     0,    84,    85,    86,    87,    88,    89,
      90,    91,     0,     0,     0,     0,     0,     0,    92,    93,
       0,     0,    94,     0,     0,     0,     0,     0,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,     0,     0,
       0,     0,     0,   105,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   106,   107,   108,   109,   110,   111,
     112,     0,   113,   114,   115,   116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   117,     0,     0,     0,     0,
     118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   335,     0,     0,     0,     0,
     336,     0,   337,     0,     0,   338,   339,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,     0,     0,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,     0,     0,   254,     0,     0,
     255,   256,   257,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4544,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    83,     0,     0,     0,     0,     0,     0,     0,     0,
      84,    85,    86,    87,    88,    89,    90,    91,     0,     0,
       0,     0,     0,     0,    92,    93,     0,     0,    94,     0,
       0,     0,     0,     0,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,     0,     0,     0,     0,     0,   105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4564,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     106,   107,   108,   109,   110,   111,   112,     0,   113,   114,
     115,   116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,     0,     0,     0,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   335,     0,     0,     0,     0,   336,     0,   337,     0,
       0,   338,   339,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,     0,     0,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,     0,     0,   254,     0,     0,   255,   256,   257,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4640,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    83,     0,     0,
       0,     0,     0,     0,     0,     0,    84,    85,    86,    87,
      88,    89,    90,    91,     0,     0,     0,     0,     0,     0,
      92,    93,     0,     0,    94,     0,     0,     0,     0,     0,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
       0,     0,     0,     0,     0,   105,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4775,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   106,   107,   108,   109,
     110,   111,   112,     0,   113,   114,   115,   116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   117,     0,     0,
       0,     0,   118,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   335,     0,     0,
       0,     0,   336,     0,   337,     0,     0,   338,   339,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,     0,     0,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,     0,     0,   254,
       0,     0,   255,   256,   257,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,  5470,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    83,     0,     0,     0,     0,     0,     0,
       0,     0,    84,    85,    86,    87,    88,    89,    90,    91,
    5473,     0,     0,     0,     0,     0,    92,    93,     0,     0,
      94,     0,     0,     0,     0,     0,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,     0,     0,     0,     0,
       0,   105,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   106,   107,   108,   109,   110,   111,   112,     0,
     113,   114,   115,   116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   117,     0,     0,     0,     0,   118,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   335,     0,     0,     0,     0,   336,     0,
     337,     0,     0,   338,   339,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,     0,
       0,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,     0,     0,   254,     0,     0,   255,   256,
     257,   258,   259,   260,   261,   262,     0,     0,     0,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    83,     0,     0,     0,     0,     0,
       0,     0,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,     0,     0,     0,     0,     0,    92,    93,     0,
       0,    94,     0,     0,     0,     0,     0,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,     0,     0,     0,
       0,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5690,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   106,   107,   108,   109,   110,   111,   112,
       0,   113,   114,   115,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,     0,     0,     0,     0,   118,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
       0,     0,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,     0,     0,   254,     0,     0,   255,
     256,   257,   258,   259,   260,   261,   262,     0,     0,     0,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    83,
       0,     0,     0,     0,     0,     0,     0,     0,    84,    85,
      86,    87,    88,    89,    90,    91,     0,     0,     0,     0,
       0,     0,    92,    93,     0,     0,    94,     0,     0,     0,
       0,     0,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,     0,     0,     0,     0,     0,   105,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5735,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   106,   107,
     108,   109,   110,   111,   112,     0,   113,   114,   115,   116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   117,
       0,     0,     0,     0,   118,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   335,
       0,     0,     0,     0,   336,     0,   337,     0,     0,   338,
     339,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,     0,     0,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,     0,
       0,   254,     0,     0,   255,   256,   257,   258,   259,   260,
     261,   262,     0,     0,     0,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      83,     0,     0,     0,     0,     0,     0,     0,     0,    84,
      85,    86,    87,    88,    89,    90,    91,  6049,     0,     0,
       0,     0,     0,    92,    93,     0,     0,    94,     0,     0,
       0,     0,     0,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,     0,     0,     0,     0,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   106,
     107,   108,   109,   110,   111,   112,     0,   113,   114,   115,
     116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,     0,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     335,     0,     0,     0,     0,   336,     0,   337,     0,     0,
     338,   339,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,     0,     0,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
       0,     0,   254,     0,     0,   255,   256,   257,   258,   259,
     260,   261,   262,     0,     0,     0,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    83,     0,     0,     0,     0,
       0,     0,     0,     0,    84,    85,    86,    87,    88,    89,
      90,    91,  6053,     0,     0,     0,     0,     0,    92,    93,
       0,     0,    94,     0,     0,     0,     0,     0,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,     0,     0,
       0,     0,     0,   105,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   106,   107,   108,   109,   110,   111,
     112,     0,   113,   114,   115,   116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   117,     0,     0,     0,     0,
     118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   335,     0,     0,     0,     0,
     336,     0,   337,     0,     0,   338,   339,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,     0,     0,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,     0,     0,   254,     0,     0,
     255,   256,   257,   258,   259,   260,   261,   262,     0,     0,
       0,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    83,     0,     0,     0,
       0,     0,     0,     0,     0,    84,    85,    86,    87,    88,
      89,    90,    91,     0,     0,     0,     0,     0,     0,    92,
      93,     0,     0,    94,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,     0,
       0,     0,     0,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   106,   107,   108,   109,   110,
     111,   112,     0,   113,   114,   115,   116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,     0,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,   336,     0,   337,     0,     0,   338,   339,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,     0,     0,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,     0,     0,     0,   254,     0,
       0,   255,   256,   257,   258,   259,   260,   261,   262,     0,
       0,     0,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    83,  3707,     0,     0,     0,     0,     0,     0,     0,
      84,    85,    86,    87,    88,    89,    90,    91,     0,     0,
       0,     0,     0,     0,    92,    93,     0,     0,    94,     0,
       0,     0,     0,     0,   497,    96,     0,     0,     0,     0,
       0,   498,   103,   104,     0,     0,     0,     0,     0,   105,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     106,   107,   108,   109,   110,   111,   112,     0,   113,   114,
     115,   116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   117,     0,     0,     0,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   335,     0,     0,     0,     0,   336,     0,   337,     0,
       0,   338,   339,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,     0,     0,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,     0,     0,   254,     0,     0,   255,   256,   257,   258,
     259,   260,   261,   262,     0,     0,     0,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    83,     0,     0,     0,     0,     0,     0,     0,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
       0,     0,     0,     0,     0,    92,    93,     0,     0,    94,
       0,     0,     0,     0,     0,   497,    96,     0,     0,     0,
       0,     0,   498,   103,   104,     0,     0,     0,     0,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,   107,   108,   109,   110,   111,   112,     0,   113,
     114,   115,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   117,     0,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   335,     0,     0,     0,     0,   336,     0,   337,
       0,     0,   338,   339,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,     0,     0,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,     0,     0,   254,     0,     0,   255,   256,   257,
     258,   259,   260,   261,   262,     0,     0,     0,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3788,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    83,     0,     0,
       0,     0,     0,     0,     0,     0,    84,    85,    86,    87,
      88,    89,    90,    91,     0,     0,     0,     0,     0,     0,
      92,    93,     0,     0,    94,     0,     0,     0,     0,     0,
     497,    96,     0,     0,     0,     0,     0,   498,   103,   104,
       0,     0,     0,     0,     0,   105,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   106,   107,   108,   109,
     110,   111,   112,     0,   113,   114,   115,   116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   117,     0,     0,
       0,     0,   118,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   335,     0,     0,
       0,     0,   336,     0,   337,     0,     0,   338,   339,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,     0,     0,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,     0,     0,   254,
       0,     0,   255,   256,   257,   258,   259,   260,   261,   262,
       0,     0,     0,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4171,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    83,     0,
       0,     0,     0,     0,     0,     0,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,     0,     0,     0,     0,
       0,    92,    93,     0,     0,    94,     0,     0,     0,     0,
       0,   497,    96,     0,     0,     0,     0,     0,   498,   103,
     104,     0,     0,     0,     0,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   106,   107,   108,
     109,   110,   111,   112,     0,   113,   114,   115,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   117,     0,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   335,     0,
       0,     0,     0,   336,     0,   337,     0,     0,   338,   339,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,     0,     0,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,     0,     0,     0,
     254,     0,     0,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3232,     0,     0,     0,     0,     0,  1471,     0,
       0,  1473,  1474,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   335,     0,     0,     0,     0,   336,     0,
     337,     0,     0,   338,   339,  1486,  1487,  1488,     0,     0,
       0,     0,     0,  1489,  1490,  1491,     0,     0,     0,  1492,
       0,  1493,  1494,  1495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,     0,  1497,  1498,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,
       0,     0,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,     0,     0,     0,   336,
       0,   337,     0,     0,   338,   339,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,
    1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,
    1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,     0,  1471,     0,  3233,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1476,  1477,  1478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3141,     0,     0,     0,     0,     0,  3142,
    3143,  1486,  1487,  1488,     0,     0,  3144,  3145,  3146,  1489,
    1490,  1491,     0,     0,  3147,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,  1557,  1558,  1559,  1560,
    1561,  1562,  1563,  1564,  3329,  3330,  3331,  3332,  3333,  3334,
    3335,  3336,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
    1471,     0,  3200,  1473,  1474,     0,     0,  2420,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1476,  1477,  1478,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3141,
       0,     0,     0,     0,     0,  3142,  3143,  1486,  1487,  1488,
       0,     0,  3144,  3145,  3146,  1489,  1490,  1491,     0,     0,
    3147,  1492,     0,  1493,  1494,  1495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1496,     0,     0,     0,
    1497,  1498,  1499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1500,     0,     0,  1501,     0,  1502,     0,  1503,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1505,  1506,  1507,
    1508,     0,     0,     0,     0,  1509,     0,     0,     0,  1510,
       0,     0,     0,  1511,     0,  1512,  1513,  1514,     0,     0,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,     0,     0,
       0,     0,  1522,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1533,  1534,
    1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,  1557,  1558,  1559,  1560,  1561,  1562,  1563,  1564,
    3329,  3330,  3331,  3332,  3333,  3334,  3335,  3336,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,
    1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
    1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,
    1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,
    1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,
    1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,
    1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,
    1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,
    1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,
    1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,
    1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,
    1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,
    1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,
    1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,
    1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,
    1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,
    2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,     0,  1471,     0,  2419,  1473,
    1474,     0,     0,  2420,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1476,  1477,  1478,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3141,     0,     0,     0,     0,
       0,  3142,  3143,  1486,  1487,  1488,     0,     0,  3144,  3145,
    3146,  1489,  1490,  1491,     0,     0,  3147,  1492,     0,  1493,
    1494,  1495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1496,     0,     0,     0,  1497,  1498,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1500,     0,
       0,  1501,     0,  1502,     0,  1503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1505,  1506,  1507,  1508,     0,     0,     0,
       0,  1509,     0,     0,     0,  1510,     0,     0,     0,  1511,
       0,  1512,  1513,  1514,     0,     0,  1515,  1516,  1517,  1518,
    1519,  1520,  1521,     0,     0,     0,     0,     0,  1522,  1523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3301,  3302,  3303,  3304,  3305,  3306,
    3307,     0,  3308,  3309,  3310,     0,     0,     0,  3311,  3312,
    3313,  3314,     0,     0,  3315,  3316,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1565,  1566,  1567,
    1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,
    1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,
    1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,
    1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,
    1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,
    1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,
    1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,
    1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,
    2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,     0,  1471,     0,  3236,  1473,  1474,     0,     0,  2420,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1476,
    1477,  1478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3141,     0,     0,     0,     0,     0,  3142,  3143,  1486,
    1487,  1488,     0,     0,  3144,  3145,  3146,  1489,  1490,  1491,
       0,     0,  3147,  1492,     0,  1493,  1494,  1495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1496,     0,
       0,     0,  1497,  1498,  1499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1500,     0,     0,  1501,     0,  1502,
       0,  1503,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1504,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1505,
    1506,  1507,  1508,     0,     0,     0,     0,  1509,     0,     0,
       0,  1510,     0,     0,     0,  1511,     0,  1512,  1513,  1514,
       0,     0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,
       0,     0,     0,     0,  1522,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,     0,     0,     0,
       0,     0,  3329,  3330,  3331,  3332,  3333,  3334,  3335,  3336,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,
    1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,
    1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,
    1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
    1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,
    1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,
    1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,
    1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,
    1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,
    2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,
    2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,
    2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,
    2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,
    2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,
    2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,
    2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,
    2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,  1471,     0,
    2419,  1473,  1474,     0,     0,  2420,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3141,     0,     0,
       0,     0,     0,  3142,  3143,  1486,  1487,  1488,     0,     0,
    3144,  3145,  3146,  1489,  1490,  1491,     0,     0,  3147,  1492,
       0,  1493,  1494,  1495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,     0,  1497,  1498,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,
       0,     0,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
    1557,  1558,  1559,  1560,  1561,  1562,  1563,  1564,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,
    1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,
    1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,     0,  1471,     0,  2419,  1473,  1474,     0,
       0,  2420,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1476,  1477,  1478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3141,     0,     0,     0,     0,     0,  3142,
    3143,  1486,  1487,  1488,     0,     0,  3144,  3145,  3146,  1489,
    1490,  1491,     0,     0,  3147,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3301,  3302,  3303,  3304,  3305,  3306,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3317,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
    1471,     0,  3236,  1473,  1474,     0,     0,  2420,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1476,  1477,  1478,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3141,
       0,     0,     0,     0,     0,  3142,  3143,  1486,  1487,  3249,
    3250,     0,  3144,  3145,  3146,  1489,  1490,  3251,  3252,     0,
    3147,  1492,     0,  1493,  1494,  3253,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1496,     0,     0,     0,
    1497,  1498,  1499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1500,     0,     0,  1501,     0,  1502,     0,  1503,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1505,  1506,  1507,
    1508,     0,     0,     0,     0,  1509,     0,     0,     0,  1510,
       0,     0,     0,  1511,     0,  1512,  1513,  1514,     0,     0,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,     0,     0,
       0,     0,  1522,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1533,  1534,
    1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,
    1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
    1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,
    1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,
    1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,
    1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,
    1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,
    1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,
    1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,
    1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,
    1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,
    1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,
    1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,
    1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,
    1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,
    1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,
    2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,     0,  1471,     0,  3200,  1473,
    1474,     0,     0,  2420,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1476,  1477,  1478,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3288,     0,     0,     0,     0,
       0,     0,     0,  1486,  1487,  1488,     0,     0,     0,     0,
       0,  1489,  1490,  1491,     0,     0,     0,  1492,     0,  1493,
    1494,  1495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1496,     0,     0,     0,  1497,  1498,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1500,     0,
       0,  1501,     0,  1502,     0,  1503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1505,  1506,  1507,  1508,     0,     0,     0,
       0,  1509,     0,     0,     0,  1510,     0,     0,     0,  1511,
       0,  1512,  1513,  1514,     0,     0,  1515,  1516,  1517,  1518,
    1519,  1520,  1521,     0,     0,     0,     0,     0,  1522,  1523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3301,  3302,  3303,  3304,  3305,  3306,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3353,  3354,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1565,  1566,  1567,
    1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,
    1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,
    1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,
    1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,
    1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,
    1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,
    1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,
    1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,
    2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,     0,  1471,     0,  3236,  1473,  1474,     0,     0,  2420,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1476,
    1477,  1478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1486,
    1487,  1488,     0,     0,     0,     0,     0,  1489,  1490,  1491,
       0,     0,     0,  1492,     0,  1493,  1494,  1495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1496,     0,
       0,     0,  1497,  1498,  1499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1500,     0,     0,  1501,     0,  1502,
       0,  1503,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1504,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1505,
    1506,  1507,  1508,     0,     0,     0,     0,  1509,     0,     0,
       0,  1510,     0,     0,     0,  1511,     0,  1512,  1513,  1514,
       0,     0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,
       0,     0,     0,     0,  1522,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,     0,     0,     0,
       0,     0,  3329,  3330,  3331,  3332,  3333,  3334,  3335,  3336,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,
    1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,
    1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,
    1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
    1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,
    1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,
    1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,
    1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,
    1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,
    2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,
    2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,
    2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,
    2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,
    2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,
    2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,
    2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,
    2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,  1471,     0,
    2419,  1473,  1474,     0,     0,  2420,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3141,     0,     0,
       0,     0,     0,  3142,  3143,  1486,  1487,  1488,     0,     0,
    3144,  3145,  3146,  1489,  1490,  1491,     0,     0,  3147,  1492,
       0,  1493,  1494,  1495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,     0,  1497,  1498,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,
       0,     0,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,
    1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,
    1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,     0,  1471,     0,  3236,  1473,  1474,     0,
       0,  2420,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1476,  1477,  1478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3141,     0,     0,     0,     0,     0,  3142,
    3143,  1486,  1487,  1488,     0,     0,  3144,  3145,  3146,  1489,
    1490,  1491,     0,     0,  3147,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
    1471,     0,  2419,  1473,  1474,     0,     0,  2420,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1476,  1477,  1478,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3141,
       0,     0,     0,     0,     0,  3142,  3143,  1486,  1487,  1488,
       0,     0,  3144,  3145,  3146,  1489,  1490,  1491,     0,     0,
    3147,  1492,     0,  1493,  1494,  1495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1496,     0,     0,     0,
    1497,  1498,  1499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1500,     0,     0,  1501,     0,  1502,     0,  1503,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1505,  1506,  1507,
    1508,     0,     0,     0,     0,  1509,     0,     0,     0,  1510,
       0,     0,     0,  1511,     0,  1512,  1513,  1514,     0,     0,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,     0,     0,
       0,     0,  1522,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1533,  1534,
    1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,
    1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
    1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,
    1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,
    1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,
    1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,
    1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,
    1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,
    1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,
    1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,
    1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,
    1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,
    1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,
    1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,
    1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,
    1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,
    2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,     0,  1471,     0,  3200,  1473,
    1474,     0,     0,  2420,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1476,  1477,  1478,     0,     0,     0,     0,
       0,  3287,     0,    90,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3288,     0,     0,     0,     0,
       0,     0,     0,  1486,  1487,  3289,  3290,     0,  3291,     0,
       0,  1489,  1490,  3292,  3293,     0,     0,  1492,     0,  1493,
    1494,  1495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1496,     0,     0,     0,  1497,  1498,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3294,     0,     0,     0,     0,     0,  1500,     0,
       0,  1501,     0,  1502,     0,  1503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1505,  1506,  1507,  1508,     0,     0,     0,
       0,  1509,     0,     0,     0,  1510,     0,     0,     0,  1511,
       0,  1512,  1513,  1514,     0,     0,  1515,  1516,  1517,  1518,
    1519,  1520,  1521,     0,     0,     0,     0,     0,  1522,  1523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1565,  1566,  1567,
    1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,
    1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,
    1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,
    1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,
    1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,
    1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,
    1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,
    1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,
    2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,     0,  1471,     0,  3200,  1473,  1474,     0,     0,  2420,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1476,
    1477,  1478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3141,     0,     0,     0,     0,     0,  3142,  3143,  1486,
    1487,  1488,     0,     0,  3144,  3145,  3146,  1489,  1490,  1491,
       0,     0,  3147,  1492,     0,  1493,  1494,  1495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1496,     0,
       0,     0,  1497,  1498,  1499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1500,     0,     0,  1501,     0,  1502,
       0,  1503,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1504,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1505,
    1506,  1507,  1508,     0,     0,     0,     0,  1509,     0,     0,
       0,  1510,     0,     0,     0,  1511,     0,  1512,  1513,  1514,
       0,     0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,
       0,     0,     0,     0,  1522,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1533,  1534,  3419,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,
    1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,
    1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,
    1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
    1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,
    1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,
    1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,
    1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,
    1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,
    2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,
    2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,
    2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,
    2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,
    2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,
    2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,
    2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,
    2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,  1471,     0,
    2419,  1473,  1474,     0,     0,  2420,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3141,     0,     0,
       0,     0,     0,  3142,  3143,  1486,  1487,  1488,     0,     0,
    3144,  3145,  3146,  1489,  1490,  1491,     0,     0,  3147,  1492,
       0,  1493,  1494,  1495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,     0,  1497,  1498,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,
       0,     0,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  3422,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,
    1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,
    1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,     0,  1471,     0,  2419,  1473,  1474,     0,
       0,  2420,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1476,  1477,  1478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3141,     0,     0,     0,     0,     0,  3142,
    3143,  1486,  1487,  1488,     0,     0,  3144,  3145,  3146,  1489,
    1490,  1491,     0,     0,  3147,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
    1471,     0,  3527,  1473,  1474,     0,     0,  2420,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1476,  1477,  1478,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3141,
       0,     0,     0,     0,     0,  3142,  3143,  1486,  1487,  1488,
       0,     0,  3144,  3145,  3146,  1489,  1490,  1491,     0,     0,
    3147,  1492,     0,  1493,  1494,  1495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1496,     0,     0,     0,
    1497,  1498,  1499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1500,     0,     0,  1501,     0,  1502,     0,  1503,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1505,  1506,  1507,
    1508,     0,     0,     0,     0,  1509,     0,     0,     0,  1510,
       0,     0,     0,  1511,     0,  1512,  1513,  1514,     0,     0,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,     0,     0,
       0,     0,  1522,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1533,  1534,
    1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,
    1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
    1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,
    1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,
    1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,
    1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,
    1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,
    1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,
    1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,
    1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,
    1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,
    1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,
    1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,
    1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,
    1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,
    1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,
    2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,     0,  1471,     0,  3233,  1473,
    1474,     0,     0,  2420,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1476,  1477,  1478,     0,     0,     0,     0,
       0,  3287,     0,    90,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3288,     0,     0,     0,     0,
       0,     0,     0,  1486,  1487,  3289,  3290,     0,  3291,     0,
       0,  1489,  1490,  3292,  3293,     0,     0,  1492,     0,  1493,
    1494,  1495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1496,     0,     0,     0,  1497,  1498,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4590,     0,     0,     0,     0,     0,  1500,     0,
       0,  1501,     0,  1502,     0,  1503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1505,  1506,  1507,  1508,     0,     0,     0,
       0,  1509,     0,     0,     0,  1510,     0,     0,     0,  1511,
       0,  1512,  1513,  1514,     0,     0,  1515,  1516,  1517,  1518,
    1519,  1520,  1521,     0,     0,     0,     0,     0,  1522,  1523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1565,  1566,  1567,
    1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,
    1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,
    1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,
    1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,
    1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,
    1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,
    1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,
    1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,
    2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,     0,  1471,     0,  2419,  1473,  1474,     0,     0,  2420,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1476,
    1477,  1478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1486,
    1487,  1488,     0,     0,     0,     0,     0,  1489,  1490,  1491,
       0,     0,     0,  1492,     0,  1493,  1494,  1495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1496,     0,
       0,     0,  1497,  1498,  1499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1500,     0,     0,  1501,     0,  1502,
       0,  1503,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1504,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1505,
    1506,  1507,  1508,     0,     0,     0,     0,  1509,     0,     0,
       0,  1510,     0,     0,     0,  1511,     0,  1512,  1513,  1514,
       0,     0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,
       0,     0,     0,     0,  1522,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,
    1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,
    1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,
    1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
    1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,
    1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,
    1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,
    1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,
    1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,
    2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,
    2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,
    2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,
    2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,
    2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,
    2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,
    2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,
    2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,  1471,     0,
    2419,  1473,  1474,     0,     0,  2420,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1486,  1487,  1488,     0,     0,
       0,     0,     0,  1489,  1490,  1491,     0,     0,     0,  1492,
       0,  1493,  1494,  1495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,     0,  1497,  1498,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,
       0,     0,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,
    1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,
    1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,     0,  1471,     0,  3236,  1473,  1474,     0,
       0,  2420,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1476,  1477,  1478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1486,  1487,  1488,     0,     0,     0,     0,     0,  1489,
    1490,  1491,     0,     0,     0,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
    1471,     0,  3561,  1473,  1474,     0,     0,  2420,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1476,  1477,  1478,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1486,  1487,  1488,
       0,     0,     0,     0,     0,  1489,  1490,  1491,     0,     0,
       0,  1492,     0,  1493,  1494,  1495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1496,     0,     0,     0,
    1497,  1498,  1499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1500,     0,     0,  1501,     0,  1502,     0,  1503,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1505,  1506,  1507,
    1508,     0,     0,     0,     0,  1509,     0,     0,     0,  1510,
       0,     0,     0,  1511,     0,  1512,  1513,  1514,     0,     0,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,     0,     0,
       0,     0,  1522,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1533,  1534,
    1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,
    1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
    1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,
    1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,
    1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,
    1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,
    1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,
    1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,
    1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,
    1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,
    1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,
    1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,
    1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,
    1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,
    1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,
    1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,
    2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,     0,  1471,     0,  3527,  1473,
    1474,     0,     0,  2420,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1476,  1477,  1478,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5132,     0,     0,     0,     0,
       0,   497,     0,  1486,  1487,  1488,     0,     0,  5133,  5002,
      69,  5134,  5135,  5136,    73,    74,  5137,  1492,     0,  1493,
    1494,  1495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1496,     0,     0,     0,  1497,  1498,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1500,     0,
       0,  1501,     0,  1502,     0,  1503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1505,  1506,  1507,  1508,     0,     0,     0,
       0,  1509,     0,     0,     0,  1510,     0,     0,     0,  1511,
       0,  1512,  1513,  1514,     0,     0,  1515,  1516,  1517,  1518,
    1519,  1520,  1521,     0,     0,     0,     0,     0,  1522,  1523,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,   126,  1078,  1079,
    1080,   130,  1081,  1082,  1083,  1084,  1085,  1086,   137,  1087,
    1088,   140,  1089,  1090,  1091,  1092,  1093,  1094,  1095,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1565,  1566,  1567,
    1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,
    1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,
    1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,
    1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,
    1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,
    1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,
    1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,
    1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,
    2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,     0,  1471,     0,  2419,  1473,  1474,     0,     0,     0,
    3153,  3154,  3155,     0,     0,     0,     0,     0,     0,  1476,
    1477,  1478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1486,
    1487,  1488,     0,     0,     0,     0,     0,  1489,  1490,  1491,
       0,     0,     0,  1492,     0,  1493,  1494,  1495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1496,     0,
       0,     0,  1497,  1498,  1499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1500,     0,     0,  1501,     0,  1502,
       0,  1503,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1504,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1505,
    1506,  1507,  1508,     0,     0,     0,     0,  1509,     0,     0,
       0,  1510,     0,     0,     0,  1511,     0,  1512,  1513,  1514,
       0,     0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,
       0,     0,     0,     0,  1522,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3157,  3158,  3159,  3160,
    3161,  3162,  3163,  3164,  3165,  3166,  3167,  3168,  3169,  3170,
    3171,  3172,  3173,  3174,  3175,  3176,  3177,  3178,  3179,  3180,
    3181,  3182,  3183,  1565,  1566,  1567,  1568,  1569,  1570,  1571,
    1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,
    1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,
    1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
    1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,
    1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,
    1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,
    1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,
    1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,
    2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,
    2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,
    2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,
    2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,
    2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,
    2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,
    2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,
    2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,  1471,     0,
    3184,  1473,  1474,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1486,  1487,  1488,     0,     0,
       0,     0,     0,  1489,  1490,  1491,     0,     0,     0,  1492,
       0,  1493,  1494,  1495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,     0,  1497,  1498,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,
       0,     0,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
    1557,  1558,  1559,  1560,  1561,  1562,  1563,  1564,  3329,  3330,
    3331,  3332,  3333,  3334,  3335,  3336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,
    1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,
    1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,     0,  1471,     0,  2419,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1476,  1477,  1478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3141,     0,     0,     0,     0,     0,  3142,
    3143,  1486,  1487,  1488,     0,     0,  3144,  3145,  3146,  1489,
    1490,  1491,     0,     0,  3147,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3375,  3376,  3377,  3378,  3379,  3380,
    3381,  3382,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
    1471,     0,  2419,  1473,  1474,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1476,  1477,  1478,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3141,
       0,     0,     0,     0,     0,  3142,  3143,  1486,  1487,  1488,
       0,     0,  3144,  3145,  3146,  1489,  1490,  1491,     0,     0,
    3147,  1492,     0,  1493,  1494,  1495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1496,     0,     0,     0,
    1497,  1498,  1499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1500,     0,     0,  1501,     0,  1502,     0,  1503,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1505,  1506,  1507,
    1508,     0,     0,     0,     0,  1509,     0,     0,     0,  1510,
       0,     0,     0,  1511,     0,  1512,  1513,  1514,     0,     0,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,     0,     0,
       0,     0,  1522,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1533,  1534,
    1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3301,  3302,
    3303,  3304,  3305,  3306,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,
    1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
    1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,
    1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,
    1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,
    1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,
    1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,
    1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,
    1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,
    1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,
    1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,
    1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,
    1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,
    1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,
    1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,
    1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,
    2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,     0,  1471,     0,  3236,  1473,
    1474,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1476,  1477,  1478,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3141,     0,     0,     0,     0,
       0,  3142,  3143,  1486,  1487,  1488,     0,     0,  3144,  3145,
    3146,  1489,  1490,  1491,     0,     0,  3147,  1492,     0,  1493,
    1494,  1495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1496,     0,     0,     0,  1497,  1498,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1500,     0,
       0,  1501,     0,  1502,     0,  1503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1505,  1506,  1507,  1508,     0,     0,     0,
       0,  1509,     0,     0,     0,  1510,     0,     0,     0,  1511,
       0,  1512,  1513,  1514,     0,     0,  1515,  1516,  1517,  1518,
    1519,  1520,  1521,     0,     0,     0,     0,     0,  1522,  1523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4618,  3317,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1565,  1566,  1567,
    1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,
    1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,
    1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,
    1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,
    1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,
    1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,
    1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,
    1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,
    2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,     0,  1471,     0,  3236,  1473,  1474,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1476,
    1477,  1478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1486,
    1487,  1488,     0,     0,     0,     0,     0,  1489,  1490,  1491,
       0,     0,     0,  1492,     0,  1493,  1494,  1495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1496,     0,
       0,     0,  1497,  1498,  1499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1500,     0,     0,  1501,     0,  1502,
       0,  1503,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1504,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1505,
    1506,  1507,  1508,     0,     0,     0,     0,  1509,     0,     0,
       0,  1510,     0,     0,     0,  1511,     0,  1512,  1513,  1514,
       0,     0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,
       0,     0,     0,     0,  1522,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3375,  3376,  3377,  3378,  3379,  3380,  3381,  3382,
    1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,
    1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,
    1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,
    1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
    1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,
    1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,
    1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,
    1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,
    1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,
    2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,
    2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,
    2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,
    2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,
    2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,
    2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,
    2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,
    2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,  1471,     0,
    2419,  1473,  1474,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1486,  1487,  1488,     0,     0,
       0,     0,     0,  1489,  1490,  1491,     0,     0,     0,  1492,
       0,  1493,  1494,  1495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,     0,  1497,  1498,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,
       0,     0,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,     0,     0,     0,     0,     0,  3329,  3330,
    3331,  3332,  3333,  3334,  3335,  3336,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,
    1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,
    1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,     0,  1471,     0,  2419,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1476,  1477,  1478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1486,  1487,  1488,     0,     0,     0,     0,     0,  1489,
    1490,  1491,     0,     0,     0,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,  1557,  1558,  1559,  1560,
    1561,  1562,  1563,  1564,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
    1471,     0,  2419,  1473,  1474,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1476,  1477,  1478,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3141,
       0,     0,     0,     0,     0,  3142,  3143,  1486,  1487,  1488,
       0,     0,  3144,  3145,  3146,  1489,  1490,  1491,     0,     0,
    3147,  1492,     0,  1493,  1494,  1495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1496,     0,     0,     0,
    1497,  1498,  1499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1500,     0,     0,  1501,     0,  1502,     0,  1503,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1505,  1506,  1507,
    1508,     0,     0,     0,     0,  1509,     0,     0,     0,  1510,
       0,     0,     0,  1511,     0,  1512,  1513,  1514,     0,     0,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,     0,     0,
       0,     0,  1522,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1533,  1534,
    1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,
    1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
    1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,
    1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,
    1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,
    1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,
    1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,
    1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,
    1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,
    1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,
    1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,
    1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,
    1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,
    1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,
    1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,
    1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,
    2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,     0,  1471,     0,  2419,  1473,
    1474,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1476,  1477,  1478,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3141,     0,     0,     0,     0,
       0,  3142,  3143,  1486,  1487,  1488,     0,     0,  3144,  3145,
    3146,  1489,  1490,  1491,     0,     0,  3147,  1492,     0,  1493,
    1494,  1495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1496,     0,     0,     0,  1497,  1498,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1500,     0,
       0,  1501,     0,  1502,     0,  1503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1505,  1506,  1507,  1508,     0,     0,     0,
       0,  1509,     0,     0,     0,  1510,     0,     0,     0,  1511,
       0,  1512,  1513,  1514,     0,     0,  1515,  1516,  1517,  1518,
    1519,  1520,  1521,     0,     0,     0,     0,     0,  1522,  1523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1565,  1566,  1567,
    1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,
    1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,
    1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,
    1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,
    1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,
    1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,
    1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,
    1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,
    2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,     0,  1471,     0,  3236,  1473,  1474,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1476,
    1477,  1478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1486,
    1487,  1488,     0,     0,     0,     0,     0,  1489,  1490,  1491,
       0,     0,     0,  1492,     0,  1493,  1494,  1495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1496,     0,
       0,     0,  1497,  1498,  1499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1500,     0,     0,  1501,     0,  1502,
       0,  1503,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1504,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1505,
    1506,  1507,  1508,     0,     0,     0,     0,  1509,     0,     0,
       0,  1510,     0,     0,     0,  1511,     0,  1512,  1513,  1514,
       0,     0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,
       0,     0,     0,     0,  1522,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1533,  1534,  4808,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4809,  4810,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,
    1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,
    1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,
    1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
    1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,
    1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,
    1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,
    1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,
    1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,
    2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,
    2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,
    2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,
    2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,
    2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,
    2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,
    2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,
    2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,  1471,     0,
    2419,  1473,  1474,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1486,  1487,  1488,     0,     0,
       0,     0,     0,  1489,  1490,  1491,     0,     0,     0,  1492,
       0,  1493,  1494,  1495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,     0,  1497,  1498,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,
       0,     0,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3375,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,
    1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,
    1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,     0,  1471,     0,  2419,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1476,  1477,  1478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1486,  1487,  1488,     0,     0,     0,     0,     0,  1489,
    1490,  1491,     0,     0,     0,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
    1471,     0,  3200,  1473,  1474,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1476,  1477,  1478,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1486,  1487,  1488,
       0,     0,     0,     0,     0,  1489,  1490,  1491,     0,     0,
       0,  1492,     0,  1493,  1494,  1495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1496,     0,     0,     0,
    1497,  1498,  1499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1500,     0,     0,  1501,     0,  1502,     0,  1503,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1505,  1506,  1507,
    1508,     0,     0,     0,     0,  1509,     0,     0,     0,  1510,
       0,     0,     0,  1511,     0,  1512,  1513,  1514,     0,     0,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,     0,     0,
       0,     0,  1522,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1533,  1534,
    1535,  1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,
    1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
    1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,
    1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,
    1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,
    1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,
    1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,
    1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,
    1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,
    1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,
    1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,
    1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,
    1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,
    1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,
    1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,
    1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,
    2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,     0,  1471,     0,  2419,  1473,
    1474,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1476,  1477,  1478,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1486,  1487,  1488,     0,     0,     0,     0,
       0,  1489,  1490,  1491,     0,     0,     0,  1492,     0,  1493,
    1494,  1495,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1496,     0,     0,     0,  1497,  1498,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1500,     0,
       0,  1501,     0,  1502,     0,  1503,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1505,  1506,  1507,  1508,     0,     0,     0,
       0,  1509,     0,     0,     0,  1510,     0,     0,     0,  1511,
       0,  1512,  1513,  1514,     0,     0,  1515,  1516,  1517,  1518,
    1519,  1520,  1521,     0,     0,     0,     0,     0,  1522,  1523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1536,  1537,  1538,
    1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1565,  1566,  1567,
    1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,
    1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,
    1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,
    1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,
    1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,
    1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,
    1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,
    1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,
    1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,
    1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,
    1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,
    1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,
    1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,
    1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,
    1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,
    1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,
    1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,
    1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,
    1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,
    1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,
    1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,
    1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,
    1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,
    1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,
    1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,
    1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,
    1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,
    1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,
    2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,
    2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,
    2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,
    2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,
    2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,
    2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,
    2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,
    2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,
    2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,
    2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,
    2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,
    2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,
    2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,
    2148,     0,  1471,     0,  3236,  1473,  1474,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1476,
    1477,  1478,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1486,
    1487,  1488,     0,     0,     0,     0,     0,  1489,  1490,  1491,
       0,     0,     0,  1492,     0,  1493,  1494,  1495,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1496,     0,
       0,     0,  1497,  1498,  1499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1500,     0,     0,  1501,     0,  1502,
       0,  1503,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1504,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1505,
    1506,  1507,  1508,     0,     0,     0,     0,  1509,     0,     0,
       0,  1510,     0,     0,     0,  1511,     0,  1512,  1513,  1514,
       0,     0,  1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,
       0,     0,     0,     0,  1522,  1523,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    3343,  1534,  3344,  3345,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1553,  1554,  1555,  1556,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,
    1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,
    1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,
    1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,
    1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,
    1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,
    1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,
    1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,
    1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,
    1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,
    1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,
    1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,
    1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,
    1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,
    1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,
    1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,
    1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,
    1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,
    1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,
    1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,
    1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,
    1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,
    1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,
    2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,
    2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,
    2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,
    2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,
    2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,
    2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,
    2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,
    2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,
    2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,
    2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,
    2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,
    2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,
    2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,
    2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,  1471,     0,
    2419,  1473,  1474,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1476,  1477,  1478,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1486,  1487,  1488,     0,     0,
       0,     0,     0,  1489,  1490,  1491,     0,     0,     0,  1492,
       0,  1493,  1494,  1495,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1496,     0,     0,     0,  1497,  1498,
    1499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1500,     0,     0,  1501,     0,  1502,     0,  1503,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1504,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1505,  1506,  1507,  1508,     0,
       0,     0,     0,  1509,     0,     0,     0,  1510,     0,     0,
       0,  1511,     0,  1512,  1513,  1514,     0,     0,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,     0,     0,     0,     0,     0,
    1522,  1523,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1533,  1534,  1535,  1536,
    1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,  1546,
    1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,  1625,
    1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,
    1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,
    1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,
    1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,
    1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,
    1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,
    1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,
    1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,  1724,  1725,
    1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,  1745,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,  1754,  1755,
    1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,  1764,  1765,
    1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,  1784,  1785,
    1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,
    1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,
    1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,
    1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,  1854,  1855,
    1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,
    1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,
    1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,  1884,  1885,
    1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,  1894,  1895,
    1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,  1904,  1905,
    1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,
    1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,
    1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,  1954,  1955,
    1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,
    1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,
    1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,
    1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,
    2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,  2014,  2015,
    2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,  2024,  2025,
    2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,  2034,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,  2045,
    2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,
    2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2084,  2085,
    2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,  2094,  2095,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,  2124,  2125,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,  2144,  2145,
    2146,  2147,  2148,     0,  1471,     0,  3527,  1473,  1474,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1476,  1477,  1478,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1486,  1487,  1488,     0,     0,     0,     0,     0,  1489,
    1490,  1491,     0,     0,     0,  1492,     0,  1493,  1494,  1495,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1496,     0,     0,     0,  1497,  1498,  1499,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1500,     0,     0,  1501,
       0,  1502,     0,  1503,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1505,  1506,  1507,  1508,     0,     0,     0,     0,  1509,
       0,     0,     0,  1510,     0,     0,     0,  1511,     0,  1512,
    1513,  1514,     0,     0,  1515,  1516,  1517,  1518,  1519,  1520,
    1521,     0,     0,     0,     0,     0,  1522,  1523,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1533,  1534,  1535,  1536,  1537,  1538,  1539,  1540,
    1541,  1542,  1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,
    1551,  1552,  1553,  1554,  1555,  1556,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1593,  1594,  1595,  1596,  1597,  1598,  1599,
    1600,  1601,  1602,  1603,  1604,  1605,  1606,  1607,  1608,  1609,
    1610,  1611,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1635,  1636,  1637,  1638,  1639,
    1640,  1641,  1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,
    1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,
    1660,  1661,  1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,
    1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,
    1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,
    1700,  1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,
    1710,  1711,  1712,  1713,  1714,  1715,  1716,  1717,  1718,  1719,
    1720,  1721,  1722,  1723,  1724,  1725,  1726,  1727,  1728,  1729,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1740,  1741,  1742,  1743,  1744,  1745,  1746,  1747,  1748,  1749,
    1750,  1751,  1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,
    1760,  1761,  1762,  1763,  1764,  1765,  1766,  1767,  1768,  1769,
    1770,  1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,
    1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,
    1790,  1791,  1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,
    1800,  1801,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,
    1810,  1811,  1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1832,  1833,  1834,  1835,  1836,  1837,  1838,  1839,
    1840,  1841,  1842,  1843,  1844,  1845,  1846,  1847,  1848,  1849,
    1850,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,  1859,
    1860,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,  1869,
    1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,  1879,
    1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,
    1890,  1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,
    1910,  1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,
    1920,  1921,  1922,  1923,  1924,  1925,  1926,  1927,  1928,  1929,
    1930,  1931,  1932,  1933,  1934,  1935,  1936,  1937,  1938,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1953,  1954,  1955,  1956,  1957,  1958,  1959,
    1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,
    1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,
    1980,  1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1999,
    2000,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,
    2020,  2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,
    2030,  2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,
    2040,  2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,
    2050,  2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,
    2060,  2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,
    2070,  2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2118,  2119,
    2120,  2121,  2122,  2123,  2124,  2125,  2126,  2127,  2128,  2129,
    2130,  2131,  2132,  2133,  2134,  2135,  2136,  2137,  2138,  2139,
    2140,  2141,  2142,  2143,  2144,  2145,  2146,  2147,  2148,     0,
    1471,     0,  3233,  1473,  1474,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1476,  1477,  1478,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1486,  1487,  1488,
       0,     0,     0,     0,     0,  1489,  1490,  1491,     0,     0,
       0,  1492,     0,  1493,  1494,  1495,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1496,     0,     0,     0,
    1497,  1498,  1499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1500,     0,     0,  1501,     0,  1502,     0,  1503,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1504,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1505,  1506,  1507,
    1508,     0,     0,     0,     0,  1509,     0,     0,     0,  1510,
       0,     0,     0,  1511,     0,  1512,  1513,  1514,     0,     0,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,     0,     0,     0,
       0,     0,  1522,  1523,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4815,  1534,
    4816,  4817,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553,  1554,
    1555,  1556,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,
    1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1604,  1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,
    1614,  1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,
    1624,  1625,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,
    1634,  1635,  1636,  1637,  1638,  1639,  1640,  1641,  1642,  1643,
    1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,  1672,  1673,
    1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,  1682,  1683,
    1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,  1692,  1693,
    1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,
    1704,  1705,  1706,  1707,  1708,  1709,  1710,  1711,  1712,  1713,
    1714,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1745,  1746,  1747,  1748,  1749,  1750,  1751,  1752,  1753,
    1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,  1762,  1763,
    1764,  1765,  1766,  1767,  1768,  1769,  1770,  1771,  1772,  1773,
    1774,  1775,  1776,  1777,  1778,  1779,  1780,  1781,  1782,  1783,
    1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,
    1824,  1825,  1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,
    1834,  1835,  1836,  1837,  1838,  1839,  1840,  1841,  1842,  1843,
    1844,  1845,  1846,  1847,  1848,  1849,  1850,  1851,  1852,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,
    1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,  1892,  1893,
    1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,  1902,  1903,
    1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,
    1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,  1922,  1923,
    1924,  1925,  1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,
    1934,  1935,  1936,  1937,  1938,  1939,  1940,  1941,  1942,  1943,
    1944,  1945,  1946,  1947,  1948,  1949,  1950,  1951,  1952,  1953,
    1954,  1955,  1956,  1957,  1958,  1959,  1960,  1961,  1962,  1963,
    1964,  1965,  1966,  1967,  1968,  1969,  1970,  1971,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1979,  1980,  1981,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,  1993,
    1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,
    2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,  2012,  2013,
    2014,  2015,  2016,  2017,  2018,  2019,  2020,  2021,  2022,  2023,
    2024,  2025,  2026,  2027,  2028,  2029,  2030,  2031,  2032,  2033,
    2034,  2035,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2044,  2045,  2046,  2047,  2048,  2049,  2050,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2062,  2063,
    2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,
    2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2087,  2088,  2089,  2090,  2091,  2092,  2093,
    2094,  2095,  2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,
    2104,  2105,  2106,  2107,  2108,  2109,  2110,  2111,  2112,  2113,
    2114,  2115,  2116,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,     0,     0,     0,  2419
};

static const yytype_int16 yycheck[] =
{
       7,     8,     9,    10,    11,    79,  1207,   429,    15,   422,
    2275,  3128,  3207,   690,  2957,  1340,  1040,  2556,  2557,  2558,
    2518,  3664,  3667,  4255,  4254,  3669,  3668,  4256,  2927,  1491,
     726,  3666,  3665,  1495,  2539,   856,  4850,  4864,  4851,  4841,
    4843,    89,  3680,    91,  4852,    58,  4240,  2547,  2542,  2880,
    3886,  2882,  3888,  3889,  3871,    50,  4917,    52,    53,  3876,
    4461,  1222,  4519,  4464,  4465,  5652,  2800,  3721,  4994,  2645,
      65,  6028,  3297,    80,  2843,  2802,  5624,  1497,  1498,  4320,
    4468,  3325,  4470,  3325,  4118,    92,    93,  2541,  2542,     1,
    3874,  2875,  4463,     1,     1,    11,  6286,  3673,     1,  1040,
    6290,  3677,     1,  1264,  1265,  3681,     1,     1,  3860,  3861,
    3862,  3863,   119,   120,   121,   122,   123,   124,   125,     1,
     127,   128,   129,  5523,   131,   132,   133,   134,   135,   136,
       1,   138,   139,     1,   141,   142,   143,   144,   145,   146,
     147,  2640,     1,    20,  2230,     1,  2645,     1,     6,    80,
       1,     9,    18,     1,    20,     1,     1,   164,     1,   166,
    1040,     1,  4916,  4917,  2343,     1,  1040,   174,   175,   176,
    2420,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,    37,    41,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,  2430,  2508,    11,    18,
      19,   318,     1,     1,   321,    41,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,  2430,  4320,  3325,  2684,    37,  2686,
      37,    37,   359,    41,     6,    37,    37,     9,    41,  2560,
    2561,  4985,  2609,    42,    43,  6672,  6672,  4985,    18,  2570,
      20,    37,  3351,   380,  4985,  6222,   383,  3117,  3357,    18,
      19,   388,    44,    18,    19,  2529,  2633,    41,  2635,  4985,
      37,    41,     1,    18,    19,    20,    37,    18,    19,    20,
    4985,   408,  2352,    18,    19,    20,  2607,    37,  2609,  2610,
      18,  4985,    20,   420,    18,   422,    20,  2664,   748,    37,
    6156,    32,  6504,    34,    32,  4921,    34,   434,   435,  6076,
    2554,   438,   439,    41,  2635,    37,    37,    41,   445,   446,
     447,   448,   449,   450,   451,   452,    37,  2648,   455,   456,
    2651,   458,   459,    37,   502,  2656,  4110,    37,   506,  5660,
      41,  1485,    37,  2664,    37,  2752,  2803,    37,  2805,  6116,
      37,  2672,  2809,    37,  2154,  2155,  2156,  2236,    32,  2822,
      34,  2161,    37,    38,    39,  2772,    37,    37,    37,  1040,
    5660,  5660,  3283,    37,    37,   440,    37,    37,  4985,  3185,
     431,   432,  3188,   470,  4052,  6293,  1973,  1127,  1130,   454,
    5910,  6360,  1134,  2856,  1134,  2073,  7301,  2425,  7303,  4697,
    4698,  5524,     1,  7465,  1125,  5641,   471,  3185,   535,    46,
    2098,  3185,  2100,   478,   479,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,  2231,  1130,  2233,  2234,   102,  1134,     1,  2238,  2846,
    5676,  6450,   485,   486,   487,   488,   489,   490,   448,   449,
     450,  7563,    11,  2860,  2861,  6464,  2863,  6449,  2675,  2676,
    7167,  7168,  4067,  4068,  2681,  7527,   447,  2684,  7240,  2686,
    6462,  5924,  2839,  6669,   107,  2842,  4144,  5928,    37,  4242,
    5933,  4246,  2803,    66,  4248,  4247,  2807,  2854,  5939,  4244,
    4243,    74,  7397,  7398,  2182,  4845,  4848,  2864,  4847,  2866,
    2867,  6703,  1126,     1,  2871,  1126,  1125,  5767,  1132,  5769,
       8,  1132,  5772,  2541,  2542,  2732,  2194,  2195,  2196,  1125,
    2198,    19,  2843,  2844,  1130,  7297,   507,   508,  1134,  1125,
      28,    29,    30,    31,    32,    33,    34,    35,  7650,    58,
    7652,  1130,  7249,  2864,  1133,  2866,  2867,    66,    46,  2842,
    1127,   678,  2873,  6522,  1125,  4160,   683,  1134,   113,  4920,
     115,  4922,   117,   690,   128,  1125,   130,  1127,    46,  4723,
    1130,   135,  3186,  3810,  3811,  4180,  3813,  3814,  1130,  3816,
    3817,  7486,  1134,   777,   778,  3199,  2803,  1126,  2805,  3203,
     723,  2808,  2809,  1132,   721,  2182,    38,    39,  3212,  1125,
    3214,   115,  3216,   718,  1130,  3950,   120,  3511,  1134,  1130,
     165,  3185,  3186,  1134,  3188,    46,   447,  2370,  2205,  2206,
     451,    97,    98,    99,   455,  3199,  5835,    57,   459,  3203,
     461,    33,   463,    35,   465,    65,   467,  2516,  3212,   313,
    3214,  3660,  3216,    73,   771,  7513,  7514,     0,   779,  2402,
    2403,   325,   779,    46,   781,   782,   170,   171,   172,   173,
    1127,    54,    55,  6430,    75,    76,   142,  1134,    46,    62,
      63,    36,  2878,  1130,    82,    36,  6443,  1134,    56,    57,
      19,    59,    60,    61,    62,    63,    64,    65,    53,    67,
    2735,     1,    53,    32,    72,    34,    61,  2742,  2743,  3610,
      61,   128,   445,   130,   447,   448,   833,   838,   135,  4467,
    4468,   838,  4470,  1126,  3618,   780,  1128,   844,  1130,  1128,
     785,   786,  1134,   788,   789,  2770,  2771,   128,   779,   130,
     857,   858,  1132,  6700,   135,  6591,  1127,   466,    32,   468,
      34,   806,   807,  1134,   809,   810,   811,   812,  2992,   814,
     815,  1130,  1133,   818,   819,  1134,   821,   822,  7626,  7627,
    7628,  1128,  5636,  5637,  5638,  5639,  1133,  1125,  5642,   267,
    1128,   836,   837,  1126,  3621,  3622,  6543,  6037,  6974,  6975,
    1128,   781,   782,  6043,  4879,  1133,  2992,   838,  1126,  2995,
     168,  1130,  5915,   844,   266,  1134,  5829,   924,    57,    58,
    5923,  1126,     1,  6711,  1475,  1128,    65,    66,   935,    32,
    1133,    34,  2857,    72,    73,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,  1129,  1125,  3123,
    3124,  1133,  3126,  3127,  1130,  3129,  3130,   466,  1134,   468,
    3240,    37,  1040,  1000,  1125,  1002,  1127,  1004,  3725,  1130,
    1127,  1008,  1009,  2953,  1011,   448,  1013,     4,  1015,   452,
    1017,  3509,  1019,   456,  1021,    37,  1023,   460,  1025,   462,
    1027,   464,  1029,  7099,  1031,  1032,  7102,  1034,  3152,  1133,
    1128,  4226,  5528,  1040,  5530,  1133,   445,    37,   447,   448,
      77,    78,    79,    80,    81,  1126,    83,    84,    85,  1130,
      87,  4835,    89,  3793,    91,  6058,  1125,  6258,  1129,  1128,
    1128,  1130,  1133,   100,   101,  1133,  3152,  4721,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    57,    58,  6258,  6258,
      37,  2553,  6739,  3294,    65,    66,  1125,  1126,  1105,  7406,
    7406,    72,    73,   128,  2524,  2525,   131,  2527,  2528,  1116,
    2530,  2531,  2792,  2793,  2794,  2795,  2796,  2797,  2798,  2799,
      33,   448,    35,  6212,  3210,   452,  1128,  2886,  2887,   456,
    1130,  1133,  1126,   460,  6223,   462,  1130,   464,  1128,   466,
    1147,   468,  2166,  1133,  7451,  7451,  3860,  6547,  3862,  3863,
    3877,  3878,  3838,  1120,  6554,  1125,  1126,  3843,  1165,  1166,
    1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,
    1177,  1178,    37,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1128,  1196,
    1197,  1198,  1199,  1133,  1201,  1202,    32,  5438,    34,  5656,
    5441,  3859,  3860,  1126,  3862,  3863,  3860,  1128,  3862,  3863,
    1126,  1128,  1133,  1224,  1225,  1128,  1133,  1224,  1225,  1131,
    1133,  1129,  1129,    37,  1127,  2166,  1133,  6874,   265,  1128,
      18,    19,  1128,  1128,  1128,  2560,  2561,  1133,   452,   183,
     184,   455,   456,  6116,   458,   459,  1128,  1258,    37,  1128,
    5621,  1258,  1129,  1128,  1133,  5626,    37,  1128,  1133,  5630,
    1128,  6908,  1269,  1270,  1130,  1210,  1211,  1212,  1126,  1128,
    2595,  1127,  1217,  1218,  1128,  5309,  1127,  3185,  3186,  1127,
    3188,  1127,  1127,  4052,  1127,  4861,  2166,  1127,    37,  1125,
    4866,  3199,  2166,  1224,  1225,  3203,  4872,  1128,  4874,    37,
    4876,  3474,  1133,  6419,  3212,  6218,  3214,  1252,  3216,  1128,
    1128,    37,  6225,  1128,  1133,  1133,  6229,  3225,  1133,  1128,
    2645,   188,   189,  2648,  1133,  4520,  2651,  1258,  6241,  1126,
    2599,  5115,  2601,  1130,  3242,    20,    21,    22,    23,    24,
      25,  2560,  2561,  3837,  2613,  5097,  5098,  2672,  2673,   128,
    2569,  1128,   131,  3261,  3848,  3849,  1133,  6757,  1128,    37,
    2629,  5749,  4606,  1133,  4606,  1128,  4106,  4592,  1128,  3277,
    1133,  1130,    37,  1133,  3950,  1134,  2595,  4111,   129,   130,
    2599,  2600,  1128,  3837,  3838,  6009,  4155,  1133,  1128,  3297,
    2609,  6009,  1128,  1133,  3848,  3849,  1130,  1133,  6009,  4168,
    1134,  4170,  1128,  4172,  4173,  2674,  3860,  1128,  3862,  3863,
    2679,  2680,  1133,  6009,  1125,  1130,  2635,  3325,    37,  1134,
    1129,  2640,  6348,  1126,  6009,  1125,  2645,  1475,   128,  2648,
    1130,   131,  2651,  7623,  7624,  6009,  1484,  1126,    37,  1127,
    1127,  1127,  1125,  4227,  4228,  2664,  1127,  1130,  1130,  3357,
    2669,  2670,  2721,  2722,  2723,  2724,  2725,  2726,  2727,  2728,
    1126,  3960,    37,  5438,  1130,  1127,  5441,  1474,  1475,   108,
    3969,   110,  1134,  6334,  1128,  3383,  1128,  1127,  2803,  1126,
      37,  3389,  2807,  1130,  2753,  2754,  1128,   129,   130,  1130,
    1129,  1133,  7139,  1500,  1129,    37,  1126,  1504,  6501,  1506,
    1507,  1508,  1509,  1510,  1129,  1512,  5963,  5964,  1129,  1516,
      37,  1518,  1130,  1520,  1129,  1522,  1523,  6271,  6272,  1127,
      37,  1132,  6009,  1127,  1135,  1126,    37,  5768,  1130,  1130,
    1130,  7380,  5773,    37,  1134,  1126,  5714,  5715,  5716,  1130,
    1128,  2810,  1126,  6546,    37,  1133,  1130,  1128,  2817,  2818,
    1130,  1126,  6555,  1126,    37,  1130,  1126,  6430,  2827,  1126,
    2829,  3826,  1126,  2832,  1130,  6965,  2835,  1574,  1575,  1128,
    6443,  1578,  1127,  1134,  1133,  1126,  1126,  1126,  1132,  1586,
    6334,  1135,  1126,  1126,  1129,  1126,  1126,  7234,  6514,  6515,
    1128,  1128,  1128,  2862,  1126,  1133,  1133,  1133,  1130,  2150,
    1134,  2152,  2153,  1610,  2300,  1612,  2283,  1614,  1615,  1616,
    7197,  3519,  6701,  1130,  1130,  2166,  1128,  1624,  1128,  7167,
    7168,  1133,  1629,  1133,  1128,  1128,  2845,  4606,  1635,  1133,
    1133,  1638,   128,  7590,  7591,   131,  4615,  3723,  1128,  1128,
    3339,   129,   130,  1133,  1133,  2864,  2865,  2866,  2867,     1,
    3558,  5305,  2871,  1128,  1128,  3563,     1,  1128,  1133,  1133,
    1128,  6750,  1133,  1128,     1,  1133,  1673,  1126,  1133,  1676,
    6543,  1130,  3580,   266,  1128,    56,    57,    58,  7265,  1133,
       1,  1128,  3929,    64,    65,    66,  1133,   206,   207,   208,
    7337,    72,    73,    74,  1701,  1128,  1703,   129,   130,  1128,
    1133,  7249,  3875,  3950,  1133,  3829,  1713,  3908,  1134,  6635,
    1717,  6525,   113,  6526,   115,  1722,   117,  6520,  1725,  6527,
    1128,  1728,  1128,  4066,  4067,  1133,  6652,  1133,  3929,  1126,
    3931,  3932,  3431,  1130,  4077,     1,  6662,  4521,  4522,  3940,
    4083,  1128,  3441,  3829,   188,   189,  1133,  1125,  3447,  3835,
    4477,  1128,  1130,  1127,  1132,  1128,  1133,  1135,  2743,  1126,
    1133,  1130,  3461,  1130,  1771,  2750,  2751,    12,    13,    14,
      15,    16,    17,  4060,  4061,  1128,  1130,  3978,  1128,  2764,
    1133,  4068,  1128,  1133,  6697,  1128,     1,  1133,  4125,  3251,
    1133,  3253,  4135,  4130,  1133,  4082,  3121,  1128,  1125,  4086,
    1128,     1,  1133,  2964,  3484,  1133,  1813,  1128,  1127,  7209,
    1128,  1128,  1133,  1820,  1821,  1133,  1133,  4160,  1497,  1498,
    1827,  1828,  1829,  1830,  1831,  1832,  1833,  1834,  1835,  1836,
    3292,    86,  6745,  6204,  5410,  2820,  5672,  4180,  6391,  2824,
      20,    21,    22,    23,    24,    25,  5663,  5664,   179,   180,
     181,  1128,  1128,  6224,  1861,  1862,  1133,  1133,  4145,  3558,
    1128,    86,  6233,  2848,  1128,  1133,  6739,  1125,    32,  1133,
      34,  1128,  2857,  2858,  2859,  1128,  1133,  1128,  1128,    88,
    1133,  3580,  1133,  1133,  1891,  1892,  1893,  6288,  6690,  1896,
    1897,  1898,  1899,  1900,  1901,  1902,  1903,   206,   207,  1128,
    1907,    46,  3121,  6274,  1133,  6276,   128,   128,  1128,   131,
     131,    56,    57,  1133,    59,    60,    61,    62,    63,    64,
      65,  4168,    67,  4170,   129,   130,  1128,    72,  4101,  3837,
    3838,  1133,  4029,  1128,  4031,    88,   128,  1128,  1133,   131,
    3848,  3849,  1133,  1950,  1951,  1952,  1953,   128,  1128,    92,
     131,  3859,  3860,  1133,  3862,  3863,    32,     1,    34,  2510,
    1128,  2512,  1969,  2514,     8,  1133,  1973,  4168,  1128,  1128,
      94,  4218,  1128,  1133,  1133,    19,  4100,  1133,  1128,  1986,
    1987,   129,   130,  1133,    28,    29,    30,    31,    32,    33,
      34,    35,  1128,  2000,  2001,  2002,     0,  1133,  1128,  1128,
    1128,  6874,    46,  1133,  1133,  1133,  1128,  4838,  1128,  1134,
    1128,  1133,  1128,  1133,  4100,  1133,  1131,  1133,  1133,  1128,
    1128,  4515,  1134,   168,  1133,  1133,  1128,  4124,  1128,  1128,
    4127,  1133,  1127,  1133,  1133,  6908,  4133,  4491,  2045,   179,
     180,   181,  4542,  2050,  2051,    11,    12,    13,    14,    15,
      16,    17,  1131,  1128,  1133,    13,  2063,  2064,  1133,  1128,
      26,  4515,  2069,   108,  1133,  2072,  2073,  1128,  6994,  1128,
     129,   130,  1133,  1128,  1133,  6705,  6308,  1126,  1133,  2086,
    1130,  1130,  2089,  6713,  6714,  1122,  1123,  1124,   183,   184,
     185,  2098,  2099,  2100,  2101,  2102,  2103,    46,  1128,  2106,
     117,  7027,  2150,  1133,  2152,  2153,  6300,  6508,  1128,  6510,
    1128,  5749,  1128,  1133,  1125,  1133,   678,  1133,  2166,  1130,
    1128,  1131,  1128,  1133,  1125,  1133,  4051,  1133,  6207,  6359,
    1128,  4056,  6361,    41,  4059,  1133,  1128,  4062,  4063,  1128,
    4065,  1133,  1125,  2150,  1133,  2152,  2153,    46,    41,  1128,
    1128,    41,  1128,  4078,  1133,  1133,  4081,  1133,  1128,  2166,
    1130,    60,    61,    62,    63,    64,    65,    66,    67,  2176,
    2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,
    2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,  2196,
    2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2210,  2211,  2212,  2213,  2214,  2215,  2216,
    2217,  2218,  2219,  2220,  2221,  2222,  1128,  6770,  2225,  2226,
    1128,  1133,  1128,   267,  1131,  1133,  1133,  1133,  6685,  2925,
    1128,  6784,  4157,  4158,  4159,  1133,  4161,  4162,  1128,  6792,
      41,  1128,  1128,  1133,  6196,  6875,  1133,  1133,    96,  1128,
    1128,  1128,    40,  6883,  1133,  1133,  1133,  4182,  4183,  1128,
    1128,  4186,  4187,     1,  1133,  1133,  1130,  1128,  2275,  4442,
    6349,   833,  1133,  1128,  1130,  1128,  2283,  1130,  1133,  2286,
    2354,  2355,    18,    19,    20,    21,    22,    23,    24,    25,
    1130,  6521,  2305,  1128,  6523,     4,  1128,    93,  1133,     8,
    2295,  1133,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,  6417,  6418,   437,
     438,   439,   440,   441,   442,   443,   444,  1128,  1128,  1128,
    4531,  2338,  1133,  1133,  1133,    94,  2343,  6708,  2889,  2890,
    2891,  2892,  2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,
    2901,  2902,  2903,  2904,  2905,  6455,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    4543,  1126,  4545,  7299,    37,  1130,  7436,  4550,   108,  7439,
    7010,  1128,  1127,     3,     4,     5,  1133,  4473,     8,  4590,
    4563,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,  6777,   206,   207,   208,
    7470,  7471,  7472,  7473,  7474,  7475,  7476,  1126,   140,  1133,
     140,   140,  1131,   145,  2431,   145,   145,   129,   130,  6381,
     204,   205,   206,   207,   208,   117,    95,  6389,    97,    98,
      99,   206,   207,   208,  7504,  1133,  2453,  2454,  2455,  3473,
     195,   196,  2397,  7006,  4468,  7008,  4470,  2464,  2465,  2466,
    2467,  1133,  2510,  1133,  2512,  1133,  2514,   183,   184,   185,
    5301,    42,    43,  3798,  1133,  6118,  1133,  6556,  6557,   206,
     207,   208,  2489,  2490,  2491,  6120,  6119,  2494,  2495,  1133,
    3431,  2498,   179,   180,   181,  1133,  2503,  7127,  1133,  7129,
    3441,   140,   141,  2510,  7564,  2512,  3447,  2514,  1133,  6880,
    1133,  6882,   179,   180,   181,  1133,  2523,  3969,  3970,  2838,
    2839,    95,  3463,    97,    98,    99,  3604,  3605,  3607,  3608,
    3790,  3791,  2539,  1130,  2541,  2542,  1130,   111,   123,   113,
     127,   115,   125,   117,  1132,  4453,  6646,    44,   122,  3874,
     124,    44,   126,  1125,  1116,  3192,  3193,  5752,  6637,   117,
      44,    44,  3113,  5758,  3115,  4738,  5293,    44,  7121,  7383,
    1128,  7384,   117,   117,  6653,  1125,    93,  7385,  4702,  3798,
    4488,   114,   121,  4491,    46,  6664,   118,  5356,  5357,  1134,
      46,   165,  1125,    41,  1125,  4768,  1125,  4770,    60,    61,
      62,    63,    64,    65,    66,    67,     1,  4515,    37,   117,
     117,    41,  1133,    41,  7417,    41,  4702,  3558,  1133,   117,
    4706,  1130,  1129,    46,  1130,  2304,  1128,  1128,  1133,   117,
     117,    41,    69,  5750,  5751,  1134,  1133,  1199,  7465,    37,
       1,    37,  1133,  1133,  3585,    28,  1133,  1129,  1128,    56,
     112,    57,     1,    11,   195,  3874,    69,   117,  6301,   117,
    6305,  1128,  6741,  6307,  6306,  7218,  2996,   117,  6303,  6302,
    7596,  7597,  7598,   117,  3943,  7478,    46,   117,  1128,    20,
      28,   117,   117,   117,  4592,    55,    56,    57,    58,    59,
     117,  3960,  3961,    63,    64,    65,    66,    67,  1134,  3968,
    3969,    71,    72,    73,    74,    28,   123,  1269,  1270,  6809,
    3929,   125,  3931,  3932,  1126,  3934,  3935,  3936,  3937,   127,
    1126,  1126,  3941,  3942,  3943,    37,  7279,    37,  7281,    37,
      37,  4000,    37,  6833,  4003,  4004,    37,    37,    37,    37,
      37,  3960,  3961,  3962,  3963,    37,  7672,  7673,  7674,    37,
    3969,  3970,    37,    37,    37,    37,    37,    37,    37,     4,
      37,    37,    37,     8,    37,    37,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,  4000,  4001,  4002,  4003,  4004,  1126,     4,  1127,   166,
      37,     8,   106,    37,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,     4,
    1129,  1125,    44,     8,   109,    45,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,  6783,    94,     9,    40,    40,  6788,  2885,    45,   178,
     187,  2889,  2890,  2891,  2892,  2893,  2894,  2895,  2896,  2897,
    2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,  6958,    45,
    6960,    45,    45,  1128,  4772,    45,  3687,    45,  1127,  4777,
    1127,  1127,  1133,  4198,  2881,  1127,  1127,  1127,  2885,  1133,
      28,   437,  2889,  2890,  2891,  2892,  2893,  2894,  2895,  2896,
    2897,  2898,  2899,  2900,  2901,  2902,  2903,  2904,  2905,   477,
     478,   479,   480,   481,   482,   483,   484,   116,  1128,  6026,
    1129,  1127,   105,  1127,  6031,  6032,  6995,  1127,   108,  2926,
    1127,  1127,  3473,  1126,   183,  3476,  3477,  4196,   191,    41,
    1127,  3482,    41,    46,  2941,  2942,    46,  2944,    46,  2946,
    2947,  1129,  2949,  1134,  1128,  2952,   142,    97,  3933,  2956,
    2957,    98,  5153,  4222,    99,  4174,  4175,  4176,   145,  2966,
    2967,   140,    94,   138,    94,    45,  3148,  2974,  2975,  2976,
     194,  1128,   195,  5146,   208,  5480,     1,  4196,  4197,  4198,
    1125,  5154,  5155,  5156,  7084,    41,  3971,  5160,  7088,    46,
     208,    41,   117,  1130,    94,  7095,  1125,  7097,    94,  4218,
    4219,  4220,  4221,    60,    61,    62,    63,    64,    65,    66,
      67,    37,   136,  4693,  4694,  4695,    73,    94,    94,   103,
    1133,  1125,  2425,  2968,  2969,     3,     4,     5,  1125,  1130,
       8,  1133,  1126,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,   138,   138,
     138,   138,  5225,   138,   185,  7685,  7686,  7687,    41,   138,
      46,    37,  1127,  7015,  1127,  3113,  7018,  3115,    37,  1126,
    3118,  4056,    94,  3255,    94,    94,  1127,  1133,  4063,  4064,
    1133,  1125,  1131,     1,  3266,  4109,  1130,  3269,  1132,    44,
    3272,  1135,    34,   179,  1133,  1133,    97,   208,    95,  4084,
      97,    98,    99,  3285,  3111,  3112,  3113,    98,  3115,    94,
    7062,  3118,    94,   684,   111,   686,   113,    37,   115,    45,
     117,    37,  7074,   120,    37,   122,  7078,   124,    93,   126,
     104,  4456,    37,    37,    37,   181,   180,   185,  2541,  2542,
    6039,   195,  3149,   195,    37,   138,  5319,  5320,  1130,  7379,
    7382,    37,  7381,    37,    37,  1126,  1130,  3339,   138,   132,
      45,  1125,  4147,    93,    93,  4150,    11,    46,   165,  3351,
    6287,    37,  6289,    37,   130,  5348,   181,    44,  3185,  3186,
    7132,    60,    61,    62,    63,    64,    65,    66,    67,   188,
      45,  1126,  3199,    72,   181,   136,  3203,   768,  3205,    46,
     181,   180,   208,    94,  5290,  3212,   140,  3214,   140,  3216,
    3392,  1126,  1126,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    93,    93,    37,  1126,    37,  3234,   799,   130,
    3237,   447,   448,   181,   181,   451,   452,  4456,  3420,   455,
     456,  3423,    45,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,  3260,   208,  3262,  3263,  3264,  3265,  3441,
    3267,  3268,  7214,  3270,  7216,  3447,   188,    93,  3275,  3276,
     208,  3278,  3279,    93,    93,  1126,  1126,  5421,  5422,   850,
      46,    93,   134,  1126,    94,    93,    93,  1126,  3295,  3296,
      94,  3298,  3299,  3300,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    94,    93,  5230,  5231,    93,   106,  5234,
    5235,  3318,   134,  3320,  1126,  3322,  1126,  3324,   195,  3326,
    3327,  3328,  7274,  5828,    93,   106,  1126,    94,    72,    94,
    3337,    93,   105,  1126,   140,  3342,    93,    93,   140,    94,
      94,  3348,    94,    96,    94,    94,    94,  1127,  1127,  3531,
     140,    94,    94,    94,  3536,   469,   470,   471,   472,   473,
     474,   475,   476,  3370,  3371,  3372,  3373,  3374,    94,   145,
     142,  7323,     3,     4,     5,    98,  1127,     8,  5522,  1127,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,  6512,  1127,    94,  1127,  1127,
      99,    99,    98,  3585,    97,   140,    98,  5912,   140,  5610,
      94,    94,    94,   140,    94,    94,  7368,    94,  7370,  3426,
    3427,  3428,    94,  3430,  1133,  3473,  3433,  3434,  3476,  3477,
    3437,  3438,  3439,  3440,  3482,  4855,  4856,  3444,  3445,  3446,
      94,  3448,  3449,  3450,  3451,  3452,  3453,  3454,  3455,  3456,
    3457,    94,    94,  3460,    94,  3462,  5956,  3464,  3465,  3466,
    3467,  3468,  3469,  3470,  3471,  3472,  3473,   140,    94,  3476,
    3477,     3,     4,     5,    94,  3482,     8,   140,    94,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    94,   140,   140,  4917,     1,  3506,
      94,  3508,    94,   140,   714,   716,    46,    17,  3515,  3516,
    4835,  3518,    52,  1133,    62,  2295,  2950,  1203,  3525,  3526,
      60,    61,    62,    63,    64,    65,    66,    67,  4844,  3960,
    3960,  3660,  3539,  3540,  4269,  3542,  3543,  3544,  3545,  3546,
    4260,  4542,  3549,  3550,  3551,  3552,  3553,  3554,  3555,  3556,
    3557,  4542,  3559,  3560,    65,  2307,  2272,  3680,  4109,  3566,
    2909,  3568,  3680,   767,  3571,  3572,  3573,  3574,  3575,  3576,
    3577,  3578,  3579,  6873,  3581,  3582,  3583,  3584,   844,  3586,
    3587,  3588,  3589,  3590,  3591,  3592,  3593,  3594,   840,   439,
    3597,  3598,  3599,   446,  6506,  7511,  7573,  6781,  5777,  6604,
    7045,  6877,  5891,  6294,  7651,  3612,  3613,  3614,  3615,  3616,
    4241,  5755,  4468,  6524,  4468,  4468,  4835,  5761,  5762,  4468,
    4470,  4468,  5302,  5303,  5304,  4470,  4470,  5806,  4470,  4470,
    4470,  4470,  5811,  4470,  1205,  4470,  4470,  4470,  4470,  5818,
    3647,  4470,  4470,  4468,  4468,  3652,  5825,  3135,  3655,  4468,
    4468,  4468,  5831,  4468,  4468,  1226,  4468,  4468,  3671,  3672,
      18,    19,    20,    21,    22,    23,    24,    25,  2278,  4108,
    2913,  2782,  5873,  2151,  5136,  1273,  2232,  2232,  3685,  3686,
    2232,   391,  3689,  5827,  6374,   732,  3693,   732,  4456,  6009,
    3210,  7334,  3699,  7338,  2171,  4730,  7340,  7339,  6920,  2803,
    2873,  7336,  7335,  3346,  3978,  6987,  6861,    95,  6258,    97,
      98,    99,  6217,  3196,  5100,  7266,  7314,  6680,  6478,  3726,
    3192,  4111,  4113,  6228,  2286,   113,  4723,   115,  5741,   117,
      46,  2166,   120,  2236,   122,  6240,   124,    -1,   126,    -1,
      56,    57,  3749,  3750,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    -1,  3761,  3762,    72,    73,    74,    -1,
    2236,    -1,  6256,    -1,    -1,    -1,  5967,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2338,    -1,  5922,  3786,
      96,  2343,    -1,  3186,    -1,  3188,    -1,    -1,    -1,    -1,
    5115,    -1,    -1,    -1,    -1,    -1,  3199,    -1,    -1,    -1,
    3203,    -1,  6256,    -1,  6069,    -1,  5979,    -1,    -1,  3212,
      -1,  3214,    -1,  3216,    -1,    -1,    -1,    -1,    -1,  3826,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6002,
    3837,    -1,    -1,    -1,    -1,    -1,    -1,  6605,    -1,  3242,
    6608,  3848,  3849,  6611,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3255,    -1,    -1,  3868,    -1,    -1,  3261,    -1,
      -1,    -1,    -1,  3266,  4277,    -1,    -1,    -1,    -1,  3272,
      -1,    -1,    -1,    -1,  3277,    -1,    -1,    -1,    -1,    -1,
    3887,  6025,  3285,  6027,  1129,    -1,    -1,    -1,  1133,    -1,
      -1,    -1,    -1,  4306,  3297,  4308,  5115,    -1,    -1,    -1,
      -1,    -1,    -1,  4316,  4317,    -1,    -1,    -1,    -1,  1125,
      -1,  3918,  1129,    -1,    -1,    -1,  1133,    -1,    -1,    -1,
      -1,    -1,  3325,    -1,     1,  1496,  1497,  1498,    -1,    -1,
      -1,    -1,    -1,    -1,  1129,    -1,  3339,    -1,  1133,  3946,
      -1,    -1,  3949,    -1,  1515,    -1,    -1,    -1,  3955,  3956,
      -1,    -1,    -1,    -1,  3357,    -1,  5175,    -1,  5177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,  6472,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,  3670,    -1,    -1,    -1,    -1,    -1,  3676,    -1,    -1,
      -1,  3680,    -1,    -1,    -1,  3684,  5426,    -1,  1973,    -1,
      -1,  5431,  5432,    -1,    -1,  4345,    -1,  3420,    -1,    -1,
    3423,    -1,  1987,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6210,    -1,    -1,  6213,    -1,    -1,    -1,  3441,    -1,
      -1,  6220,   119,  6548,  3447,    -1,    -1,  6226,    -1,    -1,
      -1,  6230,   129,   130,    -1,    -1,    -1,  6236,    -1,    -1,
      -1,  4109,    -1,  6242,  6569,    -1,    -1,   144,    -1,    -1,
      -1,  6215,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6227,    -1,    -1,    -1,  5356,  5357,    -1,
      -1,    -1,    -1,    -1,  6238,    -1,  5516,    -1,    -1,    -1,
      -1,    -1,  4109,    -1,     3,     4,     5,  2072,    -1,     8,
    4117,  4118,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,  3531,    -1,
      -1,    -1,    95,  3536,    97,    98,    99,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    -1,    -1,    -1,  6291,    -1,  1127,
     113,  1129,   115,    -1,   117,  3558,    -1,   120,  6423,   122,
    3563,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3580,    -1,    -1,
     143,    -1,  3585,    -1,    -1,    -1,    46,    -1,    -1,    -1,
      -1,  6696,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    -1,  4216,
      -1,    -1,    -1,    -1,  7157,    -1,  2181,  2182,    -1,    -1,
      -1,    -1,    -1,  2188,  2189,    -1,  2191,    -1,    -1,  2194,
    2195,  2196,  4239,  2198,    -1,   676,  4249,  4250,  2203,    -1,
    2205,  2206,    -1,  2208,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,
      -1,  4268,    -1,    -1,    -1,    -1,    -1,    -1,   128,    -1,
    4277,   131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   144,  5610,    -1,  4294,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7241,  4306,
      -1,  4308,    -1,    -1,    -1,  6570,  6845,    -1,    -1,  4316,
    4317,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     761,    -1,    -1,    -1,    -1,   766,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5753,    -1,    -1,  5756,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6256,    -1,
    7467,  7468,  7469,    -1,    -1,  7123,  6500,  7125,  7553,    -1,
    7555,    -1,    -1,    -1,    -1,  7133,    -1,    -1,  7136,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4558,    -1,    -1,    -1,
      -1,    -1,  2944,    -1,    -1,    -1,    -1,  2949,    -1,    -1,
    2952,  5610,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2966,  2967,    -1,    -1,    -1,    -1,
      -1,    -1,  2974,  2975,  2976,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4606,    -1,    -1,  4840,    -1,  4980,
    4981,    -1,    -1,  4615,  3837,    -1,    -1,    -1,  4620,    -1,
      -1,    -1,    -1,    -1,    -1,  3848,  3849,  4860,    -1,    -1,
      -1,  4864,  7220,    -1,    -1,    -1,    -1,  3860,    -1,  3862,
    3863,    -1,    -1,    -1,  4471,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  7593,  7594,  7595,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6981,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1127,  5917,  1129,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5927,  4515,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5937,    -1,  6698,
      -1,     4,    -1,    -1,    -1,     8,    -1,  6981,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,  6810,    -1,    -1,  5873,    -1,
      -1,  6695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,  6826,    -1,  6742,    -1,    -1,    -1,    -1,  6747,  6834,
    4577,  4578,     4,  4252,  4253,    -1,     8,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,  5008,  5009,  1129,    -1,    -1,
    6744,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,  6029,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    -1,    -1,    -1,
      -1,  5044,  5045,  6898,    -1,    -1,    -1,    -1,  4645,  4646,
    4647,  4648,    -1,    -1,  4651,  4652,    -1,  6912,    -1,    -1,
    2221,    -1,    -1,    -1,  5873,    -1,  5069,  5070,    -1,    -1,
      -1,  4668,  4669,    -1,  4671,    -1,  4673,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   128,    -1,    -1,
     131,    -1,    -1,    -1,    -1,  4098,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   144,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4720,  7482,  7483,  4723,    -1,    -1,    -1,
    5133,    -1,  4729,    -1,  5275,    -1,    -1,  5404,  2299,    -1,
      -1,    -1,    -1,  2304,    -1,    -1,    -1,    -1,    -1,  7004,
      -1,    -1,    -1,    -1,    -1,  5296,  5297,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,  4762,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,  4779,  4780,    -1,    -1,    -1,    -1,  2349,    -1,
    4787,  2352,    -1,    -1,    -1,    -1,    -1,  6988,  4467,  4468,
      -1,  4470,    -1,    -1,    -1,    -1,    -1,    93,    94,    95,
      -1,    97,    98,    99,    -1,    -1,    -1,  7575,    -1,    -1,
    1126,    -1,    -1,    -1,    -1,   111,    -1,   113,   114,   115,
      -1,   117,    -1,    -1,   120,    -1,   122,    -1,   124,    -1,
     126,    -1,    -1,  4840,    -1,    -1,    -1,    -1,   134,    -1,
      -1,    -1,    -1,   684,    -1,   686,    -1,   143,    -1,  7114,
      -1,    -1,  6272,  4860,    -1,    -1,    -1,  4864,    -1,    -1,
      -1,  4868,    -1,  4542,    -1,  7633,  7634,     1,    -1,   165,
      -1,  4878,    -1,  4880,     8,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,  7656,    -1,
      -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,  4919,    -1,  4921,    -1,
      -1,    -1,    46,    -1,    -1,    -1,  4923,    -1,  4925,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4933,   768,    -1,    -1,
      -1,    -1,  4980,  4981,    -1,  7703,  7704,  7705,    -1,    -1,
      -1,    -1,    -1,    -1,  3506,    -1,  3508,    -1,    -1,    -1,
      -1,    -1,  7720,    -1,  7722,    -1,    -1,  7725,   799,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,
     266,    -1,    -1,  4980,  4981,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,  4996,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5004,  5005,    -1,
      -1,  5008,  5009,    -1,    -1,    -1,    -1,    -1,    -1,   850,
      -1,    46,    -1,    -1,    -1,    -1,  7160,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    -1,    -1,    -1,  5044,  5045,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5066,
      -1,    -1,  5069,  5070,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6981,    -1,    -1,  6496,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,  3647,    -1,    -1,  4491,    -1,
    3652,    -1,    -1,  3655,   129,   130,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5111,    -1,    -1,    -1,    -1,   144,
      -1,    -1,  4515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,  5133,  5457,    -1,    -1,
    6550,    -1,    -1,   267,  5141,    -1,  5143,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4558,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4843,  4844,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,  4592,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4606,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4615,    -1,    93,    94,    95,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,  5275,    -1,  1128,
      -1,  5279,   111,    -1,   113,    -1,   115,    -1,   117,    -1,
     119,   120,    -1,   122,    -1,   124,   125,   126,  5296,  5297,
      -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   143,    -1,  1126,    -1,  5275,    -1,
      -1,    -1,  5279,    -1,    -1,  7419,  7420,  7421,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   165,    -1,    -1,  5296,
    5297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2869,    -1,
      -1,  5308,  5309,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2924,    -1,    -1,  3918,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1205,    -1,    -1,    -1,    -1,  4772,
      -1,    -1,    -1,    -1,  4777,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2953,    -1,  3946,  1226,    -1,  2958,    -1,    -1,
      -1,     4,    -1,    -1,    -1,     8,    -1,  5404,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,  7557,  7558,  7559,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5440,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5442,  5443,    -1,  5445,  5446,
    5447,  5448,  5449,  5450,  5451,  5452,  5453,  5454,  5455,  5456,
      -1,  5458,  5459,  5460,  5461,  5462,  5463,  5464,  5465,  5466,
    5467,  5468,  5469,  5470,  5471,  5472,  5473,  5474,  5475,  5476,
    5477,    -1,    -1,  5480,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   431,   432,
     433,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5512,    -1,    -1,  5515,    -1,
      -1,    -1,    -1,  5520,  5521,  5528,    -1,  5530,  5525,    -1,
      -1,    -1,    -1,    -1,     4,  5532,    -1,  5534,     8,   472,
      -1,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4117,  4118,   500,    -1,  6778,
      -1,   504,    -1,    -1,    -1,    -1,    -1,    -1,     4,    -1,
      -1,    -1,     8,    -1,     1,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6017,  6018,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5623,    -1,  5625,    46,
    5627,  5628,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    -1,    -1,    -1,  7064,    -1,  1129,  5654,    -1,    -1,
    6063,    -1,  6065,    -1,  4216,  1496,    -1,    -1,    -1,    -1,
      -1,    -1,  5669,    -1,    -1,    -1,    93,    94,    95,    -1,
      97,    98,    99,    -1,  1515,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,  1126,   113,    -1,   115,    -1,
     117,   118,    -1,   120,    -1,   122,  1128,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   143,  6918,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5732,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   165,  5746,
    5747,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5760,  5767,    -1,  5769,    -1,    -1,  5772,
    6173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     4,
    5777,    -1,  5846,     8,    -1,    -1,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     4,  5806,
      -1,    -1,     8,    -1,  5811,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,  5828,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1126,    -1,    -1,    -1,    -1,    -1,   779,   780,    -1,   266,
     783,    -1,    -1,   786,   787,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     4,    -1,    -1,    -1,     8,    -1,  7060,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    -1,   835,   836,    -1,   838,    -1,    -1,  5905,    -1,
      -1,   844,    -1,    -1,  5911,  5912,    -1,  5914,    -1,  5916,
    6606,  5918,    -1,    -1,    -1,    -1,  6612,    -1,    -1,  5926,
      -1,    -1,    -1,    -1,    -1,  5932,    -1,  5934,    -1,  5936,
      -1,  5938,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  7161,    -1,  7163,    -1,    -1,    -1,  5955,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  7376,  7377,  7378,    -1,
      -1,    -1,    -1,    -1,  5971,     3,     4,     5,    -1,    -1,
       8,    -1,    -1,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,
      -1,  1135,    -1,  6010,    -1,    -1,    -1,    -1,  6015,    -1,
    6017,  6018,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6037,    -1,    -1,    -1,  6035,    -1,
    6043,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6045,    -1,
    6047,    -1,  6049,  6050,    -1,  6052,  6053,  6054,    -1,  6056,
    6057,    -1,    -1,  6060,    -1,    -1,  6063,    -1,  6065,    -1,
      -1,    -1,  6069,    -1,  6071,  6072,  6073,  6074,    -1,     8,
    5749,  6078,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    -1,  7508,  7509,
    7510,  1126,    -1,    -1,    -1,    -1,  5775,  1040,    -1,  3670,
      -1,    -1,    -1,  6110,  6111,  3676,  6113,    -1,  6115,  3680,
    6117,    -1,    46,  3684,    -1,  6122,    -1,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    -1,    -1,    -1,  5816,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5830,    -1,    -1,    -1,    -1,  6163,    -1,  4720,  6581,
      -1,  4723,    -1,    -1,    -1,    -1,  6173,  4729,  6175,    -1,
      -1,  6178,  6179,  6180,  6181,  6182,  6183,  6184,  6185,    -1,
    6187,  6188,  6189,  6190,  6191,  6192,  6193,    -1,    -1,    -1,
    6197,  6198,  6199,  6200,    -1,    54,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    -1,    -1,
    6217,    70,    71,  6220,  6221,    -1,    -1,    -1,    -1,    -1,
      -1,  6228,    -1,    -1,  6231,  6921,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6240,   168,  6242,  6243,  6933,    -1,    -1,
      -1,    -1,    -1,  6250,    -1,  6941,    -1,  1126,    -1,  6256,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6267,  6268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1212,
      -1,    -1,    -1,    -1,  1217,    -1,    -1,    -1,    -1,  3850,
      -1,  1224,  1225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6365,    -1,    -1,  3865,    -1,  6309,    -1,    -1,    -1,
      -1,    -1,    -1,  6310,    -1,    -1,    -1,    -1,    -1,  1252,
      -1,    -1,    -1,    -1,  6321,  1258,    -1,    -1,  6325,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6337,    -1,  6339,    -1,    -1,  2776,    -1,    -1,    -1,  6346,
    6347,    -1,    -1,  6350,  6766,    -1,  6353,  6354,    -1,    -1,
      -1,  6030,    -1,    -1,    -1,  6362,    -1,  6364,    -1,  6772,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6380,    -1,    -1,    -1,    46,    -1,    -1,
    2221,  6388,  6061,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,  6406,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6420,  6421,    -1,  6423,    -1,  6425,  6426,
      -1,  6428,    -1,    -1,  6431,    -1,    -1,    -1,  7124,    -1,
    7126,    -1,    -1,  6440,    -1,    -1,    -1,  6444,    -1,  6446,
    6447,  6448,    -1,    -1,    -1,    -1,  6125,  6454,    -1,  6456,
      -1,    -1,  6459,  6460,    -1,    -1,    -1,    -1,  2299,    -1,
      -1,  6468,    -1,    -1,    -1,    -1,  6473,    -1,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,  6494,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6507,    -1,    -1,    -1,  6511,    -1,  6513,    -1,  2349,    -1,
    6517,  2352,  6519,    -1,    -1,  7211,  1129,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6531,    -1,  6533,    -1,    -1,  6536,
      -1,    -1,  1475,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1483,  6548,  6549,    -1,    -1,  6552,  2987,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6562,    -1,    -1,  6565,   228,
      -1,    -1,  6569,  6570,    -1,    -1,     8,    -1,  6575,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,  7280,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6624,  6625,  6626,
      -1,    -1,    -1,    -1,  6631,  6632,  7322,  6634,  7324,  6636,
      -1,    -1,    -1,  6640,    -1,  6642,  6643,    -1,    -1,    -1,
      -1,    -1,  6649,    -1,  6651,    -1,    -1,    -1,    -1,  1129,
      -1,  6658,  6659,    -1,  6661,    -1,  6663,    -1,  6665,  6666,
    6667,    -1,    -1,    -1,  4235,    -1,  6345,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4252,  4253,    -1,    -1,    -1,    -1,  6694,    -1,  6696,
      -1,  6765,  6699,  1129,    -1,    -1,    -1,  6704,  6705,  1126,
      -1,    -1,    -1,    -1,    -1,    -1,  6713,  6714,    -1,  6716,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6727,    -1,  6729,    -1,    -1,  6732,    -1,  6734,    -1,    -1,
    6737,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6748,    -1,    -1,    -1,    -1,  5308,  5309,    -1,    -1,
      -1,    -1,    -1,    -1,  6761,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6772,    -1,  3208,  6775,    -1,
      -1,    -1,    -1,    -1,    -1,  6782,    -1,    -1,  6785,    -1,
    6787,    -1,  6789,  6790,  6791,    -1,  6793,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6806,
      -1,  6808,    -1,  6810,    -1,  6812,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6820,    -1,    -1,  6823,    -1,  6825,  6826,
      -1,    -1,    -1,    -1,    -1,  6832,    -1,  6834,    -1,    -1,
    2568,  6838,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6520,    -1,    -1,    -1,  6919,    -1,    -1,  6855,    -1,
      -1,    -1,    -1,  6256,    -1,    -1,    -1,  6864,    -1,    -1,
      -1,    -1,    -1,    -1,  6871,    -1,    -1,    -1,  6875,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6883,    -1,    -1,    -1,
      -1,    -1,  6889,    -1,  6891,    -1,  6893,  6894,    -1,    -1,
    6897,  6898,  6899,    -1,  1129,    -1,  4467,  4468,  6905,  4470,
    6907,    -1,    -1,    -1,  6583,  6912,    -1,    -1,  6915,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6596,    -1,  6926,
      -1,    -1,  1128,    -1,    -1,    -1,    -1,    -1,  6935,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6943,    -1,  6945,  6946,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6954,    -1,    -1,
    6957,    -1,  6959,  4524,    -1,  6962,    -1,    -1,    -1,    -1,
    6967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4542,    -1,    -1,  6981,    -1,    -1,  1128,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  7059,    -1,    -1,    -1,    -1,
    6997,  6998,    -1,    -1,    -1,    -1,    -1,  7004,    -1,    -1,
      -1,    -1,    -1,  7010,    -1,    -1,    -1,  7014,    -1,    -1,
    7017,    -1,    -1,    -1,   383,    -1,  7023,    -1,  7025,  7026,
      -1,    -1,  7029,  7030,  7031,    -1,    -1,    -1,  2869,  7036,
    7037,    -1,    -1,    -1,  3475,    -1,    -1,  7044,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  7058,    -1,    -1,    -1,    -1,
      -1,    -1,  7465,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6746,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  7082,    -1,    -1,  2816,  2817,
    7087,  2819,    -1,  2924,  7158,    -1,    -1,  7094,  1126,  2827,
      -1,  7098,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2843,  7113,  7114,  7115,    -1,
      -1,  7118,  2953,  7120,    -1,  7122,    -1,  2958,    -1,    -1,
    7127,    -1,  7129,    -1,  7131,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  7143,  7144,    -1,    -1,
      -1,  7148,  7149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    7157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  7169,    -1,    -1,  7172,    -1,    -1,    -1,    -1,
    5732,  7178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  7189,    -1,    -1,  5747,    -1,    -1,    -1,    -1,
      -1,  1125,    -1,    -1,    -1,    -1,    -1,  7204,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  7213,  2150,  7215,  2152,
    2153,    -1,    -1,    -1,    -1,  5777,  7223,    -1,  7225,    -1,
      -1,    -1,    -1,  2166,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  7241,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5806,    -1,    -1,    -1,    -1,  5811,
      -1,    -1,    -1,  7260,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4834,    -1,    -1,  1125,    15,    16,    17,
      -1,  1130,  4843,  4844,    -1,  7282,    -1,    -1,  7285,    -1,
    7287,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    7307,    -1,    -1,  7310,  7311,    -1,    -1,    -1,    -1,    -1,
      -1,  7318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7326,
      -1,    -1,  7329,    -1,     1,    -1,    -1,    -1,    -1,  7342,
      -1,    -1,  7345,    -1,    -1,    -1,  7343,  7344,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4916,  3787,  7354,    -1,    -1,
    7357,    -1,   721,    -1,    -1,    -1,    -1,    -1,    -1,  7366,
    7367,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    -1,    -1,     3,     4,     5,    -1,    -1,     8,    -1,
    7407,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,  4987,     4,    -1,    -1,
      -1,     8,    -1,  7430,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,  7446,
      -1,    -1,  7449,    -1,    -1,    -1,    -1,    -1,  6010,    -1,
    3891,  7458,  1131,    -1,  1133,    -1,    -1,    -1,  7465,    -1,
      -1,    -1,  3903,    -1,    -1,    -1,  3907,    -1,    -1,    -1,
    3911,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,  6047,    -1,    -1,    -1,    -1,
    6052,  7498,   169,  7500,  6056,  7502,  7503,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6071,
      -1,  6073,    -1,    -1,    -1,    -1,  6078,    -1,    -1,    -1,
      -1,    -1,  7529,    -1,  7531,    -1,    -1,    -1,  7535,    -1,
      -1,    -1,  7539,    -1,    -1,  7542,    -1,    -1,    -1,    -1,
      -1,    -1,  7549,    -1,    -1,    -1,    -1,    -1,  7227,  7556,
      -1,  6113,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7570,    -1,    -1,    -1,  2510,    -1,  2512,
      -1,  2514,    -1,    -1,    -1,  7582,  7583,    -1,  6981,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,  7614,    -1,    -1,
      -1,    -1,  7291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  7629,  7630,  7631,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  7642,    -1,    -1,    -1,    -1,
    7647,  7648,  7649,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  7331,  7332,  7333,    -1,    -1,    -1,  7665,    -1,
    7667,    -1,    -1,    -1,  4105,    -1,    -1,    -1,    -1,    -1,
      -1,  7678,    -1,    -1,    -1,    -1,    -1,    -1,  7685,  7686,
    7687,    -1,    -1,    -1,  7691,    -1,    -1,    -1,    -1,    -1,
    2633,    -1,    -1,    -1,    -1,  4136,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7382,    -1,    -1,  6268,  7714,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   392,    -1,  7724,    -1,  7726,
      -1,  7728,  4163,    -1,    -1,    -1,  4167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3473,  3474,    -1,    -1,  7418,
      -1,    -1,    -1,    -1,   421,    -1,    -1,   424,   425,   426,
      -1,    -1,    -1,    -1,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
      -1,    -1,    -1,    -1,    -1,    -1,  1165,  1166,  1167,  1168,
    1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,
      -1,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1191,  1192,  1193,  1194,    -1,  1196,  1197,  1198,
      -1,    -1,  1201,  1202,    -1,  3676,     3,     4,     5,  3680,
      -1,     8,    -1,  3684,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6428,    -1,    -1,  6431,
      -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,  6440,    -1,
      54,    55,    -1,    57,    -1,    -1,  6448,    -1,    62,    63,
      -1,    65,  6454,    -1,    68,    -1,    70,    71,  6460,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6468,    -1,    -1,    -1,
      -1,    -1,    -1,  7592,    -1,    -1,    46,    -1,    -1,    -1,
      -1,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    -1,    -1,
      -1,    -1,  2885,    -1,    -1,    -1,  2889,  2890,  2891,  2892,
    2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,  2902,
    2903,  2904,  2905,    93,    94,    95,    -1,    97,    98,    99,
      -1,   138,   139,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,    -1,   113,    -1,   115,     1,   117,    -1,   119,
     120,   121,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,
    6562,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3850,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3865,    -1,  4467,    -1,    -1,  4470,
      -1,    46,    -1,    -1,    -1,   165,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,  5646,    -1,    -1,    -1,  5650,
      95,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5665,    -1,    -1,    -1,   113,    97,
     115,    -1,   117,  4544,   119,   120,   121,   122,  4549,   124,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,
     430,  4562,   120,  4564,    -1,    -1,  4567,    -1,   143,   144,
    4571,    -1,    -1,    -1,    -1,    -1,    -1,  3875,    -1,    -1,
      -1,    -1,    -1,   453,    -1,    -1,    -1,   457,    -1,    -1,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
      -1,    -1,    -1,   473,    -1,    -1,  3904,   477,    -1,    -1,
    3113,    -1,  3115,    -1,   140,  3118,   174,    -1,  5749,   145,
      -1,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,  4640,
      -1,    -1,    -1,    -1,  5775,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,    -1,    -1,  5816,  5817,    -1,    -1,    -1,
      -1,  4692,    -1,    -1,    -1,    -1,    -1,    -1,  5829,  5830,
    1125,    -1,    -1,    -1,    -1,    -1,  5837,    -1,    -1,    -1,
    5841,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,    -1,    -1,    -1,  4739,  4740,
      -1,    -1,    -1,    -1,  4745,    -1,    -1,    -1,    -1,  6871,
      -1,    -1,    -1,    -1,  4052,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5893,    -1,    -1,    -1,    -1,    -1,  4769,    -1,
      -1,    -1,    -1,    -1,  4775,    -1,    -1,  6899,    -1,    -1,
      -1,    -1,    -1,  6905,  3287,    -1,    -1,    -1,    -1,    -1,
      12,    -1,    54,    55,  3297,    -1,    -1,    19,    -1,    21,
      62,    63,    -1,  4101,    -1,    -1,    -1,    -1,    70,    71,
      32,  4109,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    -1,    47,    48,    49,    50,    51,
      -1,    53,    -1,    -1,  4235,    -1,    -1,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,  4144,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4153,    -1,  4155,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4168,    46,  4170,    -1,  4172,  4173,    -1,    52,    -1,    -1,
    6011,    -1,    -1,  4884,    59,    60,   108,    -1,   110,  1126,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,  6030,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4910,
    6041,  4912,    -1,    -1,   784,    -1,  4917,    -1,    -1,    -1,
      -1,    -1,    97,    -1,    -1,   795,   796,   797,   798,    -1,
    6061,   801,   802,   803,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   120,    -1,   817,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   834,    -1,    -1,    -1,    -1,    -1,
    3473,   841,    -1,  3476,  3477,    -1,    -1,   847,   848,  3482,
      -1,    -1,   852,   853,    12,    -1,    -1,    -1,    -1,    -1,
    6121,    19,  6123,    21,  6125,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    32,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    -1,    53,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    61,    -1,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,    -1,  4467,  4468,    -1,  4470,
      -1,    -1,    -1,    -1,    -1,    -1,  6207,  6208,   300,   301,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6218,    -1,    -1,
     312,   313,    -1,    -1,  6225,    -1,    -1,    -1,  6229,    -1,
      -1,    -1,   324,   325,  6235,    -1,    -1,    -1,    -1,    -1,
    6241,    -1,    -1,    -1,   336,   337,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4524,    -1,   347,   348,   349,   350,   351,
     352,   353,   354,   355,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,    46,  4442,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    -1,  6297,    -1,  6299,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6311,    -1,    -1,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,    -1,    -1,    -1,
      -1,    -1,   140,    -1,  6345,    -1,    -1,   145,  6349,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4543,    -1,  4545,    -1,    -1,
      -1,    -1,  4550,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4563,    -1,    -1,    -1,    -1,
      -1,    -1,   300,   301,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   312,   313,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   324,   325,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,   337,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,
     348,   349,   350,   351,   352,   353,   354,   355,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,    -1,    -1,  1209,
      -1,    -1,    -1,  1213,    -1,  1215,  1216,    -1,    -1,  1219,
    1220,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1228,    -1,
      -1,    -1,    -1,    -1,    -1,  1235,  1236,    -1,  1238,  1239,
    1240,  1241,    -1,  1243,  1244,    -1,  1246,  1247,  1248,  1249,
    1250,    -1,    -1,  1253,  1254,  1255,    -1,  6518,    -1,  6520,
      -1,  1125,  1262,  1263,    -1,    -1,  1266,   140,   141,    -1,
      -1,  6532,    -1,    -1,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,    -1,    -1,  6556,  6557,    -1,  5429,    -1,
      -1,    -1,    -1,  4834,    -1,    -1,  1126,    -1,    -1,    -1,
    4738,    -1,    -1,    -1,    -1,    -1,    -1,  3950,    -1,    -1,
      -1,    -1,  6583,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6596,    -1,    -1,    -1,    -1,
    4768,    -1,  4770,    -1,    -1,    -1,    -1,    -1,    -1,   140,
      -1,    -1,    -1,    -1,    -1,  6616,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,    -1,  6637,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4916,    -1,    -1,    -1,    -1,
      -1,    -1,  6653,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6664,    -1,    -1,     7,     8,     9,    10,
      11,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,
      -1,  1126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     140,    -1,    -1,    -1,    -1,    -1,  6697,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,  4987,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2523,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4109,    -1,    -1,    80,
    6741,    -1,    -1,    -1,  6745,  6746,    -1,    -1,    -1,    -1,
      -1,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5633,    -1,    -1,  5636,  5637,  5638,  5639,  5640,
      -1,  5642,  5643,    -1,    -1,  6776,    -1,    -1,   119,   120,
     121,   122,   123,   124,   125,  6786,   127,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,    -1,   138,   139,    -1,
     141,   142,   143,   144,   145,   146,   147,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5690,
      -1,    -1,    -1,   164,    -1,   166,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,    -1,  5735,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,    -1,    -1,    -1,    -1,    -1,   318,  5146,    -1,
     321,    -1,  5150,    -1,    -1,    -1,  5154,  5155,  5156,    -1,
      -1,    -1,  5160,  1125,  6995,    46,    -1,    -1,  1130,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    -1,   359,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,
    1132,    -1,  1134,  1135,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5225,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   408,    -1,    -1,
      46,    -1,  7073,    -1,    -1,  7076,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,   434,   435,    -1,    -1,   438,   439,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,    -1,    -1,   455,   456,    -1,   458,   459,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2926,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2941,  2942,    -1,    -1,    -1,  2946,  2947,    -1,
      -1,  5319,  5320,   140,    -1,    -1,    -1,  5325,    -1,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,    -1,
    5348,    -1,    -1,    -1,    -1,  5353,    -1,    -1,  5356,  5357,
     140,    -1,    -1,    -1,   535,    -1,    -1,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,    -1,    -1,    -1,  4592,
      -1,    -1,    -1,  7224,    -1,  7226,  7227,  1125,    -1,    -1,
      -1,    -1,  1130,    -1,  1132,    -1,  1134,  1135,    -1,    -1,
      -1,  7242,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  7253,    -1,    -1,  7256,  7257,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,
      -1,    62,    63,    64,    -1,    -1,    -1,    -1,    -1,    70,
      71,    72,  7283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    7291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7304,    -1,    -1,    -1,  7308,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7320,
    7321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    7331,  7332,  7333,    -1,    -1,  6206,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,  6216,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,  6234,  7365,    -1,    -1,    -1,  6239,    -1,
      -1,    -1,    -1,    -1,    -1,  5646,    -1,    -1,    -1,  5650,
      -1,  7382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5665,    -1,    -1,    -1,    -1,  7400,
      -1,  6272,  7403,    -1,    -1,    -1,  3205,    -1,    -1,    -1,
    7411,    -1,    46,    -1,    -1,    -1,    -1,  7418,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    -1,    -1,    -1,    -1,   779,    -1,
     781,   782,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  7457,    -1,  7459,    -1,
    7461,  7462,    -1,  6334,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,  5749,    -1,
      -1,    -1,    -1,    -1,  7485,    -1,    -1,    -1,  7489,    -1,
      -1,  7492,    -1,    -1,    -1,    -1,    -1,   838,    -1,    -1,
    7501,    -1,    -1,   844,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6383,    -1,    -1,    -1,    46,    -1,    -1,    -1,
      -1,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    -1,    -1,
      -1,    -1,    -1,  7544,  7545,  5816,  5817,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5829,    -1,
      -1,    -1,    -1,    93,    94,    95,  5837,    97,    98,    99,
    5841,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    7581,   111,    -1,   113,    -1,   115,    -1,   117,    -1,   119,
     120,  7592,   122,   123,   124,    -1,   126,    -1,    -1,    -1,
      -1,    -1,    -1,   133,   134,    -1,    -1,  4980,  4981,    -1,
      -1,    -1,    -1,   143,    -1,    -1,    -1,  7618,  2358,  2359,
    2360,    -1,  5893,    -1,  2364,  2365,    -1,    -1,    -1,    -1,
      -1,    -1,  6503,  2373,    -1,   165,    -1,    -1,    -1,    -1,
    7641,    -1,  7643,    -1,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2393,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    32,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
    6011,    -1,    -1,    54,    55,    56,    57,    -1,    59,    -1,
      -1,    62,    63,    64,    65,    -1,    -1,    -1,    -1,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6041,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   684,    -1,   686,    -1,    -1,    -1,    -1,    -1,
    6061,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
      -1,  5979,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6002,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6121,    -1,  6123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   768,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1224,  1225,    -1,  3685,  3686,    -1,    -1,
    3689,    -1,    -1,    -1,  3693,    -1,    -1,   799,    -1,    -1,
    3699,    -1,  5275,    -1,    -1,    -1,  5279,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1258,    -1,    -1,
      -1,    -1,    -1,  5296,  5297,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6207,  6208,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6218,   850,    -1,
      -1,    -1,    -1,    -1,  6225,  3139,    -1,    -1,  6229,    -1,
     428,   429,    -1,    -1,  6235,   433,    -1,    -1,    -1,    -1,
    6241,    -1,   440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   454,    -1,  2636,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   471,    -1,    -1,    -1,   475,   476,    -1,
     478,   479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3206,    -1,    -1,    -1,  6297,    -1,  6299,    -1,
      -1,    -1,    32,    -1,    34,    -1,    -1,    -1,    -1,    -1,
    6311,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,
      -1,    -1,  6923,    -1,    54,    55,    56,    57,    -1,    59,
      -1,    -1,    62,    63,    64,    65,    -1,    -1,    -1,    -1,
      70,    71,    -1,    -1,  6345,    -1,    -1,    -1,  6349,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2735,    -1,    -1,
      -1,    -1,    -1,    -1,  2742,  2743,    -1,    -1,    -1,    -1,
      -1,    -1,  2750,  2751,  2752,    -1,    -1,  2755,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2764,  2765,    -1,    -1,
      -1,  2769,    -1,    -1,  2772,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1474,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,  1500,
      -1,    -1,    -1,  1504,  2812,  1506,  1507,  1508,  1509,  1510,
      -1,  1512,  2820,    -1,    -1,  1516,  2824,  1518,    -1,  1520,
    2828,  1522,  1523,    -1,    -1,    -1,  7057,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2848,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2856,    -1,
    2858,  2859,  2860,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,  1574,  1575,    52,    -1,  1578,    -1,    -1,
      -1,    -1,    59,    60,    -1,  1586,    -1,  6518,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6532,    -1,   731,   732,    -1,    -1,    -1,    -1,  1610,
      -1,  1612,    -1,  1614,  1615,  1616,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1624,    -1,  6556,  6557,    -1,  1629,    -1,
      -1,    -1,    -1,    -1,  1635,    -1,    -1,  1638,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   780,    -1,    -1,    -1,    -1,   785,   786,    -1,
     788,   789,    -1,    -1,  1226,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1673,    -1,  1125,  1676,    -1,    -1,   806,   807,
      -1,   809,   810,   811,   812,  6616,   814,   815,    -1,    -1,
     818,   819,    -1,   821,   822,    -1,    -1,   174,    -1,    -1,
    1701,    -1,  1703,    -1,    -1,    -1,  6637,    -1,   836,   837,
      -1,    -1,  1713,    -1,    -1,    -1,  1717,    -1,    -1,    -1,
      -1,  1722,  6653,    -1,  1725,    -1,    -1,  1728,    -1,    -1,
      -1,    -1,    -1,  6664,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,    -1,    -1,    -1,  6697,    -1,    -1,    -1,
    1771,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4239,    -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,  4268,
    6741,    -1,  1813,    -1,  6745,    -1,    -1,    -1,    -1,  1820,
    1821,    -1,    -1,    -1,    -1,    -1,  1827,  1828,  1829,  1830,
    1831,  1832,  1833,  1834,  1835,  1836,    -1,    -1,    -1,    -1,
      54,    55,    -1,    -1,    -1,  6776,    -1,    -1,    62,    63,
      -1,    -1,    -1,    -1,    -1,  6786,    70,    71,    46,    -1,
    1861,  1862,    -1,    -1,    52,    53,    54,    55,    -1,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      -1,    -1,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
    1891,  1892,  1893,    -1,    -1,  1896,  1897,  1898,  1899,  1900,
    1901,  1902,  1903,    -1,    -1,    -1,  1907,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1496,    -1,  1126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1950,
    1951,  1952,  1953,  1515,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3809,    -1,    -1,  1969,    -1,
      -1,    -1,  1973,    -1,  1102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1986,  1987,    -1,    -1,    -1,
      -1,    -1,  3836,    -1,    -1,    -1,    -1,    -1,    -1,  2000,
    2001,  2002,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3864,    -1,  3866,    -1,    -1,  3869,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3879,    -1,  3881,    -1,  3883,
      -1,    -1,    -1,    -1,  2045,    -1,    -1,    -1,    -1,  2050,
    2051,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2063,  2064,  6995,    -1,    -1,    -1,  2069,    -1,
      -1,  2072,  2073,    -1,    -1,    -1,    -1,    -1,  1206,  1207,
      -1,    -1,  1210,  1211,  1212,  2086,    -1,    -1,  2089,  1217,
    1218,    -1,    -1,    -1,    -1,    -1,    -1,  2098,  2099,  2100,
    2101,  2102,  2103,    -1,    -1,  2106,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1252,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  7073,    -1,    -1,  7076,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2176,  2177,  2178,  2179,  2180,
    2181,  2182,  2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,
    2191,  2192,  2193,  2194,  2195,  2196,  2197,  2198,  2199,  2200,
    2201,  2202,  2203,  2204,  2205,  2206,  2207,  2208,  2209,  2210,
    2211,  2212,  2213,  2214,  2215,  2216,  2217,  2218,  2219,  2220,
    2221,  2222,    -1,    -1,  2225,  2226,    -1,    -1,    -1,    -1,
      -1,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,    -1,    -1,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7224,    -1,  7226,  7227,   485,   486,   487,
     488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7242,    -1,  3713,  3714,    -1,    -1,    -1,    -1,    -1,
     508,    -1,  7253,    -1,    -1,  7256,  7257,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    -1,
      -1,    -1,  7283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    7291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7304,    93,    94,    95,  7308,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7320,
    7321,    -1,   111,    -1,   113,    -1,   115,    -1,   117,    -1,
     119,   120,    -1,   122,    -1,   124,    -1,   126,   127,  4868,
      -1,    -1,    -1,    -1,   133,   134,    -1,    -1,    -1,  4878,
      -1,  4880,    -1,    -1,   143,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  7365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,
      -1,  7382,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4923,  1125,  4925,    -1,    -1,  7400,
    1130,    -1,  7403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    7411,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,    -1,    -1,    -1,     1,    -1,  7457,    -1,  7459,    -1,
    7461,  7462,    -1,    -1,    -1,    -1,    -1,  4996,    -1,    -1,
    2541,  2542,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  7485,    -1,    -1,    -1,  7489,    -1,
      -1,  7492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
    7501,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7544,  7545,    -1,    93,    94,    95,    -1,
      97,    98,    99,    -1,    -1,  3933,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,    -1,   113,    -1,   115,   116,
     117,    -1,    -1,   120,   121,   122,    -1,   124,    -1,   126,
    7581,    -1,  5111,    -1,    -1,    -1,    -1,   134,    -1,  2221,
      -1,    -1,    -1,  3971,    -1,  3973,   143,    -1,    -1,    -1,
    4514,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,  5143,    -1,  4530,  7618,   165,    -1,
      46,    -1,   169,    -1,    -1,    -1,    52,    53,    54,    55,
      -1,    -1,    -1,    59,    60,    61,    62,    63,    -1,    -1,
    7641,    67,  7643,    -1,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2299,    -1,    -1,
      -1,    -1,    -1,  4051,    -1,    -1,    -1,    -1,    -1,  4057,
    4058,  4059,    -1,    -1,  4062,    -1,  4064,  4065,  4066,  4067,
    4068,  4069,  4070,  4071,  4072,  4073,  4074,    -1,    -1,    -1,
      -1,  4079,  4080,    -1,    -1,    -1,    -1,  4085,  4086,  4087,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2349,    -1,   266,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4134,  4135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4148,  4149,    -1,  4151,  4152,    -1,    -1,    -1,    -1,  4157,
    4158,  4159,  4160,  4161,  4162,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4177,
    4178,  4179,  4180,  4181,    -1,    -1,  4184,  4185,    -1,    -1,
    2881,    -1,    -1,    -1,  4192,  4193,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      46,  1125,    -1,    -1,    -1,   392,    52,    53,    54,    55,
      -1,    -1,    -1,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    -1,    -1,    70,    71,    -1,  1125,    -1,    -1,
      -1,    -1,  1130,    -1,   421,    -1,    -1,   424,   425,   426,
      -1,    -1,    -1,    -1,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5442,    -1,    -1,  5445,  5446,  5447,  5448,
    5449,  5450,  5451,  5452,  5453,  5454,  5455,  5456,    -1,  5458,
    5459,  5460,  5461,  5462,  5463,  5464,  5465,  5466,  5467,  5468,
    5469,  5470,  5471,  5472,  5473,  5474,  5475,  5476,  5477,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    -1,    59,    60,    61,    62,    63,    64,    65,    -1,
      67,    -1,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5512,    -1,    -1,  5515,    -1,    -1,    -1,
      -1,    -1,  5521,    -1,    -1,    -1,  5525,    -1,    -1,    -1,
      -1,    -1,    -1,  5532,    -1,  5534,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    -1,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    -1,    -1,    70,    71,    -1,
      -1,    -1,    -1,    -1,  5623,    -1,  5625,    -1,  5627,  5628,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3185,  3186,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3199,    -1,
      -1,    -1,  3203,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3212,    -1,  3214,    -1,  3216,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,
      -1,    -1,    -1,    59,    60,    61,    62,    63,    -1,    -1,
    2368,    67,  2370,    -1,    70,    71,    -1,    -1,  5092,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2397,
    5114,    -1,    -1,    -1,  2402,  2403,    46,    -1,  5122,    -1,
      -1,  5125,    52,    53,    54,    55,    -1,  5746,    -1,    59,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    -1,    -1,
      70,    71,  2430,    -1,    -1,    -1,    -1,  2869,    -1,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2924,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2958,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    -1,    -1,    -1,    -1,  5905,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5914,    -1,  5916,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5926,    -1,    -1,
      -1,    -1,    -1,  5932,    -1,    -1,    -1,  5936,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5971,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,  5406,    -1,   477,   478,   479,   480,   481,   482,
     483,   484,    -1,    -1,    -1,    -1,  6035,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6045,    -1,    -1,    -1,
    6049,  6050,    -1,    -1,  6053,  6054,    -1,    -1,  6057,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6072,    -1,    -1,    -1,    -1,    -1,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,  1126,
      -1,  6110,  6111,    -1,    -1,    -1,  6115,    -1,  6117,    -1,
      -1,    -1,    -1,  6122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,    -1,
      -1,    -1,    -1,    -1,  6163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6175,    -1,    -1,    -1,
    6179,  6180,  6181,  6182,  6183,  6184,    -1,    -1,  6187,  6188,
    6189,  6190,  6191,  6192,  6193,    -1,    46,    -1,  6197,  6198,
    6199,  6200,    52,    53,    54,    55,    -1,    -1,    -1,    59,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    -1,    -1,
      70,    71,  6221,    -1,    -1,    -1,    -1,    -1,    -1,  1125,
      -1,    -1,  6231,    -1,  1130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2929,    -1,  2931,    -1,  2933,    -1,    -1,  6267,  5653,
      -1,    -1,    -1,  5657,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3837,    -1,    -1,    -1,
    2968,  2969,    -1,    -1,    -1,    -1,    -1,  3848,  3849,    -1,
      -1,  6310,    -1,    -1,    -1,    -1,    -1,    -1,  5166,  5167,
      -1,    -1,  6321,    -1,  2992,    -1,  6325,  2995,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6337,    -1,
    6339,    -1,    -1,    -1,    -1,    -1,  3887,  6346,  6347,    -1,
      -1,  6350,    -1,    -1,  6353,  6354,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6362,    -1,  6364,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6380,  5230,  5231,    -1,    -1,    -1,    -1,    -1,  6388,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5251,  5252,    -1,  5254,  6406,  5256,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6420,  6421,    -1,    -1,    -1,  6425,  6426,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6444,    -1,  6446,  6447,  1125,
      -1,    -1,    -1,  3121,  1130,    -1,    -1,  6456,    -1,    -1,
    6459,    -1,    -1,    -1,    -1,  3133,    -1,  3135,    -1,  3137,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3152,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5342,  6494,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6507,    -1,
      -1,    -1,  6511,    -1,  6513,    -1,  5364,    -1,  6517,    -1,
    6519,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6531,    -1,  6533,    -1,    -1,  6536,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,    -1,  6565,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6575,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5968,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,    -1,
      -1,    -1,    -1,    -1,    -1,  6624,  6625,  6626,    -1,    -1,
      -1,    -1,  6631,  6632,    -1,  6634,    -1,  6636,    -1,    -1,
      -1,  6640,    -1,  6642,  6643,    -1,  2514,    -1,    -1,    -1,
    6649,    -1,  6651,    -1,    -1,    -1,    -1,    -1,    -1,  6658,
    6659,    -1,  6661,    -1,  6663,    -1,  6665,  6666,  6667,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,  2544,  1130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6694,    -1,    -1,    -1,    -1,
    6699,    -1,  2570,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2584,  6716,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6727,    -1,
    6729,    -1,    -1,  6732,    -1,  6734,    -1,    -1,  6737,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3850,  6748,
      -1,    -1,    -1,  4294,    -1,    -1,    -1,    -1,    -1,  1125,
      -1,  2629,  6761,  3865,  1130,  2633,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6775,    -1,    -1,    -1,
      -1,    -1,    -1,  6782,    -1,    -1,  6785,    -1,  6787,    -1,
    6789,  6790,  6791,    -1,  6793,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6806,    -1,  6808,
      -1,    -1,    -1,  6812,    -1,  1125,    -1,    -1,    -1,    -1,
    1130,  6820,    -1,    -1,  6823,    -1,  6825,    -1,    -1,    -1,
      -1,    -1,    -1,  6832,    -1,    -1,    -1,    -1,    -1,  6838,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6244,    -1,    -1,    -1,    -1,  6864,    -1,  6251,    -1,    -1,
      -1,    -1,    -1,    -1,  2742,  6259,  6260,    -1,    -1,  6263,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6889,    -1,  6891,    -1,  6893,  6894,    -1,    -1,  6897,  2767,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6907,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6926,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6935,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6943,    -1,  6945,  6946,  2816,    -1,
      -1,  2819,    -1,    -1,    -1,  6954,    -1,    -1,  6957,  2827,
    6959,    -1,    -1,  6962,    -1,    -1,    -1,    -1,  6967,    -1,
      -1,    -1,    -1,    -1,  4515,  2843,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6376,  2861,  3662,    -1,    -1,    -1,  6997,  6998,
      -1,    -1,    -1,    -1,    -1,    -1,  2874,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  7014,    -1,  2885,  7017,    -1,
      -1,    -1,    -1,    -1,  7023,    -1,  7025,  7026,    -1,    -1,
    7029,  7030,  7031,    -1,    -1,    -1,    -1,  7036,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3723,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2540,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7082,    54,    55,    -1,  6471,  7087,    -1,
      -1,    -1,    62,    63,    -1,  7094,  6480,  6481,  6482,  7098,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  7113,    -1,  7115,    -1,    -1,  7118,
      -1,  7120,    -1,  7122,    -1,    -1,  2600,    -1,    -1,  3797,
      -1,    -1,  7131,  4235,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  7143,  7144,    -1,    -1,    -1,  7148,
    7149,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3829,  2636,    -1,    -1,    -1,  2640,  3835,    -1,    -1,
    7169,    -1,    -1,  7172,    -1,    -1,    -1,    -1,    -1,  7178,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    7189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2675,  2676,  2677,  2678,  7204,  3874,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  7213,    -1,  7215,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  7223,    -1,  7225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2716,  2717,  2718,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7260,    -1,  2737,    -1,    -1,    -1,    -1,  2742,  2743,
      -1,    -1,    -1,    -1,    -1,  1125,  2750,  2751,  2752,    -1,
    1130,    -1,    -1,  7282,    -1,    -1,  7285,    -1,  7287,    -1,
    2764,    -1,    -1,  6677,    -1,  6679,    -1,    -1,  2772,  7298,
      -1,    -1,    -1,    -1,  6688,    -1,    -1,  6691,  7307,    -1,
      -1,  7310,  7311,    -1,    -1,    -1,    -1,    -1,    -1,  7318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  7326,    -1,    -1,
    7329,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2812,    -1,
      -1,    -1,  2816,    -1,  7343,  7344,  2820,    -1,  2822,    -1,
    2824,  2825,    -1,    -1,    -1,  7354,    -1,    -1,  7357,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  7366,  7367,    -1,
      -1,  2845,  2846,    -1,  2848,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2856,  2857,  2858,  2859,  2860,  2861,    -1,  2863,
      -1,  2865,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7407,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,
      -1,    -1,  4524,    -1,    54,    55,    -1,    -1,    -1,    -1,
      -1,  7430,    62,    63,  4102,    -1,    -1,    -1,    -1,    -1,
      70,    71,    -1,    -1,    -1,    -1,    -1,  7446,    -1,    -1,
    7449,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7458,
      -1,    -1,    -1,  5004,  5005,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,  7498,
      -1,  7500,    -1,  7502,  7503,    -1,    -1,   477,   478,   479,
     480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5066,    -1,    -1,    -1,    -1,
    7529,    -1,  7531,    -1,    -1,    -1,  7535,    -1,    46,    -1,
    7539,    -1,    -1,  7542,    52,    53,    54,    55,    -1,    -1,
    7549,    59,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      -1,    -1,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7570,  4240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7582,  7583,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6977,    -1,  6979,  6980,    -1,    -1,  6983,
    6984,    -1,  6986,    -1,    -1,  6989,  3474,    -1,  3476,    -1,
      -1,    -1,    -1,    -1,    -1,  7614,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    7629,  7630,  7631,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7642,    -1,    -1,    -1,    -1,  7647,  7648,
    7649,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  7665,    -1,  7667,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7678,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  7686,    -1,    -1,
      -1,    -1,  7691,  7077,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5885,    -1,    -1,    -1,  7714,    -1,    -1,    -1,    -1,
      -1,  5895,    -1,  5897,  5898,  7724,    -1,  7726,    -1,  7728,
      46,    -1,  4834,    -1,    -1,    -1,    52,    53,    54,    55,
      -1,    -1,    -1,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    -1,    -1,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7165,    -1,    -1,    -1,    -1,    -1,  7171,    -1,    -1,
      -1,    -1,  4460,    -1,    -1,  4463,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4473,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4916,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,    -1,
      -1,  4509,    -1,    -1,    -1,  4513,    -1,    -1,    -1,    -1,
      -1,  4519,    -1,    -1,    -1,   485,   486,   487,   488,   489,
     490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   507,   508,    -1,
      -1,    -1,    -1,  7267,  7268,  4987,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5443,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  7306,    -1,    -1,  7309,    -1,    -1,    -1,    -1,
      -1,  7315,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   475,   476,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  7361,    -1,  5520,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7372,  7373,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3875,    -1,    -1,
      -1,  7395,    -1,    -1,    -1,    -1,    -1,  7401,    -1,    -1,
    7404,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7413,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6211,    -1,    -1,
      -1,    -1,  4710,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7445,  4730,  6237,  7448,    -1,    -1,    -1,    -1,    -1,
      -1,  7455,  7456,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3951,    -1,    -1,    -1,    -1,    -1,  3957,
    3958,  3959,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7495,    -1,  5654,    -1,    -1,    -1,     1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5669,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,    -1,  7538,  1125,    -1,  7541,    -1,    -1,
    1130,    -1,    -1,  7547,    -1,    -1,    -1,  4835,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,    -1,
      -1,  4849,    -1,    67,  4052,  4053,  4054,    -1,    -1,    -1,
      -1,    -1,  4060,  4061,    -1,    -1,    -1,    -1,    -1,    -1,
    7584,    -1,  7586,  6377,  7588,  7589,    -1,    -1,    -1,    -1,
      -1,    -1,  6386,    97,    -1,    -1,    -1,    -1,    -1,  5760,
      -1,    -1,    -1,    -1,    -1,  7609,    -1,  7611,    -1,  7613,
    4898,    -1,    -1,  4101,    -1,    -1,  7620,    -1,    -1,    -1,
      -1,  6415,    -1,    -1,   128,    -1,   130,    -1,    -1,   133,
      -1,   135,    -1,   137,    -1,  7639,  7640,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6441,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4145,  7662,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4154,  4155,  4156,    -1,
     174,    -1,    -1,    -1,    -1,  6469,    -1,    -1,    -1,  7683,
    4168,    -1,  4170,    -1,  4172,  4173,    -1,    -1,    -1,    -1,
    7694,    -1,  7696,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4188,  4189,  4190,  4191,    -1,    -1,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5911,    -1,    -1,    -1,    -1,    -1,    -1,  5918,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5934,    -1,    -1,    -1,  5938,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5955,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    54,    55,    -1,    -1,    -1,    -1,
    3904,    -1,    62,    63,  3908,    -1,    -1,    -1,    -1,    -1,
      70,    71,    -1,    -1,    -1,    -1,    -1,  5115,  6622,    -1,
      -1,    -1,    -1,    -1,  6628,    -1,  6630,    -1,    -1,  3933,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6015,    -1,  6650,    -1,    -1,    -1,
      -1,    -1,    -1,  6657,    -1,    -1,  6660,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1125,  3970,  3971,    -1,    -1,
    1130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6060,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4002,    -1,
      -1,    -1,    -1,  6074,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5646,    -1,    -1,    -1,  5650,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5665,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4442,    -1,    -1,    -1,  4052,    -1,
      -1,    -1,  4056,    -1,  6758,    -1,  4060,  4061,    -1,  4063,
    4064,    -1,  4066,  4067,  4068,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4077,    -1,    -1,    -1,    -1,  4082,  4083,
    4084,    -1,  4086,    -1,    -1,    -1,    -1,  1125,    -1,    -1,
      -1,    -1,  1130,    -1,  6798,    -1,    -1,    -1,    -1,  6803,
      -1,  6805,    -1,    -1,    -1,    -1,    -1,  6178,    -1,    -1,
    6814,    -1,  6816,  6817,  6185,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6829,    -1,  6831,    -1,    -1,
      -1,  4135,  6836,  6837,    -1,    -1,    -1,    -1,    -1,    -1,
    4144,  4145,    -1,  4147,    -1,  4543,  4150,  4545,    -1,    -1,
      -1,    -1,  4550,    -1,    -1,    -1,  4160,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4563,    -1,    -1,  6872,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4180,    -1,    -1,  6250,
      -1,    -1,    -1,    -1,    -1,  6256,    -1,    -1,    -1,    -1,
      -1,  4589,    -1,    -1,    -1,    -1,    -1,  5829,    -1,  4597,
    4598,    -1,  6906,    -1,    -1,  5837,    -1,    -1,    -1,  5841,
      -1,    -1,    -1,    -1,    -1,    -1,  4220,  4221,    -1,  5417,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5434,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6952,    -1,
      -1,    -1,  6956,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6964,  5893,    -1,    -1,    -1,    -1,  6970,    -1,    -1,  6973,
      -1,    -1,  6976,    -1,    -1,    -1,    -1,    -1,    -1,  1125,
      -1,    -1,    -1,    -1,  1130,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,    -1,
      -1,    -1,    -1,    -1,    -1,  4713,  5514,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5524,    -1,    -1,  5527,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5536,    -1,
    4738,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4768,    -1,  4770,    -1,    -1,    -1,  7080,  7081,    -1,  6011,
      -1,  7085,    -1,    -1,    -1,  7089,    -1,  7091,    -1,  7093,
      46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,
      -1,    -1,  6473,    59,    60,    61,    62,    63,    -1,  6041,
      -1,    67,  7116,  7117,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5621,    -1,    -1,    -1,    -1,  5626,    -1,
      -1,    -1,  5630,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7145,  7146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5652,    -1,    -1,  5655,  5656,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7177,    -1,    -1,    -1,    -1,  7182,    -1,
      -1,  6552,    -1,  7187,    -1,    -1,    -1,  7191,    -1,  6121,
      -1,  6123,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7203,
      -1,  7205,    -1,    -1,  7208,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  7228,  7229,    -1,    -1,  7232,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    -1,    -1,    -1,  7259,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5763,    -1,    -1,    -1,    -1,
      -1,    -1,  5770,    -1,    -1,    -1,  6208,    -1,    -1,    -1,
      -1,    97,    -1,    -1,    -1,    -1,  6218,    -1,    -1,    -1,
      -1,    -1,    -1,  6225,    -1,    -1,    -1,  6229,    -1,    -1,
      -1,    -1,    -1,  6235,    -1,    -1,    -1,    -1,    -1,  6241,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5823,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5835,    46,    -1,
      -1,    -1,    -1,    -1,    52,    53,    54,    55,    -1,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    -1,   174,    67,
      -1,    -1,    70,    71,    -1,  6297,    -1,  6299,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6311,
      -1,    -1,    -1,    -1,    -1,    -1,  5884,    15,    16,    17,
    5888,    -1,    -1,  5891,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,    -1,  5915,   234,   235,
     236,   237,   238,   239,    -1,  5923,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    71,    -1,    -1,    -1,    -1,  5146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5154,  5155,  5156,    -1,
      -1,    -1,  5160,    -1,    -1,  5963,  5964,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6855,    -1,    -1,    -1,    -1,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    46,  5225,    -1,    -1,
    5228,  5229,    52,    53,    54,    55,    -1,    -1,    -1,    59,
      60,    61,    62,    63,  6915,    -1,    -1,    67,    -1,    -1,
      70,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6058,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5279,    -1,    -1,    -1,    -1,  6518,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6532,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6981,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,  5319,  5320,    52,    53,    54,    55,  5325,    -1,    -1,
      59,    60,    61,    62,    63,    -1,    -1,    -1,    67,    -1,
      -1,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,  7653,
    5348,  7655,    -1,    -1,    -1,  5353,    -1,    -1,  5356,  5357,
      -1,    -1,    -1,    -1,    -1,  1125,  7037,    -1,    -1,    -1,
    1130,    -1,    -1,  7044,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6616,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6204,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6212,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6223,  6224,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6233,    -1,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,    -1,    -1,    -1,    -1,  6697,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6274,    -1,  6276,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6286,    -1,
      -1,    -1,  6290,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6745,    -1,    -1,    -1,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,    -1,    -1,    -1,  6776,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6786,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6417,
    6418,    -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6455,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   485,   486,   487,   488,   489,
     490,   491,    -1,   493,   494,   495,    -1,    -1,    -1,   499,
     500,   501,   502,    -1,    -1,   505,   506,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6501,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    54,    55,    -1,    -1,    -1,  6546,    -1,
      -1,    62,    63,    -1,    -1,    -1,    -1,  6555,    -1,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6581,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6597,
      -1,    -1,    -1,    -1,    -1,  6603,  6604,  6605,    -1,    -1,
    6608,    -1,    -1,  6611,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7073,    -1,    -1,  7076,    -1,    -1,    -1,  6646,    -1,
      -1,    -1,    -1,    -1,  1340,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,
      -1,    -1,    -1,    -1,  1130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  7556,    -1,  6685,    -1,    -1,
      -1,  6689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6701,    -1,    -1,    -1,    -1,    -1,    -1,
    6708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    15,    16,    17,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6750,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6759,    -1,    -1,    -1,  6763,    54,    55,  6766,    -1,
      -1,   361,    -1,    -1,    62,    63,    -1,    -1,    -1,  6777,
      -1,  5979,    70,    71,    -1,    -1,   376,   377,   378,   379,
      -1,   381,  7224,    -1,  7226,    -1,    -1,    -1,   388,    -1,
      -1,    -1,    -1,    -1,  6002,    -1,    -1,    -1,    -1,    -1,
    7242,  6809,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7253,    -1,    -1,  7256,  7257,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6833,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  7283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  7304,    -1,    -1,    -1,  7308,    -1,    -1,  6877,
      -1,    -1,  6880,    -1,  6882,    -1,    -1,    -1,  7320,  7321,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,
    6918,    -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7365,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
    6958,    -1,  6960,    -1,    -1,    -1,    -1,    -1,  7400,    -1,
      -1,  7403,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7411,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6987,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,
      -1,    -1,  1130,    -1,    -1,    -1,    -1,  1135,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  7457,    -1,  7459,    -1,  7461,
    7462,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7485,    -1,    -1,    -1,  7489,    -1,    -1,
    7492,    -1,  7060,    -1,    -1,    -1,    -1,    -1,    -1,  7501,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  7084,   677,    -1,    -1,
    7088,    -1,    -1,    -1,    -1,    -1,    -1,  7095,    -1,  7097,
      -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,
    1130,    -1,  7544,  7545,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,  7123,    -1,  7125,    59,    60,
      61,    62,    63,    -1,    -1,  7133,    67,    -1,  7136,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7581,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,    -1,    -1,   773,    -1,    -1,  7618,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,  7197,
      -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7641,
      -1,  7643,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  7220,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  7265,    -1,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     870,   871,   872,   873,   874,   875,   876,   877,   878,   879,
     880,   881,   882,   883,    -1,   885,   886,   887,   888,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,   899,
     900,   901,   902,   903,   904,   905,   906,   907,   908,   909,
     910,   911,   912,   913,   914,   915,   916,   917,   918,    -1,
     920,   921,    -1,   923,    -1,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,    -1,   936,   937,   938,   939,
     940,   941,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  7375,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   984,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
      -1,  1001,    -1,  1003,    -1,  1005,  1006,  1007,    -1,    -1,
    1010,    -1,  1012,    -1,  1014,    -1,  1016,    -1,  1018,    -1,
    1020,  7429,  1022,    -1,  1024,    -1,  1026,    -1,  1028,    -1,
    1030,    -1,    -1,  1033,    -1,  1035,  1036,  1037,  1038,  1039,
      -1,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,
    1070,    -1,    -1,    -1,  7482,  7483,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7511,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1139,
    1140,    -1,    -1,    -1,   485,   486,   487,   488,   489,   490,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  7573,    -1,  7575,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,  1179,
      -1,    -1,    -1,    -1,    52,    53,    54,    55,    -1,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      -1,    -1,    70,    71,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,    -1,    -1,    -1,    -1,  7623,  7624,    46,    -1,    -1,
      -1,    -1,    -1,    52,    -1,  7633,  7634,    -1,    -1,  1229,
      59,    60,    -1,    -1,  1234,    -1,    -1,  1237,    67,    -1,
      -1,    -1,  1242,    -1,    -1,    -1,  7654,    -1,  7656,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1256,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  7701,    -1,  7703,  7704,  7705,    -1,  1299,
      -1,    -1,    -1,    -1,   133,    -1,   135,    -1,   137,    -1,
      -1,    -1,  7720,    46,  7722,    -1,   145,  7725,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    -1,    -1,  1125,    59,    60,
      61,    62,    63,    -1,    -1,    -1,    67,    -1,    -1,    70,
      71,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2570,    -1,    -1,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,  2595,
      -1,   234,   235,   236,   237,   238,   239,    -1,    -1,    -1,
      -1,    -1,    -1,  2609,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2633,    -1,  2635,
    2636,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2645,
      -1,    -1,  2648,    -1,    -1,  2651,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2664,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2716,  2717,  2718,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,  2737,    -1,    -1,    -1,    -1,  2742,  2743,    19,    -1,
      -1,    -1,    -1,    -1,  2750,  2751,  2752,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,  2764,    -1,
      -1,    42,    43,    -1,    -1,    46,  2772,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    46,    -1,    -1,    67,    -1,    -1,    52,
      53,    54,    55,    -1,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    -1,  2812,    70,    71,    -1,
    2816,    -1,    -1,    -1,  2820,    -1,  2822,    -1,  2824,  2825,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2839,    -1,    -1,  2842,    -1,    -1,  2845,
    2846,    -1,  2848,    -1,    -1,    -1,    -1,    -1,  2854,    -1,
    2856,  2857,  2858,  2859,  2860,  2861,    -1,  2863,  2864,  2865,
    2866,  2867,    -1,    -1,    -1,  2871,    -1,   148,   149,   150,
     151,   152,   153,   154,  1125,   156,   157,   158,   159,    -1,
      -1,    54,    55,    -1,    -1,    -1,    -1,    -1,   169,    62,
      63,    -1,    -1,   174,    -1,    -1,    -1,    70,    71,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    46,    -1,    -1,    -1,
      -1,    46,    52,    53,    54,    55,    -1,    52,    -1,    59,
      60,    61,    62,    63,    59,    60,    -1,    67,    -1,    -1,
      70,    71,    67,    -1,    -1,    -1,    -1,    -1,    54,    55,
      -1,    -1,    -1,    46,   507,   508,    62,    63,    -1,    52,
      -1,    -1,    -1,    -1,    70,    71,    59,    60,    -1,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,    -1,    -1,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,    -1,    -1,    -1,
      -1,  2351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2371,  2372,    -1,    -1,    -1,    -1,    -1,  3474,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2408,    -1,
      -1,  2411,  2412,  2413,    -1,    -1,  2416,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2424,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2432,  2433,  2434,  2435,  2436,  2437,    -1,    -1,
      -1,    -1,    -1,    -1,  2444,  2445,  2446,  2447,  2448,  2449,
      -1,    -1,    -1,    -1,    -1,    -1,  2456,  2457,  2458,  2459,
    2460,  2461,    -1,    -1,    -1,    -1,    -1,    -1,  2468,  2469,
    2470,  2471,  2472,  2473,  2474,  2475,  2476,  2477,  2478,  2479,
    2480,  2481,  2482,  2483,  2484,  2485,  2486,  2487,  2488,    -1,
      -1,    -1,  2492,  2493,  1125,    -1,  2496,    -1,    -1,  2499,
    2500,  2501,  2502,    -1,  2504,  2505,  2506,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,    -1,    -1,  3875,
      -1,    -1,    -1,    -1,  2784,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   128,    -1,   130,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3904,    -1,
      -1,    -1,  3908,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3929,    -1,    -1,    -1,  3933,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,  3950,    -1,    -1,    -1,    59,    60,
      -1,    -1,  1125,    -1,    -1,    -1,    67,  1130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3971,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2921,  2922,  2923,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4052,    -1,    -1,    -1,
    4056,    -1,    -1,    -1,  4060,  4061,    -1,  4063,  4064,    -1,
    4066,  4067,  4068,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4077,    -1,    -1,    -1,  2985,  4082,  4083,  4084,    -1,
    4086,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4101,    -1,    -1,    -1,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,  4135,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4144,  4145,
      -1,  4147,    -1,    -1,  4150,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4160,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4168,    -1,  4170,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4180,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4198,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4218,    -1,  4220,  4221,    -1,    46,    -1,    -1,
      -1,  3131,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3189,
      -1,    -1,    -1,    -1,    -1,  1125,    -1,  3197,    -1,    -1,
      -1,  3201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,
      -1,    -1,    -1,    -1,  3224,    -1,  3226,  3227,  3228,  3229,
    3230,    -1,  3232,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3241,    -1,    -1,    -1,  3245,  3246,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3254,   174,    -1,    -1,  3258,  3259,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3271,    -1,  3273,    -1,    -1,    -1,    -1,    -1,    -1,
    3280,  3281,    -1,    -1,  3284,    -1,  3286,    -1,    -1,    -1,
      -1,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,    -1,    -1,   234,   235,   236,   237,   238,
     239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4442,    -1,    -1,  3349,
    3350,    -1,  3352,  3353,  3354,  3355,  3356,    -1,  3358,  3359,
    3360,  3361,  3362,  3363,  3364,  3365,  3366,  3367,  3368,  3369,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3384,  3385,  3386,    -1,    -1,    -1,
    3390,  3391,    -1,  3393,  3394,  3395,  3396,  3397,  3398,  3399,
    3400,    -1,  3402,  3403,    -1,  3405,    -1,  3407,  3408,  3409,
    3410,  3411,  3412,  3413,  3414,  3415,  3416,  3417,  3418,  3419,
      -1,  3421,  3422,    -1,  3424,  3425,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4543,    -1,  4545,
      -1,    -1,    -1,    52,  4550,    -1,    -1,    -1,  3458,  3459,
      59,    60,    -1,    -1,    -1,    -1,    -1,  4563,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    98,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3512,  3513,    -1,    -1,    -1,    -1,    -1,    -1,
    3520,  3521,  3522,  3523,    52,    -1,    -1,    -1,    -1,    -1,
    3530,    59,    60,    -1,  3534,  3535,    -1,  3537,  3538,    67,
      -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,
      -1,    -1,  3562,    -1,  3564,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3595,  3596,    -1,    -1,    -1,
    3600,  3601,  3602,  3603,  3604,  3605,  3606,  3607,  3608,    -1,
      -1,  3611,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,    -1,  4738,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4768,    -1,  4770,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,    -1,    -1,    -1,  3716,  3717,  3718,  3719,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3727,  3728,  3729,
    3730,  3731,  3732,  3733,  3734,  3735,  3736,    -1,    -1,  3739,
    3740,  3741,  3742,  3743,  3744,  3745,  3746,  3747,  3748,    -1,
      -1,  3751,  3752,  3753,  3754,  3755,  3756,  3757,  3758,  3759,
    3760,    -1,    -1,  3763,  3764,  3765,  3766,  3767,  3768,  3769,
    3770,  3771,  3772,  3773,  3774,  3775,  3776,  3777,  3778,  3779,
    3780,  3781,  3782,  3783,  3784,  3785,    46,    -1,    -1,    -1,
      -1,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    -1,    -1,
      -1,    -1,    -1,   338,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,
      -1,    -1,  3842,    -1,    50,    -1,    52,    53,    -1,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3867,    -1,    -1,
    3870,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3880,    -1,  3882,    -1,  3884,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,    -1,    -1,   234,   235,   236,   237,   238,   239,
      -1,    -1,    -1,    -1,    -1,    -1,  3986,  3987,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   536,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   556,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4045,    -1,    -1,  4048,    -1,
    5146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5155,
    5156,    -1,    -1,    -1,  5160,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    -1,    -1,  4089,
    4090,  4091,    -1,    -1,    46,  4095,  4096,  4097,    -1,  4099,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    97,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5225,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,   674,
     675,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,    -1,   711,   712,    -1,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4204,    -1,  4206,    -1,  4208,    -1,
      -1,  4211,    52,  4213,    -1,  4215,    -1,    -1,    -1,    59,
      60,    -1,   174,  5319,  5320,    -1,    -1,    67,    -1,  4229,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,    -1,  5348,   234,   235,   236,   237,   238,   239,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
      -1,    -1,   234,   235,   236,   237,   238,   239,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,   854,
     855,    59,    60,    -1,   174,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   560,    -1,    -1,    -1,    -1,   884,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     128,    -1,   130,    -1,    -1,    -1,    -1,   135,    -1,   137,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4443,  4444,    -1,   174,    -1,    -1,    -1,
    4450,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4466,    -1,    -1,  4469,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4479,
      -1,    -1,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   718,    -1,  5610,    -1,    -1,    -1,  4518,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4546,  4547,  4548,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4559,
    4560,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4568,  4569,
    4570,  1096,  4572,    -1,  4574,  4575,  4576,    -1,    -1,  4579,
    4580,  4581,  4582,  4583,  4584,  4585,  4586,    -1,    -1,    -1,
      -1,  4591,    -1,  4593,  4594,  4595,  4596,    -1,    -1,  4599,
    4600,  4601,  4602,  4603,  4604,  4605,    -1,  4607,  4608,  4609,
    4610,  4611,  4612,  4613,  4614,    -1,  4616,  4617,    -1,  4619,
      -1,  4621,  4622,  4623,  4624,  4625,  4626,  4627,  4628,    -1,
      -1,  4631,  4632,  4633,  4634,  4635,  4636,  4637,  4638,  4639,
      -1,  4641,  4642,    -1,    -1,    -1,    -1,    -1,    -1,  4649,
    4650,    -1,    -1,  4653,  4654,  4655,  4656,  4657,  4658,  4659,
    4660,  4661,  4662,  4663,  4664,  4665,  4666,  4667,    -1,    -1,
    4670,    -1,  4672,    -1,  4674,  4675,  4676,  4677,  4678,  4679,
    4680,  4681,  4682,  4683,  4684,  4685,  4686,  4687,  4688,  4689,
    4690,  4691,    -1,    -1,    -1,    -1,  1221,  1222,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4705,  4706,  4707,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4716,  4717,  4718,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4731,    -1,  4733,    -1,  4735,  4736,  4737,    -1,  1264,
    1265,  4741,  4742,  4743,  4744,    -1,  4746,  4747,  4748,  4749,
    4750,  4751,  4752,  4753,  4754,  4755,  4756,  4757,  4758,  4759,
    4760,  4761,    -1,  4763,  4764,  4765,  4766,  4767,    -1,    -1,
      -1,  4771,    -1,  4773,  4774,    -1,  4776,  5873,  4778,    -1,
      -1,  4781,  4782,  4783,  4784,  4785,  4786,    -1,  4788,  4789,
    4790,  4791,  4792,  4793,  4794,  4795,  4796,  4797,  4798,  4799,
    4800,  4801,  4802,  4803,  4804,  4805,  4806,  4807,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4823,  4824,  4825,  4826,  4827,  4828,  4829,
    4830,  4831,  4832,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    47,    48,    -1,    -1,    -1,    -1,    -1,
      54,    46,    -1,    -1,    -1,    59,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6002,    -1,    -1,    -1,
      -1,    -1,    97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4929,
    4930,  4931,  4932,    -1,  4934,  4935,  4936,  4937,  4938,  4939,
    4940,  4941,  4942,  4943,  4944,  4945,  4946,  4947,  4948,  4949,
    4950,  4951,  4952,  4953,  4954,  4955,  4956,  4957,  4958,  4959,
    4960,  4961,  4962,  4963,  4964,  4965,  4966,  4967,  4968,  4969,
    4970,  4971,  4972,  4973,  4974,  4975,  4976,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,    -1,    -1,   234,
     235,   236,   237,   238,   239,    -1,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5093,    -1,    -1,    -1,    -1,    -1,  5099,
      -1,  5101,    -1,    -1,    -1,    -1,  5106,    -1,    -1,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5118,    -1,
    5120,  5121,    -1,    -1,  5124,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   335,    -1,    -1,  5144,  5145,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5178,  5179,
      -1,  5181,  5182,    -1,    -1,    -1,   174,  5187,  5188,    -1,
      -1,    -1,    -1,    -1,  1400,    -1,  1402,    -1,  1404,    -1,
    1406,    -1,  1408,    -1,  1410,    -1,  1412,    -1,  1414,    -1,
    1416,    -1,  1418,    -1,  1420,    -1,  1422,    -1,  1424,    -1,
    1426,    -1,  1428,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,    -1,    -1,   234,   235,   236,   237,
     238,   239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5289,
    5290,    -1,    -1,  5293,    -1,    -1,    -1,    -1,    -1,    -1,
    5300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5312,    -1,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,    -1,    -1,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,    -1,   557,   558,   559,    -1,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,    -1,    -1,    -1,    -1,    -1,    -1,  1040,    46,    -1,
      -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      -1,    -1,    -1,    -1,    -1,   679,    -1,    -1,   682,    -1,
      -1,   685,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   729,    -1,    -1,    -1,    -1,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   747,    -1,   749,   750,   751,   752,   753,
     754,   755,   756,   757,    -1,   759,    -1,    -1,    -1,   763,
      -1,    -1,    -1,   767,    -1,   769,   770,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   800,    -1,    -1,    -1,
     804,   805,    -1,    -1,   808,    -1,    -1,    -1,    -1,   813,
      -1,    -1,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,  5644,    -1,   234,   235,   236,   237,
     238,   239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5684,  5685,  5686,  5687,  5688,  5689,
      -1,  5691,  5692,  5693,  5694,    -1,    -1,    -1,    -1,    -1,
      -1,  5701,  5702,  5703,  5704,  5705,  5706,  5707,  5708,    -1,
    5710,  5711,  5712,    -1,    -1,    -1,    -1,    -1,    -1,  5719,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5734,    -1,  5736,  5737,  5738,  5739,
    5740,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2289,  2290,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,
    5790,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5847,  5848,  5849,
    5850,  5851,  5852,  5853,  5854,  5855,  5856,  5857,  5858,  5859,
    5860,  5861,  5862,  5863,  5864,  5865,  5866,  5867,  5868,  5869,
     128,    -1,    -1,    -1,    -1,   133,    -1,   135,    -1,   137,
      -1,    -1,  2407,    -1,    -1,    -1,    -1,   145,    -1,  2414,
      -1,    -1,  5892,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5902,  5903,  5904,    -1,    -1,    -1,    -1,  1103,
      -1,    -1,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5931,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,  2508,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2532,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2560,  2561,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6044,  2570,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1257,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2607,    -1,  2609,  2610,    -1,    -1,    -1,  2295,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1301,    -1,    -1,
    2635,    -1,  6112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2648,    -1,    -1,  2651,    -1,    -1,    -1,
      -1,  2656,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2664,
      -1,  1335,    -1,    -1,  1338,    -1,    -1,  2672,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1351,    -1,    -1,
      -1,    -1,    -1,    -1,  1358,  1359,  1360,  1361,  1362,  1363,
    1364,  1365,  1366,  1367,  1368,  1369,  1370,  1371,  1372,  1373,
    1374,  1375,  1376,  1377,  1378,  1379,  1380,  1381,  1382,  1383,
    1384,  1385,  1386,  1387,  1388,  1389,  1390,  1391,  1392,  1393,
    1394,  1395,  1396,  1397,  1398,  1399,    -1,    -1,    -1,    -1,
      -1,  2736,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    59,    60,    -1,  1431,    -1,  1433,
      -1,  1435,    67,    -1,    -1,  1439,  1440,    -1,  1442,    -1,
    1444,    -1,  1446,    -1,  1448,    -1,  1450,  6257,  1452,    -1,
    1454,  6261,  1456,    -1,  1458,    -1,  1460,    -1,  1462,  1463,
      -1,  1465,    97,    -1,    -1,    -1,    -1,    -1,  2803,    -1,
      -1,    -1,  2807,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6292,    -1,    -1,  6295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   128,    -1,    -1,    -1,    -1,    -1,    -1,
     135,    -1,   137,  2838,  2839,    -1,    -1,    -1,  2843,  2844,
     145,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2864,
      -1,  2866,  2867,    -1,    -1,    -1,    -1,    -1,  2873,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6367,  6368,  6369,
    6370,  6371,  6372,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6382,    -1,    -1,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6422,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6433,    -1,    -1,    -1,    -1,    -1,  2964,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    -1,    -1,    -1,    -1,  6457,    52,    -1,
      -1,    -1,    -1,  6463,    -1,    59,    60,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,  6477,    -1,    -1,
      -1,    -1,    -1,  6483,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    -1,  6495,    -1,    -1,    -1,    -1,
      59,    60,    -1,    97,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,    97,    -1,
      -1,   135,    -1,   137,  6544,    -1,    -1,    -1,    -1,    -1,
      -1,   145,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6563,  6564,    -1,    -1,    -1,    -1,   128,
      -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,   137,    -1,
     174,    -1,    -1,  2166,    -1,  3110,   145,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6595,  3121,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6613,  6614,   174,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,    -1,    -1,    -1,    -1,
      -1,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3242,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3274,
      -1,    -1,  3277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3294,
      -1,  2977,    -1,  2979,    -1,  2981,    -1,  2983,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    59,    60,
      -1,  2997,    -1,  2999,    -1,  3001,    67,  3003,    -1,  3005,
    3325,  3007,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3015,
      -1,  3017,    -1,  3019,    -1,  3021,    -1,  3023,    -1,  3025,
      -1,    -1,    -1,    -1,    -1,    -1,    97,  3033,    -1,  3035,
      -1,  3037,    -1,  3039,    -1,  3041,    -1,  3043,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3051,    -1,  3053,  6848,  3055,
      -1,  3057,  6852,  3059,    -1,  3061,    -1,   128,  3383,   130,
      -1,    -1,   133,  3069,   135,  3071,   137,  3073,    -1,  3075,
      -1,  3077,    -1,  3079,    -1,  3081,    -1,  3083,    -1,  3085,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,  6904,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6924,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2560,  2561,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2569,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3519,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2595,    -1,    -1,    -1,  2599,  2600,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2609,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3567,    -1,    -1,  3570,    -1,    -1,    -1,    -1,
      -1,    -1,  2635,    -1,    -1,    -1,    -1,  2640,    -1,    -1,
      -1,    -1,  2645,    -1,    -1,  2648,    -1,    -1,  2651,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2664,    -1,    -1,  2278,    -1,  2669,  2670,    -1,    -1,
    2284,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3624,
      -1,    -1,    -1,    -1,    -1,    -1,  7106,    -1,    -1,    -1,
      -1,  7111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2337,    -1,    -1,    -1,    -1,  2342,    -1,
      -1,    -1,    -1,    -1,  7154,  7155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1566,  1567,  1568,
      -1,    -1,    -1,    -1,    -1,    -1,  7196,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1587,  1588,
    1589,  1590,  1591,  1592,  1593,    -1,    -1,  2800,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1612,    -1,  7235,  7236,    -1,  1617,  1618,
    1619,  1620,  1621,    -1,    -1,    -1,  1625,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1636,  1637,  2842,
    1639,  1640,  2845,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2864,  2865,  2866,  2867,    -1,    -1,    -1,  2871,    -1,
      -1,    -1,    -1,    -1,  3819,  1674,    -1,    -1,  3823,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1689,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1703,    -1,    -1,    -1,    -1,    -1,
      -1,  1710,    -1,    -1,  3859,  3860,  3861,  3862,  3863,  1718,
    1719,  1720,  1721,    -1,  1723,  1724,    -1,  1726,  1727,  3874,
      -1,    -1,  1731,  1732,  1733,  1734,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3908,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1771,    -1,    -1,  1774,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2597,  3929,  2988,  3931,  3932,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3940,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1803,  1804,  1805,    -1,    -1,    -1,
      -1,  1810,  1811,    -1,    -1,  1814,    -1,    -1,  1817,  1818,
    1819,    -1,    -1,    -1,    -1,  1824,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3978,    -1,    -1,    -1,  1836,  1837,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1861,  1862,  1863,  1864,  1865,  1866,  1867,  1868,
    1869,  1870,  1871,  1872,  1873,  1874,  1875,  1876,  1877,  1878,
    1879,  1880,  1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,
    1889,  1890,    -1,    -1,    -1,  1894,  1895,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1904,  1905,  1906,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3121,  2733,
    2734,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2747,  2748,  2749,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2800,    -1,    -1,  1988,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  7625,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3225,  4168,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3238,    -1,    -1,    -1,  2853,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3261,    -1,
      -1,    -1,    -1,  3266,    -1,    -1,  3269,    -1,    -1,    -1,
      -1,    -1,  2071,    -1,  3277,    -1,    -1,    -1,    -1,  2078,
      -1,    -1,    -1,    -1,  2083,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2907,    -1,  2909,    -1,  2911,    -1,  2913,
      -1,    -1,    -1,  2917,  2918,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2113,    -1,    -1,  2116,    -1,    -1,
      -1,    -1,  3325,    -1,    -1,    -1,  2940,    -1,    -1,    -1,
    2129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3351,    -1,
      -1,    -1,    -1,    -1,  3357,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2176,  2177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3009,  3010,  3011,  3012,  3013,
    3014,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3027,  3028,  3029,  3030,  3031,  3032,    -1,
      -1,    -1,    -1,    -1,  2223,    -1,    -1,    -1,    -1,    -1,
      -1,  3045,  3046,  3047,  3048,  3049,  3050,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3473,  3474,    -1,  3087,  3088,  3089,    -1,  3091,    -1,  3093,
    3094,    -1,  3096,  3097,    -1,    -1,    -1,    -1,  3102,    -1,
      -1,    -1,    -1,    -1,  3108,    -1,    -1,  4442,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4456,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4488,    -1,    -1,  4491,    -1,    -1,    -1,
      -1,  4496,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,
    3563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4531,    -1,    -1,    -1,
     128,    -1,   130,    -1,    -1,   133,    -1,   135,  4543,   137,
      -1,    -1,    -1,    -1,  3218,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4558,    -1,    -1,    -1,    -1,  4563,    -1,
      -1,    -1,    -1,    -1,    -1,  3239,    -1,    -1,  4573,    -1,
      -1,    -1,    -1,    -1,  3248,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4590,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3283,
      -1,    -1,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4335,
      -1,  4337,    -1,  4339,    -1,  4341,    -1,    -1,    -1,    -1,
    4346,    -1,  4348,    -1,  4350,    -1,  4352,    -1,  4354,    -1,
    4356,    -1,  4358,    -1,  4360,    -1,  4362,    -1,  4364,    -1,
      -1,    -1,  4368,    -1,  4370,    -1,  4372,    -1,  4374,    -1,
    4376,    -1,  4378,    -1,  4380,    -1,  4382,    -1,  4384,    -1,
    4386,    -1,    -1,    -1,  4390,    -1,  4392,    -1,  4394,    -1,
    4396,    -1,  4398,    -1,  4400,    -1,  4402,    -1,  4404,    -1,
    4406,    -1,  4408,    -1,    -1,    -1,  4412,    -1,  4414,    -1,
    4416,    -1,  4418,    -1,  4420,  3798,  4422,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4770,    -1,  4772,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,  3874,  3875,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4835,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    97,    -1,    -1,    -1,    -1,  3912,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3929,    -1,  3931,  3932,
      -1,  3934,  3935,  3936,  3937,   128,    -1,   130,  3941,  3942,
    3943,    -1,   135,    -1,   137,    -1,    -1,    -1,    -1,    -1,
      -1,  3565,    -1,    -1,    -1,    -1,    -1,  3960,  3961,  3962,
    3963,    -1,    -1,    -1,    -1,    -1,  3969,  3970,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3610,  4000,  4001,  4002,
    4003,  4004,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3694,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4098,    -1,    -1,  4101,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4109,    -1,  4111,    -1,
    4113,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5097,  5098,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5115,  4174,  4175,  4176,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4196,  4197,  4198,    -1,    -1,    -1,    -1,
      -1,  5146,    -1,    -1,    -1,    -1,    -1,    -1,  5153,    -1,
    5155,    -1,    -1,    -1,    -1,  4218,  4219,  4220,  4221,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3893,
    5225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3912,    -1,
    3914,    -1,    -1,    -1,    -1,  3919,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4013,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5353,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4442,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4453,    -1,    -1,  4456,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5414,
    5415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4108,    -1,    -1,  4111,    -1,  4113,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1040,    -1,    -1,
    4543,    -1,  4545,    -1,    -1,    -1,    -1,  4550,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4169,    -1,    -1,    -1,    -1,
    4563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4573,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4606,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4615,    -1,    -1,    -1,    -1,  4620,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5610,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5632,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4323,
      -1,    -1,    -1,    -1,  4328,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4738,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4366,  4367,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4768,    -1,  4770,    -1,    -1,
      -1,    -1,    -1,    -1,  4388,  4389,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4410,  4411,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4441,    -1,    -1,
      -1,    -1,  4835,    -1,    -1,    -1,    -1,  1340,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5820,  5821,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5538,    -1,  5540,    -1,  5542,    -1,  5544,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5553,  5873,  5555,
      -1,  5557,    -1,  5559,    -1,  5561,    -1,  5563,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5571,    -1,  5573,    -1,  5575,
      -1,  5577,    -1,  5579,    -1,  5581,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5589,    -1,  5591,    -1,  5593,    -1,  5595,
      -1,  5597,    -1,  5599,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1040,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5979,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6002,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6013,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6033,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4724,    -1,  5115,  4727,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6077,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5154,  5155,  5156,    -1,    -1,    -1,  5160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5175,    -1,  5177,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5225,    -1,    -1,    -1,    -1,  4841,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4883,
      -1,    -1,  4886,  4887,  4888,  4889,  4890,  4891,  4892,  4893,
    4894,  4895,  4896,  4897,    -1,  4899,  4900,  4901,  4902,  4903,
    4904,  4905,  4906,  4907,    -1,  4909,    -1,  4911,    -1,  4913,
    4914,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4924,    -1,  4926,    -1,    -1,    -1,  5319,  5320,    -1,    -1,
      -1,    -1,    -1,    -1,  6269,  6270,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5348,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6329,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6341,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6399,  6081,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5090,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6136,    -1,  6138,    -1,    -1,    -1,    -1,    -1,  6144,    -1,
    6146,    -1,    -1,    -1,    -1,    -1,  6152,    -1,  6154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5162,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5610,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2150,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6627,    -1,  6629,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6639,    -1,  6641,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6343,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5350,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6692,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6424,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6435,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6445,
      -1,    -1,    -1,    -1,    -1,  6451,    -1,    -1,    -1,    -1,
      -1,    -1,  6458,    -1,    -1,    -1,    -1,    -1,    -1,  6465,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5873,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5546,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5979,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6002,
      -1,    -1,    -1,    -1,    -1,  2508,    -1,    -1,    -1,    -1,
      -1,  2514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5634,    -1,    -1,    -1,    -1,    -1,    -1,  5641,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2540,  2541,  2542,
      -1,  2544,    -1,  6988,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2560,  2561,    -1,
      -1,    -1,  5676,    -1,    -1,  2568,  2569,  2570,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2595,  2150,    -1,    -1,  2599,  2600,  2601,    -1,
      -1,    -1,    -1,    -1,  2607,    -1,  2609,  2610,    -1,  2166,
    2613,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2629,    -1,    -1,  5743,
    2633,    -1,  2635,  2636,    -1,    -1,  2639,  2640,    -1,    -1,
      -1,    -1,  2645,    -1,    -1,  2648,    -1,    -1,  2651,    -1,
      -1,    -1,    -1,  2656,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2664,  5776,    -1,    -1,    -1,  2669,  2670,    -1,  2672,
    2673,  2674,  2675,  2676,  2677,  2678,  2679,  2680,  2681,    -1,
      -1,  2684,    -1,  2686,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5805,    -1,    -1,    -1,    -1,  5810,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  7152,    -1,    -1,
      -1,    -1,    -1,  2716,  2717,  2718,    -1,    -1,  2721,  2722,
    2723,  2724,  2725,  2726,  2727,  2728,    -1,    -1,    -1,  2732,
      -1,    -1,  2735,    -1,  2737,    -1,    -1,    -1,    -1,  2742,
    2743,    -1,  6868,    -1,    -1,    -1,    -1,  2750,  2751,  2752,
    2753,  2754,    -1,    -1,    -1,    -1,    -1,  2760,    -1,    -1,
      -1,  2764,    -1,    -1,  2767,    -1,    -1,  2770,  2771,  2772,
      -1,    -1,    -1,    -1,    -1,  6901,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2800,    -1,    -1,
    2803,    -1,  2805,    -1,  2807,  2808,  2809,  2810,    -1,  2812,
      -1,    -1,    -1,  2816,  2817,  2818,  2819,  2820,    -1,  2822,
      -1,  2824,  2825,    -1,  2827,    -1,  2829,    -1,    -1,  2832,
      -1,    -1,  2835,    -1,  5948,    -1,  2839,    -1,    -1,  2842,
    2843,  2844,  2845,  2846,    -1,  2848,    -1,    -1,    -1,    -1,
      -1,  2854,    -1,  2856,  2857,  2858,  2859,  2860,  2861,  2862,
    2863,  2864,  2865,  2866,  2867,    -1,    -1,    -1,  2871,    -1,
    2873,  2874,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2885,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2514,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2988,    -1,  2544,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2560,  2561,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2569,  2570,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2584,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2595,    -1,
      -1,    -1,  2599,  2600,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2609,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2629,    -1,    -1,    -1,  2633,    -1,  2635,    -1,
      -1,    -1,    -1,  2640,    -1,    -1,    -1,    -1,  2645,    -1,
      -1,  2648,    -1,    -1,  2651,  6209,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6219,    -1,  2664,    -1,    -1,
      -1,    -1,  2669,  2670,    -1,    -1,    -1,    -1,  3121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1040,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3185,  3186,    -1,  2742,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3199,    -1,    -1,    -1,
    3203,    -1,    -1,  6317,    -1,    -1,    -1,    -1,    -1,  3212,
    2767,  3214,    -1,  3216,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2780,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2800,    -1,  3248,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2816,
      -1,    -1,  2819,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2827,    -1,    -1,    -1,    -1,  6778,    -1,    -1,  6392,    -1,
    3283,    -1,    -1,    -1,    -1,    -1,  2843,    -1,  2845,    -1,
      -1,  3294,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2861,  6419,    -1,  2864,  2865,  2866,
    2867,    -1,    -1,    -1,  2871,    -1,    -1,  2874,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2885,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6476,    -1,  6478,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6534,    -1,    -1,  6537,    -1,    -1,  6540,    -1,    -1,    -1,
      -1,  2988,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3473,  3474,    -1,  3476,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6621,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6644,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3121,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6690,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3610,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6730,    -1,    -1,  6733,
      -1,  6735,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7161,  6773,
    7163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3238,    -1,  6797,    -1,  3242,    -1,    -1,    -1,    -1,
    6804,    -1,    -1,    -1,    -1,    -1,    -1,  6811,  3255,    -1,
      -1,    -1,    -1,    -1,  3261,  6819,    -1,    -1,    -1,  3266,
      -1,    -1,  3269,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3285,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3297,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3325,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3790,  3791,    -1,
      -1,    -1,    -1,    -1,  3351,  3798,    -1,    -1,    -1,    -1,
    3357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3837,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3848,  3849,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3859,  3860,  3861,  3862,
    3863,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3874,  3875,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3441,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3904,    -1,    -1,    -1,  3908,    -1,    -1,    -1,  3912,
      -1,    -1,    -1,    -1,    -1,    -1,  3473,  3474,    -1,  3476,
      -1,    -1,    -1,    -1,    -1,    -1,  3929,    -1,  3931,  3932,
    3933,  3934,  3935,  3936,  3937,    -1,    -1,  3940,  3941,  3942,
    3943,    -1,    -1,    -1,    -1,    -1,    -1,  3950,  3951,    -1,
      -1,    -1,    -1,    -1,  3957,  3958,  3959,  3960,  3961,  3962,
    3963,    -1,    -1,    -1,    -1,  3968,  3969,  3970,  3971,  7083,
      -1,    -1,    -1,    -1,  3531,  3978,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3541,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4000,  4001,  4002,
    4003,  4004,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3567,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4029,    -1,  4031,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  7151,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4051,  4052,
    4053,  4054,    -1,  4056,    -1,    -1,  4059,  4060,  4061,  4062,
    4063,  4064,  4065,  4066,  4067,  4068,    -1,  7181,    -1,    -1,
      -1,    -1,    -1,    -1,  4077,  4078,    -1,    -1,  4081,  4082,
    4083,  4084,    -1,  4086,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4101,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4109,    -1,  4111,    -1,
    4113,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4124,  4125,    -1,  4127,    -1,    -1,  4130,    -1,    -1,
    4133,    -1,  4135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4144,  4145,    -1,  4147,    -1,    -1,  4150,    -1,    -1,
    4153,  4154,  4155,  4156,  4157,  4158,  4159,  4160,  4161,  4162,
      -1,    -1,    -1,    -1,    -1,  4168,    -1,  4170,    -1,  4172,
    4173,  4174,  4175,  4176,    -1,    -1,    -1,  4180,    -1,  4182,
    4183,    -1,    -1,  4186,  4187,  4188,  4189,  4190,  4191,    -1,
      -1,    -1,    -1,  4196,  4197,  4198,    -1,    -1,    -1,  4202,
      -1,    -1,    -1,    -1,    -1,    -1,  4209,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4218,  4219,  4220,  4221,  4222,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3798,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3874,  3875,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3912,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3929,    -1,  3931,  3932,    -1,  3934,  3935,  3936,
    3937,    -1,    -1,    -1,  3941,  3942,  3943,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3951,    -1,    -1,    -1,    -1,    -1,
    3957,  3958,  3959,  3960,  3961,  3962,  3963,    -1,    -1,    -1,
      -1,    -1,  3969,  3970,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4442,
      -1,    -1,    -1,  4000,  4001,  4002,  4003,  4004,    -1,    -1,
      -1,    -1,    -1,  4456,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4052,  4053,  4054,    -1,    -1,
      -1,    -1,    -1,  4060,  4061,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4515,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4531,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4543,  4098,  4545,    -1,  4101,    -1,    -1,  4550,    -1,    -1,
      -1,    -1,  4109,    -1,  4111,    -1,  4113,    -1,    -1,    -1,
    4563,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4589,  4590,  4145,    -1,
      -1,    -1,    -1,    -1,  4597,  4598,    -1,  4154,  4155,  4156,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4168,    -1,  4170,    -1,  4172,  4173,  4174,  4175,  4176,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4188,  4189,  4190,  4191,    -1,    -1,    -1,    -1,  4196,
    4197,  4198,    -1,    -1,    -1,    -1,  2560,  2561,    -1,    -1,
      -1,    -1,    -1,    -1,  2568,  2569,    -1,    -1,    -1,    -1,
      -1,  4218,  4219,  4220,  4221,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2595,    -1,    -1,    -1,  2599,  2600,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2609,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4713,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2635,    -1,    -1,    -1,    -1,  2640,    -1,    -1,    -1,
      -1,  2645,    -1,    -1,  2648,  4738,    -1,  2651,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2664,    -1,    -1,    -1,    -1,  2669,  2670,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4768,    -1,  4770,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4835,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4442,  2800,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4453,    -1,    -1,  4456,
      -1,    -1,  2816,  2817,    -1,  2819,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2827,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2843,
      -1,  2845,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2864,  2865,  2866,  2867,    -1,    -1,    -1,  2871,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4543,    -1,  4545,    -1,
      -1,    -1,    -1,  4550,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4563,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4573,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4589,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4597,  4598,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4606,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4615,    -1,
      -1,    -1,    -1,  4620,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2988,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1340,    -1,    -1,  5097,  5098,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5146,    -1,    -1,    -1,  5150,    -1,    -1,
    5153,  5154,  5155,  5156,    -1,    -1,  4713,  5160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5175,    -1,  5177,    -1,    -1,    -1,    -1,    -1,
      -1,  4738,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3121,    -1,    -1,
      -1,  4768,    -1,  4770,    -1,  4772,    -1,    -1,    -1,    -1,
    4777,    -1,  5225,    -1,    -1,  5228,  5229,  5230,  5231,    -1,
      -1,  5234,  5235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1514,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5279,    -1,  4835,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3225,    -1,    -1,    -1,    -1,  5319,  5320,    -1,    -1,
      -1,  3235,  5325,    -1,  3238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5348,    -1,  3261,    -1,    -1,
    5353,    -1,  3266,  5356,  5357,  3269,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3277,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3351,    -1,    -1,
      -1,    -1,    -1,  3357,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5115,  3473,
    3474,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5154,  5155,  5156,
      -1,    -1,    -1,  5160,    -1,    -1,    -1,  5610,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3531,  5175,    -1,
    5177,    -1,  3536,    -1,    -1,    -1,    -1,  3541,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3567,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5225,    -1,
      -1,  5228,  5229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5319,  5320,    -1,    -1,    -1,    -1,  5325,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5348,    -1,    -1,    -1,    -1,  5353,    -1,    -1,  5356,
    5357,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5873,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3798,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3874,  3875,    -1,    -1,  5967,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5979,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3904,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3912,  6002,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3929,    -1,  3931,  3932,    -1,
    3934,  3935,  3936,  3937,    -1,    -1,    -1,  3941,  3942,  3943,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3960,  3961,  3962,  3963,
      -1,    -1,    -1,  5610,    -1,  3969,  3970,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4000,  4001,  4002,  4003,
    4004,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4052,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2425,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4098,    -1,    -1,  4101,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4109,    -1,  4111,    -1,  4113,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4153,
      -1,  4155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6256,  4168,    -1,  4170,    -1,  4172,  4173,
    4174,  4175,  4176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4196,  4197,  4198,    -1,    -1,    -1,    -1,    -1,
      -1,  2540,  2541,  2542,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4218,  4219,  4220,  4221,    -1,    -1,
      -1,  2560,  2561,    -1,    -1,    -1,  5873,    -1,    -1,    -1,
      -1,  2570,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2584,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2595,    -1,    -1,    -1,
    2599,  2600,  2601,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2609,    -1,    -1,    -1,  2613,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2629,    -1,    -1,    -1,  2633,    -1,  2635,  2636,    -1,    -1,
      -1,  2640,    -1,    -1,    -1,    -1,  2645,    -1,    -1,  2648,
      -1,    -1,  2651,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2664,    -1,    -1,    -1,    -1,
      -1,    -1,  5979,  2672,  2673,  2674,  2675,  2676,  2677,  2678,
    2679,  2680,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6002,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2716,  2717,  2718,
      -1,    -1,  2721,  2722,  2723,  2724,  2725,  2726,  2727,  2728,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2737,    -1,
      -1,    -1,    -1,  2742,  2743,    -1,    -1,    -1,    -1,    -1,
      -1,  2750,  2751,  2752,  2753,  2754,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2764,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2772,    -1,    -1,    -1,    -1,  4442,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4453,
      -1,    -1,  4456,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2803,    -1,    -1,    -1,  2807,    -1,
      -1,  2810,    -1,  2812,    -1,    -1,    -1,  2816,  2817,  2818,
      -1,  2820,    -1,  2822,    -1,  2824,  2825,    -1,  2827,    -1,
    2829,    -1,    -1,  2832,    -1,    -1,  2835,    -1,    -1,    -1,
    2839,    -1,    -1,  2842,    -1,    -1,  2845,  2846,    -1,  2848,
      -1,    -1,    -1,    -1,    -1,  2854,    -1,  2856,  2857,  2858,
    2859,  2860,  2861,  2862,  2863,  2864,  2865,  2866,  2867,    -1,
      -1,    -1,  2871,    -1,    -1,    -1,    -1,    -1,    -1,  4543,
      -1,  4545,    -1,    -1,    -1,    -1,  4550,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4563,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4573,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4606,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4615,    -1,    -1,    -1,    -1,  4620,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6778,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4738,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4768,    -1,  4770,    -1,  4772,    -1,
      -1,    -1,    -1,  4777,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3148,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4835,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3185,  3186,    -1,  3188,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3199,    -1,    -1,    -1,  3203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3212,    -1,  3214,    -1,  3216,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3225,    -1,  6981,    -1,
      -1,    -1,    -1,    -1,    -1,  6988,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3255,    -1,    -1,    -1,
      -1,    -1,  3261,    -1,    -1,    -1,    -1,  3266,    -1,    -1,
    3269,    -1,    -1,  3272,    -1,    -1,    -1,    -1,  3277,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3285,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3297,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3325,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3351,    -1,    -1,    -1,    -1,    -1,  3357,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3383,    -1,    -1,    -1,    -1,    -1,
    3389,    -1,    -1,  3392,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  7161,    -1,
    7163,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3420,    -1,    -1,  3423,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3441,    -1,    -1,    -1,    -1,    -1,  3447,    -1,
      -1,  5115,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6778,    -1,    -1,    -1,  3474,    -1,    -1,    -1,    -1,
      -1,    -1,  5146,    -1,    -1,    -1,  5150,    -1,    -1,    -1,
    5154,  5155,  5156,    -1,    -1,    -1,  5160,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5175,    -1,  5177,    -1,    -1,    -1,    -1,    -1,    -1,
    3519,    -1,    -1,   771,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3531,    -1,    -1,    -1,    -1,  3536,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3558,
      -1,  5225,    -1,    -1,  3563,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3580,    -1,    -1,    -1,    -1,  3585,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   857,
     858,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5319,  5320,    -1,    -1,    -1,
      -1,  5325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   924,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5348,    -1,    -1,   935,    -1,  5353,
      -1,    -1,  5356,  5357,   942,   943,   944,   945,   946,   947,
     948,   949,   950,   951,   952,   953,   954,   955,   956,   957,
     958,   959,   960,   961,   962,   963,   964,   965,   966,   967,
     968,   969,   970,   971,   972,   973,   974,   975,   976,   977,
     978,   979,   980,   981,   982,   983,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1000,    -1,  1002,    -1,  1004,    -1,    -1,    -1,
    1008,  1009,    -1,  1011,    -1,  1013,    -1,  1015,    -1,  1017,
      -1,  1019,    -1,  1021,    -1,  1023,    -1,  1025,    -1,  1027,
      -1,  1029,    -1,  1031,  1032,    -1,  1034,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3798,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3837,  3838,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3848,
    3849,    -1,    -1,    -1,  7161,    -1,  7163,    -1,    -1,    -1,
    3859,  3860,    -1,  3862,  3863,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3874,  3875,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1147,
      -1,    -1,    -1,    -1,    -1,  3904,    -1,    -1,    -1,  3908,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3929,    -1,    -1,    -1,  3933,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3943,    -1,  5610,    -1,    -1,    -1,
      -1,  3950,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3960,  3961,    -1,    -1,    -1,    -1,    -1,    -1,  3968,
    3969,  3970,  3971,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4000,    -1,  4002,  4003,  4004,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4052,    -1,    -1,    -1,  4056,    -1,    -1,
      -1,  4060,  4061,    -1,  4063,  4064,    -1,  4066,  4067,  4068,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4077,    -1,
      -1,    -1,    -1,  4082,  4083,  4084,    -1,  4086,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4098,
      -1,    -1,  4101,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4135,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4144,  4145,    -1,  4147,    -1,
      -1,  4150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4168,
      -1,  4170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4196,    -1,  4198,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5873,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4218,
      -1,  4220,  4221,  4222,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5979,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6002,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4442,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4453,    -1,    -1,  4456,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4488,
      -1,    -1,  4491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4543,    -1,  4545,    -1,    -1,    -1,
      -1,  4550,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4558,
      -1,    -1,    -1,    -1,  4563,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,  4592,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,  4606,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,  4615,    46,    -1,    -1,
      -1,  4620,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4738,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4768,
      -1,  4770,    -1,  4772,    -1,    -1,    -1,    -1,  4777,    -1,
      -1,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,  4835,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6778,    -1,  5115,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5155,  5156,    -1,    -1,
      -1,  5160,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2431,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2453,  2454,  2455,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2464,  2465,  2466,  2467,
      -1,    -1,    -1,    -1,    -1,    -1,  5225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2489,  2490,  2491,    -1,    -1,  2494,  2495,    -1,    -1,
    2498,    -1,    -1,    -1,    -1,  2503,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5319,  5320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5348,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5356,  5357,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  7161,    -1,  7163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5610,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,  3111,  3112,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,  5873,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3234,    -1,    -1,  3237,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6002,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3260,    -1,  3262,  3263,  3264,  3265,    -1,  3267,
    3268,    -1,  3270,    -1,    -1,    -1,    -1,  3275,  3276,    -1,
    3278,  3279,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3295,  3296,    -1,
    3298,  3299,  3300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3318,    -1,  3320,    -1,  3322,    -1,  3324,    -1,  3326,  3327,
    3328,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3337,
      -1,    -1,    -1,    -1,  3342,    -1,    -1,    -1,    -1,    -1,
    3348,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3370,  3371,  3372,  3373,  3374,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3426,  3427,
    3428,    -1,  3430,    -1,    -1,  3433,  3434,    -1,    -1,  3437,
    3438,  3439,  3440,    -1,    -1,    -1,  3444,  3445,  3446,    -1,
    3448,  3449,  3450,  3451,  3452,  3453,  3454,  3455,  3456,  3457,
      -1,    -1,  3460,    -1,  3462,    -1,  3464,  3465,  3466,  3467,
    3468,  3469,  3470,  3471,  3472,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6256,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3515,  3516,    -1,
    3518,    -1,    -1,    -1,    -1,    -1,    -1,  3525,  3526,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3539,  3540,    -1,  3542,  3543,  3544,  3545,  3546,    -1,
      -1,  3549,  3550,  3551,  3552,  3553,  3554,  3555,  3556,  3557,
      -1,  3559,  3560,    -1,    -1,    -1,    -1,    -1,  3566,    -1,
    3568,    -1,    -1,  3571,  3572,  3573,  3574,  3575,  3576,  3577,
    3578,  3579,    -1,  3581,  3582,  3583,  3584,    -1,  3586,  3587,
    3588,  3589,  3590,  3591,  3592,  3593,  3594,    -1,    -1,  3597,
    3598,  3599,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3612,  3613,  3614,  3615,  3616,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3726,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3749,  3750,     1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,  3761,  3762,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    29,    30,    31,    32,    33,    34,    35,  3786,    -1,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,    -1,    -1,
     148,   149,   150,   151,   152,   153,   154,    -1,   156,   157,
     158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3949,    -1,    -1,    -1,    -1,    -1,  3955,  3956,    -1,
      -1,    -1,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,    -1,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6981,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4471,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4577,
    4578,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4645,  4646,  4647,
    4648,    -1,    -1,  4651,  4652,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4668,  4669,    -1,  4671,    -1,  4673,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,  4762,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,  4779,  4780,    42,    43,    -1,    -1,    46,    -1,  4787,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,
      -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4933,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,     1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,     1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,
    1135,  1136,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,
    1135,  1136,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,     1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,     1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,
    1135,  1136,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,
    1135,  1136,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,     1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,     1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,
    1135,  1136,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,
    1135,  1136,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,     1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
       1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,     1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,     7,     8,    -1,    10,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    24,    25,    26,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,
      -1,    62,    63,    64,    -1,    -1,    -1,    68,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    93,    -1,  1135,  1136,    97,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,
      -1,   192,   193,   194,    -1,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   267,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,
    1135,  1136,    -1,    -1,    -1,    -1,    -1,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   764,   765,   766,   767,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   777,   778,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,
    1121,    -1,    -1,    -1,  1125,    -1,     1,    -1,    -1,  1130,
      -1,  1132,     7,     8,  1135,    10,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      55,    56,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,    -1,   124,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,   148,   149,   150,   151,   152,   153,
     154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,    -1,    -1,    -1,   190,    -1,   192,   193,   194,
      -1,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
      -1,    -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,    -1,    -1,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,   267,    -1,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,    -1,    -1,
    1125,    -1,     1,    -1,    -1,  1130,    -1,  1132,     7,     8,
    1135,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    54,    55,    56,    -1,    -1,
      -1,    -1,    -1,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   267,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,     7,     8,  1135,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   485,   486,   487,   488,   489,   490,   491,    -1,
     493,   494,   495,    -1,    -1,    -1,   499,   500,   501,   502,
      -1,    -1,   505,   506,    -1,   508,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    44,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   115,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   507,   508,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   115,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   507,   508,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,     7,     8,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
      -1,    -1,  1125,    -1,    -1,     1,    -1,  1130,    -1,  1132,
      -1,     7,  1135,  1136,    10,    11,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,
      26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,
      56,    -1,    -1,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    -1,    70,    71,    72,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   119,    -1,    -1,   122,    -1,   124,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,
     176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,
     186,    -1,    -1,    -1,   190,    -1,   192,   193,   194,    -1,
      -1,   197,   198,   199,   200,   201,   202,   203,    -1,    -1,
      -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   584,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   617,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   649,   650,   651,   652,   653,   654,   655,
     656,   657,   658,   659,   660,   661,   662,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   687,   688,   689,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   733,   734,   735,
     736,   737,   738,   739,   740,   741,   742,   743,   744,   745,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
     756,   757,   758,   759,   760,   761,   762,   763,   764,   765,
     766,   767,   768,   769,   770,   771,   772,   773,   774,   775,
     776,   777,   778,   779,   780,   781,   782,   783,   784,   785,
     786,   787,   788,   789,   790,   791,   792,   793,   794,   795,
     796,   797,   798,   799,   800,   801,   802,   803,   804,   805,
     806,   807,   808,   809,   810,   811,   812,   813,   814,   815,
     816,   817,   818,   819,   820,   821,   822,   823,   824,   825,
     826,   827,   828,   829,   830,   831,   832,   833,   834,   835,
     836,   837,   838,   839,   840,   841,   842,   843,   844,   845,
     846,   847,   848,   849,   850,   851,   852,   853,   854,   855,
     856,   857,   858,   859,   860,   861,   862,   863,   864,   865,
     866,   867,   868,   869,   870,   871,   872,   873,   874,   875,
     876,   877,   878,   879,   880,   881,   882,   883,   884,   885,
     886,   887,   888,   889,   890,   891,   892,   893,   894,   895,
     896,   897,   898,   899,   900,   901,   902,   903,   904,   905,
     906,   907,   908,   909,   910,   911,   912,   913,   914,   915,
     916,   917,   918,   919,   920,   921,   922,   923,   924,   925,
     926,   927,   928,   929,   930,   931,   932,   933,   934,   935,
     936,   937,   938,   939,   940,   941,   942,   943,   944,   945,
     946,   947,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   960,   961,   962,   963,   964,   965,
     966,   967,   968,   969,   970,   971,   972,   973,   974,   975,
     976,   977,   978,   979,   980,   981,   982,   983,   984,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,
    1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,
    1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,
    1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,
    1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,
    1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,
    1116,  1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,  1125,
      10,    11,    -1,    -1,  1130,    15,    16,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,
      -1,    -1,    62,    63,    64,    -1,    -1,    -1,    68,    -1,
      70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,    -1,
      -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,    -1,
     190,    -1,   192,   193,   194,    -1,    -1,   197,   198,   199,
     200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,   209,
     210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   618,   619,
     620,   621,   622,   623,   624,   625,   626,   627,   628,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   662,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   687,   688,   689,
     690,   691,   692,   693,   694,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   705,   706,   707,   708,   709,
     710,   711,   712,   713,   714,   715,   716,   717,   718,   719,
     720,   721,   722,   723,   724,   725,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,   746,   747,   748,   749,
     750,   751,   752,   753,   754,   755,   756,   757,   758,   759,
     760,   761,   762,   763,   764,   765,   766,   767,   768,   769,
     770,   771,   772,   773,   774,   775,   776,   777,   778,   779,
     780,   781,   782,   783,   784,   785,   786,   787,   788,   789,
     790,   791,   792,   793,   794,   795,   796,   797,   798,   799,
     800,   801,   802,   803,   804,   805,   806,   807,   808,   809,
     810,   811,   812,   813,   814,   815,   816,   817,   818,   819,
     820,   821,   822,   823,   824,   825,   826,   827,   828,   829,
     830,   831,   832,   833,   834,   835,   836,   837,   838,   839,
     840,   841,   842,   843,   844,   845,   846,   847,   848,   849,
     850,   851,   852,   853,   854,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     870,   871,   872,   873,   874,   875,   876,   877,   878,   879,
     880,   881,   882,   883,   884,   885,   886,   887,   888,   889,
     890,   891,   892,   893,   894,   895,   896,   897,   898,   899,
     900,   901,   902,   903,   904,   905,   906,   907,   908,   909,
     910,   911,   912,   913,   914,   915,   916,   917,   918,   919,
     920,   921,   922,   923,   924,   925,   926,   927,   928,   929,
     930,   931,   932,   933,   934,   935,   936,   937,   938,   939,
     940,   941,   942,   943,   944,   945,   946,   947,   948,   949,
     950,   951,   952,   953,   954,   955,   956,   957,   958,   959,
     960,   961,   962,   963,   964,   965,   966,   967,   968,   969,
     970,   971,   972,   973,   974,   975,   976,   977,   978,   979,
     980,   981,   982,   983,   984,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,
    1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,
    1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,
    1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,
    1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,
    1120,  1121,    -1,     7,    -1,  1125,    10,    11,    -1,    -1,
    1130,    15,    16,    17,    -1,  1135,    -1,    -1,    -1,    -1,
      24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      54,    55,    56,    -1,    -1,    -1,    -1,    -1,    62,    63,
      64,    -1,    -1,    -1,    68,    -1,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,    -1,
     124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,
      -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,   193,
     194,    -1,    -1,   197,   198,   199,   200,   201,   202,   203,
      -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,   730,   731,   732,   733,
     734,   735,   736,   737,   738,   739,   740,   741,   742,   743,
     744,   745,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,   756,   757,   758,   759,   760,   761,   762,   763,
     764,   765,   766,   767,   768,   769,   770,   771,   772,   773,
     774,   775,   776,   777,   778,   779,   780,   781,   782,   783,
     784,   785,   786,   787,   788,   789,   790,   791,   792,   793,
     794,   795,   796,   797,   798,   799,   800,   801,   802,   803,
     804,   805,   806,   807,   808,   809,   810,   811,   812,   813,
     814,   815,   816,   817,   818,   819,   820,   821,   822,   823,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   835,   836,   837,   838,   839,   840,   841,   842,   843,
     844,   845,   846,   847,   848,   849,   850,   851,   852,   853,
     854,   855,   856,   857,   858,   859,   860,   861,   862,   863,
     864,   865,   866,   867,   868,   869,   870,   871,   872,   873,
     874,   875,   876,   877,   878,   879,   880,   881,   882,   883,
     884,   885,   886,   887,   888,   889,   890,   891,   892,   893,
     894,   895,   896,   897,   898,   899,   900,   901,   902,   903,
     904,   905,   906,   907,   908,   909,   910,   911,   912,   913,
     914,   915,   916,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,   935,   936,   937,   938,   939,   940,   941,   942,   943,
     944,   945,   946,   947,   948,   949,   950,   951,   952,   953,
     954,   955,   956,   957,   958,   959,   960,   961,   962,   963,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,   976,   977,   978,   979,   980,   981,   982,   983,
     984,   985,   986,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,
    1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,
    1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,
    1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,
    1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
    1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,
    1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,     7,
      -1,  1125,    10,    11,    -1,    -1,  1130,    15,    16,    17,
      -1,  1135,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    54,    55,    56,    -1,
      -1,    -1,    -1,    -1,    62,    63,    64,    -1,    -1,    -1,
      68,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,
      98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,
      -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,
      -1,    -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,
     198,   199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,
      -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   511,   512,   513,   514,   515,   516,   517,
     518,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   552,   553,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,   583,   584,   585,   586,   587,
     588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   606,   607,
     608,   609,   610,   611,   612,   613,   614,   615,   616,   617,
     618,   619,   620,   621,   622,   623,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   649,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   662,   663,   664,   665,   666,   667,
     668,   669,   670,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   683,   684,   685,   686,   687,
     688,   689,   690,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   703,   704,   705,   706,   707,
     708,   709,   710,   711,   712,   713,   714,   715,   716,   717,
     718,   719,   720,   721,   722,   723,   724,   725,   726,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,   737,
     738,   739,   740,   741,   742,   743,   744,   745,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,   756,   757,
     758,   759,   760,   761,   762,   763,   764,   765,   766,   767,
     768,   769,   770,   771,   772,   773,   774,   775,   776,   777,
     778,   779,   780,   781,   782,   783,   784,   785,   786,   787,
     788,   789,   790,   791,   792,   793,   794,   795,   796,   797,
     798,   799,   800,   801,   802,   803,   804,   805,   806,   807,
     808,   809,   810,   811,   812,   813,   814,   815,   816,   817,
     818,   819,   820,   821,   822,   823,   824,   825,   826,   827,
     828,   829,   830,   831,   832,   833,   834,   835,   836,   837,
     838,   839,   840,   841,   842,   843,   844,   845,   846,   847,
     848,   849,   850,   851,   852,   853,   854,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   864,   865,   866,   867,
     868,   869,   870,   871,   872,   873,   874,   875,   876,   877,
     878,   879,   880,   881,   882,   883,   884,   885,   886,   887,
     888,   889,   890,   891,   892,   893,   894,   895,   896,   897,
     898,   899,   900,   901,   902,   903,   904,   905,   906,   907,
     908,   909,   910,   911,   912,   913,   914,   915,   916,   917,
     918,   919,   920,   921,   922,   923,   924,   925,   926,   927,
     928,   929,   930,   931,   932,   933,   934,   935,   936,   937,
     938,   939,   940,   941,   942,   943,   944,   945,   946,   947,
     948,   949,   950,   951,   952,   953,   954,   955,   956,   957,
     958,   959,   960,   961,   962,   963,   964,   965,   966,   967,
     968,   969,   970,   971,   972,   973,   974,   975,   976,   977,
     978,   979,   980,   981,   982,   983,   984,   985,   986,   987,
     988,   989,   990,   991,   992,   993,   994,   995,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,
    1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,
    1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,
    1118,  1119,  1120,  1121,    -1,     7,    -1,  1125,    10,    11,
      -1,    -1,  1130,    15,    16,    17,    -1,  1135,    -1,    -1,
      -1,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,    -1,
      62,    63,    64,    -1,    -1,    -1,    68,    -1,    70,    71,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,
     122,    -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,
     182,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,
     192,   193,   194,    -1,    -1,   197,   198,   199,   200,   201,
     202,   203,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   511,
     512,   513,   514,   515,   516,   517,   518,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,   747,   748,   749,   750,   751,
     752,   753,   754,   755,   756,   757,   758,   759,   760,   761,
     762,   763,   764,   765,   766,   767,   768,   769,   770,   771,
     772,   773,   774,   775,   776,   777,   778,   779,   780,   781,
     782,   783,   784,   785,   786,   787,   788,   789,   790,   791,
     792,   793,   794,   795,   796,   797,   798,   799,   800,   801,
     802,   803,   804,   805,   806,   807,   808,   809,   810,   811,
     812,   813,   814,   815,   816,   817,   818,   819,   820,   821,
     822,   823,   824,   825,   826,   827,   828,   829,   830,   831,
     832,   833,   834,   835,   836,   837,   838,   839,   840,   841,
     842,   843,   844,   845,   846,   847,   848,   849,   850,   851,
     852,   853,   854,   855,   856,   857,   858,   859,   860,   861,
     862,   863,   864,   865,   866,   867,   868,   869,   870,   871,
     872,   873,   874,   875,   876,   877,   878,   879,   880,   881,
     882,   883,   884,   885,   886,   887,   888,   889,   890,   891,
     892,   893,   894,   895,   896,   897,   898,   899,   900,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,   911,
     912,   913,   914,   915,   916,   917,   918,   919,   920,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,   931,
     932,   933,   934,   935,   936,   937,   938,   939,   940,   941,
     942,   943,   944,   945,   946,   947,   948,   949,   950,   951,
     952,   953,   954,   955,   956,   957,   958,   959,   960,   961,
     962,   963,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,   976,   977,   978,   979,   980,   981,
     982,   983,   984,   985,   986,   987,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,   998,   999,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,
    1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
    1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,
    1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,
       8,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,
      -1,    19,    -1,  1135,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    52,    53,    54,    55,    -1,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      -1,    -1,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,   149,   150,   151,   152,   153,   154,    -1,   156,   157,
     158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,    -1,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   485,   486,   487,
     488,   489,   490,   491,     8,   493,   494,   495,    -1,    -1,
      -1,   499,   500,   501,   502,    19,    -1,   505,   506,    -1,
     508,    -1,    -1,    -1,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,
      54,    55,    -1,    -1,    -1,    59,    60,    61,    62,    63,
      -1,    -1,    -1,    67,    -1,    -1,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,   153,
     154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    -1,    -1,    -1,    59,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    -1,    -1,    70,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,
      -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    52,    53,    54,    55,    -1,    -1,
      -1,    59,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      -1,    -1,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,   149,   150,   151,   152,   153,   154,    -1,   156,   157,
     158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,
      -1,  1135,  1136,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,    -1,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    -1,
      -1,    -1,    59,    60,    61,    62,    63,    -1,    -1,    -1,
      67,    -1,    -1,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      52,    53,    54,    55,    -1,    -1,    -1,    59,    60,    61,
      62,    63,    -1,    -1,    -1,    67,    -1,    -1,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,   158,   159,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,
      -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,
      -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
      -1,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,    -1,    -1,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    -1,    -1,    -1,    59,    60,
      61,    62,    63,    -1,    -1,    -1,    67,    -1,    -1,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,
      -1,    -1,    -1,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    -1,    -1,    70,    71,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   148,   149,   150,   151,   152,   153,   154,    -1,
     156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,
    1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,    -1,    -1,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    -1,    -1,    -1,    59,    60,    61,    62,    63,    -1,
      -1,    -1,    67,    -1,    -1,    70,    71,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,
      -1,    -1,    52,    53,    -1,    -1,    -1,    -1,    -1,    59,
      60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,
     150,   151,   152,   153,   154,    -1,   156,   157,   158,   159,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,
      -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,
    1136,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,    -1,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,    -1,    -1,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    -1,    -1,    -1,    -1,    -1,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,
    1135,  1136,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,   448,
      -1,    -1,   451,   452,    -1,    -1,   455,   456,    -1,    -1,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,   153,
     154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,
    1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,   149,   150,   151,   152,   153,   154,    -1,   156,   157,
     158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,
      -1,  1135,  1136,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,    -1,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,   158,   159,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,
      -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,
      -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
      -1,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,    -1,    -1,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   148,   149,   150,   151,   152,   153,   154,    -1,
     156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1125,    -1,    -1,    -1,  1129,  1130,    -1,
    1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,    -1,    -1,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,
      -1,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,
     150,   151,   152,   153,   154,    -1,   156,   157,   158,   159,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,
      -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,
    1136,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,    -1,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,    -1,    -1,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,
    1135,  1136,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,   153,
     154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,
    1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,   149,   150,   151,   152,   153,   154,    -1,   156,   157,
     158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,
      -1,  1135,  1136,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,    -1,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,   158,   159,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,
      -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,
      -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
      -1,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,    -1,    -1,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,
      46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   148,   149,   150,   151,   152,   153,   154,    -1,
     156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,
    1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,    -1,
      -1,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,    -1,    -1,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
      -1,    -1,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,
      -1,    -1,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,
     150,   151,   152,   153,   154,    -1,   156,   157,   158,   159,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,
      -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,
      -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,
    1136,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,    -1,    -1,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,    -1,    -1,
      -1,   351,    -1,    -1,   354,   355,   356,   357,   358,   359,
     360,   361,    -1,    -1,    -1,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,
     149,   150,   151,   152,   153,   154,    -1,   156,   157,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,
    1135,  1136,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,    -1,    -1,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,    -1,
      -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    -1,    -1,    -1,    42,    43,
      -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,   153,
     154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,
    1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,    -1,    -1,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,    -1,
     354,   355,   356,   357,   358,   359,   360,   361,    -1,    -1,
      -1,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,   152,
     153,   154,    -1,   156,   157,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,    -1,
      -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,
      -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    -1,    -1,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,    -1,    -1,    -1,   351,    -1,
      -1,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    52,    53,    -1,    -1,    -1,    -1,
      -1,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     148,   149,   150,   151,   152,   153,   154,    -1,   156,   157,
     158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,    -1,
      -1,  1135,  1136,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,    -1,    -1,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
      -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,    -1,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    -1,    -1,    -1,
      -1,    -1,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,  1132,
      -1,    -1,  1135,  1136,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,    -1,    -1,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,    -1,    -1,    -1,   351,    -1,    -1,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   459,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      52,    53,    -1,    -1,    -1,    -1,    -1,    59,    60,    61,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,   151,
     152,   153,   154,    -1,   156,   157,   158,   159,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,    -1,
      -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,    -1,
      -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,    -1,    -1,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,    -1,    -1,    -1,   351,
      -1,    -1,   354,   355,   356,   357,   358,   359,   360,   361,
      -1,    -1,    -1,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   453,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    42,    43,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    -1,    -1,    -1,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   148,   149,   150,
     151,   152,   153,   154,    -1,   156,   157,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1125,    -1,
      -1,    -1,    -1,  1130,    -1,  1132,    -1,    -1,  1135,  1136,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,    -1,    -1,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,    -1,    -1,    -1,
     351,    -1,    -1,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,     7,    -1,
      -1,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,    -1,
    1132,    -1,    -1,  1135,  1136,    54,    55,    56,    -1,    -1,
      -1,    -1,    -1,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1125,    -1,    -1,    -1,    -1,  1130,
      -1,  1132,    -1,    -1,  1135,  1136,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,    -1,     7,    -1,  1125,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
       7,    -1,  1125,    10,    11,    -1,    -1,  1130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,    -1,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,    -1,    -1,
      -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,   471,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,
    1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,  1125,    10,
      11,    -1,    -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    97,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,
      -1,   192,   193,   194,    -1,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   485,   486,   487,   488,   489,   490,
     491,    -1,   493,   494,   495,    -1,    -1,    -1,   499,   500,
     501,   502,    -1,    -1,   505,   506,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   764,   765,   766,   767,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   777,   778,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,
    1121,    -1,     7,    -1,  1125,    10,    11,    -1,    -1,  1130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,    -1,   124,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,    -1,    -1,    -1,   190,    -1,   192,   193,   194,
      -1,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
      -1,    -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   477,   478,   479,   480,   481,   482,   483,   484,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,
    1125,    10,    11,    -1,    -1,  1130,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,    -1,     7,    -1,  1125,    10,    11,    -1,
      -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   485,   486,   487,   488,   489,   490,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   508,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
       7,    -1,  1125,    10,    11,    -1,    -1,  1130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      57,    -1,    59,    60,    61,    62,    63,    64,    65,    -1,
      67,    68,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,    -1,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,    -1,    -1,
      -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,
    1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,  1125,    10,
      11,    -1,    -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,
      -1,    62,    63,    64,    -1,    -1,    -1,    68,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    97,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,
      -1,   192,   193,   194,    -1,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   485,   486,   487,   488,   489,   490,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,   508,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   764,   765,   766,   767,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   777,   778,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,
    1121,    -1,     7,    -1,  1125,    10,    11,    -1,    -1,  1130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      55,    56,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,    -1,   124,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,    -1,    -1,    -1,   190,    -1,   192,   193,   194,
      -1,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
      -1,    -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   477,   478,   479,   480,   481,   482,   483,   484,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,
    1125,    10,    11,    -1,    -1,  1130,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,    -1,     7,    -1,  1125,    10,    11,    -1,
      -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
       7,    -1,  1125,    10,    11,    -1,    -1,  1130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,    -1,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,    -1,    -1,
      -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,
    1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,  1125,    10,
      11,    -1,    -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,
      -1,    32,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    55,    56,    57,    -1,    59,    -1,
      -1,    62,    63,    64,    65,    -1,    -1,    68,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    97,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,
      -1,   192,   193,   194,    -1,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   764,   765,   766,   767,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   777,   778,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,
    1121,    -1,     7,    -1,  1125,    10,    11,    -1,    -1,  1130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    46,    -1,    -1,    -1,    -1,    -1,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,    -1,   124,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,    -1,    -1,    -1,   190,    -1,   192,   193,   194,
      -1,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
      -1,    -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,
    1125,    10,    11,    -1,    -1,  1130,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,
      -1,    -1,    -1,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,    -1,     7,    -1,  1125,    10,    11,    -1,
      -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
       7,    -1,  1125,    10,    11,    -1,    -1,  1130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,    -1,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,    -1,    -1,
      -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,
    1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,  1125,    10,
      11,    -1,    -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,
      -1,    32,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    55,    56,    57,    -1,    59,    -1,
      -1,    62,    63,    64,    65,    -1,    -1,    68,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    97,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   113,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,
      -1,   192,   193,   194,    -1,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   764,   765,   766,   767,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   777,   778,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,
    1121,    -1,     7,    -1,  1125,    10,    11,    -1,    -1,  1130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      55,    56,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,    -1,   124,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,    -1,    -1,    -1,   190,    -1,   192,   193,   194,
      -1,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
      -1,    -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,
    1125,    10,    11,    -1,    -1,  1130,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    54,    55,    56,    -1,    -1,
      -1,    -1,    -1,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,    -1,     7,    -1,  1125,    10,    11,    -1,
      -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    54,    55,    56,    -1,    -1,    -1,    -1,    -1,    62,
      63,    64,    -1,    -1,    -1,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
       7,    -1,  1125,    10,    11,    -1,    -1,  1130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    55,    56,
      -1,    -1,    -1,    -1,    -1,    62,    63,    64,    -1,    -1,
      -1,    68,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,    -1,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,    -1,    -1,
      -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,
    1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,  1125,    10,
      11,    -1,    -1,  1130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    97,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,
      -1,   192,   193,   194,    -1,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,    -1,    -1,    -1,    -1,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   764,   765,   766,   767,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   777,   778,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,
    1121,    -1,     7,    -1,  1125,    10,    11,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      55,    56,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,    -1,   124,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,    -1,    -1,    -1,   190,    -1,   192,   193,   194,
      -1,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
      -1,    -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,
    1125,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    54,    55,    56,    -1,    -1,
      -1,    -1,    -1,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,    -1,     7,    -1,  1125,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
       7,    -1,  1125,    10,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,    -1,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,    -1,    -1,
      -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   485,   486,
     487,   488,   489,   490,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,
    1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,  1125,    10,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    97,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,
      -1,   192,   193,   194,    -1,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   507,   508,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   764,   765,   766,   767,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   777,   778,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,
    1121,    -1,     7,    -1,  1125,    10,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      55,    56,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,    -1,   124,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,    -1,    -1,    -1,   190,    -1,   192,   193,   194,
      -1,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
      -1,    -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,
    1125,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    54,    55,    56,    -1,    -1,
      -1,    -1,    -1,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   477,   478,
     479,   480,   481,   482,   483,   484,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,    -1,     7,    -1,  1125,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    54,    55,    56,    -1,    -1,    -1,    -1,    -1,    62,
      63,    64,    -1,    -1,    -1,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
       7,    -1,  1125,    10,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      -1,    -1,    -1,    -1,    -1,    52,    53,    54,    55,    56,
      -1,    -1,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,    -1,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,    -1,    -1,
      -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,
    1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,  1125,    10,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,
      -1,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    97,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,
      -1,   192,   193,   194,    -1,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   764,   765,   766,   767,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   777,   778,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,
    1121,    -1,     7,    -1,  1125,    10,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      55,    56,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,    -1,   124,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,    -1,    -1,    -1,   190,    -1,   192,   193,   194,
      -1,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
      -1,    -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   507,   508,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,
    1125,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    54,    55,    56,    -1,    -1,
      -1,    -1,    -1,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   437,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,    -1,     7,    -1,  1125,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    54,    55,    56,    -1,    -1,    -1,    -1,    -1,    62,
      63,    64,    -1,    -1,    -1,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
       7,    -1,  1125,    10,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    55,    56,
      -1,    -1,    -1,    -1,    -1,    62,    63,    64,    -1,    -1,
      -1,    68,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,    -1,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,    -1,    -1,
      -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,
    1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,  1125,    10,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    55,    56,    -1,    -1,    -1,    -1,
      -1,    62,    63,    64,    -1,    -1,    -1,    68,    -1,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    97,    98,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,
      -1,   122,    -1,   124,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   174,   175,   176,   177,    -1,    -1,    -1,
      -1,   182,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,
      -1,   192,   193,   194,    -1,    -1,   197,   198,   199,   200,
     201,   202,   203,    -1,    -1,    -1,    -1,    -1,   209,   210,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   589,   590,
     591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   608,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   653,   654,   655,   656,   657,   658,   659,   660,
     661,   662,   663,   664,   665,   666,   667,   668,   669,   670,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,   683,   684,   685,   686,   687,   688,   689,   690,
     691,   692,   693,   694,   695,   696,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   708,   709,   710,
     711,   712,   713,   714,   715,   716,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
     731,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,   742,   743,   744,   745,   746,   747,   748,   749,   750,
     751,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   764,   765,   766,   767,   768,   769,   770,
     771,   772,   773,   774,   775,   776,   777,   778,   779,   780,
     781,   782,   783,   784,   785,   786,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   799,   800,
     801,   802,   803,   804,   805,   806,   807,   808,   809,   810,
     811,   812,   813,   814,   815,   816,   817,   818,   819,   820,
     821,   822,   823,   824,   825,   826,   827,   828,   829,   830,
     831,   832,   833,   834,   835,   836,   837,   838,   839,   840,
     841,   842,   843,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   894,   895,   896,   897,   898,   899,   900,
     901,   902,   903,   904,   905,   906,   907,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   988,   989,   990,
     991,   992,   993,   994,   995,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,
    1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,
    1121,    -1,     7,    -1,  1125,    10,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,
      25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      55,    56,    -1,    -1,    -1,    -1,    -1,    62,    63,    64,
      -1,    -1,    -1,    68,    -1,    70,    71,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   119,    -1,    -1,   122,    -1,   124,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,
     175,   176,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,
      -1,   186,    -1,    -1,    -1,   190,    -1,   192,   193,   194,
      -1,    -1,   197,   198,   199,   200,   201,   202,   203,    -1,
      -1,    -1,    -1,    -1,   209,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   792,   793,   794,
     795,   796,   797,   798,   799,   800,   801,   802,   803,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     845,   846,   847,   848,   849,   850,   851,   852,   853,   854,
     855,   856,   857,   858,   859,   860,   861,   862,   863,   864,
     865,   866,   867,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   878,   879,   880,   881,   882,   883,   884,
     885,   886,   887,   888,   889,   890,   891,   892,   893,   894,
     895,   896,   897,   898,   899,   900,   901,   902,   903,   904,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   920,   921,   922,   923,   924,
     925,   926,   927,   928,   929,   930,   931,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,   976,   977,   978,   979,   980,   981,   982,   983,   984,
     985,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,
    1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,
    1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,     7,    -1,
    1125,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    54,    55,    56,    -1,    -1,
      -1,    -1,    -1,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     119,    -1,    -1,   122,    -1,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   174,   175,   176,   177,    -1,
      -1,    -1,    -1,   182,    -1,    -1,    -1,   186,    -1,    -1,
      -1,   190,    -1,   192,   193,   194,    -1,    -1,   197,   198,
     199,   200,   201,   202,   203,    -1,    -1,    -1,    -1,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,   587,   588,
     589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   652,   653,   654,   655,   656,   657,   658,
     659,   660,   661,   662,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,   683,   684,   685,   686,   687,   688,
     689,   690,   691,   692,   693,   694,   695,   696,   697,   698,
     699,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,   744,   745,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,   764,   765,   766,   767,   768,
     769,   770,   771,   772,   773,   774,   775,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   828,
     829,   830,   831,   832,   833,   834,   835,   836,   837,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   940,   941,   942,   943,   944,   945,   946,   947,   948,
     949,   950,   951,   952,   953,   954,   955,   956,   957,   958,
     959,   960,   961,   962,   963,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,   976,   977,   978,
     979,   980,   981,   982,   983,   984,   985,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,
    1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,
    1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,    -1,     7,    -1,  1125,    10,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    54,    55,    56,    -1,    -1,    -1,    -1,    -1,    62,
      63,    64,    -1,    -1,    -1,    68,    -1,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    97,    98,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,   122,
      -1,   124,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   146,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   174,   175,   176,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,   186,    -1,    -1,    -1,   190,    -1,   192,
     193,   194,    -1,    -1,   197,   198,   199,   200,   201,   202,
     203,    -1,    -1,    -1,    -1,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,    -1,
       7,    -1,  1125,    10,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    55,    56,
      -1,    -1,    -1,    -1,    -1,    62,    63,    64,    -1,    -1,
      -1,    68,    -1,    70,    71,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,   122,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   174,   175,   176,
     177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,   186,
      -1,    -1,    -1,   190,    -1,   192,   193,   194,    -1,    -1,
     197,   198,   199,   200,   201,   202,   203,    -1,    -1,    -1,
      -1,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   584,   585,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
     617,   618,   619,   620,   621,   622,   623,   624,   625,   626,
     627,   628,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   649,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   662,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   690,   691,   692,   693,   694,   695,   696,
     697,   698,   699,   700,   701,   702,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   715,   716,
     717,   718,   719,   720,   721,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   770,   771,   772,   773,   774,   775,   776,
     777,   778,   779,   780,   781,   782,   783,   784,   785,   786,
     787,   788,   789,   790,   791,   792,   793,   794,   795,   796,
     797,   798,   799,   800,   801,   802,   803,   804,   805,   806,
     807,   808,   809,   810,   811,   812,   813,   814,   815,   816,
     817,   818,   819,   820,   821,   822,   823,   824,   825,   826,
     827,   828,   829,   830,   831,   832,   833,   834,   835,   836,
     837,   838,   839,   840,   841,   842,   843,   844,   845,   846,
     847,   848,   849,   850,   851,   852,   853,   854,   855,   856,
     857,   858,   859,   860,   861,   862,   863,   864,   865,   866,
     867,   868,   869,   870,   871,   872,   873,   874,   875,   876,
     877,   878,   879,   880,   881,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,   894,   895,   896,
     897,   898,   899,   900,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   993,   994,   995,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
    1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,
    1117,  1118,  1119,  1120,  1121,    -1,    -1,    -1,  1125
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    77,    78,    79,    80,    81,    83,    84,    85,    87,
      89,    91,   100,   101,   265,  1122,  1123,  1124,  1138,  1139,
    1142,  1143,  1144,  1145,  1146,  1147,  1148,  1149,  1151,  1153,
    1156,  1157,  1159,  1160,  1166,  1205,  1212,  1226,  1125,  1165,
     102,  1344,  1347,   107,  1323,  1326,  1327,  1125,  1125,  1125,
    1175,  1182,  1175,  1175,  1175,  1175,    46,    46,  1206,  1175,
    1161,  1163,  1161,  1164,     0,    82,  1171,    46,    60,    61,
      62,    63,    64,    65,    66,    67,  1140,  1255,  1259,  1259,
    1328,  1329,     8,    19,    28,    29,    30,    31,    32,    33,
      34,    35,    42,    43,    46,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    67,   148,   149,   150,   151,
     152,   153,   154,   156,   157,   158,   159,   169,   174,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   351,   354,   355,   356,   357,   358,
     359,   360,   361,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1125,  1130,  1132,  1135,  1136,
    1249,  1250,  1251,  1252,  1257,  1266,  1267,  1268,  1276,  1277,
    1278,  1658,  1662,  1664,  1665,  1668,  1669,  1674,  1682,  1683,
    1689,  1662,    52,    53,    54,    55,    56,    57,    58,    59,
    1140,  1141,  1254,  1255,  1256,     1,  1140,  1256,  1140,  1256,
    1662,  1256,  1227,  1213,  1126,  1207,  1234,  1235,  1158,  1662,
    1162,  1162,     1,    46,    53,    61,   148,   149,   150,   151,
     152,   153,   154,   156,   157,   158,   159,   169,   392,   421,
     424,   425,   426,   431,   432,   433,   434,   435,   436,  1126,
    1140,  1256,  1257,  1279,  1280,  1281,  1557,  1167,  1352,  1352,
      12,    19,    21,    32,    42,    43,    47,    48,    49,    50,
      51,    53,    61,   108,   110,   300,   301,   312,   313,   324,
     325,   336,   337,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   357,   358,   359,   360,   361,   362,   363,   364,
    1130,  1134,  1135,  1175,  1330,  1332,  1334,  1340,  1668,  1674,
      46,    55,    56,    57,    58,    59,    63,    64,    65,    66,
      67,    71,    72,    73,    74,  1659,  1660,    52,    59,  1664,
      32,  1668,    33,  1669,    32,  1668,    33,  1669,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1681,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,   117,  1662,  1269,  1270,
    1680,  1664,  1132,  1127,  1134,  1130,  1134,  1128,  1176,  1182,
       3,     4,     5,     8,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,  1175,
    1176,    11,    37,  1176,  1176,  1176,  1176,  1133,  1181,  1182,
    1176,  1231,  1126,  1172,  1182,   266,  1208,  1126,  1176,  1181,
    1182,  1690,  1690,  1126,    38,    39,    37,    37,    37,    37,
      37,    37,    37,    37,    37,    37,    37,    37,  1175,    37,
      37,    37,    37,    37,    37,    37,    37,    37,    37,    37,
    1127,  1173,  1182,    37,    38,    39,  1173,  1130,  1134,    37,
      37,    75,    76,  1168,  1170,  1125,  1290,  1354,  1354,  1329,
      32,   313,   325,  1135,  1668,  1674,    32,  1135,  1668,  1674,
      18,    20,    41,  1127,  1290,  1341,  1175,  1175,  1339,  1127,
    1175,  1335,  1335,  1341,  1325,  1175,  1338,  1338,  1175,  1336,
    1336,  1336,  1336,  1175,  1337,  1337,  1329,  1341,  1337,  1337,
    1329,  1337,  1337,  1329,  1329,  1329,  1329,  1329,  1329,  1329,
    1329,  1329,  1329,  1269,  1341,    19,    32,  1668,  1329,   108,
     110,     4,  1290,  1331,  1133,  1290,  1333,    18,    20,    41,
    1127,  1329,  1341,  1341,  1130,  1130,  1661,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1175,  1664,  1662,     1,  1662,     1,
    1662,     1,  1662,  1662,     1,  1662,     1,  1662,     1,  1662,
       1,  1662,     1,  1662,     1,  1662,     1,  1662,     1,  1662,
       1,  1662,     1,  1662,     1,  1662,     1,  1662,     1,  1662,
    1685,     1,  1662,  1686,  1664,     1,  1662,     1,  1662,     1,
    1662,    46,  1256,     1,  1662,  1662,     1,  1662,  1662,  1662,
       1,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,     1,
    1662,     1,  1662,     1,  1662,     1,  1662,     1,  1662,  1662,
       1,  1662,     1,  1662,     1,  1662,     1,  1662,     1,  1662,
       1,  1662,     1,  1662,     1,  1662,     1,  1662,     1,  1662,
       1,  1662,  1662,     1,  1662,     1,  1662,     1,  1662,  1937,
    1938,  1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,
    1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,
    1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,  1937,  1664,
    1664,   211,   212,   213,   214,   215,   216,   217,   219,   220,
     221,   223,   224,   225,   226,   227,   228,   230,   231,   233,
     234,   235,   236,   237,   238,   239,  1249,  1176,  1129,  1177,
    1182,  1273,  1662,  1679,  1662,  1670,  1671,  1672,  1673,  1130,
    1178,  1182,    46,  1254,  1255,  1260,  1275,  1662,  1260,     1,
    1178,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,
    1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,  1664,
    1664,  1664,  1150,  1150,  1152,  1152,  1140,  1155,  1256,     1,
    1154,  1172,  1214,  1234,     1,  1216,  1662,     1,  1290,  1691,
    1692,  1693,  1290,  1692,  1693,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1937,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,     1,
     466,   468,    36,  1662,  1249,     1,    36,  1662,  1249,  1275,
    1260,  1662,  1662,  1181,  1176,  1355,  1352,  1352,  1330,  1341,
    1336,  1336,    32,  1668,  1329,  1341,  1341,    32,  1668,  1341,
    1341,  1130,  1130,  1329,  1329,  1329,  1127,  1329,  1260,  1662,
    1329,  1329,  1329,  1662,  1662,  1341,  1341,  1662,  1341,  1341,
    1341,  1341,  1662,  1341,  1341,  1329,  1341,  1341,  1341,  1341,
    1177,  1329,    32,  1668,  1341,  1341,  1330,  1325,  1329,  1332,
    1329,  1329,    18,    20,  1130,  1130,  1260,  1329,  1329,  1664,
    1664,  1691,  1181,  1181,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1664,
    1176,  1133,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1133,  1176,  1176,  1133,  1176,
    1181,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1181,  1176,  1176,  1176,  1176,  1176,  1176,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,
    1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,
    1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,
    1176,  1181,  1176,  1181,  1176,  1181,  1176,  1176,  1176,  1181,
    1181,  1176,  1181,  1176,  1181,  1176,  1181,  1176,  1181,  1176,
    1181,  1176,  1181,  1176,  1181,  1176,  1181,  1176,  1181,  1176,
    1181,  1176,  1181,  1181,  1176,  1181,  1176,  1176,  1176,  1176,
    1176,     7,     8,    10,    11,    19,    24,    25,    26,    28,
      29,    30,    31,    32,    33,    46,    54,    55,    56,    62,
      63,    64,    68,    70,    71,    72,    93,    97,    98,    99,
     119,   122,   124,   126,   146,   174,   175,   176,   177,   182,
     186,   190,   192,   193,   194,   197,   198,   199,   200,   201,
     202,   203,   209,   210,   267,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   649,   650,   651,   652,
     653,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     683,   684,   685,   686,   687,   688,   689,   690,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     703,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
     733,   734,   735,   736,   737,   738,   739,   740,   741,   742,
     743,   744,   745,   746,   747,   748,   749,   750,   751,   752,
     753,   754,   755,   756,   757,   758,   759,   760,   761,   762,
     763,   764,   765,   766,   767,   768,   769,   770,   771,   772,
     773,   774,   775,   776,   777,   778,   779,   780,   781,   782,
     783,   784,   785,   786,   787,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   800,   801,   802,
     803,   804,   805,   806,   807,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     853,   854,   855,   856,   857,   858,   859,   860,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   891,   892,
     893,   894,   895,   896,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   929,   930,   931,   932,
     933,   934,   935,   936,   937,   938,   939,   940,   941,   942,
     943,   944,   945,   946,   947,   948,   949,   950,   951,   952,
     953,   954,   955,   956,   957,   958,   959,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,   976,   977,   978,   979,   980,   981,   982,
     983,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     993,   994,   995,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,
    1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,  1125,
    1130,  1132,  1135,  1175,  1183,  1184,  1185,  1187,  1188,  1190,
    1192,  1196,  1258,  1361,  1668,  1669,  1702,  1722,  1730,  1731,
    1732,  1733,  1734,  1735,  1737,  1739,  1767,  1768,  1769,  1770,
    1771,  1772,  1773,  1774,  1775,  1776,  1777,  1778,  1779,  1780,
    1781,  1782,  1783,  1784,  1785,  1786,  1787,  1789,  1790,  1791,
    1792,  1793,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,
    1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1813,
    1815,  1816,  1817,  1818,  1819,  1820,  1822,  1863,  1866,  1869,
    1927,  1936,  1939,  1940,  1941,  1943,  1944,  1947,  1951,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1664,
       1,  1133,  1272,  1290,  1662,  1675,  1676,  1131,  1133,  1179,
    1182,  1667,     1,  1127,  1133,  1177,  1269,  1176,  1176,   138,
     139,    86,    86,    88,    88,  1181,    92,  1232,  1234,    94,
    1215,   113,   115,   117,   165,  1209,  1134,  1134,  1172,  1172,
    1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,
    1172,  1172,  1176,  1172,  1172,  1172,  1172,  1172,  1172,  1172,
    1172,  1172,  1172,  1172,  1172,  1172,  1172,    37,  1130,  1172,
    1172,  1172,    37,  1130,  1172,  1177,  1172,  1172,  1171,   228,
    1260,  1356,  1127,  1290,  1357,  1357,    13,  1329,  1341,  1341,
    1341,  1329,  1329,  1329,  1341,  1341,  1329,  1329,  1342,  1664,
    1342,  1330,  1330,  1260,  1329,  1176,   108,  1176,  1329,  1329,
    1176,  1329,  1329,  1329,  1329,  1176,  1329,  1329,  1329,  1329,
    1329,  1329,  1329,  1341,  1329,  1329,  1329,  1176,  1662,  1330,
    1329,  1329,  1342,  1342,  1329,  1177,  1177,  1130,    36,    53,
      61,  1688,    36,  1688,  1684,  1176,  1662,  1662,  1662,  1125,
    1130,  1183,  1184,  1185,  1687,  1702,  1705,  1707,  1915,  1926,
    1927,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1256,  1256,  1256,  1256,  1256,  1256,
    1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,    46,  1175,    46,
    1130,  1951,  1125,  1127,  1130,  1943,  1945,  1946,  1125,  1742,
    1742,  1125,  1742,  1260,    72,  1259,  1291,    73,  1259,  1291,
      66,    74,  1175,  1627,  1628,  1649,  1650,  1635,  1636,  1175,
    1828,  1175,  1175,  1175,  1175,  1175,  1857,  1175,  1872,    57,
      65,    68,  1125,  1871,  1927,  1260,  1175,  1175,  1175,  1830,
    1175,  1175,  1125,  1126,  1763,  1763,  1763,  1763,  1175,  1175,
    1175,    46,    56,    57,    59,    60,    61,    62,    63,    64,
      65,    67,    72,   168,  1175,  1760,  1761,  1762,  1763,  1763,
    1763,  1763,  1763,  1763,  1763,  1175,  1125,  1175,  1763,  1175,
    1175,  1175,  1763,  1763,  1763,  1763,  1763,  1175,  1763,  1175,
    1175,  1763,  1763,  1175,  1763,  1763,    46,    56,    57,    59,
      60,    61,    62,    63,    64,    65,    67,    72,   168,  1175,
    1826,  1827,  1763,  1175,  1763,  1175,  1175,  1763,  1763,  1175,
    1175,  1763,  1763,  1763,  1763,  1175,  1763,  1763,  1175,  1763,
    1763,  1175,  1763,  1763,  1763,  1763,  1175,  1763,  1763,  1763,
    1763,  1763,  1763,  1763,  1175,  1763,  1763,  1763,  1763,  1175,
    1175,  1763,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,
    1175,  1175,  1763,  1763,  1175,  1763,  1175,  1763,  1763,  1763,
    1763,  1763,  1763,  1763,  1763,  1763,  1763,  1763,  1763,  1763,
    1763,  1763,  1763,  1763,  1763,  1763,  1763,  1763,  1763,  1763,
    1763,  1763,  1763,  1763,  1763,  1763,  1175,  1175,  1175,  1763,
    1763,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,  1763,
    1763,  1763,  1175,  1175,  1175,  1175,  1175,  1175,  1719,  1720,
    1719,  1720,  1175,  1175,  1717,  1719,  1763,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1721,  1763,  1175,  1719,
    1175,  1717,  1763,  1763,  1175,  1175,  1721,  1175,  1721,  1175,
    1175,  1175,  1175,  1763,  1763,  1763,   117,  1125,  1185,  1191,
    1702,  1951,  1680,  1951,  1951,  1939,  1939,  1939,    41,  1939,
      96,  1125,  1183,  1184,  1185,  1196,  1936,  1940,  1941,  1951,
    1130,  1741,  1925,  1175,  1763,  1175,  1763,  1175,  1175,  1175,
    1175,  1719,  1175,  1719,  1720,  1721,  1175,  1175,  1175,  1175,
    1175,  1719,  1175,  1719,  1175,  1175,  1719,  1175,  1175,  1175,
    1717,  1719,  1175,  1717,  1719,  1175,  1717,  1719,  1175,  1175,
    1717,  1719,  1175,  1175,  1175,  1175,  1175,  1719,  1175,  1719,
    1720,  1719,  1720,  1175,  1175,  1719,  1175,  1175,  1175,  1175,
    1175,  1175,  1175,  1175,  1175,  1175,  1175,  1175,   168,  1175,
    1260,  1175,  1763,  1175,  1175,  1741,  1925,  1929,  1931,  1939,
    1682,  1683,  1689,  1939,  1939,  1130,  1944,  1945,  1950,     4,
       8,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,  1939,  1130,  1176,  1271,
    1271,    40,  1677,  1133,  1179,  1673,     1,  1666,  1178,  1662,
    1177,  1664,  1664,  1155,    93,  1233,  1260,  1216,  1543,  1544,
    1549,  1550,  1531,  1532,    52,  1259,  1234,  1262,  1263,  1262,
      37,    36,  1662,  1177,  1274,  1662,    36,  1662,  1177,  1274,
    1169,  1260,  1130,  1133,  1176,  1356,  1352,  1352,  1127,  1329,
    1329,  1329,  1329,  1329,  1133,  1290,  1343,  1343,  1176,  1176,
    1329,  1329,  1341,   108,  1343,  1343,  1664,  1133,  1176,  1133,
    1176,  1133,  1176,  1133,  1176,  1664,  1176,   117,  1270,  1176,
    1915,  1926,  1927,  1290,  1925,  1931,  1181,  1133,  1176,  1133,
    1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,
    1133,  1133,  1133,  1133,  1133,  1133,  1176,  1133,  1176,  1133,
    1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1133,  1133,
    1181,  1181,  1181,  1133,  1176,  1133,  1176,  1133,  1176,  1133,
    1176,  1133,  1176,  1133,  1176,  1133,  1133,  1181,  1181,  1181,
    1181,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,
    1176,  1133,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1133,
    1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,
    1176,  1133,  1176,  1133,  1176,  1133,  1176,  1181,  1181,  1181,
    1176,  1133,  1176,  1181,  1181,  1176,  1133,  1181,  1176,  1176,
    1176,  1176,  1181,  1176,  1176,  1176,   174,   459,  1125,  1664,
    1702,  1715,  1825,  1130,  1951,  1130,  1191,  1951,  1130,  1950,
    1699,  1724,  1172,  1291,  1291,  1292,  1291,  1291,  1292,  1291,
    1291,  1664,   123,  1629,   125,  1651,   127,  1637,  1132,  1180,
    1182,    46,    52,    53,    59,    60,    61,    67,  1702,  1706,
    1916,  1917,  1927,    15,    16,    17,    44,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,  1125,  1135,  1175,  1192,  1702,  1907,
    1910,  1911,  1912,  1913,  1915,  1926,    44,  1907,    44,  1874,
    1125,  1191,    44,  1851,  1858,  1722,  1860,  1125,   117,  1742,
    1931,    44,  1874,    44,  1874,    44,  1874,  1695,  1125,  1183,
    1184,  1186,  1189,  1191,  1193,  1702,  1705,  1715,  1193,  1705,
    1715,  1128,     1,  1125,  1189,  1702,  1125,  1193,  1702,  1125,
    1130,  1191,  1702,  1705,  1707,  1709,  1715,  1126,  1130,    56,
      57,    64,    65,    72,  1191,  1702,  1706,  1707,  1708,  1759,
    1193,  1702,  1705,  1707,  1662,  1193,  1702,  1708,  1193,  1702,
    1706,     1,  1702,  1708,  1702,  1715,  1193,  1702,  1709,  1715,
    1715,  1708,  1126,  1130,  1191,  1702,  1708,    32,    46,    56,
      57,    59,    64,    65,   113,  1191,  1668,  1702,  1709,  1716,
    1794,   485,   486,   487,   488,   489,   490,   491,   493,   494,
     495,   499,   500,   501,   502,   505,   506,   508,  1193,  1197,
    1198,  1199,  1200,  1201,  1202,  1702,  1703,  1709,  1715,   477,
     478,   479,   480,   481,   482,   483,   484,  1203,  1204,  1702,
    1706,  1707,  1712,   445,   447,   448,  1702,  1823,  1824,  1193,
    1198,  1702,  1706,   507,   508,  1193,  1198,  1702,  1705,  1707,
    1716,  1193,  1705,  1707,  1715,  1193,  1705,  1707,  1715,  1715,
    1193,  1709,  1715,  1193,  1193,   437,   438,   439,   440,   441,
     442,   443,   444,  1702,  1705,  1715,  1764,  1765,  1766,  1702,
    1705,  1708,  1702,  1706,  1764,  1706,  1764,  1706,  1706,  1708,
    1708,  1702,  1764,  1764,  1765,  1764,  1765,  1706,  1707,  1706,
    1707,  1706,  1707,  1708,  1708,  1708,  1708,  1708,  1708,   447,
    1702,  1708,   447,  1702,  1708,  1764,  1662,  1662,  1195,  1196,
    1203,  1702,  1664,  1788,  1203,  1706,  1707,  1713,  1191,  1195,
    1203,  1702,  1706,  1707,  1711,  1195,  1203,  1702,  1712,  1662,
    1662,  1662,  1203,  1712,  1203,  1712,  1203,  1711,  1708,  1708,
    1203,  1702,  1195,  1702,  1203,  1712,  1203,  1191,  1203,  1195,
    1195,  1203,  1711,    46,  1249,   117,    18,    19,  1129,  1125,
    1185,  1129,  1133,  1952,  1679,  1176,    46,    54,    55,    62,
      63,  1928,   117,  1939,  1939,  1939,  1939,  1939,  1939,  1939,
    1939,    54,    55,    56,  1193,  1662,  1920,  1922,  1924,  1125,
    1744,  1740,  1705,  1715,  1764,  1765,  1766,  1764,  1765,  1702,
    1705,  1715,  1764,  1764,  1765,  1708,  1203,  1125,  1189,  1191,
    1194,  1702,  1706,  1707,  1710,  1189,  1702,  1708,  1708,  1189,
    1191,  1702,  1203,  1712,  1713,  1203,  1712,  1706,  1707,  1714,
    1189,  1191,  1708,  1203,  1708,  1708,  1708,  1788,  1702,  1709,
    1788,  1125,  1186,  1702,  1709,  1125,  1194,  1702,  1715,   453,
    1702,  1715,  1821,  1193,  1706,  1707,  1711,  1203,  1712,  1662,
    1702,  1709,  1203,  1713,  1195,  1702,  1712,  1203,  1712,  1203,
    1712,  1203,  1711,  1191,  1711,  1708,  1711,  1193,  1709,  1715,
    1193,  1706,  1707,  1193,  1709,  1715,  1193,  1709,  1715,  1126,
    1130,  1260,  1193,  1709,  1715,  1821,  1191,  1744,  1740,  1930,
    1125,  1736,  1925,  1938,  1175,  1938,  1191,  1951,  1950,  1950,
    1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,  1951,
    1951,  1951,  1951,  1951,  1951,  1951,  1951,  1662,  1273,  1662,
    1676,   130,  1282,  1283,  1662,  1662,  1176,  1176,  1176,  1260,
    1216,  1172,    95,   111,   113,   115,   117,   122,   124,   126,
     165,  1239,  1361,   114,  1219,  1290,  1545,   121,  1218,  1290,
    1551,   118,  1221,  1290,  1533,  1241,  1240,  1694,    46,  1662,
    1172,  1172,  1560,  1177,  1181,  1182,  1172,  1172,  1561,  1177,
    1168,  1177,  1356,  1172,  1350,  1350,  1260,    20,  1342,  1177,
    1177,  1341,  1341,  1177,  1177,  1177,  1256,  1256,  1256,  1256,
    1176,  1922,  1925,  1931,  1290,  1925,  1937,  1256,  1256,  1256,
    1256,  1256,  1256,  1662,  1662,  1662,  1662,  1662,  1662,  1256,
    1256,  1256,  1256,  1256,  1256,  1662,  1662,  1662,  1662,  1662,
    1662,  1256,  1256,  1256,  1256,  1256,  1256,  1662,  1662,  1662,
    1662,  1662,  1662,  1256,  1256,  1256,  1256,  1256,  1256,  1256,
    1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,   117,   459,  1664,
    1181,  1181,  1128,  1951,    20,  1129,  1952,  1743,   115,   507,
     508,  1193,  1290,  1705,  1715,  1725,  1726,  1727,  1728,  1873,
    1292,  1292,  1530,  1292,  1292,  1530,  1292,  1292,  1176,  1125,
    1290,  1631,  1631,  1125,  1290,  1639,  1695,     1,  1916,  1927,
      37,  1174,  1182,  1290,  1925,  1931,  1880,  1175,  1702,  1910,
    1911,  1912,  1907,  1135,  1192,  1910,  1915,  1926,     6,     9,
    1176,    11,    12,    13,    14,    15,    16,    17,    26,  1908,
    1909,  1908,  1909,  1909,  1880,  1176,  1885,  1907,  1176,  1854,
    1907,  1859,  1172,  1695,  1724,  1249,  1864,  1736,  1925,  1875,
    1907,  1876,  1907,  1877,  1907,   204,   205,   206,   207,   208,
    1700,   117,  1176,  1125,  1183,  1184,  1185,  1176,  1176,  1176,
    1176,  1176,  1176,   117,  1181,  1125,  1184,   117,  1181,  1125,
    1183,   117,  1270,  1176,  1125,  1176,  1176,  1662,  1663,  1702,
    1176,    56,    57,    64,    65,    72,  1125,  1176,  1176,  1181,
    1125,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1176,  1176,
    1181,  1181,  1181,  1181,  1176,  1176,  1663,  1176,  1176,  1715,
    1181,  1181,    46,    56,    64,  1668,  1794,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,   508,  1197,  1199,  1201,  1181,  1181,
    1181,  1181,  1204,  1181,   445,   447,   448,  1823,  1181,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,   507,   508,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1181,  1181,  1181,  1181,  1181,   437,   438,   439,   440,   441,
     442,   443,   444,  1125,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1133,
    1176,  1133,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,   447,  1176,  1176,   447,  1176,
    1176,  1181,  1181,  1181,  1181,  1196,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1176,  1176,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1125,  1183,
    1185,  1189,  1940,  1941,  1951,  1186,  1189,  1191,  1702,  1707,
    1927,  1249,  1191,  1951,  1951,   117,  1951,  1129,  1939,    46,
    1177,  1130,  1923,    18,    19,    20,  1177,  1918,  1921,  1699,
    1744,  1176,  1176,  1128,  1181,  1181,  1128,  1181,  1176,  1176,
    1133,  1176,  1176,  1133,  1181,  1181,   117,  1176,  1125,  1176,
    1176,  1125,  1176,  1176,  1181,  1181,  1125,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,   117,  1176,  1125,  1176,   117,  1181,  1125,
    1181,   453,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,  1181,
    1181,  1181,  1181,  1181,  1176,  1176,  1181,  1181,  1181,  1176,
    1176,  1176,  1133,  1176,  1812,  1176,  1812,  1176,  1812,  1133,
    1176,  1814,  1176,  1814,  1176,  1814,  1663,  1176,  1181,  1181,
    1181,  1181,  1181,  1744,  1932,  1935,    69,  1740,  1740,  1664,
      20,  1129,  1129,  1177,  1678,  1134,  1177,  1133,  1177,  1228,
      95,   111,   113,   115,   117,   120,   122,   124,   126,  1239,
    1361,  1290,  1358,  1542,  1543,  1549,  1531,  1627,  1649,  1635,
      52,    53,    54,    55,    56,    57,    58,    59,  1244,  1259,
    1234,  1234,  1235,     1,    46,  1126,  1254,  1259,  1546,  1577,
    1235,     1,   148,   149,   150,   151,   152,   153,   154,   156,
     157,   158,   159,   169,   392,   421,   424,   425,   426,   431,
     432,   433,   434,   435,   436,  1126,  1254,  1255,  1259,  1280,
    1281,  1552,  1577,  1235,     1,  1126,  1254,  1259,  1534,  1172,
    1172,  1691,  1172,    37,  1172,  1558,  1662,     1,    37,  1172,
    1559,  1353,  1324,  1329,  1329,  1133,  1176,  1133,  1176,  1133,
    1176,  1133,  1176,  1923,  1925,  1181,  1133,  1176,  1133,  1176,
    1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,
    1133,  1176,  1133,  1176,  1133,  1176,  1133,  1133,  1133,  1176,
    1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,
    1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1181,  1181,
    1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,
    1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,
    1181,  1181,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,
    1133,  1176,  1133,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1181,  1249,  1824,  1824,  1129,  1952,    28,  1129,  1290,
    1746,  1747,  1193,  1702,  1705,  1128,  1133,  1695,  1530,  1530,
      56,  1530,  1530,    57,  1530,  1530,  1664,  1632,  1653,  1664,
    1640,  1179,  1925,  1931,  1829,     1,  1290,  1925,  1695,  1907,
    1910,  1176,  1910,  1907,  1907,  1260,    11,  1664,  1702,  1912,
    1914,  1702,  1911,  1912,  1913,  1914,  1702,  1914,  1911,  1912,
    1913,  1914,  1911,  1912,  1913,  1914,  1695,  1260,  1695,  1176,
    1234,  1901,  1695,  1176,  1860,  1849,   195,  1725,  1191,  1860,
      69,  1740,  1740,  1695,  1176,  1695,  1176,  1695,  1176,  1831,
    1831,  1175,  1831,  1831,   485,   486,   487,   488,   489,   490,
    1126,  1696,  1699,  1249,   117,  1249,  1189,  1706,  1707,   117,
    1249,    46,    52,    53,    59,    60,    61,    67,  1702,  1706,
    1707,  1715,   117,  1249,   117,  1177,  1662,   117,  1193,  1709,
    1715,   117,  1193,  1702,  1715,  1193,  1715,  1203,  1712,  1193,
    1193,  1193,  1193,  1715,  1193,  1193,  1193,  1708,  1177,  1181,
     113,  1668,  1702,  1709,  1716,  1794,  1191,  1181,  1181,  1191,
    1191,  1191,  1193,  1198,  1200,  1202,  1702,  1708,  1193,  1708,
    1193,  1193,  1708,  1193,  1198,  1702,  1703,  1708,   507,  1193,
    1702,  1703,  1704,  1706,  1203,  1712,  1203,  1715,  1825,  1176,
    1176,  1193,  1708,  1193,  1193,  1706,  1193,  1708,  1193,  1708,
     117,  1764,  1764,  1176,  1176,  1195,  1203,  1194,  1710,  1191,
    1191,  1195,  1712,  1203,  1203,  1195,  1203,  1191,  1711,  1191,
    1711,  1195,  1203,  1195,  1712,  1712,  1195,  1203,  1203,  1713,
    1718,  1713,  1718,  1711,  1718,  1203,  1203,  1203,  1203,  1203,
    1203,  1713,  1203,  1203,  1195,  1711,  1713,  1712,  1203,  1203,
    1711,  1203,   117,  1176,  1176,  1176,  1128,  1128,  1128,  1176,
    1176,  1176,  1927,  1176,  1128,  1925,  1931,  1191,    20,  1290,
    1948,  1129,  1129,  1249,  1952,  1675,  1183,  1185,  1189,  1923,
    1920,  1922,  1662,  1924,  1919,    28,  1177,    18,  1177,  1918,
    1745,  1764,  1702,  1765,  1764,  1765,  1764,  1203,  1249,   117,
     117,  1189,  1710,  1191,  1711,   117,  1712,  1203,  1203,  1712,
    1203,  1203,  1189,  1191,  1194,  1191,  1195,  1203,  1195,  1203,
    1195,  1203,  1713,  1718,  1195,  1203,  1195,  1203,  1249,   117,
    1249,  1194,  1702,  1709,  1715,   117,  1194,  1702,  1709,  1194,
    1194,  1193,  1193,  1193,  1203,  1203,  1203,  1713,  1718,  1203,
    1195,  1195,  1203,  1203,  1195,  1195,  1191,  1191,  1191,  1191,
    1203,  1203,  1193,  1708,  1193,  1193,  1705,  1707,   447,   507,
     508,  1702,  1176,  1176,  1176,   445,   447,   448,  1702,  1176,
    1176,  1176,  1177,  1193,  1709,  1193,  1193,  1706,  1707,  1193,
    1706,  1707,  1708,  1134,  1933,  1724,  1744,  1744,  1176,    28,
    1260,  1284,  1172,  1358,  1542,  1543,  1549,  1531,  1562,  1563,
    1627,  1649,  1635,  1234,  1234,    56,    57,    68,    72,    73,
      74,    96,  1126,  1225,  1259,  1359,   112,  1217,  1259,  1219,
    1218,  1221,   123,  1222,   125,  1223,   127,  1224,  1241,  1172,
    1240,  1126,  1126,    37,  1173,  1126,    37,    37,    37,    37,
      37,    37,    37,    37,    37,    37,    37,    37,  1175,    37,
      37,    37,    37,    37,    37,    37,    37,    37,    37,    37,
    1173,    37,  1173,    37,    37,  1126,  1173,  1173,   166,  1236,
    1237,  1236,  1237,  1662,    37,  1662,    37,   106,   109,  1256,
    1256,  1256,  1256,  1937,  1256,  1256,  1256,  1256,  1256,  1256,
    1256,  1256,  1256,  1256,  1662,  1662,  1256,  1256,  1256,  1256,
    1256,  1256,  1256,  1256,  1256,  1256,  1662,  1662,  1256,  1256,
    1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1662,  1662,
    1256,  1256,  1256,  1256,  1256,  1256,  1662,  1176,  1176,  1129,
      18,    19,  1129,  1176,  1749,  1723,  1727,    94,  1481,  1526,
    1125,  1290,  1488,  1481,  1528,  1488,  1481,  1481,  1176,     1,
      52,    59,    60,    67,   119,   133,  1126,  1249,  1254,  1259,
    1576,  1577,  1579,  1580,  1582,  1583,  1584,  1586,  1588,  1590,
    1591,  1592,  1593,  1595,  1597,  1599,  1601,  1603,  1604,  1606,
    1608,  1611,  1613,  1615,  1616,  1618,  1620,  1621,  1623,  1624,
    1625,  1630,  1633,  1126,  1254,  1259,  1576,  1577,  1579,  1580,
    1582,  1583,  1584,  1592,  1613,  1615,  1616,  1618,  1620,  1621,
    1623,  1624,  1625,  1652,  1654,  1176,   133,  1126,  1249,  1254,
    1259,  1576,  1577,  1579,  1586,  1588,  1590,  1591,  1593,  1595,
    1597,  1599,  1601,  1603,  1604,  1606,  1608,  1611,  1638,  1641,
    1181,  1925,    44,    45,  1176,  1879,  1664,    40,    40,    45,
    1878,    45,   178,  1290,  1898,  1902,    45,   187,  1290,  1856,
    1695,  1907,  1128,  1176,  1856,  1724,  1744,  1744,    45,  1260,
      45,    45,  1832,  1695,  1715,  1833,  1127,  1127,  1127,  1127,
    1127,  1127,    46,    59,    62,    63,    64,    67,  1251,  1252,
    1253,  1259,  1261,  1722,  1186,  1189,  1249,  1176,  1176,  1176,
    1249,  1176,  1176,  1133,  1249,  1249,  1249,  1176,  1176,  1176,
    1249,  1176,  1125,  1176,  1176,  1176,  1181,  1181,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1133,  1176,  1133,  1191,  1715,
    1176,  1668,  1794,  1176,  1176,  1176,  1176,  1191,  1191,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,   507,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1249,  1176,  1176,  1181,  1181,
    1181,  1181,  1176,  1176,  1181,  1181,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1181,  1181,  1176,  1181,  1176,  1181,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,    46,  1939,  1939,  1939,  1130,
    1134,  1942,  1943,  1950,  1134,  1942,  1134,  1942,  1128,  1925,
    1931,  1176,  1176,  1925,  1176,    28,    18,    19,  1290,  1949,
    1191,  1131,  1176,  1176,  1176,  1177,  1923,  1177,  1918,  1921,
    1662,  1177,  1746,  1176,  1176,  1128,  1176,  1176,  1176,  1249,
    1249,  1176,  1176,  1176,  1176,  1249,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1181,  1176,  1176,  1176,  1176,  1176,  1249,  1176,
    1125,  1176,  1176,  1249,  1176,  1176,  1181,  1181,  1176,  1176,
    1176,  1176,  1176,  1176,  1181,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,   447,   507,   508,   445,   447,
     448,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1260,  1725,  1938,  1173,  1283,  1229,  1225,  1217,  1219,
     116,  1220,  1221,  1218,    37,  1130,  1290,  1564,  1222,  1223,
    1224,  1291,  1291,  1127,  1127,  1127,  1404,  1173,  1235,  1127,
    1173,  1365,  1404,  1235,  1172,  1235,  1235,  1235,  1172,  1237,
    1243,  1172,  1662,   145,  1249,  1662,  1662,  1662,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,  1290,  1662,  1662,
    1662,  1662,  1662,  1662,  1662,  1662,  1662,     1,   466,   468,
      36,  1662,  1249,    36,  1662,  1249,  1662,  1662,   128,   130,
     135,   174,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,  1260,  1264,  1265,  1299,    46,    97,   130,   135,   137,
     145,  1249,  1291,  1298,  1299,  1238,  1210,  1234,  1236,  1210,
    1236,  1172,  1662,  1172,  1662,   105,  1345,   108,  1133,  1176,
    1133,  1176,  1133,  1176,  1133,  1176,  1181,  1176,  1176,  1176,
    1176,  1176,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,
    1176,  1133,  1176,  1133,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,
    1176,  1133,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1133,
    1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,  1176,  1133,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1951,  1951,
    1750,  1752,  1729,  1730,  1731,  1732,  1734,  1735,  1737,  1739,
    1260,  1379,  1216,  1505,  1489,  1418,  1399,  1505,  1433,  1172,
    1389,  1126,  1175,  1175,  1634,  1127,  1173,  1173,  1173,  1173,
    1175,  1648,  1173,  1173,  1662,  1695,  1176,  1881,  1914,  1914,
    1176,  1881,  1176,  1882,   183,  1903,  1176,  1852,   191,  1172,
    1865,  1695,  1725,  1867,  1870,  1176,  1176,  1176,  1695,   206,
     207,   208,  1176,  1695,    41,  1173,  1697,  1127,  1182,  1698,
      41,  1172,  1176,  1176,  1186,  1189,  1191,  1189,  1715,  1186,
     117,  1203,  1203,  1193,  1193,  1176,  1176,  1176,  1176,  1176,
    1176,  1191,  1191,  1195,  1203,  1195,  1203,  1195,  1195,  1203,
    1203,  1203,  1203,  1125,    46,    46,    46,  1176,  1176,  1925,
    1176,  1951,  1951,  1129,  1176,  1938,  1939,  1939,  1939,  1923,
    1177,  1177,  1918,  1176,  1203,   117,  1194,  1708,  1194,  1708,
    1203,  1934,  1128,  1178,  1695,  1235,  1664,  1664,  1290,  1565,
    1292,  1292,   142,    97,    98,  1291,    99,    97,   142,  1249,
     145,  1291,  1291,   140,  1290,  1317,  1318,  1236,  1237,  1242,
    1234,  1245,  1236,  1237,  1172,  1175,    37,  1130,  1172,  1172,
    1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,
    1937,  1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,  1172,
    1172,  1172,  1172,  1172,  1172,    37,  1130,  1172,  1172,  1172,
      37,  1130,  1172,  1172,  1172,  1305,  1308,  1180,  1130,  1172,
      37,  1130,  1290,  1300,  1301,  1130,  1172,  1291,  1535,   138,
    1175,  1130,  1172,  1292,  1305,  1300,  1172,    94,  1211,  1290,
    1210,    94,  1210,  1172,  1172,  1290,  1351,  1256,  1256,  1256,
    1256,  1662,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,
    1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,  1256,
    1129,  1129,    44,   115,   174,   507,   508,  1193,  1705,  1707,
    1715,  1755,  1756,  1488,  1506,  1172,   115,   120,   170,   171,
     172,   173,  1492,  1523,  1524,  1172,  1488,  1172,  1172,  1290,
    1501,  1488,  1664,    46,  1249,  1655,  1657,  1662,     1,    97,
     130,   133,   135,   137,  1249,  1299,    46,    97,   133,   135,
     137,  1249,  1291,  1299,    97,   137,  1249,    97,   135,   137,
    1249,  1249,  1655,    97,   133,   137,  1249,    97,   133,   135,
     137,  1249,  1176,    45,  1260,  1260,  1898,  1695,  1175,   183,
     184,  1290,  1899,  1856,  1695,  1861,  1846,  1862,  1863,  1866,
    1869,   195,  1128,  1860,  1860,  1260,   208,  1175,  1834,  1831,
     208,  1655,     1,  1176,  1176,  1176,  1176,  1176,  1176,  1249,
    1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,   117,  1942,  1942,  1942,  1176,
    1177,  1176,  1249,  1176,  1176,  1176,  1176,  1176,  1932,  1738,
    1662,    94,  1172,  1127,  1177,   119,  1126,  1254,  1259,  1566,
    1576,  1577,  1530,  1530,  1724,  1291,  1292,  1291,  1724,  1369,
    1175,  1292,  1292,  1125,  1290,  1319,  1245,  1236,  1245,  1246,
    1290,    94,  1245,  1236,  1259,  1662,  1177,  1274,  1176,    36,
    1662,  1177,  1274,    36,  1662,  1177,  1274,   131,  1299,     1,
     119,   144,  1126,  1254,  1259,  1309,  1310,  1254,  1259,  1286,
    1289,  1274,  1664,  1664,   136,  1290,  1297,    37,  1274,  1292,
    1180,    97,   174,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   234,   235,   236,   237,   238,   239,
    1260,  1537,  1259,  1274,  1293,   131,  1297,  1260,   113,   115,
     117,    94,  1260,    94,   103,  1349,  1352,  1176,  1176,  1176,
    1176,  1176,  1176,  1176,  1176,  1176,  1133,  1176,  1133,  1176,
    1176,  1176,  1176,  1176,  1133,  1176,  1133,  1176,  1176,  1176,
    1176,  1176,  1133,  1176,  1133,  1176,  1758,  1193,  1705,  1707,
    1715,  1133,  1757,  1380,  1125,  1290,  1507,  1501,  1125,  1290,
    1525,  1525,  1176,  1260,  1501,  1400,  1501,  1501,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,  1440,  1390,  1176,  1176,
    1176,  1172,  1133,  1126,  1585,  1305,  1175,  1180,   138,    37,
    1130,  1172,  1300,  1130,  1172,  1291,  1175,  1321,   138,    37,
    1130,  1619,  1292,  1300,  1585,   138,  1130,  1291,  1321,   138,
    1130,  1176,  1172,  1585,  1175,   138,  1130,  1172,  1291,  1175,
    1321,   138,  1130,  1646,  1886,   180,   181,  1884,  1662,  1906,
    1904,  1900,   185,  1895,   188,   189,  1175,  1722,  1868,  1856,
    1856,  1715,  1695,  1835,  1172,  1729,  1177,  1260,  1664,    37,
    1175,  1173,  1173,  1127,  1416,  1127,  1431,    56,    57,    58,
      64,    65,    66,    72,    73,    74,  1360,  1292,  1530,  1292,
    1360,  1291,  1259,  1530,  1530,  1664,  1172,    94,  1245,    94,
      95,   113,   115,   117,   120,   122,   124,   126,  1247,  1361,
    1260,    94,  1245,  1176,  1172,  1548,  1177,    37,  1172,  1172,
    1556,  1177,  1172,  1172,  1555,  1177,  1172,  1300,  1126,  1175,
    1254,  1259,  1127,  1173,  1173,  1133,  1133,  1179,     1,  1177,
    1172,  1127,  1177,  1175,  1302,  1308,  1664,  1177,  1538,  1536,
    1256,  1172,  1172,  1176,  1177,  1294,  1172,  1302,  1172,  1543,
    1549,  1531,  1260,  1172,  1260,  1259,  1346,  1256,  1256,  1256,
    1256,  1256,  1256,  1696,  1701,  1753,    44,  1172,  1508,   140,
     145,  1362,    34,  1173,   140,  1419,  1172,   140,   145,  1373,
     140,  1434,  1175,  1172,  1172,  1172,  1172,  1172,  1172,  1175,
     448,   452,   456,   460,   462,   464,  1500,  1172,  1172,  1172,
    1172,  1172,  1172,  1172,  1232,  1172,  1172,  1172,  1172,  1656,
    1488,   131,  1249,  1286,    97,  1260,  1537,  1662,  1274,  1501,
    1297,  1274,  1292,  1249,  1180,    97,  1260,  1537,  1662,  1177,
    1274,  1172,  1293,  1297,  1488,    97,  1260,  1537,  1274,  1292,
    1180,    97,  1260,  1537,  1274,  1172,  1488,  1249,    97,  1260,
    1274,  1501,  1292,  1249,  1180,    97,  1260,  1537,  1274,  1172,
    1695,  1883,   179,  1889,  1890,  1894,  1133,  1905,  1175,  1695,
    1855,  1850,    44,  1907,  1176,  1862,  1695,  1695,  1176,   208,
    1695,  1133,  1172,  1177,  1664,  1664,    97,   135,   137,  1249,
    1291,  1299,    97,  1426,  1488,    98,  1488,  1319,  1530,  1481,
    1530,  1319,  1292,  1176,  1526,  1528,  1176,  1260,    94,  1260,
    1358,  1543,  1549,  1531,  1248,  1627,  1649,  1635,  1218,  1234,
    1172,  1260,    94,  1578,    37,  1547,  1662,    37,  1172,  1554,
      37,  1172,  1553,  1306,  1664,     1,   128,   130,   135,    46,
      97,   137,   145,  1249,  1298,  1299,  1288,  1287,  1172,  1126,
    1131,  1172,  1664,    46,  1256,   129,  1298,  1172,  1172,  1505,
    1286,  1172,  1172,  1172,  1480,   129,  1219,  1220,  1221,  1172,
    1172,  1352,   104,  1348,  1176,  1176,  1176,  1176,  1176,  1176,
      45,  1700,  1751,  1695,  1501,  1511,  1523,  1410,  1172,  1232,
    1176,    97,   120,  1249,  1494,  1415,  1487,  1501,  1413,  1172,
    1232,  1430,  1487,  1662,  1664,  1172,    93,  1501,  1317,  1317,
    1655,    37,  1172,  1172,  1176,  1179,  1256,    37,  1172,    37,
    1172,  1607,  1177,  1302,  1177,  1320,  1176,  1322,  1256,    37,
    1614,    37,  1617,  1605,    37,  1177,  1501,  1295,  1302,  1256,
    1172,  1177,  1320,  1322,  1256,  1177,  1317,  1172,  1176,  1256,
    1172,  1177,  1320,  1176,  1322,  1256,  1644,  1645,  1177,  1501,
     180,   181,  1888,  1695,  1699,  1175,   181,   180,  1662,  1176,
    1906,  1695,  1695,  1695,  1176,  1847,   195,   195,  1837,  1836,
    1285,  1230,    37,  1172,  1176,  1291,  1569,   138,  1130,  1573,
    1292,  1300,  1249,  1425,  1418,  1433,  1172,  1481,  1405,  1481,
    1172,  1530,  1172,  1505,  1505,  1172,  1260,  1172,  1225,  1219,
    1220,  1221,  1562,  1222,  1223,  1224,  1172,  1260,  1172,  1662,
      37,  1172,  1662,    37,  1662,    37,  1302,  1176,  1126,  1300,
    1305,  1180,  1130,  1172,  1291,   138,  1175,  1130,  1315,  1305,
    1300,  1286,  1286,  1177,  1176,  1176,  1172,  1303,  1126,  1180,
    1503,  1179,   132,  1541,  1172,  1354,  1259,  1696,  1748,    45,
    1381,  1176,  1259,  1125,  1290,  1499,    93,  1498,    11,  1290,
    1491,  1491,  1499,  1216,  1401,  1499,    93,  1499,  1216,  1176,
    1176,  1260,  1391,  1662,  1501,  1172,  1172,    37,  1172,  1664,
    1501,  1664,  1501,  1172,    37,  1172,   129,  1172,  1505,  1172,
    1286,    37,  1581,  1664,  1172,  1664,  1172,  1172,  1662,    37,
    1622,  1317,   130,   129,  1501,  1505,  1286,  1501,  1172,  1172,
    1501,  1172,  1505,  1172,  1286,  1172,  1172,  1172,  1647,  1318,
    1887,  1890,  1894,   181,    44,  1897,  1695,  1695,  1905,   188,
     189,   188,    45,  1856,  1695,   206,   207,  1290,  1839,  1840,
    1841,  1843,  1283,  1695,  1664,  1172,  1292,  1180,    97,  1260,
    1537,  1274,  1172,  1293,  1297,  1418,  1126,  1180,  1502,  1502,
    1384,  1488,  1394,  1526,  1502,  1502,  1172,  1172,  1172,  1662,
    1172,  1662,  1172,  1662,   129,  1172,  1302,   131,  1286,  1274,
    1292,    97,  1260,  1537,  1259,  1274,  1172,   131,  1297,  1305,
    1501,  1290,  1504,  1126,  1172,   136,  1290,  1296,  1352,  1354,
    1754,  1487,  1173,  1510,  1662,  1172,  1260,  1488,  1193,  1490,
    1490,  1172,  1232,  1487,  1172,  1260,  1172,  1232,  1172,  1172,
    1172,  1487,  1172,  1662,  1501,  1598,  1602,  1501,  1662,  1501,
    1172,    37,  1172,  1317,  1179,  1662,  1172,  1596,  1501,  1600,
    1501,  1501,  1610,  1662,  1172,  1626,  1172,  1179,  1501,  1501,
    1172,  1317,  1179,  1642,  1501,  1501,  1172,  1896,   181,   180,
    1892,  1874,   181,  1176,  1853,  1176,  1848,  1838,  1175,  1842,
     208,  1840,    94,  1172,  1567,  1570,  1256,  1571,  1572,  1177,
    1501,  1295,  1302,  1502,  1504,   140,  1422,   140,  1437,  1488,
    1406,  1488,  1502,   140,   145,  1366,   140,   145,  1376,  1172,
    1172,  1172,  1172,   129,  1172,  1179,  1177,  1311,  1256,  1313,
    1314,  1176,  1177,  1501,  1172,  1302,   131,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,  1133,  1179,  1175,  1539,  1357,
    1352,  1752,  1216,    46,    97,   120,  1249,  1509,  1176,  1172,
    1496,  1126,  1126,    93,  1216,  1172,    93,  1441,  1216,  1172,
    1172,  1172,  1612,  1587,  1501,  1172,  1594,  1589,  1501,  1172,
    1317,  1172,  1317,  1172,  1609,  1501,  1305,  1501,  1643,  1501,
    1318,  1318,  1501,  1695,  1695,  1695,  1907,  1695,  1695,  1695,
    1839,  1715,  1695,  1505,  1286,  1568,  1172,  1172,  1574,   130,
     129,  1427,  1179,  1417,  1487,  1432,  1487,  1385,  1502,  1395,
     140,   145,  1370,  1411,  1172,  1232,  1414,  1172,  1232,  1307,
    1172,  1172,  1172,  1505,  1312,  1172,  1172,  1172,  1316,   129,
    1172,  1175,  1175,  1500,    46,  1249,  1234,  1352,  1357,  1232,
    1291,    11,  1514,    11,  1512,  1363,  1126,  1493,  1495,  1260,
    1232,  1374,  1260,  1695,  1232,  1501,  1501,  1172,  1662,  1317,
    1501,    37,  1172,  1317,  1501,  1501,  1501,  1172,  1317,   131,
    1317,  1172,  1318,  1318,   181,   181,    45,  1176,   188,   195,
     196,   208,  1176,  1172,  1179,  1172,  1501,  1501,  1172,  1575,
    1172,  1487,  1172,  1499,  1216,  1499,  1216,  1502,  1407,  1502,
    1412,  1172,  1232,  1499,    93,  1499,    93,  1308,  1172,  1172,
    1501,  1501,  1172,  1172,  1304,  1662,  1664,  1176,  1176,  1540,
    1350,  1352,    93,  1292,  1193,  1126,  1193,  1126,  1695,  1497,
    1492,  1492,  1172,    93,  1695,  1172,    94,    93,  1501,  1172,
    1662,  1501,  1501,  1172,  1501,  1176,  1898,  1845,  1844,  1501,
    1172,  1501,  1501,  1305,  1216,  1172,  1232,  1172,  1232,  1386,
    1487,  1396,  1499,    93,  1172,  1260,  1172,  1260,  1501,  1501,
    1501,  1308,  1176,  1176,  1442,  1456,  1353,  1350,  1260,  1522,
    1516,  1515,  1518,  1513,    94,  1492,  1420,  1260,    94,  1435,
    1260,  1260,  1501,  1172,  1898,  1882,  1695,  1695,   131,  1232,
      93,    93,  1487,  1216,  1487,  1172,  1260,  1172,  1172,   134,
      95,    97,    98,    99,   113,   115,   117,   120,   122,   124,
     126,   143,  1463,  1466,  1474,  1482,   106,  1353,  1172,  1505,
    1126,  1511,  1126,  1511,  1260,  1695,  1172,  1260,  1695,  1172,
    1172,  1886,  1695,   195,  1172,    93,  1260,  1260,  1216,  1232,
    1216,  1172,  1367,  1377,  1172,  1450,  1259,  1259,  1259,  1543,
    1549,  1531,  1308,  1627,  1649,  1635,    95,    97,    98,    99,
    1234,  1172,  1172,  1234,   106,  1382,  1520,  1517,  1519,  1172,
      94,  1402,  1172,    94,  1392,  1695,  1891,  1260,  1172,  1172,
    1232,    93,  1232,  1371,  1695,  1695,  1290,  1457,  1458,  1291,
    1291,  1291,  1219,  1220,  1221,  1218,  1222,  1223,  1224,  1452,
      72,    57,    65,    73,    58,    66,  1455,   140,   140,  1454,
     105,  1695,  1126,  1511,  1511,  1364,  1260,  1695,  1375,  1260,
    1695,  1893,  1890,  1894,  1172,  1423,  1438,    93,  1260,    93,
    1695,    94,    94,  1225,    68,  1259,  1465,  1292,  1292,  1292,
    1443,  1444,  1445,  1446,  1447,  1448,  1449,  1290,  1460,  1461,
    1172,  1442,  1469,  1476,  1442,    94,  1521,  1695,  1172,    94,
    1695,  1172,    94,  1890,  1894,  1428,  1695,  1695,  1260,  1172,
    1260,    94,  1260,  1260,  1451,  1127,  1127,  1173,  1365,  1404,
    1464,  1459,  1530,  1530,  1530,  1442,  1442,  1442,  1442,  1442,
    1442,  1442,  1225,    57,    58,    65,    66,    72,    73,  1467,
    1468,  1475,   140,  1499,  1499,  1260,  1511,    94,  1421,  1260,
      94,  1436,  1260,  1695,    94,    94,  1172,  1408,  1172,  1260,
    1172,  1172,  1442,   142,    99,   142,   145,  1291,  1291,  1291,
    1457,  1473,  1473,  1473,  1453,    98,  1127,  1127,  1127,  1127,
    1365,  1127,  1172,  1462,  1172,  1485,  1172,  1695,  1172,  1695,
    1172,    94,  1260,  1260,  1387,  1695,  1397,  1172,  1368,  1378,
    1724,  1724,  1175,  1292,  1292,  1292,  1527,  1529,  1527,  1442,
      99,    98,    99,  1172,    98,   140,  1460,   140,  1499,  1383,
      94,  1403,    94,  1393,  1260,  1172,  1172,  1695,    94,  1695,
    1372,  1695,  1695,  1360,  1360,  1259,  1530,  1530,  1530,  1505,
    1505,  1505,   140,  1470,  1477,  1695,  1695,  1695,  1172,  1424,
    1439,    94,  1260,    94,  1695,    94,    94,  1319,  1319,  1176,
    1473,  1473,  1473,  1172,  1172,  1172,  1486,  1499,  1499,    94,
      94,    94,  1429,  1695,  1695,  1260,  1172,  1260,    94,  1172,
    1172,  1172,  1527,  1529,  1527,  1501,  1290,  1501,  1499,  1695,
      94,    94,  1172,  1409,  1172,  1505,  1505,  1505,   140,   140,
     140,   141,  1172,    94,  1388,  1695,  1398,  1502,  1126,  1172,
    1182,  1502,  1502,  1483,  1478,  1471,  1172,  1695,    94,  1695,
     140,     1,  1290,   140,   141,  1499,  1499,  1499,    94,    94,
    1484,   140,  1472,  1172,  1499,  1479,  1499,  1172,  1499,  1172,
    1172
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 20:

/* Line 1464 of yacc.c  */
#line 2559 "hlaparse.bsn"
    {
			_here;
			doCTForLoop9
			( 
				(yyvsp[(3) - (8)].s), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				1 
			);
			YYACCEPT;
		;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 2583 "hlaparse.bsn"
    {
			_here;
			doCTForLoop9( (yyvsp[(3) - (8)].s), YYS &(yyvsp[(5) - (8)].v), YYS &(yyvsp[(7) - (8)].v), -1 );
			YYACCEPT;
				
		;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 2599 "hlaparse.bsn"
    {
			union	YYSTYPE	v;

			_here;
			doCTForLoop7( (yyvsp[(3) - (6)].s), YYS &(yyvsp[(5) - (6)].v) );
			YYACCEPT;
				
		;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 2611 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(1) - (1)].idStr);
		;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 2620 "hlaparse.bsn"
    {
			union	YYSTYPE	dummy;
			
			_here;
			dummy.v.u.intval = 0;
			(yyval.s) = 
				InsertSym
				( 
					(yyvsp[(1) - (1)].idStr), 
					&int32_ste,		/* Default is int32 object.		*/
					tInt32,
					cValue, 
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					YYS &dummy,		/* Initially, no initialization	*/
					0,				/* Object size					*/
					0,				/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);
			_here;
		;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 2647 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			
			
			_if( (yyvsp[(1) - (1)].s)->SymClass != cValue )
			
				yyerror
				( 
					"Expected a VALUE identifier as the #FOR "
					"loop control variable" 
				);
				(yyval.s) = &forctrlvar_ste;
				
			_else
			
				FreeValue( YYS (yyvsp[(1) - (1)].s) );
				(yyvsp[(1) - (1)].s)->pType = tInt32;
				(yyvsp[(1) - (1)].s)->Type = &int32_ste;
				
			_endif
		;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 2686 "hlaparse.bsn"
    {				/* $5 */
			
			_here;
			_if( doCollect )
			
				PushBackStr( "\xDD" );
				delayCollect = 1;
				
			_endif
			
			doTextParameters5( YYS &(yyvsp[(3) - (4)].v) );
			YYACCEPT;
		;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 2715 "hlaparse.bsn"
    { 
			_here; 
			inVal = (yyvsp[(1) - (3)].v.u.unsval);
			YYACCEPT; 
			_here; 
		;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 2724 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.unsval) = inVal;
			inVal = 1;
			_here;
		;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 2743 "hlaparse.bsn"
    {
			YYACCEPT;
		;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 2764 "hlaparse.bsn"
    {
			YYACCEPT;
		;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 2787 "hlaparse.bsn"
    {
 			_here; 
 			memcpy( &d1ceReturnVal, &(yyvsp[(2) - (2)].v), sizeofSymNode );
 			YYACCEPT; 
 		;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 2811 "hlaparse.bsn"
    {
			_here; 
			memcpy( &d1ceReturnVal, &(yyvsp[(3) - (4)].v), sizeofSymNode );
			YYACCEPT; 
			_here;
		;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 2851 "hlaparse.bsn"
    {				/* $7 */

			_here;
			doTextBlock7( (yyvsp[(3) - (6)].idStr), YYS &(yyvsp[(6) - (6)].v) ); 
			YYACCEPT
		;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 2865 "hlaparse.bsn"
    {				/* $7 */

			_here;
			doTextBlock7a( (yyvsp[(3) - (6)].s), YYS &(yyvsp[(6) - (6)].v) );
			YYACCEPT
		;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 2874 "hlaparse.bsn"
    {
			_here;
			startGetTextBlock();
			_here;
		;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 2916 "hlaparse.bsn"
    {				/* $7 */

			_here;
			doStringBlock( (yyvsp[(3) - (6)].idStr), YYS &(yyvsp[(6) - (6)].v) ); 
			YYACCEPT
		;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 2930 "hlaparse.bsn"
    {				/* $7 */

			_here;
			doStringBlocka( (yyvsp[(3) - (6)].s), YYS &(yyvsp[(6) - (6)].v) );
			YYACCEPT
		;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 2939 "hlaparse.bsn"
    {
			_here;
			startGetStringBlock();
			_here;
		;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 2976 "hlaparse.bsn"
    {				/* $7 */

			_here;
			doMatchBlock( (yyvsp[(3) - (6)].s), YYS &(yyvsp[(6) - (6)].v) );
			YYACCEPT
		;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 2985 "hlaparse.bsn"
    {
			_here;
			startGetMatchBlock();
			_here;
		;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 3010 "hlaparse.bsn"
    {
			union YYSTYPE v;
			
			// Create a dummy entry that we can change:
			
			ClrConst
			(
				YYS &v,
				tUns32,
				&uns32_ste
			);
			
			InsertSym
			(
				(yyvsp[(1) - (1)].idStr),
				&uns32_ste,
				tUns32,
				cValue,
				0,						/* Arity 			*/
				NULL,					/* Dimensions		*/
				0,						/* NumElements		*/
				&v,						/* The Value		*/
				4,						/* Object Size		*/
				0,						/* Current Offset	*/
				NULL,					/* Static Name		*/
				NULL,					/* Base				*/
				NULL,					/* Fields			*/
				0						/* FieldCnt			*/
			);
			(yyval.s) = SymbolTable;
		
		;}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 3044 "hlaparse.bsn"
    {
			(yyval.s) = (yyvsp[(1) - (1)].s);
		
		;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 3059 "hlaparse.bsn"
    {				/* $9 */

			_here;
			doScanBlock(  &yylval, YYS &(yyvsp[(3) - (8)].v), (yyvsp[(5) - (8)].s), (yyvsp[(7) - (8)].s) ); 
			YYACCEPT
		;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 3081 "hlaparse.bsn"
    {
			_here;
			_if( PrintOut != writeHandle )
			
				// Write a newline for #print, but not for #write
				
				fputs( "\n", PrintOut );
				
			_endif
			YYACCEPT 
		;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 3101 "hlaparse.bsn"
    {
			_here;
			PrintList2( YYS &(yyvsp[(1) - (1)].v) );
			
		;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 3115 "hlaparse.bsn"
    {
		
			_here;
			PrintList2( YYS &(yyvsp[(3) - (3)].v) );
		;}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 3147 "hlaparse.bsn"
    { 
			_here;
			memcpy( &d1dnReturnVal, &(yyvsp[(2) - (2)].dotName), sizeofYYSTYPE );
			_here; 
			YYACCEPT
		;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 3158 "hlaparse.bsn"
    {
			_here;
			memcpy( &d1dnReturnVal, &(yyvsp[(2) - (2)].dotName), sizeofYYSTYPE );
			_here;
			YYACCEPT 
		;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 3173 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(0) - (0)].s);
			_here;
		;}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 3181 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = hlastrdup2( (yyvsp[(0) - (0)].s)->TrueName );
			_here;
		;}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 3207 "hlaparse.bsn"
    {					/* $5 */

			int	 nameLen;
			char *name;

			_here;

			/*
			** Note: 3/14/2000, rlh
			** Not sure if the following IF statement is ever
			** false (under reasonable conditions).  Added the
			** assert statement to let me know if this is ever
			** the case.  If the assert triggers for reasonable
			** code, perhaps we should remove the assert.  At some
			** point in the future, we may want to remove the IF
			** statement and ELSE body if the assert never triggers.
			**
			** $<s>1 should only be NULL if the class symbol is undefined.
			** However, that situation is handled elsewhere.
			*/

			_if( (yyvsp[(1) - (4)].s) != NULL )

				/*
				** Generate the new FullName field.
				*/

				nameLen = 
						strlen( (yyvsp[(1) - (4)].s)->TrueName ) 
					+	strlen( (yyvsp[(4) - (4)].dotName.FullName) )
					+	1;

				name = malloc2( nameLen );
				strcpy( name, (yyvsp[(1) - (4)].s)->TrueName );
				strcat( name, (yyvsp[(4) - (4)].dotName.FullName) );
				(yyval.dotName.FullName) = name;
				free2( vss (yyvsp[(4) - (4)].dotName.FullName) );

				/*
				** Generate the StaticName field.
				**
				**	The new StaticName field is the value
				**	of the hlaFields StaticName field if it
				**	is non-null.  If it is null, then the
				**	hlaFields StaticName field is the StaticName
				**	value of the hlaSingleID field and the Disp
				**	field is the value of the hlaFields Disp value.
				*/

				_if( (yyvsp[(4) - (4)].dotName.StaticName) != NULL )

					(yyval.dotName.StaticName) = (yyvsp[(4) - (4)].dotName.StaticName);

				_else

					(yyval.dotName.StaticName) = (yyvsp[(1) - (4)].s)->StaticName;
				
				_endif
				(yyval.dotName.Disp) = (yyvsp[(4) - (4)].dotName.Disp);
				(yyval.dotName.Sym) = (yyvsp[(4) - (4)].dotName.Sym);


			_else	
			
				/* 
				** Class/object name is undefined. 
				** Not sure if this code is needed.
				*/

				nameLen = 
						strlen( (yyvsp[(2) - (4)].idStr) ) 
					+	strlen( (yyvsp[(4) - (4)].dotName.FullName) )
					+	1;

				name = malloc2( nameLen );
				strcpy( name, (yyvsp[(2) - (4)].idStr) );
				strcat( name, (yyvsp[(4) - (4)].dotName.FullName) );
				(yyval.dotName.FullName) = name;
				(yyval.dotName.Sym) = NULL;
				(yyval.dotName.StaticName) = NULL;
				(yyval.dotName.Disp) = 0;

			_endif
			free2( vss (yyvsp[(2) - (4)].idStr) );
			_here;
		;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 3304 "hlaparse.bsn"
    {
			_here;
			(yyval.dotName.FullName) = NULL;
			(yyval.dotName.Sym) = NULL;
			(yyval.dotName.StaticName) = NULL;
			free2( vss (yyvsp[(2) - (4)].idStr) );
			_here;
		;}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 3336 "hlaparse.bsn"
    {
			_here;
			(yyval.dotName.FullName) = NULL;
			(yyval.dotName.Sym) = NULL;
			(yyval.dotName.StaticName) = NULL;
			free2( vss (yyvsp[(2) - (4)].idStr) );
			_here;
		;}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 3349 "hlaparse.bsn"
    {					/* $5 */

			int	 nameLen;
			char *name;

			_here;

			/*
			** Once again, it doesn't appear as though $<s>1 can
			** ever be NULL at this point.  The following assert
			** was added just to check this.  If it ever triggers
			** for reasonable code, just remove the assert.  Else,
			** (if it never triggers), we should remove the IF and
			** ELSE code at some point in the future.
			*/

			assert( (yyvsp[(1) - (4)].s) != NULL );
			assert( (yyvsp[(4) - (4)].dotName.FullName) != NULL );
			_if( (yyvsp[(1) - (4)].s) != NULL )

				/*
				** Generate the new FullName field.
				*/
				nameLen = 
						strlen( (yyvsp[(1) - (4)].s)->TrueName ) 
					+	strlen( (yyvsp[(4) - (4)].dotName.FullName) )
					+	2;

				name = malloc2( nameLen );

				strcpy( name, (yyvsp[(1) - (4)].s)->TrueName );
				
				// Kludge, because macro/text expansions don't
				// put a "." in front of the FullName identifier.
				
				_if( *(yyvsp[(4) - (4)].dotName.FullName) != '.' )
				
					strcat( name, "." );
					
				_endif
				strcat( name, (yyvsp[(4) - (4)].dotName.FullName) );
				(yyval.dotName.FullName) = name;
				free2( vss (yyvsp[(4) - (4)].dotName.FullName) );

				
				// Generate the StaticName field.
				//
				//	The new StaticName field is the value
				//	of the hlaFields StaticName field if it
				//	is non-null.  If it is null, then the
				//	hlaFields StaticName field is the StaticName
				//	value of the hlaSingleID field and the Disp
				//	field is the value of the hlaFields Disp value.
				

				_if( (yyvsp[(4) - (4)].dotName.StaticName) != NULL )

					(yyval.dotName.StaticName) = (yyvsp[(4) - (4)].dotName.StaticName);

				_else

					(yyval.dotName.StaticName) = (yyvsp[(1) - (4)].s)->StaticName;
				
				_endif
				(yyval.dotName.Disp) = (yyvsp[(4) - (4)].dotName.Disp);
				(yyval.dotName.Sym) = (yyvsp[(4) - (4)].dotName.Sym);

			_else

				nameLen = 
						strlen( (yyvsp[(2) - (4)].idStr) ) 
					+	strlen( (yyvsp[(4) - (4)].dotName.FullName) )
					+	1;

				name = malloc2( nameLen );
				strcpy( name, (yyvsp[(2) - (4)].idStr) );
				strcat( name, (yyvsp[(4) - (4)].dotName.FullName) );
				(yyval.dotName.FullName) = name;
				(yyval.dotName.Sym) = NULL;
				(yyval.dotName.StaticName) = NULL;
				(yyval.dotName.Disp) = 0;

			_endif
			free2( vss (yyvsp[(2) - (4)].idStr) );
			_here;
		;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 3454 "hlaparse.bsn"
    {
			(yyval.macroInvocation.LineCnt) = globalMacroLineCnt;
			globalMacroLineCnt = LineCnt;
			(yyval.macroInvocation.FileName) = globalMacroFilename;
			globalMacroFilename = hlastrdup2( FileName );
		;}
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 3466 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (3)].s) != NULL );
			(yyval.s) = (yyvsp[(1) - (3)].s)->u.MacroData.Parameters;
			VarMacParms = 0;		/* Used for a variable parm list	*/
			_here; 
		;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 3475 "hlaparse.bsn"
    {
			_here;
			(void) (yyvsp[(4) - (6)].s);
			assert( globalMacroFilename != NULL );
			free2( vss globalMacroFilename );
			globalMacroFilename = (yyvsp[(2) - (6)].macroInvocation.FileName);
			globalMacroLineCnt = (yyvsp[(2) - (6)].macroInvocation.LineCnt);
			
			YYACCEPT;
		;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 3505 "hlaparse.bsn"
    {
			_here;
			
			// Just in case there was a syntax error in the macro
			// parameter list.
			
			(yyval.v.u.ArrayOfValues) = NULL;
			_here;
			
		;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 3528 "hlaparse.bsn"
    {
			SymNode_t	v;
			char		msg[1200];

			/*
			** Have we exhausted all the formal parameters already?
			*/

			_here;
			_if( (yyvsp[(0) - (1)].s) == NULL )

				sprintf
				( 
					msg, 
					"Excessive macro parameters (%s:%d)",
					globalMacroFilename,
					globalMacroLineCnt
				);
				yyerror( msg );


			/*
			** Okay, there's at least one formal parameter left.
			** Since this is the last actual parameter we're processing,
			** make sure that this is the last formal parameter, or if
			** there is at least one more formal parameter, make sure that
			** it is the last one and it's a VAR or STRING parameter 
			** (which accepts zero actual parameters).
			*/

			_elseif
			( 
					(yyvsp[(0) - (1)].s)->Next != NULL 
				&&	(yyvsp[(0) - (1)].s)->Next->pType != tArray 
				&&	(yyvsp[(0) - (1)].s)->Next->pType != tString 
			)

				SymNode_t 		*s;
				char			msg[1200];

				sprintf
				( 
					msg, 
					"Too few macro parameters (%s:%d)",
					globalMacroFilename,
					globalMacroLineCnt
				);
				ErrorNear
				( 
					msg, 
					(yyvsp[(1) - (1)].v.u.strval), 
					__LINE__,
					__FILE__ 
				);

				/*
				** Okay, we don't have enough parameters, so let's
				** create some fake ones so the system won't crash on us.
				*/

				s = (yyvsp[(0) - (1)].s);
				_while( s != NULL )

					v.u.strval = hlastrdup2( "" );
					SetSym
					( 
						s,
						&text_ste,			/* Type					*/
						tText, 				/* pType				*/
						0,					/* Arity				*/
						NULL,				/* Dimensions			*/
						0, 					/* NumElements			*/
						YYS &v,				/* Value				*/
						0,					/* Object Size			*/
						0,					/* Offset				*/
						NULL,				/* Static Name			*/
						NULL,				/* Record BASE address	*/
						NULL,				/* Fields				*/
						0,					/* FieldCnt				*/ 
						NULL,				/* CurField				*/
						0					/* CurIndex				*/ 
					);
					s = s->Next;

				_endwhile
					

			_else

				/*
				** Okay, this is the last actual parameter and there is
				** exactly one formal parameter left.  Process that
				** parameter here.
				**
				** First, check to see if this is a regular (non-VAR/STRING)
				** parameter.
				*/

				_if( (yyvsp[(0) - (1)].s)->pType == tText )

					v.u.strval = (yyvsp[(1) - (1)].v.u.strval);
					SetSym
					( 
						(yyvsp[(0) - (1)].s),
						&text_ste,			/* Type					*/
						tText, 				/* pType				*/
						0,					/* Arity				*/
						NULL,				/* Dimensions			*/
						0, 					/* NumElements			*/
						YYS &v,				/* Value				*/
						0,					/* Object Size			*/
						0,					/* Offset				*/
						NULL,				/* Static Name			*/
						NULL,				/* Record BASE address	*/
						NULL,				/* Fields				*/
						0,					/* FieldCnt				*/ 
						NULL,				/* CurField				*/
						0					/* CurIndex				*/ 
					);

				
				_elseif( (yyvsp[(0) - (1)].s)->pType == tString)

					v.u.strval = (yyvsp[(1) - (1)].v.u.strval);
					SetSym
					( 
						(yyvsp[(0) - (1)].s),
						&string_ste,		/* Type					*/
						tString, 			/* pType				*/
						0,					/* Arity				*/
						NULL,				/* Dimensions			*/
						0, 					/* NumElements			*/
						YYS &v,				/* Value				*/
						0,					/* Object Size			*/
						0,					/* Offset				*/
						NULL,				/* Static Name			*/
						NULL,				/* Record BASE address	*/
						NULL,				/* Fields				*/
						0,					/* FieldCnt				*/ 
						NULL,				/* CurField				*/
						0					/* CurIndex				*/ 
					);

				
				_elseif( (yyvsp[(0) - (1)].s)->pType == tArray )

					/*
					** Okay, we must be processing a VAR  parameter
					** at this point.  Since this is the last
					** actual parameter, we can now allocate storage
					** for the array of strings (for the VAR parm)
					** and store the current parameter into the *last*
					** element of that string array.
					*/


					int			*Dims;
					SymNode_t 	*TheParms;

					++VarMacParms;			/* One last parameter	*/
					TheParms =	malloc2
								(
									VarMacParms * sizeofSymNode
								);

					/*
					** Initialize each element of the string array so
					** we can store data into these elements as we
					** unwind the recursive calls later.
					**
					** Note that the actual type and value is irrelevant
					** since it will all be overwritten later.
					*/

					_for( int i=0, i < VarMacParms, ++i )

						TheParms[i].Type = &uns8_ste;
						TheParms[i].pType = tUns8;
						TheParms[i].SymClass = cValue;
						TheParms[i].u.unsval = 0;


					_endfor

					/*
					** Store the text of the current parameter into
					** the last entry of the string array.
					*/

					SetSym
					( 
						&TheParms[ VarMacParms - 1 ],
						&string_ste,		/* Type					*/
						tString,			/* pType				*/
						0,					/* Arity				*/
						NULL,				/* Dimensions			*/
						0, 					/* NumElements			*/
						YYS &(yyvsp[(1) - (1)].v),			/* Value				*/
						0,					/* Object Size			*/
						0,					/* Offset				*/
						NULL,				/* Static Name			*/
						NULL,				/* Record BASE address	*/
						NULL,				/* Fields				*/
						0,					/* FieldCnt				*/ 
						NULL,				/* CurField				*/
						0					/* CurIndex				*/ 
					);

					
					/*
					** Set up the symbol table entry for the array of
					** strings object.
					*/

					v.u.ArrayOfValues = TheParms;
					Dims = malloc2( sizeofInt );
					*Dims = VarMacParms;
					SetSym
					( 
						(yyvsp[(0) - (1)].s),
						&string_ste,		/* Type					*/
						tArray,				/* pType				*/
						1,					/* Arity				*/
						Dims,				/* Dimensions			*/
						VarMacParms,		/* NumElements			*/
						YYS &v,				/* Value				*/
						VarMacParms*4,		/* Object Size			*/
						0,					/* Offset				*/
						NULL,				/* Static Name			*/
						NULL,				/* Record BASE address	*/
						NULL,				/* Fields				*/
						0,					/* FieldCnt				*/ 
						NULL,				/* CurField				*/
						0					/* CurIndex				*/ 
					);

					/*
					** Must return a pointer to the array data so
					** we can store the previous entries as well.
					** Also, we just ate the last parameter, so subtract
					** it from the number we need to still process.
					*/

					(yyval.v.u.ArrayOfValues) = TheParms;
					--VarMacParms;

				_else
				
					sprintf
					( 
						msg, 
						"Internal HLA error -- unknown macro parm type (%s:%d)",
						globalMacroFilename,
						globalMacroLineCnt
					);
				
					yyerror( msg );

				_endif

				/*
				** Check to see if there was a VAR parameter at the
				** end of the formal parameter list.  Since there are
				** no more actual parameters, we need to create an array
				** with a single empty string in it if this is the case.
				**
				** Note that we only do this if the last actual parameter
				** was not associated with a VAR formal parameter.  That
				** is, there was an extra VAR parameter at the end of the
				** formal parameter list and the current set of actual
				** parameters only fulfilled the needs of the non-VAR
				** formal parameters.
				*/

				_if( (yyvsp[(0) - (1)].s)->Next != NULL )
				
					_if( (yyvsp[(0) - (1)].s)->Next->pType == tArray )

						int			*Dims;
						SymNode_t	*ps = (yyvsp[(0) - (1)].s)->Next;

						/*
						** Free any existing variable parameter value.
						*/

						FreeValue( YYS ps );

						/*
						** Must allocate dummy objects so they can
						** be freed later.
						*/

						ps->Type = &string_ste;
						ps->pType = tArray;
						ps->SymClass = cValue;
						ps->Arity = 1;

						Dims = malloc2( sizeofInt );
						*Dims = 0;
						ps->Dimensions = Dims;

						ps->NumElements = 0;
						ps->u.ArrayOfValues = NULL;
						
					_elseif( (yyvsp[(0) - (1)].s)->Next->pType == tString )

							int			*Dims;
							SymNode_t	*ps = (yyvsp[(0) - (1)].s)->Next;

							
							// Free any existing variable parameter value.
							
							FreeValue( YYS ps );

							// Set this guy to the empty string.
							
							ps->Type = &string_ste;
							ps->pType = tString;
							ps->SymClass = cValue;
							ps->Arity = 0;

							ps->Dimensions = NULL;

							ps->NumElements = 0;
							ps->u.strval = hlastrdup2( "" );


					_endif
					
				_endif

			_endif
			_here;

		;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 3880 "hlaparse.bsn"
    { 
			char	msg[1200];
			
			/*
			** Have we exhausted all the formal parameters already?
			*/

			_here;
			_if( (yyvsp[(0) - (3)].s) == NULL )

				sprintf
				( 
					msg, 
					"Too many macro parameters (%s:%d)",
					globalMacroFilename,
					globalMacroLineCnt
				);

				yyerror( "Too many macro parameters" );
				
				// If we get to this point, must quit because
				// continuing will cause the program to crash.
				
				exit( 1 );


			_elseif( (yyvsp[(0) - (3)].s)->pType == tText )

				(yyval.s) = (yyvsp[(0) - (3)].s)->Next;

			_else // tArray or tString

				(yyval.s) = (yyvsp[(0) - (3)].s);
				++VarMacParms;	/* One more variable parameter */

			_endif
			_here;
		;}
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 3919 "hlaparse.bsn"
    {
			char msg[1200];
			
			_here;
			_if( (yyvsp[(5) - (5)].v.u.ArrayOfValues) == NULL )
			
				sprintf
				( 
					msg, 
					"Syntax error in macro parameter list (%s:%d)",
					globalMacroFilename,
					globalMacroLineCnt
				);
			
				yyerror( msg );

			_elseif( VarMacParms > 0 )
			
				_if( (yyvsp[(0) - (5)].s)->pType == tString )
				
					char 		*newStr;
					int	 		prependLen = strlen( (yyvsp[(1) - (5)].v.u.strval) );
					int  		suffixLen  = strlen( (yyvsp[(0) - (5)].s)->u.strval );
					SymNode_t	v;

				
					--VarMacParms;	/* One less parameter, now */

					newStr = malloc2( prependLen + suffixLen + 2 );
					strcpy( newStr, (yyvsp[(1) - (5)].v.u.strval) );
					newStr[ prependLen ] = ',';
					strcpy( newStr + prependLen+1,  (yyvsp[(0) - (5)].s)->u.strval );
					v.u.strval = newStr;

					SetSym
					( 
						(yyvsp[(0) - (5)].s),
						&string_ste,		/* Type					*/
						tString, 			/* pType				*/
						0,					/* Arity				*/
						NULL,				/* Dimensions			*/
						0, 					/* NumElements			*/
						YYS &v,				/* Value				*/
						0,					/* Object Size			*/
						0,					/* Offset				*/
						NULL,				/* Static Name			*/
						NULL,				/* Record BASE address	*/
						NULL,				/* Fields				*/
						0,					/* FieldCnt				*/ 
						NULL,				/* CurField				*/
						0					/* CurIndex				*/ 
					);
					
				
				_elseif( (yyvsp[(0) - (5)].s)->pType == tArray )

					
					// If VarMacParms is greater than zero, and we're
					// processing a VAR formal parameter then the current
					// actual parameter needs to be assigned to the
					// appropriate element of the VAR parm array of strings.
					

					--VarMacParms;	/* One less parameter, now */
					SetSym
					( 
						&(yyvsp[(5) - (5)].v.u.ArrayOfValues)[ VarMacParms ],
						&string_ste,		/* Type					*/
						tString,			/* pType				*/
						0,					/* Arity				*/
						NULL,				/* Dimensions			*/
						0, 					/* NumElements			*/
						YYS &(yyvsp[(1) - (5)].v),			/* Value				*/
						0,					/* Object Size			*/
						0,					/* Offset				*/
						NULL,				/* Static Name			*/
						NULL,				/* Record BASE address	*/
						NULL,				/* Fields				*/
						0,					/* FieldCnt				*/ 
						NULL,				/* CurField				*/
						0					/* CurIndex				*/ 
					);
					(yyval.v.u.ArrayOfValues) = (yyvsp[(5) - (5)].v.u.ArrayOfValues);
					
				_else
				
					sprintf
					( 
						msg, 
						"Internal HLA error processing macro parms (%s:%d)",
						globalMacroFilename,
						globalMacroLineCnt
					);
				
					yyerror( msg );
					
				_endif



			_else

				/*
				** Here we have a standard formal parameter.
				** Assign to it the value of the current actual parameter.
				*/

				SymNode_t v;

				v.u.strval = (yyvsp[(1) - (5)].v.u.strval);
				SetSym
				( 
					(yyvsp[(0) - (5)].s),
					&text_ste,			/* Type					*/
					tText, 				/* pType				*/
					0,					/* Arity				*/
					NULL,				/* Dimensions			*/
					0, 					/* NumElements			*/
					YYS &v,				/* Value				*/
					0,					/* Object Size			*/
					0,					/* Offset				*/
					NULL,				/* Static Name			*/
					NULL,				/* Record BASE address	*/
					NULL,				/* Fields				*/
					0,					/* FieldCnt				*/ 
					NULL,				/* CurField				*/
					0					/* CurIndex				*/ 
				);

			_endif
			(void) (yyvsp[(4) - (5)].s);	// Shut up bison, we really use this.
			_here;
		;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 4058 "hlaparse.bsn"
    {
				SymNode_t	v;
				char		msg[1200];
				
				_here;
				_if( (yyvsp[(0) - (0)].s) != NULL )

					_if( (yyvsp[(0) - (0)].s)->pType != tArray )

						SymNode_t *s;

						sprintf
						( 
							msg, 
							"Macro invocation needs parameters (%s:%d)",
							globalMacroFilename,
							globalMacroLineCnt
						);
						yyerror( msg );

						/*
						** Okay, we don't have enough parameters, so let's
						** create some fake ones so the system won't crash 
						** on us.
						*/

						s = (yyvsp[(0) - (0)].s);
						_while( s != NULL )

							v.u.strval = hlastrdup2( "" );
							SetSym
							( 
								s,
								&text_ste,			/* Type					*/
								tText, 				/* pType				*/
								0,					/* Arity				*/
								NULL,				/* Dimensions			*/
								0, 					/* NumElements			*/
								YYS &v,				/* Value				*/
								0,					/* Object Size			*/
								0,					/* Offset				*/
								NULL,				/* Static Name			*/
								NULL,				/* Record BASE address	*/
								NULL,				/* Fields				*/
								0,					/* FieldCnt				*/ 
								NULL,				/* CurField				*/
								0					/* CurIndex				*/ 
							);
							s = s->Next;

						_endwhile
							

					_endif

					/*
					** Check to see if there was a VAR or string parameter at 
					** the end of the formal parameter list.  Since there are
					** no more actual parameters, we need to create an array
					** with a single empty string in it if this is the case.
					**
					** Note that we only do this if the last actual parameter
					** was not associated with a VAR/string formal parameter.
					** That is, there was an extra VAR parameter at the end of
					** the formal parameter list and the current set of actual
					** parameters only fulfilled the needs of the non-VAR/string
					** formal parameters.
					*/

					_if( (yyvsp[(0) - (0)].s)->Next != NULL )
					
						_if( (yyvsp[(0) - (0)].s)->Next->pType == tArray )

							int			*Dims;
							SymNode_t	*ps = (yyvsp[(0) - (0)].s)->Next;

							/*
							** Free any existing variable parameter value.
							*/

							FreeValue( YYS ps );

							/*
							** Must allocate dummy objects so they can
							** be freed later.
							*/

							ps->Type = &string_ste;
							ps->pType = tArray;
							ps->SymClass = cValue;
							ps->Arity = 1;

							Dims = malloc2( sizeofInt );
							*Dims = 0;
							ps->Dimensions = Dims;

							ps->NumElements = 0;
							ps->u.ArrayOfValues = NULL;
							
						_elseif( (yyvsp[(0) - (0)].s)->Next->pType == tString )

							int			*Dims;
							SymNode_t	*ps = (yyvsp[(0) - (0)].s)->Next;

							/*
							** Free any existing string parameter value.
							*/

							FreeValue( YYS ps );

							/*
							** Must allocate dummy objects so they can
							** be freed later.
							*/

							ps->Type = &string_ste;
							ps->pType = tString;
							ps->SymClass = cValue;
							ps->Arity = 0;
							ps->NumElements = 0;							
							ps->u.strval = hlastrdup2( "" );

						_endif

					_endif

				_endif
				_here;
			;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 4189 "hlaparse.bsn"
    {
				_here;
				doMacParm();
				_here;
			;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 4213 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected ';', encountered '%s'",
				yytext
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 4236 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected ':', encountered '%s'\n"
				"(Possible undefined ID)",
				yytext
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 4259 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected ':=', encountered '%s'",
				yytext
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 4282 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected '(', encountered '%s'",
				yytext
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 4305 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected ')', encountered '%s'",
				yytext
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 4328 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected ']', encountered '%s'",
				yytext
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 4352 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected '[', encountered '%s'",
				yytext
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 4378 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected '}', encountered '%s'",
				yytext
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 4406 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected '{', encountered '%s'",
				yytext
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 4432 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected ',', encountered '%s'",
				yytext
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 4450 "hlaparse.bsn"
    {
			TempIgnoreErrors = 1;
		;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 4469 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_al;
		;}
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 4475 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_ah;
		;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 4481 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_bl;
		;}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 4487 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_bh;
		;}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 4493 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_cl;
		;}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 4499 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_ch;
		;}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 4505 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_dl;
		;}
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 4511 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_dh;
		;}
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 4519 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_ax;
		;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 4525 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_bx;
		;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 4531 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_cx;
		;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 4537 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_dx;
		;}
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 4543 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_sp;
		;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 4549 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_bp;
		;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 4555 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_si;
		;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 4561 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_di;
		;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 4569 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_eax;
		;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 4575 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_ebx;
		;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 4581 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_ecx;
		;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 4587 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_edx;
		;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 4593 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_ebp;
		;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 4599 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_esi;
		;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 4605 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_edi;
		;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 4611 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_esp;
		;}
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 4621 "hlaparse.bsn"
    {
			(yyval.reg.encoding) = (yyvsp[(1) - (1)].u);
			(yyval.reg.Size) = 1;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tByte;
			(yyval.reg.Type) = &byte_ste;
				
		;}
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 4632 "hlaparse.bsn"
    {
			(yyval.reg.encoding) = (yyvsp[(2) - (2)].u);
			(yyval.reg.Size) = 1;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tByte;
			(yyval.reg.Type) = &byte_ste;
				
		;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 4647 "hlaparse.bsn"
    {			/* $6 */
		
			_if( (yyvsp[(3) - (5)].s)->ObjectSize != (yyvsp[(4) - (5)].reg.Size) )
			
				ErrorNear
				(
					"Illegal register size.",
					regStrs[ (yyvsp[(4) - (5)].reg.encoding) ],
					__LINE__,
					__FILE__
				);
				
			_endif
			(yyval.reg.encoding) = (yyvsp[(4) - (5)].reg.encoding);
			(yyval.reg.Size) = (yyvsp[(4) - (5)].reg.Size);
			(yyval.reg.IsSigned) = IsInt( (yyvsp[(3) - (5)].s)->pType );
			(yyval.reg.pType) = (yyvsp[(3) - (5)].s)->pType;
			(yyval.reg.Type) = (yyvsp[(3) - (5)].s);
		;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 4673 "hlaparse.bsn"
    {			/* $7 */
		
			_if( (yyvsp[(4) - (6)].s)->ObjectSize != (yyvsp[(5) - (6)].reg.Size) )
			
				ErrorNear
				(
					"Illegal register size.",
					regStrs[ (yyvsp[(5) - (6)].reg.encoding) ],
					__LINE__,
					__FILE__
				);
				
			_endif
			(yyval.reg.encoding) = (yyvsp[(5) - (6)].reg.encoding);
			(yyval.reg.Size) = (yyvsp[(5) - (6)].reg.Size);
			(yyval.reg.IsSigned) = IsInt( (yyvsp[(4) - (6)].s)->pType );
			(yyval.reg.pType) = (yyvsp[(4) - (6)].s)->pType;
			(yyval.reg.Type) = (yyvsp[(4) - (6)].s);
		;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 4698 "hlaparse.bsn"
    {
			(yyval.reg.encoding) = (yyvsp[(1) - (1)].u);
			(yyval.reg.Size) = 1;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tByte;
			(yyval.reg.Type) = &byte_ste;
				
		;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 4713 "hlaparse.bsn"
    {			/* $6 */
		
			_if( (yyvsp[(3) - (5)].s)->ObjectSize != (yyvsp[(4) - (5)].reg.Size) )
			
				ErrorNear
				(
					"Illegal register size.",
					regStrs[ (yyvsp[(4) - (5)].reg.encoding) ],
					__LINE__,
					__FILE__
				);
				
			_endif
			(yyval.reg.encoding) = (yyvsp[(4) - (5)].reg.encoding);
			(yyval.reg.Size) = (yyvsp[(4) - (5)].reg.Size);
			(yyval.reg.IsSigned) = IsInt( (yyvsp[(3) - (5)].s)->pType );
			(yyval.reg.pType) = (yyvsp[(3) - (5)].s)->pType;
			(yyval.reg.Type) = (yyvsp[(3) - (5)].s);
		;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 4738 "hlaparse.bsn"
    {
			(yyval.reg.encoding) = (yyvsp[(1) - (1)].u);
			(yyval.reg.Size) = 2;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tWord;
			(yyval.reg.Type) = &word_ste;
		;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 4752 "hlaparse.bsn"
    {			/* $6 */
		
			_if( (yyvsp[(3) - (5)].s)->ObjectSize != (yyvsp[(4) - (5)].reg.Size) )
			
				ErrorNear
				(
					"Illegal register size.",
					regStrs[ (yyvsp[(4) - (5)].reg.encoding) ],
					__LINE__,
					__FILE__
				);
				
			_endif
			(yyval.reg.encoding) = (yyvsp[(4) - (5)].reg.encoding);
			(yyval.reg.Size) = (yyvsp[(4) - (5)].reg.Size);
			(yyval.reg.IsSigned) = IsInt( (yyvsp[(3) - (5)].s)->pType );
			(yyval.reg.pType) = (yyvsp[(3) - (5)].s)->pType;
			(yyval.reg.Type) = (yyvsp[(3) - (5)].s);
		;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 4777 "hlaparse.bsn"
    {
			(yyval.reg.encoding) = (yyvsp[(1) - (1)].u);
			(yyval.reg.Size) = 2;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tWord;
			(yyval.reg.Type) = &word_ste;
		;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 4787 "hlaparse.bsn"
    {
			(yyval.reg.encoding) = (yyvsp[(2) - (2)].u);
			(yyval.reg.Size) = 2;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tWord;
			(yyval.reg.Type) = &word_ste;
		;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 4801 "hlaparse.bsn"
    {			/* $6 */
		
			_if( (yyvsp[(3) - (5)].s)->ObjectSize != (yyvsp[(4) - (5)].reg.Size) )
			
				ErrorNear
				(
					"Illegal register size.",
					regStrs[ (yyvsp[(4) - (5)].reg.encoding) ],
					__LINE__,
					__FILE__
				);
				
			_endif
			(yyval.reg.encoding) = (yyvsp[(4) - (5)].reg.encoding);
			(yyval.reg.Size) = (yyvsp[(4) - (5)].reg.Size);
			(yyval.reg.IsSigned) = IsInt( (yyvsp[(3) - (5)].s)->pType );
			(yyval.reg.pType) = (yyvsp[(3) - (5)].s)->pType;
			(yyval.reg.Type) = (yyvsp[(3) - (5)].s);
		;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 4827 "hlaparse.bsn"
    {			/* $7 */
		
			_if( (yyvsp[(4) - (6)].s)->ObjectSize != (yyvsp[(5) - (6)].reg.Size) )
			
				ErrorNear
				(
					"Illegal register size.",
					regStrs[ (yyvsp[(5) - (6)].reg.encoding) ],
					__LINE__,
					__FILE__
				);
				
			_endif
			(yyval.reg.encoding) = (yyvsp[(5) - (6)].reg.encoding);
			(yyval.reg.Size) = (yyvsp[(5) - (6)].reg.Size);
			(yyval.reg.IsSigned) = IsInt( (yyvsp[(4) - (6)].s)->pType );
			(yyval.reg.pType) = (yyvsp[(4) - (6)].s)->pType;
			(yyval.reg.Type) = (yyvsp[(4) - (6)].s);
		;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 4852 "hlaparse.bsn"
    {
			(yyval.reg.encoding) = (yyvsp[(1) - (1)].u);
			(yyval.reg.Size) = 4;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tDWord;
			(yyval.reg.Type) = &dword_ste;
		;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 4866 "hlaparse.bsn"
    {			/* $6 */
		
			_if( (yyvsp[(3) - (5)].s)->ObjectSize != (yyvsp[(4) - (5)].reg.Size) )
			
				ErrorNear
				(
					"Illegal register size.",
					regStrs[ (yyvsp[(4) - (5)].reg.encoding) ],
					__LINE__,
					__FILE__
				);
			
			_endif
			(yyval.reg.encoding) = (yyvsp[(4) - (5)].reg.encoding);
			(yyval.reg.Size) = (yyvsp[(4) - (5)].reg.Size);
			(yyval.reg.IsSigned) = IsInt( (yyvsp[(3) - (5)].s)->pType );
			(yyval.reg.pType) = (yyvsp[(3) - (5)].s)->pType;
			(yyval.reg.Type) = (yyvsp[(3) - (5)].s);
		;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 4891 "hlaparse.bsn"
    {
			(yyval.reg.encoding) = (yyvsp[(1) - (1)].u);
			(yyval.reg.Size) = 4;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tDWord;
			(yyval.reg.Type) = &dword_ste;
		;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 4901 "hlaparse.bsn"
    {
			(yyval.reg.encoding) = (yyvsp[(2) - (2)].u);
			(yyval.reg.Size) = 4;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tDWord;
			(yyval.reg.Type) = &dword_ste;
		;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 4914 "hlaparse.bsn"
    {			/* $6 */
		
			_if( (yyvsp[(3) - (5)].s)->ObjectSize != (yyvsp[(4) - (5)].reg.Size) )
			
				ErrorNear
				(
					"Illegal register size.",
					regStrs[ (yyvsp[(4) - (5)].reg.encoding) ],
					__LINE__,
					__FILE__
				);
			
			_endif
			(yyval.reg.encoding) = (yyvsp[(4) - (5)].reg.encoding);
			(yyval.reg.Size) = (yyvsp[(4) - (5)].reg.Size);
			(yyval.reg.IsSigned) = IsInt( (yyvsp[(3) - (5)].s)->pType );
			(yyval.reg.pType) = (yyvsp[(3) - (5)].s)->pType;
			(yyval.reg.Type) = (yyvsp[(3) - (5)].s);
		;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 4940 "hlaparse.bsn"
    {			/* $7 */
		
			_if( (yyvsp[(4) - (6)].s)->ObjectSize != (yyvsp[(5) - (6)].reg.Size) )
			
				ErrorNear
				(
					"Illegal register size.",
					regStrs[ (yyvsp[(5) - (6)].reg.encoding) ],
					__LINE__,
					__FILE__
				);
			
			_endif
			(yyval.reg.encoding) = (yyvsp[(5) - (6)].reg.encoding);
			(yyval.reg.Size) = (yyvsp[(5) - (6)].reg.Size);
			(yyval.reg.IsSigned) = IsInt( (yyvsp[(4) - (6)].s)->pType );
			(yyval.reg.pType) = (yyvsp[(4) - (6)].s)->pType;
			(yyval.reg.Type) = (yyvsp[(4) - (6)].s);
		;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 4964 "hlaparse.bsn"
    {
			(yyval.reg) = (yyvsp[(1) - (1)].reg);
		;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 4971 "hlaparse.bsn"
    {
			(yyval.reg) = (yyvsp[(1) - (1)].reg);
		;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 4978 "hlaparse.bsn"
    {
			(yyval.reg) = (yyvsp[(1) - (1)].reg);
		;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 4987 "hlaparse.bsn"
    {
			(yyval.reg) = (yyvsp[(1) - (1)].reg);
		;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 4994 "hlaparse.bsn"
    {
			(yyval.reg) = (yyvsp[(1) - (1)].reg);
		;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 5001 "hlaparse.bsn"
    {
			(yyval.reg) = (yyvsp[(1) - (1)].reg);
		;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 5012 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(1) - (1)].reg.encoding);
		;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 5017 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(1) - (1)].reg.encoding);
		;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 5025 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(1) - (1)].u);
		;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 5031 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(1) - (2)].u);
		;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 5038 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 0;
		;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 5044 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 1;
		;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 5050 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 2;
		;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 5056 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 3;
		;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 5062 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 4;
		;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 5068 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 5;
		;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 5074 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 6;
		;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 5080 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 7;
		;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 5092 "hlaparse.bsn"
    {
			(yyval.u) = reg_eseg;
			_here;
		;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 5098 "hlaparse.bsn"
    {
			(yyval.u) = reg_cseg;
			_here;
		;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 5104 "hlaparse.bsn"
    {
			(yyval.u) = reg_sseg;
			_here;
		;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 5109 "hlaparse.bsn"
    {
			(yyval.u) = reg_dseg;
			_here;
		;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 5115 "hlaparse.bsn"
    {
			(yyval.u) = reg_fseg;
			_here;
		;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 5121 "hlaparse.bsn"
    {
			(yyval.u) = reg_gseg;
			_here;
		;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 5129 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(1) - (1)].u);
		;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 5135 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(2) - (2)].u);
		;}
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 5147 "hlaparse.bsn"
    {
			(yyval.u) = 0;
			_here;
		;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 5153 "hlaparse.bsn"
    {
			(yyval.u) = 2;
			_here;
		;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 5159 "hlaparse.bsn"
    {
			(yyval.u) = 3;
			_here;
		;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 5165 "hlaparse.bsn"
    {
			(yyval.u) = 4;
			_here;
		;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 5174 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(1) - (1)].u);
		;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 5180 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(2) - (2)].u);
		;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 5190 "hlaparse.bsn"
    {
			(yyval.u) = 0;
			_here;
		;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 5196 "hlaparse.bsn"
    {
			(yyval.u) = 1;
			_here;
		;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 5202 "hlaparse.bsn"
    {
			(yyval.u) = 2;
			_here;
		;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 5208 "hlaparse.bsn"
    {
			(yyval.u) = 3;
			_here;
		;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 5214 "hlaparse.bsn"
    {
			(yyval.u) = 6;
			_here;
		;}
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 5220 "hlaparse.bsn"
    {
			(yyval.u) = 7;
			_here;
		;}
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 5228 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(1) - (1)].u);
		;}
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 5234 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(2) - (2)].u);
		;}
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 5246 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(1) - (1)].u);
		;}
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 5252 "hlaparse.bsn"
    {
			(yyval.u) = (yyvsp[(1) - (2)].u);
		;}
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 5260 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 0;
		;}
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 5266 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 1;
		;}
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 5272 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 2;
		;}
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 5278 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 3;
		;}
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 5284 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 4;
		;}
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 5290 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 5;
		;}
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 5296 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 6;
		;}
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 5302 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 7;
		;}
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 5326 "hlaparse.bsn"
    {					/* $2 */
			inCTL = 1;
		;}
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 5331 "hlaparse.bsn"
    {					/* $5 */
			inCTL = 0;
			wasCTL = 1;
		;}
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 5355 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 5364 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 183:

/* Line 1464 of yacc.c  */
#line 5373 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 5381 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (4)].ru.saveCurNS); 
		;}
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 5397 "hlaparse.bsn"
    {						/* $10 */

			SymNode_t *CurSym;

			assert( (yyvsp[(8) - (9)].neID.idStr) != NULL );


			/*
			** Reset NSGlobal pointer (used by @global) since
			** we're no longer in a namespace.
			**
			** Ditto for currentNS (since we shouldn't be using
			** a hash table for a search while outside a namespace.  
			*/

			NSGlobal = NULL;
			currentNS = NULL;
			
			/*
			** Mark the end of the local symbols in this
			** Name Space with a NULL terminating link.
			*/

			_if( SymbolTable == (yyvsp[(3) - (9)].s) )

				yyerror( "Namespaces must have at least one field" );

				/*
				** Create a dummy set of fields to
				** prevent any problems from occurring.
				*/

				(yyvsp[(3) - (9)].s)->Fields = &error_ste;

			_else

				(yyvsp[(3) - (9)].s)->Fields = SymbolTable;
				CurSym = SymbolTable;
				_while( CurSym->Next != (yyvsp[(3) - (9)].s) )

					assert( CurSym->Next != NULL );
					CurSym = CurSym->Next;

				_endwhile
				CurSym->Next = NULL;

			_endif
			

			/*
			** Check to make sure all pointer forward references have
			** been resolved.
			*/

			CheckPtrs();
			
				
			/*
			** Restore linkage to the rest of the symbol table.
			*/

			(yyvsp[(3) - (9)].s)->Next = (yyvsp[(3) - (9)].s)->Base;
			(yyvsp[(3) - (9)].s)->Base = NULL;


			/*
			** Be sure the identifier after the END keyword
			** matches the name space name.
			*/

			_if( _strne( (yyvsp[(2) - (9)].idStr), (yyvsp[(8) - (9)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				(
					msg,
					"Identifier <<%s>> after END in name space\n"
					"declaration must match <<%s>>",
					(yyvsp[(8) - (9)].neID.idStr),
					(yyvsp[(2) - (9)].idStr)
				);
				yyerror( msg );

			_endif

			/*
			** Remove the local symbols in this namespace
			** from the symbol table.
			*/

			SymbolTable = (yyvsp[(3) - (9)].s);
			
			/*
			** Restore the previous PointerList value
			*/
			
			PointerList = (yyvsp[(5) - (9)].plist);

			/*
			** Convert the symbol to a Namespace object.
			** We couldn't do this before this point because
			** we wouldn't be able to handle the "end <id>;"
			** syntax if "<id>" was a namespace object.
			*/

			(yyvsp[(3) - (9)].s)->pType = tNamespace;


			inNamespace = 0;
			free2( vss (yyvsp[(8) - (9)].neID.idStr) );
		;}
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 5523 "hlaparse.bsn"
    {					/* $11 */

			SymNode_t *CurSym;

			assert( (yyvsp[(9) - (10)].neID.idStr) != NULL );


			/*
			** Reset NSGlobal pointer (used by @global) since

			** we're no longer in a namespace.
			**
			** Ditto for currentNS (since we shouldn't be using
			** a hash table for a search while outside a namespace.  
			*/

			NSGlobal = NULL;
			currentNS = NULL;
			
			/*
			** Mark the end of the local symbols in this
			** Name Space with a NULL terminating link.
			*/

			_if( SymbolTable == (yyvsp[(3) - (10)].s) )

				yyerror( "Namespaces must have at least one field" );

				/*
				** Create a dummy set of fields to
				** prevent any problems from occurring.
				*/

				(yyvsp[(3) - (10)].s)->Fields = &error_ste;

			_else

				(yyvsp[(3) - (10)].s)->Fields = SymbolTable;
				CurSym = SymbolTable;
				_while( CurSym->Next != (yyvsp[(3) - (10)].s) )

					assert( CurSym->Next != NULL );
					CurSym = CurSym->Next;

				_endwhile
				CurSym->Next = NULL;

			_endif
			

			/*
			** Check to make sure all pointer forward references have
			** been resolved.
			*/

			CheckPtrs();
			
				
			/*
			** Restore linkage to the rest of the symbol table.
			*/

			(yyvsp[(3) - (10)].s)->Next = (yyvsp[(3) - (10)].s)->Base;
			(yyvsp[(3) - (10)].s)->Base = NULL;


			/*
			** Be sure the identifier after the END keyword
			** matches the name space name.
			*/

			_if( _strne( (yyvsp[(2) - (10)].idStr), (yyvsp[(9) - (10)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				(
					msg,
					"Identifier <<%s>> after END in name space\n"
					"declaration must match <<%s>>",
					(yyvsp[(9) - (10)].neID.idStr),
					(yyvsp[(2) - (10)].idStr)
				);
				yyerror( msg );

			_endif

			/*
			** Remove the local symbols in this namespace
			** from the symbol table.
			*/

			SymbolTable = (yyvsp[(3) - (10)].s);
			
			/*
			** Restore the previous PointerList value
			*/
			
			PointerList = (yyvsp[(6) - (10)].plist);

			/*
			** Convert the symbol to a Namespace object.
			** We couldn't do this before this point because
			** we wouldn't be able to handle the "end <id>;"
			** syntax if "<id>" was a namespace object.
			*/

			(yyvsp[(3) - (10)].s)->pType = tNamespace;


			inNamespace = 0;
			free2( vss (yyvsp[(9) - (10)].neID.idStr) );
			
			/*
			** Turn off the Fast Namespace operation
			*/
			
			fastNamespace = 0;
		;}
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 5657 "hlaparse.bsn"
    {					/* $10 */

			assert( (yyvsp[(8) - (9)].neID.idStr) != NULL );


			/*
			** Reset NSGlobal pointer (used by @global) since
			** we're no longer in a namespace.
			**
			** Ditto for currentNS.
			*/

			NSGlobal = NULL;
			currentNS = NULL;

			/*
			** Add the new identifiers to the name space:
			*/

			(yyvsp[(2) - (9)].s)->Fields = SymbolTable;
			(yyvsp[(2) - (9)].s)->Base = NULL;
				
			/*
			** Restore linkage to the rest of the symbol table.
			*/

			SymbolTable = (yyvsp[(3) - (9)].s);
			
			/*
			** Restore PointerList:
			*/
			
			PointerList = (yyvsp[(5) - (9)].plist);


			/*
			** Be sure the identifier after the END keyword
			** matches the name space name.
			*/

			_if( _strne( (yyvsp[(2) - (9)].s)->TrueName, (yyvsp[(8) - (9)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				(
					msg,
					"Identifier <<%s>> after END in name space\n"
					"declaration must match <<%s>>",
					(yyvsp[(8) - (9)].neID.idStr),
					(yyvsp[(2) - (9)].s)->TrueName
				);
				yyerror( msg );

			_endif



			inNamespace = 0;
			free2( vss (yyvsp[(8) - (9)].neID.idStr) );
		;}
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 5733 "hlaparse.bsn"
    {					/* $11 */

			assert( (yyvsp[(9) - (10)].neID.idStr) != NULL );


			/*
			** Reset NSGlobal pointer (used by @global) since
			** we're no longer in a namespace.
			**
			** Ditto for currentNS.
			*/

			NSGlobal = NULL;
			currentNS = NULL;

			/*
			** Add the new identifiers to the name space:
			*/

			(yyvsp[(2) - (10)].s)->Fields = SymbolTable;
			(yyvsp[(2) - (10)].s)->Base = NULL;
				
			/*
			** Restore linkage to the rest of the symbol table.
			*/

			SymbolTable = (yyvsp[(3) - (10)].s);
			
			/*
			** Restore PointerList:
			*/
			

			PointerList = (yyvsp[(6) - (10)].plist);


			/*
			** Be sure the identifier after the END keyword
			** matches the name space name.
			*/

			_if( _strne( (yyvsp[(2) - (10)].s)->TrueName, (yyvsp[(9) - (10)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				(
					msg,
					"Identifier <<%s>> after END in name space\n"
					"declaration must match <<%s>>",
					(yyvsp[(9) - (10)].neID.idStr),
					(yyvsp[(2) - (10)].s)->TrueName
				);
				yyerror( msg );

			_endif



			inNamespace = 0;
			free2( vss (yyvsp[(9) - (10)].neID.idStr) );
			
			/*
			** Turn off the Fast Namespace operation
			*/
			
			fastNamespace = 0;
		;}
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 5829 "hlaparse.bsn"
    {				/* $3 */

			SymNode_t dummy;	/* Aribtrary value for Program object	*/


			inUnit = 1;

			/*
			** Emit the start of the program file (done here so that
			** any #asm..#endasm directives before "unit" will emit
			** their code before the initial output).
			*/

			SkeletalOutput();
		

			/*
			** Enter the unit name into the symbol table.
			*/

			CurLexLevel = 0;
			(yyval.s) = 
				InsertSym
				(
					(yyvsp[(2) - (2)].idStr),
					&pgmID_ste,
					tProgram,
					cProgram,
					0,
					NULL,
					0,
					YYS &dummy,
					0,
					0,
					NULL,
					NULL,
					NULL,
					0
				);

			CurrentContext = (yyval.s);
			(yyval.s)->u.proc.Locals =  (yyval.s)->Next;
			MainLocals = &(yyval.s)->u.proc.Locals;
			CurOffset = -4;		/* Make room for display */
			CurOffsetDir = -1;
			_here;

		;}
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 5882 "hlaparse.bsn"
    { 					/* $9 */

			char 					msg[ 256 ];
			struct	MethodListType	*temp;


			_if( _strne( (yyvsp[(2) - (8)].idStr), (yyvsp[(7) - (8)].neID.idStr) ) )
			
				yyerror( "Identifier must match unit name" );

			_endif
			
			// Reset the MainLocals (unit->u.proc.locals) to point
			// at the current local symbol table before we start
			// checking forward and static lists.
			
			*MainLocals = SymbolTable;

			/*
			** Check to ensure that all forward declared procedures
			** have be defined prior to code emission.
			*/

			CheckForwardDecls( (yyvsp[(3) - (8)].s) );

			/*
			** Check to make sure all pointer forward references have
			** been resolved.
			*/

			CheckPtrs();

			/*
			** See if there are any outstanding undefined static
			** objects at lex level zero.  Although this isn't a main
			** program, the second parameter to CheckStatic must be
			** a one since we need to check for any undefined symbols
			** at this point.
			*/

			(yyvsp[(3) - (8)].s)->u.proc.Locals = SymbolTable;
			CurrentContext = SymbolTable;
			CheckStatic( StaticList, 1 );
			
			/*
			** See if there are any undefined methods or class procedures
			** at this point.
			*/

			_while( MethodList != NULL )

				assert( MethodList->ClassSym != NULL );
				assert( MethodList->MethodSym != NULL );
				assert( MethodList->ClassSym->TrueName != NULL );
				assert( MethodList->MethodSym->TrueName != NULL );

				/*
				** If the method was declared as external, it's
				** okay if it's undefined.
				*/

				_if( !MethodList->MethodSym->IsExternal )

					sprintf
					( 
						msg,
						"Undefined class procedure/method: %s.%s\n",
						MethodList->ClassSym->TrueName,
						MethodList->MethodSym->TrueName
					);
					yyerror( msg );

				_endif
				temp = MethodList;
				MethodList = MethodList->Next;
				free2( vss temp );

			_endwhile

			/*
			** See if there are any outstanding forward reference
			** labels.
			*/

			--CurLexLevel;
			CheckFwdRef();

			free2( vss (yyvsp[(7) - (8)].neID.idStr) );
			endSourceFile();
			inUnit = 0;
			_here;

		;}
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 5996 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 6005 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 200:

/* Line 1464 of yacc.c  */
#line 6014 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 201:

/* Line 1464 of yacc.c  */
#line 6023 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 6032 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 203:

/* Line 1464 of yacc.c  */
#line 6041 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 204:

/* Line 1464 of yacc.c  */
#line 6050 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 205:

/* Line 1464 of yacc.c  */
#line 6059 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 206:

/* Line 1464 of yacc.c  */
#line 6067 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (4)].ru.saveCurNS); 
		;}
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 6076 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (4)].ru.saveCurNS); 
		;}
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 6083 "hlaparse.bsn"
    {
			(yyval.ru.saveCurNS) = currentNS;
			(yyval.ru.saveProcNS) = ProcNS;
			(yyval.ru.saveProcGlobal) = ProcGlobal;
			currentNS = NULL;
		;}
    break;

  case 227:

/* Line 1464 of yacc.c  */
#line 6186 "hlaparse.bsn"
    {				/* $3 */

		SymNode_t				dummy;	/* Aribtrary val for Pgm object	*/
		struct contextListType	*p;
		int						*dims;

		_here;

		/*
		** Set the inProgram flag for use by the @section function.
		*/

		inProgram = 1;
		wasProgram = 1;
		
		/*
		** Emit the start of the program file (done here so that
		** any #asm..#endasm directives before "program" will emit
		** their code before the initial output).
		*/

		SkeletalOutput();
		

		/*
		** Enter the program name into the symbol table.
		*/

		CurLexLevel = 0;
		InsertSym
		(
			(yyvsp[(2) - (2)].idStr),
			&pgmID_ste,
			tProgram,
			cProgram,
			0,
			NULL,
			0,
			YYS &dummy,
			0,
			0,
			NULL,
			NULL,
			NULL,
			0
		);
		(yyval.s) = SymbolTable;
		CurrentContext = SymbolTable;
		CurrentContext->u.proc.Locals =  SymbolTable->Next;
		MainLocals = &CurrentContext->u.proc.Locals;
		CurOffset = -4;		/* Make room for display */
		CurOffsetDir = -1;

		/*
		** Insert symbol table entry for "_display_" into
		** the main program's local symbols.
		*/

		dims = (int *) malloc( sizeofInt );
		*dims = 1;
		InsertSym
		(
			"_display_",
			&dword_ste,
			tDWord,
			cVar,
			1,				// Arity
			dims,			// [1]
			1,				// # elements
			NULL,			// No value
			4,				// display is 4 bytes
			CurOffset,
			NULL,			// Static name
			NULL,			// Base
			NULL,			// Fields
			0				// FieldCnt
		);



		/*
		** Add the main program to the context list so we
		** can bail on this program via the EXIT and EXITIF
		** statements.
		*/
		
		p = malloc2( sizeofContextListType );
		p->Next = contextList;
		p->label = (yyvsp[(2) - (2)].idStr);

		p->StaticName = hlastrdup2( "xHLAMain" sympost );
		p->LexLevel = CurLexLevel;
		p->IsProc = 2;
		p->HasDisplay = 1;
		p->SizeParms = 0;
		contextList = p;
		_here;

	;}
    break;

  case 228:

/* Line 1464 of yacc.c  */
#line 6290 "hlaparse.bsn"
    {				/* $9 */

		_here;
		_if( _strne( (yyvsp[(2) - (8)].idStr), (yyvsp[(8) - (8)].neID.idStr)) )
		
			yyerror( "Identifier must match program name" );

		_endif

		/*
		** Set up the _initialize_ and _finalize_ variables
		** so that they point at the strings created in the
		** Declarations production.
		*/

		_initialize_ = (yyvsp[(4) - (8)].s)->Next;
		_finalize_ = (yyvsp[(4) - (8)].s);

			
		// Reset the MainLocals (unit->u.proc.locals) to point
		// at the current local symbol table before we start
		// checking forward and static lists.
		
		*MainLocals = SymbolTable;

		/*
		** Check to ensure that all forward declared procedures
		** have be defined prior to code emission.
		*/

		CheckForwardDecls( (yyvsp[(3) - (8)].s) );

		/*
		** Check to make sure all pointer forward references have
		** been resolved.
		*/

		CheckPtrs();

		inMain = 1;
		_here;
	;}
    break;

  case 229:

/* Line 1464 of yacc.c  */
#line 6333 "hlaparse.bsn"
    {				/* $11 */

		/*
		** If this is a program compilation (vs. a unit compilation),
		** output some stuff that can only appear once in the entire
		** object module.  The stack and some important variables
		** are good examples of such items.
		*/

		SymNode_t 	*s;
		
		_here;

		/*
		** Support for coroutines.  Must define the MainPgmCoroutine
		** object as an external here (actual definition appears in
		** the stdlib code).
		*/

		_if( !threadSafe )
		
			startDseg();
			EmitImmExtern( "MainPgmCoroutine" sympost, tByte ); 
			endDseg();
			
		_endif

		/*
		** If the FullExceptions variable is true, then link in the
		** full exception handling package, otherwise, link in
		** a couple of short default handlers.
		**
		** Note that the user controls the FullExceptions value via
		** the compile time @exceptions variable.  Also note that
		** if the user has included the "excepts.hhf" include file
		** then FullExceptions has been set to true unless the user
		** has explicitly set it to false after the include.
		*/
		
		EmitExceptionCode( FullExceptions );		


		/*
		** For the main program, we need to output the assembly
		** language procedure declaration for the "?HLAMain"
		** procedure.  Note that this code always sets up a stack
		** frame and display (since it only executes once, the minor
		** inefficiency of always doing this is irrelevant).
		*/

		BeginMain( CurOffset );

		CurrentContext = (yyvsp[(3) - (10)].s);



		/*
		** Emit the text associated with the _initialize_ string
		** at this point.
		**
		**	Note: the "InvisibleCode" variable is used by
		**	yyerror to determine if it should print the
		**	_initialize_ string as part of the error message.
		*/

		
		InvisibleCode = NULL;
		_if
		( 
				_initialize_->pType != tString 
			&&	_initialize_->pType != tZString 
		)

			WarnNear
			( 
				"_initialize_'s type is not string.  Initialization ignored.",
				"_initialize_" 
			);

		_elseif( strlen( _initialize_->u.strval ) != 0 )

			InvisibleCode = _initialize_->u.strval;
			PushBackStr( "\xF3" );
			PushBackStr( _initialize_->u.strval );

		_endif
		_here;


	;}
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 6428 "hlaparse.bsn"
    { 				/* $16 */

		char 					msg[ 256 ];
		struct	MethodListType	*temp;


		_here;
		_if( _strne( (yyvsp[(2) - (15)].idStr), (yyvsp[(14) - (15)].neID.idStr) ) )
		
			yyerror( "Identifier must match program name" );

		_endif

		/*
		** See if there are any outstanding undefined static
		** objects at lex level zero.
		*/

		(yyvsp[(3) - (15)].s)->u.proc.Locals = SymbolTable;

		CurrentContext = (yyvsp[(3) - (15)].s);
		CheckStatic( StaticList, 1 );
		
		/*
		** See if there are any undefined methods or class procedures
		** at this point.
		*/

		_while( MethodList != NULL )

			assert( MethodList->ClassSym != NULL );
			assert( MethodList->MethodSym != NULL );
			assert( MethodList->ClassSym->TrueName != NULL );
			assert( MethodList->MethodSym->TrueName != NULL );

			/*
			** If the method was declared as external, it's
			** okay if it's undefined.
			*/

			_if( !MethodList->MethodSym->IsExternal )

				sprintf
				( 
					msg,
					"Undefined class procedure/iterator/method: %s.%s\n",
					MethodList->ClassSym->TrueName,
					MethodList->MethodSym->TrueName
				);
				yyerror( msg );

			_endif
			temp = MethodList;
			MethodList = MethodList->Next;
			free2( vss temp );

		_endwhile

		/*
		** See if there are any outstanding forward reference
		** labels.
		*/

		--CurLexLevel;
		CheckFwdRef();


		/*
		** Emit the text associated with the _finalize_ string
		** at this point.
		**
		**	Note: the "InvisibleCode" variable is used by
		**	yyerror to determine if it should print the
		**	_finalize_ string as part of the error message.
		*/


		PushBackStr( "end" );		
		InvisibleCode = NULL;
		_if
		( 
				_finalize_->pType != tString 
			&&	_finalize_->pType != tZString 
		)

			WarnNear
			(
				"_finalize_ must be a string constant.  Value ignored",
				"_finalize_"
			);

		_elseif( strlen( _finalize_->u.strval ) != 0 )

			InvisibleCode = _finalize_->u.strval;
			PushBackStr( "\xF3" );
			PushBackStr( _finalize_->u.strval );

		_endif
		_here;

	;}
    break;

  case 231:

/* Line 1464 of yacc.c  */
#line 6531 "hlaparse.bsn"
    {		/* $19 */
		

		_here;

		/*
		** Output the end of the main program here.
		*/

		EndMain();
		endCseg();
		endSourceFile();

		inMain = 0;
		inProgram = 0;
		_here;

	;}
    break;

  case 232:

/* Line 1464 of yacc.c  */
#line 6553 "hlaparse.bsn"
    {
			union YYSTYPE dummy;

			/*
			** Create the "_initialize_" and "_finalize_" text symbols 
			** used to emit initialization code later on.  Set the 
			** $<s>$ attribute to point at the _finalize_ symbol table
			** entry (note that $<s>$->Next points at _initialize_'s
			** symbol table entry.
			*/

			_here;
			dummy.v.u.strval = hlastrdup2( "" );
			InsertSym
			( 
				"_initialize_", 
				&string_ste,	/* This is a STRING object.		*/
				tString,
				cValue, 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				YYS &dummy,		/* Initially, no initialization	*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				NULL,			/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);

			dummy.v.u.strval = hlastrdup2( "" );
			InsertSym
			( 
				"_finalize_", 
				&string_ste,	/* This is a STRING object.		*/
				tString,
				cValue, 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				YYS &dummy,		/* Initially, no initialization	*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				NULL,			/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);

			(yyval.s) = SymbolTable;
			_here;
		;}
    break;

  case 235:

/* Line 1464 of yacc.c  */
#line 6633 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 236:

/* Line 1464 of yacc.c  */
#line 6642 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 237:

/* Line 1464 of yacc.c  */
#line 6651 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 238:

/* Line 1464 of yacc.c  */
#line 6660 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 239:

/* Line 1464 of yacc.c  */
#line 6669 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 240:

/* Line 1464 of yacc.c  */
#line 6678 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 241:

/* Line 1464 of yacc.c  */
#line 6687 "hlaparse.bsn"
    {
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 242:

/* Line 1464 of yacc.c  */
#line 6696 "hlaparse.bsn"
    {
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 243:

/* Line 1464 of yacc.c  */
#line 6705 "hlaparse.bsn"
    {
			currentNS = (yyvsp[(2) - (5)].ru.saveCurNS); 
		;}
    break;

  case 244:

/* Line 1464 of yacc.c  */
#line 6714 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (4)].ru.saveCurNS); 
		;}
    break;

  case 245:

/* Line 1464 of yacc.c  */
#line 6722 "hlaparse.bsn"
    { 
			currentNS = (yyvsp[(2) - (4)].ru.saveCurNS); 
		;}
    break;

  case 250:

/* Line 1464 of yacc.c  */
#line 6758 "hlaparse.bsn"
    { (yyval.plist) = PointerList; PointerList = NULL; ;}
    break;

  case 251:

/* Line 1464 of yacc.c  */
#line 6762 "hlaparse.bsn"
    {
			fastNamespace = 1;
		;}
    break;

  case 253:

/* Line 1464 of yacc.c  */
#line 6779 "hlaparse.bsn"
    {						/* $10 */

			SymNode_t *CurSym;

			assert( (yyvsp[(8) - (9)].neID.idStr) != NULL );


			/*
			** Reset NSGlobal pointer (used by @global) since
			** we're no longer in a namespace.
			**
			** Ditto for currentNS (since we shouldn't be using
			** a hash table for a search while outside a namespace.  
			*/

			NSGlobal = NULL;
			currentNS = NULL;
			
			/*
			** Mark the end of the local symbols in this
			** Name Space with a NULL terminating link.
			*/

			_if( SymbolTable == (yyvsp[(3) - (9)].s) )

				yyerror( "Namespaces must have at least one field" );

				/*
				** Create a dummy set of fields to
				** prevent any problems from occurring.
				*/

				(yyvsp[(3) - (9)].s)->Fields = &error_ste;

			_else

				(yyvsp[(3) - (9)].s)->Fields = SymbolTable;
				CurSym = SymbolTable;
				_while( CurSym->Next != (yyvsp[(3) - (9)].s) )

					assert( CurSym->Next != NULL );
					CurSym = CurSym->Next;

				_endwhile
				CurSym->Next = NULL;

			_endif
			

			/*
			** Check to make sure all pointer forward references have
			** been resolved.
			*/

			CheckPtrs();
			
				
			/*
			** Restore linkage to the rest of the symbol table.
			*/

			(yyvsp[(3) - (9)].s)->Next = (yyvsp[(3) - (9)].s)->Base;
			(yyvsp[(3) - (9)].s)->Base = NULL;


			/*
			** Be sure the identifier after the END keyword
			** matches the name space name.
			*/

			_if( _strne( (yyvsp[(2) - (9)].idStr), (yyvsp[(8) - (9)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				(
					msg,
					"Identifier <<%s>> after END in name space\n"
					"declaration must match <<%s>>",
					(yyvsp[(8) - (9)].neID.idStr),
					(yyvsp[(2) - (9)].idStr)
				);
				yyerror( msg );

			_endif

			/*
			** Remove the local symbols in this namespace
			** from the symbol table.
			*/

			SymbolTable = (yyvsp[(3) - (9)].s);
			
			/*
			** Restore the previous PointerList value
			*/
			
			PointerList = (yyvsp[(5) - (9)].plist);

			/*
			** Convert the symbol to a Namespace object.
			** We couldn't do this before this point because
			** we wouldn't be able to handle the "end <id>;"
			** syntax if "<id>" was a namespace object.
			*/

			(yyvsp[(3) - (9)].s)->pType = tNamespace;


			inNamespace = 0;
			free2( vss (yyvsp[(8) - (9)].neID.idStr) );
		;}
    break;

  case 254:

/* Line 1464 of yacc.c  */
#line 6905 "hlaparse.bsn"
    {					/* $11 */

			SymNode_t *CurSym;

			assert( (yyvsp[(9) - (10)].neID.idStr) != NULL );


			/*
			** Reset NSGlobal pointer (used by @global) since

			** we're no longer in a namespace.
			**
			** Ditto for currentNS (since we shouldn't be using
			** a hash table for a search while outside a namespace.  
			*/

			NSGlobal = NULL;
			currentNS = NULL;
			
			/*
			** Mark the end of the local symbols in this
			** Name Space with a NULL terminating link.
			*/

			_if( SymbolTable == (yyvsp[(3) - (10)].s) )

				yyerror( "Namespaces must have at least one field" );

				/*
				** Create a dummy set of fields to
				** prevent any problems from occurring.
				*/

				(yyvsp[(3) - (10)].s)->Fields = &error_ste;

			_else

				(yyvsp[(3) - (10)].s)->Fields = SymbolTable;
				CurSym = SymbolTable;
				_while( CurSym->Next != (yyvsp[(3) - (10)].s) )

					assert( CurSym->Next != NULL );
					CurSym = CurSym->Next;

				_endwhile
				CurSym->Next = NULL;

			_endif
			

			/*
			** Check to make sure all pointer forward references have
			** been resolved.
			*/

			CheckPtrs();
			
				
			/*
			** Restore linkage to the rest of the symbol table.
			*/

			(yyvsp[(3) - (10)].s)->Next = (yyvsp[(3) - (10)].s)->Base;
			(yyvsp[(3) - (10)].s)->Base = NULL;


			/*
			** Be sure the identifier after the END keyword
			** matches the name space name.
			*/

			_if( _strne( (yyvsp[(2) - (10)].idStr), (yyvsp[(9) - (10)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				(
					msg,
					"Identifier <<%s>> after END in name space\n"
					"declaration must match <<%s>>",
					(yyvsp[(9) - (10)].neID.idStr),
					(yyvsp[(2) - (10)].idStr)
				);
				yyerror( msg );

			_endif

			/*
			** Remove the local symbols in this namespace
			** from the symbol table.
			*/

			SymbolTable = (yyvsp[(3) - (10)].s);
			
			/*
			** Restore the previous PointerList value
			*/
			
			PointerList = (yyvsp[(6) - (10)].plist);

			/*
			** Convert the symbol to a Namespace object.
			** We couldn't do this before this point because
			** we wouldn't be able to handle the "end <id>;"
			** syntax if "<id>" was a namespace object.
			*/

			(yyvsp[(3) - (10)].s)->pType = tNamespace;


			inNamespace = 0;
			free2( vss (yyvsp[(9) - (10)].neID.idStr) );
			
			/*
			** Turn off the Fast Namespace operation
			*/
			
			fastNamespace = 0;
		;}
    break;

  case 255:

/* Line 1464 of yacc.c  */
#line 7039 "hlaparse.bsn"
    {					/* $10 */

			assert( (yyvsp[(8) - (9)].neID.idStr) != NULL );


			/*
			** Reset NSGlobal pointer (used by @global) since
			** we're no longer in a namespace.
			**
			** Ditto for currentNS.
			*/

			NSGlobal = NULL;
			currentNS = NULL;

			/*
			** Add the new identifiers to the name space:
			*/

			(yyvsp[(2) - (9)].s)->Fields = SymbolTable;
			(yyvsp[(2) - (9)].s)->Base = NULL;
				
			/*
			** Restore linkage to the rest of the symbol table.
			*/

			SymbolTable = (yyvsp[(3) - (9)].s);
			
			/*
			** Restore PointerList:
			*/
			
			PointerList = (yyvsp[(5) - (9)].plist);


			/*
			** Be sure the identifier after the END keyword
			** matches the name space name.
			*/

			_if( _strne( (yyvsp[(2) - (9)].s)->TrueName, (yyvsp[(8) - (9)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				(
					msg,
					"Identifier <<%s>> after END in name space\n"
					"declaration must match <<%s>>",
					(yyvsp[(8) - (9)].neID.idStr),
					(yyvsp[(2) - (9)].s)->TrueName
				);
				yyerror( msg );

			_endif



			inNamespace = 0;
			free2( vss (yyvsp[(8) - (9)].neID.idStr) );
		;}
    break;

  case 256:

/* Line 1464 of yacc.c  */
#line 7115 "hlaparse.bsn"
    {					/* $11 */

			assert( (yyvsp[(9) - (10)].neID.idStr) != NULL );


			/*
			** Reset NSGlobal pointer (used by @global) since
			** we're no longer in a namespace.
			**
			** Ditto for currentNS.
			*/

			NSGlobal = NULL;
			currentNS = NULL;

			/*
			** Add the new identifiers to the name space:
			*/

			(yyvsp[(2) - (10)].s)->Fields = SymbolTable;
			(yyvsp[(2) - (10)].s)->Base = NULL;
				
			/*
			** Restore linkage to the rest of the symbol table.
			*/

			SymbolTable = (yyvsp[(3) - (10)].s);
			
			/*
			** Restore PointerList:
			*/
			

			PointerList = (yyvsp[(6) - (10)].plist);


			/*
			** Be sure the identifier after the END keyword
			** matches the name space name.
			*/

			_if( _strne( (yyvsp[(2) - (10)].s)->TrueName, (yyvsp[(9) - (10)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				(
					msg,
					"Identifier <<%s>> after END in name space\n"
					"declaration must match <<%s>>",
					(yyvsp[(9) - (10)].neID.idStr),
					(yyvsp[(2) - (10)].s)->TrueName
				);
				yyerror( msg );

			_endif



			inNamespace = 0;
			free2( vss (yyvsp[(9) - (10)].neID.idStr) );
			
			/*
			** Turn off the Fast Namespace operation
			*/
			
			fastNamespace = 0;
		;}
    break;

  case 257:

/* Line 1464 of yacc.c  */
#line 7187 "hlaparse.bsn"
    {
			assert( (yyvsp[(0) - (0)].idStr) != NULL );

			/*
			** Insert the name space identifier into the
			** symbol table.
			*/

			InsertSym
			( 
				(yyvsp[(0) - (0)].idStr), 
				&namespace_ste,	/* Need a type for @typename.			*/
				tVariant,		/* It's a namespace, but not yet.		*/
				cNamespace, 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				NULL,			/* No value						*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				SymbolTable,	/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);
			
			/*
			** Allocate storage for this namespace's hash table
			** (the hash table has 256 entries):
			*/
			
			SymbolTable->u.hashTable = 
				malloc2( sizeofSymNodePtr * 256 );
				
			currentNS = SymbolTable;
			
			/*
			** I'm paranoid and not counting on those entries all being
			** set to NULL.
			*/
			
			memset
			( 
				SymbolTable->u.hashTable, 
				0, 
				sizeofSymNodePtr * 256 
			);

			/*
			** Save a pointer to the namespace entry in the symbol
			** table so we can patch various fields later.  Also,
			** remove the rest of the symbol table from further
			** comparison until we're through processing the name
			** space.
			*/

			(yyval.s) = SymbolTable;
			NSGlobal = SymbolTable->Next;	/* Used by @global	*/
			SymbolTable->Next = NULL;

			/*
			** Set the inNamespace flag for the @section function.
			*/

			inNamespace = 1;
			
			/*
			** "Prime" fastLookup for the first identifier we encounter:
			*/
			
			fastLookup = 1;
		;}
    break;

  case 258:

/* Line 1464 of yacc.c  */
#line 7262 "hlaparse.bsn"
    {
			/*
			** Preserve a pointer to the current symbol table
			** so we can restore this later.
			*/

			(yyval.s) = SymbolTable;
			
			/*
			** If the ID is a locally defined namespace identifier,
			** then append all fields to the end of that namespace's
			** symbol table.  Otherwise we have an error.
			*/
			 
			_if( (yyvsp[(0) - (0)].s)->SymClass != cNamespace )

				yyerror( "Expected a NAMESPACE identifier" );

			_else

				/*
				** Save a pointer to the namespace entry in the symbol
				** table so we can patch various fields later.  Also,
				** remove the rest of the symbol table from further
				** comparison until we're through processing the name
				** space.
				*/

				NSGlobal = SymbolTable;		/* Used by @global */
				SymbolTable = (yyvsp[(0) - (0)].s)->Fields;
				
				/*
				** Set up the currentNS pointer so we can search
				** via a hash table.
				*/
				
				currentNS = (yyvsp[(0) - (0)].s);

			_endif

			/*
			** Set the inNamespace flag for the @section function.
			*/

			inNamespace = 1;
		;}
    break;

  case 259:

/* Line 1464 of yacc.c  */
#line 7316 "hlaparse.bsn"
    {
			yyerror( "Expected a NAMESPACE identifier" );
		;}
    break;

  case 261:

/* Line 1464 of yacc.c  */
#line 7327 "hlaparse.bsn"
    {
			yyerror( "Expected a NAMESPACE identifier" );
		;}
    break;

  case 282:

/* Line 1464 of yacc.c  */
#line 7375 "hlaparse.bsn"
    {
			_here;
			_if( inUnit )
			
				yyerror( "Variable section is not allowed in UNIT" );
				
			_endif
			_here;
		;}
    break;

  case 283:

/* Line 1464 of yacc.c  */
#line 7479 "hlaparse.bsn"
    {
 				SymNode_t *SymPtr;
				
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );

				/*
				** Figure out the base class for this type name.
				*/

				SymPtr = (yyvsp[(1) - (1)].s);
				_while
				(
						IsType( SymPtr->SymClass )
					&&	IsPrimitive( SymPtr->pType )
					&&	!EndOfTypeList( SymPtr )
				)
															 

					SymPtr = SymPtr->Type;

				_endwhile


				_if( IsType( SymPtr->SymClass ))
				
					/*
					** Pass the type information
					** back as the synthesized attribute.
					*/

					(yyval.s) = SymPtr;


				_else

					/*
					** Pass back a dummy type to prevent
					** unexpected problems.
					*/

					(yyval.s) = &uns32_ste;
					yyerror( "Expected type identifier" );

				_endif
				_here;

			;}
    break;

  case 284:

/* Line 1464 of yacc.c  */
#line 7529 "hlaparse.bsn"
    { 
				_here; 
				(yyval.s) = (yyvsp[(1) - (1)].s); 
			;}
    break;

  case 285:

/* Line 1464 of yacc.c  */
#line 7546 "hlaparse.bsn"
    {
				(yyval.s) = (yyvsp[(1) - (1)].s);
			;}
    break;

  case 286:

/* Line 1464 of yacc.c  */
#line 7551 "hlaparse.bsn"
    {
				(yyval.s) = &thunk_ste;
			;}
    break;

  case 287:

/* Line 1464 of yacc.c  */
#line 7559 "hlaparse.bsn"
    {
				(yyval.s) = &boolean_ste;
			;}
    break;

  case 288:

/* Line 1464 of yacc.c  */
#line 7564 "hlaparse.bsn"
    {
				(yyval.s) = &int8_ste;
			;}
    break;

  case 289:

/* Line 1464 of yacc.c  */
#line 7569 "hlaparse.bsn"
    {
				(yyval.s) = &int16_ste;
			;}
    break;

  case 290:

/* Line 1464 of yacc.c  */
#line 7574 "hlaparse.bsn"
    {
				(yyval.s) = &int32_ste;
			;}
    break;

  case 291:

/* Line 1464 of yacc.c  */
#line 7580 "hlaparse.bsn"
    {
				(yyval.s) = &int64_ste;
			;}
    break;

  case 292:

/* Line 1464 of yacc.c  */
#line 7586 "hlaparse.bsn"
    {
				(yyval.s) = &int128_ste;
			;}
    break;

  case 293:

/* Line 1464 of yacc.c  */
#line 7592 "hlaparse.bsn"
    {
				(yyval.s) = &uns8_ste;
			;}
    break;

  case 294:

/* Line 1464 of yacc.c  */
#line 7597 "hlaparse.bsn"
    {
				(yyval.s) = &uns16_ste;
			;}
    break;

  case 295:

/* Line 1464 of yacc.c  */
#line 7602 "hlaparse.bsn"
    {
				(yyval.s) = &uns32_ste;
			;}
    break;

  case 296:

/* Line 1464 of yacc.c  */
#line 7608 "hlaparse.bsn"
    {
				(yyval.s) = &uns64_ste;
			;}
    break;

  case 297:

/* Line 1464 of yacc.c  */
#line 7614 "hlaparse.bsn"
    {
				(yyval.s) = &uns128_ste;
			;}
    break;

  case 298:

/* Line 1464 of yacc.c  */
#line 7620 "hlaparse.bsn"
    {
				(yyval.s) = &byte_ste;
			;}
    break;

  case 299:

/* Line 1464 of yacc.c  */
#line 7625 "hlaparse.bsn"
    {
				(yyval.s) = &word_ste;
			;}
    break;

  case 300:

/* Line 1464 of yacc.c  */
#line 7630 "hlaparse.bsn"
    {
				(yyval.s) = &dword_ste;
			;}
    break;

  case 301:

/* Line 1464 of yacc.c  */
#line 7636 "hlaparse.bsn"
    {
				(yyval.s) = &qword_ste;
			;}
    break;

  case 302:

/* Line 1464 of yacc.c  */
#line 7642 "hlaparse.bsn"
    {
				(yyval.s) = &tbyte_ste;
			;}
    break;

  case 303:

/* Line 1464 of yacc.c  */
#line 7648 "hlaparse.bsn"
    {
				(yyval.s) = &lword_ste;
			;}
    break;

  case 304:

/* Line 1464 of yacc.c  */
#line 7654 "hlaparse.bsn"
    {
				(yyval.s) = &char_ste;
			;}
    break;

  case 305:

/* Line 1464 of yacc.c  */
#line 7659 "hlaparse.bsn"
    {
				(yyval.s) = &wchar_ste;
			;}
    break;

  case 306:

/* Line 1464 of yacc.c  */
#line 7664 "hlaparse.bsn"
    {
				(yyval.s) = &real32_ste;
			;}
    break;

  case 307:

/* Line 1464 of yacc.c  */
#line 7669 "hlaparse.bsn"
    {
				(yyval.s) = &real64_ste;
			;}
    break;

  case 308:

/* Line 1464 of yacc.c  */
#line 7674 "hlaparse.bsn"
    {
				(yyval.s) = &real80_ste;
			;}
    break;

  case 309:

/* Line 1464 of yacc.c  */
#line 7680 "hlaparse.bsn"
    {
				(yyval.s) = &real128_ste;
			;}
    break;

  case 310:

/* Line 1464 of yacc.c  */
#line 7686 "hlaparse.bsn"
    {
				(yyval.s) = &string_ste;
			;}
    break;

  case 311:

/* Line 1464 of yacc.c  */
#line 7691 "hlaparse.bsn"
    {
				(yyval.s) = &zstring_ste;
			;}
    break;

  case 312:

/* Line 1464 of yacc.c  */
#line 7696 "hlaparse.bsn"
    {
				(yyval.s) = &wstring_ste;
			;}
    break;

  case 313:

/* Line 1464 of yacc.c  */
#line 7701 "hlaparse.bsn"
    {
				(yyval.s) = &cset_ste;
			;}
    break;

  case 314:

/* Line 1464 of yacc.c  */
#line 7706 "hlaparse.bsn"
    {
				(yyval.s) = &text_ste;
			;}
    break;

  case 315:

/* Line 1464 of yacc.c  */
#line 7711 "hlaparse.bsn"
    {
				(yyval.s) = &regex_ste;
			;}
    break;

  case 316:

/* Line 1464 of yacc.c  */
#line 7720 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 317:

/* Line 1464 of yacc.c  */
#line 7729 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 318:

/* Line 1464 of yacc.c  */
#line 7743 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 319:

/* Line 1464 of yacc.c  */
#line 7751 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 320:

/* Line 1464 of yacc.c  */
#line 7768 "hlaparse.bsn"
    {
 				SymNode_t *SymPtr;
				
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );


				/*
				** Figure out the base class for this type name.
				*/

				SymPtr = (yyvsp[(1) - (1)].s);
				_while
				(
						IsType( SymPtr->SymClass )
					&&	IsPrimitive( SymPtr->pType )
					&&	!EndOfTypeList( SymPtr )
				)
															 

					SymPtr = SymPtr->Type;

				_endwhile


				_if( IsType( SymPtr->SymClass ))
				
					/*
					** Pass the type information
					** back as the synthesized attribute.
					*/

					(yyval.s) = SymPtr;


				_else

					/*
					**	This probably never executes since
					**	non-type identifiers are illegal

					**	at the beginning of a statement and
					**	the type processing logic doesn't prevent
					**	a type ID to point (ultimately) at a
					**	non-type ID.  Note that the assert
					**	statement always raises the assertion.
					*/

					/* $<s>$ = &uns32_ste; */
					assert( "Unxpected non-type identifier" );

				_endif

			;}
    break;

  case 321:

/* Line 1464 of yacc.c  */
#line 7823 "hlaparse.bsn"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 322:

/* Line 1464 of yacc.c  */
#line 7848 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 323:

/* Line 1464 of yacc.c  */
#line 7857 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 324:

/* Line 1464 of yacc.c  */
#line 7865 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 325:

/* Line 1464 of yacc.c  */
#line 7873 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 326:

/* Line 1464 of yacc.c  */
#line 7881 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 327:

/* Line 1464 of yacc.c  */
#line 7889 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 328:

/* Line 1464 of yacc.c  */
#line 7897 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 329:

/* Line 1464 of yacc.c  */
#line 7905 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 330:

/* Line 1464 of yacc.c  */
#line 7915 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 331:

/* Line 1464 of yacc.c  */
#line 7923 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 332:

/* Line 1464 of yacc.c  */
#line 7931 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 333:

/* Line 1464 of yacc.c  */
#line 7939 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 334:

/* Line 1464 of yacc.c  */
#line 7947 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 335:

/* Line 1464 of yacc.c  */
#line 7955 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 336:

/* Line 1464 of yacc.c  */
#line 7963 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 337:

/* Line 1464 of yacc.c  */
#line 7971 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 338:

/* Line 1464 of yacc.c  */
#line 7982 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 339:

/* Line 1464 of yacc.c  */
#line 7991 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 340:

/* Line 1464 of yacc.c  */
#line 8004 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 341:

/* Line 1464 of yacc.c  */
#line 8012 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 342:

/* Line 1464 of yacc.c  */
#line 8028 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 343:

/* Line 1464 of yacc.c  */
#line 8036 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 344:

/* Line 1464 of yacc.c  */
#line 8061 "hlaparse.bsn"
    {
				_here;
				(yyval.idStr) = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
				fastLookup = 0;
				_here;
			;}
    break;

  case 345:

/* Line 1464 of yacc.c  */
#line 8069 "hlaparse.bsn"
    {
				_here;
				(yyval.idStr) = (yyvsp[(1) - (1)].idStr);
				fastLookup = 0;
				_here;
			;}
    break;

  case 346:

/* Line 1464 of yacc.c  */
#line 8090 "hlaparse.bsn"
    {
			_here;
			assert(	(yyvsp[(1) - (1)].idStr) != NULL );
			(yyval.neID.idStr) = (yyvsp[(1) - (1)].idStr);
			(yyval.neID.s) = NULL;
			_here;
		;}
    break;

  case 347:

/* Line 1464 of yacc.c  */
#line 8099 "hlaparse.bsn"
    {
			_here;
			(yyval.neID.idStr) = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
			(yyval.neID.s) = (yyvsp[(1) - (1)].s);
			_here;
		;}
    break;

  case 348:

/* Line 1464 of yacc.c  */
#line 8107 "hlaparse.bsn"
    {
			_here;
			(yyval.neID.idStr) = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
			(yyval.neID.s) = (yyvsp[(1) - (1)].s);
			_here;
		;}
    break;

  case 349:

/* Line 1464 of yacc.c  */
#line 8118 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (1)].s) != NULL );
			(yyval.s) = (yyvsp[(1) - (1)].s);
			_here;
		;}
    break;

  case 350:

/* Line 1464 of yacc.c  */
#line 8126 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (1)].s) != NULL );
			(yyval.s) = (yyvsp[(1) - (1)].s);
			_here;
		;}
    break;

  case 351:

/* Line 1464 of yacc.c  */
#line 8138 "hlaparse.bsn"
    {
			_here;
			assert(	(yyvsp[(2) - (2)].idStr) != NULL );
			(yyval.idStr) = (yyvsp[(2) - (2)].idStr);
			SkipLookup = (yyvsp[(1) - (2)].v.u.unsval);
			_here;
		;}
    break;

  case 352:

/* Line 1464 of yacc.c  */
#line 8148 "hlaparse.bsn"
    {
			(yyval.v.u.unsval) = SkipLookup;
			SkipLookup = 1;
		;}
    break;

  case 353:

/* Line 1464 of yacc.c  */
#line 8165 "hlaparse.bsn"
    {
			_here;
			assert(	(yyvsp[(1) - (1)].idStr) != NULL );
			(yyval.idStr) = (yyvsp[(1) - (1)].neID.idStr);
		;}
    break;

  case 354:

/* Line 1464 of yacc.c  */
#line 8171 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = hlastrdup2( yytext );
		;}
    break;

  case 385:

/* Line 1464 of yacc.c  */
#line 8195 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
//				SetReferenced( $<s>1 );
				_here;
			;}
    break;

  case 386:

/* Line 1464 of yacc.c  */
#line 8205 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 387:

/* Line 1464 of yacc.c  */
#line 8213 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 388:

/* Line 1464 of yacc.c  */
#line 8222 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 389:

/* Line 1464 of yacc.c  */
#line 8230 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 390:

/* Line 1464 of yacc.c  */
#line 8238 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 391:

/* Line 1464 of yacc.c  */
#line 8246 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 392:

/* Line 1464 of yacc.c  */
#line 8294 "hlaparse.bsn"
    {
			_here;

			/*
			** Clear out unimportant fields.
			*/

			(yyval.v.Name) = "";
			(yyval.v.TrueName) = "";
			(yyval.v.StaticName) = NULL;
			(yyval.v.Offset) = 0;
			SetEndOfTypeList( &(yyval.v) );
			(yyval.v.Base) = NULL;			/* Note: array of records	*/
			(yyval.v.Fields) = NULL;		/* field info is maintained	*/
			(yyval.v.FieldCnt) = 0;			/* Type field.				*/

			/*
			** For an array constant, here are the important
			** assignments.
			*/

			(yyval.v.pType) = tArray;
			(yyval.v.SymClass) = cConstant;
			(yyval.v.Type) = (yyvsp[(2) - (3)].v.Type);
			(yyval.v.Arity) = 1;
			(yyval.v.Dimensions) = malloc2( sizeofInt );
			*(yyval.v.Dimensions) = (yyvsp[(2) - (3)].v.NumElements);
			(yyval.v.NumElements) = (yyvsp[(2) - (3)].v.NumElements);

			(yyval.v.u.ArrayOfValues) = (yyvsp[(2) - (3)].v.u.ArrayOfValues);
			(yyval.v.ObjectSize) = (yyvsp[(2) - (3)].v.NumElements) * (yyvsp[(2) - (3)].v.ObjectSize);

			_here;

		;}
    break;

  case 393:

/* Line 1464 of yacc.c  */
#line 8331 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			_here;
		;}
    break;

  case 394:

/* Line 1464 of yacc.c  */
#line 8354 "hlaparse.bsn"
    {
				SymNode_t	*data;
				int			rowsize;

				/*
				** Range and type check the duplication constant.
				*/

				_here;
				_if( !checkSmallUns( YYS &(yyvsp[(1) - (5)].v) ))

					yyerror
					( 
						"Array dup value must be an integer value "
						"greater than zero" 
					);
					Setval( YYS &(yyvsp[(1) - (5)].v), 1 );
					
				_endif
				 
				/*
				** Set up the attributes for the return value.
				*/

				(yyval.v.pType) = tArray;
				(yyval.v.Type) = (yyvsp[(4) - (5)].v.Type);
				(yyval.v.Arity) = 1;
				(yyval.v.Dimensions) = malloc2( sizeofInt );
				*(yyval.v.Dimensions) = (yyvsp[(1) - (5)].v.u.unsval) * (yyvsp[(4) - (5)].v.NumElements);
				(yyval.v.NumElements) = *(yyval.v.Dimensions);
				(yyval.v.ObjectSize) = (yyvsp[(4) - (5)].v.ObjectSize) * (yyvsp[(1) - (5)].v.u.unsval);
				
				/*
				** Create the data to return by duplicating the ArrayList
				** values the number of times specified by ConstExpr.
				*/

				rowsize = (yyvsp[(4) - (5)].v.NumElements) * sizeofSymNode;
				data =	malloc2( rowsize * (yyvsp[(1) - (5)].v.u.unsval) );
				_for( unsigned i=0, i < (yyvsp[(1) - (5)].v.u.unsval), ++ i )
					
					_for( int j=0, j < (yyvsp[(4) - (5)].v.NumElements), ++j )

						DeepCopy
						(
							data + i*(yyvsp[(4) - (5)].v.NumElements) + j,
							&(yyvsp[(4) - (5)].v.u.ArrayOfValues)[j]
							/*
							** rowsize
							*/
						);

					_endfor

				_endfor

				(yyval.v.u.ArrayOfValues) = data;

				/*
				** Clear out unimportant fields.
				*/

				(yyval.v.Name) = "";
				(yyval.v.TrueName) = "";
				(yyval.v.StaticName) = NULL;
				(yyval.v.Offset) = 0;
				SetEndOfTypeList( &(yyval.v) );
				(yyval.v.Base) = NULL;			/* Note: array of records	*/
				(yyval.v.Fields) = NULL;		/* field info is maintained	*/
				(yyval.v.FieldCnt) = 0;			/* Type field.				*/
				_here;

			;}
    break;

  case 395:

/* Line 1464 of yacc.c  */
#line 8461 "hlaparse.bsn"
    {
				_here;

				/*
				** Clear out unimportant fields.
				*/

				(yyval.v.Name) = "";
				(yyval.v.TrueName) = "";
				(yyval.v.StaticName) = NULL;
				(yyval.v.Offset) = 0;
				SetEndOfTypeList( &(yyval.v) );
				(yyval.v.Base) = NULL;			/* Note: array of records	*/
				(yyval.v.Fields) = NULL;		/* field info is maintained	*/
				(yyval.v.FieldCnt) = 0;			/* Type field.				*/

				/*
				** Set up the array specific fields.
				*/

				(yyval.v.pType) = (yyvsp[(2) - (2)].v.pType);
				(yyval.v.Type) = (yyvsp[(2) - (2)].v.Type);
				(yyval.v.Dimensions) = malloc2( sizeofInt );
				*(yyval.v.Dimensions) = (yyvsp[(2) - (2)].v.NumElements);
				(yyval.v.NumElements) = (yyvsp[(2) - (2)].v.NumElements);
				(yyval.v.Arity) = 1;
				(yyval.v.u.ArrayOfValues) = (yyvsp[(2) - (2)].v.u.ArrayOfValues);
				(yyval.v.ObjectSize) = (yyvsp[(2) - (2)].v.ObjectSize);

				_here;

			;}
    break;

  case 396:

/* Line 1464 of yacc.c  */
#line 8496 "hlaparse.bsn"
    { 
			_here;
			(yyval.v.u.unsval) = 0;
		;}
    break;

  case 397:

/* Line 1464 of yacc.c  */
#line 8502 "hlaparse.bsn"
    { 
			_here;
			_if( (yyvsp[(-1) - (0)].v.pType) == tArray )
			
				(yyval.v.u.unsval) = (yyvsp[(-2) - (0)].v.u.unsval) + (yyvsp[(-1) - (0)].v.NumElements);
				
			_else
			
				(yyval.v.u.unsval) = (yyvsp[(-2) - (0)].v.u.unsval) + 1;
				
			_endif 
		;}
    break;

  case 398:

/* Line 1464 of yacc.c  */
#line 8554 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 399:

/* Line 1464 of yacc.c  */
#line 8558 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 400:

/* Line 1464 of yacc.c  */
#line 8581 "hlaparse.bsn"
    {
			int	TotalElements;
			int	ThisIndex;
			
			_here;
			TotalElements = (yyvsp[(3) - (3)].v.u.unsval);

			/*
			** The IncElementCnt production
			** has been nice enough to count up all the elements
			** in the array for us.  This being the last object
			** in the array, it is now possible to allocate the
			** storage for the array and begin assigning the
			** element values to the array.
			*/

			(yyval.v.u.ArrayOfValues) = malloc2( TotalElements * sizeofSymNode );
			(yyval.v.NumElements) = TotalElements;
			(yyval.v.pType) = tArray;

			/*
			** Pass the result on back to the caller.
			*/

			ThisIndex = (yyvsp[(0) - (3)].v.u.unsval);
			_if( (yyvsp[(1) - (3)].v.pType) == tArray )

				_for( int i=0, i < (yyvsp[(1) - (3)].v.NumElements), ++i )
								
					DeepCopy
					(
						&(yyval.v.u.ArrayOfValues)[ ThisIndex+i ],
						&(yyvsp[(1) - (3)].v.u.ArrayOfValues)[i]

						/*
						** $<v.NumElements>1 * sizeofSymNode
						*/
					);

				_endfor

				
			_elseif( (yyvsp[(1) - (3)].v.pType) == tRecord )

				/*
				** Check to see if the record is bad:
				*/

				_if( (yyvsp[(1) - (3)].v.Type) != NULL )

					DeepCopy
					(
						&(yyval.v.u.ArrayOfValues)[ ThisIndex ],
						&(yyvsp[(1) - (3)].v)
						/* sizeofSymNode */
					);
					

					(yyval.v.u.ArrayOfValues)[ ThisIndex ].TrueName = 
						(yyvsp[(1) - (3)].v.Type)->TrueName;
					(yyval.v.u.ArrayOfValues)[ ThisIndex ].Name = 
						(yyvsp[(1) - (3)].v.Type)->Name;

				_else

					// We had an error, so just return
					// the error element.

					memcpy
					( 
						&(yyval.v.u.ArrayOfValues)[ ThisIndex ],
						&error_ste,
						sizeofSymNode 

					);

				_endif

			_else /* object is scalar or string object */
			
				DeepCopy
				(
					&(yyval.v.u.ArrayOfValues)[ ThisIndex ],
					&(yyvsp[(1) - (3)].v)
				);

				/*
				** Kludge so the call to free value below
				** doesn't wipe out our string.
				*/

				_if
				( 
						(yyvsp[(1) - (3)].v.pType) == tString 
					||	(yyvsp[(1) - (3)].v.pType) == tZString 

					||	(yyvsp[(1) - (3)].v.pType) == tPointer )

					(yyvsp[(1) - (3)].v.pType) = tUns8;
					(yyvsp[(1) - (3)].v.Type) = &uns8_ste;

				_endif

				
			_endif
			(yyval.v.pType) = tArray;
			_if( (yyvsp[(1) - (3)].v.Type) != &error_ste )

				(yyval.v.Type)  = (yyval.v.u.ArrayOfValues)[ThisIndex].Type;

			_else

				(yyval.v.Type) = &error_ste;

			_endif
			FreeValue( YYS &(yyvsp[(1) - (3)].v) );
			_here;
		;}
    break;

  case 401:

/* Line 1464 of yacc.c  */
#line 8722 "hlaparse.bsn"
    {
			enum PrimType lp, rp;
			
			_here;
			(yyval.v.u.ArrayOfValues) = (yyvsp[(4) - (4)].v.u.ArrayOfValues);
			(yyval.v.NumElements) = (yyvsp[(4) - (4)].v.NumElements);
			(yyval.v.pType) = tArray;

			/*
			** Okay, if the result is type compatible, concatenate
			** the two arrays.  
			*/

			_if
			( 
				CoerceArrays
				( 
					YYS &(yyvsp[(1) - (4)].v), 
					YYS &(yyvsp[(4) - (4)].v), 
					(yyvsp[(3) - (4)].v.u.unsval), 
					(yyvsp[(4) - (4)].v.NumElements) 
				)
			)

				/*
				** Set the type to the newly coerced type value.
				*/

				(yyval.v.Type) = (yyvsp[(1) - (4)].v.Type);  /* Note: $1===$4 */

				_if( (yyvsp[(1) - (4)].v.pType) == tArray )

					/*
					** Copy ConstExpr's values into their appropriate
					** places in the array.
					*/

					_for( int i=0, i < (yyvsp[(1) - (4)].v.NumElements), ++i )
					
						DeepCopy
						(
							&(yyval.v.u.ArrayOfValues)[ (yyvsp[(0) - (4)].v.u.unsval)+i ],
							&(yyvsp[(1) - (4)].v.u.ArrayOfValues)[i]
							/* $<v.NumElements>1 * sizeofSymNode */
						);

					_endfor

				_elseif( (yyvsp[(1) - (4)].v.pType) == tRecord )

					DeepCopy
					(
						&(yyval.v.u.ArrayOfValues)[ (yyvsp[(0) - (4)].v.u.unsval) ],
						&(yyvsp[(1) - (4)].v)
						/* sizeofSymNode */
					);
					(yyval.v.u.ArrayOfValues)[ (yyvsp[(0) - (4)].v.u.unsval) ].TrueName = 
						(yyvsp[(1) - (4)].v.Type)->TrueName;
					(yyval.v.u.ArrayOfValues)[ (yyvsp[(0) - (4)].v.u.unsval) ].Name = 
						(yyvsp[(1) - (4)].v.Type)->Name;

				_else /* ConstExpr is a scalar or string object */

					DeepCopy
					(
						&(yyval.v.u.ArrayOfValues)[ (yyvsp[(0) - (4)].v.u.unsval) ],
						&(yyvsp[(1) - (4)].v)
						/* sizeofSymNode */
					);

					/*
					** Kludge so the call to free value below
					** doesn't wipe out our string.
					*/

					_if
					( 
							(yyvsp[(1) - (4)].v.pType) == tString 
						||	(yyvsp[(1) - (4)].v.pType) == tZString 
					)

						(yyvsp[(1) - (4)].v.pType) = tUns8;
						(yyvsp[(1) - (4)].v.Type) = &uns8_ste;

					_endif

				_endif

			_else /* Arrays are incompatible */

				/*
				** If we can't coerce the arrays to be compatible,
				** print an error message and return the DoArrayList
				** data as the result.
				*/

				yyerror( "Type mismatch in operands" );
				(yyval.v.Type) = (yyvsp[(4) - (4)].v.Type);	/* Keep DoArrayList type */
				memcpy
				(
					&(yyval.v.u.ArrayOfValues)[ (yyvsp[(0) - (4)].v.u.unsval) ],
					&(yyval.v.u.ArrayOfValues)[ (yyvsp[(0) - (4)].v.u.unsval) + 1 ],
					sizeofSymNode
				);

			_endif
			FreeValue( YYS &(yyvsp[(1) - (4)].v) );
			_here;
		;}
    break;

  case 402:

/* Line 1464 of yacc.c  */
#line 8883 "hlaparse.bsn"
    {
			/*
			** Range and type check this dimension's size.
			*/

			_here;
			_if( !checkSmallUns( YYS &(yyvsp[(1) - (1)].v) ))

				yyerror
				( 
					"Array size must be an integer value "
					"greater than zero"
				);
				(yyvsp[(1) - (1)].v.pType) = tUns32;
				Setval( YYS &(yyvsp[(1) - (1)].v), 1 );

			_endif

			/*
			** Set up the return attributes for a single dimension
			** array.
			*/

			(yyval.v.Arity) = 1;
			(yyval.v.Dimensions) =
				malloc2
				( 
					sizeofUns 
				);

			*(yyval.v.Dimensions) = (yyvsp[(1) - (1)].v.u.unsval);
			(yyval.v.NumElements) = (yyvsp[(1) - (1)].v.u.unsval);
			(yyval.v.u.ArrayOfValues) = NULL;
			_here;
		;}
    break;

  case 403:

/* Line 1464 of yacc.c  */
#line 8929 "hlaparse.bsn"
    {
			/*
			** Type and range check the new item to concatenate
			** to our dimension array.
			*/

			_here;
			_if
			( 
					!checkSmallUns( YYS &(yyvsp[(3) - (3)].v) )
				||	(yyvsp[(3) - (3)].v.u.unsval) == 0 
			)

				yyerror
				( 
					"Array size must be a 32-bit integer greater than zero" 
				);
				(yyvsp[(3) - (3)].v.pType) = tUns32;
				(yyvsp[(3) - (3)].v.u.unsval) = 1;
				(yyvsp[(3) - (3)].v.u.lwordval)[1] = 0;
				(yyvsp[(3) - (3)].v.u.lwordval)[2] = 0;
				(yyvsp[(3) - (3)].v.u.lwordval)[3] = 0;

			_endif

			/*
			** Create a new dimension list with enough room to hold
			** the old one plus one additional element.
			*/

			(yyval.v.Arity) = (yyvsp[(1) - (3)].v.Arity) + 1;
			(yyval.v.Dimensions) =
				malloc2
				( 
					sizeofUns * 
						( (yyvsp[(1) - (3)].v.Arity) + 1 )
				);


			/*
			** Copy the old DimList data to the new array.
			*/

			assert( (yyvsp[(1) - (3)].v.Dimensions) != NULL );
			memcpy
			( 
				(yyval.v.Dimensions), 
				(yyvsp[(1) - (3)].v.Dimensions),
				sizeofInt  * (yyvsp[(1) - (3)].v.Arity)
			);

			/*
			** Append the latest dimension to the end of the new array.
			*/

			(yyval.v.Dimensions)[(yyvsp[(1) - (3)].v.Arity)] = 
				(yyvsp[(3) - (3)].v.u.unsval);

			/*
			** Update the new NumElements and u.ArrayOfValues attributes.
			*/

			(yyval.v.NumElements) = 
				(yyvsp[(1) - (3)].v.NumElements) * (yyvsp[(3) - (3)].v.u.unsval);

			(yyval.v.u.ArrayOfValues) = NULL;

			/*
			** Free the old array, we won't be using it any more.
			*/

			free2( vss (yyvsp[(1) - (3)].v.Dimensions) );
			_here; 

		;}
    break;

  case 404:

/* Line 1464 of yacc.c  */
#line 9043 "hlaparse.bsn"
    {
			_here;
			_if( !checkSmallUns( YYS &(yyvsp[(1) - (1)].v) ))

				yyerror
				( 
					"Index size must be an unsigned value "
					"greater than or equal to zero"
				);
				(yyvsp[(1) - (1)].v.pType) = tUns32;
				(yyvsp[(1) - (1)].v.Type) = &uns32_ste;
				Setval( YYS &(yyvsp[(1) - (1)].v), 0 );

			_endif


			(yyval.v.Arity) = 1;
			(yyval.v.Dimensions) =
				malloc2
				( 
					sizeofUns 
				);

			*(yyval.v.Dimensions) = (yyvsp[(1) - (1)].v.u.unsval);
			(yyval.v.NumElements) = (yyvsp[(1) - (1)].v.u.unsval);
			(yyval.v.u.ArrayOfValues) = NULL;
			_here;
		;}
    break;

  case 405:

/* Line 1464 of yacc.c  */
#line 9073 "hlaparse.bsn"
    {
			_here;
			_if( !checkSmallUns( YYS &(yyvsp[(1) - (3)].v) ))

				yyerror
				( 
					"Index size must be an unsigned integer "
					"greater than or equal to zero" 
				);
				(yyvsp[(3) - (3)].v.pType) = tUns32;
				(yyvsp[(3) - (3)].v.Type) = &uns32_ste;
				Setval( YYS &(yyvsp[(1) - (3)].v), 1 );

			_endif

			(yyval.v.Arity) = (yyvsp[(1) - (3)].v.Arity) + 1;
			(yyval.v.Dimensions) =
				malloc2
				( 
					sizeofUns * 
						( (yyvsp[(1) - (3)].v.Arity) + 1 )
				);

			assert( (yyvsp[(1) - (3)].v.Dimensions) != NULL );
			memcpy
			( 
				(yyval.v.Dimensions), 
				(yyvsp[(1) - (3)].v.Dimensions),
				sizeofInt  * (yyvsp[(1) - (3)].v.Arity)
			);
			(yyval.v.Dimensions)[(yyvsp[(1) - (3)].v.Arity)] = (yyvsp[(3) - (3)].v.u.unsval);
			(yyval.v.NumElements) = (yyvsp[(1) - (3)].v.NumElements) * (yyvsp[(3) - (3)].v.u.unsval);
			(yyval.v.u.ArrayOfValues) = NULL;
			free2( vss (yyvsp[(1) - (3)].v.Dimensions) );
			_here; 

		;}
    break;

  case 406:

/* Line 1464 of yacc.c  */
#line 9139 "hlaparse.bsn"
    { _here; memcpy( &(yyval.v), (yyvsp[(1) - (1)].s), sizeofSymNode ); ;}
    break;

  case 407:

/* Line 1464 of yacc.c  */
#line 9140 "hlaparse.bsn"
    { _here; memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );  ;}
    break;

  case 408:

/* Line 1464 of yacc.c  */
#line 9141 "hlaparse.bsn"
    { _here; memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );  ;}
    break;

  case 409:

/* Line 1464 of yacc.c  */
#line 9163 "hlaparse.bsn"
    {
			/*
			** Be sure this is a constant or value.
			*/

			_here;
			_if( !IsConstant( (yyvsp[(1) - (4)].v.SymClass) ))

				/*
				** 04/05/2000-
				**
				** Not sure this condition is possible here.
				** RLH.
				*/

				yyerror( "Expected an array constant" );

				/*
				** Return an arbitrary constant value (true)
				** just to ensure the integrity of this attribute
				** for the calling code.
				*/

				memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );


			/*
			** Be sure it's an array constant.
			*/

			_elseif( (yyvsp[(1) - (4)].v.pType) != tArray )

				yyerror( "Object must be an array" );

				/*
				** Return an arbitrary constant value (true)
				** just to ensure the integrity of this attribute
				** for the calling code.
				*/

				memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );


			_else

				int Offset;
				int ResultSize;
				int NewArity;

				/*
				** Okay, we've got an array identifier that is either
				** a cConstant or cValue object.  Pass along the
				** appropriate information to the calling code.
				**
				** Begin by determining if IndexList provides a valid
				** set of indices into the array by calling ComputeOffset.
				*/

				_if
				( 
					ComputeOffset
					( 
						YYS &(yyvsp[(1) - (4)].v), 
						YYS &(yyvsp[(3) - (4)].v), 
						&Offset, 
						&ResultSize 
					)
				)

					/*
					** Okay, the indexes are fine.  Extract an element
					** or an array slice.
					*/

					(yyval.v.Type) = (yyvsp[(1) - (4)].v.Type);
					(yyval.v.ObjectSize) = (yyvsp[(1) - (4)].v.Type)->ObjectSize;
					(yyval.v.MaxObjectSize) = (yyvsp[(1) - (4)].v.Type)->MaxObjectSize;
					(yyval.v.Base) = (yyvsp[(1) - (4)].v.Type)->Base;
					(yyval.v.Fields) = (yyvsp[(1) - (4)].v.Type)->Fields;
					(yyval.v.FieldCnt) = (yyvsp[(1) - (4)].v.Type)->FieldCnt;
					(yyval.v.NumElements) = 
						_ifx( ResultSize == 1, 0, ResultSize );

					NewArity = (yyvsp[(1) - (4)].v.Arity) - (yyvsp[(3) - (4)].v.Arity);
					(yyval.v.Arity)  = NewArity;

					/*
					** If this object is not an array slice, 
					** just copy the data field.
					*/

					_if( (yyval.v.Arity) == 0 )

						/*
						** ClipType( &$<v>$, $<v.Type>1 );
						*/

						(yyval.v.pType) = (yyvsp[(1) - (4)].v.Type)->pType;
						(yyval.v.NumElements) = 0;
						(yyval.v.Dimensions) = NULL;
						memcpy
						( 
							&(yyval.v.u.StartOfValues),
							&(yyvsp[(1) - (4)].v.u.ArrayOfValues)[ Offset ].u.StartOfValues,
							sizeofValuesSize
						);

					_else

						/*
						** At this point, the object must be an 
						** array slice.
						**
						** Begin by copying the dimension array
						** (the dope vector).
						** We have an array object, make
						** a copy of the Dimensions list and
						** make a copy of the array data.
						*/

						(yyval.v.pType) = tArray;
						(yyval.v.Dimensions) = 
							malloc2( NewArity * sizeofInt );


						memcpy
						( 
							(yyval.v.Dimensions), 
							&(yyvsp[(1) - (4)].v.Dimensions)[ (yyvsp[(3) - (4)].v.Arity) ],
							NewArity * sizeofInt 
						);


						/*
						** Now make a copy of the array's data.
						*/

						(yyval.v.u.ArrayOfValues) =
							malloc2
							( 
								ResultSize * sizeofSymNode 
							);

						memcpy
						(
							(yyval.v.u.ArrayOfValues),
							&(yyvsp[(1) - (4)].v.u.ArrayOfValues)[ Offset ], 
							ResultSize * sizeofSymNode
						);
						FreeValue( YYS &(yyvsp[(3) - (4)].v) );

					_endif

				_endif

			_endif
			_here;
		;}
    break;

  case 410:

/* Line 1464 of yacc.c  */
#line 9339 "hlaparse.bsn"
    {
			char msg[ 256 ];
			
			_here;
			_if( !IsConstant( (yyvsp[(1) - (3)].v.SymClass) ))

				/*
				** Not sure this condition is possible here.
				** 04/05/2000, RLH.
				*/

				yyerror( "Expected a record or union constant" );
				
				/*
				** Return a dummy value to prevent inconsistencies
				** in the program.
				*/

				memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );

			_elseif( (yyvsp[(1) - (3)].v.pType) == tRecord )

				/*
				** Look up the field reference to see if
				** it is actually a field of the record object.
				*/

				SymNode_t *FieldList;
				int		  ValueIndex;
				char	  *lcID;
				
				lcID = hlastrdup2( (yyvsp[(3) - (3)].neID.idStr) ); 
				lowercase( lcID );
				FieldList = (yyvsp[(1) - (3)].v.Fields);
				ValueIndex = 0;
				_while
				( 
						FieldList != NULL 
					&&	_strne( lcID, FieldList->Name )
				)

					FieldList = FieldList->Next;
					++ValueIndex;

				_endwhile
				_if
				( 
						FieldList != NULL 
					&&	_streq( (yyvsp[(3) - (3)].neID.idStr), FieldList->TrueName )
				)
				
					assert( (yyvsp[(1) - (3)].v.u.FieldValues) != NULL );

					/*
					** Copy the data associated with this record entry.
					** (Does this really need to be a deep copy?)
					*/


					DeepCopy
					( 
						&(yyval.v), 
						&(yyvsp[(1) - (3)].v.u.FieldValues)[ ValueIndex ] 
						/* sizeofSymNode  */
					);

					/*
					** Alas, the important type info wasn't part of
					** the field values, we must grab that info
					** from the FieldList object.
					*/

					memcpy
					(
						&(yyval.v),
						FieldList,
						sizeofSymNode - sizeofValuesSize
					);
					(yyval.v.SymClass) = (yyvsp[(1) - (3)].v.SymClass);

				_else

					ErrorNear
					( 
						"Undefined symbol/field name", 
						(yyvsp[(3) - (3)].neID.idStr), 
						__LINE__,
						__FILE__ 
					);

					/*
					** Return a dummy value to prevent inconsistencies
					** in the program.
					*/

					memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );

				_endif
				free2( vss lcID );
				
				

			_elseif( (yyvsp[(1) - (3)].v.pType) == tUnion || (yyvsp[(1) - (3)].v.pType) == tReal128 )
			
				assert( (yyvsp[(1) - (3)].v.CurField) != NULL );
				assert( (yyvsp[(1) - (3)].v.CurField)->TrueName != NULL );
				
				_if( _strne( (yyvsp[(3) - (3)].neID.idStr), (yyvsp[(1) - (3)].v.CurField)->TrueName ))

					sprintf
					(
						msg,
						"%s is the currently active "
						"field for union object %s (not %s)",
						(yyvsp[(1) - (3)].v.CurField)->TrueName,
						(yyvsp[(1) - (3)].v.TrueName),
						(yyvsp[(3) - (3)].neID.idStr)
					);
					yyerror( msg );

					/*
					** Return a dummy value to prevent inconsistencies
					** in the program.
					*/

					memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );
					
				_else
				
					// Okay, they've specified the current field.
					// Return its value.

					/*
					** Copy the data associated with this record entry.
					** (Does this really need to be a deep copy?)
					*/

					DeepCopy
					( 
						&(yyval.v), 
						&(yyvsp[(1) - (3)].v.u.FieldValues)[ (yyvsp[(1) - (3)].v.CurIndex) ] 
					);

					/*
					** Alas, the important type info wasn't part of
					** the field CurField List object.
					*/

					memcpy
					(
						&(yyval.v),
						(yyvsp[(1) - (3)].v.CurField),
						sizeofSymNode - sizeofValuesSize
					);
					(yyval.v.SymClass) = (yyvsp[(1) - (3)].v.SymClass);
					

				_endif					

			_else /* not a record object */

				yyerror
				( 
					"Expected record or union object" 
				);

				/*
				** Return a dummy value to prevent inconsistencies
				** in the program.
				*/

				memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );

			_endif
			free2( vss (yyvsp[(3) - (3)].neID.idStr) );
			_here;
		;}
    break;

  case 411:

/* Line 1464 of yacc.c  */
#line 9534 "hlaparse.bsn"
    { 

				_here;
				memcpy( &(yyval.v), (yyvsp[(1) - (1)].s), sizeofSymNode );
				(yyval.v.u.PtrToValue) = (yyvsp[(1) - (1)].s);
				
				/*
				** If this is an array object, we must make a copy of the
				** dimensions array since users of ArrayAdrs and RecordAdrs
				** will free this array when they are done.
				*/
				
				_if( (yyval.v.Dimensions) != NULL )
				
					(yyval.v.Dimensions) = malloc2( (yyval.v.Arity) * sizeofInt );
					memcpy
					( 
						(yyval.v.Dimensions), 
						(yyvsp[(1) - (1)].s)->Dimensions,
						(yyval.v.Arity) * sizeofInt   
					);

				_endif
				_here;
			;}
    break;

  case 412:

/* Line 1464 of yacc.c  */
#line 9560 "hlaparse.bsn"
    { _here; memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode ); ;}
    break;

  case 413:

/* Line 1464 of yacc.c  */
#line 9561 "hlaparse.bsn"
    { _here; memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode ); ;}
    break;

  case 414:

/* Line 1464 of yacc.c  */
#line 9586 "hlaparse.bsn"
    {
			_here;
			_if( !IsConstant( (yyvsp[(1) - (3)].v.SymClass) ))

				/*
				** 04/05/2000 RLH
				**
				**	This  condition doesn't seem possible.
				*/

				yyerror( "Expected a record or union constant" );
				
				/*
				** Return a dummy value to prevent inconsistencies
				** in the program.
				*/

				memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );
				(yyval.v.u.PtrToValue) = NULL;


			_elseif
			( 
					(yyvsp[(1) - (3)].v.pType) == tRecord 
				||	(yyvsp[(1) - (3)].v.pType) == tUnion 
				||	(yyvsp[(1) - (3)].v.pType) == tReal128 
			)

				/*
				** Look up the field reference to see if
				** it is actually a field of the record object.
				*/

				SymNode_t *FieldList;
				int		  ValueIndex;
				char	  *lcID;
				
				lcID = hlastrdup2( (yyvsp[(3) - (3)].neID.idStr) );
				lowercase( lcID );
				FieldList = (yyvsp[(1) - (3)].v.Fields);
				ValueIndex = 0;
				_while
				( 
						FieldList != NULL 
					&&	_strne( lcID, FieldList->Name )
				)

					FieldList = FieldList->Next;
					++ValueIndex;

				_endwhile

				_if
				( 
						FieldList != NULL 
					&&	_streq( (yyvsp[(3) - (3)].neID.idStr), FieldList->TrueName )
				)

					
					/*
					** Copy all the uninteresting fields.
					*/

					memcpy
					( 
						&(yyval.v), 
						FieldList, 
						sizeofSymNode 
					);
					(yyval.v).SymClass = (yyvsp[(1) - (3)].v.SymClass);

					// If it's a union, we've got to set the current
					// field info:
					
					_if( (yyvsp[(1) - (3)].v.pType) == tUnion || (yyvsp[(1) - (3)].v.pType) == tReal128 )

						(yyvsp[(1) - (3)].v.u.PtrToValue)->CurIndex = ValueIndex;
						(yyvsp[(1) - (3)].v.u.PtrToValue)->CurField = FieldList;
						
					_endif
					
					/*
					** If this is a scalar (non-array) object, 
					** just get the address of the data field.
					*/

					_if( FieldList->Arity == 0 )

						(yyval.v.u.PtrToValue) = 
							&(yyvsp[(1) - (3)].v.u.PtrToValue)->u.FieldValues[ ValueIndex ];

					_else


						/*
						** At this point, the object must be an 
						** array.
						**
						** Begin by copying the dimension array
						** (the dope vector).
						** We have an array object, make
						** a copy of the Dimensions list and
						** make a copy of the array data.
						*/

						(yyval.v.pType) = tArray;
						(yyval.v.Dimensions) = 
							malloc2
							( 
									FieldList->Arity
								* 	sizeofInt 
							);


						memcpy
						( 
							(yyval.v.Dimensions), 
							FieldList->Dimensions,
							FieldList->Arity * sizeofInt 
						);

						/*
						** Now return the address of the fields's data.
						*/

						(yyval.v.u.PtrToValue) = 
							&(yyvsp[(1) - (3)].v.u.PtrToValue)->u.FieldValues[ ValueIndex ];

					_endif


				_else

					ErrorNear
					( 
						"Undefined field name", 
						(yyvsp[(3) - (3)].neID.idStr),
						__LINE__,
						__FILE__ 
					);

					/*
					** Return a dummy value to prevent inconsistencies
					** in the program.
					*/

					memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );
					(yyval.v.u.PtrToValue) = NULL;

				_endif
				free2( vss lcID );


			_else /* not a record object */

				yyerror
				( 
					"Expected record or union object" 
				);

				/*
				** Return a dummy value to prevent inconsistencies
				** in the program.
				*/

				memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );
				(yyval.v.u.PtrToValue) = NULL;

			_endif
			free2( vss (yyvsp[(3) - (3)].neID.idStr) );
			_here;
		;}
    break;

  case 415:

/* Line 1464 of yacc.c  */
#line 9777 "hlaparse.bsn"
    {

				_here;
				
				/*
				** Be sure this is a constant or value.
				*/

				_if( !IsConstant( (yyvsp[(1) - (4)].v.SymClass) ))

					/*
					** 04/05/2000 RLH
					**
					**	This  condition doesn't seem possible.
					*/

					yyerror( "Expected an array constant" );

					/*
					** Return an arbitrary constant value (true)
					** just to ensure the integrity of this attribute
					** for the calling code.
					*/

					memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );
					(yyval.v.u.PtrToValue) = NULL;


				/*
				** Be sure it's an array constant.
				*/

				_elseif( (yyvsp[(1) - (4)].v.pType) != tArray )

					yyerror( "Object must be an array" );

					/*
					** Return an arbitrary constant value (true)
					** just to ensure the integrity of this attribute
					** for the calling code.
					*/

					memcpy( &(yyval.v), &dummy_ste, sizeofSymNode );
					(yyval.v.u.PtrToValue) = NULL;


				_else

					int Offset;
					int ResultSize;
					int NewArity;

					/*
					** Okay, we've got an array identifier that is either
					** a cConstant or cValue object.  Pass along the
					** appropriate information to the calling code.
					**
					** Begin by determining if IndexList provides a valid
					** set of indices into the array by calling ComputeOffset.
					*/

					_if
					( 
						ComputeOffset
						( 
							YYS &(yyvsp[(1) - (4)].v), 
							YYS &(yyvsp[(3) - (4)].v), 
							&Offset, 
							&ResultSize 
						)
					)

						/*
						** Okay, the indexes are fine.  Extract an element
						** or an array slice.
						*/

						(yyval.v.Type) = (yyvsp[(1) - (4)].v.Type);
						(yyval.v.Base) = (yyvsp[(1) - (4)].v.Type)->Base;
						(yyval.v.Fields) = (yyvsp[(1) - (4)].v.Type)->Fields;
						(yyval.v.FieldCnt) = (yyvsp[(1) - (4)].v.Type)->FieldCnt;
						(yyval.v.NumElements) = 
							_ifx( ResultSize == 1, 0, ResultSize );

						NewArity = (yyvsp[(1) - (4)].v.Arity) - (yyvsp[(3) - (4)].v.Arity);
						(yyval.v.Arity)  = NewArity;

						/*
						** If this is a scalar object, 
						** just get the address of the data field.
						*/

						_if( (yyval.v.Arity) == 0 )

							(yyval.v.pType) = (yyvsp[(1) - (4)].v.Type)->pType;

							(yyval.v.Dimensions) = NULL;
							(yyval.v.u.PtrToValue) =
								&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.ArrayOfValues[ Offset ];

						_else

							/*
							** At this point, the object must be an 
							** array slice.
							**
							** Begin by copying the dimension array
							** (the dope vector).
							** We have an array object, make
							** a copy of the Dimensions list and
							** make a copy of the array data.
							*/

							(yyval.v.pType) = tArray;
							(yyval.v.Dimensions) = 
								malloc2( NewArity * sizeofInt );


							memcpy
							( 
								(yyval.v.Dimensions), 
								&(yyvsp[(1) - (4)].v.Dimensions)[ (yyvsp[(3) - (4)].v.Arity) ],
								NewArity * sizeofInt 
							);


							/*
							** Now the address of the array's data.
							*/

							(yyval.v.u.PtrToValue) = 
								&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.ArrayOfValues[ Offset ];

							FreeValue( YYS &(yyvsp[(3) - (4)].v) );

						_endif

					_endif

				_endif
			    _here;
			;}
    break;

  case 416:

/* Line 1464 of yacc.c  */
#line 9945 "hlaparse.bsn"
    {
			
			SymNode_t *s;

			_here;
			s = (yyvsp[(1) - (1)].s);

			// Begin by skipping over the VAL/CONST fields that might exist:
			
			_while( s != NULL && IsConstant( s->SymClass ) )
			
				s = s->Next;
				
			_endwhile;

			/*
			** RecList did the actual work, now just check to see
			** if there were enough fields in the record constant.
			*/

			_here;
			_if( s != NULL )

				yyerror( "Incorrect number of fields in record constant" );

				/*
				** Return a "safe" type to avoid problems.
				*/

				(yyval.v.pType) = tUns32;

			_else

				(yyval.v.pType) = tRecord;

			_endif
			_here;
		;}
    break;

  case 417:

/* Line 1464 of yacc.c  */
#line 9993 "hlaparse.bsn"
    {
			SymNode_t 		*s;
			SymNode_t 		*iter;
			SymNode_t 		*next;
			union	YYSTYPE	*v;
			union	YYSTYPE	*endAU;
			int				fIndex;
			int				cnt;
			
			_here;
			s = (yyvsp[(0) - (1)].s);
			assert( s != NULL );

			// Begin by skipping over the VAL/CONST fields that might exist:
			
			_while( s != NULL && IsConstant( s->SymClass ) )
			
				s = s->Next;
				
			_endwhile;
			assert( s != NULL );


			// Default next field (the one that follows the current field)
			// is the very next field in the list.  
			//
			// "next" holds the pointer to the next field in the fields list
			// that this production will return.
			
			next = s->Next;
			
			
			// Check to see if the record is expecting an anonymous union
			// here.
			

			_if( s->pType == tAnonUnion )

				// We're expecting an anonymous union here.
				// Since they simply supplied a constant
				// (without the union.field[ --- ] syntax),
				// we'll just assume they want to use the
				// first field of the union.  This means
				// we use offset one (zero-based) into the
				// array of field values to select the
				// "slot" for the value, and we use the
				// next-to-last item in the fields list
				// as the type specification.
				//
				// Save a pointer (endAU) to this entry in the constant
				// as we have to back-patch some fields later on.
				
				endAU = 
					YYS &RecordValues->v.u.FieldValues[ RecordValues->v.Arity ];
					
				ClrConst
				(
					YYS endAU,
					tAnonUnion,
					&dummyType_ste		// No type, it's dynamically created.
				);
				s = s->Next;
				assert( s != NULL );
				
				// We have to count the number of fields in the anonymous
				// record so we can fill in the field values in the reverse
				// order.  Note that cnt doesn't include the bracketing fields,
				// so we'll have to add two to it later.
				
				cnt = 0;
				iter = s;	// Point iter at first data field.
				_while( iter->pType != tAnonUnion )
				
					++cnt;
					iter = iter->Next;
					assert( iter != NULL );
					
				_endwhile
				
				
				// Save the current index into the record's data array.
				// This corresponds to the first field of the anonymous
				// union which is where we will place the actual data
				// later on.
				
				fIndex = RecordValues->v.Arity + 1; // Skips 1st bracket entry.
				RecordValues->v.Arity += cnt+2;		// Skip beyond anon union.
				
				// Okay, now except for the first field (which is the
				// last field in the "s" list), let's clear all the
				// data fields.  
				
				_for( int i=cnt-1, i > 0, --i )
				
					v = YYS &RecordValues->v.u.FieldValues
							[ 
								fIndex + i 
							];
						
					ClrConst
					(
						YYS v,
						s->pType,
						s->Type
					);
					s = s->Next;
					assert( s->Next != NULL );
					
				_endfor
				
				
				
				// Okay, now s is pointing at the first field of
				// the union (which was the last item in the list).
				
				_if( FieldsAreCompatible( s, YYS &(yyvsp[(1) - (1)].v) ))
				
					/*
					** Force the value's type to be the same as
					** the field if the types were compatible.
					** This undoes promotions like byte->uns8
					** when the field type really should be byte.
					** Treat pointers specially and pass them though
					** unchanged.
					*/
					
					_if( (yyvsp[(1) - (1)].v.pType) != tPointer )

						(yyvsp[(1) - (1)].v.pType) = s->pType;
						(yyvsp[(1) - (1)].v.Type) = s->Type;

					_endif
										
					/*
					** Okay, the data types are compatible, copy the data 
					** from the constant into the record object we are 
					** constructing (in RecordValues).
					*/

					memcpy
					(
						&RecordValues->v.u.FieldValues[ fIndex ],
						&(yyvsp[(1) - (1)].v),
						sizeofSymNode
					);

					
					
					// Okay, set up the last tAnonUnion field:

					v = YYS &RecordValues->v.u.FieldValues
							[ 
								RecordValues->v.Arity - 1 
							];
							
					ClrConst
					(
						YYS v,
						tAnonUnion,
						&dummyType_ste
					);
					
					// The ending Anon Union field overloads
					// the following symbol table fields:
					//
					//	CurField-	Pointer to the record's field list
					//				entry (so we can extract the type
					//				name later.
					//
					//	CurIndex-	Offset from the first tAnonUnion
					//				field where the actual data lies.
					//				This is always one since we're
					//				assuming the use of the first field
					//				in the union.
					//
					//	FieldCnt-	Total number of fields for this
					//				anonymous record (including the two
					//				tAnonUnion fields).
					
					v->v.CurField = s;
					v->v.CurIndex = 1;
					v->v.FieldCnt = cnt+2;

					endAU->v.CurField = s;
					endAU->v.CurIndex = 1;
					endAU->v.FieldCnt = cnt+2;

					// Skip the End Anon Union field:
					
					next = s->Next->Next;
					

				_else

					char msg[ 256 ];

					sprintf
					(
						msg, 
						"Type mismatch in field %s",
						s->TrueName
					);
					yyerror( msg );

				_endif
			
			
			_elseif( s->pType == tAnonRec )
			
				yyerror
				( 
					"Record/union constants may not contain anonymous records"
				);
				
			_else
			
				/*
				** Assume we correctly return a record type.
				** First, see if the type of the current constant in the
				** list of record fields (which looks like an array constant
				** to us) is the same type as the current field that
				** $<s>0 is pointing at.
				*/

				_if( FieldsAreCompatible( s, YYS &(yyvsp[(1) - (1)].v) ))
				

					/*
					** Force the value's type to be the same as
					** the field if the types were compatible.
					** This undoes promotions like byte->uns8
					** when the field type really should be byte.
					*/
					
					_if( (yyvsp[(1) - (1)].v.pType) != tPointer )
					
						(yyvsp[(1) - (1)].v.pType) = s->pType;
						(yyvsp[(1) - (1)].v.Type) = s->Type;
						
					_endif
					
					/*
					** Okay, the data types are compatible, if we haven't
					** exceeded the total number of fields allowed in the
					** specified record type, then copy the data from the
					** constant into the record object we are constructing
					** (in RecordValues).
					*/

					_if( RecordValues->v.Arity < RecordValues->v.FieldCnt )

						memcpy
						(
							&RecordValues->v.u.FieldValues
								[ RecordValues->v.Arity ],
							&(yyvsp[(1) - (1)].v),
							sizeofSymNode
						);
						++RecordValues->v.Arity;

					_endif

				_else

					char msg[ 256 ];

					sprintf
					(
						msg, 
						"Type mismatch in field %s",
						s->TrueName
					);
					yyerror( msg );

				_endif
				
			_endif
			(yyval.s) = next;
			_here;

		;}
    break;

  case 418:

/* Line 1464 of yacc.c  */
#line 10292 "hlaparse.bsn"
    {
			SymNode_t 		*s;
			SymNode_t 		*temp;
			SymNode_t 		*theField;
			SymNode_t 		*next;
			union	YYSTYPE	*v;
			union	YYSTYPE	*f;
			union	YYSTYPE	*endAU;
			int				rIndex;
			int				startIndex;
			int				upCntr;
			char			*lcName;
			int				cnt;
			char			msg[ 256 ];
			
			_here;
			s = (yyvsp[(0) - (7)].s);
			assert( s != NULL );

			// Default next field is the very next field in the list.
			
			next = s->Next;
			_if( s->pType == tAnonUnion )
			
				// Because we have to reverse everything, the
				// first thing we need to do is count all the fields.
				
				cnt = 1;
				temp = s->Next;
				_while( temp->pType != tAnonUnion )
				
					++cnt;
					temp = temp->Next;
					assert( temp != NULL );
					
				_endwhile
				++cnt;		// Count the last field, too.
				
				// Now clear all the fields associated with
				// this anonymous union, and while we're doing that,
				// let's find the selected field.
				//
				// Begin by clearing the last bracketing field item:
				
				startIndex = RecordValues->v.Arity;
				endAU = YYS &RecordValues->v.u.FieldValues[ startIndex ]; 
				ClrConst
				(
					YYS endAU,
					tAnonUnion,
					&dummyType_ste
				);
				++RecordValues->v.Arity;
				s = s->Next;
				
				// The fields are actually in the list backwards.
				// Clear all the fields and save an index into
				// the array where we find the field we're interested in.
				
				
				lcName = lowercase( hlastrdup2( (yyvsp[(3) - (7)].neID.idStr) ));
				f = NULL;
				upCntr = 1;
				_for( int i=cnt-2, i > 0, --i )

					v = YYS &RecordValues->v.u.FieldValues
							[ 
								RecordValues->v.Arity + i - 1 
							];
						
					_if( _streq( s->Name, lcName ))
					
						f = v;
						theField = s;
						rIndex = i;
						_if( _strne( (yyvsp[(3) - (7)].neID.idStr), s->TrueName ))
						
							sprintf
							(
								msg,
								"Mispelled identifier, perhaps you meant %s",
								s->TrueName
							);
							yyerror( msg );
							
						_endif
						
					_endif

					ClrConst
					(
						YYS v,
						s->pType,
						s->Type
					);

					++upCntr;
					s = s->Next;
					
				_endfor
				RecordValues->v.Arity += cnt-2;
				free2( vss lcName );

				// Okay, set up the last tAnonUnion field:

				v = YYS &RecordValues->v.u.FieldValues
						[ 
							RecordValues->v.Arity 
						];
						
				ClrConst
				(
					YYS v,
					tAnonUnion,
					&dummyType_ste
				);
				
				// The ending Anon Union field overloads
				// the following symbol table fields:
				//
				//	CurField-	Pointer to the record's field list
				//				entry (so we can extract the type
				//				name later.
				//
				//	CurIndex-	Offset from the first tAnonUnion
				//				field where the actual data lies.
				//				This is always one since we're
				//				assuming the use of the first field
				//				in the union.
				//
				//	FieldCnt-	Total number of fields for this
				//				anonymous record (including the two
				//				tAnonUnion fields).
				
				v->v.CurField = _ifx( f == NULL, s, theField );
				v->v.CurIndex = rIndex;
				v->v.FieldCnt = cnt;

				endAU->v.CurField = _ifx( f == NULL, s, theField );
				endAU->v.CurIndex = rIndex;
				endAU->v.FieldCnt = cnt;


				// Skip the End Anon Union field:
				
				++RecordValues->v.Arity;
				next = s->Next;
				
				// Okay, now f is pointing at the appropriate field,
				
				_if( f == NULL )
				
					sprintf
					( 
						msg, 
						"Field %s was not found in anonymous union",
						(yyvsp[(3) - (7)].neID.idStr)
					);
					yyerror( msg );
					
				
				_elseif( FieldsAreCompatible( SSN f, YYS &(yyvsp[(6) - (7)].v) ))
				

					/*
					** Force the value's type to be the same as
					** the field if the types were compatible.
					** This undoes promotions like byte->uns8
					** when the field type really should be byte.
					*/
					
					_if( (yyvsp[(1) - (7)].v.pType) != tPointer )

						(yyvsp[(1) - (7)].v.pType) = f->v.pType;
						(yyvsp[(1) - (7)].v.Type) = f->v.Type;
						
					_endif
					
					/*
					** Okay, the data types are compatible, copy the data 
					** from the constant into the record object we are 
					** constructing (in RecordValues).
					*/

					memcpy
					(
						&RecordValues->v.u.FieldValues[ rIndex + startIndex ],
						&(yyvsp[(6) - (7)].v),
						sizeofSymNode
					);					

				_else

					sprintf
					(
						msg, 
						"Type mismatch in field %s",
						(yyvsp[(3) - (7)].neID.idStr)
					);
					yyerror( msg );

				_endif
				next = s->Next;
				
			
			_elseif( s->pType == tAnonRec )
			
				yyerror
				( 
					"Record/union constants may not contain anonymous records"
				);
				
			_else
			
				sprintf
				(
					msg,
					"Expected an anonymous union with field %s",
					(yyvsp[(3) - (7)].neID.idStr)
				);
				yyerror( msg );
				
			_endif
			
			free2( vss (yyvsp[(3) - (7)].neID.idStr) );
			(yyval.s) = next;
			_here;
		;}
    break;

  case 419:

/* Line 1464 of yacc.c  */
#line 10526 "hlaparse.bsn"
    {
			/*
			** Set up inherited attribute for RecList
			*/

			_here;
			(yyval.s) = (yyvsp[(0) - (2)].s);
		;}
    break;

  case 420:

/* Line 1464 of yacc.c  */
#line 10535 "hlaparse.bsn"
    {

			SymNode_t 		*s;
			SymNode_t 		*iter;
			SymNode_t 		*next;
			union	YYSTYPE	*v;
			union	YYSTYPE	*endAU;
			int				fIndex;
			int				cnt;
			
			_here;
			
			// Begin by skipping over the VAL/CONST fields that might exist:
			
			s = (yyvsp[(4) - (4)].s);
			_while( s != NULL && IsConstant( s->SymClass ) )
			
				s = s->Next;
				
			_endwhile;
			_if( s != NULL )

				// Default next field is the very next field in the list.
				
				next = s->Next;
				_if( s->pType == tAnonUnion )

					// We've got an anonymous union here.
					// Since they simply supplied a constant
					// (without the union.field[ --- ] syntax),
					// we'll just assume they want to use the
					// first field of the union.
					
					endAU = 
						YYS &RecordValues->v.u.FieldValues
							[ 

								RecordValues->v.Arity 
							];
						
					ClrConst
					(
						YYS endAU,
						tAnonUnion,
						&dummyType_ste
					);
					s = s->Next;
					assert( s != NULL );



					// We have to count the number of fields in the anonymous
					// record so we can fill in the field values in the reverse
					// order.  Note that cnt doesn't include the bracketing fields,
					// so we'll have to add two to it later.
					
					cnt = 0;
					iter = s;	// Point iter at first data field.
					_while( iter->pType != tAnonUnion )

					
						++cnt;
						iter = iter->Next;
						assert( iter != NULL );
						
					_endwhile
					fIndex = RecordValues->v.Arity + 1;	// Save index for later
					RecordValues->v.Arity += cnt+2;		// Skip beyond union.
				
					// Okay, let's clear all the data fields except
					// the first one (which is the last entry in the list).  
					
					_for( int i=cnt-1, i > 0, --i )
					
						v = YYS &RecordValues->v.u.FieldValues
								[ 
									fIndex + i 
								];
							
						ClrConst
						(
							YYS v,
							s->pType,
							s->Type
						);
						s = s->Next;
						assert( s->Next != NULL );
						
					_endfor
					
					
					
					// Okay, now s is pointing at the first field
					// (the last entry in the list).
					
					_if( FieldsAreCompatible( s, YYS &(yyvsp[(1) - (4)].v) ))
					

						/*
						** Force the value's type to be the same as
						** the field if the types were compatible.
						** This undoes promotions like byte->uns8
						** when the field type really should be byte.
						*/
						
						_if( (yyvsp[(1) - (4)].v.pType) != tPointer )

							(yyvsp[(1) - (4)].v.pType) = s->pType;
							(yyvsp[(1) - (4)].v.Type) = s->Type;
							
						_endif
							
						/*
						** Okay, the data types are compatible, copy the data 
						** from the constant into the record object we are 
						** constructing (in RecordValues).
						*/

						memcpy
						(
							&RecordValues->v.u.FieldValues[ fIndex ],
							&(yyvsp[(1) - (4)].v),
							sizeofSymNode
						);

						
						
						// Okay, set up the last tAnonUnion field:

						v = YYS &RecordValues->v.u.FieldValues
								[ 
									RecordValues->v.Arity - 1 
								];
								
						ClrConst
						(
							YYS v,
							tAnonUnion,
							&dummyType_ste
						);
						
						// The ending Anon Union field overloads
						// the following symbol table fields:
						//
						//	Offset-		Index into the record constant array
						//				where the value for this field can
						//				be found (always one since this is
						//				the default index).
						//
						//	FieldCnt-	Total number of fields for this
						//				anonymous record (including the two
						//				tAnonUnion fields).
						//
						//	Base-		Pointer to the ending type bracket
						//				for the anon union (this is the
						//				"Anon Union" entry).
						//
						//	unsval-		Number of fields to skip in the
						//				backwards field list to get to
						//				the field description that corresponds
						//				to this field (Always FieldCnt-1 since
						//				the default field is always the first
						//				field of this Anon Union).

						v->v.CurField = s;
						v->v.CurIndex = 1;
						v->v.FieldCnt = cnt+2;

						endAU->v.CurField = s;
						endAU->v.CurIndex = 1;
						endAU->v.FieldCnt = cnt+2;
								 
						// Skip the End Anon Union field:
						
						next = s->Next->Next;
						

					_else

						char msg[ 256 ];

						sprintf
						(
							msg, 
							"Type mismatch in field %s",
							s->TrueName
						);
						yyerror( msg );

					_endif
				
				
			
				_elseif( s->pType == tAnonRec )
				
					yyerror
					( 
						"Record/union constants may not contain "
						"anonymous records"
					);
				
				_else


					_if( FieldsAreCompatible( s, YYS &(yyvsp[(1) - (4)].v) ))


						/*
						** Force the value's type to be the same as
						** the field if the types were compatible.
						** This undoes promotions like byte->uns8
						** when the field type really should be byte.
						*/
						
						_if( (yyvsp[(1) - (4)].v.pType) != tPointer )
						
							(yyvsp[(1) - (4)].v.pType) = s->pType;
							(yyvsp[(1) - (4)].v.Type) = s->Type;
							
						_endif
						
						
						_if
						( 
								RecordValues->v.Arity < 
									RecordValues->v.FieldCnt 
						)

							memcpy
							(
								&RecordValues->v.u.FieldValues
									[ RecordValues->v.Arity ],
								&(yyvsp[(1) - (4)].v),
								sizeofSymNode
							);
							++RecordValues->v.Arity;

						_endif
			 
					_else

						char msg[ 256 ];

						sprintf
						(
							msg, 
							"Type mismatch in field %s",
							s->TrueName
						);
						yyerror( msg );

					_endif
					
				_endif
				(yyval.s) = next;

			_else

				yyerror( "Too many fields in record constant" );
				
				(yyval.s) = NULL; 

			_endif
			(void) (yyvsp[(3) - (4)].s);	// Shut up Bison
			_here;
		;}
    break;

  case 421:

/* Line 1464 of yacc.c  */
#line 10821 "hlaparse.bsn"
    {
			/*
			** Set up inherited attribute for RecList
			*/

			_here;
			(yyval.s) = (yyvsp[(0) - (8)].s);
		;}
    break;

  case 422:

/* Line 1464 of yacc.c  */
#line 10830 "hlaparse.bsn"
    {
			SymNode_t 		*s;
			SymNode_t 		*temp;
			SymNode_t 		*next;
			SymNode_t 		*theField;
			union	YYSTYPE	*v;
			union	YYSTYPE	*f;
			union	YYSTYPE	*endAU;
			int				rIndex;
			int				startIndex;
			int				upCntr;
			int				cnt;
			char			*lcName;
			char			msg[ 256 ];
			
			_here;
			_if( (yyvsp[(10) - (10)].s) != NULL )
				
				s = (yyvsp[(10) - (10)].s);

				// Default next field is the very next field in the list.
				
				next = s->Next;
				_if( s->pType == tAnonUnion )

					// Because we have to reverse everything, the
					// first thing we need to do is count all the fields.
					
					cnt = 1;
					temp = s->Next;
					_while( temp->pType != tAnonUnion )
					
						++cnt;
						temp = temp->Next;
						assert( temp != NULL );
						
					_endwhile
					++cnt;		// Count the last field, too.
				

					// We've got an anonymous union here.  That's good
					// since the user is specifying a field of that union.
					
					startIndex = RecordValues->v.Arity;
					endAU = YYS &RecordValues->v.u.FieldValues[ startIndex ];
					ClrConst
					(
						YYS endAU,
						tAnonUnion,
						&dummyType_ste
					);
					++RecordValues->v.Arity;
					s = s->Next;
					
					// The fields are actually in the list backwards.
					// Clear all the fields and save an index into
					// the array where we find the field we're interested in.
					
					
					lcName = lowercase( hlastrdup2( (yyvsp[(3) - (10)].neID.idStr) ));
					f = NULL;
					upCntr = 1;
					_for( int i=cnt-2, i > 0, --i )
					
						v = YYS &RecordValues->v.u.FieldValues
								[ 
									RecordValues->v.Arity + i - 1 
								];
							
						_if( _streq( s->Name, lcName ))
						
							f = v;
							theField = s;
							rIndex = i;
							_if( _strne( (yyvsp[(3) - (10)].neID.idStr), s->TrueName ))
							
								sprintf
								(
									msg,
									"Mispelled identifier, "
									"perhaps you meant %s",
									s->TrueName
								);
								yyerror( msg );
								
							_endif
							
						_endif

						ClrConst
						(
							YYS v,
							s->pType,
							s->Type
						);
						++upCntr;

						s = s->Next;
						
					_endfor
					RecordValues->v.Arity += cnt-2;
					free2( vss lcName );

					// Initialize the last tAnonUnion field:
					
					v = YYS &RecordValues->v.u.FieldValues
							[ 
								RecordValues->v.Arity 
							];
							
					ClrConst
					(
						YYS v,
						tAnonUnion,
						&dummyType_ste
					);
					
				
					// The ending Anon Union field overloads
					// the following symbol table fields:
					//
					//	CurField-	Pointer to the record's field list
					//				entry (so we can extract the type
					//				name later.
					//
					//	CurIndex-	Offset from the first tAnonUnion
					//				field where the actual data lies.
					//				This is always one since we're
					//				assuming the use of the first field
					//				in the union.
					//
					//	FieldCnt-	Total number of fields for this
					//				anonymous record (including the two
					//				tAnonUnion fields).
					
					v->v.CurField = _ifx( f == NULL, s, theField );
					v->v.CurIndex = rIndex;
					v->v.FieldCnt = cnt;

					endAU->v.CurField = _ifx( f == NULL, s, theField );
					endAU->v.CurIndex = rIndex;
					endAU->v.FieldCnt = cnt;

					// Move on to the next field in the constant:
					
					++RecordValues->v.Arity;
					next = s->Next;
					
					// Okay, now f is pointing at the appropriate field,
					
					_if( f == NULL )
					
						sprintf
						( 
							msg, 
							"Field %s was not found in anonymous union",
							(yyvsp[(3) - (10)].neID.idStr)
						);
						yyerror( msg );
						
					
					_elseif( FieldsAreCompatible( SSN f, YYS &(yyvsp[(6) - (10)].v) ))
					

						/*
						** Force the value's type to be the same as
						** the field if the types were compatible.
						** This undoes promotions like byte->uns8
						** when the field type really should be byte.
						*/
						
						_if( (yyvsp[(1) - (10)].v.pType) != tPointer )

							(yyvsp[(1) - (10)].v.pType) = f->v.pType;
							(yyvsp[(1) - (10)].v.Type) = f->v.Type;
							
						_endif
						
						/*
						** Okay, the data types are compatible, copy the data 
						** from the constant into the record object we are 
						** constructing (in RecordValues).
						*/

						memcpy
						(
							&RecordValues->v.u.FieldValues[ rIndex + startIndex ],
							&(yyvsp[(6) - (10)].v),
							sizeofSymNode
						);					

					_else

						sprintf
						(
							msg, 
							"Type mismatch in field %s",
							(yyvsp[(3) - (10)].neID.idStr)
						);
						yyerror( msg );

					_endif
					next = s->Next;
					
			
				_elseif( s->pType == tAnonRec )
				
					yyerror
					( 
						"Record/union constants may not contain "
						"anonymous records"
					);
					
				_else
				
					sprintf
					(
						msg,
						"Expected an anonymous union with field %s",
						(yyvsp[(3) - (10)].neID.idStr)
					);
					yyerror( msg );
					
				_endif
				free2( vss (yyvsp[(3) - (10)].neID.idStr) );
				(yyval.s) = next;

			_else

				yyerror( "Too many fields in record constant" );
				
				(yyval.s) = NULL; 

			_endif
			(void) (yyvsp[(9) - (10)].s);
			_here;
		;}
    break;

  case 423:

/* Line 1464 of yacc.c  */
#line 11108 "hlaparse.bsn"
    {
			union YYSTYPE TheValue;

			_here;
			assert( (yyvsp[(1) - (1)].idStr) != NULL );

			Setval( &TheValue, EnumVal );
			++EnumVal;

			InsertSym
			( 
				(yyvsp[(1) - (1)].idStr), 
				(yyvsp[(0) - (1)].v.Type),
				tEnum, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &TheValue,
				1,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			_here;
		;}
    break;

  case 424:

/* Line 1464 of yacc.c  */
#line 11148 "hlaparse.bsn"
    {
			union YYSTYPE TheValue;

			_here;
			assert( (yyvsp[(1) - (2)].idStr) != NULL );

			Setval( &TheValue, EnumVal );
			++EnumVal;

			InsertSym
			( 
				(yyvsp[(1) - (2)].idStr), 
				(yyvsp[(0) - (2)].v.Type),
				tEnum, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &TheValue,
				1,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			(yyval.v.Type) = (yyvsp[(0) - (2)].v.Type);
			_here; 
		;}
    break;

  case 425:

/* Line 1464 of yacc.c  */
#line 11178 "hlaparse.bsn"
    {
			_here;
			(void) (yyvsp[(3) - (4)].v.Type);	// To shut up Bison
		;}
    break;

  case 426:

/* Line 1464 of yacc.c  */
#line 11191 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Duplicate enumeration constant", 
				(yyvsp[(1) - (1)].s)->Name,
				__LINE__,
				__FILE__ 
			);
		;}
    break;

  case 427:

/* Line 1464 of yacc.c  */
#line 11203 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Duplicate enumeration constant", 
				(yyvsp[(1) - (2)].s)->Name,
				__LINE__,
				__FILE__ 
			);
		;}
    break;

  case 429:

/* Line 1464 of yacc.c  */
#line 11216 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Illegal enumeration list", 
				(yyvsp[(1) - (3)].idStr),
				__LINE__,
				__FILE__
			);
			PushBackStr( "}" );
			free2( vss (yyvsp[(1) - (3)].idStr) );
		;}
    break;

  case 430:

/* Line 1464 of yacc.c  */
#line 11229 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Illegal enumeration list", 
				(yyvsp[(1) - (3)].idStr),
				__LINE__,
				__FILE__ 
			);
			PushBackStr( "};" );
			free2( vss (yyvsp[(1) - (3)].idStr) );
		;}
    break;

  case 431:

/* Line 1464 of yacc.c  */
#line 11244 "hlaparse.bsn"
    {
				/*
				** Set TempIgnoreErrors to true so yyerror
				** won't print a syntax error message along
				** with the error message we are providing.
				*/

				_here;
				TempIgnoreErrors = 1;
				(yyval.idStr) = hlastrdup2(yytext);
			;}
    break;

  case 432:

/* Line 1464 of yacc.c  */
#line 11267 "hlaparse.bsn"
    { _here; ;}
    break;

  case 433:

/* Line 1464 of yacc.c  */
#line 11271 "hlaparse.bsn"
    {
				(yyval.v.u.intval) = CurOffset;
				_here;
			;}
    break;

  case 434:

/* Line 1464 of yacc.c  */
#line 11278 "hlaparse.bsn"
    {
				_here;
				(yyval.v.u.intval) = CurOffsetDir;
			;}
    break;

  case 435:

/* Line 1464 of yacc.c  */
#line 11285 "hlaparse.bsn"
    {
				_here;
				(yyval.v.u.intval) = AddOffset1st;
			;}
    break;

  case 436:

/* Line 1464 of yacc.c  */
#line 11292 "hlaparse.bsn"
    {
				_here;
				(yyval.v.u.intval) = CurLexLevel;
				CurLexLevel = -256;
			;}
    break;

  case 437:

/* Line 1464 of yacc.c  */
#line 11300 "hlaparse.bsn"
    {
				_here;
				(yyval.v.u.intval) = CurLexLevel;
				CurLexLevel = CurLexLevel+1;  //was -3
			;}
    break;

  case 438:

/* Line 1464 of yacc.c  */
#line 11338 "hlaparse.bsn"
    {
				_here;
				(yyval.s) = NULL
			;}
    break;

  case 439:

/* Line 1464 of yacc.c  */
#line 11352 "hlaparse.bsn"
    {
				assert( (yyvsp[(3) - (4)].s) != NULL );

				_here;
				_if( (yyvsp[(3) - (4)].s)->pType == tClass )

					(yyval.s) = (yyvsp[(3) - (4)].s);

				_else

					yyerror( "Base class type expected" );
					(yyval.s) = NULL;

				_endif
			;}
    break;

  case 440:

/* Line 1464 of yacc.c  */
#line 11374 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Undefined base type identifier",
					(yyvsp[(3) - (4)].idStr),
					__LINE__,
					__FILE__ 
				);
				(yyval.s) = NULL;

			;}
    break;

  case 441:

/* Line 1464 of yacc.c  */
#line 11420 "hlaparse.bsn"
    {
				_here;
				(yyvsp[(-1) - (1)].ru.base) = NULL				  
			;}
    break;

  case 442:

/* Line 1464 of yacc.c  */
#line 11436 "hlaparse.bsn"
    {
				assert( (yyvsp[(3) - (4)].s) != NULL );
				_here;
				_if( (yyvsp[(-1) - (4)].ru.newOffset) )
				
					yyerror
					( 
						"This record cannot both inherit fields and set a "
						"starting offset"
					);
					
				_endif
				_if
				( 
						(yyvsp[(-1) - (4)].ru.MinRecAlignment) != 1 
					||	(yyvsp[(-1) - (4)].ru.MaxRecAlignment) != 1 
				)
				
					yyerror
					(
						"This record cannot both inherit fields and specify "
						"alignment values"
					);
				
				_endif;
				_if( (yyvsp[(3) - (4)].s)->SymClass == cType )

					_if( (yyvsp[(3) - (4)].s)->pType == tRecord )
					
						SymNode_t *s;

						(yyvsp[(-1) - (4)].ru.base) = (yyvsp[(3) - (4)].s);

						// Copy the inherited fields to the new record:

						SymbolTable = CopyRecSymbols( (yyvsp[(3) - (4)].s)->Fields );

						
						// We've got to determine the starting
						// offset of the first field of the base
						// class so we can use that as our starting
						// field:
						
						s = (yyvsp[(3) - (4)].s)->Fields;
						assert( s != NULL );
						_while( s->Next != NULL )
						
							s = s->Next;
							
						_endwhile;
						
						(yyvsp[(-1) - (4)].ru.CurOffset) = s->Offset;	// Starting offset.
						
						// Set the current offset to the base record's
						// starting offset plus it's size.  The next
						// record will pick up from there.
						
						CurOffset = s->Offset + (yyvsp[(3) - (4)].s)->ObjectSize;
						
						

					_else

						ErrorNear
						( 
							"Base record type expected",
							(yyvsp[(3) - (4)].s)->TrueName,
							__LINE__,
							__FILE__ 
						);
						(yyvsp[(-1) - (4)].ru.base) = NULL;

					_endif

				_else

					ErrorNear
					( 
						"Expected a base type ID",
						(yyvsp[(3) - (4)].s)->TrueName,
						__LINE__,
						__FILE__ 
					);
					(yyvsp[(-1) - (4)].ru.base) = NULL;

				_endif
				_here;
			;}
    break;

  case 443:

/* Line 1464 of yacc.c  */
#line 11534 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Undefined base type identifier",
					(yyvsp[(3) - (4)].idStr),
					__LINE__,
					__FILE__ 
				);
				(yyvsp[(-1) - (4)].ru.base) = NULL;
			;}
    break;

  case 444:

/* Line 1464 of yacc.c  */
#line 11549 "hlaparse.bsn"
    {
			// Unions (generally) start with an offset of zero.
			// Save the current offset value away and set the
			// global CurOffset value to zero (note that anonymous
			// unions will have to reset the CurOffset back to
			// its original value, but that's another story...)
			
			_here;
			(yyval.ru.SaveOffset) = CurOffset;
			(yyval.ru.CurOffset) = CurOffset;
			CurOffset = 0;

			// Save the direction and add1st values.
			// Set them both to zero for unions.
			
			(yyval.ru.SaveDir) = CurOffsetDir;
			CurOffsetDir = 0;	/* Forces all fields to the same offset */

			(yyval.ru.SaveAdd1st) = AddOffset1st;
			AddOffset1st = 0;

			// Bump the current lex level (again, anonymous unions
			// will have to undo this).
			
			(yyval.ru.SaveLex) = CurLexLevel;
			++CurLexLevel;
			

			// Save the alignment values.  Unions don't change them,
			// but it's not a bad idea to do this for consistency's
			// sake.
			
			(yyval.ru.MinRecAlignment) = MinRecAlignment;
			(yyval.ru.MaxRecAlignment) = MaxRecAlignment;
			(yyval.ru.TempRecAlign) = TempRecAlign;
			TempRecAlign = 1;
			
			// Save the current record/union field count and then
			// set it to zero so we can count the fields in this record.
			
			(yyval.ru.RecFieldCnt) = RecFieldCnt;
			RecFieldCnt = 0;

			// Misc initialization:
			
			(yyval.ru.newOffset) = 0;
			(yyval.ru.inSave) = (char)inUnion;
			inUnion = 1;
			
			// Preserve currentNS, etc.
			
			(yyval.ru.saveCurNS) = currentNS;
			(yyval.ru.saveRecNS) = RecNS;
			(yyval.ru.saveRecGlobal) = RecGlobal;
			_if( RecNS == NULL )
			
				RecNS = currentNS;
				
			_endif
			_if( RecGlobal == NULL )
			
				RecGlobal = SymbolTable;
				
			_endif
			currentNS = NULL;
			
			// The current symbol table pointer is where the field list
			// will end.  Save a pointer to this spot so we can find
			// it later.
						
			(yyval.ru.endFields) = SymbolTable;
			(yyval.ru.base) = NULL;
			SymbolTable = &dummyField_ste;
			_here;
		;}
    break;

  case 445:

/* Line 1464 of yacc.c  */
#line 11630 "hlaparse.bsn"
    {
			/*
			** Initialize misc values:
			*/
			
			_here;
			(yyval.ru.inSave) = (char)inRecord;
			inRecord = 1;

			(yyval.ru.MinRecAlignment) = MinRecAlignment;
			(yyval.ru.MaxRecAlignment) = MaxRecAlignment;
			MinRecAlignment = 1;
			MaxRecAlignment = 1;

			(yyval.ru.RecFieldCnt) = RecFieldCnt;
			RecFieldCnt = 0;
			
			(yyval.ru.SaveOffset) = CurOffset;
			(yyval.ru.CurOffset) = 0;
			(yyval.ru.newOffset) = 0;
			CurOffset = 0;
			
			(yyval.ru.SaveLex) = CurLexLevel;
			++CurLexLevel;
			

			/*
			** In a record offsets are increasing and we increment
			** the offset *after* assigning to a field.
			*/

			(yyval.ru.SaveDir) = CurOffsetDir;
			CurOffsetDir = 1;

			(yyval.ru.SaveAdd1st) = AddOffset1st;
			AddOffset1st = 0;
			
			// Preserve currentNS:
			
			(yyval.ru.saveCurNS) = currentNS;
			(yyval.ru.saveRecNS) = RecNS;
			(yyval.ru.saveRecGlobal) = RecGlobal;
			_if( RecNS == NULL )
			
				RecNS = currentNS;
				
			_endif
			_if( RecGlobal == NULL )
			
				RecGlobal = SymbolTable;
				
			_endif
			currentNS = NULL;

			/*
			** Mark the end of the fields for the record/union
			*/
			
			(yyval.ru.endFields) = SymbolTable;
			(yyval.ru.base) = NULL;
			SymbolTable = &dummyField_ste;
			_here;
		;}
    break;

  case 446:

/* Line 1464 of yacc.c  */
#line 11705 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 447:

/* Line 1464 of yacc.c  */
#line 11712 "hlaparse.bsn"
    {			

			_here;
			
			/*
			** If reasonable, set the starting offset to the
			** value of the constant expression above.
			*/
			
			_if( IsNumber( (yyvsp[(2) - (3)].v.pType) ) && numBits( YYS &(yyvsp[(2) - (3)].v) ) <= 32 )

				(yyvsp[(0) - (3)].ru.CurOffset) = (yyvsp[(2) - (3)].v.u.intval);
				CurOffset = (yyvsp[(2) - (3)].v.u.intval);
				(yyvsp[(0) - (3)].ru.newOffset) = 1;

			_else

				yyerror
				( 
					"Expected a 32-bit numeric constant" 
				);

			_endif
		;}
    break;

  case 448:

/* Line 1464 of yacc.c  */
#line 11740 "hlaparse.bsn"
    {

			/*
			** In a record offsets are increasing and we increment
			** the offset *after* assigning to a field.
			*/

			_here;
			MinRecAlignment = (yyvsp[(1) - (1)].ru.MinRecAlignment);
			MaxRecAlignment = (yyvsp[(1) - (1)].ru.MaxRecAlignment);
		;}
    break;

  case 449:

/* Line 1464 of yacc.c  */
#line 11756 "hlaparse.bsn"
    {
			_here;
			MinRecAlignment = (yyvsp[(1) - (4)].ru.MinRecAlignment);
			MaxRecAlignment = (yyvsp[(1) - (4)].ru.MaxRecAlignment);
			_if( IsNumber( (yyvsp[(3) - (4)].v.pType) ) && numBits( YYS &(yyvsp[(3) - (4)].v) ) <= 32)

				(yyvsp[(0) - (4)].ru.CurOffset) = (yyvsp[(3) - (4)].v.u.intval);
				CurOffset = (yyvsp[(3) - (4)].v.u.intval);
				(yyvsp[(0) - (4)].ru.newOffset) = 1;

			_else

				yyerror
				( 
					"Expected a 32-bit numeric constant for starting offset" 
				);

			_endif
		;}
    break;

  case 450:

/* Line 1464 of yacc.c  */
#line 11782 "hlaparse.bsn"
    {
			int align;

			_here;
			_if
			( 
					IsNumber( (yyvsp[(2) - (3)].v.pType) )
				&&	checkSmallUns( YYS &(yyvsp[(2) - (3)].v) ) 
				&&	(yyvsp[(2) - (3)].v.u.unsval) >= 1
				&&	(yyvsp[(2) - (3)].v.u.unsval) <= 4096
			)

				(yyval.ru.MinRecAlignment) = (yyvsp[(2) - (3)].v.u.unsval); // Min alignment
				(yyval.ru.MaxRecAlignment) = (yyvsp[(2) - (3)].v.u.unsval); // Max alignment

			_else

				yyerror( "Expected a constant in the range 1..4096" );
				(yyval.ru.MinRecAlignment) = MinRecAlignment;
				(yyval.ru.MaxRecAlignment) = MaxRecAlignment;

			_endif
			_here;
		;}
    break;

  case 451:

/* Line 1464 of yacc.c  */
#line 11812 "hlaparse.bsn"
    {
			int align;

			_here;
			_if
			( 
					IsNumber( (yyvsp[(2) - (5)].v.pType) )
				&&	IsNumber( (yyvsp[(4) - (5)].v.pType) ) 
				&&	checkSmallUns( YYS &(yyvsp[(2) - (5)].v) ) 
				&&	checkSmallUns( YYS &(yyvsp[(4) - (5)].v) ) 
				&&	(yyvsp[(2) - (5)].v.u.unsval) <= 16
				&&	(yyvsp[(4) - (5)].v.u.unsval) <= 16
			)
				_if( (yyvsp[(2) - (5)].v.u.unsval) >= (yyvsp[(4) - (5)].v.u.unsval) )
				
					(yyval.ru.MaxRecAlignment) = (yyvsp[(2) - (5)].v.u.unsval); // Max alignment
					(yyval.ru.MinRecAlignment) = (yyvsp[(4) - (5)].v.u.unsval); // Min alignment
					
				_else
				
					yyerror
					(
						"In record alignment, the first (max) value must be "
						"greater or equal to the second (min) value"
					);
					
					// Note that the following swaps the minimum and
					// maximum values:
					
					(yyval.ru.MinRecAlignment) = (yyvsp[(2) - (5)].v.u.unsval); // Max alignment
					(yyval.ru.MaxRecAlignment) = (yyvsp[(4) - (5)].v.u.unsval); // Min alignment

				_endif

			_else

				yyerror( "Expected a constant in the range 0..16" );
				(yyval.ru.MinRecAlignment) = MinRecAlignment;
				(yyval.ru.MaxRecAlignment) = MaxRecAlignment;

			_endif
			_here;
		;}
    break;

  case 453:

/* Line 1464 of yacc.c  */
#line 11883 "hlaparse.bsn"
    {				/* $3 */
			char	anonUnion[ 256 ];
			
			/*
			** Undo some of the effects of doUnionTkn that
			** we don't need for anonymous unions:
			*/
			
			_here;
			SymbolTable = (yyvsp[(2) - (2)].ru.endFields);
			
			/*
			** doUnionTkn has bumped the lex level,
			** we really didn't want that to happen for
			** anonymous unions.
			*/
			
			CurLexLevel = (yyvsp[(2) - (2)].ru.SaveLex);
			
			/*
			** It also set the offset to zero, we didn't really
			** want that to happen, either.
			*/
			
			CurOffset = (yyvsp[(2) - (2)].ru.SaveOffset);
			
			// Create a dummy entry to mark the fact that
			// we have an anonymous union here.

			sprintf( anonUnion, "Anon Union %d", LblCntr++ );
			InsertSym
			( 
				hlastrdup2( anonUnion ),		// Name
				NULL,						// TYPE
				tAnonUnion,					// pType
				cVar,	 					// class
				0,							// Arity
				NULL,						// Dimensions
				0, 							// NumElements
				NULL,						// Value
				0,							// ObjectSize
				CurOffset,					// Offset
				NULL,						// StaticName
				NULL,						// Base
				NULL,						// Fields
				0							// FieldCnt
			);
			(yyval.ru.endFields) = SymbolTable;
			(yyval.ru.RecFieldCnt) = LblCntr - 1;
			
			_here;
			
		;}
    break;

  case 454:

/* Line 1464 of yacc.c  */
#line 11939 "hlaparse.bsn"
    {
			int				SizeOfUnion;
			int				ofsDiff;
			SymNode_t		*CurSym;
			char			endAnonUnion[ 256 ];

			_here;
			inUnion = (yyvsp[(2) - (6)].ru.inSave);

			/*
			** Note that we must add the number of fields in the
			** anonymous union to the field count for the record
			** (note that the "+2" component is to cover the two
			** anonymous union fields we added):
			*/
			
			RecFieldCnt = RecFieldCnt + (yyvsp[(2) - (6)].ru.RecFieldCnt) + 2;
			
			/*
			** Restore other values to their pre-record form:
			*/
			
			MinRecAlignment = (yyvsp[(2) - (6)].ru.MinRecAlignment);
			MaxRecAlignment = (yyvsp[(2) - (6)].ru.MaxRecAlignment);

			/*
			** If there were no fields present in the anonymous
			** union, complain about this.  By happenstance, the
			** size of the union will wind up being zero, so this
			** has no deterimental effect on the record being
			** created.
			*/

			_if( RecFieldCnt == 0 )

				ErrorNear
				( 
					"Unions must have at least one field",
					"endunion",
					__LINE__,
					__FILE__ 
				);

			_endif

			/*
			** Determine the size of the union (this is the size
			** of the largest object in the union).
			*/

			CurSym = SymbolTable;
			SizeOfUnion = 0;
			_while( CurSym != (yyvsp[(3) - (6)].ru.endFields) )

				SizeOfUnion = 
					max( SizeOfUnion, CurSym->ObjectSize);

				CurSym = CurSym->Next;

			_endwhile
			(yyvsp[(3) - (6)].ru.endFields)->ObjectSize = SizeOfUnion;

			/*
			** Now that we know the size of the largest field
			** of the union, set the alignment based on the
			** size of that largest object.
			*/
			
			CurOffset = (yyvsp[(2) - (6)].ru.SaveOffset);	// Restore original curOffset.
			_if( (yyvsp[(2) - (6)].ru.TempRecAlign) != 1 )

				AlignTo
				( 
					&CurOffset, 
					(yyvsp[(2) - (6)].ru.TempRecAlign), 
					(yyvsp[(2) - (6)].ru.TempRecAlign), 
					SizeOfUnion 
				);
				
			_else
			 
			 	// If there was no align directive prior to the
				// union, then align the union on the basis of
				// the largest object in the union.
				
				AlignTo
				( 
					&CurOffset, 

					MinRecAlignment, 
					MaxRecAlignment, 
					SizeOfUnion 
				);
				
			_endif
			ofsDiff = CurOffset - (yyvsp[(2) - (6)].ru.SaveOffset);
			
			/*
			** Okay, now step through the fields of the anonymous
			** union again and set their offset fields to the
			** CurOffset value we just aligned.  Note that we actually
			** add the difference between the saved offset and the
			** current offset to the field offsets since there may
			** be anonymous records buried within this anonymous union.
			*/
			
			CurSym = SymbolTable;
			_while( CurSym->Next != (yyvsp[(3) - (6)].ru.endFields) )

				CurSym->Offset += ofsDiff;
				CurSym = CurSym->Next;

			_endwhile
			CurSym->Offset += ofsDiff;
						
			// Create a dummy entry to mark the end of the
			// anonymous union in the symbol table dump.

			sprintf( endAnonUnion, "End Union %d", (yyvsp[(3) - (6)].ru.RecFieldCnt) );
			InsertSym
			( 
				hlastrdup2( endAnonUnion ),	// Name
				NULL,						// TYPE
				tAnonUnion,					// pType
				cVar,	 					// class
				0,							// Arity
				NULL,						// Dimensions
				0, 							// NumElements
				NULL,						// Value
				0,							// ObjectSize
				0,							// Offset
				NULL,						// StaticName
				NULL,						// Base
				NULL,						// Fields
				0							// FieldCnt
			);

			
			
			/*
			** Reset the compiler variables to their RECORD defaults.
			** Note this code does not restore these values
			** since we know that previously we were processing a
			** record.  That being the case, we can directly set them
			** here.  Note that we must add the size of the largest
			** object in the anonymous union to our offset at this
			** point so that the next record field skips past the
			** union data.
			*/

			CurOffsetDir = 1;
			AddOffset1st = 0;
			CurOffset = CurOffset + SizeOfUnion;
			
			/*
			** restore currentNS:
			*/
			
			currentNS = (yyvsp[(2) - (6)].ru.saveCurNS);
			RecNS = (yyvsp[(2) - (6)].ru.saveRecNS);
			RecGlobal = (yyvsp[(2) - (6)].ru.saveRecGlobal);
			_here;
		;}
    break;

  case 457:

/* Line 1464 of yacc.c  */
#line 12142 "hlaparse.bsn"
    {				/* $4 */
		
			char anonRec[ 256 ];
			
			_here;
			
			/*
			** Undo some of the effects of dorecordTkn that
			** we don't need for anonymous unions:
			*/
			
			SymbolTable = (yyvsp[(2) - (3)].ru.endFields);
			
			
			
			/*
			** Note: doRecordTkn has incremented the lex level.
			**		 We can't have this in nested records.  Correct
			**		 for that here.
			*/
			
			--CurLexLevel;
			
			/*
			** Assigning an offset to the start of the record
			** (e.g., "record :=8;") is illogical inside a
			** union, so we'll report an error if the user
			** has done this.
			*/
			
			_if( (yyvsp[(2) - (3)].ru.newOffset) )
			
				yyerror( "Cannot assign an offset to an anonymous record" );
				
			_endif
			
			// Since this is an anonymous record, pick up with the offset
			// of the whole union object:
			
			CurOffset = (yyvsp[(2) - (3)].ru.SaveOffset);
			CurOffsetDir = 1;	// Records have incrementing offsets.
			
			// Create a dummy entry to hold the size of the
			// record so we can compute the maximum size later.

			sprintf( anonRec, "Anon Record %d", LblCntr++ );
			InsertSym
			( 
				hlastrdup2( anonRec ),			// Name
				NULL,						// TYPE
				tAnonRec, 					// pType
				cVar,	 					// class
				0,							// Arity
				NULL,						// Dimensions
				0, 							// NumElements
				NULL,						// Value
				0,							// ObjectSize
				0,							// Offset
				NULL,						// StaticName
				NULL,						// Base
				NULL,						// Fields
				0							// FieldCnt
			);
			(yyval.ru.endFields) = SymbolTable;
			(yyval.ru.RecFieldCnt) = LblCntr - 1;
			_here;

		;}
    break;

  case 458:

/* Line 1464 of yacc.c  */
#line 12213 "hlaparse.bsn"
    {
			int				SizeOfRecord;
			int				StartOffset;
			SymNode_t		*CurSym;
			char			endAnonRec[ 256 ];

			_here;
			_if( RecFieldCnt == 0 )
			
				yyerror( "Anonymous records must have at least one field" );
				
			_endif

			/*
			** Note that we must add the number of fields in the
			** anonymous record to the field count for the union:
			** Note that the "+2" component adjusts for the two
			** anonymous record fields we added.
			*/
			
			RecFieldCnt = RecFieldCnt + (yyvsp[(2) - (7)].ru.RecFieldCnt) + 2;
			MinRecAlignment = (yyvsp[(2) - (7)].ru.MinRecAlignment);
			MaxRecAlignment = (yyvsp[(2) - (7)].ru.MaxRecAlignment);
			
			/*
			** Restore other values to their pre-record form:
			*/
			
			inRecord = (yyvsp[(2) - (7)].ru.inSave);

			
			
			/*
			** Original comment (which is not true):
			** We know that CurOffset started at zero for this
			** record (since it's buried in a union), therefore,
			** the current value of CurOffset is also the record's
			** size.  Record that value in the anon rec field we
			** created earlier.
			**
			** ---------------------
			**
			** if the anon record appears inside an anon union inside
			** another record, then the starting offset isn't zero.
			** so compute the size based on the starting and ending offsets.
			*/

			SizeOfRecord = CurOffset - (yyvsp[(2) - (7)].ru.SaveOffset);
			(yyvsp[(4) - (7)].ru.endFields)->ObjectSize = SizeOfRecord; 
			
			/*
			** If there was an align at the end of the
			** record, then we need to extend the size
			** of the record so that it is aligned on
			** the specified boundary.
			*/

			_if( TempRecAlign != 1 )
			

				SizeOfRecord = 
						(
								(SizeOfRecord + TempRecAlign - 1)
							/	TempRecAlign
						) * TempRecAlign; 
						
				TempRecAlign = 1;

			_endif
			

			/*
			** If there were no fields present in the anonymous
			** record, complain about this.  By happenstance, the
			** size of the union will wind up being zero, so this
			** has no deterimental effect on the union being
			** created.
			*/

			_if( RecFieldCnt == 0 )

				ErrorNear
				( 
					"Records must have at least one field",
					"endrecord",
					__LINE__,
					__FILE__ 
				);

			_endif



			// Create a dummy entry to mark the end of the
			// anonymous record in the symbol table dump.

			sprintf( endAnonRec, "End Record %d", (yyvsp[(4) - (7)].ru.RecFieldCnt) );
			InsertSym
			( 
				hlastrdup2( endAnonRec ),	// Name
				NULL,						// TYPE
				tAnonRec, 					// pType
				cVar,	 					// class
				0,							// Arity
				NULL,						// Dimensions
				0, 							// NumElements
				NULL,						// Value
				0,							// ObjectSize
				0,							// Offset
				NULL,						// StaticName
				NULL,						// Base
				NULL,						// Fields
				0							// FieldCnt
			);




			/*
			** Reset the compiler variables to their UNION defaults.
			** Note this code does not save and restore these values
			** since we know that previously we were processing a
			** union.  That being the case, we can directly set them
			** here.  Note that we must add the size of the largest
			** object in the anonymous union to our offset at this
			** point so that the next record field skips past the
			** union data.
			*/

			CurOffsetDir = 0;
			AddOffset1st = 0;
			CurOffset = (yyvsp[(2) - (7)].ru.SaveOffset);
			CurOffsetDir = 0;
			
			/*
			** Restore currentNS, etc:
			*/
			
			currentNS = (yyvsp[(2) - (7)].ru.saveCurNS);
			RecNS = (yyvsp[(2) - (7)].ru.saveRecNS);
			RecGlobal = (yyvsp[(2) - (7)].ru.saveRecGlobal);
			_here;
		;}
    break;

  case 461:

/* Line 1464 of yacc.c  */
#line 12374 "hlaparse.bsn"
    {
				_here;
				++RecFieldCnt;
			;}
    break;

  case 462:

/* Line 1464 of yacc.c  */
#line 12390 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(1) - (1)].idStr);
		;}
    break;

  case 463:

/* Line 1464 of yacc.c  */
#line 12396 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = hlastrdup2( (yyvsp[(2) - (2)].s)->TrueName );
		;}
    break;

  case 464:

/* Line 1464 of yacc.c  */
#line 12402 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(2) - (2)].idStr);
			HLAWarning
			( 
				"Attempted to override an undefined identifier", 
				(yyvsp[(2) - (2)].idStr), 
				__LINE__, 
				__FILE__ 
			);
		;}
    break;

  case 465:

/* Line 1464 of yacc.c  */
#line 12438 "hlaparse.bsn"
    {
				_here;
			;}
    break;

  case 466:

/* Line 1464 of yacc.c  */
#line 12458 "hlaparse.bsn"
    {				/* $8 */

			union YYSTYPE v;
			_here;
			
			_here;
			assert( (yyvsp[(1) - (7)].idStr) != NULL );
			assert( (yyvsp[(5) - (7)].idStr) != NULL );

			v.v.u.strval = (yyvsp[(1) - (7)].idStr);
			InsertSym
			( 
				(yyvsp[(5) - (7)].idStr), 
				&text_ste,
				tText, 
				cConstant, 
				0,				/* arity 			*/
				NULL,			/* NumDimensions	*/
				0, 				/* NumElements		*/
				YYS &v,
				4,				/* ObjectSize		*/
				0,
				NULL,
				NULL,			/* Base				*/
				NULL,			/* Fields			*/
				0				/* FieldCnt			*/ 
			);

			fastLookup = 1;

			_here;
		;}
    break;

  case 467:

/* Line 1464 of yacc.c  */
#line 12499 "hlaparse.bsn"
    {			/* $6 */
			_here;
			_if( IsNumber( (yyvsp[(3) - (5)].v.pType) ) && checkSmallUns( YYS &(yyvsp[(3) - (5)].v)) )

				TempRecAlign = (yyvsp[(3) - (5)].v.u.unsval);

			_else

				yyerror
				( 
					"Expected an integer constant here" 
				);

			_endif
			FreeValue( YYS &(yyvsp[(3) - (5)].v) );
			_here;
		;}
    break;

  case 468:

/* Line 1464 of yacc.c  */
#line 12546 "hlaparse.bsn"
    {				/* $6 */
			
				SymNode_t *saveSym;
				
				_here;
				assert( (yyvsp[(1) - (5)].idStr) != NULL );

				
				AlignTo
				( 
					(int *) &(yyvsp[(4) - (5)].v.u.intval), 
					MinRecAlignment, 
					MaxRecAlignment, 
					4 
				);
				InsertSym
				( 
					(yyvsp[(1) - (5)].idStr),
					NULL,			/* Type - Filled in later.		*/
					tProcptr, 		/* pType						*/
					cVar, 			/* SymClass						*/
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					NULL,			/* Initially, no initialization	*/
					4,				/* Object size					*/
					(yyvsp[(4) - (5)].v.u.intval),	/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);
				(yyval.s) = SymbolTable;

				CurOffset = StartParmOffs;
				++CurLexLevel;

				/*
				** Reinsert the symbol into the local symbols
				** to keep the logic of this program happy.
				*/

				saveSym = currentNS;	// Don't enter this symbol into
				currentNS = NULL;		//  a hash table.
				InsertSym
				( 
					(yyvsp[(1) - (5)].idStr),
					NULL, 
					tProcptr, 
					cVar, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
				currentNS = saveSym;

				/*
				** Temporary assignment so we can patch the local
				** entry later.
				*/

				(yyval.s)->u.proc.parms = SymbolTable;
				_here;

			;}
    break;

  case 469:

/* Line 1464 of yacc.c  */
#line 12629 "hlaparse.bsn"
    {				/* $10 */
				SymNode_t *saveST;
				SymNode_t *s;

				_here;
				--CurLexLevel;				
				CurOffset = (yyvsp[(4) - (9)].v.u.intval);
				CurOffsetDir = (yyvsp[(5) - (9)].v.u.unsval);
				CheckLegalOptions
				( 
					(yyvsp[(9) - (9)].options.SpecifiedOptions),
						specified_returns
					|	specified_use
					|	specified_pascal
					|	specified_stdcall
					|	specified_cdecl
					|	specified_alignment 
					|	specified_nostorage 
				);
				
				saveST = SymbolTable;
				s =
					InsertSym
					( 
						" (ProcPtrType) ",
						NULL,			/* Primitive Type.				*/
						tProcptr, 		/* pType						*/
						cVar, 			/* SymClass						*/
						0,				/* Arity						*/
						NULL,			/* Dimensions					*/
						0, 				/* NumElements					*/
						NULL,			/* Initially, no initialization	*/
						4,				/* Object size					*/
						0,				/* Offset						*/
						NULL,			/* Static Name					*/
						NULL,			/* Base							*/
						NULL,			/* Fields						*/
						0				/* FieldCnt						*/
					);
					
				s->u.proc.parms = saveST;
				s->u.proc.Locals = NULL;
				s->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
				s->u.proc.use = (yyvsp[(9) - (9)].options.use);
				s->u.proc.cs = (yyvsp[(9) - (9)].options.CallingSequence);
				
				// Remove the dummy type we just created from the record:
				
				SymbolTable = saveST;
				
				// Fill in the original procptr fields:
				
				(yyvsp[(6) - (9)].s)->u.proc.parms->Type = s;
				(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.parms = saveST;
				(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.returns = hlastrdup2( "" );
				(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.use = NULL;
				(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.Locals = NULL;

				(yyvsp[(6) - (9)].s)->Type = s;
				(yyvsp[(6) - (9)].s)->u.proc.parms = saveST;
				(yyvsp[(6) - (9)].s)->u.proc.Locals = NULL;
				(yyvsp[(6) - (9)].s)->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
				(yyvsp[(6) - (9)].s)->u.proc.use = (yyvsp[(9) - (9)].options.use);
				(yyvsp[(6) - (9)].s)->u.proc.cs = (yyvsp[(9) - (9)].options.CallingSequence);
				SymbolTable = (yyvsp[(6) - (9)].s);
				
				_if( !(yyvsp[(9) - (9)].options.NoStorage) )
				
					CurOffset += 4 * CurOffsetDir;
					
				_endif
				
				_here;

				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
			;}
    break;

  case 470:

/* Line 1464 of yacc.c  */
#line 12725 "hlaparse.bsn"
    {				/* $7 */
			
			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );
			
			AlignTo
			( 
				&CurOffset, 
				MinRecAlignment, 
				MaxRecAlignment, 
				4 
			);
			
			CreatePtrToProc( (yyvsp[(1) - (6)].idStr), (yyvsp[(6) - (6)].s), NULL, cVar );
			_here;
				
		;}
    break;

  case 471:

/* Line 1464 of yacc.c  */
#line 12744 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(9) - (9)].options.SpecifiedOptions),
					specified_nostorage
			);
			_if( !(yyvsp[(9) - (9)].options.NoStorage) )
			
				CurOffset += 4 * CurOffsetDir;
				
			_endif

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;
		;}
    break;

  case 472:

/* Line 1464 of yacc.c  */
#line 12779 "hlaparse.bsn"
    {					/* $6 */

				SymNode_t	*BaseType;

			
				assert( (yyvsp[(1) - (5)].idStr) != NULL );
				assert( (yyvsp[(5) - (5)].neID.idStr) != NULL );

				_here;
				BaseType = (yyvsp[(5) - (5)].neID.s);
				_if( BaseType != NULL )

					BaseType = GetBaseType( BaseType );
					_if( CantBeVar( BaseType->pType ))

						yyerror( "Fields cannot be this type" );
						BaseType = &uns32_ste;

					_endif

				_endif

				AlignTo
				( 
					&CurOffset, 
					MinRecAlignment, 
					MaxRecAlignment, 
					4 
				);
				InsertSym
				( 
					(yyvsp[(1) - (5)].idStr),			/* Name			*/
					&pointer_ste,		/* Type			*/
					tPointer, 			/* pType		*/
					cVar,				/* SymClass		*/
					0,					/* Arity		*/
					NULL,				/* Dimensions	*/
					0, 					/* NumElements	*/
					NULL,				/* Value		*/
					4,					/* ObjectSize	*/
					CurOffset,			/* Offset		*/
					NULL,				/* StaticName	*/
					BaseType,			/* BaseType		*/
					NULL,				/* Fields		*/
					0					/* FieldCnt		*/
				);
				_if( BaseType == NULL )

					Add2PtrList( SymbolTable, (yyvsp[(5) - (5)].neID.idStr) );

				_endif
				_here;

			;}
    break;

  case 473:

/* Line 1464 of yacc.c  */
#line 12835 "hlaparse.bsn"
    {
				/*
				** If processing records, unions, parameters, etc.
				*/

				_here;
				CheckLegalOptions
				( 
					(yyvsp[(8) - (8)].options.SpecifiedOptions),
						specified_nostorage 
				);
				_if( !(yyvsp[(8) - (8)].options.NoStorage) )
				
					CurOffset += 4 * CurOffsetDir;
					
				_endif

				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				_here;

			;}
    break;

  case 474:

/* Line 1464 of yacc.c  */
#line 12871 "hlaparse.bsn"
    {					/* $6 */

				_here;
				assert( (yyvsp[(1) - (5)].idStr) != NULL );
				AlignTo
				( 
					&CurOffset, 
					MinRecAlignment, 
					MaxRecAlignment, 
					4 
				);
				InsertSym
				( 
					(yyvsp[(1) - (5)].idStr),			/* Name			*/
					&pointer_ste,		/* Type			*/
					tPointer, 			/* pType		*/
					cVar,				/* SymClass		*/
					0,					/* Arity		*/
					NULL,				/* Dimensions	*/
					0, 					/* NumElements	*/
					NULL,				/* Value		*/
					4,					/* ObjectSize	*/
					CurOffset,			/* Offset		*/
					NULL,				/* StaticName	*/
					(yyvsp[(5) - (5)].s),				/* BaseType		*/
					NULL,				/* Fields		*/
					0					/* FieldCnt		*/
				);
				_here;

			;}
    break;

  case 475:

/* Line 1464 of yacc.c  */
#line 12904 "hlaparse.bsn"
    {
				_here;
				CheckLegalOptions
				( 
					(yyvsp[(8) - (8)].options.SpecifiedOptions),
						specified_nostorage 
				);
				_if( !(yyvsp[(8) - (8)].options.NoStorage) )

					CurOffset += 4 * CurOffsetDir;

				_endif
				
				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				_here;
			;}
    break;

  case 476:

/* Line 1464 of yacc.c  */
#line 12938 "hlaparse.bsn"
    {					/* $4 */
			
				_here;
				assert( (yyvsp[(1) - (3)].idStr) != NULL );
				assert( (yyvsp[(3) - (3)].s) != NULL );
				
				_if( CantBeVar((yyvsp[(3) - (3)].s)->pType ))

					yyerror( "Variables cannot be this type" );

				_else
				
					AlignTo
					( 
						&CurOffset, 
						MinRecAlignment, 
						MaxRecAlignment, 
						min( (yyvsp[(3) - (3)].s)->ObjectSize, 16 ) 
					);
					InsertSym
					( 
						(yyvsp[(1) - (3)].idStr), 
										/* 3/7/00
										GetBaseType( $<s>3 ),
										*/
						(yyvsp[(3) - (3)].s),
						(yyvsp[(3) - (3)].s)->pType, 
						cVar, 
						(yyvsp[(3) - (3)].s)->Arity,
						(yyvsp[(3) - (3)].s)->Dimensions,
						(yyvsp[(3) - (3)].s)->NumElements, 
						NULL,
						(yyvsp[(3) - (3)].s)->ObjectSize,
						CurOffset,
						NULL,
						(yyvsp[(3) - (3)].s)->Base,
						(yyvsp[(3) - (3)].s)->Fields,
						(yyvsp[(3) - (3)].s)->FieldCnt
					);
					SymbolTable->MaxObjectSize = (yyvsp[(3) - (3)].s)->MaxObjectSize;

					/*
					** If this is a class object, we need to duplicate
					** all the fields to all private constants, etc.
					*/

					_if( (yyvsp[(3) - (3)].s)->pType == tClass )

						SymbolTable->Fields = 
							CopySymbols
							( 
								(yyvsp[(3) - (3)].s)->Fields,
								(yyvsp[(3) - (3)].s)->StaticName
							);
						NullTerminate( SymbolTable->Fields, SymbolTable );

					_elseif(  (yyvsp[(3) - (3)].s)->pType == tThunk )

						/*
						** Need some dummy local vars for a thunk.
						*/

						SymbolTable->u.proc.parms = &true_ste;


					_endif

					/*
					** If the type is a pointer type, we need to check
					** to see if there was a forward reference so we
					** can eventually patch the "Base" field.
					*/

					_if( (yyvsp[(3) - (3)].s)->pType == tPointer && (yyvsp[(3) - (3)].s)->Base == NULL )

						struct PatchListType *pbl;

						pbl = malloc2( sizeofPatchListType );
						
						pbl->Next = PatchBaseList;
						pbl->Symbol = SymbolTable;
						PatchBaseList = pbl;

						SymbolTable->Type = (yyvsp[(3) - (3)].s);	/* so we can patch later */

					_endif

				_endif
				_here;

			;}
    break;

  case 477:

/* Line 1464 of yacc.c  */
#line 13031 "hlaparse.bsn"
    {
				_here;
				CheckLegalOptions
				( 
					(yyvsp[(6) - (6)].options.SpecifiedOptions),
						specified_nostorage 
				);
				_if( !(yyvsp[(6) - (6)].options.NoStorage) )
					
					CurOffset += (yyvsp[(3) - (6)].s)->ObjectSize * CurOffsetDir;
					
				_endif
				
				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				_here;
			;}
    break;

  case 478:

/* Line 1464 of yacc.c  */
#line 13069 "hlaparse.bsn"
    {					/* $7 */
			
				int	*DimensionArray;

				_here;
				assert( (yyvsp[(1) - (6)].idStr) != NULL );
				assert( (yyvsp[(3) - (6)].s) != NULL );
				assert( (yyvsp[(5) - (6)].v.Dimensions) != NULL );

				_if( (yyvsp[(5) - (6)].v.NumElements) <= 0 )
				
					yyerror( "Array declaration must have at least one element" );
					(yyvsp[(5) - (6)].v.NumElements) = 1;
				
				_endif
				
				/*
				** Make sure this is a legal variable type
				** (e.g., no text variables).
				*/

				_if( CantBeVar( (yyvsp[(3) - (6)].s)->pType ))
				
					yyerror( "Illegal variable type" );
					
				_else 
				
					/*
					** Check to see if TypeID is an array type
					** (i.e., we're creating a multi-dimensional array).
					*/

					_if( (yyvsp[(3) - (6)].s)->pType != tArray )

						/*
						** TypeID is *not* an array type, so create
						** a single dimension array here.
						*/

						(yyval.i) = (yyvsp[(3) - (6)].s)->ObjectSize * (yyvsp[(5) - (6)].v.NumElements);

						AlignTo
						( 
							&CurOffset, 
							MinRecAlignment, 
							MaxRecAlignment, 
							min( (yyvsp[(3) - (6)].s)->ObjectSize, 16 ) 
						);
						InsertSym
						( 
							(yyvsp[(1) - (6)].idStr), 
											/* 3/7/00
											GetBaseType( $<s>3 ),
											*/
							(yyvsp[(3) - (6)].s),
							tArray, 
							cVar, 
							(yyvsp[(5) - (6)].v.Arity),
							(yyvsp[(5) - (6)].v.Dimensions),
							(yyvsp[(5) - (6)].v.NumElements), 
							NULL,
							(yyval.i),
							CurOffset,
							NULL,
							(yyvsp[(3) - (6)].s)->Base,
							(yyvsp[(3) - (6)].s)->Fields,
							(yyvsp[(3) - (6)].s)->FieldCnt
						);
						
						/*
						** For arrays, the MaxObjectSize (used for alignment)
						** value must be the MaxObjectSize of an element.
						*/
						
						SymbolTable->MaxObjectSize = (yyvsp[(3) - (6)].s)->MaxObjectSize;
						

						/*
						** If this is a class object, we need to duplicate
						** all the fields to all private constants, etc.
						*/

						_if( (yyvsp[(3) - (6)].s)->pType == tClass )

							SymbolTable->Fields = 
								CopySymbols
								( 
									(yyvsp[(3) - (6)].s)->Fields,
									(yyvsp[(3) - (6)].s)->StaticName
								);
							NullTerminate( SymbolTable->Fields, SymbolTable );

						_elseif(  (yyvsp[(3) - (6)].s)->pType == tThunk )

							/*
							** Need some dummy local vars for a thunk.
							*/

							SymbolTable->u.proc.parms = &true_ste;


						_endif

						/*
						** If the type is a pointer type, we need to check
						** to see if there was a forward reference so we
						** can eventually patch the "Base" field.
						*/

						_if( (yyvsp[(3) - (6)].s)->pType == tPointer && (yyvsp[(3) - (6)].s)->Base == NULL )

							struct PatchListType *pbl;

							pbl = malloc2( sizeofPatchListType );
							
							pbl->Next = PatchBaseList;
							pbl->Symbol = SymbolTable;
							PatchBaseList = pbl;

							/*
							** So we can patch later:
							*/

							SymbolTable->Type = (yyvsp[(3) - (6)].s);	

						_endif



					/*
					** Okay, down here TypeID *is* an array type,
					** so we're creating a multi-dimensional array.
					*/

					_else

						assert( (yyvsp[(3) - (6)].s)->Dimensions != NULL );

						/*
						** Create the new dimension array by concatenating
						** the two existing dimension arrays.
						*/

						DimensionArray = 
							malloc2
							( 
								( (yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.NumElements) ) * 
									sizeofInt 
							);


						memcpy
						( 
							DimensionArray, 
							(yyvsp[(3) - (6)].s)->Dimensions, 
							(yyvsp[(3) - (6)].s)->Arity * sizeofInt 
						);
						memcpy
						(
							&DimensionArray[ (yyvsp[(3) - (6)].s)->Arity ],
							(yyvsp[(5) - (6)].v.Dimensions),
							(yyvsp[(5) - (6)].v.Arity) * sizeofInt 
						);
						(yyval.i) = (yyvsp[(3) - (6)].s)->ObjectSize * (yyvsp[(5) - (6)].v.NumElements);

						AlignTo
						( 
							&CurOffset, 
							MinRecAlignment, 
							MaxRecAlignment, 
							min( (yyvsp[(3) - (6)].s)->ObjectSize, 16 ) 
						);
						InsertSym
						( 
							(yyvsp[(1) - (6)].idStr), 
											/* 3/7/00
											GetBaseType( $<s>3 ),
											*/
							(yyvsp[(3) - (6)].s),
							tArray, 
							cVar, 
							(yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.Arity),
							DimensionArray,
							(yyvsp[(3) - (6)].s)->NumElements * (yyvsp[(5) - (6)].v.NumElements), 
							NULL,
							(yyval.i),
							CurOffset,
							NULL,
							(yyvsp[(3) - (6)].s)->Base,
							(yyvsp[(3) - (6)].s)->Fields,
							(yyvsp[(3) - (6)].s)->FieldCnt
						);

						/*
						** If this is a class object, we need to duplicate
						** all the fields to all private constants, etc.
						*/

						_if( (yyvsp[(3) - (6)].s)->pType == tClass )

							SymbolTable->Fields = 
								CopySymbols
								( 
									(yyvsp[(3) - (6)].s)->Fields,
									(yyvsp[(3) - (6)].s)->StaticName
								);
							NullTerminate( SymbolTable->Fields, SymbolTable );

						_elseif(  (yyvsp[(3) - (6)].s)->pType == tThunk )

							/*
							** Need some dummy local vars for a thunk.
							*/

							SymbolTable->u.proc.parms = &true_ste;

						_endif


						free2( vss (yyvsp[(5) - (6)].v.Dimensions) );

					_endif

				_endif
				_here;
			;}
    break;

  case 479:

/* Line 1464 of yacc.c  */
#line 13297 "hlaparse.bsn"
    {
				_here;
				CheckLegalOptions
				( 
					(yyvsp[(9) - (9)].options.SpecifiedOptions),
						specified_nostorage 
				);
				_if( !(yyvsp[(9) - (9)].options.NoStorage) )
				
					CurOffset += (yyvsp[(7) - (9)].i) * CurOffsetDir;
					
				_endif
				
				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				_here;
			;}
    break;

  case 480:

/* Line 1464 of yacc.c  */
#line 13339 "hlaparse.bsn"
    {				/* $9  */
			
				SymNode_t *Fields;
				SymNode_t *CurSym;
				int		  RecSize;
				int		  FieldCnt;
				int		  LargestField;

				_here;
				
				/*
				** Restore currentNS before we enter this record
				** type into the symbol table.
				*/
				
				currentNS = (yyvsp[(3) - (8)].ru.saveCurNS);
				RecNS = (yyvsp[(3) - (8)].ru.saveRecNS);
				RecGlobal = (yyvsp[(3) - (8)].ru.saveRecGlobal);

				/*
				** If RecFieldCnt is zero at this point then there
				** weren't any fields in the record.  Records must
				** have at least one field.
				*/

				_if( RecFieldCnt != 0 )

					/*
					** If there is no base record, we need to mark
					** the end of the fields symbol list.  If there is
					** a base record, then that base record definition will
					** mark the end of our list.  In either case, we
					** need to count the number of fields in the record.
					**
					** While we're traversing the fields, also compute
					** the size of the largest field (for alignment
					** purposes).
					*/
					
					FieldCnt = 0;
					LargestField = 0;
					CurSym = SymbolTable;
					_while
					( 
							CurSym->Next != NULL 
						&&	CurSym->Next != &dummyField_ste 
					)

						++FieldCnt;
						
						LargestField = 
							max( LargestField, CurSym->MaxObjectSize);
						
						CurSym = CurSym->Next;

					_endwhile
					LargestField = 
						max( LargestField, CurSym->MaxObjectSize);
				
					CurSym->Next = NULL;

					/*
					** Okay, create the record symbol table entry
					** and attach the fields symbol table to that entry.
					*/

					CurLexLevel = (yyvsp[(3) - (8)].ru.SaveLex);	
					Fields = SymbolTable;			
					SymbolTable = (yyvsp[(3) - (8)].ru.endFields);		
					RecSize = CurOffset - (yyvsp[(3) - (8)].ru.CurOffset);
					
					/*
					** If there was an align at the end of the
					** record, then we need to extend the size
					** of the record so that it is aligned on
					** the specified boundary.
					*/

					_if( TempRecAlign != 1 )
					

						RecSize = 
								(

										(RecSize + TempRecAlign - 1) 
									/ 	TempRecAlign 
								) * TempRecAlign;
								
						TempRecAlign = 1;

					_endif
					
					
					
					CurOffset = (yyvsp[(3) - (8)].ru.SaveOffset);		
					CurOffsetDir = (yyvsp[(3) - (8)].ru.SaveDir);	
					AddOffset1st = (yyvsp[(3) - (8)].ru.SaveAdd1st);	

					/*
					** Okay, insert the record symbol into the symbol table
					*/

					MinRecAlignment = (yyvsp[(3) - (8)].ru.MinRecAlignment);
					MaxRecAlignment = (yyvsp[(3) - (8)].ru.MaxRecAlignment);
					AlignTo
					( 
						&CurOffset, 
						MinRecAlignment, 
						MaxRecAlignment, 
						min( LargestField, 16 ) 
					);
					InsertSym
					(
						(yyvsp[(1) - (8)].idStr),
						NULL,
						tRecord,
						cVar,
						0,
						NULL,
						0,
						NULL,
						RecSize,
						CurOffset,
						NULL,
						(yyvsp[(3) - (8)].ru.base),
						Fields,
						FieldCnt
					);
					SymbolTable->MaxObjectSize = LargestField;
					CurOffset += RecSize * CurOffsetDir;

				_else

					yyerror
					( 
						"Record variables must have at least one field" 
					);

				_endif
				MinRecAlignment = (yyvsp[(3) - (8)].ru.MinRecAlignment);
				MaxRecAlignment = (yyvsp[(3) - (8)].ru.MaxRecAlignment);
				inRecord = (yyvsp[(3) - (8)].ru.inSave);

				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				_here;
			;}
    break;

  case 481:

/* Line 1464 of yacc.c  */
#line 13517 "hlaparse.bsn"
    {
				int				SizeOfUnion;
				int				FieldCnt;
				SymNode_t		*Fields;
				SymNode_t		*CurSym;
				SymNode_t		*LastSym;

				_here;
				
				/*
				** Restore currentNS before we enter this union
				** type into the symbol table.
				*/
				
				currentNS = (yyvsp[(3) - (6)].ru.saveCurNS);
				RecNS = (yyvsp[(3) - (6)].ru.saveRecNS);
				RecGlobal = (yyvsp[(3) - (6)].ru.saveRecGlobal);

				/*
				** Determine if there were any fields in the union.
				** Error if not.
				*/

				_if( RecFieldCnt == 0 )

					ErrorNear
					( 
						"Unions must have at least one field",
						"endunion",
						__LINE__,
						__FILE__ 
					);

				_else

					/*
					** Null terminate the list of fields in the union.
					** Search for the saved symbol table entry which
					** marks the first entry that is not a field.  Upon
					** finding that entry, store a NULL in the previous
					** link field.
					*/

					CurSym = SymbolTable;
					SizeOfUnion = 0;
					FieldCnt = 0;
					_while
					( 
							CurSym->Next != NULL 
						&&	CurSym->Next != &dummyField_ste 
					)					

						SizeOfUnion = 
							max( SizeOfUnion, CurSym->ObjectSize);
						
						_if( CurSym->pType != tAnonRec )
						
							++FieldCnt;
							
						_endif
						CurSym = CurSym->Next;

					_endwhile
					CurSym->Next = NULL;
					_if( CurSym->pType != tAnonRec )
					
						++FieldCnt;
					
					_endif
					SizeOfUnion = 
						max( SizeOfUnion, CurSym->ObjectSize);
				


					/*
					** Restore all the compiler variables and set
					** up Fields so we can enter the union variable
					** into the symbol table.
					*/

					CurLexLevel = (yyvsp[(3) - (6)].ru.SaveLex);
					Fields = SymbolTable;
					SymbolTable = (yyvsp[(3) - (6)].ru.endFields);
					CurOffset = (yyvsp[(3) - (6)].ru.SaveOffset);
					CurOffsetDir = (yyvsp[(3) - (6)].ru.SaveDir);
					AddOffset1st = (yyvsp[(3) - (6)].ru.SaveAdd1st);

					/*
					** Okay, create the union symbol table entry
					** and attach the fields symbol table to that entry.
					*/

					AlignTo
					( 
						&CurOffset, 
						MinRecAlignment, 
						MaxRecAlignment, 
						min( SizeOfUnion, 16 ) 
					);
					InsertSym
					(
						(yyvsp[(1) - (6)].idStr),
						NULL,
						tUnion,
						cVar,
						0,
						NULL,
						0,
						NULL,
						SizeOfUnion,
						CurOffset,
						NULL,
						NULL,
						Fields,
						FieldCnt
					);
					CurOffset += SizeOfUnion * CurOffsetDir;

				_endif

				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				_here;
			;}
    break;

  case 482:

/* Line 1464 of yacc.c  */
#line 13659 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Duplicate symbol definition", 
				(yyvsp[(1) - (6)].s)->TrueName,
				__LINE__,
				__FILE__ 
			);
			exit( 1 );

		;}
    break;

  case 483:

/* Line 1464 of yacc.c  */
#line 13680 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Duplicate symbol definition", 
				(yyvsp[(1) - (7)].s)->TrueName,
				__LINE__,
				__FILE__ 
			);
			exit( 1 );

		;}
    break;

  case 484:

/* Line 1464 of yacc.c  */
#line 13698 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Duplicate symbol definition", 
				(yyvsp[(1) - (4)].s)->TrueName,
				__LINE__,
				__FILE__ 
			);
			exit( 1 );
			
		;}
    break;

  case 485:

/* Line 1464 of yacc.c  */
#line 13719 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Duplicate symbol definition", 
				(yyvsp[(1) - (7)].s)->TrueName,
				__LINE__,
				__FILE__ 
			);
			exit( 1 );

		;}
    break;

  case 486:

/* Line 1464 of yacc.c  */
#line 13740 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Undefined symbol", 
				(yyvsp[(3) - (7)].idStr),
				__LINE__,
				__FILE__ 
			);
			exit( 1 );

		;}
    break;

  case 487:

/* Line 1464 of yacc.c  */
#line 13758 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Undefined symbol", 
				(yyvsp[(3) - (4)].idStr),
				__LINE__,
				__FILE__ 
			);
			exit( 1 );

		;}
    break;

  case 488:

/* Line 1464 of yacc.c  */
#line 13773 "hlaparse.bsn"
    {
			_here;
			exit( 1 );
		;}
    break;

  case 489:

/* Line 1464 of yacc.c  */
#line 13807 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = NULL;
		;}
    break;

  case 490:

/* Line 1464 of yacc.c  */
#line 13813 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 491:

/* Line 1464 of yacc.c  */
#line 13823 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(2) - (3)].returns);
		;}
    break;

  case 492:

/* Line 1464 of yacc.c  */
#line 13832 "hlaparse.bsn"
    {
				_here;
				(yyval.returns) = hlastrdup2( "" );
				_here;
			;}
    break;

  case 493:

/* Line 1464 of yacc.c  */
#line 13842 "hlaparse.bsn"
    {			/* $4 */
				_here;
				_if
				( 
						(yyvsp[(2) - (3)].v.pType) != tString 
					&&	(yyvsp[(2) - (3)].v.pType) != tZString 
				)

					yyerror( "Expected a string constant" );
					(yyval.returns) = hlastrdup2( "" );

				_else

					(yyval.returns) = (yyvsp[(2) - (3)].v.u.strval);

				_endif
				_here;
			;}
    break;

  case 494:

/* Line 1464 of yacc.c  */
#line 13874 "hlaparse.bsn"
    {
			char 		StaticName[ 256 ];
			char 		*sn;
			SymNode_t	*saveNS;

			_here;
			assert( (yyvsp[(-4) - (0)].idStr) != NULL );

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-4) - (0)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );
			InsertSym
			( 
				(yyvsp[(-4) - (0)].idStr),
				&proctype_ste,
				tProcptr, 
				cStatic, 
				0,
				NULL,
				0, 
				NULL,
				4,
				0,
				sn,
				NULL,
				NULL,
				0
			);

			(yyval.s) = SymbolTable;
			CurOffset = StartParmOffs;
			++CurLexLevel;

			/*
			** Reinsert the symbol into the local symbols
			** to keep the logic of this program happy.
			** If in a namespace, don't insert this symbol
			** into the hash table.
			*/

			saveNS = currentNS;
			currentNS = NULL;
			InsertSym
			( 
				(yyvsp[(-4) - (0)].idStr),
				&proctype_ste,
				tProcptr, 
				cStatic, 
				0,
				NULL,
				0, 
				NULL,
				4,
				0,
				sn,
				NULL,
				NULL,
				0
			);
			currentNS = saveNS;

			/*
			** Temporary assignment so we can patch the local
			** entry later.
			*/

			(yyval.s)->u.proc.parms = SymbolTable;
			_here;

		;}
    break;

  case 495:

/* Line 1464 of yacc.c  */
#line 13953 "hlaparse.bsn"
    {
				char StaticName[ 256 ];
				char *sn;

				_here;
				assert( (yyvsp[(-2) - (0)].idStr) != NULL );

				sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-2) - (0)].idStr), LblCntr++ );
				sn = hlastrdup2( StaticName );
				InsertSym
				( 
					(yyvsp[(-2) - (0)].idStr), 
					NULL,
					tEnum, 
					cStatic, 
					0,
					NULL,
					0, 
					NULL,
					EnumSize,
					0,
					sn,
					NULL,
					NULL,
					0
				);

				/*
				** Initialize EnumVal to zero so we can assign
				** successive values to the following named constants.
				*/

				EnumVal = 0;

				/*
				** Return pointer to symbol table entry as result.
				*/

				(yyval.s) = SymbolTable;
				_here;

			;}
    break;

  case 496:

/* Line 1464 of yacc.c  */
#line 14006 "hlaparse.bsn"
    {
				/*
				** Set up an inherited attribute for EnumList.
				** This must be the address of the variable symbol
				** table entry created above.
				*/

				(yyval.v.Type) = SymbolTable;
				_here;
			;}
    break;

  case 497:

/* Line 1464 of yacc.c  */
#line 14067 "hlaparse.bsn"
    {
			SymNode_t v;
			SymNode_t *s;

			_here;
			
			// Restore currentNS before entering the symbol
			// into the symbol table.
			
			currentNS = (yyvsp[(4) - (11)].s);

			#define ptr(p,prev) _ifx((p)!=(prev),p,NULL)

			/*
			** Initialize the regex data for the macro
			** symbol table entry.
			*/

			v.u.MacroData.Text = (yyvsp[(10) - (11)].m.Text);
			v.u.MacroData.Parameters = ptr((yyvsp[(5) - (11)].s),(yyvsp[(3) - (11)].s));
			v.u.MacroData.Locals = ptr((yyvsp[(7) - (11)].s),(yyvsp[(5) - (11)].s));
			v.u.MacroData.Terminator = NULL;
			v.u.MacroData.NameSpace = NULL;
			v.u.MacroData.LineCnt = (yyvsp[(8) - (11)].v.u.unsval);
			v.u.MacroData.Filename = 	hlastrdup2( FileName );

			/*
			** If there are parameters or local symbols, null
			** terminate the list of such symbols so they don't
			** point into the main symbol table.
			*/

			_if( (yyvsp[(7) - (11)].s) != (yyvsp[(3) - (11)].s) )

				s = (yyvsp[(7) - (11)].s);
				_while( s->Next != NULL && s->Next != (yyvsp[(3) - (11)].s) )

					s = s->Next;

				_endwhile
				s->Next = NULL;

			_endif
			SymbolTable = (yyvsp[(3) - (11)].s);

			/*
			** Insert the text for the regex into
			** the symbol table.
			*/
			assert( (yyvsp[(2) - (11)].idStr) != NULL );
			InsertSym
			( 
				(yyvsp[(2) - (11)].idStr), 
				NULL,			/* No type associated with this symbol.	*/
				tRegexMac,		/* It's a regex.						*/
				cRegex, 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				YYS &v,			/* Ptr to macro's text.			*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				NULL,			/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);

			inRegex = 0;
			_here;
		;}
    break;

  case 498:

/* Line 1464 of yacc.c  */
#line 14152 "hlaparse.bsn"
    { 
			_here;
			doRecRegex();
		;}
    break;

  case 499:

/* Line 1464 of yacc.c  */
#line 14166 "hlaparse.bsn"
    {
			// Tell the lexer to grab the #return
			// string and return it as a string constant.
			
			PushBackStr( "\xE1" );	
		;}
    break;

  case 500:

/* Line 1464 of yacc.c  */
#line 14181 "hlaparse.bsn"
    {
			_here;
			(yyval.v) = (yyvsp[(2) - (4)].v);
			(yyval.v.u.rx)->concat = (yyvsp[(3) - (4)].v.u.rx);
			(yyval.v.u.rx)->returns = hlastrdup( "" );
			inRegex = (yyvsp[(1) - (4)].u);
		;}
    break;

  case 501:

/* Line 1464 of yacc.c  */
#line 14201 "hlaparse.bsn"
    {
			_here;
			(yyval.v) = (yyvsp[(2) - (7)].v);
			(yyval.v.u.rx)->concat = (yyvsp[(3) - (7)].v.u.rx);

			_if( (yyvsp[(6) - (7)].v.pType) != tString && (yyvsp[(6) - (7)].v.pType) != tText )
			
				yyerror( "Expected a string expression after #return" );
				(yyval.v.u.rx)->returns = hlastrdup( "" );
				
			_else

				(yyval.v.u.rx)->returns = (yyvsp[(6) - (7)].v.u.strval);
				
			_endif
			inRegex = (yyvsp[(1) - (7)].u);
		;}
    break;

  case 502:

/* Line 1464 of yacc.c  */
#line 14229 "hlaparse.bsn"
    {
			// Mark the end of the regular expression list.
			
			_here;
			(yyval.v) = (yyvsp[(2) - (3)].v);
			(yyval.v.u.rx)->returns = hlastrdup( "" );
			inRegex = (yyvsp[(1) - (3)].u);
		;}
    break;

  case 503:

/* Line 1464 of yacc.c  */
#line 14248 "hlaparse.bsn"
    {
			// Mark the end of the regular expression list.
			
			_here;
			(yyval.v) = (yyvsp[(2) - (6)].v);
			(yyval.v.u.rx)->returns = (yyvsp[(5) - (6)].v.u.strval);
			inRegex = (yyvsp[(1) - (6)].u);
		;}
    break;

  case 504:

/* Line 1464 of yacc.c  */
#line 14260 "hlaparse.bsn"
    {
			(yyval.u) = inRegex;
		;}
    break;

  case 505:

/* Line 1464 of yacc.c  */
#line 14268 "hlaparse.bsn"
    {			
			_here;
			(yyval.v) = (yyvsp[(1) - (1)].v);
			inRegex = 1;
		;}
    break;

  case 506:

/* Line 1464 of yacc.c  */
#line 14276 "hlaparse.bsn"
    {
			struct regexListType *rxl;
			
			_here;
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			rxl = malloc2( sizeofRegexListType  );
			rxl->returns		= NULL;
			rxl->concat			= NULL;
			rxl->subexpr		= NULL;
			rxl->alt[0]			= NULL;
			rxl->alt[1]			= NULL;
			rxl->nodeType		= nt_StartOfRegex;
			rxl->minCnt			= 1;	// Default is one
			rxl->maxCnt			= 1;	//  copy of this item.
			rxl->id				= NULL;
			ClrConst( YYS &rxl->v, tRegex, &regex_ste );
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 507:

/* Line 1464 of yacc.c  */
#line 14306 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_if( (yyvsp[(2) - (2)].v.u.rx) != NULL )
			
				// $<v>2 is the alternation node.
				// We need to attach $1 to the alt[0] leg
				// of the alternation.
				
				(yyval.v) = (yyvsp[(2) - (2)].v);	// This is the "alternation" node.
				(yyval.v.u.rx)->alt[0] = (yyvsp[(1) - (2)].v.u.rx);
				
				
			_else // No alternation
			
				(yyval.v) = (yyvsp[(1) - (2)].v);
			
			_endif
			_here;
		;}
    break;

  case 508:

/* Line 1464 of yacc.c  */
#line 14339 "hlaparse.bsn"
    {
			// $2 is an extra node that holds the alternation value.
			
			(yyval.v) = (yyvsp[(2) - (3)].v);
			(yyval.v.u.rx)->nodeType = nt_Alternative;
			
			// The $3 regex is the alt[1] leg of the alternation:
			
			(yyval.v.u.rx)->alt[1] = (yyvsp[(3) - (3)].v.u.rx);
			_here;
		;}
    break;

  case 509:

/* Line 1464 of yacc.c  */
#line 14356 "hlaparse.bsn"
    {						/* $2 */
			_here;
			(yyval.v.u.rx) = NULL;
		;}
    break;

  case 510:

/* Line 1464 of yacc.c  */
#line 14373 "hlaparse.bsn"
    {
			_if( (yyvsp[(2) - (2)].v.u.rx) != NULL )
			
				// Must concatenate the expression of
				// "optionalConcat" to the end of #1:
				
				(yyval.v) = (yyvsp[(1) - (2)].v);
				(yyval.v.u.rx)->concat = (yyvsp[(2) - (2)].v.u.rx);
			
			_else // no concatenation
			
				(yyval.v) = (yyvsp[(1) - (2)].v);
				
			_endif
			_here;
		;}
    break;

  case 511:

/* Line 1464 of yacc.c  */
#line 14395 "hlaparse.bsn"
    {
			(yyval.v) = (yyvsp[(2) - (2)].v);
			_here;
		;}
    break;

  case 512:

/* Line 1464 of yacc.c  */
#line 14401 "hlaparse.bsn"
    {						/* $2 */
			_here;
			(yyval.v.u.rx) = NULL;
		;}
    break;

  case 513:

/* Line 1464 of yacc.c  */
#line 14418 "hlaparse.bsn"
    {
			// $2 holds the subexpression node.
			
			(yyval.v) = (yyvsp[(2) - (5)].v);
			(yyval.v.u.rx)->nodeType = nt_Subexpr;
			(yyval.v.u.rx)->subexpr = (yyvsp[(3) - (5)].v.u.rx);
			(yyval.v.u.rx)->minCnt = (yyvsp[(5) - (5)].ranges.minRange);	
			(yyval.v.u.rx)->maxCnt = (yyvsp[(5) - (5)].ranges.maxRange);
			(yyval.v.u.rx)->lazy = (yyvsp[(5) - (5)].ranges.lazy);
			_here;
		;}
    break;

  case 514:

/* Line 1464 of yacc.c  */
#line 14443 "hlaparse.bsn"
    {
			// $2 holds the subexpression node.
			
			(yyval.v) = (yyvsp[(3) - (6)].v);
			(yyval.v.u.rx)->nodeType = nt_match;
			(yyval.v.u.rx)->subexpr = (yyvsp[(4) - (6)].v.u.rx);
			(yyval.v.u.rx)->minCnt = (yyvsp[(6) - (6)].ranges.minRange);	
			(yyval.v.u.rx)->maxCnt = (yyvsp[(6) - (6)].ranges.maxRange);
			(yyval.v.u.rx)->lazy = (yyvsp[(6) - (6)].ranges.lazy);
			_here;
		;}
    break;

  case 515:

/* Line 1464 of yacc.c  */
#line 14468 "hlaparse.bsn"
    {
			// $2 holds the subexpression node.
			
			(yyval.v) = (yyvsp[(3) - (6)].v);
			(yyval.v.u.rx)->nodeType = nt_match2;
			(yyval.v.u.rx)->subexpr = (yyvsp[(4) - (6)].v.u.rx);
			(yyval.v.u.rx)->minCnt = (yyvsp[(6) - (6)].ranges.minRange);	
			(yyval.v.u.rx)->maxCnt = (yyvsp[(6) - (6)].ranges.maxRange);
			(yyval.v.u.rx)->lazy = (yyvsp[(6) - (6)].ranges.lazy);
			_here;
		;}
    break;

  case 516:

/* Line 1464 of yacc.c  */
#line 14489 "hlaparse.bsn"
    {
			_if( (yyvsp[(2) - (4)].v.pType) != tArray )
			
				yyerror( "Expected an array inside '[]'" );
			
			_elseif( (yyvsp[(2) - (4)].v.Type) == NULL || (yyvsp[(2) - (4)].v.Type)->pType != tString )
			
				yyerror( "Expected a string array inside '[]'" );
				
			_else
			
				// $4 holds the subexpression node.
				
				(yyval.v) = (yyvsp[(4) - (4)].v);
				(yyval.v.u.rx)->nodeType = nt_List;
				(yyval.v.u.rx)->v = (yyvsp[(2) - (4)].v);
				
			_endif
			_here;
		;}
    break;

  case 517:

/* Line 1464 of yacc.c  */
#line 14521 "hlaparse.bsn"
    {
			SymNode_t *s;
			
			s = (yyvsp[(6) - (6)].neID.s);
			_if( s != NULL )
			
				_if( s->SymClass != cValue )
				
					yyerror( "Expected a VAL object for string extraction ID" );
					
					// Create the symbol anyway, to prevent cascading errors:
					
					ClrNewSym
					(
						(yyvsp[(6) - (6)].neID.idStr),		// Name,
						&string_ste,   		// TheType
						tString,	   		// pType
						cValue,		   		// TheClass
						0,			   		// Arity
						NULL,		   		// Dimensions
						0,			   		// NumElements
						4,			   		// ObjectSize
						0,			   		// CurOffset
						NULL,		   		// StaticName
						NULL,		   		// Base
						NULL,		   		// Fields
						0,			   		// FieldCnt
						NULL,		   		// CurField
						0			   		// CurIndex
					);
					s = SymbolTable;
					
				_endif
				
			_else // If the symbol is undefined, create a new one
			
				ClrNewSym
				(
					(yyvsp[(6) - (6)].neID.idStr),		// Name,
					&string_ste,   		// TheType
					tString,	   		// pType
					cValue,		   		// TheClass
					0,			   		// Arity
					NULL,		   		// Dimensions
					0,			   		// NumElements
					4,			   		// ObjectSize
					0,			   		// CurOffset
					NULL,		   		// StaticName
					NULL,		   		// Base
					NULL,		   		// Fields
					0,			   		// FieldCnt
					NULL,		   		// CurField
					0			   		// CurIndex
				);
				s = SymbolTable;
			
			_endif
			
			// $2 holds the first half of the extraction node.
			// $7 holds the second half of the extraction node.
			
			(yyval.v) = (yyvsp[(2) - (6)].v);
			(yyval.v.u.rx)->nodeType = nt_ExtractStr;
			(yyval.v.u.rx)->id = s;
			(yyval.v.u.rx)->subexpr = (yyvsp[(3) - (6)].v.u.rx);
			_here;
		;}
    break;

  case 518:

/* Line 1464 of yacc.c  */
#line 14597 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(3) - (3)].v.u.rx);
			rxl->nodeType = nt_AnyChar;
			rxl->minCnt = (yyvsp[(2) - (3)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(2) - (3)].ranges.maxRange);
			rxl->lazy = (yyvsp[(2) - (3)].ranges.lazy);
			
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 519:

/* Line 1464 of yacc.c  */
#line 14627 "hlaparse.bsn"
    {
			_here;
			_if( !IsSmallNumber( (yyvsp[(2) - (3)].v.pType) ) || ((yyvsp[(2) - (3)].v.u.intval) < 0)  )
			
				yyerror( "Function expects a small unsigned integer argument" );
				FreeValue( YYS &(yyvsp[(2) - (3)].v) );
				(yyvsp[(2) - (3)].v.pType) = tUns32;
				(yyvsp[(2) - (3)].v.Type) = &uns32_ste;
				(yyvsp[(2) - (3)].v.u.lwordval)[0] = 1;
				(yyvsp[(2) - (3)].v.u.lwordval)[1] = 0;
				(yyvsp[(2) - (3)].v.u.lwordval)[2] = 0;
				(yyvsp[(2) - (3)].v.u.lwordval)[3] = 0;
				
			_endif
			(yyval.v) = (yyvsp[(2) - (3)].v);			
			_here;
				
		;}
    break;

  case 520:

/* Line 1464 of yacc.c  */
#line 14655 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(3) - (3)].v.u.rx);
			rxl->nodeType = nt_pos;
			rxl->minCnt = (yyvsp[(2) - (3)].v.u.unsval);	
			rxl->maxCnt = 0;
			rxl->lazy = 0;
			
			// Create a dummy pattern value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = 0;
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 521:

/* Line 1464 of yacc.c  */
#line 14688 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(3) - (3)].v.u.rx);
			rxl->nodeType = nt_tab;
			rxl->minCnt = (yyvsp[(2) - (3)].v.u.unsval);	
			rxl->maxCnt = 0;
			rxl->lazy = 0;
			
			// Create a dummy pattern value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = 0;
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 522:

/* Line 1464 of yacc.c  */
#line 14721 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(2) - (3)].v.pType) != tChar )
			
				yyerror( "@matchChar/@oneChar expects a char argument" );
				FreeValue( YYS &(yyvsp[(2) - (3)].v) );
				(yyvsp[(2) - (3)].v.pType) = tChar;
				(yyvsp[(2) - (3)].v.Type) = &char_ste;
				(yyvsp[(2) - (3)].v.u.charval) = ' ';
				
			_endif
			(yyval.v) = (yyvsp[(2) - (3)].v);			
			_here;
				
		;}
    break;

  case 523:

/* Line 1464 of yacc.c  */
#line 14745 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_Char;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(2) - (4)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 524:

/* Line 1464 of yacc.c  */
#line 14782 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(5) - (5)].v.u.rx);
			rxl->nodeType = nt_notChar;
			rxl->minCnt = (yyvsp[(4) - (5)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(4) - (5)].ranges.maxRange);
			rxl->lazy = (yyvsp[(4) - (5)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(3) - (5)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 525:

/* Line 1464 of yacc.c  */
#line 14818 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_iChar;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(2) - (4)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 526:

/* Line 1464 of yacc.c  */
#line 14855 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(5) - (5)].v.u.rx);
			rxl->nodeType = nt_notiChar;
			rxl->minCnt = (yyvsp[(4) - (5)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(4) - (5)].ranges.maxRange);
			rxl->lazy = (yyvsp[(4) - (5)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(3) - (5)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 527:

/* Line 1464 of yacc.c  */
#line 14889 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(3) - (3)].v.u.rx);
			rxl->nodeType = nt_Char;
			rxl->minCnt = (yyvsp[(2) - (3)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(2) - (3)].ranges.maxRange);
			rxl->lazy = (yyvsp[(2) - (3)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(1) - (3)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 528:

/* Line 1464 of yacc.c  */
#line 14924 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_notChar;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(2) - (4)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 529:

/* Line 1464 of yacc.c  */
#line 14962 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_iChar;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(2) - (4)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 530:

/* Line 1464 of yacc.c  */
#line 15001 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(5) - (5)].v.u.rx);
			rxl->nodeType = nt_notiChar;
			rxl->minCnt = (yyvsp[(4) - (5)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(4) - (5)].ranges.maxRange);
			rxl->lazy = (yyvsp[(4) - (5)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(3) - (5)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 531:

/* Line 1464 of yacc.c  */
#line 15030 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(5) - (5)].v.u.rx);
			rxl->nodeType = nt_notiChar;
			rxl->minCnt = (yyvsp[(4) - (5)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(4) - (5)].ranges.maxRange);
			rxl->lazy = (yyvsp[(4) - (5)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(3) - (5)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 532:

/* Line 1464 of yacc.c  */
#line 15067 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_peekChar;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(2) - (4)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 533:

/* Line 1464 of yacc.c  */
#line 15095 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_peekChar;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(2) - (4)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 534:

/* Line 1464 of yacc.c  */
#line 15132 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_peekiChar;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(2) - (4)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 535:

/* Line 1464 of yacc.c  */
#line 15161 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(5) - (5)].v.u.rx);
			rxl->nodeType = nt_peekiChar;
			rxl->minCnt = (yyvsp[(4) - (5)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(4) - (5)].ranges.maxRange);
			rxl->lazy = (yyvsp[(4) - (5)].ranges.lazy);
			
			// Save away the character value.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
			rxl->v.u.charval = (yyvsp[(3) - (5)].v.u.charval);
				
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 536:

/* Line 1464 of yacc.c  */
#line 15196 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(2) - (3)].v.pType) != tString )
			
				yyerror( "Function expects a string argument" );
				FreeValue( YYS &(yyvsp[(2) - (3)].v) );
				(yyvsp[(2) - (3)].v.pType) = tString;
				(yyvsp[(2) - (3)].v.Type) = &string_ste;
				(yyvsp[(2) - (3)].v.u.strval) = hlastrdup( "" );
				
			_endif
			(yyval.v) = (yyvsp[(2) - (3)].v);			
			_here;
				
		;}
    break;

  case 537:

/* Line 1464 of yacc.c  */
#line 15222 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_matchWord;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(2) - (4)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 538:

/* Line 1464 of yacc.c  */
#line 15256 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_matchiWord;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(2) - (4)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 539:

/* Line 1464 of yacc.c  */
#line 15291 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_String;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(2) - (4)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 540:

/* Line 1464 of yacc.c  */
#line 15324 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_iString;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(2) - (4)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 541:

/* Line 1464 of yacc.c  */
#line 15358 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(3) - (3)].v.u.rx);
			rxl->nodeType = nt_String;
			rxl->minCnt = (yyvsp[(2) - (3)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(2) - (3)].ranges.maxRange);
			rxl->lazy = (yyvsp[(2) - (3)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(1) - (3)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 542:

/* Line 1464 of yacc.c  */
#line 15392 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_iString;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(2) - (4)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 543:

/* Line 1464 of yacc.c  */
#line 15427 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(3) - (3)].v.u.rx);
			rxl->nodeType = nt_notString;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(2) - (3)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 544:

/* Line 1464 of yacc.c  */
#line 15459 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_notiString;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(3) - (4)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 545:

/* Line 1464 of yacc.c  */
#line 15486 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_notiString;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(3) - (4)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 546:

/* Line 1464 of yacc.c  */
#line 15522 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_peekStr;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(2) - (4)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 547:

/* Line 1464 of yacc.c  */
#line 15550 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_peekStr;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(2) - (4)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 548:

/* Line 1464 of yacc.c  */
#line 15587 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_peekiStr;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(2) - (4)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 549:

/* Line 1464 of yacc.c  */
#line 15616 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(5) - (5)].v.u.rx);
			rxl->nodeType = nt_peekiStr;
			rxl->minCnt = (yyvsp[(4) - (5)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(4) - (5)].ranges.maxRange);
			rxl->lazy = (yyvsp[(4) - (5)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tString, &string_ste );
			rxl->v.u.strval = (yyvsp[(3) - (5)].v.u.strval);	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 550:

/* Line 1464 of yacc.c  */
#line 15647 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(2) - (3)].v.pType) != tCset )
			
				yyerror( "@matchCset/@oneCset expects a cset argument" );
				FreeValue( YYS &(yyvsp[(2) - (3)].v) );
				(yyvsp[(2) - (3)].v.pType) = tCset;
				(yyvsp[(2) - (3)].v.Type) = &cset_ste;
				(yyvsp[(2) - (3)].v.u.lwordval)[0] = 0;
				(yyvsp[(2) - (3)].v.u.lwordval)[1] = 0;
				(yyvsp[(2) - (3)].v.u.lwordval)[2] = 0;
				(yyvsp[(2) - (3)].v.u.lwordval)[3] = 0;
				
			_endif
			(yyval.v) = (yyvsp[(2) - (3)].v);			
			_here;
				
		;}
    break;

  case 551:

/* Line 1464 of yacc.c  */
#line 15675 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_Cset;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tCset, &cset_ste );
			rxl->v.u.lwordval[0] = (yyvsp[(2) - (4)].v.u.lwordval)[0];	  
			rxl->v.u.lwordval[1] = (yyvsp[(2) - (4)].v.u.lwordval)[1];	  
			rxl->v.u.lwordval[2] = (yyvsp[(2) - (4)].v.u.lwordval)[2];	  
			rxl->v.u.lwordval[3] = (yyvsp[(2) - (4)].v.u.lwordval)[3];	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 552:

/* Line 1464 of yacc.c  */
#line 15711 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this as a cset object:
			
			rxl = (yyvsp[(3) - (3)].v.u.rx);
			rxl->nodeType = nt_Cset;
			rxl->minCnt = (yyvsp[(2) - (3)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(2) - (3)].ranges.maxRange);
			rxl->lazy = (yyvsp[(2) - (3)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
			memcpy( &rxl->v.u.csetval, (yyvsp[(1) - (3)].v.u.csetval), CSetSizeInBytes );			
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 553:

/* Line 1464 of yacc.c  */
#line 15746 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this as a cset object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_notCset;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
			memcpy( &rxl->v.u.csetval, (yyvsp[(2) - (4)].v.u.csetval), CSetSizeInBytes );			
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 554:

/* Line 1464 of yacc.c  */
#line 15780 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this guy as a string object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_peekCset;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tCset, &cset_ste );
			rxl->v.u.lwordval[0] = (yyvsp[(2) - (4)].v.u.lwordval)[0];	  
			rxl->v.u.lwordval[1] = (yyvsp[(2) - (4)].v.u.lwordval)[1];	  
			rxl->v.u.lwordval[2] = (yyvsp[(2) - (4)].v.u.lwordval)[2];	  
			rxl->v.u.lwordval[3] = (yyvsp[(2) - (4)].v.u.lwordval)[3];	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 555:

/* Line 1464 of yacc.c  */
#line 15811 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;

			// Store this as a cset object:
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_peekCset;
			rxl->minCnt = (yyvsp[(3) - (4)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(3) - (4)].ranges.maxRange);
			rxl->lazy = (yyvsp[(3) - (4)].ranges.lazy);
			
			ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
			memcpy( &rxl->v.u.csetval, (yyvsp[(2) - (4)].v.u.csetval), CSetSizeInBytes );			
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 556:

/* Line 1464 of yacc.c  */
#line 15847 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			// It's a char constant
			
			_if( (yyvsp[(1) - (2)].s)->pType == tChar )

				struct regexListType *rxl;
			
				_here;
				
				rxl = (yyvsp[(2) - (2)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				
				// Although this is a character constant,
				// we're going to store it as a singleton
				// character set object.
				
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				
				// Set the single bit corresponding to the 
				// ASCII code for this character:
				
				rxl->v.u.charval = (yyvsp[(1) - (2)].s)->u.charval;
					
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				_here;

			
			// If it's a string constant ID, store it as a string:
			
			_elseif( (yyvsp[(1) - (2)].s)->pType == tString )

				struct regexListType *rxl;
			
				_here;

				rxl = (yyvsp[(2) - (2)].v.u.rx);
				rxl->nodeType = nt_String;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tString, &string_ste );
				rxl->v.u.strval = (yyvsp[(1) - (2)].s)->u.strval;	  
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				_here;


			// If the identifier is a cset constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (2)].s)->pType == tCset )

				rxl = (yyvsp[(2) - (2)].v.u.rx);
				rxl->nodeType = nt_Cset;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
				memcpy( &rxl->v.u.csetval, (yyvsp[(1) - (2)].s)->u.csetval, CSetSizeInBytes );			
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			// If the identifier is a regex constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (2)].s)->pType == tRegex )

				rxl = (yyvsp[(2) - (2)].v.u.rx);
				rxl->nodeType = nt_Regex2;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tRegex, &regex_ste );	  
				memcpy( &rxl->v, (yyvsp[(1) - (2)].s), sizeofSymNode );
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			_else
			
				yyerror( "Unexpected constant ID type in regular expression" );
				
				// Create a dummy entry to prevent cascading problems:
				
				rxl = (yyvsp[(2) - (2)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				rxl->v.u.charval = ' ';
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				
			_endif				
			_here;
		;}
    break;

  case 557:

/* Line 1464 of yacc.c  */
#line 15979 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			// It's a char constant
			
			_if( (yyvsp[(1) - (3)].s)->pType == tChar )

				struct regexListType *rxl;
			
				_here;
				
				rxl = (yyvsp[(3) - (3)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 0;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 0;
				
				// Although this is a character constant,
				// we're going to store it as a singleton
				// character set object.
				
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				
				// Set the single bit corresponding to the 
				// ASCII code for this character:
				
				rxl->v.u.charval = (yyvsp[(1) - (3)].s)->u.charval;
					
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				_here;

			
			// If it's a string constant ID, store it as a string:
			
			_elseif( (yyvsp[(1) - (3)].s)->pType == tString )

				struct regexListType *rxl;
			
				_here;

				rxl = (yyvsp[(3) - (3)].v.u.rx);
				rxl->nodeType = nt_String;
				rxl->minCnt = 0;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tString, &string_ste );
				rxl->v.u.strval = (yyvsp[(1) - (3)].s)->u.strval;	  
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				_here;


			// If the identifier is a cset constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (3)].s)->pType == tCset )

				rxl = (yyvsp[(3) - (3)].v.u.rx);
				rxl->nodeType = nt_Cset;
				rxl->minCnt = 0;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
				memcpy( &rxl->v.u.csetval, (yyvsp[(1) - (3)].s)->u.csetval, CSetSizeInBytes );			
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			// If the identifier is a regex constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (3)].s)->pType == tRegex )

				yyerror( "Regular expression IDs do not allow a '*' operator" );
				
			
			_else
			
				yyerror( "Unexpected constant ID type in regular expression" );
				
				// Create a dummy entry to prevent cascading problems:
				
				rxl = (yyvsp[(3) - (3)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				rxl->v.u.charval = ' ';
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				
			_endif				
			_here;
		;}
    break;

  case 558:

/* Line 1464 of yacc.c  */
#line 16098 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			// It's a char constant
			
			_if( (yyvsp[(1) - (3)].s)->pType == tChar )

				struct regexListType *rxl;
			
				_here;
				
				rxl = (yyvsp[(3) - (3)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 0;
				
				// Although this is a character constant,
				// we're going to store it as a singleton
				// character set object.
				
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				
				// Set the single bit corresponding to the 
				// ASCII code for this character:
				
				rxl->v.u.charval = (yyvsp[(1) - (3)].s)->u.charval;
					
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				_here;

			
			// If it's a string constant ID, store it as a string:
			
			_elseif( (yyvsp[(1) - (3)].s)->pType == tString )

				struct regexListType *rxl;
			
				_here;

				rxl = (yyvsp[(3) - (3)].v.u.rx);
				rxl->nodeType = nt_String;
				rxl->minCnt = 1;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tString, &string_ste );
				rxl->v.u.strval = (yyvsp[(1) - (3)].s)->u.strval;	  
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				_here;


			// If the identifier is a cset constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (3)].s)->pType == tCset )

				rxl = (yyvsp[(3) - (3)].v.u.rx);
				rxl->nodeType = nt_Cset;
				rxl->minCnt = 1;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
				memcpy( &rxl->v.u.csetval, (yyvsp[(1) - (3)].s)->u.csetval, CSetSizeInBytes );			
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			// If the identifier is a regex constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (3)].s)->pType == tRegex )

				yyerror( "Regular expression IDs do not allow a '+' operator" );
				
			
			_else
			
				yyerror( "Unexpected constant ID type in regular expression" );
				
				// Create a dummy entry to prevent cascading problems:
				
				rxl = (yyvsp[(3) - (3)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				rxl->v.u.charval = ' ';
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				
			_endif				
			_here;
		;}
    break;

  case 559:

/* Line 1464 of yacc.c  */
#line 16220 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			// It's a char constant
			
			_if( (yyvsp[(1) - (7)].s)->pType == tChar )

				struct regexListType *rxl;
			
				_here;
				
				rxl = (yyvsp[(7) - (7)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = (yyvsp[(4) - (7)].ranges.minRange);	
				rxl->maxCnt = (yyvsp[(5) - (7)].ranges.maxRange);
				rxl->lazy = 0;
				
				// Although this is a character constant,
				// we're going to store it as a singleton
				// character set object.
				
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				
				// Set the single bit corresponding to the 
				// ASCII code for this character:
				
				rxl->v.u.charval = (yyvsp[(1) - (7)].s)->u.charval;
					
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				_here;

			
			// If it's a string constant ID, store it as a string:
			
			_elseif( (yyvsp[(1) - (7)].s)->pType == tString )

				struct regexListType *rxl;
			
				_here;

				rxl = (yyvsp[(7) - (7)].v.u.rx);
				rxl->nodeType = nt_String;
				rxl->minCnt = (yyvsp[(4) - (7)].ranges.minRange);	
				rxl->maxCnt = (yyvsp[(5) - (7)].ranges.maxRange);
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tString, &string_ste );
				rxl->v.u.strval = (yyvsp[(1) - (7)].s)->u.strval;	  
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				_here;


			// If the identifier is a cset constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (7)].s)->pType == tCset )

				rxl = (yyvsp[(7) - (7)].v.u.rx);
				rxl->nodeType = nt_Cset;
				rxl->minCnt = (yyvsp[(4) - (7)].ranges.minRange);	
				rxl->maxCnt = (yyvsp[(5) - (7)].ranges.maxRange);
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
				memcpy( &rxl->v.u.csetval, (yyvsp[(1) - (7)].s)->u.csetval, CSetSizeInBytes );			
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			// If the identifier is a regex constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (7)].s)->pType == tRegex )

				rxl = (yyvsp[(3) - (7)].v.u.rx);
				rxl->nodeType = nt_Regex2;
				_if( (yyvsp[(2) - (7)].ranges.minRange) != 1 || (yyvsp[(2) - (7)].ranges.maxRange) != 1 )
				
					yyerror( "Regex items do not allow repetition values" );
					
				_endif
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tRegex, &regex_ste );	  
				memcpy( &rxl->v, (yyvsp[(1) - (7)].s), sizeofSymNode );
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			_else
			
				yyerror( "Unexpected constant ID type in regular expression" );
				
				// Create a dummy entry to prevent cascading problems:
				
				rxl = (yyvsp[(7) - (7)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				rxl->v.u.charval = ' ';
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				
			_endif				
			_here;
		;}
    break;

  case 560:

/* Line 1464 of yacc.c  */
#line 16361 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			// It's a char constant
			
			_if( (yyvsp[(1) - (7)].s)->pType == tChar )

				struct regexListType *rxl;
			
				_here;
				
				rxl = (yyvsp[(7) - (7)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = (yyvsp[(4) - (7)].ranges.minRange);	
				rxl->maxCnt = (yyvsp[(5) - (7)].ranges.maxRange);
				rxl->lazy = 1;
				
				// Although this is a character constant,
				// we're going to store it as a singleton
				// character set object.
				
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				
				// Set the single bit corresponding to the 
				// ASCII code for this character:
				
				rxl->v.u.charval = (yyvsp[(1) - (7)].s)->u.charval;
					
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				_here;

			
			// If it's a string constant ID, store it as a string:
			
			_elseif( (yyvsp[(1) - (7)].s)->pType == tString )

				struct regexListType *rxl;
			
				_here;

				rxl = (yyvsp[(7) - (7)].v.u.rx);
				rxl->nodeType = nt_String;
				rxl->minCnt = (yyvsp[(4) - (7)].ranges.minRange);	
				rxl->maxCnt = (yyvsp[(5) - (7)].ranges.maxRange);
				rxl->lazy = 1;
				
				ClrConst( YYS &rxl->v, tString, &string_ste );
				rxl->v.u.strval = (yyvsp[(1) - (7)].s)->u.strval;	  
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				_here;


			// If the identifier is a cset constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (7)].s)->pType == tCset )

				rxl = (yyvsp[(7) - (7)].v.u.rx);
				rxl->nodeType = nt_Cset;
				rxl->minCnt = (yyvsp[(4) - (7)].ranges.minRange);	
				rxl->maxCnt = (yyvsp[(5) - (7)].ranges.maxRange);
				rxl->lazy = 1;
				
				ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
				memcpy( &rxl->v.u.csetval, (yyvsp[(1) - (7)].s)->u.csetval, CSetSizeInBytes );			
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			// If the identifier is a regex constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (7)].s)->pType == tRegex )

				rxl = (yyvsp[(3) - (7)].v.u.rx);
				rxl->nodeType = nt_Regex2;
				_if( (yyvsp[(2) - (7)].ranges.minRange) != 1 || (yyvsp[(2) - (7)].ranges.maxRange) != 1 )
				
					yyerror( "Regex items do not allow repetition values" );
					
				_endif
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tRegex, &regex_ste );	  
				memcpy( &rxl->v, (yyvsp[(1) - (7)].s), sizeofSymNode );
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			_else
			
				yyerror( "Unexpected constant ID type in regular expression" );
				
				// Create a dummy entry to prevent cascading problems:
				
				rxl = (yyvsp[(7) - (7)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				rxl->v.u.charval = ' ';
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				
			_endif				
			_here;
		;}
    break;

  case 561:

/* Line 1464 of yacc.c  */
#line 16494 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			// It's a char constant
			
			_if( (yyvsp[(1) - (4)].s)->pType == tChar )

				struct regexListType *rxl;
			
				_here;
				
				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 0;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 1;
				
				// Although this is a character constant,
				// we're going to store it as a singleton
				// character set object.
				
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				
				// Set the single bit corresponding to the 
				// ASCII code for this character:
				
				rxl->v.u.charval = (yyvsp[(1) - (4)].s)->u.charval;
					
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				_here;

			
			// If it's a string constant ID, store it as a string:
			
			_elseif( (yyvsp[(1) - (4)].s)->pType == tString )

				struct regexListType *rxl;
			
				_here;

				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_String;
				rxl->minCnt = 0;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 1;
				
				ClrConst( YYS &rxl->v, tString, &string_ste );
				rxl->v.u.strval = (yyvsp[(1) - (4)].s)->u.strval;	  
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				_here;


			// If the identifier is a cset constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (4)].s)->pType == tCset )

				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_Cset;
				rxl->minCnt = 0;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 1;
				
				ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
				memcpy( &rxl->v.u.csetval, (yyvsp[(1) - (4)].s)->u.csetval, CSetSizeInBytes );			
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			// If the identifier is a regex constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (4)].s)->pType == tRegex )

				rxl = (yyvsp[(3) - (4)].v.u.rx);
				rxl->nodeType = nt_Regex2;
				_if( (yyvsp[(2) - (4)].ranges.minRange) != 1 || (yyvsp[(2) - (4)].ranges.maxRange) != 1 )
				
					yyerror( "Regex items do not allow repetition values" );
					
				_endif
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tRegex, &regex_ste );	  
				memcpy( &rxl->v, (yyvsp[(1) - (4)].s), sizeofSymNode );
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			_else
			
				yyerror( "Unexpected constant ID type in regular expression" );
				
				// Create a dummy entry to prevent cascading problems:
				
				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				rxl->v.u.charval = ' ';
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				
			_endif				
			_here;
		;}
    break;

  case 562:

/* Line 1464 of yacc.c  */
#line 16627 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			// It's a char constant
			
			_if( (yyvsp[(1) - (4)].s)->pType == tChar )

				struct regexListType *rxl;
			
				_here;
				
				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 1;
				
				// Although this is a character constant,
				// we're going to store it as a singleton
				// character set object.
				
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				
				// Set the single bit corresponding to the 
				// ASCII code for this character:
				
				rxl->v.u.charval = (yyvsp[(1) - (4)].s)->u.charval;
					
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				_here;

			
			// If it's a string constant ID, store it as a string:
			
			_elseif( (yyvsp[(1) - (4)].s)->pType == tString )

				struct regexListType *rxl;
			
				_here;

				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_String;
				rxl->minCnt = 1;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 1;
				
				ClrConst( YYS &rxl->v, tString, &string_ste );
				rxl->v.u.strval = (yyvsp[(1) - (4)].s)->u.strval;	  
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				_here;


			// If the identifier is a cset constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (4)].s)->pType == tCset )

				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_Cset;
				rxl->minCnt = 1;	
				rxl->maxCnt = 0x7fffffff;
				rxl->lazy = 1;
				
				ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
				memcpy( &rxl->v.u.csetval, (yyvsp[(1) - (4)].s)->u.csetval, CSetSizeInBytes );			
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			// If the identifier is a regex constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (4)].s)->pType == tRegex )

				rxl = (yyvsp[(3) - (4)].v.u.rx);
				rxl->nodeType = nt_Regex2;
				_if( (yyvsp[(2) - (4)].ranges.minRange) != 1 || (yyvsp[(2) - (4)].ranges.maxRange) != 1 )
				
					yyerror( "Regex items do not allow repetition values" );
					
				_endif
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tRegex, &regex_ste );	  
				memcpy( &rxl->v, (yyvsp[(1) - (4)].s), sizeofSymNode );
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			_else
			
				yyerror( "Unexpected constant ID type in regular expression" );
				
				// Create a dummy entry to prevent cascading problems:
				
				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				rxl->v.u.charval = ' ';
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				
			_endif				
			_here;
		;}
    break;

  case 563:

/* Line 1464 of yacc.c  */
#line 16766 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			// It's a char constant
			
			_if( (yyvsp[(1) - (4)].s)->pType == tChar )

				struct regexListType *rxl;
			
				_here;
				
				yyerror( "Illegal syntax for a char constant ID in a regex" );
				
				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 0;	
				rxl->maxCnt = 0;
				rxl->lazy = 1;
				
				// Although this is a character constant,
				// we're going to store it as a singleton
				// character set object.
				
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				
				// Set the single bit corresponding to the 
				// ASCII code for this character:
				
				rxl->v.u.charval = (yyvsp[(1) - (4)].s)->u.charval;
					
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				_here;

			
			// If it's a string constant ID, store it as a string:
			
			_elseif( (yyvsp[(1) - (4)].s)->pType == tString )

				struct regexListType *rxl;
			
				_here;

				yyerror( "Illegal syntax for a string constant ID in a regex" );

				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_String;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tString, &string_ste );
				rxl->v.u.strval = (yyvsp[(1) - (4)].s)->u.strval;	  
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				_here;


			// If the identifier is a cset constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (4)].s)->pType == tCset )

				yyerror( "Illegal syntax for a cset constant ID in a regex" );

				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_Cset;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				
				ClrConst( YYS &rxl->v, tCset, &cset_ste );	  
				memcpy( &rxl->v.u.csetval, (yyvsp[(1) - (4)].s)->u.csetval, CSetSizeInBytes );			
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			// If the identifier is a regex constant, deal with that here:
			
			_elseif( (yyvsp[(1) - (4)].s)->pType == tRegex )

				SymNode_t	*s;
				
				s = (yyvsp[(3) - (4)].neID.s);
				_if( s != NULL )
				
					_if( s->SymClass != cValue )
					
						yyerror( "Expected a VAL object for string extraction ID" );
						
						// Create the symbol anyway, to prevent cascading errors:
						
						ClrNewSym
						(
							(yyvsp[(3) - (4)].neID.idStr),// Name,
							_ifx(s->pType == tText,&text_ste,&string_ste),// TheType
							_ifx(s->pType == tText,tText,tString),	// pType
							cValue,		   // TheClass
							0,			   // Arity
							NULL,		   // Dimensions
							0,			   // NumElements
							4,			   // ObjectSize
							0,			   // CurOffset
							NULL,		   // StaticName
							NULL,		   // Base
							NULL,		   // Fields
							0,			   // FieldCnt
							NULL,		   // CurField
							0			   // CurIndex
						);
						s = SymbolTable;
						
					_endif
					
				_else // If the symbol is undefined, create a new one
				
					ClrNewSym
					(
						(yyvsp[(3) - (4)].neID.idStr),	// Name,
						&string_ste,   	// TheType
						tString,	   	// pType
						cValue,		   	// TheClass
						0,			   	// Arity
						NULL,		   	// Dimensions
						0,			   	// NumElements
						4,			   	// ObjectSize
						0,			   	// CurOffset
						NULL,		   	// StaticName
						NULL,		   	// Base
						NULL,		   	// Fields
						0,			   	// FieldCnt
						NULL,		   	// CurField
						0			   	// CurIndex
					);
					s = SymbolTable;
				
				_endif

				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_Regex2;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				rxl->id = s;
				
				ClrConst( YYS &rxl->v, tRegex, &regex_ste );	  
				memcpy( &rxl->v, (yyvsp[(1) - (4)].s), sizeofSymNode );
								
				// Return the new node we've created as this
				// production's attribute:
				
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;
				
			
			_else
			
				yyerror( "Unexpected constant ID type in regular expression" );
				
				// Create a dummy entry to prevent cascading problems:
				
				rxl = (yyvsp[(4) - (4)].v.u.rx);
				rxl->nodeType = nt_Char;
				rxl->minCnt = 1;	
				rxl->maxCnt = 1;
				rxl->lazy = 0;
				ClrConst( YYS &rxl->v, tChar, &char_ste );	  
				rxl->v.u.charval = ' ';
				ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
				(yyval.v.u.rx) = rxl;				
				
			_endif				
			_here;
		;}
    break;

  case 564:

/* Line 1464 of yacc.c  */
#line 16960 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_EOS;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 565:

/* Line 1464 of yacc.c  */
#line 16991 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_reg;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 566:

/* Line 1464 of yacc.c  */
#line 17022 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_matchid;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 567:

/* Line 1464 of yacc.c  */
#line 17051 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_matchInt;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 568:

/* Line 1464 of yacc.c  */
#line 17080 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_matchReal;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 569:

/* Line 1464 of yacc.c  */
#line 17109 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_matchStr;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 570:

/* Line 1464 of yacc.c  */
#line 17138 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_reg8;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 571:

/* Line 1464 of yacc.c  */
#line 17167 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_reg16;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 572:

/* Line 1464 of yacc.c  */
#line 17196 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_reg32;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 573:

/* Line 1464 of yacc.c  */
#line 17225 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_regfpu;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 574:

/* Line 1464 of yacc.c  */
#line 17254 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_regmmx;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 575:

/* Line 1464 of yacc.c  */
#line 17283 "hlaparse.bsn"
    {		
			struct regexListType *rxl;

			_here;

			// Store this as an EOS object:
			
			rxl = (yyvsp[(2) - (2)].v.u.rx);
			rxl->nodeType = nt_regxmm;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 576:

/* Line 1464 of yacc.c  */
#line 17316 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(3) - (3)].v.u.rx);
			rxl->nodeType = nt_ws;
			rxl->minCnt = (yyvsp[(2) - (3)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(2) - (3)].ranges.maxRange);
			rxl->lazy = (yyvsp[(2) - (3)].ranges.lazy);
			
			// Although this is a character constant,
			// we're going to store it as a singleton
			// character set object.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 577:

/* Line 1464 of yacc.c  */
#line 17352 "hlaparse.bsn"
    {
			struct regexListType *rxl;
		
			_here;
			
			rxl = (yyvsp[(3) - (3)].v.u.rx);
			rxl->nodeType = nt_AnyChar;
			rxl->minCnt = (yyvsp[(2) - (3)].ranges.minRange);	
			rxl->maxCnt = (yyvsp[(2) - (3)].ranges.maxRange);
			rxl->lazy = 1;
			
			// Although this is a character constant,
			// we're going to store it as a singleton
			// character set object.
			
			ClrConst( YYS &rxl->v, tChar, &char_ste );	  
							
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;
			_here;
		;}
    break;

  case 578:

/* Line 1464 of yacc.c  */
#line 17388 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(0) - (0)].s)->u.MacroData.Parameters != NULL )
			
				processMacroID( (yyvsp[(0) - (0)].s) );
				
			_endif
		;}
    break;

  case 579:

/* Line 1464 of yacc.c  */
#line 17403 "hlaparse.bsn"
    {
			SymNode_t		 		*s;
			SymNode_t		 		*t;
			SymNode_t		 		**lastT;
			struct regexListType	*rxl;
			
			_here;
			rxl = (yyvsp[(3) - (3)].v.u.rx);
			rxl->nodeType = nt_Regex;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			
			// Does this need to be a deep copy of some sort?
			
			memcpy( &rxl->v,  (yyvsp[(1) - (3)].s), sizeofSymNode );
			s = (yyvsp[(1) - (3)].s)->u.MacroData.Parameters;
			lastT = &rxl->v.u.MacroData.Parameters;
			_while( s != NULL )
			
				t = malloc2( sizeofSymNode );
				*lastT = t;
				lastT = &t->Next;
				DeepCopy( t, s );
				s = s->Next;
				
			_endwhile;
						

			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;

		;}
    break;

  case 580:

/* Line 1464 of yacc.c  */
#line 17452 "hlaparse.bsn"
    {
			SymNode_t		 		*sym;
			SymNode_t		 		*t;
			SymNode_t		 		**lastT;
			struct regexListType	*rxl;
			SymNode_t		 		*s;
			
			s = (yyvsp[(4) - (5)].neID.s);
			_if( s != NULL )
			
				_if( s->SymClass != cValue )
				
					yyerror( "Expected a VAL object for string extraction ID" );
					
					// Create the symbol anyway, to prevent cascading errors:
					
					ClrNewSym
					(
						(yyvsp[(4) - (5)].neID.idStr),	// Name,
						_ifx(s->pType == tText,&text_ste,&string_ste),// TheType
						_ifx(s->pType == tText,tText,tString),	// pType
						cValue,		   	// TheClass
						0,			   	// Arity
						NULL,		   	// Dimensions
						0,			   	// NumElements
						4,			   	// ObjectSize
						0,			   	// CurOffset
						NULL,		   	// StaticName
						NULL,		   	// Base
						NULL,		   	// Fields
						0,			   	// FieldCnt
						NULL,		   	// CurField
						0			   	// CurIndex
					);
					s = SymbolTable;
					
				_endif
				
			_else // If the symbol is undefined, create a new one
			
				ClrNewSym
				(
					(yyvsp[(4) - (5)].neID.idStr),	// Name,
					&string_ste,   	// TheType
					tString,	   	// pType
					cValue,		   	// TheClass
					0,			   	// Arity
					NULL,		   	// Dimensions
					0,			   	// NumElements
					4,			   	// ObjectSize
					0,			   	// CurOffset
					NULL,		   	// StaticName
					NULL,		   	// Base
					NULL,		   	// Fields
					0,			   	// FieldCnt
					NULL,		   	// CurField
					0			   	// CurIndex
				);
				s = SymbolTable;
			
			_endif
			
			rxl = (yyvsp[(5) - (5)].v.u.rx);
			rxl->nodeType = nt_Regex;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			rxl->id = s;
			
			// Does this need to be a deep copy of some sort?
			
			memcpy( &rxl->v,  (yyvsp[(1) - (5)].s), sizeofSymNode );
			s = (yyvsp[(1) - (5)].s)->u.MacroData.Parameters;
			lastT = &rxl->v.u.MacroData.Parameters;
			_while( s != NULL )
			
				t = malloc2( sizeofSymNode );
				*lastT = t;
				lastT = &t->Next;
				DeepCopy( t, s );
				s = s->Next;
				
			_endwhile;
						

			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 581:

/* Line 1464 of yacc.c  */
#line 17554 "hlaparse.bsn"
    {
			SymNode_t		 		*sym;
			SymNode_t		 		*t;
			struct regexListType	*rxl;
			SymNode_t		 		*s;
			
			s = (yyvsp[(3) - (4)].neID.s);
			_if( s != NULL )
			
				_if( s->SymClass != cValue )
				
					yyerror( "Expected a VAL object for '@at:' identifier" );
					
					// Create the symbol anyway, to prevent cascading errors:
					
					ClrNewSym
					(
						(yyvsp[(3) - (4)].neID.idStr),		// Name,
						&uns32_ste,			// TheType
						tUns32,				// pType
						cValue,				// TheClass
						0,	   				// Arity
						NULL,  				// Dimensions
						0,	   				// NumElements
						4,	   				// ObjectSize
						0,	   				// CurOffset
						NULL,  				// StaticName
						NULL,  				// Base
						NULL,  				// Fields
						0,	   				// FieldCnt
						NULL,  				// CurField
						0	   				// CurIndex
					);
					s = SymbolTable;
					
				_endif
				
			_else // If the symbol is undefined, create a new one
			
				ClrNewSym
				(
					(yyvsp[(3) - (4)].neID.idStr), 	// Name,
					&uns32_ste,			// TheType
					tUns32,	   			// pType
					cValue,	   			// TheClass
					0,		   			// Arity
					NULL,	   			// Dimensions
					0,		   			// NumElements
					4,		   			// ObjectSize
					0,		   			// CurOffset
					NULL,	   			// StaticName
					NULL,	   			// Base
					NULL,	   			// Fields
					0,		   			// FieldCnt
					NULL,	   			// CurField
					0		   			// CurIndex
				);
				s = SymbolTable;
			
			_endif
			
			rxl = (yyvsp[(4) - (4)].v.u.rx);
			rxl->nodeType = nt_at;
			rxl->minCnt = 1;	
			rxl->maxCnt = 1;
			rxl->id = s;
			
			// Return the new node we've created as this
			// production's attribute:
			
			ClrConst( YYS &(yyval.v), tRegex, &regex_ste );			
			(yyval.v.u.rx) = rxl;				
			_here;
		;}
    break;

  case 582:

/* Line 1464 of yacc.c  */
#line 17638 "hlaparse.bsn"
    {
			(yyval.s) = (yyvsp[(1) - (1)].s);
		;}
    break;

  case 583:

/* Line 1464 of yacc.c  */
#line 17643 "hlaparse.bsn"
    {
			(yyval.s) = (yyvsp[(1) - (1)].s);
		;}
    break;

  case 584:

/* Line 1464 of yacc.c  */
#line 17655 "hlaparse.bsn"
    {
			_here;
			(yyval.ranges.minRange) = 1;
			(yyval.ranges.maxRange) = 1;
			(yyval.ranges.lazy) = 0;
		;}
    break;

  case 585:

/* Line 1464 of yacc.c  */
#line 17667 "hlaparse.bsn"
    {
			_here;
			(yyval.ranges.minRange) = (yyvsp[(3) - (5)].ranges.minRange);
			(yyval.ranges.maxRange) = (yyvsp[(4) - (5)].ranges.maxRange);
			(yyval.ranges.lazy) = 0;
		;}
    break;

  case 586:

/* Line 1464 of yacc.c  */
#line 17679 "hlaparse.bsn"
    {
			_here;
			(yyval.ranges.minRange) = (yyvsp[(3) - (5)].ranges.minRange);
			(yyval.ranges.maxRange) = (yyvsp[(4) - (5)].ranges.maxRange);
			(yyval.ranges.lazy) = 1;
		;}
    break;

  case 587:

/* Line 1464 of yacc.c  */
#line 17687 "hlaparse.bsn"
    {
			_here;
			(yyval.ranges.minRange) = 0;
			(yyval.ranges.maxRange) = 0x7fffffff;
			(yyval.ranges.lazy) = 0;
		;}
    break;

  case 588:

/* Line 1464 of yacc.c  */
#line 17695 "hlaparse.bsn"
    {
			_here;
			(yyval.ranges.minRange) = 1;
			(yyval.ranges.maxRange) = 0x7fffffff;
			(yyval.ranges.lazy) = 0;
		;}
    break;

  case 589:

/* Line 1464 of yacc.c  */
#line 17707 "hlaparse.bsn"
    {
			_here;
			_if( !IsSmallNumber( (yyvsp[(1) - (1)].v.pType) ) )
			
				yyerror
				( 
					"Expected a constant integer expression	after ':'"
				);
				(yyval.ranges.minRange) = 1;
				(yyval.ranges.maxRange) = 1;
				FreeValue( YYS &(yyvsp[(1) - (1)].v) );
				(yyval.ranges.minRange) = 1;
				(yyval.ranges.maxRange) = 1;
				
			_else

				(yyval.ranges.minRange) = (yyvsp[(1) - (1)].v.u.unsval);
				(yyval.ranges.maxRange) = (yyvsp[(1) - (1)].v.u.unsval);

			_endif
		;}
    break;

  case 590:

/* Line 1464 of yacc.c  */
#line 17732 "hlaparse.bsn"
    {
			_here;
			(yyval.ranges.minRange) = (yyvsp[(0) - (1)].v.u.unsval);
			(yyval.ranges.maxRange) = (yyvsp[(0) - (1)].v.u.unsval);
		;}
    break;

  case 591:

/* Line 1464 of yacc.c  */
#line 17742 "hlaparse.bsn"
    {
			_here;
			(yyval.ranges.minRange) = (yyvsp[(2) - (2)].v.u.unsval);
			(yyval.ranges.maxRange) = (yyvsp[(2) - (2)].v.u.unsval);
		;}
    break;

  case 592:

/* Line 1464 of yacc.c  */
#line 17753 "hlaparse.bsn"
    {
			_here;
			(yyval.ranges.minRange) = 0x7fffffff;
			(yyval.ranges.maxRange) = 0x7fffffff;
		;}
    break;

  case 593:

/* Line 1464 of yacc.c  */
#line 17805 "hlaparse.bsn"
    {
			SymNode_t v;
			SymNode_t *s;

			_here;
			
			// Restore currentNS before entering the symbol
			// into the symbol table.
			
			currentNS = (yyvsp[(4) - (11)].s);

			#define ptr(p,prev) _ifx((p)!=(prev),p,NULL)

			/*
			** Initialize the macro data for the macro
			** symbol table entry.
			*/

			v.u.MacroData.Text = (yyvsp[(10) - (11)].m.Text);
			v.u.MacroData.Parameters = ptr((yyvsp[(5) - (11)].s),(yyvsp[(3) - (11)].s));
			v.u.MacroData.Locals = ptr((yyvsp[(7) - (11)].s),(yyvsp[(5) - (11)].s));
			v.u.MacroData.Terminator = NULL;
			v.u.MacroData.NameSpace = NULL;
			v.u.MacroData.LineCnt = (yyvsp[(8) - (11)].v.u.unsval);
			v.u.MacroData.Filename = 	hlastrdup2( FileName );

			/*
			** If there are parameters or local symbols, null
			** terminate the list of such symbols so they don't
			** point into the main symbol table.
			*/

			_if( (yyvsp[(7) - (11)].s) != (yyvsp[(3) - (11)].s) )

				s = (yyvsp[(7) - (11)].s);
				_while( s->Next != NULL && s->Next != (yyvsp[(3) - (11)].s) )

					s = s->Next;

				_endwhile
				s->Next = NULL;

			_endif
			SymbolTable = (yyvsp[(3) - (11)].s);

			/*
			** Insert the text for the macro into
			** the symbol table.
			*/
			assert( (yyvsp[(2) - (11)].idStr) != NULL );
			InsertSym
			( 
				(yyvsp[(2) - (11)].idStr), 
				NULL,			/* No type associated with this symbol.	*/
				tMacro,			/* It's a macro.						*/
				cMacro, 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				YYS &v,			/* Ptr to macro's text.			*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				NULL,			/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);

			_here;
		;}
    break;

  case 594:

/* Line 1464 of yacc.c  */
#line 17922 "hlaparse.bsn"
    {					/*11*/ 
			_here;
			currentNS = (yyvsp[(4) - (10)].s);
			(yyval.s) = currentNS; 
		;}
    break;

  case 595:

/* Line 1464 of yacc.c  */
#line 17931 "hlaparse.bsn"
    {					/*14*/ 
			_here;
			currentNS = (yyvsp[(4) - (13)].s); 
		;}
    break;

  case 596:

/* Line 1464 of yacc.c  */
#line 17946 "hlaparse.bsn"
    {
			SymNode_t v;
			SymNode_t *s;

			_here;

			// Restore currentNS before entering the symbols
			// into the symbol table.
			
			currentNS = (yyvsp[(4) - (24)].s);

			/*
			** Set up the textual data for the terminator.
			*/

			v.u.MacroData.Text = (yyvsp[(23) - (24)].m.Text);

			v.u.MacroData.Parameters = ptr( (yyvsp[(18) - (24)].s), (yyvsp[(13) - (24)].s) );
			v.u.MacroData.Locals = ptr( (yyvsp[(20) - (24)].s), (yyvsp[(18) - (24)].s) );
			v.u.MacroData.Terminator = NULL;
			v.u.MacroData.LineCnt = (yyvsp[(21) - (24)].v.u.unsval);
			v.u.MacroData.NameSpace = currentNS;
			v.u.MacroData.Filename = 	hlastrdup2( FileName );

			/*
			** Null-terminate the list of parameters and
			** local symbols associated with the terminator.
			*/

			_if( (yyvsp[(20) - (24)].s) != (yyvsp[(13) - (24)].s) )

				s = (yyvsp[(20) - (24)].s);
				_while( s->Next != NULL && s->Next != (yyvsp[(13) - (24)].s) )

					s = s->Next;

				_endwhile
				s->Next = NULL;

			_endif
			SymbolTable = (yyvsp[(13) - (24)].s);



			/*
			** Insert the text for the terminator macro into
			** the symbol table.
			*/

			assert( (yyvsp[(16) - (24)].idStr) != NULL );
			InsertSym
			( 
				(yyvsp[(16) - (24)].idStr), 
				NULL,			/* No type associated with this symbol.	*/
				tMacro,			/* It's a macro.						*/
				cTerminator, 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				YYS &v,			/* Ptr to macro's text.			*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				NULL,			/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);
			_here;


			/*
			** Set up the textual macro data for the main macro.
			*/

			v.u.MacroData.Text = (yyvsp[(10) - (24)].m.Text);
			v.u.MacroData.Parameters = ptr( (yyvsp[(5) - (24)].s), (yyvsp[(3) - (24)].s) );
			v.u.MacroData.Locals = ptr( (yyvsp[(7) - (24)].s), (yyvsp[(5) - (24)].s) );
			v.u.MacroData.Terminator = SymbolTable;
			v.u.MacroData.LineCnt = (yyvsp[(8) - (24)].v.u.unsval);
			v.u.MacroData.Filename = 	hlastrdup2( FileName );


			/*
			** Null-terminate the list of keywords, parameters, and
			** local symbols associated with the main macro.
			*/

			s = SymbolTable;
			_while( s->Next != NULL && s->Next != (yyvsp[(3) - (24)].s) )

				s = s->Next;

			_endwhile
			s->Next = NULL;
			SymbolTable = (yyvsp[(3) - (24)].s);




			/*
			** Insert the text for the macro into
			** the symbol table.
			*/

			assert( (yyvsp[(2) - (24)].idStr) != NULL );
			InsertSym
			( 
				(yyvsp[(2) - (24)].idStr), 
				NULL,			/* No type associated with this symbol.	*/
				tMacro,			/* It's a macro.						*/
				cMacro, 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				YYS &v,			/* Ptr to macro's text.			*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				NULL,			/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);

			(void) (yyvsp[(11) - (24)].s); // To shut up bison
			_here;
		;}
    break;

  case 597:

/* Line 1464 of yacc.c  */
#line 18087 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 598:

/* Line 1464 of yacc.c  */
#line 18101 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 599:

/* Line 1464 of yacc.c  */
#line 18115 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 600:

/* Line 1464 of yacc.c  */
#line 18131 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.unsval) = LineCnt;
			_here;
		;}
    break;

  case 601:

/* Line 1464 of yacc.c  */
#line 18147 "hlaparse.bsn"
    { _here; (yyval.s) = NULL; ;}
    break;

  case 602:

/* Line 1464 of yacc.c  */
#line 18161 "hlaparse.bsn"
    {
				SymNode_t v;
				SymNode_t *s;

				_here;

				/*
				** Process the macro text associated with
				** each keyword clause present in the macro.
				*/

				v.u.MacroData.Text = (yyvsp[(11) - (11)].m.Text);
				v.u.MacroData.Parameters = ptr( (yyvsp[(6) - (11)].s), (yyvsp[(4) - (11)].s) );
				v.u.MacroData.Locals = ptr( (yyvsp[(8) - (11)].s), (yyvsp[(6) - (11)].s) );
				v.u.MacroData.NameSpace = (yyvsp[(0) - (11)].s);
				v.u.MacroData.Terminator = NULL;
				v.u.MacroData.LineCnt = (yyvsp[(9) - (11)].v.u.unsval);
				v.u.MacroData.Filename = 	hlastrdup2( FileName );

				/*
				** Null-terminate the list of parameter names and
				** local identifiers associated with this keyword macro.
				*/

				_if( (yyvsp[(8) - (11)].s) != (yyvsp[(4) - (11)].s) )

					s = (yyvsp[(8) - (11)].s);
					_while( s->Next != NULL && s->Next != (yyvsp[(4) - (11)].s) )

						s = s->Next;

					_endwhile
					s->Next = NULL;

				_endif
				SymbolTable = (yyvsp[(4) - (11)].s);


				/*
				** Insert the text for the keyword macro into
				** the symbol table.
				*/

				assert( (yyvsp[(3) - (11)].idStr) != NULL );
				InsertSym
				( 
					(yyvsp[(3) - (11)].idStr), 
					NULL,			/* No type associated with this symbol.	*/
					tMacro,			/* It's a macro.						*/
					cKeyword, 
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					YYS &v,			/* Ptr to macro's text.			*/
					0,				/* Object size					*/
					0,				/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);
				(yyval.s) = SymbolTable;
				_here;
			;}
    break;

  case 603:

/* Line 1464 of yacc.c  */
#line 18235 "hlaparse.bsn"
    { _here; (yyval.s) = SymbolTable; ;}
    break;

  case 604:

/* Line 1464 of yacc.c  */
#line 18246 "hlaparse.bsn"
    { 
				_here;
				doRecMac();
			;}
    break;

  case 605:

/* Line 1464 of yacc.c  */
#line 18264 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = currentNS;
			currentNS = NULL;
		;}
    break;

  case 606:

/* Line 1464 of yacc.c  */
#line 18271 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = currentNS;
			currentNS = NULL;
		;}
    break;

  case 607:

/* Line 1464 of yacc.c  */
#line 18278 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(2) - (4)].s);
		;}
    break;

  case 608:

/* Line 1464 of yacc.c  */
#line 18297 "hlaparse.bsn"
    {
			SymNode_t v;

			_here;
			v.u.strval = hlastrdup2( "" );
			v.pType = tString;
			v.Type = &string_ste;
			InsertSym
			( 
				(yyvsp[(1) - (1)].neID.idStr), 
				&text_ste,
				tText, 
				cValue, 
				0,				/* Arity			*/
				NULL,			/* Dimensions		*/
				0, 				/* NumElements		*/
				YYS &v,			/* Value			*/
				0,				/* ObjectSize		*/
				0,				/* Offset			*/
				NULL,			/* Static Name		*/
				NULL,			/* Base				*/
				NULL,			/* Fields			*/
				0				/* FieldCnt			*/
			);
			(yyval.s) = SymbolTable;
			_here;
		;}
    break;

  case 609:

/* Line 1464 of yacc.c  */
#line 18333 "hlaparse.bsn"
    {
				int			*Dims;
				SymNode_t	v;

				_here;
				
				/*
				** Must allocate dummy objects so they can
				** be freed later.
				*/

				Dims = malloc2( sizeofInt );
				*Dims = 0;

				v.u.ArrayOfValues = NULL;
				InsertSym
				( 
					(yyvsp[(1) - (3)].neID.idStr), 
					&string_ste,
					tArray, 
					cValue, 
					1,				/* Arity			*/
					Dims,			/* Dimensions		*/
					0, 				/* NumElements		*/
					YYS &v,			/* Value			*/
					0,				/* ObjectSize		*/
					0,				/* Offset			*/
					NULL,			/* Static Name		*/
					NULL,			/* Base				*/
					NULL,			/* Fields			*/
					0				/* FieldCnt			*/
				);
				(yyval.s) = SymbolTable;
				_here;
			;}
    break;

  case 610:

/* Line 1464 of yacc.c  */
#line 18377 "hlaparse.bsn"
    {
				int			*Dims;
				SymNode_t	v;

				_here;
				
				v.u.strval = hlastrdup2( "" );
				v.pType = tString;
				v.Type = &string_ste;
				InsertSym
				( 
					(yyvsp[(2) - (2)].neID.idStr), 
					&string_ste,
					tString, 
					cValue, 
					0,				/* Arity			*/
					NULL,			/* Dimensions		*/
					0, 				/* NumElements		*/
					YYS &v,			/* Value			*/
					0,				/* ObjectSize		*/
					0,				/* Offset			*/
					NULL,			/* Static Name		*/
					NULL,			/* Base				*/
					NULL,			/* Fields			*/
					0				/* FieldCnt			*/
				);
				(yyval.s) = SymbolTable;
				_here;
			;}
    break;

  case 611:

/* Line 1464 of yacc.c  */
#line 18419 "hlaparse.bsn"
    { 				/* $4 */

			SymNode_t v;

			_here;
			v.u.strval = hlastrdup2( "" );
			v.pType = tString;
			v.Type = &string_ste;
			InsertSym
			( 
				(yyvsp[(1) - (3)].neID.idStr), 
				&text_ste,
				tText, 
				cValue, 
				0,				/* Arity			*/
				NULL,			/* Dimensions		*/
				0, 				/* NumElements		*/
				YYS &v,			/* Value			*/
				0,				/* ObjectSize		*/
				0,				/* Offset			*/
				NULL,			/* Static Name		*/
				NULL,			/* Base				*/
				NULL,			/* Fields			*/
				0				/* FieldCnt			*/
			);
			(yyval.s) = (yyvsp[(3) - (3)].s);
			_here;
		;}
    break;

  case 613:

/* Line 1464 of yacc.c  */
#line 18463 "hlaparse.bsn"
    {

			/*
			** Kludge!
			**
			**	Using MacroParmList to process the local names
			** means that the last local identifier could be
			** an array of strings (rather than a scalar text object).
			** This is legal for parameters (variable parms) but makes
			** no sense for local symbols.  The following code checks
			** the last declaration out to ensure it is not an attempt
			** to supply the "[]" suffix.  Note that $<s>2 points at
			** the last entry in the symbol table, which is the only
			** entry that may legally have the "[]" suffix from the
			** above productions.
			*/

			_here;
			_if( (yyvsp[(2) - (2)].s)->Dimensions != NULL )

				yyerror( "\"[]\" not allowed after local symbol" );

			_endif

		;}
    break;

  case 614:

/* Line 1464 of yacc.c  */
#line 18514 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 615:

/* Line 1464 of yacc.c  */
#line 18522 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 616:

/* Line 1464 of yacc.c  */
#line 18530 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 617:

/* Line 1464 of yacc.c  */
#line 18541 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 618:

/* Line 1464 of yacc.c  */
#line 18549 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 619:

/* Line 1464 of yacc.c  */
#line 18557 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 620:

/* Line 1464 of yacc.c  */
#line 18565 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 621:

/* Line 1464 of yacc.c  */
#line 18573 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 622:

/* Line 1464 of yacc.c  */
#line 18581 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 623:

/* Line 1464 of yacc.c  */
#line 18589 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 624:

/* Line 1464 of yacc.c  */
#line 18597 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 625:

/* Line 1464 of yacc.c  */
#line 18605 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (1)].s) != NULL );
				(yyval.s) = (yyvsp[(1) - (1)].s);
				_here;
			;}
    break;

  case 626:

/* Line 1464 of yacc.c  */
#line 18622 "hlaparse.bsn"
    {
			SymNode_t	*s;
			SymNode_t	*parmPtr;
			int			parmCnt;
			
			_here;
			doCollect = 0;
			s = InsertSym
				(
					(yyvsp[(1) - (7)].idStr),			//TrueName
					NULL,				//Type
					tOverloads,			//pType
					cOverloads,			//TheClass
					0,					//Arity
					NULL,				//Dimensions,
					0,					//NumElements,
					NULL,				//TheValue,
					0,					//ObjectSize,
					0,					//Offset,
					NULL,				//StaticName,
					NULL,				//Base,
					NULL,				//Fields,
					0					//FieldCnt
				);
				
			s->u.ovld.nextOvld	= NULL;
			parmPtr				= (yyvsp[(5) - (7)].s)->u.proc.parms;
			s->u.ovld.parms		= parmPtr;
			parmCnt = 0;
			_while( parmPtr->SymClass == cParm )
			
				parmPtr = parmPtr->Next;
				++parmCnt;
				
			_endwhile;
			s->u.ovld.numParms = parmCnt;
			_if( *(yyvsp[(6) - (7)].returns) != '\0' )
			
				s->u.ovld.procName = (yyvsp[(6) - (7)].returns);
			
			_else
			
				collectBuf[ collectIndex-1 ] = '\0'; // Trim ';'
				s->u.ovld.procName = hlastrdup2( collectBuf );
				
			_endif
			_here;
		;}
    break;

  case 627:

/* Line 1464 of yacc.c  */
#line 18681 "hlaparse.bsn"
    {
			SymNode_t	*s;
			SymNode_t	*parmPtr;
			int			parmCnt;
			
			_here;
			doCollect = 0;
			s = InsertSym
				(
					strdup( (yyvsp[(1) - (7)].s)->TrueName ),	//TrueName
					NULL,						//Type
					tOverloads,					//pType
					cOverloads,					//TheClass
					0,							//Arity
					NULL,						//Dimensions,
					0,							//NumElements,
					NULL,						//TheValue,
					0,							//ObjectSize,
					0,							//Offset,
					NULL,						//StaticName,
					NULL,						//Base,
					NULL,						//Fields,
					0							//FieldCnt
				);
				
			s->u.ovld.nextOvld	= (yyvsp[(1) - (7)].s);
			parmPtr				= (yyvsp[(5) - (7)].s)->u.proc.parms;
			s->u.ovld.parms		= parmPtr;
			parmCnt = 0;
			_while( parmPtr->SymClass == cParm )
			
				parmPtr = parmPtr->Next;
				++parmCnt;
				
			_endwhile;
			s->u.ovld.numParms = parmCnt;
			_if( *(yyvsp[(6) - (7)].returns) != '\0' )
			
				s->u.ovld.procName = (yyvsp[(6) - (7)].returns);
				
			_else
			
				collectBuf[ collectIndex-1 ] = '\0'; // Trim ';'
				s->u.ovld.procName = hlastrdup2( collectBuf );
				
			_endif
			_here;
		;}
    break;

  case 628:

/* Line 1464 of yacc.c  */
#line 18809 "hlaparse.bsn"
    {				/* $10 */

				int 					*dimension;
				SymNode_t 				value;
				struct contextListType	*p;
				char					exitname[ 256 ];
				union YYSTYPE			dummy;

				_here;


				CheckLegalOptions
				( 
					(yyvsp[(9) - (9)].options.SpecifiedOptions),
						specified_returns
					|	specified_use
					|	specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_noenter 
					|	specified_noleave
					|	specified_pascal
					|	specified_stdcall
					|	specified_cdecl
					|	specified_alignment 
				);
				
				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.  This allows recursive calls
				** to gain access to the parameter list and "returns"
				** value for this procedure.
				*/

				(yyvsp[(6) - (9)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(6) - (9)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
				(yyvsp[(6) - (9)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (9)].options.use);


				/*
				** Okay, now set up the pointers for the main
				** symbol table entry.
				*/

				(yyvsp[(6) - (9)].en.s)->u.proc.parms = SymbolTable;
				CurOffsetDir = -1;
				(yyvsp[(6) - (9)].en.s)->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
				(yyvsp[(6) - (9)].en.s)->u.proc.use = (yyvsp[(9) - (9)].options.use);
				
				CurOffset = StartLclOffs;
				_if( (yyvsp[(9) - (9)].options.UseDisplay) )

					CurOffset -= 4;

					/*
					** Create a symbol table entry for the display.
					*/

					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);
					CurOffset -= CurLexLevel * 4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(7) - (9)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);



				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.  Do not add it if there is no
				** frame generation.
				*/
				
				_if( (yyvsp[(9) - (9)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(2) - (9)].idStr);

					sprintf
					( 
						exitname, 
						"x%s" sympost, 
						(yyvsp[(6) - (9)].en.s)->StaticName 
					); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(9) - (9)].options.UseDisplay);
					p->SizeParms = (yyvsp[(7) - (9)].v.u.unsval);
					contextList = p;

				_endif

				// If the calling sequence reverses the parameters,
				// go in and swap all the offsets on the parameters:


				(yyvsp[(6) - (9)].en.s)->u.proc.cs = (yyvsp[(9) - (9)].options.CallingSequence);
				_if
				(
						(yyvsp[(9) - (9)].options.CallingSequence) == stdcall_cs
					||	(yyvsp[(9) - (9)].options.CallingSequence) == cdecl_cs
				)

					SymNode_t	*fixParms;
					int			offset;

					fixParms = (yyvsp[(6) - (9)].en.s)->u.proc.parms;

					offset = 8;
					_while( fixParms != NULL && fixParms != (yyvsp[(6) - (9)].en.s) )

						_if( fixParms->SymClass == cParm )

							fixParms->Offset = offset;
							
							// Round up to the next multiple of four:
							
							offset += ((( fixParms->ObjectSize + 3) >> 2) << 2);

						_endif
						fixParms = fixParms->Next;

					_endwhile


				_endif
				_here;
			;}
    break;

  case 629:

/* Line 1464 of yacc.c  */
#line 19005 "hlaparse.bsn"
    {				/* $15 */

				int					HadPassByValRes;
				int 				RoundedOffset;
				SymNode_t			*s;
				SymNode_t			*bt;
				SymNode_t			*d;
				SymNode_t			value;

				_here;
				inProcedure = 1;

				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(9) - (14)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(6) - (14)].en.s)->u.proc.parms;

					_while( s != NULL && s != (yyvsp[(6) - (14)].en.s) )

						bt = GetBaseType( s );
						_if
						( 
								bt->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)


							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = s->u.proc.Locals;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;

							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );

						_elseif( s->pClass == vrp_pc || s->pClass == result_pc  )

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(

								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif

				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** Don't count the size of the display as part
				** of the local variable count.
				*/

				_if( (yyvsp[(9) - (14)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);



				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				startCseg();
				_if( (yyvsp[(9) - (14)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(9) - (14)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(6) - (14)].en.s)->StaticName ); 
				_if( (yyvsp[(9) - (14)].options.UseFrame) )
				
					_if( !(yyvsp[(9) - (14)].options.UseDisplay) )


						/*
						** If we're not building a display, just use the
						** standard entry sequence.
						*/

						StdEntry( RoundedOffset, (yyvsp[(9) - (14)].options.NoEnter) );

						/*
						** Align the stack on a dword boundary.
						*/

						_if( AlwaysAlignStk && (yyvsp[(9) - (14)].options.AlignStk) )

							AlignStack();

						_endif

					_else //$<options.UseFrame>9

						/*
						** We've got to construct the display.
						*/

						ConstructDisplay
						( 
							CurLexLevel, 
							RoundedOffset,
							(yyvsp[(9) - (14)].options.NoEnter) 
						);

						/*
						** Align the stack on a dword boundary.
						*/

						_if( AlwaysAlignStk && (yyvsp[(9) - (14)].options.AlignStk) )

							AlignStack();

						_endif
						
					_endif

					
					/*
					** _else
					**
					** 		Don't do anything special if we're not emiting
					**		code to construct the stack frame.  Note that
					**		"noframe" automatically assumes "nodisplay" as
					**		far as code emission is concerned.
					*/

				_endif


				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(9) - (14)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(6) - (14)].en.s) );

				_endif


				assert( (yyvsp[(13) - (14)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(2) - (14)].idStr), (yyvsp[(13) - (14)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"procedure name <<%s>>",
						(yyvsp[(13) - (14)].neID.idStr),
						(yyvsp[(2) - (14)].idStr)
					);

					yyerror( msg );

				_endif

				/*
				** Check to ensure that all forward declared procedures
				** have been defined prior to code emission.
				*/

				CheckForwardDecls( (yyvsp[(6) - (14)].en.s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				CurrentContext = (yyvsp[(6) - (14)].en.s);
				free2( vss (yyvsp[(13) - (14)].neID.idStr) );


				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/

				
				(yyval.s) = lookup( "_finalize_", 1 );
				_if( (yyvsp[(9) - (14)].options.UseFrame) )
				
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
			    _here;
			;}
    break;

  case 630:

/* Line 1464 of yacc.c  */
#line 19380 "hlaparse.bsn"
    {				/* $20 */


				_here;
				assert( (yyvsp[(18) - (19)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(2) - (19)].idStr), (yyvsp[(18) - (19)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"procedure name <<%s>>",
						(yyvsp[(18) - (19)].neID.idStr),
						(yyvsp[(2) - (19)].idStr)
					);

					yyerror( msg );

				_endif

				/*
				** Emit the exit label for this procedure.
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(9) - (19)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(6) - (19)].en.s)->StaticName );
					EmitStmtLbl( lbl );



					/*
					** Deal with the _finalize_ string here.
					*/

					_here;
					InvisibleCode = NULL;
					_if
					( 
							(yyvsp[(15) - (19)].s)->pType != tString 
						&&	(yyvsp[(15) - (19)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(15) - (19)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(15) - (19)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(15) - (19)].s)->u.strval );

					_endif
					
				_endif
				_here;

			;}
    break;

  case 631:

/* Line 1464 of yacc.c  */
#line 19449 "hlaparse.bsn"
    {			/* $22 */


				struct contextListType	*cNode;
				SymNode_t				*s;
				SymNode_t				*d;

				_here;
				
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_if( (yyvsp[(9) - (22)].options.UseFrame) )

					StoreValResParms( (yyvsp[(6) - (22)].en.s) );

				_endif

		

				
				--CurLexLevel;
				CurOffset = (yyvsp[(3) - (22)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (22)].v.u.unsval);
				



				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table.
				*/

				(yyvsp[(6) - (22)].en.s)->u.proc.Locals = SymbolTable;
				SymbolTable = (yyvsp[(6) - (22)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(6) - (22)].en.s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (22)].s);

				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();

				/*
				** Output the necessary data to the assembly language
				** file to complete this procedure.
				*/

				_if( (yyvsp[(9) - (22)].options.UseFrame) )

					StdExit
					( 
						(yyvsp[(7) - (22)].v.u.unsval), 
						(yyvsp[(6) - (22)].en.s)->u.proc.cs == cdecl_cs,
						(yyvsp[(9) - (22)].options.NoLeave) 
					);

				_endif
				EndProc( (yyvsp[(6) - (22)].en.s)->StaticName );
				endCseg();
				free2( vss (yyvsp[(18) - (22)].neID.idStr) );
				
				currentNS = (yyvsp[(6) - (22)].en.cns);

				inProcedure = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(9) - (22)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( cNode->label == (yyvsp[(2) - (22)].idStr) );
					free2( vss cNode->StaticName );

				_endif
				_here;
			;}
    break;

  case 632:

/* Line 1464 of yacc.c  */
#line 19556 "hlaparse.bsn"
    {				/* $8 */

			union YYSTYPE v;

			_here;
			assert( (yyvsp[(1) - (7)].idStr) != NULL );
			assert( (yyvsp[(5) - (7)].idStr) != NULL );

			v.v.u.strval = (yyvsp[(1) - (7)].idStr);
			InsertSym
			( 
				(yyvsp[(5) - (7)].idStr), 
				&text_ste,
				tText, 
				cConstant, 
				0,				/* arity 			*/
				NULL,			/* NumDimensions	*/
				0, 				/* NumElements		*/
				YYS &v,
				4,				/* ObjectSize		*/
				0,
				NULL,
				NULL,			/* Base				*/
				NULL,			/* Fields			*/
				0				/* FieldCnt			*/ 
			);

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;
		;}
    break;

  case 633:

/* Line 1464 of yacc.c  */
#line 19597 "hlaparse.bsn"
    {
				_here;
				(yyval.idStr) = (yyvsp[(0) - (2)].idStr);
			;}
    break;

  case 634:

/* Line 1464 of yacc.c  */
#line 19661 "hlaparse.bsn"
    {				/* $9 */

				int 					*dimension;
				SymNode_t 				value;
				struct contextListType	*p;
				char					exitname[ 256 ];
				union YYSTYPE			dummy;

				_here;

				CheckLegalOptions
				( 
					(yyvsp[(8) - (8)].options.SpecifiedOptions),
						specified_returns
					|	specified_use
					|	specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_noenter 
					|	specified_noleave
					|	specified_pascal
					|	specified_stdcall
					|	specified_cdecl
					|	specified_alignment 
				);

				
				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.  This allows recursive calls
				** to gain access to the parameter list and "returns"
				** value for this procedure.
				*/

				(yyvsp[(6) - (8)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(6) - (8)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(8) - (8)].options.returns);
				(yyvsp[(6) - (8)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(8) - (8)].options.use);


				/*
				** Okay, now set up the pointers for the main
				** symbol table entry.
				*/

				(yyvsp[(6) - (8)].en.s)->u.proc.parms = SymbolTable;
				CurOffsetDir = -1;
				(yyvsp[(6) - (8)].en.s)->u.proc.returns = (yyvsp[(8) - (8)].options.returns);
				(yyvsp[(6) - (8)].en.s)->u.proc.use = (yyvsp[(8) - (8)].options.use);
				
				CurOffset = StartLclOffs;
				_if( (yyvsp[(8) - (8)].options.UseDisplay) )

					CurOffset -= 4;

					/*
					** Create a symbol table entry for the display.
					*/

					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);
					CurOffset -= CurLexLevel * 4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(7) - (8)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);



				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.  Do not add it if there is no
				** frame generation.
				*/
				
				_if( (yyvsp[(8) - (8)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(2) - (8)].idStr);

					sprintf
					( 
						exitname, 
						"x%s" sympost, 
						(yyvsp[(6) - (8)].en.s)->StaticName 
					); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(8) - (8)].options.UseDisplay);
					p->SizeParms = (yyvsp[(7) - (8)].v.u.unsval);
					contextList = p;

				_endif

				// If the calling sequence reverses the parameters,
				// go in and swap all the offsets on the parameters:


				(yyvsp[(6) - (8)].en.s)->u.proc.cs = (yyvsp[(8) - (8)].options.CallingSequence);
				_if
				(
						(yyvsp[(8) - (8)].options.CallingSequence) == stdcall_cs
					||	(yyvsp[(8) - (8)].options.CallingSequence) == cdecl_cs
				)

					SymNode_t	*fixParms;
					int			offset;

					fixParms = (yyvsp[(6) - (8)].en.s)->u.proc.parms;

					offset = 8;
					_while( fixParms != NULL && fixParms != (yyvsp[(6) - (8)].en.s) )

						_if( fixParms->SymClass == cParm )

							fixParms->Offset = offset;
							
							// Round up to the next multiple of four:
							
							offset += ((( fixParms->ObjectSize + 3) >> 2) << 2);

						_endif
						fixParms = fixParms->Next;

					_endwhile


				_endif
				_here;
			;}
    break;

  case 635:

/* Line 1464 of yacc.c  */
#line 19857 "hlaparse.bsn"
    {				/* $14 */

				int					HadPassByValRes;
				int 				RoundedOffset;
				SymNode_t			*s;
				SymNode_t			*bt;
				SymNode_t			*d;
				SymNode_t			value;

				_here;
				inProcedure = 1;

				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(8) - (13)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(6) - (13)].en.s)->u.proc.parms;

					_while( s != NULL && s != (yyvsp[(6) - (13)].en.s) )

						bt = GetBaseType( s );
						_if
						( 
								bt->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)


							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = s->u.proc.Locals;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;

							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );

						_elseif( s->pClass == vrp_pc || s->pClass == result_pc  )

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(

								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif

				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** Don't count the size of the display as part
				** of the local variable count.
				*/

				_if( (yyvsp[(8) - (13)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);



				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				startCseg();
				_if( (yyvsp[(8) - (13)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(8) - (13)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(6) - (13)].en.s)->StaticName ); 
				_if( (yyvsp[(8) - (13)].options.UseFrame) && !(yyvsp[(8) - (13)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(8) - (13)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(8) - (13)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(8) - (13)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(8) - (13)].options.NoEnter) 
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(8) - (13)].options.AlignStk) )

						AlignStack();

					_endif



				
				/*
				** _else
				**
				** 		Don't do anything special if we're not emiting
				**		code to construct the stack frame.  Note that
				**		"noframe" automatically assumes "nodisplay" as
				**		far as code emission is concerned.
				*/

				_endif


				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(8) - (13)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(6) - (13)].en.s) );

				_endif


				assert( (yyvsp[(12) - (13)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(2) - (13)].idStr), (yyvsp[(12) - (13)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"procedure name <<%s>>",
						(yyvsp[(12) - (13)].neID.idStr),
						(yyvsp[(2) - (13)].idStr)
					);

					yyerror( msg );

				_endif

				/*
				** Check to ensure that all forward declared procedures
				** have been defined prior to code emission.
				*/

				CheckForwardDecls( (yyvsp[(6) - (13)].en.s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				CurrentContext = (yyvsp[(6) - (13)].en.s);
				free2( vss (yyvsp[(12) - (13)].neID.idStr) );


				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/

				
				(yyval.s) = lookup( "_finalize_", 1 );
				_if( (yyvsp[(8) - (13)].options.UseFrame) )
				
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
				_here;
			;}
    break;

  case 636:

/* Line 1464 of yacc.c  */
#line 20230 "hlaparse.bsn"
    {				/* $19 */


				_here;
				assert( (yyvsp[(17) - (18)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(2) - (18)].idStr), (yyvsp[(17) - (18)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"procedure name <<%s>>",
						(yyvsp[(17) - (18)].neID.idStr),
						(yyvsp[(2) - (18)].idStr)
					);

					yyerror( msg );

				_endif

				/*
				** Emit the exit label for this procedure.
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(8) - (18)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(6) - (18)].en.s)->StaticName );
					EmitStmtLbl( lbl );



					/*
					** Deal with the _finalize_ string here.
					*/

					_here;
					InvisibleCode = NULL;
					_if
					( 
							(yyvsp[(14) - (18)].s)->pType != tString 
						&&	(yyvsp[(14) - (18)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(14) - (18)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(14) - (18)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(14) - (18)].s)->u.strval );

					_endif
					
				_endif
				_here;

			;}
    break;

  case 637:

/* Line 1464 of yacc.c  */
#line 20299 "hlaparse.bsn"
    {			/* $22 */


				struct contextListType	*cNode;
				SymNode_t				*s;
				SymNode_t				*d;

				_here;
				
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_if( (yyvsp[(8) - (21)].options.UseFrame) )

					StoreValResParms( (yyvsp[(6) - (21)].en.s) );

				_endif

		

				
				--CurLexLevel;
				CurOffset = (yyvsp[(3) - (21)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (21)].v.u.unsval);
				



				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table.
				*/

				(yyvsp[(6) - (21)].en.s)->u.proc.Locals = SymbolTable;
				SymbolTable = (yyvsp[(6) - (21)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(6) - (21)].en.s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (21)].s);

				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();

				/*
				** Output the necessary data to the assembly language
				** file to complete this procedure.
				*/

				_if( (yyvsp[(8) - (21)].options.UseFrame) )

					StdExit
					( 
						(yyvsp[(7) - (21)].v.u.unsval), 
						(yyvsp[(6) - (21)].en.s)->u.proc.cs == cdecl_cs,
						(yyvsp[(8) - (21)].options.NoLeave) 
					);

				_endif
				EndProc( (yyvsp[(6) - (21)].en.s)->StaticName );
				endCseg();
				free2( vss (yyvsp[(17) - (21)].neID.idStr) );
				
				currentNS = (yyvsp[(6) - (21)].en.cns);

				inProcedure = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(8) - (21)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( cNode->label == (yyvsp[(2) - (21)].idStr) );
					free2( vss cNode->StaticName );

				_endif
				_here;
			;}
    break;

  case 638:

/* Line 1464 of yacc.c  */
#line 20406 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(-2) - (0)].idStr);
		;}
    break;

  case 639:

/* Line 1464 of yacc.c  */
#line 20468 "hlaparse.bsn"
    {				/* $10 */

				int 					*dimension;
				SymNode_t 				value;
				struct contextListType	*p;
				char					exitname[ 256 ];
				union YYSTYPE			dummy;
				
				short					CallingSequence;
				
				_here;
				_if( (yyvsp[(3) - (9)].s)->pType != tProcptr )
				
					char msg[256];
				
					sprintf
					( 
						msg,
						"Expected procedure type identifier after ':', "
						"found '%s'",
						(yyvsp[(3) - (9)].s)->TrueName
					);
					yyerror( msg );
				
				_endif
				CheckLegalOptions
				( 
					(yyvsp[(9) - (9)].options.SpecifiedOptions),
						specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_alignment 
					|	specified_noenter 
					|	specified_noleave
					|	specified_use
					|	specified_returns
					|	specified_stdcall
					|	specified_pascal
					|	specified_cdecl
				);
				
				_if( (yyvsp[(9) - (9)].options.SpecifiedOptions) & specified_stdcall )
				
					CallingSequence = stdcall_cs;
					
				_elseif( (yyvsp[(9) - (9)].options.SpecifiedOptions) & specified_cdecl )
				
					CallingSequence = cdecl_cs;
					
				_elseif( (yyvsp[(9) - (9)].options.SpecifiedOptions) & specified_pascal )
				
					CallingSequence = pascal_cs;
					
				_else
				
					CallingSequence = (yyvsp[(3) - (9)].s)->u.proc.cs;
					_if( (yyvsp[(3) - (9)].s)->u.proc.cs == stdcall_cs )
					
						(yyvsp[(9) - (9)].options.SpecifiedOptions) |= specified_stdcall;
						(yyvsp[(9) - (9)].options.CallingSequence) = stdcall_cs;	
					
					_elseif( (yyvsp[(3) - (9)].s)->u.proc.cs == cdecl_cs )
					
						(yyvsp[(9) - (9)].options.SpecifiedOptions) |= specified_cdecl;	
						(yyvsp[(9) - (9)].options.CallingSequence) = cdecl_cs;
						
					_endif	
				
				_endif
				(yyvsp[(8) - (9)].en.s)->u.proc.parms->u.proc.cs = CallingSequence;
				
				

				
				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.  This allows recursive calls
				** to gain access to the parameter list and "returns"
				** value for this procedure.
				*/
				
				copyProcPtrParms( (yyvsp[(3) - (9)].s) );

				(yyvsp[(8) - (9)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				_if( (yyvsp[(9) - (9)].options.SpecifiedOptions) & specified_returns )
				
					(yyvsp[(8) - (9)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
					(yyvsp[(8) - (9)].en.s)->u.proc.returns =	(yyvsp[(9) - (9)].options.returns);

				_else
				
					(yyvsp[(8) - (9)].en.s)->u.proc.parms->u.proc.returns = 
												(yyvsp[(3) - (9)].s)->u.proc.returns;
					(yyvsp[(8) - (9)].en.s)->u.proc.returns =	(yyvsp[(3) - (9)].s)->u.proc.returns;
				
				_endif
				_if( (yyvsp[(9) - (9)].options.SpecifiedOptions) & specified_use )
				
					(yyvsp[(8) - (9)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (9)].options.use);
					(yyvsp[(8) - (9)].en.s)->u.proc.use = (yyvsp[(9) - (9)].options.use);

				_else
				
					(yyvsp[(8) - (9)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(3) - (9)].s)->u.proc.use;
					(yyvsp[(8) - (9)].en.s)->u.proc.use = (yyvsp[(3) - (9)].s)->u.proc.use;
				
				_endif
				(yyvsp[(8) - (9)].en.s)->u.proc.ParmSize = (yyvsp[(3) - (9)].s)->u.proc.ParmSize;
				(yyvsp[(8) - (9)].en.s)->u.proc.parms->u.proc.ParmSize = (yyvsp[(3) - (9)].s)->u.proc.ParmSize;
				(yyvsp[(8) - (9)].en.s)->u.proc.parms = SymbolTable;
				CurOffsetDir = -1;
				
				CurOffset = StartLclOffs;
				_if( (yyvsp[(9) - (9)].options.UseDisplay) )

					CurOffset -= 4;

					/*
					** Create a symbol table entry for the display.
					*/

					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);
					CurOffset -= CurLexLevel * 4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(3) - (9)].s)->u.proc.ParmSize;
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);



				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.  Do not add it if there is no
				** frame generation.
				*/
				
				_if( (yyvsp[(9) - (9)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(1) - (9)].idStr);

					sprintf
					( 
						exitname, 
						"x%s" sympost, 
						(yyvsp[(8) - (9)].en.s)->StaticName 
					); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(9) - (9)].options.UseDisplay);
					p->SizeParms = (yyvsp[(3) - (9)].s)->u.proc.ParmSize;
					contextList = p;

				_endif

				// If the calling sequence reverses the parameters,
				// go in and swap all the offsets on the parameters:


				(yyvsp[(8) - (9)].en.s)->u.proc.cs = CallingSequence;
				_if( CallingSequence == stdcall_cs || CallingSequence == cdecl_cs )

					SymNode_t	*fixParms;
					int			offset;

					fixParms = (yyvsp[(8) - (9)].en.s)->u.proc.parms;

					offset = 8;
					_while( fixParms != NULL && fixParms != (yyvsp[(8) - (9)].en.s) )

						_if( fixParms->SymClass == cParm )

							fixParms->Offset = offset;
							
							// Round up to the next multiple of four:
							
							offset += ((( fixParms->ObjectSize + 3) >> 2) << 2);

						_endif
						fixParms = fixParms->Next;

					_endwhile


				_endif
				_here;
			;}
    break;

  case 640:

/* Line 1464 of yacc.c  */
#line 20723 "hlaparse.bsn"
    {				/* $15 */

				int					HadPassByValRes;
				int 				RoundedOffset;
				SymNode_t			*s;
				SymNode_t			*bt;
				SymNode_t			*d;
				SymNode_t			value;

				_here;
				inProcedure = 1;

				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(9) - (14)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(8) - (14)].en.s)->u.proc.parms;

					_while( s != NULL && s != (yyvsp[(8) - (14)].en.s) )

						bt = GetBaseType( s );
						_if
						( 
								bt->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)


							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = s->u.proc.Locals;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;

							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );

						_elseif( s->pClass == vrp_pc || s->pClass == result_pc  )

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(

								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif

				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** Don't count the size of the display as part
				** of the local variable count.
				*/

				_if( (yyvsp[(9) - (14)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);



				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				startCseg();
				_if( (yyvsp[(9) - (14)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(9) - (14)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(8) - (14)].en.s)->StaticName ); 
				_if( (yyvsp[(9) - (14)].options.UseFrame) && !(yyvsp[(9) - (14)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(9) - (14)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(9) - (14)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(9) - (14)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(9) - (14)].options.NoEnter) 
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(9) - (14)].options.AlignStk) )

						AlignStack();

					_endif



				
				/*
				** _else
				**
				** 		Don't do anything special if we're not emiting
				**		code to construct the stack frame.  Note that
				**		"noframe" automatically assumes "nodisplay" as
				**		far as code emission is concerned.
				*/

				_endif


				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(9) - (14)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(8) - (14)].en.s) );

				_endif


				assert( (yyvsp[(13) - (14)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(1) - (14)].idStr), (yyvsp[(13) - (14)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"procedure name <<%s>>",
						(yyvsp[(13) - (14)].neID.idStr),
						(yyvsp[(1) - (14)].idStr)
					);

					yyerror( msg );

				_endif

				/*
				** Check to ensure that all forward declared procedures
				** have been defined prior to code emission.
				*/

				CheckForwardDecls( (yyvsp[(8) - (14)].en.s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				CurrentContext = (yyvsp[(8) - (14)].en.s);
				free2( vss (yyvsp[(13) - (14)].neID.idStr) );


				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/

				
				(yyval.s) = lookup( "_finalize_", 1 );
				_if( (yyvsp[(9) - (14)].options.UseFrame) )
				
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif

			;}
    break;

  case 641:

/* Line 1464 of yacc.c  */
#line 21096 "hlaparse.bsn"
    {				/* $20 */


				_here;
				assert( (yyvsp[(18) - (19)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(1) - (19)].idStr), (yyvsp[(18) - (19)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"procedure name <<%s>>",
						(yyvsp[(18) - (19)].neID.idStr),
						(yyvsp[(1) - (19)].idStr)
					);

					yyerror( msg );

				_endif

				/*
				** Emit the exit label for this procedure.
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(9) - (19)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(8) - (19)].en.s)->StaticName );
					EmitStmtLbl( lbl );



					/*
					** Deal with the _finalize_ string here.
					*/

					_here;
					InvisibleCode = NULL;
					_if
					( 
							(yyvsp[(15) - (19)].s)->pType != tString 
						&&	(yyvsp[(15) - (19)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(15) - (19)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(15) - (19)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(15) - (19)].s)->u.strval );

					_endif
					
				_endif
				_here;

			;}
    break;

  case 642:

/* Line 1464 of yacc.c  */
#line 21165 "hlaparse.bsn"
    {			/* $22 */


				struct contextListType	*cNode;
				SymNode_t				*s;
				SymNode_t				*d;

				_here;
				
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_if( (yyvsp[(9) - (22)].options.UseFrame) )

					StoreValResParms( (yyvsp[(8) - (22)].en.s) );

				_endif

		

				
				--CurLexLevel;
				CurOffset = (yyvsp[(5) - (22)].v.u.unsval);
				CurOffsetDir = (yyvsp[(6) - (22)].v.u.unsval);
				



				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table.
				*/

				(yyvsp[(8) - (22)].en.s)->u.proc.Locals = SymbolTable;
				SymbolTable = (yyvsp[(8) - (22)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(8) - (22)].en.s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(7) - (22)].s);

				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();

				/*
				** Output the necessary data to the assembly language
				** file to complete this procedure.
				*/

				_if( (yyvsp[(9) - (22)].options.UseFrame) )
				

					StdExit
					( 
						(yyvsp[(3) - (22)].s)->u.proc.ParmSize, 
						(yyvsp[(8) - (22)].en.s)->u.proc.cs == cdecl_cs,
						(yyvsp[(9) - (22)].options.NoLeave) 
					);

				_endif
				EndProc( (yyvsp[(8) - (22)].en.s)->StaticName );
				endCseg();
			
				free2( vss (yyvsp[(18) - (22)].neID.idStr) );
				
				currentNS = (yyvsp[(8) - (22)].en.cns);

				inProcedure = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(9) - (22)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( cNode->label == (yyvsp[(1) - (22)].idStr) );
					free2( vss cNode->StaticName );

				_endif
				_here;
			;}
    break;

  case 643:

/* Line 1464 of yacc.c  */
#line 21334 "hlaparse.bsn"
    {					/* $10 */

			int 					*dimension;
			SymNode_t 				value;
			struct contextListType	*p;
			char					exitname[ 256 ];
			union YYSTYPE			dummy;

			_here;

			CheckLegalOptions
			( 
				(yyvsp[(9) - (9)].options.SpecifiedOptions),
					specified_noframe 
				|	specified_nodisplay 
				|	specified_noalignstk 
				|	specified_alignment 
				|	specified_noenter 
				|	specified_noleave 
				|	specified_use
			);


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.  This allows recursive calls
			** to gain access to the parameter list and "returns"
			** value for this procedure.
			*/


			(yyvsp[(6) - (9)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(6) - (9)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
			(yyvsp[(6) - (9)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (9)].options.use);

			/*
			** Okay, now set up the pointers for the main
			** symbol table entry.
			*/

			(yyvsp[(6) - (9)].en.s)->u.proc.parms = SymbolTable;
			CurOffsetDir = -1;
			(yyvsp[(6) - (9)].en.s)->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
			(yyvsp[(6) - (9)].en.s)->u.proc.use = (yyvsp[(9) - (9)].options.use);
			CurOffset = StartLclOffs;

			// Iterators always use the pascal calling sequence:
			
			(yyvsp[(6) - (9)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(6) - (9)].en.s)->u.proc.cs = pascal_cs;

			/*
			** Create a symbol table entry for the "yield" thunk.
			*/

			InsertSym
			( 
				"yield", 
				&thunk_ste,	/* Type			*/
				tThunk, 	/* pType		*/
				cVar,		/* SymClass		*/ 
				0,			/* Arity		*/
				NULL,		/* dimensions	*/
				0, 			/* # elements	*/
				NULL,		/* Value		*/
				8,			/* ObjectSize	*/
				0,			/* Offset 		*/
				NULL,		/* StaticName	*/
				NULL,		/* Base			*/
				NULL,		/* Fields		*/
				0			/* FieldCnt		*/
			);

			/*
			** Thunks (yield) don't have any parameters,
			** but we can't leave proc.parms NULL (since other
			** code treats this as an error).  Just give each
			** Yield thunk a set of local constants which are
			** the lex level zero constants.
			*/
			
			SymbolTable->u.proc.parms = &true_ste;


			_if( (yyvsp[(9) - (9)].options.UseDisplay) )

				CurOffset -= 4;

				/*
				** Create a symbol table entry for the display.
				*/

				dimension = malloc2( sizeofInt );
				*dimension = CurLexLevel + 1;
				InsertSym
				( 
					"_display_", 
					&dword_ste,
					tDWord, 
					cVar, 
					1,
					dimension,
					*dimension, 
					NULL,
					*dimension*4,
					CurOffset,
					NULL,
					NULL,
					NULL,
					0
				);
				CurOffset -= CurLexLevel * 4;

			_endif

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);

			value.u.unsval = (yyvsp[(7) - (9)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);


			/*
			** Add this procedure to the context list so we
			** can bail on this procedure via the EXIT and EXITIF
			** statements.
			*/
			
			_if( (yyvsp[(9) - (9)].options.UseFrame) )

				p = malloc2( sizeofContextListType );
				p->Next = contextList;
				p->label = (yyvsp[(2) - (9)].idStr);

				sprintf( exitname, "x%s" sympost, (yyvsp[(6) - (9)].en.s)->StaticName ); 
				p->StaticName = hlastrdup2( exitname );
				p->LexLevel = CurLexLevel;
				p->IsProc = 1;
				p->HasDisplay = (yyvsp[(9) - (9)].options.UseDisplay);
				p->SizeParms = (yyvsp[(7) - (9)].v.u.unsval);
				contextList = p;

			_endif


			_here;
		;}
    break;

  case 644:

/* Line 1464 of yacc.c  */
#line 21525 "hlaparse.bsn"
    {				/* $15 */

			int 		RoundedOffset;
			SymNode_t	value;
			SymNode_t	*s;
			SymNode_t	*bt;
			SymNode_t	*d;
			int			HadPassByValRes;

			_here;
			inIterator = 1;




			/*
			** Check for pass by value/result or pass by result
			** parameters because we need to allocate local
			** storage for these.
			*/
			
			_if( (yyvsp[(9) - (14)].options.UseFrame) )

				HadPassByValRes = 0;
				s = (yyvsp[(6) - (14)].en.s)->u.proc.parms;
				_while( s != NULL && s != (yyvsp[(6) - (14)].en.s) )

					bt = GetBaseType( s );
					_if
					( 
							bt->pType == tProcptr 
						&&	(
									s->pClass == vrp_pc 
								||	s->pClass == result_pc
							)
					)

						CurOffset = CurOffset - 4;
						InsertSym
						(
							s->TrueName, 
							NULL,				/* Type			*/
							tProcptr,		 	/* pType		*/
							cVar,				/* SymClass		*/ 
							s->Arity,			/* Arity		*/
							s->Dimensions,		/* dimensions	*/
							s->NumElements,		/* # elements	*/
							NULL,				/* Value		*/
							4,					/* ObjectSize	*/
							CurOffset,			/* Offset 		*/
							s->StaticName,		/* StaticName	*/
							s->Base,			/* Base			*/
							s->Fields,			/* Fields		*/
							s->FieldCnt			/* FieldCnt		*/
						);
						d = SymbolTable;
						d->u.proc.returns = hlastrdup2( "" );
						d->u.proc.use = s->u.proc.use;
						d->u.proc.parms = s->u.proc.parms;
						d->u.proc.Locals = s->u.proc.Locals;
						d->u.proc.Forward = s->u.proc.Forward;
						d->u.proc.BaseClass = s->u.proc.BaseClass;
						d->u.proc.ParmSize = s->u.proc.ParmSize;
						d->u.proc.cs = s->u.proc.cs;

						// Insert a dummy type for the parameter list.
						
						InsertSym
						(
							" (procptr type) ", 
							NULL,				/* Type			*/
							tProcptr,		 	/* pType		*/
							cType,				/* SymClass		*/ 
							0,					/* Arity		*/
							NULL,				/* dimensions	*/
							0,					/* # elements	*/
							NULL,				/* Value		*/
							4,					/* ObjectSize	*/
							0,					/* Offset 		*/
							NULL,				/* StaticName	*/
							NULL,				/* Base			*/
							NULL,				/* Fields		*/
							0					/* FieldCnt		*/
						);
						SymbolTable->u.proc.parms = s->u.proc.parms;
						SymbolTable->u.proc.returns = d->u.proc.returns;
						SymbolTable->u.proc.use = s->u.proc.use;
						SymbolTable->u.proc.Locals = s->u.proc.Locals;
						SymbolTable->u.proc.Forward = s->u.proc.Forward;
						SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
						SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
						SymbolTable->u.proc.cs = s->u.proc.cs;
						d->Type = SymbolTable;
						SymbolTable = d;

						HadPassByValRes = 
							HadPassByValRes || (s->pClass == vrp_pc );


					_elseif( s->pClass == vrp_pc || s->pClass == result_pc  )

						assert( s->Type != NULL );
						CurOffset = CurOffset - s->Type->ObjectSize;
						InsertSym
						(
							s->TrueName, 
							s->Type,			/* Type			*/
							s->Type->pType, 	/* pType		*/
							cVar,				/* SymClass		*/ 
							s->Arity,			/* Arity		*/
							s->Dimensions,		/* dimensions	*/
							s->NumElements,		/* # elements	*/
							NULL,				/* Value		*/
							s->Type->ObjectSize,/* ObjectSize	*/
							CurOffset,			/* Offset 		*/
							s->StaticName,		/* StaticName	*/
							s->Base,			/* Base			*/
							s->Fields,			/* Fields		*/
							s->FieldCnt			/* FieldCnt		*/
						);

						HadPassByValRes = 
							HadPassByValRes | (s->pClass == vrp_pc );

					_endif
					s = s->Next;

				_endwhile

			_endif



			/*
			** Compute the number of bytes of local variables
			** and round this number to the larger multiple of
			** four bytes.
			*/

			RoundedOffset = -CurOffset;
			_if( RoundedOffset != ( RoundedOffset & ~3 ))

				RoundedOffset = ( RoundedOffset + 4 ) & ~3;

			_endif

			/*
			** Don't count the size of the display as part
			** of the local variable count.
			*/

			_if( (yyvsp[(9) - (14)].options.UseDisplay) )

				RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

			_endif

			/*
			** Create a symbol table entry for the # of bytes
			** of local variables in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = RoundedOffset;
			InsertSym
			( 
				"_vars_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);



			/*
			** Output the assembly code for this procedure.
			**
			** For nested procedures (lex level 2 and above)
			** we need to emit the display
			*/


			startCseg();
			_if( (yyvsp[(9) - (14)].options.Alignment) != 1 )

				EmitAlign( (yyvsp[(9) - (14)].options.Alignment) ); 

			_endif
			StartProc( (yyvsp[(6) - (14)].en.s)->StaticName );
			_if( (yyvsp[(9) - (14)].options.UseFrame) && !(yyvsp[(9) - (14)].options.UseDisplay) )


				/*
				** If we're not building a display, just use the
				** standard entry sequence.
				*/

				StdEntry( RoundedOffset, (yyvsp[(9) - (14)].options.NoEnter) );

				/*
				** Align the stack on a dword boundary.
				*/

				_if( AlwaysAlignStk  && (yyvsp[(9) - (14)].options.AlignStk) )

					AlignStack();

				_endif

			_elseif( (yyvsp[(9) - (14)].options.UseFrame) )

				/*
				** We've got to construct the display.
				*/

				ConstructDisplay
				( 
					CurLexLevel, 
					RoundedOffset,
					(yyvsp[(9) - (14)].options.NoEnter) 
				);

				/*
				** Align the stack on a dword boundary.
				*/

				_if( AlwaysAlignStk && (yyvsp[(9) - (14)].options.AlignStk) )

					AlignStack();

				_endif


			/*
			** _else
			**
			** 		Don't do anything special if we're not emiting
			**		code to construct the stack frame.  Note that
			**		"noframe" automatically assumes "nodisplay" as
			**		far as code emission is concerned.
			*/

			_endif




			/*
			** If we have any pass by value/result parameters, emit
			** code to copy the data into the local storage allocated
			** to hold the parameter.  Note that we do not copy pass
			** by result parameters here because they are "out only"
			** variables.
			*/

			_if( (yyvsp[(9) - (14)].options.UseFrame) && HadPassByValRes )

				CopyValResParms( (yyvsp[(6) - (14)].en.s) );

			_endif






			assert( (yyvsp[(13) - (14)].neID.idStr) != NULL );

			_if( _strne( (yyvsp[(2) - (14)].idStr), (yyvsp[(13) - (14)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				( 
					msg,
					"Identifier <<%s>> after 'begin' must match "
					"iterator name <<%s>>",
					(yyvsp[(13) - (14)].neID.idStr),
					(yyvsp[(2) - (14)].idStr)
				);

				yyerror( msg );

			_endif

			/*
			** Check to ensure that all forward declared procedures
			** have been defined prior to code emission.
			*/

			CheckForwardDecls( (yyvsp[(6) - (14)].en.s) );

			/*
			** Check to make sure all pointer forward references have
			** been resolved.
			*/

			CheckPtrs();

			CurrentContext = (yyvsp[(6) - (14)].en.s);
			free2( vss (yyvsp[(13) - (14)].neID.idStr) );

			/*
			** Emit the text associated with the _initialize_ string
			** at this point.
			**
			**	Note: the "InvisibleCode" variable is used by
			**	yyerror to determine if it should print the
			**	_initialize_ string as part of the error message.
			*/

			
			(yyval.s) = lookup( "_finalize_", 1 );
			assert( (yyval.s) != NULL );
			_if( (yyvsp[(9) - (14)].options.UseFrame) )
			
				s=(yyval.s)->Next;
				InvisibleCode = NULL;
				_if
				( 
						s->pType != tString 
					&&	s->pType != tZString 
				)

					WarnNear
					( 
						"_initialize_'s type is not string.  "
						"Initialization ignored.",
						"_initialize_" 
					);

				_elseif( strlen( s->u.strval ) != 0 )

					InvisibleCode = s->u.strval;
					PushBackStr( "\xF3" );
					PushBackStr( s->u.strval );

				_endif
				
			_endif
			_here;

		;}
    break;

  case 645:

/* Line 1464 of yacc.c  */
#line 21909 "hlaparse.bsn"
    {				/* $20 */

			_here;
			assert( (yyvsp[(18) - (19)].neID.idStr) != NULL );

			_if( _strne( (yyvsp[(2) - (19)].idStr), (yyvsp[(18) - (19)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				( 
					msg,
					"Identifier <<%s>> after 'end' must match "
					"iterator name <<%s>>",
					(yyvsp[(18) - (19)].neID.idStr),
					(yyvsp[(2) - (19)].idStr)
				);

				yyerror( msg );

			_endif


			/*
			** Emit the label at the end of the procedure
			*/

			PushBackStr( "end" );
			_if( (yyvsp[(9) - (19)].options.UseFrame) )

				char lbl[256];
				
				sprintf( lbl, "x%s" sympost, (yyvsp[(6) - (19)].en.s)->StaticName );
				EmitStmtLbl( lbl );

				/*
				** Deal with the _finalize_ string here.
				*/

				InvisibleCode = NULL;
				_if
				( 
						(yyvsp[(15) - (19)].s)->pType != tString 
					&&	(yyvsp[(15) - (19)].s)->pType != tZString 
				)

					WarnNear
					(
						"_finalize_ must be a string constant.  Value ignored",
						"_finalize_"
					);

				_elseif( strlen( (yyvsp[(15) - (19)].s)->u.strval ) != 0 )

					InvisibleCode = (yyvsp[(15) - (19)].s)->u.strval;
					PushBackStr( "\xF3" );
					PushBackStr( (yyvsp[(15) - (19)].s)->u.strval );

				_endif
				
			_endif
			_here;
		;}
    break;

  case 646:

/* Line 1464 of yacc.c  */
#line 21974 "hlaparse.bsn"
    {			/* $22 */

			struct contextListType	*cNode;
			SymNode_t				*s;
			SymNode_t				*d;

			_here;
	
			/*
			** If we've got any pass by value/result or
			** pass by result parameters, we've got to
			** copy the data back to the caller at this point.
			*/

			_if( (yyvsp[(9) - (22)].options.UseFrame) )

				StoreValResParms( (yyvsp[(6) - (22)].en.s) );

			_endif




			
			--CurLexLevel;
			CurOffset = (yyvsp[(3) - (22)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (22)].v.u.unsval);
			



			/*
			** Remove this iterator's local symbols from
			** further consideration in the symbol table.
			*/

			(yyvsp[(6) - (22)].en.s)->u.proc.Locals = SymbolTable;
			SymbolTable = (yyvsp[(6) - (22)].en.s);


			/*
			** See if there are any outstanding undefined static
			** objects at lex level zero.
			*/

			CurrentContext = (yyvsp[(6) - (22)].en.s);
			CheckStatic( StaticList, 0 );
			CurrentContext = (yyvsp[(5) - (22)].s);

			/*
			** See if there are any outstanding forward reference
			** labels.
			*/

			CheckFwdRef();

			/*
			** Output the necessary data to the assembly language
			** file to complete this iterator.
			*/

			_if( (yyvsp[(9) - (22)].options.UseFrame) )

				IteratorExit( (yyvsp[(7) - (22)].v.u.unsval) ); 

			_endif
			EndProc( (yyvsp[(6) - (22)].en.s)->StaticName ); 
			endCseg();
			free2( vss (yyvsp[(18) - (22)].neID.idStr) );


			/*
			** Restore currentNS and inIterator values:
			*/
			
			currentNS = (yyvsp[(6) - (22)].en.cns);
			inIterator = 0;

			/*
			** Remove the current context from the context stack.
			*/
			
			_if( (yyvsp[(9) - (22)].options.UseFrame) )

				assert( contextList != NULL );
				cNode = contextList;
				contextList = cNode->Next;

				assert( cNode->label == (yyvsp[(2) - (22)].idStr) );
				free2( vss cNode->StaticName );

			_endif
			_here;
		;}
    break;

  case 647:

/* Line 1464 of yacc.c  */
#line 22149 "hlaparse.bsn"
    {					/* $9 */

			int 					*dimension;
			SymNode_t 				value;
			struct contextListType	*p;
			char					exitname[ 256 ];
			union YYSTYPE			dummy;

			_here;

			CheckLegalOptions
			( 
				(yyvsp[(8) - (8)].options.SpecifiedOptions),
					specified_noframe 
				|	specified_nodisplay 
				|	specified_noalignstk 
				|	specified_alignment 
				|	specified_noenter 
				|	specified_noleave 
				|	specified_use
			);


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.  This allows recursive calls
			** to gain access to the parameter list and "returns"
			** value for this procedure.
			*/


			(yyvsp[(6) - (8)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(6) - (8)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(8) - (8)].options.returns);
			(yyvsp[(6) - (8)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(8) - (8)].options.use);

			/*
			** Okay, now set up the pointers for the main
			** symbol table entry.
			*/

			(yyvsp[(6) - (8)].en.s)->u.proc.parms = SymbolTable;
			CurOffsetDir = -1;
			(yyvsp[(6) - (8)].en.s)->u.proc.returns = (yyvsp[(8) - (8)].options.returns);
			(yyvsp[(6) - (8)].en.s)->u.proc.use = (yyvsp[(8) - (8)].options.use);
			CurOffset = StartLclOffs;

			// Iterators always use the pascal calling sequence:
			
			(yyvsp[(6) - (8)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(6) - (8)].en.s)->u.proc.cs = pascal_cs;

			/*
			** Create a symbol table entry for the "yield" thunk.
			*/

			InsertSym
			( 
				"yield", 
				&thunk_ste,	/* Type			*/
				tThunk, 	/* pType		*/
				cVar,		/* SymClass		*/ 
				0,			/* Arity		*/
				NULL,		/* dimensions	*/
				0, 			/* # elements	*/
				NULL,		/* Value		*/
				8,			/* ObjectSize	*/
				0,			/* Offset 		*/
				NULL,		/* StaticName	*/
				NULL,		/* Base			*/
				NULL,		/* Fields		*/
				0			/* FieldCnt		*/
			);

			/*
			** Thunks (yield) don't have any parameters,
			** but we can't leave proc.parms NULL (since other
			** code treats this as an error).  Just give each
			** Yield thunk a set of local constants which are
			** the lex level zero constants.
			*/
			
			SymbolTable->u.proc.parms = &true_ste;


			_if( (yyvsp[(8) - (8)].options.UseDisplay) )

				CurOffset -= 4;

				/*
				** Create a symbol table entry for the display.
				*/

				dimension = malloc2( sizeofInt );
				*dimension = CurLexLevel + 1;
				InsertSym
				( 
					"_display_", 
					&dword_ste,
					tDWord, 
					cVar, 
					1,
					dimension,
					*dimension, 
					NULL,
					*dimension*4,
					CurOffset,
					NULL,
					NULL,
					NULL,
					0
				);
				CurOffset -= CurLexLevel * 4;

			_endif

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);

			value.u.unsval = (yyvsp[(7) - (8)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);


			/*
			** Add this procedure to the context list so we
			** can bail on this procedure via the EXIT and EXITIF
			** statements.
			*/
			
			_if( (yyvsp[(8) - (8)].options.UseFrame) )

				p = malloc2( sizeofContextListType );
				p->Next = contextList;
				p->label = (yyvsp[(2) - (8)].idStr);

				sprintf( exitname, "x%s" sympost, (yyvsp[(6) - (8)].en.s)->StaticName ); 
				p->StaticName = hlastrdup2( exitname );
				p->LexLevel = CurLexLevel;
				p->IsProc = 1;
				p->HasDisplay = (yyvsp[(8) - (8)].options.UseDisplay);
				p->SizeParms = (yyvsp[(7) - (8)].v.u.unsval);
				contextList = p;

			_endif


			_here;
		;}
    break;

  case 648:

/* Line 1464 of yacc.c  */
#line 22340 "hlaparse.bsn"
    {				/* $14 */

			int 			RoundedOffset;
			SymNode_t		value;
			SymNode_t 		*s;
			SymNode_t 		*bt;
			SymNode_t 		*d;
			int				HadPassByValRes;

			_here;
			inIterator = 1;




			/*
			** Check for pass by value/result or pass by result
			** parameters because we need to allocate local
			** storage for these.
			*/
			
			_if( (yyvsp[(8) - (13)].options.UseFrame) )

				HadPassByValRes = 0;
				s = (yyvsp[(6) - (13)].en.s)->u.proc.parms;
				_while( s != NULL && s != (yyvsp[(6) - (13)].en.s) )

					bt = GetBaseType( s );
					_if
					( 
							bt->pType == tProcptr 
						&&	(
									s->pClass == vrp_pc 
								||	s->pClass == result_pc
							)
					)

						CurOffset = CurOffset - 4;
						InsertSym
						(
							s->TrueName, 
							NULL,				/* Type			*/
							tProcptr,		 	/* pType		*/
							cVar,				/* SymClass		*/ 
							s->Arity,			/* Arity		*/
							s->Dimensions,		/* dimensions	*/
							s->NumElements,		/* # elements	*/
							NULL,				/* Value		*/
							4,					/* ObjectSize	*/
							CurOffset,			/* Offset 		*/
							s->StaticName,		/* StaticName	*/
							s->Base,			/* Base			*/
							s->Fields,			/* Fields		*/
							s->FieldCnt			/* FieldCnt		*/
						);
						d = SymbolTable;
						d->u.proc.returns = hlastrdup2( "" );
						d->u.proc.use = s->u.proc.use;
						d->u.proc.parms = s->u.proc.parms;
						d->u.proc.Locals = s->u.proc.Locals;
						d->u.proc.Forward = s->u.proc.Forward;
						d->u.proc.BaseClass = s->u.proc.BaseClass;
						d->u.proc.ParmSize = s->u.proc.ParmSize;
						d->u.proc.cs = s->u.proc.cs;

						// Insert a dummy type for the parameter list.
						
						InsertSym
						(
							" (procptr type) ", 
							NULL,				/* Type			*/
							tProcptr,		 	/* pType		*/
							cType,				/* SymClass		*/ 
							0,					/* Arity		*/
							NULL,				/* dimensions	*/
							0,					/* # elements	*/
							NULL,				/* Value		*/
							4,					/* ObjectSize	*/
							0,					/* Offset 		*/
							NULL,				/* StaticName	*/
							NULL,				/* Base			*/
							NULL,				/* Fields		*/
							0					/* FieldCnt		*/
						);
						SymbolTable->u.proc.parms = s->u.proc.parms;
						SymbolTable->u.proc.returns = d->u.proc.returns;
						SymbolTable->u.proc.use = s->u.proc.use;
						SymbolTable->u.proc.Locals = s->u.proc.Locals;
						SymbolTable->u.proc.Forward = s->u.proc.Forward;
						SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
						SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
						SymbolTable->u.proc.cs = s->u.proc.cs;
						d->Type = SymbolTable;
						SymbolTable = d;

						HadPassByValRes = 
							HadPassByValRes || (s->pClass == vrp_pc );


					_elseif( s->pClass == vrp_pc || s->pClass == result_pc  )

						assert( s->Type != NULL );
						CurOffset = CurOffset - s->Type->ObjectSize;
						InsertSym
						(
							s->TrueName, 
							s->Type,			/* Type			*/
							s->Type->pType, 	/* pType		*/
							cVar,				/* SymClass		*/ 
							s->Arity,			/* Arity		*/
							s->Dimensions,		/* dimensions	*/
							s->NumElements,		/* # elements	*/
							NULL,				/* Value		*/
							s->Type->ObjectSize,/* ObjectSize	*/
							CurOffset,			/* Offset 		*/
							s->StaticName,		/* StaticName	*/
							s->Base,			/* Base			*/
							s->Fields,			/* Fields		*/
							s->FieldCnt			/* FieldCnt		*/
						);

						HadPassByValRes = 
							HadPassByValRes | (s->pClass == vrp_pc );

					_endif
					s = s->Next;

				_endwhile

			_endif



			/*
			** Compute the number of bytes of local variables
			** and round this number to the larger multiple of
			** four bytes.
			*/

			RoundedOffset = -CurOffset;
			_if( RoundedOffset != ( RoundedOffset & ~3 ))

				RoundedOffset = ( RoundedOffset + 4 ) & ~3;

			_endif

			/*
			** Don't count the size of the display as part
			** of the local variable count.
			*/

			_if( (yyvsp[(8) - (13)].options.UseDisplay) )

				RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

			_endif

			/*
			** Create a symbol table entry for the # of bytes
			** of local variables in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = RoundedOffset;
			InsertSym
			( 
				"_vars_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);



			/*
			** Output the assembly code for this procedure.
			**
			** For nested procedures (lex level 2 and above)
			** we need to emit the display
			*/


			startCseg();
			_if( (yyvsp[(8) - (13)].options.Alignment) != 1 )

				EmitAlign( (yyvsp[(8) - (13)].options.Alignment) ); 

			_endif
			StartProc( (yyvsp[(6) - (13)].en.s)->StaticName );
			_if( (yyvsp[(8) - (13)].options.UseFrame) && !(yyvsp[(8) - (13)].options.UseDisplay) )


				/*
				** If we're not building a display, just use the
				** standard entry sequence.
				*/

				StdEntry( RoundedOffset, (yyvsp[(8) - (13)].options.NoEnter) );

				/*
				** Align the stack on a dword boundary.
				*/

				_if( AlwaysAlignStk  && (yyvsp[(8) - (13)].options.AlignStk) )

					AlignStack();

				_endif

			_elseif( (yyvsp[(8) - (13)].options.UseFrame) )

				/*
				** We've got to construct the display.
				*/

				ConstructDisplay
				( 
					CurLexLevel, 
					RoundedOffset,
					(yyvsp[(8) - (13)].options.NoEnter) 
				);

				/*
				** Align the stack on a dword boundary.
				*/

				_if( AlwaysAlignStk && (yyvsp[(8) - (13)].options.AlignStk) )

					AlignStack();

				_endif


			/*
			** _else
			**
			** 		Don't do anything special if we're not emiting
			**		code to construct the stack frame.  Note that
			**		"noframe" automatically assumes "nodisplay" as
			**		far as code emission is concerned.
			*/

			_endif




			/*
			** If we have any pass by value/result parameters, emit
			** code to copy the data into the local storage allocated
			** to hold the parameter.  Note that we do not copy pass
			** by result parameters here because they are "out only"
			** variables.
			*/

			_if( (yyvsp[(8) - (13)].options.UseFrame) && HadPassByValRes )

				CopyValResParms( (yyvsp[(6) - (13)].en.s) );

			_endif






			assert( (yyvsp[(12) - (13)].neID.idStr) != NULL );

			_if( _strne( (yyvsp[(2) - (13)].idStr), (yyvsp[(12) - (13)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				( 
					msg,
					"Identifier <<%s>> after 'begin' must match "
					"iterator name <<%s>>",
					(yyvsp[(12) - (13)].neID.idStr),
					(yyvsp[(2) - (13)].idStr)
				);

				yyerror( msg );

			_endif

			/*
			** Check to ensure that all forward declared procedures
			** have been defined prior to code emission.
			*/

			CheckForwardDecls( (yyvsp[(6) - (13)].en.s) );

			/*
			** Check to make sure all pointer forward references have
			** been resolved.
			*/

			CheckPtrs();

			CurrentContext = (yyvsp[(6) - (13)].en.s);
			free2( vss (yyvsp[(12) - (13)].neID.idStr) );

			/*
			** Emit the text associated with the _initialize_ string
			** at this point.
			**
			**	Note: the "InvisibleCode" variable is used by
			**	yyerror to determine if it should print the
			**	_initialize_ string as part of the error message.
			*/

			
			(yyval.s) = lookup( "_finalize_", 1 );
			assert( (yyval.s) != NULL );
			_if( (yyvsp[(8) - (13)].options.UseFrame) )
			
				s=(yyval.s)->Next;
				InvisibleCode = NULL;
				_if
				( 
						s->pType != tString 
					&&	s->pType != tZString 
				)

					WarnNear
					( 
						"_initialize_'s type is not string.  "
						"Initialization ignored.",
						"_initialize_" 
					);

				_elseif( strlen( s->u.strval ) != 0 )

					InvisibleCode = s->u.strval;
					PushBackStr( "\xF3" );
					PushBackStr( s->u.strval );

				_endif
				
			_endif
			_here;

		;}
    break;

  case 649:

/* Line 1464 of yacc.c  */
#line 22724 "hlaparse.bsn"
    {				/* $19 */

			_here;
			assert( (yyvsp[(17) - (18)].neID.idStr) != NULL );

			_if( _strne( (yyvsp[(2) - (18)].idStr), (yyvsp[(17) - (18)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				( 
					msg,
					"Identifier <<%s>> after 'end' must match "
					"iterator name <<%s>>",
					(yyvsp[(17) - (18)].neID.idStr),
					(yyvsp[(2) - (18)].idStr)
				);

				yyerror( msg );

			_endif


			/*
			** Emit the label at the end of the procedure
			*/

			PushBackStr( "end" );
			_if( (yyvsp[(8) - (18)].options.UseFrame) )

				char lbl[256];
				
				sprintf( lbl, "x%s" sympost, (yyvsp[(6) - (18)].en.s)->StaticName );
				EmitStmtLbl( lbl );

				/*
				** Deal with the _finalize_ string here.
				*/

				InvisibleCode = NULL;
				_if
				( 
						(yyvsp[(14) - (18)].s)->pType != tString 
					&&	(yyvsp[(14) - (18)].s)->pType != tZString 
				)

					WarnNear
					(
						"_finalize_ must be a string constant.  Value ignored",
						"_finalize_"
					);

				_elseif( strlen( (yyvsp[(14) - (18)].s)->u.strval ) != 0 )

					InvisibleCode = (yyvsp[(14) - (18)].s)->u.strval;
					PushBackStr( "\xF3" );
					PushBackStr( (yyvsp[(14) - (18)].s)->u.strval );

				_endif
				
			_endif
			_here;
		;}
    break;

  case 650:

/* Line 1464 of yacc.c  */
#line 22789 "hlaparse.bsn"
    {			/* $22 */

			struct contextListType	*cNode;
			SymNode_t				*s;
			SymNode_t				*d;

			_here;
	
			/*
			** If we've got any pass by value/result or
			** pass by result parameters, we've got to
			** copy the data back to the caller at this point.
			*/

			_if( (yyvsp[(8) - (21)].options.UseFrame) )

				StoreValResParms( (yyvsp[(6) - (21)].en.s) );

			_endif




			
			--CurLexLevel;
			CurOffset = (yyvsp[(3) - (21)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (21)].v.u.unsval);
			



			/*
			** Remove this iterator's local symbols from
			** further consideration in the symbol table.
			*/

			(yyvsp[(6) - (21)].en.s)->u.proc.Locals = SymbolTable;
			SymbolTable = (yyvsp[(6) - (21)].en.s);


			/*
			** See if there are any outstanding undefined static
			** objects at lex level zero.
			*/

			CurrentContext = (yyvsp[(6) - (21)].en.s);
			CheckStatic( StaticList, 0 );
			CurrentContext = (yyvsp[(5) - (21)].s);

			/*
			** See if there are any outstanding forward reference
			** labels.
			*/

			CheckFwdRef();

			/*
			** Output the necessary data to the assembly language
			** file to complete this iterator.
			*/

			_if( (yyvsp[(8) - (21)].options.UseFrame) )

				IteratorExit( (yyvsp[(7) - (21)].v.u.unsval) ); 

			_endif
			EndProc( (yyvsp[(6) - (21)].en.s)->StaticName ); 
			endCseg();
			free2( vss (yyvsp[(17) - (21)].neID.idStr) );


			/*
			** Restore currentNS and inIterator values:
			*/
			
			currentNS = (yyvsp[(6) - (21)].en.cns);
			inIterator = 0;

			/*
			** Remove the current context from the context stack.
			*/
			
			_if( (yyvsp[(8) - (21)].options.UseFrame) )

				assert( contextList != NULL );
				cNode = contextList;
				contextList = cNode->Next;

				assert( cNode->label == (yyvsp[(2) - (21)].idStr) );
				free2( vss cNode->StaticName );

			_endif
			_here;
		;}
    break;

  case 651:

/* Line 1464 of yacc.c  */
#line 22903 "hlaparse.bsn"
    { (yyval.s) = (yyvsp[(2) - (6)].s); ;}
    break;

  case 652:

/* Line 1464 of yacc.c  */
#line 22905 "hlaparse.bsn"
    {					/* $9 */

				SymNode_t				*s;
				char					msg[ 256 ];
				struct MethodListType	*FindProc;
				struct MethodListType	**PrevPtr;


				_here;

				/*
				** Save the current SymbolTable pointer so we
				** can find the end of the declarations later.
				*/

				(yyval.s) = SymbolTable;
				
				/*
				** Point ThisPtr at the current procedure ID
				** so we can access the class' fields (through
				** the proc.BaseClass field).
				*/
				
				ThisPtr = (yyvsp[(2) - (8)].s)->u.proc.BaseClass;

				/*
				** If the proc.Forward field contains NULL, then
				** we've already processed code corresponding to
				** this static procedure.  That means this is the
				** second occurrence of that procedure declaration
				** and we have a duplicate symbol definition.
				*/

				_if( (yyvsp[(2) - (8)].s)->u.proc.Forward == NULL )

					sprintf
					(
						msg,
						"Duplicate symbol <<%s>>",
						(yyvsp[(2) - (8)].s)->TrueName
					);
					yyerror( msg );
						

				_endif

				/*
				** Okay, this is the first declaration
				** of this procedure.  Point the SymbolTable
				** variable at this procedure's local vars
				** (that would just be the parameters, if any,
				** at this point) and mark the procedure as
				** processed.  Also, scan through the MethodList
				** and remove the reference to this procedure.
				*/

				SymbolTable = (yyvsp[(2) - (8)].s)->u.proc.Locals;
				(yyvsp[(2) - (8)].s)->u.proc.Forward = NULL;

				/*
				** Okay, remove the reference to this procedure
				** from the MethodList.
				*/

				FindProc = MethodList;
				PrevPtr = &MethodList;
				_while
				(
						FindProc != NULL 
					&&	FindProc->MethodSym != (yyvsp[(2) - (8)].s) 
				)

					PrevPtr = &FindProc->Next;
					FindProc = FindProc->Next;

				_endwhile

				_if( FindProc != NULL )

					*PrevPtr = FindProc->Next;
					free2( vss FindProc );

				_else

					yyerror
					( 
						"This class procedure has not been overridden" 
					);

				_endif


				/*
				** NULL terminate the local symbols for
				** use by FixSymbols
				*/

				s = SymbolTable;
				_while( s != NULL && s->Next != (yyvsp[(2) - (8)].s) )

					s = s->Next;

				_endwhile
				_if( s != NULL )

					s->Next = NULL;

				_endif

				_if( CurLexLevel != (yyvsp[(2) - (8)].s)->u.proc.BaseClass->LexLevel )

					yyerror
					( 
						"Class procedure declared at different lex level" 
					);

				_endif
				++CurLexLevel;
				CurOffset = StartLclOffs;
				CurOffsetDir = -1;
				_here;
			;}
    break;

  case 653:

/* Line 1464 of yacc.c  */
#line 23029 "hlaparse.bsn"
    {					/* $12 */

				char 					msg[ 256 ];
				int	 					*dimension;
				SymNode_t				*s;
				struct contextListType	*p;
				char					exitname[ 256 ];

				_here;
				CheckLegalOptions
				( 
					(yyvsp[(11) - (11)].options.SpecifiedOptions),
						specified_returns
					|	specified_use
					|	specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_noenter 
					|	specified_noleave
					|	specified_pascal
					|	specified_stdcall
					|	specified_cdecl
					|	specified_alignment 
				);
				CurrentContext = (yyvsp[(2) - (11)].s);
				_if( _strne( (yyvsp[(11) - (11)].options.returns), "" ))

					yyerror( "\"returns\" clause not allowed here" );
					free2( vss (yyvsp[(11) - (11)].options.returns) );

				_endif


				_if( (yyvsp[(11) - (11)].options.UseDisplay) )

					CurOffset -= ( CurLexLevel + 1 ) * 4;
					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);

				_endif





				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.
				*/
				
				_if( (yyvsp[(11) - (11)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(2) - (11)].s)->TrueName;

					sprintf( exitname, "x%s" sympost, (yyvsp[(2) - (11)].s)->StaticName ); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(11) - (11)].options.UseDisplay);
					p->SizeParms = (yyvsp[(2) - (11)].s)->u.proc.ParmSize;
					contextList = p;

				_endif

				(yyval.s) = (yyvsp[(9) - (11)].s); /* Required by FixSymbols */
				_here;
			;}
    break;

  case 654:

/* Line 1464 of yacc.c  */
#line 23143 "hlaparse.bsn"
    {				/* $19 */

				SymNode_t	*CurSym;
				int			RoundedOffset;
				SymNode_t	value;
				SymNode_t	*s;

				int			HadPassByValRes;
				SymNode_t	*d;

				_here;
				inProcedure = 1;


				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(11) - (18)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(2) - (18)].s)->u.proc.parms;
					_while( s != NULL && s != (yyvsp[(2) - (18)].s) )

						_if
						( 
								s->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)

							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = SymbolTable;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;


							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );


						_elseif( s->pClass == vrp_pc || s->pClass == result_pc  )

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(
								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes | (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif


				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** If we have a display, don't factor its size into
				** the # of bytes of local variables.
				*/

				_if( (yyvsp[(11) - (18)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);




				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				_if( (yyvsp[(2) - (18)].s)->IsExternal )

					EmitPublic( (yyvsp[(2) - (18)].s)->StaticName ); 

				_endif

				startCseg();
				_if( (yyvsp[(11) - (18)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(11) - (18)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(2) - (18)].s)->StaticName ); 
				_if( (yyvsp[(11) - (18)].options.UseFrame) && !(yyvsp[(11) - (18)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(11) - (18)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(11) - (18)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(11) - (18)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(11) - (18)].options.NoEnter) 
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(11) - (18)].options.AlignStk) )

						AlignStack();

					_endif

				_endif






				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(11) - (18)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(2) - (18)].s) );

				_endif








				assert( (yyvsp[(17) - (18)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(2) - (18)].s)->TrueName, (yyvsp[(17) - (18)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"procedure name <<%s>>",
						(yyvsp[(17) - (18)].neID.idStr),
						(yyvsp[(2) - (18)].s)->TrueName
					);

					yyerror( msg );

				_endif

				/*
				** Set up the Locals pointer to point at the
				** newly acquired local variables.
				*/

				(yyvsp[(2) - (18)].s)->u.proc.Locals = SymbolTable;


				/*
				** Check to ensure that all forward declared procedures
				** have been defined prior to code emission.
				*/

			
				CheckForwardDecls( (yyvsp[(9) - (18)].s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				/*
				** CurrentContext = $<s>2;
				*/

				free2( vss (yyvsp[(17) - (18)].neID.idStr) );


				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/
				
				(yyval.s) = lookup( "_finalize_", 1 );
				_if( (yyvsp[(11) - (18)].options.UseFrame) )
				
					assert( (yyval.s) != NULL );
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored.",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
				_here;

			;}
    break;

  case 655:

/* Line 1464 of yacc.c  */
#line 23535 "hlaparse.bsn"
    {			/* $24 */

				_here;
				assert( (yyvsp[(22) - (23)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(2) - (23)].s)->TrueName, (yyvsp[(22) - (23)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"procedure name <<%s>>",
						(yyvsp[(22) - (23)].neID.idStr),
						(yyvsp[(2) - (23)].s)->TrueName
					);

					yyerror( msg );

				_endif


				/*
				** Emit the label at the end of the procedure
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(11) - (23)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(2) - (23)].s)->StaticName );
					EmitStmtLbl( lbl );


					/*
					** Deal with the _finalize_ string here.
					*/

					InvisibleCode = NULL;
					_if
					( 
							(yyvsp[(19) - (23)].s)->pType != tString 
						&&	(yyvsp[(19) - (23)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(19) - (23)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(19) - (23)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(19) - (23)].s)->u.strval );

					_endif
					
				_endif
				_here;
			;}
    break;

  case 656:

/* Line 1464 of yacc.c  */
#line 23601 "hlaparse.bsn"
    {			/* $27 */


				struct contextListType	*cNode;
				SymNode_t				*s;
				SymNode_t				*d;


				_here;

	
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					StoreValResParms( (yyvsp[(2) - (26)].s) );

				_endif




				--CurLexLevel;
				CurOffset = (yyvsp[(3) - (26)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (26)].v.u.unsval);
				ThisPtr = (yyvsp[(6) - (26)].s);


				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table.
				*/

				//$<s>2->u.proc.BaseClass->u.proc.Locals = SymbolTable;
				(yyvsp[(2) - (26)].s)->u.proc.Locals = SymbolTable;
				(yyvsp[(13) - (26)].s)->Next = NULL;
				SymbolTable = (yyvsp[(9) - (26)].s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/


				CurrentContext = (yyvsp[(2) - (26)].s)->u.proc.BaseClass;
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (26)].s);



				/*
				** Output the necessary data to the assembly language
				** file to complete this procedure.
				*/

				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					StdExit
					( 
						(yyvsp[(2) - (26)].s)->u.proc.ParmSize, 
						(yyvsp[(2) - (26)].s)->u.proc.cs == cdecl_cs,
						(yyvsp[(11) - (26)].options.NoLeave) 
					); 

				_endif
				EndProc( (yyvsp[(2) - (26)].s)->StaticName ); 
				endCseg();


				
				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();

				free2( vss (yyvsp[(22) - (26)].neID.idStr) );

				/*
				** Restore currentNS:
				*/
				
				currentNS = (yyvsp[(14) - (26)].ru.saveCurNS);
				
				
				
				inProcedure = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( _streq( cNode->label, (yyvsp[(2) - (26)].s)->TrueName) );
					free2( vss cNode->StaticName );

				_endif
				(void) (yyvsp[(7) - (26)].s);	// To shut up bison
				(void) (yyvsp[(12) - (26)].s);
				_here;
			;}
    break;

  case 657:

/* Line 1464 of yacc.c  */
#line 23727 "hlaparse.bsn"
    { (yyval.s) = (yyvsp[(1) - (7)].s); ;}
    break;

  case 658:

/* Line 1464 of yacc.c  */
#line 23729 "hlaparse.bsn"
    {					/* $10 */

				SymNode_t				*s;
				char					msg[ 256 ];
				struct MethodListType	*FindProc;
				struct MethodListType	**PrevPtr;


				_here;

				/*
				** Save the current SymbolTable pointer so we
				** can find the end of the declarations later.
				*/

				(yyval.s) = SymbolTable;
				
				/*
				** Point ThisPtr at the current procedure ID
				** so we can access the class' fields (through
				** the proc.BaseClass field).
				*/
				
				ThisPtr = (yyvsp[(1) - (9)].s)->u.proc.BaseClass; 

				/*
				** If the proc.Forward field contains NULL, then
				** we've already processed code corresponding to
				** this static procedure.  That means this is the
				** second occurrence of that procedure declaration
				** and we have a duplicate symbol definition.
				*/

				_if( (yyvsp[(1) - (9)].s)->u.proc.Forward == NULL )

					sprintf
					(
						msg,
						"Duplicate symbol <<%s>>",
						(yyvsp[(1) - (9)].s)->TrueName
					);
					yyerror( msg );
						

				_endif

				/*
				** Okay, this is the first declaration
				** of this procedure.  Point the SymbolTable
				** variable at this procedure's local vars
				** (that would just be the parameters, if any,
				** at this point) and mark the procedure as
				** processed.  Also, scan through the MethodList
				** and remove the reference to this procedure.
				*/

				SymbolTable = (yyvsp[(1) - (9)].s)->u.proc.Locals;
				(yyvsp[(1) - (9)].s)->u.proc.Forward = NULL;

				/*
				** Okay, remove the reference to this procedure
				** from the MethodList.
				*/

				FindProc = MethodList;
				PrevPtr = &MethodList;
				_while
				(
						FindProc != NULL 
					&&	FindProc->MethodSym != (yyvsp[(1) - (9)].s) 
				)

					PrevPtr = &FindProc->Next;
					FindProc = FindProc->Next;

				_endwhile

				_if( FindProc != NULL )

					*PrevPtr = FindProc->Next;
					free2( vss FindProc );

				_else

					yyerror
					( 
						"This class procedure has not been overridden" 
					);

				_endif


				/*
				** NULL terminate the local symbols for
				** use by FixSymbols
				*/

				s = SymbolTable;
				_while( s != NULL && s->Next != (yyvsp[(1) - (9)].s) )

					s = s->Next;

				_endwhile
				_if( s != NULL )

					s->Next = NULL;

				_endif

				_if( CurLexLevel != (yyvsp[(1) - (9)].s)->u.proc.BaseClass->LexLevel )

					yyerror
					( 
						"Class procedure declared at different lex level" 
					);

				_endif
				++CurLexLevel;
				CurOffset = StartLclOffs;
				CurOffsetDir = -1;
				_here;
			;}
    break;

  case 659:

/* Line 1464 of yacc.c  */
#line 23852 "hlaparse.bsn"
    {							/* $12 */

				char 					msg[ 256 ];
				int	 					*dimension;
				SymNode_t				*s;
				struct contextListType	*p;
				char					exitname[ 256 ];

				_here;
				CheckLegalOptions
				( 
					(yyvsp[(11) - (11)].options.SpecifiedOptions),
						specified_returns
					|	specified_use
					|	specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_noenter 
					|	specified_noleave
					|	specified_pascal
					|	specified_stdcall
					|	specified_cdecl
					|	specified_alignment 
				);
				CurrentContext = (yyvsp[(1) - (11)].s);
				_if( _strne( (yyvsp[(11) - (11)].options.returns), "" ))

					yyerror( "\"returns\" clause not allowed here" );
					free2( vss (yyvsp[(11) - (11)].options.returns) );

				_endif


				_if( (yyvsp[(11) - (11)].options.UseDisplay) )

					CurOffset -= ( CurLexLevel + 1 ) * 4;
					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);

				_endif





				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.
				*/
				
				_if( (yyvsp[(11) - (11)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(1) - (11)].s)->TrueName;

					sprintf( exitname, "x%s" sympost, (yyvsp[(1) - (11)].s)->StaticName ); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(11) - (11)].options.UseDisplay);
					p->SizeParms = (yyvsp[(1) - (11)].s)->u.proc.ParmSize;
					contextList = p;

				_endif

				(yyval.s) = (yyvsp[(10) - (11)].s); /* Required by FixSymbols */
				_here;
			;}
    break;

  case 660:

/* Line 1464 of yacc.c  */
#line 23966 "hlaparse.bsn"
    {				/* $19 */

				SymNode_t	*CurSym;
				int			RoundedOffset;
				SymNode_t	value;
				SymNode_t	*s;

				int			HadPassByValRes;
				SymNode_t	*d;

				_here;
				inProcedure = 1;


				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(11) - (18)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(1) - (18)].s)->u.proc.parms;
					_while( s != NULL && s != (yyvsp[(1) - (18)].s) )

						_if
						( 
								s->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)

							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = SymbolTable;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;


							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );


						_elseif( s->pClass == vrp_pc || s->pClass == result_pc  )

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(
								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes | (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif


				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** If we have a display, don't factor its size into
				** the # of bytes of local variables.
				*/

				_if( (yyvsp[(11) - (18)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);




				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				_if( (yyvsp[(1) - (18)].s)->IsExternal )

					EmitPublic( (yyvsp[(1) - (18)].s)->StaticName ); 

				_endif

				startCseg();
				_if( (yyvsp[(11) - (18)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(11) - (18)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(1) - (18)].s)->StaticName ); 
				_if( (yyvsp[(11) - (18)].options.UseFrame) && !(yyvsp[(11) - (18)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(11) - (18)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(11) - (18)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(11) - (18)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(11) - (18)].options.NoEnter) 
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(11) - (18)].options.AlignStk) )

						AlignStack();

					_endif

				_endif






				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(11) - (18)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(1) - (18)].s) );

				_endif








				assert( (yyvsp[(17) - (18)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(1) - (18)].s)->TrueName, (yyvsp[(17) - (18)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"procedure name <<%s>>",
						(yyvsp[(17) - (18)].neID.idStr),
						(yyvsp[(1) - (18)].s)->TrueName
					);

					yyerror( msg );

				_endif

				/*
				** Set up the Locals pointer to point at the
				** newly acquired local variables.
				*/

				(yyvsp[(1) - (18)].s)->u.proc.Locals = SymbolTable;


				/*
				** Check to ensure that all forward declared procedures
				** have been defined prior to code emission.
				*/

			
				CheckForwardDecls( (yyvsp[(10) - (18)].s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				/*
				** CurrentContext = $<s>2;
				*/

				free2( vss (yyvsp[(17) - (18)].neID.idStr) );


				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/
				
				(yyval.s) = lookup( "_finalize_", 1 );
				_if( (yyvsp[(11) - (18)].options.UseFrame) )
				
					assert( (yyval.s) != NULL );
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored.",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
				_here;

			;}
    break;

  case 661:

/* Line 1464 of yacc.c  */
#line 24358 "hlaparse.bsn"
    {			/* $24 */

				_here;
				assert( (yyvsp[(22) - (23)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(1) - (23)].s)->TrueName, (yyvsp[(22) - (23)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"procedure name <<%s>>",
						(yyvsp[(22) - (23)].neID.idStr),
						(yyvsp[(1) - (23)].s)->TrueName
					);

					yyerror( msg );

				_endif


				/*
				** Emit the label at the end of the procedure
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(11) - (23)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(2) - (23)].s)->StaticName );
					EmitStmtLbl( lbl );


					/*
					** Deal with the _finalize_ string here.
					*/

					InvisibleCode = NULL;
					_if
					( 
							(yyvsp[(19) - (23)].s)->pType != tString 
						&&	(yyvsp[(19) - (23)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(19) - (23)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(19) - (23)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(19) - (23)].s)->u.strval );

					_endif
					
				_endif
				_here;
			;}
    break;

  case 662:

/* Line 1464 of yacc.c  */
#line 24424 "hlaparse.bsn"
    {			/* $27 */


				struct contextListType	*cNode;
				SymNode_t				*s;
				SymNode_t				*d;


				_here;

	
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					StoreValResParms( (yyvsp[(1) - (26)].s) );

				_endif




				--CurLexLevel;
				CurOffset = (yyvsp[(4) - (26)].v.u.unsval);
				CurOffsetDir = (yyvsp[(5) - (26)].v.u.unsval);
				ThisPtr = (yyvsp[(7) - (26)].s);


				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table.
				*/

				//$<s>2->u.proc.BaseClass->u.proc.Locals = SymbolTable;
				(yyvsp[(1) - (26)].s)->u.proc.Locals = SymbolTable;
				(yyvsp[(13) - (26)].s)->Next = NULL;
				SymbolTable = (yyvsp[(10) - (26)].s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/


				CurrentContext = (yyvsp[(1) - (26)].s)->u.proc.BaseClass;
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(6) - (26)].s);



				/*
				** Output the necessary data to the assembly language
				** file to complete this procedure.
				*/

				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					StdExit
					( 
						(yyvsp[(1) - (26)].s)->u.proc.ParmSize, 
						(yyvsp[(1) - (26)].s)->u.proc.cs == cdecl_cs,
						(yyvsp[(11) - (26)].options.NoLeave) 
					); 

				_endif
				EndProc( (yyvsp[(1) - (26)].s)->StaticName ); 
				endCseg();


				
				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();

				free2( vss (yyvsp[(22) - (26)].neID.idStr) );

				/*
				** Restore currentNS:
				*/
				
				currentNS = (yyvsp[(14) - (26)].ru.saveCurNS);
				
				
				
				inProcedure = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( _streq( cNode->label, (yyvsp[(1) - (26)].s)->TrueName) );
					free2( vss cNode->StaticName );

				_endif
				(void) (yyvsp[(8) - (26)].s);	// To shut up bison
				(void) (yyvsp[(12) - (26)].s);
				_here;
			;}
    break;

  case 663:

/* Line 1464 of yacc.c  */
#line 24551 "hlaparse.bsn"
    { (yyval.s) = (yyvsp[(2) - (6)].s); ;}
    break;

  case 664:

/* Line 1464 of yacc.c  */
#line 24553 "hlaparse.bsn"
    {					/* $9 */

				char msg[ 256 ];

				_here;
				
				/*
				** Save the current SymbolTable pointer so we
				** can find the end of the declarations later.
				*/

				(yyval.s) = SymbolTable;
				
				_if( (yyvsp[(2) - (8)].s)->IsReferenced != NULL )
				
					(yyvsp[(2) - (8)].s)->IsReferenced->IsPublic = 1;
					
				_endif
								
				/*
				** Point ThisPtr at the current procedure ID
				** so we can access the class' fields (through
				** the proc.BaseClass field).
				*/
				
				ThisPtr = (yyvsp[(2) - (8)].s)->u.proc.BaseClass; 
				

				_if( (yyvsp[(2) - (8)].s)->u.proc.Forward == NULL )

					sprintf
					(
						msg,
						"Duplicate symbol <<%s>>",
						(yyvsp[(2) - (8)].s)->TrueName
					);
					yyerror( msg );
					SymbolTable = (yyvsp[(2) - (8)].s)->u.proc.Locals;
						

				_else

					struct MethodListType	*FindProc;
					struct MethodListType	**PrevPtr;
					SymNode_t				*s;

					/*
					** Okay, this is the first declaration
					** of this method.  Point the SymbolTable
					** variable at this method's local vars
					** (that would just be the parameters, if any,
					** at this point) and mark the method as
					** processed.  Also, scan through the MethodList
					** and remove the reference to this method.
					*/

					SymbolTable = (yyvsp[(2) - (8)].s)->u.proc.Locals;
					(yyvsp[(2) - (8)].s)->u.proc.Forward = NULL;

					/*
					** Okay, remove the reference to this procedure
					** from the MethodList.
					*/

					FindProc = MethodList;
					PrevPtr = &MethodList;
					_while
					(
							FindProc != NULL 
						&&	FindProc->MethodSym != (yyvsp[(2) - (8)].s) 
					)

						PrevPtr = &FindProc->Next;
						FindProc = FindProc->Next;

					_endwhile
					_if( FindProc != NULL )

						*PrevPtr = FindProc->Next;
						free2( vss FindProc );

					_else

						yyerror
						( 
							"This class method has not been overridden" 
						);

					_endif


					/*
					** NULL terminate the local symbols for
					** use by FixSymbols
					*/

					s = SymbolTable;
					_while( s != NULL && s->Next != (yyvsp[(2) - (8)].s) )

						s = s->Next;

					_endwhile
					_if( s != NULL )

						s->Next = NULL;

					_endif


				_endif
				_if( CurLexLevel != (yyvsp[(2) - (8)].s)->u.proc.BaseClass->LexLevel )

					yyerror
					( 
						"Class method declared at different lex level" 
					);

				_endif
				++CurLexLevel;
				CurOffset = StartLclOffs;
				CurOffsetDir = -1;
				_here;

			;}
    break;

  case 665:

/* Line 1464 of yacc.c  */
#line 24679 "hlaparse.bsn"
    {					/* $12 */

				int	 *dimension;
				struct contextListType	*p;
				char					exitname[ 256 ];

				_here;
				CheckLegalOptions
				( 
					(yyvsp[(11) - (11)].options.SpecifiedOptions),
						specified_returns
					|	specified_use
					|	specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_noenter 
					|	specified_noleave
					|	specified_pascal
					|	specified_stdcall
					|	specified_cdecl
					|	specified_alignment 
				);
				CurrentContext = (yyvsp[(2) - (11)].s);

				(yyval.s) = (yyvsp[(9) - (11)].s); /* Required by FixSymbols */



				_if( _strne( (yyvsp[(11) - (11)].options.returns), "" ))

					yyerror( "\"returns\" clause not allowed here" );
					free2( vss (yyvsp[(11) - (11)].options.returns) );

				_endif


				_if( (yyvsp[(11) - (11)].options.UseDisplay) )

					CurOffset -= ( CurLexLevel + 1 ) * 4;
					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);

				_endif



				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.
				*/
				
				_if( (yyvsp[(11) - (11)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(2) - (11)].s)->TrueName;

					sprintf( exitname, "x%s" sympost, (yyvsp[(2) - (11)].s)->StaticName ); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(11) - (11)].options.UseDisplay);
					p->SizeParms = (yyvsp[(2) - (11)].s)->u.proc.ParmSize;
					contextList = p;

				_endif
				_here;
			;}
    break;

  case 666:

/* Line 1464 of yacc.c  */
#line 24796 "hlaparse.bsn"
    {					/* $19 */

				SymNode_t  *CurSym;
				int			RoundedOffset;
				SymNode_t	value;
				SymNode_t	*s;


				int			HadPassByValRes;
				SymNode_t	*d;

				_here;
				inMethod = 1;


				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(11) - (18)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(2) - (18)].s)->u.proc.parms;
					_while( s != NULL && s != (yyvsp[(2) - (18)].s) )

						_if
						( 
								s->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)

							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
	
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = s->u.proc.Locals;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;

							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );


						_elseif
						( 
								s->pClass == vrp_pc 
							||	s->pClass == result_pc  
						)

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(
								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes | (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif



				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** If we have a display, don't factor its size into
				** the # of bytes of local variables.
				*/

				_if( (yyvsp[(11) - (18)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/
				
				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);

				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);




				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				_if( (yyvsp[(2) - (18)].s)->IsExternal )

					EmitPublic( (yyvsp[(2) - (18)].s)->StaticName );

				_endif
				startCseg();
				_if( (yyvsp[(11) - (18)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(11) - (18)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(2) - (18)].s)->StaticName ); 
				_if( (yyvsp[(11) - (18)].options.UseFrame) && !(yyvsp[(11) - (18)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(11) - (18)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(11) - (18)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(11) - (18)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(11) - (18)].options.NoEnter)
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(11) - (18)].options.AlignStk) )

						AlignStack();

					_endif

				_endif




				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(11) - (18)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(2) - (18)].s) );

				_endif




				assert( (yyvsp[(17) - (18)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(2) - (18)].s)->TrueName, (yyvsp[(17) - (18)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"method name <<%s>>",
						(yyvsp[(17) - (18)].neID.idStr),
						(yyvsp[(2) - (18)].s)->TrueName
					);

					yyerror( msg );

				_endif


				/*
				** Set up the Locals pointer to point at the
				** newly acquired local variables.
				*/

				(yyvsp[(2) - (18)].s)->u.proc.Locals = SymbolTable;


				/*
				** Check to ensure that all forward declared methods
				** have been defined prior to code emission.
				*/

			
				CheckForwardDecls( (yyvsp[(12) - (18)].s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				free2( vss (yyvsp[(17) - (18)].neID.idStr) );

				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/

				
				(yyval.s) = lookup( "_finalize_", 1 );
				assert( (yyval.s) != NULL );
				_if( (yyvsp[(11) - (18)].options.UseFrame) )
				
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored.",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
				_here;


			;}
    break;

  case 667:

/* Line 1464 of yacc.c  */
#line 25186 "hlaparse.bsn"
    {				/* $24 */

				_here;
				assert( (yyvsp[(22) - (23)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(2) - (23)].s)->TrueName, (yyvsp[(22) - (23)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"method name <<%s>>",
						(yyvsp[(22) - (23)].neID.idStr),
						(yyvsp[(2) - (23)].s)->TrueName
					);

					yyerror( msg );

				_endif

				/*
				** Emit the label at the end of the procedure
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(11) - (23)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(2) - (23)].s)->StaticName );
					EmitStmtLbl( lbl );


					/*
					** Deal with the _finalize_ string here.
					*/

					InvisibleCode = NULL;
					_if
					( 
							(yyvsp[(19) - (23)].s)->pType != tString 
						&&	(yyvsp[(19) - (23)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(19) - (23)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(19) - (23)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(19) - (23)].s)->u.strval );

					_endif
					
				_endif
				_here;
			;}
    break;

  case 668:

/* Line 1464 of yacc.c  */
#line 25251 "hlaparse.bsn"
    {			/* $26 */

				struct contextListType	*cNode;
				SymNode_t				*s;
				SymNode_t				*d;


				_here;

	
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					StoreValResParms( (yyvsp[(2) - (26)].s) );

				_endif

		

				
				--CurLexLevel;
				CurOffset = (yyvsp[(3) - (26)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (26)].v.u.unsval);
				ThisPtr = (yyvsp[(6) - (26)].s);

				/*
				** Remove this method's local symbols from
				** further consideration in the symbol table.
				*/

				(yyvsp[(2) - (26)].s)->u.proc.Locals = SymbolTable;
				(yyvsp[(13) - (26)].s)->Next = NULL;
				SymbolTable = (yyvsp[(12) - (26)].s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(2) - (26)].s)->u.proc.BaseClass;
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (26)].s);

				/*
				** Output the necessary data to the assembly language
				** file to complete this method.
				*/

				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					StdExit
					( 
						(yyvsp[(2) - (26)].s)->u.proc.ParmSize, 
						(yyvsp[(2) - (26)].s)->u.proc.cs == cdecl_cs,
						(yyvsp[(11) - (26)].options.NoLeave) 
					);

				_endif
				EndProc( (yyvsp[(2) - (26)].s)->StaticName );
				endCseg();


				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();

				free2( vss (yyvsp[(22) - (26)].neID.idStr) );


				/*
				** Restore currentNS value:
				*/
				
				currentNS = (yyvsp[(14) - (26)].ru.saveCurNS);
				
				inMethod = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( _streq( cNode->label, (yyvsp[(2) - (26)].s)->TrueName) );
					free2( vss cNode->StaticName );

				_endif
				(void) (yyvsp[(7) - (26)].s);	// Shut up bison
				_here;
			;}
    break;

  case 669:

/* Line 1464 of yacc.c  */
#line 25369 "hlaparse.bsn"
    { (yyval.s) = (yyvsp[(2) - (7)].s); ;}
    break;

  case 670:

/* Line 1464 of yacc.c  */
#line 25371 "hlaparse.bsn"
    {					/* $10 */

				char msg[ 256 ];

				/*
				** Save the current SymbolTable pointer so we
				** can find the end of the declarations later.
				*/

				_here;
				(yyval.s) = SymbolTable;
				
				_if( (yyvsp[(1) - (9)].s)->IsReferenced != NULL )
				
					(yyvsp[(1) - (9)].s)->IsReferenced->IsPublic = 1;
					
				_endif
								
				/*
				** Point ThisPtr at the current procedure ID
				** so we can access the class' fields (through
				** the proc.BaseClass field).
				*/
				
				ThisPtr = (yyvsp[(1) - (9)].s)->u.proc.BaseClass; 
				

				_if( (yyvsp[(1) - (9)].s)->u.proc.Forward == NULL )

					sprintf
					(
						msg,
						"Duplicate symbol <<%s>>",
						(yyvsp[(1) - (9)].s)->TrueName
					);
					yyerror( msg );
					SymbolTable = (yyvsp[(1) - (9)].s)->u.proc.Locals;
						

				_else

					struct MethodListType	*FindProc;
					struct MethodListType	**PrevPtr;
					SymNode_t				*s;

					/*
					** Okay, this is the first declaration
					** of this method.  Point the SymbolTable
					** variable at this method's local vars
					** (that would just be the parameters, if any,
					** at this point) and mark the method as
					** processed.  Also, scan through the MethodList
					** and remove the reference to this method.
					*/

					SymbolTable = (yyvsp[(1) - (9)].s)->u.proc.Locals;
					(yyvsp[(1) - (9)].s)->u.proc.Forward = NULL;

					/*
					** Okay, remove the reference to this procedure
					** from the MethodList.
					*/

					FindProc = MethodList;
					PrevPtr = &MethodList;
					_while
					(
							FindProc != NULL 
						&&	FindProc->MethodSym != (yyvsp[(1) - (9)].s) 
					)

						PrevPtr = &FindProc->Next;
						FindProc = FindProc->Next;

					_endwhile
					_if( FindProc != NULL )

						*PrevPtr = FindProc->Next;
						free2( vss FindProc );

					_else

						yyerror
						( 
							"This class method has not been overridden" 
						);

					_endif


					/*
					** NULL terminate the local symbols for
					** use by FixSymbols
					*/

					s = SymbolTable;
					_while( s != NULL && s->Next != (yyvsp[(1) - (9)].s) )

						s = s->Next;

					_endwhile
					_if( s != NULL )

						s->Next = NULL;

					_endif


				_endif
				_if( CurLexLevel != (yyvsp[(1) - (9)].s)->u.proc.BaseClass->LexLevel )

					yyerror
					( 
						"Class method declared at different lex level" 
					);

				_endif
				++CurLexLevel;
				CurOffset = StartLclOffs;
				CurOffsetDir = -1;
				_here;

			;}
    break;

  case 671:

/* Line 1464 of yacc.c  */
#line 25495 "hlaparse.bsn"
    {						/* $12 */

				int	 *dimension;
				struct contextListType	*p;
				char					exitname[ 256 ];

				_here;
				CheckLegalOptions
				( 
					(yyvsp[(11) - (11)].options.SpecifiedOptions),
						specified_returns
					|	specified_use
					|	specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_noenter 
					|	specified_noleave
					|	specified_pascal
					|	specified_stdcall
					|	specified_cdecl
					|	specified_alignment 
				);
				CurrentContext = (yyvsp[(1) - (11)].s);

				(yyval.s) = (yyvsp[(10) - (11)].s); /* Required by FixSymbols */



				_if( _strne( (yyvsp[(11) - (11)].options.returns), "" ))

					yyerror( "\"returns\" clause not allowed here" );
					free2( vss (yyvsp[(11) - (11)].options.returns) );

				_endif


				_if( (yyvsp[(11) - (11)].options.UseDisplay) )

					CurOffset -= ( CurLexLevel + 1 ) * 4;
					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);

				_endif



				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.
				*/
				
				_if( (yyvsp[(11) - (11)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(1) - (11)].s)->TrueName;

					sprintf( exitname, "x%s" sympost, (yyvsp[(1) - (11)].s)->StaticName ); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(11) - (11)].options.UseDisplay);
					p->SizeParms = (yyvsp[(1) - (11)].s)->u.proc.ParmSize;
					contextList = p;

				_endif
				_here;
			;}
    break;

  case 672:

/* Line 1464 of yacc.c  */
#line 25612 "hlaparse.bsn"
    {					/* $19 */

				SymNode_t  *CurSym;
				int			RoundedOffset;
				SymNode_t	value;
				SymNode_t	*s;


				int			HadPassByValRes;
				SymNode_t	*d;

				_here;
				inMethod = 1;


				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(11) - (18)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(1) - (18)].s)->u.proc.parms;
					_while( s != NULL && s != (yyvsp[(1) - (18)].s) )

						_if
						( 
								s->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)

							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
	
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = s->u.proc.Locals;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;

							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );


						_elseif
						( 
								s->pClass == vrp_pc 
							||	s->pClass == result_pc  
						)

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(
								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes | (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif



				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** If we have a display, don't factor its size into
				** the # of bytes of local variables.
				*/

				_if( (yyvsp[(11) - (18)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/
				
				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);

				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);




				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				_if( (yyvsp[(1) - (18)].s)->IsExternal )

					EmitPublic( (yyvsp[(1) - (18)].s)->StaticName );

				_endif
				startCseg();
				_if( (yyvsp[(11) - (18)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(11) - (18)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(1) - (18)].s)->StaticName ); 
				_if( (yyvsp[(11) - (18)].options.UseFrame) && !(yyvsp[(11) - (18)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(11) - (18)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(11) - (18)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(11) - (18)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(11) - (18)].options.NoEnter)
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(11) - (18)].options.AlignStk) )

						AlignStack();

					_endif

				_endif




				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(11) - (18)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(1) - (18)].s) );

				_endif




				assert( (yyvsp[(17) - (18)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(1) - (18)].s)->TrueName, (yyvsp[(17) - (18)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"method name <<%s>>",
						(yyvsp[(17) - (18)].neID.idStr),
						(yyvsp[(1) - (18)].s)->TrueName
					);

					yyerror( msg );

				_endif


				/*
				** Set up the Locals pointer to point at the
				** newly acquired local variables.
				*/

				(yyvsp[(1) - (18)].s)->u.proc.Locals = SymbolTable;


				/*
				** Check to ensure that all forward declared methods
				** have been defined prior to code emission.
				*/

			
				CheckForwardDecls( (yyvsp[(12) - (18)].s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				free2( vss (yyvsp[(17) - (18)].neID.idStr) );

				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/

				
				(yyval.s) = lookup( "_finalize_", 1 );
				assert( (yyval.s) != NULL );
				_if( (yyvsp[(11) - (18)].options.UseFrame) )
				
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored.",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
				_here;


			;}
    break;

  case 673:

/* Line 1464 of yacc.c  */
#line 26002 "hlaparse.bsn"
    {				/* $24 */

				_here;
				assert( (yyvsp[(22) - (23)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(1) - (23)].s)->TrueName, (yyvsp[(22) - (23)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"method name <<%s>>",
						(yyvsp[(22) - (23)].neID.idStr),
						(yyvsp[(1) - (23)].s)->TrueName
					);

					yyerror( msg );

				_endif

				/*
				** Emit the label at the end of the procedure
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(11) - (23)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(1) - (23)].s)->StaticName );
					EmitStmtLbl( lbl );


					/*
					** Deal with the _finalize_ string here.
					*/

					InvisibleCode = NULL;
					_if
					( 
							(yyvsp[(19) - (23)].s)->pType != tString 
						&&	(yyvsp[(19) - (23)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(19) - (23)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(19) - (23)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(19) - (23)].s)->u.strval );

					_endif
					
				_endif
				_here;
			;}
    break;

  case 674:

/* Line 1464 of yacc.c  */
#line 26067 "hlaparse.bsn"
    {			/* $26 */

				struct contextListType	*cNode;
				SymNode_t				*s;
				SymNode_t				*d;


				_here;

	
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					StoreValResParms( (yyvsp[(1) - (26)].s) );

				_endif

		

				
				--CurLexLevel;
				CurOffset = (yyvsp[(4) - (26)].v.u.unsval);
				CurOffsetDir = (yyvsp[(5) - (26)].v.u.unsval);
				ThisPtr = (yyvsp[(7) - (26)].s);

				/*
				** Remove this method's local symbols from
				** further consideration in the symbol table.
				*/

				(yyvsp[(1) - (26)].s)->u.proc.Locals = SymbolTable;
				(yyvsp[(13) - (26)].s)->Next = NULL;
				SymbolTable = (yyvsp[(12) - (26)].s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(1) - (26)].s)->u.proc.BaseClass;
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(6) - (26)].s);

				/*
				** Output the necessary data to the assembly language
				** file to complete this method.
				*/

				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					StdExit
					( 
						(yyvsp[(1) - (26)].s)->u.proc.ParmSize, 
						(yyvsp[(1) - (26)].s)->u.proc.cs == cdecl_cs,
						(yyvsp[(11) - (26)].options.NoLeave) 
					);

				_endif
				EndProc( (yyvsp[(1) - (26)].s)->StaticName );
				endCseg();


				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();

				free2( vss (yyvsp[(22) - (26)].neID.idStr) );


				/*
				** Restore currentNS value:
				*/
				
				currentNS = (yyvsp[(14) - (26)].ru.saveCurNS);
				
				inMethod = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(11) - (26)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( _streq( cNode->label, (yyvsp[(1) - (26)].s)->TrueName) );
					free2( vss cNode->StaticName );

				_endif
				(void) (yyvsp[(8) - (26)].s);	// Shut up bison
				_here;
			;}
    break;

  case 675:

/* Line 1464 of yacc.c  */
#line 26189 "hlaparse.bsn"
    { (yyval.s) = (yyvsp[(2) - (6)].s); ;}
    break;

  case 676:

/* Line 1464 of yacc.c  */
#line 26191 "hlaparse.bsn"
    {					/* $9  */

			char msg[ 256 ];

			/*
			** Save the current SymbolTable pointer so we
			** can find the end of the declarations later.
			*/

			_here;
			(yyval.s) = SymbolTable;

			/*
			** Save the current SymbolTable pointer so we
			** can find the end of the declarations later.
			*/

			(yyval.s) = SymbolTable;
			
			_if( (yyvsp[(2) - (8)].s)->IsReferenced != NULL )
			
				(yyvsp[(2) - (8)].s)->IsReferenced->IsPublic = 1;
				
			_endif
			
			
			/*
			** Point ThisPtr at the current procedure ID
			** so we can access the class' fields (through
			** the proc.BaseClass field).
			*/
			
			ThisPtr = (yyvsp[(2) - (8)].s)->u.proc.BaseClass; 
			
			
			
			 

			_if( (yyvsp[(2) - (8)].s)->u.proc.Forward == NULL )

				sprintf
				(
					msg,
					"Duplicate symbol <<%s>>",
					(yyvsp[(2) - (8)].s)->TrueName
				);
				yyerror( msg );
				SymbolTable = (yyvsp[(2) - (8)].s)->u.proc.Locals;
					

			_else

				struct MethodListType	*FindProc;
				struct MethodListType	**PrevPtr;
				SymNode_t				*s;

				/*
				** Okay, this is the first declaration
				** of this iterator.  Point the SymbolTable
				** variable at this method's local vars
				** (that would just be the parameters, if any,
				** at this point) and mark the iterator as
				** processed.  Also, scan through the MethodList
				** and remove the reference to this iterator.
				*/

				SymbolTable = (yyvsp[(2) - (8)].s)->u.proc.Locals;
				(yyvsp[(2) - (8)].s)->u.proc.Forward = NULL;

				/*
				** Okay, remove the reference to this procedure
				** from the MethodList.
				*/

				FindProc = MethodList;
				PrevPtr = &MethodList;
				_while( FindProc->MethodSym != (yyvsp[(2) - (8)].s) )

					PrevPtr = &FindProc->Next;
					FindProc = FindProc->Next;
					assert( FindProc != NULL );

				_endwhile
				*PrevPtr = FindProc->Next;
				free2( vss FindProc );


				/*
				** NULL terminate the local symbols for
				** use by FixSymbols
				*/

				s = SymbolTable;
				_while( s != NULL && s->Next != (yyvsp[(2) - (8)].s) )

					s = s->Next;

				_endwhile
				_if( s != NULL )

					s->Next = NULL;

				_endif


			_endif
			_if( CurLexLevel != (yyvsp[(2) - (8)].s)->u.proc.BaseClass->LexLevel )

				yyerror
				( 
					"Class iterator declared at different lex level" 
				);

			_endif
			CurOffset = StartLclOffs;
			CurOffsetDir = -1;
			++CurLexLevel;

			/*
			** Create a symbol table entry for the "yield" thunk.
			*/

			InsertSym
			( 
				"yield", 
				&thunk_ste,	/* Type			*/
				tThunk, 	/* pType		*/
				cVar,		/* SymClass		*/ 
				0,			/* Arity		*/
				NULL,		/* dimensions	*/
				0, 			/* # elements	*/
				NULL,		/* Value		*/
				8,			/* ObjectSize	*/
				0,			/* Offset 		*/
				NULL,		/* StaticName	*/
				NULL,		/* Base			*/
				NULL,		/* Fields		*/
				0			/* FieldCnt		*/
			);

			/*
			** Thunks (yield) don't have any parameters,
			** but we can't leave proc.parms NULL (since other
			** code treats this as an error).  Just give each
			** Yield thunk a set of local constants which are
			** the lex level zero constants.
			*/
			
			SymbolTable->u.proc.parms = &true_ste;


			_here;
		;}
    break;

  case 677:

/* Line 1464 of yacc.c  */
#line 26346 "hlaparse.bsn"
    {					/* $12 */

			int	 *dimension;
			struct contextListType	*p;
			char					exitname[ 256 ];

			_here;
			CheckLegalOptions
			( 
				(yyvsp[(11) - (11)].options.SpecifiedOptions),
					specified_returns
				|	specified_use
				|	specified_noframe 
				|	specified_nodisplay 
				|	specified_noalignstk 
				|	specified_noenter 
				|	specified_noleave
				|	specified_pascal
				|	specified_stdcall
				|	specified_cdecl
				|	specified_alignment 
			);
			CurrentContext = (yyvsp[(2) - (11)].s);

			(yyval.s) = (yyvsp[(9) - (11)].s);  /* Required by FixSymbols and other code */


			_if( _strne( (yyvsp[(11) - (11)].options.returns), "" ))

				yyerror( "\"returns\" clause not allowed here" );
				free2( vss (yyvsp[(11) - (11)].options.returns) );

			_endif

			/*
			** Insert an entry for the display, if necessary.
			*/

			_if( (yyvsp[(11) - (11)].options.UseDisplay) )

				CurOffset -= ( CurLexLevel + 1 ) * 4;
				dimension = malloc2( sizeofInt );
				*dimension = CurLexLevel + 1;
				InsertSym
				( 
					"_display_", 
					&dword_ste,
					tDWord, 
					cVar, 
					1,
					dimension,
					*dimension, 
					NULL,
					*dimension*4,
					CurOffset,
					NULL,
					NULL,
					NULL,
					0
				);

			_endif



			/*
			** Add this procedure to the context list so we
			** can bail on this procedure via the EXIT and EXITIF
			** statements.
			*/
			
			_if( (yyvsp[(11) - (11)].options.UseFrame) )

				p = malloc2( sizeofContextListType );
				p->Next = contextList;
				p->label = (yyvsp[(2) - (11)].s)->TrueName;

				sprintf( exitname, "x%s" sympost, (yyvsp[(2) - (11)].s)->StaticName ); 
				p->StaticName = hlastrdup2( exitname );
				p->LexLevel = CurLexLevel;
				p->IsProc = 1;
				p->HasDisplay = (yyvsp[(11) - (11)].options.UseDisplay);
				p->SizeParms = (yyvsp[(2) - (11)].s)->u.proc.ParmSize;
				contextList = p;

			_endif
			_here;

		;}
    break;

  case 678:

/* Line 1464 of yacc.c  */
#line 26462 "hlaparse.bsn"
    {					/* $19 */

			SymNode_t *CurSym;
			int			RoundedOffset;
			SymNode_t	value;
			int			HadPassByValRes;
			SymNode_t	*s;
			SymNode_t	*d;

			_here;
			inIterator = 1;


			/*
			** Check for pass by value/result or pass by result
			** parameters because we need to allocate local
			** storage for these.
			*/

			_if( (yyvsp[(11) - (18)].options.UseFrame) )

				HadPassByValRes = 0;
				s = (yyvsp[(2) - (18)].s)->u.proc.parms;
				_while( s != NULL && s != (yyvsp[(2) - (18)].s) )

					_if
					( 
							s->pType == tProcptr 
						&&	(
									s->pClass == vrp_pc 
								||	s->pClass == result_pc
							)
					)

						CurOffset = CurOffset - 4;
						InsertSym
						(
							s->TrueName, 
							NULL,				/* Type			*/
							tProcptr,		 	/* pType		*/
							cVar,				/* SymClass		*/ 
							s->Arity,			/* Arity		*/
							s->Dimensions,		/* dimensions	*/
							s->NumElements,		/* # elements	*/
							NULL,				/* Value		*/
							4,					/* ObjectSize	*/
							CurOffset,			/* Offset 		*/
							s->StaticName,		/* StaticName	*/
							s->Base,			/* Base			*/
							s->Fields,			/* Fields		*/
							s->FieldCnt			/* FieldCnt		*/
						);
						d = SymbolTable;
						d->u.proc.returns = hlastrdup2( "" );
						d->u.proc.use = s->u.proc.use;
						d->u.proc.parms = s->u.proc.parms;
						d->u.proc.Locals = s->u.proc.Locals;
						d->u.proc.Forward = s->u.proc.Forward;
						d->u.proc.BaseClass = s->u.proc.BaseClass;
						d->u.proc.ParmSize = s->u.proc.ParmSize;
						d->u.proc.cs = s->u.proc.cs;


						InsertSym
						(
							" (procptr type) ", 
							NULL,				/* Type			*/
							tProcptr,		 	/* pType		*/
							cType,				/* SymClass		*/ 
							0,					/* Arity		*/
							NULL,				/* dimensions	*/
							0,					/* # elements	*/
							NULL,				/* Value		*/
							4,					/* ObjectSize	*/
							0,					/* Offset 		*/
							NULL,				/* StaticName	*/
							NULL,				/* Base			*/
							NULL,				/* Fields		*/
							0					/* FieldCnt		*/
						);
						SymbolTable->u.proc.parms = s->u.proc.parms;
						SymbolTable->u.proc.returns = d->u.proc.returns;
						SymbolTable->u.proc.use = s->u.proc.use;
						SymbolTable->u.proc.Locals = s->u.proc.Locals;
						SymbolTable->u.proc.Forward = s->u.proc.Forward;
						SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
						SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
						SymbolTable->u.proc.cs = s->u.proc.cs;
						d->Type = SymbolTable;
						SymbolTable = d;

						HadPassByValRes = 
							HadPassByValRes || (s->pClass == vrp_pc );


					_elseif( s->pClass == vrp_pc || s->pClass == result_pc  )

						assert( s->Type != NULL );
						CurOffset = CurOffset - s->Type->ObjectSize;
						InsertSym
						(
							s->TrueName, 
							s->Type,			/* Type			*/
							s->Type->pType, 	/* pType		*/
							cVar,				/* SymClass		*/ 
							s->Arity,			/* Arity		*/
							s->Dimensions,		/* dimensions	*/
							s->NumElements,		/* # elements	*/
							NULL,				/* Value		*/
							s->Type->ObjectSize,/* ObjectSize	*/
							CurOffset,			/* Offset 		*/
							s->StaticName,		/* StaticName	*/
							s->Base,			/* Base			*/
							s->Fields,			/* Fields		*/
							s->FieldCnt			/* FieldCnt		*/
						);

						HadPassByValRes = 
							HadPassByValRes | (s->pClass == vrp_pc );

					_endif
					s = s->Next;

				_endwhile

			_endif



			/*
			** Compute the number of bytes of local variables
			** and round this number to the larger multiple of
			** four bytes.
			*/

			RoundedOffset = -CurOffset;
			_if( RoundedOffset != ( RoundedOffset & ~3 ))

				RoundedOffset = ( RoundedOffset + 4 ) & ~3;

			_endif

			/*
			** If we have a display, don't factor its size into
			** the # of bytes of local variables.
			*/

			_if( (yyvsp[(11) - (18)].options.UseDisplay) )

				RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

			_endif

			/*
			** Create a symbol table entry for the # of bytes
			** of local variables in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = RoundedOffset;
			InsertSym
			( 
				"_vars_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);




			/*
			** Output the assembly code for this procedure.
			**
			** For nested procedures (lex level 2 and above)
			** we need to emit the display
			*/

			_if( (yyvsp[(2) - (18)].s)->IsExternal )

				EmitPublic( (yyvsp[(2) - (18)].s)->StaticName );

			_endif
			startCseg();
			_if( (yyvsp[(11) - (18)].options.Alignment) != 1 )

				EmitAlign( (yyvsp[(11) - (18)].options.Alignment) );

			_endif
			StartProc( (yyvsp[(2) - (18)].s)->StaticName );
			_if( (yyvsp[(11) - (18)].options.UseFrame) && !(yyvsp[(11) - (18)].options.UseDisplay) )


				/*
				** If we're not building a display, just use the
				** standard entry sequence.
				*/

				StdEntry( RoundedOffset, (yyvsp[(11) - (18)].options.NoEnter) );

				/*
				** Align the stack on a dword boundary.
				*/

				_if( AlwaysAlignStk && (yyvsp[(11) - (18)].options.AlignStk) )

					AlignStack();

				_endif

			_elseif( (yyvsp[(11) - (18)].options.UseFrame) )

				/*
				** We've got to construct the display.
				*/

				ConstructDisplay
				( 
					CurLexLevel, 
					RoundedOffset,
					(yyvsp[(11) - (18)].options.NoEnter) 
				);

				/*
				** Align the stack on a dword boundary.
				*/

				_if( AlwaysAlignStk && (yyvsp[(11) - (18)].options.AlignStk) )

					AlignStack();

				_endif

			_endif





			/*
			** If we have any pass by value/result parameters, emit
			** code to copy the data into the local storage allocated
			** to hold the parameter.  Note that we do not copy pass
			** by result parameters here because they are "out only"
			** variables.
			*/

			_if( (yyvsp[(11) - (18)].options.UseFrame) && HadPassByValRes )

				CopyValResParms( (yyvsp[(2) - (18)].s) );

			_endif





			assert( (yyvsp[(17) - (18)].neID.idStr) != NULL );

			_if( _strne( (yyvsp[(2) - (18)].s)->TrueName, (yyvsp[(17) - (18)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				( 
					msg,
					"Identifier <<%s>> after 'begin' must match "
					"iterator name <<%s>>",
					(yyvsp[(17) - (18)].neID.idStr),
					(yyvsp[(2) - (18)].s)->TrueName
				);

				yyerror( msg );

			_endif


			/*
			** Set up the Locals pointer to point at the
			** newly acquired local variables.
			*/

			(yyvsp[(2) - (18)].s)->u.proc.Locals = SymbolTable;


			/*
			** Check to ensure that all forward declared symbols
			** have been defined prior to code emission.
			*/

		
			CheckForwardDecls( (yyvsp[(12) - (18)].s) );

			/*
			** Check to make sure all pointer forward references have
			** been resolved.
			*/

			CheckPtrs();

			free2( vss (yyvsp[(17) - (18)].neID.idStr) );

			/*
			** Emit the text associated with the _initialize_ string
			** at this point.
			**
			**	Note: the "InvisibleCode" variable is used by
			**	yyerror to determine if it should print the
			**	_initialize_ string as part of the error message.
			*/

			
			(yyval.s) = lookup( "_finalize_", 1 );
			assert( (yyval.s) != NULL );
			_if( (yyvsp[(11) - (18)].options.UseFrame) )
			
				s=(yyval.s)->Next;
				InvisibleCode = NULL;
				_if
				( 
						s->pType != tString 
					&&	s->pType != tZString 
				)

					WarnNear
					( 
						"_initialize_'s type is not string.  "
						"Initialization ignored.",
						"_initialize_" 
					);

				_elseif( strlen( s->u.strval ) != 0 )

					InvisibleCode = s->u.strval;
					PushBackStr( "\xF3" );
					PushBackStr( s->u.strval );

				_endif
				
			_endif
			_here;

		;}
    break;

  case 679:

/* Line 1464 of yacc.c  */
#line 26846 "hlaparse.bsn"
    {				/* $24 */

			_here;
			assert( (yyvsp[(22) - (23)].neID.idStr) != NULL );

			_if( _strne( (yyvsp[(2) - (23)].s)->TrueName, (yyvsp[(22) - (23)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				( 
					msg,
					"Identifier <<%s>> after 'end' must match "
					"iterator name <<%s>>",
					(yyvsp[(22) - (23)].neID.idStr),
					(yyvsp[(2) - (23)].s)->TrueName
				);

				yyerror( msg );

			_endif


			/*
			** Emit the label at the end of the procedure
			*/

			PushBackStr( "end" );
			_if( (yyvsp[(11) - (23)].options.UseFrame) )

				char lbl[256];
				
				sprintf( lbl, "x%s" sympost, (yyvsp[(2) - (23)].s)->StaticName );
				EmitStmtLbl( lbl );

	
				/*
				** Deal with the _finalize_ string here.
				*/

				InvisibleCode = NULL;
				_if
				( 
						(yyvsp[(19) - (23)].s)->pType != tString 
					&&	(yyvsp[(19) - (23)].s)->pType != tZString 
				)

					WarnNear
					(
						"_finalize_ must be a string constant.  Value ignored",
						"_finalize_"
					);

				_elseif( strlen( (yyvsp[(19) - (23)].s)->u.strval ) != 0 )

					InvisibleCode = (yyvsp[(19) - (23)].s)->u.strval;
					PushBackStr( "\xF3" );
					PushBackStr( (yyvsp[(19) - (23)].s)->u.strval );

				_endif
			
			_endif

		;}
    break;

  case 680:

/* Line 1464 of yacc.c  */
#line 26912 "hlaparse.bsn"
    {			/* $27 */

			struct contextListType	*cNode;
			SymNode_t				*s;
			SymNode_t				*d;


			_here;

	
			/*
			** If we've got any pass by value/result or
			** pass by result parameters, we've got to
			** copy the data back to the caller at this point.
			*/

			_if( (yyvsp[(11) - (26)].options.UseFrame) )

					StoreValResParms( (yyvsp[(2) - (26)].s) );

			_endif


			
			--CurLexLevel;
			CurOffset = (yyvsp[(3) - (26)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (26)].v.u.unsval);
			ThisPtr = (yyvsp[(6) - (26)].s);

			/*
			** Remove this iterator's local symbols from
			** further consideration in the symbol table.
			*/

			(yyvsp[(2) - (26)].s)->u.proc.Locals = SymbolTable;
			(yyvsp[(13) - (26)].s)->Next = NULL;
			SymbolTable = (yyvsp[(12) - (26)].s);

			/*
			** See if there are any outstanding undefined static
			** objects at lex level zero.
			*/

			CurrentContext = (yyvsp[(2) - (26)].s)->u.proc.BaseClass;
			CheckStatic( StaticList, 0 );
			CurrentContext = (yyvsp[(5) - (26)].s);

			/*
			** Output the necessary data to the assembly language
			** file to complete this method.
			*/

			_if( (yyvsp[(11) - (26)].options.UseFrame) )

				IteratorExit( (yyvsp[(2) - (26)].s)->u.proc.ParmSize ); 

			_endif
			EndProc( (yyvsp[(2) - (26)].s)->StaticName );
			endCseg();


			/*
			** See if there are any outstanding forward reference
			** labels.
			*/

			CheckFwdRef();

			free2( vss (yyvsp[(22) - (26)].neID.idStr) );


			/*
			** Restore currentNS value:
			*/
			
			currentNS = (yyvsp[(14) - (26)].ru.saveCurNS);
			
			
			
			inIterator = 0;

			/*
			** Remove the current context from the context stack.
			*/
			
			_if( (yyvsp[(11) - (26)].options.UseFrame) )

				assert( contextList != NULL );
				cNode = contextList;
				contextList = cNode->Next;

				assert( _streq( cNode->label, (yyvsp[(2) - (26)].s)->TrueName) );
				free2( vss cNode->StaticName );


			_endif
			(void) (yyvsp[(7) - (26)].s);	// Shut up bison
			_here;
		;}
    break;

  case 681:

/* Line 1464 of yacc.c  */
#line 27022 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(0) - (2)].s);
		;}
    break;

  case 682:

/* Line 1464 of yacc.c  */
#line 27035 "hlaparse.bsn"
    { (yyval.s) = (yyvsp[(2) - (6)].s); ;}
    break;

  case 683:

/* Line 1464 of yacc.c  */
#line 27037 "hlaparse.bsn"
    {					/* $9  */

			char msg[ 256 ];

			/*
			** Save the current SymbolTable pointer so we
			** can find the end of the declarations later.
			*/

			_here;
			(yyval.s) = SymbolTable;

			/*
			** Save the current SymbolTable pointer so we
			** can find the end of the declarations later.
			*/

			(yyval.s) = SymbolTable;
			
			_if( (yyvsp[(2) - (8)].s)->IsReferenced != NULL )
			
				(yyvsp[(2) - (8)].s)->IsReferenced->IsPublic = 1;
				
			_endif
			
			
			/*
			** Point ThisPtr at the current procedure ID
			** so we can access the class' fields (through
			** the proc.BaseClass field).
			*/
			
			ThisPtr = (yyvsp[(2) - (8)].s)->u.proc.BaseClass; 
			
			
			
			 

			_if( (yyvsp[(2) - (8)].s)->u.proc.Forward == NULL )

				sprintf
				(
					msg,
					"Duplicate symbol <<%s>>",
					(yyvsp[(2) - (8)].s)->TrueName
				);
				yyerror( msg );
				SymbolTable = (yyvsp[(2) - (8)].s)->u.proc.Locals;
					

			_else

				struct MethodListType	*FindProc;
				struct MethodListType	**PrevPtr;
				SymNode_t				*s;

				/*
				** Okay, this is the first declaration
				** of this iterator.  Point the SymbolTable
				** variable at this method's local vars
				** (that would just be the parameters, if any,
				** at this point) and mark the iterator as
				** processed.  Also, scan through the MethodList
				** and remove the reference to this iterator.
				*/

				SymbolTable = (yyvsp[(2) - (8)].s)->u.proc.Locals;
				(yyvsp[(2) - (8)].s)->u.proc.Forward = NULL;

				/*
				** Okay, remove the reference to this procedure
				** from the MethodList.
				*/

				FindProc = MethodList;
				PrevPtr = &MethodList;
				_while( FindProc->MethodSym != (yyvsp[(2) - (8)].s) )

					PrevPtr = &FindProc->Next;
					FindProc = FindProc->Next;
					assert( FindProc != NULL );

				_endwhile
				*PrevPtr = FindProc->Next;
				free2( vss FindProc );


				/*
				** NULL terminate the local symbols for
				** use by FixSymbols
				*/

				s = SymbolTable;
				_while( s != NULL && s->Next != (yyvsp[(2) - (8)].s) )

					s = s->Next;

				_endwhile
				_if( s != NULL )

					s->Next = NULL;

				_endif


			_endif
			_if( CurLexLevel != (yyvsp[(2) - (8)].s)->u.proc.BaseClass->LexLevel )

				yyerror
				( 
					"Class iterator declared at different lex level" 
				);

			_endif
			CurOffset = StartLclOffs;
			CurOffsetDir = -1;
			++CurLexLevel;

			/*
			** Create a symbol table entry for the "yield" thunk.
			*/

			InsertSym
			( 
				"yield", 
				&thunk_ste,	/* Type			*/
				tThunk, 	/* pType		*/
				cVar,		/* SymClass		*/ 
				0,			/* Arity		*/
				NULL,		/* dimensions	*/
				0, 			/* # elements	*/
				NULL,		/* Value		*/
				8,			/* ObjectSize	*/
				0,			/* Offset 		*/
				NULL,		/* StaticName	*/
				NULL,		/* Base			*/
				NULL,		/* Fields		*/
				0			/* FieldCnt		*/
			);

			/*
			** Thunks (yield) don't have any parameters,
			** but we can't leave proc.parms NULL (since other
			** code treats this as an error).  Just give each
			** Yield thunk a set of local constants which are
			** the lex level zero constants.
			*/
			
			SymbolTable->u.proc.parms = &true_ste;


			_here;
		;}
    break;

  case 684:

/* Line 1464 of yacc.c  */
#line 27191 "hlaparse.bsn"
    {						/* $11 */

			int	 *dimension;
			struct contextListType	*p;
			char					exitname[ 256 ];

			_here;
			CheckLegalOptions
			( 
				(yyvsp[(10) - (10)].options.SpecifiedOptions),
					specified_returns
				|	specified_use
				|	specified_noframe 
				|	specified_nodisplay 
				|	specified_noalignstk 
				|	specified_noenter 
				|	specified_noleave
				|	specified_pascal
				|	specified_stdcall
				|	specified_cdecl
				|	specified_alignment 
			);
			CurrentContext = (yyvsp[(2) - (10)].s);

			(yyval.s) = (yyvsp[(9) - (10)].s);  /* Required by FixSymbols and other code */


			_if( _strne( (yyvsp[(10) - (10)].options.returns), "" ))

				yyerror( "\"returns\" clause not allowed here" );
				free2( vss (yyvsp[(10) - (10)].options.returns) );

			_endif

			/*
			** Insert an entry for the display, if necessary.
			*/

			_if( (yyvsp[(10) - (10)].options.UseDisplay) )

				CurOffset -= ( CurLexLevel + 1 ) * 4;
				dimension = malloc2( sizeofInt );
				*dimension = CurLexLevel + 1;
				InsertSym
				( 
					"_display_", 
					&dword_ste,
					tDWord, 
					cVar, 
					1,
					dimension,
					*dimension, 
					NULL,
					*dimension*4,
					CurOffset,
					NULL,
					NULL,
					NULL,
					0
				);

			_endif



			/*
			** Add this procedure to the context list so we
			** can bail on this procedure via the EXIT and EXITIF
			** statements.
			*/
			
			_if( (yyvsp[(10) - (10)].options.UseFrame) )

				p = malloc2( sizeofContextListType );
				p->Next = contextList;
				p->label = (yyvsp[(2) - (10)].s)->TrueName;

				sprintf( exitname, "x%s" sympost, (yyvsp[(2) - (10)].s)->StaticName ); 
				p->StaticName = hlastrdup2( exitname );
				p->LexLevel = CurLexLevel;
				p->IsProc = 1;
				p->HasDisplay = (yyvsp[(10) - (10)].options.UseDisplay);
				p->SizeParms = (yyvsp[(2) - (10)].s)->u.proc.ParmSize;
				contextList = p;

			_endif
			_here;

		;}
    break;

  case 685:

/* Line 1464 of yacc.c  */
#line 27307 "hlaparse.bsn"
    {					/* $18 */

			SymNode_t	*CurSym;
			int			RoundedOffset;
			SymNode_t	value;
			int			HadPassByValRes;
			SymNode_t	*s;
			SymNode_t	*d;

			_here;
			inIterator = 1;


			/*
			** Check for pass by value/result or pass by result
			** parameters because we need to allocate local
			** storage for these.
			*/

			_if( (yyvsp[(10) - (17)].options.UseFrame) )

				HadPassByValRes = 0;
				s = (yyvsp[(2) - (17)].s)->u.proc.parms;
				_while( s != NULL && s != (yyvsp[(2) - (17)].s) )

					_if
					( 
							s->pType == tProcptr 
						&&	(
									s->pClass == vrp_pc 
								||	s->pClass == result_pc
							)
					)

						CurOffset = CurOffset - 4;
						InsertSym
						(
							s->TrueName, 
							NULL,				/* Type			*/
							tProcptr,		 	/* pType		*/
							cVar,				/* SymClass		*/ 
							s->Arity,			/* Arity		*/
							s->Dimensions,		/* dimensions	*/
							s->NumElements,		/* # elements	*/
							NULL,				/* Value		*/
							4,					/* ObjectSize	*/
							CurOffset,			/* Offset 		*/
							s->StaticName,		/* StaticName	*/
							s->Base,			/* Base			*/
							s->Fields,			/* Fields		*/
							s->FieldCnt			/* FieldCnt		*/
						);
						d = SymbolTable;
						d->u.proc.returns = hlastrdup2( "" );
						d->u.proc.use = s->u.proc.use;
						d->u.proc.parms = s->u.proc.parms;
						d->u.proc.Locals = s->u.proc.Locals;
						d->u.proc.Forward = s->u.proc.Forward;
						d->u.proc.BaseClass = s->u.proc.BaseClass;
						d->u.proc.ParmSize = s->u.proc.ParmSize;
						d->u.proc.cs = s->u.proc.cs;


						InsertSym
						(
							" (procptr type) ", 
							NULL,				/* Type			*/
							tProcptr,		 	/* pType		*/
							cType,				/* SymClass		*/ 
							0,					/* Arity		*/
							NULL,				/* dimensions	*/
							0,					/* # elements	*/
							NULL,				/* Value		*/
							4,					/* ObjectSize	*/
							0,					/* Offset 		*/
							NULL,				/* StaticName	*/
							NULL,				/* Base			*/
							NULL,				/* Fields		*/
							0					/* FieldCnt		*/
						);
						SymbolTable->u.proc.parms = s->u.proc.parms;
						SymbolTable->u.proc.returns = d->u.proc.returns;
						SymbolTable->u.proc.use = s->u.proc.use;
						SymbolTable->u.proc.Locals = s->u.proc.Locals;
						SymbolTable->u.proc.Forward = s->u.proc.Forward;
						SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
						SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
						SymbolTable->u.proc.cs = s->u.proc.cs;
						d->Type = SymbolTable;
						SymbolTable = d;

						HadPassByValRes = 
							HadPassByValRes || (s->pClass == vrp_pc );


					_elseif( s->pClass == vrp_pc || s->pClass == result_pc  )

						assert( s->Type != NULL );
						CurOffset = CurOffset - s->Type->ObjectSize;
						InsertSym
						(
							s->TrueName, 
							s->Type,			/* Type			*/
							s->Type->pType, 	/* pType		*/
							cVar,				/* SymClass		*/ 
							s->Arity,			/* Arity		*/
							s->Dimensions,		/* dimensions	*/
							s->NumElements,		/* # elements	*/
							NULL,				/* Value		*/
							s->Type->ObjectSize,/* ObjectSize	*/
							CurOffset,			/* Offset 		*/
							s->StaticName,		/* StaticName	*/
							s->Base,			/* Base			*/
							s->Fields,			/* Fields		*/
							s->FieldCnt			/* FieldCnt		*/
						);

						HadPassByValRes = 
							HadPassByValRes | (s->pClass == vrp_pc );

					_endif
					s = s->Next;

				_endwhile

			_endif



			/*
			** Compute the number of bytes of local variables
			** and round this number to the larger multiple of
			** four bytes.
			*/

			RoundedOffset = -CurOffset;
			_if( RoundedOffset != ( RoundedOffset & ~3 ))

				RoundedOffset = ( RoundedOffset + 4 ) & ~3;

			_endif

			/*
			** If we have a display, don't factor its size into
			** the # of bytes of local variables.
			*/

			_if( (yyvsp[(10) - (17)].options.UseDisplay) )

				RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

			_endif

			/*
			** Create a symbol table entry for the # of bytes
			** of local variables in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = RoundedOffset;
			InsertSym
			( 
				"_vars_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);




			/*
			** Output the assembly code for this procedure.
			**
			** For nested procedures (lex level 2 and above)
			** we need to emit the display
			*/

			_if( (yyvsp[(2) - (17)].s)->IsExternal )

				EmitPublic( (yyvsp[(2) - (17)].s)->StaticName );

			_endif
			startCseg();
			_if( (yyvsp[(10) - (17)].options.Alignment) != 1 )

				EmitAlign( (yyvsp[(10) - (17)].options.Alignment) );

			_endif
			StartProc( (yyvsp[(2) - (17)].s)->StaticName );
			_if( (yyvsp[(10) - (17)].options.UseFrame) && !(yyvsp[(10) - (17)].options.UseDisplay) )


				/*
				** If we're not building a display, just use the
				** standard entry sequence.
				*/

				StdEntry( RoundedOffset, (yyvsp[(10) - (17)].options.NoEnter) );

				/*
				** Align the stack on a dword boundary.
				*/

				_if( AlwaysAlignStk && (yyvsp[(10) - (17)].options.AlignStk) )

					AlignStack();

				_endif

			_elseif( (yyvsp[(10) - (17)].options.UseFrame) )

				/*
				** We've got to construct the display.
				*/

				ConstructDisplay
				( 
					CurLexLevel, 
					RoundedOffset,
					(yyvsp[(10) - (17)].options.NoEnter) 
				);

				/*
				** Align the stack on a dword boundary.
				*/

				_if( AlwaysAlignStk && (yyvsp[(10) - (17)].options.AlignStk) )

					AlignStack();

				_endif

			_endif





			/*
			** If we have any pass by value/result parameters, emit
			** code to copy the data into the local storage allocated
			** to hold the parameter.  Note that we do not copy pass
			** by result parameters here because they are "out only"
			** variables.
			*/

			_if( (yyvsp[(10) - (17)].options.UseFrame) && HadPassByValRes )

				CopyValResParms( (yyvsp[(2) - (17)].s) );

			_endif





			assert( (yyvsp[(16) - (17)].neID.idStr) != NULL );

			_if( _strne( (yyvsp[(2) - (17)].s)->TrueName, (yyvsp[(16) - (17)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				( 
					msg,
					"Identifier <<%s>> after 'begin' must match "
					"iterator name <<%s>>",
					(yyvsp[(16) - (17)].idStr),
					(yyvsp[(2) - (17)].s)->TrueName
				);

				yyerror( msg );

			_endif


			/*
			** Set up the Locals pointer to point at the
			** newly acquired local variables.
			*/

			(yyvsp[(2) - (17)].s)->u.proc.Locals = SymbolTable;


			/*
			** Check to ensure that all forward declared symbols
			** have been defined prior to code emission.
			*/

		
			CheckForwardDecls( (yyvsp[(11) - (17)].s) );

			/*
			** Check to make sure all pointer forward references have
			** been resolved.
			*/

			CheckPtrs();

			free2( vss (yyvsp[(16) - (17)].neID.idStr) );

			/*
			** Emit the text associated with the _initialize_ string
			** at this point.
			**
			**	Note: the "InvisibleCode" variable is used by
			**	yyerror to determine if it should print the
			**	_initialize_ string as part of the error message.
			*/

			
			(yyval.s) = lookup( "_finalize_", 1 );
			assert( (yyval.s) != NULL );
			_if( (yyvsp[(11) - (17)].options.UseFrame) )
			
				s=(yyval.s)->Next;
				InvisibleCode = NULL;
				_if
				( 
						s->pType != tString 
					&&	s->pType != tZString 
				)

					WarnNear
					( 
						"_initialize_'s type is not string.  "
						"Initialization ignored.",
						"_initialize_" 
					);

				_elseif( strlen( s->u.strval ) != 0 )

					InvisibleCode = s->u.strval;
					PushBackStr( "\xF3" );
					PushBackStr( s->u.strval );

				_endif
				
			_endif
			_here;

		;}
    break;

  case 686:

/* Line 1464 of yacc.c  */
#line 27691 "hlaparse.bsn"
    {				/* $23 */

			_here;
			assert( (yyvsp[(21) - (22)].neID.idStr) != NULL );

			_if( _strne( (yyvsp[(2) - (22)].s)->TrueName, (yyvsp[(21) - (22)].neID.idStr) ))

				char msg[ 256 ];

				sprintf
				( 
					msg,
					"Identifier <<%s>> after 'end' must match "
					"iterator name <<%s>>",
					(yyvsp[(21) - (22)].neID.idStr),
					(yyvsp[(2) - (22)].s)->TrueName
				);

				yyerror( msg );

			_endif


			/*
			** Emit the label at the end of the procedure
			*/

			PushBackStr( "end" );
			_if( (yyvsp[(10) - (22)].options.UseFrame) )

				char lbl[256];
				
				sprintf( lbl, "x%s" sympost, (yyvsp[(2) - (22)].s)->StaticName );
				EmitStmtLbl( lbl );

	
				/*
				** Deal with the _finalize_ string here.
				*/

				InvisibleCode = NULL;
				_if
				( 
						(yyvsp[(18) - (22)].s)->pType != tString 
					&&	(yyvsp[(18) - (22)].s)->pType != tZString 
				)

					WarnNear
					(
						"_finalize_ must be a string constant.  Value ignored",
						"_finalize_"
					);

				_elseif( strlen( (yyvsp[(18) - (22)].s)->u.strval ) != 0 )

					InvisibleCode = (yyvsp[(18) - (22)].s)->u.strval;
					PushBackStr( "\xF3" );
					PushBackStr( (yyvsp[(18) - (22)].s)->u.strval );

				_endif
			
			_endif
			_here;
		;}
    break;

  case 687:

/* Line 1464 of yacc.c  */
#line 27757 "hlaparse.bsn"
    {			/* $26 */

			struct contextListType	*cNode;
			SymNode_t				*s;
			SymNode_t				*d;


			_here;

	
			/*
			** If we've got any pass by value/result or
			** pass by result parameters, we've got to
			** copy the data back to the caller at this point.
			*/

			_if( (yyvsp[(10) - (25)].options.UseFrame) )

					StoreValResParms( (yyvsp[(2) - (25)].s) );

			_endif


			
			--CurLexLevel;
			CurOffset = (yyvsp[(3) - (25)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (25)].v.u.unsval);
			ThisPtr = (yyvsp[(6) - (25)].s);

			/*
			** Remove this iterator's local symbols from
			** further consideration in the symbol table.
			*/

			(yyvsp[(2) - (25)].s)->u.proc.Locals = SymbolTable;
			(yyvsp[(12) - (25)].s)->Next = NULL;
			SymbolTable = (yyvsp[(11) - (25)].s);

			/*
			** See if there are any outstanding undefined static
			** objects at lex level zero.
			*/

			CurrentContext = (yyvsp[(2) - (25)].s)->u.proc.BaseClass;
			CheckStatic( StaticList, 0 );
			CurrentContext = (yyvsp[(5) - (25)].s);

			/*
			** Output the necessary data to the assembly language
			** file to complete this method.
			*/

			_if( (yyvsp[(10) - (25)].options.UseFrame) )

				IteratorExit( (yyvsp[(2) - (25)].s)->u.proc.ParmSize ); 

			_endif
			EndProc( (yyvsp[(2) - (25)].s)->StaticName );
			endCseg();


			/*
			** See if there are any outstanding forward reference
			** labels.
			*/

			CheckFwdRef();

			free2( vss (yyvsp[(21) - (25)].neID.idStr) );


			/*
			** Restore currentNS value:
			*/
			
			currentNS = (yyvsp[(13) - (25)].ru.saveCurNS);
			
			
			
			inIterator = 0;

			/*
			** Remove the current context from the context stack.
			*/
			
			_if( (yyvsp[(10) - (25)].options.UseFrame) )

				assert( contextList != NULL );
				cNode = contextList;
				contextList = cNode->Next;

				assert( _streq( cNode->label, (yyvsp[(2) - (25)].s)->TrueName) );
				free2( vss cNode->StaticName );


			_endif
			(void) (yyvsp[(7) - (25)].s);	// Shut up bison
			_here;
		;}
    break;

  case 688:

/* Line 1464 of yacc.c  */
#line 27884 "hlaparse.bsn"
    { 					/* $11 */
				_here;
				(yyval.idStr) = hlastrdup2( (yyvsp[(2) - (10)].idStr) ); 
			;}
    break;

  case 689:

/* Line 1464 of yacc.c  */
#line 27890 "hlaparse.bsn"
    {
				SymNode_t	*ParmList;
				SymNode_t	*localProcDcl;
				char		*CurrentType;
				SymNode_t	value;

				_here;
				CheckLegalOptions
				( 
					(yyvsp[(9) - (13)].options.SpecifiedOptions),
						specified_returns 
					|	specified_pascal 
					|	specified_stdcall 
					|	specified_cdecl 
					|	specified_use
				);

				CurOffset = (yyvsp[(3) - (13)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (13)].v.u.unsval);
				--CurLexLevel;

				_if( CurLexLevel != 0 )

					yyerror
					( 
						"External procedures may only be declared "
						"at lex level zero"
					);

				_endif


				// On return. u.proc.parms points at the local
				// declaration for this procedure. Save it so
				// we can use that data later.
				
				localProcDcl = (yyvsp[(6) - (13)].en.s)->u.proc.parms;

				/*
				** Change the static name to correspond to the
				** external name of this procedure.  Note that
				** we need to update the name in two places.
				*/

				free2( vss localProcDcl->StaticName );
				localProcDcl->StaticName = hlastrdup2( (yyvsp[(12) - (13)].idStr) );

				free2( vss (yyvsp[(6) - (13)].en.s)->StaticName );
				(yyvsp[(6) - (13)].en.s)->StaticName = (yyvsp[(12) - (13)].idStr);

			
				/*
				** Since this is an external declaration, mark it
				** as such.
				*/

				(yyvsp[(6) - (13)].en.s)->IsExternal = 1;

				/*
				** Update this procedure's "returns" and "use" fields.
				*/

				(yyvsp[(6) - (13)].en.s)->u.proc.returns = (yyvsp[(9) - (13)].options.returns);
				(yyvsp[(6) - (13)].en.s)->u.proc.use = (yyvsp[(9) - (13)].options.use);


				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.
				*/


				localProcDcl->u.proc.parms = SymbolTable;
				localProcDcl->u.proc.returns = (yyvsp[(9) - (13)].options.returns);
				localProcDcl->u.proc.use = (yyvsp[(9) - (13)].options.use);




				/*
				** Mark the end of the parameter list, and then
				** insert the _parms_ constant into the symbol table.
				*/

				(yyvsp[(6) - (13)].en.s)->u.proc.parms = SymbolTable;


				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(7) - (13)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);


				/*
				** This is a external procedure, so mark it as a forward
				** procedure in the event this external declaration appears
				** within a header file included by the file containing
				** the actual declaration.
				*/

				(yyvsp[(6) - (13)].en.s)->u.proc.Forward = SymbolTable;

				/*
				** Store up the external definition for later emission:
				*/

				EmitTypedExtern( (yyvsp[(6) - (13)].en.s), (yyvsp[(12) - (13)].idStr), tLabel );

				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table
				*/

				(yyvsp[(6) - (13)].en.s)->u.proc.Locals = SymbolTable;

				SymbolTable = (yyvsp[(6) - (13)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(6) - (13)].en.s);
				localProcDcl->IsExternal = 1;
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (13)].s);
				(yyvsp[(6) - (13)].en.s)->IsReferenced = localProcDcl->IsReferenced;
				



				// If the calling sequence reverses the parameters,
				// go in and swap all the offsets on the parameters:

				(yyvsp[(6) - (13)].en.s)->u.proc.cs = (yyvsp[(9) - (13)].options.CallingSequence);
				_if
				(
						(yyvsp[(9) - (13)].options.CallingSequence) == stdcall_cs
					||	(yyvsp[(9) - (13)].options.CallingSequence) == cdecl_cs
				)

					SymNode_t	*fixParms;
					int			offset;

					fixParms = (yyvsp[(6) - (13)].en.s)->u.proc.parms;

					offset = 8;
					_while( fixParms != NULL && fixParms != (yyvsp[(6) - (13)].en.s) )

						_if( fixParms->SymClass == cParm )

							fixParms->Offset = offset;
							
							// Round up to the next multiple of four:
							
							offset += ((( fixParms->ObjectSize + 3) >> 2) << 2);

						_endif
						fixParms = fixParms->Next;

					_endwhile


				_endif
				
				
				/*
				** Restore the currentNS value saved in EnterName:
				*/
				
				currentNS = (yyvsp[(6) - (13)].en.cns);
				(void) (yyvsp[(11) - (13)].idStr);	// Shut Up Bison				
				_here;
			;}
    break;

  case 690:

/* Line 1464 of yacc.c  */
#line 28117 "hlaparse.bsn"
    { 						/* $10 */
				_here;
				(yyval.idStr) = hlastrdup2( (yyvsp[(1) - (9)].idStr) ); 
			;}
    break;

  case 691:

/* Line 1464 of yacc.c  */
#line 28123 "hlaparse.bsn"
    {
				SymNode_t	*ParmList;
				SymNode_t	*localProcDcl;
				char		*CurrentType;
				SymNode_t	value;

				_here;
				CheckLegalOptions
				( 
					(yyvsp[(8) - (12)].options.SpecifiedOptions),
						specified_returns 
					|	specified_pascal 
					|	specified_stdcall 
					|	specified_cdecl 
					|	specified_use
				);

				CurOffset = (yyvsp[(3) - (12)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (12)].v.u.unsval);
				--CurLexLevel;

				_if( CurLexLevel != 0 )

					yyerror
					( 
						"External procedures may only be declared "
						"at lex level zero"
					);

				_endif


				// On return. u.proc.parms points at the local
				// declaration for this procedure. Save it so
				// we can use that data later.
				
				localProcDcl = (yyvsp[(6) - (12)].en.s)->u.proc.parms;

				/*
				** Change the static name to correspond to the
				** external name of this procedure.  Note that
				** we need to update the name in two places.
				*/

				free2( vss localProcDcl->StaticName );
				localProcDcl->StaticName = hlastrdup2( (yyvsp[(11) - (12)].idStr) );

				free2( vss (yyvsp[(6) - (12)].en.s)->StaticName );
				(yyvsp[(6) - (12)].en.s)->StaticName = (yyvsp[(11) - (12)].idStr);

			
				/*
				** Since this is an external declaration, mark it
				** as such.
				*/

				(yyvsp[(6) - (12)].en.s)->IsExternal = 1;

				/*
				** Update this procedure's "returns" and "use" fields.
				*/

				(yyvsp[(6) - (12)].en.s)->u.proc.returns 		= (yyvsp[(8) - (12)].options.returns);
				(yyvsp[(6) - (12)].en.s)->u.proc.use 			= (yyvsp[(8) - (12)].options.use);


				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.
				*/


				localProcDcl->u.proc.parms = SymbolTable;
				localProcDcl->u.proc.returns = (yyvsp[(8) - (12)].options.returns);
				localProcDcl->u.proc.use = (yyvsp[(8) - (12)].options.use);




				/*
				** Mark the end of the parameter list, and then
				** insert the _parms_ constant into the symbol table.
				*/

				(yyvsp[(6) - (12)].en.s)->u.proc.parms = SymbolTable;


				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(7) - (12)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);


				/*
				** This is a external procedure, so mark it as a forward
				** procedure in the event this external declaration appears
				** within a header file included by the file containing
				** the actual declaration.
				*/

				(yyvsp[(6) - (12)].en.s)->u.proc.Forward = SymbolTable;

				/*
				** Store up the external definition for later emission:
				*/

				EmitTypedExtern( (yyvsp[(6) - (12)].en.s), (yyvsp[(11) - (12)].idStr), tLabel );

				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table
				*/

				(yyvsp[(6) - (12)].en.s)->u.proc.Locals = SymbolTable;

				SymbolTable = (yyvsp[(6) - (12)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(6) - (12)].en.s);
				localProcDcl->IsExternal = 1;
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (12)].s);
				(yyvsp[(6) - (12)].en.s)->IsReferenced = localProcDcl->IsReferenced;
				



				// If the calling sequence reverses the parameters,
				// go in and swap all the offsets on the parameters:

				(yyvsp[(6) - (12)].en.s)->u.proc.cs = (yyvsp[(8) - (12)].options.CallingSequence);
				localProcDcl->u.proc.cs = (yyvsp[(8) - (12)].options.CallingSequence);
				_if
				(
						(yyvsp[(9) - (12)].options.CallingSequence) == stdcall_cs
					||	(yyvsp[(9) - (12)].options.CallingSequence) == cdecl_cs
				)

					SymNode_t	*fixParms;
					int			offset;

					fixParms = (yyvsp[(6) - (12)].en.s)->u.proc.parms;

					offset = 8;
					_while( fixParms != NULL && fixParms != (yyvsp[(6) - (12)].en.s) )

						_if( fixParms->SymClass == cParm )

							fixParms->Offset = offset;
							
							// Round up to the next multiple of four:
							
							offset += ((( fixParms->ObjectSize + 3) >> 2) << 2);

						_endif
						fixParms = fixParms->Next;

					_endwhile


				_endif
				
				
				/*
				** Restore the currentNS value saved in EnterName:
				*/
				
				currentNS = (yyvsp[(6) - (12)].en.cns);
				(void) (yyvsp[(10) - (12)].idStr);	// Shut Up Bison				
				_here;
			;}
    break;

  case 692:

/* Line 1464 of yacc.c  */
#line 28347 "hlaparse.bsn"
    { 						/* $11 */
				_here;
				(yyval.idStr) = hlastrdup2( (yyvsp[(1) - (10)].idStr) ); 
			;}
    break;

  case 693:

/* Line 1464 of yacc.c  */
#line 28353 "hlaparse.bsn"
    {					/* $14 */
				SymNode_t	*ParmList;
				SymNode_t	*localProcDcl;
				char		*CurrentType;
				SymNode_t	value;
				short		CallingSequence;
				char		*use;
				char		*returns;

				_here;


				CheckLegalOptions
				( 
					(yyvsp[(9) - (13)].options.SpecifiedOptions),
						specified_returns 
					|	specified_use
					|	specified_pascal 
					|	specified_stdcall 
					|	specified_cdecl 
				);
				_if( (yyvsp[(9) - (13)].options.SpecifiedOptions) & specified_use )
				
					use = (yyvsp[(9) - (13)].options.use);
					
				_else
				
					use = (yyvsp[(3) - (13)].s)->u.proc.use;
					
				_endif
				_if( (yyvsp[(9) - (13)].options.SpecifiedOptions) & specified_returns )
				
					returns = (yyvsp[(9) - (13)].options.returns);
					
				_else
				
					returns = (yyvsp[(3) - (13)].s)->u.proc.returns;
					
				_endif
				_if( (yyvsp[(9) - (13)].options.SpecifiedOptions) & specified_stdcall )
				
					CallingSequence = stdcall_cs;
					
				_elseif( (yyvsp[(9) - (13)].options.SpecifiedOptions) & specified_cdecl )
				
					CallingSequence = cdecl_cs;
					
				_elseif( (yyvsp[(9) - (13)].options.SpecifiedOptions) & specified_pascal )
				
					CallingSequence = pascal_cs;
					
				_else
				
					CallingSequence = (yyvsp[(3) - (13)].s)->u.proc.cs;
					_if( (yyvsp[(3) - (13)].s)->u.proc.cs == stdcall_cs )
					
						(yyvsp[(9) - (13)].options.SpecifiedOptions) |= specified_stdcall;
						(yyvsp[(9) - (13)].options.CallingSequence) = stdcall_cs;	
					
					_elseif( (yyvsp[(3) - (13)].s)->u.proc.cs == cdecl_cs )
					
						(yyvsp[(9) - (13)].options.SpecifiedOptions) |= specified_cdecl;	
						(yyvsp[(9) - (13)].options.CallingSequence) = cdecl_cs;
						
					_endif	
				
				_endif
				(yyvsp[(8) - (13)].en.s)->u.proc.parms->u.proc.cs = CallingSequence;
				

				CurOffset = (yyvsp[(5) - (13)].v.u.unsval);
				CurOffsetDir = (yyvsp[(6) - (13)].v.u.unsval);
				--CurLexLevel;

				_if( CurLexLevel != 0 )

					yyerror
					( 
						"External procedures may only be declared "
						"at lex level zero"
					);

				_endif


				// Save a pointer to the local declaration of this
				// procedure because we're about to wipe out the value
				// in u.proc.parms.
				
				localProcDcl = (yyvsp[(8) - (13)].en.s)->u.proc.parms;
				

				// On return. u.proc.parms points at the local
				// declaration for this procedure. Save it so
				// we can use that data later.
				
				copyProcPtrParms( (yyvsp[(3) - (13)].s) );
				(yyvsp[(8) - (13)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(8) - (13)].en.s)->u.proc.parms->u.proc.returns = returns;
				(yyvsp[(8) - (13)].en.s)->u.proc.parms->u.proc.use = use;
				(yyvsp[(8) - (13)].en.s)->u.proc.parms->u.proc.ParmSize = (yyvsp[(3) - (13)].s)->u.proc.ParmSize;
				(yyvsp[(8) - (13)].en.s)->u.proc.ParmSize = (yyvsp[(3) - (13)].s)->u.proc.ParmSize;
				(yyvsp[(8) - (13)].en.s)->u.proc.parms = SymbolTable;
				(yyvsp[(8) - (13)].en.s)->u.proc.returns = returns;
				(yyvsp[(8) - (13)].en.s)->u.proc.use = use;
				

				/*
				** Change the static name to correspond to the
				** external name of this procedure.  Note that
				** we need to update the name in two places.
				*/

				free2( vss localProcDcl->StaticName );
				localProcDcl->StaticName = hlastrdup2( (yyvsp[(12) - (13)].idStr) );

				free2( vss (yyvsp[(8) - (13)].en.s)->StaticName );
				(yyvsp[(8) - (13)].en.s)->StaticName = (yyvsp[(12) - (13)].idStr);

			
				/*
				** Since this is an external declaration, mark it
				** as such.
				*/

				(yyvsp[(8) - (13)].en.s)->IsExternal = 1;

				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(3) - (13)].s)->u.proc.ParmSize;
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);


				/*
				** This is a external procedure, so mark it as a forward
				** procedure in the event this external declaration appears
				** within a header file included by the file containing
				** the actual declaration.
				*/

				(yyvsp[(8) - (13)].en.s)->u.proc.Forward = SymbolTable;

				/*
				** Store up the external definition for later emission:
				*/

				EmitTypedExtern( (yyvsp[(8) - (13)].en.s), (yyvsp[(12) - (13)].idStr), tLabel );

				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table
				*/

				(yyvsp[(8) - (13)].en.s)->u.proc.Locals = SymbolTable;

				SymbolTable = (yyvsp[(8) - (13)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(8) - (13)].en.s);
				localProcDcl->IsExternal = 1;
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(7) - (13)].s);
				(yyvsp[(8) - (13)].en.s)->IsReferenced = localProcDcl->IsReferenced;
				



				// If the calling sequence reverses the parameters,
				// go in and swap all the offsets on the parameters:

				(yyvsp[(8) - (13)].en.s)->u.proc.cs = CallingSequence;
				_if
				(
						CallingSequence == stdcall_cs
					||	CallingSequence == cdecl_cs
				)

					SymNode_t	*fixParms;
					int			offset;

					fixParms = (yyvsp[(8) - (13)].en.s)->u.proc.parms;

					offset = 8;
					_while( fixParms != NULL && fixParms != (yyvsp[(8) - (13)].en.s) )

						_if( fixParms->SymClass == cParm )

							fixParms->Offset = offset;
							
							// Round up to the next multiple of four:
							
							offset += ((( fixParms->ObjectSize + 3) >> 2) << 2);

						_endif
						fixParms = fixParms->Next;

					_endwhile


				_endif
				
				
				/*
				** Restore the currentNS value saved in EnterName:
				*/
				
				currentNS = (yyvsp[(8) - (13)].en.cns);
				(void) (yyvsp[(11) - (13)].idStr);	// Shut Up Bison				
				_here;
			;}
    break;

  case 694:

/* Line 1464 of yacc.c  */
#line 28616 "hlaparse.bsn"
    { 					/* $11 */
				_here;
				(yyval.idStr) = hlastrdup2( (yyvsp[(2) - (10)].idStr) ); 
			;}
    break;

  case 695:

/* Line 1464 of yacc.c  */
#line 28622 "hlaparse.bsn"
    {					/* $14 */

				SymNode_t	*ParmList;
				char		*CurrentType;
				SymNode_t	value;


				_here;
				CheckLegalOptions
				( 
					(yyvsp[(9) - (13)].options.SpecifiedOptions),
					specified_use
				);

				CurOffset = (yyvsp[(3) - (13)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (13)].v.u.unsval);
				--CurLexLevel;

				_if( CurLexLevel != 0 )

					yyerror
					( 
						"External iterators may only be declared "
						"at lex level zero"
					);

				_endif

				/*
				** Change the static name to correspond to the
				** external name of this procedure.  Note that
				** we need to update the name in two places.
				*/

				free2( vss (yyvsp[(6) - (13)].en.s)->u.proc.parms->StaticName );
				(yyvsp[(6) - (13)].en.s)->u.proc.parms->StaticName = hlastrdup2( (yyvsp[(12) - (13)].idStr) );

				free2( vss (yyvsp[(6) - (13)].en.s)->StaticName );
				(yyvsp[(6) - (13)].en.s)->StaticName = (yyvsp[(12) - (13)].idStr);

				/*
				** Since this is an external declaration, mark it
				** as such.
				*/

				(yyvsp[(6) - (13)].en.s)->IsExternal = 1;

				/*
				** Update this procedure's "returns" and "use" fields.
				*/


				(yyvsp[(6) - (13)].en.s)->u.proc.returns = (yyvsp[(9) - (13)].options.returns);
				(yyvsp[(6) - (13)].en.s)->u.proc.use = (yyvsp[(9) - (13)].options.use);


				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.
				*/


				(yyvsp[(6) - (13)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(6) - (13)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (13)].options.returns);
				(yyvsp[(6) - (13)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (13)].options.use);

				// Iterators always use the pascal calling sequence:
				
				(yyvsp[(6) - (13)].en.s)->u.proc.cs = pascal_cs;
				(yyvsp[(6) - (13)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
				



				/*
				** Mark the end of the parameter list, and then
				** insert the _parms_ constant into the symbol table.
				*/

				(yyvsp[(6) - (13)].en.s)->u.proc.parms = SymbolTable;


				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(7) - (13)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);


				/*
				** This is a external procedure, so mark it as a forward
				** procedure in the event this external declaration appears
				** within a header file included by the file containing
				** the actual declaration.
				*/

				(yyvsp[(6) - (13)].en.s)->u.proc.Forward = SymbolTable;


				/*
				** Queue up the external declaration for later emission.
				*/

				EmitTypedExtern( (yyvsp[(6) - (13)].en.s), (yyvsp[(12) - (13)].idStr), tLabel );


				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table
				*/

				(yyvsp[(6) - (13)].en.s)->u.proc.Locals = SymbolTable;

				SymbolTable = (yyvsp[(6) - (13)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(6) - (13)].en.s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (13)].s);


				/*
				** Restore currentNS.
				*/
				
				currentNS = (yyvsp[(6) - (13)].en.cns);
				(void) (yyvsp[(11) - (13)].idStr);	// Shut up bison				
				_here;
			;}
    break;

  case 696:

/* Line 1464 of yacc.c  */
#line 28801 "hlaparse.bsn"
    { 						/* $10 */
				_here;
				(yyval.idStr) = hlastrdup2( (yyvsp[(2) - (9)].idStr) ); 
			;}
    break;

  case 697:

/* Line 1464 of yacc.c  */
#line 28807 "hlaparse.bsn"
    {					/* $13 */

				SymNode_t	*ParmList;
				char		*CurrentType;
				SymNode_t	value;
				char		*use;


				_here;
				CheckLegalOptions
				( 
					(yyvsp[(8) - (12)].options.SpecifiedOptions),
					specified_use
				);

				CurOffset = (yyvsp[(3) - (12)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (12)].v.u.unsval);
				--CurLexLevel;

				_if( CurLexLevel != 0 )

					yyerror
					( 
						"External iterators may only be declared "
						"at lex level zero"
					);

				_endif

				/*
				** Change the static name to correspond to the
				** external name of this procedure.  Note that
				** we need to update the name in two places.
				*/

				free2( vss (yyvsp[(6) - (12)].en.s)->u.proc.parms->StaticName );
				(yyvsp[(6) - (12)].en.s)->u.proc.parms->StaticName = hlastrdup2( (yyvsp[(11) - (12)].idStr) );

				free2( vss (yyvsp[(6) - (12)].en.s)->StaticName );
				(yyvsp[(6) - (12)].en.s)->StaticName = (yyvsp[(11) - (12)].idStr);

				/*
				** Since this is an external declaration, mark it
				** as such.
				*/

				(yyvsp[(6) - (12)].en.s)->IsExternal = 1;

				/*
				** Update this procedure's "returns" and "use" fields.
				*/


				(yyvsp[(6) - (12)].en.s)->u.proc.returns = (yyvsp[(8) - (12)].options.returns);
				(yyvsp[(6) - (12)].en.s)->u.proc.use = (yyvsp[(8) - (12)].options.use);


				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.
				*/


				(yyvsp[(6) - (12)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(6) - (12)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(8) - (12)].options.returns);
				(yyvsp[(6) - (12)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(8) - (12)].options.use);

				// Iterators always use the pascal calling sequence:
				
				(yyvsp[(6) - (12)].en.s)->u.proc.cs = pascal_cs;
				(yyvsp[(6) - (12)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
				



				/*
				** Mark the end of the parameter list, and then
				** insert the _parms_ constant into the symbol table.
				*/

				(yyvsp[(6) - (12)].en.s)->u.proc.parms = SymbolTable;


				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(7) - (12)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);


				/*
				** This is a external procedure, so mark it as a forward
				** procedure in the event this external declaration appears
				** within a header file included by the file containing
				** the actual declaration.
				*/

				(yyvsp[(6) - (12)].en.s)->u.proc.Forward = SymbolTable;


				/*
				** Queue up the external declaration for later emission.
				*/

				EmitTypedExtern( (yyvsp[(6) - (12)].en.s), (yyvsp[(11) - (12)].idStr), tLabel );


				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table
				*/

				(yyvsp[(6) - (12)].en.s)->u.proc.Locals = SymbolTable;

				SymbolTable = (yyvsp[(6) - (12)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(6) - (12)].en.s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (12)].s);


				/*
				** Restore currentNS.
				*/
				
				currentNS = (yyvsp[(6) - (12)].en.cns);
				(void) (yyvsp[(10) - (12)].idStr);	// Shut up bison				
				_here;
			;}
    break;

  case 698:

/* Line 1464 of yacc.c  */
#line 28988 "hlaparse.bsn"
    {					/* $12 */

				SymNode_t	*ParmList;
				char		*CurrentType;
				int			*dimension;
				SymNode_t	value;

				_here;
				CheckLegalOptions
				( 
					(yyvsp[(9) - (11)].options.SpecifiedOptions),
						specified_returns 
					|	specified_pascal 
					|	specified_stdcall 
					|	specified_cdecl 
					|	specified_use
				);

				(yyvsp[(6) - (11)].en.s)->u.proc.cs = (yyvsp[(9) - (11)].options.CallingSequence);

				/*
				** Set up the "returns" field for this procedure.
				*/

				(yyvsp[(6) - (11)].en.s)->u.proc.returns = (yyvsp[(9) - (11)].options.returns);
				(yyvsp[(6) - (11)].en.s)->u.proc.use = (yyvsp[(9) - (11)].options.use);

				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.  Note that $<6>->u.proc.parms
				** points at the local symbol table entry that has
				** the same name as the current procedure (to prevent
				** reusing the name in the procedure).
				*/

				(yyvsp[(6) - (11)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(6) - (11)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (11)].options.returns);
				(yyvsp[(6) - (11)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (11)].options.use);


				/*
				** Mark the end of the parameter list, and then
				** insert the _parms_ constant into the symbol table.
				*/

				(yyvsp[(6) - (11)].en.s)->u.proc.parms = SymbolTable;

				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(7) - (11)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);


				/*
				** This is a forward procedure, so mark it as such
				** in the symbol table.
				*/

				(yyvsp[(6) - (11)].en.s)->u.proc.Forward = SymbolTable;


				

				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table
				** (of course, there are no local symbols for
				** forward declarations, but we still have to
				** point proc.Locals at the parameters, if any).
				*/

				(yyvsp[(6) - (11)].en.s)->u.proc.Locals = SymbolTable;




				CurOffset = (yyvsp[(3) - (11)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (11)].v.u.unsval);
				--CurLexLevel;

				SymbolTable = (yyvsp[(6) - (11)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(6) - (11)].en.s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (11)].s);

				// If the calling sequence reverses the parameters,
				// go in and swap all the offsets on the parameters:

				_if
				(
						(yyvsp[(6) - (11)].en.s)->u.proc.cs == stdcall_cs
					||	(yyvsp[(6) - (11)].en.s)->u.proc.cs == cdecl_cs
				)

					SymNode_t	*fixParms;
					int			offset;

					fixParms = (yyvsp[(6) - (11)].en.s)->u.proc.parms;

					offset = 8;
					_while( fixParms != NULL && fixParms != (yyvsp[(6) - (11)].en.s) )

						_if( fixParms->SymClass == cParm )

							fixParms->Offset = offset;
							
							// Round up to the next multiple of four:
							
							offset += ((( fixParms->ObjectSize + 3) >> 2) << 2);

						_endif
						fixParms = fixParms->Next;

					_endwhile

				_endif
				
				/*
				** Restore currentNS
				*/
				
				currentNS = (yyvsp[(6) - (11)].en.cns);
				_here;
			;}
    break;

  case 699:

/* Line 1464 of yacc.c  */
#line 29177 "hlaparse.bsn"
    {						/* $11 */

				SymNode_t	*ParmList;
				char		*CurrentType;
				int			*dimension;
				SymNode_t	value;

				_here;
				CheckLegalOptions
				( 
					(yyvsp[(8) - (10)].options.SpecifiedOptions),
						specified_returns 
					|	specified_pascal 
					|	specified_stdcall 
					|	specified_cdecl 
					|	specified_use
				);

				(yyvsp[(6) - (10)].en.s)->u.proc.cs = (yyvsp[(8) - (10)].options.CallingSequence);

				/*
				** Set up the "returns" field for this procedure.
				*/

				(yyvsp[(6) - (10)].en.s)->u.proc.returns = (yyvsp[(8) - (10)].options.returns);
				(yyvsp[(6) - (10)].en.s)->u.proc.use = (yyvsp[(8) - (10)].options.use);

				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.  Note that $<6>->u.proc.parms
				** points at the local symbol table entry that has
				** the same name as the current procedure (to prevent
				** reusing the name in the procedure).
				*/

				(yyvsp[(6) - (10)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(6) - (10)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(8) - (10)].options.returns);
				(yyvsp[(6) - (10)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(8) - (10)].options.use);


				/*
				** Mark the end of the parameter list, and then
				** insert the _parms_ constant into the symbol table.
				*/

				(yyvsp[(6) - (10)].en.s)->u.proc.parms = SymbolTable;

				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(7) - (10)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);


				/*
				** This is a forward procedure, so mark it as such
				** in the symbol table.
				*/

				(yyvsp[(6) - (10)].en.s)->u.proc.Forward = SymbolTable;


				

				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table
				** (of course, there are no local symbols for
				** forward declarations, but we still have to
				** point proc.Locals at the parameters, if any).
				*/

				(yyvsp[(6) - (10)].en.s)->u.proc.Locals = SymbolTable;




				CurOffset = (yyvsp[(3) - (10)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (10)].v.u.unsval);
				--CurLexLevel;

				SymbolTable = (yyvsp[(6) - (10)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(6) - (10)].en.s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (10)].s);

				// If the calling sequence reverses the parameters,
				// go in and swap all the offsets on the parameters:

				_if
				(
						(yyvsp[(6) - (10)].en.s)->u.proc.cs == stdcall_cs
					||	(yyvsp[(6) - (10)].en.s)->u.proc.cs == cdecl_cs
				)

					SymNode_t	*fixParms;
					int			offset;

					fixParms = (yyvsp[(6) - (10)].en.s)->u.proc.parms;

					offset = 8;
					_while( fixParms != NULL && fixParms != (yyvsp[(6) - (10)].en.s) )

						_if( fixParms->SymClass == cParm )

							fixParms->Offset = offset;
							
							// Round up to the next multiple of four:
							
							offset += ((( fixParms->ObjectSize + 3) >> 2) << 2);

						_endif
						fixParms = fixParms->Next;

					_endwhile

				_endif
				
				/*
				** Restore currentNS
				*/
				
				currentNS = (yyvsp[(6) - (10)].en.cns);
				_here;
			;}
    break;

  case 700:

/* Line 1464 of yacc.c  */
#line 29356 "hlaparse.bsn"
    {						/* $12 */

				SymNode_t	*ParmList;
				char		*CurrentType;
				int			*dimension;
				SymNode_t	value;

				_here;
				
				CheckLegalOptions
				( 
					(yyvsp[(9) - (11)].options.SpecifiedOptions),
						specified_use
					|	specified_returns
					|	specified_stdcall
					|	specified_pascal
					|	specified_cdecl
				);
				_if
				( 
						(yyvsp[(9) - (11)].options.SpecifiedOptions) 
					&	(
								specified_stdcall
							|	specified_pascal
							|	specified_cdecl
						)
				)
				
					(yyvsp[(8) - (11)].en.s)->u.proc.cs = (yyvsp[(9) - (11)].options.CallingSequence);

				_else

					(yyvsp[(8) - (11)].en.s)->u.proc.cs = (yyvsp[(3) - (11)].s)->u.proc.cs;
					
				_endif
				_if( (yyvsp[(9) - (11)].options.SpecifiedOptions) & specified_use )
				
					(yyvsp[(8) - (11)].en.s)->u.proc.use = (yyvsp[(9) - (11)].options.use);
				
				_else
				
					(yyvsp[(8) - (11)].en.s)->u.proc.use = (yyvsp[(3) - (11)].s)->u.proc.use;
					
				_endif
				_if( (yyvsp[(9) - (11)].options.SpecifiedOptions) & specified_returns )
				
					(yyvsp[(8) - (11)].en.s)->u.proc.returns = (yyvsp[(9) - (11)].options.returns);
				
				_else 
				
					(yyvsp[(8) - (11)].en.s)->u.proc.returns = (yyvsp[(3) - (11)].s)->u.proc.returns;
					
				_endif
				

				/*
				** Copy the parameters from the type ID:
				*/

				copyProcPtrParms( (yyvsp[(3) - (11)].s) );
				(yyvsp[(8) - (11)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(8) - (11)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(8) - (11)].en.s)->u.proc.returns;
				(yyvsp[(8) - (11)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(8) - (11)].en.s)->u.proc.use;


				/*
				** Mark the end of the parameter list, and then
				** insert the _parms_ constant into the symbol table.
				*/

				(yyvsp[(8) - (11)].en.s)->u.proc.parms = SymbolTable;

				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(3) - (11)].s)->u.proc.ParmSize;
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);


				/*
				** This is a forward procedure, so mark it as such
				** in the symbol table.
				*/

				(yyvsp[(8) - (11)].en.s)->u.proc.Forward = SymbolTable;


				

				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table
				** (of course, there are no local symbols for
				** forward declarations, but we still have to
				** point proc.Locals at the parameters, if any).
				*/

				(yyvsp[(8) - (11)].en.s)->u.proc.Locals = SymbolTable;




				CurOffset = (yyvsp[(5) - (11)].v.u.unsval);
				CurOffsetDir = (yyvsp[(6) - (11)].v.u.unsval);
				--CurLexLevel;

				SymbolTable = (yyvsp[(8) - (11)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(8) - (11)].en.s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(7) - (11)].s);

				// If the calling sequence reverses the parameters,
				// go in and swap all the offsets on the parameters:

				_if
				(
						(yyvsp[(8) - (11)].en.s)->u.proc.cs == stdcall_cs
					||	(yyvsp[(8) - (11)].en.s)->u.proc.cs == cdecl_cs
				)

					SymNode_t	*fixParms;
					int			offset;

					fixParms = (yyvsp[(3) - (11)].s)->u.proc.parms;

					offset = 8;
					_while( fixParms != NULL && fixParms != (yyvsp[(8) - (11)].en.s) )

						_if( fixParms->SymClass == cParm )

							fixParms->Offset = offset;
							
							// Round up to the next multiple of four:
							
							offset += ((( fixParms->ObjectSize + 3) >> 2) << 2);

						_endif
						fixParms = fixParms->Next;

					_endwhile

				_endif
				
				/*
				** Restore currentNS
				*/
				
				currentNS = (yyvsp[(8) - (11)].en.cns);
				_here;
			;}
    break;

  case 701:

/* Line 1464 of yacc.c  */
#line 29557 "hlaparse.bsn"
    {					/* $12 */

				SymNode_t	*ParmList;
				char		*CurrentType;
				int			*dimension;
				SymNode_t	value;

				_here;

				CheckLegalOptions
				( 
					(yyvsp[(9) - (11)].options.SpecifiedOptions),
					specified_use
				);
				
				// Iterators always use the pascal calling sequence:
				
				(yyvsp[(6) - (11)].en.s)->u.proc.cs = pascal_cs;
				(yyvsp[(6) - (11)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;


				/*
				** Set up the "returns" field for this procedure.
				*/

				(yyvsp[(6) - (11)].en.s)->u.proc.returns = (yyvsp[(9) - (11)].options.returns);
				(yyvsp[(6) - (11)].en.s)->u.proc.use = (yyvsp[(9) - (11)].options.use);

				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.
				*/


				(yyvsp[(6) - (11)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(6) - (11)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (11)].options.returns);
				(yyvsp[(6) - (11)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (11)].options.use);



				/*
				** Mark the end of the parameter list, and then
				** insert the _parms_ constant into the symbol table.
				*/

				(yyvsp[(6) - (11)].en.s)->u.proc.parms = SymbolTable;


				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(7) - (11)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);


				/*
				** This is a forward procedure, so mark it as such
				** in the symbol table.
				*/

				(yyvsp[(6) - (11)].en.s)->u.proc.Forward = SymbolTable;


				

				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table
				** (of course, there are no local symbols for
				** forward declarations, but we still have to
				** point proc.Locals at the parameters, if any).
				*/

				(yyvsp[(6) - (11)].en.s)->u.proc.Locals = SymbolTable;




				CurOffset = (yyvsp[(3) - (11)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (11)].v.u.unsval);
				--CurLexLevel;

				SymbolTable = (yyvsp[(6) - (11)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(6) - (11)].en.s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (11)].s);

				_here;

				
				/*
				** Restore currentNS:
				*/
				
				currentNS = (yyvsp[(6) - (11)].en.cns);
				_here;
			;}
    break;

  case 702:

/* Line 1464 of yacc.c  */
#line 29704 "hlaparse.bsn"
    {						/* $11 */

				SymNode_t	*ParmList;
				char		*CurrentType;
				int			*dimension;
				SymNode_t	value;

				_here;

				CheckLegalOptions
				( 
					(yyvsp[(8) - (10)].options.SpecifiedOptions),
					specified_use
				);
				
				// Iterators always use the pascal calling sequence:
				
				(yyvsp[(6) - (10)].en.s)->u.proc.cs = pascal_cs;
				(yyvsp[(6) - (10)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;


				/*
				** Set up the "returns" field for this procedure.
				*/

				(yyvsp[(6) - (10)].en.s)->u.proc.returns = (yyvsp[(8) - (10)].options.returns);
				(yyvsp[(6) - (10)].en.s)->u.proc.use = (yyvsp[(8) - (10)].options.use);

				/*
				** Patch the local symbol table entry's proc.parms
				** field first, then store the address of the start
				** of parameters into the main symbol table entry
				** for this procedure.
				*/


				(yyvsp[(6) - (10)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(6) - (10)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(8) - (10)].options.returns);
				(yyvsp[(6) - (10)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(8) - (10)].options.use);



				/*
				** Mark the end of the parameter list, and then
				** insert the _parms_ constant into the symbol table.
				*/

				(yyvsp[(6) - (10)].en.s)->u.proc.parms = SymbolTable;


				/*
				** Create a symbol table entry for the # of bytes
				** of parameters in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = (yyvsp[(7) - (10)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);


				/*
				** This is a forward procedure, so mark it as such
				** in the symbol table.
				*/

				(yyvsp[(6) - (10)].en.s)->u.proc.Forward = SymbolTable;


				

				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table
				** (of course, there are no local symbols for
				** forward declarations, but we still have to
				** point proc.Locals at the parameters, if any).
				*/

				(yyvsp[(6) - (10)].en.s)->u.proc.Locals = SymbolTable;




				CurOffset = (yyvsp[(3) - (10)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (10)].v.u.unsval);
				--CurLexLevel;

				SymbolTable = (yyvsp[(6) - (10)].en.s);

				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(6) - (10)].en.s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(5) - (10)].s);

				_here;

				
				/*
				** Restore currentNS:
				*/
				
				currentNS = (yyvsp[(6) - (10)].en.cns);
				_here;
			;}
    break;

  case 703:

/* Line 1464 of yacc.c  */
#line 29852 "hlaparse.bsn"
    {					/* $11 */
			_here;
			(yyval.idStr) = hlastrdup2( "" );
		;}
    break;

  case 704:

/* Line 1464 of yacc.c  */
#line 29858 "hlaparse.bsn"
    {
			char msg[ 256 ];
			
			_here;
			sprintf
			(
				msg,
				"Procedure <%s> is already defined,\n"
				"external definition is illegal here",
				(yyvsp[(5) - (13)].s)->TrueName
			);
				
			yyerror( msg );

			(void)(yyvsp[(11) - (13)].idStr); // Shut up bison
			exit( 1 );
		;}
    break;

  case 705:

/* Line 1464 of yacc.c  */
#line 29886 "hlaparse.bsn"
    {
				(yyval.idStr) = (yyvsp[(-3) - (2)].idStr);
			;}
    break;

  case 706:

/* Line 1464 of yacc.c  */
#line 29903 "hlaparse.bsn"
    {						/* $10 */
			_here;
			(yyval.idStr) = hlastrdup2( "" );
		;}
    break;

  case 707:

/* Line 1464 of yacc.c  */
#line 29909 "hlaparse.bsn"
    {
			char msg[ 256 ];
			
			sprintf
			(
				msg,
				"Procedure <%s> is already defined,\n"
				"external definition is illegal here",
				(yyvsp[(5) - (12)].s)->TrueName
			);
				
			yyerror( msg );
			free2( vss (yyvsp[(11) - (12)].idStr) );
			(void)(yyvsp[(10) - (12)].idStr); // Shut up bison
			exit( 1 );
		;}
    break;

  case 708:

/* Line 1464 of yacc.c  */
#line 29937 "hlaparse.bsn"
    {

			SymNode_t	*s;
			char 		msg[ 256 ];

			_here;
			++CurLexLevel;

			/*
			** Return the current (nonlocal) symbol in the symbol
			** table as this action's attribute:
			*/


			(yyval.s) = SymbolTable;

			/*
			** If the symbol's .Forward field is non-NULL, then
			** a definition for this procedure already exists.
			** If it's not a tProc, then they are defining a
			** procedure when the forward or external declaration
			** appearing previously was not a procedure.
			*/
			 
			_if( (yyvsp[(-1) - (0)].s)->pType != tProc )

				/*
				** This condition may not be possible
				** RLH 4/20/2000
				*/

				sprintf
				(
					msg,
					"Symbol <<%s>> previously declared, but not as procedure",
					(yyvsp[(-1) - (0)].s)->TrueName
				);
				yyerror( msg );

			_else
			
				_if( (yyvsp[(-1) - (0)].s)->u.proc.Forward == NULL )

					sprintf
					(
						msg,
						"Duplicate procedure symbol <<%s>>",
						(yyvsp[(-1) - (0)].s)->TrueName
					);
					yyerror( msg );

					assert( (yyvsp[(-1) - (0)].s)->u.proc.Locals != NULL );
					SymbolTable = (yyvsp[(-1) - (0)].s)->u.proc.Locals;

				_else


					SymbolTable = (yyvsp[(-1) - (0)].s)->u.proc.Forward;
					(yyvsp[(-1) - (0)].s)->u.proc.Forward = NULL;

				_endif

				/*
				** NULL terminate the local symbols for
				** use by FixSymbols
				*/


				s = SymbolTable;
				_while( s != NULL && s->Next != (yyvsp[(-1) - (0)].s) )

					s = s->Next;

				_endwhile
				_if( s != NULL )

					s->Next = NULL;

				_endif

			_endif
			_here;
		;}
    break;

  case 709:

/* Line 1464 of yacc.c  */
#line 30038 "hlaparse.bsn"
    {					/* $10 */

				int						*dimension;
				SymNode_t				*s;
				struct contextListType	*p;
				char					exitname[ 256 ];
				
				_here;
				CurrentContext = (yyvsp[(5) - (9)].s);
				CheckLegalOptions
				( 
					(yyvsp[(9) - (9)].options.SpecifiedOptions),
						specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_alignment 
					|	specified_noenter 
					|	specified_noleave
				);

				// Note: FixSymbols will patch this procedure's local symbol
				// table chain to point at $<s>$.  So set $<s>$ to point
				// back at the current local symbol table.

				(yyval.s) = (yyvsp[(7) - (9)].s);


				/*
				** If we need a display, allocate storage for it and
				** create a symbol table entry for it.
				*/

				CurOffset = StartLclOffs;
				_if( (yyvsp[(9) - (9)].options.UseDisplay) )

					CurOffset -= 4;
					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);
					CurOffset -= CurLexLevel * 4;

				_endif


				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.
				*/
				
				_if( (yyvsp[(9) - (9)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(5) - (9)].s)->TrueName;

					sprintf( exitname, "x%s" sympost, (yyvsp[(5) - (9)].s)->StaticName ); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(9) - (9)].options.UseDisplay);
					p->SizeParms = (yyvsp[(5) - (9)].s)->u.proc.ParmSize;
					contextList = p;
				
				_endif
				_here;
			;}
    break;

  case 710:

/* Line 1464 of yacc.c  */
#line 30147 "hlaparse.bsn"
    {					/* $17 */


				int			RoundedOffset;
				SymNode_t	value;

				int			HadPassByValRes;
				SymNode_t	*s;
				SymNode_t	*d;

				_here;
				inProcedure = 1;


				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(9) - (16)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(5) - (16)].s)->u.proc.parms;
					_while( s != NULL && s != (yyvsp[(5) - (16)].s) )

						_if
						( 
								s->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)

							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = s->u.proc.Locals;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;


							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );


						_elseif
						( 
								s->pClass == vrp_pc 
							||	s->pClass == result_pc  
						)

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(
								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes | (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif




				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** If we have a display, remove the size of the
				** display from the number of local variables.
				*/

				_if( (yyvsp[(9) - (16)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);




				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				_if( (yyvsp[(5) - (16)].s)->IsExternal )

					EmitPublic( (yyvsp[(5) - (16)].s)->StaticName );

				_endif
				startCseg();
				_if( (yyvsp[(9) - (16)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(9) - (16)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(5) - (16)].s)->StaticName );
				_if( (yyvsp[(9) - (16)].options.UseFrame) && !(yyvsp[(9) - (16)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(9) - (16)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(9) - (16)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(9) - (16)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(9) - (16)].options.NoEnter) 
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(9) - (16)].options.AlignStk) )

						AlignStack();

					_endif

				_endif




				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(9) - (16)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(5) - (16)].s) );

				_endif





				assert( (yyvsp[(15) - (16)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(5) - (16)].s)->TrueName, (yyvsp[(15) - (16)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"procedure name <<%s>>",

						(yyvsp[(15) - (16)].neID.idStr),
						(yyvsp[(5) - (16)].s)->TrueName
					);

					yyerror( msg );

				_endif

				/*
				** Check to ensure that all forward declared procedures
				** have be defined prior to code emission.
				*/

				CheckForwardDecls( (yyvsp[(10) - (16)].s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				/*
				** CurrentContext = $<s>5;
				*/

				free2( vss (yyvsp[(15) - (16)].neID.idStr) );


				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/

				
				(yyval.s) = lookup( "_finalize_", 1 );
				assert( (yyval.s) != NULL );
				_if( (yyvsp[(9) - (16)].options.UseFrame) )
				
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored.",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
				_here;

			;}
    break;

  case 711:

/* Line 1464 of yacc.c  */
#line 30532 "hlaparse.bsn"
    {				/* $22 */

				SymNode_t			*s;
				SymNode_t			*d;


				_here;
				assert( (yyvsp[(20) - (21)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(5) - (21)].s)->TrueName, (yyvsp[(20) - (21)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"procedure name <<%s>>",
						(yyvsp[(20) - (21)].neID.idStr),
						(yyvsp[(5) - (21)].s)->TrueName
					);

					yyerror( msg );

				_endif


				/*
				** Emit the label at the end of the procedure
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(9) - (21)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(5) - (21)].s)->StaticName );
					EmitStmtLbl( lbl );


					/*
					** Deal with the _finalize_ string here.
					*/

					InvisibleCode = NULL;
					_if
					( 
							(yyvsp[(17) - (21)].s)->pType != tString 
						&&	(yyvsp[(17) - (21)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(17) - (21)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(17) - (21)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(17) - (21)].s)->u.strval );

					_endif
					
				_endif

			;}
    break;

  case 712:

/* Line 1464 of yacc.c  */
#line 30602 "hlaparse.bsn"
    {			/* $25 */
		
				struct contextListType	*cNode;
				SymNode_t				*s;
				int						HadPassByValRes;
				SymNode_t				*d;
	
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_here;
				_if( (yyvsp[(9) - (24)].options.UseFrame) )

					StoreValResParms( (yyvsp[(5) - (24)].s) );

				_endif


				
				--CurLexLevel;
				CurOffset = (yyvsp[(2) - (24)].v.u.unsval);
				CurOffsetDir = (yyvsp[(3) - (24)].v.u.unsval);


				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table.
				*/

				(yyvsp[(5) - (24)].s)->u.proc.Locals = SymbolTable;
				(yyvsp[(11) - (24)].s)->Next = NULL;
				SymbolTable = (yyvsp[(7) - (24)].s);

				/*
				** Since this can no longer be an external reference,
				** set the external flag to false.
				*/

				(yyvsp[(5) - (24)].s)->IsExternal = 0;


				/*
				** See if there are any outstanding undefined static
				** objects at this lex level.
				*/

				CurrentContext = (yyvsp[(5) - (24)].s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(4) - (24)].s);

				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();


				/*
				** Output the necessary data to the assembly language
				** file to complete this procedure.
				*/

				_if( (yyvsp[(9) - (24)].options.UseFrame) )

					StdExit
					( 
						(yyvsp[(5) - (24)].s)->u.proc.ParmSize, 
						(yyvsp[(5) - (24)].s)->u.proc.cs == cdecl_cs,
						(yyvsp[(9) - (24)].options.NoLeave)
					);

				_endif
				EndProc( (yyvsp[(5) - (24)].s)->StaticName );
				endCseg();
				free2( vss (yyvsp[(20) - (24)].neID.idStr) );

				inProcedure = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(9) - (24)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( _streq( cNode->label, (yyvsp[(5) - (24)].s)->TrueName) );
					free2( vss cNode->StaticName );

				_endif
				
				
				/*
				** Restore currentNS
				*/
				
				currentNS = (yyvsp[(12) - (24)].ru.saveCurNS);
				_here;
			;}
    break;

  case 713:

/* Line 1464 of yacc.c  */
#line 30722 "hlaparse.bsn"
    {						/* $9 */

				int						*dimension;
				SymNode_t				*s;
				struct contextListType	*p;
				char					exitname[ 256 ];
				
				_here;
				CurrentContext = (yyvsp[(5) - (8)].s);
				CheckLegalOptions
				( 
					(yyvsp[(8) - (8)].options.SpecifiedOptions),
						specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_alignment 
					|	specified_noenter 
					|	specified_noleave
				);

				// Note: FixSymbols will patch this procedure's local symbol
				// table chain to point at $<s>$.  So set $<s>$ to point
				// back at the current local symbol table.

				(yyval.s) = (yyvsp[(7) - (8)].s);


				/*
				** If we need a display, allocate storage for it and
				** create a symbol table entry for it.
				*/

				CurOffset = StartLclOffs;
				_if( (yyvsp[(8) - (8)].options.UseDisplay) )

					CurOffset -= 4;
					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);
					CurOffset -= CurLexLevel * 4;

				_endif


				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.
				*/
				
				_if( (yyvsp[(8) - (8)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(5) - (8)].s)->TrueName;

					sprintf( exitname, "x%s" sympost, (yyvsp[(5) - (8)].s)->StaticName ); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(8) - (8)].options.UseDisplay);
					p->SizeParms = (yyvsp[(5) - (8)].s)->u.proc.ParmSize;
					contextList = p;
				
				_endif
				_here;
			;}
    break;

  case 714:

/* Line 1464 of yacc.c  */
#line 30831 "hlaparse.bsn"
    {					/* $16 */


				int			RoundedOffset;
				SymNode_t	value;

				int			HadPassByValRes;
				SymNode_t	*s;
				SymNode_t	*d;

				_here;
				inProcedure = 1;


				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(9) - (15)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(5) - (15)].s)->u.proc.parms;
					_while( s != NULL && s != (yyvsp[(5) - (15)].s) )

						_if
						( 
								s->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)

							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = s->u.proc.Locals;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;


							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );


						_elseif
						( 
								s->pClass == vrp_pc 
							||	s->pClass == result_pc  
						)

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(
								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes | (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif




				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** If we have a display, remove the size of the
				** display from the number of local variables.
				*/

				_if( (yyvsp[(8) - (15)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);




				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				_if( (yyvsp[(5) - (15)].s)->IsExternal )

					EmitPublic( (yyvsp[(5) - (15)].s)->StaticName );

				_endif
				startCseg();
				_if( (yyvsp[(8) - (15)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(8) - (15)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(5) - (15)].s)->StaticName );
				_if( (yyvsp[(8) - (15)].options.UseFrame) && !(yyvsp[(8) - (15)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(8) - (15)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(8) - (15)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(8) - (15)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(8) - (15)].options.NoEnter) 
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(8) - (15)].options.AlignStk) )

						AlignStack();

					_endif

				_endif




				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(8) - (15)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(5) - (15)].s) );

				_endif





				assert( (yyvsp[(14) - (15)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(5) - (15)].s)->TrueName, (yyvsp[(14) - (15)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"procedure name <<%s>>",

						(yyvsp[(14) - (15)].neID.idStr),
						(yyvsp[(5) - (15)].s)->TrueName
					);

					yyerror( msg );

				_endif

				/*
				** Check to ensure that all forward declared procedures
				** have be defined prior to code emission.
				*/

				CheckForwardDecls( (yyvsp[(9) - (15)].s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				/*
				** CurrentContext = $<s>5;
				*/

				free2( vss (yyvsp[(14) - (15)].neID.idStr) );


				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/

				
				(yyval.s) = lookup( "_finalize_", 1 );
				assert( (yyval.s) != NULL );
				_if( (yyvsp[(8) - (15)].options.UseFrame) )
				
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored.",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
				_here;

			;}
    break;

  case 715:

/* Line 1464 of yacc.c  */
#line 31216 "hlaparse.bsn"
    {				/* $21 */

				SymNode_t		*s;
				SymNode_t		*d;


				_here;
				assert( (yyvsp[(19) - (20)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(5) - (20)].s)->TrueName, (yyvsp[(19) - (20)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"procedure name <<%s>>",
						(yyvsp[(19) - (20)].neID.idStr),
						(yyvsp[(5) - (20)].s)->TrueName
					);

					yyerror( msg );

				_endif


				/*
				** Emit the label at the end of the procedure
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(8) - (20)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(5) - (20)].s)->StaticName );
					EmitStmtLbl( lbl );


					/*
					** Deal with the _finalize_ string here.
					*/

					InvisibleCode = NULL;
					_if
					( 
							(yyvsp[(16) - (20)].s)->pType != tString 
						&&	(yyvsp[(16) - (20)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(16) - (20)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(16) - (20)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(16) - (20)].s)->u.strval );

					_endif
					
				_endif
				_here;
			;}
    break;

  case 716:

/* Line 1464 of yacc.c  */
#line 31286 "hlaparse.bsn"
    {			/* $24 */
		
				struct contextListType	*cNode;
				SymNode_t				*s;
				int						HadPassByValRes;
				SymNode_t				*d;
	
				_here;
				
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_if( (yyvsp[(8) - (23)].options.UseFrame) )

					StoreValResParms( (yyvsp[(5) - (23)].s) );

				_endif


				
				--CurLexLevel;
				CurOffset = (yyvsp[(2) - (23)].v.u.unsval);
				CurOffsetDir = (yyvsp[(3) - (23)].v.u.unsval);


				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table.
				*/

				(yyvsp[(5) - (23)].s)->u.proc.Locals = SymbolTable;
				(yyvsp[(10) - (23)].s)->Next = NULL;
				SymbolTable = (yyvsp[(7) - (23)].s);

				/*
				** Since this can no longer be an external reference,
				** set the external flag to false.
				*/

				(yyvsp[(5) - (23)].s)->IsExternal = 0;


				/*
				** See if there are any outstanding undefined static
				** objects at this lex level.
				*/

				CurrentContext = (yyvsp[(5) - (23)].s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(4) - (23)].s);

				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();


				/*
				** Output the necessary data to the assembly language
				** file to complete this procedure.
				*/

				_if( (yyvsp[(8) - (23)].options.UseFrame) )

					StdExit
					( 
						(yyvsp[(5) - (23)].s)->u.proc.ParmSize, 
						(yyvsp[(5) - (23)].s)->u.proc.cs == cdecl_cs,
						(yyvsp[(8) - (23)].options.NoLeave)
					);

				_endif
				EndProc( (yyvsp[(5) - (23)].s)->StaticName );
				endCseg();
				free2( vss (yyvsp[(19) - (23)].neID.idStr) );

				inProcedure = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(8) - (23)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( _streq( cNode->label, (yyvsp[(5) - (23)].s)->TrueName) );
					free2( vss cNode->StaticName );

				_endif
				
				
				/*
				** Restore currentNS
				*/
				
				currentNS = (yyvsp[(11) - (23)].ru.saveCurNS);
				_here;
			;}
    break;

  case 717:

/* Line 1464 of yacc.c  */
#line 31406 "hlaparse.bsn"
    {
				SymNode_t *p;
				SymNode_t *t;
				char	msg[256];
				
				_here;
				_if( (yyvsp[(1) - (1)].s)->pType != tProcptr )
				
					sprintf
					(
						msg, 
						"Expected a procedure type ID after ':', found '%s'",
						(yyvsp[(1) - (1)].s)->TrueName
					);
					yyerror( msg );
					
				_else
					
					t = (yyvsp[(1) - (1)].s)->u.proc.parms;
					p = (yyvsp[(0) - (1)].s)->u.proc.parms;
					_while( t->Next != (yyvsp[(1) - (1)].s) && p->Next != (yyvsp[(0) - (1)].s) )
					
						/*
						** Be sure the forward definition wasn't a procedural
						** parameter.
						*/

						_if(  p->Type == NULL )

							/*
							** This occurs if the declared parameter is
							** a procedure parameter but the forward parameter was not.
							*/
							
							sprintf
							(
								msg,
								"Parameter \"%s\" was not a procedure parameter in "
								"the original\n"
								"definition (may have been a type symbol"
								"that is indirectly a\n"
								"procedure type, though)",
								t->TrueName
							);
							yyerror( msg );

						
						
							/*
							** Next, make sure the object is an actual parameter
							** in the original declaration.
							*/

						_elseif( p->SymClass != cParm )

							sprintf
							(
								msg,
								"Parameter \"%s\" is not present in original definition",
								t->TrueName
							);
							yyerror
							(
								msg
							);

						_else /* This is a parameter */
						

							/*
							** Make sure the two parameters were passed the same
							** way (e.g., pass by reference).
							*/

							_if( t->pClass != p->pClass )

								yyerror
								(
									"Parameter classes must agree "
									"(e.g., pass by value,\n"
									"pass by reference, etc.) with "
									"original declaration"
								);


							/*
							** Be sure the names are identical.
							*/

							_elseif( _strne( p->TrueName, t->TrueName ))

							 	sprintf
								(
									msg,
									"Identifier \"%s\" must be identical to "
									" declaration \"%s\"",
									t->TrueName,
									p->TrueName
								);
								yyerror( msg );

							/*
							** Be sure their types are identical
							*/

							_elseif( p->Type != t->Type )

								sprintf
								(
									msg,
									"Type (%s:%s) must match original "
									"declaration (%s:%s)",
									p->TrueName,
									p->Type->TrueName,
									t->TrueName,
									t->Type->TrueName
								);
								yyerror( msg );



							/*
							** If the StaticName field is non-NULL, then we
							** have a register parameter (e.g., "in <reg>" was
							** used).
							*/

							_elseif( p->StaticName != NULL )

								/*
								** Make sure the current declaration also
								** specifies a register parameter.
								*/

								_if( t->StaticName == NULL )

									sprintf
									(
										msg,
										"Original parameter declaration was in register %s",
										p->StaticName
									);
									yyerror( msg );


								/*
								** Make sure the current declaration specifies
								** the same register.
								*/

								_elseif( _strne( t->StaticName, p->StaticName ))

									sprintf
									(
										msg,
										"IN <reg> declarations must be the same "
										"(%s vs. %s [fwd])",
										t->StaticName,
										p->StaticName
									);
									yyerror( msg );

								_endif


							/*
							** If the current declaration is a register parameter
							** but the original (forward) definition wasn't, print
							** the appropriate message.
							*/

							_elseif( p->StaticName != NULL )

								sprintf
								(
									msg,
									"Original parameter declaration wasn't specified "
									"in a register (%s)",
									p->TrueName
								);
								yyerror( msg );

							_endif

						_endif

						t = t->Next;
						p = p->Next;
					
					_endwhile
					
					_if( t->Next != (yyvsp[(1) - (1)].s) || _strne( p->TrueName, "_finalize_") )
					
						yyerror
						( 
							"Number of declared parameters does not match "
							"original declaration"
						);
						
					_endif
					
				_endif
				_here;  
			;}
    break;

  case 718:

/* Line 1464 of yacc.c  */
#line 31622 "hlaparse.bsn"
    { (yyval.s) = (yyvsp[(1) - (5)].s); ;}
    break;

  case 719:

/* Line 1464 of yacc.c  */
#line 31626 "hlaparse.bsn"
    {						/* $10 */

				int						*dimension;
				SymNode_t				*s;
				struct contextListType	*p;
				char					exitname[ 256 ];
				
				_here;
				CurrentContext = (yyvsp[(4) - (9)].s);
				CheckLegalOptions
				( 
					(yyvsp[(9) - (9)].options.SpecifiedOptions),
						specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_alignment 
					|	specified_noenter 
					|	specified_noleave
				);

				// Note: FixSymbols will patch this procedure's local symbol
				// table chain to point at $<s>$.  So set $<s>$ to point
				// back at the current local symbol table.

				(yyval.s) = (yyvsp[(8) - (9)].s);


				/*
				** If we need a display, allocate storage for it and
				** create a symbol table entry for it.
				*/

				CurOffsetDir = -1;
				CurOffset = StartLclOffs;
				_if( (yyvsp[(9) - (9)].options.UseDisplay) )

					CurOffset -= 4;
					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);
					CurOffset -= CurLexLevel * 4;

				_endif


				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.
				*/
				
				_if( (yyvsp[(9) - (9)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(5) - (9)].s)->TrueName;

					sprintf( exitname, "x%s" sympost, (yyvsp[(5) - (9)].s)->StaticName ); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(9) - (9)].options.UseDisplay);
					p->SizeParms = (yyvsp[(5) - (9)].s)->u.proc.ParmSize;
					contextList = p;
				
				_endif
				_here;
			;}
    break;

  case 720:

/* Line 1464 of yacc.c  */
#line 31736 "hlaparse.bsn"
    {					/* $17 */


				int				RoundedOffset;
				SymNode_t		value;

				int				HadPassByValRes;
				SymNode_t		*s;
				SymNode_t		*d;

				_here;
				inProcedure = 1;


				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(9) - (16)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(6) - (16)].s)->u.proc.parms;
					_while( s != NULL && s != (yyvsp[(6) - (16)].s) )

						_if
						( 
								s->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)

							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = s->u.proc.Locals;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;


							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );


						_elseif
						( 
								s->pClass == vrp_pc 
							||	s->pClass == result_pc  
						)

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(
								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes | (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif




				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** If we have a display, remove the size of the
				** display from the number of local variables.
				*/

				_if( (yyvsp[(9) - (16)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);




				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				_if( (yyvsp[(6) - (16)].s)->IsExternal )

					EmitPublic( (yyvsp[(6) - (16)].s)->StaticName );

				_endif
				startCseg();
				_if( (yyvsp[(9) - (16)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(9) - (16)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(5) - (16)].s)->StaticName );
				_if( (yyvsp[(9) - (16)].options.UseFrame) && !(yyvsp[(9) - (16)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(9) - (16)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(9) - (16)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(9) - (16)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(9) - (16)].options.NoEnter) 
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(9) - (16)].options.AlignStk) )

						AlignStack();

					_endif

				_endif




				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(9) - (16)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(6) - (16)].s) );

				_endif





				assert( (yyvsp[(15) - (16)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(5) - (16)].s)->TrueName, (yyvsp[(15) - (16)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"procedure name <<%s>>",

						(yyvsp[(15) - (16)].neID.idStr),
						(yyvsp[(5) - (16)].s)->TrueName
					);

					yyerror( msg );

				_endif

				/*
				** Check to ensure that all forward declared procedures
				** have be defined prior to code emission.
				*/

				CheckForwardDecls( (yyvsp[(10) - (16)].s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				/*
				** CurrentContext = $<s>5;
				*/

				free2( vss (yyvsp[(15) - (16)].neID.idStr) );


				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/

				
				(yyval.s) = lookup( "_finalize_", 1 );
				assert( (yyval.s) != NULL );
				_if( (yyvsp[(9) - (16)].options.UseFrame) )
				
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored.",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
				_here;

			;}
    break;

  case 721:

/* Line 1464 of yacc.c  */
#line 32121 "hlaparse.bsn"
    {				/* $22 */

				SymNode_t			*s;
				SymNode_t			*d;


				_here;
				assert( (yyvsp[(20) - (21)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(6) - (21)].s)->TrueName, (yyvsp[(20) - (21)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"procedure name <<%s>>",
						(yyvsp[(20) - (21)].neID.idStr),
						(yyvsp[(6) - (21)].s)->TrueName
					);

					yyerror( msg );

				_endif


				/*
				** Emit the label at the end of the procedure
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(9) - (21)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(6) - (21)].s)->StaticName );
					EmitStmtLbl( lbl );


					/*
					** Deal with the _finalize_ string here.
					*/

					InvisibleCode = NULL;
					_if
					( 
							(yyvsp[(17) - (21)].s)->pType != tString 
						&&	(yyvsp[(17) - (21)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(17) - (21)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(17) - (21)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(17) - (21)].s)->u.strval );

					_endif
					
				_endif

			;}
    break;

  case 722:

/* Line 1464 of yacc.c  */
#line 32191 "hlaparse.bsn"
    {			/* $25 */
		
				struct contextListType	*cNode;
				SymNode_t				*s;
				int						HadPassByValRes;
				SymNode_t				*d;
	
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_here;
				_if( (yyvsp[(9) - (24)].options.UseFrame) )

					StoreValResParms( (yyvsp[(6) - (24)].s) );

				_endif


				
				--CurLexLevel;
				CurOffset = (yyvsp[(2) - (24)].v.u.unsval);
				CurOffsetDir = (yyvsp[(3) - (24)].v.u.unsval);


				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table.
				*/

				(yyvsp[(6) - (24)].s)->u.proc.Locals = SymbolTable;
				(yyvsp[(11) - (24)].s)->Next = NULL;
				SymbolTable = (yyvsp[(8) - (24)].s);

				/*
				** Since this can no longer be an external reference,
				** set the external flag to false.
				*/

				(yyvsp[(6) - (24)].s)->IsExternal = 0;


				/*
				** See if there are any outstanding undefined static
				** objects at this lex level.
				*/

				CurrentContext = (yyvsp[(6) - (24)].s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(4) - (24)].s);

				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();


				/*
				** Output the necessary data to the assembly language
				** file to complete this procedure.
				*/

				_if( (yyvsp[(9) - (24)].options.UseFrame) )

					StdExit
					( 
						(yyvsp[(6) - (24)].s)->u.proc.ParmSize, 
						(yyvsp[(6) - (24)].s)->u.proc.cs == cdecl_cs,
						(yyvsp[(9) - (24)].options.NoLeave)
					);

				_endif
				EndProc( (yyvsp[(6) - (24)].s)->StaticName );
				endCseg();
				free2( vss (yyvsp[(20) - (24)].neID.idStr) );

				inProcedure = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(9) - (24)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( _streq( cNode->label, (yyvsp[(6) - (24)].s)->TrueName) );
					free2( vss cNode->StaticName );

				_endif
				
				
				/*
				** Restore currentNS
				*/
				
				currentNS = (yyvsp[(12) - (24)].ru.saveCurNS);
				_here;
			;}
    break;

  case 723:

/* Line 1464 of yacc.c  */
#line 32322 "hlaparse.bsn"
    {					/* $11 */
			_here;
			(yyval.idStr) = hlastrdup2( "" );
		;}
    break;

  case 724:

/* Line 1464 of yacc.c  */
#line 32328 "hlaparse.bsn"
    {
			char msg[ 256 ];
			
			sprintf
			(
				msg,
				"Iterator <%s> is already defined,\n"
				"external definition is illegal here",
				(yyvsp[(5) - (13)].s)->TrueName
			);
				
			yyerror( msg );
			free2( vss (yyvsp[(12) - (13)].idStr) );

			/*
			** Undo the stuff done by PatchLclIter.
			** (PatchLocals isn't really used by this
			** production, it appears simply to eliminate
			** shift/reduce conflicts).
			*/

			SymbolTable = (yyvsp[(7) - (13)].s);
			--CurLexLevel;
			(void) (yyvsp[(11) - (13)].idStr);	// shut up bison
			_here;
		;}
    break;

  case 725:

/* Line 1464 of yacc.c  */
#line 32366 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(-3) - (2)].idStr);
		;}
    break;

  case 726:

/* Line 1464 of yacc.c  */
#line 32382 "hlaparse.bsn"
    {						/* $10 */
			_here;
			(yyval.idStr) = hlastrdup2( "" );
		;}
    break;

  case 727:

/* Line 1464 of yacc.c  */
#line 32388 "hlaparse.bsn"
    {
			char msg[ 256 ];
			
			sprintf
			(
				msg,
				"Iterator <%s> is already defined,\n"
				"external definition is illegal here",
				(yyvsp[(5) - (12)].s)->TrueName
			);
				
			yyerror( msg );
			free2( vss (yyvsp[(11) - (12)].idStr) );

			/*
			** Undo the stuff done by PatchLclIter.
			** (PatchLocals isn't really used by this
			** production, it appears simply to eliminate
			** shift/reduce conflicts).
			*/

			SymbolTable = (yyvsp[(7) - (12)].s);
			--CurLexLevel;
			(void) (yyvsp[(10) - (12)].idStr);	// shut up bison
			_here;
		;}
    break;

  case 728:

/* Line 1464 of yacc.c  */
#line 32419 "hlaparse.bsn"
    {

			SymNode_t	*s;
			char 		msg[ 256 ];

			_here;
			++CurLexLevel;

			/*
			** Return the current (nonlocal) symbol in the symbol
			** table as this action's attribute:
			*/


			(yyval.s) = SymbolTable;

			/*
			** If the symbol's .Forward field is non-NULL, then
			** a definition for this procedure already exists.
			** If it's not a tProc, then they are defining a
			** procedure when the forward or external declaration
			** appearing previously was not a procedure.
			*/
			 
			_if( (yyvsp[(-1) - (0)].s)->pType != tIterator )

				sprintf
				(
					msg,
					"Symbol <<%s>> previously declared, but not as iterator",
					(yyvsp[(-1) - (0)].s)->TrueName
				);
				yyerror( msg );

			_else
			
				_if( (yyvsp[(-1) - (0)].s)->u.proc.Forward == NULL )

					sprintf
					(
						msg,
						"Duplicate iterator symbol <<%s>>",
						(yyvsp[(-1) - (0)].s)->TrueName
					);
					yyerror( msg );

					assert( (yyvsp[(-1) - (0)].s)->u.proc.Locals != NULL );
					SymbolTable = (yyvsp[(-1) - (0)].s)->u.proc.Locals;

				_else


					SymbolTable = (yyvsp[(-1) - (0)].s)->u.proc.Forward;
					(yyvsp[(-1) - (0)].s)->u.proc.Forward = NULL;

				_endif

				/*
				** NULL terminate the local symbols for
				** use by FixSymbols
				*/


				s = SymbolTable;
				_while( s != NULL && s->Next != (yyvsp[(-1) - (0)].s) )

					s = s->Next;

				_endwhile
				_if( s != NULL )

					s->Next = NULL;

				_endif

			_endif
			_here;
		;}
    break;

  case 729:

/* Line 1464 of yacc.c  */
#line 32517 "hlaparse.bsn"
    {					/* $10 */

				char 					msg[ 256 ];
				int						*dimension;
				SymNode_t				*s;
				struct contextListType	*p;
				char					exitname[ 256 ];

				_here;
				CurrentContext = (yyvsp[(5) - (9)].s);
				CheckLegalOptions
				( 
					(yyvsp[(9) - (9)].options.SpecifiedOptions),
						specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_alignment 
					|	specified_noenter 
					|	specified_noleave
				);


				/*
				** Required by FixSymbols.
				*/

				(yyval.s) = (yyvsp[(7) - (9)].s);


				/*
				** Create a symbol table entry for the "yield" thunk.
				*/

				InsertSym
				( 
					"yield", 
					&thunk_ste,	/* Type			*/
					tThunk, 	/* pType		*/
					cVar,		/* SymClass		*/ 
					0,			/* Arity		*/
					NULL,		/* dimensions	*/
					0, 			/* # elements	*/
					NULL,		/* Value		*/
					8,			/* ObjectSize	*/
					0,			/* Offset 		*/
					NULL,		/* StaticName	*/
					NULL,		/* Base			*/
					NULL,		/* Fields		*/
					0			/* FieldCnt		*/
				);

				/*
				** Thunks (yield) don't have any parameters,
				** but we can't leave proc.parms NULL (since other
				** code treats this as an error).  Just give each
				** Yield thunk a set of local constants which are
				** the lex level zero constants.
				*/
				
				SymbolTable->u.proc.parms = &true_ste;



				/*
				** If we need a display, allocate storage for it and
				** create a symbol table entry for it.
				*/

				CurOffset = StartLclOffs;
				_if( (yyvsp[(9) - (9)].options.UseDisplay) )

					CurOffset -= 4;
					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);
					CurOffset -= CurLexLevel * 4;

				_endif



				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.
				*/
				
				_if( (yyvsp[(9) - (9)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(5) - (9)].s)->TrueName;

					sprintf( exitname, "x%s" sympost, (yyvsp[(5) - (9)].s)->StaticName ); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(9) - (9)].options.UseDisplay);
					p->SizeParms = (yyvsp[(5) - (9)].s)->u.proc.ParmSize;
					contextList = p;

				_endif


				_here;
			;}
    break;

  case 730:

/* Line 1464 of yacc.c  */
#line 32665 "hlaparse.bsn"
    {					/* $17 */


				int				RoundedOffset;
				SymNode_t		value;

				int				HadPassByValRes;
				SymNode_t		*s;
				SymNode_t		*d;

				_here;
				inIterator = 1;


				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(9) - (16)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(5) - (16)].s)->u.proc.parms;
					_while( s != NULL && s != (yyvsp[(5) - (16)].s) )

						_if
						( 
								s->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)

							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = s->u.proc.Locals;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;


							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );


						_elseif
						( 
								s->pClass == vrp_pc 
							||	s->pClass == result_pc  
						)

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(
								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes | (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif


				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** If we have a display, remove the size of the
				** display from the number of local variables.
				*/

				_if( (yyvsp[(9) - (16)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);




				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				_if( (yyvsp[(5) - (16)].s)->IsExternal )

					EmitPublic( (yyvsp[(5) - (16)].s)->StaticName );

				_endif
				startCseg();
				_if( (yyvsp[(9) - (16)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(9) - (16)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(5) - (16)].s)->StaticName );
				_if( (yyvsp[(9) - (16)].options.UseFrame) && !(yyvsp[(9) - (16)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(9) - (16)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(9) - (16)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(9) - (16)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(9) - (16)].options.NoEnter) 
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(9) - (16)].options.AlignStk) )

						AlignStack();

					_endif

				_endif


				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(9) - (16)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(5) - (16)].s) );

				_endif



				assert( (yyvsp[(15) - (16)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(5) - (16)].s)->TrueName, (yyvsp[(15) - (16)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"iterator name <<%s>>",
						(yyvsp[(15) - (16)].neID.idStr),
						(yyvsp[(5) - (16)].s)->TrueName
					);

					yyerror( msg );

				_endif

				/*
				** Check to ensure that all forward declared procedures
				** have be defined prior to code emission.
				*/

				CheckForwardDecls( (yyvsp[(10) - (16)].s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				free2( vss (yyvsp[(15) - (16)].neID.idStr) );




				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/

				
				(yyval.s) = lookup( "_finalize_", 1 );
				assert( (yyval.s) != NULL );
				_if( (yyvsp[(9) - (16)].options.UseFrame) )
				
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored.",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
				_here;

			;}
    break;

  case 731:

/* Line 1464 of yacc.c  */
#line 33041 "hlaparse.bsn"
    {				/* $22 */


				_here;
				assert( (yyvsp[(20) - (21)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(5) - (21)].s)->TrueName, (yyvsp[(20) - (21)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"iteator name <<%s>>",
						(yyvsp[(20) - (21)].neID.idStr),
						(yyvsp[(5) - (21)].s)->TrueName
					);

					yyerror( msg );

				_endif



				/*
				** Emit the label at the end of the procedure
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(9) - (21)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(5) - (21)].s)->StaticName );
					EmitStmtLbl( lbl );


					/*
					** Deal with the _finalize_ string here.
					*/

					InvisibleCode = NULL;
					_if
					(
							(yyvsp[(17) - (21)].s)->pType != tString 
						&&	(yyvsp[(17) - (21)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(17) - (21)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(17) - (21)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(17) - (21)].s)->u.strval );

					_endif
					
				_endif
				_here;
			;}
    break;

  case 732:

/* Line 1464 of yacc.c  */
#line 33109 "hlaparse.bsn"
    {			/* $25 */
							 
				struct contextListType	*cNode;
				SymNode_t				*s;
				SymNode_t				*d;

				_here;
	
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_if( (yyvsp[(9) - (24)].options.UseFrame) )

					StoreValResParms( (yyvsp[(5) - (24)].s) );

				_endif



				
				--CurLexLevel;
				CurOffset = (yyvsp[(2) - (24)].v.u.unsval);
				CurOffsetDir = (yyvsp[(3) - (24)].v.u.unsval);


				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table.
				*/

				(yyvsp[(5) - (24)].s)->u.proc.Locals = SymbolTable;
				(yyvsp[(11) - (24)].s)->Next = NULL;
				SymbolTable = (yyvsp[(7) - (24)].s);

				/*
				** Since this can no longer be an external reference,
				** set the external flag to false.
				*/

				(yyvsp[(5) - (24)].s)->IsExternal = 0;


				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(5) - (24)].s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(4) - (24)].s);

				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();


				/*
				** Output the necessary data to the assembly language
				** file to complete this procedure.
				*/

				_if( (yyvsp[(9) - (24)].options.UseFrame) )

					IteratorExit( (yyvsp[(5) - (24)].s)->u.proc.ParmSize ); 

				_endif
				EndProc( (yyvsp[(5) - (24)].s)->StaticName );
				endCseg();
				free2( vss (yyvsp[(20) - (24)].neID.idStr) );

				inIterator = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(9) - (24)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( _streq( cNode->label, (yyvsp[(5) - (24)].s)->TrueName) );
					free2( vss cNode->StaticName );

				_endif
				
				/*
				** Restore currentNS
				*/
				
				currentNS = (yyvsp[(12) - (24)].ru.saveCurNS);
				
				_here;
			;}
    break;

  case 733:

/* Line 1464 of yacc.c  */
#line 33231 "hlaparse.bsn"
    {						/* $9  */

				char 					msg[ 256 ];
				int						*dimension;
				SymNode_t				*s;
				struct contextListType	*p;
				char					exitname[ 256 ];

				_here;
				CurrentContext = (yyvsp[(5) - (8)].s);
				CheckLegalOptions
				( 
					(yyvsp[(8) - (8)].options.SpecifiedOptions),
						specified_noframe 
					|	specified_nodisplay 
					|	specified_noalignstk 
					|	specified_alignment 
					|	specified_noenter 
					|	specified_noleave
				);


				/*
				** Required by FixSymbols.
				*/

				(yyval.s) = (yyvsp[(7) - (8)].s);


				/*
				** Create a symbol table entry for the "yield" thunk.
				*/

				InsertSym
				( 
					"yield", 
					&thunk_ste,	/* Type			*/
					tThunk, 	/* pType		*/
					cVar,		/* SymClass		*/ 
					0,			/* Arity		*/
					NULL,		/* dimensions	*/
					0, 			/* # elements	*/
					NULL,		/* Value		*/
					8,			/* ObjectSize	*/
					0,			/* Offset 		*/
					NULL,		/* StaticName	*/
					NULL,		/* Base			*/
					NULL,		/* Fields		*/
					0			/* FieldCnt		*/
				);

				/*
				** Thunks (yield) don't have any parameters,
				** but we can't leave proc.parms NULL (since other
				** code treats this as an error).  Just give each
				** Yield thunk a set of local constants which are
				** the lex level zero constants.
				*/
				
				SymbolTable->u.proc.parms = &true_ste;



				/*
				** If we need a display, allocate storage for it and
				** create a symbol table entry for it.
				*/

				CurOffset = StartLclOffs;
				_if( (yyvsp[(8) - (8)].options.UseDisplay) )

					CurOffset -= 4;
					dimension = malloc2( sizeofInt );
					*dimension = CurLexLevel + 1;
					InsertSym
					( 
						"_display_", 
						&dword_ste,
						tDWord, 
						cVar, 
						1,
						dimension,
						*dimension, 
						NULL,
						*dimension*4,
						CurOffset,
						NULL,
						NULL,
						NULL,
						0
					);
					CurOffset -= CurLexLevel * 4;

				_endif



				/*
				** Add this procedure to the context list so we
				** can bail on this procedure via the EXIT and EXITIF
				** statements.
				*/
				
				_if( (yyvsp[(8) - (8)].options.UseFrame) )

					p = malloc2( sizeofContextListType );
					p->Next = contextList;
					p->label = (yyvsp[(5) - (8)].s)->TrueName;

					sprintf( exitname, "x%s" sympost, (yyvsp[(5) - (8)].s)->StaticName ); 
					p->StaticName = hlastrdup2( exitname );
					p->LexLevel = CurLexLevel;
					p->IsProc = 1;
					p->HasDisplay = (yyvsp[(8) - (8)].options.UseDisplay);
					p->SizeParms = (yyvsp[(5) - (8)].s)->u.proc.ParmSize;
					contextList = p;

				_endif


				_here;
			;}
    break;

  case 734:

/* Line 1464 of yacc.c  */
#line 33379 "hlaparse.bsn"
    {					/* $16 */


				int				RoundedOffset;
				SymNode_t		value;

				int				HadPassByValRes;
				SymNode_t		*s;
				SymNode_t		*d;

				_here;
				inIterator = 1;


				/*
				** Check for pass by value/result or pass by result
				** parameters because we need to allocate local
				** storage for these.
				*/

				_if( (yyvsp[(8) - (15)].options.UseFrame) )

					HadPassByValRes = 0;
					s = (yyvsp[(5) - (15)].s)->u.proc.parms;
					_while( s != NULL && s != (yyvsp[(5) - (15)].s) )

						_if
						( 
								s->pType == tProcptr 
							&&	(
										s->pClass == vrp_pc 
									||	s->pClass == result_pc
								)
						)

							CurOffset = CurOffset - 4;
							InsertSym
							(
								s->TrueName, 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);
							d = SymbolTable;
							d->u.proc.returns = hlastrdup2( "" );
							d->u.proc.use = s->u.proc.use;
							d->u.proc.parms = s->u.proc.parms;
							d->u.proc.Locals = s->u.proc.Locals;
							d->u.proc.Forward = s->u.proc.Forward;
							d->u.proc.BaseClass = s->u.proc.BaseClass;
							d->u.proc.ParmSize = s->u.proc.ParmSize;
							d->u.proc.cs = s->u.proc.cs;


							InsertSym
							(
								" (procptr type) ", 
								NULL,				/* Type			*/
								tProcptr,		 	/* pType		*/
								cType,				/* SymClass		*/ 
								0,					/* Arity		*/
								NULL,				/* dimensions	*/
								0,					/* # elements	*/
								NULL,				/* Value		*/
								4,					/* ObjectSize	*/
								0,					/* Offset 		*/
								NULL,				/* StaticName	*/
								NULL,				/* Base			*/
								NULL,				/* Fields		*/
								0					/* FieldCnt		*/
							);
							SymbolTable->u.proc.parms = s->u.proc.parms;
							SymbolTable->u.proc.returns = d->u.proc.returns;
							SymbolTable->u.proc.use = s->u.proc.use;
							SymbolTable->u.proc.Locals = s->u.proc.Locals;
							SymbolTable->u.proc.Forward = s->u.proc.Forward;
							SymbolTable->u.proc.BaseClass = s->u.proc.BaseClass;
							SymbolTable->u.proc.ParmSize = s->u.proc.ParmSize;
							SymbolTable->u.proc.cs = s->u.proc.cs;
							d->Type = SymbolTable;
							SymbolTable = d;

							HadPassByValRes = 
								HadPassByValRes || (s->pClass == vrp_pc );


						_elseif
						( 
								s->pClass == vrp_pc 
							||	s->pClass == result_pc  
						)

							assert( s->Type != NULL );
							CurOffset = CurOffset - s->Type->ObjectSize;
							InsertSym
							(
								s->TrueName, 
								s->Type,			/* Type			*/
								s->Type->pType, 	/* pType		*/
								cVar,				/* SymClass		*/ 
								s->Arity,			/* Arity		*/
								s->Dimensions,		/* dimensions	*/
								s->NumElements,		/* # elements	*/
								NULL,				/* Value		*/
								s->Type->ObjectSize,/* ObjectSize	*/
								CurOffset,			/* Offset 		*/
								s->StaticName,		/* StaticName	*/
								s->Base,			/* Base			*/
								s->Fields,			/* Fields		*/
								s->FieldCnt			/* FieldCnt		*/
							);

							HadPassByValRes = 
								HadPassByValRes | (s->pClass == vrp_pc );

						_endif
						s = s->Next;

					_endwhile

				_endif


				/*
				** Compute the number of bytes of local variables
				** and round this number to the larger multiple of
				** four bytes.
				*/

				RoundedOffset = -CurOffset;
				_if( RoundedOffset != ( RoundedOffset & ~3 ))

					RoundedOffset = ( RoundedOffset + 4 ) & ~3;

				_endif

				/*
				** If we have a display, remove the size of the
				** display from the number of local variables.
				*/

				_if( (yyvsp[(8) - (15)].options.UseDisplay) )

					RoundedOffset = RoundedOffset - ( CurLexLevel + 1 )*4;

				_endif

				/*
				** Create a symbol table entry for the # of bytes
				** of local variables in this procedure.
				*/

				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.u.unsval = RoundedOffset;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);




				/*
				** Output the assembly code for this procedure.
				**
				** For nested procedures (lex level 2 and above)
				** we need to emit the display
				*/

				_if( (yyvsp[(5) - (15)].s)->IsExternal )

					EmitPublic( (yyvsp[(5) - (15)].s)->StaticName );

				_endif
				startCseg();
				_if( (yyvsp[(8) - (15)].options.Alignment) != 1 )

					EmitAlign( (yyvsp[(8) - (15)].options.Alignment) );

				_endif
				StartProc( (yyvsp[(5) - (15)].s)->StaticName );
				_if( (yyvsp[(8) - (15)].options.UseFrame) && !(yyvsp[(8) - (15)].options.UseDisplay) )


					/*
					** If we're not building a display, just use the
					** standard entry sequence.
					*/

					StdEntry( RoundedOffset, (yyvsp[(8) - (15)].options.NoEnter) );

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(8) - (15)].options.AlignStk) )

						AlignStack();

					_endif

				_elseif( (yyvsp[(8) - (15)].options.UseFrame) )

					/*
					** We've got to construct the display.
					*/

					ConstructDisplay
					( 
						CurLexLevel, 
						RoundedOffset,
						(yyvsp[(8) - (15)].options.NoEnter) 
					);

					/*
					** Align the stack on a dword boundary.
					*/

					_if( AlwaysAlignStk && (yyvsp[(8) - (15)].options.AlignStk) )

						AlignStack();

					_endif

				_endif


				/*
				** If we have any pass by value/result parameters, emit
				** code to copy the data into the local storage allocated
				** to hold the parameter.  Note that we do not copy pass
				** by result parameters here because they are "out only"
				** variables.
				*/

				_if( (yyvsp[(8) - (15)].options.UseFrame) && HadPassByValRes )

					CopyValResParms( (yyvsp[(5) - (15)].s) );

				_endif



				assert( (yyvsp[(14) - (15)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(5) - (15)].s)->TrueName, (yyvsp[(14) - (15)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'begin' must match "
						"iterator name <<%s>>",
						(yyvsp[(14) - (15)].neID.idStr),
						(yyvsp[(5) - (15)].s)->TrueName
					);

					yyerror( msg );

				_endif

				/*
				** Check to ensure that all forward declared procedures
				** have be defined prior to code emission.
				*/

				CheckForwardDecls( (yyvsp[(9) - (15)].s) );

				/*
				** Check to make sure all pointer forward references have
				** been resolved.
				*/

				CheckPtrs();

				free2( vss (yyvsp[(14) - (15)].neID.idStr) );




				/*
				** Emit the text associated with the _initialize_ string
				** at this point.
				**
				**	Note: the "InvisibleCode" variable is used by
				**	yyerror to determine if it should print the
				**	_initialize_ string as part of the error message.
				*/

				
				(yyval.s) = lookup( "_finalize_", 1 );
				assert( (yyval.s) != NULL );
				_if( (yyvsp[(8) - (15)].options.UseFrame) )
				
					s=(yyval.s)->Next;
					InvisibleCode = NULL;
					_if
					( 
							s->pType != tString 
						&&	s->pType != tZString 
					)

						WarnNear
						( 
							"_initialize_'s type is not string.  "
							"Initialization ignored.",
							"_initialize_" 
						);

					_elseif( strlen( s->u.strval ) != 0 )

						InvisibleCode = s->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( s->u.strval );

					_endif
					
				_endif
				_here;

			;}
    break;

  case 735:

/* Line 1464 of yacc.c  */
#line 33755 "hlaparse.bsn"
    {				/* $21 */


				_here;
				assert( (yyvsp[(19) - (20)].neID.idStr) != NULL );

				_if( _strne( (yyvsp[(5) - (20)].s)->TrueName, (yyvsp[(19) - (20)].neID.idStr) ))

					char msg[ 256 ];

					sprintf
					( 
						msg,
						"Identifier <<%s>> after 'end' must match "
						"iteator name <<%s>>",
						(yyvsp[(19) - (20)].neID.idStr),
						(yyvsp[(5) - (20)].s)->TrueName
					);

					yyerror( msg );

				_endif



				/*
				** Emit the label at the end of the procedure
				*/

				PushBackStr( "end" );
				_if( (yyvsp[(8) - (20)].options.UseFrame) )

					char lbl[256];
					
					sprintf( lbl, "x%s" sympost, (yyvsp[(5) - (20)].s)->StaticName );
					EmitStmtLbl( lbl );


					/*
					** Deal with the _finalize_ string here.
					*/

					InvisibleCode = NULL;
					_if
					(
							(yyvsp[(16) - (20)].s)->pType != tString 
						&&	(yyvsp[(16) - (20)].s)->pType != tZString 
					)

						WarnNear
						(
							"_finalize_ must be a string constant.  Value ignored",
							"_finalize_"
						);

					_elseif( strlen( (yyvsp[(16) - (20)].s)->u.strval ) != 0 )

						InvisibleCode = (yyvsp[(16) - (20)].s)->u.strval;
						PushBackStr( "\xF3" );
						PushBackStr( (yyvsp[(16) - (20)].s)->u.strval );

					_endif
					
				_endif
				_here;
			;}
    break;

  case 736:

/* Line 1464 of yacc.c  */
#line 33823 "hlaparse.bsn"
    {			/* $24 */
							 
				struct contextListType	*cNode;
				SymNode_t				*s;
				SymNode_t				*d;

				_here;
	
				/*
				** If we've got any pass by value/result or
				** pass by result parameters, we've got to
				** copy the data back to the caller at this point.
				*/

				_if( (yyvsp[(8) - (23)].options.UseFrame) )

					StoreValResParms( (yyvsp[(5) - (23)].s) );

				_endif



				
				--CurLexLevel;
				CurOffset = (yyvsp[(2) - (23)].v.u.unsval);
				CurOffsetDir = (yyvsp[(3) - (23)].v.u.unsval);


				/*
				** Remove this procedure's local symbols from
				** further consideration in the symbol table.
				*/

				(yyvsp[(5) - (23)].s)->u.proc.Locals = SymbolTable;
				(yyvsp[(10) - (23)].s)->Next = NULL;
				SymbolTable = (yyvsp[(7) - (23)].s);

				/*
				** Since this can no longer be an external reference,
				** set the external flag to false.
				*/

				(yyvsp[(5) - (23)].s)->IsExternal = 0;


				/*
				** See if there are any outstanding undefined static
				** objects at lex level zero.
				*/

				CurrentContext = (yyvsp[(5) - (23)].s);
				CheckStatic( StaticList, 0 );
				CurrentContext = (yyvsp[(4) - (23)].s);

				/*
				** See if there are any outstanding forward reference
				** labels.
				*/

				CheckFwdRef();


				/*
				** Output the necessary data to the assembly language
				** file to complete this procedure.
				*/

				_if( (yyvsp[(8) - (23)].options.UseFrame) )

					IteratorExit( (yyvsp[(5) - (23)].s)->u.proc.ParmSize ); 

				_endif
				EndProc( (yyvsp[(5) - (23)].s)->StaticName );
				endCseg();
				free2( vss (yyvsp[(19) - (23)].neID.idStr) );

				inIterator = 0;

				/*
				** Remove the current context from the context stack.
				*/
				
				_if( (yyvsp[(8) - (23)].options.UseFrame) )

					assert( contextList != NULL );
					cNode = contextList;
					contextList = cNode->Next;

					assert( _streq( cNode->label, (yyvsp[(5) - (23)].s)->TrueName) );
					free2( vss cNode->StaticName );

				_endif
				
				/*
				** Restore currentNS
				*/
				
				currentNS = (yyvsp[(11) - (23)].ru.saveCurNS);
				
				_here;
			;}
    break;

  case 737:

/* Line 1464 of yacc.c  */
#line 33949 "hlaparse.bsn"
    {					/* $9 */
				_here;
				yyerror( "Cannot define this method at this lex level" );
				(yyval.s) = SymbolTable;
			;}
    break;

  case 738:

/* Line 1464 of yacc.c  */
#line 33958 "hlaparse.bsn"
    {					/* $14 */
				_here;
				free2( vss (yyvsp[(12) - (13)].neID.idStr) );
			;}
    break;

  case 739:

/* Line 1464 of yacc.c  */
#line 33966 "hlaparse.bsn"
    {					/* $19 */

				_here;
				--CurLexLevel;
				CurOffset = (yyvsp[(3) - (18)].v.u.unsval);
				CurOffsetDir = (yyvsp[(4) - (18)].v.u.unsval);
				ThisPtr = (yyvsp[(6) - (18)].s);
				(yyvsp[(2) - (18)].s)->u.proc.Locals = SymbolTable;
				SymbolTable = (yyvsp[(9) - (18)].s);
				free2( vss (yyvsp[(17) - (18)].neID.idStr) );
				_here;
			;}
    break;

  case 741:

/* Line 1464 of yacc.c  */
#line 34010 "hlaparse.bsn"
    {
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (4)].v.u.intval); 
			;}
    break;

  case 742:

/* Line 1464 of yacc.c  */
#line 34015 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(5) - (6)].v.u.intval);	//Shut up bison
			;}
    break;

  case 743:

/* Line 1464 of yacc.c  */
#line 34025 "hlaparse.bsn"
    { 
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (4)].v.u.intval); 
			;}
    break;

  case 744:

/* Line 1464 of yacc.c  */
#line 34030 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(5) - (6)].v.u.intval);	//Shut up bison
			;}
    break;

  case 745:

/* Line 1464 of yacc.c  */
#line 34040 "hlaparse.bsn"
    { 
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (4)].v.u.intval); 
			;}
    break;

  case 746:

/* Line 1464 of yacc.c  */
#line 34045 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(5) - (6)].v.u.intval);	//Shut up bison
			;}
    break;

  case 747:

/* Line 1464 of yacc.c  */
#line 34055 "hlaparse.bsn"
    { 
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (4)].v.u.intval); 
			;}
    break;

  case 748:

/* Line 1464 of yacc.c  */
#line 34060 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(5) - (6)].v.u.intval);	//Shut up bison
			;}
    break;

  case 749:

/* Line 1464 of yacc.c  */
#line 34070 "hlaparse.bsn"
    { 
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (4)].v.u.intval); 
			;}
    break;

  case 750:

/* Line 1464 of yacc.c  */
#line 34075 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(5) - (6)].v.u.intval);	//Shut up bison
			;}
    break;

  case 751:

/* Line 1464 of yacc.c  */
#line 34084 "hlaparse.bsn"
    { 
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (4)].v.u.intval); 
			;}
    break;

  case 752:

/* Line 1464 of yacc.c  */
#line 34089 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(5) - (6)].v.u.intval);	//Shut up bison
			;}
    break;

  case 753:

/* Line 1464 of yacc.c  */
#line 34099 "hlaparse.bsn"
    { 
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (4)].v.u.intval); 
			;}
    break;

  case 754:

/* Line 1464 of yacc.c  */
#line 34104 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(5) - (6)].v.u.intval);	//Shut up bison
			;}
    break;

  case 755:

/* Line 1464 of yacc.c  */
#line 34112 "hlaparse.bsn"
    {
				(yyval.v) = (yyvsp[(1) - (2)].v);
			;}
    break;

  case 756:

/* Line 1464 of yacc.c  */
#line 34117 "hlaparse.bsn"
    { 
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (5)].v.u.intval); 
			;}
    break;

  case 757:

/* Line 1464 of yacc.c  */
#line 34122 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(3) - (7)].v.u.intval);	//Shut up bison
				(void) (yyvsp[(6) - (7)].v.u.intval);	//Shut up bison
			;}
    break;

  case 758:

/* Line 1464 of yacc.c  */
#line 34132 "hlaparse.bsn"
    {
				_here;
				(yyval.v) = (yyvsp[(1) - (3)].v);
			;}
    break;

  case 759:

/* Line 1464 of yacc.c  */
#line 34138 "hlaparse.bsn"
    { 
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (6)].v.u.intval); 
			;}
    break;

  case 760:

/* Line 1464 of yacc.c  */
#line 34143 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(4) - (8)].v.u.intval);	//Shut up bison
				(void) (yyvsp[(7) - (8)].v.u.intval);	//Shut up bison
			;}
    break;

  case 761:

/* Line 1464 of yacc.c  */
#line 34153 "hlaparse.bsn"
    { 
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (3)].v.u.intval); 
			;}
    break;

  case 762:

/* Line 1464 of yacc.c  */
#line 34158 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(4) - (5)].v.u.intval);	//Shut up bison
			;}
    break;

  case 763:

/* Line 1464 of yacc.c  */
#line 34166 "hlaparse.bsn"
    { 
				_here; 
				(yyval.v.u.intval) = (yyvsp[(1) - (3)].v.u.intval); 
			;}
    break;

  case 764:

/* Line 1464 of yacc.c  */
#line 34171 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(4) - (5)].v.u.intval);	//Shut up bison
			;}
    break;

  case 765:

/* Line 1464 of yacc.c  */
#line 34179 "hlaparse.bsn"
    { 
			_here; 
			(yyval.v.u.intval) = (yyvsp[(0) - (0)].v.u.intval); 
		;}
    break;

  case 766:

/* Line 1464 of yacc.c  */
#line 34192 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 767:

/* Line 1464 of yacc.c  */
#line 34198 "hlaparse.bsn"
    { _here;(yyval.v) = (yyvsp[(0) - (0)].v); ;}
    break;

  case 768:

/* Line 1464 of yacc.c  */
#line 34200 "hlaparse.bsn"
    { _here;(yyval.v) = (yyvsp[(1) - (2)].v); ;}
    break;

  case 769:

/* Line 1464 of yacc.c  */
#line 34202 "hlaparse.bsn"
    { _here;(void) (yyvsp[(3) - (4)].v);  ;}
    break;

  case 770:

/* Line 1464 of yacc.c  */
#line 34211 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 771:

/* Line 1464 of yacc.c  */
#line 34217 "hlaparse.bsn"
    { _here;(yyval.v) = (yyvsp[(0) - (0)].v); ;}
    break;

  case 772:

/* Line 1464 of yacc.c  */
#line 34219 "hlaparse.bsn"
    { _here;(yyval.v) = (yyvsp[(1) - (2)].v); ;}
    break;

  case 773:

/* Line 1464 of yacc.c  */
#line 34221 "hlaparse.bsn"
    { _here;(void) (yyvsp[(3) - (4)].v);  ;}
    break;

  case 774:

/* Line 1464 of yacc.c  */
#line 34245 "hlaparse.bsn"
    {				/* $11 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			CurOffset = (yyvsp[(3) - (10)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (10)].v.u.unsval);
			
			/*
			** EnterName entered this code into the symbol
			** table as a procedure rather than as a method.
			** We need to fix that here.
			*/

			(yyvsp[(7) - (10)].en.s)->SymClass = cMethod;
			(yyvsp[(7) - (10)].en.s)->pType = tMethod;

			// Methods always use the pascal calling sequence
			
			(yyvsp[(7) - (10)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (10)].en.s)->u.proc.cs = pascal_cs;

			/*
			** Enter the "returns" value into the symbol table.
			*/
			
			(yyvsp[(7) - (10)].en.s)->u.proc.returns = (yyvsp[(10) - (10)].options.returns);
			(yyvsp[(7) - (10)].en.s)->u.proc.use = (yyvsp[(10) - (10)].options.use);

			CheckLegalOptions
			( 
				(yyvsp[(10) - (10)].options.SpecifiedOptions),
					specified_returns 
				|	specified_use
			);



			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(7) - (10)].en.s)->u.proc.BaseClass = ClassPtr;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (10)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (10)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(10) - (10)].options.returns);
			(yyvsp[(7) - (10)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(10) - (10)].options.use);

			/*
			** Mark the end of the parameters in the symbol table.
			*/

			(yyvsp[(7) - (10)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (10)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (10)].en.s)->u.proc.Forward = SymbolTable;

			/*
			** This guy isn't external, so ensure that:
			*/
			
			(yyvsp[(7) - (10)].en.s)->IsExternal = 0;
				

			/*
			** Remove this methods's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class method declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (10)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (10)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;

			_endwhile
		
			ParmList->Next = NULL;
			
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (method parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (10)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (10)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (10)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (10)].en.s)->u.proc.cs;
			(yyvsp[(7) - (10)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (10)].en.s);
			
			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;

			CurrentContext = (yyvsp[(5) - (10)].s);
			CurLexLevel = (yyvsp[(6) - (10)].v.u.intval);
			
			/*
			** Restore currentNS
			*/

			currentNS = (yyvsp[(7) - (10)].en.cns);
			_here;
		;}
    break;

  case 775:

/* Line 1464 of yacc.c  */
#line 34439 "hlaparse.bsn"
    {
				_here;
				(yyval.idStr) = (yyvsp[(0) - (2)].idStr);
			;}
    break;

  case 776:

/* Line 1464 of yacc.c  */
#line 34462 "hlaparse.bsn"
    {						/* $10 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			CurOffset = (yyvsp[(3) - (9)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (9)].v.u.unsval);
			
			/*
			** EnterName entered this code into the symbol
			** table as a procedure rather than as a method.
			** We need to fix that here.
			*/

			(yyvsp[(7) - (9)].en.s)->SymClass = cMethod;
			(yyvsp[(7) - (9)].en.s)->pType = tMethod;

			// Methods always use the pascal calling sequence
			
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (9)].en.s)->u.proc.cs = pascal_cs;

			/*
			** Enter the "returns" value into the symbol table.
			*/
			
			(yyvsp[(7) - (9)].en.s)->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
			(yyvsp[(7) - (9)].en.s)->u.proc.use = (yyvsp[(9) - (9)].options.use);

			CheckLegalOptions
			( 
				(yyvsp[(9) - (9)].options.SpecifiedOptions),
				specified_returns |
				specified_use
			);



			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.BaseClass = ClassPtr;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (9)].options.use);

			/*
			** Mark the end of the parameters in the symbol table.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (9)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.Forward = SymbolTable;

			/*
			** This guy isn't external, so ensure that:
			*/
			
			(yyvsp[(7) - (9)].en.s)->IsExternal = 0;
				

			/*
			** Remove this methods's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class method declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (9)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;

			_endwhile
		
			ParmList->Next = NULL;
			
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (method parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (9)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (9)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (9)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (9)].en.s)->u.proc.cs;
			(yyvsp[(7) - (9)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (9)].en.s);
			
			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;

			CurrentContext = (yyvsp[(5) - (9)].s);
			CurLexLevel = (yyvsp[(6) - (9)].v.u.intval);
			
			/*
			** Restore currentNS
			*/

			currentNS = (yyvsp[(7) - (9)].en.cns);
			_here;
		;}
    break;

  case 777:

/* Line 1464 of yacc.c  */
#line 34671 "hlaparse.bsn"
    {							/* $13 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			CurOffset = (yyvsp[(3) - (12)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (12)].v.u.unsval);
			

			/*
			** EnterName entered this code into the symbol
			** table as a procedure rather than as a method.
			** We need to fix that here.
			*/

			(yyvsp[(7) - (12)].en.s)->SymClass = cMethod;
			(yyvsp[(7) - (12)].en.s)->pType = tMethod;


			/*
			** Enter the "returns" value into the symbol table.
			*/
			
			(yyvsp[(7) - (12)].en.s)->u.proc.returns = (yyvsp[(10) - (12)].options.returns);
			(yyvsp[(7) - (12)].en.s)->u.proc.use = (yyvsp[(10) - (12)].options.use);

			// Methods always use the pascal calling sequence
			
			(yyvsp[(7) - (12)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (12)].en.s)->u.proc.cs = pascal_cs;

			CheckLegalOptions
			( 
				(yyvsp[(10) - (12)].options.SpecifiedOptions),
					specified_returns 
				|	specified_use
			);

			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(7) - (12)].en.s)->u.proc.BaseClass = ClassPtr;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (12)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (12)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(10) - (12)].options.returns);
			(yyvsp[(7) - (12)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(10) - (12)].options.use);

			/*
			** Mark the end of the parameters in the symbol table.
			*/

			(yyvsp[(7) - (12)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (12)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (12)].en.s)->u.proc.Forward = SymbolTable;

			/*
			** It is abstract, so we don't need to have a definition
			** for it later in the code.  We can specify this by claiming
			** that the method is external.
			*/

			(yyvsp[(7) - (12)].en.s)->IsExternal = 1;

			/*
			** The static name assigned earlier is incorrect,
			** substitute the name of the ?abstract procedure
			** to generate a run-time error if the program accidentally
			** calls this abstract procedure.  Also set "HasAbstract" to
			** true so the compiler will emit code for the ?abstract
			** procedure.
			*/

			free2( vss (yyvsp[(7) - (12)].en.s)->StaticName );
			(yyvsp[(7) - (12)].en.s)->StaticName = hlastrdup2( "abstract" sympost );
			HasAbstract = 1;
			need_raise = 1;

			/*
			** Remove this methods's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class method declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (12)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (12)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;
				//assert( ParmList != NULL );

			_endwhile
			ParmList->Next = NULL;
			
			
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (method parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (12)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (12)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (12)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (12)].en.s)->u.proc.cs;
			(yyvsp[(7) - (12)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (12)].en.s);
			

			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been defined (in the event this
			** external declaration just turns out to be
			** a forward declaration).
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;

			CurrentContext = (yyvsp[(5) - (12)].s);
			CurLexLevel = (yyvsp[(6) - (12)].v.u.intval);
			
			/*
			** Restore currentNS
			*/
			
			currentNS = (yyvsp[(7) - (12)].en.cns);
			_here;
		;}
    break;

  case 778:

/* Line 1464 of yacc.c  */
#line 34898 "hlaparse.bsn"
    {							/* $12 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			CurOffset = (yyvsp[(3) - (11)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (11)].v.u.unsval);
			

			/*
			** EnterName entered this code into the symbol
			** table as a procedure rather than as a method.
			** We need to fix that here.
			*/

			(yyvsp[(7) - (11)].en.s)->SymClass = cMethod;
			(yyvsp[(7) - (11)].en.s)->pType = tMethod;


			/*
			** Enter the "returns" value into the symbol table.
			*/
			
			(yyvsp[(7) - (11)].en.s)->u.proc.returns = (yyvsp[(9) - (11)].options.returns);
			(yyvsp[(7) - (11)].en.s)->u.proc.use = (yyvsp[(9) - (11)].options.use);

			// Methods always use the pascal calling sequence
			
			(yyvsp[(7) - (11)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (11)].en.s)->u.proc.cs = pascal_cs;

			CheckLegalOptions
			( 
				(yyvsp[(9) - (11)].options.SpecifiedOptions),
					specified_returns 
				|	specified_use
			);

			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(7) - (11)].en.s)->u.proc.BaseClass = ClassPtr;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (11)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (11)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (11)].options.returns);
			(yyvsp[(7) - (11)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (11)].options.use);

			/*
			** Mark the end of the parameters in the symbol table.
			*/

			(yyvsp[(7) - (11)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (11)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (11)].en.s)->u.proc.Forward = SymbolTable;

			/*
			** It is abstract, so we don't need to have a definition
			** for it later in the code.  We can specify this by claiming
			** that the method is external.
			*/

			(yyvsp[(7) - (11)].en.s)->IsExternal = 1;

			/*
			** The static name assigned earlier is incorrect,
			** substitute the name of the ?abstract procedure
			** to generate a run-time error if the program accidentally
			** calls this abstract procedure.  Also set "HasAbstract" to
			** true so the compiler will emit code for the ?abstract
			** procedure.
			*/

			free2( vss (yyvsp[(7) - (11)].en.s)->StaticName );
			(yyvsp[(7) - (11)].en.s)->StaticName = hlastrdup2( "abstract" sympost );
			HasAbstract = 1;
			need_raise = 1;

			/*
			** Remove this methods's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class method declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (11)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (11)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;
				//assert( ParmList != NULL );

			_endwhile
			ParmList->Next = NULL;
			
			
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (method parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (11)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (11)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (11)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (11)].en.s)->u.proc.cs;
			(yyvsp[(7) - (11)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (11)].en.s);
			

			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been defined (in the event this
			** external declaration just turns out to be
			** a forward declaration).
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;

			CurrentContext = (yyvsp[(5) - (11)].s);
			CurLexLevel = (yyvsp[(6) - (11)].v.u.intval);
			
			/*
			** Restore currentNS
			*/
			
			currentNS = (yyvsp[(7) - (11)].en.cns);
			_here;
		;}
    break;

  case 779:

/* Line 1464 of yacc.c  */
#line 35115 "hlaparse.bsn"
    {
			SymNode_t	*s;
			SymNode_t	*parmPtr;
			int			parmCnt;
			
		    _here;
		   	doCollect = 0;
			s = InsertSym
				(
					(yyvsp[(1) - (7)].idStr),			//TrueName
					NULL,				//Type
					tOverloads,			//pType
					cOverloads,			//TheClass
					0,					//Arity
					NULL,				//Dimensions,
					0,					//NumElements,
					NULL,				//TheValue,
					0,					//ObjectSize,
					0,					//Offset,
					NULL,				//StaticName,
					NULL,				//Base,
					NULL,				//Fields,
					0					//FieldCnt
				);
				
			s->u.ovld.nextOvld	= NULL;
			parmPtr				= (yyvsp[(5) - (7)].s)->u.proc.parms;
			s->u.ovld.parms		= parmPtr;
			parmCnt = 0;
			_while( parmPtr->SymClass == cParm )
			
				parmPtr = parmPtr->Next;
				++parmCnt;
				
			_endwhile;
			s->u.ovld.numParms = parmCnt;
			_if( *(yyvsp[(6) - (7)].returns) != '\0' )
			
				s->u.ovld.procName = (yyvsp[(6) - (7)].returns);
			
			_else
			
				collectBuf[ collectIndex-1 ] = '\0'; // Trim ';'
				s->u.ovld.procName = hlastrdup2( collectBuf );
				
			_endif
			_here;
		;}
    break;

  case 780:

/* Line 1464 of yacc.c  */
#line 35174 "hlaparse.bsn"
    {
			SymNode_t	*s;
			SymNode_t	*parmPtr;
			int			parmCnt;
			
			_here;
			doCollect = 0;
			s = InsertSym
				(
					strdup( (yyvsp[(1) - (7)].s)->TrueName ),	//TrueName
					NULL,						//Type
					tOverloads,					//pType
					cOverloads,					//TheClass
					0,							//Arity
					NULL,						//Dimensions,
					0,							//NumElements,
					NULL,						//TheValue,
					0,							//ObjectSize,
					0,							//Offset,
					NULL,						//StaticName,
					NULL,						//Base,
					NULL,						//Fields,
					0							//FieldCnt
				);
				
			s->u.ovld.nextOvld	= (yyvsp[(1) - (7)].s);
			parmPtr				= (yyvsp[(5) - (7)].s)->u.proc.parms;
			s->u.ovld.parms		= parmPtr;
			parmCnt = 0;
			_while( parmPtr->SymClass == cParm )
			
				parmPtr = parmPtr->Next;
				++parmCnt;
				
			_endwhile;
			s->u.ovld.numParms = parmCnt;
			_if( *(yyvsp[(6) - (7)].returns) != '\0' )
			
				s->u.ovld.procName = (yyvsp[(6) - (7)].returns);
				
			_else
			
				s->u.ovld.procName = hlastrdup( collectBuf );
				
			_endif
			_here;
		;}
    break;

  case 781:

/* Line 1464 of yacc.c  */
#line 35236 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = (yyvsp[(3) - (3)].s); 
		;}
    break;

  case 782:

/* Line 1464 of yacc.c  */
#line 35244 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = (yyvsp[(3) - (3)].s); 
		;}
    break;

  case 783:

/* Line 1464 of yacc.c  */
#line 35254 "hlaparse.bsn"
    {					/* $3 */

			char   					StaticName[ 256 ];
			struct MethodListType	*ml;
			SymNode_t 				*sym;


			_here;

			/*
			** Verify that the lex level of the original method
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(1) - (2)].s)->LexLevel != (yyvsp[(0) - (2)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden method does not match\n"
					"the lex level of the original method"
				);

			_endif

			/*
			** Change the symbol's static ID at this point.
			*/

			sym = lookupin( (yyvsp[(1) - (2)].s)->TrueName, (yyvsp[(1) - (2)].s)->u.proc.parms );
			
			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (2)].s)->TrueName, LblCntr++ );
			free2( vss (yyvsp[(1) - (2)].s)->StaticName );
			(yyvsp[(1) - (2)].s)->StaticName = hlastrdup2( StaticName );
			_if( sym != NULL )

				//free2( vss sym->StaticName ); // Not a unique ptr!
				sym->StaticName = hlastrdup2( StaticName );

			_endif

			/*
			** Ensure that this is not an external ID.
			*/

			(yyvsp[(1) - (2)].s)->IsExternal = 0;
			SetReferenced( (yyvsp[(1) - (2)].s) );


			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(1) - (2)].s)->u.proc.BaseClass = ClassPtr;



			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(1) - (2)].s)->u.proc.Forward = (yyvsp[(1) - (2)].s); /* Any non-NULL value works */


			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(1) - (2)].s);
			ml->LexLevel = CurLexLevel;

			_here;
		;}
    break;

  case 784:

/* Line 1464 of yacc.c  */
#line 35346 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = (yyvsp[(1) - (3)].s); 
		;}
    break;

  case 785:

/* Line 1464 of yacc.c  */
#line 35354 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = (yyvsp[(1) - (3)].s); 
		;}
    break;

  case 786:

/* Line 1464 of yacc.c  */
#line 35364 "hlaparse.bsn"
    {					/* $3 */

			char   					StaticName[ 256 ];
			struct MethodListType	*ml;
			SymNode_t 				*sym;


			_here;

			/*
			** Verify that the lex level of the original method
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(1) - (2)].s)->LexLevel != (yyvsp[(0) - (2)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden method does not match\n"
					"the lex level of the original method"
				);

			_endif

			/*
			** Change the symbol's static ID at this point.
			*/

			sym = lookupin( (yyvsp[(1) - (2)].s)->TrueName, (yyvsp[(1) - (2)].s)->u.proc.parms );
			
			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (2)].s)->TrueName, LblCntr++ );
			free2( vss (yyvsp[(1) - (2)].s)->StaticName );
			(yyvsp[(1) - (2)].s)->StaticName = hlastrdup2( StaticName );
			_if( sym != NULL )

				//free2( vss sym->StaticName ); // Not a unique ptr!
				sym->StaticName = hlastrdup2( StaticName );

			_endif

			/*
			** Ensure that this is not an external ID.
			*/

			(yyvsp[(1) - (2)].s)->IsExternal = 0;
			SetReferenced( (yyvsp[(1) - (2)].s) );


			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(1) - (2)].s)->u.proc.BaseClass = ClassPtr;



			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(1) - (2)].s)->u.proc.Forward = (yyvsp[(1) - (2)].s); /* Any non-NULL value works */


			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(1) - (2)].s);
			ml->LexLevel = CurLexLevel;

			_here;
		;}
    break;

  case 787:

/* Line 1464 of yacc.c  */
#line 35458 "hlaparse.bsn"
    {				/* $4 */ 

			char DefaultName[ 256 ];

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <procname>
			*/
			
			_here;
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(1) - (3)].s)->TrueName );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 788:

/* Line 1464 of yacc.c  */
#line 35478 "hlaparse.bsn"
    {				/* $6 */

			char   					StaticName[ 256 ];
			struct MethodListType	*ml;
			SymNode_t				*sym;


			_here;

			/*
			** Verify that the lex level of the original method
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(1) - (5)].s)->LexLevel != (yyvsp[(0) - (5)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden method does not match\n"
					"the lex level of the original method"
				);

			_endif

			/*
			** Change the symbol's static ID at this point.
			*/

			free2( vss (yyvsp[(1) - (5)].s)->StaticName );
			(yyvsp[(1) - (5)].s)->StaticName = (yyvsp[(5) - (5)].idStr);
			sym = lookupin( (yyvsp[(1) - (5)].s)->TrueName, (yyvsp[(1) - (5)].s)->u.proc.parms );
			_if( sym != NULL )

				//free2( vss sym->StaticName ); not a unique ptr!
				sym->StaticName = hlastrdup2( (yyvsp[(5) - (5)].idStr) );

			_endif

			/*
			** Ensure that this is an external ID.
			*/

			(yyvsp[(1) - (5)].s)->IsExternal = 1;

			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(1) - (5)].s)->u.proc.BaseClass = ClassPtr;



			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(1) - (5)].s)->u.proc.Forward = (yyvsp[(1) - (5)].s); /* Any non-NULL value works */


			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(1) - (5)].s);
			ml->LexLevel = CurLexLevel;

			/*
			** Output an externdef directive to keep MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(1) - (5)].s), (yyvsp[(1) - (5)].s)->StaticName, tLabel );
			(void) (yyvsp[(4) - (5)].idStr);	// shut up bison
			_here;
		;}
    break;

  case 789:

/* Line 1464 of yacc.c  */
#line 35574 "hlaparse.bsn"
    {				/* $4 */ 

			char DefaultName[ 256 ];

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <procname>
			*/
			
			_here;
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(1) - (3)].s)->TrueName );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 790:

/* Line 1464 of yacc.c  */
#line 35594 "hlaparse.bsn"
    {				/* $6 */

			char   					StaticName[ 256 ];
			struct MethodListType	*ml;
			SymNode_t				*sym;


			_here;

			/*
			** Verify that the lex level of the original method
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(1) - (5)].s)->LexLevel != (yyvsp[(0) - (5)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden method does not match\n"
					"the lex level of the original method"
				);

			_endif

			/*
			** Change the symbol's static ID at this point.
			*/

			free2( vss (yyvsp[(1) - (5)].s)->StaticName );
			(yyvsp[(1) - (5)].s)->StaticName = (yyvsp[(5) - (5)].idStr);
			sym = lookupin( (yyvsp[(1) - (5)].s)->TrueName, (yyvsp[(1) - (5)].s)->u.proc.parms );
			_if( sym != NULL )

				//free2( vss sym->StaticName ); not a unique ptr!
				sym->StaticName = hlastrdup2( (yyvsp[(5) - (5)].idStr) );

			_endif

			/*
			** Ensure that this is an external ID.
			*/

			(yyvsp[(1) - (5)].s)->IsExternal = 1;

			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(1) - (5)].s)->u.proc.BaseClass = ClassPtr;



			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(1) - (5)].s)->u.proc.Forward = (yyvsp[(1) - (5)].s); /* Any non-NULL value works */


			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(1) - (5)].s);
			ml->LexLevel = CurLexLevel;

			/*
			** Output an externdef directive to keep MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(1) - (5)].s), (yyvsp[(1) - (5)].s)->StaticName, tLabel );
			(void) (yyvsp[(4) - (5)].idStr);	// shut up bison
			_here;
		;}
    break;

  case 791:

/* Line 1464 of yacc.c  */
#line 35698 "hlaparse.bsn"
    {							/* $12 */ 

			char DefaultName[ 256 ];

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <methodname>
			*/
			
			_here;
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(2) - (11)].idStr) );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 792:

/* Line 1464 of yacc.c  */
#line 35718 "hlaparse.bsn"
    {							/* $14 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;
			SymNode_t				*sym;


			_here;
			CurOffset = (yyvsp[(3) - (13)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (13)].v.u.unsval);
			
			/*
			** EnterName entered this code into the symbol
			** table as a procedure rather than as a method.
			** We need to fix that here.
			*/

			(yyvsp[(7) - (13)].en.s)->SymClass = cMethod;
			(yyvsp[(7) - (13)].en.s)->pType = tMethod;


			/*
			** Enter the "returns" value into the symbol table.
			*/
			
			(yyvsp[(7) - (13)].en.s)->u.proc.returns = (yyvsp[(10) - (13)].options.returns);
			(yyvsp[(7) - (13)].en.s)->u.proc.use = (yyvsp[(10) - (13)].options.use);

			// Methods always use the pascal calling sequence
			
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (13)].en.s)->u.proc.cs = pascal_cs;

			CheckLegalOptions
			( 
				(yyvsp[(10) - (13)].options.SpecifiedOptions),
					specified_returns 
				|	specified_use
			);

			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.BaseClass = ClassPtr;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(10) - (13)].options.returns);
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(10) - (13)].options.use);

			/*
			** Mark the end of the parameters in the symbol table.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (13)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.Forward = SymbolTable;

			/*
			** It is also external, deal with that here.
			*/

			(yyvsp[(7) - (13)].en.s)->IsExternal = 1;

			free2( vss (yyvsp[(7) - (13)].en.s)->StaticName );
			(yyvsp[(7) - (13)].en.s)->StaticName = (yyvsp[(13) - (13)].idStr);
			sym = lookupin( (yyvsp[(7) - (13)].en.s)->TrueName, (yyvsp[(7) - (13)].en.s)->u.proc.parms );
			_if( sym != NULL )

				//free2( vss sym->StaticName ); not a unique ptr!
				sym->StaticName = hlastrdup2( (yyvsp[(13) - (13)].idStr) );

			_endif


			/*
			** Remove this methods's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class method declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (13)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;

			_endwhile
			ParmList->Next = NULL;
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (method parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (13)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (13)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (13)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (13)].en.s)->u.proc.cs;
			(yyvsp[(7) - (13)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (13)].en.s);
			


			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been defined (in the event this
			** external declaration just turns out to be
			** a forward declaration).
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;

			CurrentContext = (yyvsp[(5) - (13)].s);
			CurLexLevel = (yyvsp[(6) - (13)].v.u.intval);

			/*
			** Output an externdef directive to keep MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(7) - (13)].en.s), (yyvsp[(7) - (13)].en.s)->StaticName, tLabel );
			
			/*
			** restore currentNS
			*/
			
			currentNS = (yyvsp[(7) - (13)].en.cns);
			(void) (yyvsp[(12) - (13)].idStr);	// shut up bison
			_here;
		;}
    break;

  case 793:

/* Line 1464 of yacc.c  */
#line 35941 "hlaparse.bsn"
    {							/* $11 */ 

			char DefaultName[ 256 ];

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <methodname>
			*/
			
			_here;
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(2) - (10)].idStr) );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 794:

/* Line 1464 of yacc.c  */
#line 35962 "hlaparse.bsn"
    {							/* $14 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;
			SymNode_t				*sym;


			_here;
			CurOffset = (yyvsp[(3) - (13)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (13)].v.u.unsval);
			
			/*
			** EnterName entered this code into the symbol
			** table as a procedure rather than as a method.
			** We need to fix that here.
			*/

			(yyvsp[(7) - (13)].en.s)->SymClass = cMethod;
			(yyvsp[(7) - (13)].en.s)->pType = tMethod;


			/*
			** Enter the "returns" value into the symbol table.
			*/
			
			(yyvsp[(7) - (13)].en.s)->u.proc.returns = (yyvsp[(9) - (13)].options.returns);
			(yyvsp[(7) - (13)].en.s)->u.proc.use = (yyvsp[(9) - (13)].options.use);

			// Methods always use the pascal calling sequence
			
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (13)].en.s)->u.proc.cs = pascal_cs;

			CheckLegalOptions
			( 
				(yyvsp[(9) - (13)].options.SpecifiedOptions),
					specified_returns 
				|	specified_use
			);

			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.BaseClass = ClassPtr;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (13)].options.returns);
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (13)].options.use);

			/*
			** Mark the end of the parameters in the symbol table.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (13)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.Forward = SymbolTable;

			/*
			** It is also external, deal with that here.
			*/

			(yyvsp[(7) - (13)].en.s)->IsExternal = 1;

			free2( vss (yyvsp[(7) - (13)].en.s)->StaticName );
			(yyvsp[(7) - (13)].en.s)->StaticName = (yyvsp[(12) - (13)].idStr);
			sym = lookupin( (yyvsp[(7) - (13)].en.s)->TrueName, (yyvsp[(7) - (13)].en.s)->u.proc.parms );
			_if( sym != NULL )

				//free2( vss sym->StaticName ); not a unique ptr!
				sym->StaticName = hlastrdup2( (yyvsp[(12) - (13)].idStr) );

			_endif


			/*
			** Remove this methods's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class method declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (13)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;

			_endwhile
			ParmList->Next = NULL;
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (method parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (13)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (13)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (13)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (13)].en.s)->u.proc.cs;
			(yyvsp[(7) - (13)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (13)].en.s);
			


			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been defined (in the event this
			** external declaration just turns out to be
			** a forward declaration).
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;

			CurrentContext = (yyvsp[(5) - (13)].s);
			CurLexLevel = (yyvsp[(6) - (13)].v.u.intval);

			/*
			** Output an externdef directive to keep MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(7) - (13)].en.s), (yyvsp[(7) - (13)].en.s)->StaticName, tLabel );
			
			/*
			** restore currentNS
			*/
			
			currentNS = (yyvsp[(7) - (13)].en.cns);
			(void) (yyvsp[(11) - (13)].idStr);	// shut up bison
			_here;
		;}
    break;

  case 795:

/* Line 1464 of yacc.c  */
#line 36181 "hlaparse.bsn"
    {

			(yyval.v.u.intval) = CurLexLevel;
			CurLexLevel = (yyvsp[(-5) - (0)].v.u.intval);
			_here;
		;}
    break;

  case 796:

/* Line 1464 of yacc.c  */
#line 36212 "hlaparse.bsn"
    {				/* $10 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			CurOffset = (yyvsp[(3) - (9)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (9)].v.u.unsval);

			
			/*
			** EnterIterName entered this code into the symbol
			** table as an iterator rather than as a class iterator.
			** We need to fix that here.
			*/

			(yyvsp[(7) - (9)].en.s)->SymClass = cClassIter;
			(yyvsp[(7) - (9)].en.s)->pType = tClassIter;
			(yyvsp[(7) - (9)].en.s)->Type = &classiterID_ste;


			/*
			** Enter the "returns" value into the symbol table.
			** (Iterators can't appear in an expression, so return
			** the empty string.)
			*/
			
			(yyvsp[(7) - (9)].en.s)->u.proc.returns = hlastrdup2( "" );
			(yyvsp[(7) - (9)].en.s)->u.proc.use = NULL;

			// Iterators always use the pascal calling sequence
			
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (9)].en.s)->u.proc.cs = pascal_cs;


			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.BaseClass = ClassPtr;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.returns = hlastrdup2( "" );
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.use = NULL;

			/*
			** Mark the end of the parameters in the symbol table.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this iterator.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (9)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward iterator, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.Forward = SymbolTable;

			/*
			** Remove this iterator's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class iterator declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (9)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;
				//assert( ParmList != NULL );

			_endwhile
			ParmList->Next = NULL;
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (classiter parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (9)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (9)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (9)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (9)].en.s)->u.proc.cs;
			(yyvsp[(7) - (9)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (9)].en.s);
			

			/*
			** Add this iterator to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;

			CurrentContext = (yyvsp[(5) - (9)].s);
			CurLexLevel = (yyvsp[(6) - (9)].v.u.intval);
			
			/*
			** restore currentNS
			*/
			
			currentNS = (yyvsp[(7) - (9)].en.cns);
			
			_here;
		;}
    break;

  case 797:

/* Line 1464 of yacc.c  */
#line 36413 "hlaparse.bsn"
    {				/* $10 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			CurOffset = (yyvsp[(3) - (9)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (9)].v.u.unsval);

			
			/*
			** EnterIterName entered this code into the symbol
			** table as an iterator rather than as a class iterator.
			** We need to fix that here.
			*/

			(yyvsp[(7) - (9)].en.s)->SymClass = cClassIter;
			(yyvsp[(7) - (9)].en.s)->pType = tClassIter;
			(yyvsp[(7) - (9)].en.s)->Type = &classiterID_ste;


			/*
			** Enter the "returns" value into the symbol table.
			** (Iterators can't appear in an expression, so return
			** the empty string.)
			*/
			
			(yyvsp[(7) - (9)].en.s)->u.proc.returns = hlastrdup2( "" );
			(yyvsp[(7) - (9)].en.s)->u.proc.use = NULL;

			// Iterators always use the pascal calling sequence
			
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (9)].en.s)->u.proc.cs = pascal_cs;


			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.BaseClass = ClassPtr;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.returns = hlastrdup2( "" );
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.use = NULL;

			/*
			** Mark the end of the parameters in the symbol table.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this iterator.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (9)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward iterator, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.Forward = SymbolTable;

			/*
			** Remove this iterator's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class iterator declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (9)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;
				//assert( ParmList != NULL );

			_endwhile
			ParmList->Next = NULL;
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (classiter parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (9)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (9)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (9)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (9)].en.s)->u.proc.cs;
			(yyvsp[(7) - (9)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (9)].en.s);
			

			/*
			** Add this iterator to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;

			CurrentContext = (yyvsp[(5) - (9)].s);
			CurLexLevel = (yyvsp[(6) - (9)].v.u.intval);
			
			/*
			** restore currentNS
			*/
			
			currentNS = (yyvsp[(7) - (9)].en.cns);
			
			_here;
		;}
    break;

  case 798:

/* Line 1464 of yacc.c  */
#line 36608 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(3) - (3)].s); 
		;}
    break;

  case 799:

/* Line 1464 of yacc.c  */
#line 36616 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = (yyvsp[(3) - (3)].s); 
		;}
    break;

  case 800:

/* Line 1464 of yacc.c  */
#line 36624 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = (yyvsp[(3) - (3)].s); 
		;}
    break;

  case 801:

/* Line 1464 of yacc.c  */
#line 36636 "hlaparse.bsn"
    {					/* $3 */

			char   					StaticName[ 256 ];
			struct MethodListType	*ml;
			SymNode_t 				*sym;


			_here;

			/*
			** Verify that the lex level of the original iterator
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(1) - (2)].s)->LexLevel != (yyvsp[(0) - (2)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden iterator does not match\n"
					"the lex level of the original iterator"
				);

			_endif

			/*
			** Change the symbol's static ID at this point.
			*/

			sym = lookupin( (yyvsp[(1) - (2)].s)->TrueName, (yyvsp[(1) - (2)].s)->u.proc.parms );
			
			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (2)].s)->TrueName, LblCntr++ );
			free2( vss (yyvsp[(1) - (2)].s)->StaticName );
			(yyvsp[(1) - (2)].s)->StaticName = hlastrdup2( StaticName );
			_if( sym != NULL )

				sym->StaticName = hlastrdup2( StaticName );

			_endif

			/*
			** Ensure that this is not an external ID.
			*/

			(yyvsp[(1) - (2)].s)->IsExternal = 0;
			SetReferenced( (yyvsp[(1) - (2)].s) );


			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(1) - (2)].s)->u.proc.BaseClass = ClassPtr;



			/*
			** This is a forward iterator, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(1) - (2)].s)->u.proc.Forward = (yyvsp[(1) - (2)].s); /* Any non-NULL value works */


			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(1) - (2)].s);
			ml->LexLevel = CurLexLevel;

			_here;
		;}
    break;

  case 802:

/* Line 1464 of yacc.c  */
#line 36726 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (2)].s); 
		;}
    break;

  case 803:

/* Line 1464 of yacc.c  */
#line 36734 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = (yyvsp[(1) - (3)].s); 
		;}
    break;

  case 804:

/* Line 1464 of yacc.c  */
#line 36742 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = (yyvsp[(1) - (3)].s); 
		;}
    break;

  case 805:

/* Line 1464 of yacc.c  */
#line 36754 "hlaparse.bsn"
    {					/* $3 */

			char   					StaticName[ 256 ];
			struct MethodListType	*ml;
			SymNode_t 				*sym;


			_here;

			/*
			** Verify that the lex level of the original iterator
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(1) - (2)].s)->LexLevel != (yyvsp[(0) - (2)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden iterator does not match\n"
					"the lex level of the original iterator"
				);

			_endif

			/*
			** Change the symbol's static ID at this point.
			*/

			sym = lookupin( (yyvsp[(1) - (2)].s)->TrueName, (yyvsp[(1) - (2)].s)->u.proc.parms );
			
			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (2)].s)->TrueName, LblCntr++ );
			free2( vss (yyvsp[(1) - (2)].s)->StaticName );
			(yyvsp[(1) - (2)].s)->StaticName = hlastrdup2( StaticName );
			_if( sym != NULL )

				sym->StaticName = hlastrdup2( StaticName );

			_endif

			/*
			** Ensure that this is not an external ID.
			*/

			(yyvsp[(1) - (2)].s)->IsExternal = 0;
			SetReferenced( (yyvsp[(1) - (2)].s) );


			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(1) - (2)].s)->u.proc.BaseClass = ClassPtr;



			/*
			** This is a forward iterator, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(1) - (2)].s)->u.proc.Forward = (yyvsp[(1) - (2)].s); /* Any non-NULL value works */


			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(1) - (2)].s);
			ml->LexLevel = CurLexLevel;

			_here;
		;}
    break;

  case 806:

/* Line 1464 of yacc.c  */
#line 36849 "hlaparse.bsn"
    {				/* $4 */ 

			char DefaultName[ 256 ];

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <itername>
			*/
			
			_here;
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(1) - (3)].s)->TrueName );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 807:

/* Line 1464 of yacc.c  */
#line 36869 "hlaparse.bsn"
    {				/* $6 */

			char   					StaticName[ 256 ];
			struct MethodListType	*ml;
			SymNode_t				*sym;


			_here;

			/*
			** Verify that the lex level of the original iterator
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(1) - (5)].s)->LexLevel != (yyvsp[(0) - (5)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden iterator does not match\n"
					"the lex level of the original iterator"
				);

			_endif

			/*
			** Change the symbol's static ID at this point.
			*/

			free2( vss (yyvsp[(1) - (5)].s)->StaticName );
			(yyvsp[(1) - (5)].s)->StaticName = (yyvsp[(5) - (5)].idStr);
			sym = lookupin( (yyvsp[(1) - (5)].s)->TrueName, (yyvsp[(1) - (5)].s)->u.proc.parms );
			_if( sym != NULL )

				sym->StaticName = hlastrdup2( (yyvsp[(5) - (5)].idStr) );

			_endif

			/*
			** Ensure that this is an external ID.
			*/

			(yyvsp[(1) - (5)].s)->IsExternal = 1;

			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(1) - (5)].s)->u.proc.BaseClass = ClassPtr;



			/*
			** This is a forward iterator, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(1) - (5)].s)->u.proc.Forward = (yyvsp[(1) - (5)].s); /* Any non-NULL value works */


			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(1) - (5)].s);
			ml->LexLevel = CurLexLevel;

			/*
			** Output an externdef directive to keep MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(1) - (5)].s), (yyvsp[(1) - (5)].s)->StaticName, tLabel );
			(void) (yyvsp[(4) - (5)].idStr);	// shut up bison
			_here;
		;}
    break;

  case 808:

/* Line 1464 of yacc.c  */
#line 36971 "hlaparse.bsn"
    {				/* $4 */ 

			char DefaultName[ 256 ];

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <itername>
			*/
			
			_here;
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(1) - (3)].s)->TrueName );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 809:

/* Line 1464 of yacc.c  */
#line 36991 "hlaparse.bsn"
    {				/* $6 */

			char   					StaticName[ 256 ];
			struct MethodListType	*ml;
			SymNode_t				*sym;


			_here;

			/*
			** Verify that the lex level of the original iterator
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(1) - (5)].s)->LexLevel != (yyvsp[(0) - (5)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden iterator does not match\n"
					"the lex level of the original iterator"
				);

			_endif

			/*
			** Change the symbol's static ID at this point.
			*/

			free2( vss (yyvsp[(1) - (5)].s)->StaticName );
			(yyvsp[(1) - (5)].s)->StaticName = (yyvsp[(5) - (5)].idStr);
			sym = lookupin( (yyvsp[(1) - (5)].s)->TrueName, (yyvsp[(1) - (5)].s)->u.proc.parms );
			_if( sym != NULL )

				sym->StaticName = hlastrdup2( (yyvsp[(5) - (5)].idStr) );

			_endif

			/*
			** Ensure that this is an external ID.
			*/

			(yyvsp[(1) - (5)].s)->IsExternal = 1;

			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(1) - (5)].s)->u.proc.BaseClass = ClassPtr;



			/*
			** This is a forward iterator, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(1) - (5)].s)->u.proc.Forward = (yyvsp[(1) - (5)].s); /* Any non-NULL value works */


			/*
			** Add this method to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(1) - (5)].s);
			ml->LexLevel = CurLexLevel;

			/*
			** Output an externdef directive to keep MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(1) - (5)].s), (yyvsp[(1) - (5)].s)->StaticName, tLabel );
			(void) (yyvsp[(4) - (5)].idStr);	// shut up bison
			_here;
		;}
    break;

  case 810:

/* Line 1464 of yacc.c  */
#line 37102 "hlaparse.bsn"
    {				/* $12 */ 

			char DefaultName[ 256 ];

			_here;

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <methodname>
			*/
			
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(2) - (11)].idStr) );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 811:

/* Line 1464 of yacc.c  */
#line 37123 "hlaparse.bsn"
    {					/* $14 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			SymNode_t				*sym;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			CurOffset = (yyvsp[(3) - (13)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (13)].v.u.unsval);
			
			/*
			** EnterIterName entered this code into the symbol
			** table as an iterator rather than as a class iterator.
			** We need to fix that here.
			*/

			(yyvsp[(7) - (13)].en.s)->SymClass = cClassIter;
			(yyvsp[(7) - (13)].en.s)->pType = tClassIter;
			(yyvsp[(7) - (13)].en.s)->Type = &classiterID_ste;


			/*
			** Enter the "returns" value into the symbol table.
			** (Iterators can't appear in an expression, so return
			** the empty string.)
			*/
			
			(yyvsp[(7) - (13)].en.s)->u.proc.returns = hlastrdup2( "" );
			(yyvsp[(7) - (13)].en.s)->u.proc.use = NULL;

			// Iterators always use pascal calling sequence:
			
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (13)].en.s)->u.proc.cs = pascal_cs;


			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.BaseClass = ClassPtr;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.returns = hlastrdup2( "" );
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.use = NULL;

			/*
			** Mark the end of the parameters in the symbol table.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this iterator.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (13)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward iterator, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.Forward = SymbolTable;


			/*
			** This symbol is external, deal with that here.
			*/

			(yyvsp[(7) - (13)].en.s)->IsExternal = 1;

			free2( vss (yyvsp[(7) - (13)].en.s)->StaticName );
			(yyvsp[(7) - (13)].en.s)->StaticName = (yyvsp[(13) - (13)].idStr);
			sym = lookupin( (yyvsp[(7) - (13)].en.s)->TrueName, (yyvsp[(7) - (13)].en.s)->u.proc.parms );
			_if( sym != NULL )

				//free2( vss sym->StaticName ); not a unique ptr!
				sym->StaticName = hlastrdup2( (yyvsp[(13) - (13)].idStr) );

			_endif

			/*
			** Remove this iterator's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class iterator declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (13)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;
				//assert( ParmList != NULL );

			_endwhile
			ParmList->Next = NULL;
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (classiter parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (13)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (13)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (13)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (13)].en.s)->u.proc.cs;
			(yyvsp[(7) - (13)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (13)].en.s);
			

			/*
			** Add this iterator to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;


			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;

			CurrentContext = (yyvsp[(5) - (13)].s);
			CurLexLevel = (yyvsp[(6) - (13)].v.u.intval);

			/*
			** Output an externdef directive to keep
			** MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(7) - (13)].en.s), (yyvsp[(7) - (13)].en.s)->StaticName, tLabel );
			
			/*
			** Restore currentNS
			*/
			
			currentNS = (yyvsp[(7) - (13)].en.cns);
			(void) (yyvsp[(12) - (13)].idStr);	// shut up bison
			_here;
		;}
    break;

  case 812:

/* Line 1464 of yacc.c  */
#line 37353 "hlaparse.bsn"
    {						/* $12 */ 

			char DefaultName[ 256 ];

			_here;

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <methodname>
			*/
			
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(2) - (11)].idStr) );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 813:

/* Line 1464 of yacc.c  */
#line 37375 "hlaparse.bsn"
    {					/* $15 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			SymNode_t				*sym;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			CheckLegalOptions
			( 
				(yyvsp[(9) - (14)].options.SpecifiedOptions),
				specified_use
			);

			CurOffset = (yyvsp[(3) - (14)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (14)].v.u.unsval);
			
			/*
			** EnterIterName entered this code into the symbol
			** table as an iterator rather than as a class iterator.
			** We need to fix that here.
			*/

			(yyvsp[(7) - (14)].en.s)->SymClass = cClassIter;
			(yyvsp[(7) - (14)].en.s)->pType = tClassIter;
			(yyvsp[(7) - (14)].en.s)->Type = &classiterID_ste;


			/*
			** Enter the "returns" value into the symbol table.
			** (Iterators can't appear in an expression, so return
			** the empty string.)
			*/
			
			(yyvsp[(7) - (14)].en.s)->u.proc.returns = hlastrdup2( "" );
			(yyvsp[(7) - (14)].en.s)->u.proc.use = (yyvsp[(9) - (14)].options.use);

			// Iterators always use pascal calling sequence:
			
			(yyvsp[(7) - (14)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (14)].en.s)->u.proc.cs = pascal_cs;


			/*
			** Set the BaseClass field to point at the base
			** class for this symbol.
			*/

			(yyvsp[(7) - (14)].en.s)->u.proc.BaseClass = ClassPtr;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (14)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (14)].en.s)->u.proc.parms->u.proc.returns = hlastrdup2( "" );
			(yyvsp[(7) - (14)].en.s)->u.proc.parms->u.proc.use = NULL;

			/*
			** Mark the end of the parameters in the symbol table.
			*/

			(yyvsp[(7) - (14)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this iterator.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (14)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward iterator, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (14)].en.s)->u.proc.Forward = SymbolTable;


			/*
			** This symbol is external, deal with that here.
			*/

			(yyvsp[(7) - (14)].en.s)->IsExternal = 1;

			free2( vss (yyvsp[(7) - (14)].en.s)->StaticName );
			(yyvsp[(7) - (14)].en.s)->StaticName = (yyvsp[(13) - (14)].idStr);
			sym = lookupin( (yyvsp[(7) - (14)].en.s)->TrueName, (yyvsp[(7) - (14)].en.s)->u.proc.parms );
			_if( sym != NULL )

				//free2( vss sym->StaticName ); not a unique ptr!
				sym->StaticName = hlastrdup2( (yyvsp[(13) - (14)].idStr) );

			_endif

			/*
			** Remove this iterator's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class iterator declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (14)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (14)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;
				//assert( ParmList != NULL );

			_endwhile
			ParmList->Next = NULL;
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (classiter parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (14)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (14)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (14)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (14)].en.s)->u.proc.cs;
			(yyvsp[(7) - (14)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (14)].en.s);
			

			/*
			** Add this iterator to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;


			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;

			CurrentContext = (yyvsp[(5) - (14)].s);
			CurLexLevel = (yyvsp[(6) - (14)].v.u.intval);

			/*
			** Output an externdef directive to keep
			** MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(7) - (14)].en.s), (yyvsp[(7) - (14)].en.s)->StaticName, tLabel );
			
			/*
			** Restore currentNS
			*/
			
			currentNS = (yyvsp[(7) - (14)].en.cns);
			(void) (yyvsp[(12) - (14)].idStr);	// shut up bison
			_here;
		;}
    break;

  case 814:

/* Line 1464 of yacc.c  */
#line 37600 "hlaparse.bsn"
    { _here; (yyval.s) = ClassPtr; _here; ;}
    break;

  case 815:

/* Line 1464 of yacc.c  */
#line 37601 "hlaparse.bsn"
    { _here; (yyval.s) = ThisPtr; _here;  ;}
    break;

  case 816:

/* Line 1464 of yacc.c  */
#line 37627 "hlaparse.bsn"
    {					/* $11 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;

			_here;
			CurOffset = (yyvsp[(3) - (10)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (10)].v.u.unsval);
			
			/*
			** Enter the optional "returns" value into the symbol table.
			*/
			

			(yyvsp[(7) - (10)].en.s)->u.proc.returns = (yyvsp[(10) - (10)].options.returns);
			(yyvsp[(7) - (10)].en.s)->u.proc.use = (yyvsp[(10) - (10)].options.use);

			CheckLegalOptions
			( 
				(yyvsp[(10) - (10)].options.SpecifiedOptions),
					specified_returns 
				|	specified_use
			);

			/*
			** Save a pointer to this procedure's class' symbol
			** table entry for later reference:
			*/

			(yyvsp[(7) - (10)].en.s)->u.proc.BaseClass = ClassPtr;

			/*
			** EnterName entered this symbol as a "cProc" object.
			** It really needs to be a "cClassProc" and "tClassProc"
			** object since it is a static procedure in a class.
			** Handle that change here.
			*/

			(yyvsp[(7) - (10)].en.s)->SymClass = cClassProc;
			(yyvsp[(7) - (10)].en.s)->pType = tClassProc;
			(yyvsp[(7) - (10)].en.s)->Type = &classprocID_ste;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (10)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (10)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(10) - (10)].options.returns);
			(yyvsp[(7) - (10)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(10) - (10)].options.use);
			
			(yyvsp[(7) - (10)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (10)].en.s)->u.proc.cs = pascal_cs;

			/*
			** Mark the end of the parameter list.
			*/

			(yyvsp[(7) - (10)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (10)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (10)].en.s)->u.proc.Forward = SymbolTable;


			/*
			** Remove this procedure's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class procedure declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (10)].en.s)->u.proc.Locals = SymbolTable;
			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (10)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;
				//assert( ParmList != NULL );

			_endwhile
			ParmList->Next = NULL;
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (classproc parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (10)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (10)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (10)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (10)].en.s)->u.proc.cs;
			(yyvsp[(7) - (10)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (10)].en.s);
			

			/*
			** Add this (static) class procedure to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;
			CurrentContext = (yyvsp[(5) - (10)].s);
			CurLexLevel = (yyvsp[(6) - (10)].v.u.intval);
			
			/*
			** Restore currentNS
			*/
			
			currentNS = (yyvsp[(7) - (10)].en.cns);
			
			_here;
		;}
    break;

  case 817:

/* Line 1464 of yacc.c  */
#line 37823 "hlaparse.bsn"
    {						/* $10 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;

			_here;
			CurOffset = (yyvsp[(3) - (9)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (9)].v.u.unsval);
			
			/*
			** Enter the optional "returns" value into the symbol table.
			*/
			

			(yyvsp[(7) - (9)].en.s)->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
			(yyvsp[(7) - (9)].en.s)->u.proc.use = (yyvsp[(9) - (9)].options.use);

			CheckLegalOptions
			( 
				(yyvsp[(9) - (9)].options.SpecifiedOptions),
					specified_returns 
				|	specified_use
			);

			/*
			** Save a pointer to this procedure's class' symbol
			** table entry for later reference:
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.BaseClass = ClassPtr;

			/*
			** EnterName entered this symbol as a "cProc" object.
			** It really needs to be a "cClassProc" and "tClassProc"
			** object since it is a static procedure in a class.
			** Handle that change here.
			*/

			(yyvsp[(7) - (9)].en.s)->SymClass = cClassProc;
			(yyvsp[(7) - (9)].en.s)->pType = tClassProc;
			(yyvsp[(7) - (9)].en.s)->Type = &classprocID_ste;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (9)].options.use);
			
			(yyvsp[(7) - (9)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (9)].en.s)->u.proc.cs = pascal_cs;

			/*
			** Mark the end of the parameter list.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (9)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.Forward = SymbolTable;


			/*
			** Remove this procedure's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class procedure declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (9)].en.s)->u.proc.Locals = SymbolTable;
			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (9)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;
				//assert( ParmList != NULL );

			_endwhile
			ParmList->Next = NULL;
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (classproc parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (9)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (9)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (9)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (9)].en.s)->u.proc.cs;
			(yyvsp[(7) - (9)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (9)].en.s);
			

			/*
			** Add this (static) class procedure to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;
			CurrentContext = (yyvsp[(5) - (9)].s);
			CurLexLevel = (yyvsp[(6) - (9)].v.u.intval);
			
			/*
			** Restore currentNS
			*/
			
			currentNS = (yyvsp[(7) - (9)].en.cns);
			
			_here;
		;}
    break;

  case 818:

/* Line 1464 of yacc.c  */
#line 38020 "hlaparse.bsn"
    {							/* $12 */ 

			char DefaultName[ 256 ];

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <procname>
			*/
			
			_here;
			
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(2) - (11)].idStr) );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 819:

/* Line 1464 of yacc.c  */
#line 38041 "hlaparse.bsn"
    {							/* $14 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			SymNode_t				*sym;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			CurOffset = (yyvsp[(3) - (13)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (13)].v.u.unsval);
			
			/*
			** Enter the optional "returns" value into the symbol table.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.returns = (yyvsp[(10) - (13)].options.returns);
			(yyvsp[(7) - (13)].en.s)->u.proc.use = (yyvsp[(10) - (13)].options.use);
			
			
			// Always use pascal calling sequence for class stuff:
			
			(yyvsp[(7) - (13)].en.s)->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;

			CheckLegalOptions
			( 
				(yyvsp[(10) - (13)].options.SpecifiedOptions),
				specified_returns
			);

			/*
			** Save a pointer to this procedure's class' symbol
			** table entry for later reference:
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.BaseClass = ClassPtr;

			/*
			** EnterName entered this symbol as a "cProc" object.
			** It really needs to be a "cClassProc" and "tClassProc"
			** object since it is a static procedure in a class.
			** Handle that change here.
			*/

			(yyvsp[(7) - (13)].en.s)->SymClass = cClassProc;
			(yyvsp[(7) - (13)].en.s)->pType = tClassProc;
			(yyvsp[(7) - (13)].en.s)->Type = &classprocID_ste;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(10) - (13)].options.returns);
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(10) - (13)].options.use);
			

			/*
			** Mark the end of the parameter list.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (13)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.Forward = SymbolTable;


			/*
			** It is also external, deal with that here.
			*/

			(yyvsp[(7) - (13)].en.s)->IsExternal = 1;

			free2( vss (yyvsp[(7) - (13)].en.s)->StaticName );
			(yyvsp[(7) - (13)].en.s)->StaticName = (yyvsp[(13) - (13)].idStr);
			sym = lookupin( (yyvsp[(7) - (13)].en.s)->TrueName, (yyvsp[(7) - (13)].en.s)->u.proc.parms );
			_if( sym != NULL )

				sym->StaticName = hlastrdup2( (yyvsp[(13) - (13)].idStr) );

			_endif


			/*
			** Remove this procedure's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class procedure declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (13)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;
				//assert( ParmList != NULL );

			_endwhile
			ParmList->Next = NULL;
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (classproc parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (13)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (13)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (13)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (13)].en.s)->u.proc.cs;
			(yyvsp[(7) - (13)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (13)].en.s);
			

			/*
			** Add this (static) class procedure to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;
			CurrentContext = (yyvsp[(5) - (13)].s);
			CurLexLevel = (yyvsp[(6) - (13)].v.u.intval);

			/*
			** Output an externdef directive to keep MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(7) - (13)].en.s), (yyvsp[(7) - (13)].en.s)->StaticName, tLabel );
			
			/*
			** Restore currentNS:
			*/
			
			currentNS = (yyvsp[(7) - (13)].en.cns);
			(void) (yyvsp[(12) - (13)].idStr);	//shut up bison
			_here;
		;}
    break;

  case 820:

/* Line 1464 of yacc.c  */
#line 38267 "hlaparse.bsn"
    {							/* $11 */ 

			char DefaultName[ 256 ];

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <procname>
			*/
			
			_here;
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(2) - (10)].idStr) );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 821:

/* Line 1464 of yacc.c  */
#line 38288 "hlaparse.bsn"
    {							/* $14 */

			SymNode_t				*ParmList;
			SymNode_t				*s;
			SymNode_t				*sym;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			CurOffset = (yyvsp[(3) - (13)].v.u.unsval);
			CurOffsetDir = (yyvsp[(4) - (13)].v.u.unsval);
			
			/*
			** Enter the optional "returns" value into the symbol table.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.returns = (yyvsp[(9) - (13)].options.returns);
			(yyvsp[(7) - (13)].en.s)->u.proc.use = (yyvsp[(9) - (13)].options.use);
			
			
			// Always use pascal calling sequence for class stuff:
			
			(yyvsp[(7) - (13)].en.s)->u.proc.cs = pascal_cs;
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.cs = pascal_cs;

			CheckLegalOptions
			( 
				(yyvsp[(9) - (13)].options.SpecifiedOptions),
					specified_returns
				|	specified_use
			);

			/*
			** Save a pointer to this procedure's class' symbol
			** table entry for later reference:
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.BaseClass = ClassPtr;

			/*
			** EnterName entered this symbol as a "cProc" object.
			** It really needs to be a "cClassProc" and "tClassProc"
			** object since it is a static procedure in a class.
			** Handle that change here.
			*/

			(yyvsp[(7) - (13)].en.s)->SymClass = cClassProc;
			(yyvsp[(7) - (13)].en.s)->pType = tClassProc;
			(yyvsp[(7) - (13)].en.s)->Type = &classprocID_ste;


			/*
			** Patch the local symbol table entry's proc.parms
			** field first, then store the address of the start
			** of parameters into the main symbol table entry
			** for this procedure.
			*/


			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (13)].options.returns);
			(yyvsp[(7) - (13)].en.s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (13)].options.use);
			

			/*
			** Mark the end of the parameter list.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.parms = SymbolTable;

			/*
			** Create a symbol table entry for the # of bytes
			** of parameters in this procedure.
			*/

			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.u.unsval = (yyvsp[(8) - (13)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.Forward = SymbolTable;


			/*
			** It is also external, deal with that here.
			*/

			(yyvsp[(7) - (13)].en.s)->IsExternal = 1;

			free2( vss (yyvsp[(7) - (13)].en.s)->StaticName );
			(yyvsp[(7) - (13)].en.s)->StaticName = (yyvsp[(12) - (13)].idStr);
			sym = lookupin( (yyvsp[(7) - (13)].en.s)->TrueName, (yyvsp[(7) - (13)].en.s)->u.proc.parms );
			_if( sym != NULL )

				//free2( vss sym->StaticName ); not a unique ptr!
				sym->StaticName = hlastrdup2( (yyvsp[(12) - (13)].idStr) );

			_endif


			/*
			** Remove this procedure's parameters from
			** further consideration in the symbol table
			** (of course, there are no local symbols for
			** class procedure declarations, but we still have to
			** point proc.Locals at the parameters, if any).
			**
			** NULL terminate the local symbols.
			*/

			(yyvsp[(7) - (13)].en.s)->u.proc.Locals = SymbolTable;

			ParmList = SymbolTable;
			_while( ParmList->Next != (yyvsp[(7) - (13)].en.s) && ParmList->Next != NULL )

				ParmList = ParmList->Next;
				//assert( ParmList != NULL );

			_endwhile
			ParmList->Next = NULL;
			
			// Create a type for the parameter list.
			
			s =
				InsertSym
				( 
					" (classproc parms) ", 
					NULL,
					tMethod, 
					cMethod, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
			
			s->u.proc.parms = (yyvsp[(7) - (13)].en.s)->u.proc.parms;
			s->u.proc.returns = (yyvsp[(7) - (13)].en.s)->u.proc.returns;
			s->u.proc.use = (yyvsp[(7) - (13)].en.s)->u.proc.use;
			s->u.proc.cs = (yyvsp[(7) - (13)].en.s)->u.proc.cs;
			(yyvsp[(7) - (13)].en.s)->Type = s;
			SymbolTable = (yyvsp[(7) - (13)].en.s);
			

			/*
			** Add this (static) class procedure to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = SymbolTable;
			ml->LexLevel = CurLexLevel;
			CurrentContext = (yyvsp[(5) - (13)].s);
			CurLexLevel = (yyvsp[(6) - (13)].v.u.intval);

			/*
			** Output an externdef directive to keep MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(7) - (13)].en.s), (yyvsp[(7) - (13)].en.s)->StaticName, tLabel );
			
			/*
			** Restore currentNS:
			*/
			
			currentNS = (yyvsp[(7) - (13)].en.cns);
			(void) (yyvsp[(11) - (13)].idStr);	//shut up bison
			_here;
		;}
    break;

  case 822:

/* Line 1464 of yacc.c  */
#line 38508 "hlaparse.bsn"
    {				/* $8 */

			union YYSTYPE v;

			_here;
			assert( (yyvsp[(1) - (7)].idStr) != NULL );
			assert( (yyvsp[(5) - (7)].idStr) != NULL );

			v.v.u.strval = (yyvsp[(1) - (7)].idStr);
			InsertSym
			( 
				(yyvsp[(5) - (7)].idStr), 
				&text_ste,
				tText, 
				cConstant, 
				0,				/* arity 			*/
				NULL,			/* NumDimensions	*/
				0, 				/* NumElements		*/
				YYS &v,
				4,				/* ObjectSize		*/
				0,
				NULL,
				NULL,			/* Base				*/
				NULL,			/* Fields			*/
				0				/* FieldCnt			*/ 
			);

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;
		;}
    break;

  case 823:

/* Line 1464 of yacc.c  */
#line 38568 "hlaparse.bsn"
    {					/* $5 */

			struct	MethodListType	*ml;
			char					StaticName[ 256 ];


			_here;
			
			/*
			** Verify that the lex level of the original procedure
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(3) - (4)].s)->LexLevel != (yyvsp[(0) - (4)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden procedure does not match\n"
					"the lex level of the original procedure"
				);

			_endif


			/*
			** Change the symbol's static ID at this point.
			*/

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(3) - (4)].s)->TrueName, LblCntr++ );
			(yyvsp[(3) - (4)].s)->StaticName = hlastrdup2( StaticName );

			/*
			** Make sure this isn't treated as an external declaration.
			*/

			(yyvsp[(3) - (4)].s)->IsExternal = 0;


			/*
			** Save a pointer to this procedure's class' symbol
			** table entry for later reference:
			*/

			(yyvsp[(3) - (4)].s)->u.proc.BaseClass = ClassPtr;

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(3) - (4)].s)->u.proc.Forward = (yyvsp[(3) - (4)].s); /* Any non-NULL value works */


			/*
			** Add this (static) class procedure to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(3) - (4)].s);
			ml->LexLevel = CurLexLevel;

			_here;
		;}
    break;

  case 824:

/* Line 1464 of yacc.c  */
#line 38647 "hlaparse.bsn"
    {					/* $4  */

			struct	MethodListType	*ml;
			char					StaticName[ 256 ];


			_here;
			
			/*
			** Verify that the lex level of the original procedure
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(1) - (3)].s)->LexLevel != (yyvsp[(0) - (3)].v.u.intval) )
			
				char msg[256];

				sprintf
				( 
					msg,
					"Lex level of overriden procedure (%d) does not match\n"
					"the lex level of the original procedure (%d)",
					(yyvsp[(1) - (3)].s)->LexLevel,
					(yyvsp[(0) - (3)].v.u.intval)
				);
				yyerror( msg );

			_endif


			/*
			** Change the symbol's static ID at this point.
			*/

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (3)].s)->TrueName, LblCntr++ );
			(yyvsp[(1) - (3)].s)->StaticName = hlastrdup2( StaticName );

			/*
			** Make sure this isn't treated as an external declaration.
			*/

			(yyvsp[(1) - (3)].s)->IsExternal = 0;


			/*
			** Save a pointer to this procedure's class' symbol
			** table entry for later reference:
			*/

			(yyvsp[(1) - (3)].s)->u.proc.BaseClass = ClassPtr;

			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(1) - (3)].s)->u.proc.Forward = (yyvsp[(1) - (3)].s); /* Any non-NULL value works */


			/*
			** Add this (static) class procedure to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(1) - (3)].s);
			ml->LexLevel = CurLexLevel;

			_here;
		;}
    break;

  case 825:

/* Line 1464 of yacc.c  */
#line 38738 "hlaparse.bsn"
    {							/* $6 */ 

			char DefaultName[ 256 ];

			_here;
			
			/*
			** Verify that the lex level of the original procedure
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(3) - (5)].s)->LexLevel != (yyvsp[(0) - (5)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden procedure does not match\n"
					"the lex level of the original procedure"
				);

			_endif

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <procname>
			*/
			
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(3) - (5)].s)->TrueName );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 826:

/* Line 1464 of yacc.c  */
#line 38774 "hlaparse.bsn"
    {							/* $8 */

			SymNode_t				*ParmList;
			SymNode_t				*sym;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			
			/*
			** Save a pointer to this procedure's class' symbol
			** table entry for later reference:
			*/

			(yyvsp[(3) - (7)].s)->u.proc.BaseClass = ClassPtr;


					 
			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(3) - (7)].s)->u.proc.Forward = (yyvsp[(3) - (7)].s); /* Any non-null item works here */


			/*
			** It is also external, deal with that here.
			*/

			(yyvsp[(3) - (7)].s)->IsExternal = 1;

			free2( vss (yyvsp[(3) - (7)].s)->StaticName );
			(yyvsp[(3) - (7)].s)->StaticName = (yyvsp[(7) - (7)].idStr);
			sym = lookupin( (yyvsp[(3) - (7)].s)->TrueName, (yyvsp[(3) - (7)].s)->u.proc.parms );
			_if( sym != NULL )


				//free2( vss sym->StaticName ); not a unique ptr!
				sym->StaticName = hlastrdup2( (yyvsp[(7) - (7)].idStr) );

			_endif



			/*
			** Add this (static) class procedure to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(3) - (7)].s);
			ml->LexLevel = CurLexLevel;

			/*
			** Output an externdef directive to keep MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(3) - (7)].s), (yyvsp[(3) - (7)].s)->StaticName, tLabel );
			(void) (yyvsp[(6) - (7)].idStr); // shut up bison
			_here;
		;}
    break;

  case 827:

/* Line 1464 of yacc.c  */
#line 38858 "hlaparse.bsn"
    {							/* $5 */ 

			char DefaultName[ 256 ];

			_here;
			
			/*
			** Verify that the lex level of the original procedure
			** is the same as the current lex level (provided by $0).
			*/

			_if( (yyvsp[(1) - (4)].s)->LexLevel != (yyvsp[(0) - (4)].v.u.intval) )

				yyerror
				( 
					"Lex level of overriden procedure does not match\n"
					"the lex level of the original procedure"
				);

			_endif

			/*
			** We need to pass the default external name to the
			** OptionalExtName production to use if there is no
			** external name explicitly supplied.  The default
			** name is:
			**
			**	<classname> + "_" + <procname>
			*/
			
			strcpy( DefaultName, ClassPtr->TrueName );
			strcat( DefaultName, "_" );
			strcat( DefaultName, (yyvsp[(1) - (4)].s)->TrueName );
			(yyval.idStr) = hlastrdup2( DefaultName ); 
		;}
    break;

  case 828:

/* Line 1464 of yacc.c  */
#line 38895 "hlaparse.bsn"
    {							/* $8 */

			SymNode_t				*ParmList;
			SymNode_t				*sym;
			struct MethodListType	*ml;
			char					*CurrentType;
			SymNode_t				value;


			_here;
			
			/*
			** Save a pointer to this procedure's class' symbol
			** table entry for later reference:
			*/

			(yyvsp[(1) - (7)].s)->u.proc.BaseClass = ClassPtr;


					 
			/*
			** This is a forward procedure, so mark it as such
			** in the symbol table.
			*/

			(yyvsp[(1) - (7)].s)->u.proc.Forward = (yyvsp[(1) - (7)].s); /* Any non-null item works here */


			/*
			** It is also external, deal with that here.
			*/

			(yyvsp[(1) - (7)].s)->IsExternal = 1;

			free2( vss (yyvsp[(1) - (7)].s)->StaticName );
			(yyvsp[(1) - (7)].s)->StaticName = (yyvsp[(6) - (7)].idStr);
			sym = lookupin( (yyvsp[(1) - (7)].s)->TrueName, (yyvsp[(1) - (7)].s)->u.proc.parms );
			_if( sym != NULL )


				//free2( vss sym->StaticName ); not a unique ptr!
				sym->StaticName = hlastrdup2( (yyvsp[(6) - (7)].idStr) );

			_endif



			/*
			** Add this (static) class procedure to the
			** Method List so we can check later to see
			** if it has been properly defined.
			*/

			ml = malloc2( sizeofMethodListType );
			ml->Next = MethodList;
			MethodList = ml;

			ml->ClassSym = ClassPtr;
			ml->MethodSym = (yyvsp[(1) - (7)].s);
			ml->LexLevel = CurLexLevel;

			/*
			** Output an externdef directive to keep MASM happy.
			*/

			EmitTypedExtern( (yyvsp[(1) - (7)].s), (yyvsp[(1) - (7)].s)->StaticName, tLabel );
			(void) (yyvsp[(5) - (7)].idStr); // shut up bison
			_here;
		;}
    break;

  case 829:

/* Line 1464 of yacc.c  */
#line 38994 "hlaparse.bsn"
    {
			SymNode_t *s;

			/*
			** Symbol table points at the local symbols,
			** locate the last item in that list and point
			** it's NEXT field at $<s>0.
			*/

			_here;
			s = SymbolTable;
			assert( s != NULL );
			_while( s->Next != NULL )

				s = s->Next;

			_endwhile

			(yyval.s) = s;
			s->Next = (yyvsp[(0) - (0)].s);
		;}
    break;

  case 830:

/* Line 1464 of yacc.c  */
#line 39035 "hlaparse.bsn"
    {
			char msg[ 256 ];

			_here;
			(yyval.v.u.intval) = 0;
			assert( (yyvsp[(0) - (1)].s) != NULL );


			_if( (yyvsp[(0) - (1)].s)->u.proc.parms == NULL )

				/*
				** 5/3/2000- Not sure what triggers this case. RLH.
				*/

				yyerror( "Parameters do not match original declaration" );


			/*
			** Check to see if there should have been a parameter here.
			*/

			_elseif( (yyvsp[(0) - (1)].s)->u.proc.ParmSize != 0 )

				sprintf
				(
					msg,
					"Missing parameter \"%s\" found in fwd/extern definition",
					(yyvsp[(0) - (1)].s)->u.proc.parms->TrueName
				);
				yyerror( msg );
				
				// Continuing may crash the program. So quit:
				
				exit( 1 );

			_endif
		;}
    break;

  case 831:

/* Line 1464 of yacc.c  */
#line 39081 "hlaparse.bsn"
    {	
			/*
			** Pass a pointer to the parameter symbols to the
			** MatchOneOrMoreParms code.
			*/

			_here;
			(yyval.s) = (yyvsp[(0) - (1)].s)->u.proc.parms;
			++CurLexLevel;
			parmLookup = 1;
			fastLookup = 1;	
		;}
    break;

  case 832:

/* Line 1464 of yacc.c  */
#line 39095 "hlaparse.bsn"
    {
			char msg[ 256 ];

			/*
			** Okay, the very last entry in the procedure's local
			** symbol table is a duplicate entry for the procedure
			** itself.  This entry will not be of class "cParm".
			** If the current entry is of class cParm, then there
			** are an insufficient number of parameters in the
			** current declaration.
			*/

			_here;
			_if( (yyvsp[(3) - (4)].s)->SymClass == cParm )

				sprintf
				(
					msg,
					"Parameter list is missing \"%s\" found in fwd/extern " 
					"definition",
					(yyvsp[(3) - (4)].s)->TrueName
				);
				yyerror
				( 
					msg
				);

			_endif
			--CurLexLevel;
			parmLookup = 0;
			fastLookup = 0;
			(void) (yyvsp[(2) - (4)].s);	//shut up bison
			_here;	
		;}
    break;

  case 833:

/* Line 1464 of yacc.c  */
#line 39142 "hlaparse.bsn"
    { 
			char msg[ 256 ];

			_here;
			assert( (yyvsp[(-3) - (0)].neID.idStr) != NULL );
			assert( (yyvsp[(-5) - (0)].s) != NULL );


			(yyval.s) = (yyvsp[(-5) - (0)].s);	/* Just in case there is an error */

			/*
			** Be sure the forward definition wasn't a procedural
			** paramter.
			*/

			_if(  (yyvsp[(-5) - (0)].s)->Type == NULL )

				/*
				** This occurs if the declared parameter is
				** a procedure parameter but the forward parameter was not.
				*/
				
				sprintf
				(
					msg,
					"Parameter \"%s\" was not a procedure parameter in "
					"the original\n"
					"definition (may have been a type symbol"
					"that is indirectly a\n"
					"procedure type, though)",
					(yyvsp[(-3) - (0)].neID.idStr)
				);
				yyerror( msg );

			
			
				/*
				** Next, make sure the object is an actual parameter
				** in the original declaration.
				*/

			_elseif( (yyvsp[(-5) - (0)].s)->SymClass != cParm )

				sprintf
				(
					msg,
					"Parameter \"%s\" is not present in original definition",
					(yyvsp[(-3) - (0)].neID.idStr)
				);
				yyerror
				(
					msg
				);

			_else /* This is a parameter */
			

				/*
				** Make sure the two parameters were passed the same
				** way (e.g., pass by reference).
				*/

				_if( (yyvsp[(-4) - (0)].v.pClass) != (yyvsp[(-5) - (0)].s)->pClass )

					yyerror
					(
						"Parameter classes must agree (e.g., pass by value,\n"
						"pass by reference, etc.) with original declaration"
					);


				/*
				** Be sure the names are identical.
				*/

				_elseif( _strne( (yyvsp[(-3) - (0)].neID.idStr), (yyvsp[(-5) - (0)].s)->TrueName ))

				 	sprintf
					(
						msg,
						"Identifier \"%s\" must be identical to "
						" declaration \"%s\"",
						(yyvsp[(-3) - (0)].neID.idStr),
						(yyvsp[(-5) - (0)].s)->TrueName
					);
					yyerror( msg );

				/*
				** Be sure their types are identical
				*/

				_elseif( (yyvsp[(-5) - (0)].s)->Type != (yyvsp[(-1) - (0)].s) )

					sprintf
					(
						msg,
						"Type (%s:%s) must match original "
						"declaration (%s:%s)",
						(yyvsp[(-3) - (0)].neID.idStr),
						(yyvsp[(-1) - (0)].s)->TrueName,
						(yyvsp[(-5) - (0)].s)->TrueName,
						(yyvsp[(-5) - (0)].s)->Type->TrueName
					);
					yyerror( msg );



				/*
				** If the StaticName field is non-NULL, then we
				** have a register parameter (e.g., "in <reg>" was
				** used).
				*/

				_elseif( (yyvsp[(-5) - (0)].s)->StaticName != NULL )

					/*
					** Make sure the current declaration also
					** specifies a register parameter.
					*/

					_if( (yyvsp[(0) - (0)].idStr) == NULL )

						sprintf
						(
							msg,
							"Original parameter declaration was in register %s",
							(yyvsp[(-5) - (0)].s)->StaticName
						);
						yyerror( msg );


					/*
					** Make sure the current declaration specifies
					** the same register.
					*/

					_elseif( _strne( (yyvsp[(0) - (0)].idStr), (yyvsp[(-5) - (0)].s)->StaticName ))

						sprintf
						(
							msg,
							"IN <reg> declarations must be the same "
							"(%s vs. %s [fwd])",
							(yyvsp[(0) - (0)].idStr),
							(yyvsp[(-5) - (0)].s)->StaticName
						);
						yyerror( msg );

					_endif


				/*
				** If the current declaration is a register parameter
				** but the original (forward) definition wasn't, print
				** the appropriate message.
				*/

				_elseif( (yyvsp[(0) - (0)].idStr) != NULL )

					sprintf
					(
						msg,
						"Original parameter declaration wasn't specified "
						"in a register (%s)",
						(yyvsp[(0) - (0)].idStr)
					);
					yyerror( msg );

				_endif
				(yyval.s) = (yyvsp[(-5) - (0)].s)->Next;

			_endif
		;}
    break;

  case 834:

/* Line 1464 of yacc.c  */
#line 39324 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = NULL;
		;}
    break;

  case 835:

/* Line 1464 of yacc.c  */
#line 39331 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = regStrs[ (yyvsp[(2) - (2)].reg.encoding) ];
		;}
    break;

  case 836:

/* Line 1464 of yacc.c  */
#line 39360 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(6) - (6)].s);
		;}
    break;

  case 837:

/* Line 1464 of yacc.c  */
#line 39384 "hlaparse.bsn"
    {						/* $8 */ 

			/*
			** Pass a pointer to the next symbol table entry
			** (appearing in the original declaration) to the
			** MatchOneOrMoreParms production.
			*/

			_here;
			(yyval.s) = (yyvsp[(6) - (7)].s);	
		;}
    break;

  case 838:

/* Line 1464 of yacc.c  */
#line 39396 "hlaparse.bsn"
    {						/* $10 */

			/*
			** Return the pointer to the last symbol appearing the
			** the parameter list of the original definition.
			*/

			_here;
			(void) (yyvsp[(8) - (9)].s);	//shut up bison
			(yyval.s) = (yyvsp[(9) - (9)].s);
		;}
    break;

  case 839:

/* Line 1464 of yacc.c  */
#line 39413 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &variant_ste;
		;}
    break;

  case 840:

/* Line 1464 of yacc.c  */
#line 39428 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(6) - (6)].s);
		;}
    break;

  case 841:

/* Line 1464 of yacc.c  */
#line 39443 "hlaparse.bsn"
    {						/* $8 */ 

			/*
			** Pass a pointer to the next symbol table entry
			** (appearing in the original declaration) to the
			** MatchOneOrMoreParms production.
			*/

			_here;
			(yyval.s) = (yyvsp[(6) - (7)].s);	
		;}
    break;

  case 842:

/* Line 1464 of yacc.c  */
#line 39455 "hlaparse.bsn"
    {						/* $10 */

			/*
			** Return the pointer to the last symbol appearing the
			** the parameter list of the original definition.
			*/

			_here;
			(void) (yyvsp[(8) - (9)].s);	//shut up bison
			(yyval.s) = (yyvsp[(9) - (9)].s);
		;}
    break;

  case 843:

/* Line 1464 of yacc.c  */
#line 39477 "hlaparse.bsn"
    {								/* $7 */
			char msg[ 256 ];

			_here;
			assert( (yyvsp[(-4) - (0)].neID.idStr) != NULL );
			assert( (yyvsp[(-6) - (0)].s) != NULL );

			(yyval.s) = (yyvsp[(-6) - (0)].s);	/* Just in case there is an error */

			/*
			** Be sure this parameter is actually present in the
			** original declaration.
			*/

			_if( (yyvsp[(-6) - (0)].s)->SymClass != cParm )

				sprintf
				(
					msg,
					"\"%s\" appears to be an extra parameter",
					(yyvsp[(-4) - (0)].neID.idStr)
				);
				yyerror
				(
					msg
				);

			_else /* This is a parameter */
			
				/*
				** Be sure this parameter was passed the same way
				** as in the original declaration.
				*/

				_if( (yyvsp[(-5) - (0)].v.pClass) != (yyvsp[(-6) - (0)].s)->pClass )

					yyerror
					(
						"Parameter classes must agree (e.g., pass by value,\n"
						"pass by reference, etc.) with original declaration"
					);

				/*
				** Be sure this parameter has the same name as in the
				** original declaration.
				*/

				_elseif( _strne( (yyvsp[(-4) - (0)].neID.idStr), (yyvsp[(-6) - (0)].s)->TrueName ))

				 	sprintf
					(
						msg,
						"Identifier (%s) must match original declaration (%s)",
						(yyvsp[(-4) - (0)].neID.idStr),
						(yyvsp[(-6) - (0)].s)->TrueName
					);
					yyerror( msg );

				
				// Be sure the original parameter was a procedural parameter.
				

				_elseif( (yyvsp[(-6) - (0)].s)->pType != tProcptr )

					sprintf
					(
						msg,
						"\"%s\" cannot be a procedure parameter",
						(yyvsp[(-4) - (0)].neID.idStr)
					);
					yyerror( msg );

				_endif
				(yyval.s) = (yyvsp[(-6) - (0)].s)->Next;

			_endif
			_here;
		;}
    break;

  case 844:

/* Line 1464 of yacc.c  */
#line 39573 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(7) - (7)].s);
		;}
    break;

  case 845:

/* Line 1464 of yacc.c  */
#line 39599 "hlaparse.bsn"
    {						/* $9 */
			/*
			** Pass the address of the entry for the
			** next (original) parameter on to the
			** MatchOneOrMoreParms production.
			*/

			_here;
			(yyval.s) = (yyvsp[(7) - (8)].s);	
		;}
    break;

  case 846:

/* Line 1464 of yacc.c  */
#line 39610 "hlaparse.bsn"
    {						/* $11 */
			/*
			** Return the address of the last parameter
			** to the MatchParms production.
			*/

 			_here;
			(void) (yyvsp[(9) - (10)].s);	//shut up bison
			(yyval.s) = (yyvsp[(10) - (10)].s);
		;}
    break;

  case 847:

/* Line 1464 of yacc.c  */
#line 39625 "hlaparse.bsn"
    { 
			_here;
			_if( (yyvsp[(-4) - (0)].s)->pType == tProcptr )
			
				// If the parameter is a procedure pointer,
				// return a pointer to the parameter list
				// (Note that we must skip the dummy procedure
				// entry at the start of the list).
				
				_if( (yyvsp[(-4) - (0)].s)->Type != NULL )
				
					// If the type field is non-NULL, then
					// this is a procedure parameter that was
					// specified by some type name.  So grab
					// the parameter list from the type's proc.parms
					// pointer.
					
					assert( (yyvsp[(-4) - (0)].s)->Type->u.proc.parms != NULL );
					(yyval.s) = (yyvsp[(-4) - (0)].s)->Type->u.proc.parms->Next;
					
				_else
				
					// If the type field is NULL, then this is
					// a procedure parameter declared directly as
					// a procedure object in the parameter list.
					// Extract the parameter pointer directly from
					// the current object.
					
					(yyval.s) = (yyvsp[(-4) - (0)].s)->u.proc.parms->Next;
					
				_endif
				
			_else
			
				// If the parameter is not a procedure pointer,
				// just return a pointer to its type.
				
				(yyval.s) = (yyvsp[(-4) - (0)].s);
				
			_endif
			assert( (yyval.s) != NULL );
		;}
    break;

  case 848:

/* Line 1464 of yacc.c  */
#line 39678 "hlaparse.bsn"
    { _here; (yyval.idStr) = (yyvsp[(0) - (1)].idStr); ;}
    break;

  case 849:

/* Line 1464 of yacc.c  */
#line 39681 "hlaparse.bsn"
    {
				_here;
				_if
				( 
						(yyvsp[(2) - (3)].v.pType) != tString 
					&&	(yyvsp[(2) - (3)].v.pType) != tZString 
				)

					yyerror( "Expected string type for external name" );
					(yyval.idStr) = (yyvsp[(0) - (3)].idStr);

				_else

					(yyval.idStr) = hlastrdup2( (yyvsp[(2) - (3)].v.u.strval) );
					free2( vss (yyvsp[(0) - (3)].idStr) );
					FreeValue( YYS &(yyvsp[(2) - (3)].v) );

				_endif
			;}
    break;

  case 850:

/* Line 1464 of yacc.c  */
#line 39705 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = "eax";
		;}
    break;

  case 851:

/* Line 1464 of yacc.c  */
#line 39711 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = "ebx";
		;}
    break;

  case 852:

/* Line 1464 of yacc.c  */
#line 39717 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = "ecx";
		;}
    break;

  case 853:

/* Line 1464 of yacc.c  */
#line 39723 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = "edx";
		;}
    break;

  case 854:

/* Line 1464 of yacc.c  */
#line 39729 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = "esi";
		;}
    break;

  case 855:

/* Line 1464 of yacc.c  */
#line 39735 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = "edi";
		;}
    break;

  case 856:

/* Line 1464 of yacc.c  */
#line 39760 "hlaparse.bsn"
    {
			_here;
			(yyval.options.returns) = hlastrdup2( "" );
			(yyval.options.use) = NULL;
			(yyval.options.SpecifiedOptions) = 0;
			(yyval.options.UseFrame) = FrameDefault;
			(yyval.options.UseDisplay) = DisplayDefault;
			(yyval.options.AlignStk) = AlignStackDefault;
			(yyval.options.Alignment) = AlignDefault;
			(yyval.options.NoEnter) = EnterDefault;
			(yyval.options.NoLeave) = LeaveDefault;
			(yyval.options.CallingSequence) = pascal_cs;
			(yyval.options.NoStorage) = 0;
			(yyval.options.IsVolatile) = 0;
		;}
    break;

  case 857:

/* Line 1464 of yacc.c  */
#line 39784 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (6)].options);
			free2( vss (yyvsp[(1) - (6)].options.returns) );
			_if
			( 
					(yyvsp[(4) - (6)].v.pType) != tString 
				&&	(yyvsp[(4) - (6)].v.pType) != tZString 
			)

				yyerror( "Expected string type for 'returns' value" );
				(yyval.options.returns) = hlastrdup2( "" );

			_else

				(yyval.options.returns) = hlastrdup2( (yyvsp[(4) - (6)].v.u.strval) );

			_endif
			FreeValue( YYS &(yyvsp[(4) - (6)].v) );

			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (6)].options.SpecifiedOptions) | specified_returns;

		;}
    break;

  case 858:

/* Line 1464 of yacc.c  */
#line 39815 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (4)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (4)].options.SpecifiedOptions) | specified_use;
			(yyval.options.use) = (yyvsp[(3) - (4)].idStr);
		;}
    break;

  case 859:

/* Line 1464 of yacc.c  */
#line 39828 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_noframe;
			(yyval.options.UseFrame) = 0;
		;}
    break;

  case 860:

/* Line 1464 of yacc.c  */
#line 39841 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_noframe;
			(yyval.options.UseFrame) = 1;
		;}
    break;

  case 861:

/* Line 1464 of yacc.c  */
#line 39854 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_nodisplay;
			(yyval.options.UseDisplay) = 0;
		;}
    break;

  case 862:

/* Line 1464 of yacc.c  */
#line 39867 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_nodisplay;
			(yyval.options.UseDisplay) = 1;
		;}
    break;

  case 863:

/* Line 1464 of yacc.c  */
#line 39880 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_noalignstk;
			(yyval.options.AlignStk) = 0;
		;}
    break;

  case 864:

/* Line 1464 of yacc.c  */
#line 39893 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_noalignstk;
			(yyval.options.AlignStk) = 1;
		;}
    break;

  case 865:

/* Line 1464 of yacc.c  */
#line 39906 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_noenter;
			(yyval.options.NoEnter) = 1;
		;}
    break;

  case 866:

/* Line 1464 of yacc.c  */
#line 39919 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_noenter;

			(yyval.options.NoEnter) = 0;
		;}
    break;

  case 867:

/* Line 1464 of yacc.c  */
#line 39933 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_noleave;

			(yyval.options.NoLeave) = 1;
		;}
    break;

  case 868:

/* Line 1464 of yacc.c  */
#line 39947 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_noleave;
			(yyval.options.NoLeave) = 0;
		;}
    break;

  case 869:

/* Line 1464 of yacc.c  */
#line 39960 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.CallingSequence) = pascal_cs;

			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_pascal;

		;}
    break;

  case 870:

/* Line 1464 of yacc.c  */
#line 39975 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.CallingSequence) = stdcall_cs;

			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_stdcall;

		;}
    break;

  case 871:

/* Line 1464 of yacc.c  */
#line 39990 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.CallingSequence) = cdecl_cs;

			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_cdecl;

		;}
    break;

  case 872:

/* Line 1464 of yacc.c  */
#line 40009 "hlaparse.bsn"
    {				/* $7 */

			_here;
			(yyval.options) = (yyvsp[(1) - (6)].options);
			(yyval.options.SpecifiedOptions) = 
				(yyval.options.SpecifiedOptions) | specified_alignment;

			_if( IsNumber( (yyvsp[(4) - (6)].v.pType) ) && numBits( YYS &(yyvsp[(4) - (6)].v)) <= 32 )

				_if
				(
						assembler == fasm
					&&	(yyvsp[(4) - (6)].v.u.unsval) != 1
					&&	(yyvsp[(4) - (6)].v.u.unsval) != 2
					&&	(yyvsp[(4) - (6)].v.u.unsval) != 4
					&&	(yyvsp[(4) - (6)].v.u.unsval) != 8
					&&	(yyvsp[(4) - (6)].v.u.unsval) != 16
				)
				
					yyerror
					( 
						"FASM output supports only 1, 2, 4, 8, and 16 "
						"as alignment values" 
					);
				
					
				_endif
				(yyval.options.Alignment) = (yyvsp[(4) - (6)].v.u.unsval);

			_else

				yyerror
				( 
					"Expected an integer constant here" 
				);
				(yyval.options.Alignment) = 1;

			_endif
			FreeValue( YYS &(yyvsp[(4) - (6)].v) );
			_here;
		;}
    break;

  case 873:

/* Line 1464 of yacc.c  */
#line 40055 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.NoStorage) = 1;
		;}
    break;

  case 874:

/* Line 1464 of yacc.c  */
#line 40065 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.IsVolatile) = 1;
		;}
    break;

  case 875:

/* Line 1464 of yacc.c  */
#line 40079 "hlaparse.bsn"
    {
			_here;
			(yyval.options.returns) = hlastrdup2( "" );
			(yyval.options.use) = NULL;
			(yyval.options.SpecifiedOptions) = 0;
			(yyval.options.UseFrame) = FrameDefault;
			(yyval.options.UseDisplay) = DisplayDefault;
			(yyval.options.AlignStk) = AlignStackDefault;
			(yyval.options.Alignment) = AlignDefault;
			(yyval.options.NoEnter) = EnterDefault;
			(yyval.options.NoLeave) = LeaveDefault;
			(yyval.options.CallingSequence) = pascal_cs;
			(yyval.options.NoStorage) = (yyvsp[(1) - (1)].options.NoStorage);
			(yyval.options.IsVolatile) = (yyvsp[(1) - (1)].options.IsVolatile);
		;}
    break;

  case 876:

/* Line 1464 of yacc.c  */
#line 40101 "hlaparse.bsn"
    {
				_here;
				(yyval.options) = (yyvsp[(2) - (4)].options);
			;}
    break;

  case 877:

/* Line 1464 of yacc.c  */
#line 40115 "hlaparse.bsn"
    {
				_here;
				(yyval.options) = (yyvsp[(2) - (3)].options);
			;}
    break;

  case 878:

/* Line 1464 of yacc.c  */
#line 40127 "hlaparse.bsn"
    {
			_here;
			(yyval.options.returns) = hlastrdup2( "" );
			(yyval.options.use) = NULL;
			(yyval.options.SpecifiedOptions) = 0;
			(yyval.options.UseFrame) = FrameDefault;
			(yyval.options.UseDisplay) = DisplayDefault;
			(yyval.options.AlignStk) = AlignStackDefault;
			(yyval.options.Alignment) = AlignDefault;
			(yyval.options.NoEnter) = EnterDefault;
			(yyval.options.NoLeave) = LeaveDefault;
			(yyval.options.CallingSequence) = pascal_cs;
			(yyval.options.NoStorage) = 0;
			(yyval.options.IsVolatile) = 0;
		;}
    break;

  case 879:

/* Line 1464 of yacc.c  */
#line 40145 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
		;}
    break;

  case 880:

/* Line 1464 of yacc.c  */
#line 40155 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (5)].options);
			free2( vss (yyvsp[(1) - (5)].options.returns) );
			_if
			( 
					(yyvsp[(4) - (5)].v.pType) != tString 
				&&	(yyvsp[(4) - (5)].v.pType) != tZString 
			)

				yyerror( "Expected string type for 'returns' value" );
				(yyval.options.returns) = hlastrdup2( "" );

			_else

				(yyval.options.returns) = hlastrdup2( (yyvsp[(4) - (5)].v.u.strval) );

			_endif
			FreeValue( YYS &(yyvsp[(4) - (5)].v) );

			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (5)].options.SpecifiedOptions) | specified_returns;
			_here;
		;}
    break;

  case 881:

/* Line 1464 of yacc.c  */
#line 40183 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (3)].options);
			(yyval.options.use) = (yyvsp[(3) - (3)].idStr);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (3)].options.SpecifiedOptions) | specified_use;
		;}
    break;

  case 882:

/* Line 1464 of yacc.c  */
#line 40195 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.UseFrame) = 0;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_noframe;
		;}
    break;

  case 883:

/* Line 1464 of yacc.c  */
#line 40204 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_noframe;
			(yyval.options.UseFrame) = 1;
		;}
    break;

  case 884:

/* Line 1464 of yacc.c  */
#line 40213 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.UseDisplay) = 0;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_nodisplay;

		;}
    break;

  case 885:

/* Line 1464 of yacc.c  */
#line 40224 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.UseDisplay) = 1;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_nodisplay;

		;}
    break;

  case 886:

/* Line 1464 of yacc.c  */
#line 40235 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.AlignStk) = 0;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_noalignstk;

		;}
    break;

  case 887:

/* Line 1464 of yacc.c  */
#line 40245 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.AlignStk) = 1;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_noalignstk;

		;}
    break;

  case 888:

/* Line 1464 of yacc.c  */
#line 40256 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.NoEnter) = 1;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_noenter;

		;}
    break;

  case 889:

/* Line 1464 of yacc.c  */
#line 40267 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.NoEnter) = 0;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_noenter;

		;}
    break;

  case 890:

/* Line 1464 of yacc.c  */
#line 40278 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.NoLeave) = 1;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_noleave;

		;}
    break;

  case 891:

/* Line 1464 of yacc.c  */
#line 40289 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.NoLeave) = 0;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_noleave;

		;}
    break;

  case 892:

/* Line 1464 of yacc.c  */
#line 40300 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.CallingSequence) = pascal_cs;

			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_pascal;

		;}
    break;

  case 893:

/* Line 1464 of yacc.c  */
#line 40312 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.CallingSequence) = stdcall_cs;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_stdcall;

		;}
    break;

  case 894:

/* Line 1464 of yacc.c  */
#line 40323 "hlaparse.bsn"
    {

			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.CallingSequence) = cdecl_cs;
			(yyval.options.SpecifiedOptions) =
				(yyvsp[(1) - (2)].options.SpecifiedOptions) | specified_cdecl;

		;}
    break;

  case 895:

/* Line 1464 of yacc.c  */
#line 40338 "hlaparse.bsn"
    {				/* $6 */

			_here;
			(yyval.options) = (yyvsp[(1) - (5)].options);
			(yyval.options.SpecifiedOptions) = 
				(yyval.options.SpecifiedOptions) | specified_alignment;

			_if( IsNumber( (yyvsp[(4) - (5)].v.pType) ) )

				_if
				(
					(yyvsp[(4) - (5)].v.u.unsval) != 1
					&&	(yyvsp[(4) - (5)].v.u.unsval) != 2
					&&	(yyvsp[(4) - (5)].v.u.unsval) != 4
					&&	(yyvsp[(4) - (5)].v.u.unsval) != 8
					&&	(yyvsp[(4) - (5)].v.u.unsval) != 16
				)
				
					yyerror
					( 
						"HLA supports only 1, 2, 4, 8, and 16 "
						"as alignment values" 
					);
				
					
				_endif
				(yyval.options.Alignment) = (yyvsp[(4) - (5)].v.u.unsval);

			_else

				yyerror
				( 
					"Expected an integer constant here" 
				);
				(yyval.options.Alignment) = 1;

			_endif
			FreeValue( YYS &(yyvsp[(4) - (5)].v) );
			_here;
		;}
    break;

  case 896:

/* Line 1464 of yacc.c  */
#line 40381 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.NoStorage) = 1;
			(yyval.options.SpecifiedOptions) = 
				(yyval.options.SpecifiedOptions) | specified_nostorage;
		;}
    break;

  case 897:

/* Line 1464 of yacc.c  */
#line 40390 "hlaparse.bsn"
    {
			_here;
			(yyval.options) = (yyvsp[(1) - (2)].options);
			(yyval.options.IsVolatile) = 1;
			(yyval.options.SpecifiedOptions) = 
				(yyval.options.SpecifiedOptions) | specified_volatile;
		;}
    break;

  case 898:

/* Line 1464 of yacc.c  */
#line 40420 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = (yyvsp[(0) - (1)].s);
			parmLookup = 1;
			fastLookup = 1; 
			ProcNS = currentNS;
			//ProcGlobal = SymbolTable; // Removed, messed up parms
		;}
    break;

  case 899:

/* Line 1464 of yacc.c  */
#line 40429 "hlaparse.bsn"
    { 
			_here;
			currentNS = (yyvsp[(1) - (3)].ru.saveCurNS);
			//ProcGlobal = $<ru.saveProcGlobal>1; // see above
			ProcNS = (yyvsp[(1) - (3)].ru.saveProcNS);
			(yyval.v.u.intval) = (yyvsp[(3) - (3)].v.u.intval);
			parmLookup = 0;
			fastLookup = 0;
			(void) (yyvsp[(2) - (3)].s);	//shut up bison 
		;}
    break;

  case 900:

/* Line 1464 of yacc.c  */
#line 40444 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 0;
			assert( (yyvsp[(0) - (1)].s) != NULL );
			(yyvsp[(0) - (1)].s)->u.proc.ParmSize = 0;
		;}
    break;

  case 901:

/* Line 1464 of yacc.c  */
#line 40452 "hlaparse.bsn"
    { 
			_here;
			(yyval.v.u.intval) = CurOffset;
		;}
    break;

  case 902:

/* Line 1464 of yacc.c  */
#line 40458 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = (yyvsp[(3) - (4)].v.u.intval) - CurOffset;
			assert( (yyvsp[(0) - (4)].s) != NULL );
			(void) (yyvsp[(2) - (4)].v.u.intval);	//shut up bison
			(yyvsp[(0) - (4)].s)->u.proc.ParmSize = (yyval.v.u.intval);
		;}
    break;

  case 903:

/* Line 1464 of yacc.c  */
#line 40469 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
		;}
    break;

  case 904:

/* Line 1464 of yacc.c  */
#line 40475 "hlaparse.bsn"
    {
			yyerror( "Undefined type identifier" );
			(yyval.s) = &dword_ste;
			_here;
		;}
    break;

  case 905:

/* Line 1464 of yacc.c  */
#line 40484 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = ProcGlobal;
			ProcGlobal = SymbolTable;
		;}
    break;

  case 906:

/* Line 1464 of yacc.c  */
#line 40496 "hlaparse.bsn"
    {
			int CurParmSize;
			
			_here;
			assert( (yyvsp[(2) - (4)].idStr) != NULL );
			assert( (yyvsp[(4) - (4)].s) != NULL );
			
			// Restore ProcGlobal:
			
			ProcGlobal = (yyvsp[(3) - (4)].s);

			CurParmSize = 0;
			_if( CantBeParm( (yyvsp[(4) - (4)].s)->pType ))

				yyerror( "Parameters cannot be this type" );

			_else
			
				CurParmSize =
					_ifx
					( 
						(yyvsp[(1) - (4)].v.pClass) == valp_pc, 
						(yyvsp[(4) - (4)].s)->ObjectSize,	/* Pass by Value */
						_ifx
						( 
								(yyvsp[(1) - (4)].v.pClass) >= refp_pc 
							&&	(yyvsp[(1) - (4)].v.pClass) <= result_pc, 
							4,				/* Pass by ref, valres, result	*/
							8				/* Pass by name or lazy.		*/
						)
					);

				_if( (yyvsp[(1) - (4)].v.pClass) == valp_pc  )


					/*
					** If we're passing this by value, specify the
					** base type of this object as the parameter type.
					*/

					InsertSym
					( 
						(yyvsp[(2) - (4)].idStr),
						(yyvsp[(4) - (4)].s),
						(yyvsp[(4) - (4)].s)->pType, 
						cParm, 
						(yyvsp[(4) - (4)].s)->Arity,
						(yyvsp[(4) - (4)].s)->Dimensions,
						(yyvsp[(4) - (4)].s)->NumElements, 
						NULL,
						CurParmSize,
						(yyvsp[(0) - (4)].v.u.intval),
						NULL,
						(yyvsp[(4) - (4)].s)->Base,
						(yyvsp[(4) - (4)].s)->Fields,
						(yyvsp[(4) - (4)].s)->FieldCnt
					);


				_else

					/*

					** If we're passing this parameter by address
					** (reference, value/result, or result), or
					** by thunk (name, lazy evaluation), then
					** specify the actual type of the parameter.
					*/

					InsertSym
					( 
						(yyvsp[(2) - (4)].idStr), 
						(yyvsp[(4) - (4)].s),
						(yyvsp[(4) - (4)].s)->pType, 
						cParm, 
						(yyvsp[(4) - (4)].s)->Arity,
						(yyvsp[(4) - (4)].s)->Dimensions,
						(yyvsp[(4) - (4)].s)->NumElements, 
						NULL,
						CurParmSize,
						(yyvsp[(0) - (4)].v.u.intval),
						NULL,
						(yyvsp[(4) - (4)].s),
						NULL,
						0
					);

				_endif
				SymbolTable->u.proc.returns = (yyvsp[(1) - (4)].v.u.proc.returns);
				SymbolTable->u.proc.use = (yyvsp[(1) - (4)].v.u.proc.use);
				_if( (yyvsp[(4) - (4)].s)->pType == tProcptr )
				
					SymbolTable->u.proc.parms = (yyvsp[(4) - (4)].s)->u.proc.parms;
					SymbolTable->u.proc.ParmSize = (yyvsp[(4) - (4)].s)->u.proc.ParmSize;
					SymbolTable->u.proc.parms->u.proc.ParmSize = 
						(yyvsp[(4) - (4)].s)->u.proc.ParmSize;

				_else
				
					// Put a bogus entry here, for consistency,
					// if it's not a proc pointer.
					
					SymbolTable->u.proc.parms = &true_ste;
					
				_endif

				/*
				** For parameters, the pClass field contains the passing
				** mechanism.
				*/

				SymbolTable->pClass = (yyvsp[(1) - (4)].v.pClass);
				
			_endif
			(yyval.v.u.intval) = (yyvsp[(0) - (4)].v.u.intval) + max( CurParmSize, MinParmSize);
			_if( max( CurParmSize, MinParmSize) % 4 != 0 )

				(yyval.v.u.intval) = (yyval.v.u.intval) + 
									4 - (max( CurParmSize, MinParmSize) % 4);

			_endif
			_here;
		;}
    break;

  case 907:

/* Line 1464 of yacc.c  */
#line 40635 "hlaparse.bsn"
    {
			int CurParmSize;

			assert( (yyvsp[(2) - (6)].idStr) != NULL );
			assert( (yyvsp[(4) - (6)].s) != NULL );
			_here;
			
			// Restore ProcGlobal
			
			ProcGlobal = (yyvsp[(3) - (6)].s);

			CurParmSize = 0;
			_if( CantBeParm( (yyvsp[(4) - (6)].s)->pType ))

				yyerror( "Parameters cannot be this type" );

			_elseif
			(
					(yyvsp[(1) - (6)].v.pClass) != valp_pc
				&&	(yyvsp[(1) - (6)].v.pClass) != refp_pc
			)

				yyerror
				( 
					"Can only pass value and reference parameters in registers"
				);

			_else
			
				CurParmSize =
					_ifx
					( 
						(yyvsp[(1) - (6)].v.pClass) == valp_pc, 
						(yyvsp[(4) - (6)].s)->ObjectSize,	/* Pass by Value */
						4					/* Pass by ref	 */
					);

				_if( CurParmSize != (yyvsp[(6) - (6)].reg.Size) )


					ErrorNear
					( 
						"Type size and register size are not the same", 
						(yyvsp[(4) - (6)].s)->TrueName,
						__LINE__,
						__FILE__ 
					);
					
				_elseif( (yyvsp[(1) - (6)].v.pClass) == valp_pc  )


					/*
					** If we're passing this by value, specify the
					** base type of this object as the parameter type.
					*/

					InsertSym
					( 
						(yyvsp[(2) - (6)].idStr),
						(yyvsp[(4) - (6)].s),
						(yyvsp[(4) - (6)].s)->pType, 
						cParm, 
						(yyvsp[(4) - (6)].s)->Arity,
						(yyvsp[(4) - (6)].s)->Dimensions,
						(yyvsp[(4) - (6)].s)->NumElements, 
						NULL,
						CurParmSize,
						(yyvsp[(0) - (6)].v.u.intval),
						regDup( (yyvsp[(6) - (6)].reg.encoding) ),
						(yyvsp[(4) - (6)].s)->Base,
						(yyvsp[(4) - (6)].s)->Fields,
						(yyvsp[(4) - (6)].s)->FieldCnt
					);
					SymbolTable->regnum = (yyvsp[(6) - (6)].reg.encoding);
					_if( (yyvsp[(4) - (6)].s)->pType == tProcptr )
					
						// Copy parameter info if a proc ptr.
						
						memcpy
						( 
							&SymbolTable->u, 
							&(yyvsp[(4) - (6)].s)->u, 
							sizeofValuesSize
						);
						
					_endif



				_else

					/*
					** If we're passing this parameter by reference then
					** specify the actual type of the parameter.
					*/

					InsertSym
					( 
						(yyvsp[(2) - (6)].idStr), 
						(yyvsp[(4) - (6)].s),
						(yyvsp[(4) - (6)].s)->pType, 
						cParm, 
						(yyvsp[(4) - (6)].s)->Arity,
						(yyvsp[(4) - (6)].s)->Dimensions,
						(yyvsp[(4) - (6)].s)->NumElements, 
						NULL,
						CurParmSize,
						(yyvsp[(0) - (6)].v.u.intval),
						regDup( (yyvsp[(6) - (6)].reg.encoding) ),
						(yyvsp[(4) - (6)].s),
						NULL,
						0
					);
					SymbolTable->regnum = (yyvsp[(6) - (6)].reg.encoding);
					

				_endif
				SymbolTable->u.proc.returns = (yyvsp[(1) - (6)].v.u.proc.returns);
				SymbolTable->u.proc.use = (yyvsp[(1) - (6)].v.u.proc.use);
				_if( (yyvsp[(4) - (6)].s)->pType == tProcptr )
				
					SymbolTable->u.proc.parms = (yyvsp[(4) - (6)].s)->u.proc.parms;

				_else
				
					// Put a bogus entry here, for consistency,
					// if it's not a proc pointer.
					
					SymbolTable->u.proc.parms = &true_ste;
					
				_endif



				/*
				** For parameters, the pClass field contains the passing
				** mechanism.
				*/

				SymbolTable->pClass = (yyvsp[(1) - (6)].v.pClass);

			_endif

			/*
			** Register variables don't consume any space on the stack,
			** so just return the previous offset.
			*/

			(yyval.v.u.intval) = (yyvsp[(0) - (6)].v.u.intval);
			_here;
		;}
    break;

  case 908:

/* Line 1464 of yacc.c  */
#line 40794 "hlaparse.bsn"
    {
			_here;
			ProcGlobal = (yyvsp[(3) - (4)].s);
			fastLookup = 1;
		;}
    break;

  case 909:

/* Line 1464 of yacc.c  */
#line 40800 "hlaparse.bsn"
    {
			(yyval.v.u.unsval) = (yyvsp[(0) - (6)].v.u.unsval);
		;}
    break;

  case 910:

/* Line 1464 of yacc.c  */
#line 40804 "hlaparse.bsn"
    {
			int CurParmSize;

			_here;
			assert( (yyvsp[(2) - (8)].idStr) != NULL );
			assert( (yyvsp[(4) - (8)].s) != NULL );

			CurParmSize = 0;
			_if( CantBeParm((yyvsp[(4) - (8)].s)->pType ))

				yyerror( "Parameters cannot be this type" );

			_else
			
				_if( (yyvsp[(1) - (8)].v.pClass) == valp_pc )

					CurParmSize = (yyvsp[(4) - (8)].s)->ObjectSize;
					InsertSym
					( 
						(yyvsp[(2) - (8)].idStr), 
						(yyvsp[(4) - (8)].s),
						(yyvsp[(4) - (8)].s)->pType, 
						cParm, 
						(yyvsp[(4) - (8)].s)->Arity,
						(yyvsp[(4) - (8)].s)->Dimensions,
						(yyvsp[(4) - (8)].s)->NumElements, 
						NULL,
						CurParmSize,
						(yyvsp[(8) - (8)].v.u.unsval),
						NULL,
						(yyvsp[(4) - (8)].s)->Base,
						(yyvsp[(4) - (8)].s)->Fields,
						(yyvsp[(4) - (8)].s)->FieldCnt
					);
					SymbolTable->u.proc.returns = (yyvsp[(1) - (8)].v.u.proc.returns);
					SymbolTable->u.proc.use = (yyvsp[(1) - (8)].v.u.proc.use);
					_if( (yyvsp[(4) - (8)].s)->pType == tProcptr )
					
						SymbolTable->u.proc.parms = (yyvsp[(4) - (8)].s)->u.proc.parms;

					_else
					
						// Put a bogus entry here, for consistency,
						// if it's not a proc pointer.
						
						SymbolTable->u.proc.parms = &true_ste;
						
					_endif

				_elseif
				(
						(yyvsp[(1) - (8)].v.pClass) >= refp_pc 
					&&	(yyvsp[(1) - (8)].v.pClass) <= result_pc
				)
				 
					InsertSym
					( 
						(yyvsp[(2) - (8)].idStr), 
						(yyvsp[(4) - (8)].s),
						(yyvsp[(4) - (8)].s)->pType, 
						cParm, 
						(yyvsp[(4) - (8)].s)->Arity,
						(yyvsp[(4) - (8)].s)->Dimensions,
						(yyvsp[(4) - (8)].s)->NumElements, 
						NULL,
						4,
						(yyvsp[(8) - (8)].v.u.unsval),
						NULL,
						(yyvsp[(4) - (8)].s),
						NULL,
						0
					);
					CurParmSize = 4;
					SymbolTable->u.proc.returns = (yyvsp[(1) - (8)].v.u.proc.returns);
					SymbolTable->u.proc.use = (yyvsp[(1) - (8)].v.u.proc.use);
					_if( (yyvsp[(4) - (8)].s)->pType == tProcptr )
					
						SymbolTable->u.proc.parms = (yyvsp[(4) - (8)].s)->u.proc.parms;

					_else
					
						// Put a bogus entry here, for consistency,
						// if it's not a proc pointer.
						
						SymbolTable->u.proc.parms = &true_ste;
						
					_endif

				_else
				 
					InsertSym
					( 
						(yyvsp[(2) - (8)].idStr), 
						(yyvsp[(4) - (8)].s),
						(yyvsp[(4) - (8)].s)->pType, 
						cParm, 
						(yyvsp[(4) - (8)].s)->Arity,
						(yyvsp[(4) - (8)].s)->Dimensions,
						(yyvsp[(4) - (8)].s)->NumElements, 
						NULL,
						8,
						(yyvsp[(8) - (8)].v.u.unsval),
						NULL,
						NULL,
						NULL,
						0
					);
					SymbolTable->u.proc.returns = (yyvsp[(1) - (8)].v.u.proc.returns);
					SymbolTable->u.proc.use = (yyvsp[(1) - (8)].v.u.proc.use);
					CurParmSize = 8;

				_endif

				/*
				** For parameters, the pClass field contains the passing
				** mechanism.
				*/

				SymbolTable->pClass = (yyvsp[(1) - (8)].v.pClass);


			_endif
			(yyval.v.u.intval) = (yyvsp[(8) - (8)].v.u.intval) + max( CurParmSize, MinParmSize);
			_if( max( CurParmSize, MinParmSize) % 4 != 0 )

				(yyval.v.u.intval) = (yyval.v.u.intval) + 
								4 - (max( CurParmSize, MinParmSize) % 4);

			_endif
			
			(void) (yyvsp[(7) - (8)].v.u.unsval); // shut up bison
			_here;
		;}
    break;

  case 911:

/* Line 1464 of yacc.c  */
#line 40955 "hlaparse.bsn"
    {
			_here;
			ProcGlobal = (yyvsp[(3) - (4)].s);
			fastLookup = 1
		;}
    break;

  case 912:

/* Line 1464 of yacc.c  */
#line 40961 "hlaparse.bsn"
    {				/* $7 */

			(yyval.v.u.unsval) = (yyvsp[(0) - (6)].v.u.unsval);
		;}
    break;

  case 913:

/* Line 1464 of yacc.c  */
#line 40966 "hlaparse.bsn"
    {				/* $9 */

			_here;
			assert( (yyvsp[(2) - (8)].idStr) != NULL );

			
			_if( (yyvsp[(1) - (8)].v.pClass) != refp_pc )

				yyerror( "Variant parameters must be pass by reference" );

			_endif
				 
			InsertSym
			( 
				(yyvsp[(2) - (8)].idStr),		/* ID			*/ 
				&variant_ste,	/* Type			*/
				tDWord, 		/* pType		*/
				cParm, 			/* Class		*/
				0,				/* arity		*/
				NULL,			/* Dimensions	*/
				0, 				/* NumElements	*/
				NULL,			/* Value		*/
				4,				/* Size			*/
				(yyvsp[(8) - (8)].v.u.unsval),	/* Offset		*/
				NULL,			/* StaticName	*/
				&dword_ste,		/* Base			*/
				NULL,			/* Fields		*/
				0				/* FieldCnt		*/
			);

			/* Register parameters don't consume any space, so just */
			/* return the previous offset.							*/

			(yyval.v.u.intval) = (yyvsp[(8) - (8)].v.u.intval);

			/*
			** For parameters, the pClass field contains the passing
			** mechanism.
			*/

			SymbolTable->pClass = refp_pc;

			// Return new offset here

			(yyval.v.u.intval) = (yyvsp[(8) - (8)].v.u.intval) + 4;
			(void) (yyvsp[(7) - (8)].v.u.unsval); // shut up bison
			_here;			

		;}
    break;

  case 914:

/* Line 1464 of yacc.c  */
#line 41028 "hlaparse.bsn"
    {				/* $5 */

			assert( (yyvsp[(2) - (4)].idStr) != NULL );
			_here;	 
			ProcGlobal = (yyvsp[(3) - (4)].s);
			
			_if( (yyvsp[(1) - (4)].v.pClass) != refp_pc )

				yyerror( "Variant parameters must be pass by reference" );

			_endif
			InsertSym
			( 
				(yyvsp[(2) - (4)].idStr),		/* ID			*/ 
				&variant_ste,	/* Type			*/
				tDWord, 		/* pType		*/
				cParm, 			/* Class		*/
				0,				/* arity		*/
				NULL,			/* Dimensions	*/
				0, 				/* NumElements	*/
				NULL,			/* Value		*/
				4,				/* Size			*/
				(yyvsp[(0) - (4)].v.u.intval),	/* Offset		*/
				NULL,			/* StaticName	*/
				NULL,			/* Base			*/
				NULL,			/* Fields		*/
				0				/* FieldCnt		*/
			);

			// Put the PassBy parameters into this symbol
			// (returns is always NULL for VAR objects,
			// parms is always ref_pc.)

			SymbolTable->u.proc.returns = (yyvsp[(1) - (4)].v.u.proc.returns);
			SymbolTable->u.proc.use = (yyvsp[(1) - (4)].v.u.proc.use);
			SymbolTable->u.proc.parms = &true_ste;

			/*
			** For parameters, the pClass field contains the passing
			** mechanism.
			*/

			SymbolTable->pClass = refp_pc;

			// Return new offset here

			(yyval.v.u.intval) = (yyvsp[(0) - (4)].v.u.intval) + 4;

			_here;			

		;}
    break;

  case 915:

/* Line 1464 of yacc.c  */
#line 41089 "hlaparse.bsn"
    {
			_here;
			ProcGlobal = (yyvsp[(3) - (6)].s);
			fastLookup = 1;
		;}
    break;

  case 916:

/* Line 1464 of yacc.c  */
#line 41095 "hlaparse.bsn"
    {				/* $9 */
			_here;
			(yyval.v.u.unsval) = (yyvsp[(0) - (8)].v.u.unsval);
		;}
    break;

  case 917:

/* Line 1464 of yacc.c  */
#line 41100 "hlaparse.bsn"
    {				/* $11 */

			assert( (yyvsp[(2) - (10)].idStr) != NULL );
			_here;
			_if( (yyvsp[(6) - (10)].reg.Size) != 4 )

				yyerror
				( 
					"Can only pass reference parameters in 32-bit registers" 
				);
				
			_else
				
				_if( (yyvsp[(1) - (10)].v.pClass) != refp_pc )

					yyerror
					( 
						"Variant parameters must be pass by reference" 
					);

				_endif /* must be pass by reference */
			 
			 
				InsertSym
				( 
					(yyvsp[(2) - (10)].idStr),		/* ID			*/ 
					&variant_ste,	/* Type			*/
					tDWord, 		/* pType		*/
					cParm, 			/* Class		*/
					0,				/* arity		*/
					NULL,			/* Dimensions	*/
					0, 				/* NumElements	*/
					NULL,			/* Value		*/
					4,				/* Size			*/
					(yyvsp[(8) - (10)].v.u.unsval),	/* Offset		*/
					regDup( (yyvsp[(6) - (10)].reg.encoding) ),		/* StaticName	*/
					&dword_ste,		/* Base			*/
					NULL,			/* Fields		*/
					0				/* FieldCnt		*/
				);
				SymbolTable->regnum = (yyvsp[(6) - (10)].reg.encoding);
				

			_endif

			/*
			** For parameters, the pClass field contains the passing
			** mechanism.
			*/

			SymbolTable->pClass = (yyvsp[(1) - (10)].v.pClass);


			/* 
			** Register parameters don't consume any space
			** in the activation record, so just return
			** the previous offset.
			*/
			
			(yyval.v.u.intval) = (yyvsp[(10) - (10)].v.u.intval); 
			(void) (yyvsp[(9) - (10)].v.u.unsval); // shut up bison
			_here;
		;}
    break;

  case 918:

/* Line 1464 of yacc.c  */
#line 41174 "hlaparse.bsn"
    {				/* $7 */

			assert( (yyvsp[(2) - (6)].idStr) != NULL );
			_here;
			ProcGlobal = (yyvsp[(3) - (6)].s);
			
			_if( (yyvsp[(6) - (6)].reg.Size) != 4 )

				yyerror
				( 
					"Can only pass reference parameters in 32-bit registers" 
				);
				
			_else
				
				_if( (yyvsp[(1) - (6)].v.pClass) != refp_pc )

					yyerror
					( 
						"Variant parameters must be pass by reference" 
					);

				_endif /* must be pass by reference */
			 
			 
				InsertSym
				( 
					(yyvsp[(2) - (6)].idStr),		/* ID			*/ 
					&variant_ste,	/* Type			*/
					tDWord, 		/* pType		*/
					cParm, 			/* Class		*/
					0,				/* arity		*/
					NULL,			/* Dimensions	*/
					0, 				/* NumElements	*/
					NULL,			/* Value		*/
					4,				/* Size			*/
					(yyvsp[(0) - (6)].v.u.unsval),	/* Offset		*/
					regDup( (yyvsp[(6) - (6)].reg.encoding) ),		/* StaticName	*/
					&dword_ste,		/* Base			*/
					NULL,			/* Fields		*/
					0				/* FieldCnt		*/
				);
				SymbolTable->regnum = (yyvsp[(6) - (6)].reg.encoding);
				

			_endif

			/*
			** For parameters, the pClass field contains the passing
			** mechanism.
			*/

			SymbolTable->pClass = (yyvsp[(1) - (6)].v.pClass);


			/*
			** Register parameters don't consume any space in
			** the activation record, so just return the
			** previous offset.
			*/

			(yyval.v.u.intval) = (yyvsp[(0) - (6)].v.u.intval); 
			_here;
		;}
    break;

  case 919:

/* Line 1464 of yacc.c  */
#line 41261 "hlaparse.bsn"
    {
			_here;
			ProcGlobal = (yyvsp[(3) - (6)].s);
			fastLookup = 1;
		;}
    break;

  case 920:

/* Line 1464 of yacc.c  */
#line 41267 "hlaparse.bsn"
    {				/* $9 */

			(yyval.v.u.unsval) = (yyvsp[(0) - (8)].v.u.unsval);
		;}
    break;

  case 921:

/* Line 1464 of yacc.c  */
#line 41272 "hlaparse.bsn"
    {				/* $11 */

			int CurParmSize;

			assert( (yyvsp[(2) - (10)].idStr) != NULL );
			assert( (yyvsp[(4) - (10)].s) != NULL );
			_here;
			CurParmSize = 0;
			_if( CantBeParm((yyvsp[(4) - (10)].s)->pType ))

				yyerror( "Parameters cannot be this type" );

			_elseif
			(
					(yyvsp[(1) - (10)].v.pClass) != valp_pc
				&&	(yyvsp[(1) - (10)].v.pClass) != refp_pc
			)

				yyerror
				( 
					"Can only pass value and reference parameters in registers"
				);

			_else
			
				CurParmSize =
					_ifx
					( 
						(yyvsp[(1) - (10)].v.pClass) == valp_pc, 
						(yyvsp[(4) - (10)].s)->ObjectSize,	/* Pass by Value */
						4					/* Pass by ref   */
					);

				_if( CurParmSize != (yyvsp[(6) - (10)].reg.Size) )

					ErrorNear
					( 
						"Type size and register size are not the same", 
						(yyvsp[(4) - (10)].s)->TrueName,
						__LINE__,
						__FILE__ 
					);
					
				_elseif( (yyvsp[(1) - (10)].v.pClass) == valp_pc )

					InsertSym
					( 
						(yyvsp[(2) - (10)].idStr), 
						(yyvsp[(4) - (10)].s),
						(yyvsp[(4) - (10)].s)->pType, 
						cParm, 
						(yyvsp[(4) - (10)].s)->Arity,
						(yyvsp[(4) - (10)].s)->Dimensions,
						(yyvsp[(4) - (10)].s)->NumElements, 
						NULL,
						CurParmSize,
						(yyvsp[(10) - (10)].v.u.unsval),
						regDup( (yyvsp[(6) - (10)].reg.encoding) ),
						(yyvsp[(4) - (10)].s)->Base,
						(yyvsp[(4) - (10)].s)->Fields,
						(yyvsp[(4) - (10)].s)->FieldCnt
					);
					SymbolTable->regnum = (yyvsp[(6) - (10)].reg.encoding);

				_else /* must be pass by reference */
				 
					InsertSym
					( 
						(yyvsp[(2) - (10)].idStr), 
						(yyvsp[(4) - (10)].s),
						(yyvsp[(4) - (10)].s)->pType, 
						cParm, 
						(yyvsp[(4) - (10)].s)->Arity,
						(yyvsp[(4) - (10)].s)->Dimensions,
						(yyvsp[(4) - (10)].s)->NumElements, 
						NULL,
						4,
						(yyvsp[(10) - (10)].v.u.unsval),
						regDup( (yyvsp[(6) - (10)].reg.encoding) ),
						(yyvsp[(4) - (10)].s),
						NULL,
						0
					);
					CurParmSize = 4;
					SymbolTable->regnum = (yyvsp[(6) - (10)].reg.encoding);

				_endif
				SymbolTable->u.proc.returns = (yyvsp[(1) - (10)].v.u.proc.returns);
				SymbolTable->u.proc.use = (yyvsp[(1) - (10)].v.u.proc.use);
				_if( (yyvsp[(4) - (10)].s)->pType == tProcptr )
				
					SymbolTable->u.proc.parms = (yyvsp[(4) - (10)].s)->u.proc.parms;

				_else
				
					// Put a bogus entry here, for consistency,
					// if it's not a proc pointer.
					
					SymbolTable->u.proc.parms = &true_ste;
					
				_endif

				/*
				** For parameters, the pClass field contains the passing
				** mechanism.
				*/

				SymbolTable->pClass = (yyvsp[(1) - (10)].v.pClass);


			_endif

			(yyval.v.u.intval) = (yyvsp[(10) - (10)].v.u.intval);
			(void) (yyvsp[(9) - (10)].v.u.unsval); // shut up bison
			_here;
		;}
    break;

  case 922:

/* Line 1464 of yacc.c  */
#line 41414 "hlaparse.bsn"
    {				/* $9 */

			SymNode_t *s;
			SymNode_t *t;
			
			_here;
			ProcGlobal = (yyvsp[(3) - (8)].s);

			_if( (yyvsp[(1) - (8)].v.pClass) != valp_pc )

				yyerror
				( 
					"Procedure parameters can only be passed by value"
				);
				(yyvsp[(1) - (8)].v.pClass) = valp_pc;

			_endif

			/*
			** We have to fix the procedure pointer's offset
			** because EnterProcName just set this to zero.
			*/

			(yyvsp[(7) - (8)].s)->Offset = (yyvsp[(0) - (8)].v.u.intval);


			// Create a dummy type to hold the parameter list:
			
			s = SymbolTable;
			InsertSym
			( 
				" (parameter Proc Ptr Type) ", 
				NULL,			/* Default is int32 object.		*/
				tProcptr,
				cType, 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				NULL,			/* No initialization			*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				NULL,			/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);
			SymbolTable->u.proc.parms = s;
			SymbolTable->u.proc.returns = (yyvsp[(1) - (8)].v.u.proc.returns);
			SymbolTable->u.proc.use = (yyvsp[(1) - (8)].v.u.proc.use);
			(yyvsp[(7) - (8)].s)->Type = SymbolTable;

			/*
			** Initialize the pointer to the end of the parameters
			** for this procedure variable.
			** Set up the offset and direction variables to handle
			** local variable declarations.  
			*/

			(yyvsp[(7) - (8)].s)->u.proc.parms->u.proc.parms = s;
			(yyvsp[(7) - (8)].s)->u.proc.parms->u.proc.returns = (yyvsp[(1) - (8)].v.u.proc.returns);
			(yyvsp[(7) - (8)].s)->u.proc.parms->u.proc.use = (yyvsp[(1) - (8)].v.u.proc.use);
			(yyvsp[(7) - (8)].s)->u.proc.parms->u.proc.Locals = NULL;

			(yyvsp[(7) - (8)].s)->u.proc.parms = s;
			(yyvsp[(7) - (8)].s)->u.proc.Locals = NULL;
			(yyvsp[(7) - (8)].s)->u.proc.returns = (yyvsp[(1) - (8)].v.u.proc.returns);
			(yyvsp[(7) - (8)].s)->u.proc.use = (yyvsp[(1) - (8)].v.u.proc.use);
			--CurLexLevel;
			CurOffset = (yyvsp[(5) - (8)].v.u.unsval);
			CurOffsetDir = (yyvsp[(6) - (8)].v.u.unsval);
			
			// Remove the parameter list for this procedure pointer argument
			// from the symbol table we're building:
			
			SymbolTable = (yyvsp[(7) - (8)].s);

			/*
			** Update the offset into the activation record for
			** the next parameter.
			*/

			(yyval.v.u.intval) = (yyvsp[(0) - (8)].v.u.intval) + max( 4, MinParmSize);
			_here;
		;}
    break;

  case 923:

/* Line 1464 of yacc.c  */
#line 41522 "hlaparse.bsn"
    {
			_here;
			ProcGlobal = (yyvsp[(3) - (8)].s);
			fastLookup = 1;
		;}
    break;

  case 924:

/* Line 1464 of yacc.c  */
#line 41528 "hlaparse.bsn"
    {				/* $11 */ 
		
			SymNode_t *s;
			
			_here;
			_if( (yyvsp[(1) - (10)].v.pClass) != valp_pc )

				yyerror
				( 
					"Procedure parameters can only be passed by value"
				);
				(yyvsp[(1) - (10)].v.pClass) = valp_pc;

			_endif



			// Create a dummy type to hold the parameter list:
			
			s = SymbolTable;
			InsertSym
			( 
				" (parameter Proc Ptr Type) ", 
				NULL,			/* Primitive type.		*/
				tProcptr,
				cType, 
				0,				/* Arity				*/
				NULL,			/* Dimensions			*/
				0, 				/* NumElements			*/
				NULL,			/* No initialization	*/
				0,				/* Object size			*/
				0,				/* Offset				*/
				NULL,			/* Static Name			*/
				NULL,			/* Base					*/
				NULL,			/* Fields				*/
				0				/* FieldCnt				*/
			);
			SymbolTable->u.proc.parms = s;
			SymbolTable->u.proc.returns = hlastrdup2( "" );
			SymbolTable->u.proc.use = (yyvsp[(1) - (10)].v.u.proc.use);
			(yyvsp[(7) - (10)].s)->Type = SymbolTable;

			/*
			** Initialize the pointer to the end of the parameters
			** for this procedure variable.
			** Set up the offset and direction variables to handle
			** local variable declarations.  
			*/

			(yyvsp[(7) - (10)].s)->u.proc.parms->u.proc.parms = s;
			(yyvsp[(7) - (10)].s)->u.proc.parms->u.proc.returns = (yyvsp[(1) - (10)].v.u.proc.returns);
			(yyvsp[(7) - (10)].s)->u.proc.parms->u.proc.use = (yyvsp[(1) - (10)].v.u.proc.use);
			(yyvsp[(7) - (10)].s)->u.proc.parms->u.proc.Locals = NULL;

			(yyvsp[(7) - (10)].s)->u.proc.parms = s;
			(yyvsp[(7) - (10)].s)->u.proc.Locals = NULL;
			(yyvsp[(7) - (10)].s)->u.proc.returns = (yyvsp[(1) - (10)].v.u.proc.returns);
			(yyvsp[(7) - (10)].s)->u.proc.use = (yyvsp[(1) - (10)].v.u.proc.use);
			--CurLexLevel;
			CurOffset = (yyvsp[(5) - (10)].v.u.intval);
			CurOffsetDir = (yyvsp[(6) - (10)].v.u.intval);

			/*
			** Temporarily remove this symbol from the Symbol Table
			** so we can insert the parameters following the
			** procedure parameter first.
			*/

			SymbolTable = (yyvsp[(7) - (10)].s)->Next;

			_here;

			/*
			** Since this isn't the last parameter, pass the starting
			** offset value on to the next parameter in the list (because
			** the last parameter has the smallest offset value in the
			** parameter list).
			*/

			(yyval.v.u.intval) = (yyvsp[(0) - (10)].v.u.intval);
			_here;
		;}
    break;

  case 925:

/* Line 1464 of yacc.c  */
#line 41611 "hlaparse.bsn"
    {				/* $13 */

			_here;

			/*
			** We have to fix the procedure pointer's offset
			** because EnterProcName just set this to zero.
			*/

			(yyvsp[(7) - (12)].s)->Offset = (yyvsp[(12) - (12)].v.u.intval);

			/*
			** Update the offset into the activation record for
			** the previous parameter.
			*/

			(yyval.v.u.intval) = (yyvsp[(12) - (12)].v.u.intval) + max( 4, MinParmSize);

			/*
			** Insert the procedure pointer parameter back into
			** the symbol table since we've already processed all
			** the parameters after the procedure parm.
			*/

			(yyvsp[(7) - (12)].s)->Next = SymbolTable;
			SymbolTable = (yyvsp[(7) - (12)].s);
			(void) (yyvsp[(11) - (12)].v.u.intval); // shut up bison
			_here;
		;}
    break;

  case 926:

/* Line 1464 of yacc.c  */
#line 41660 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(-4) - (0)].idStr) != NULL );
			InsertSym
			( 
				(yyvsp[(-4) - (0)].idStr),
				&proctype_ste,
				tProcptr, 
				cParm, 
				0,					/* Arity		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				4,					/* ObjectSize	*/
				CurOffset,			/* Offset		*/
				NULL,				/* StaticName	*/
				NULL,				/* Base			*/
				NULL,			  	/* Fields		*/
				0					/* FieldCnt		*/
			);


			/*
			** For parameters, the pClass field contains the passing
			** mechanism.
			*/

			SymbolTable->pClass = (yyvsp[(-5) - (0)].v.pClass);
			SymbolTable->u.proc.returns = (yyvsp[(-5) - (0)].v.u.proc.returns);
			SymbolTable->u.proc.use = (yyvsp[(-5) - (0)].v.u.proc.use);


			/*
			** Set up globals so we can process the parameter
			** list of this procedure pointer.
			*/

			(yyval.s) = SymbolTable;
			CurOffset = StartParmOffs;
			++CurLexLevel;

			/*
			** Reinsert the symbol into the local symbols
			** to keep the logic of this program happy.
			*/

			InsertSym
			( 
				(yyvsp[(-4) - (0)].idStr),
				&proctype_ste,
				tProcptr, 
				cVar, 
				0,					/* Arity		*/
				NULL,				/* Dimensions	*/
				0,					/* NumElements	*/ 
				NULL,				/* Value		*/
				4,					/* ObjectSize	*/
				0,					/* Offset		*/
				NULL,				/* StaticName	*/
				NULL,				/* Base			*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);

			/*
			** Temporary assignment so we can patch the local
			** entry later.
			*/

			(yyval.s)->u.proc.parms = SymbolTable;
			(yyval.s)->u.proc.returns = hlastrdup2( "" );
			(yyval.s)->u.proc.use = NULL;
			_here;

		;}
    break;

  case 927:

/* Line 1464 of yacc.c  */
#line 41740 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.pClass) = valp_pc; 
			(yyval.v.u.proc.returns) = hlastrdup2( "" );
			(yyval.v.u.proc.use) = NULL;
			_here; 
		;}
    break;

  case 928:

/* Line 1464 of yacc.c  */
#line 41748 "hlaparse.bsn"
    { 
			_here; 
			(yyval.v.pClass) = valp_pc; 
			(yyval.v.u.proc.returns) = hlastrdup2( "" );
			(yyval.v.u.proc.use) = NULL;
			_here; 
		;}
    break;

  case 929:

/* Line 1464 of yacc.c  */
#line 41756 "hlaparse.bsn"
    { 
			_here; 
			(yyval.v.pClass) = refp_pc; 
			(yyval.v.u.proc.returns) = hlastrdup2( "" );
			(yyval.v.u.proc.use) = NULL;
			_here; 
		;}
    break;

  case 930:

/* Line 1464 of yacc.c  */
#line 41764 "hlaparse.bsn"
    { 
			_here; 
			(yyval.v.pClass) = vrp_pc; 
			(yyval.v.u.proc.returns) = hlastrdup2( "" );
			(yyval.v.u.proc.use) = NULL;
			_here; 
		;}
    break;

  case 931:

/* Line 1464 of yacc.c  */
#line 41772 "hlaparse.bsn"
    { 
			_here; 
			(yyval.v.pClass) = result_pc; 
			(yyval.v.u.proc.returns) = hlastrdup2( "" );
			(yyval.v.u.proc.use) = NULL;
			_here; 
		;}
    break;

  case 932:

/* Line 1464 of yacc.c  */
#line 41780 "hlaparse.bsn"
    { 
			_here; 
			(yyval.v.pClass) = name_pc; 
			(yyval.v.u.proc.returns) = (yyvsp[(2) - (2)].returns);
			(yyval.v.u.proc.use) = NULL;
			assert( (yyval.v.u.proc.returns) != NULL );
			_here; 
		;}
    break;

  case 933:

/* Line 1464 of yacc.c  */
#line 41789 "hlaparse.bsn"
    { 
			_here; 
			(yyval.v.pClass) = lazy_pc; 
			(yyval.v.u.proc.returns) = (yyvsp[(2) - (2)].returns);
			(yyval.v.u.proc.use) = NULL;
			assert( (yyval.v.u.proc.returns) != NULL );
			_here; 
		;}
    break;

  case 935:

/* Line 1464 of yacc.c  */
#line 41804 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = hlastrdup2( "" );
		;}
    break;

  case 936:

/* Line 1464 of yacc.c  */
#line 41810 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(2) - (3)].v.u.strval);
		;}
    break;

  case 937:

/* Line 1464 of yacc.c  */
#line 41826 "hlaparse.bsn"
    {
				char StaticName[ 256 ];
				char *sn;
				union YYSTYPE dummy;

				_here;
				assert( (yyvsp[(-3) - (0)].neID.idStr) != NULL );
				sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-3) - (0)].neID.idStr), LblCntr++ );
				sn = hlastrdup2( StaticName ); 
				InsertProc
				(
					(yyvsp[(-3) - (0)].neID.idStr),
					sn
				);

				(yyval.en.s) = SymbolTable;
				SymbolTable->u.proc.Forward = NULL;
				CurrentContext = SymbolTable;

				/*
				** If we're processing a namespace section,
				** turn off the use of the Hash Table while
				** handling local symbols for the procedure.
				*/
				
				(yyval.en.cns) = currentNS;
				currentNS = NULL;
				

				/*
				** Enter second copy of procedure name at the next
				** lower lex level in order to prevent an immediately
				** local procedure from having the same name.
				*/

				++CurLexLevel;
				sn = hlastrdup2( StaticName );
				InsertProc
				(
					hlastrdup2( (yyvsp[(-3) - (0)].neID.idStr) ),
					hlastrdup2( sn )
				);
				SymbolTable->u.proc.Forward = NULL;
				CurOffset = StartParmOffs;

				/*
				** For the moment, return the pointer to the local
				** entry of this procedure in the proc.parms pointer
				** so the caller can fill in appropriate fields in
				** the local entry as well as the main entry for this
				** procedure.
				*/

				(yyval.en.s)->u.proc.parms = SymbolTable;

				/*
				** Create the "_initialize_" and "_finalize_" text symbols 
				** used to emit initialization code later on.
				*/

				dummy.v.u.strval = hlastrdup2( "" );
				InsertSym
				( 
					hlastrdup2( "_initialize_" ), 
					&string_ste,	/* This is a STRING object.		*/
					tString,
					cValue, 
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					&dummy,			/* Initially, no initialization	*/
					0,				/* Object size					*/
					0,				/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);

				dummy.v.u.strval = hlastrdup2( "" );
				InsertSym
				( 
					hlastrdup2( "_finalize_" ), 
					&string_ste,	/* This is a STRING object.		*/
					tString,
					cValue, 
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					YYS &dummy,		/* Initially, no initialization	*/
					0,				/* Object size					*/
					0,				/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);

				_here;

			;}
    break;

  case 938:

/* Line 1464 of yacc.c  */
#line 41932 "hlaparse.bsn"
    {
				char StaticName[ 256 ];
				char *sn;
				union YYSTYPE dummy;

				_here;
				assert( (yyvsp[(-4) - (0)].idStr) != NULL );
				sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-4) - (0)].idStr), LblCntr++ );
				sn = hlastrdup2( StaticName ); 
				InsertProc
				(
					(yyvsp[(-4) - (0)].idStr),
					sn
				);

				(yyval.en.s) = SymbolTable;
				SymbolTable->u.proc.Forward = NULL;
				CurrentContext = SymbolTable;

				/*
				** If we're processing a namespace section,
				** turn off the use of the Hash Table while
				** handling local symbols for the procedure.
				*/
				
				(yyval.en.cns) = currentNS;
				currentNS = NULL;
				

				/*
				** Enter second copy of procedure name at the next
				** lower lex level in order to prevent an immediately
				** local procedure from having the same name.
				*/

				++CurLexLevel;
				sn = hlastrdup2( StaticName );
				InsertProc
				(
					hlastrdup2( (yyvsp[(-4) - (0)].idStr) ),
					hlastrdup2( sn )
				);
				SymbolTable->u.proc.Forward = NULL;
				CurOffset = StartParmOffs;

				/*
				** For the moment, return the pointer to the local
				** entry of this procedure in the proc.parms pointer
				** so the caller can fill in appropriate fields in
				** the local entry as well as the main entry for this
				** procedure.
				*/

				(yyval.en.s)->u.proc.parms = SymbolTable;

				/*
				** Create the "_initialize_" and "_finalize_" text symbols 
				** used to emit initialization code later on.
				*/

				dummy.v.u.strval = hlastrdup2( "" );
				InsertSym
				( 
					hlastrdup2( "_initialize_" ), 
					&string_ste,	/* This is a STRING object.		*/
					tString,
					cValue, 
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					&dummy,			/* Initially, no initialization	*/
					0,				/* Object size					*/
					0,				/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);

				dummy.v.u.strval = hlastrdup2( "" );
				InsertSym
				( 
					hlastrdup2( "_finalize_" ), 
					&string_ste,	/* This is a STRING object.		*/
					tString,
					cValue, 
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					YYS &dummy,		/* Initially, no initialization	*/
					0,				/* Object size					*/
					0,				/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);

				_here;

			;}
    break;

  case 939:

/* Line 1464 of yacc.c  */
#line 42042 "hlaparse.bsn"
    {
				char StaticName[ 256 ];
				char *sn;
				union YYSTYPE dummy;

				_here;
				assert( (yyvsp[(-3) - (0)].neID.idStr) != NULL );
				sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-3) - (0)].neID.idStr), LblCntr++ );
				sn = hlastrdup2( StaticName ); 
				InsertProc
				(
					(yyvsp[(-3) - (0)].neID.idStr),
					sn
				);

				(yyval.en.s) = SymbolTable;
				SymbolTable->u.proc.Forward = NULL;
				SymbolTable->pType = tIterator;
				SymbolTable->Type = &iterID_ste;
				SymbolTable->SymClass = cIterator;
				CurrentContext = SymbolTable;

				/*
				** Save currentNS and then set it to NULL
				** so that local IDs don't wind up in the
				** namespace hash table.
				*/
				
				(yyval.en.cns) = currentNS;
				currentNS = NULL;

				/*
				** Enter second copy of procedure name at the next
				** lower lex level in order to prevent an immediately
				** local procedure from having the same name.
				*/

				++CurLexLevel;
				sn = hlastrdup2( StaticName );
				InsertProc
				(
					(yyvsp[(-3) - (0)].neID.idStr),
					sn
				);
				SymbolTable->u.proc.Forward = NULL;
				SymbolTable->pType = tIterator;
				SymbolTable->Type = &iterID_ste;
				SymbolTable->SymClass = cIterator;
				CurOffset = StartParmOffs + 4;

				/*
				** For the moment, return the pointer to the local
				** entry of this procedure in the proc.parms pointer
				** so the caller can fill in appropriate fields in
				** the local entry as well as the main entry for this
				** procedure.
				*/

				(yyval.en.s)->u.proc.parms = SymbolTable;

				/*
				** Create the "_initialize_" and "_finalize_" text symbols 
				** used to emit initialization code later on.
				*/

				dummy.v.u.strval = hlastrdup2( "" );
				InsertSym
				( 
					"_initialize_", 
					&string_ste,	/* This is a STRING object.		*/
					tString,
					cValue, 
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					YYS &dummy,		/* Initially, no initialization	*/
					0,				/* Object size					*/
					0,				/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);

				dummy.v.u.strval = hlastrdup2( "" );
				InsertSym
				( 
					"_finalize_", 
					&string_ste,	/* This is a STRING object.		*/
					tString,
					cValue, 
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					YYS &dummy,		/* Initially, no initialization	*/
					0,				/* Object size					*/
					0,				/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);
				_here;
			;}
    break;

  case 940:

/* Line 1464 of yacc.c  */
#line 42152 "hlaparse.bsn"
    {
				char StaticName[ 256 ];
				char *sn;
				union YYSTYPE dummy;

				_here;
				assert( (yyvsp[(-4) - (0)].idStr) != NULL );
				sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-4) - (0)].idStr), LblCntr++ );
				sn = hlastrdup2( StaticName ); 
				InsertProc
				(
					(yyvsp[(-4) - (0)].idStr),
					sn
				);

				(yyval.en.s) = SymbolTable;
				SymbolTable->u.proc.Forward = NULL;
				SymbolTable->pType = tIterator;
				SymbolTable->Type = &iterID_ste;
				SymbolTable->SymClass = cIterator;
				CurrentContext = SymbolTable;

				/*
				** Save currentNS and then set it to NULL
				** so that local IDs don't wind up in the
				** namespace hash table.
				*/
				
				(yyval.en.cns) = currentNS;
				currentNS = NULL;

				/*
				** Enter second copy of procedure name at the next
				** lower lex level in order to prevent an immediately
				** local procedure from having the same name.
				*/

				++CurLexLevel;
				sn = hlastrdup2( StaticName );
				InsertProc
				(
					(yyvsp[(-4) - (0)].idStr),
					sn
				);
				SymbolTable->u.proc.Forward = NULL;
				SymbolTable->pType = tIterator;
				SymbolTable->Type = &iterID_ste;
				SymbolTable->SymClass = cIterator;
				CurOffset = StartParmOffs + 4;

				/*
				** For the moment, return the pointer to the local
				** entry of this procedure in the proc.parms pointer
				** so the caller can fill in appropriate fields in
				** the local entry as well as the main entry for this
				** procedure.
				*/

				(yyval.en.s)->u.proc.parms = SymbolTable;

				/*
				** Create the "_initialize_" and "_finalize_" text symbols 
				** used to emit initialization code later on.
				*/

				dummy.v.u.strval = hlastrdup2( "" );
				InsertSym
				( 
					"_initialize_", 
					&string_ste,	/* This is a STRING object.		*/
					tString,
					cValue, 
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					YYS &dummy,		/* Initially, no initialization	*/
					0,				/* Object size					*/
					0,				/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);

				dummy.v.u.strval = hlastrdup2( "" );
				InsertSym
				( 
					"_finalize_", 
					&string_ste,	/* This is a STRING object.		*/
					tString,
					cValue, 
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					YYS &dummy,		/* Initially, no initialization	*/
					0,				/* Object size					*/
					0,				/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);
				_here;
			;}
    break;

  case 941:

/* Line 1464 of yacc.c  */
#line 42262 "hlaparse.bsn"
    {
				(yyval.s) = CurrentContext;
				_here;
			;}
    break;

  case 942:

/* Line 1464 of yacc.c  */
#line 42310 "hlaparse.bsn"
    {
			_here;
			inType = (yyvsp[(1) - (2)].i);
			_here;
		;}
    break;

  case 943:

/* Line 1464 of yacc.c  */
#line 42318 "hlaparse.bsn"
    {
			_here;
			(yyval.i) = inType;
			inType = 1;

			/*
			** "Prime" fastLookup for the first identifier we encounter:
			*/
			
			fastLookup = 1;
			
		;}
    break;

  case 944:

/* Line 1464 of yacc.c  */
#line 42343 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 945:

/* Line 1464 of yacc.c  */
#line 42348 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 946:

/* Line 1464 of yacc.c  */
#line 42371 "hlaparse.bsn"
    {
				_here;
			;}
    break;

  case 947:

/* Line 1464 of yacc.c  */
#line 42385 "hlaparse.bsn"
    {				/* $8 */

			union YYSTYPE v;

			_here;
			assert( (yyvsp[(1) - (7)].idStr) != NULL );
			assert( (yyvsp[(5) - (7)].idStr) != NULL );

			v.v.u.strval = (yyvsp[(1) - (7)].idStr);
			InsertSym
			( 
				(yyvsp[(5) - (7)].idStr), 
				&text_ste,
				tText, 
				cConstant, 
				0,				/* arity 			*/
				NULL,			/* NumDimensions	*/
				0, 				/* NumElements		*/
				YYS &v,
				4,				/* ObjectSize		*/
				0,
				NULL,
				NULL,			/* Base				*/
				NULL,			/* Fields			*/
				0				/* FieldCnt			*/ 
			);

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;
		;}
    break;

  case 948:

/* Line 1464 of yacc.c  */
#line 42432 "hlaparse.bsn"
    {				/* $4 */
				_here;
				assert( (yyvsp[(1) - (3)].idStr) != NULL );

				/*
				** Insert the type name into the symbol table.
				*/

				InsertSym
				( 
					(yyvsp[(1) - (3)].idStr), 
					NULL,		/* Treat like a primitive type (NULL type) */
					tEnum, 
					cType, 
					0,
					NULL,
					0, 
					NULL,
					EnumSize,
					0,
					NULL,
					NULL,
					NULL,
					0
				);

				/*
				** Initialize EnumVal to zero so we can assign
				** successive values to the following named constants.
				*/

				EnumVal = 0;
				(yyval.s) = SymbolTable;

			;}
    break;

  case 949:

/* Line 1464 of yacc.c  */
#line 42468 "hlaparse.bsn"
    {
				/*
				** Set up an inherited attribute (parameter) for the
				** EnumList non-terminal.  This must be the address
				** of the symbol table entry created above.  Note that
				** the global SymbolTable pointer is currently pointing
				** at the symbol table entry for the type name we just
				** entered into the symbol table.
				*/

				(yyval.v.Type) = SymbolTable;
				_here;
			;}
    break;

  case 950:

/* Line 1464 of yacc.c  */
#line 42489 "hlaparse.bsn"
    {
				// Patch a pointer to the list of enumerated constant names
				// into the symbol table entry for the enumerated type:
				
				(yyvsp[(4) - (9)].s)->Fields = SymbolTable;
				(yyvsp[(4) - (9)].s)->FieldCnt = EnumVal;

				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				(void) (yyvsp[(6) - (9)].v.Type); // shut up bison
				_here;
			;}
    break;

  case 951:

/* Line 1464 of yacc.c  */
#line 42520 "hlaparse.bsn"
    {					/* $7 */

				SymNode_t			*BaseType;

				char	*UndefinedID = (yyvsp[(1) - (6)].idStr);
			
				assert( UndefinedID != NULL );
				assert( (yyvsp[(5) - (6)].neID.idStr) != NULL );


				_here;
				BaseType = (yyvsp[(5) - (6)].neID.s);
				_if( BaseType != NULL )

					BaseType = GetBaseType( BaseType );

				_endif
				InsertSym
				( 
					UndefinedID,		/* Name			*/
					&pointer_ste,		/* Type			*/
					tPointer, 			/* pType		*/
					cType,				/* SymClass		*/
					0,					/* Arity		*/
					NULL,				/* Dimensions	*/
					0, 					/* NumElements	*/
					NULL,				/* Value		*/
					4,					/* ObjectSize	*/
					0,					/* Offset		*/
					NULL,				/* StaticName	*/
					BaseType,			/* BaseType		*/
					NULL,				/* Fields		*/
					0					/* FieldCnt		*/
				);
				_if( BaseType == NULL )
				
					Add2PtrList( SymbolTable, (yyvsp[(5) - (6)].neID.idStr) );

				_endif

				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				_here;
			;}
    break;

  case 952:

/* Line 1464 of yacc.c  */
#line 42578 "hlaparse.bsn"
    {					/* $7 */

			
				assert( (yyvsp[(1) - (6)].idStr) != NULL );
				_here;
				InsertSym
				( 
					(yyvsp[(1) - (6)].idStr),			/* Name			*/
					&pointer_ste,		/* Type			*/
					tPointer, 			/* pType		*/
					cType,				/* SymClass		*/
					0,					/* Arity		*/
					NULL,				/* Dimensions	*/
					0, 					/* NumElements	*/
					NULL,				/* Value		*/
					4,					/* ObjectSize	*/
					0,					/* Offset		*/
					NULL,				/* StaticName	*/
					(yyvsp[(5) - (6)].s),				/* BaseType		*/
					NULL,				/* Fields		*/
					0					/* FieldCnt		*/
				);

				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				_here;
			;}
    break;

  case 953:

/* Line 1464 of yacc.c  */
#line 42614 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &boolean_ste;
		;}
    break;

  case 954:

/* Line 1464 of yacc.c  */
#line 42620 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &int8_ste;
		;}
    break;

  case 955:

/* Line 1464 of yacc.c  */
#line 42626 "hlaparse.bsn"
    {
			(yyval.s) = &int16_ste;
		;}
    break;

  case 956:

/* Line 1464 of yacc.c  */
#line 42631 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &int32_ste;
		;}
    break;

  case 957:

/* Line 1464 of yacc.c  */
#line 42637 "hlaparse.bsn"
    {
			(yyval.s) = &int64_ste;
		;}
    break;

  case 958:

/* Line 1464 of yacc.c  */
#line 42642 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &int128_ste;
		;}
    break;

  case 959:

/* Line 1464 of yacc.c  */
#line 42648 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &char_ste;
		;}
    break;

  case 960:

/* Line 1464 of yacc.c  */
#line 42654 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &wchar_ste;
		;}
    break;

  case 961:

/* Line 1464 of yacc.c  */
#line 42660 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &real32_ste;
		;}
    break;

  case 962:

/* Line 1464 of yacc.c  */
#line 42666 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &real64_ste;
		;}
    break;

  case 963:

/* Line 1464 of yacc.c  */
#line 42672 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &real80_ste;
		;}
    break;

  case 964:

/* Line 1464 of yacc.c  */
#line 42678 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &real128_ste;
		;}
    break;

  case 965:

/* Line 1464 of yacc.c  */
#line 42684 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &uns8_ste;
		;}
    break;

  case 966:

/* Line 1464 of yacc.c  */
#line 42690 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &uns16_ste;
		;}
    break;

  case 967:

/* Line 1464 of yacc.c  */
#line 42696 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &uns32_ste;
		;}
    break;

  case 968:

/* Line 1464 of yacc.c  */
#line 42702 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &uns64_ste;
		;}
    break;

  case 969:

/* Line 1464 of yacc.c  */
#line 42708 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &uns128_ste;
		;}
    break;

  case 970:

/* Line 1464 of yacc.c  */
#line 42714 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &string_ste;
		;}
    break;

  case 971:

/* Line 1464 of yacc.c  */
#line 42720 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &zstring_ste;
		;}
    break;

  case 972:

/* Line 1464 of yacc.c  */
#line 42726 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &wstring_ste;
		;}
    break;

  case 973:

/* Line 1464 of yacc.c  */
#line 42732 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &cset_ste;
		;}
    break;

  case 974:

/* Line 1464 of yacc.c  */
#line 42738 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &byte_ste;
		;}
    break;

  case 975:

/* Line 1464 of yacc.c  */
#line 42744 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &word_ste;
		;}
    break;

  case 976:

/* Line 1464 of yacc.c  */
#line 42750 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &dword_ste;
		;}
    break;

  case 977:

/* Line 1464 of yacc.c  */
#line 42756 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &qword_ste;
		;}
    break;

  case 978:

/* Line 1464 of yacc.c  */
#line 42762 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &tbyte_ste;
		;}
    break;

  case 979:

/* Line 1464 of yacc.c  */
#line 42768 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &lword_ste;
		;}
    break;

  case 980:

/* Line 1464 of yacc.c  */
#line 42774 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = &thunk_ste;
		;}
    break;

  case 981:

/* Line 1464 of yacc.c  */
#line 42788 "hlaparse.bsn"
    {

			SymNode_t *saveSym;
			
			_here;
			assert( (yyvsp[(-4) - (0)].idStr) != NULL );
			InsertSym
			( 

				(yyvsp[(-4) - (0)].idStr),
				&proctype_ste,
				tProcptr, 
				cType, 
				0,
				NULL,
				0, 
				NULL,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			(yyval.s) = SymbolTable;
			CurOffset = StartParmOffs;
			++CurLexLevel;

			/*
			** Reinsert the symbol into the local symbols
			** to keep the logic of this program happy.
			*/

			saveSym = currentNS;	// Do not enter this second
			currentNS = NULL;		//  symbol into the hash table!
			InsertSym
			( 
				(yyvsp[(-4) - (0)].idStr),
				&proctype_ste,
				tProcptr, 
				cType, 
				0,
				NULL,
				0, 
				NULL,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			currentNS = saveSym;

			/*
			** Temporary assignment so we can patch the local
			** entry later.
			*/

			(yyval.s)->u.proc.parms = SymbolTable;
			(yyval.s)->u.proc.returns = hlastrdup2( "" );
			(yyval.s)->u.proc.use = NULL;
			_here;
		;}
    break;

  case 982:

/* Line 1464 of yacc.c  */
#line 42891 "hlaparse.bsn"
    {				/* $10 */

			union YYSTYPE value;
			
			_here;
			--CurLexLevel;
			CurOffset = (yyvsp[(4) - (9)].v.u.unsval);
			CurOffsetDir = (yyvsp[(5) - (9)].v.u.unsval);
			CheckLegalOptions
			( 
				(yyvsp[(9) - (9)].options.SpecifiedOptions),
					specified_returns
				|	specified_use
				|	specified_pascal
				|	specified_stdcall
				|	specified_cdecl
				|	specified_alignment 
			);
			(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
			(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (9)].options.use);
			(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.ParmSize = (yyvsp[(7) - (9)].v.u.unsval);

			(yyvsp[(6) - (9)].s)->u.proc.parms = SymbolTable;
			(yyvsp[(6) - (9)].s)->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
			(yyvsp[(6) - (9)].s)->u.proc.use = (yyvsp[(9) - (9)].options.use);
			(yyvsp[(6) - (9)].s)->u.proc.cs = (yyvsp[(9) - (9)].options.CallingSequence);
			(yyvsp[(6) - (9)].s)->u.proc.ParmSize = (yyvsp[(7) - (9)].v.u.unsval);

			/*
			** Just to be on the safe side, let's create
			** a "parms" and "vars" entry for this object.
			*/
			
			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.v.u.unsval = (yyvsp[(7) - (9)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			value.v.u.unsval = 0;
			InsertSym
			( 
				"_vars_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.Locals = SymbolTable;
			(yyvsp[(6) - (9)].s)->u.proc.Locals = SymbolTable;
			
			SymbolTable = (yyvsp[(6) - (9)].s);

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;
		;}
    break;

  case 983:

/* Line 1464 of yacc.c  */
#line 43021 "hlaparse.bsn"
    {							/* $10 */

			union YYSTYPE value;
			
			_here;
			--CurLexLevel;
			CurOffset = (yyvsp[(4) - (9)].v.u.unsval);
			CurOffsetDir = (yyvsp[(5) - (9)].v.u.unsval);
			CheckLegalOptions
			( 
				(yyvsp[(8) - (9)].options.SpecifiedOptions),
					specified_returns
				|	specified_use
				|	specified_pascal
				|	specified_stdcall
				|	specified_cdecl
				|	specified_alignment 
			);
			(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.returns = (yyvsp[(8) - (9)].options.returns);
			(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.use = (yyvsp[(8) - (9)].options.use);

			(yyvsp[(6) - (9)].s)->u.proc.parms = SymbolTable;
			(yyvsp[(6) - (9)].s)->u.proc.returns = (yyvsp[(8) - (9)].options.returns);
			(yyvsp[(6) - (9)].s)->u.proc.use = (yyvsp[(8) - (9)].options.use);
			(yyvsp[(6) - (9)].s)->u.proc.cs = (yyvsp[(8) - (9)].options.CallingSequence);
			
			/*
			** Just to be on the safe side, let's create
			** a "parms" and "vars" entry for this object.
			*/
			
			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.v.u.unsval = (yyvsp[(7) - (9)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			value.v.u.unsval = 0;
			InsertSym
			( 
				"_vars_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.Locals = SymbolTable;
			(yyvsp[(6) - (9)].s)->u.proc.Locals = SymbolTable;
			
			SymbolTable = (yyvsp[(6) - (9)].s);

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;
		;}
    break;

  case 984:

/* Line 1464 of yacc.c  */
#line 43138 "hlaparse.bsn"
    {				/* $8 */
			
			_here;
			assert( (yyvsp[(1) - (7)].idStr) != NULL );
			CreatePtrToProc( (yyvsp[(1) - (7)].idStr), (yyvsp[(6) - (7)].s), NULL, cType );

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;
		;}
    break;

  case 985:

/* Line 1464 of yacc.c  */
#line 43169 "hlaparse.bsn"
    {
				SymNode_t 	*BaseType;
				SymNode_t 	*next;
				char		*name;
				char		*trueName;
			
				_here;
				assert( (yyvsp[(1) - (4)].idStr) != NULL );

				/*
				** If TypeID is an isomorphism for some other type,
				** then its type field will point at the most
				** primitive type representing the complete transitive
				** closure of its type (i.e., following the type
				** chain down to the root as long as there are type
				** isomorphisms).  Once a non-primitive type enters
				** the equation, the TypeID field will contain NULL
				** (e.g., for a record object).
				**
				** Note, since all type IDs are maintained this
				** way, there is never more than one level we
				** have to seek (at most) only one link down
				** from TypeID.
				**
				** Hence, if TypeID's Type field is NULL, then
				** using TypeID's address as the type of this new
				** symbol  If TypeID's Type field is non-Null,
				** then use TypeID's Type field as the type of the
				** new object.
				*/

				BaseType = GetBaseType( (yyvsp[(3) - (4)].s) );
				InsertSym
				( 
					(yyvsp[(1) - (4)].idStr),
					BaseType, 
					(yyvsp[(3) - (4)].s)->pType, 
					cType, 
					(yyvsp[(3) - (4)].s)->Arity,
					(yyvsp[(3) - (4)].s)->Dimensions,
					(yyvsp[(3) - (4)].s)->NumElements, 
					NULL,
					(yyvsp[(3) - (4)].s)->ObjectSize,
					0,
					NULL,
					(yyvsp[(3) - (4)].s)->Base,
					(yyvsp[(3) - (4)].s)->Fields,
					(yyvsp[(3) - (4)].s)->FieldCnt
				);
				SymbolTable->MaxObjectSize = (yyvsp[(3) - (4)].s)->MaxObjectSize;
				_if( (yyvsp[(3) - (4)].s)->pType == tProcptr )
				
					// Copy parameter info if a proc ptr.
					
					memcpy
					( 
						&SymbolTable->u, 
						&(yyvsp[(3) - (4)].s)->u, 
						sizeofValuesSize
					);
					
				_endif

				/*
				** Copy any data (e.g., procedure "returns" value) to
				** the new type.
				*/

				memcpy
				(
					&SymbolTable->u.StartOfValues,
					&BaseType->u.StartOfValues,
					sizeofValuesSize
				);


				/*
				** If it's a class object, copy the fields.
				*/

				_if( BaseType->pType == tClass )

					SymbolTable->Fields = 
						CopySymbols
						( 
							BaseType->Fields,
							BaseType->StaticName
						);
					SymbolTable->StaticName = hlastrdup2( BaseType->StaticName );
					NullTerminate( SymbolTable->Fields, SymbolTable );

				_elseif(  BaseType->pType == tThunk )

					/*
					** Need some dummy local vars for a thunk.
					*/

					SymbolTable->u.proc.parms = &true_ste;

				_endif


				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				_here;
			;}
    break;

  case 986:

/* Line 1464 of yacc.c  */
#line 43304 "hlaparse.bsn"
    {
				int	Size = 1;

				_here;
				assert( (yyvsp[(3) - (7)].s) != NULL );
				assert( (yyvsp[(1) - (7)].idStr) != NULL );

				/*
				** Text arrays are illegal.  Deal with that here.
				*/

				_if( (yyvsp[(3) - (7)].s)->pType == tText )

					assert( (yyvsp[(5) - (7)].v.Dimensions) != NULL );
					yyerror( "Text arrays are illegal" );
					free2( vss (yyvsp[(5) - (7)].v.Dimensions) );
				

				/*
				** If TypeID is not an array type, then we've got an
				** array of some scalar type.
				*/

				_elseif( (yyvsp[(3) - (7)].s)->pType != tArray )

					SymNode_t *TheType;

					/*
					** Compute the total size (in bytes) of the array.
					*/

					Size = 	(yyvsp[(3) - (7)].s)->ObjectSize * (yyvsp[(5) - (7)].v.NumElements);

					/*
					** Compute the type of an array element.
					** (If Type field is NULL, it's a base type, else it's
					** a some derived type).
					*/

					TheType = GetBaseType( (yyvsp[(3) - (7)].s) );

					
					// Insert the new type definition into the symbol table.
					
					InsertSym
					( 
						(yyvsp[(1) - (7)].idStr), 
						TheType,
						tArray, 
						cType, 
						(yyvsp[(5) - (7)].v.Arity),
						(yyvsp[(5) - (7)].v.Dimensions),
						(yyvsp[(5) - (7)].v.NumElements), 
						NULL,
						Size,
						0,
						NULL,
						(yyvsp[(3) - (7)].s)->Base,
						(yyvsp[(3) - (7)].s)->Fields,
						(yyvsp[(3) - (7)].s)->FieldCnt
					);
					_if( (yyvsp[(3) - (7)].s)->pType == tProcptr )
					
						// Copy parameter info if a proc ptr.
						
						memcpy
						( 
							&SymbolTable->u, 
							&(yyvsp[(3) - (7)].s)->u, 
							sizeofValuesSize
						);
						
					_endif
					
					/*
					** For arrays, the MaxObjectSize field must
					** be the MaxObjectSize of an element
					*/
					
					SymbolTable->MaxObjectSize = (yyvsp[(3) - (7)].s)->MaxObjectSize; 

					/*
					** Copy any data (e.g., procedure "returns" value) to
					** the new type.
					*/

					memcpy
					(
						&SymbolTable->u.StartOfValues,
						&TheType->u.StartOfValues,
						sizeofValuesSize
					);

					/*
					** Handle the case where the base type is a class.
					*/

					_if( TheType->pType == tClass )

						SymbolTable->Fields = 
							CopySymbols
							( 
								TheType->Fields,
								TheType->StaticName
							);
							
						SymbolTable->StaticName = 
							hlastrdup2( TheType->StaticName );
							
						NullTerminate( SymbolTable->Fields, SymbolTable );

					_elseif(  TheType->pType == tThunk )

						/*
						** Need some dummy local vars for a thunk.
						*/

						SymbolTable->u.proc.parms = &true_ste;


					_endif



				/*
				** If TypeID is an array type, then we're creating
				** an array of arrays (i.e., a multidimensional array).
				** The following code handles this case.
				*/

				_else

					int 		*DimensionArray;
					SymNode_t 	*TheType;

					/*
					** Create a dimension array big enough to hold
					** the indexes from TypeID plus the indexes the
					** current production is adding.
					*/

					DimensionArray = 
						malloc2
						( 
							( (yyvsp[(3) - (7)].s)->Arity + (yyvsp[(5) - (7)].v.NumElements) ) * 
								sizeofInt 
						);


					/*
					** Copy TypeID's dimension list to the new
					** dimension list.
					*/

					assert( (yyvsp[(3) - (7)].s)->Dimensions != NULL );
					memcpy
					( 
						DimensionArray, 
						(yyvsp[(3) - (7)].s)->Dimensions, 
						(yyvsp[(3) - (7)].s)->Arity * sizeofInt 
					);

					/*
					** Append the new dimension list to the end of TypeID's.
					*/			   

					assert( (yyvsp[(5) - (7)].v.Dimensions) != NULL );
					memcpy
					(
						&DimensionArray[ (yyvsp[(3) - (7)].s)->Arity ],
						(yyvsp[(5) - (7)].v.Dimensions),
						(yyvsp[(5) - (7)].v.Arity) * sizeofInt 
					);

					/*
					** Compute and save the base type of an array element.
					*/

					TheType =	GetBaseType( (yyvsp[(3) - (7)].s) );

					/*
					** Insert this new array type into the symbol table.
					*/

					InsertSym
					( 
						(yyvsp[(1) - (7)].idStr), 
						TheType,
						tArray, 
						cType, 
						(yyvsp[(3) - (7)].s)->Arity + (yyvsp[(5) - (7)].v.Arity),
						DimensionArray,
						(yyvsp[(3) - (7)].s)->NumElements * (yyvsp[(5) - (7)].v.NumElements), 
						NULL,
						(yyvsp[(3) - (7)].s)->ObjectSize * (yyvsp[(5) - (7)].v.NumElements),
						0,
						NULL,
						(yyvsp[(3) - (7)].s)->Base,
						(yyvsp[(3) - (7)].s)->Fields,
						(yyvsp[(3) - (7)].s)->FieldCnt
					);
					_if( (yyvsp[(3) - (7)].s)->pType == tProcptr )
					
						// Copy parameter info if a proc ptr.
						
						memcpy
						( 
							&SymbolTable->u, 
							&(yyvsp[(3) - (7)].s)->u, 
							sizeofValuesSize
						);
						
					_endif

					/*
					** Copy any data (e.g., procedure "returns" value) to
					** the new type.
					*/

					memcpy
					(
						&SymbolTable->u.StartOfValues,
						&TheType->u.StartOfValues,
						sizeofValuesSize
					);

					/*
					** Handle the case where the base type is a class.
					*/

					_if( TheType->pType == tClass )

						SymbolTable->Fields = 
							CopySymbols
							( 
								TheType->Fields,
								TheType->StaticName
							);
						SymbolTable->StaticName = 
							hlastrdup2( TheType->StaticName );
							
						NullTerminate( SymbolTable->Fields, SymbolTable );

					_elseif(  TheType->pType == tThunk )

						/*
						** Need some dummy local vars for a thunk.
						*/

						SymbolTable->u.proc.parms = &true_ste;


					_endif


					/*
					** Free the dimension list array because we're
					** not going to use it.  Note that we don't
					** free TypeID's dimension list because TypeID
					** is still using it.
					*/

					free2( vss (yyvsp[(5) - (7)].v.Dimensions) );

				_endif


				/*
				** "Prime" fastLookup for the next identifier we encounter:
				*/
				
				fastLookup = 1;
				_here;
			;}
    break;

  case 987:

/* Line 1464 of yacc.c  */
#line 43624 "hlaparse.bsn"
    {
			SymNode_t		*Fields;
			SymNode_t		TheValue;
			int				FieldCnt;
			int				LargestField;
			int				RecSize;
			int				fieldCntr;

			/*
			** Restore currentNS before we enter this record
			** type into the symbol table.
			*/
			
			_here;
			currentNS = (yyvsp[(3) - (8)].ru.saveCurNS);
			RecNS = (yyvsp[(3) - (8)].ru.saveRecNS);
			RecGlobal = (yyvsp[(3) - (8)].ru.saveRecGlobal);

			/*
			** Make sure there was at least one field in the record.
			*/

			_if( RecFieldCnt != 0 )


				SymNode_t	*CurSym;


				
				/*
				** We need to mark the end of the fields symbol list.  
				** This is all the entries in the symbol table from
				** SymbolTable through the pointer to the record
				** sym tbl entry saved above.
				**
				** While traversing the fields, we'll also compute
				** the size of the largest field (for alignment
				** purposes).
				*/

				FieldCnt = 1;

				CurSym = SymbolTable;
				LargestField = 0;
				_while
				( 
						CurSym->Next != NULL 
					&&	CurSym->Next != &dummyField_ste 
				)

					LargestField = max( LargestField, CurSym->MaxObjectSize );
					CurSym = CurSym->Next;
					++FieldCnt;

				_endwhile
				LargestField = max( LargestField, CurSym->MaxObjectSize );
				CurSym->Next = NULL;


				/*
				** Okay, create the record symbol table entry
				** and attach the fields symbol table to that entry.
				*/


				CurLexLevel = (yyvsp[(3) - (8)].ru.SaveLex);
				Fields = SymbolTable;
				SymbolTable = (yyvsp[(3) - (8)].ru.endFields);
				RecSize = CurOffset - (yyvsp[(3) - (8)].ru.CurOffset);
				
				/*
				** If there was an align at the end of the
				** record, then we need to extend the size
				** of the record so that it is aligned on
				** the specified boundary.
				*/

				_if( TempRecAlign != 1 )
				

					RecSize = 
							(
									(RecSize + TempRecAlign - 1) 
								/ 	TempRecAlign 
							) * TempRecAlign;
							
					TempRecAlign = 1;

				_endif
					
					

				TheValue.u.intval = RecSize;
				InsertSym
				(
					(yyvsp[(1) - (8)].idStr),

					NULL,
					tRecord,
					cType,
					0,
					NULL,
					FieldCnt,
					YYS &TheValue,
					RecSize,
					0,
					NULL,
					(yyvsp[(3) - (8)].ru.base),
					Fields,
					FieldCnt
				);
				SymbolTable->MaxObjectSize = LargestField;
				
				// Now we need to go through all the fields and
				// patch the "Parent" field to point at this
				// symbol table entry.
				
				_for( int fieldCntr = 0, fieldCntr < FieldCnt, ++fieldCntr )
				
					Fields->Parent = SymbolTable;
					Fields = Fields->Next;
					
				_endfor
				 

			_else	/* There were no fields in this record */

				CurLexLevel = (yyvsp[(3) - (8)].ru.SaveLex);
				yyerror
				( 
					"Records must contain at least one field" 
				);

			_endif

			/*
			** Patch any forward referenced pointers that
			** may reference the newly created record
			*/
			
			PatchPtrs();

			/*
			** Restore the following to their previous values
			** (prior to processing the fields in the record).
			*/

			CurOffset = (yyvsp[(3) - (8)].ru.SaveOffset);
			CurOffsetDir = (yyvsp[(3) - (8)].ru.SaveDir);
			AddOffset1st = (yyvsp[(3) - (8)].ru.SaveAdd1st);
			inRecord = (yyvsp[(3) - (8)].ru.inSave);
			MinRecAlignment = (yyvsp[(3) - (8)].ru.MinRecAlignment);
			MaxRecAlignment = (yyvsp[(3) - (8)].ru.MaxRecAlignment);
			RecFieldCnt = (yyvsp[(3) - (8)].ru.RecFieldCnt);
			_here;
		;}
    break;

  case 988:

/* Line 1464 of yacc.c  */
#line 43804 "hlaparse.bsn"
    {
			int				SizeOfUnion;
			int				FieldCnt;
			SymNode_t		*Fields;
			SymNode_t		TheValue;
			SymNode_t		*CurSym;
			  
			_here;
			
			/*
			** Restore currentNS before we enter this union
			** type into the symbol table.
			*/
			
			currentNS = (yyvsp[(3) - (6)].ru.saveCurNS);
			RecNS = (yyvsp[(3) - (6)].ru.saveRecNS);
			RecGlobal = (yyvsp[(3) - (6)].ru.saveRecGlobal);

			/*
			** Determine if there were any fields present in
			** the union.
			*/

			_if( RecFieldCnt == 0 )

				yyerror( "Unions must have at least one field" );
				CurLexLevel = (yyvsp[(3) - (6)].ru.SaveOffset);

			_else

				/*
				** Null terminate the list of fields in the union.
				** Since inheritence is not possible, just search
				** for the Union ID's symbol table entry to determine
				** the end of the union field list.
				*/

				CurSym = SymbolTable;
				SizeOfUnion = 0;
				FieldCnt = 0;
				_while
				( 
						CurSym->Next != NULL 
					&&	CurSym->Next != &dummyField_ste 
				)					
				

					SizeOfUnion = 
						max( SizeOfUnion, CurSym->ObjectSize);
					
					_if( CurSym->pType != tAnonRec )
					
						++FieldCnt;
					
					_endif
					CurSym = CurSym->Next;

				_endwhile
				CurSym->Next = NULL;
				_if( CurSym->pType != tAnonRec )
				
					++FieldCnt;
				
				_endif
				SizeOfUnion = 
					max( SizeOfUnion, CurSym->ObjectSize);

				/*
				** Okay, create the union symbol table entry
				** and attach the fields symbol table to that entry.
				*/

				CurLexLevel = (yyvsp[(3) - (6)].ru.SaveLex);
				Fields = SymbolTable;
				SymbolTable = (yyvsp[(3) - (6)].ru.endFields);
				TheValue.u.intval = SizeOfUnion;
				InsertSym
				(
					(yyvsp[(1) - (6)].idStr),
					NULL,
					tUnion,
					cType,
					0,
					NULL,
					0,
					YYS &TheValue,
					SizeOfUnion,
					0,
					NULL,
					NULL,
					Fields,
					FieldCnt
				);

			_endif

			/*
			** Restore remaining compiler variable not already
			** restored above.
			*/

			CurOffset = (yyvsp[(3) - (6)].ru.SaveOffset);
			CurOffsetDir = (yyvsp[(3) - (6)].ru.SaveDir);
			AddOffset1st = (yyvsp[(3) - (6)].ru.SaveAdd1st);
			inUnion = (yyvsp[(3) - (6)].ru.inSave);
			RecFieldCnt = (yyvsp[(3) - (6)].ru.RecFieldCnt);
			MinRecAlignment = (yyvsp[(3) - (6)].ru.MinRecAlignment);
			MaxRecAlignment = (yyvsp[(3) - (6)].ru.MaxRecAlignment);
			inUnion = (yyvsp[(3) - (6)].ru.inSave);

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;
		;}
    break;

  case 989:

/* Line 1464 of yacc.c  */
#line 43964 "hlaparse.bsn"
    {				/* $10 */

			SymNode_t	*theClass;
			SymNode_t	TheValue;
			char		StaticName[ 256 ];
			char		*sn;

			_here;
			
			/*
			** Put the name of the virtual method table (VMT)
			** in the StaticName field of this symbol.
			*/

			sprintf( StaticName, "_VMT_%s_" sympost, (yyvsp[(1) - (9)].idStr) );
			sn = hlastrdup2( StaticName );

			/*
			** Save the address of the class' symbol table entry
			** as the Symbol attribute for this semantic action.
			** We'll use this address later to determine which
			** symbol table entries are fields in the class.
			*/

			TheValue.u.intval = CurOffset;
			InsertSym
			(
				(yyvsp[(1) - (9)].idStr),
				NULL,
				tClass,
				cType,
				0,
				NULL,
				0,
				YYS &TheValue,
				CurOffset,
				0,
				sn,
				(yyvsp[(9) - (9)].s),
				NULL,
				0
			);
			(yyval.s) = SymbolTable;	// So we can find the end of the list later.
			ClassPtr = SymbolTable;
			
			
			// Patch any pointers to this class:
			
			PatchPtrs();


			/*
			** If this class is inheriting fields from a base class,
			** adjust the CurOffset value to the size of the base
			** class; otherwise set the CurOffset value to four and
			** add a VMT (virtual method table) pointer to the class.
			*/

			_if( (yyvsp[(9) - (9)].s) == NULL )


				/*
				** No fields to inherit, so create an entry for
				** the VMT.
				*/

				SymNode_t v;
						 
				TheValue.u.strval = hlastrdup2( StaticName );
				InsertSym
				(
					"_VMT_",			/* Name,		 */
					&dword_ste,			/* TheType,		 */
					tDWord,				/* pType,		 */
					cStatic,			/* TheClass,	 */
					0,					/* Arity,		 */
					NULL,				/* Dimensions,	 */
					0,					/* NumElements,	 */
					YYS &TheValue,		/* TheValue,	 */
					4,					/* ObjectSize,	 */
					0,					/* Offset,		 */
					hlastrdup2(StaticName),/* StaticName,	 */
					NULL,				/* Base,		 */
					NULL,				/* Fields,		 */
					0					/* FieldCnt		 */
				);
				EmitVMTExtern( SymbolTable, sn );
				SymbolTable->IsExternal = 1;


				v.u.strval = hlastrdup2( "_pVMT_" );
				CurOffset = 4;
				InsertSym
				(
					"_pVMT_",
					&pointer_ste,
					tPointer,
					cVar,
					0,
					NULL,
					0,
					YYS &v,
					4,
					0,
					hlastrdup2( StaticName ),
					&dword_ste,
					NULL,
					0
				);


			_else

				SymNode_t *vmt;
				SymNode_t *s;
				
				/*
				** Okay, we're inheriting fields.  Copy the fields
				** from the base type to this class (we have to do
				** this because someone might change the values
				** of the VAL objects and we don't want those changes
				** to be global).
				*/

				SymbolTable = CopySymbols( (yyvsp[(9) - (9)].s)->Fields, sn );
				
				// Must search for the VMT entry:
				
				s = SymbolTable;
				vmt = NULL;
				_while( s != (yyval.s) )
				
					vmt = s;
					s=s->Next;
					
				_endwhile;
 
				
				// The first entry is always the VMT:
				
				EmitVMTExtern( vmt, sn );
				
				CurOffset = (yyvsp[(9) - (9)].s)->ObjectSize;

				(yyval.s)->NumElements = (yyvsp[(9) - (9)].s)->NumElements;
				(yyval.s)->Base = (yyvsp[(9) - (9)].s);
				(yyval.s)->Fields = SymbolTable;
				(yyval.s)->FieldCnt = (yyvsp[(9) - (9)].s)->FieldCnt;
				(yyval.s)->LexLevel = (yyvsp[(6) - (9)].v.u.intval);
				(yyval.s)->u.intval = CurOffset;
				(yyval.s)->ObjectSize = CurOffset;


			_endif



			/*
			** Class fields have increasing offset values,
			** the first field is at offset four (to make room
			** for the VMT pointer), and fields don't
			** exist at the current program unit's lex level.
			*/

			CurOffsetDir = 1;
			AddOffset1st = 0;
			
			
			_here;

		;}
    break;

  case 990:

/* Line 1464 of yacc.c  */
#line 44136 "hlaparse.bsn"
    {					/* $12 */

			/*
			** Get the surrounding lex level for use by ClassStuff
			*/

			(yyval.v.u.intval) = (yyvsp[(6) - (11)].v.u.intval);
			_here;
		;}
    break;

  case 991:

/* Line 1464 of yacc.c  */
#line 44148 "hlaparse.bsn"
    {				/* $16 */

			SymNode_t		*classSym;
			SymNode_t		*CurSym;
			int				FieldCnt;
			char			StaticName[ 256 ];

			_here;
			
			/*
			** We need to mark the end of the fields symbol list.  
			** This is all the entries in the symbol table from
			** SymbolTable through the pointer to the record
			** sym tbl entry saved above.
			*/

			FieldCnt = 1;
			CurSym = SymbolTable;
			_while( CurSym->Next != NULL && CurSym->Next != (yyvsp[(10) - (15)].s) )

				CurSym = CurSym->Next;
				++FieldCnt;

			_endwhile
			CurSym->Next = NULL;
			classSym = (yyvsp[(10) - (15)].s);		// Ptr to original class entry.


			/*
			** Okay, create the class symbol table entry
			** and attach the field's symbol table to that entry.
			*/


			CurLexLevel = (yyvsp[(6) - (15)].v.u.intval);
			classSym->NumElements = FieldCnt;
			classSym->u.intval = CurOffset;
			classSym->ObjectSize = CurOffset;
			classSym->Base = (yyvsp[(9) - (15)].s);
			classSym->Fields = SymbolTable;
			classSym->FieldCnt = FieldCnt;
			classSym->LexLevel = (yyvsp[(6) - (15)].v.u.intval);
			SymbolTable = classSym;


			/*
			** Update the offset values in the class' method and iterator
			** fields.
			*/

			UpdateVMTOffsets( classSym );


			/*
			** Clean up any forward pointer declarations
			** that were handled within the class:
			*/
			
			PatchPtrs();
			
			/*
			** Restore the following to their previous values
			** (prior to processing the fields in the class).
			*/

			CurOffset = (yyvsp[(3) - (15)].v.u.intval);
			CurOffsetDir = (yyvsp[(4) - (15)].v.u.intval);
			AddOffset1st = (yyvsp[(5) - (15)].v.u.unsval);
			ClassPtr = (yyvsp[(6) - (15)].s);
			inClass = (yyvsp[(8) - (15)].v.u.unsval);

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			(void) (yyvsp[(12) - (15)].v.u.intval); // shut up bison
			_here;

		;}
    break;

  case 992:

/* Line 1464 of yacc.c  */
#line 44233 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.unsval) = inClass;
			inClass = 1;
		;}
    break;

  case 993:

/* Line 1464 of yacc.c  */
#line 44264 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Duplicate symbol definition", 
					(yyvsp[(1) - (6)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);

			;}
    break;

  case 994:

/* Line 1464 of yacc.c  */
#line 44283 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Duplicate symbol definition", 
					(yyvsp[(1) - (8)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);
				inRecord =	(yyvsp[(5) - (8)].ru.inSave);
				MinRecAlignment =	(yyvsp[(5) - (8)].ru.MinRecAlignment);
				MaxRecAlignment =	(yyvsp[(5) - (8)].ru.MaxRecAlignment);
				currentNS = (yyvsp[(3) - (8)].ru.saveCurNS);
				RecNS = (yyvsp[(3) - (8)].ru.saveRecNS);
				RecGlobal = (yyvsp[(3) - (8)].ru.saveRecGlobal);

			;}
    break;

  case 995:

/* Line 1464 of yacc.c  */
#line 44307 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Duplicate symbol definition", 
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);
				free2( vss (yyvsp[(3) - (7)].idStr) );
			;}
    break;

  case 996:

/* Line 1464 of yacc.c  */
#line 44322 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Duplicate symbol definition", 
					(yyvsp[(1) - (4)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);
				free2( vss (yyvsp[(3) - (4)].idStr) );
			;}
    break;

  case 997:

/* Line 1464 of yacc.c  */
#line 44341 "hlaparse.bsn"
    {
				ErrorNear
				( 			  
					"Duplicate symbol definition", 
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);

			;}
    break;

  case 998:

/* Line 1464 of yacc.c  */
#line 44360 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Undefined symbol", 
					(yyvsp[(3) - (7)].idStr),
					__LINE__,
					__FILE__ 
				);

			;}
    break;

  case 999:

/* Line 1464 of yacc.c  */
#line 44375 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Undefined symbol", 
					(yyvsp[(3) - (4)].idStr),
					__LINE__,
					__FILE__ 
				);

			;}
    break;

  case 1002:

/* Line 1464 of yacc.c  */
#line 44414 "hlaparse.bsn"
    {
			/*
			** The program is declaring a forward-referenced statement
			** label.  Enter the label into the forward reference list.
			*/

			struct FwdRefLabelType *flist;
			struct FwdRefLabelType *temp;
			char sn[ 256 ];

			_here;
			
			/*
			** First, let's see if there is already a reference
			** to this particular identifier so we can use the
			** existing StaticName.
			*/

			flist = FwdLabelsList;
			_while( flist != NULL )

				_breakif( _streq( (yyvsp[(2) - (4)].idStr), flist->label ));
				flist = flist->Next;

			_endwhile

			_if( flist == NULL && (yyvsp[(4) - (4)].returns) == NULL )

				/*
				** We didn't find the symbol in the forward reference
				** list and it's not an external label, so add it to the list.
				*/

				temp = malloc2( sizeofFwdRefLabelType );
				temp->Next = FwdLabelsList;
				temp->label = hlastrdup2( (yyvsp[(2) - (4)].idStr) );
				temp->lexLevel = CurLexLevel;
				sprintf( sn, "%s" sympost "%d", (yyvsp[(2) - (4)].idStr), LblCntr++ );
				temp->StaticName = hlastrdup2( sn );
				temp->isExternal = 0;
				temp->referenced = 0;
				FwdLabelsList = temp;
				
			_else
			
				_if( (yyvsp[(4) - (4)].returns) != NULL )
				
					// They've specified the @external option:
					
					_if( *(yyvsp[(4) - (4)].returns) == '\0' ) // No optional string.
					
						strcpy( sn, (yyvsp[(2) - (4)].idStr) );
						
					_else // Has optional string.
					
						strcpy( sn, (yyvsp[(4) - (4)].returns) );
						
					_endif
					
				_else
				
					// The symbol has been previously referenced but
					// is not yet defined.  Create a static name for it.
					
					sprintf( sn, "%s" sympost "%d", (yyvsp[(2) - (4)].idStr), LblCntr++ );
				
				_endif
			
				/*
				** Okay, it's an external label.  First check to
				** see if it appears in the forward reference
				** list.  If so, we've got to adjust the
				** static name for the label.
				*/
				
				_if( flist != NULL )
				
					EmitBackPatchss( flist->StaticName, sn, tLabel );
					free2( vss flist->StaticName );
					flist->StaticName = hlastrdup2( sn );
					
				_endif 
				InsertSym
				( 
					(yyvsp[(2) - (4)].idStr), 
					NULL,
					tLabel, 
					cLabel, 
					0,					/* Arity 		*/
					NULL,				/* Dimensions	*/
					0, 					/* NumElements	*/
					NULL,				/* Value		*/
					0,					/* ObjectSize	*/
					0,					/* Offset		*/
					hlastrdup2( sn ),	/* Static Name	*/
					NULL,				/* Base			*/
					NULL,				/* Fields		*/
					0					/* FieldCnt		*/
				);
				
				EmitTypedExtern( SymbolTable, sn, tLabel );				
				_if( (yyvsp[(4) - (4)].returns) != NULL )

					SymbolTable->IsExternal = 1;
					
				_endif
				
				// Set the type to NULL to indicate that
				// it's not been defined yet.
				
				SymbolTable->Type = NULL;
			
			_endif
			free2( vss (yyvsp[(4) - (4)].returns) );
			_here;
		;}
    break;

  case 1003:

/* Line 1464 of yacc.c  */
#line 44563 "hlaparse.bsn"
    {
			_here;
			inConst = (yyvsp[(1) - (2)].i);
		;}
    break;

  case 1004:

/* Line 1464 of yacc.c  */
#line 44570 "hlaparse.bsn"
    {
			_here;
			(yyval.i) = inConst;
			inConst = 1;

			/*
			** "Prime" fastLookup for the first identifier we encounter:
			*/
			
			fastLookup = 1;
		;}
    break;

  case 1005:

/* Line 1464 of yacc.c  */
#line 44590 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 1006:

/* Line 1464 of yacc.c  */
#line 44595 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 1007:

/* Line 1464 of yacc.c  */
#line 44626 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 1008:

/* Line 1464 of yacc.c  */
#line 44638 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1009:

/* Line 1464 of yacc.c  */
#line 44669 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (4)].idStr) != NULL );
			assert( (yyvsp[(3) - (4)].v.Type) != NULL );

			InsertSym
			( 
				(yyvsp[(1) - (4)].idStr), 
				(yyvsp[(3) - (4)].v.Type),
				(yyvsp[(3) - (4)].v.pType), 
				cConstant, 
				(yyvsp[(3) - (4)].v.Arity),
				(yyvsp[(3) - (4)].v.Dimensions),
				(yyvsp[(3) - (4)].v.NumElements), 
				YYS &(yyvsp[(3) - (4)].v),
				_ifx
				( 
					(yyvsp[(3) - (4)].v.pType) == tArray,
					(yyvsp[(3) - (4)].v.Type)->ObjectSize * (yyvsp[(3) - (4)].v.NumElements),
					(yyvsp[(3) - (4)].v.Type)->ObjectSize
				),
				0,
				NULL,
				(yyvsp[(3) - (4)].v.Base),
				(yyvsp[(3) - (4)].v.Fields),
				(yyvsp[(3) - (4)].v.FieldCnt) 
			);

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;

		;}
    break;

  case 1010:

/* Line 1464 of yacc.c  */
#line 44723 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(3) - (6)].s) != NULL );
			
			/*
			** Check to see if the TypeID and the ConstOnlyExpr (which
			** is an ID) are both arrays and if they are compatible.
			*/
				 
			_if( (yyvsp[(3) - (6)].s)->pType == tArray && (yyvsp[(5) - (6)].v.pType) == tArray )

				_if
				( 
					ArraysAreCompatible
					( 
						YYS (yyvsp[(3) - (6)].s), 
						YYS &(yyvsp[(5) - (6)].v) 
					)
				)

					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr), 
						GetBaseType( (yyvsp[(3) - (6)].s) ),
						tArray, 
						cConstant, 
						(yyvsp[(3) - (6)].s)->Arity,
						(yyvsp[(3) - (6)].s)->Dimensions,
						(yyvsp[(3) - (6)].s)->NumElements, 
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

				_else

					yyerror
					( 
						"Type mismatch of operands or "
						"value out of range in declaration" 
					);
					FreeValue( YYS &(yyvsp[(5) - (6)].v) );


				_endif


			/*
			** If it's not an array, check to see if it is
			** a record.
			*/

			_elseif( (yyvsp[(3) - (6)].s)->pType == tRecord && (yyvsp[(5) - (6)].v.pType) == tRecord )

				_if
				( 
					RecordsAreCompatible
					( 
						(yyvsp[(3) - (6)].s), 
						YYS &(yyvsp[(5) - (6)].v) 
					)
				)

					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr), 
						GetBaseType( (yyvsp[(3) - (6)].s) ),
						tRecord, 
						cConstant, 
						(yyvsp[(3) - (6)].s)->Arity,
						(yyvsp[(3) - (6)].s)->Dimensions,
						(yyvsp[(3) - (6)].s)->NumElements, 
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

				_else

					yyerror
					( 
						"Type mismatch of operands. Expected "
						"compatible record types" 
					);
					FreeValue( YYS &(yyvsp[(5) - (6)].v) );

				_endif


			/*
			** If it's not an array or record, check to see if it
			** is a primitive type (error if it's not).
			*/

			_elseif( IsNotPrimType( (yyvsp[(3) - (6)].s)->pType ))

				yyerror( "Constants can only have primitive types" );
				FreeValue( YYS &(yyvsp[(5) - (6)].v) );

			/*
			** Okay, we've got a primitive (scalar) type.  See if the
			** constant is compatible with the TypeID.  If so, enter
			** the symbol into the symbol table.
			*/

			_elseif( IsCompatible( (yyvsp[(3) - (6)].s), YYS &(yyvsp[(5) - (6)].v) ))

				InsertSym
				( 
					(yyvsp[(1) - (6)].idStr), 
					GetBaseType( (yyvsp[(3) - (6)].s) ),
					(yyvsp[(3) - (6)].s)->pType, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &(yyvsp[(5) - (6)].v),
					(yyvsp[(3) - (6)].s)->ObjectSize,
					0,
					NULL,
					NULL,
					NULL,
					0
				);

			_else

				yyerror
				( 
					"Type mismatch of operands or "
					"value out of range in declaration" 
				);
				FreeValue( YYS &(yyvsp[(5) - (6)].v) );

			_endif

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;
		;}
    break;

  case 1011:

/* Line 1464 of yacc.c  */
#line 44893 "hlaparse.bsn"
    {			/* $7 */
		
			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );

			/*
			** Set up some common synthesized attribute return values.
			*/

			(yyval.v.pType) = tArray;
			(yyval.v.Arity) = (yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.Arity);
			(yyval.v.Base) = (yyvsp[(3) - (6)].s)->Base;
			(yyval.v.Fields) = (yyvsp[(3) - (6)].s)->Fields;
			(yyval.v.FieldCnt) = (yyvsp[(3) - (6)].s)->FieldCnt;
			(yyval.v.Type) =GetBaseType( (yyvsp[(3) - (6)].s) );

			/*
			** Scream if the user is trying to define a text array.
			*/

			_if( (yyvsp[(3) - (6)].s)->pType == tText )

				yyerror( "Cannot have TEXT arrays" );
				(yyvsp[(3) - (6)].s) = &string_ste;

			_endif

			/*
			** If it's not a primitive scalar type, complain about
			** that and then fake a usable type.
			*/

			_if( !CanBeVal( (yyvsp[(3) - (6)].s)->pType ))

				yyerror( "Constants can only have primitive types" );
				(yyvsp[(3) - (6)].s) = &uns32_ste;

			_endif

			/*
			** If the TypeID isn't an array object, this is easy;
			** Just return the size of the array constant list.
			*/

			_if( (yyvsp[(3) - (6)].s)->pType != tArray )
			
				(yyval.v.NumElements) = (yyvsp[(5) - (6)].v.NumElements);
				(yyval.v.Dimensions) = (yyvsp[(5) - (6)].v.Dimensions);

			/*
			** On the other hand, if TypeID is an array object,
			** then we've got to add a new list of dimensions onto
			** the end of the TypeID list.
			*/

			_else

				/*
				** Compute the number of dimensions and elements in
				** the new type.
				*/

				(yyval.v.NumElements) = 
						(yyvsp[(3) - (6)].s)->NumElements * (yyvsp[(5) - (6)].v.NumElements);

				(yyval.v.Dimensions) =
					malloc2( (yyval.v.Arity) * sizeofInt );


				/*
				** Copy TypeID's dimensions to our Dimensions array.
				*/
				
				assert( (yyvsp[(3) - (6)].s)->Dimensions != NULL );
				memcpy
				( 
					(yyval.v.Dimensions), 
					(yyvsp[(3) - (6)].s)->Dimensions,
					(yyvsp[(3) - (6)].s)->Arity * sizeofInt 
				);

				/*
				** Concatenate the explict dimensions list to the end
				** of our Dimensions array.
				*/
				 
				assert( (yyvsp[(5) - (6)].v.Dimensions) != NULL );
				memcpy
				(
					(yyval.v.Dimensions) +	(yyvsp[(3) - (6)].s)->Arity,
					(yyvsp[(5) - (6)].v.Dimensions),
					(yyvsp[(5) - (6)].v.Arity) * sizeofInt 
				);

				/*
				** We're done with the explict list, so free it.
				*/

				free2( vss (yyvsp[(5) - (6)].v.Dimensions) );

			_endif
			(yyval.v.u.ArrayOfValues) = NULL;
			_here;
		;}
    break;

  case 1012:

/* Line 1464 of yacc.c  */
#line 45001 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(9) - (10)].v.pType) == tArray )

				/*
				** Check to see if the list of array values specified
				** by the user is type and count compatible with the
				** array type specified by the TypeID and the explicit
				** dimensions list.	If so, insert the constant into
				** the symbol table.
				*/

				_if
				( 
					ArraysAreCompatible
					( 
						YYS &(yyvsp[(7) - (10)].v), 
						YYS &(yyvsp[(9) - (10)].v) 
					)
				)

					InsertSym
					( 
						(yyvsp[(1) - (10)].idStr), 
						(yyvsp[(7) - (10)].v.Type),
						tArray, 
						cConstant, 
						(yyvsp[(7) - (10)].v.Arity),
						(yyvsp[(7) - (10)].v.Dimensions),
						(yyvsp[(7) - (10)].v.NumElements),
						YYS &(yyvsp[(9) - (10)].v),
						(yyvsp[(3) - (10)].s)->ObjectSize * (yyvsp[(5) - (10)].v.NumElements),
						0,
						NULL,
						(yyvsp[(7) - (10)].v.Base),
						(yyvsp[(7) - (10)].v.Fields),
						(yyvsp[(7) - (10)].v.FieldCnt)
					);


				_else

					/*
					** At this point either the types of the elements do
					** not agree or the number of elements do not agree.
					** Figure out which and print the appropriate error 
					** msg.
					*/

					_if
					( 
							(yyvsp[(7) - (10)].v.NumElements) == (yyvsp[(9) - (10)].v.NumElements)
						||	(yyvsp[(3) - (10)].s)->pType == tText 
					)

						yyerror( "Type mismatch in operands" );

					_else
					
						char msg[80];
						
						sprintf
						(
							msg,
							"The number of array elements do not match "
							"(expects %d, has %d)",
							(yyvsp[(7) - (10)].v.NumElements),
							(yyvsp[(9) - (10)].v.NumElements)
						);
						yyerror( msg );
						
					_endif
					_if( (yyvsp[(9) - (10)].v.pType) == tArray )
					
						FreeValue( YYS &(yyvsp[(9) - (10)].v) );

					_endif
					free2( vss (yyvsp[(7) - (10)].v.Dimensions) );

				_endif

			_else

				yyerror( "Expected array expression" );
				_if( (yyvsp[(9) - (10)].v.pType) == tArray )
				
					FreeValue( YYS &(yyvsp[(9) - (10)].v) );

				_endif
				free2( vss (yyvsp[(7) - (10)].v.Dimensions) );

			_endif

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;		
		;}
    break;

  case 1013:

/* Line 1464 of yacc.c  */
#line 45122 "hlaparse.bsn"
    {			/* $6 */
		
			_here;
			assert( (yyvsp[(1) - (5)].idStr) != NULL );
			assert( (yyvsp[(3) - (5)].s) != NULL );
			/*
			** Scream if the user is trying to define a text array.
			*/

			_if( (yyvsp[(3) - (5)].s)->pType == tText )

				yyerror( "Cannot have TEXT arrays" );
				(yyvsp[(3) - (5)].s) = &string_ste;

			_endif

			/*
			** If it's not a primitive scalar type, complain about
			** that and then fake a usable type.
			*/

			_if( !CanBeVal( (yyvsp[(3) - (5)].s)->pType ))

				yyerror( "Constants can only have primitive types" );
				(yyvsp[(3) - (5)].s) = &uns32_ste;

			_endif
			_here;
		;}
    break;

  case 1014:

/* Line 1464 of yacc.c  */
#line 45154 "hlaparse.bsn"
    {				/* $10 */

			int		i;
			char	IsValid;

			_here;
			_if( (yyvsp[(8) - (9)].v.pType) != tArray )
			
				yyerror( "Expected array expression" );
				FreeValue( YYS &(yyvsp[(8) - (9)].v) );
			
			_else				
			
				/*
				** There are two cases we need to consider here:
				**
				**	1.	The base type of the constant is a scalar
				**		type.  For this case, we simply give the
				**		constant type the same number of elements
				**		as the array constant.
				**
				**	2.	The base type of the constant is an array type.
				**		In this case we have to make sure that the
				**		number of elements in the array constant is
				**		an even multiple of the number of elements in
				**		the array type.
				*/
				
				_if( (yyvsp[(3) - (9)].s)->pType != tArray )
				
					/*
					** Okay, we've got the simple case where we
					** just copy the data from the expression into
					** the new constant object. But first, let's make sure 
					** that the elements of this array are compatible with
					** the base type of the array constant object:
					*/
					
					
					IsValid = 1;
					i = 0;
					_do
					
						/*
						** Verify that each element of the array expression
						** is compatible with our destination type:
						*/
						
						IsValid = 
								IsValid 
							&&	IsCompatible
								(
									GetBaseType( (yyvsp[(3) - (9)].s) ),
									YYS &(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i] 
								);
								
						++i;
						
					_until( i >= (yyvsp[(8) - (9)].v.NumElements) || !IsValid )

					_if( IsValid )
					
						InsertSym
						( 
							(yyvsp[(1) - (9)].idStr), 
							GetBaseType( (yyvsp[(3) - (9)].s) ),
							tArray, 
							cConstant, 
							1,							/* Arity		*/
							malloc2( sizeofInt ),	/* Dimensions	*/
							(yyvsp[(8) - (9)].v.NumElements),			/* NumElements	*/
							NULL,						/* Value		*/
							0,							/* ObjectSize	*/
							0,							/* Offset		*/
							NULL,						/* Static Name	*/
							(yyvsp[(8) - (9)].v.Base),					/* Base Type	*/
							(yyvsp[(8) - (9)].v.Fields),				/* Field list	*/
							(yyvsp[(8) - (9)].v.FieldCnt)				/* Num Fields	*/
						);
						
						/*
						** Allocate storage to hold the data:
						*/
						
						SymbolTable->u.ArrayOfValues = 
							malloc2
							( 
								(yyvsp[(8) - (9)].v.NumElements) * sizeofSymNode
							);
							
						/*
						** Copy the data from the array constant expression
						** to the array object we've just created:
						*/
						
						_for( i=0, i < (yyvsp[(8) - (9)].v.NumElements), ++i )
						
							DeepCopy
							( 
								&SymbolTable->u.ArrayOfValues[i], 
								&(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i]
							);
							
						_endfor
						
						/*
						** Set up the size information for this constant array:
						*/
						
						SymbolTable->Dimensions[0] = (yyvsp[(8) - (9)].v.NumElements);
						SymbolTable->ObjectSize = 
							(yyvsp[(3) - (9)].s)->ObjectSize * (yyvsp[(8) - (9)].v.NumElements);
							
						
						
					_else
					
						yyerror( "Type mismatch in operands" );
					
					_endif


				_else
				
					/*
					** Okay, the base type of the constant object is
					** an array type.  This means that the number
					** of elements in the constant expression must
					** be an even multiple of the number of elements
					** in the base type.
					*/
					
					_if
					(
							(yyvsp[(3) - (9)].s)->NumElements >= (yyvsp[(8) - (9)].v.NumElements)
						||	( (yyvsp[(8) - (9)].v.NumElements) % (yyvsp[(3) - (9)].s)->NumElements ) != 0
					)
					
						yyerror
						( 
							"Array constant has bad number of elements"
						);
						
					_else

						IsValid = 1;
						i = 0;
						_do
						
							/*
							** Verify that each element of the array expression
							** is compatible with our destination type:
							*/
							
							IsValid = 
									IsValid 
								&&	IsCompatible
									(
										GetBaseType( (yyvsp[(3) - (9)].s) ),
										YYS &(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i] 
									);
									
							++i;
							
						_until( i >= (yyvsp[(8) - (9)].v.NumElements) || !IsValid )
						
						_if( IsValid )
						
							InsertSym
							( 
								(yyvsp[(1) - (9)].idStr), 
								GetBaseType( (yyvsp[(3) - (9)].s) ),
								tArray, 
								cConstant, 
								(yyvsp[(3) - (9)].s)->Arity + 1,			
								malloc2( sizeofInt  * ((yyvsp[(3) - (9)].s)->Arity + 1)),
								(yyvsp[(8) - (9)].v.NumElements),			
								NULL,						
								0,							
								0,							
								NULL,						
								(yyvsp[(8) - (9)].v.Base),					
								(yyvsp[(8) - (9)].v.Fields),				
								(yyvsp[(8) - (9)].v.FieldCnt)				
							);
							
							/*
							** Allocate storage to hold the data:
							*/
							
							SymbolTable->u.ArrayOfValues = 
								malloc2
								( 
									(yyvsp[(8) - (9)].v.NumElements) * sizeofSymNode
								);
								
							/*
							** Copy the data from the array constant expression
							** to the array object we've just created:
							*/
							
							_for( i=0, i < (yyvsp[(8) - (9)].v.NumElements), ++i )
							
								DeepCopy
								( 
									&SymbolTable->u.ArrayOfValues[i], 
									&(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i]
								);
								
							_endfor
							
							/*
							** Set up the size information for this 
							** constant array:
							*/
							
							_for( i = 0, i < SymbolTable->Arity - 1, ++i )
							
								SymbolTable->Dimensions[i] = 
									(yyvsp[(3) - (9)].s)->Dimensions[i];
									
							_endfor
							SymbolTable->Dimensions[ SymbolTable->Arity - 1 ] =
								(yyvsp[(8) - (9)].v.NumElements) / (yyvsp[(3) - (9)].s)->NumElements;
								
							SymbolTable->ObjectSize = 
								(yyvsp[(3) - (9)].s)->Type->ObjectSize * (yyvsp[(8) - (9)].v.NumElements);
								
							
							
						_else
						
							yyerror( "Type mismatch in operands" );
						
						_endif

					
					_endif


				_endif

			_endif
			FreeValue( YYS &(yyvsp[(8) - (9)].v) );

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;		
		;}
    break;

  case 1015:

/* Line 1464 of yacc.c  */
#line 45424 "hlaparse.bsn"
    {
			char msg[ 256 ];

			sprintf
			( 
				msg,
				"Symbol <<%s>> is already defined", 
				(yyvsp[(1) - (1)].s)->TrueName 
			);
			yyerror( msg );
		;}
    break;

  case 1016:

/* Line 1464 of yacc.c  */
#line 45442 "hlaparse.bsn"
    {
			yyerror( "Syntax error, expected declaration" );
		;}
    break;

  case 1017:

/* Line 1464 of yacc.c  */
#line 45447 "hlaparse.bsn"
    {_here; ;}
    break;

  case 1018:

/* Line 1464 of yacc.c  */
#line 45498 "hlaparse.bsn"
    {
			_here;
			inVal = (yyvsp[(1) - (2)].i);
			fastLookup = 0; /* force lookup */
			
		;}
    break;

  case 1019:

/* Line 1464 of yacc.c  */
#line 45508 "hlaparse.bsn"
    {
			_here;
			(yyval.i) = inVal;
			inVal = 1;
		;}
    break;

  case 1020:

/* Line 1464 of yacc.c  */
#line 45516 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1021:

/* Line 1464 of yacc.c  */
#line 45518 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1022:

/* Line 1464 of yacc.c  */
#line 45583 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1023:

/* Line 1464 of yacc.c  */
#line 45591 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1024:

/* Line 1464 of yacc.c  */
#line 45601 "hlaparse.bsn"
    {
				_here;
				_if( (yyvsp[(3) - (4)].v.pType) != tString )

					yyerror( "Error prefix value must be a string expression" );
					

				_else

					_if( errorPrefixMsg != NULL )
					
						free2( vss errorPrefixMsg );
						FreeValue( YYS &(yyvsp[(3) - (4)].v) );
						
					_else
					
						errorPrefixMsg = (yyvsp[(3) - (4)].v.u.strval);
						
					_endif

				_endif
				_here;
					
			;}
    break;

  case 1025:

/* Line 1464 of yacc.c  */
#line 45630 "hlaparse.bsn"
    {
				_here;
				_if( !checkSmallInt( YYS &(yyvsp[(3) - (4)].v) ) )

					yyerror( "Parameter offset value must be a small integer" );

				_else


					StartParmOffs = (yyvsp[(3) - (4)].v.u.intval);

				_endif
				_here;
					
			;}
    break;

  case 1026:

/* Line 1464 of yacc.c  */
#line 45651 "hlaparse.bsn"
    {
			_here;
			_if( !checkSmallInt( YYS &(yyvsp[(3) - (4)].v) ) )

				yyerror( "Locals offset value must be a small integer" );

			_else

				StartLclOffs = (yyvsp[(3) - (4)].v.u.intval);

			_endif
			_here;
				
		;}
    break;

  case 1027:

/* Line 1464 of yacc.c  */
#line 45671 "hlaparse.bsn"
    {
				_here;
				_if( !checkSmallUns( YYS &(yyvsp[(3) - (4)].v) ) )

					yyerror( "Enum size must be a small non-negative integer" );

				_else

					EnumSize = (yyvsp[(3) - (4)].v.u.intval);

				_endif
				_here;
					
			;}
    break;

  case 1028:

/* Line 1464 of yacc.c  */
#line 45691 "hlaparse.bsn"
    {
			_here;
			_if( !checkSmallUns( YYS &(yyvsp[(3) - (4)].v) ) || (yyvsp[(3) - (4)].v.u.intval) < 1 )

				yyerror( "@label must be assigned an integer > 1" );

			_else

				LblCntr = (yyvsp[(3) - (4)].v.u.intval);

			_endif
			_here;
		;}
    break;

  case 1029:

/* Line 1464 of yacc.c  */
#line 45712 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@bound expects a boolean expression" );

			_else

				CompileBound = (yyvsp[(3) - (4)].v.u.boolval);
				
			_endif
		;}
    break;

  case 1030:

/* Line 1464 of yacc.c  */
#line 45731 "hlaparse.bsn"
    {
			_here;
			CurBaseReg = "ebp";
		;}
    break;

  case 1031:

/* Line 1464 of yacc.c  */
#line 45741 "hlaparse.bsn"
    {
			_here;
			CurBaseReg = "esp";
		;}
    break;

  case 1032:

/* Line 1464 of yacc.c  */
#line 45750 "hlaparse.bsn"
    {
			yyerror( "'@basereg := reg' only allows ESP or EBP" );
		;}
    break;

  case 1033:

/* Line 1464 of yacc.c  */
#line 45758 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@into expects a boolean expression" );

			_else

				CompileInto = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1034:

/* Line 1464 of yacc.c  */
#line 45777 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@trace expects a boolean expression" );

			_else

				TraceFlag = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1035:

/* Line 1464 of yacc.c  */
#line 45796 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@exceptions expects a boolean expression" );

			_else

				FullExceptions = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1036:

/* Line 1464 of yacc.c  */
#line 45819 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@display expects a boolean expression" );

			_else

				DisplayDefault = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1037:

/* Line 1464 of yacc.c  */
#line 45839 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@nodisplay expects a boolean expression" );

			_else

				DisplayDefault = !(yyvsp[(3) - (4)].v.u.boolval);

			_endif
				
		;}
    break;

  case 1038:

/* Line 1464 of yacc.c  */
#line 45858 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@frame expects a boolean expression" );

			_else

				FrameDefault = (yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level && (yyvsp[(3) - (4)].v.u.boolval) )
				
					yyerror
					( 
						"@frame can only be assigned false except in \n"
						"high-level and medium-level language modes."
					);
					
				_endif


			_endif

				
		;}
    break;

  case 1039:

/* Line 1464 of yacc.c  */
#line 45888 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@nodisplay expects a boolean expression" );

			_else

				FrameDefault = !(yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level && !(yyvsp[(3) - (4)].v.u.boolval) )
				
					yyerror
					( 
						"@noframe can only be assigned true except in \n"
						"high-level and medium-level language modes."
					);
					
				_endif
				

			_endif

				
		;}
    break;

  case 1040:

/* Line 1464 of yacc.c  */
#line 45918 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@alignstack expects a boolean expression" );

			_else

				AlignStackDefault = (yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level && (yyvsp[(3) - (4)].v.u.boolval) )
				
					yyerror
					( 
						"@alignstack can only be assigned false except in \n"
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1041:

/* Line 1464 of yacc.c  */
#line 45947 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@noalignstack expects a boolean expression" );

			_else

				AlignStackDefault = !(yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level && !(yyvsp[(3) - (4)].v.u.boolval) )
				
					yyerror
					( 
						"@noalignstack can only be assigned false except in \n"
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1042:

/* Line 1464 of yacc.c  */
#line 45976 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@enter expects a boolean expression" );

			_else

				EnterDefault = (yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level )
				
					yyerror
					( 
						"@enter is illegal except in "
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1043:

/* Line 1464 of yacc.c  */
#line 46005 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@noenter expects a boolean expression" );

			_else

				EnterDefault = !(yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level )
				
					yyerror
					( 
						"@noenter is illegal except in "
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1044:

/* Line 1464 of yacc.c  */
#line 46034 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@leave expects a boolean expression" );

			_else

				LeaveDefault = (yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level )
				
					yyerror
					( 
						"@leave is illegal except in "
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1045:

/* Line 1464 of yacc.c  */
#line 46063 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@noalignstack expects a boolean expression" );

			_else

				LeaveDefault = !(yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level )
				
					yyerror
					( 
						"@noleave is illegal except in "
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1046:

/* Line 1464 of yacc.c  */
#line 46092 "hlaparse.bsn"
    {
				_here;
				_if( !checkSmallUns( YYS &(yyvsp[(3) - (4)].v) ) )

					yyerror
					( 
						"@align value must be a small non-negative integer" 
					);

				_else

					int bits;
					int value;
					
					bits = 0;
					value = (yyvsp[(3) - (4)].v.u.intval);
					_while( value != 0 )
					
						bits = bits + (value & 1);
						value = value >> 1;
						
					_endwhile;
					_if( bits != 1 )
					
						yyerror
						( 
							"@align requires an operand that is a power of two" 
						);
						
					_else
					
						AlignDefault = (yyvsp[(3) - (4)].v.u.intval);
						
					_endif;

				_endif
				_here;
			;}
    break;

  case 1047:

/* Line 1464 of yacc.c  */
#line 46144 "hlaparse.bsn"
    {				/* $5 */
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@optstrings expects a boolean expression" );

			_else

				OptimizeStrings = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1048:

/* Line 1464 of yacc.c  */
#line 46176 "hlaparse.bsn"
    {
			_here;
			_if(( (yyvsp[(4) - (8)].cls.cls) & cfy_SingleID ) == 0 )

				yyerror( "@offset requires a single ID parameter" );

			_elseif(( (yyvsp[(4) - (8)].cls.cls) & cfy_Undefined) || (yyvsp[(4) - (8)].cls.sym) == NULL )

				yyerror( "@offset requires a defined identifier" );

			_else

				_if( checkSmallInt( YYS &(yyvsp[(7) - (8)].v) ))

					(yyvsp[(4) - (8)].cls.sym)->Offset = (yyvsp[(7) - (8)].v.u.intval);
					
				_else
				
					yyerror( "Expected a 32-bit numeric offset value" );
					
				_endif
				
			_endif
			FreeValue( YYS &(yyvsp[(7) - (8)].v) );
			_here;
		;}
    break;

  case 1049:

/* Line 1464 of yacc.c  */
#line 46228 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (4)].idStr) != NULL );
			assert( (yyvsp[(3) - (4)].v.Type) != NULL );

			InsertSym
			( 
				(yyvsp[(1) - (4)].idStr), 
				(yyvsp[(3) - (4)].v.Type),
				(yyvsp[(3) - (4)].v.pType), 
				cValue, 
				(yyvsp[(3) - (4)].v.Arity),
				(yyvsp[(3) - (4)].v.Dimensions),	/* ConstOnlyExpr mallocs this if array */
				(yyvsp[(3) - (4)].v.NumElements), 
				YYS &(yyvsp[(3) - (4)].v),
				_ifx
				( 
					(yyvsp[(3) - (4)].v.pType) == tArray,
					(yyvsp[(3) - (4)].v.Type)->ObjectSize * (yyvsp[(3) - (4)].v.NumElements),
					(yyvsp[(3) - (4)].v.Type)->ObjectSize
				),
				0,
				NULL,
				(yyvsp[(3) - (4)].v.Base),
				(yyvsp[(3) - (4)].v.Fields),
				(yyvsp[(3) - (4)].v.FieldCnt) 
			);
			
			// Must handle the union field manually:
			
			SymbolTable->CurField = (yyvsp[(3) - (4)].v.CurField);
			SymbolTable->CurIndex = (yyvsp[(3) - (4)].v.CurIndex);
			_here;

		;}
    break;

  case 1050:

/* Line 1464 of yacc.c  */
#line 46273 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (4)].idStr) != NULL );

			InsertSym
			( 
				(yyvsp[(1) - (4)].idStr), 
				&regex_ste,
				tRegex, 
				cValue, 
				0,
				NULL,
				0, 
				YYS &(yyvsp[(3) - (4)].v),
				4,
				0,
				NULL,
				NULL,
				NULL,
				0 
			);
			_here;

		;}
    break;

  case 1051:

/* Line 1464 of yacc.c  */
#line 46319 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (4)].s) != NULL );

			SetSym
			( 
				(yyvsp[(1) - (4)].s), 
				(yyvsp[(3) - (4)].v.Type),
				(yyvsp[(3) - (4)].v.pType), 
				(yyvsp[(3) - (4)].v.Arity),
				(yyvsp[(3) - (4)].v.Dimensions),	/* ConstOnlyExpr mallocs this if array */
				(yyvsp[(3) - (4)].v.NumElements), 
				YYS &(yyvsp[(3) - (4)].v),
				_ifx
				( 
					(yyvsp[(3) - (4)].v.pType) == tArray,
					(yyvsp[(3) - (4)].v.Type)->ObjectSize * (yyvsp[(3) - (4)].v.NumElements),
					(yyvsp[(3) - (4)].v.Type)->ObjectSize
				),
				0,
				NULL,
				(yyvsp[(3) - (4)].v.Base),
				(yyvsp[(3) - (4)].v.Fields),
				(yyvsp[(3) - (4)].v.FieldCnt),
				(yyvsp[(3) - (4)].v.CurField),
				(yyvsp[(3) - (4)].v.CurIndex) 
			);
			_here;
		;}
    break;

  case 1052:

/* Line 1464 of yacc.c  */
#line 46358 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (4)].s) != NULL );

			SetSym
			( 
				(yyvsp[(1) - (4)].s), 
				&regex_ste,
				tRegex, 
				0,
				NULL,
				0, 
				YYS &(yyvsp[(3) - (4)].v),
				4,
				0,
				NULL,
				NULL,
				NULL,
				0,
				NULL,
				0 
			);
			_here;
		;}
    break;

  case 1053:

/* Line 1464 of yacc.c  */
#line 46401 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (4)].idStr) != NULL );
			assert( (yyvsp[(3) - (4)].s) != NULL );

			_if( !CanBeVal( (yyvsp[(3) - (4)].s)->pType ))

				yyerror( "Values can only have primitive types" );

			_elseif( (yyvsp[(3) - (4)].s)->pType != tArray )

				ClrNewSym
				( 
					(yyvsp[(1) - (4)].idStr), 
					(yyvsp[(3) - (4)].s),
					(yyvsp[(3) - (4)].s)->pType, 
					cValue, 
					0,
					NULL,
					0, 
					(yyvsp[(3) - (4)].s)->ObjectSize,
					0,
					NULL,
					(yyvsp[(3) - (4)].s)->Base,
					(yyvsp[(3) - (4)].s)->Fields,
					(yyvsp[(3) - (4)].s)->FieldCnt,
					(yyvsp[(3) - (4)].s)->CurField,
					(yyvsp[(3) - (4)].s)->CurIndex 
				);

			_else /* We have an array */


				ClrNewSym
				( 
					(yyvsp[(1) - (4)].idStr), 
					(yyvsp[(3) - (4)].s)->Type,
					tArray, 
					cValue, 
					(yyvsp[(3) - (4)].s)->Arity,
					DupDims( (yyvsp[(3) - (4)].s) ),
					(yyvsp[(3) - (4)].s)->NumElements, 
					(yyvsp[(3) - (4)].s)->ObjectSize,
					0,
					NULL,
					(yyvsp[(3) - (4)].s)->Base, 
					(yyvsp[(3) - (4)].s)->Fields,
					(yyvsp[(3) - (4)].s)->FieldCnt,
					(yyvsp[(3) - (4)].s)->CurField,
					(yyvsp[(3) - (4)].s)->CurIndex
				);

			_endif


		;}
    break;

  case 1054:

/* Line 1464 of yacc.c  */
#line 46481 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (4)].s) != NULL );
			assert( (yyvsp[(3) - (4)].s) != NULL );

			_if( !CanBeVal( (yyvsp[(3) - (4)].s)->pType ))

				yyerror( "Values can only have primitive types" );

			_elseif( (yyvsp[(3) - (4)].s)->pType != tArray )

				ClrSym
				( 
					(yyvsp[(1) - (4)].s), 
					(yyvsp[(3) - (4)].s),
					(yyvsp[(3) - (4)].s)->pType, 
					0,
					NULL,
					0, 
					(yyvsp[(3) - (4)].s)->ObjectSize,
					0,
					NULL,
					(yyvsp[(3) - (4)].s)->Base,
					(yyvsp[(3) - (4)].s)->Fields,
					(yyvsp[(3) - (4)].s)->FieldCnt,
					(yyvsp[(3) - (4)].s)->CurField,
					(yyvsp[(3) - (4)].s)->CurIndex 
				);

			_else /* We have an array */


				ClrSym
				( 
					(yyvsp[(1) - (4)].s), 
					(yyvsp[(3) - (4)].s)->Type,
					tArray, 
					(yyvsp[(3) - (4)].s)->Arity,
					DupDims( (yyvsp[(3) - (4)].s) ),
					(yyvsp[(3) - (4)].s)->NumElements, 
					(yyvsp[(3) - (4)].s)->ObjectSize,
					0,
					NULL,
					(yyvsp[(3) - (4)].s)->Base, 
					(yyvsp[(3) - (4)].s)->Fields,
					(yyvsp[(3) - (4)].s)->FieldCnt,
					(yyvsp[(3) - (4)].s)->CurField,
					(yyvsp[(3) - (4)].s)->CurIndex
				);

			_endif


		;}
    break;

  case 1055:

/* Line 1464 of yacc.c  */
#line 46553 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );

			/*
			** If the TypeID is an array, the ConstOnlyExpr must also
			** be an array (ID).  That being the case, make sure
			** they are compatible with one another.
			*/
				 
			_if( (yyvsp[(3) - (6)].s)->pType == tArray && (yyvsp[(5) - (6)].v.pType) == tArray )

				_if
				( 
					ArraysAreCompatible
					( 
						YYS (yyvsp[(3) - (6)].s), 
						YYS &(yyvsp[(5) - (6)].v) 
					)
				)

					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr),
						GetBaseType( (yyvsp[(3) - (6)].s) ), 
						tArray, 
						cValue, 
						(yyvsp[(3) - (6)].s)->Arity,
						DupDims( (yyvsp[(3) - (6)].s) ),
						(yyvsp[(3) - (6)].s)->NumElements, 
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

				_else

					yyerror
					( 
						"Type mismatch of array operands or "
						"element value out of range" 
					);
					FreeValue( YYS &(yyvsp[(5) - (6)].v) );


				_endif

			/*
			** If it's not an array, check to see if it is
			** a record.
			*/

			_elseif( (yyvsp[(3) - (6)].s)->pType == tRecord && (yyvsp[(5) - (6)].v.pType) == tRecord )

				_if
				( 
					RecordsAreCompatible
					( 
						(yyvsp[(3) - (6)].s), 
						YYS &(yyvsp[(5) - (6)].v) 
					)
				)

					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr), 
						GetBaseType( (yyvsp[(3) - (6)].s) ),
						tRecord, 
						cValue, 
						(yyvsp[(3) - (6)].s)->Arity,
						(yyvsp[(3) - (6)].s)->Dimensions,
						(yyvsp[(3) - (6)].s)->NumElements, 
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

				_else

					yyerror
					( 
						"Type mismatch of operands. Expected "
						"compatible record types" 
					);

					FreeValue( YYS &(yyvsp[(5) - (6)].v) );

				_endif


			/*
			** If it's not an array or record, check to see if it is
			** a union.
			*/

			_elseif
			( 
					(yyvsp[(3) - (6)].s)->pType == tUnion 
				&&	(yyvsp[(5) - (6)].v.pType) == tUnion
				&&	GetBaseType( (yyvsp[(3) - (6)].s) ) == GetBaseType( (yyvsp[(5) - (6)].v.Type) )
			)

				InsertSym
				( 
					(yyvsp[(1) - (6)].idStr), 
					GetBaseType( (yyvsp[(3) - (6)].s) ),
					tUnion, 
					cValue, 
					0,					// Arity
					NULL,				// Dimensions
					0,					// NumElements
					YYS &(yyvsp[(5) - (6)].v),			// FieldValues points at data.
					(yyvsp[(3) - (6)].s)->ObjectSize,
					(yyvsp[(5) - (6)].v.Offset),		// Offset holds field #
					NULL,
					(yyvsp[(3) - (6)].s)->Base,
					(yyvsp[(3) - (6)].s)->Fields,
					(yyvsp[(3) - (6)].s)->FieldCnt
				);
				
				// Must manually set up the two fields associated with
				// union constants:
				
				SymbolTable->CurField = (yyvsp[(5) - (6)].v.CurField);
				SymbolTable->CurIndex = (yyvsp[(5) - (6)].v.CurIndex);


			/*
			** If it's not an array, union, or record, check to see if it is
			** a real128.
			*/

			_elseif
			( 
					(yyvsp[(3) - (6)].s)->pType == tReal128 
				&&	(yyvsp[(5) - (6)].v.pType) == tReal128
				&&	GetBaseType( (yyvsp[(3) - (6)].s) ) == GetBaseType( (yyvsp[(5) - (6)].v.Type) )
			)

				InsertSym
				( 
					(yyvsp[(1) - (6)].idStr), 
					GetBaseType( (yyvsp[(3) - (6)].s) ),
					tReal128, 
					cValue, 
					0,					// Arity
					NULL,				// Dimensions
					0,					// NumElements
					YYS &(yyvsp[(5) - (6)].v),			// FieldValues points at data.
					(yyvsp[(3) - (6)].s)->ObjectSize,
					(yyvsp[(5) - (6)].v.Offset),		// Offset holds field #
					NULL,
					(yyvsp[(3) - (6)].s)->Base,
					(yyvsp[(3) - (6)].s)->Fields,
					(yyvsp[(3) - (6)].s)->FieldCnt
				);
				
				// Must manually set up the two fields associated with
				// real128 constants:
				
				SymbolTable->CurField = (yyvsp[(5) - (6)].v.CurField);
				SymbolTable->CurIndex = (yyvsp[(5) - (6)].v.CurIndex);




			/*
			** If TypeID is not an array, make sure that it's a
			** primitive type.
			*/

			_elseif( IsNotPrimType( (yyvsp[(3) - (6)].s)->pType ))

				yyerror( "Constants can only have primitive types" );
				FreeValue( YYS &(yyvsp[(5) - (6)].v) );

			/*
			** If TypeID is a primitive type, then check to see if
			** it is type compatible with the ConstOnlyExpr value.
			** Insert the object into the symbol table if they
			** are compatible.
			*/

			_elseif( IsCompatible( (yyvsp[(3) - (6)].s), YYS &(yyvsp[(5) - (6)].v) ))

				InsertSym
				( 
					(yyvsp[(1) - (6)].idStr),
					GetBaseType( (yyvsp[(3) - (6)].s) ), 
					(yyvsp[(3) - (6)].s)->pType, 
					cValue, 
					0,
					NULL,
					0, 
					YYS &(yyvsp[(5) - (6)].v),
					(yyvsp[(3) - (6)].s)->ObjectSize,
					0,
					NULL,
					(yyvsp[(3) - (6)].s)->Base,
					(yyvsp[(3) - (6)].s)->Fields,
					(yyvsp[(3) - (6)].s)->FieldCnt
				);

			_else

				yyerror
				( 
					"Type mismatch of operands or "
					"value out of range in declaration" 
				);
				FreeValue( YYS &(yyvsp[(5) - (6)].v) );

			_endif

		;}
    break;

  case 1056:

/* Line 1464 of yacc.c  */
#line 46790 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );

			_if( (yyvsp[(3) - (6)].s)->pType != tRegex )
			
				yyerror( "Type mismatch, expected REGEX object" );
				
			_else
			
				InsertSym
				( 
					(yyvsp[(1) - (6)].idStr), 
					&regex_ste,
					tRegex, 
					cValue, 
					0,
					NULL,
					0, 
					YYS &(yyvsp[(5) - (6)].v),
					4,
					0,
					NULL,
					NULL,
					NULL,
					0 
				);
			
			_endif
		;}
    break;

  case 1057:

/* Line 1464 of yacc.c  */
#line 46839 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (6)].s) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );
			
			/*
			** Check to see if TypeID is an array type and if
			** ConstOnlyExpr is also an array value (array ID).
			*/
				 
			_if( (yyvsp[(3) - (6)].s)->pType == tArray && (yyvsp[(5) - (6)].v.pType) == tArray )

				/*
				** If they are compatible arrays, then assign
				** ConstOnlyExpr's value to the Local ID, else
				** print an appropriate error message.
				*/

				_if
				( 
					ArraysAreCompatible
					( 
						YYS (yyvsp[(3) - (6)].s), 
						YYS &(yyvsp[(5) - (6)].v) 
					)
				)

					SetSym
					( 
						(yyvsp[(1) - (6)].s),
						GetBaseType( (yyvsp[(3) - (6)].s) ), 
						tArray, 
						(yyvsp[(3) - (6)].s)->Arity,
						DupDims( (yyvsp[(3) - (6)].s) ),
						(yyvsp[(3) - (6)].s)->NumElements, 
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt,
						(yyvsp[(3) - (6)].s)->CurField,
						(yyvsp[(3) - (6)].s)->CurIndex
					);
					
				_else

					yyerror
					( 
						"Type mismatch of operands or "
						"value out of range in declaration" 
					);
					FreeValue( YYS &(yyvsp[(5) - (6)].v) );


				_endif

			/*
			** If it's not an array, check to see if it is
			** a record.
			*/

			_elseif( (yyvsp[(3) - (6)].s)->pType == tRecord && (yyvsp[(5) - (6)].v.pType) == tRecord )

				_if
				( 
					RecordsAreCompatible
					( 
						(yyvsp[(3) - (6)].s), 
						YYS &(yyvsp[(5) - (6)].v) 
					)
				)

					SetSym
					( 
						(yyvsp[(1) - (6)].s), 
						GetBaseType( (yyvsp[(3) - (6)].s) ),
						tRecord, 
						(yyvsp[(3) - (6)].s)->Arity,
						(yyvsp[(3) - (6)].s)->Dimensions,
						(yyvsp[(3) - (6)].s)->NumElements, 
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt,
						(yyvsp[(3) - (6)].s)->CurField,
						(yyvsp[(3) - (6)].s)->CurIndex
					);

				_else

					yyerror
					( 
						"Type mismatch of operands. Expected "
						"compatible record types" 
					);
					FreeValue( YYS &(yyvsp[(5) - (6)].v) );

				_endif




			/*
			** If it's not an array or record, check to see if it is
			** a union.
			*/

			_elseif
			( 
					(yyvsp[(3) - (6)].s)->pType == tUnion 
				&&	(yyvsp[(5) - (6)].v.pType) == tUnion
				&&	GetBaseType( (yyvsp[(3) - (6)].s) ) == GetBaseType( (yyvsp[(5) - (6)].v.Type) )
			)

				SetSym
				( 
					(yyvsp[(1) - (6)].s), 
					GetBaseType( (yyvsp[(3) - (6)].s) ),
					tUnion, 
					0,					// Arity
					NULL,				// Dimensions
					0,					// NumElements
					YYS &(yyvsp[(5) - (6)].v),			// Value
					(yyvsp[(3) - (6)].s)->ObjectSize,
					0,					// Offset
					NULL,
					(yyvsp[(5) - (6)].v.Base),
					(yyvsp[(5) - (6)].v.Fields),
					(yyvsp[(5) - (6)].v.FieldCnt),
					(yyvsp[(5) - (6)].v.CurField),
					(yyvsp[(5) - (6)].v.CurIndex)
				);




			/*
			** If it's not an array, union, or record, check to see if it is
			** a real128.
			*/

			_elseif
			( 
					(yyvsp[(3) - (6)].s)->pType == tReal128 
				&&	(yyvsp[(5) - (6)].v.pType) == tReal128
				&&	GetBaseType( (yyvsp[(3) - (6)].s) ) == GetBaseType( (yyvsp[(5) - (6)].v.Type) )
			)

				SetSym
				( 
					(yyvsp[(1) - (6)].s), 
					GetBaseType( (yyvsp[(3) - (6)].s) ),
					tReal128, 
					0,					// Arity
					NULL,				// Dimensions
					0,					// NumElements
					YYS &(yyvsp[(5) - (6)].v),			// Value
					(yyvsp[(3) - (6)].s)->ObjectSize,
					0,					// Offset
					NULL,
					(yyvsp[(5) - (6)].v.Base),
					(yyvsp[(5) - (6)].v.Fields),
					(yyvsp[(5) - (6)].v.FieldCnt),
					(yyvsp[(5) - (6)].v.CurField),
					(yyvsp[(5) - (6)].v.CurIndex)
				);





			/*
			** If TypeID and/or ConstOnlyExpr are not arrays, see if
			** they are primitive types.
			*/

			_elseif( IsNotPrimType( (yyvsp[(3) - (6)].s)->pType ))

				yyerror( "Values can only have primitive types" );
				FreeValue( YYS &(yyvsp[(5) - (6)].v) );

			/*
			** If they are primitive types, see if they are type
			** compatible.  Set the value of the LocalID if they
			** are compatible.
			*/

			_elseif( IsCompatible( (yyvsp[(3) - (6)].s), YYS &(yyvsp[(5) - (6)].v) ))

				SetSym
				( 
					(yyvsp[(1) - (6)].s),
					GetBaseType( (yyvsp[(3) - (6)].s) ), 
					(yyvsp[(3) - (6)].s)->pType, 
					0,
					NULL,
					0, 
					YYS &(yyvsp[(5) - (6)].v),
					(yyvsp[(3) - (6)].s)->ObjectSize,
					0,
					NULL,
					(yyvsp[(3) - (6)].s)->Base,
					(yyvsp[(3) - (6)].s)->Fields,
					(yyvsp[(3) - (6)].s)->FieldCnt,
					(yyvsp[(3) - (6)].s)->CurField,
					(yyvsp[(3) - (6)].s)->CurIndex
				);

			_else

				yyerror
				( 
					"Type mismatch of operands or "
					"value out of range in declaration" 
				);
				FreeValue( YYS &(yyvsp[(5) - (6)].v) );

			_endif

		;}
    break;

  case 1058:

/* Line 1464 of yacc.c  */
#line 47077 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (6)].s) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );
			
			_if( (yyvsp[(3) - (6)].s)->pType != tRegex )
			
				yyerror( "Type mismatch, expected REGEX object" );
				
			_else
			
				SetSym
				( 
					(yyvsp[(1) - (6)].s), 
					&regex_ste,
					tRegex, 
					0,
					NULL,
					0, 
					YYS &(yyvsp[(5) - (6)].v),
					4,
					0,
					NULL,
					NULL,
					NULL,
					0,
					NULL,
					0 
				);
			
			_endif
		;}
    break;

  case 1059:

/* Line 1464 of yacc.c  */
#line 47127 "hlaparse.bsn"
    {				/* $7 */
		
			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );

			/*
			** Set up some common synthesized attribute return values.
			*/

			(yyval.v.pType) = tArray;
			(yyval.v.Arity) = (yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.Arity);
			(yyval.v.Base) = (yyvsp[(3) - (6)].s)->Base;
			(yyval.v.Fields) = (yyvsp[(3) - (6)].s)->Fields;
			(yyval.v.FieldCnt) = (yyvsp[(3) - (6)].s)->FieldCnt;
			(yyval.v.Type) =GetBaseType( (yyvsp[(3) - (6)].s) );

			/*
			** Scream if the user is trying to define a text array.
			*/

			_if( (yyvsp[(3) - (6)].s)->pType == tText )

				yyerror( "Cannot have TEXT arrays" );
				(yyvsp[(3) - (6)].s) = &string_ste;

			_endif

			/*
			** If it's not a primitive scalar type, complain about
			** that and then fake a usable type.
			*/

			_if( !CanBeVal( (yyvsp[(3) - (6)].s)->pType ))

				yyerror( "Values can only have primitive types" );
				(yyvsp[(3) - (6)].s) = &uns32_ste;

			_endif

			/*
			** If the TypeID isn't an array object, this is easy;
			** Just return the size of the array constant list.
			*/

			_if( (yyvsp[(3) - (6)].s)->pType != tArray )
			
				(yyval.v.NumElements) = (yyvsp[(5) - (6)].v.NumElements);
				(yyval.v.Dimensions) = (yyvsp[(5) - (6)].v.Dimensions);

			/*
			** On the other hand, if TypeID is an array object,
			** then we've got to add a new list of dimensions onto
			** the end of the TypeID list.
			*/

			_else

				/*
				** Compute the number of dimensions and elements in
				** the new type.
				*/

				(yyval.v.NumElements) = 
						(yyvsp[(3) - (6)].s)->NumElements * (yyvsp[(5) - (6)].v.NumElements);

				(yyval.v.Dimensions) =
					malloc2( (yyval.v.Arity) * sizeofInt );


				/*
				** Copy TypeID's dimensions to our Dimensions array.
				*/
				
				assert( (yyvsp[(3) - (6)].s)->Dimensions != NULL );
				memcpy
				( 
					(yyval.v.Dimensions), 
					(yyvsp[(3) - (6)].s)->Dimensions,
					(yyvsp[(3) - (6)].s)->Arity * sizeofInt 
				);

				/*
				** Concatenate the explict dimensions list to the end
				** of our Dimensions array.
				*/
				 
				assert( (yyvsp[(5) - (6)].v.Dimensions) != NULL );
				memcpy
				(
					(yyval.v.Dimensions) +	(yyvsp[(3) - (6)].s)->Arity,
					(yyvsp[(5) - (6)].v.Dimensions),
					(yyvsp[(5) - (6)].v.Arity) * sizeofInt 
				);

				/*
				** We're done with the explict list, so free it.
				*/

				free2( vss (yyvsp[(5) - (6)].v.Dimensions) );

			_endif
			(yyval.v.u.ArrayOfValues) = NULL;
		;}
    break;

  case 1060:

/* Line 1464 of yacc.c  */
#line 47234 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(9) - (10)].v.pType) == tArray )

				/*
				** Check to see if the list of array values specified
				** by the user is type and count compatible with the
				** array type specified by the TypeID and the explicit
				** dimensions list.	If so, insert the constant into
				** the symbol table.
				*/

				_if
				( 
					ArraysAreCompatible
					( 
						YYS &(yyvsp[(7) - (10)].v), 
						YYS &(yyvsp[(9) - (10)].v) 
					)
				)

					InsertSym
					( 
						(yyvsp[(1) - (10)].idStr), 
						(yyvsp[(7) - (10)].v.Type),
						tArray, 
						cValue, 
						(yyvsp[(7) - (10)].v.Arity),
						(yyvsp[(7) - (10)].v.Dimensions),
						(yyvsp[(7) - (10)].v.NumElements),
						YYS &(yyvsp[(9) - (10)].v),
						(yyvsp[(3) - (10)].s)->ObjectSize * (yyvsp[(5) - (10)].v.NumElements),
						0,
						NULL,
						(yyvsp[(7) - (10)].v.Base),
						(yyvsp[(7) - (10)].v.Fields),
						(yyvsp[(7) - (10)].v.FieldCnt)
					);


				_else

					/*
					** At this point either the types of the elements do
					** not agree or the number of elements do not agree.
					** Figure out which and print the appropriate error 
					** msg.
					*/

					_if
					( 
							(yyvsp[(7) - (10)].v.NumElements) == (yyvsp[(9) - (10)].v.NumElements)
						||	(yyvsp[(3) - (10)].s)->pType == tText 
					)

						yyerror( "Type mismatch in operands" );

					_else

						yyerror
						( 
							"The number of array elements do not match" 
						);

					_endif
					_if( (yyvsp[(9) - (10)].v.pType) == tArray )
					
						FreeValue( YYS &(yyvsp[(9) - (10)].v) );

					_endif
					free2( vss (yyvsp[(7) - (10)].v.Dimensions) );

				_endif

			_else

				yyerror( "Expected array expression" );
				_if( (yyvsp[(9) - (10)].v.pType) == tArray )
				
					FreeValue( YYS &(yyvsp[(9) - (10)].v) );

				_endif
				free2( vss (yyvsp[(7) - (10)].v.Dimensions) );

			_endif

		
		;}
    break;

  case 1061:

/* Line 1464 of yacc.c  */
#line 47336 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (6)].s) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );

			/*
			** Set up some common synthesized attribute return values.
			*/

			(yyval.v.pType) = tArray;
			(yyval.v.Arity) = (yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.Arity);
			(yyval.v.Base) = (yyvsp[(3) - (6)].s)->Base;
			(yyval.v.Fields) = (yyvsp[(3) - (6)].s)->Fields;
			(yyval.v.FieldCnt) = (yyvsp[(3) - (6)].s)->FieldCnt;
			(yyval.v.Type) =GetBaseType( (yyvsp[(3) - (6)].s) );

			/*
			** Scream if the user is trying to define a text array.
			*/

			_if( (yyvsp[(3) - (6)].s)->pType == tText )

				yyerror( "Cannot have TEXT arrays" );
				(yyvsp[(3) - (6)].s) = &string_ste;

			_endif

			/*
			** If it's not a primitive scalar type, complain about
			** that and then fake a usable type.
			*/

			_if( !CanBeVal( (yyvsp[(3) - (6)].s)->pType ))

				yyerror( "Values can only have primitive types" );
				(yyvsp[(3) - (6)].s) = &uns32_ste;

			_endif

			/*
			** If the TypeID isn't an array object, this is easy;
			** Just return the size of the array constant list.
			*/

			_if( (yyvsp[(3) - (6)].s)->pType != tArray )
			
				(yyval.v.NumElements) = (yyvsp[(5) - (6)].v.NumElements);
				(yyval.v.Dimensions) = (yyvsp[(5) - (6)].v.Dimensions);

			/*
			** On the other hand, if TypeID is an array object,
			** then we've got to add a new list of dimensions onto
			** the end of the TypeID list.
			*/

			_else

				/*
				** Compute the number of dimensions and elements in
				** the new type.
				*/

				(yyval.v.NumElements) = 
						(yyvsp[(3) - (6)].s)->NumElements * (yyvsp[(5) - (6)].v.NumElements);

				(yyval.v.Dimensions) =
					malloc2( (yyval.v.Arity) * sizeofInt );


				/*
				** Copy TypeID's dimensions to our Dimensions array.
				*/
				
				assert( (yyvsp[(3) - (6)].s)->Dimensions != NULL );
				memcpy
				( 
					(yyval.v.Dimensions), 
					(yyvsp[(3) - (6)].s)->Dimensions,
					(yyvsp[(3) - (6)].s)->Arity * sizeofInt 
				);

				/*
				** Concatenate the explict dimensions list to the end
				** of our Dimensions array.
				*/
				 
				assert( (yyvsp[(5) - (6)].v.Dimensions) != NULL );
				memcpy
				(
					(yyval.v.Dimensions) +	(yyvsp[(3) - (6)].s)->Arity,
					(yyvsp[(5) - (6)].v.Dimensions),
					(yyvsp[(5) - (6)].v.Arity) * sizeofInt 
				);

				/*
				** We're done with the explict list, so free it.
				*/

				free2( vss (yyvsp[(5) - (6)].v.Dimensions) );

			_endif
			(yyval.v.u.ArrayOfValues) = NULL;
		;}
    break;

  case 1062:

/* Line 1464 of yacc.c  */
#line 47442 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(9) - (10)].v.pType) == tArray )

				/*
				** Check to see if the list of array values specified
				** by the user is type and count compatible with the
				** array type specified by the TypeID and the explicit
				** dimensions list.	If so, insert the constant into
				** the symbol table.
				*/

				_if
				( 
					ArraysAreCompatible
					( 
						YYS &(yyvsp[(7) - (10)].v), 
						YYS &(yyvsp[(9) - (10)].v) 
					)
				)

					SetSym
					( 
						(yyvsp[(1) - (10)].s), 
						(yyvsp[(7) - (10)].v.Type),
						tArray, 
						(yyvsp[(7) - (10)].v.Arity),
						(yyvsp[(7) - (10)].v.Dimensions),
						(yyvsp[(7) - (10)].v.NumElements),
						YYS &(yyvsp[(9) - (10)].v),
						(yyvsp[(3) - (10)].s)->ObjectSize * (yyvsp[(5) - (10)].v.NumElements),
						0,
						NULL,
						(yyvsp[(7) - (10)].v.Base),
						(yyvsp[(7) - (10)].v.Fields),
						(yyvsp[(7) - (10)].v.FieldCnt),
						(yyvsp[(7) - (10)].v.CurField),
						(yyvsp[(7) - (10)].v.CurIndex)
					);


				_else

					/*
					** At this point either the types of the elements do
					** not agree or the number of elements do not agree.
					** Figure out which and print the appropriate error 
					** msg.
					*/

					_if
					( 
							(yyvsp[(7) - (10)].v.NumElements) == (yyvsp[(9) - (10)].v.NumElements)
						||	(yyvsp[(3) - (10)].s)->pType == tText 
					)

						yyerror( "Type mismatch in operands" );

					_else

						yyerror
						( 
							"The number of array elements do not match" 
						);

					_endif
					_if( (yyvsp[(9) - (10)].v.pType) == tArray )
					
						FreeValue( YYS &(yyvsp[(9) - (10)].v) );

					_endif
					free2( vss (yyvsp[(7) - (10)].v.Dimensions) );

				_endif

			_else

				yyerror( "Expected array expression" );
				_if( (yyvsp[(9) - (10)].v.pType) == tArray )
				
					FreeValue( YYS &(yyvsp[(9) - (10)].v) );

				_endif
				free2( vss (yyvsp[(7) - (10)].v.Dimensions) );

			_endif
			_here;
		
		;}
    break;

  case 1063:

/* Line 1464 of yacc.c  */
#line 47548 "hlaparse.bsn"
    {			/* $6 */
		
			_here;
			assert( (yyvsp[(1) - (5)].idStr) != NULL );
			assert( (yyvsp[(3) - (5)].s) != NULL );
			/*
			** Scream if the user is trying to define a text array.
			*/

			_if( (yyvsp[(3) - (5)].s)->pType == tText )

				yyerror( "Cannot have TEXT arrays" );
				(yyvsp[(3) - (5)].s) = &string_ste;

			_endif

			/*
			** If it's not a primitive scalar type, complain about
			** that and then fake a usable type.
			*/

			_if( !CanBeVal( (yyvsp[(3) - (5)].s)->pType ))

				yyerror( "Values can only have primitive types" );
				(yyvsp[(3) - (5)].s) = &uns32_ste;

			_endif
			_here;
		;}
    break;

  case 1064:

/* Line 1464 of yacc.c  */
#line 47580 "hlaparse.bsn"
    {				/* $10 */

			int		i;
			char	IsValid;

			_here;
			_if( (yyvsp[(8) - (9)].v.pType) != tArray )
			
				yyerror( "Expected array expression" );
				FreeValue( YYS &(yyvsp[(8) - (9)].v) );
			
			_else				
			
				/*
				** There are two cases we need to consider here:
				**
				**	1.	The base type of the constant is a scalar
				**		type.  For this case, we simply give the
				**		constant type the same number of elements
				**		as the array constant.
				**
				**	2.	The base type of the constant is an array type.
				**		In this case we have to make sure that the
				**		number of elements in the array constant is
				**		an even multiple of the number of elements in
				**		the array type.
				*/
				
				_if( (yyvsp[(3) - (9)].s)->pType != tArray )
				
					/*
					** Okay, we've got the simple case where we
					** just copy the data from the expression into
					** the new constant object. But first, let's make sure 
					** that the elements of this array are compatible with
					** the base type of the array constant object:
					*/
					
					
					IsValid = 1;
					i = 0;
					_do
					
						/*
						** Verify that each element of the array expression
						** is compatible with our destination type:
						*/
						
						IsValid = 
								IsValid 
							&&	IsCompatible
								(
									GetBaseType( (yyvsp[(3) - (9)].s) ),
									YYS &(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i] 
								);
								
						++i;
						
					_until( i >= (yyvsp[(8) - (9)].v.NumElements) || !IsValid )
					
					_if( IsValid )
					
						InsertSym
						( 
							(yyvsp[(1) - (9)].idStr), 
							GetBaseType( (yyvsp[(3) - (9)].s) ),
							tArray, 
							cValue, 
							1,							/* Arity		*/
							malloc2( sizeofInt ),	/* Dimensions	*/
							(yyvsp[(8) - (9)].v.NumElements),			/* NumElements	*/
							NULL,						/* Value		*/
							0,							/* ObjectSize	*/
							0,							/* Offset		*/
							NULL,						/* Static Name	*/
							(yyvsp[(8) - (9)].v.Base),					/* Base Type	*/
							(yyvsp[(8) - (9)].v.Fields),				/* Field list	*/
							(yyvsp[(8) - (9)].v.FieldCnt)				/* Num Fields	*/
						);
						
						/*
						** Allocate storage to hold the data:
						*/
						
						SymbolTable->u.ArrayOfValues = 
							malloc2
							( 
								(yyvsp[(8) - (9)].v.NumElements) * sizeofSymNode
							);
							
						/*
						** Copy the data from the array constant expression
						** to the array object we've just created:
						*/
						
						_for( i=0, i < (yyvsp[(8) - (9)].v.NumElements), ++i )
						
							DeepCopy
							( 
								&SymbolTable->u.ArrayOfValues[i], 
								&(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i]
							);
							
						_endfor
						
						/*
						** Set up the size information for this constant array:
						*/
						
						SymbolTable->Dimensions[0] = (yyvsp[(8) - (9)].v.NumElements);
						SymbolTable->ObjectSize = 
							(yyvsp[(3) - (9)].s)->ObjectSize * (yyvsp[(8) - (9)].v.NumElements);
							
						
						
					_else
					
						yyerror( "Type mismatch in operands" );
					
					_endif


				_else
				
					/*
					** Okay, the base type of the constant object is
					** an array type.  This means that the number
					** of elements in the constant expression must
					** be an even multiple of the number of elements
					** in the base type.
					*/
					
					_if
					(
							(yyvsp[(3) - (9)].s)->NumElements >= (yyvsp[(8) - (9)].v.NumElements)
						||	( (yyvsp[(8) - (9)].v.NumElements) % (yyvsp[(3) - (9)].s)->NumElements ) != 0
					)
					
						yyerror
						( 
							"Array constant has bad number of elements"
						);
						
					_else

						IsValid = 1;
						i = 0;
						_do
						
							/*
							** Verify that each element of the array expression
							** is compatible with our destination type:
							*/
							
							IsValid = 
									IsValid 
								&&	IsCompatible
									(
										GetBaseType( (yyvsp[(3) - (9)].s) ),
										YYS &(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i] 
									);
									
							++i;
							
						_until( i >= (yyvsp[(8) - (9)].v.NumElements) || !IsValid )
						
						_if( IsValid )
						
							InsertSym
							( 
								(yyvsp[(1) - (9)].idStr), 
								GetBaseType( (yyvsp[(3) - (9)].s) ),
								tArray, 
								cValue, 
								(yyvsp[(3) - (9)].s)->Arity + 1,			
								malloc2( sizeofInt  * ((yyvsp[(3) - (9)].s)->Arity + 1)),
								(yyvsp[(8) - (9)].v.NumElements),			
								NULL,						
								0,							
								0,							
								NULL,						
								(yyvsp[(8) - (9)].v.Base),					
								(yyvsp[(8) - (9)].v.Fields),				
								(yyvsp[(8) - (9)].v.FieldCnt)				
							);
							
							/*
							** Allocate storage to hold the data:
							*/
							
							SymbolTable->u.ArrayOfValues = 
								malloc2
								( 
									(yyvsp[(8) - (9)].v.NumElements) * sizeofSymNode
								);
								
							/*
							** Copy the data from the array constant expression
							** to the array object we've just created:
							*/
							
							_for( i=0, i < (yyvsp[(8) - (9)].v.NumElements), ++i )
							
								DeepCopy
								( 
									&SymbolTable->u.ArrayOfValues[i], 
									&(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i]
								);
								
							_endfor
							
							/*
							** Set up the size information for this 
							** constant array:
							*/
												
							_for( i = 0, i < SymbolTable->Arity - 1, ++i )
							
								SymbolTable->Dimensions[i] = 
									(yyvsp[(3) - (9)].s)->Dimensions[i];
									
							_endfor
							SymbolTable->Dimensions[ SymbolTable->Arity - 1 ] =
								(yyvsp[(8) - (9)].v.NumElements) / (yyvsp[(3) - (9)].s)->NumElements;
								
							SymbolTable->ObjectSize = 
								(yyvsp[(3) - (9)].s)->Type->ObjectSize * (yyvsp[(8) - (9)].v.NumElements);
								
							
							
						_else
						
							yyerror( "Type mismatch in operands" );
						
						_endif

					
					_endif


				_endif

			_endif
			FreeValue( YYS &(yyvsp[(8) - (9)].v) );

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;	
			_here;	
		;}
    break;

  case 1065:

/* Line 1464 of yacc.c  */
#line 47858 "hlaparse.bsn"
    {			/* $6 */
		
			_here;
			assert( (yyvsp[(1) - (5)].s) != NULL );
			assert( (yyvsp[(3) - (5)].s) != NULL );
			/*
			** Scream if the user is trying to define a text array.
			*/

			_if( (yyvsp[(3) - (5)].s)->pType == tText )

				yyerror( "Cannot have TEXT arrays" );
				(yyvsp[(3) - (5)].s) = &string_ste;

			_endif

			/*
			** If it's not a primitive scalar type, complain about
			** that and then fake a usable type.
			*/

			_if( !CanBeVal( (yyvsp[(3) - (5)].s)->pType ))

				yyerror( "Values can only have primitive types" );
				(yyvsp[(3) - (5)].s) = &uns32_ste;

			_endif
			_here;
		;}
    break;

  case 1066:

/* Line 1464 of yacc.c  */
#line 47890 "hlaparse.bsn"
    {				/* $10 */

			int		i;
			char	IsValid;

			_here;
			_if( (yyvsp[(8) - (9)].v.pType) != tArray )
			
				yyerror( "Expected array expression" );
				FreeValue( YYS &(yyvsp[(8) - (9)].v) );
			
			_else				
			
				/*
				** There are two cases we need to consider here:
				**
				**	1.	The base type of the constant is a scalar
				**		type.  For this case, we simply give the
				**		constant type the same number of elements
				**		as the array constant.
				**
				**	2.	The base type of the constant is an array type.
				**		In this case we have to make sure that the
				**		number of elements in the array constant is
				**		an even multiple of the number of elements in
				**		the array type.
				*/
				
				_if( (yyvsp[(3) - (9)].s)->pType != tArray )
				
					/*
					** Okay, we've got the simple case where we
					** just copy the data from the expression into
					** the new constant object. But first, let's make sure 
					** that the elements of this array are compatible with
					** the base type of the array constant object:
					*/
					
					
					IsValid = 1;
					i = 0;
					_do
					
						/*
						** Verify that each element of the array expression
						** is compatible with our destination type:
						*/
						
						IsValid = 
								IsValid 
							&&	IsCompatible
								(
									GetBaseType( (yyvsp[(3) - (9)].s) ),
									YYS &(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i] 
								);
								
						++i;
						
					_until( i >= (yyvsp[(8) - (9)].v.NumElements) || !IsValid )
					
					_if( IsValid )
					
						SetSym
						( 
							(yyvsp[(1) - (9)].s), 
							GetBaseType( (yyvsp[(3) - (9)].s) ),
							tArray, 
							1,							/* Arity		*/
							malloc2( sizeofInt ),	/* Dimensions	*/
							(yyvsp[(8) - (9)].v.NumElements),			/* NumElements	*/
							NULL,						/* Value		*/
							0,							/* ObjectSize	*/
							0,							/* Offset		*/
							NULL,						/* Static Name	*/
							(yyvsp[(8) - (9)].v.Base),					/* Base Type	*/
							(yyvsp[(8) - (9)].v.Fields),				/* Field list	*/
							(yyvsp[(8) - (9)].v.FieldCnt),				/* Num Fields	*/
							(yyvsp[(8) - (9)].v.Fields),				/* Current Field*/
							0							/* CurfieldIndx */
						);
						
						/*
						** Allocate storage to hold the data:
						*/
						
						SymbolTable->u.ArrayOfValues = 
							malloc2
							( 
								(yyvsp[(8) - (9)].v.NumElements) * sizeofSymNode
							);
							
						/*
						** Copy the data from the array constant expression
						** to the array object we've just created:
						*/
						
						_for( i=0, i < (yyvsp[(8) - (9)].v.NumElements), ++i )
						
							DeepCopy
							( 
								&SymbolTable->u.ArrayOfValues[i], 
								&(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i]
							);
							
						_endfor
						
						/*
						** Set up the size information for this constant array:
						*/
						
						SymbolTable->Dimensions[0] = (yyvsp[(8) - (9)].v.NumElements);
						SymbolTable->ObjectSize = 
							(yyvsp[(3) - (9)].s)->ObjectSize * (yyvsp[(8) - (9)].v.NumElements);
							
						
						
					_else
					
						yyerror( "Type mismatch in operands" );
					
					_endif


				_else
				
					/*
					** Okay, the base type of the constant object is
					** an array type.  This means that the number
					** of elements in the constant expression must
					** be an even multiple of the number of elements
					** in the base type.
					*/
					
					_if
					(
							(yyvsp[(3) - (9)].s)->NumElements >= (yyvsp[(8) - (9)].v.NumElements)
						||	( (yyvsp[(8) - (9)].v.NumElements) % (yyvsp[(3) - (9)].s)->NumElements ) != 0
					)
					
						yyerror
						( 
							"Array constant has bad number of elements"
						);
						
					_else

						IsValid = 1;
						i = 0;
						_do
						
							/*
							** Verify that each element of the array expression
							** is compatible with our destination type:
							*/
							
							IsValid = 
									IsValid 
								&&	IsCompatible
									(
										GetBaseType( (yyvsp[(3) - (9)].s) ),
										YYS &(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i] 
									);
									
							++i;
							
						_until( i >= (yyvsp[(8) - (9)].v.NumElements) || !IsValid )
						
						_if( IsValid )
						
							SetSym
							( 
								(yyvsp[(1) - (9)].s), 
								GetBaseType( (yyvsp[(3) - (9)].s) ),
								tArray, 
								(yyvsp[(3) - (9)].s)->Arity + 1,			
								malloc2( sizeofInt  * ((yyvsp[(3) - (9)].s)->Arity + 1)),	
								(yyvsp[(8) - (9)].v.NumElements),			
								NULL,						
								0,							
								0,							
								NULL,						
								(yyvsp[(8) - (9)].v.Base),					
								(yyvsp[(8) - (9)].v.Fields),				
								(yyvsp[(8) - (9)].v.FieldCnt),				
								(yyvsp[(8) - (9)].v.Fields),  
								0
							);
							
							/*
							** Allocate storage to hold the data:
							*/
							
							SymbolTable->u.ArrayOfValues = 
								malloc2
								( 
									(yyvsp[(8) - (9)].v.NumElements) * sizeofSymNode
								);
								
							/*
							** Copy the data from the array constant expression
							** to the array object we've just created:
							*/
							
							_for( i=0, i < (yyvsp[(8) - (9)].v.NumElements), ++i )
							
								DeepCopy
								( 
									&SymbolTable->u.ArrayOfValues[i], 
									&(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i]
								);
								
							_endfor
							
							/*
							** Set up the size information for this 
							** constant array:
							*/
												
							_for( i = 0, i < SymbolTable->Arity - 1, ++i )
							
								SymbolTable->Dimensions[i] = 
									(yyvsp[(3) - (9)].s)->Dimensions[i];
									
							_endfor
							SymbolTable->Dimensions[ SymbolTable->Arity - 1 ] =
								(yyvsp[(8) - (9)].v.NumElements) / (yyvsp[(3) - (9)].s)->NumElements;
								
							SymbolTable->ObjectSize = 
								(yyvsp[(3) - (9)].s)->Type->ObjectSize * (yyvsp[(8) - (9)].v.NumElements);
								
							
							
						_else
						
							yyerror( "Type mismatch in operands" );
						
						_endif

					
					_endif


				_endif

			_endif
			FreeValue( YYS &(yyvsp[(8) - (9)].v) );

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;		
		;}
    break;

  case 1067:

/* Line 1464 of yacc.c  */
#line 48172 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (7)].idStr) != NULL );
			assert( (yyvsp[(3) - (7)].s) != NULL );

			/*
			** Initialize some common synthesized attributes.
			*/

			(yyval.v.pType) 	= tArray;
			(yyval.v.Arity) 	= (yyvsp[(3) - (7)].s)->Arity + (yyvsp[(5) - (7)].v.Arity);
			(yyval.v.Type)  	= GetBaseType( (yyvsp[(3) - (7)].s) );
			(yyval.v.Base)		= (yyvsp[(3) - (7)].s)->Base;
			(yyval.v.Fields)	= (yyvsp[(3) - (7)].s)->Fields;
			(yyval.v.FieldCnt)	= (yyvsp[(3) - (7)].s)->FieldCnt;


			/*
			** Text arrays are illegal.
			*/

			_if( (yyvsp[(3) - (7)].s)->pType == tText )

				yyerror( "Cannot have TEXT arrays" );
				(yyvsp[(3) - (7)].s) = &string_ste;


			/*								
			** Make sure this is a legal constant type.
			*/

			_elseif( !CanBeVal( (yyvsp[(3) - (7)].s)->pType ))

				yyerror( "Values can only have primitive types" );
				(yyvsp[(3) - (7)].s) = &string_ste;

			_else

				/*
				** If TypeID is a scalar type, just use the
				** DimList attributes.
				*/

				_if( (yyvsp[(3) - (7)].s)->pType != tArray )
				
					(yyval.v.NumElements) = (yyvsp[(5) - (7)].v.NumElements);
					(yyval.v.Dimensions) = (yyvsp[(5) - (7)].v.Dimensions);

				/*
				** If TypeID is an array type, we need to
				** combine TypeID with DimList to produce
				** a larger array.
				*/

				_else


					(yyval.v.NumElements) = 
							(yyvsp[(3) - (7)].s)->NumElements * (yyvsp[(5) - (7)].v.NumElements);

					(yyval.v.Dimensions) =
						malloc2( (yyval.v.Arity) * sizeofInt );
 
					assert( (yyvsp[(3) - (7)].s)->Dimensions != NULL );
					memcpy
					( 
						(yyval.v.Dimensions), 
						(yyvsp[(3) - (7)].s)->Dimensions,
						(yyvsp[(3) - (7)].s)->Arity * sizeofInt 
					);

					assert( (yyvsp[(5) - (7)].v.Dimensions) != NULL );
					memcpy
					(
						(yyval.v.Dimensions) +	(yyvsp[(3) - (7)].s)->Arity,
						(yyvsp[(5) - (7)].v.Dimensions),
						(yyvsp[(5) - (7)].v.Arity) * sizeofInt 
					);
					free2( vss (yyvsp[(5) - (7)].v.Dimensions) );

				_endif

				ClrNewSym
				( 
					(yyvsp[(1) - (7)].idStr), 
					(yyval.v.Type),
					tArray, 
					cValue, 
					(yyval.v.Arity),
					(yyval.v.Dimensions),
					(yyval.v.NumElements),
					(yyvsp[(3) - (7)].s)->ObjectSize * (yyvsp[(5) - (7)].v.NumElements),
					0,
					NULL,
					(yyval.v.Base),
					(yyval.v.Fields),
					(yyval.v.FieldCnt),
					(yyval.v.CurField),
					(yyval.v.CurIndex)
				);

			_endif
			_here;
		;}
    break;

  case 1068:

/* Line 1464 of yacc.c  */
#line 48291 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (7)].s) != NULL );
			assert( (yyvsp[(3) - (7)].s) != NULL );

			/*
			** Initialize some common synthesized attributes.
			*/

			(yyval.v.pType) 	= tArray;
			(yyval.v.Arity) 	= (yyvsp[(3) - (7)].s)->Arity + (yyvsp[(5) - (7)].v.Arity);
			(yyval.v.Type)  	= GetBaseType( (yyvsp[(3) - (7)].s) );
			(yyval.v.Base)		= (yyvsp[(3) - (7)].s)->Base;
			(yyval.v.Fields)	= (yyvsp[(3) - (7)].s)->Fields;
			(yyval.v.FieldCnt)	= (yyvsp[(3) - (7)].s)->FieldCnt;


			/*
			** Text arrays are illegal.
			*/

			_if( (yyvsp[(3) - (7)].s)->pType == tText )

				yyerror( "Cannot have TEXT arrays" );
				(yyvsp[(3) - (7)].s) = &string_ste;


			/*
			** Make sure this is a legal constant type.
			*/

			_elseif( !CanBeVal( (yyvsp[(3) - (7)].s)->pType ))

				yyerror( "Values can only have primitive types" );
				(yyvsp[(3) - (7)].s) = &string_ste;

			_else

				/*
				** If TypeID is a scalar type, just use the
				** DimList attributes.
				*/

				_if( (yyvsp[(3) - (7)].s)->pType != tArray )
				
					(yyval.v.NumElements) = (yyvsp[(5) - (7)].v.NumElements);
					(yyval.v.Dimensions) = (yyvsp[(5) - (7)].v.Dimensions);

				/*
				** If TypeID is an array type, we need to
				** combine TypeID with DimList to produce
				** a larger array.
				*/

				_else


					(yyval.v.NumElements) = 
							(yyvsp[(3) - (7)].s)->NumElements * (yyvsp[(5) - (7)].v.NumElements);

					(yyval.v.Dimensions) =
						malloc2( (yyval.v.Arity) * sizeofInt );
 
					assert( (yyvsp[(3) - (7)].s)->Dimensions != NULL );
					memcpy
					( 
						(yyval.v.Dimensions), 
						(yyvsp[(3) - (7)].s)->Dimensions,
						(yyvsp[(3) - (7)].s)->Arity * sizeofInt 
					);

					assert( (yyvsp[(5) - (7)].v.Dimensions) != NULL );
					memcpy
					(
						(yyval.v.Dimensions) +	(yyvsp[(3) - (7)].s)->Arity,
						(yyvsp[(5) - (7)].v.Dimensions),
						(yyvsp[(5) - (7)].v.Arity) * sizeofInt 
					);
					free2( vss (yyvsp[(5) - (7)].v.Dimensions) );

				_endif

				ClrSym
				( 
					(yyvsp[(1) - (7)].s), 
					(yyval.v.Type),
					tArray, 
					(yyval.v.Arity),
					(yyval.v.Dimensions),
					(yyval.v.NumElements),
					(yyvsp[(3) - (7)].s)->ObjectSize * (yyvsp[(5) - (7)].v.NumElements),
					0,
					NULL,
					(yyval.v.Base),
					(yyval.v.Fields),
					(yyval.v.FieldCnt),
					(yyval.v.CurField),
					(yyval.v.CurIndex)
				);

			_endif
			_here;
		;}
    break;

  case 1069:

/* Line 1464 of yacc.c  */
#line 48406 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (4)].v.u.PtrToValue) != NULL )

				_if( (yyvsp[(1) - (4)].v.pType) == tArray )

					_if
					( 
						ArraysAreCompatible
						( 
							YYS &(yyvsp[(1) - (4)].v), 
							YYS &(yyvsp[(3) - (4)].v) 
						)
					)


						_for( int i=0, i < (yyvsp[(1) - (4)].v.NumElements), ++i )
						
							DeepCopy
							(
									&(yyvsp[(1) - (4)].v.u.PtrToValue)[i],
									&(yyvsp[(3) - (4)].v.u.ArrayOfValues)[i]
							);

						_endfor

					_elseif( (yyvsp[(1) - (4)].v.NumElements) == (yyvsp[(3) - (4)].v.NumElements) )

						yyerror( "Type mismatch in operands" );

					_else

						yyerror
						( 
							"The number of array elements do not match"
						);

					_endif
					FreeValue( YYS &(yyvsp[(3) - (4)].v) );


				_elseif( (yyvsp[(1) - (4)].v.pType) == tRecord )

					_if
					( 
						RecordsAreCompatible
						( 
							&(yyvsp[(1) - (4)].v), 
							YYS &(yyvsp[(3) - (4)].v) 
						)
					)
			
						_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

							// Note: A deep copy was already done on
							// the constant, no need to repeat that here.
												
							FreeValue( YYS &(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i] );
							(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i] =
								(yyvsp[(3) - (4)].v.u.FieldValues)[i];

						_endfor

					_else

						yyerror
						( 
							"The records are incompatible"
						);
						FreeValue( YYS &(yyvsp[(3) - (4)].v) );

					_endif



				_elseif
				( 
						(yyvsp[(1) - (4)].v.pType) == tUnion
					&&	(yyvsp[(3) - (4)].v.pType) == tUnion
					&&	GetBaseType( (yyvsp[(1) - (4)].v.Type) ) == 
							GetBaseType( (yyvsp[(3) - (4)].v.Type) ) 
				)

					_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

						// Note: A deep copy was already done on
						// the constant, no need to repeat that here.
											
						FreeValue( YYS &(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i] );
						(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i] =
							(yyvsp[(3) - (4)].v.u.FieldValues)[i];

					_endfor
					(yyvsp[(1) - (4)].v.u.PtrToValue)->CurField = (yyvsp[(3) - (4)].v.CurField);
					(yyvsp[(1) - (4)].v.u.PtrToValue)->CurIndex = (yyvsp[(3) - (4)].v.CurIndex);





				_elseif
				( 
						(yyvsp[(1) - (4)].v.pType) == tReal128
					&&	(yyvsp[(3) - (4)].v.pType) == tReal128
					&&	GetBaseType( (yyvsp[(1) - (4)].v.Type) ) == 
							GetBaseType( (yyvsp[(3) - (4)].v.Type) ) 
				)

					_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

						// Note: A deep copy was already done on
						// the constant, no need to repeat that here.
											
						FreeValue( YYS &(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i] );
						(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i] =
							(yyvsp[(3) - (4)].v.u.FieldValues)[i];

					_endfor
					(yyvsp[(1) - (4)].v.u.PtrToValue)->CurField = (yyvsp[(3) - (4)].v.CurField);
					(yyvsp[(1) - (4)].v.u.PtrToValue)->CurIndex = (yyvsp[(3) - (4)].v.CurIndex);


				_else /* Must be a scalar value */

					memcpy
					( 
						&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.StartOfValues, 
						&(yyvsp[(3) - (4)].v.u.StartOfValues), 
						sizeofValuesSize
					);

				_endif

			_endif
			_here;
		;}
    break;

  case 1070:

/* Line 1464 of yacc.c  */
#line 48553 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (4)].v.u.PtrToValue) != NULL )

				_if( (yyvsp[(1) - (4)].v.pType) == tArray )

					_if
					( 
						ArraysAreCompatible
						( 
							YYS &(yyvsp[(1) - (4)].v), 
							YYS &(yyvsp[(3) - (4)].v) 
						)
					)


						_for( int i=0, i < (yyvsp[(1) - (4)].v.NumElements), ++i )

							DeepCopy
							(
								&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.ArrayOfValues[i],
								&(yyvsp[(3) - (4)].v.u.ArrayOfValues)[i]
							);

						_endfor

					_elseif( (yyvsp[(1) - (4)].v.NumElements) == (yyvsp[(3) - (4)].v.NumElements) )

						yyerror( "Type mismatch in operands" );

					_else

						yyerror
						( 
							"The number of array elements do not match"
						);

					_endif
					FreeValue( YYS &(yyvsp[(3) - (4)].v) );


				_elseif( (yyvsp[(1) - (4)].v.pType) == tRecord )

					_if
					( 
						RecordsAreCompatible
						( 
							&(yyvsp[(1) - (4)].v), 
							YYS &(yyvsp[(3) - (4)].v) 
						)
					)
			
						_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

							DeepCopy
							(
									&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i],
									&(yyvsp[(3) - (4)].v.u.FieldValues)[i]
							);

						_endfor

					_else

						yyerror
						( 
							"The fields are incompatible"
						);

					_endif
					FreeValue( YYS &(yyvsp[(3) - (4)].v) );

				_elseif( (yyvsp[(1) - (4)].v.pType) == tUnion || (yyvsp[(1) - (4)].v.pType) == tReal128 )

					_if( (yyvsp[(1) - (4)].v.Type) == (yyvsp[(3) - (4)].v.Type) )
					
			
						_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

							DeepCopy
							(
									&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i],
									&(yyvsp[(3) - (4)].v.u.FieldValues)[i]
							);

						_endfor

						
					_else
					
						yyerror
						( 
							"The union field and constant are incompatible"
						);
						
						// Need to set up a dummy value to prevent problems:
						
						memcpy
						( 
							(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues,
							&dummy_ste,
							sizeofSymNode
						);
						(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues->StaticName = 
							(yyvsp[(1) - (4)].v.u.PtrToValue)->StaticName;
							
						(yyvsp[(1) - (4)].v.u.PtrToValue)->StaticName = NULL;
						(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues->Offset = (yyvsp[(1) - (4)].v.Offset);
							
					_endif



				_else /* Must be a scalar value */

					memcpy
					( 
						&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.StartOfValues, 
						&(yyvsp[(3) - (4)].v.u.StartOfValues), 
						sizeofValuesSize
					);

				_endif

			_endif
			_here;
		;}
    break;

  case 1071:

/* Line 1464 of yacc.c  */
#line 48683 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1072:

/* Line 1464 of yacc.c  */
#line 48765 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1073:

/* Line 1464 of yacc.c  */
#line 48776 "hlaparse.bsn"
    {
				_here;
				_if( (yyvsp[(3) - (4)].v.pType) != tString )

					yyerror( "Error prefix value must be a string expression" );
					

				_else

					_if( errorPrefixMsg != NULL )
					
						free2( vss errorPrefixMsg );
						FreeValue( YYS &(yyvsp[(3) - (4)].v) );
						
					_else
					
						errorPrefixMsg = (yyvsp[(3) - (4)].v.u.strval);
						
					_endif

				_endif
				_here;
					
			;}
    break;

  case 1074:

/* Line 1464 of yacc.c  */
#line 48804 "hlaparse.bsn"
    {
				_here;
				_if( !checkSmallInt( YYS &(yyvsp[(3) - (4)].v) ) )

					yyerror
					( 
						"Parameter offset value must be a 32-bit integer" 
					);

				_else

					StartParmOffs = (yyvsp[(3) - (4)].v.u.intval);

				_endif

					
			;}
    break;

  case 1075:

/* Line 1464 of yacc.c  */
#line 48825 "hlaparse.bsn"
    {
				_here;
				_if( !checkSmallInt( YYS &(yyvsp[(3) - (4)].v) ) )

					yyerror( "Locals offset value must be a 32-bit integer" );

				_else

					StartLclOffs = (yyvsp[(3) - (4)].v.u.intval);

				_endif

					
			;}
    break;

  case 1076:

/* Line 1464 of yacc.c  */
#line 48843 "hlaparse.bsn"
    {
				_here;
				_if( !checkSmallInt( YYS &(yyvsp[(3) - (4)].v) ) )

					yyerror( "Enum size must be an integer" );

				_else

					EnumSize = (yyvsp[(3) - (4)].v.u.intval);

				_endif

					
			;}
    break;

  case 1077:

/* Line 1464 of yacc.c  */
#line 48862 "hlaparse.bsn"
    {
				_here;
				_if( !checkSmallInt( YYS &(yyvsp[(3) - (4)].v) ) || (yyvsp[(3) - (4)].v.u.intval) < 1 )

					yyerror( "@label must be assigned an integer > 1" );

				_else

					LblCntr = (yyvsp[(3) - (4)].v.u.intval);

				_endif
				_here;
			;}
    break;

  case 1078:

/* Line 1464 of yacc.c  */
#line 48880 "hlaparse.bsn"
    {
				_here;
				CurBaseReg = "ebp";
			;}
    break;

  case 1079:

/* Line 1464 of yacc.c  */
#line 48888 "hlaparse.bsn"
    {
				_here;
				CurBaseReg = "esp";
			;}
    break;

  case 1080:

/* Line 1464 of yacc.c  */
#line 48895 "hlaparse.bsn"
    {
				yyerror( "'@basereg := reg' only allows ESP or EBP" );
			;}
    break;

  case 1081:

/* Line 1464 of yacc.c  */
#line 48903 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@bound expects a boolean expression" );

			_else

				CompileBound = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1082:

/* Line 1464 of yacc.c  */
#line 48920 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@into expects a boolean expression" );

			_else

				CompileInto = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1083:

/* Line 1464 of yacc.c  */
#line 48936 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@trace expects a boolean expression" );

			_else

				TraceFlag = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1084:

/* Line 1464 of yacc.c  */
#line 48954 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@exceptions expects a boolean expression" );

			_else

				FullExceptions = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1085:

/* Line 1464 of yacc.c  */
#line 48973 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@display expects a boolean expression" );

			_else

				DisplayDefault = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1086:

/* Line 1464 of yacc.c  */
#line 48991 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@nodisplay expects a boolean expression" );

			_else

				DisplayDefault = !(yyvsp[(3) - (4)].v.u.boolval);

			_endif
				
		;}
    break;

  case 1087:

/* Line 1464 of yacc.c  */
#line 49008 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@frame expects a boolean expression" );

			_else

				FrameDefault = (yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level && (yyvsp[(3) - (4)].v.u.boolval) )
				
					yyerror
					( 
						"@frame can only be assigned false except in \n"
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1088:

/* Line 1464 of yacc.c  */
#line 49035 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@nodisplay expects a boolean expression" );

			_else

				FrameDefault = !(yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level && !(yyvsp[(3) - (4)].v.u.boolval) )
				
					yyerror
					( 
						"@noframe can only be assigned true except in \n"
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1089:

/* Line 1464 of yacc.c  */
#line 49062 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@alignstack expects a boolean expression" );

			_else

				AlignStackDefault = (yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level && (yyvsp[(3) - (4)].v.u.boolval) )
				
					yyerror
					( 
						"@alignstack can only be assigned false except in \n"
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1090:

/* Line 1464 of yacc.c  */
#line 49089 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@noalignstack expects a boolean expression" );

			_else

				AlignStackDefault = !(yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level && !(yyvsp[(3) - (4)].v.u.boolval) )
				
					yyerror
					( 
						"@noalignstack can only be assigned true except in \n"
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1091:

/* Line 1464 of yacc.c  */
#line 49116 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@enter expects a boolean expression" );

			_else

				EnterDefault = (yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level  )
				
					yyerror
					( 
						"@enter is illegal except in "
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1092:

/* Line 1464 of yacc.c  */
#line 49143 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@noenter expects a boolean expression" );

			_else

				EnterDefault = !(yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level  )
				
					yyerror
					( 
						"@noenter is illegal except in "
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1093:

/* Line 1464 of yacc.c  */
#line 49170 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@leave expects a boolean expression" );

			_else

				LeaveDefault = (yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level  )
				
					yyerror
					( 
						"@leave is illegal except in "
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1094:

/* Line 1464 of yacc.c  */
#line 49197 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@noleave expects a boolean expression" );

			_else

				LeaveDefault = !(yyvsp[(3) - (4)].v.u.boolval);
				_if( langLevel <= low_level  )
				
					yyerror
					( 
						"@noleave is illegal except in "
						"high-level and medium-level language modes."
					);
					
				_endif

			_endif

				
		;}
    break;

  case 1095:

/* Line 1464 of yacc.c  */
#line 49225 "hlaparse.bsn"
    {
				_here;
				_if( !checkSmallInt( YYS &(yyvsp[(3) - (4)].v) ) )

					yyerror( "@align value must be a 32-bit integer" );

				_else

					int bits;
					int value;
					
					bits = 0;
					value = (yyvsp[(3) - (4)].v.u.intval);
					_while( value != 0 )
					
						bits = bits + (value & 1);
						value = value >> 1;
						
					_endwhile;
					_if( bits != 1 )
					
						yyerror
						( 
							"@align requires an operand that is a power of two" 
						);
						
					_elseif
					(
							assembler == fasm
						&&	(yyvsp[(3) - (4)].v.u.intval) > 16
					)
					
						yyerror
						( 
							"FASM output supports only 1, 2, 4, 8, and 16 "
							"as alignment values" 
						);
					
						
					_else
					
						AlignDefault = (yyvsp[(3) - (4)].v.u.intval);
						
					_endif;

				_endif
			;}
    break;

  case 1096:

/* Line 1464 of yacc.c  */
#line 49282 "hlaparse.bsn"
    {				/* $5 */
			_here;
			_if( (yyvsp[(3) - (4)].v.pType) != tBoolean )

				yyerror( "@optstrings expects a boolean expression" );

			_else

				OptimizeStrings = (yyvsp[(3) - (4)].v.u.boolval);

			_endif

				
		;}
    break;

  case 1097:

/* Line 1464 of yacc.c  */
#line 49312 "hlaparse.bsn"
    {
			_here;
			_if(( (yyvsp[(3) - (7)].cls.cls) & cfy_SingleID ) == 0 )

				yyerror( "@offset requires a single ID parameter" );

			_elseif(( (yyvsp[(3) - (7)].cls.cls) & cfy_Undefined) || (yyvsp[(3) - (7)].cls.sym) == NULL )

				yyerror( "@offset requires a defined identifier" );

			_else

				_if( checkSmallInt( YYS &(yyvsp[(6) - (7)].v) ))

					(yyvsp[(3) - (7)].cls.sym)->Offset = (yyvsp[(6) - (7)].v.u.intval);
					
				_else
				
					yyerror( "Expected a 32-bit numeric offset value" );
					
				_endif
				
			_endif
			FreeValue( YYS &(yyvsp[(6) - (7)].v) );
			_here;
		;}
    break;

  case 1098:

/* Line 1464 of yacc.c  */
#line 49370 "hlaparse.bsn"
    {

			_here;
			assert( (yyvsp[(1) - (4)].idStr) != NULL );
			assert( (yyvsp[(3) - (4)].v.Type) != NULL );

			InsertSym
			( 
				(yyvsp[(1) - (4)].idStr), 
				(yyvsp[(3) - (4)].v.Type),
				(yyvsp[(3) - (4)].v.pType), 
				cValue, 
				(yyvsp[(3) - (4)].v.Arity),
				(yyvsp[(3) - (4)].v.Dimensions),	/* ConstOnlyExpr mallocs this if array */
				(yyvsp[(3) - (4)].v.NumElements), 
				YYS &(yyvsp[(3) - (4)].v),
				_ifx
				( 
					(yyvsp[(3) - (4)].v.pType) == tArray,
					(yyvsp[(3) - (4)].v.Type)->ObjectSize * (yyvsp[(3) - (4)].v.NumElements),
					(yyvsp[(3) - (4)].v.Type)->ObjectSize
				),
				0,
				NULL,
				(yyvsp[(3) - (4)].v.Base),
				(yyvsp[(3) - (4)].v.Fields),
				(yyvsp[(3) - (4)].v.FieldCnt) 
			);
			_here;

		;}
    break;

  case 1099:

/* Line 1464 of yacc.c  */
#line 49415 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (4)].idStr) != NULL );

			InsertSym
			( 
				(yyvsp[(1) - (4)].idStr), 
				&regex_ste,
				tRegex, 
				cValue, 
				0,
				NULL,
				0, 
				YYS &(yyvsp[(3) - (4)].v),
				4,
				0,
				NULL,
				NULL,
				NULL,
				0 
			);
			_here;

		;}
    break;

  case 1100:

/* Line 1464 of yacc.c  */
#line 49457 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (4)].s) != NULL );

			SetSym
			( 
				(yyvsp[(1) - (4)].s), 
				(yyvsp[(3) - (4)].v.Type),
				(yyvsp[(3) - (4)].v.pType), 
				(yyvsp[(3) - (4)].v.Arity),
				(yyvsp[(3) - (4)].v.Dimensions),	/* ConstOnlyExpr mallocs this if array */
				(yyvsp[(3) - (4)].v.NumElements), 
				YYS &(yyvsp[(3) - (4)].v),
				_ifx
				( 
					(yyvsp[(3) - (4)].v.pType) == tArray,
					(yyvsp[(3) - (4)].v.Type)->ObjectSize * (yyvsp[(3) - (4)].v.NumElements),
					(yyvsp[(3) - (4)].v.Type)->ObjectSize
				),
				0,
				NULL,
				(yyvsp[(3) - (4)].v.Base),
				(yyvsp[(3) - (4)].v.Fields),
				(yyvsp[(3) - (4)].v.FieldCnt),
				(yyvsp[(3) - (4)].v.CurField),
				(yyvsp[(3) - (4)].v.CurIndex) 
			);
			_here;
		;}
    break;

  case 1101:

/* Line 1464 of yacc.c  */
#line 49496 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (4)].s) != NULL );

			SetSym
			( 
				(yyvsp[(1) - (4)].s), 
				&regex_ste,
				tRegex, 
				0,
				NULL,
				0, 
				YYS &(yyvsp[(3) - (4)].v),
				4,
				0,
				NULL,
				NULL,
				NULL,
				0,
				NULL,
				0 
			);
			_here;
		;}
    break;

  case 1102:

/* Line 1464 of yacc.c  */
#line 49530 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (2)].s) != NULL );
			PushBackStr( "+" );
			PushBackStr( (yyvsp[(1) - (2)].s)->TrueName );
			PushBackStr( ":=" );
			PushBackStr( (yyvsp[(1) - (2)].s)->TrueName );
			PushBackStr( "?" );				
			_here;
		;}
    break;

  case 1103:

/* Line 1464 of yacc.c  */
#line 49542 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (2)].s) != NULL );
			PushBackStr( "-" );
			PushBackStr( (yyvsp[(1) - (2)].s)->TrueName );
			PushBackStr( ":=" );
			PushBackStr( (yyvsp[(1) - (2)].s)->TrueName );
			PushBackStr( "?" );				
			_here;
		;}
    break;

  case 1104:

/* Line 1464 of yacc.c  */
#line 49562 "hlaparse.bsn"
    {
			yyerror( "+= operator is not legal with undefined left hand side" );
		;}
    break;

  case 1105:

/* Line 1464 of yacc.c  */
#line 49573 "hlaparse.bsn"
    {
			yyerror( "-= operator is not legal with undefined left hand side" );
		;}
    break;

  case 1106:

/* Line 1464 of yacc.c  */
#line 49590 "hlaparse.bsn"
    {

				_here;
				assert( (yyvsp[(1) - (4)].idStr) != NULL );
				assert( (yyvsp[(3) - (4)].s) != NULL );

				_if( !CanBeVal( (yyvsp[(3) - (4)].s)->pType ))

					yyerror( "Values can only have primitive types" );

				_elseif( (yyvsp[(3) - (4)].s)->pType != tArray )

					ClrNewSym
					( 
						(yyvsp[(1) - (4)].idStr), 
						(yyvsp[(3) - (4)].s),
						(yyvsp[(3) - (4)].s)->pType, 
						cValue, 
						0,
						NULL,
						0, 
						(yyvsp[(3) - (4)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (4)].s)->Base,
						(yyvsp[(3) - (4)].s)->Fields,
						(yyvsp[(3) - (4)].s)->FieldCnt,
						(yyvsp[(3) - (4)].s)->CurField,
						(yyvsp[(3) - (4)].s)->CurIndex 
					);

				_else /* We have an array */


					ClrNewSym
					( 
						(yyvsp[(1) - (4)].idStr), 
						(yyvsp[(3) - (4)].s)->Type,
						tArray, 
						cValue, 
						(yyvsp[(3) - (4)].s)->Arity,
						DupDims( (yyvsp[(3) - (4)].s) ),
						(yyvsp[(3) - (4)].s)->NumElements, 
						(yyvsp[(3) - (4)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (4)].s)->Base, 
						(yyvsp[(3) - (4)].s)->Fields,
						(yyvsp[(3) - (4)].s)->FieldCnt,
						(yyvsp[(3) - (4)].s)->CurField,
						(yyvsp[(3) - (4)].s)->CurIndex
					);

				_endif
				_here;

			;}
    break;

  case 1107:

/* Line 1464 of yacc.c  */
#line 49663 "hlaparse.bsn"
    {
				assert( (yyvsp[(1) - (4)].s) != NULL );
				assert( (yyvsp[(3) - (4)].s) != NULL );
				_here;
				_if( !CanBeVal( (yyvsp[(3) - (4)].s)->pType ))

					yyerror( "Values can only have primitive types" );

				_elseif( (yyvsp[(3) - (4)].s)->pType != tArray )

					ClrSym
					( 
						(yyvsp[(1) - (4)].s), 
						(yyvsp[(3) - (4)].s),
						(yyvsp[(3) - (4)].s)->pType, 
						0,
						NULL,
						0, 
						(yyvsp[(3) - (4)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (4)].s)->Base,
						(yyvsp[(3) - (4)].s)->Fields,
						(yyvsp[(3) - (4)].s)->FieldCnt,
						(yyvsp[(3) - (4)].s)->CurField,
						(yyvsp[(3) - (4)].s)->CurIndex 
					);

				_else /* We have an array */


					ClrSym
					( 
						(yyvsp[(1) - (4)].s), 
						(yyvsp[(3) - (4)].s)->Type,
						tArray, 
						(yyvsp[(3) - (4)].s)->Arity,
						DupDims( (yyvsp[(3) - (4)].s) ),
						(yyvsp[(3) - (4)].s)->NumElements, 
						(yyvsp[(3) - (4)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (4)].s)->Base, 
						(yyvsp[(3) - (4)].s)->Fields,
						(yyvsp[(3) - (4)].s)->FieldCnt,
						(yyvsp[(3) - (4)].s)->CurField,
						(yyvsp[(3) - (4)].s)->CurIndex
					);

				_endif

				_here;
			;}
    break;

  case 1108:

/* Line 1464 of yacc.c  */
#line 49733 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );
			
			/*
			** If the TypeID is an array, the ConstOnlyExpr must also
			** be an array (ID).  That being the case, make sure
			** they are compatible with one another.
			*/
				 
			_if( (yyvsp[(3) - (6)].s)->pType == tArray && (yyvsp[(5) - (6)].v.pType) == tArray )

				_if
				( 
					ArraysAreCompatible
					( 
						YYS (yyvsp[(3) - (6)].s), 
						YYS &(yyvsp[(5) - (6)].v) 
					)
				)

					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr),
						GetBaseType( (yyvsp[(3) - (6)].s) ), 
						tArray, 
						cValue, 
						(yyvsp[(3) - (6)].s)->Arity,
						DupDims( (yyvsp[(3) - (6)].s) ),
						(yyvsp[(3) - (6)].s)->NumElements, 
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

				_else

					yyerror
					( 
						"Type mismatch of array operands or "
						"element value out of range" 
					);
					FreeValue( YYS &(yyvsp[(5) - (6)].v) );


				_endif

			/*
			** If it's not an array, check to see if it is
			** a record.
			*/

			_elseif( (yyvsp[(3) - (6)].s)->pType == tRecord && (yyvsp[(5) - (6)].v.pType) == tRecord )

				_if
				( 
					RecordsAreCompatible
					( 
						(yyvsp[(3) - (6)].s), 
						YYS &(yyvsp[(5) - (6)].v) 
					)
				)

					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr), 
						GetBaseType( (yyvsp[(3) - (6)].s) ),
						tRecord, 
						cValue, 
						(yyvsp[(3) - (6)].s)->Arity,
						(yyvsp[(3) - (6)].s)->Dimensions,
						(yyvsp[(3) - (6)].s)->NumElements, 
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

				_else

					yyerror
					( 
						"Type mismatch of operands. Expected "
						"compatible record types" 
					);

					FreeValue( YYS &(yyvsp[(5) - (6)].v) );

				_endif


				/*
				** If it's not an array or record, check to see if it is
				** a union.
				*/

				_elseif
				( 
						(yyvsp[(3) - (6)].s)->pType == tUnion 
					&&	(yyvsp[(5) - (6)].v.pType) == tUnion
					&&	GetBaseType( (yyvsp[(3) - (6)].s) ) == GetBaseType( (yyvsp[(5) - (6)].v.Type) )
				)

					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr), 
						GetBaseType( (yyvsp[(3) - (6)].s) ),
						tUnion, 
						cValue, 
						0,					// Arity
						NULL,				// Dimensions
						0,					// NumElements
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						(yyvsp[(3) - (6)].s)->Offset,		// Index of selected field.
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

					// Must manually set up the two fields associated with
					// union constants:
					
					SymbolTable->CurField = (yyvsp[(5) - (6)].v.CurField);
					SymbolTable->CurIndex = (yyvsp[(5) - (6)].v.CurIndex);


				/*
				** If it's not an array, union, or record, check to see if it is
				** a real128.
				*/

				_elseif
				( 
						(yyvsp[(3) - (6)].s)->pType == tReal128 
					&&	(yyvsp[(5) - (6)].v.pType) == tReal128
					&&	GetBaseType( (yyvsp[(3) - (6)].s) ) == GetBaseType( (yyvsp[(5) - (6)].v.Type) )
				)

					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr), 
						GetBaseType( (yyvsp[(3) - (6)].s) ),
						tReal128, 
						cValue, 
						0,					// Arity
						NULL,				// Dimensions
						0,					// NumElements
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						(yyvsp[(3) - (6)].s)->Offset,		// Index of selected field.
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

					// Must manually set up the two fields associated with
					// union constants:
					
					SymbolTable->CurField = (yyvsp[(5) - (6)].v.CurField);
					SymbolTable->CurIndex = (yyvsp[(5) - (6)].v.CurIndex);


			/*
			** If TypeID is not an array, make sure that it's a
			** primitive type.
			*/

			_elseif( IsNotPrimType( (yyvsp[(3) - (6)].s)->pType ))

				yyerror( "Constants can only have primitive types" );
				FreeValue( YYS &(yyvsp[(5) - (6)].v) );

			/*
			** If TypeID is a primitive type, then check to see if
			** it is type compatible with the ConstOnlyExpr value.
			** Insert the object into the symbol table if they
			** are compatible.
			*/

			_elseif( IsCompatible( (yyvsp[(3) - (6)].s), YYS &(yyvsp[(5) - (6)].v) ))

				InsertSym
				( 
					(yyvsp[(1) - (6)].idStr),
					GetBaseType( (yyvsp[(3) - (6)].s) ), 
					(yyvsp[(3) - (6)].s)->pType, 
					cValue, 
					0,
					NULL,
					0, 
					YYS &(yyvsp[(5) - (6)].v),
					(yyvsp[(3) - (6)].s)->ObjectSize,
					0,
					NULL,
					(yyvsp[(3) - (6)].s)->Base,
					(yyvsp[(3) - (6)].s)->Fields,
					(yyvsp[(3) - (6)].s)->FieldCnt
				);

			_else

				yyerror
				( 
					"Type mismatch of operands or "
					"value out of range in declaration" 
				);
				FreeValue( YYS &(yyvsp[(5) - (6)].v) );

			_endif
			_here;
		;}
    break;

  case 1109:

/* Line 1464 of yacc.c  */
#line 49967 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );

			_if( (yyvsp[(3) - (6)].s)->pType != tRegex )
			
				yyerror( "Type mismatch, expected REGEX object" );
				
			_else
			
				InsertSym
				( 
					(yyvsp[(1) - (6)].idStr), 
					&regex_ste,
					tRegex, 
					cValue, 
					0,
					NULL,
					0, 
					YYS &(yyvsp[(5) - (6)].v),
					4,
					0,
					NULL,
					NULL,
					NULL,
					0 
				);
			
			_endif
		;}
    break;

  case 1110:

/* Line 1464 of yacc.c  */
#line 50014 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (6)].s) != NULL );
				assert( (yyvsp[(3) - (6)].s) != NULL );
				
				/*
				** Check to see if TypeID is an array type and if
				** ConstOnlyExpr is also an array value (array ID).
				*/
					 
				_if( (yyvsp[(3) - (6)].s)->pType == tArray && (yyvsp[(5) - (6)].v.pType) == tArray )

					/*
					** If they are compatible arrays, then assign
					** ConstOnlyExpr's value to the Local ID, else
					** print an appropriate error message.
					*/

					_if
					( 
						ArraysAreCompatible
						( 
							YYS (yyvsp[(3) - (6)].s), 
							YYS &(yyvsp[(5) - (6)].v) 
						)
					)

						SetSym
						( 
							(yyvsp[(1) - (6)].s),
							GetBaseType( (yyvsp[(3) - (6)].s) ), 
							tArray, 
							(yyvsp[(3) - (6)].s)->Arity,
							DupDims( (yyvsp[(3) - (6)].s) ),
							(yyvsp[(3) - (6)].s)->NumElements, 
							YYS &(yyvsp[(5) - (6)].v),
							(yyvsp[(3) - (6)].s)->ObjectSize,
							0,
							NULL,
							(yyvsp[(3) - (6)].s)->Base,
							(yyvsp[(3) - (6)].s)->Fields,
							(yyvsp[(3) - (6)].s)->FieldCnt,
							(yyvsp[(3) - (6)].s)->CurField,
							(yyvsp[(3) - (6)].s)->CurIndex
						);
						
					_else

						yyerror
						( 
							"Type mismatch of operands or "
							"value out of range in declaration" 
						);
						FreeValue( YYS &(yyvsp[(5) - (6)].v) );


					_endif

				/*
				** If it's not an array, check to see if it is
				** a record.
				*/

				_elseif( (yyvsp[(3) - (6)].s)->pType == tRecord && (yyvsp[(5) - (6)].v.pType) == tRecord )

					_if
					( 
						RecordsAreCompatible
						( 
							(yyvsp[(3) - (6)].s), 
							YYS &(yyvsp[(5) - (6)].v) 
						)
					)

						SetSym
						( 
							(yyvsp[(1) - (6)].s), 
							GetBaseType( (yyvsp[(3) - (6)].s) ),
							tRecord, 
							(yyvsp[(3) - (6)].s)->Arity,
							(yyvsp[(3) - (6)].s)->Dimensions,
							(yyvsp[(3) - (6)].s)->NumElements, 
							YYS &(yyvsp[(5) - (6)].v),
							(yyvsp[(3) - (6)].s)->ObjectSize,
							0,
							NULL,
							(yyvsp[(3) - (6)].s)->Base,
							(yyvsp[(3) - (6)].s)->Fields,
							(yyvsp[(3) - (6)].s)->FieldCnt,
							(yyvsp[(3) - (6)].s)->CurField,
							(yyvsp[(3) - (6)].s)->CurIndex
						);

					_else

						yyerror
						( 
							"Type mismatch of operands. Expected "
							"compatible record types" 
						);
						FreeValue( YYS &(yyvsp[(5) - (6)].v) );

					_endif





				/*
				** If it's not an array or record, check to see if it is
				** a union.
				*/

				_elseif
				( 
						(yyvsp[(3) - (6)].s)->pType == tUnion 
					&&	(yyvsp[(5) - (6)].v.pType) == tUnion
					&&	GetBaseType( (yyvsp[(3) - (6)].s) ) == GetBaseType( (yyvsp[(5) - (6)].v.Type) )
				)

					SetSym
					( 
						(yyvsp[(1) - (6)].s), 
						GetBaseType( (yyvsp[(3) - (6)].s) ),
						tUnion, 
						0,					// Arity
						NULL,				// Dimensions
						0,					// NumElements
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						(yyvsp[(5) - (6)].v.Offset),		// Index of selected field.
						NULL,
						(yyvsp[(5) - (6)].v.Base),
						(yyvsp[(5) - (6)].v.Fields),
						(yyvsp[(5) - (6)].v.FieldCnt),
						(yyvsp[(5) - (6)].v.CurField),
						(yyvsp[(5) - (6)].v.CurIndex)
					);





				/*
				** If it's not an array, union, or record, check to see if it is
				** a real128.
				*/

				_elseif
				( 
						(yyvsp[(3) - (6)].s)->pType == tReal128 
					&&	(yyvsp[(5) - (6)].v.pType) == tReal128
					&&	GetBaseType( (yyvsp[(3) - (6)].s) ) == GetBaseType( (yyvsp[(5) - (6)].v.Type) )
				)

					SetSym
					( 
						(yyvsp[(1) - (6)].s), 
						GetBaseType( (yyvsp[(3) - (6)].s) ),
						tReal128, 
						0,					// Arity
						NULL,				// Dimensions
						0,					// NumElements
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						(yyvsp[(5) - (6)].v.Offset),		// Index of selected field.
						NULL,
						(yyvsp[(5) - (6)].v.Base),
						(yyvsp[(5) - (6)].v.Fields),
						(yyvsp[(5) - (6)].v.FieldCnt),
						(yyvsp[(5) - (6)].v.CurField),
						(yyvsp[(5) - (6)].v.CurIndex)
					);





				/*
				** If TypeID and/or ConstOnlyExpr are not arrays, see if
				** they are primitive types.
				*/

				_elseif( IsNotPrimType( (yyvsp[(3) - (6)].s)->pType ))

					yyerror( "Values can only have primitive types" );
					FreeValue( YYS &(yyvsp[(5) - (6)].v) );

				/*
				** If they are primitive types, see if they are type
				** compatible.  Set the value of the LocalID if they
				** are compatible.
				*/

				_elseif( IsCompatible( (yyvsp[(3) - (6)].s), YYS &(yyvsp[(5) - (6)].v) ))

					SetSym
					( 
						(yyvsp[(1) - (6)].s),
						GetBaseType( (yyvsp[(3) - (6)].s) ), 
						(yyvsp[(3) - (6)].s)->pType, 
						0,
						NULL,
						0, 
						YYS &(yyvsp[(5) - (6)].v),
						(yyvsp[(3) - (6)].s)->ObjectSize,
						0,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt,
						(yyvsp[(3) - (6)].s)->CurField,
						(yyvsp[(3) - (6)].s)->CurIndex
					);

				_else

					yyerror
					( 
						"Type mismatch of operands or "
						"value out of range in declaration" 
					);
					FreeValue( YYS &(yyvsp[(5) - (6)].v) );

				_endif
				_here;
			;}
    break;

  case 1111:

/* Line 1464 of yacc.c  */
#line 50254 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(1) - (6)].s) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );
			
			_if( (yyvsp[(3) - (6)].s)->pType != tRegex )
			
				yyerror( "Type mismatch, expected REGEX object" );
				
			_else
			
				SetSym
				( 
					(yyvsp[(1) - (6)].s), 
					&regex_ste,
					tRegex, 
					0,
					NULL,
					0, 
					YYS &(yyvsp[(5) - (6)].v),
					4,
					0,
					NULL,
					NULL,
					NULL,
					0,
					NULL,
					0 
				);
			
			_endif
			;}
    break;

  case 1112:

/* Line 1464 of yacc.c  */
#line 50303 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (6)].idStr) != NULL );
				assert( (yyvsp[(3) - (6)].s) != NULL );

				/*
				** Set up some common synthesized attribute return values.
				*/

				(yyval.v.pType) = tArray;
				(yyval.v.Arity) = (yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.Arity);
				(yyval.v.Base) = (yyvsp[(3) - (6)].s)->Base;
				(yyval.v.Fields) = (yyvsp[(3) - (6)].s)->Fields;
				(yyval.v.FieldCnt) = (yyvsp[(3) - (6)].s)->FieldCnt;
				(yyval.v.Type) =GetBaseType( (yyvsp[(3) - (6)].s) );

				/*
				** Scream if the user is trying to define a text array.
				*/

				_if( (yyvsp[(3) - (6)].s)->pType == tText )

					yyerror( "Cannot have TEXT arrays" );
					(yyvsp[(3) - (6)].s) = &string_ste;

				_endif

				/*
				** If it's not a primitive scalar type, complain about
				** that and then fake a usable type.
				*/

				_if( !CanBeVal( (yyvsp[(3) - (6)].s)->pType ))

					yyerror( "Values can only have primitive types" );
					(yyvsp[(3) - (6)].s) = &uns32_ste;

				_endif

				/*
				** If the TypeID isn't an array object, this is easy;
				** Just return the size of the array constant list.
				*/

				_if( (yyvsp[(3) - (6)].s)->pType != tArray )
				
					(yyval.v.NumElements) = (yyvsp[(5) - (6)].v.NumElements);
					(yyval.v.Dimensions) = (yyvsp[(5) - (6)].v.Dimensions);
 
				/*
				** On the other hand, if TypeID is an array object,
				** then we've got to add a new list of dimensions onto
				** the end of the TypeID list.
				*/

				_else

					/*
					** Compute the number of dimensions and elements in
					** the new type.
					*/

					(yyval.v.NumElements) = 
							(yyvsp[(3) - (6)].s)->NumElements * (yyvsp[(5) - (6)].v.NumElements);

					(yyval.v.Dimensions) =
						malloc2( (yyval.v.Arity) * sizeofInt );
 

					/*
					** Copy TypeID's dimensions to our Dimensions array.
					*/
					
					assert( (yyvsp[(3) - (6)].s)->Dimensions != NULL );
					memcpy
					( 
						(yyval.v.Dimensions), 
						(yyvsp[(3) - (6)].s)->Dimensions,
						(yyvsp[(3) - (6)].s)->Arity * sizeofInt 
					);

					/*
					** Concatenate the explict dimensions list to the end
					** of our Dimensions array.
					*/
					 
					assert( (yyvsp[(5) - (6)].v.Dimensions) != NULL );
					memcpy
					(
						(yyval.v.Dimensions) +	(yyvsp[(3) - (6)].s)->Arity,
						(yyvsp[(5) - (6)].v.Dimensions),
						(yyvsp[(5) - (6)].v.Arity) * sizeofInt 
					);

					/*
					** We're done with the explict list, so free it.
					*/

					free2( vss (yyvsp[(5) - (6)].v.Dimensions) );

				_endif
				(yyval.v.u.ArrayOfValues) = NULL;
				_here;
			;}
    break;

  case 1113:

/* Line 1464 of yacc.c  */
#line 50410 "hlaparse.bsn"
    {
 				_here;
				_if( (yyvsp[(9) - (10)].v.pType) == tArray )

					/*
					** Check to see if the list of array values specified
					** by the user is type and count compatible with the
					** array type specified by the TypeID and the explicit
					** dimensions list.	If so, insert the constant into
					** the symbol table.
					*/

					_if
					( 
						ArraysAreCompatible
						( 
							YYS &(yyvsp[(7) - (10)].v), 
							YYS &(yyvsp[(9) - (10)].v) 
						)
					)

						InsertSym
						( 
							(yyvsp[(1) - (10)].idStr), 
							(yyvsp[(7) - (10)].v.Type),
							tArray, 
							cValue, 
							(yyvsp[(7) - (10)].v.Arity),
							(yyvsp[(7) - (10)].v.Dimensions),
							(yyvsp[(7) - (10)].v.NumElements),
							YYS &(yyvsp[(9) - (10)].v),
							(yyvsp[(3) - (10)].s)->ObjectSize * (yyvsp[(5) - (10)].v.NumElements),
							0,
							NULL,
							(yyvsp[(7) - (10)].v.Base),
							(yyvsp[(7) - (10)].v.Fields),
							(yyvsp[(7) - (10)].v.FieldCnt)
						);


					_else

						/*
						** At this point either the types of the elements do
						** not agree or the number of elements do not agree.
						** Figure out which and print the appropriate error 
						** msg.
						*/

						_if
						( 
								(yyvsp[(7) - (10)].v.NumElements) == (yyvsp[(9) - (10)].v.NumElements)
							||	(yyvsp[(3) - (10)].s)->pType == tText 
						)

							yyerror( "Type mismatch in operands" );

						_else

							yyerror
							( 
								"The number of array elements do not match" 
							);

						_endif
						_if( (yyvsp[(9) - (10)].v.pType) == tArray )
						
							FreeValue( YYS &(yyvsp[(9) - (10)].v) );

						_endif
						free2( vss (yyvsp[(7) - (10)].v.Dimensions) );

					_endif

				_else

					yyerror( "Expected array expression" );
					_if( (yyvsp[(9) - (10)].v.pType) == tArray )
					
						FreeValue( YYS &(yyvsp[(9) - (10)].v) );

					_endif
					free2( vss (yyvsp[(7) - (10)].v.Dimensions) );

				_endif
				_here;
			;}
    break;

  case 1114:

/* Line 1464 of yacc.c  */
#line 50514 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (6)].s) != NULL );
				assert( (yyvsp[(3) - (6)].s) != NULL );

				/*
				** Set up some common synthesized attribute return values.
				*/

				(yyval.v.pType) = tArray;
				(yyval.v.Arity) = (yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.Arity);
				(yyval.v.Base) = (yyvsp[(3) - (6)].s)->Base;
				(yyval.v.Fields) = (yyvsp[(3) - (6)].s)->Fields;
				(yyval.v.FieldCnt) = (yyvsp[(3) - (6)].s)->FieldCnt;
				(yyval.v.Type) =GetBaseType( (yyvsp[(3) - (6)].s) );

				/*
				** Scream if the user is trying to define a text array.
				*/

				_if( (yyvsp[(3) - (6)].s)->pType == tText )

					yyerror( "Cannot have TEXT arrays" );
					(yyvsp[(3) - (6)].s) = &string_ste;

				_endif

				/*
				** If it's not a primitive scalar type, complain about
				** that and then fake a usable type.
				*/

				_if( !CanBeVal( (yyvsp[(3) - (6)].s)->pType ))

					yyerror( "Values can only have primitive types" );
					(yyvsp[(3) - (6)].s) = &uns32_ste;

				_endif

				/*
				** If the TypeID isn't an array object, this is easy;
				** Just return the size of the array constant list.
				*/

				_if( (yyvsp[(3) - (6)].s)->pType != tArray )
				
					(yyval.v.NumElements) = (yyvsp[(5) - (6)].v.NumElements);
					(yyval.v.Dimensions) = (yyvsp[(5) - (6)].v.Dimensions);
 
				/*
				** On the other hand, if TypeID is an array object,
				** then we've got to add a new list of dimensions onto
				** the end of the TypeID list.
				*/

				_else

					/*
					** Compute the number of dimensions and elements in
					** the new type.
					*/

					(yyval.v.NumElements) = 
							(yyvsp[(3) - (6)].s)->NumElements * (yyvsp[(5) - (6)].v.NumElements);

					(yyval.v.Dimensions) =
						malloc2( (yyval.v.Arity) * sizeofInt );
 

					/*
					** Copy TypeID's dimensions to our Dimensions array.
					*/
					
					assert( (yyvsp[(3) - (6)].s)->Dimensions != NULL );
					memcpy
					( 
						(yyval.v.Dimensions), 
						(yyvsp[(3) - (6)].s)->Dimensions,
						(yyvsp[(3) - (6)].s)->Arity * sizeofInt 
					);

					/*
					** Concatenate the explict dimensions list to the end
					** of our Dimensions array.
					*/
					 
					assert( (yyvsp[(5) - (6)].v.Dimensions) != NULL );
					memcpy
					(
						(yyval.v.Dimensions) +	(yyvsp[(3) - (6)].s)->Arity,
						(yyvsp[(5) - (6)].v.Dimensions),
						(yyvsp[(5) - (6)].v.Arity) * sizeofInt 
					);

					/*
					** We're done with the explict list, so free it.
					*/

					free2( vss (yyvsp[(5) - (6)].v.Dimensions) );

				_endif
				(yyval.v.u.ArrayOfValues) = NULL;
				_here;
			;}
    break;

  case 1115:

/* Line 1464 of yacc.c  */
#line 50621 "hlaparse.bsn"
    {
 				_here;
				_if( (yyvsp[(9) - (10)].v.pType) == tArray )

					/*
					** Check to see if the list of array values specified
					** by the user is type and count compatible with the
					** array type specified by the TypeID and the explicit
					** dimensions list.	If so, insert the constant into
					** the symbol table.
					*/

					_if
					( 
						ArraysAreCompatible
						( 
							YYS &(yyvsp[(7) - (10)].v), 
							YYS &(yyvsp[(9) - (10)].v) 
						)
					)

						SetSym
						( 
							(yyvsp[(1) - (10)].s), 
							(yyvsp[(7) - (10)].v.Type),
							tArray, 
							(yyvsp[(7) - (10)].v.Arity),
							(yyvsp[(7) - (10)].v.Dimensions),
							(yyvsp[(7) - (10)].v.NumElements),
							YYS &(yyvsp[(9) - (10)].v),
							(yyvsp[(3) - (10)].s)->ObjectSize * (yyvsp[(5) - (10)].v.NumElements),
							0,
							NULL,
							(yyvsp[(7) - (10)].v.Base),
							(yyvsp[(7) - (10)].v.Fields),
							(yyvsp[(7) - (10)].v.FieldCnt),
							(yyvsp[(7) - (10)].v.CurField),
							(yyvsp[(7) - (10)].v.CurIndex)
						);


					_else

						/*
						** At this point either the types of the elements do
						** not agree or the number of elements do not agree.
						** Figure out which and print the appropriate error 
						** msg.
						*/

						_if
						( 
								(yyvsp[(7) - (10)].v.NumElements) == (yyvsp[(9) - (10)].v.NumElements)
							||	(yyvsp[(3) - (10)].s)->pType == tText 
						)

							yyerror( "Type mismatch in operands" );

						_else

							yyerror
							( 
								"The number of array elements do not match" 
							);

						_endif
						_if( (yyvsp[(9) - (10)].v.pType) == tArray )
						
							FreeValue( YYS &(yyvsp[(9) - (10)].v) );

						_endif
						free2( vss (yyvsp[(7) - (10)].v.Dimensions) );

					_endif

				_else

					yyerror( "Expected array expression" );
					_if( (yyvsp[(9) - (10)].v.pType) == tArray )
					
						FreeValue( YYS &(yyvsp[(9) - (10)].v) );

					_endif
					free2( vss (yyvsp[(7) - (10)].v.Dimensions) );

				_endif
				_here;
			
			;}
    break;

  case 1116:

/* Line 1464 of yacc.c  */
#line 50728 "hlaparse.bsn"
    {			/* $6 */
		
			_here;
			assert( (yyvsp[(1) - (5)].idStr) != NULL );
			assert( (yyvsp[(3) - (5)].s) != NULL );
			/*
			** Scream if the user is trying to define a text array.
			*/

			_if( (yyvsp[(3) - (5)].s)->pType == tText )

				yyerror( "Cannot have TEXT arrays" );
				(yyvsp[(3) - (5)].s) = &string_ste;

			_endif

			/*
			** If it's not a primitive scalar type, complain about
			** that and then fake a usable type.
			*/

			_if( !CanBeVal( (yyvsp[(3) - (5)].s)->pType ))

				yyerror( "Values can only have primitive types" );
				(yyvsp[(3) - (5)].s) = &uns32_ste;

			_endif
			_here;
		;}
    break;

  case 1117:

/* Line 1464 of yacc.c  */
#line 50760 "hlaparse.bsn"
    {				/* $10 */

			int		i;
			char	IsValid;

			_here;
			_if( (yyvsp[(8) - (9)].v.pType) != tArray )
			
				yyerror( "Expected array expression" );
				FreeValue( YYS &(yyvsp[(8) - (9)].v) );
			
			_else				
			
				/*
				** There are two cases we need to consider here:
				**
				**	1.	The base type of the constant is a scalar
				**		type.  For this case, we simply give the
				**		constant type the same number of elements
				**		as the array constant.
				**
				**	2.	The base type of the constant is an array type.
				**		In this case we have to make sure that the
				**		number of elements in the array constant is
				**		an even multiple of the number of elements in
				**		the array type.
				*/
				
				_if( (yyvsp[(3) - (9)].s)->pType != tArray )
				
					/*
					** Okay, we've got the simple case where we
					** just copy the data from the expression into
					** the new constant object. But first, let's make sure 
					** that the elements of this array are compatible with
					** the base type of the array constant object:
					*/
					
					
					IsValid = 1;
					i = 0;
					_do
					
						/*
						** Verify that each element of the array expression
						** is compatible with our destination type:
						*/
						
						IsValid = 
								IsValid 
							&&	IsCompatible
								(
									GetBaseType( (yyvsp[(3) - (9)].s) ),
									YYS &(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i] 
								);
								
						++i;
						
					_until( i >= (yyvsp[(8) - (9)].v.NumElements) || !IsValid )
					
					_if( IsValid )
					
						InsertSym
						( 
							(yyvsp[(1) - (9)].idStr), 
							GetBaseType( (yyvsp[(3) - (9)].s) ),
							tArray, 
							cValue, 
							1,							/* Arity		*/
							malloc2( sizeofInt ),	/* Dimensions	*/
							(yyvsp[(8) - (9)].v.NumElements),			/* NumElements	*/
							NULL,						/* Value		*/
							0,							/* ObjectSize	*/
							0,							/* Offset		*/
							NULL,						/* Static Name	*/
							(yyvsp[(8) - (9)].v.Base),					/* Base Type	*/
							(yyvsp[(8) - (9)].v.Fields),				/* Field list	*/
							(yyvsp[(8) - (9)].v.FieldCnt)				/* Num Fields	*/
						);
						
						/*
						** Allocate storage to hold the data:
						*/
						
						SymbolTable->u.ArrayOfValues = 
							malloc2
							( 
								(yyvsp[(8) - (9)].v.NumElements) * sizeofSymNode
							);
							
						/*
						** Copy the data from the array constant expression
						** to the array object we've just created:
						*/
						
						_for( i=0, i < (yyvsp[(8) - (9)].v.NumElements), ++i )
						
							DeepCopy
							( 
								&SymbolTable->u.ArrayOfValues[i], 
								&(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i]
							);
							
						_endfor
						
						/*
						** Set up the size information for this constant array:
						*/
						
						SymbolTable->Dimensions[0] = (yyvsp[(8) - (9)].v.NumElements);
						SymbolTable->ObjectSize = 
							(yyvsp[(3) - (9)].s)->ObjectSize * (yyvsp[(8) - (9)].v.NumElements);
							
						
						
					_else
					
						yyerror( "Type mismatch in operands" );
					
					_endif


				_else
				
					/*
					** Okay, the base type of the constant object is
					** an array type.  This means that the number
					** of elements in the constant expression must
					** be an even multiple of the number of elements
					** in the base type.
					*/
					
					_if
					(
							(yyvsp[(3) - (9)].s)->NumElements >= (yyvsp[(8) - (9)].v.NumElements)
						||	( (yyvsp[(8) - (9)].v.NumElements) % (yyvsp[(3) - (9)].s)->NumElements ) != 0
					)
					
						yyerror
						( 
							"Array constant has bad number of elements"
						);
						
					_else

						IsValid = 1;
						i = 0;
						_do
						
							/*
							** Verify that each element of the array expression
							** is compatible with our destination type:
							*/
							
							IsValid = 
									IsValid 
								&&	IsCompatible
									(
										GetBaseType( (yyvsp[(3) - (9)].s) ),
										YYS &(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i] 
									);
									
							++i;
							
						_until( i >= (yyvsp[(8) - (9)].v.NumElements) || !IsValid )
						
						_if( IsValid )
						
							InsertSym
							( 
								(yyvsp[(1) - (9)].idStr), 
								GetBaseType( (yyvsp[(3) - (9)].s) ),
								tArray, 
								cValue, 
								(yyvsp[(3) - (9)].s)->Arity + 1,			
								malloc2( sizeofInt  * ((yyvsp[(3) - (9)].s)->Arity + 1)),
								(yyvsp[(8) - (9)].v.NumElements),			
								NULL,						
								0,							
								0,							
								NULL,						
								(yyvsp[(8) - (9)].v.Base),					
								(yyvsp[(8) - (9)].v.Fields),				
								(yyvsp[(8) - (9)].v.FieldCnt)				
							);
							
							/*
							** Allocate storage to hold the data:
							*/
							
							SymbolTable->u.ArrayOfValues = 
								malloc2
								( 
									(yyvsp[(8) - (9)].v.NumElements) * sizeofSymNode
								);
								
							/*
							** Copy the data from the array constant expression
							** to the array object we've just created:
							*/
							
							_for( i=0, i < (yyvsp[(8) - (9)].v.NumElements), ++i )
							
								DeepCopy
								( 
									&SymbolTable->u.ArrayOfValues[i], 
									&(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i]
								);
								
							_endfor
							
							/*
							** Set up the size information for this 
							** constant array:
							*/
												
							_for( i = 0, i < SymbolTable->Arity - 1, ++i )
							
								SymbolTable->Dimensions[i] = 
									(yyvsp[(3) - (9)].s)->Dimensions[i];
									
							_endfor
							SymbolTable->Dimensions[ SymbolTable->Arity - 1 ] =
								(yyvsp[(8) - (9)].v.NumElements) / (yyvsp[(3) - (9)].s)->NumElements;
								
							SymbolTable->ObjectSize = 
								(yyvsp[(3) - (9)].s)->Type->ObjectSize * (yyvsp[(8) - (9)].v.NumElements);
								
							
							
						_else
						
							yyerror( "Type mismatch in operands" );
						
						_endif

					
					_endif


				_endif

			_endif
			FreeValue( YYS &(yyvsp[(8) - (9)].v) );

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;		
		;}
    break;

  case 1118:

/* Line 1464 of yacc.c  */
#line 51037 "hlaparse.bsn"
    {				/* $6 */
		
			_here;
			assert( (yyvsp[(1) - (5)].s) != NULL );
			assert( (yyvsp[(3) - (5)].s) != NULL );
			/*
			** Scream if the user is trying to define a text array.
			*/

			_if( (yyvsp[(3) - (5)].s)->pType == tText )

				yyerror( "Cannot have TEXT arrays" );
				(yyvsp[(3) - (5)].s) = &string_ste;

			_endif

			/*
			** If it's not a primitive scalar type, complain about
			** that and then fake a usable type.
			*/

			_if( !CanBeVal( (yyvsp[(3) - (5)].s)->pType ))

				yyerror( "Values can only have primitive types" );
				(yyvsp[(3) - (5)].s) = &uns32_ste;

			_endif
			_here;
		;}
    break;

  case 1119:

/* Line 1464 of yacc.c  */
#line 51069 "hlaparse.bsn"
    {				/* $10 */

			int		i;
			char	IsValid;

			_here;
			_if( (yyvsp[(8) - (9)].v.pType) != tArray )
			
				yyerror( "Expected array expression" );
				FreeValue( YYS &(yyvsp[(8) - (9)].v) );
			
			_else				
			
				/*
				** There are two cases we need to consider here:
				**
				**	1.	The base type of the constant is a scalar
				**		type.  For this case, we simply give the
				**		constant type the same number of elements
				**		as the array constant.
				**
				**	2.	The base type of the constant is an array type.
				**		In this case we have to make sure that the
				**		number of elements in the array constant is
				**		an even multiple of the number of elements in
				**		the array type.
				*/
				
				_if( (yyvsp[(3) - (9)].s)->pType != tArray )
				
					/*
					** Okay, we've got the simple case where we
					** just copy the data from the expression into
					** the new constant object. But first, let's make sure 
					** that the elements of this array are compatible with
					** the base type of the array constant object:
					*/
					
					
					IsValid = 1;
					i = 0;
					_do
					
						/*
						** Verify that each element of the array expression
						** is compatible with our destination type:
						*/
						
						IsValid = 
								IsValid 
							&&	IsCompatible
								(
									GetBaseType( (yyvsp[(3) - (9)].s) ),
									YYS &(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i] 
								);
								
						++i;
						
					_until( i >= (yyvsp[(8) - (9)].v.NumElements) || !IsValid )
					
					_if( IsValid )
					
						int *dimensions = malloc2( sizeofInt );
					
						SetSym
						( 
							(yyvsp[(1) - (9)].s), 
							GetBaseType( (yyvsp[(3) - (9)].s) ),
							tArray, 
							1,							/* Arity		*/
							dimensions,					/* Dimensions	*/
							(yyvsp[(8) - (9)].v.NumElements),			/* NumElements	*/
							NULL,						/* Value		*/
							0,							/* ObjectSize	*/
							0,							/* Offset		*/
							NULL,						/* Static Name	*/
							(yyvsp[(8) - (9)].v.Base),					/* Base Type	*/
							(yyvsp[(8) - (9)].v.Fields),				/* Field list	*/
							(yyvsp[(8) - (9)].v.FieldCnt),				/* Num Fields	*/
							(yyvsp[(8) - (9)].v.Fields),				/* Current Field*/
							0							/* CurfieldIndx */
						);
						
						/*
						** Allocate storage to hold the data:
						*/
						
						(yyvsp[(1) - (9)].s)->u.ArrayOfValues = 
							malloc2
							( 
								(yyvsp[(8) - (9)].v.NumElements) * sizeofSymNode
							);
							
						/*
						** Copy the data from the array constant expression
						** to the array object we've just created:
						*/
						

						_for( i=0, i < (yyvsp[(8) - (9)].v.NumElements), ++i )
						
							DeepCopy
							( 
								&(yyvsp[(1) - (9)].s)->u.ArrayOfValues[i], 
								&(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i]
							);
							
						_endfor
						
						/*
						** Set up the size information for this constant array:
						*/
						
						(yyvsp[(1) - (9)].s)->Dimensions[0] = (yyvsp[(8) - (9)].v.NumElements);
						(yyvsp[(1) - (9)].s)->ObjectSize = 
							(yyvsp[(3) - (9)].s)->ObjectSize * (yyvsp[(8) - (9)].v.NumElements);
							
						
						
					_else
					
						yyerror( "Type mismatch in operands" );
					
					_endif


				_else
				
					/*
					** Okay, the base type of the constant object is
					** an array type.  This means that the number
					** of elements in the constant expression must
					** be an even multiple of the number of elements
					** in the base type.
					*/
					
					_if
					(
							(yyvsp[(3) - (9)].s)->NumElements >= (yyvsp[(8) - (9)].v.NumElements)
						||	( (yyvsp[(8) - (9)].v.NumElements) % (yyvsp[(3) - (9)].s)->NumElements ) != 0
					)
					
						yyerror
						( 
							"Array constant has bad number of elements"
						);
						
					_else

						IsValid = 1;
						i = 0;
						_do
						
							/*
							** Verify that each element of the array expression
							** is compatible with our destination type:
							*/
							
							IsValid = 
									IsValid 
								&&	IsCompatible
									(
										GetBaseType( (yyvsp[(3) - (9)].s) ),
										YYS &(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i] 
									);
									
							++i;
							
						_until( i >= (yyvsp[(8) - (9)].v.NumElements) || !IsValid )
						
						_if( IsValid )
						
							SetSym
							( 
								(yyvsp[(1) - (9)].s), 
								GetBaseType( (yyvsp[(3) - (9)].s) ),
								tArray, 
								(yyvsp[(3) - (9)].s)->Arity + 1,			
								malloc2( sizeofInt  * ((yyvsp[(3) - (9)].s)->Arity + 1)),	
								(yyvsp[(8) - (9)].v.NumElements),			
								NULL,						
								0,							
								0,							
								NULL,						
								(yyvsp[(8) - (9)].v.Base),					
								(yyvsp[(8) - (9)].v.Fields),				
								(yyvsp[(8) - (9)].v.FieldCnt),				
								(yyvsp[(8) - (9)].v.Fields),  
								0
							);
							
							/*
							** Allocate storage to hold the data:
							*/
							
							(yyvsp[(1) - (9)].s)->u.ArrayOfValues = 
								malloc2
								( 
									(yyvsp[(8) - (9)].v.NumElements) * sizeofSymNode
								);
								
							/*
							** Copy the data from the array constant expression
							** to the array object we've just created:
							*/
							
							_for( i=0, i < (yyvsp[(8) - (9)].v.NumElements), ++i )
							
								DeepCopy
								( 
									&(yyvsp[(1) - (9)].s)->u.ArrayOfValues[i], 
									&(yyvsp[(8) - (9)].v.u.ArrayOfValues)[i]
								);
								
							_endfor
							
							/*
							** Set up the size information for this 
							** constant array:
							*/
												
							_for( i = 0, i < (yyvsp[(1) - (9)].s)->Arity - 1, ++i )
							
								(yyvsp[(1) - (9)].s)->Dimensions[i] = 
									(yyvsp[(3) - (9)].s)->Dimensions[i];
									
							_endfor
							(yyvsp[(1) - (9)].s)->Dimensions[ (yyvsp[(1) - (9)].s)->Arity - 1 ] =
								(yyvsp[(8) - (9)].v.NumElements) / (yyvsp[(3) - (9)].s)->NumElements;
								
							(yyvsp[(1) - (9)].s)->ObjectSize = 
								(yyvsp[(3) - (9)].s)->Type->ObjectSize * (yyvsp[(8) - (9)].v.NumElements);
								
							
							
						_else
						
							yyerror( "Type mismatch in operands" );
						
						_endif

					
					_endif


				_endif

			_endif
			FreeValue( YYS &(yyvsp[(8) - (9)].v) );

			/*
			** "Prime" fastLookup for the next identifier we encounter:
			*/
			
			fastLookup = 1;
			_here;		
		;}
    break;

  case 1120:

/* Line 1464 of yacc.c  */
#line 51354 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (7)].idStr) != NULL );
				assert( (yyvsp[(3) - (7)].s) != NULL );

				/*
				** Initialize some common synthesized attributes.
				*/

				(yyval.v.pType) 	= tArray;
				(yyval.v.Arity) 	= (yyvsp[(3) - (7)].s)->Arity + (yyvsp[(5) - (7)].v.Arity);
				(yyval.v.Type)  	= GetBaseType( (yyvsp[(3) - (7)].s) );
				(yyval.v.Base)		= (yyvsp[(3) - (7)].s)->Base;
				(yyval.v.Fields)	= (yyvsp[(3) - (7)].s)->Fields;
				(yyval.v.FieldCnt)	= (yyvsp[(3) - (7)].s)->FieldCnt;


				/*
				** Text arrays are illegal.
				*/

				_if( (yyvsp[(3) - (7)].s)->pType == tText )

					yyerror( "Cannot have TEXT arrays" );
					(yyvsp[(3) - (7)].s) = &string_ste;


				/*
				** Make sure this is a legal constant type.
				*/

				_elseif( !CanBeVal( (yyvsp[(3) - (7)].s)->pType ))

					yyerror( "Values can only have primitive types" );
					(yyvsp[(3) - (7)].s) = &string_ste;

				_else

					/*
					** If TypeID is a scalar type, just use the
					** DimList attributes.
					*/

					_if( (yyvsp[(3) - (7)].s)->pType != tArray )
					
						(yyval.v.NumElements) = (yyvsp[(5) - (7)].v.NumElements);
						(yyval.v.Dimensions) = (yyvsp[(5) - (7)].v.Dimensions);

					/*
					** If TypeID is an array type, we need to
					** combine TypeID with DimList to produce
					** a larger array.
					*/

					_else


						(yyval.v.NumElements) = 
								(yyvsp[(3) - (7)].s)->NumElements * (yyvsp[(5) - (7)].v.NumElements);

						(yyval.v.Dimensions) =
							malloc2( (yyval.v.Arity) * sizeofInt );
	 
						assert( (yyvsp[(3) - (7)].s)->Dimensions != NULL );
						memcpy
						( 
							(yyval.v.Dimensions), 
							(yyvsp[(3) - (7)].s)->Dimensions,
							(yyvsp[(3) - (7)].s)->Arity * sizeofInt 
						);

						assert( (yyvsp[(5) - (7)].v.Dimensions) != NULL );
						memcpy
						(
							(yyval.v.Dimensions) +	(yyvsp[(3) - (7)].s)->Arity,
							(yyvsp[(5) - (7)].v.Dimensions),
							(yyvsp[(5) - (7)].v.Arity) * sizeofInt 
						);
						free2( vss (yyvsp[(5) - (7)].v.Dimensions) );

					_endif

					ClrNewSym
					( 
						(yyvsp[(1) - (7)].idStr), 
						(yyval.v.Type),
						tArray, 
						cValue, 
						(yyval.v.Arity),
						(yyval.v.Dimensions),
						(yyval.v.NumElements),
						(yyvsp[(3) - (7)].s)->ObjectSize * (yyvsp[(5) - (7)].v.NumElements),
						0,
						NULL,
						(yyval.v.Base),
						(yyval.v.Fields),
						(yyval.v.FieldCnt),
						(yyval.v.CurField),
						(yyval.v.CurIndex)
					);

				_endif
				_here;
			;}
    break;

  case 1121:

/* Line 1464 of yacc.c  */
#line 51476 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (7)].s) != NULL );
				assert( (yyvsp[(3) - (7)].s) != NULL );

				/*
				** Initialize some common synthesized attributes.
				*/

				(yyval.v.pType) 	= tArray;
				(yyval.v.Arity) 	= (yyvsp[(3) - (7)].s)->Arity + (yyvsp[(5) - (7)].v.Arity);
				(yyval.v.Type)  	= GetBaseType( (yyvsp[(3) - (7)].s) );
				(yyval.v.Base)		= (yyvsp[(3) - (7)].s)->Base;
				(yyval.v.Fields)	= (yyvsp[(3) - (7)].s)->Fields;
				(yyval.v.FieldCnt)	= (yyvsp[(3) - (7)].s)->FieldCnt;


				/*
				** Text arrays are illegal.
				*/

				_if( (yyvsp[(3) - (7)].s)->pType == tText )

					yyerror( "Cannot have TEXT arrays" );
					(yyvsp[(3) - (7)].s) = &string_ste;


				/*
				** Make sure this is a legal constant type.
				*/

				_elseif( !CanBeVal( (yyvsp[(3) - (7)].s)->pType ))

					yyerror( "Values can only have primitive types" );
					(yyvsp[(3) - (7)].s) = &string_ste;

				_else

					/*
					** If TypeID is a scalar type, just use the
					** DimList attributes.
					*/

					_if( (yyvsp[(3) - (7)].s)->pType != tArray )
					
						(yyval.v.NumElements) = (yyvsp[(5) - (7)].v.NumElements);
						(yyval.v.Dimensions) = (yyvsp[(5) - (7)].v.Dimensions);

					/*
					** If TypeID is an array type, we need to
					** combine TypeID with DimList to produce
					** a larger array.
					*/

					_else


						(yyval.v.NumElements) = 
								(yyvsp[(3) - (7)].s)->NumElements * (yyvsp[(5) - (7)].v.NumElements);

						(yyval.v.Dimensions) =
							malloc2( (yyval.v.Arity) * sizeofInt );
	 
						assert( (yyvsp[(3) - (7)].s)->Dimensions != NULL );
						memcpy
						( 
							(yyval.v.Dimensions), 
							(yyvsp[(3) - (7)].s)->Dimensions,
							(yyvsp[(3) - (7)].s)->Arity * sizeofInt 
						);

						assert( (yyvsp[(5) - (7)].v.Dimensions) != NULL );
						memcpy
						(
							(yyval.v.Dimensions) +	(yyvsp[(3) - (7)].s)->Arity,
							(yyvsp[(5) - (7)].v.Dimensions),
							(yyvsp[(5) - (7)].v.Arity) * sizeofInt 
						);
						free2( vss (yyvsp[(5) - (7)].v.Dimensions) );

					_endif

					ClrSym
					( 
						(yyvsp[(1) - (7)].s), 
						(yyval.v.Type),
						tArray, 
						(yyval.v.Arity),
						(yyval.v.Dimensions),
						(yyval.v.NumElements),
						(yyvsp[(3) - (7)].s)->ObjectSize * (yyvsp[(5) - (7)].v.NumElements),
						0,
						NULL,
						(yyval.v.Base),
						(yyval.v.Fields),
						(yyval.v.FieldCnt),
						(yyval.v.CurField),
						(yyval.v.CurIndex)
					);

				_endif
				_here;
			;}
    break;

  case 1122:

/* Line 1464 of yacc.c  */
#line 51591 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (4)].v.u.PtrToValue) != NULL )

				_if( (yyvsp[(1) - (4)].v.pType) == tArray )

					_if
					( 
						ArraysAreCompatible
						( 
							YYS &(yyvsp[(1) - (4)].v), 
							YYS &(yyvsp[(3) - (4)].v) 
						)
					)


						_for( int i=0, i < (yyvsp[(1) - (4)].v.NumElements), ++i )
						
							DeepCopy
							(
									&(yyvsp[(1) - (4)].v.u.PtrToValue)[i],
									&(yyvsp[(3) - (4)].v.u.ArrayOfValues)[i]
							);

						_endfor

					_elseif( (yyvsp[(1) - (4)].v.NumElements) == (yyvsp[(3) - (4)].v.NumElements) )

							yyerror( "Type mismatch in operands" );

					_else

						yyerror
						( 
							"The number of array elements do not match"
						);

					_endif
					FreeValue( YYS &(yyvsp[(3) - (4)].v) );


				_elseif( (yyvsp[(1) - (4)].v.pType) == tRecord )

					_if
					( 
						RecordsAreCompatible
						( 
							&(yyvsp[(1) - (4)].v), 
							YYS &(yyvsp[(3) - (4)].v) 
						)
					)
			
						_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

							DeepCopy
							(
									&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i],
									&(yyvsp[(3) - (4)].v.u.FieldValues)[i]
							);

						_endfor

					_else

						yyerror
						( 
							"The records/unions are incompatible"
						);

					_endif
					FreeValue( YYS &(yyvsp[(3) - (4)].v) );



				_elseif
				( 
						(yyvsp[(1) - (4)].v.pType) == tUnion
					&&	(yyvsp[(3) - (4)].v.pType) == tUnion
					&&	GetBaseType( (yyvsp[(1) - (4)].v.Type) ) == 
							GetBaseType( (yyvsp[(3) - (4)].v.Type) ) 
				)

					_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

						// Note: A deep copy was already done on
						// the constant, no need to repeat that here.
											
						FreeValue( YYS &(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i] );
						(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i] =
							(yyvsp[(3) - (4)].v.u.FieldValues)[i];

					_endfor
					(yyvsp[(1) - (4)].v.u.PtrToValue)->CurField = (yyvsp[(3) - (4)].v.CurField);
					(yyvsp[(1) - (4)].v.u.PtrToValue)->CurIndex = (yyvsp[(3) - (4)].v.CurIndex);





				_elseif
				( 
						(yyvsp[(1) - (4)].v.pType) == tReal128
					&&	(yyvsp[(3) - (4)].v.pType) == tReal128
					&&	GetBaseType( (yyvsp[(1) - (4)].v.Type) ) == 
							GetBaseType( (yyvsp[(3) - (4)].v.Type) ) 
				)

					_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

						// Note: A deep copy was already done on
						// the constant, no need to repeat that here.
											
						FreeValue( YYS &(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i] );
						(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i] =
							(yyvsp[(3) - (4)].v.u.FieldValues)[i];

					_endfor
					(yyvsp[(1) - (4)].v.u.PtrToValue)->CurField = (yyvsp[(3) - (4)].v.CurField);
					(yyvsp[(1) - (4)].v.u.PtrToValue)->CurIndex = (yyvsp[(3) - (4)].v.CurIndex);


				_else /* Must be a scalar value */

					memcpy
					( 
						&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.StartOfValues, 
						&(yyvsp[(3) - (4)].v.u.StartOfValues), 
						sizeofValuesSize
					);

				_endif

			_endif
			_here;
		;}
    break;

  case 1123:

/* Line 1464 of yacc.c  */
#line 51742 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (4)].v.u.PtrToValue) != NULL )

				_if( (yyvsp[(1) - (4)].v.pType) == tArray )

					_if
					( 
						ArraysAreCompatible
						( 
							YYS &(yyvsp[(1) - (4)].v), 
							YYS &(yyvsp[(3) - (4)].v) 
						)
					)


						_for( int i=0, i < (yyvsp[(1) - (4)].v.NumElements), ++i )

							DeepCopy
							(
								&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.ArrayOfValues[i],
								&(yyvsp[(3) - (4)].v.u.ArrayOfValues)[i]
							);

						_endfor

					_elseif( (yyvsp[(1) - (4)].v.NumElements) == (yyvsp[(3) - (4)].v.NumElements) )

						yyerror( "Type mismatch in operands" );

					_else

						yyerror
						( 
							"The number of array elements do not match"
						);

					_endif
					FreeValue( YYS &(yyvsp[(3) - (4)].v) );


				_elseif( (yyvsp[(1) - (4)].v.pType) == tRecord )



					_if
					( 
						RecordsAreCompatible
						( 
							&(yyvsp[(1) - (4)].v), YYS &(yyvsp[(3) - (4)].v) 
						)
					)
			
						_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

							DeepCopy
							(
									&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i],
									&(yyvsp[(3) - (4)].v.u.FieldValues)[i]
							);

						_endfor

					_else

						yyerror
						( 
							"The fields are incompatible"
						);

					_endif
					FreeValue( YYS &(yyvsp[(3) - (4)].v) );


				_elseif
				( 
						(yyvsp[(1) - (4)].v.pType) == tUnion
					&&	(yyvsp[(3) - (4)].v.pType) == tUnion
					&&	GetBaseType( (yyvsp[(1) - (4)].v.Type) ) == 
							GetBaseType( (yyvsp[(3) - (4)].v.Type) ) 
				)

					_if( (yyvsp[(1) - (4)].v.Type) == (yyvsp[(3) - (4)].v.Type) )
					
			
						_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

							DeepCopy
							(
									&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i],
									&(yyvsp[(3) - (4)].v.u.FieldValues)[i]
							);

						_endfor

						
					_else
					
						yyerror
						( 
							"The union field and constant are incompatible"
						);
						
						// Need to set up a dummy value to prevent problems:
						
						memcpy
						( 
							(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues,
							&dummy_ste,
							sizeofSymNode
						);
						(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues->StaticName = 
							(yyvsp[(1) - (4)].v.u.PtrToValue)->StaticName;
							
						(yyvsp[(1) - (4)].v.u.PtrToValue)->StaticName = NULL;
						(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues->Offset = (yyvsp[(1) - (4)].v.Offset);
							
					_endif





				_elseif
				( 
						(yyvsp[(1) - (4)].v.pType) == tReal128
					&&	(yyvsp[(3) - (4)].v.pType) == tReal128
					&&	GetBaseType( (yyvsp[(1) - (4)].v.Type) ) == 
							GetBaseType( (yyvsp[(3) - (4)].v.Type) ) 
				)

					_if( (yyvsp[(1) - (4)].v.Type) == (yyvsp[(3) - (4)].v.Type) )
					
			
						_for( int i=0, i < (yyvsp[(3) - (4)].v.FieldCnt), ++i )

							DeepCopy
							(
									&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues[i],
									&(yyvsp[(3) - (4)].v.u.FieldValues)[i]
							);

						_endfor

						
					_else
					
						yyerror
						( 
							"The real128 field and constant are incompatible"
						);
						
						// Need to set up a dummy value to prevent problems:
						
						memcpy
						( 
							(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues,
							&dummy_ste,
							sizeofSymNode
						);
						(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues->StaticName = 
							(yyvsp[(1) - (4)].v.u.PtrToValue)->StaticName;
							
						(yyvsp[(1) - (4)].v.u.PtrToValue)->StaticName = NULL;
						(yyvsp[(1) - (4)].v.u.PtrToValue)->u.FieldValues->Offset = (yyvsp[(1) - (4)].v.Offset);
							
					_endif



				_else /* Must be a scalar value */

					memcpy
					( 
						&(yyvsp[(1) - (4)].v.u.PtrToValue)->u.StartOfValues, 
						&(yyvsp[(3) - (4)].v.u.StartOfValues), 
						sizeofValuesSize
					);

				_endif

			_endif
			_here;
		;}
    break;

  case 1124:

/* Line 1464 of yacc.c  */
#line 51928 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1125:

/* Line 1464 of yacc.c  */
#line 51986 "hlaparse.bsn"
    {
				_here;
				inVar = (yyvsp[(1) - (3)].i);
			;}
    break;

  case 1126:

/* Line 1464 of yacc.c  */
#line 51994 "hlaparse.bsn"
    {
			/*
			**	Note: "Variables" productions get used by
			**	records and unions, even when we're not
			**	declaring variables.  Deal with that here.
			**	Also note that Variables is also used by
			**	classes, but we treat those as var dcls.
			*/

			_here;
			(yyval.i) = inVar;
			inVar = !(( inRecord || inUnion ) && !inVar );
		;}
    break;

  case 1127:

/* Line 1464 of yacc.c  */
#line 52014 "hlaparse.bsn"
    {
			_here;
			MinVarAlignment = 1;
			MaxVarAlignment = 1;
			TempVarAlign = 0;
			HoldOffset = 0;
		;}
    break;

  case 1128:

/* Line 1464 of yacc.c  */
#line 52026 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					IsNumber( (yyvsp[(2) - (3)].v.pType) )
				&&	checkSmallInt( YYS &(yyvsp[(2) - (3)].v) ) 
			)

				CurOffset = (yyvsp[(2) - (3)].v.u.intval); 
				HoldOffset = 1;

			_else

				yyerror( "Expected a constant in the range 1..64" );
				HoldOffset = 0;

			_endif
			MinVarAlignment = 1;	// Min alignment
			MaxVarAlignment = 1;	// Max alignment
			TempVarAlign = 0;
			FreeValue( YYS &(yyvsp[(2) - (3)].v) );
			_here;
		;}
    break;

  case 1129:

/* Line 1464 of yacc.c  */
#line 52054 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					IsNumber( (yyvsp[(2) - (3)].v.pType) )
				&&	checkSmallUns( YYS &(yyvsp[(2) - (3)].v) ) 
				&&	(yyvsp[(2) - (3)].v.u.unsval) >= 1
				&&	(yyvsp[(2) - (3)].v.u.unsval) <= 64
			)

				MinVarAlignment = (yyvsp[(2) - (3)].v.u.unsval); // Min alignment
				MaxVarAlignment = (yyvsp[(2) - (3)].v.u.unsval); // Max alignment

			_else

				yyerror( "Expected a constant in the range 1..64" );
				MinVarAlignment = 1;
				MaxVarAlignment = 1;

			_endif
			TempVarAlign = 0;
			HoldOffset = 0;
			FreeValue( YYS &(yyvsp[(2) - (3)].v) );
			_here;
		;}
    break;

  case 1130:

/* Line 1464 of yacc.c  */
#line 52087 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					IsNumber( (yyvsp[(2) - (6)].v.pType) )
				&&	checkSmallUns( YYS &(yyvsp[(2) - (6)].v) ) 
				&&	(yyvsp[(2) - (6)].v.u.unsval) >= 1
				&&	(yyvsp[(2) - (6)].v.u.unsval) <= 64
			)

				MinVarAlignment = (yyvsp[(2) - (6)].v.u.unsval); // Min alignment
				MaxVarAlignment = (yyvsp[(2) - (6)].v.u.unsval); // Max alignment

			_else

				yyerror( "Expected an alignment constant in the range 1..64" );
				MinVarAlignment = 1;
				MaxVarAlignment = 1;

			_endif
			HoldOffset = 0;
			_if
			( 
					IsNumber( (yyvsp[(5) - (6)].v.pType) )
				&&	checkSmallInt( YYS &(yyvsp[(5) - (6)].v) ) 
			)

				CurOffset = (yyvsp[(5) - (6)].v.u.intval); 
				HoldOffset = 1;

			_else

				yyerror( "Expected an integer constant as starting offset" );

			_endif
			TempVarAlign = 0;
			FreeValue( YYS &(yyvsp[(2) - (6)].v) );
			FreeValue( YYS &(yyvsp[(5) - (6)].v) );
			_here;
		;}
    break;

  case 1131:

/* Line 1464 of yacc.c  */
#line 52133 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					IsNumber( (yyvsp[(2) - (5)].v.pType) )
				&&	IsNumber( (yyvsp[(4) - (5)].v.pType) ) 
				&&	checkSmallUns( YYS &(yyvsp[(2) - (5)].v) ) 
				&&	checkSmallUns( YYS &(yyvsp[(4) - (5)].v) ) 
				&&	(yyvsp[(2) - (5)].v.u.unsval) >= 1
				&&	(yyvsp[(2) - (5)].v.u.unsval) <= 64
				&&	(yyvsp[(4) - (5)].v.u.unsval) >= 1
				&&	(yyvsp[(4) - (5)].v.u.unsval) <= 64
			)
				_if( (yyvsp[(2) - (5)].v.u.unsval) >= (yyvsp[(4) - (5)].v.u.unsval) )
				
					MaxVarAlignment = (yyvsp[(2) - (5)].v.u.unsval); // Max alignment
					MinVarAlignment = (yyvsp[(4) - (5)].v.u.unsval); // Min alignment
					
				_else
				
					yyerror
					(
						"In VAR alignment, the first (max) value must be "
						"greater or equal to the second (min) value"
					);
					
					// Note that the following swaps the minimum and
					// maximum values:
					
					MinVarAlignment = (yyvsp[(2) - (5)].v.u.unsval); // Max alignment
					MaxVarAlignment = (yyvsp[(4) - (5)].v.u.unsval); // Min alignment

				_endif

			_else

				yyerror( "Expected a constant in the range 1..64" );
				MinVarAlignment = 1;
				MaxVarAlignment = 1;

			_endif
			TempVarAlign = 0;
			HoldOffset = 0;
			FreeValue( YYS &(yyvsp[(2) - (5)].v) );
			FreeValue( YYS &(yyvsp[(4) - (5)].v) );
			_here;
		;}
    break;

  case 1132:

/* Line 1464 of yacc.c  */
#line 52189 "hlaparse.bsn"
    {
			int align;

			_here;
			_if
			( 
					IsNumber( (yyvsp[(2) - (8)].v.pType) )
				&&	IsNumber( (yyvsp[(4) - (8)].v.pType) ) 
				&&	checkSmallUns( YYS &(yyvsp[(2) - (8)].v) ) 
				&&	checkSmallUns( YYS &(yyvsp[(4) - (8)].v) ) 
				&&	(yyvsp[(2) - (8)].v.u.unsval) >= 1
				&&	(yyvsp[(2) - (8)].v.u.unsval) <= 64
				&&	(yyvsp[(4) - (8)].v.u.unsval) >= 1
				&&	(yyvsp[(4) - (8)].v.u.unsval) <= 64
			)
				_if( (yyvsp[(2) - (8)].v.u.unsval) >= (yyvsp[(4) - (8)].v.u.unsval) )
				
					MaxVarAlignment = (yyvsp[(2) - (8)].v.u.unsval); // Max alignment
					MinVarAlignment = (yyvsp[(4) - (8)].v.u.unsval); // Min alignment
					
				_else
				
					yyerror
					(
						"In VAR alignment, the first (max) value must be "
						"greater or equal to the second (min) value"
					);
					
					// Note that the following swaps the minimum and
					// maximum values:
					
					MinVarAlignment = (yyvsp[(2) - (8)].v.u.unsval); // Max alignment
					MaxVarAlignment = (yyvsp[(4) - (8)].v.u.unsval); // Min alignment

				_endif

			_else

				yyerror( "Expected a constant in the range 1..64 for align" );
				MinVarAlignment = 1;
				MaxVarAlignment = 1;

			_endif
			HoldOffset = 0;
			_if
			( 
					IsNumber( (yyvsp[(7) - (8)].v.pType) )
				&&	checkSmallInt( YYS &(yyvsp[(7) - (8)].v) ) 
			)

				CurOffset = (yyvsp[(7) - (8)].v.u.intval); 
				HoldOffset = 1;

			_else

				yyerror( "Expected an integer constant as starting offset" );

			_endif
			TempVarAlign = 0;
			FreeValue( YYS &(yyvsp[(2) - (8)].v) );
			FreeValue( YYS &(yyvsp[(4) - (8)].v) );
			FreeValue( YYS &(yyvsp[(7) - (8)].v) );
			_here;
		;}
    break;

  case 1133:

/* Line 1464 of yacc.c  */
#line 52260 "hlaparse.bsn"
    {
				_here;
			;}
    break;

  case 1134:

/* Line 1464 of yacc.c  */
#line 52264 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1135:

/* Line 1464 of yacc.c  */
#line 52283 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1137:

/* Line 1464 of yacc.c  */
#line 52302 "hlaparse.bsn"
    {			/* $6 */

			_here;
			_if( IsNumber( (yyvsp[(3) - (5)].v.pType) ) && numBits( YYS &(yyvsp[(3) - (5)].v) ) <= 32 )

				TempVarAlign = (yyvsp[(3) - (5)].v.u.unsval);

			_else

				yyerror
				( 
					"Expected an integer constant here" 
				);

			_endif
			FreeValue( YYS &(yyvsp[(3) - (5)].v) );
			_here;
		;}
    break;

  case 1138:

/* Line 1464 of yacc.c  */
#line 52353 "hlaparse.bsn"
    {				/* $6 */
			
				_here;
				assert( (yyvsp[(1) - (5)].idStr) != NULL );

				/*
				** If a local variable, bump the offset prior to
				** assigning it to the symbol.
				*/
				
				(yyval.v.u.intval) = CurOffset;
				_if( AddOffset1st && !HoldOffset )
				
					(yyvsp[(4) - (5)].v.u.intval) += 4 * CurOffsetDir;

				_endif

				(yyvsp[(4) - (5)].v.u.intval) = AlignVarOffset( (yyvsp[(4) - (5)].v.u.intval), 4, CurOffsetDir );
				InsertSym
				( 
					(yyvsp[(1) - (5)].idStr),
					NULL,			/* Type							*/
					tProcptr, 		/* pType						*/
					cVar, 			/* SymClass						*/
					0,				/* Arity						*/
					NULL,			/* Dimensions					*/
					0, 				/* NumElements					*/
					NULL,			/* Initially, no initialization	*/
					4,				/* Object size					*/
					(yyvsp[(4) - (5)].v.u.intval),	/* Offset						*/
					NULL,			/* Static Name					*/
					NULL,			/* Base							*/
					NULL,			/* Fields						*/
					0				/* FieldCnt						*/
				);
				(yyval.s) = SymbolTable;

				/*
				** If a parameter, bump up the offset after assigning
				** the offset to the symbol.
				*/
				
				_if( !AddOffset1st )
				
					(yyvsp[(4) - (5)].v.u.intval) += 4 * CurOffsetDir;

				_endif

				CurOffset = StartParmOffs;
				++CurLexLevel;
				
				/*
				** Reinsert the symbol into the local symbols
				** to keep the logic of this program happy.
				*/

				InsertSym
				( 
					(yyvsp[(1) - (5)].idStr),
					NULL,
					tProcptr, 
					cVar, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);

				/*
				** Temporary assignment so we can patch the local
				** entry later.
				*/

				(yyval.s)->u.proc.parms = SymbolTable;
				_here;
			;}
    break;

  case 1139:

/* Line 1464 of yacc.c  */
#line 52438 "hlaparse.bsn"
    {				/* $10 	*/

				SymNode_t 		*s;
				union	YYSTYPE	value;
				
				_here;
				CheckLegalOptions
				( 
					(yyvsp[(9) - (9)].options.SpecifiedOptions),
						specified_returns
					|	specified_use
					|	specified_pascal
					|	specified_stdcall
					|	specified_cdecl
					|	specified_alignment 
					|	specified_nostorage
					|	specified_volatile 
				);

				--CurLexLevel;
				_if( (yyvsp[(9) - (9)].options.NoStorage) )
				
					CurOffset = (yyvsp[(6) - (9)].v.u.intval);
					
				_else
				
					CurOffset = (yyvsp[(4) - (9)].v.u.intval);
					
				_endif
				CurOffsetDir = (yyvsp[(5) - (9)].v.u.unsval);
			 
				/*
				** Initialize the pointer to the end of the parameters
				** for this procedure variable.
				** Set up the offset and direction variables to handle
				** local variable declarations.  
				*/
			 

			
				// Need to create a dummy type to hold the procedure pointer parameters.
				
				s = SymbolTable;
				InsertSym
				( 
					" (procptr parms) ", 
					NULL,
					tProcptr, 
					cType, 
					0,
					NULL,
					0, 
					NULL,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
				SymbolTable->u.proc.parms = s;
				SymbolTable->u.proc.returns = hlastrdup2( "" );
				SymbolTable->u.proc.use = NULL;
				SymbolTable->u.proc.cs = (yyvsp[(9) - (9)].options.CallingSequence);
				(yyvsp[(6) - (9)].s)->Type = SymbolTable;
				(yyvsp[(6) - (9)].s)->u.proc.parms->Type = SymbolTable;
				
				// Remove the dummy entry from the symbol table:
			
				SymbolTable = s;
				
				// Patch the original symbol table entries:

				(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.parms = SymbolTable;
				(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
				(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.use = (yyvsp[(9) - (9)].options.use);

				(yyvsp[(6) - (9)].s)->u.proc.parms = SymbolTable;
				(yyvsp[(6) - (9)].s)->u.proc.returns = (yyvsp[(9) - (9)].options.returns);
				(yyvsp[(6) - (9)].s)->u.proc.use = (yyvsp[(9) - (9)].options.use);
				(yyvsp[(6) - (9)].s)->u.proc.cs = (yyvsp[(9) - (9)].options.CallingSequence);
				
			
				/*
				** Just to be on the safe side, let's create
				** a "parms" and "vars" entry for this object.
				*/
				
				ClrConst
				(
					YYS &value,
					tUns32,
					&uns32_ste
				);
				value.v.u.unsval = (yyvsp[(7) - (9)].v.u.unsval);
				InsertSym
				( 
					"_parms_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
				value.v.u.unsval = 0;
				InsertSym
				( 
					"_vars_", 
					&uns32_ste,
					tUns32, 
					cConstant, 
					0,
					NULL,
					0, 
					YYS &value,
					4,
					0,
					NULL,
					NULL,
					NULL,
					0
				);
				(yyvsp[(6) - (9)].s)->u.proc.parms->u.proc.Locals = SymbolTable;
				(yyvsp[(6) - (9)].s)->u.proc.Locals = SymbolTable;
							
				SymbolTable = (yyvsp[(6) - (9)].s);
				_here;
			;}
    break;

  case 1140:

/* Line 1464 of yacc.c  */
#line 52584 "hlaparse.bsn"
    {				/* $7 */
			
			
			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );

			(yyval.i) = CurOffset;
			_if( AddOffset1st && !HoldOffset )
			
				CurOffset += 4 * CurOffsetDir;

			_endif

			CurOffset = AlignVarOffset( CurOffset, 4, CurOffsetDir );
			CreatePtrToProc( (yyvsp[(1) - (6)].idStr), (yyvsp[(6) - (6)].s), NULL, cVar );
			_if( !AddOffset1st )
			
				CurOffset += 4 * CurOffsetDir;

			_endif
			_here;
		;}
    break;

  case 1141:

/* Line 1464 of yacc.c  */
#line 52608 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(9) - (9)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(9) - (9)].options.NoStorage) )
			
				CurOffset = (yyvsp[(7) - (9)].i);
				
			_endif
			_here;
		;}
    break;

  case 1142:

/* Line 1464 of yacc.c  */
#line 52642 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (3)].idStr) != NULL );
				 
				/*
				** For local variables, we need to add the object's
				** size the the current offset before saving the
				** offset in the symbol table.  The following code
				** handles that case.
				*/

				_if( AddOffset1st && !HoldOffset )
				
					CurOffset = 
							CurOffset 
						+ 	EnumSize * CurOffsetDir;

				_endif

				CurOffset = 
					AlignVarOffset( CurOffset, EnumSize, CurOffsetDir );

				InsertSym
				( 
					(yyvsp[(1) - (3)].idStr), 
					NULL,
					tEnum, 
					cVar, 
					0,
					NULL,
					0, 
					NULL,
					EnumSize,
					CurOffset,
					NULL,
					NULL,
					NULL,
					0
				);

				/*
				** For records, unions, parameters, and other such
				** stuff, we need to add the object's size to the
				** CurOffset variable *after* entering the symbol
				** into the symbol table.  This code segment
				** handles that case.
				*/

				_if( !AddOffset1st )
				
					CurOffset = 
							CurOffset 
						+ 	EnumSize * CurOffsetDir;

				_endif

				/*
				** Initialize EnumVal to zero so we can assign
				** successive values to the following named constants.
				*/

				EnumVal = 0;
				_here;
			;}
    break;

  case 1143:

/* Line 1464 of yacc.c  */
#line 52707 "hlaparse.bsn"
    {
				/*
				** Set up an inherited attribute for EnumList.
				** This must be the address of the variable symbol
				** table entry created above.
				*/

				(yyval.v.Type) = SymbolTable;
				_here;
			;}
    break;

  case 1144:

/* Line 1464 of yacc.c  */
#line 52720 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(6) - (9)].v.Type); // shut up bison
			;}
    break;

  case 1145:

/* Line 1464 of yacc.c  */
#line 52739 "hlaparse.bsn"
    {					/* $6 */

				SymNode_t		*BaseType;

				_here;
				assert( (yyvsp[(1) - (5)].idStr) != NULL );
				assert( (yyvsp[(5) - (5)].neID.idStr) != NULL );

				(yyval.i) = CurOffset;
				
				// If processing local vars...
				
				_if( AddOffset1st && !HoldOffset )
				
					CurOffset += 4 * CurOffsetDir;

				_endif

				CurOffset = AlignVarOffset( CurOffset, 4, CurOffsetDir );
				BaseType = (yyvsp[(5) - (5)].neID.s);
				_if( BaseType != NULL )

					BaseType = GetBaseType( BaseType );
					_if( CantBeVar( BaseType->pType ))

						yyerror( "Variables cannot be this type" );
						BaseType = &uns32_ste;

					_endif

				_endif

				InsertSym
				( 
					(yyvsp[(1) - (5)].idStr),			/* Name			*/
					&pointer_ste,		/* Type			*/
					tPointer, 			/* pType		*/
					cVar,				/* SymClass		*/
					0,					/* Arity		*/
					NULL,				/* Dimensions	*/
					0, 					/* NumElements	*/
					NULL,				/* Value		*/
					4,					/* ObjectSize	*/
					CurOffset,			/* Offset		*/
					NULL,				/* StaticName	*/
					BaseType,			/* BaseType		*/
					NULL,				/* Fields		*/
					0					/* FieldCnt		*/
				);
				_if( BaseType == NULL )

					Add2PtrList( SymbolTable, (yyvsp[(5) - (5)].neID.idStr) );

				_endif

				
				// If processing records, unions, parameters, etc.
				
				_if( !AddOffset1st )
				
					CurOffset += 4 * CurOffsetDir;

				_endif
				_here;
			;}
    break;

  case 1146:

/* Line 1464 of yacc.c  */
#line 52806 "hlaparse.bsn"
    {
				_here;
				CheckLegalOptions
				( 
					(yyvsp[(8) - (8)].options.SpecifiedOptions),
						specified_nostorage
					|	specified_volatile 
				);
				_if( (yyvsp[(8) - (8)].options.NoStorage) )
				
					CurOffset = (yyvsp[(6) - (8)].i);
					
				_endif
				_here;
			;}
    break;

  case 1147:

/* Line 1464 of yacc.c  */
#line 52832 "hlaparse.bsn"
    {					/* $6 */
				_here;
				assert( (yyvsp[(1) - (5)].idStr) != NULL );

				(yyval.i) = CurOffset;
				
				/*
				** If processing local vars...
				*/

				_if( AddOffset1st && !HoldOffset )
				
					CurOffset += 4 * CurOffsetDir;

				_endif
				CurOffset = AlignVarOffset( CurOffset, 4, CurOffsetDir );
				InsertSym
				( 
					(yyvsp[(1) - (5)].idStr),			/* Name			*/
					&pointer_ste,		/* Type			*/
					tPointer, 			/* pType		*/
					cVar,				/* SymClass		*/
					0,					/* Arity		*/
					NULL,				/* Dimensions	*/
					0, 					/* NumElements	*/
					NULL,				/* Value		*/
					4,					/* ObjectSize	*/
					CurOffset,			/* Offset		*/
					NULL,				/* StaticName	*/
					(yyvsp[(5) - (5)].s),				/* BaseType		*/
					NULL,				/* Fields		*/
					0					/* FieldCnt		*/
				);

				/*
				** If processing records, unions, parameters, etc.
				*/

				_if( !AddOffset1st )
				
					CurOffset += 4 * CurOffsetDir;

				_endif
				_here;
			;}
    break;

  case 1148:

/* Line 1464 of yacc.c  */
#line 52879 "hlaparse.bsn"
    {
				_here;
				CheckLegalOptions
				( 
					(yyvsp[(8) - (8)].options.SpecifiedOptions),
						specified_nostorage
					|	specified_volatile 
				);
				_if( (yyvsp[(8) - (8)].options.NoStorage) )
				
					CurOffset = (yyvsp[(6) - (8)].i);
					
				_endif
				_here;
			;}
    break;

  case 1149:

/* Line 1464 of yacc.c  */
#line 52905 "hlaparse.bsn"
    {					/* $4 */

				_here;
				assert( (yyvsp[(1) - (3)].idStr) != NULL );
				assert( (yyvsp[(3) - (3)].s) != NULL );
				
				(yyval.i) = CurOffset;

				_if( CantBeVar((yyvsp[(3) - (3)].s)->pType ))

					yyerror( "Variables cannot be this type" );

				_else
				
					/*
					** If processing local vars...
					*/

					_if( AddOffset1st && !HoldOffset )
					
						CurOffset += (yyvsp[(3) - (3)].s)->ObjectSize * CurOffsetDir;

					_endif
					CurOffset = 
						AlignVarOffset
						( 
							CurOffset, 
							(yyvsp[(3) - (3)].s)->ObjectSize, 
							CurOffsetDir 
						);
					
					InsertSym
					( 
						(yyvsp[(1) - (3)].idStr), 
						(yyvsp[(3) - (3)].s),
						(yyvsp[(3) - (3)].s)->pType, 
						cVar, 
						(yyvsp[(3) - (3)].s)->Arity,
						(yyvsp[(3) - (3)].s)->Dimensions,
						(yyvsp[(3) - (3)].s)->NumElements, 
						NULL,
						(yyvsp[(3) - (3)].s)->ObjectSize,
						CurOffset,
						NULL,
						(yyvsp[(3) - (3)].s)->Base,
						(yyvsp[(3) - (3)].s)->Fields,
						(yyvsp[(3) - (3)].s)->FieldCnt
					);
					_if( (yyvsp[(3) - (3)].s)->pType == tProcptr )
					
						// Copy parameter info if a proc ptr.
						
						memcpy
						( 
							&SymbolTable->u, 
							&(yyvsp[(3) - (3)].s)->u, 
							sizeofValuesSize
						);
						
					_endif

					/*
					** If this is a class object, we need to duplicate
					** all the fields to all private constants, etc.
					*/

					_if( (yyvsp[(3) - (3)].s)->pType == tClass )

						SymbolTable->Fields = 
							CopySymbols
							( 
								(yyvsp[(3) - (3)].s)->Fields,
								(yyvsp[(3) - (3)].s)->StaticName
							);
						NullTerminate( SymbolTable->Fields, SymbolTable );

					_elseif(  (yyvsp[(3) - (3)].s)->pType == tThunk )

						/*
						** Need some dummy local vars for a thunk.
						*/

						SymbolTable->u.proc.parms = &true_ste;


					_endif

					/*
					** If the type is a pointer type, we need to check
					** to see if there was a forward reference so we
					** can eventually patch the "Base" field.
					*/

					_if( (yyvsp[(3) - (3)].s)->pType == tPointer && (yyvsp[(3) - (3)].s)->Base == NULL )

						struct PatchListType *pbl;

						pbl = malloc2( sizeofPatchListType );
						
						pbl->Next = PatchBaseList;
						pbl->Symbol = SymbolTable;
						PatchBaseList = pbl;

						SymbolTable->Type = (yyvsp[(3) - (3)].s);	/* so we can patch later */

					_endif


					/*
					** If processing records, unions, parameters, etc.
					*/

					_if( !AddOffset1st )
					
						CurOffset += (yyvsp[(3) - (3)].s)->ObjectSize * CurOffsetDir;

					_endif

				_endif
				_here;

			;}
    break;

  case 1150:

/* Line 1464 of yacc.c  */
#line 53029 "hlaparse.bsn"
    {
				_here;
				CheckLegalOptions
				( 
					(yyvsp[(6) - (6)].options.SpecifiedOptions),
						specified_nostorage
					|	specified_volatile 
				);
				_if( (yyvsp[(6) - (6)].options.NoStorage) )
				
					CurOffset = (yyvsp[(4) - (6)].i);
					
				_endif
				_here;
			;}
    break;

  case 1151:

/* Line 1464 of yacc.c  */
#line 53060 "hlaparse.bsn"
    {					/* $7 */

			int	*DimensionArray;
			int	ArraySize;

			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );
			assert( (yyvsp[(5) - (6)].v.Dimensions) != NULL );

			(yyval.i) = CurOffset;
			
			_if( (yyvsp[(5) - (6)].v.NumElements) <= 0 )
			
				yyerror( "Array declaration must have at least one element" );
				(yyvsp[(5) - (6)].v.NumElements) = 1;
			
			_endif
			
			/*
			** Make sure this is a legal variable type
			** (e.g., no text variables).
			*/

			_if( CantBeVar( (yyvsp[(3) - (6)].s)->pType ))
			
				yyerror( "Illegal variable type" );
				
			_else 
			
				/*
				** Check to see if TypeID is an array type
				** (i.e., we're creating a multi-dimensional array).
				*/

				_if( (yyvsp[(3) - (6)].s)->pType != tArray )

					/*
					** TypeID is *not* an array type, so create
					** a single dimension array here.
					*/

					ArraySize = (yyvsp[(3) - (6)].s)->ObjectSize * (yyvsp[(5) - (6)].v.NumElements);

					/*
					** If local variable.
					*/

					_if( AddOffset1st && !HoldOffset )

						CurOffset += ArraySize * CurOffsetDir;

					_endif

					CurOffset = 
						AlignVarOffset
						( 
							CurOffset, 
							ArraySize, 
							CurOffsetDir 
						);
						
					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr), 
						(yyvsp[(3) - (6)].s),
						tArray, 
						cVar, 
						(yyvsp[(5) - (6)].v.Arity),
						(yyvsp[(5) - (6)].v.Dimensions),
						(yyvsp[(5) - (6)].v.NumElements), 
						NULL,
						ArraySize,
						CurOffset,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

					/*
					** If this is a class object, we need to duplicate
					** all the fields to all private constants, etc.
					*/

					_if( (yyvsp[(3) - (6)].s)->pType == tClass )

						SymbolTable->Fields = 
							CopySymbols
							( 
								(yyvsp[(3) - (6)].s)->Fields,
								(yyvsp[(3) - (6)].s)->StaticName
							);
						NullTerminate( SymbolTable->Fields, SymbolTable );

					_elseif(  (yyvsp[(3) - (6)].s)->pType == tThunk )

						/*
						** Need some dummy local vars for a thunk.
						*/

						SymbolTable->u.proc.parms = &true_ste;


					_endif

					/*
					** If the type is a pointer type, we need to check
					** to see if there was a forward reference so we
					** can eventually patch the "Base" field.
					*/

					_if( (yyvsp[(3) - (6)].s)->pType == tPointer && (yyvsp[(3) - (6)].s)->Base == NULL )

						struct PatchListType *pbl;

						pbl = malloc2( sizeofPatchListType );
						
						pbl->Next = PatchBaseList;
						pbl->Symbol = SymbolTable;
						PatchBaseList = pbl;

						/*
						** So we can patch later:
						*/

						SymbolTable->Type = (yyvsp[(3) - (6)].s);	

					_endif


					/*
					** If not a local variable
					*/

					_if( !AddOffset1st )

						CurOffset += ArraySize * CurOffsetDir;

					_endif


				/*
				** Okay, down here TypeID *is* an array type,
				** so we're creating a multi-dimensional array.
				*/

				_else

					assert( (yyvsp[(3) - (6)].s)->Dimensions != NULL );

					/*
					** Create the new dimension array by concatenating
					** the two existing dimension arrays.
					*/

					DimensionArray = 
						malloc2
						( 
							( (yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.NumElements) ) * 
								sizeofInt 
						);

					memcpy
					( 
						DimensionArray, 
						(yyvsp[(3) - (6)].s)->Dimensions, 
						(yyvsp[(3) - (6)].s)->Arity * sizeofInt 
					);
					memcpy
					(
						&DimensionArray[ (yyvsp[(3) - (6)].s)->Arity ],
						(yyvsp[(5) - (6)].v.Dimensions),
						(yyvsp[(5) - (6)].v.Arity) * sizeofInt 
					);
					ArraySize = (yyvsp[(3) - (6)].s)->ObjectSize * (yyvsp[(5) - (6)].v.NumElements);

					/*
					** Add the new array to the symbol table.
					*/

					_if( AddOffset1st && !HoldOffset ) /* If local variable */

						CurOffset += ArraySize * CurOffsetDir;

					_endif

					CurOffset = 
						AlignVarOffset
						( 
							CurOffset, 
							ArraySize,
							CurOffsetDir 
						);
						
					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr), 
						(yyvsp[(3) - (6)].s),
						tArray, 
						cVar, 
						(yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.Arity),
						DimensionArray,
						(yyvsp[(3) - (6)].s)->NumElements * (yyvsp[(5) - (6)].v.NumElements), 
						NULL,
						ArraySize,
						CurOffset,
						NULL,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

					/*
					** If this is a class object, we need to duplicate
					** all the fields to all private constants, etc.
					*/

					_if( (yyvsp[(3) - (6)].s)->pType == tClass )


						SymbolTable->Fields = 
							CopySymbols
							( 
								(yyvsp[(3) - (6)].s)->Fields,
								(yyvsp[(3) - (6)].s)->StaticName
							);
						NullTerminate( SymbolTable->Fields, SymbolTable );

					_elseif(  (yyvsp[(3) - (6)].s)->pType == tThunk )

						/*
						** Need some dummy local vars for a thunk.
						*/

						SymbolTable->u.proc.parms = &true_ste;

					_endif


					_if( !AddOffset1st )	/* If not a local variable */

						CurOffset += ArraySize * CurOffsetDir;

					_endif
					free2( vss (yyvsp[(5) - (6)].v.Dimensions) );

				_endif

			_endif
			_here;
		;}
    break;

  case 1152:

/* Line 1464 of yacc.c  */
#line 53314 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(9) - (9)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(9) - (9)].options.NoStorage) )
			
				CurOffset = (yyvsp[(7) - (9)].i);
				
			_endif
		;}
    break;

  case 1153:

/* Line 1464 of yacc.c  */
#line 53347 "hlaparse.bsn"
    {
				SymNode_t *Fields;
				SymNode_t *CurSym;
				int		  RecSize;
				int		  FieldCnt;
				int		  LargestField;

				_here;
				
				/*
				** Restore currentNS before we enter this record
				** type into the symbol table.
				*/
				
				currentNS = (yyvsp[(3) - (8)].ru.saveCurNS);
				RecNS = (yyvsp[(3) - (8)].ru.saveRecNS);
				RecGlobal = (yyvsp[(3) - (8)].ru.saveRecGlobal);


				/*
				** Make sure there was at least one field.
				*/

				_if( RecFieldCnt != 0 )


					
					/*
					** If there is no base record, we need to mark
					** the end of the fields symbol list.  If there is
					** a base record, then that base record definition will
					** mark the end of our list.  In either case, we
					** need to count the number of fields in the record.
					**
					** Also compute the size of the largest field
					** (for alignment purposes).
					*/
					
					FieldCnt = 0;
					LargestField = 0;
					CurSym = SymbolTable;
					_while
					( 
							CurSym->Next != NULL 
						&&	CurSym->Next != &dummyField_ste 
					)

						LargestField = 
							max( LargestField, CurSym->MaxObjectSize );
							
						++FieldCnt;
						CurSym = CurSym->Next;

					_endwhile
					LargestField = 
						max( LargestField, CurSym->MaxObjectSize );

					CurSym->Next = NULL;
					
					/*
					** Okay, create the record symbol table entry
					** and attach the fields symbol table to that entry.
					*/

					CurLexLevel = (yyvsp[(3) - (8)].ru.SaveLex);	
					Fields = SymbolTable;			
					SymbolTable = (yyvsp[(3) - (8)].ru.endFields);		
					RecSize = CurOffset - (yyvsp[(3) - (8)].ru.CurOffset);			
				
					/*
					** If there was an align at the end of the
					** record, then we need to extend the size
					** of the record so that it is aligned on
					** the specified boundary.
					*/

					_if( TempRecAlign != 1 )
					

						RecSize = 
								(
										(RecSize + TempRecAlign - 1) 
									/ 	TempRecAlign 
								) * TempRecAlign;
								
						TempRecAlign = 1;

					_endif
					
					


					CurOffset = (yyvsp[(3) - (8)].ru.SaveOffset);		
					CurOffsetDir = (yyvsp[(3) - (8)].ru.SaveDir);	
					AddOffset1st = (yyvsp[(3) - (8)].ru.SaveAdd1st);	

					/*
					** Okay, insert the record symbol into the symbol table
					*/

					_if( AddOffset1st && !HoldOffset )	/* If a local variable */

						CurOffset += RecSize * CurOffsetDir;

					_endif
					CurOffset = 
						AlignVarOffset
						( 
							CurOffset,
							RecSize, 
							CurOffsetDir 
						);

					InsertSym
					(
						(yyvsp[(1) - (8)].idStr),
						NULL,
						tRecord,
						cVar,
						0,
						NULL,
						0,
						NULL,
						RecSize,
						CurOffset,
						NULL,
						(yyvsp[(3) - (8)].ru.base),
						Fields,
						FieldCnt
					);
					SymbolTable->MaxObjectSize = LargestField;

					_if( !AddOffset1st )	/* If not a local variable */

						CurOffset += RecSize * CurOffsetDir;

					_endif
					
					// Now we need to go through all the fields and
					// patch the "Parent" field to point at this
					// symbol table entry.
					
					_for( int fieldCntr = 0, fieldCntr < FieldCnt, ++fieldCntr )
					
						Fields->Parent = SymbolTable;
						Fields = Fields->Next;
						
					_endfor
					

				_else

					yyerror
					( 
						"Record variables must have at least one field" 
					);

				_endif
				inRecord = (yyvsp[(3) - (8)].ru.inSave);
				MinRecAlignment = (yyvsp[(3) - (8)].ru.MinRecAlignment);
				MaxRecAlignment = (yyvsp[(3) - (8)].ru.MaxRecAlignment);
				RecFieldCnt = (yyvsp[(3) - (8)].ru.RecFieldCnt);
				_here;
			;}
    break;

  case 1154:

/* Line 1464 of yacc.c  */
#line 53528 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (7)].idStr) != NULL );

				(yyval.s) = SymbolTable;
				CurOffset = 0;
				CurOffsetDir = 0;	/* Forces all fields to the same offset */
				AddOffset1st = 0;

			;}
    break;

  case 1155:

/* Line 1464 of yacc.c  */
#line 53541 "hlaparse.bsn"
    {
				int				SizeOfUnion;
				int				FieldCnt;
				SymNode_t		*Fields;
				SymNode_t		*CurSym;
				SymNode_t		*LastSym;

				/*
				** Determine if there were any fields in the union.
				** Error if not.
				*/

				_here;
				_if( SymbolTable == (yyvsp[(8) - (11)].s) )

					ErrorNear
					( 
						"Unions must have at least one field",
						"endunion",
						__LINE__,
						__FILE__ 
					);

				_else

					/*
					** Null terminate the list of fields in the union.
					** Search for the saved symbol table entry which
					** marks the first entry that is not a field.  Upon
					** finding that entry, store a NULL in the previous
					** link field.
					*/

					CurSym = SymbolTable;
					SizeOfUnion = 0;
					FieldCnt = 0;
					_while( CurSym != (yyvsp[(8) - (11)].s) )

						SizeOfUnion = 
							max( SizeOfUnion, CurSym->ObjectSize);
						
						LastSym =  CurSym;
						CurSym = CurSym->Next;
						++FieldCnt;

					_endwhile
					LastSym->Next = NULL;


					/*
					** Restore all the compiler variables and set
					** up Fields so we can enter the union variable
					** into the symbol table.
					*/

					CurLexLevel = (yyvsp[(6) - (11)].v.u.intval);
					Fields = SymbolTable;
					SymbolTable = (yyvsp[(8) - (11)].s);
					CurOffset = (yyvsp[(3) - (11)].v.u.intval);
					CurOffsetDir = (yyvsp[(4) - (11)].v.u.intval);
					AddOffset1st = (yyvsp[(5) - (11)].v.u.unsval);

					/*
					** Okay, create the union symbol table entry
					** and attach the fields symbol table to that entry.
					*/

					_if( AddOffset1st && !HoldOffset )	/* If a local variable */

						CurOffset += SizeOfUnion * CurOffsetDir;

					_endif
					CurOffset = 
						AlignVarOffset
						( 
							CurOffset,
							SizeOfUnion, 
							CurOffsetDir 
						);
						
					InsertSym
					(
						(yyvsp[(1) - (11)].idStr),
						NULL,
						tUnion,
						cVar,
						0,
						NULL,
						0,
						NULL,
						SizeOfUnion,
						CurOffset,
						NULL,
						NULL,
						Fields,
						FieldCnt
					);
					_if( !AddOffset1st )	/* If not a local variable */

						CurOffset += SizeOfUnion * CurOffsetDir;

					_endif
					
					// Now we need to go through all the fields and
					// patch the "Parent" field to point at this
					// symbol table entry.
					
					_for( int fieldCntr = 0, fieldCntr < FieldCnt, ++fieldCntr )
					
						Fields->Parent = SymbolTable;
						Fields = Fields->Next;
						
					_endfor

				_endif
				_here;
			;}
    break;

  case 1157:

/* Line 1464 of yacc.c  */
#line 53678 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Duplicate symbol definition", 
					(yyvsp[(1) - (6)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);

			;}
    break;

  case 1158:

/* Line 1464 of yacc.c  */
#line 53697 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Duplicate symbol definition", 
					(yyvsp[(1) - (8)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);
				inRecord = (yyvsp[(3) - (8)].ru.inSave);
				MinRecAlignment = (yyvsp[(3) - (8)].ru.MinRecAlignment);
				MaxRecAlignment = (yyvsp[(3) - (8)].ru.MaxRecAlignment);
				currentNS = (yyvsp[(3) - (8)].ru.saveCurNS);
				RecNS = (yyvsp[(3) - (8)].ru.saveRecNS);
				RecGlobal = (yyvsp[(3) - (8)].ru.saveRecGlobal);

			;}
    break;

  case 1159:

/* Line 1464 of yacc.c  */
#line 53715 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Duplicate symbol definition", 
					(yyvsp[(1) - (4)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);
			;}
    break;

  case 1160:

/* Line 1464 of yacc.c  */
#line 53726 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Duplicate symbol definition", 
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,

					__FILE__ 
				);

			;}
    break;

  case 1161:

/* Line 1464 of yacc.c  */
#line 53740 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Undefined symbol", 
					(yyvsp[(3) - (7)].idStr),
					__LINE__,
					__FILE__ 
				);

			;}
    break;

  case 1162:

/* Line 1464 of yacc.c  */
#line 53752 "hlaparse.bsn"
    {
				ErrorNear
				( 
					"Undefined symbol", 
					(yyvsp[(3) - (4)].idStr),
					__LINE__,
					__FILE__ 
				);

			;}
    break;

  case 1164:

/* Line 1464 of yacc.c  */
#line 53799 "hlaparse.bsn"
    {				/* $7 */

			union YYSTYPE v;

			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );
			assert( (yyvsp[(5) - (6)].idStr) != NULL );

			v.v.u.strval = (yyvsp[(1) - (6)].idStr);
			InsertSym
			( 
				(yyvsp[(5) - (6)].idStr), 
				&text_ste,
				tText, 
				cConstant, 
				0,				/* arity 			*/
				NULL,			/* NumDimensions	*/
				0, 				/* NumElements		*/
				YYS &v,
				4,				/* ObjectSize		*/
				0,
				NULL,
				NULL,			/* Base				*/
				NULL,			/* Fields			*/
				0				/* FieldCnt			*/ 
			);

			_here;
		;}
    break;

  case 1165:

/* Line 1464 of yacc.c  */
#line 53830 "hlaparse.bsn"
    {				/* $9 */
			_here;
		;}
    break;

  case 1166:

/* Line 1464 of yacc.c  */
#line 53844 "hlaparse.bsn"
    {			/* $6 */

			_here;
			_if
			( 
					IsNumber( (yyvsp[(3) - (5)].v.pType) ) 
				&&	numBits32( YYS &(yyvsp[(3) - (5)].v) ) <= 32
				&&	(yyvsp[(3) - (5)].v.u.intval) > 0 
			)
			
				EmitAlign( (yyvsp[(3) - (5)].v.u.unsval) );
				
			_else
			
				yyerror( "Expected a 32-bit positive constant" );
				
			_endif
			FreeValue( YYS &(yyvsp[(3) - (5)].v.u.unsval) );
			_here;
		;}
    break;

  case 1167:

/* Line 1464 of yacc.c  */
#line 53876 "hlaparse.bsn"
    {					/* $7  */
			
			char StaticName[ 256 ];
			char *sn;

			_here;
			assert( (yyvsp[(1) - (6)].idStr) != NULL );

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (6)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );

			CreatePtrToProc( (yyvsp[(1) - (6)].idStr), (yyvsp[(6) - (6)].s), sn, cStatic );
			_here;
		;}
    break;

  case 1168:

/* Line 1464 of yacc.c  */
#line 53893 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(9) - (10)].options.SpecifiedOptions),
					specified_use
				|	specified_pascal
				|	specified_stdcall
				|	specified_cdecl
				|	specified_alignment 
				|	specified_nostorage 
				|	specified_volatile 
			);
			_if( (yyvsp[(10) - (10)].returns) == NULL )

				EmitTypedLabel( SymbolTable->StaticName, tDWord );
				_if( !(yyvsp[(9) - (10)].options.NoStorage) )

					EmitDword();

				_endif

			_else
			 
				SymbolTable->IsExternal = 1;
				_if( *(yyvsp[(10) - (10)].returns) == '\0' )

				 	free2( vss SymbolTable->StaticName );
					SymbolTable->StaticName = hlastrdup2( SymbolTable->TrueName );
					free2( vss (yyvsp[(10) - (10)].returns) );

				_else

					SymbolTable->StaticName = (yyvsp[(10) - (10)].returns);

				_endif
				EmitTypedExtern
				( 
					SymbolTable, 
					SymbolTable->StaticName, 
					tDWord 
				);

			_endif
			_here;
		;}
    break;

  case 1169:

/* Line 1464 of yacc.c  */
#line 53978 "hlaparse.bsn"
    {					/* $11 */

			SymNode_t 		*s;
			union	YYSTYPE	value;

			_here;
			--CurLexLevel;
			CurOffset = (yyvsp[(4) - (10)].v.u.intval);
			CurOffsetDir = (yyvsp[(5) - (10)].v.u.unsval);
			CheckLegalOptions
			( 
				(yyvsp[(9) - (10)].options.SpecifiedOptions),
					specified_returns
				|	specified_use
				|	specified_pascal
				|	specified_stdcall
				|	specified_cdecl
				|	specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(10) - (10)].returns) != NULL && (yyvsp[(9) - (10)].options.NoStorage) )

				yyerror
				(
					"Can't specify both 'NOSTORAGE' and 'EXTERNAL' options"
				);

			_endif
			
			// Need to create a dummy type to hold the procedure pointer parameters.
			
			s = SymbolTable;
			InsertSym
			( 
				" (procptr parms) ", 
				NULL,
				tProcptr, 
				cType, 
				0,
				NULL,
				0, 
				NULL,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			SymbolTable->u.proc.parms = s;
			SymbolTable->u.proc.returns = (yyvsp[(9) - (10)].options.returns);
			SymbolTable->u.proc.use = (yyvsp[(9) - (10)].options.use);
			SymbolTable->u.proc.cs = (yyvsp[(9) - (10)].options.CallingSequence);
			(yyvsp[(6) - (10)].s)->Type = SymbolTable;
			(yyvsp[(6) - (10)].s)->u.proc.parms->Type = SymbolTable;
			
			// Remove the dummy entry from the symbol table:
			
			SymbolTable = s;
			
			// Patch the original symbol table entries:

			(yyvsp[(6) - (10)].s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(6) - (10)].s)->u.proc.parms->u.proc.returns = hlastrdup2( "" );
			(yyvsp[(6) - (10)].s)->u.proc.parms->u.proc.use = NULL;

			(yyvsp[(6) - (10)].s)->u.proc.parms = SymbolTable;
			(yyvsp[(6) - (10)].s)->u.proc.returns = (yyvsp[(9) - (10)].options.returns);
			(yyvsp[(6) - (10)].s)->u.proc.use = (yyvsp[(9) - (10)].options.use);
			(yyvsp[(6) - (10)].s)->u.proc.cs = (yyvsp[(9) - (10)].options.CallingSequence);
			
			/*
			** Just to be on the safe side, let's create
			** a "parms" and "vars" entry for this object.
			*/
			
			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.v.u.unsval = (yyvsp[(7) - (10)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			value.v.u.unsval = 0;
			InsertSym
			( 
				"_vars_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			(yyvsp[(6) - (10)].s)->u.proc.parms->u.proc.Locals = SymbolTable;
			(yyvsp[(6) - (10)].s)->u.proc.Locals = SymbolTable;
			
			SymbolTable = (yyvsp[(6) - (10)].s);


			_if( (yyvsp[(10) - (10)].returns) == NULL )

				EmitTypedLabel( (yyvsp[(6) - (10)].s)->StaticName, tDWord );
				_if( !(yyvsp[(9) - (10)].options.NoStorage) )

					EmitDword();

				_endif

			_else

				(yyvsp[(6) - (10)].s)->IsExternal = 1;
				_if( *(yyvsp[(10) - (10)].returns) == '\0' )

				 	free2( vss (yyvsp[(6) - (10)].s)->StaticName );
					(yyvsp[(6) - (10)].s)->StaticName = hlastrdup2( (yyvsp[(6) - (10)].s)->TrueName );
					free2( vss (yyvsp[(10) - (10)].returns) );

				_else

					(yyvsp[(6) - (10)].s)->StaticName = (yyvsp[(10) - (10)].returns);

				_endif
				EmitTypedExtern( (yyvsp[(6) - (10)].s), (yyvsp[(6) - (10)].s)->StaticName, tDWord );

			_endif
			_here;
		;}
    break;

  case 1170:

/* Line 1464 of yacc.c  */
#line 54145 "hlaparse.bsn"
    {				/* $8 */
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(7) - (7)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(1) - (7)].s)->IsExternal && (yyvsp[(1) - (7)].s)->SymClass == cStatic )

				(yyvsp[(1) - (7)].s)->IsExternal = 0;
				_if( (yyvsp[(1) - (7)].s)->pType == tProcptr )

					EmitTypedPublic( (yyvsp[(1) - (7)].s)->StaticName, (yyvsp[(1) - (7)].s)->pType );
					EmitTypedLabel( (yyvsp[(1) - (7)].s)->StaticName, tDWord );
					_if( !(yyvsp[(7) - (7)].options.NoStorage) )

						EmitDword();

					_endif

				_else

					ErrorNear
					(
						"External base type must be a procedure pointer",
						(yyvsp[(1) - (7)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif
			_here;
		;}
    break;

  case 1171:

/* Line 1464 of yacc.c  */
#line 54202 "hlaparse.bsn"
    {					/* $9  */
			
			char msg[ 256 ];
			
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(8) - (8)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			assert( (yyvsp[(1) - (8)].idStr) != NULL );

			_if( (yyvsp[(1) - (8)].s)->IsExternal && (yyvsp[(1) - (8)].s)->SymClass == cStatic )

				(yyvsp[(1) - (8)].s)->IsExternal = 0;
				_if( (yyvsp[(1) - (8)].s)->pType == tProcptr )

					assert( (yyvsp[(1) - (8)].s)->u.proc.Forward != NULL );
					_if( (yyvsp[(1) - (8)].s)->u.proc.Forward != (yyvsp[(6) - (8)].s) )
						
						sprintf
						( 
							msg,
							"Base procedure does not agree with original "
							"declaration\n('%s' should be '%s')",
							(yyvsp[(6) - (8)].s)->TrueName,
							(yyvsp[(1) - (8)].s)->u.proc.Forward->TrueName
						);
						yyerror( msg );
						
					_endif

					EmitTypedPublic( (yyvsp[(1) - (8)].s)->StaticName, (yyvsp[(1) - (8)].s)->pType );
					EmitTypedLabel( (yyvsp[(1) - (8)].s)->StaticName, tDWord );
					_if( !(yyvsp[(8) - (8)].options.NoStorage) )

						EmitDword();

					_endif

				_else

					ErrorNear
					(
						"External base type must be a procedure pointer",
						(yyvsp[(1) - (8)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (8)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif
			_here;
		;}
    break;

  case 1172:

/* Line 1464 of yacc.c  */
#line 54277 "hlaparse.bsn"
    { 
			_here;
			(yyval.s) = (yyvsp[(-2) - (0)].s); 
			_if( (yyval.s)->pType != tProcptr )

				yyerror( "External declaration is a pointer to a procedure" );

			_endif
		;}
    break;

  case 1173:

/* Line 1464 of yacc.c  */
#line 54305 "hlaparse.bsn"
    {				/* $9  */

				/*
				** Must fix restore these here because they
				** might affect the constant expression.
				*/

				_here;
				--CurLexLevel;
				CurOffset = (yyvsp[(4) - (8)].v.u.unsval);
				CurOffsetDir = (yyvsp[(5) - (8)].v.u.unsval);
			;}
    break;

  case 1174:

/* Line 1464 of yacc.c  */
#line 54328 "hlaparse.bsn"
    {
				SymNode_t 		*s;
				union	YYSTYPE	value;
				
				_here;
				CheckLegalOptions
				( 
					(yyvsp[(12) - (12)].options.SpecifiedOptions),
						specified_returns
					|	specified_use
					|	specified_pascal
					|	specified_stdcall
					|	specified_cdecl
					|	specified_nostorage
					|	specified_volatile 
				);
				_if( (yyvsp[(12) - (12)].options.NoStorage) )

					yyerror( "'nostorage' option is illegal here" );

				_endif

				_if( (yyvsp[(10) - (12)].v.pType) != tPointer )

					yyerror
					( 
						"Operand must be the address of a static object" 
					);

				_else

			
					// Need to create a dummy type to hold the procedure pointer parameters.
					
					s = SymbolTable;
					InsertSym
					( 
						" (procptr parms) ", 
						NULL,
						tProcptr, 
						cType, 
						0,
						NULL,
						0, 
						NULL,
						4,
						0,
						NULL,
						NULL,
						NULL,
						0
					);
					SymbolTable->u.proc.parms = s;
					SymbolTable->u.proc.returns = (yyvsp[(12) - (12)].options.returns);
					SymbolTable->u.proc.use = (yyvsp[(12) - (12)].options.use);
					SymbolTable->u.proc.cs = (yyvsp[(12) - (12)].options.CallingSequence);
					(yyvsp[(6) - (12)].s)->Type = SymbolTable;
					(yyvsp[(6) - (12)].s)->u.proc.parms->Type = SymbolTable;
					(yyvsp[(6) - (12)].s)->u.proc.returns = hlastrdup2( "" );
					(yyvsp[(6) - (12)].s)->u.proc.use = NULL;
					
					// Remove the dummy entry from the symbol table:
					
					SymbolTable = s;
			
					// Patch the original symbol table entries:

					(yyvsp[(6) - (12)].s)->u.proc.parms->u.proc.parms = SymbolTable;
					(yyvsp[(6) - (12)].s)->u.proc.parms->u.proc.returns = hlastrdup2( "" );
					(yyvsp[(6) - (12)].s)->u.proc.parms->u.proc.use = NULL;
					(yyvsp[(6) - (12)].s)->u.proc.parms->u.proc.Locals = NULL;

					(yyvsp[(6) - (12)].s)->u.proc.parms = SymbolTable;
					(yyvsp[(6) - (12)].s)->u.proc.Locals = NULL;
					(yyvsp[(6) - (12)].s)->u.proc.returns = (yyvsp[(12) - (12)].options.returns);
					(yyvsp[(6) - (12)].s)->u.proc.use = (yyvsp[(12) - (12)].options.use);
					(yyvsp[(6) - (12)].s)->u.proc.cs = (yyvsp[(12) - (12)].options.CallingSequence);
			
					/*
					** Just to be on the safe side, let's create
					** a "parms" and "vars" entry for this object.
					*/
					
					ClrConst
					(
						YYS &value,
						tUns32,
						&uns32_ste
					);
					value.v.u.unsval = (yyvsp[(7) - (12)].v.u.unsval);
					InsertSym
					( 
						"_parms_", 
						&uns32_ste,
						tUns32, 
						cConstant, 
						0,
						NULL,
						0, 
						YYS &value,
						4,
						0,
						NULL,
						NULL,
						NULL,
						0
					);
					value.v.u.unsval = 0;
					InsertSym
					( 
						"_vars_", 
						&uns32_ste,
						tUns32, 
						cConstant, 
						0,
						NULL,
						0, 
						YYS &value,
						4,
						0,
						NULL,
						NULL,
						NULL,
						0
					);
					(yyvsp[(6) - (12)].s)->u.proc.parms->u.proc.Locals = SymbolTable;
					(yyvsp[(6) - (12)].s)->u.proc.Locals = SymbolTable;
					
					SymbolTable = (yyvsp[(6) - (12)].s);
					EmitTypedLabel( (yyvsp[(6) - (12)].s)->StaticName, tDWord );
					EmitAdrs( (yyvsp[(10) - (12)].v.u.strval) ); 

				_endif
				_here;
			;}
    break;

  case 1175:

/* Line 1464 of yacc.c  */
#line 54475 "hlaparse.bsn"
    {					/* $9  */					
			
			char StaticName[ 256 ];
			char *sn;

			_here;
			assert( (yyvsp[(1) - (8)].idStr) != NULL );

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (8)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );

			CreatePtrToProc( (yyvsp[(1) - (8)].idStr), (yyvsp[(6) - (8)].s), sn, cStatic );

			_here;
		;}
    break;

  case 1176:

/* Line 1464 of yacc.c  */
#line 54492 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(11) - (11)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(11) - (11)].options.NoStorage) )

				yyerror( "'nostorage' option is illegal here" );

			_elseif( (yyvsp[(8) - (11)].v.pType) != tPointer )

				yyerror
				( 
					"Operand must be the address of a static object" 
				);

			_else

				EmitTypedLabel( SymbolTable->StaticName, tDWord );
				EmitAdrs( (yyvsp[(8) - (11)].v.u.strval) ); 

			_endif
		;}
    break;

  case 1177:

/* Line 1464 of yacc.c  */
#line 54539 "hlaparse.bsn"
    {						/* $9  */
			_here;
			_if( (yyvsp[(1) - (8)].s)->IsExternal && (yyvsp[(1) - (8)].s)->SymClass == cStatic )

				(yyvsp[(1) - (8)].s)->IsExternal = 0;
				_if( (yyvsp[(7) - (8)].v.pType) != tPointer )

					yyerror
					( 
						"Operand must be the address of a static object" 
					);

				_else


					_if( (yyvsp[(1) - (8)].s)->pType == tProcptr )

						EmitTypedPublic( (yyvsp[(1) - (8)].s)->StaticName, (yyvsp[(1) - (8)].s)->pType );
						EmitTypedLabel( (yyvsp[(1) - (8)].s)->StaticName, tDWord );
						EmitAdrs( (yyvsp[(7) - (8)].v.u.strval) );

					_else

						ErrorNear
						(
							"External base type must be a procedure pointer",
							(yyvsp[(1) - (8)].s)->TrueName,
							__LINE__,
							__FILE__
						);

					_endif


				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (8)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif
			FreeValue( YYS &(yyvsp[(7) - (8)].v) );
			_here;
		;}
    break;

  case 1178:

/* Line 1464 of yacc.c  */
#line 54604 "hlaparse.bsn"
    {		
			char msg[ 256 ];
						
			_here;
			_if( (yyvsp[(1) - (9)].s)->IsExternal && (yyvsp[(1) - (9)].s)->SymClass == cStatic )

				(yyvsp[(1) - (9)].s)->IsExternal = 0;
				_if( (yyvsp[(8) - (9)].v.pType) != tPointer )

					yyerror
					( 
						"Operand must be the address of a static object" 
					);

				_else


					_if( (yyvsp[(1) - (9)].s)->pType == tProcptr )

						_if( (yyvsp[(1) - (9)].s)->u.proc.Forward != (yyvsp[(6) - (9)].s) )
							
							sprintf
							( 
								msg,
								"Base procedure does not agree with original "
								"declaration\n('%s' should be '%s')",
								(yyvsp[(6) - (9)].s)->TrueName,
								(yyvsp[(1) - (9)].s)->u.proc.Forward->TrueName
							);
							yyerror( msg );
							
						_endif

						EmitTypedPublic( (yyvsp[(1) - (9)].s)->StaticName, (yyvsp[(1) - (9)].s)->pType );
						EmitTypedLabel( (yyvsp[(1) - (9)].s)->StaticName, tDWord );
						EmitAdrs( (yyvsp[(8) - (9)].v.u.strval) );

					_else

						ErrorNear
						(
							"External base type must be a procedure pointer",
							(yyvsp[(1) - (9)].s)->TrueName,
							__LINE__,
							__FILE__
						);

					_endif


				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (9)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif
			FreeValue( YYS &(yyvsp[(8) - (9)].v) );
			_here;
		;}
    break;

  case 1179:

/* Line 1464 of yacc.c  */
#line 54692 "hlaparse.bsn"
    {				/* $11 */
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(10) - (10)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			// Fix up the generated enum type to include a pointer to
			// the enum symbols and the count of enum symbols:
			
			(yyvsp[(4) - (10)].s)->Fields = SymbolTable;
			(yyvsp[(4) - (10)].s)->FieldCnt = EnumVal;
			

			_if( EnumSize == 1 )

				EmitTypedLabel( (yyvsp[(4) - (10)].s)->StaticName, tByte );
				_if( !(yyvsp[(10) - (10)].options.NoStorage) )

					EmitByte();

				_endif

			_elseif( EnumSize == 2 )

				EmitTypedLabel( (yyvsp[(4) - (10)].s)->StaticName, tWord );
				_if( !(yyvsp[(10) - (10)].options.NoStorage) )

					EmitWord();

				_endif

			_else

				EmitTypedLabel( (yyvsp[(4) - (10)].s)->StaticName, tDWord );
				_if( !(yyvsp[(10) - (10)].options.NoStorage) )

					EmitDword();

				_endif

			_endif
		 ;}
    break;

  case 1180:

/* Line 1464 of yacc.c  */
#line 54753 "hlaparse.bsn"
    {				/* $9 */

			// Fix up the generated enum type to include a pointer to
			// the enum symbols and the count of enum symbols:
			
			_here;
			(yyvsp[(4) - (8)].s)->Fields = SymbolTable;
			(yyvsp[(4) - (8)].s)->FieldCnt = EnumVal;

		;}
    break;

  case 1181:

/* Line 1464 of yacc.c  */
#line 54766 "hlaparse.bsn"
    {
			char	valStr[32];
			
			_here;
			sprintf( valStr, "%d", (yyvsp[(11) - (12)].v.u.unsval) );
			
			_if( (yyvsp[(11) - (12)].v.Type) != (yyvsp[(6) - (12)].v.Type) )

				yyerror( "Type mismatch in enum constant" );

			_else
			
				_switch( EnumSize )
				
					_case( 4 )
					
						EmitData( (yyvsp[(4) - (12)].s)->StaticName, tDWord, valStr );
						
					_endcase
				
					_case( 2 )
					
						EmitData( (yyvsp[(4) - (12)].s)->StaticName, tWord, valStr );
						
					_endcase
				
					_default
					
						EmitData( (yyvsp[(4) - (12)].s)->StaticName, tByte, valStr );
						
				_endswitch
				

			_endif
			_here;
		;}
    break;

  case 1182:

/* Line 1464 of yacc.c  */
#line 54821 "hlaparse.bsn"
    {					/* $10 */

			SymNode_t	*BaseType;
			char		*sn;
			char		StaticName[ 256 ];

			_here;
			assert( (yyvsp[(1) - (7)].idStr) != NULL );
			assert( (yyvsp[(5) - (7)].neID.idStr) != NULL );

			BaseType = (yyvsp[(5) - (7)].neID.s);
			_if( BaseType != NULL )

				BaseType = GetBaseType( BaseType );
				_if( CantBeVar( BaseType->pType ))

					yyerror( "Static/Readonly variables cannot be this type" );
					BaseType = &uns32_ste;

				_endif

			_endif

			_if
			( 
					(yyvsp[(7) - (7)].v.pType) != tPointer 

			)

				yyerror( "Expression must be a pointer constant" );
				FreeValue( YYS &(yyvsp[(7) - (7)].v) );
				(yyvsp[(7) - (7)].v.u.strval) = hlastrdup2( "0" );
				(yyvsp[(7) - (7)].v.pType) = tString;
				(yyvsp[(7) - (7)].v.Type) = &string_ste;

			_endif

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (7)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );
			InsertSym
			( 
				(yyvsp[(1) - (7)].idStr),			/* Name			*/
				&pointer_ste,		/* Type			*/
				tPointer, 			/* pType		*/
				cStatic,			/* SymClass		*/ 
				0,					/* Arity		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				4,					/* ObjectSize	*/
				0,					/* CurOffset	*/
				sn,					/* StaticName	*/
				BaseType,			/* BaseType		*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);


			EmitTypedLabel( sn, tDWord );
			EmitAdrs( (yyvsp[(7) - (7)].v.u.strval) );


			_if( BaseType == NULL )

				Add2PtrList( SymbolTable, (yyvsp[(5) - (7)].neID.idStr) );

			_endif
			FreeValue( YYS &(yyvsp[(7) - (7)].v) );
			_here;
		;}
    break;

  case 1183:

/* Line 1464 of yacc.c  */
#line 54893 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(10) - (10)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(10) - (10)].options.NoStorage) )

				yyerror( "'nostorage' option is illegal here" );

			_endif

		;}
    break;

  case 1184:

/* Line 1464 of yacc.c  */
#line 54925 "hlaparse.bsn"
    {					/* $8  */


			SymNode_t	*BaseType;
			char		*sn;
			char		StaticName[ 256 ];

			_here;
			assert( (yyvsp[(1) - (7)].idStr) != NULL );
			assert( (yyvsp[(5) - (7)].neID.idStr) != NULL );

			BaseType = (yyvsp[(5) - (7)].neID.s);
			_if( BaseType != NULL )

				BaseType = GetBaseType( BaseType );
				_if( CantBeVar( BaseType->pType ))

					yyerror( "Static/Readonly variables cannot be this type" );
					BaseType = &uns32_ste;

				_endif

			_endif

			_if
			( 
					(yyvsp[(7) - (7)].v.pType) != tPointer 

			)

				yyerror( "Expression must be a pointer constant" );
				FreeValue( YYS &(yyvsp[(7) - (7)].v) );
				(yyvsp[(7) - (7)].v.u.strval) = hlastrdup2( "0" );
				(yyvsp[(7) - (7)].v.pType) = tString;
				(yyvsp[(7) - (7)].v.Type) = &string_ste;

			_endif



			_if( (yyvsp[(1) - (7)].s)->IsExternal && (yyvsp[(1) - (7)].s)->SymClass == cStatic )

				(yyvsp[(1) - (7)].s)->IsExternal = 0;
				_if( (yyvsp[(1) - (7)].s)->Type == &pointer_ste && (yyvsp[(1) - (7)].s)->Base == BaseType ) 

					EmitTypedPublic( (yyvsp[(1) - (7)].s)->StaticName, (yyvsp[(1) - (7)].s)->pType );
					EmitTypedLabel( (yyvsp[(1) - (7)].s)->StaticName, tDWord );
					EmitAdrs( (yyvsp[(7) - (7)].v.u.strval) );

				_else

					ErrorNear
					(
						"External base type must match declared base type",
						(yyvsp[(5) - (7)].neID.idStr),
						__LINE__,
						__FILE__
					);

				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif


			_if( BaseType == NULL )

				Add2PtrList( (yyvsp[(1) - (7)].s), (yyvsp[(5) - (7)].neID.idStr) );

			_endif
			FreeValue( YYS &(yyvsp[(7) - (7)].v) );
			_here;
		;}
    break;

  case 1185:

/* Line 1464 of yacc.c  */
#line 55009 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(10) - (10)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(10) - (10)].options.NoStorage) )

				yyerror( "'nostorage' option is illegal here" );

			_endif

		;}
    break;

  case 1186:

/* Line 1464 of yacc.c  */
#line 55040 "hlaparse.bsn"
    {					/* $8  */

			SymNode_t *BaseType;
			char	  *sn;
			char	  StaticName[ 256 ];

			_here;
			assert( (yyvsp[(1) - (7)].idStr) != NULL );


			BaseType = (yyvsp[(5) - (7)].s);
			_if( CantBeVar( BaseType->pType ))

				yyerror( "Static/Readonly variables cannot be this type" );
				BaseType = &uns32_ste;

			_endif

			/*
			** It better be a pointer constant.
			*/

			_if
			( 
					(yyvsp[(7) - (7)].v.pType) != tPointer 

			)

				yyerror( "Expression must be a pointer constant" );
				FreeValue( YYS &(yyvsp[(7) - (7)].v) );
				(yyvsp[(7) - (7)].v.u.strval) = hlastrdup2( "0" );
				(yyvsp[(7) - (7)].v.pType) = tString;
				(yyvsp[(7) - (7)].v.Type) = &string_ste;

			_endif

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (7)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );
			InsertSym
			( 
				(yyvsp[(1) - (7)].idStr),			/* Name			*/
				&pointer_ste,		/* Type			*/
				tPointer, 			/* pType		*/
				cStatic,			/* SymClass		*/ 
				0,					/* Arity		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				4,					/* ObjectSize	*/
				0,					/* CurOffset	*/
				sn,					/* StaticName	*/
				BaseType,			/* BaseType		*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);
			EmitTypedLabel( sn, tDWord );
			EmitAdrs( (yyvsp[(7) - (7)].v.u.strval) );
			FreeValue( YYS &(yyvsp[(7) - (7)].v) );
			_here;
		;}
    break;

  case 1187:

/* Line 1464 of yacc.c  */
#line 55102 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(10) - (10)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(10) - (10)].options.NoStorage) )

				yyerror( "'nostorage' option is illegal here" );

			_endif
		;}
    break;

  case 1188:

/* Line 1464 of yacc.c  */
#line 55133 "hlaparse.bsn"
    {					/* $8 */					
			
			_here;


			_if( (yyvsp[(1) - (7)].s)->IsExternal && (yyvsp[(1) - (7)].s)->SymClass == cStatic )

				(yyvsp[(1) - (7)].s)->IsExternal = 0;
				_if( (yyvsp[(1) - (7)].s)->Type == &pointer_ste && (yyvsp[(1) - (7)].s)->Base == (yyvsp[(5) - (7)].s) )

					EmitTypedPublic( (yyvsp[(1) - (7)].s)->StaticName, (yyvsp[(1) - (7)].s)->pType );
					EmitTypedLabel( (yyvsp[(1) - (7)].s)->StaticName, tDWord );
					EmitAdrs( (yyvsp[(7) - (7)].v.u.strval) );

				_else

					ErrorNear
					(
						"Pointer constant is illegal here",
						(yyvsp[(5) - (7)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif
			FreeValue( YYS &(yyvsp[(7) - (7)].v) );
			_here;
		;}
    break;

  case 1189:

/* Line 1464 of yacc.c  */
#line 55175 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(10) - (10)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(10) - (10)].options.NoStorage) )

				yyerror( "'nostorage' option is illegal here" );

			_endif
		;}
    break;

  case 1190:

/* Line 1464 of yacc.c  */
#line 55206 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(7) - (7)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(1) - (7)].s)->IsExternal && (yyvsp[(1) - (7)].s)->SymClass == cStatic )

				(yyvsp[(1) - (7)].s)->IsExternal = 0;
				_if( (yyvsp[(1) - (7)].s)->Type == &pointer_ste && (yyvsp[(1) - (7)].s)->Base == (yyvsp[(5) - (7)].s) ) 

					EmitTypedPublic( (yyvsp[(1) - (7)].s)->StaticName, (yyvsp[(1) - (7)].s)->pType );
					EmitTypedLabel( (yyvsp[(1) - (7)].s)->StaticName, tDWord );
					_if( !(yyvsp[(7) - (7)].options.NoStorage) )

						EmitDwordConst( 0, "" );

					_endif

				_else

					ErrorNear
					(
						"External base type must match declared base type",
						(yyvsp[(5) - (7)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif
			_here;
		;}
    break;

  case 1191:

/* Line 1464 of yacc.c  */
#line 55267 "hlaparse.bsn"
    {					/* $6 */

			char StaticName[ 256 ];
			char *sn;

			assert( (yyvsp[(1) - (5)].idStr) != NULL );
			assert( (yyvsp[(3) - (5)].s) != NULL );

			_here;

			_if( CantBeVar((yyvsp[(3) - (5)].s)->pType ))

				yyerror( "Object cannot be this type" );

			_else
			
				sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (5)].idStr), LblCntr++ );
				sn = hlastrdup2( StaticName );

				InsertSym
				( 
					(yyvsp[(1) - (5)].idStr), 
					(yyvsp[(3) - (5)].s),			/* GetBaseType( $<s>3 ), */
					(yyvsp[(3) - (5)].s)->pType, 
					cStatic, 
					(yyvsp[(3) - (5)].s)->Arity,
					(yyvsp[(3) - (5)].s)->Dimensions,
					(yyvsp[(3) - (5)].s)->NumElements, 
					NULL,
					(yyvsp[(3) - (5)].s)->ObjectSize,
					0,
					sn,
					(yyvsp[(3) - (5)].s)->Base,
					(yyvsp[(3) - (5)].s)->Fields,
					(yyvsp[(3) - (5)].s)->FieldCnt
				);
				_if( (yyvsp[(3) - (5)].s)->pType == tProcptr )
				
					// Copy parameter info if a proc ptr.
					
					memcpy
					( 
						&SymbolTable->u, 
						&(yyvsp[(3) - (5)].s)->u, 
						sizeofValuesSize
					);
					
				_endif

				/*
				** Check to see if the TypeID and the ConstOnlyExpr
				** are both arrays and if they are compatible.
				*/

				_if( (yyvsp[(3) - (5)].s)->pType == tArray && (yyvsp[(5) - (5)].v.pType) == tArray )

					_if
					( 
						ArraysAreCompatible
						( 
							YYS (yyvsp[(3) - (5)].s), 
							YYS &(yyvsp[(5) - (5)].v) 
						)
					)

						OutValue( sn, (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) );

					_else

						yyerror
						( 
							"Array type mismatch or value out of range" 
						);

					_endif


				/*
				** Check to see if the TypeID and the ConstOnlyExpr are
				** compatible record objects. 
				*/

				_elseif
				( 
						(yyvsp[(3) - (5)].s)->pType == tRecord 
					&&	(yyvsp[(5) - (5)].v.pType) == tRecord 
				)

					_if
					( 
						RecordsAreCompatible
						( 
							(yyvsp[(3) - (5)].s), 
							YYS &(yyvsp[(5) - (5)].v) 
						)
					)

						OutValue( sn, (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) );

					_else

						yyerror
						( 
							"Type mismatch, expected compatible "
							"record types"
						);

					_endif




				/*
				** Check to see if the TypeID and the ConstOnlyExpr are
				** compatible union objects. 
				*/

				_elseif
				( 
						(yyvsp[(3) - (5)].s)->pType == tUnion 
					&&	GetBaseType( (yyvsp[(3) - (5)].s) ) == GetBaseType( (yyvsp[(5) - (5)].v.Type) ) 
				)

					OutValue( sn, (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) );



				/*
				** Check to see if the TypeID and the ConstOnlyExpr are
				** compatible real128 objects. 
				*/

				_elseif
				( 
						(yyvsp[(3) - (5)].s)->pType == tReal128 
					&&	GetBaseType( (yyvsp[(3) - (5)].s) ) == GetBaseType( (yyvsp[(5) - (5)].v.Type) ) 
				)

					OutValue( sn, (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) );


				_elseif
				( 
						( 
								(yyvsp[(3) - (5)].s)->pType == tPointer 
							||	(yyvsp[(3) - (5)].s)->pType == tProcptr
							||	(yyvsp[(3) - (5)].s)->pType == tDWord
						)
					&&	(yyvsp[(5) - (5)].v.pType) == tPointer
				)

					OutValue( sn, (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) );



				/*
				** Check to see if the TypeID and the ConstOnlyExpr are
				** compatible pointer objects here.
				*/

				_elseif( IsNotPrimType( (yyvsp[(3) - (5)].s)->pType ))

					yyerror( "This static type requires a constant" );


				/*
				** Special case: since strings are really pointer
				** objects, we'll allow a pointer constant as the
				** initial value of a string.  Can't really check
				** the type (since the pointer constant might
				** not be defined yet), but this is assembly language,
				** the programmer has to take responsibility for
				** some things!
				*/

				_elseif
				( 
						( IsStr( (yyvsp[(3) - (5)].s)->pType ))
					&&	(yyvsp[(5) - (5)].v.pType) == tPointer
				)

					assert( (yyvsp[(5) - (5)].v.u.strval) != NULL );
					EmitTypedLabel( StaticName, tDWord );
					EmitAdrs( (yyvsp[(5) - (5)].v.u.strval) );
				
				/*
				** We've got a scalar object, output the constant here.
				*/

				_elseif( IsCompatible( (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) ))

					OutStaticConst( sn, (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) );

				_else

					yyerror( "Static type mismatch or range error" );

				_endif

			_endif
			FreeValue( YYS &(yyvsp[(5) - (5)].v) );
			_here;
		;}
    break;

  case 1192:

/* Line 1464 of yacc.c  */
#line 55472 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(8) - (8)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(8) - (8)].options.NoStorage) )

				yyerror( "'nostorage' option is illegal here" );

			_endif
		;}
    break;

  case 1193:

/* Line 1464 of yacc.c  */
#line 55503 "hlaparse.bsn"
    {					/* $6 */

			char StaticName[ 256 ];
			char *sn;

			assert( (yyvsp[(1) - (5)].s) != NULL );
			assert( (yyvsp[(3) - (5)].s) != NULL );

			_here;

			_if( CantBeVar((yyvsp[(3) - (5)].s)->pType ))

				yyerror( "Variables cannot be this type" );

			_else
			

				_if( (yyvsp[(1) - (5)].s)->IsExternal && (yyvsp[(1) - (5)].s)->SymClass == cStatic )

					/*
					** The type of the previously declared symbol must
					** be identical to the current declared type.
					*/

					(yyvsp[(1) - (5)].s)->IsExternal = 0;
					_if( (yyvsp[(1) - (5)].s)->Type == (yyvsp[(3) - (5)].s) ) 

						EmitTypedPublic( (yyvsp[(1) - (5)].s)->StaticName, (yyvsp[(1) - (5)].s)->pType );

						/*
						** Check to see if the TypeID and the ConstOnlyExpr
						** are both arrays and if they are compatible.
						*/

						_if( (yyvsp[(3) - (5)].s)->pType == tArray && (yyvsp[(5) - (5)].v.pType) == tArray )

							_if
							( 
								ArraysAreCompatible
								( 
									YYS (yyvsp[(3) - (5)].s), 
									YYS &(yyvsp[(5) - (5)].v) 
								)
							)

								OutValue
								( 
									(yyvsp[(1) - (5)].s)->StaticName, 
									(yyvsp[(3) - (5)].s), 
									YYS &(yyvsp[(5) - (5)].v) 
								);

							_else

								yyerror
								( 
									"Array type mismatch or value out of range" 
								);

							_endif


						/*
						** Check to see if the TypeID and the ConstOnlyExpr are
						** compatible record objects. 
						*/

						_elseif
						( 
								(yyvsp[(3) - (5)].s)->pType == tRecord 
							&&	(yyvsp[(5) - (5)].v.pType) == tRecord 
						)

							_if
							( 
								RecordsAreCompatible
								( 
									(yyvsp[(3) - (5)].s), 
									YYS &(yyvsp[(5) - (5)].v) 
								)
							)

								OutValue
								( 
									(yyvsp[(1) - (5)].s)->StaticName, 
									(yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) 
								);

							_else

								yyerror
								( 
									"Type mismatch, expected compatible "
									"record types"
								);

							_endif






						/*
						** Check to see if the TypeID and the ConstOnlyExpr are
						** compatible union objects. 
						*/

						_elseif
						( 
								(yyvsp[(3) - (5)].s)->pType == tUnion 
							&&	GetBaseType( (yyvsp[(3) - (5)].s) ) == 
									GetBaseType( (yyvsp[(5) - (5)].v.Type) ) 
						)

							OutValue( (yyvsp[(1) - (5)].s)->StaticName, (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) );




						/*
						** Check to see if the TypeID and the ConstOnlyExpr are
						** compatible real128 objects. 
						*/

						_elseif
						( 
								(yyvsp[(3) - (5)].s)->pType == tReal128 
							&&	GetBaseType( (yyvsp[(3) - (5)].s) ) == 
									GetBaseType( (yyvsp[(5) - (5)].v.Type) ) 
						)

							OutValue( (yyvsp[(1) - (5)].s)->StaticName, (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) );




						_elseif
						( 
								( 
										(yyvsp[(3) - (5)].s)->pType == tPointer 
									||	(yyvsp[(3) - (5)].s)->pType == tProcptr
									||	(yyvsp[(3) - (5)].s)->pType == tDWord
								)
							&&	(yyvsp[(5) - (5)].v.pType) == tPointer
						)

							OutValue
							( 
								(yyvsp[(1) - (5)].s)->StaticName, 
								(yyvsp[(3) - (5)].s), 
								YYS &(yyvsp[(5) - (5)].v) 
							);



						/*
						** Check to see if the TypeID and the ConstOnlyExpr are
						** compatible pointer objects here.
						*/

						_elseif( IsNotPrimType( (yyvsp[(3) - (5)].s)->pType ))

							yyerror( "This static type requires a constant" );

						
						/*
						** We've got a scalar object, output the constant here.
						*/

						_elseif
						( 
							IsCompatible( (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) )
						)

							OutStaticConst( (yyvsp[(1) - (5)].s)->StaticName, (yyvsp[(3) - (5)].s), YYS &(yyvsp[(5) - (5)].v) );

						_else

							yyerror( "Static type mismatch or range error" );

						_endif

					_else

						ErrorNear
						(
							"External type must match "
							"declared type",
							(yyvsp[(1) - (5)].s)->TrueName,
							__LINE__,
							__FILE__
						);

					_endif

				_else

					ErrorNear
					( 
						"Duplicate symbol definition",
						(yyvsp[(1) - (5)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif

			_endif
			FreeValue( YYS &(yyvsp[(5) - (5)].v) );
			_here;
		;}
    break;

  case 1194:

/* Line 1464 of yacc.c  */
#line 55717 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(8) - (8)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(8) - (8)].options.NoStorage) )

				yyerror( "'nostorage' option is illegal here" );

			_endif
		;}
    break;

  case 1195:

/* Line 1464 of yacc.c  */
#line 55751 "hlaparse.bsn"
    {				/* $9 */
		
			int		*DimensionArray;
			int		ArraySize;
			char	StaticName[ 256 ];
			char	*sn;

			assert( (yyvsp[(1) - (8)].idStr) != NULL );
			assert( (yyvsp[(3) - (8)].s) != NULL );
			assert( (yyvsp[(5) - (8)].v.Dimensions) != NULL );

			_here;

			_if( (yyvsp[(5) - (8)].v.NumElements) <= 0 )
			
				yyerror( "Array declaration must have at least one element" );
				(yyvsp[(5) - (8)].v.NumElements) = 1;
			
			_endif
			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (8)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );

			/*
			** Make sure this is a legal variable type
			** (e.g., no text variables).
			*/

			_if( CantBeVar( (yyvsp[(3) - (8)].s)->pType ))
			
				yyerror( "Bad static/readonly variable type" );
				
			_else 
			
				/*
				** Check to see if TypeID is an array type
				** (i.e., we're creating a multi-dimensional array).
				*/

				_if( (yyvsp[(3) - (8)].s)->pType != tArray )

					/*
					** TypeID is *not* an array type, so create
					** a single dimension array here.
					*/

					ArraySize = (yyvsp[(3) - (8)].s)->ObjectSize * (yyvsp[(5) - (8)].v.NumElements);
					InsertSym
					( 
						(yyvsp[(1) - (8)].idStr), 
						(yyvsp[(3) - (8)].s),
						tArray, 
						cStatic, 
						(yyvsp[(5) - (8)].v.Arity),
						(yyvsp[(5) - (8)].v.Dimensions),
						(yyvsp[(5) - (8)].v.NumElements), 
						NULL,
						ArraySize,
						0,
						sn,
						(yyvsp[(3) - (8)].s)->Base,
						(yyvsp[(3) - (8)].s)->Fields,
						(yyvsp[(3) - (8)].s)->FieldCnt
					);
					DimensionArray = (yyvsp[(5) - (8)].v.Dimensions);


				/*
				** Okay, down here TypeID *is* an array type,
				** so we're creating a multi-dimensional array.
				*/

				_else

					assert( (yyvsp[(3) - (8)].s)->Dimensions != NULL );

					/*
					** Create the new dimension array by concatenating
					** the two existing dimension arrays.
					*/

					DimensionArray = 
						malloc2
						( 
							( (yyvsp[(3) - (8)].s)->Arity + (yyvsp[(5) - (8)].v.NumElements) ) * 
								sizeofInt 
						);

					memcpy
					( 
						DimensionArray, 
						(yyvsp[(3) - (8)].s)->Dimensions, 
						(yyvsp[(3) - (8)].s)->Arity * sizeofInt 
					);
					memcpy
					(
						&DimensionArray[ (yyvsp[(3) - (8)].s)->Arity ],
						(yyvsp[(5) - (8)].v.Dimensions),
						(yyvsp[(5) - (8)].v.Arity) * sizeofInt 
					);
					ArraySize = (yyvsp[(3) - (8)].s)->ObjectSize * (yyvsp[(5) - (8)].v.NumElements);
					free2( vss (yyvsp[(5) - (8)].v.Dimensions) );

					/*
					** Add the new array to the symbol table.
					*/

					InsertSym
					( 
						(yyvsp[(1) - (8)].idStr), 
						(yyvsp[(3) - (8)].s)->Type,
						tArray, 
						cStatic, 
						(yyvsp[(3) - (8)].s)->Arity + (yyvsp[(5) - (8)].v.Arity),
						DimensionArray,
						(yyvsp[(3) - (8)].s)->NumElements * (yyvsp[(5) - (8)].v.NumElements), 
						NULL,
						ArraySize,
						0,
						sn,
						(yyvsp[(3) - (8)].s)->Base,
						(yyvsp[(3) - (8)].s)->Fields,
						(yyvsp[(3) - (8)].s)->FieldCnt
					);

				_endif
				
				
				/*
				** Check to see if the TypeID and the ConstOnlyExpr
				** are both arrays and if they are compatible.
				*/

				_if( (yyvsp[(8) - (8)].v.pType) != tArray )

					yyerror( "Expected an array constant as initializer" );

				_else
				
					_if
					( 
						ArraysAreCompatible
						( 
							YYS SymbolTable, 
							YYS &(yyvsp[(8) - (8)].v) 
						)
					)
					
						OutValue( sn, SymbolTable, YYS &(yyvsp[(8) - (8)].v) );

					_else

						yyerror
						( 
							"Array type mismatch or value out of range" 
						);

					_endif


				_endif
				FreeValue( YYS &(yyvsp[(8) - (8)].v) );

			_endif
			_here;
		;}
    break;

  case 1196:

/* Line 1464 of yacc.c  */
#line 55918 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(11) - (11)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(11) - (11)].options.NoStorage) )

				yyerror( "'nostorage' option is illegal here" );

			_endif
		;}
    break;

  case 1197:

/* Line 1464 of yacc.c  */
#line 55955 "hlaparse.bsn"
    {				/* $8 */
		
			int		*DimensionArray;
			int		ArraySize;
			char	StaticName[ 256 ];
			char	*sn;

			assert( (yyvsp[(1) - (7)].idStr) != NULL );
			assert( (yyvsp[(3) - (7)].s) != NULL );


			_here;

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (7)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );

			/*
			** Make sure this is a legal variable type
			** (e.g., no text variables).
			*/

			_if( CantBeVar( (yyvsp[(3) - (7)].s)->pType ))
			
				yyerror( "Bad static/readonly variable type" );
				
			_else 
			
				/*
				** Check to see if TypeID is an array type
				** (i.e., we're creating a multi-dimensional array).
				*/

				_if( (yyvsp[(3) - (7)].s)->pType != tArray )

					/*
					** TypeID is *not* an array type, so create
					** a single dimension array here.
					*/

					ArraySize = (yyvsp[(3) - (7)].s)->ObjectSize * (yyvsp[(7) - (7)].v.NumElements);
					InsertSym
					( 
						(yyvsp[(1) - (7)].idStr), 
						(yyvsp[(3) - (7)].s),
						tArray, 
						cStatic, 
						1,							/* arity       */
						malloc2( sizeofInt ),	/* dimensions  */
						(yyvsp[(7) - (7)].v.NumElements),			/* numelements */
						NULL,						/* value       */
						ArraySize,					/* object size */
						0,
						sn,
						(yyvsp[(3) - (7)].s)->Base,
						(yyvsp[(3) - (7)].s)->Fields,
						(yyvsp[(3) - (7)].s)->FieldCnt
					);
					SymbolTable->Dimensions[0] = (yyvsp[(7) - (7)].v.NumElements);


				/*
				** Okay, down here TypeID *is* an array type,
				** so we're creating a multi-dimensional array.
				*/

				_elseif
				( 
						(yyvsp[(7) - (7)].v.NumElements) <= (yyvsp[(3) - (7)].s)->NumElements
					||	((yyvsp[(7) - (7)].v.NumElements) % (yyvsp[(3) - (7)].s)->NumElements) != 0
				)
				
					/*
					** The array constant must have an even multiple
					** of the number of elements of $<s>3's type, or
					** this is an error.
					*/
					
					yyerror( "Illegal number of array elements in constant" );
					
				_else

					assert( (yyvsp[(3) - (7)].s)->Dimensions != NULL );
					assert( (yyvsp[(3) - (7)].s)->NumElements != 0 );

					/*
					** Create the new dimension array by concatenating
					** the two existing dimension arrays.
					*/

					DimensionArray = 
						malloc2
						( 
							( (yyvsp[(3) - (7)].s)->Arity + 1 ) * sizeofInt 
						);

					memcpy
					( 
						DimensionArray, 
						(yyvsp[(3) - (7)].s)->Dimensions, 
						(yyvsp[(3) - (7)].s)->Arity * sizeofInt 
					);
					DimensionArray[ (yyvsp[(3) - (7)].s)->Arity ] =
						(yyvsp[(7) - (7)].v.NumElements) / (yyvsp[(3) - (7)].s)->NumElements;
						
					/*
					** Add the new array to the symbol table.
					*/

					InsertSym
					( 
						(yyvsp[(1) - (7)].idStr), 
						(yyvsp[(3) - (7)].s)->Type,
						tArray, 
						cStatic, 
						(yyvsp[(3) - (7)].s)->Arity + 1,
						DimensionArray,
						(yyvsp[(7) - (7)].v.NumElements), 
						NULL,
						GetBaseType( (yyvsp[(3) - (7)].s) )->ObjectSize * (yyvsp[(7) - (7)].v.NumElements),
						0,
						sn,
						(yyvsp[(3) - (7)].s)->Base,
						(yyvsp[(3) - (7)].s)->Fields,
						(yyvsp[(3) - (7)].s)->FieldCnt
					);

				_endif
				
				
				/*
				** Check to see if the TypeID and the ConstOnlyExpr
				** are both arrays and if they are compatible.
				*/

				_if( (yyvsp[(7) - (7)].v.pType) != tArray )

					yyerror( "Expected an array constant as initializer" );

				_else
				
					_if
					( 
						ArraysAreCompatible
						( 
							YYS SymbolTable, 
							YYS &(yyvsp[(7) - (7)].v) 
						)
					)
					
						OutValue( sn, SymbolTable, YYS &(yyvsp[(7) - (7)].v) );

					_else

						yyerror
						( 
							"Array type mismatch or value out of range" 
						);

					_endif


				_endif
				FreeValue( YYS &(yyvsp[(7) - (7)].v) );

			_endif
			_here;
		;}
    break;

  case 1198:

/* Line 1464 of yacc.c  */
#line 56124 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(10) - (10)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(10) - (10)].options.NoStorage) )

				yyerror( "'nostorage' option is illegal here" );

			_endif
			_here;
		;}
    break;

  case 1199:

/* Line 1464 of yacc.c  */
#line 56159 "hlaparse.bsn"
    {				/* $9  */

				int		*DimensionArray;
				int		ArraySize;
				int		Arity;


				assert( (yyvsp[(1) - (8)].s) != NULL );
				assert( (yyvsp[(3) - (8)].s) != NULL );
				assert( (yyvsp[(5) - (8)].v.Dimensions) != NULL );

				_here;
				
				_if( (yyvsp[(5) - (8)].v.NumElements) <= 0 )
				
					yyerror( "Array declaration must have at least one element" );
					(yyvsp[(5) - (8)].v.NumElements) = 1;
				
				_endif
				
				/*
				** Set DimensionArray so that it contains all the
				** dimensions for the declared type (including
				** the dimensions from TypeID if it is an array type).
				*/
				
				_if( (yyvsp[(3) - (8)].s)->pType == tArray )
				
					DimensionArray =
						malloc2
						( 
							((yyvsp[(5) - (8)].v.Arity) + (yyvsp[(3) - (8)].s)->Arity ) * sizeofInt 
						);
						
					memcpy
					( 
						DimensionArray, 
						(yyvsp[(3) - (8)].s)->Dimensions, 
						(yyvsp[(3) - (8)].s)->Arity * sizeofInt 
					);
					memcpy
					(
						&DimensionArray[ (yyvsp[(3) - (8)].s)->Arity ],
						(yyvsp[(5) - (8)].v.Dimensions),
						(yyvsp[(5) - (8)].v.Arity) * sizeofInt 
					);
					ArraySize = (yyvsp[(3) - (8)].s)->NumElements * (yyvsp[(5) - (8)].v.NumElements);
					Arity = (yyvsp[(3) - (8)].s)->Arity + (yyvsp[(5) - (8)].v.Arity);
						
				_else
				
					DimensionArray = malloc2( (yyvsp[(5) - (8)].v.NumElements) * sizeofInt );
					memcpy
					(
						DimensionArray,
						(yyvsp[(5) - (8)].v.Dimensions),
						(yyvsp[(5) - (8)].v.Arity) * sizeofInt 
					);
					ArraySize = (yyvsp[(5) - (8)].v.NumElements);
					Arity = (yyvsp[(5) - (8)].v.Arity);
					
				_endif
				
				/*
				** Make sure this is a legal variable type
				** (e.g., no text variables).
				*/

				_if( CantBeVar( (yyvsp[(3) - (8)].s)->pType ))
				
					yyerror( "Bad static variable type" );
				
				
				/*
				** Make sure the number of elements in the new
				** declared size matches the original.
				*/
				
				_elseif
				( 
						(yyvsp[(1) - (8)].s)->pType != tArray 
					||	(yyvsp[(1) - (8)].s)->NumElements != ArraySize
					||	(yyvsp[(1) - (8)].s)->Arity != Arity 
				)
				
					yyerror
					( 
						"Number of elements does not match original" 
					);
				
				_else
				
				
					_if( (yyvsp[(1) - (8)].s)->IsExternal && (yyvsp[(1) - (8)].s)->SymClass == cStatic )

						(yyvsp[(1) - (8)].s)->IsExternal = 0;
						EmitTypedPublic( (yyvsp[(1) - (8)].s)->StaticName, (yyvsp[(1) - (8)].s)->pType );
						_if
						( 
							ArraysAreCompatible
							( 
								YYS (yyvsp[(1) - (8)].s), 
								YYS &(yyvsp[(8) - (8)].v) 
							)
						)
						
							OutValue( (yyvsp[(1) - (8)].s)->StaticName, (yyvsp[(1) - (8)].s), YYS &(yyvsp[(8) - (8)].v) );

						_else

							yyerror
							( 
								"Array type mismatch or value out of range" 
							);

						_endif


					_else

						ErrorNear
						( 
							"Duplicate symbol definition",
							(yyvsp[(1) - (8)].s)->TrueName,
							__LINE__,
							__FILE__
						);

					_endif

					/*
					** If it's a multidimensional array,
					** free the dimensions array of the constant.
					*/

					FreeValue( YYS &(yyvsp[(5) - (8)].v) );
					free2( vss (yyvsp[(5) - (8)].v.Dimensions) );
					FreeValue( YYS &(yyvsp[(8) - (8)].v) );

				_endif
				_here;
			;}
    break;

  case 1200:

/* Line 1464 of yacc.c  */
#line 56303 "hlaparse.bsn"
    {
				_here;
				CheckLegalOptions
				( 
					(yyvsp[(11) - (11)].options.SpecifiedOptions),
						specified_nostorage
					|	specified_volatile 
				);
				_if( (yyvsp[(11) - (11)].options.NoStorage) )

					yyerror( "'nostorage' option is illegal here" );

				_endif
				_here;
			;}
    break;

  case 1201:

/* Line 1464 of yacc.c  */
#line 56332 "hlaparse.bsn"
    {					/* $6 */

			SymNode_t	*BaseType;
			char		*sn;
			char		StaticName[ 256 ];

			assert( (yyvsp[(1) - (5)].idStr) != NULL );
			assert( (yyvsp[(5) - (5)].neID.idStr) != NULL );

			_here;
			BaseType = (yyvsp[(5) - (5)].neID.s);
			_if( BaseType != NULL )

				BaseType = GetBaseType( BaseType );
				_if( CantBeVar( BaseType->pType ))

					yyerror( "Static/Storage variables cannot be this type" );
					BaseType = &uns32_ste;

				_endif

			_endif

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (5)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );
			InsertSym
			( 
				(yyvsp[(1) - (5)].idStr),			/* Name			*/
				&pointer_ste,		/* Type			*/
				tPointer, 			/* pType		*/
				cStatic,			/* SymClass		*/ 
				0,					/* Arity		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				4,					/* ObjectSize	*/
				0,					/* CurOffset	*/
				sn,					/* StaticName	*/
				BaseType,			/* BaseType		*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);
			(yyval.s) = SymbolTable;
			_here;
		;}
    break;

  case 1202:

/* Line 1464 of yacc.c  */
#line 56380 "hlaparse.bsn"
    {

			_here;
			CheckLegalOptions
			( 
				(yyvsp[(8) - (9)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(9) - (9)].returns) != NULL && (yyvsp[(8) - (9)].options.NoStorage) )

				yyerror
				(
					"Can't specify both 'NOSTORAGE' and 'EXTERNAL' options"
				);

			_endif
			_if( (yyvsp[(9) - (9)].returns) == NULL )
			 
				EmitTypedLabel( (yyvsp[(6) - (9)].s)->StaticName, tDWord );
				_if( !(yyvsp[(8) - (9)].options.NoStorage) )

					EmitDword( );

				_endif

			_else

				SymbolTable->IsExternal = 1;
				_if( *(yyvsp[(9) - (9)].returns) == '\0' )

					free2( vss SymbolTable->StaticName );
					SymbolTable->StaticName = hlastrdup2( (yyvsp[(1) - (9)].idStr) );

				_else

					free2( vss SymbolTable->StaticName );
					SymbolTable->StaticName = hlastrdup2( (yyvsp[(9) - (9)].returns) );

				_endif
				EmitTypedExtern
				( 
					SymbolTable, 
					SymbolTable->StaticName, 
					tDWord 
				);

			_endif
			free2( vss (yyvsp[(9) - (9)].returns) );


			_if( SymbolTable->Base == NULL )

				Add2PtrList( SymbolTable, (yyvsp[(5) - (9)].neID.idStr) );

			_endif
			_here;
		;}
    break;

  case 1203:

/* Line 1464 of yacc.c  */
#line 56454 "hlaparse.bsn"
    {					/* $8 */

			SymNode_t *BaseType;
	
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(7) - (7)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			BaseType = (yyvsp[(5) - (7)].neID.s);
			_if( BaseType != NULL )

				BaseType = GetBaseType( BaseType );
				_if( CantBeVar( BaseType->pType ))

					yyerror( "Static/Storage variables cannot be this type" );
					BaseType = &uns32_ste;

				_endif

			_endif
			_if( (yyvsp[(1) - (7)].s)->IsExternal && (yyvsp[(1) - (7)].s)->SymClass == cStatic )

				_if( (yyvsp[(1) - (7)].s)->Type == &pointer_ste && (yyvsp[(1) - (7)].s)->Base == BaseType ) 

					(yyvsp[(1) - (7)].s)->IsExternal = 0;
					EmitTypedPublic( (yyvsp[(1) - (7)].s)->StaticName, (yyvsp[(1) - (7)].s)->pType );
					EmitTypedLabel( (yyvsp[(1) - (7)].s)->StaticName, tDWord );
					_if( !(yyvsp[(7) - (7)].options.NoStorage) )

						EmitDword( );

					_endif

				_else

					ErrorNear
					(
						"External base type must match declared base type",
						(yyvsp[(5) - (7)].neID.idStr),
						__LINE__,
						__FILE__
					);

				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif


			_if( BaseType == NULL )

				Add2PtrList( (yyvsp[(1) - (7)].s), (yyvsp[(5) - (7)].neID.idStr) );

			_endif

			free2( vss (yyvsp[(5) - (7)].neID.idStr) );
			_here;
		;}
    break;

  case 1204:

/* Line 1464 of yacc.c  */
#line 56538 "hlaparse.bsn"
    {					/* $6 */

			SymNode_t *BaseType;
			char	  *sn;
			char	  StaticName[ 256 ];

			assert( (yyvsp[(1) - (5)].idStr) != NULL );

			_here;
			BaseType = (yyvsp[(5) - (5)].s);
			_if( CantBeVar( BaseType->pType ))

				yyerror( "Static/Storage variables cannot be this type" );
				BaseType = &uns32_ste;

			_endif

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (5)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );
			InsertSym
			( 
				(yyvsp[(1) - (5)].idStr),			/* Name			*/
				&pointer_ste,		/* Type			*/
				tPointer, 			/* pType		*/
				cStatic,			/* SymClass		*/ 
				0,					/* Arity		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				4,					/* ObjectSize	*/
				0,					/* CurOffset	*/
				sn,					/* StaticName	*/
				BaseType,			/* BaseType		*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);
			(yyval.s) = SymbolTable;
			_here;

		;}
    break;

  case 1205:

/* Line 1464 of yacc.c  */
#line 56581 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(8) - (9)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(9) - (9)].returns) != NULL && (yyvsp[(8) - (9)].options.NoStorage) )

				yyerror
				(
					"Can't specify both 'NOSTORAGE' and 'EXTERNAL' options"
				);

			_endif
			_if( (yyvsp[(9) - (9)].returns) == NULL )
			 
				EmitTypedLabel( (yyvsp[(6) - (9)].s)->StaticName, tDWord );
				_if( !(yyvsp[(8) - (9)].options.NoStorage) )

					EmitDword( );

				_endif

			_else

				SymbolTable->IsExternal = 1;
				_if( *(yyvsp[(9) - (9)].returns) == '\0' )

					free2( vss SymbolTable->StaticName );
					SymbolTable->StaticName = hlastrdup2( (yyvsp[(1) - (9)].idStr) );

				_else

					free2( vss SymbolTable->StaticName );
					SymbolTable->StaticName = hlastrdup2( (yyvsp[(9) - (9)].returns) );

				_endif
				EmitTypedExtern
				( 
					SymbolTable,
					SymbolTable->StaticName, 
					tDWord 
				);

			_endif
			free2( vss (yyvsp[(9) - (9)].returns) );
			_here;
		;}
    break;

  case 1206:

/* Line 1464 of yacc.c  */
#line 56649 "hlaparse.bsn"
    {					/* $4 */

			char			StaticName[ 1024 ];
			char 			*sn;
			/* SymNode_t *bt;*/


			assert( (yyvsp[(1) - (3)].idStr) != NULL );
			assert( (yyvsp[(3) - (3)].s) != NULL );

			_here;

			/*bt = GetBaseType( $<s>3 );*/

			_if( CantBeVar( (yyvsp[(3) - (3)].s)->pType ))

				yyerror( "Static/Storage variables cannot be this type" );

			_else
			
				sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (3)].idStr), LblCntr++ );
				sn = hlastrdup2( StaticName );
				InsertSym
				( 
					(yyvsp[(1) - (3)].idStr), 
					(yyvsp[(3) - (3)].s),
					(yyvsp[(3) - (3)].s)->pType, 
					cStatic, 
					(yyvsp[(3) - (3)].s)->Arity,
					(yyvsp[(3) - (3)].s)->Dimensions,
					(yyvsp[(3) - (3)].s)->NumElements, 
					NULL,
					(yyvsp[(3) - (3)].s)->ObjectSize,
					0,
					sn,
					(yyvsp[(3) - (3)].s)->Base,
					(yyvsp[(3) - (3)].s)->Fields,
					(yyvsp[(3) - (3)].s)->FieldCnt
				);
				(yyval.idStr) = sn;
				
			_endif
			_here;
		;}
    break;

  case 1207:

/* Line 1464 of yacc.c  */
#line 56696 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(6) - (7)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(7) - (7)].returns) != NULL && (yyvsp[(6) - (7)].options.NoStorage) )

				yyerror
				(
					"Can't specify both 'NOSTORAGE' and 'EXTERNAL' options"
				);

			_endif
			_if( !CantBeVar( (yyvsp[(3) - (7)].s)->pType ))
			
				_if( (yyvsp[(3) - (7)].s)->pType == tProcptr )
				
					// Copy parameter info if a proc ptr.
					
					memcpy( &SymbolTable->u, &(yyvsp[(3) - (7)].s)->u, sizeofValuesSize);
					
				_endif


				// If this is an external declaration,
				// output an externdef statement to the ASM file.

				_if( (yyvsp[(7) - (7)].returns) != NULL )
				 
					SymbolTable->IsExternal = 1;
					_if( *(yyvsp[(7) - (7)].returns) == '\0' )

						free2( vss SymbolTable->StaticName );
						SymbolTable->StaticName = hlastrdup2( (yyvsp[(1) - (7)].idStr) );

					_else

						free2( vss SymbolTable->StaticName );
						SymbolTable->StaticName = hlastrdup2( (yyvsp[(7) - (7)].returns) );

					_endif
					EmitExtern( SymbolTable, (yyvsp[(3) - (7)].s)->ObjectSize );


				_else


					/*
					** If this is a class object, we need to duplicate
					** all the fields to all private constants, etc.
					*/

					
					_if( (yyvsp[(3) - (7)].s)->pType == tClass )

						SymbolTable->Fields = 
							CopySymbols
							( 
								(yyvsp[(3) - (7)].s)->Fields,
								(yyvsp[(4) - (7)].idStr)
							);
						NullTerminate( SymbolTable->Fields, SymbolTable );

					_elseif(  (yyvsp[(3) - (7)].s)->pType == tThunk )

						/*
						** Need some dummy local vars for a thunk.
						*/

						SymbolTable->u.proc.parms = &true_ste;

					_endif

					_if( !(yyvsp[(6) - (7)].options.NoStorage) )

						_if( IsPrimitive( (yyvsp[(3) - (7)].s)->pType ) )
						
							ReserveTypedStorage( (yyvsp[(4) - (7)].idStr), (yyvsp[(3) - (7)].s), 1 );

						_elseif
						( 
								(yyvsp[(3) - (7)].s)->pType == tPointer
							||	(yyvsp[(3) - (7)].s)->pType == tProcptr
						)
						
							ReserveTypedStorage( (yyvsp[(4) - (7)].idStr), &dword_ste, 1 );
						
						_else
  
							ReserveUntypedStorage( (yyvsp[(4) - (7)].idStr), (yyvsp[(3) - (7)].s)->ObjectSize );

						_endif

					_else // Nostorage active

						_if
						( 
								(yyvsp[(3) - (7)].s)->pType == tPointer
							||	(yyvsp[(3) - (7)].s)->pType == tProcptr
						)
						
							EmitTypedLabel( (yyvsp[(4) - (7)].idStr), tDWord );
							
						
						_elseif( IsPrimitive( (yyvsp[(3) - (7)].s)->pType ))

							EmitTypedLabel( (yyvsp[(4) - (7)].idStr), (yyvsp[(3) - (7)].s)->pType );

						_elseif
						( 
								(yyvsp[(3) - (7)].s)->pType == tPointer
							||	(yyvsp[(3) - (7)].s)->pType == tProcptr
						)
						
							EmitTypedLabel( (yyvsp[(4) - (7)].idStr), tDWord );
							
						_else

							EmitTypedLabel( (yyvsp[(4) - (7)].idStr), tByte );

						_endif

					_endif

				_endif

			_endif
			free2( vss (yyvsp[(7) - (7)].returns) );
			_here;
		;}
    break;

  case 1208:

/* Line 1464 of yacc.c  */
#line 56847 "hlaparse.bsn"
    {					/* $6 */

			SymNode_t *BaseType;

			assert( (yyvsp[(1) - (5)].s) != NULL );
			assert( (yyvsp[(3) - (5)].s) != NULL );

			_here;
			CheckLegalOptions
			( 
				(yyvsp[(5) - (5)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			BaseType = GetBaseType( (yyvsp[(3) - (5)].s) );

			_if( CantBeVar( BaseType->pType ))

				yyerror( "Static/Storage variables cannot be this type" );
				BaseType = &uns32_ste;

			_elseif( (yyvsp[(1) - (5)].s)->IsExternal && (yyvsp[(1) - (5)].s)->SymClass == cStatic )

				(yyvsp[(1) - (5)].s)->IsExternal = 0;
				EmitTypedPublic( (yyvsp[(1) - (5)].s)->StaticName, (yyvsp[(1) - (5)].s)->pType );
				_if( !(yyvsp[(5) - (5)].options.NoStorage) )
				
					_if( IsPrimitive( (yyvsp[(3) - (5)].s)->pType ))
					
						ReserveTypedStorage( (yyvsp[(1) - (5)].s)->StaticName, (yyvsp[(3) - (5)].s), 1 );
						
					_else
					
						ReserveUntypedStorage
						( 
							(yyvsp[(1) - (5)].s)->StaticName,
							_ifx
							( 
								(yyvsp[(3) - (5)].s)->pType != tArray || (yyvsp[(1) - (5)].s)->NumElements == 0, 
								(yyvsp[(3) - (5)].s)->ObjectSize, 
								(yyvsp[(1) - (5)].s)->NumElements * (yyvsp[(3) - (5)].s)->ObjectSize 
							)
						);
						
					_endif

				_else
				
					EmitTypedLabel
					( 
						(yyvsp[(1) - (5)].s)->StaticName, 
						_ifx( (yyvsp[(1) - (5)].s)->StaticName ,(yyvsp[(3) - (5)].s)->pType, tByte )
					);
				
				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (5)].s)->TrueName,
					__LINE__,
					__FILE__
				);
				exit( 1 );

			_endif
			_here;
		;}
    break;

  case 1209:

/* Line 1464 of yacc.c  */
#line 56934 "hlaparse.bsn"
    {					/* $7 */					

			int		*DimensionArray;
			int		ArraySize;
			char	*sn;
			char	StaticName[ 1024 ];


			assert( (yyvsp[(1) - (6)].idStr) != NULL );
			assert( (yyvsp[(3) - (6)].s) != NULL );
			assert( (yyvsp[(5) - (6)].v.Dimensions) != NULL );

			_here;

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (6)].idStr), LblCntr++ );


			_if( (yyvsp[(5) - (6)].v.NumElements) <= 0 )
			
				yyerror( "Array declaration must have at least one element" );
				(yyvsp[(5) - (6)].v.NumElements) = 1;
			
			_endif
			 
			/*
			** Make sure this is a legal variable type
			** (e.g., no text variables).
			*/

			(yyval.s) = NULL;
			
			_if( CantBeVar( (yyvsp[(3) - (6)].s)->pType ))
			
				yyerror( "Illegal static/storage variable type" );
				
			_else 
			
				/*
				** Check to see if this is an external declaration.
				*/


				/*
				** Check to see if TypeID is an array type
				** (i.e., we're creating a multi-dimensional array).
				*/

				_if( (yyvsp[(3) - (6)].s)->pType != tArray )

					/*
					** TypeID is *not* an array type, so create
					** a single dimension array here.
					*/

					ArraySize = (yyvsp[(3) - (6)].s)->ObjectSize * (yyvsp[(5) - (6)].v.NumElements);
					sn = hlastrdup2( StaticName );
					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr), 
						(yyvsp[(3) - (6)].s),
						tArray, 
						cStatic, 
						(yyvsp[(5) - (6)].v.Arity),
						(yyvsp[(5) - (6)].v.Dimensions),
						(yyvsp[(5) - (6)].v.NumElements), 
						NULL,
						ArraySize,
						0,
						sn,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);




				/*
				** Okay, down here TypeID *is* an array type,
				** so we're creating a multi-dimensional array.
				*/

				_else

					SymNode_t *BaseType;

					assert( (yyvsp[(3) - (6)].s)->Dimensions != NULL );

					/*
					** Create the new dimension array by concatenating
					** the two existing dimension arrays.
					*/

					DimensionArray = 
						malloc2
						( 
							( (yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.NumElements) ) * 
								sizeofInt 
						);

					memcpy
					( 
						DimensionArray, 
						(yyvsp[(3) - (6)].s)->Dimensions, 
						(yyvsp[(3) - (6)].s)->Arity * sizeofInt 
					);
					memcpy
					(
						&DimensionArray[ (yyvsp[(3) - (6)].s)->Arity ],
						(yyvsp[(5) - (6)].v.Dimensions),
						(yyvsp[(5) - (6)].v.Arity) * sizeofInt 
					);
					ArraySize = (yyvsp[(3) - (6)].s)->ObjectSize * (yyvsp[(5) - (6)].v.NumElements);

					/*
					** Add the new array to the symbol table.
					*/

					sn = hlastrdup2( StaticName );
					InsertSym
					( 
						(yyvsp[(1) - (6)].idStr), 
						(yyvsp[(3) - (6)].s),
						tArray, 
						cStatic, 
						(yyvsp[(3) - (6)].s)->Arity + (yyvsp[(5) - (6)].v.Arity),
						DimensionArray,
						(yyvsp[(3) - (6)].s)->NumElements * (yyvsp[(5) - (6)].v.NumElements), 
						NULL,
						ArraySize,
						0,
						sn,
						(yyvsp[(3) - (6)].s)->Base,
						(yyvsp[(3) - (6)].s)->Fields,
						(yyvsp[(3) - (6)].s)->FieldCnt
					);

				_endif
				(yyval.s) = SymbolTable;

			_endif
			_here;
		;}
    break;

  case 1210:

/* Line 1464 of yacc.c  */
#line 57080 "hlaparse.bsn"
    {
		
			SymNode_t *bt;

			_here;
			CheckLegalOptions
			( 
				(yyvsp[(9) - (10)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(10) - (10)].returns) != NULL && (yyvsp[(9) - (10)].options.NoStorage) )

				yyerror
				(
					"Can't specify both 'NOSTORAGE' and 'EXTERNAL' options"
				);

			_endif
			_if( !CantBeVar( (yyvsp[(3) - (10)].s)->pType ))
			
				bt = GetBaseType( (yyvsp[(3) - (10)].s) );
			
				/*
				** Check to see if TypeID is an array type
				** (i.e., we're creating a multi-dimensional array).
				*/

				_if( (yyvsp[(3) - (10)].s)->pType != tArray )

					/*
					** If this is a class object, we need to duplicate
					** all the fields to all private constants, etc.
					*/

					_if( (yyvsp[(3) - (10)].s)->pType == tClass )

						SymbolTable->Fields = 
							CopySymbols
							( 
								(yyvsp[(3) - (10)].s)->Fields,
								(yyvsp[(3) - (10)].s)->StaticName
							);
						NullTerminate( SymbolTable->Fields, SymbolTable );

						/*
						** Check to see if this class object is external.
						*/

						_if( (yyvsp[(10) - (10)].returns) != NULL )
						 
							SymbolTable->IsExternal = 1;
							_if( *(yyvsp[(10) - (10)].returns) == '\0' )

								free2( vss SymbolTable->StaticName );
								SymbolTable->StaticName = 
									hlastrdup2( (yyvsp[(1) - (10)].idStr) );

							_else

								free2( vss SymbolTable->StaticName );
								SymbolTable->StaticName = 
									hlastrdup2( (yyvsp[(10) - (10)].returns) );

							_endif
							EmitExtern
							( 
								SymbolTable,
								bt->ObjectSize 
							);  


						_else /* No External Clause */
						
							_if( (yyvsp[(9) - (10)].options.NoStorage) )
							
								EmitTypedLabel
								( 
									(yyvsp[(7) - (10)].s)->StaticName, 
									_ifx
									(
										IsPrimitive( (yyvsp[(3) - (10)].s)->pType ),
										(yyvsp[(3) - (10)].s)->pType,
										tByte
									) 
								);
								
							_else

								_if( IsPrimitive( (yyvsp[(3) - (10)].s)->pType ) )
								
									ReserveTypedStorage
									(
										(yyvsp[(7) - (10)].s)->StaticName,
										(yyvsp[(3) - (10)].s),
										(yyvsp[(5) - (10)].v.NumElements)
									);
										
								_else
								
									ReserveUntypedStorage
									(
										(yyvsp[(7) - (10)].s)->StaticName, 
										(yyvsp[(3) - (10)].s)->ObjectSize*(yyvsp[(5) - (10)].v.NumElements) 
									);

								_endif

							_endif
							
						_endif
							
					_else
					
						_if(  (yyvsp[(3) - (10)].s)->pType == tThunk )

							/*
							** Need some dummy local vars for a thunk.
							*/

							SymbolTable->u.proc.parms = &true_ste;

						_endif

						/*
						** Check to see if this array object
						** is external.
						*/

						_if( (yyvsp[(10) - (10)].returns) != NULL )
						 
							SymbolTable->IsExternal = 1;
							_if( *(yyvsp[(10) - (10)].returns) != '\0' )

								free2( vss SymbolTable->StaticName );
								SymbolTable->StaticName = 
									hlastrdup2( (yyvsp[(10) - (10)].returns) );

							_else

								free2( vss SymbolTable->StaticName );
								SymbolTable->StaticName =
									hlastrdup2( SymbolTable->TrueName );

							_endif
							EmitExtern
							( 
								SymbolTable,
								bt->ObjectSize 
							);  


						_else /* No External Clause */

							_if( (yyvsp[(9) - (10)].options.NoStorage) )
									
								EmitTypedLabel
								( 
									(yyvsp[(7) - (10)].s)->StaticName, 
									_ifx
									( 
										IsPrimitive( (yyvsp[(3) - (10)].s)->pType ), 
										(yyvsp[(3) - (10)].s)->pType, 
										tByte
									) 
								);
								
							_else

								_if( IsPrimitive( (yyvsp[(3) - (10)].s)->pType ) )
								
									ReserveTypedStorage
									(
										(yyvsp[(7) - (10)].s)->StaticName,
										(yyvsp[(3) - (10)].s), 
										(yyvsp[(5) - (10)].v.NumElements) 
									);
								
								_elseif
								( 
										(yyvsp[(3) - (10)].s)->pType == tPointer 	
									||	(yyvsp[(3) - (10)].s)->pType == tProcptr
								) 	
								
									ReserveTypedStorage
									(
										(yyvsp[(7) - (10)].s)->StaticName,
										&dword_ste, 
										(yyvsp[(5) - (10)].v.NumElements) 
									);
								
								_else
								
									ReserveUntypedStorage
									(
										(yyvsp[(7) - (10)].s)->StaticName,
										(yyvsp[(5) - (10)].v.NumElements) * (yyvsp[(3) - (10)].s)->ObjectSize
									);
									
								_endif

							_endif
							
						_endif  

					_endif



				/*
				** Okay, down here TypeID *is* an array type,
				** so we're creating a multi-dimensional array.
				*/

				_else


					assert( (yyvsp[(3) - (10)].s)->Dimensions != NULL );


					/*
					** If this is a class object, we need to duplicate
					** all the fields to all private constants, etc.
					*/

					
					_if( SymbolTable->Type->pType == tClass )

						int ThisObjSize;

						SymbolTable->Fields = 
							CopySymbols
							( 
								bt->Fields,
								bt->StaticName
							);
						NullTerminate( SymbolTable->Fields, SymbolTable );

						/*
						** See if it's an external array of classes
						** declaration.
						*/

						_if( (yyvsp[(10) - (10)].returns) != NULL )
						 
							SymbolTable->IsExternal = 1;
							_if( *(yyvsp[(10) - (10)].returns) == '\0' )

								free2( vss SymbolTable->StaticName );
								SymbolTable->StaticName = 
									hlastrdup2( (yyvsp[(1) - (10)].idStr) );

							_else

								free2( vss SymbolTable->StaticName );
								SymbolTable->StaticName = 
									hlastrdup2( (yyvsp[(10) - (10)].returns) );

							_endif

							EmitTypedExtern
							( 
								SymbolTable,
								SymbolTable->StaticName, 
								tDWord 
							);


						_else /* No External Clause */

							ThisObjSize = (yyvsp[(3) - (10)].s)->ObjectSize;
							EmitTypedLabel
							( 
								(yyvsp[(7) - (10)].s)->StaticName, 
								_ifx
								( 
									IsPrimitive( (yyvsp[(3) - (10)].s)->pType ), 
									(yyvsp[(3) - (10)].s)->pType, 
									tByte
								) 
							);
							_if( !(yyvsp[(9) - (10)].options.NoStorage) )

								ReserveStorage
								( 
									ThisObjSize 
								);

							_endif

						_endif

					_else
					
						_if(  SymbolTable->Type->pType == tThunk )

							/*
							** Need some dummy local vars for a thunk.
							*/

							SymbolTable->u.proc.parms = &true_ste;

						_endif

						
						/*
						** Deal with other array types here.
						** First, see if this is an external declaration.
						*/

						_if( (yyvsp[(10) - (10)].returns) != NULL )
						 
							SymbolTable->IsExternal = 1;
							_if( *(yyvsp[(10) - (10)].returns) == '\0' )

								free2( vss SymbolTable->StaticName );
								SymbolTable->StaticName = 
									hlastrdup2( (yyvsp[(1) - (10)].idStr) );

							_else

								free2( vss SymbolTable->StaticName );
								SymbolTable->StaticName = 
									hlastrdup2( (yyvsp[(10) - (10)].returns) );

							_endif
							EmitExtern( SymbolTable, bt->ObjectSize );


						_else /* No External Clause */

							EmitTypedLabel
							( 
								(yyvsp[(7) - (10)].s)->StaticName, 
								_ifx
								( 
									IsPrimitive( (yyvsp[(3) - (10)].s)->pType ), 
									(yyvsp[(3) - (10)].s)->pType, 
									tByte
								) 
							);
							_if( !(yyvsp[(9) - (10)].options.NoStorage) )

								ReserveStorage
								( 
									(yyvsp[(7) - (10)].s)->ObjectSize 
								);

							_endif
							
						_endif 

					_endif
					free2( vss (yyvsp[(5) - (10)].v.Dimensions) );

				_endif

			_endif
			free2( vss (yyvsp[(10) - (10)].returns) );
			_here;
		;}
    break;

  case 1211:

/* Line 1464 of yacc.c  */
#line 57460 "hlaparse.bsn"
    {				/* $9 */

			int			*DimensionArray;
			int			ArraySize;
			SymNode_t	*bt;

			_here;
			assert( (yyvsp[(1) - (8)].s) != NULL );
			assert( (yyvsp[(3) - (8)].s) != NULL );
			assert( (yyvsp[(5) - (8)].v.Dimensions) != NULL );

			CheckLegalOptions
			( 
				(yyvsp[(8) - (8)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			bt = GetBaseType( (yyvsp[(3) - (8)].s) );

			_if( (yyvsp[(5) - (8)].v.NumElements) <= 0 )
			
				yyerror( "Array declaration must have at least one element" );
				(yyvsp[(5) - (8)].v.NumElements) = 1;
			
			_endif

			/*
			** Make sure this is a legal variable type
			** (e.g., no text variables).
			*/

			_if( CantBeVar( (yyvsp[(3) - (8)].s)->pType ))
			
				yyerror( "Illegal static variable type" );
				
			_else 
			
				_if( (yyvsp[(1) - (8)].s)->IsExternal && (yyvsp[(1) - (8)].s)->SymClass == cStatic )

					char *theType;

					(yyvsp[(1) - (8)].s)->IsExternal = 0;
					EmitTypedPublic( (yyvsp[(1) - (8)].s)->StaticName, (yyvsp[(1) - (8)].s)->pType );
					EmitTypedLabel
					( 
						(yyvsp[(1) - (8)].s)->StaticName, 
						_ifx
						(
							IsPrimitive( bt->pType ),
							bt->pType,
							tByte
						)
					);
					_if( !(yyvsp[(8) - (8)].options.NoStorage) )

						ReserveStorage
						( 
							(yyvsp[(1) - (8)].s)->ObjectSize 
						);

					_endif
						
					_if
					(
							(yyvsp[(1) - (8)].s)->ObjectSize
						!=	(yyvsp[(3) - (8)].s)->ObjectSize * (yyvsp[(5) - (8)].v.NumElements)
					)

						WarnNear
						( 
							"Declared size does not match external size",
							(yyvsp[(1) - (8)].s)->TrueName 
						);

					_endif

				_else

					ErrorNear
					( 
						"Duplicate symbol definition",
						(yyvsp[(1) - (8)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif


			_endif
			free2( vss (yyvsp[(5) - (8)].v.Dimensions) );
			_here;
		;}
    break;

  case 1212:

/* Line 1464 of yacc.c  */
#line 57572 "hlaparse.bsn"
    {
				SymNode_t *Fields;
				SymNode_t *CurSym;
				int		  RecSize;
				int		  FieldCnt;
				int		  LargestField;
				char	  StaticName[ 256 ];


				/*
				** Restore currentNS before we enter this record
				** type into the symbol table.
				*/
				
				_here;
				currentNS = (yyvsp[(3) - (8)].ru.saveCurNS);
				RecNS = (yyvsp[(3) - (8)].ru.saveRecNS);
				RecGlobal = (yyvsp[(3) - (8)].ru.saveRecGlobal);

				/*
				** If CurOffset is zero at this point then there
				** weren't any fields in the record.  Records must
				** have at least one field.
				*/

				_if( RecFieldCnt != 0 )


					/*
					** If there is no base record, we need to mark
					** the end of the fields symbol list.  If there is
					** a base record, then that base record definition will
					** mark the end of our list.  In either case, we
					** need to count the number of fields in the record.
					*/
					
					FieldCnt = 0;
					CurSym = SymbolTable;
					LargestField = 0;
					_while
					( 
							CurSym->Next != NULL 
						&&	CurSym->Next != &dummyField_ste 
					)

						LargestField = 
							max( LargestField, CurSym->MaxObjectSize );
							
						++FieldCnt;
						CurSym = CurSym->Next;

					_endwhile
					LargestField = 
						max( LargestField, CurSym->MaxObjectSize );

					CurSym->Next = NULL;

					/*
					** Okay, create the record symbol table entry
					** and attach the fields symbol table to that entry.
					*/

					CurLexLevel = (yyvsp[(3) - (8)].ru.SaveLex);	
					Fields = SymbolTable;			
					SymbolTable = (yyvsp[(3) - (8)].ru.endFields);		
					CurOffset = AlignVarOffset( CurOffset, 1, 1 );
					RecSize = CurOffset - (yyvsp[(3) - (8)].ru.CurOffset);			

					/*
					** If there was an align at the end of the
					** record, then we need to extend the size
					** of the record so that it is aligned on
					** the specified boundary.
					*/

					_if( TempRecAlign != 1 )
					

						RecSize = 
								(
										(RecSize + TempRecAlign - 1) 
									/ 	TempRecAlign 
								) * TempRecAlign;
								
						TempRecAlign = 1;

					_endif
					
					
					CurOffset = (yyvsp[(3) - (8)].ru.SaveOffset);		
					CurOffsetDir = (yyvsp[(3) - (8)].ru.SaveDir);	
					AddOffset1st = (yyvsp[(3) - (8)].ru.SaveAdd1st);	

					sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (8)].idStr), LblCntr++ );
					InsertSym
					(
						(yyvsp[(1) - (8)].idStr),
						(yyvsp[(3) - (8)].ru.base),
						tRecord,
						cStatic,
						0,
						NULL,
						0,
						NULL,
						RecSize,
						0,
						hlastrdup2( StaticName ),
						(yyvsp[(3) - (8)].ru.base),
						Fields,
						FieldCnt
					);
					SymbolTable->MaxObjectSize = LargestField;
					
					// Now we need to go through all the fields and
					// patch the "Parent" field to point at this
					// symbol table entry.
					
					_for( int fieldCntr = 0, fieldCntr < FieldCnt, ++fieldCntr )
					
						Fields->Parent = SymbolTable;
						Fields = Fields->Next;
						
					_endfor
					
					// Okay, reserve storage for this static object.
					
					ReserveUntypedStorage( StaticName, RecSize );
					

				_else

					yyerror
					( 
						"Record variables must have at least one field" 
					);

				_endif
				inRecord = (yyvsp[(3) - (8)].ru.inSave);
				MinRecAlignment = (yyvsp[(3) - (8)].ru.MinRecAlignment);
				MaxRecAlignment = (yyvsp[(3) - (8)].ru.MaxRecAlignment);
				RecFieldCnt = (yyvsp[(3) - (8)].ru.RecFieldCnt);
				_here;
			;}
    break;

  case 1213:

/* Line 1464 of yacc.c  */
#line 57734 "hlaparse.bsn"
    {
				_here;
				assert( (yyvsp[(1) - (7)].idStr) != NULL );

				(yyval.s) = SymbolTable;
				CurOffset = 0;
				CurOffsetDir = 0;	/* Forces all fields to the same offset */
				AddOffset1st = 0;

			;}
    break;

  case 1214:

/* Line 1464 of yacc.c  */
#line 57747 "hlaparse.bsn"
    {
				int				SizeOfUnion;
				int				FieldCnt;
				SymNode_t		*Fields;
				SymNode_t		*CurSym;
				SymNode_t		*LastSym;

				/*
				** Determine if there were any fields in the union.
				** Error if not.
				*/

				_if( SymbolTable == (yyvsp[(8) - (11)].s) )

					ErrorNear
					( 
						"Unions must have at least one field",
						"endunion",
						__LINE__,
						__FILE__ 
					);

				_else

					char	StaticName[ 256 ];

					/*
					** Null terminate the list of fields in the union.
					** Search for the saved symbol table entry which
					** marks the first entry that is not a field.  Upon
					** finding that entry, store a NULL in the previous
					** link field.
					*/

					CurSym = SymbolTable;
					SizeOfUnion = 0;
					FieldCnt = 0;
					_while( CurSym != (yyvsp[(8) - (11)].s) )

						SizeOfUnion = 
							max( SizeOfUnion, CurSym->ObjectSize);
						
						LastSym =  CurSym;
						CurSym = CurSym->Next;
						++FieldCnt;

					_endwhile
					LastSym->Next = NULL;


					/*
					** Restore all the compiler variables and set
					** up Fields so we can enter the union variable
					** into the symbol table.
					*/

					CurLexLevel = (yyvsp[(6) - (11)].v.u.intval);
					Fields = SymbolTable;
					SymbolTable = (yyvsp[(8) - (11)].s);
					CurOffset = (yyvsp[(3) - (11)].v.u.intval);
					CurOffsetDir = (yyvsp[(4) - (11)].v.u.intval);
					AddOffset1st = (yyvsp[(5) - (11)].v.u.unsval);

					sprintf( StaticName, "%s" sympost "%d", (yyvsp[(1) - (11)].idStr), LblCntr++ );
					InsertSym
					(
						(yyvsp[(1) - (11)].idStr),
						NULL,
						tUnion,
						cStatic,
						0,
						NULL,
						0,
						NULL,
						SizeOfUnion,
						0,
						hlastrdup2( StaticName ),
						NULL,
						Fields,
						FieldCnt
					);
					ReserveUntypedStorage( StaticName, SizeOfUnion );

				_endif
				_here;
			;}
    break;

  case 1215:

/* Line 1464 of yacc.c  */
#line 57850 "hlaparse.bsn"
    {
			_here;
			inStatic = (yyvsp[(1) - (5)].i);
		;}
    break;

  case 1216:

/* Line 1464 of yacc.c  */
#line 57859 "hlaparse.bsn"
    {
			_here;
			(yyval.i) = inStatic;
			inStatic = 1;
		;}
    break;

  case 1217:

/* Line 1464 of yacc.c  */
#line 57867 "hlaparse.bsn"
    {
			_here;
			startDseg();
		;}
    break;

  case 1218:

/* Line 1464 of yacc.c  */
#line 57874 "hlaparse.bsn"
    {
			_here;
			endDseg();
			_here;
		;}
    break;

  case 1219:

/* Line 1464 of yacc.c  */
#line 57882 "hlaparse.bsn"
    { _here; ;}
    break;

  case 1220:

/* Line 1464 of yacc.c  */
#line 57887 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					IsNumber( (yyvsp[(2) - (3)].v.pType) )
				&&	numBits32( YYS &(yyvsp[(2) - (3)].v) ) <= 32 
				&&	(
							(yyvsp[(2) - (3)].v.u.unsval) == 1
						||	(yyvsp[(2) - (3)].v.u.unsval) == 2
						||	(yyvsp[(2) - (3)].v.u.unsval) == 4
						||	(yyvsp[(2) - (3)].v.u.unsval) == 8
						||	(yyvsp[(2) - (3)].v.u.unsval) == 16
					)
			)

				EmitAlign( (yyvsp[(2) - (3)].v.u.unsval) );

			_else

				yyerror
				( 
					"Expected the constant 1, 2, 4, 8, or 16 here" 
				);

			_endif
			FreeValue( YYS &(yyvsp[(2) - (3)].v.u.unsval) );
			_here;
		;}
    break;

  case 1223:

/* Line 1464 of yacc.c  */
#line 57943 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].s)->pType == tClass )

				/*
				** Okay, build the Virtual Method Table for
				** this class and adjust the offsets for each
				** of the methods to reflect the index into the
				** VMT.
				*/

				_if( (yyvsp[(6) - (6)].returns) == NULL )  // No "@external" on VMT.
				
					BuildVMT( (yyvsp[(3) - (6)].s), (yyvsp[(3) - (6)].s)->StaticName, NULL );
					extLookup
					( 
						(yyvsp[(3) - (6)].s), 				  // sym,
						(yyvsp[(3) - (6)].s)->StaticName, 	  // theLabel, 
						tDWord, 			  // theType, 
						1, 					  // IsPublic,
						1, 					  // ForceRef,
						1 					  // isVMT 
					);
					
				_elseif( *(yyvsp[(6) - (6)].returns) == '\0' ) // @external;
				
					extLookup
					( 
						(yyvsp[(3) - (6)].s), 				  // sym,
						(yyvsp[(3) - (6)].s)->StaticName, 	  // theLabel, 
						tDWord, 			  // theType, 
						0, 					  // IsPublic,
						0, 					  // ForceRef,
						1 					  // isVMT 
					);
				
				_else		// @external( "some_name" );

					extLookup
					( 
						(yyvsp[(3) - (6)].s), 				  // sym,
						(yyvsp[(6) - (6)].returns),	 	  // theLabel, 
						tDWord, 			  // theType, 
						0, 					  // IsPublic,
						0, 					  // ForceRef,
						1 					  // isVMT 
					);
				
				_endif

			_else

				yyerror( "Expected a class type identifier" );

			_endif
			_here;
		;}
    break;

  case 1224:

/* Line 1464 of yacc.c  */
#line 58009 "hlaparse.bsn"
    {
			char 		*sn;
			SymNode_t	*sym;

			/*
			** Okay, the user wants to attach a label to this VMT.
			** Automatically make it public.
			*/

			_here;
			_if( (yyvsp[(8) - (8)].returns) == NULL || *(yyvsp[(8) - (8)].returns) == '\0' )
			
				sn = hlastrdup2( (yyvsp[(1) - (8)].idStr) );
				
			_else
			
				sn = (yyvsp[(8) - (8)].returns);
				
			_endif
			InsertSym
			( 
				(yyvsp[(1) - (8)].idStr),			/* Name			*/
				&dword_ste,			/* Type			*/
				tDWord, 			/* pType		*/
				cStatic,			/* SymClass		*/ 
				0,					/* Arity		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				4,					/* ObjectSize	*/
				0,					/* CurOffset	*/
				sn,					/* StaticName	*/
				NULL,				/* BaseType		*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);
			_if( (yyvsp[(8) - (8)].returns) != NULL )
			
				EmitTypedExtern
				( 
					SymbolTable,
					sn, 
					tDWord 
				);
				SymbolTable->IsExternal = 1;

			_else
			
				EmitTypedPublic
				( 
					sn, 
					tDWord 
				);
				
			_endif
			

			_if( (yyvsp[(5) - (8)].s)->pType == tClass )

				/*
				** Okay, build the Virtual Method Table for
				** this class and adjust the offsets for each
				** of the methods to reflect the index into the
				** VMT.
				*/

				_if( (yyvsp[(8) - (8)].returns) == NULL )
				
					BuildVMT( (yyvsp[(5) - (8)].s), (yyvsp[(5) - (8)].s)->StaticName, sn );
					extLookup
					( 
						(yyvsp[(5) - (8)].s), 				  // sym,
						(yyvsp[(5) - (8)].s)->StaticName, 	  // theLabel, 
						tDWord, 			  // theType, 
						1, 					  // IsPublic,
						1, 					  // ForceRef,
						1 					  // isVMT 
					);
					
				_else // @external;
				
					extLookup
					( 
						(yyvsp[(5) - (8)].s), 				  // sym,
						(yyvsp[(5) - (8)].s)->StaticName, 	  // theLabel, 
						tDWord, 			  // theType, 
						0, 					  // IsPublic,
						0, 					  // ForceRef,
						1 					  // isVMT 
					);
								
				_endif

			_else

				yyerror( "Expected a class type identifier" );

			_endif
			_here;
		;}
    break;

  case 1225:

/* Line 1464 of yacc.c  */
#line 58117 "hlaparse.bsn"
    {
			SymNode_t	*sym;

			/*
			** Okay, the user wants to attach a label to this VMT.
			** Automatically make it public.
			*/

			_here;
			_if( (yyvsp[(1) - (7)].s)->IsExternal && (yyvsp[(1) - (7)].s)->SymClass == cStatic )
			
				(yyvsp[(1) - (7)].s)->IsExternal = 0;
				EmitTypedPublic( (yyvsp[(1) - (7)].s)->StaticName, (yyvsp[(1) - (7)].s)->pType );
			
				_if( (yyvsp[(5) - (7)].s)->pType == tClass )

					/*
					** Okay, build the Virtual Method Table for
					** this class and adjust the offsets for each
					** of the methods to reflect the index into the
					** VMT.
					*/

					
					BuildVMT( (yyvsp[(5) - (7)].s), (yyvsp[(5) - (7)].s)->StaticName, (yyvsp[(1) - (7)].s)->StaticName );
						

				_else

					yyerror( "Expected a class type identifier" );

				_endif
				
			_endif
			_here;
		;}
    break;

  case 1226:

/* Line 1464 of yacc.c  */
#line 58162 "hlaparse.bsn"
    {
			char msg[1024];
			
			sprintf
			( 
				msg, 
				"Undefined type ID in VMT statement: '%s'\n", 
				(yyvsp[(3) - (6)].idStr) 
			);
			yyerror( msg );			
		;}
    break;

  case 1258:

/* Line 1464 of yacc.c  */
#line 58444 "hlaparse.bsn"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 1259:

/* Line 1464 of yacc.c  */
#line 58447 "hlaparse.bsn"
    {
				(void) (yyvsp[(2) - (4)].s);	// shut up bison
			;}
    break;

  case 1261:

/* Line 1464 of yacc.c  */
#line 58502 "hlaparse.bsn"
    {
				_here;
				inReadonly = (yyvsp[(1) - (5)].i);
			;}
    break;

  case 1262:

/* Line 1464 of yacc.c  */
#line 58511 "hlaparse.bsn"
    {
			_here;
			(yyval.i) = inReadonly;
			inReadonly = 1;
		;}
    break;

  case 1263:

/* Line 1464 of yacc.c  */
#line 58519 "hlaparse.bsn"
    {
			_here;
			startROseg();
		;}
    break;

  case 1264:

/* Line 1464 of yacc.c  */
#line 58526 "hlaparse.bsn"
    {
			_here;
			endROseg();
		;}
    break;

  case 1266:

/* Line 1464 of yacc.c  */
#line 58539 "hlaparse.bsn"
    {
				_here;
				_if
				( 
						IsNumber( (yyvsp[(2) - (3)].v.pType) )
					&&	numBits32( YYS &(yyvsp[(2) - (3)].v) ) <= 32  
					&&	(
								(yyvsp[(2) - (3)].v.u.unsval) == 1
							||	(yyvsp[(2) - (3)].v.u.unsval) == 2
							||	(yyvsp[(2) - (3)].v.u.unsval) == 4
							||	(yyvsp[(2) - (3)].v.u.unsval) == 8
							||	(yyvsp[(2) - (3)].v.u.unsval) == 16
						)
				)

					EmitAlign( (yyvsp[(2) - (3)].v.u.unsval) );

				_else

					yyerror( "Expected the constant 1, 2, 4, 8, or 16 here" );

				_endif
			;}
    break;

  case 1271:

/* Line 1464 of yacc.c  */
#line 58608 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].s)->pType == tClass )

				/*
				** Okay, build the Virtual Method Table for
				** this class and adjust the offsets for each
				** of the methods to reflect the index into the
				** VMT.
				*/

				_if( (yyvsp[(6) - (6)].returns) == NULL )
				
					BuildVMT( (yyvsp[(3) - (6)].s), (yyvsp[(3) - (6)].s)->StaticName, NULL );
					extLookup
					( 
						(yyvsp[(3) - (6)].s), 				  // sym,
						(yyvsp[(3) - (6)].s)->StaticName, 	  // theLabel, 
						tDWord, 			  // theType, 
						1, 					  // IsPublic,
						1, 					  // ForceRef,
						1 					  // isVMT 
					);
					
				_else // @external;
				
					extLookup
					( 
						(yyvsp[(3) - (6)].s), 				  // sym,
						(yyvsp[(3) - (6)].s)->StaticName, 	  // theLabel, 
						tDWord, 			  // theType, 
						0, 					  // IsPublic,
						0, 					  // ForceRef,
						1 					  // isVMT 
					);
					_if( *(yyvsp[(6) - (6)].returns) != '\0' )
					
						HLAWarning
						( 
							"Ignoring VMT external string", 
							(yyvsp[(6) - (6)].returns), 
							__LINE__, 
							__FILE__ 
						);
						
					_endif
								
				_endif

			_else

				yyerror( "Expected a class type identifier" );

			_endif
			_here;
		;}
    break;

  case 1272:

/* Line 1464 of yacc.c  */
#line 58679 "hlaparse.bsn"
    {
			char 		*sn;
			SymNode_t	*sym;

			/*
			** Okay, the user wants to attach a label to this VMT.
			** Automatically make it public.
			*/

			_here;
			_if( (yyvsp[(8) - (8)].returns) == NULL || *(yyvsp[(8) - (8)].returns) == '\0' )
			
				sn = hlastrdup2( (yyvsp[(1) - (8)].idStr) );
				
			_else
			
				sn = (yyvsp[(8) - (8)].returns);
				
			_endif
			InsertSym
			( 
				(yyvsp[(1) - (8)].idStr),			/* Name			*/
				&dword_ste,			/* Type			*/
				tDWord, 			/* pType		*/
				cStatic,			/* SymClass		*/ 
				0,					/* Arity		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				4,					/* ObjectSize	*/
				0,					/* CurOffset	*/
				sn,					/* StaticName	*/
				NULL,				/* BaseType		*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);
			_if( (yyvsp[(8) - (8)].returns) != NULL )
			
				EmitTypedExtern
				( 
					SymbolTable,
					sn, 
					tDWord 
				);
				SymbolTable->IsExternal = 1;

			_else
			
				EmitTypedPublic
				( 
					sn, 
					tDWord 
				);
				
			_endif
			

			_if( (yyvsp[(5) - (8)].s)->pType == tClass )

				/*
				** Okay, build the Virtual Method Table for
				** this class and adjust the offsets for each
				** of the methods to reflect the index into the
				** VMT.
				*/

				_if( (yyvsp[(8) - (8)].returns) == NULL )
				
					BuildVMT( (yyvsp[(5) - (8)].s), (yyvsp[(5) - (8)].s)->StaticName, sn );
					extLookup
					( 
						(yyvsp[(5) - (8)].s), 				  // sym,
						(yyvsp[(5) - (8)].s)->StaticName, 	  // theLabel, 
						tDWord, 			  // theType, 
						1, 					  // IsPublic,
						1, 					  // ForceRef,
						1 					  // isVMT 
					);
					
				_else // @external;
				
					extLookup
					( 
						(yyvsp[(5) - (8)].s), 				  // sym,
						(yyvsp[(5) - (8)].s)->StaticName, 	  // theLabel, 
						tDWord, 			  // theType, 
						0, 					  // IsPublic,
						0, 					  // ForceRef,
						1 					  // isVMT 
					);
								
				_endif

			_else

				yyerror( "Expected a class type identifier" );

			_endif
			_here;
		;}
    break;

  case 1273:

/* Line 1464 of yacc.c  */
#line 58795 "hlaparse.bsn"
    {
			SymNode_t	*sym;

			/*
			** Okay, the user wants to attach a label to this VMT.
			** Automatically make it public.
			*/

			_here;
			_if( (yyvsp[(1) - (7)].s)->IsExternal && (yyvsp[(1) - (7)].s)->SymClass == cStatic )
			
				(yyvsp[(1) - (7)].s)->IsExternal = 0;
				EmitTypedPublic( (yyvsp[(1) - (7)].s)->StaticName, (yyvsp[(1) - (7)].s)->pType );
			
				_if( (yyvsp[(5) - (7)].s)->pType == tClass )

					/*
					** Okay, build the Virtual Method Table for
					** this class and adjust the offsets for each
					** of the methods to reflect the index into the
					** VMT.
					*/

					
					BuildVMT( (yyvsp[(5) - (7)].s), (yyvsp[(5) - (7)].s)->StaticName, (yyvsp[(1) - (7)].s)->StaticName );
						

				_else

					yyerror( "Expected a class type identifier" );

				_endif
				
			_endif
			_here;
		;}
    break;

  case 1277:

/* Line 1464 of yacc.c  */
#line 58872 "hlaparse.bsn"
    {
			SymNode_t 		*s;
			union YYSTYPE	value;

			_here;
			--CurLexLevel;
			CurOffset = (yyvsp[(4) - (10)].v.u.intval);
			CurOffsetDir = (yyvsp[(5) - (10)].v.u.unsval);
			CheckLegalOptions
			( 
				(yyvsp[(9) - (10)].options.SpecifiedOptions),
					specified_returns
				|	specified_use
				|	specified_pascal
				|	specified_stdcall
				|	specified_cdecl
				|	specified_alignment 
			);
			_if( (yyvsp[(9) - (10)].options.NoStorage) && (yyvsp[(10) - (10)].returns) != NULL )

				yyerror( "'nostorage' option is illegal here" );

			_endif
			
			// Need to create a dummy type to hold the procedure pointer parameters.
			
			s = SymbolTable;
			InsertSym
			( 
				" (procptr parms) ", 
				NULL,
				tProcptr, 
				cType, 
				0,
				NULL,
				0, 
				NULL,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			SymbolTable->u.proc.parms = s;
			SymbolTable->u.proc.returns = hlastrdup2( "" );
			SymbolTable->u.proc.use = NULL;
			SymbolTable->u.proc.cs = (yyvsp[(9) - (10)].options.CallingSequence);
			(yyvsp[(6) - (10)].s)->Type = SymbolTable;
			(yyvsp[(6) - (10)].s)->u.proc.parms->Type = SymbolTable;
			
			// Remove the dummy entry from the symbol table:
			
			SymbolTable = s;
			
			// Patch the original symbol table entries:

			(yyvsp[(6) - (10)].s)->u.proc.parms->u.proc.parms = SymbolTable;
			(yyvsp[(6) - (10)].s)->u.proc.parms->u.proc.returns = hlastrdup2( "" );
			(yyvsp[(6) - (10)].s)->u.proc.parms->u.proc.use = NULL;
			(yyvsp[(6) - (10)].s)->u.proc.parms->u.proc.Locals = NULL;

			(yyvsp[(6) - (10)].s)->u.proc.parms = SymbolTable;
			(yyvsp[(6) - (10)].s)->u.proc.returns = (yyvsp[(9) - (10)].options.returns);
			(yyvsp[(6) - (10)].s)->u.proc.use = (yyvsp[(9) - (10)].options.use);
			(yyvsp[(6) - (10)].s)->u.proc.cs = (yyvsp[(9) - (10)].options.CallingSequence);
			
			/*
			** Just to be on the safe side, let's create
			** a "parms" and "vars" entry for this object.
			*/
			
			ClrConst
			(
				YYS &value,
				tUns32,
				&uns32_ste
			);
			value.v.u.unsval = (yyvsp[(7) - (10)].v.u.unsval);
			InsertSym
			( 
				"_parms_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,
				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			value.v.u.unsval = 0;
			InsertSym
			( 
				"_vars_", 
				&uns32_ste,
				tUns32, 
				cConstant, 
				0,

				NULL,
				0, 
				YYS &value,
				4,
				0,
				NULL,
				NULL,
				NULL,
				0
			);
			(yyvsp[(6) - (10)].s)->u.proc.parms->u.proc.Locals = SymbolTable;
			(yyvsp[(6) - (10)].s)->u.proc.Locals = SymbolTable;
			
			SymbolTable = (yyvsp[(6) - (10)].s);

			// Deal with the @external option here:
			
			_if( (yyvsp[(10) - (10)].returns) != NULL )
			
				(yyvsp[(6) - (10)].s)->IsExternal = 1;
			 	free2( vss (yyvsp[(6) - (10)].s)->StaticName );
				_if( *(yyvsp[(10) - (10)].returns) == '\0' )

					(yyvsp[(6) - (10)].s)->StaticName = hlastrdup2( (yyvsp[(6) - (10)].s)->TrueName );
					free2( vss (yyvsp[(10) - (10)].returns) );

				_else
					
					(yyvsp[(6) - (10)].s)->StaticName = (yyvsp[(10) - (10)].returns);

				_endif
				EmitTypedExtern( (yyvsp[(6) - (10)].s), (yyvsp[(6) - (10)].s)->StaticName, tDWord );
				
			_elseif( (yyvsp[(9) - (10)].options.NoStorage) )

				// @nostorage option was present.
				
				EmitTypedLabel( (yyvsp[(6) - (10)].s)->StaticName, tDWord );

			_else

				yyerror
				( 
					NeedsInitializerMsg 
				);

			_endif 
			_here;
		;}
    break;

  case 1278:

/* Line 1464 of yacc.c  */
#line 59030 "hlaparse.bsn"
    {
			
			char StaticName[ 256 ];
			char *sn;

			_here;
			assert( (yyvsp[(-6) - (0)].idStr) != NULL );

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-6) - (0)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );

			CreatePtrToProc( (yyvsp[(-6) - (0)].idStr), (yyvsp[(-1) - (0)].s), sn, cStatic );
			 
			_here;
		;}
    break;

  case 1279:

/* Line 1464 of yacc.c  */
#line 59060 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(10) - (10)].returns) != NULL );
			CheckLegalOptions
			( 
				(yyvsp[(9) - (10)].options.SpecifiedOptions),
					specified_returns
				|	specified_use
				|	specified_pascal
				|	specified_stdcall
				|	specified_cdecl
				|	specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(9) - (10)].options.NoStorage) )

				yyerror( "'@nostorage' option is illegal here" );

			_endif

			SymbolTable->IsExternal = 1;
			_if( *(yyvsp[(10) - (10)].returns) == '\0' )

			 	free2( vss SymbolTable->StaticName );
				SymbolTable->StaticName = hlastrdup2( SymbolTable->TrueName );
				free2( vss (yyvsp[(10) - (10)].returns) );

			_else

				SymbolTable->StaticName = (yyvsp[(10) - (10)].returns);

			_endif
			EmitTypedExtern( SymbolTable, SymbolTable->StaticName, tDWord );
			_here;
		;}
    break;

  case 1280:

/* Line 1464 of yacc.c  */
#line 59111 "hlaparse.bsn"
    {
			CheckLegalOptions
			( 
				(yyvsp[(9) - (9)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(9) - (9)].options.NoStorage) )

				EmitTypedLabel( SymbolTable->StaticName, tDWord );

			_else

				yyerror
				( 
					NeedsInitializerMsg 
				);

			_endif
			_here;
		;}
    break;

  case 1283:

/* Line 1464 of yacc.c  */
#line 59160 "hlaparse.bsn"
    {						/* $8 */

			_here;
			CheckLegalOptions
			( 
				(yyvsp[(7) - (7)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(7) - (7)].options.NoStorage) )

				_if( (yyvsp[(1) - (7)].s)->IsExternal && (yyvsp[(1) - (7)].s)->SymClass == cStatic )

					EmitTypedLabel( (yyvsp[(1) - (7)].s)->StaticName, tDWord );
					
				_else

					ErrorNear
					( 
						"Duplicate symbol definition",
						(yyvsp[(1) - (7)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif

			_else

				yyerror( NeedsInitializerMsg );

			_endif
			_here;
		;}
    break;

  case 1284:

/* Line 1464 of yacc.c  */
#line 59208 "hlaparse.bsn"
    {
			
			char msg[256];
			char StaticName[ 256 ];
			char *sn;

			_here;
			CheckLegalOptions
			( 
				(yyvsp[(8) - (8)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			assert( (yyvsp[(1) - (8)].idStr) != NULL );

			assert( (yyvsp[(1) - (8)].s)->u.proc.Forward != NULL );
			_if( (yyvsp[(1) - (8)].s)->u.proc.Forward != (yyvsp[(6) - (8)].s) )
				
				sprintf
				( 
					msg,
					"Base procedure does not agree with original "
					"declaration\n('%s' should be '%s')",
					(yyvsp[(6) - (8)].s)->TrueName,
					(yyvsp[(1) - (8)].s)->u.proc.Forward->TrueName
				);
				yyerror( msg );
				
			_endif

			_if( (yyvsp[(8) - (8)].options.NoStorage) )

				_if( (yyvsp[(1) - (8)].s)->IsExternal && (yyvsp[(1) - (8)].s)->SymClass == cStatic )

					EmitTypedLabel( (yyvsp[(1) - (8)].s)->StaticName, tDWord );

				_else

					ErrorNear
					( 
						"Duplicate symbol definition",
						(yyvsp[(1) - (8)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif

			_else

				yyerror( NeedsInitializerMsg );

			_endif
			_here;
		;}
    break;

  case 1286:

/* Line 1464 of yacc.c  */
#line 59289 "hlaparse.bsn"
    {				/* $9  */

			// Fix up the generated enum type to include a pointer to
			// the enum symbols and the count of enum symbols:
			
			_here;
			(yyvsp[(4) - (8)].s)->Fields = SymbolTable;
			(yyvsp[(4) - (8)].s)->FieldCnt = EnumVal;

		;}
    break;

  case 1287:

/* Line 1464 of yacc.c  */
#line 59301 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(11) - (11)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(11) - (11)].options.NoStorage) )

				EmitLabel( (yyvsp[(4) - (11)].s)->StaticName, EnumSize ); 

			_else

				yyerror( NeedsInitializerMsg );

			_endif
			_here;
		;}
    break;

  case 1289:

/* Line 1464 of yacc.c  */
#line 59338 "hlaparse.bsn"
    {

			SymNode_t	*BaseType;
			char		*sn;
			char		StaticName[ 256 ];

			assert( (yyvsp[(-4) - (0)].idStr) != NULL );
			assert( (yyvsp[(0) - (0)].neID.idStr) != NULL );

			_here;
			BaseType = (yyvsp[(0) - (0)].neID.s);
			_if( BaseType != NULL )

				BaseType = GetBaseType( BaseType );
				_if( CantBeVar( BaseType->pType ))

					yyerror( "Readonly variables cannot be this type" );
					BaseType = &uns32_ste;

				_endif

			_endif

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-4) - (0)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );
			InsertSym
			( 
				(yyvsp[(-4) - (0)].idStr),			/* Name			*/
				&pointer_ste,		/* Type			*/
				tPointer, 			/* pType		*/
				cStatic,			/* SymClass		*/ 
				0,					/* Arity		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				4,					/* ObjectSize	*/
				0,					/* CurOffset	*/
				sn,					/* StaticName	*/
				BaseType,			/* BaseType		*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);
			(yyval.s) = SymbolTable;
			_here;
		;}
    break;

  case 1290:

/* Line 1464 of yacc.c  */
#line 59397 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(8) - (8)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( !(yyvsp[(8) - (8)].options.NoStorage) )

				yyerror
				( 
					"Readonly object requires an initializer\n"
					"or the 'NOSTORAGE' option."
				);

			_endif
			EmitTypedLabel( (yyvsp[(6) - (8)].s)->StaticName, tDWord );


			_if( (yyvsp[(6) - (8)].s)->Base == NULL )

				Add2PtrList( (yyvsp[(6) - (8)].s), (yyvsp[(5) - (8)].neID.idStr) );

			_endif
			_here;
		;}
    break;

  case 1291:

/* Line 1464 of yacc.c  */
#line 59444 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(8) - (9)].options.SpecifiedOptions),
					specified_volatile 
			);
			_if( (yyvsp[(9) - (9)].returns) == NULL )
			 
				EmitTypedLabel( (yyvsp[(6) - (9)].s)->StaticName, tDWord );
				EmitDwordConst( 0, "" );

			_else

				(yyvsp[(6) - (9)].s)->IsExternal = 1;
				_if( *(yyvsp[(9) - (9)].returns) == '\0' )

					free2( vss (yyvsp[(6) - (9)].s)->StaticName );
					(yyvsp[(6) - (9)].s)->StaticName = hlastrdup2( (yyvsp[(1) - (9)].idStr) );

				_else

					free2( vss (yyvsp[(6) - (9)].s)->StaticName );
					(yyvsp[(6) - (9)].s)->StaticName = hlastrdup2( (yyvsp[(9) - (9)].returns) );

				_endif
				EmitTypedExtern
				( 
					(yyvsp[(6) - (9)].s), 
					SymbolTable->StaticName, 
					tDWord 
				);

			_endif
			free2( vss (yyvsp[(9) - (9)].returns) );


			_if( (yyvsp[(6) - (9)].s) == NULL )
			
				Add2PtrList( SymbolTable, (yyvsp[(5) - (9)].neID.idStr) );

			_endif
			_here;
		;}
    break;

  case 1293:

/* Line 1464 of yacc.c  */
#line 59516 "hlaparse.bsn"
    {					/* $8 */

			SymNode_t *BaseType;
	
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(7) - (7)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( !(yyvsp[(7) - (7)].options.NoStorage) )

				yyerror
				( 
					"Readonly object requires an initializer\n"
					"or the 'NOSTORAGE' option."
				);

			_endif
			BaseType = (yyvsp[(5) - (7)].neID.s);
			_if( BaseType != NULL )

				BaseType = GetBaseType( BaseType );
				_if( CantBeVar( BaseType->pType ))

					yyerror( "Readonly variables cannot be this type" );
					BaseType = &uns32_ste;

				_endif

			_endif

			_if( (yyvsp[(1) - (7)].s)->IsExternal && (yyvsp[(1) - (7)].s)->SymClass == cStatic )

				_if( (yyvsp[(1) - (7)].s)->Type == &pointer_ste && (yyvsp[(1) - (7)].s)->Base == BaseType ) 

					(yyvsp[(1) - (7)].s)->IsExternal = 0;
					EmitTypedPublic( (yyvsp[(1) - (7)].s)->StaticName, tDWord );
					EmitTypedLabel( (yyvsp[(1) - (7)].s)->StaticName, tDWord ); 

				_else

					ErrorNear
					(
						"External base type must match declared base type",
						(yyvsp[(5) - (7)].neID.idStr),
						__LINE__,
						__FILE__
					);

				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif


			_if( BaseType == NULL )

				Add2PtrList( (yyvsp[(1) - (7)].s), (yyvsp[(5) - (7)].neID.idStr) );
				
			_endif

			free2( vss (yyvsp[(5) - (7)].neID.idStr) );
			_here;
		;}
    break;

  case 1295:

/* Line 1464 of yacc.c  */
#line 59608 "hlaparse.bsn"
    {

			SymNode_t *BaseType;
			char	  *sn;
			char	  StaticName[ 256 ];

			assert( (yyvsp[(-4) - (0)].idStr) != NULL );

			_here;
			BaseType = (yyvsp[(0) - (0)].s);
			_if( CantBeVar( BaseType->pType ))

				yyerror( "Readonly variables cannot be this type" );
				BaseType = &uns32_ste;

			_endif

			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-4) - (0)].idStr), LblCntr++ );
			sn = hlastrdup2( StaticName );
			InsertSym
			( 
				(yyvsp[(-4) - (0)].idStr),			/* Name			*/
				&pointer_ste,		/* Type			*/
				tPointer, 			/* pType		*/
				cStatic,			/* SymClass		*/ 
				0,					/* Arity		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				4,					/* ObjectSize	*/
				0,					/* CurOffset	*/
				sn,					/* StaticName	*/
				BaseType,			/* BaseType		*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);

			 
			EmitTypedLabel( sn, tDWord );
			_here;
		;}
    break;

  case 1296:

/* Line 1464 of yacc.c  */
#line 59663 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(8) - (8)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( !(yyvsp[(8) - (8)].options.NoStorage) )

				yyerror
				( 
					"Readonly object requires an initializer\n"
					"or the 'NOSTORAGE' option."
				);

			_endif
		;}
    break;

  case 1297:

/* Line 1464 of yacc.c  */
#line 59704 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(8) - (9)].options.SpecifiedOptions),
					specified_volatile 
			);
 
			_if( (yyvsp[(9) - (9)].returns) == NULL )
			 
				EmitTypedLabel( SymbolTable->StaticName, tDWord );
				EmitDwordConst( 0, "" );

			_else

				SymbolTable->IsExternal = 1;
				_if( *(yyvsp[(9) - (9)].returns) == '\0' )

					free2( vss SymbolTable->StaticName );
					SymbolTable->StaticName = hlastrdup2( (yyvsp[(1) - (9)].idStr) );

				_else

					free2( vss SymbolTable->StaticName );
					SymbolTable->StaticName = hlastrdup2( (yyvsp[(9) - (9)].returns) );

				_endif
				EmitTypedExtern
				( 
					SymbolTable,
					SymbolTable->StaticName, 
					tDWord 
				);

			_endif
			free2( vss (yyvsp[(9) - (9)].returns) );
			_here;
		;}
    break;

  case 1301:

/* Line 1464 of yacc.c  */
#line 59777 "hlaparse.bsn"
    {

			char			StaticName[ 256 ];
			char 			*sn;
			int				size;


			assert( (yyvsp[(-2) - (0)].idStr) != NULL );
			assert( (yyvsp[(0) - (0)].s) != NULL );

			_here;

			size = (yyvsp[(0) - (0)].s)->ObjectSize;

			_if( CantBeVar( (yyvsp[(0) - (0)].s)->pType ))

				yyerror( "Readonly variables cannot be this type" );

			_else
			
				sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-2) - (0)].idStr), LblCntr++ );
				sn = hlastrdup2( StaticName );
				InsertSym
				( 
					(yyvsp[(-2) - (0)].idStr), 
					(yyvsp[(0) - (0)].s), 			/*GetBaseType( $<s>3 ),*/
					(yyvsp[(0) - (0)].s)->pType, 
					cStatic, 
					(yyvsp[(0) - (0)].s)->Arity,
					(yyvsp[(0) - (0)].s)->Dimensions,
					(yyvsp[(0) - (0)].s)->NumElements, 
					NULL,
					size,
					0,
					sn,
					(yyvsp[(0) - (0)].s)->Base,
					(yyvsp[(0) - (0)].s)->Fields,
					(yyvsp[(0) - (0)].s)->FieldCnt
				);
				_if( (yyvsp[(0) - (0)].s)->pType == tProcptr )
				
					// Copy parameter info if a proc ptr.
					
					memcpy
					( 
						&SymbolTable->u, 
						&(yyvsp[(0) - (0)].s)->u, 
						sizeofValuesSize
					);
					
				_endif



				/*
				** If this is a class object, we need to duplicate
				** all the fields to all private constants, etc.
				*/

				
				_if( (yyvsp[(0) - (0)].s)->pType == tClass )

					SymbolTable->Fields = 
						CopySymbols
						( 
							(yyvsp[(0) - (0)].s)->Fields,
							StaticName
						);
					NullTerminate( SymbolTable->Fields, SymbolTable );

				_elseif(  (yyvsp[(0) - (0)].s)->pType == tThunk )

					/*
					** Need some dummy local vars for a thunk.
					*/

					SymbolTable->u.proc.parms = &true_ste;

				_endif

			_endif
			_here;
		;}
    break;

  case 1302:

/* Line 1464 of yacc.c  */
#line 59872 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(6) - (6)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( !(yyvsp[(6) - (6)].options.NoStorage) )

				yyerror
				( 
					"Readonly object requires an initializer\n"
					"or the 'NOSTORAGE' option."
				);

			_endif
			_if( !CantBeVar( (yyvsp[(3) - (6)].s)->pType ))

				_if
				( 
						(yyvsp[(3) - (6)].s)->pType == tPointer
					||	(yyvsp[(3) - (6)].s)->pType == tProcptr
				)
				
					EmitTypedLabel( SymbolTable->StaticName, tDWord );
					
				
				_else

					EmitTypedLabel( SymbolTable->StaticName, tByte );

				_endif

			_endif
		;}
    break;

  case 1303:

/* Line 1464 of yacc.c  */
#line 59925 "hlaparse.bsn"
    {
			SymNode_t *bt;
			
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(6) - (7)].options.SpecifiedOptions),
					specified_volatile 
			);
			
			_if( CantBeVar( (yyvsp[(3) - (7)].s)->pType ))

				free2( vss (yyvsp[(7) - (7)].returns) );
				
			_else
			
				SymbolTable->IsExternal = 1;
				_if( *(yyvsp[(7) - (7)].returns) == '\0' )

				 	free2( vss SymbolTable->StaticName );
					SymbolTable->StaticName = hlastrdup2( SymbolTable->TrueName );
					free2( vss (yyvsp[(7) - (7)].returns) );

				_else

					SymbolTable->StaticName = (yyvsp[(7) - (7)].returns);

				_endif
				bt = GetBaseType( (yyvsp[(3) - (7)].s) );
				EmitExtern( SymbolTable, bt->ObjectSize );
				
			_endif

		;}
    break;

  case 1305:

/* Line 1464 of yacc.c  */
#line 59992 "hlaparse.bsn"
    {					/* $6 */

			char 		StaticName[ 256 ];
			char 		*sn;
			SymNode_t	*bt;

			assert( (yyvsp[(1) - (5)].s) != NULL );
			assert( (yyvsp[(3) - (5)].s) != NULL );

			_here;
			CheckLegalOptions
			( 
				(yyvsp[(5) - (5)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( !(yyvsp[(5) - (5)].options.NoStorage) )

				yyerror
				( 
					"Readonly object requires an initializer\n"
					"or the 'NOSTORAGE' option."
				);

			_endif

			bt = GetBaseType( (yyvsp[(3) - (5)].s) );
			_if( CantBeVar((yyvsp[(3) - (5)].s)->pType ))

				yyerror( "Readonly variables cannot be this type" );

			_else
			

				_if( (yyvsp[(1) - (5)].s)->IsExternal && (yyvsp[(1) - (5)].s)->SymClass == cStatic )

					_if
					(
							(yyvsp[(1) - (5)].s)->Type == (yyvsp[(3) - (5)].s)
						||	(yyvsp[(1) - (5)].s)->Type == GetBaseType( (yyvsp[(3) - (5)].s) )
					)

						(yyvsp[(1) - (5)].s)->IsExternal = 0;
						EmitTypedPublic ( (yyvsp[(1) - (5)].s)->StaticName, (yyvsp[(1) - (5)].s)->pType );
						EmitLabel( (yyvsp[(1) - (5)].s)->StaticName, bt->ObjectSize );  

					_else

						ErrorNear
						(
							"External type must match "
							"declared type",
							(yyvsp[(1) - (5)].s)->TrueName,
							__LINE__,
							__FILE__
						);

					_endif

				_else

					ErrorNear
					( 
						"Duplicate symbol definition",
						(yyvsp[(1) - (5)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif

			_endif
			_here;
		;}
    break;

  case 1307:

/* Line 1464 of yacc.c  */
#line 60082 "hlaparse.bsn"
    {

			int		*DimensionArray;
			int		ArraySize;
			char	StaticName[ 256 ];
			char	*sn;


			assert( (yyvsp[(-5) - (0)].idStr) != NULL );
			assert( (yyvsp[(-3) - (0)].s) != NULL );
			assert( (yyvsp[(-1) - (0)].v.Dimensions) != NULL );

			_here;

			_if( (yyvsp[(-1) - (0)].v.NumElements) <= 0 )
			
				yyerror( "Array declaration must have at least one element" );
				(yyvsp[(-1) - (0)].v.NumElements) = 1;
			
			_endif
			sprintf( StaticName, "%s" sympost "%d", (yyvsp[(-5) - (0)].idStr), LblCntr++ );

			/*
			** Make sure this is a legal variable type
			** (e.g., no text variables).
			*/

			_if( CantBeVar( (yyvsp[(-3) - (0)].s)->pType ))
			
				yyerror( "Illegal Readonly variable type" );
				
			_else 
			
				/*
				** Check to see if TypeID is an array type
				** (i.e., we're creating a multi-dimensional array).
				*/

				_if( (yyvsp[(-3) - (0)].s)->pType != tArray )

					/*
					** TypeID is *not* an array type, so create
					** a single dimension array here.
					*/

					ArraySize = (yyvsp[(-3) - (0)].s)->ObjectSize * (yyvsp[(-1) - (0)].v.NumElements);
					sn = hlastrdup2( StaticName );
					InsertSym
					( 
						(yyvsp[(-5) - (0)].idStr), 
						(yyvsp[(-3) - (0)].s),
						tArray, 
						cStatic, 
						(yyvsp[(-1) - (0)].v.Arity),
						(yyvsp[(-1) - (0)].v.Dimensions),
						(yyvsp[(-1) - (0)].v.NumElements), 
						NULL,
						ArraySize,
						0,
						sn,
						(yyvsp[(-3) - (0)].s)->Base,
						(yyvsp[(-3) - (0)].s)->Fields,
						(yyvsp[(-3) - (0)].s)->FieldCnt
					);

					/*
					** If this is a class object, we need to duplicate
					** all the fields to all private constants, etc.
					*/

					_if( (yyvsp[(-3) - (0)].s)->pType == tClass )

						SymbolTable->Fields = 
							CopySymbols
							( 
								(yyvsp[(-3) - (0)].s)->Fields,
								(yyvsp[(-3) - (0)].s)->StaticName
							);
						NullTerminate( SymbolTable->Fields, SymbolTable );

					_else
					
						_if(  (yyvsp[(-3) - (0)].s)->pType == tThunk )

							/*
							** Need some dummy local vars for a thunk.
							*/

							SymbolTable->u.proc.parms = &true_ste;

						_endif

					_endif


				/*
				** Okay, down here TypeID *is* an array type,
				** so we're creating a multi-dimensional array.
				*/

				_else

					SymNode_t *BaseType;

					assert( (yyvsp[(-3) - (0)].s)->Dimensions != NULL );

					/*
					** Create the new dimension array by concatenating
					** the two existing dimension arrays.
					*/

					DimensionArray = 
						malloc2
						( 
							( (yyvsp[(-3) - (0)].s)->Arity + (yyvsp[(-1) - (0)].v.NumElements) ) * 
								sizeofInt 
						);

					memcpy
					( 
						DimensionArray, 
						(yyvsp[(-3) - (0)].s)->Dimensions, 
						(yyvsp[(-3) - (0)].s)->Arity * sizeofInt 
					);
					memcpy
					(
						&DimensionArray[ (yyvsp[(-3) - (0)].s)->Arity ],
						(yyvsp[(-1) - (0)].v.Dimensions),
						(yyvsp[(-1) - (0)].v.Arity) * sizeofInt 
					);
					ArraySize = (yyvsp[(-3) - (0)].s)->ObjectSize * (yyvsp[(-1) - (0)].v.NumElements);

					/*
					** Add the new array to the symbol table.
					*/

					sn = hlastrdup2( StaticName );
					BaseType = GetBaseType( (yyvsp[(-3) - (0)].s) );
					InsertSym
					( 
						(yyvsp[(-5) - (0)].idStr), 
						(yyvsp[(-3) - (0)].s),
						tArray, 
						cStatic, 
						(yyvsp[(-3) - (0)].s)->Arity + (yyvsp[(-1) - (0)].v.Arity),
						DimensionArray,
						(yyvsp[(-3) - (0)].s)->NumElements * (yyvsp[(-1) - (0)].v.NumElements), 
						NULL,
						ArraySize,
						0,
						sn,
						(yyvsp[(-3) - (0)].s)->Base,
						(yyvsp[(-3) - (0)].s)->Fields,
						(yyvsp[(-3) - (0)].s)->FieldCnt
					);

					/*
					** If this is a class object, we need to duplicate
					** all the fields to all private constants, etc.
					*/

					
					_if( SymbolTable->Type->pType == tClass )

						int ThisObjSize;

						SymbolTable->Fields = 
							CopySymbols
							( 
								BaseType->Fields,
								BaseType->StaticName
							);
						NullTerminate( SymbolTable->Fields, SymbolTable );

					_else
					
						_if(  SymbolTable->Type->pType == tThunk )

							/*
							** Need some dummy local vars for a thunk.
							*/

							SymbolTable->u.proc.parms = &true_ste;

						_endif

					_endif
					free2( vss (yyvsp[(-1) - (0)].v.Dimensions) );

				_endif

			_endif
			_here;
		;}
    break;

  case 1308:

/* Line 1464 of yacc.c  */
#line 60288 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(9) - (9)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( !(yyvsp[(9) - (9)].options.NoStorage) )

				yyerror
				( 
					"Readonly object requires an initializer\n"
					"or the 'NOSTORAGE' option."
				);

			_endif
			_if( !CantBeVar( (yyvsp[(3) - (9)].s)->pType ))
			
				EmitTypedLabel( SymbolTable->StaticName, tByte );
					
			_endif  
			
		;}
    break;

  case 1309:

/* Line 1464 of yacc.c  */
#line 60332 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(9) - (10)].options.SpecifiedOptions),
					specified_volatile 
			);
			_if( !CantBeVar( (yyvsp[(3) - (10)].s)->pType ))
			
				SymbolTable->IsExternal = 1;
				_if( *(yyvsp[(10) - (10)].returns) == '\0' )

				 	free2( vss SymbolTable->StaticName );
					SymbolTable->StaticName = hlastrdup2( SymbolTable->TrueName );
					free2( vss (yyvsp[(10) - (10)].returns) );

				_else

					SymbolTable->StaticName = (yyvsp[(10) - (10)].returns);

				_endif
				EmitExtern( SymbolTable, GetBaseType( (yyvsp[(3) - (10)].s) )->ObjectSize );
				
			_endif
		;}
    break;

  case 1311:

/* Line 1464 of yacc.c  */
#line 60385 "hlaparse.bsn"
    {				/* $9 */

			int			*DimensionArray;
			int			ArraySize;
			SymNode_t	*bt;


			assert( (yyvsp[(1) - (8)].s) != NULL );
			assert( (yyvsp[(3) - (8)].s) != NULL );
			assert( (yyvsp[(5) - (8)].v.Dimensions) != NULL );

			_here;
			_if( (yyvsp[(5) - (8)].v.NumElements) <= 0 )
			
				yyerror( "Array declaration must have at least one element" );
				(yyvsp[(5) - (8)].v.NumElements) = 1;
			
			_endif
			CheckLegalOptions
			( 
				(yyvsp[(8) - (8)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( !(yyvsp[(8) - (8)].options.NoStorage) )

				yyerror
				( 
					"Readonly object requires an initializer\n"
					"or the 'NOSTORAGE' option."
				);

			_endif


			bt = GetBaseType( (yyvsp[(3) - (8)].s) );

			/*
			** Make sure this is a legal variable type
			** (e.g., no text variables).
			*/

			_if( CantBeVar( (yyvsp[(3) - (8)].s)->pType ))
			
				yyerror( "Illegal Readonly variable type" );
				
			_else 
			
				_if( (yyvsp[(1) - (8)].s)->IsExternal && (yyvsp[(1) - (8)].s)->SymClass == cStatic )

					(yyvsp[(1) - (8)].s)->IsExternal = 0;
					EmitTypedPublic( (yyvsp[(1) - (8)].s)->StaticName, (yyvsp[(1) - (8)].s)->pType );
					EmitLabel( (yyvsp[(1) - (8)].s)->StaticName, bt->ObjectSize );
					
					_if
					(
							(yyvsp[(1) - (8)].s)->ObjectSize
						!=	(yyvsp[(3) - (8)].s)->ObjectSize * (yyvsp[(5) - (8)].v.NumElements)
					)

						WarnNear
						( 
							"Declared size does not match external size",
							(yyvsp[(1) - (8)].s)->TrueName 
						);

					_endif

				_else

					ErrorNear
					( 
						"Duplicate symbol definition",
						(yyvsp[(1) - (8)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif


			_endif
			free2( vss (yyvsp[(5) - (8)].v.Dimensions) );
			_here;
		;}
    break;

  case 1312:

/* Line 1464 of yacc.c  */
#line 60481 "hlaparse.bsn"
    { _here; (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 1313:

/* Line 1464 of yacc.c  */
#line 60484 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(2) - (4)].s);	// shut up bison
			;}
    break;

  case 1315:

/* Line 1464 of yacc.c  */
#line 60524 "hlaparse.bsn"
    {
				_here;
				inStorage = (yyvsp[(1) - (5)].i);
			;}
    break;

  case 1316:

/* Line 1464 of yacc.c  */
#line 60532 "hlaparse.bsn"
    {
			_here;
			(yyval.i) = inStorage;
			inStorage = 1;
		;}
    break;

  case 1317:

/* Line 1464 of yacc.c  */
#line 60540 "hlaparse.bsn"
    {
			_here;
			startBssSeg();
		;}
    break;

  case 1318:

/* Line 1464 of yacc.c  */
#line 60546 "hlaparse.bsn"
    {
					_here;
					endBssSeg();
					_here;
			   ;}
    break;

  case 1332:

/* Line 1464 of yacc.c  */
#line 60665 "hlaparse.bsn"
    {
			_here;
			CheckLegalOptions
			( 
				(yyvsp[(7) - (7)].options.SpecifiedOptions),
					specified_nostorage
				|	specified_volatile 
			);
			_if( (yyvsp[(1) - (7)].s)->IsExternal && (yyvsp[(1) - (7)].s)->SymClass == cStatic )

				_if( (yyvsp[(1) - (7)].s)->Type == &pointer_ste && (yyvsp[(1) - (7)].s)->Base == (yyvsp[(5) - (7)].s) ) 

					(yyvsp[(1) - (7)].s)->IsExternal = 0;
					EmitTypedPublic( (yyvsp[(1) - (7)].s)->StaticName, (yyvsp[(1) - (7)].s)->pType );
					EmitTypedLabel( (yyvsp[(1) - (7)].s)->StaticName, tDWord );
					_if( !(yyvsp[(7) - (7)].options.NoStorage) )

						EmitDword();

					_endif

				_else

					ErrorNear
					(
						"External base type must match declared base type",
						(yyvsp[(5) - (7)].s)->TrueName,
						__LINE__,
						__FILE__
					);

				_endif

			_else

				ErrorNear
				( 
					"Duplicate symbol definition",
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif
			_here;
		;}
    break;

  case 1341:

/* Line 1464 of yacc.c  */
#line 60807 "hlaparse.bsn"
    { _here; (yyval.s) = (yyvsp[(0) - (2)].s); ;}
    break;

  case 1342:

/* Line 1464 of yacc.c  */
#line 60809 "hlaparse.bsn"
    {
				_here;
				(void) (yyvsp[(3) - (4)].s);	// shut up bison
			;}
    break;

  case 1343:

/* Line 1464 of yacc.c  */
#line 60818 "hlaparse.bsn"
    {	

				/*
				** Check to see if the TypeID and the ConstOnlyExpr
				** are both arrays and if they are compatible.
				*/

				_here;
				_if( (yyvsp[(0) - (1)].s)->pType == tArray && (yyvsp[(1) - (1)].v.pType) == tArray )

					_if
					( 
						ArraysAreCompatible
						( 
							YYS (yyvsp[(0) - (1)].s), 
							YYS &(yyvsp[(1) - (1)].v) 
						)
					)

						OutValue( NULL, (yyvsp[(0) - (1)].s), YYS &(yyvsp[(1) - (1)].v) );

					_else

						yyerror
						( 
							"Array type mismatch or value out of range" 
						);

					_endif


				/*
				** Check to see if the TypeID and the ConstOnlyExpr are
				** compatible record objects. 
				*/

				_elseif
				( 
						(yyvsp[(0) - (1)].s)->pType == tRecord 
					&&	(yyvsp[(1) - (1)].v.pType) == tRecord 
				)

					_if
					( 
						RecordsAreCompatible
						( 
							(yyvsp[(0) - (1)].s), 
							YYS &(yyvsp[(1) - (1)].v) 
						)
					)

						OutValue( NULL, (yyvsp[(0) - (1)].s), YYS &(yyvsp[(1) - (1)].v) );

					_else

						yyerror
						( 
							"Type mismatch, expected compatible "
							"record types"
						);

					_endif


				/*
				** Check for a pointer object with the dword directive.
				*/

				_elseif
				( 
						( 
								(yyvsp[(0) - (1)].s)->pType == tDWord 
							||	(yyvsp[(0) - (1)].s)->pType == tPointer
							||	(yyvsp[(0) - (1)].s)->pType == tProcptr
						)
					&&	(yyvsp[(1) - (1)].v.pType) == tPointer
				)

					OutValue( NULL, &pointer_ste, YYS &(yyvsp[(1) - (1)].v) );


				/*
				** Check to see if the TypeID and the ConstOnlyExpr are
				** compatible pointer objects here.
				*/

				_elseif( IsNotPrimType( (yyvsp[(0) - (1)].s)->pType ))

					yyerror( "This data/static type requires a constant" );

				
				/*
				** We've got a scalar object, output the constant here.
				*/

				_elseif( IsCompatible( (yyvsp[(0) - (1)].s), YYS &(yyvsp[(1) - (1)].v) ))

					OutValue( NULL, (yyvsp[(0) - (1)].s), YYS &(yyvsp[(1) - (1)].v) );


				_elseif
				( 
						(yyvsp[(0) - (1)].s) == &byte_ste 
					&&	( (yyvsp[(1) - (1)].v.pType) == tString || (yyvsp[(1) - (1)].v.pType) == tZString )
				)

					EmitByteString( (yyvsp[(1) - (1)].v.u.strval), 0 );

				_elseif( (yyvsp[(0) - (1)].s) == &byte_ste && (yyvsp[(1) - (1)].v.pType) == tWString )

					EmitWordString( (yyvsp[(1) - (1)].v.u.strval) );

				_else

					yyerror( "Static type mismatch or range error" );

				_endif
				FreeValue( YYS &(yyvsp[(1) - (1)].v) );
				_here;
			;}
    break;

  case 1344:

/* Line 1464 of yacc.c  */
#line 60992 "hlaparse.bsn"
    {
			struct FwdRefLabelType	*flist;
			struct StaticListType	*StaticListEntry;
			struct StaticListType	*sList;
			static char				StaticName[ 256 ];

			/*
			** Check to see if this symbol is in the
			** forward labels list (because it appeared
			** in a LABEL declaration).
			*/

			_here;
			flist = FwdLabelsList;
			_while( flist != NULL )

				_breakif( _streq( (yyvsp[(2) - (2)].idStr), flist->label ));
				flist = flist->Next;

			_endwhile

			_if( flist != NULL && *flist->StaticName != '\0' )
			
				// Okay, it's in the forward list, just use the
				// static name we find there:
				
				(yyval.idStr) = hlastrdup2( flist->StaticName );
				flist->referenced = 1;			

			_else
			
				// See if this symbol is in the StaticList. Use the
				// existing static name if it is:
				
				sList = searchStatic( (yyvsp[(2) - (2)].idStr) );
				_if( sList == NULL )
				
					/*
					** Add a node to the StaticList so we can check
					** this definition once we've compiled the current
					** code to make sure that the type is ultimately
					** defined.
					*/

					sprintf
					( 
						StaticName, 
						"%s" sympost "%d", 
						(yyvsp[(2) - (2)].idStr), 
						LblCntr++ 
					);
					StaticListEntry = malloc2( sizeofStaticListType );
					StaticListEntry->Next = StaticList;
					StaticListEntry->DefinedSym = NULL;
					StaticListEntry->Context = CurrentContext;
					StaticListEntry->Name = hlastrdup2( (yyvsp[(2) - (2)].idStr) );
					StaticListEntry->StaticName = hlastrdup2( StaticName );
					StaticListEntry->LineNumber = LineCnt;
					StaticListEntry->Fixed = 0;
					StaticList = StaticListEntry;
					(yyval.idStr) = hlastrdup2( StaticListEntry->StaticName );
					
				_else

					(yyval.idStr) = hlastrdup2( sList->StaticName );
					
				_endif
				
			_endif
			free2( vss (yyvsp[(2) - (2)].idStr) );
			_here;
		;}
    break;

  case 1345:

/* Line 1464 of yacc.c  */
#line 61076 "hlaparse.bsn"
    {
			struct FwdRefLabelType	*flist;
			struct StaticListType	*StaticListEntry;
			struct StaticListType	*sList;
			static char				StaticName[ 256 ];

			_here;
			_if( !IsOrdinal( (yyvsp[(4) - (5)].v.pType) ) || numBits32( YYS &(yyvsp[(4) - (5)].v) ) > 32 )

				yyerror( "Expected 32-bit ordinal type in index expression" );
			
			_endif



			/*
			** Check to see if this symbol is in the
			** forward labels list (because it appeared
			** in a LABEL declaration).
			*/

			flist = FwdLabelsList;
			_while( flist != NULL )

				_breakif( _streq( (yyvsp[(2) - (5)].idStr), flist->label ));
				flist = flist->Next;

			_endwhile

			_if( flist != NULL && *flist->StaticName != '\0' )
			
				// Okay, it's in the forward list, just use the
				// static name we find there:
				
				sprintf
				( 
					StaticName, 
					"(%s%s%d)", 
					flist->StaticName,
					_ifx( (yyvsp[(4) - (5)].v.u.intval) < 0, "", "+" ), 
					(yyvsp[(4) - (5)].v.u.intval) 
				);
				(yyval.idStr) = hlastrdup2( StaticName );
				flist->referenced = 1;

			_else

				// See if this symbol is in the StaticList. Use the
				// existing static name if it is:
				
				sList = searchStatic( (yyvsp[(2) - (5)].idStr) );
				_if( sList == NULL )
				
					sprintf( StaticName, "%s" sympost "%d", (yyvsp[(2) - (5)].idStr), LblCntr );

					/*
					** Add a node to the StaticList so we can check
					** this definition once we've compiled the current
					** code to make sure that the type is ultimately
					** defined.
					*/

					StaticListEntry = malloc2( sizeofStaticListType );
					StaticListEntry->Next = StaticList;
					StaticListEntry->DefinedSym = NULL;
					StaticListEntry->Context = CurrentContext;
					StaticListEntry->Name = hlastrdup2( (yyvsp[(2) - (5)].idStr) );
					StaticListEntry->StaticName = hlastrdup2( StaticName );
					StaticListEntry->LineNumber = LineCnt;
					StaticListEntry->Fixed = 0;
					StaticList = StaticListEntry;

					sprintf
					( 
						StaticName, 
						"(%s" sympost "%d%s%d)", 
						(yyvsp[(2) - (5)].idStr), 
						LblCntr++, 
						_ifx( (yyvsp[(4) - (5)].v.u.intval) < 0, "", "+" ), 
						(yyvsp[(4) - (5)].v.u.intval) 
					);
					(yyval.idStr) = hlastrdup2( StaticName );
					
				_else
				
					sprintf
					( 
						StaticName, 
						"(%s%s%d)", 
						sList->StaticName, 
						_ifx( (yyvsp[(4) - (5)].v.u.intval) < 0, "", "+" ), 
						(yyvsp[(4) - (5)].v.u.intval) 
					);
					(yyval.idStr) = hlastrdup2( StaticName );
					
				_endif
				
			_endif
			free2( vss (yyvsp[(2) - (5)].idStr) );
			FreeValue( YYS &(yyvsp[(4) - (5)].v) );
			_here;
		;}
    break;

  case 1346:

/* Line 1464 of yacc.c  */
#line 61186 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = hlastrdup2( (yyvsp[(2) - (2)].s)->StaticName );
			_here;
		;}
    break;

  case 1347:

/* Line 1464 of yacc.c  */
#line 61202 "hlaparse.bsn"
    {
			char	StaticName[256];
			
			_here;
			_if( !IsOrdinal( (yyvsp[(4) - (5)].v.pType) ) || numBits32( YYS &(yyvsp[(4) - (5)].v) ) > 32 )

				yyerror( "Expected 32-bit ordinal type in index expression" );
			
			_endif
			sprintf
			( 
				StaticName, 
				"(%s%s%d)", 
				(yyvsp[(2) - (5)].s)->StaticName, 
				_ifx( (yyvsp[(4) - (5)].v.u.intval) < 0, "", "+" ), 
				(yyvsp[(4) - (5)].v.u.intval) 
			);
			(yyval.idStr) = hlastrdup2( StaticName );
			_here;
		;}
    break;

  case 1348:

/* Line 1464 of yacc.c  */
#line 61234 "hlaparse.bsn"
    {					/* $5 */

			char msg[ 256 ];
			char adrs[ 256 ];

			_here;
			_if( (yyvsp[(2) - (4)].s)->Fields == NULL );

				ErrorNear
				( 
					"Object is not class/record/union/namespace",
					(yyvsp[(2) - (4)].s)->TrueName,
						__LINE__,
						__FILE__
				);													   
				(yyval.idStr) = hlastrdup2( "" );

			_elseif( (yyvsp[(4) - (4)].dotName.Sym) == NULL )

				sprintf
				( 
					msg,
					"Symbol is not defined or is not a field of '%s'",
					(yyvsp[(2) - (4)].s)->TrueName
				);
				yyerror( msg );
				(yyval.idStr) = hlastrdup2( "" );

			_else

				_if
				( 
						(yyvsp[(4) - (4)].dotName.StaticName) != NULL
					||	(yyvsp[(4) - (4)].dotName.Sym)->SymClass == cProc
				)
				
					sprintf
					(
						adrs,
						"(%s%s%d)",
						(yyvsp[(4) - (4)].dotName.StaticName),
						_ifx( (yyvsp[(4) - (4)].dotName.Disp) < 0, "", "+" ), 
						(yyvsp[(4) - (4)].dotName.Disp)

					);
					(yyval.idStr) = hlastrdup2( adrs );

				_elseif( (yyvsp[(2) - (4)].s)->SymClass == cStatic )

					assert( (yyvsp[(2) - (4)].s)->StaticName != NULL );
					sprintf
					(
						adrs,
						"(%s%s%d)",
						(yyvsp[(2) - (4)].s)->StaticName,
						_ifx( (yyvsp[(4) - (4)].dotName.Disp) < 0, "", "+" ), 
						(yyvsp[(4) - (4)].dotName.Disp)
					);

					(yyval.idStr) = hlastrdup2( adrs );
												  
				_else

					yyerror( "Illegal static symbol" );
					(yyval.idStr) = hlastrdup2( "" );

				_endif

			_endif
			free2( vss (yyvsp[(4) - (4)].dotName.FullName) );
			_here;
		;}
    break;

  case 1349:

/* Line 1464 of yacc.c  */
#line 61318 "hlaparse.bsn"
    {					/* $8 */

			char msg[ 256 ];
			char adrs[ 256 ];
			
			_here;
			_if( !IsOrdinal( (yyvsp[(6) - (7)].v.pType) ) || numBits32( YYS &(yyvsp[(6) - (7)].v) ) > 32 )

				yyerror( "Expected 32-bit ordinal type in index expression" );
			
			_endif
			_if( (yyvsp[(2) - (7)].s)->Fields == NULL );

				ErrorNear
				( 
					"Object is not class/record/union/namespace",
					(yyvsp[(2) - (7)].s)->TrueName,
						__LINE__,
						__FILE__
				);
				(yyval.idStr) = hlastrdup2( "" );

			_elseif( (yyvsp[(4) - (7)].dotName.Sym) == NULL )

				sprintf
				( 
					msg,
					"Symbol is not defined or is not a field of '%s'",
					(yyvsp[(2) - (7)].s)->TrueName
				);
				yyerror( msg );
				(yyval.idStr) = hlastrdup2( "" );

			_else

				_if
				( 
						(yyvsp[(4) - (7)].dotName.StaticName) != NULL
					||	(yyvsp[(4) - (7)].dotName.Sym)->SymClass == cProc
				)
				
					sprintf
					(
						adrs,
						"(%s%s%d)",
						(yyvsp[(4) - (7)].dotName.StaticName),
						_ifx( (yyvsp[(4) - (7)].dotName.Disp) < 0, "", "+" ), 
						(yyvsp[(4) - (7)].dotName.Disp) + (yyvsp[(6) - (7)].v.u.unsval)
					);
					(yyval.idStr) = hlastrdup2( adrs );

				_elseif( (yyvsp[(2) - (7)].s)->SymClass == cStatic )

					assert( (yyvsp[(2) - (7)].s)->StaticName != NULL );
					sprintf
					(
						adrs,
						"(%s%s%d)",
						(yyvsp[(2) - (7)].s)->StaticName,
						_ifx( (yyvsp[(4) - (7)].dotName.Disp) < 0, "", "+" ), 
						(yyvsp[(4) - (7)].dotName.Disp) + (yyvsp[(6) - (7)].v.u.unsval)
					);
					(yyval.idStr) = hlastrdup2( adrs );
												  
				_else

					yyerror( "Illegal static symbol" );
					(yyval.idStr) = hlastrdup2( "" );

				_endif

			_endif
			free2( vss (yyvsp[(4) - (7)].dotName.FullName) );
			FreeValue( YYS &(yyvsp[(6) - (7)].v) );
			_here;
		;}
    break;

  case 1350:

/* Line 1464 of yacc.c  */
#line 61403 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1351:

/* Line 1464 of yacc.c  */
#line 61411 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1352:

/* Line 1464 of yacc.c  */
#line 61419 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1353:

/* Line 1464 of yacc.c  */
#line 61427 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1354:

/* Line 1464 of yacc.c  */
#line 61435 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1355:

/* Line 1464 of yacc.c  */
#line 61443 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1356:

/* Line 1464 of yacc.c  */
#line 61451 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1357:

/* Line 1464 of yacc.c  */
#line 61459 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1358:

/* Line 1464 of yacc.c  */
#line 61467 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1359:

/* Line 1464 of yacc.c  */
#line 61475 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1360:

/* Line 1464 of yacc.c  */
#line 61483 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1361:

/* Line 1464 of yacc.c  */
#line 61491 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1362:

/* Line 1464 of yacc.c  */
#line 61499 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1363:

/* Line 1464 of yacc.c  */
#line 61507 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1364:

/* Line 1464 of yacc.c  */
#line 61518 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1365:

/* Line 1464 of yacc.c  */
#line 61527 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_here;
		;}
    break;

  case 1366:

/* Line 1464 of yacc.c  */
#line 61537 "hlaparse.bsn"
    {
			_here;
			(yyval.dotName.Sym) = (yyvsp[(0) - (0)].s);
			(yyval.dotName.Disp) = 0;
			_if( (yyvsp[(0) - (0)].s) != NULL )

				(yyval.dotName.StaticName) = (yyvsp[(0) - (0)].s)->StaticName;

			_else

				(yyval.dotName.StaticName) = NULL;

			_endif
			_here;
		;}
    break;

  case 1367:

/* Line 1464 of yacc.c  */
#line 61589 "hlaparse.bsn"
    {

			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			_here;
		;}
    break;

  case 1368:

/* Line 1464 of yacc.c  */
#line 61597 "hlaparse.bsn"
    {
			char msg[ 256 ];
			
			   
			sprintf
			(
				msg,
				"<<%s>> must be a const or val identifier",
				(yyvsp[(1) - (1)].s)->TrueName
			);
			yyerror( msg );

			/*
			** Return an arbitrary constant value (error)
			** just to ensure the integrity of this attribute
			** for the calling code.
			*/

			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);
			_here;
		;}
    break;

  case 1369:

/* Line 1464 of yacc.c  */
#line 61627 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			_here;
		;}
    break;

  case 1370:

/* Line 1464 of yacc.c  */
#line 61635 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(2) - (2)].v), sizeofSymNode );
			_here;
		;}
    break;

  case 1371:

/* Line 1464 of yacc.c  */
#line 61667 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(2) - (3)].v), sizeofSymNode );
			_here;

		;}
    break;

  case 1372:

/* Line 1464 of yacc.c  */
#line 61678 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			_here;

		;}
    break;

  case 1373:

/* Line 1464 of yacc.c  */
#line 61698 "hlaparse.bsn"
    {
			SymNode_t *sym;
			
			_here;
			(yyval.v.u.strval) = (yyvsp[(1) - (1)].idStr);
			assert( (yyval.v.u.strval) != NULL );
			
			sym = lookup( (yyvsp[(1) - (1)].idStr), 1 );
			_if( sym != NULL )
			
				SetReferenced( sym );
				
			_endif
			(yyval.v.SymClass) = cConstant;
			(yyval.v.pType) = tPointer;
			(yyval.v.Type) = &pointer_ste;
			(yyval.v.Base) = &byte_ste;
			_here;
		;}
    break;

  case 1374:

/* Line 1464 of yacc.c  */
#line 61723 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.strval) = NullPointer;
			(yyval.v.SymClass) = cConstant;
			(yyval.v.pType) = tPointer;
			(yyval.v.Type) = &pointer_ste;
			(yyval.v.Base) = NULL;
			_here;
		;}
    break;

  case 1375:

/* Line 1464 of yacc.c  */
#line 61747 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			_here;
		;}
    break;

  case 1376:

/* Line 1464 of yacc.c  */
#line 61754 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			_here;
		;}
    break;

  case 1377:

/* Line 1464 of yacc.c  */
#line 61761 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			_here;
		;}
    break;

  case 1378:

/* Line 1464 of yacc.c  */
#line 61768 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			_here;
		;}
    break;

  case 1379:

/* Line 1464 of yacc.c  */
#line 61775 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			_here;
		;}
    break;

  case 1380:

/* Line 1464 of yacc.c  */
#line 61782 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			_here;
		;}
    break;

  case 1381:

/* Line 1464 of yacc.c  */
#line 61804 "hlaparse.bsn"
    {
			_here;

			/*
			** Okay, we've got an identifier that is either
			** a cConstant or cValue object.  Pass along the
			** appropriate information to the calling code.
			*/

			_if
			( 
					(yyvsp[(1) - (1)].s)->pType == tString 
				||	(yyvsp[(1) - (1)].s)->pType == tZString 
				||	(yyvsp[(1) - (1)].s)->pType == tText 
			)
			
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste, 
					YYS &true_ste
				);
				(yyval.v.u.strval) = hlastrdup2( (yyvsp[(1) - (1)].s)->u.strval );

			_else

				DeepCopy( &(yyval.v), (yyvsp[(1) - (1)].s) );

			_endif
			_here;
		;}
    break;

  case 1382:

/* Line 1464 of yacc.c  */
#line 61844 "hlaparse.bsn"
    {

			yyerror( "Undefined symbol" );

			/*
			** Since we're in ConstExpr, the caller might expect
			** us to return an actual defined object at this point.
			** Let's create a dummy one to avoid program errors.
			** Note that this may cause some cascading errors if
			** the user actually defines this symbol later in this
			** current declaration section.
			*/

			memcpy( &(yyval.v), &true_ste, sizeofSymNode );
			_here;

		;}
    break;

  case 1383:

/* Line 1464 of yacc.c  */
#line 61881 "hlaparse.bsn"
    {
			_here;
			DeepCopy( &(yyval.v), &(yyvsp[(1) - (1)].v) );
			_here;
		;}
    break;

  case 1384:

/* Line 1464 of yacc.c  */
#line 61898 "hlaparse.bsn"
    {
			_here;
			DeepCopy( &(yyval.v), &(yyvsp[(1) - (1)].v) );
			_here;
		;}
    break;

  case 1385:

/* Line 1464 of yacc.c  */
#line 61919 "hlaparse.bsn"
    {

			_here;

			/*
			** Begin by creating the dimension array
			** (the dope vector).  This will be a
			** single element array whose sole element
			** contains NumElements.
			*/

			(yyval.v.Dimensions) = (yyvsp[(1) - (1)].v.Dimensions);

			/*
			** Now pass the array's data on.
			*/

			(yyval.v.u.ArrayOfValues) = (yyvsp[(1) - (1)].v.u.ArrayOfValues);

			/*
			** Set up the other important attribute fields.
			*/

			(yyval.v.pType) = tArray;
			(yyval.v.SymClass) = cConstant;

			(yyval.v.Type) = (yyvsp[(1) - (1)].v.Type);
			(yyval.v.Base) = (yyvsp[(1) - (1)].v.Base);
			(yyval.v.Fields) = (yyvsp[(1) - (1)].v.Fields);
			(yyval.v.FieldCnt) = (yyvsp[(1) - (1)].v.FieldCnt);
			(yyval.v.Arity) = (yyvsp[(1) - (1)].v.Arity);
			(yyval.v.NumElements) = (yyvsp[(1) - (1)].v.NumElements);
			_here;
		;}
    break;

  case 1386:

/* Line 1464 of yacc.c  */
#line 61970 "hlaparse.bsn"
    {
			_here;

			assert( (yyvsp[(1) - (4)].s) != NULL );

			/*
			** Initialize the global RecordValues object so the
			** recursive invocations of RecordList have unfettered access.
			** Note that the Arity field (normally unused for record
			** objects) is used as a "temporary" variable by this code.
			** Arity holds an integer specifying the current field
			** we're processing.
			**
			**	Note: the following malloc allocates one extra entry
			**	just in case the TypeID object is not a record object
			**	(meaning FieldCnt will be zero).  The error will be
			**	caught later, but we don't want malloc to return NULL
			**	just because we didn't allocate any storage. 
			*/

			RecordValues->v.u.FieldValues = 
				malloc2( ( (yyvsp[(1) - (4)].s)->FieldCnt + 1 ) * sizeofSymNode );
			RecordValues->v.FieldCnt = (yyvsp[(1) - (4)].s)->FieldCnt;
			RecordValues->v.Arity = 0;


			/*
			** If TypeID is a valid record type identifier, then
			** pass a pointer to the symbol table entry of the
			** last field in the record as an inherited attribute
			** to the RecordList non-terminal.
			**
			** If TypeID is not a valid record type, pass any old
			** junk (just to cause a failure) as the inherited attribute.
			*/


			_if
			( 
					(yyvsp[(1) - (4)].s)->pType == tRecord 
				||	(yyvsp[(1) - (4)].s)->pType == tUnion 
				||	(yyvsp[(1) - (4)].s)->pType == tReal128 
			)

				(yyval.s) = (yyvsp[(1) - (4)].s)->Fields;

			_else

				(yyval.s) = &UndefinedType;

			_endif
			_here;
		;}
    break;

  case 1387:

/* Line 1464 of yacc.c  */
#line 62025 "hlaparse.bsn"
    {
			
			_here;
			_if( (yyvsp[(1) - (7)].s)->pType == tUnion || (yyvsp[(6) - (7)].v.pType) == tUnion )

				ErrorNear
				( 
					"Union constants do not take this form", 
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);

			_elseif( (yyvsp[(1) - (7)].s)->pType == tReal128 || (yyvsp[(6) - (7)].v.pType) == tReal128 )

				ErrorNear
				( 
					"Real128 constants do not take this form", 
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);

			_elseif( (yyvsp[(1) - (7)].s)->pType != tRecord || (yyvsp[(6) - (7)].v.pType) != tRecord )

				ErrorNear
				(  
					"Illegal record type", 
					(yyvsp[(1) - (7)].s)->TrueName,
					__LINE__,
					__FILE__ 
				);

				/*
				** Generate some quasi-safe record constant:
				*/

				memcpy( &(yyval.v), &error_ste, sizeofSymNode );


			_else

				memcpy( &(yyval.v), (yyvsp[(1) - (7)].s), sizeofSymNode );
				(yyval.v.pType) = tRecord;
				(yyval.v.Type) = GetBaseType( (yyvsp[(1) - (7)].s) );
				(yyval.v.SymClass)	= cConstant;
				(yyval.v.u.FieldValues) = RecordValues->v.u.FieldValues;

			_endif

			/*
			** Restore the global RecordValues object.
			*/

			memcpy
			(
				RecordValues,
				&(yyvsp[(4) - (7)].v),
				sizeofSymNode
			);
			(void) (yyvsp[(5) - (7)].s);	// shut up bison
			_here;

		;}
    break;

  case 1388:

/* Line 1464 of yacc.c  */
#line 62108 "hlaparse.bsn"
    {
			int				i;
			int				fieldIndex;
			SymNode_t 		*field;
			SymNode_t 		*theField;
			SymNode_t 		*s;
			char			lcName[256];
			char			msg[ 256 ];
			int				pType;
				
			_here;
			assert( (yyvsp[(1) - (7)].s) != NULL );
			assert( (yyvsp[(3) - (7)].neID.idStr) != NULL );
			
			pType = (yyvsp[(1) - (7)].s)->pType;
			_if( pType == tUnion || pType == tReal128 )

				strcpy( lcName, (yyvsp[(3) - (7)].neID.idStr) );
				lowercase( lcName );
				
				// We've got a union or real128 constant.
				// Allocate storage for all the fields
				// even though we only use one at a time
				// (this is done to keep things general).
				// Note that, unlike records, HLA stores
				// the value entries in the FieldValues
				// array in reverse order so that their
				// indexes match the entries in the field
				// list (this is called "live and learn"
				// since I learned from the kludge that
				// the record stuff became).
				
				s = (yyvsp[(1) - (7)].s)->Type;
				_if( s == NULL )
				
					(yyvsp[(1) - (7)].s)->Type = (yyvsp[(1) - (7)].s);
					
				_endif
				ClrConst
				(
					YYS &(yyval.v),
					pType,
					(yyvsp[(1) - (7)].s)
				);
				(yyvsp[(1) - (7)].s)->Type = s;
				
				// Allocate storage to hold all the fields:
				
				(yyval.v.u.FieldValues) = 
					malloc2( (yyvsp[(1) - (7)].s)->FieldCnt * sizeofSymNode );
					
				// Initialize the field we just allocated and
				// give it a default type in case we have an error.
				
				field = (yyvsp[(1) - (7)].s)->Fields;
				assert( field != NULL );
				fieldIndex = -1;
				_for( i=0, i < (yyvsp[(1) - (7)].s)->FieldCnt, ++i )
				
					// Initialize this guy, in case we're not using it:
					
					ClrConst
					(
						YYS &(yyval.v.u.FieldValues)[i],
						field->pType,
						field->Type
					);
					
					// See if the current field is the field
					// we're searching for.
					
					_if( _streq( lcName, field->Name ))
					
						fieldIndex = i;		// Save field index.
						theField = field;	// Save ptr to field.
						
						// Handle case neutrality check:
						
						_if( _strne( (yyvsp[(3) - (7)].neID.idStr), field->TrueName ))
						
							sprintf
							(
								msg,
								"Mispelled identifier %s, perhaps "
								"you meant %s",
								(yyvsp[(3) - (7)].neID.idStr),
								field->TrueName
							);
							yyerror( msg );
							
						_endif
						
					_endif
					
					_if( field->pType == tAnonRec )
					
						yyerror
						( 
							"Union constants are illegal if an "
							"anonymous record is present in the union"
						);
						
					_endif;
					
					field = field->Next;
					
				_endfor
				
				_if( fieldIndex == -1 )
				
					sprintf
					(
						msg,
						"Field %s is not a member of union/real128 %s",
						(yyvsp[(3) - (7)].neID.idStr),
						(yyvsp[(1) - (7)].s)->TrueName
					);
					
				_else
					
					assert( theField->Type != NULL );
					_if( FieldsAreCompatible( theField, YYS &(yyvsp[(6) - (7)].v) ))
				
						// Okay, initialize the union/real128 constant:

						memcpy
						( 
							&(yyval.v.u.FieldValues)[fieldIndex], 
							&(yyvsp[(6) - (7)].v), 
							sizeofSymNode 
						);
						
						// Entry zero contains all the information for
						// the actual field we're initializing:
						
						(yyval.v.u.FieldValues)->pType = theField->pType;
						(yyval.v.u.FieldValues)->ObjectSize = 
							theField->ObjectSize;
						
						(yyval.v.u.FieldValues)->MaxObjectSize = 
							theField->MaxObjectSize;
							
						(yyval.v.u.FieldValues)->Type = theField->Type;
						(yyval.v.u.FieldValues)->Arity = theField->Arity;

						_if( theField->Dimensions == NULL )
						
						
							(yyval.v.u.FieldValues)->Dimensions = NULL;
							
						_else
						
							(yyval.v.u.FieldValues)->Dimensions =
								malloc2( theField->NumElements * sizeofInt );
							
							memcpy
							(
								(yyval.v.u.FieldValues)->Dimensions,  
								theField->Dimensions,
								theField->NumElements * sizeofInt 
							);
							
						_endif

						(yyval.v.u.FieldValues)->NumElements = 
							theField->NumElements; 
							
						(yyval.v.u.FieldValues)->Fields = theField->Fields;
						(yyval.v.u.FieldValues)->Base = theField->Base;
						(yyval.v.u.FieldValues)->FieldCnt = theField->FieldCnt;
						
						// The CurField and CurIndex fields provide the
						// link to the actual data field of this union
						// constant where the current data can be found.
						
						(yyval.v.u.FieldValues)->CurField = theField;
						(yyval.v.u.FieldValues)->CurIndex = fieldIndex; 
						
						
						// Initialize the the main value's fields:
						
						(yyval.v.pType) = pType;
						(yyval.v.Type) = (yyvsp[(1) - (7)].s);
						(yyval.v.SymClass)	= cConstant;
						(yyval.v.Fields) = (yyvsp[(1) - (7)].s)->Fields;
						(yyval.v.Base) = (yyvsp[(1) - (7)].s)->Base;
						(yyval.v.FieldCnt) = (yyvsp[(1) - (7)].s)->FieldCnt;
						(yyval.v.CurField) = theField;
						(yyval.v.CurIndex) = fieldIndex; 
						
						
					_else
					
						assert( (yyvsp[(6) - (7)].v.Type) != NULL );
						sprintf
						(
							msg,
							"Type mismatch in field %s of union "
							"constant %s (expected %s, found %s)",
							theField->TrueName,
							(yyvsp[(1) - (7)].s)->TrueName,
							theField->Type->TrueName,
							(yyvsp[(6) - (7)].v.Type)->TrueName
						);
						yyerror( msg );
						
					_endif
					
				_endif					
					
			_else
			
				sprintf
				(
					msg,
					"Expected a union type rather than '%s'",
					(yyvsp[(1) - (7)].s)->TrueName
				);
				yyerror( msg );

			_endif
			free2( vss (yyvsp[(3) - (7)].neID.idStr) );
			_here;
		;}
    break;

  case 1389:

/* Line 1464 of yacc.c  */
#line 62342 "hlaparse.bsn"
    {
				_here;
				memcpy
				(
					&(yyval.v),
					RecordValues,
					sizeofSymNode
				);
				_here;
			;}
    break;

  case 1390:

/* Line 1464 of yacc.c  */
#line 62371 "hlaparse.bsn"
    {
			_here;
			(yyval.v.Type) = &string_ste;
			(yyval.v.pType) = tString;
			ClrArray( YYS &(yyval.v) );
			(yyval.v.u.strval) = (yyvsp[(1) - (1)].v.u.strval);
			_here;
		;}
    break;

  case 1391:

/* Line 1464 of yacc.c  */
#line 62381 "hlaparse.bsn"
    {
			_here;
			(yyval.v.Type) = &wstring_ste;
			(yyval.v.pType) = tWString;
			ClrArray( YYS &(yyval.v) );
			(yyval.v.u.strval) = (yyvsp[(1) - (1)].v.u.strval);
			_here;
		;}
    break;

  case 1392:

/* Line 1464 of yacc.c  */
#line 62396 "hlaparse.bsn"
    {
				_here;
				(yyval.v.Type) = &string_ste;
				(yyval.v.pType) = tString;
				(yyval.v.u.strval) = (yyvsp[(1) - (1)].v.u.strval);
				_here;
			;}
    break;

  case 1393:

/* Line 1464 of yacc.c  */
#line 62410 "hlaparse.bsn"
    {
				_here;
				(yyval.v.Type) = &string_ste;
				(yyval.v.pType) = tString;
				(yyval.v.u.strval) = malloc2( 3 );
				(yyval.v.u.strval)[ 0 ] = (yyvsp[(1) - (2)].v.u.charval);
				(yyval.v.u.strval)[ 1 ] = (yyvsp[(2) - (2)].v.u.charval);
				(yyval.v.u.strval)[ 2 ] = '\0';
				_here;
			;}
    break;

  case 1394:

/* Line 1464 of yacc.c  */
#line 62427 "hlaparse.bsn"
    {
				int len = strlen( (yyvsp[(1) - (2)].v.u.strval) );

				_here;
				(yyval.v.Type) = &string_ste;
				(yyval.v.pType) = tString;
				(yyval.v.u.strval) = malloc2( len + 2 );
				strcpy( (yyval.v.u.strval), (yyvsp[(1) - (2)].v.u.strval) );
				(yyval.v.u.strval)[ len ] =  (yyvsp[(2) - (2)].v.u.charval);
				(yyval.v.u.strval)[ len + 1 ] =  '\0';
				free2( vss (yyvsp[(1) - (2)].v.u.strval) );
				_here;
			;}
    break;

  case 1395:

/* Line 1464 of yacc.c  */
#line 62447 "hlaparse.bsn"
    {
				_here;
				(yyval.v.Type) = &string_ste;
				(yyval.v.pType) = tString;
				(yyval.v.u.strval) = malloc2( strlen( (yyvsp[(2) - (2)].v.u.strval) ) + 2 );

				(yyval.v.u.strval)[ 0 ] = (yyvsp[(1) - (2)].v.u.charval);
				strcpy( (yyval.v.u.strval) + 1, (yyvsp[(2) - (2)].v.u.strval) );

				free2( vss (yyvsp[(2) - (2)].v.u.strval) );
				_here;
			;}
    break;

  case 1396:

/* Line 1464 of yacc.c  */
#line 62466 "hlaparse.bsn"
    {
				_here;
				(yyval.v.Type) = &string_ste;
				(yyval.v.pType) = tString;
				(yyval.v.u.strval) = 
					malloc2
					( 
							strlen( (yyvsp[(1) - (2)].v.u.strval) )
						+	strlen( (yyvsp[(2) - (2)].v.u.strval) )
						+	1
					);

				assert( (yyval.v.u.strval) != NULL );
				strcpy( (yyval.v.u.strval), (yyvsp[(1) - (2)].v.u.strval) );
				strcat( (yyval.v.u.strval), (yyvsp[(2) - (2)].v.u.strval) );
				free2( vss (yyvsp[(1) - (2)].v.u.strval) );
				free2( vss (yyvsp[(2) - (2)].v.u.strval) );
				_here;
			;}
    break;

  case 1397:

/* Line 1464 of yacc.c  */
#line 62494 "hlaparse.bsn"
    {
				_here;
				(yyval.v.Type) = &wstring_ste;
				(yyval.v.pType) = tWString;
				(yyval.v.u.strval) = (yyvsp[(1) - (1)].v.u.strval);
				_here;
			;}
    break;

  case 1398:

/* Line 1464 of yacc.c  */
#line 62508 "hlaparse.bsn"
    {
				_here;
				(yyval.v.Type) = &wstring_ste;
				(yyval.v.pType) = tWString;
				(yyval.v.u.strval) = malloc2( 6 );
				(yyval.v.u.strval)[ 0 ] = (yyvsp[(1) - (2)].v.u.bytes)[0];
				(yyval.v.u.strval)[ 1 ] = (yyvsp[(1) - (2)].v.u.bytes)[1];
				(yyval.v.u.strval)[ 2 ] = (yyvsp[(2) - (2)].v.u.bytes)[0];
				(yyval.v.u.strval)[ 3 ] = (yyvsp[(2) - (2)].v.u.bytes)[1];
				(yyval.v.u.strval)[ 4 ] = '\0';
				(yyval.v.u.strval)[ 5 ] = '\0';
				_here;
			;}
    break;

  case 1399:

/* Line 1464 of yacc.c  */
#line 62528 "hlaparse.bsn"
    {
				int len = wstrlen( (yyvsp[(1) - (2)].v.u.strval) );

				_here;
				(yyval.v.Type) = &wstring_ste;
				(yyval.v.pType) = tWString;
				(yyval.v.u.strval) = malloc2( len + 2 );
				memcpy( (yyval.v.u.strval), (yyvsp[(1) - (2)].v.u.strval), len + 2 );
				(yyval.v.u.strval)[ len ] =  (yyvsp[(2) - (2)].v.u.bytes)[0];
				(yyval.v.u.strval)[ len + 1 ] =  (yyvsp[(2) - (2)].v.u.bytes)[1];
				(yyval.v.u.strval)[ len + 2 ] =  '\0';
				(yyval.v.u.strval)[ len + 3 ] =  '\0';
				free2( vss (yyvsp[(1) - (2)].v.u.strval) );
				_here;
			;}
    break;

  case 1400:

/* Line 1464 of yacc.c  */
#line 62550 "hlaparse.bsn"
    {
				int len;
				
				_here;
				len = wstrlen( (yyvsp[(2) - (2)].v.u.strval) );
				
				(yyval.v.Type) = &wstring_ste;
				(yyval.v.pType) = tWString;
				(yyval.v.u.strval) = malloc2( len );

				(yyval.v.u.strval)[ 0 ] = (yyvsp[(1) - (2)].v.u.bytes)[0];
				(yyval.v.u.strval)[ 1 ] = (yyvsp[(1) - (2)].v.u.bytes)[1];
				memcpy( (yyval.v.u.strval) + 2, (yyvsp[(2) - (2)].v.u.strval), len );

				free2( vss (yyvsp[(2) - (2)].v.u.strval) );
				_here;
			;}
    break;

  case 1401:

/* Line 1464 of yacc.c  */
#line 62574 "hlaparse.bsn"
    {
				int len1;
				int len2;
				
				_here;
				len1 = wstrlen( (yyvsp[(1) - (2)].v.u.strval) );
				len2 = wstrlen( (yyvsp[(2) - (2)].v.u.strval) );
				(yyval.v.Type) = &wstring_ste;
				(yyval.v.pType) = tWString;
				(yyval.v.u.strval) = malloc2( len1 + len2 );

				memcpy( (yyval.v.u.strval), (yyvsp[(1) - (2)].v.u.strval), len1 );
				memcpy( (yyval.v.u.strval)+len1-2, (yyvsp[(2) - (2)].v.u.strval), len2 );
				free2( vss (yyvsp[(1) - (2)].v.u.strval) );
				free2( vss (yyvsp[(2) - (2)].v.u.strval) );
				_here;
			;}
    break;

  case 1402:

/* Line 1464 of yacc.c  */
#line 62609 "hlaparse.bsn"
    {
			_here;
			ClrConst
			(
				YYS &(yyval.v),
				tDWord,
				&dword_ste
			);
			(yyval.v.u.unsval) = (yyvsp[(3) - (4)].v.u.unsval);
		;}
    break;

  case 1403:

/* Line 1464 of yacc.c  */
#line 62623 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.unsval) = 0;
		;}
    break;

  case 1404:

/* Line 1464 of yacc.c  */
#line 62629 "hlaparse.bsn"
    {
		 	_here;
		 	(yyval.v.u.unsval) = (yyvsp[(1) - (1)].v.u.unsval);
		;}
    break;

  case 1405:

/* Line 1464 of yacc.c  */
#line 62637 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.unsval) = (yyvsp[(1) - (1)].v.u.unsval);
		;}
    break;

  case 1406:

/* Line 1464 of yacc.c  */
#line 62645 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.unsval) = (yyvsp[(1) - (3)].v.u.unsval) | (yyvsp[(3) - (3)].v.u.unsval);
		;}
    break;

  case 1408:

/* Line 1464 of yacc.c  */
#line 62656 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					( !IsUns( (yyvsp[(1) - (1)].v.pType) ) && !IsBytes( (yyvsp[(1) - (1)].v.pType) ) )
				||	numBits32( YYS &(yyvsp[(1) - (1)].v) ) > 32
				||	(yyvsp[(1) - (1)].v.u.unsval) >= 32
			)
			
				yyerror( "Expected an integer value between 0 and 31" );
				(yyval.v.u.unsval) = 0;
				
			_else
			
				(yyval.v.u.unsval) = 1 << (yyvsp[(1) - (1)].v.u.unsval);

			_endif
			(yyval.v.pType) = tDWord;
		;}
    break;

  case 1409:

/* Line 1464 of yacc.c  */
#line 62688 "hlaparse.bsn"
    {
			_here;
			(yyval.v) = (yyvsp[(1) - (1)].v);
		;}
    break;

  case 1410:

/* Line 1464 of yacc.c  */
#line 62700 "hlaparse.bsn"
    {
				_here;
				(yyval.v.Type) = &cset_ste;
				(yyval.v.pType) = tCset;
				ClrArray( YYS &(yyval.v) );

				/*
				** Return the set constant prepared by the
				** SetItems productions.
				*/

				memcpy( &(yyval.v.u.csetval), &GlobalCset, CSetSizeInBytes );


				/*
				** PreserveGlobal pushed a copy of GlobalCset
				** onto the parser stack.  The following for
				** loop restores GlobalCset from that copy made.
				** The allows the use of the global value GlobalCset
				** in a reentrant fashion.
				*/

				memcpy( &GlobalCset, &(yyvsp[(2) - (5)].v.u.csetval), CSetSizeInBytes );
				_here;
			;}
    break;

  case 1416:

/* Line 1464 of yacc.c  */
#line 62752 "hlaparse.bsn"
    {
				_here;
				_if( (yyvsp[(0) - (0)].v.pType) == tString )
				
					char *str =(yyvsp[(0) - (0)].v.u.strval);
					_while( *str != '\0' )
					
						AddGlobalCset( *str );
						++str;
						
					_endwhile
					
				_elseif( (yyvsp[(0) - (0)].v.pType) == tChar )

					AddGlobalCset( (yyvsp[(0) - (0)].v.u.charval) );

				_else

					yyerror( "Only character constants allowed here" );

				_endif
				_here;
			;}
    break;

  case 1417:

/* Line 1464 of yacc.c  */
#line 62787 "hlaparse.bsn"
    {
				_here;
				_if( (yyvsp[(0) - (0)].v.pType) != tChar || (yyvsp[(-2) - (0)].v.pType) != tChar )
				
					yyerror( "Character set constructor requires char constants" );
					
				_endif
				_if( (yyvsp[(-2) - (0)].v.u.charval) > (yyvsp[(0) - (0)].v.u.charval) )

					yyerror( "Bad range for character set constant" );

				_endif
				_for
				( 
					unsigned char ch=(yyvsp[(-2) - (0)].v.u.charval), 
					ch <= (yyvsp[(0) - (0)].v.u.charval), 
					++ch 
				)
			
					_if( ch <= 127 )

						AddGlobalCset( ch );

					_else

						yyerror( "Charset range must be 0..127" );
						break;

					_endif
				
				_endfor
				_here;

				
			;}
    break;

  case 1418:

/* Line 1464 of yacc.c  */
#line 62829 "hlaparse.bsn"
    {	
				_here;
				memset( &GlobalCset, 0, CSetSizeInBytes );
				_here;

			;}
    break;

  case 1419:

/* Line 1464 of yacc.c  */
#line 62854 "hlaparse.bsn"
    {
				_here;
				memcpy( &(yyval.v.u.csetval), &GlobalCset, CSetSizeInBytes );
				_here;

			;}
    break;

  case 1420:

/* Line 1464 of yacc.c  */
#line 62880 "hlaparse.bsn"
    {
			SymNode_t v;

			_here;
			memcpy( &(yyval.v), &(yyvsp[(2) - (2)].v), sizeofSymNode );
			negval
			( 
				&(yyval.v.u.lwordval)[0], 
				&(yyvsp[(2) - (2)].v.u.lwordval)[0], 
				(yyvsp[(2) - (2)].v.pType), 
				&(yyval.v.pType), 
				&(yyval.v.Type) 
			);
			ClrArray( YYS &(yyval.v) );
			_here;
		;}
    break;

  case 1421:

/* Line 1464 of yacc.c  */
#line 62909 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(2) - (2)].v), sizeofSymNode );
			notval
			( 
				&(yyval.v.u.lwordval)[0], 
				&(yyvsp[(2) - (2)].v.u.lwordval)[0], 
				(yyvsp[(2) - (2)].v.pType), 
				&(yyval.v.pType), 
				&(yyval.v.Type) 
			);
			ClrArray( YYS &(yyval.v) );
			_here;
		;}
    break;

  case 1422:

/* Line 1464 of yacc.c  */
#line 62946 "hlaparse.bsn"
    {


			SymNode_t v;

			/*
			** Handle the special case where the left operand
			** is of the form "&ID" which can only be used as
			** an address in a static operand.
			*/

			_here;
			_if( (yyvsp[(1) - (3)].v.pType) == tPointer )

				_if
				( 
						IsOrdinal( (yyvsp[(3) - (3)].v.pType) )
					&&	numBits32( YYS &(yyvsp[(3) - (3)].v) ) <= 32
				)

					char temp[ 256 ];
					
					sprintf( temp, "%s+%u", (yyvsp[(1) - (3)].v.u.strval), (yyvsp[(3) - (3)].v.u.unsval) );
					(yyval.v.pType) = tPointer;
					(yyval.v.Type) = &pointer_ste;
					(yyval.v.SymClass) = cConstant;
					(yyval.v.u.strval) = hlastrdup2( temp );


				_else

					yyerror( "Illegal static address constant" );

				_endif
				free2( vss (yyvsp[(1) - (3)].v.u.strval) );


			/*
			** Next, see if the two operands are compatible
			** with one another or if we can make them compatible
			** with one another.
			*/

			_elseif( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))				
				
				/*
				** At this point, the objects are compatible with
				** one another, so we can use the type of either
				** operand to determine how to perform the "+"
				** operation.  
				*/

				_switch( (yyvsp[(1) - (3)].v.pType) )

					/* For numeric values, just do an addition.
					*/

					_case( tUns8 )
					_case( tUns16 )
					_case( tUns32 )
					_case( tUns64 )
					_case( tUns128 )
					_case( tByte )
					_case( tWord )
					_case( tDWord )
					_case( tQWord )
					_case( tTByte )
					_case( tLWord )
					_case( tInt8 )
					_case( tInt16 )
					_case( tInt32 )
					_case( tInt64 )
					_case( tInt128 )
					_case( tReal32 )
					_case( tReal64 )
					_case( tReal80 )
					_case( tCset )

						memcpy( &(yyval.v), &(yyvsp[(1) - (3)].v), sizeofSymNode );
						addval
						( 
							&(yyval.v.u.lwordval)[0], 
							&(yyvsp[(3) - (3)].v.u.lwordval)[0], 
							&(yyval.v.pType),
							&(yyval.v.Type) 
						);
						
					_endcase


					/*
					** For string operands, do string concat.
					*/

			    	_case( tString )
					{
						char *newstr;

						ClrConst
						( 
							YYS &(yyval.v), 
							tString, 
							&string_ste
						);
						newstr = 
							malloc2
							( 
									strlen( (yyvsp[(1) - (3)].v.u.strval) ) 
								+	strlen( (yyvsp[(3) - (3)].v.u.strval) )
								+	1
							);

						strcpy( newstr, (yyvsp[(1) - (3)].v.u.strval) );
						strcat( newstr, (yyvsp[(3) - (3)].v.u.strval) );
						(yyval.v.u.strval) = newstr;
						free2( vss (yyvsp[(1) - (3)].v.u.strval) );
						free2( vss (yyvsp[(3) - (3)].v.u.strval) );
					}
			    	_endcase
			    		
			    	_case( tZString )
					{
						char *newstr;

						ClrConst
						( 
							YYS &(yyval.v), 
							tZString, 
							&zstring_ste
						);
						newstr = 
							malloc2
							( 
									strlen( (yyvsp[(1) - (3)].v.u.strval) ) 
								+	strlen( (yyvsp[(3) - (3)].v.u.strval) )
								+	1
							);

						strcpy( newstr, (yyvsp[(1) - (3)].v.u.strval) );
						strcat( newstr, (yyvsp[(3) - (3)].v.u.strval) );
						(yyval.v.u.strval) = newstr;
						free2( vss (yyvsp[(1) - (3)].v.u.strval) );
						free2( vss (yyvsp[(3) - (3)].v.u.strval) );
					}
			    	_endcase
			    		
					/*
					** For character operands, do string concatenation.
					*/


			    	_case( tChar )
					{
						char *newstr;

						newstr = malloc2( 3 );


						/*
						** Alas, above we set the type of the
						** return value to tChar.  It really needs to
						** be of type string.  Correct that here.
						*/

						SetConst
						( 
							YYS &(yyval.v), 
							tString, 
							&string_ste,
							YYS &v
						);

						newstr[ 0 ] = (yyvsp[(1) - (3)].v.u.charval);
						newstr[ 1 ] = (yyvsp[(3) - (3)].v.u.charval);
						newstr[ 2 ] = '\0';
						(yyval.v.u.strval) = newstr;

					}
			    	_endcase
			    		

					_default

						yyerror( "Illegal operand types" );
						SetConst
						( 
							YYS &(yyval.v), 
							tBoolean, 
							&boolean_ste,
							YYS &v
						);
				

				_endswitch

			_else

				yyerror( "Type mismatch in operands" );
				SetConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste,
					YYS &v
				);
				
			_endif
			_here;

		;}
    break;

  case 1423:

/* Line 1464 of yacc.c  */
#line 63185 "hlaparse.bsn"
    {
				SymNode_t v;

				_here;
				
				/*
				** Handle the special case where the left operand
				** is of the form "@ID" which can only be used as
				** an address in a static operand.
				*/

				_if( (yyvsp[(1) - (3)].v.pType) == tPointer )

					_if( IsOrdinal( (yyvsp[(3) - (3)].v.pType) ) && numBits( YYS &(yyvsp[(3) - (3)].v) ) <= 32 )

						char temp[ 256 ];
						
						sprintf( temp, "%s-%u", (yyvsp[(1) - (3)].v.u.strval), (yyvsp[(3) - (3)].v.u.unsval) );
						(yyval.v.pType) = tPointer;
						(yyval.v.Type) = &pointer_ste;
						(yyval.v.SymClass) = cConstant;
						(yyval.v.u.strval) = hlastrdup2( temp );


					_else

						yyerror( "Illegal static address constant" );

					_endif
					free2( vss (yyvsp[(1) - (3)].v.u.strval) );

				_elseif( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					_here;
					SetConst
					( 
						YYS &(yyval.v), 
						(yyvsp[(1) - (3)].v.pType), 
						(yyvsp[(1) - (3)].v.Type),
						YYS &v				/* Dummy value */
					);

					_switch( (yyvsp[(1) - (3)].v.pType) )

						/*
						** For the numeric types, do subtraction.
						*/

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )
						_case( tQWord )
						_case( tTByte )
						_case( tLWord )
						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )
						_case( tReal32 )
						_case( tReal64 )
						_case( tReal80 )
  			    		_case( tCset )

							_here;
							memcpy( &(yyval.v), &(yyvsp[(1) - (3)].v), sizeofSymNode );
							subval
							( 
								&(yyval.v.u.lwordval)[0], 
								&(yyvsp[(3) - (3)].v.u.lwordval)[0], 
								&(yyval.v.pType),
								&(yyval.v.Type) 
							);
							_here;
						

						_endcase

						_default

							yyerror( "Illegal operand types" );
							ClrConst
							(
								YYS &(yyval.v),
								tUns32,
								&uns32_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					(
						YYS &(yyval.v),
						tUns32,
						&uns32_ste
					);


				_endif
				_here;

			;}
    break;

  case 1424:

/* Line 1464 of yacc.c  */
#line 63324 "hlaparse.bsn"
    {

			SymNode_t v;

			_here;
			_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

				_switch( (yyvsp[(1) - (3)].v.pType) )

					/*
					** For numeric operands, compute the product.
					*/

					_case( tUns8 )
					_case( tUns16 )
					_case( tUns32 )
					_case( tUns64 )
					_case( tUns128 )
					_case( tByte )
					_case( tWord )
					_case( tDWord )
					_case( tQWord )
					_case( tTByte )
					_case( tLWord )
					_case( tInt8 )
					_case( tInt16 )
					_case( tInt32 )
					_case( tInt64 )
					_case( tInt128 )
					_case( tReal32 )
					_case( tReal64 )
					_case( tReal80 )
			    	_case( tCset )
					
						memcpy( &(yyval.v), &(yyvsp[(1) - (3)].v), sizeofSymNode );
						mulval
						( 
							&(yyval.v.u.lwordval)[0], 
							&(yyvsp[(3) - (3)].v.u.lwordval)[0], 
							&(yyval.v.pType),
							&(yyval.v.Type) 
						);
					

					_endcase

					_default

						yyerror( "Illegal operand types" );
						ClrConst
						(
							YYS &(yyval.v),
							tUns32,
							&uns32_ste
						);

				_endswitch

			_else

				yyerror( "Type mismatch in operands" );
				ClrConst
				(
					YYS &(yyval.v),
					tUns32,
					&uns32_ste
				);

			_endif
			_here;
		;}
    break;

  case 1425:

/* Line 1464 of yacc.c  */
#line 63421 "hlaparse.bsn"
    {

			// If the left operand is not real80, convert it
			// to real80 (if possible, print an error if not).
			
			_here;
			_if( !IsCompatible( &real80_ste, YYS &(yyvsp[(1) - (3)].v) ) )
				
				yyerror
				( 
					"Left operand to '/' is incompatible with REAL80 type"
				);
				(yyvsp[(1) - (3)].v.u.lwordval)[0] = 1;
				(yyvsp[(1) - (3)].v.u.lwordval)[1] = 0;
				(yyvsp[(1) - (3)].v.u.lwordval)[2] = 0;
				(yyvsp[(1) - (3)].v.u.lwordval)[3] = 0;
				(yyvsp[(1) - (3)].v.pType) = tUns8;
				(yyvsp[(1) - (3)].v.Type) = &uns8_ste;
				
				// Force '1' to real:
				
				IsCompatible( &real80_ste, YYS &(yyvsp[(1) - (3)].v) );
				
			_endif;

			// If the right operand is not real80, convert it
			// to real80 (if possible, print an error if not).
			
			_if( !IsCompatible( &real80_ste, YYS &(yyvsp[(3) - (3)].v) ) )
				
				yyerror
				( 
					"Right operand to '/' is incompatible with REAL80 type"
				);
				(yyvsp[(3) - (3)].v.u.lwordval)[0] = 1;
				(yyvsp[(3) - (3)].v.u.lwordval)[1] = 0;
				(yyvsp[(3) - (3)].v.u.lwordval)[2] = 0;
				(yyvsp[(3) - (3)].v.u.lwordval)[3] = 0;
				(yyvsp[(1) - (3)].v.pType) = tUns8;
				(yyvsp[(1) - (3)].v.Type) = &uns8_ste;
				
				// Force '1' to real:
				
				IsCompatible( &real80_ste, YYS &(yyvsp[(1) - (3)].v) );
				
			_endif;

			_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

				// At this point, both operands are
				// real80, so do the division:
				
				memcpy( &(yyval.v), &(yyvsp[(1) - (3)].v), sizeofSymNode );
				divval
				( 
					&(yyval.v.u.lwordval)[0], 
					&(yyvsp[(3) - (3)].v.u.lwordval)[0], 
					&(yyval.v.pType),
					&(yyval.v.Type) 
				);
				


			_else

				yyerror( "Type mismatch in operands" );
				ClrConst
				(
					YYS &(yyval.v), 
					tUns32, 
					&uns32_ste
				);

			_endif
			_here;
		;}
    break;

  case 1426:

/* Line 1464 of yacc.c  */
#line 63519 "hlaparse.bsn"
    {
				SymNode_t v;

				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					_switch( (yyvsp[(1) - (3)].v.pType) )

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )
						_case( tQWord )
						_case( tTByte )
						_case( tLWord )
						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )

							memcpy( &(yyval.v), &(yyvsp[(1) - (3)].v), sizeofSymNode );
							divval
							( 
								&(yyval.v.u.lwordval)[0], 
								&(yyvsp[(3) - (3)].v.u.lwordval)[0], 
								&(yyval.v.pType),
								&(yyval.v.Type) 
							);

						_endcase
						
						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							(
								YYS &(yyval.v),
								tUns32,
								&uns32_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					(
						YYS &(yyval.v), 
						tUns32, 
						&uns32_ste
					);

				_endif
				_here;

			;}
    break;

  case 1427:

/* Line 1464 of yacc.c  */
#line 63605 "hlaparse.bsn"
    {
				SymNode_t v;
				
				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					_switch( (yyvsp[(1) - (3)].v.pType) )

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )
						_case( tQWord )
						_case( tTByte )
						_case( tLWord )
						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )


							memcpy( &(yyval.v), &(yyvsp[(1) - (3)].v), sizeofSymNode );
							modval
							( 
								&(yyval.v.u.lwordval)[0], 
								&(yyvsp[(3) - (3)].v.u.lwordval)[0], 
								&(yyval.v.pType),
								&(yyval.v.Type) 
							);

						_endcase

						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							(
								YYS &(yyval.v),
								tUns32,
								&uns32_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					(
						YYS &(yyval.v), 
						tUns32, 
						&uns32_ste
					);

				_endif
				_here;
			;}
    break;

  case 1428:

/* Line 1464 of yacc.c  */
#line 63686 "hlaparse.bsn"
    {
				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					ClrConst
					( 
						YYS &(yyval.v), 
						(yyvsp[(1) - (3)].v.pType), 
						(yyvsp[(1) - (3)].v.Type)			/* Dummy value */
					);

					_switch( (yyvsp[(1) - (3)].v.pType) )

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )
						_case( tQWord )
						_case( tTByte )
						_case( tLWord )

							(yyval.v.u.lwordval)[0] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[0] & (yyvsp[(3) - (3)].v.u.lwordval)[0];

							(yyval.v.u.lwordval)[1] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[1] & (yyvsp[(3) - (3)].v.u.lwordval)[1];

							(yyval.v.u.lwordval)[2] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[2] & (yyvsp[(3) - (3)].v.u.lwordval)[2];

							(yyval.v.u.lwordval)[3] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[3] & (yyvsp[(3) - (3)].v.u.lwordval)[3];
								
							compactType
							( 
								&(yyval.v.u.lwordval), 
								&(yyval.v.pType), 
								&(yyval.v.Type) 
							);
							(yyval.v.ObjectSize) = (yyval.v.Type)->ObjectSize;


						_endcase

						_case( tBoolean )

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.boolval) && (yyvsp[(3) - (3)].v.u.boolval);

						_endcase

						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							(
								YYS &(yyval.v),
								tUns32,
								&uns32_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					(
						YYS &(yyval.v), 
						tUns32, 
						&uns32_ste
					);

				_endif
				_here;
			;}
    break;

  case 1429:

/* Line 1464 of yacc.c  */
#line 63775 "hlaparse.bsn"
    {

				SymNode_t v;

				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					SetConst
					( 
						YYS &(yyval.v), 
						(yyvsp[(1) - (3)].v.pType), 
						(yyvsp[(1) - (3)].v.Type),
						YYS &v	/* Dummy value */
					);

					_switch( (yyvsp[(1) - (3)].v.pType) )

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )
						_case( tQWord )
						_case( tTByte )
						_case( tLWord )

							(yyval.v.u.lwordval)[0] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[0] | (yyvsp[(3) - (3)].v.u.lwordval)[0];

							(yyval.v.u.lwordval)[1] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[1] | (yyvsp[(3) - (3)].v.u.lwordval)[1];

							(yyval.v.u.lwordval)[2] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[2] | (yyvsp[(3) - (3)].v.u.lwordval)[2];

							(yyval.v.u.lwordval)[3] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[3] | (yyvsp[(3) - (3)].v.u.lwordval)[3];

							compactType
							( 
								&(yyval.v.u.lwordval), 
								&(yyval.v.pType), 
								&(yyval.v.Type) 
							);
							(yyval.v.ObjectSize) = (yyval.v.Type)->ObjectSize;

						_endcase

						_case( tBoolean )

							(yyval.v.u.boolval) = 
								(yyvsp[(1) - (3)].v.u.boolval) || (yyvsp[(3) - (3)].v.u.boolval);

						_endcase

						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							(
								YYS &(yyval.v),
								tUns32,
								&uns32_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					(
						YYS &(yyval.v), 
						tUns32, 
						&uns32_ste
					);

				_endif
				_here;
			;}
    break;

  case 1430:

/* Line 1464 of yacc.c  */
#line 63868 "hlaparse.bsn"
    {

				SymNode_t v;

				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					ClrConst
					( 
						YYS &(yyval.v), 
						(yyvsp[(1) - (3)].v.pType), 
						(yyvsp[(1) - (3)].v.Type)
					);

					_switch( (yyvsp[(1) - (3)].v.pType) )

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )
						_case( tQWord )
						_case( tTByte )
						_case( tLWord )

							(yyval.v.u.lwordval)[0] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[0] ^ (yyvsp[(3) - (3)].v.u.lwordval)[0];

							(yyval.v.u.lwordval)[1] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[1] ^ (yyvsp[(3) - (3)].v.u.lwordval)[1];

							(yyval.v.u.lwordval)[2] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[2] ^ (yyvsp[(3) - (3)].v.u.lwordval)[2];

							(yyval.v.u.lwordval)[3] = 
								(yyvsp[(1) - (3)].v.u.lwordval)[3] ^ (yyvsp[(3) - (3)].v.u.lwordval)[3];

							compactType
							( 
								&(yyval.v.u.lwordval), 
								&(yyval.v.pType), 
								&(yyval.v.Type) 
							);
							(yyval.v.ObjectSize) = (yyval.v.Type)->ObjectSize;

						_endcase

						_case( tBoolean )

							(yyval.v.u.boolval) = 
									( (yyvsp[(1) - (3)].v.u.boolval) != 0 )
								^	( (yyvsp[(3) - (3)].v.u.boolval) != 0 );

						_endcase

						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							(
								YYS &(yyval.v),
								tUns32,
								&uns32_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					(
						YYS &(yyval.v), 
						tUns32, 
						&uns32_ste
					);

				_endif
				_here;
			;}
    break;

  case 1431:

/* Line 1464 of yacc.c  */
#line 63975 "hlaparse.bsn"
    {

			SymNode_t v;
			
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (3)].v), sizeofSymNode );
			
			_if
			( 
					IsNumber( (yyvsp[(3) - (3)].v.pType) )
				&&	(yyvsp[(3) - (3)].v.u.lwordval)[0] <= 128
				&&	(yyvsp[(3) - (3)].v.u.lwordval)[1] == 0 
				&&	(yyvsp[(3) - (3)].v.u.lwordval)[1] == 0 
				&&	(yyvsp[(3) - (3)].v.u.lwordval)[1] == 0
			)
			
				_if( IsNumber( (yyvsp[(1) - (3)].v.pType) ))
				
					shlval
					( 
						&(yyval.v.u.lwordval)[0],
						&(yyvsp[(3) - (3)].v.u.lwordval)[0], 
						&(yyval.v.pType), 
						&(yyval.v.Type) 
					);
									
				_else
				
					yyerror( "Shift operands must be integers" );
					
				_endif
			
			
			_else
			
				yyerror
				( 
					"Shift count must be an integer in the range 0..128"
				);
				
			_endif
			_here;
		;}
    break;

  case 1432:

/* Line 1464 of yacc.c  */
#line 64031 "hlaparse.bsn"
    {

			SymNode_t v;

			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (3)].v), sizeofSymNode );
			
			_if
			( 
					IsNumber( (yyvsp[(3) - (3)].v.pType) )
				&&	(yyvsp[(3) - (3)].v.u.lwordval)[0] <= 128
				&&	(yyvsp[(3) - (3)].v.u.lwordval)[1] == 0 
				&&	(yyvsp[(3) - (3)].v.u.lwordval)[1] == 0 
				&&	(yyvsp[(3) - (3)].v.u.lwordval)[1] == 0
			)
			
				_if( IsNumber( (yyvsp[(1) - (3)].v.pType) ))
				
					shrval
					( 
						&(yyval.v.u.lwordval)[0],
						&(yyvsp[(3) - (3)].v.u.lwordval)[0], 
						&(yyval.v.pType), 
						&(yyval.v.Type) 
					);
									
				_else
				
					yyerror( "Shift operands must be integers" );
					
				_endif
			
			
			_else
			
				yyerror
				( 
					"Shift count must be an integer in the range 0..128"
				);
				
			_endif
			_here;
		;}
    break;

  case 1433:

/* Line 1464 of yacc.c  */
#line 64089 "hlaparse.bsn"
    {

				/*
				** If the operand types are different, see if we
				** can coerce them to be the same.
				*/

				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					/*
					** Initialize the fields of the return result.
					** Type is always boolean, default to true...
					*/

					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

					_switch( (yyvsp[(1) - (3)].v.pType) )

						/*
						** Compare ordinal types here.
						*/

						_case( tEnum )						

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.unsval) == (yyvsp[(3) - (3)].v.u.unsval);
							
						_endcase


						_case( tBoolean )
						_case( tChar )

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.charval) == (yyvsp[(3) - (3)].v.u.charval);
							
						_endcase

						/*
						** Compare numeric types here.
						*/

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )
						_case( tQWord )
						_case( tTByte )
						_case( tLWord )
						_case( tCset )

							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.lwordval)[0] == (yyvsp[(3) - (3)].v.u.lwordval)[0]
								&&	(yyvsp[(1) - (3)].v.u.lwordval)[1] == (yyvsp[(3) - (3)].v.u.lwordval)[1]
								&&	(yyvsp[(1) - (3)].v.u.lwordval)[2] == (yyvsp[(3) - (3)].v.u.lwordval)[2]
								&&	(yyvsp[(1) - (3)].v.u.lwordval)[3] == (yyvsp[(3) - (3)].v.u.lwordval)[3];
								
						_endcase

						_case( tReal32 )
							
							// Floats are equal only if all 32 bits are equal:
							
							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.lwordval)[0] == (yyvsp[(3) - (3)].v.u.lwordval)[0];
							


						_case( tReal64 )
							
							// Doubles are equal only if all 64 bits are equal:

							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.lwordval)[0] == (yyvsp[(3) - (3)].v.u.lwordval)[0]
								&&	(yyvsp[(1) - (3)].v.u.lwordval)[1] == (yyvsp[(3) - (3)].v.u.lwordval)[1];
							

						_case( tReal80 )

							(yyval.v.u.boolval) = 
								feq80( (yyvsp[(1) - (3)].v.u.fltval), (yyvsp[(3) - (3)].v.u.fltval) );

						_endcase



						/*
						** Compare strings and pointer constants (which
						** are string objects) here.
						*/
																 
						_case( tPointer )
						{
							char *l = (yyvsp[(1) - (3)].v.u.strval);
							char *r	= (yyvsp[(3) - (3)].v.u.strval);

							/*
							** skip over the "?nnnn_" preceding
							** the static name.
							*/

							_do _until( *l++ == '_' );
							_do _until( *r++ == '_' );

							(yyval.v.u.boolval) = 
								_streq( l, r );
						}
						_endcase


						_case( tString )
						_case( tZString )

							(yyval.v.u.boolval) = 
								_streq( (yyvsp[(1) - (3)].v.u.strval), (yyvsp[(3) - (3)].v.u.strval) );

						_endcase



						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							(
								YYS &(yyval.v),
								tBoolean,
								&boolean_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

				_endif
				_here;
			;}
    break;

  case 1434:

/* Line 1464 of yacc.c  */
#line 64259 "hlaparse.bsn"
    {

				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

					_switch( (yyvsp[(1) - (3)].v.pType) )

						_case( tEnum )						

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.unsval) != (yyvsp[(3) - (3)].v.u.unsval);
							
						_endcase


						_case( tBoolean )
						_case( tChar )

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.charval) != (yyvsp[(3) - (3)].v.u.charval);
							
						_endcase

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )						
						_case( tQWord )						
						_case( tTByte )
						_case( tLWord )
						_case( tCset )						

							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.lwordval)[0] != (yyvsp[(3) - (3)].v.u.lwordval)[0]
								||	(yyvsp[(1) - (3)].v.u.lwordval)[1] != (yyvsp[(3) - (3)].v.u.lwordval)[1]
								||	(yyvsp[(1) - (3)].v.u.lwordval)[2] != (yyvsp[(3) - (3)].v.u.lwordval)[2]
								||	(yyvsp[(1) - (3)].v.u.lwordval)[3] != (yyvsp[(3) - (3)].v.u.lwordval)[3];
								

						_endcase



						_case( tReal32 )
							
							// Floats are equal only if all 32 bits are equal:
							
							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.lwordval)[0] != (yyvsp[(3) - (3)].v.u.lwordval)[0];
							


						_case( tReal64 )
							
							// Doubles are equal only if all 64 bits are equal:

							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.lwordval)[0] != (yyvsp[(3) - (3)].v.u.lwordval)[0]
								&&	(yyvsp[(1) - (3)].v.u.lwordval)[1] != (yyvsp[(3) - (3)].v.u.lwordval)[1];
							

						_case( tReal80 )

							(yyval.v.u.boolval) = 
								fne80( (yyvsp[(1) - (3)].v.u.fltval), (yyvsp[(3) - (3)].v.u.fltval) );

						_endcase




						_case( tPointer )
						{
							char *l = (yyvsp[(1) - (3)].v.u.strval);
							char *r	= (yyvsp[(3) - (3)].v.u.strval);

							/*
							** skip over the "?nnnn_" preceding
							** the static name.
							*/

							_do _until( *l++ == '_' );
							_do _until( *r++ == '_' );

							(yyval.v.u.boolval) = 
								_strne( l, r );
						}
						_endcase



						_case( tString )
						_case( tZString )

							(yyval.v.u.boolval) = 
								_strne( (yyvsp[(1) - (3)].v.u.strval), (yyvsp[(3) - (3)].v.u.strval) );

						_endcase


						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							( 
								YYS &(yyval.v), 
								tBoolean, 
								&boolean_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

				_endif
				_here;
			;}
    break;

  case 1435:

/* Line 1464 of yacc.c  */
#line 64408 "hlaparse.bsn"
    {
				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

					_switch( (yyvsp[(1) - (3)].v.pType) )


						_case( tEnum )						

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.unsval) < (yyvsp[(3) - (3)].v.u.unsval);
							
						_endcase


						_case( tBoolean )
						_case( tChar )

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.charval) < (yyvsp[(3) - (3)].v.u.charval);
							
						_endcase

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )						
						_case( tQWord )						
						_case( tTByte )
						_case( tLWord )

							(yyval.v.u.boolval) = 
								UnsLT( &(yyvsp[(1) - (3)].v.u.lwordval)[0], &(yyvsp[(3) - (3)].v.u.lwordval)[0] );

						_endcase


						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )

							(yyval.v.u.boolval) = 
								IntLT( &(yyvsp[(1) - (3)].v.u.lwordval)[0], &(yyvsp[(3) - (3)].v.u.lwordval)[0] );

						_endcase




						_case( tReal32 )
							
							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.fltval.f.f) < (yyvsp[(3) - (3)].v.u.fltval.f.f); 
							


						_case( tReal64 )
							
							// Doubles are equal only if all 64 bits are equal:

							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.fltval.f.d) < (yyvsp[(3) - (3)].v.u.fltval.f.d); 
							

						_case( tReal80 )

							(yyval.v.u.boolval) = 
								flt80( (yyvsp[(1) - (3)].v.u.fltval), (yyvsp[(3) - (3)].v.u.fltval) );

						_endcase


						_case( tString )
						_case( tZString )

							(yyval.v.u.boolval) = 
								_strlt( (yyvsp[(1) - (3)].v.u.strval), (yyvsp[(3) - (3)].v.u.strval) );

						_endcase


						/*
						** One character set is less than another if
						** the first CSet is a proper subset of the other.
						** This occurs if their intersection equals
						** the first operand but not the seconv.
						*/

						_case( tCset )
						{
							int IsEql = 1;
							int IsLE = 1;

							_for( int i=0, i < CSetSizeInBytes, ++i )

								IsEql &=
										(yyvsp[(1) - (3)].v.u.csetval)[i] 
									== 	(yyvsp[(3) - (3)].v.u.csetval)[i];

								IsLE &=
									( 
											(yyvsp[(1) - (3)].v.u.csetval)[i] 
										&	(yyvsp[(3) - (3)].v.u.csetval)[i] 
									)
									== (yyvsp[(1) - (3)].v.u.csetval)[i];

							_endfor
							(yyval.v.u.boolval) =	IsLE && !IsEql;
						}
						_endcase



						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							( 
								YYS &(yyval.v), 
								tBoolean, 
								&boolean_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

				_endif
				_here;
			;}
    break;

  case 1436:

/* Line 1464 of yacc.c  */
#line 64567 "hlaparse.bsn"
    {
				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

					_switch( (yyvsp[(1) - (3)].v.pType) )

						_case( tEnum )						

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.unsval) <= (yyvsp[(3) - (3)].v.u.unsval);
							
						_endcase


						_case( tBoolean )
						_case( tChar )

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.charval) <= (yyvsp[(3) - (3)].v.u.charval);
							
						_endcase

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )						
						_case( tQWord )						
						_case( tTByte )
						_case( tLWord )

							(yyval.v.u.boolval) = 
								UnsLE( &(yyvsp[(1) - (3)].v.u.lwordval)[0], &(yyvsp[(3) - (3)].v.u.lwordval)[0] );

						_endcase


						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )

							(yyval.v.u.boolval) = 
								IntLE( &(yyvsp[(1) - (3)].v.u.lwordval)[0], &(yyvsp[(3) - (3)].v.u.lwordval)[0] );

						_endcase




						_case( tReal32 )
							
							// Floats are equal only if all 32 bits are equal:
							
							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.fltval.f.f) <= (yyvsp[(3) - (3)].v.u.fltval.f.f); 
							


						_case( tReal64 )
							
							// Doubles are equal only if all 64 bits are equal:

							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.fltval.f.d) <= (yyvsp[(3) - (3)].v.u.fltval.f.d); 
							

						_case( tReal80 )

							(yyval.v.u.boolval) = 
								fle80( (yyvsp[(1) - (3)].v.u.fltval), (yyvsp[(3) - (3)].v.u.fltval) );

						_endcase


						_case( tString )
						_case( tZString )

							(yyval.v.u.boolval) = 
								_strle( (yyvsp[(1) - (3)].v.u.strval), (yyvsp[(3) - (3)].v.u.strval) );

						_endcase


						
						/*
						** One Cset is less than or equal to another if
						** the first cset is a subset of the other.
						** This occurs when their intersection is equal
						** to the first cset.
						*/

						_case( tCset )
						{
							int IsLE = 1;

							_for( int i=0, i < CSetSizeInBytes, ++i )

								IsLE &=
									( 
											(yyvsp[(1) - (3)].v.u.csetval)[i] 
										&	(yyvsp[(3) - (3)].v.u.csetval)[i] 
									)
									== (yyvsp[(1) - (3)].v.u.csetval)[i];

							_endfor
							(yyval.v.u.boolval) =	IsLE;
						}
						_endcase



						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							( 
								YYS &(yyval.v), 
								tBoolean, 
								&boolean_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

				_endif
				_here;
			;}
    break;

  case 1437:

/* Line 1464 of yacc.c  */
#line 64726 "hlaparse.bsn"
    {
				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

					_switch( (yyvsp[(1) - (3)].v.pType) )

						_case( tEnum )						

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.unsval) > (yyvsp[(3) - (3)].v.u.unsval);
							
						_endcase


						_case( tBoolean )
						_case( tChar )

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.charval) > (yyvsp[(3) - (3)].v.u.charval);
							
						_endcase

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )						
						_case( tQWord )						
						_case( tTByte )
						_case( tLWord )

							(yyval.v.u.boolval) = 
								UnsGT( &(yyvsp[(1) - (3)].v.u.lwordval)[0], &(yyvsp[(3) - (3)].v.u.lwordval)[0] );

						_endcase


						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )

							(yyval.v.u.boolval) = 
								IntGT( &(yyvsp[(1) - (3)].v.u.lwordval)[0], &(yyvsp[(3) - (3)].v.u.lwordval)[0] );

						_endcase




						_case( tReal32 )
							
							// Floats are equal only if all 32 bits are equal:
							
							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.fltval.f.f) > (yyvsp[(3) - (3)].v.u.fltval.f.f); 
							


						_case( tReal64 )
							
							// Doubles are equal only if all 64 bits are equal:

							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.fltval.f.d) > (yyvsp[(3) - (3)].v.u.fltval.f.d); 
							

						_case( tReal80 )

							(yyval.v.u.boolval) = 
								fgt80( (yyvsp[(1) - (3)].v.u.fltval), (yyvsp[(3) - (3)].v.u.fltval) );

						_endcase


						_case( tString )
						_case( tZString )

							(yyval.v.u.boolval) = 
								_strgt( (yyvsp[(1) - (3)].v.u.strval), (yyvsp[(3) - (3)].v.u.strval) );

						_endcase


						/*
						** One cset is greater than another if it is
						** a proper superset of the other.  This means
						** that their intersection will be equal to the
						** second operand but not the first.
						*/

						_case( tCset )
						{
							int IsEql = 1;
							int IsGE = 1;

							_for( int i=0, i < CSetSizeInBytes, ++i )

								IsEql &=
										(yyvsp[(1) - (3)].v.u.csetval)[i] 
									== 	(yyvsp[(3) - (3)].v.u.csetval)[i];

								IsGE &=
									( 
											(yyvsp[(1) - (3)].v.u.csetval)[i] 
										&	(yyvsp[(3) - (3)].v.u.csetval)[i] 
									)
									== (yyvsp[(3) - (3)].v.u.csetval)[i];

							_endfor
							(yyval.v.u.boolval) =	IsGE && !IsEql;
						}
						_endcase






						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							( 
								YYS &(yyval.v), 
								tBoolean, 
								&boolean_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

				_endif
				_here;
			;}
    break;

  case 1438:

/* Line 1464 of yacc.c  */
#line 64892 "hlaparse.bsn"
    {
				_here;
				_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))

					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

					_switch( (yyvsp[(1) - (3)].v.pType) )


						_case( tEnum )						

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.unsval) >= (yyvsp[(3) - (3)].v.u.unsval);
							
						_endcase


						_case( tBoolean )
						_case( tChar )

							(yyval.v.u.boolval) = (yyvsp[(1) - (3)].v.u.charval) >= (yyvsp[(3) - (3)].v.u.charval);
							
						_endcase

						_case( tUns8 )
						_case( tUns16 )
						_case( tUns32 )
						_case( tUns64 )
						_case( tUns128 )
						_case( tByte )
						_case( tWord )
						_case( tDWord )						
						_case( tQWord )						
						_case( tTByte )
						_case( tLWord )

							(yyval.v.u.boolval) = 
								UnsGE( &(yyvsp[(1) - (3)].v.u.lwordval)[0], &(yyvsp[(3) - (3)].v.u.lwordval)[0] );

						_endcase


						_case( tInt8 )
						_case( tInt16 )
						_case( tInt32 )
						_case( tInt64 )
						_case( tInt128 )

							(yyval.v.u.boolval) = 
								IntGE( &(yyvsp[(1) - (3)].v.u.lwordval)[0], &(yyvsp[(3) - (3)].v.u.lwordval)[0] );

						_endcase




						_case( tReal32 )
							
							// Floats are equal only if all 32 bits are equal:
							
							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.fltval.f.f) >= (yyvsp[(3) - (3)].v.u.fltval.f.f); 
							


						_case( tReal64 )
							
							// Doubles are equal only if all 64 bits are equal:

							(yyval.v.u.boolval) = 
									(yyvsp[(1) - (3)].v.u.fltval.f.d) >= (yyvsp[(3) - (3)].v.u.fltval.f.d); 
							

						_case( tReal80 )

							(yyval.v.u.boolval) = 
								fge80( (yyvsp[(1) - (3)].v.u.fltval), (yyvsp[(3) - (3)].v.u.fltval) );

						_endcase


						_case( tString )
						_case( tZString )

							(yyval.v.u.boolval) = 
								_strge( (yyvsp[(1) - (3)].v.u.strval), (yyvsp[(3) - (3)].v.u.strval) );

						_endcase


						/*
						** One cset is greater than or equal to another
						** if it is a superset of the other.  This occurs
						** when their intersection is equal to the second
						** set or both sets.
						*/

						_case( tCset )
						{
							int IsGE = 1;

							_for( int i=0, i < CSetSizeInBytes, ++i )

								IsGE &=
									( 
											(yyvsp[(1) - (3)].v.u.csetval)[i] 
										&	(yyvsp[(3) - (3)].v.u.csetval)[i] 
									)
									== (yyvsp[(3) - (3)].v.u.csetval)[i];

							_endfor
							(yyval.v.u.boolval) =	IsGE;
						}
						_endcase



						_default
							
							yyerror( "Illegal operand types" );
							ClrConst
							( 
								YYS &(yyval.v), 
								tBoolean, 
								&boolean_ste
							);

					_endswitch

				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

				_endif
				_here;
			;}
    break;

  case 1439:

/* Line 1464 of yacc.c  */
#line 65049 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				_if( (yyvsp[(1) - (3)].v.pType) == tChar && (yyvsp[(3) - (3)].v.pType) == tCset )

					(yyval.v.u.boolval) =
						( 
								(yyvsp[(3) - (3)].v.u.csetval)[ (yyvsp[(1) - (3)].v.u.charval) / 8 ]
							&	( 1 << (yyvsp[(1) - (3)].v.u.charval) % 8 )
						) != 0;
				_else

					yyerror( "Type mismatch in operands" );
					ClrConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste
					);

				_endif
				_here;

			;}
    break;

  case 1440:

/* Line 1464 of yacc.c  */
#line 65107 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(3) - (4)].v), sizeofSymNode );
			(yyval.v.pType) = (yyvsp[(1) - (4)].v.pType);
			(yyval.v.Type) = (yyvsp[(1) - (4)].v.Type);
			
			// Zero fill to 128 bytes from the actual type unless
			// it's an INTxx type, in which case we need to sign extend
			// the value.
			
			_if( (yyvsp[(1) - (4)].v.pType) >= tInt8 && (yyvsp[(1) - (4)].v.pType) <= tInt128 )
			
				_if( (yyvsp[(1) - (4)].v.pType) == tInt8 )
				
					_if( (yyvsp[(3) - (4)].v.u.csetval)[0] >= 0x80 )
					
						(yyval.v.u.csetval)[0] = (yyvsp[(3) - (4)].v.u.csetval)[0];
						(yyval.v.u.csetval)[1] = 0xff;
						(yyval.v.u.csetval)[2] = 0xff;
						(yyval.v.u.csetval)[3] = 0xff;
						(yyval.v.u.lwordval)[1] = 0xffffffff;
						(yyval.v.u.lwordval)[2] = 0xffffffff;
						(yyval.v.u.lwordval)[3] = 0xffffffff;
						
					_else
					
						(yyval.v.u.csetval)[0] = (yyvsp[(3) - (4)].v.u.csetval)[0];
						(yyval.v.u.csetval)[1] = 0;
						(yyval.v.u.csetval)[2] = 0;
						(yyval.v.u.csetval)[3] = 0;
						(yyval.v.u.lwordval)[1] = 0;
						(yyval.v.u.lwordval)[2] = 0;
						(yyval.v.u.lwordval)[3] = 0;
						
					_endif
				
				_elseif( (yyvsp[(1) - (4)].v.pType) == tInt16 )
				
					_if( (yyvsp[(3) - (4)].v.u.csetval)[1] >= 0x80 )
					
						(yyval.v.u.csetval)[0] = (yyvsp[(3) - (4)].v.u.csetval)[0];
						(yyval.v.u.csetval)[1] = (yyvsp[(3) - (4)].v.u.csetval)[1];
						(yyval.v.u.csetval)[2] = 0xff;
						(yyval.v.u.csetval)[3] = 0xff;
						(yyval.v.u.lwordval)[1] = 0xffffffff;
						(yyval.v.u.lwordval)[2] = 0xffffffff;
						(yyval.v.u.lwordval)[3] = 0xffffffff;
						
					_else
					
						(yyval.v.u.csetval)[0] = (yyvsp[(3) - (4)].v.u.csetval)[0];
						(yyval.v.u.csetval)[1] = (yyvsp[(3) - (4)].v.u.csetval)[1];
						(yyval.v.u.csetval)[2] = 0;
						(yyval.v.u.csetval)[3] = 0;
						(yyval.v.u.lwordval)[1] = 0;
						(yyval.v.u.lwordval)[2] = 0;
						(yyval.v.u.lwordval)[3] = 0;
						
					_endif
				

				_elseif( (yyvsp[(1) - (4)].v.pType) == tInt32 )
				
					_if( (yyvsp[(3) - (4)].v.u.csetval)[3] >= 0x80 )
					
						(yyval.v.u.lwordval)[0] = (yyvsp[(3) - (4)].v.u.lwordval)[0];
						(yyval.v.u.lwordval)[1] = 0xffffffff;
						(yyval.v.u.lwordval)[2] = 0xffffffff;
						(yyval.v.u.lwordval)[3] = 0xffffffff;
						
					_else
					
						(yyval.v.u.lwordval)[0] = (yyvsp[(3) - (4)].v.u.lwordval)[0];
						(yyval.v.u.lwordval)[1] = 0;
						(yyval.v.u.lwordval)[2] = 0;
						(yyval.v.u.lwordval)[3] = 0;
						
					_endif
				

				_elseif( (yyvsp[(1) - (4)].v.pType) == tInt64 )
				
					_if( (yyvsp[(3) - (4)].v.u.csetval)[3] >= 0x80 )
					
						(yyval.v.u.lwordval)[0] = (yyvsp[(3) - (4)].v.u.lwordval)[0];
						(yyval.v.u.lwordval)[1] = (yyvsp[(3) - (4)].v.u.lwordval)[1];
						(yyval.v.u.lwordval)[2] = 0xffffffff;
						(yyval.v.u.lwordval)[3] = 0xffffffff;
						
					_else
					
						(yyval.v.u.lwordval)[0] = (yyvsp[(3) - (4)].v.u.lwordval)[0];
						(yyval.v.u.lwordval)[1] = (yyvsp[(3) - (4)].v.u.lwordval)[1];
						(yyval.v.u.lwordval)[2] = 0;
						(yyval.v.u.lwordval)[3] = 0;
						
					_endif
					
					
				_else

					(yyval.v.u.lwordval)[0] = (yyvsp[(3) - (4)].v.u.lwordval)[0];
					(yyval.v.u.lwordval)[1] = (yyvsp[(3) - (4)].v.u.lwordval)[1];
					(yyval.v.u.lwordval)[2] = (yyvsp[(3) - (4)].v.u.lwordval)[2];
					(yyval.v.u.lwordval)[3] = (yyvsp[(3) - (4)].v.u.lwordval)[3];
						
				_endif
				

			_elseif( (yyvsp[(1) - (4)].v.pType) == tPointer )
		
				char adrs[16];
				
				sprintf( adrs, "%u", (yyvsp[(3) - (4)].v.u.lwordval)[0] );
				(yyval.v.u.strval) = hlastrdup2( adrs );
				(yyval.v.u.lwordval)[1] = 0;
				(yyval.v.u.lwordval)[2] = 0;
				(yyval.v.u.lwordval)[3] = 0;
					

			_else  // Not an Int object
			
				_switch( (yyvsp[(1) - (4)].v.u.intval) )
				
					// Note: cases 1..4 fall through to case 8.
					
					_case( 1 )
					
						(yyval.v.u.csetval)[1] = 0;
						
					_case( 2 )
					
						(yyval.v.u.csetval)[2] = 0;
						(yyval.v.u.csetval)[3] = 0;
						
					_case( 4 )
					
						(yyval.v.u.lwordval)[1] = 0;
						
					_case( 8 )
					
						(yyval.v.u.lwordval)[2] = 0;
						(yyval.v.u.lwordval)[3] = 0;
						
					_endcase
					
					_case( 10 )
					
						(yyval.v.u.csetval)[8] = 0;
						(yyval.v.u.csetval)[9] = 0;
						(yyval.v.u.lwordval)[3] = 0;
						
				_endswitch
				
			_endif
			_here;		
		;}
    break;

  case 1441:

/* Line 1464 of yacc.c  */
#line 65272 "hlaparse.bsn"
    {
			enum PrimType	pType;
			SymNode_t		*s;
			
			_here;
			_if
			(
					(
							IsPrimitive( (yyvsp[(3) - (5)].s)->pType )
						&&	IsPrimitive( (yyvsp[(4) - (5)].v.pType) )
						&&	(yyvsp[(3) - (5)].s)->ObjectSize == (yyvsp[(4) - (5)].v.ObjectSize)
						&&	(yyvsp[(4) - (5)].v.ObjectSize) <= 16
					)
				
				||	IsCompatible( (yyvsp[(3) - (5)].s), YYS &(yyvsp[(4) - (5)].v) )
			)
			
				pType = (yyvsp[(3) - (5)].s)->pType;
				s = (yyvsp[(3) - (5)].s);
				
				memcpy( &(yyval.v), &(yyvsp[(4) - (5)].v), sizeofSymNode );
				(yyval.v.pType) = pType;
				(yyval.v.Type) = s;
				
				// Zero fill to 128 bytes from the actual type unless
				// it's an INTxx type, in which case we need to sign extend
				// the value.
				
				_if( pType >= tInt8 && pType <= tInt128 )
				
					_if( pType == tInt8 )
					
						_if( (yyvsp[(3) - (5)].v.u.csetval)[0] >= 0x80 )
						
							(yyval.v.u.csetval)[0] = (yyvsp[(3) - (5)].v.u.csetval)[0];
							(yyval.v.u.csetval)[1] = 0xff;
							(yyval.v.u.csetval)[2] = 0xff;
							(yyval.v.u.csetval)[3] = 0xff;
							(yyval.v.u.lwordval)[1] = 0xffffffff;
							(yyval.v.u.lwordval)[2] = 0xffffffff;
							(yyval.v.u.lwordval)[3] = 0xffffffff;
							
						_else
						
							(yyval.v.u.csetval)[0] = (yyvsp[(3) - (5)].v.u.csetval)[0];
							(yyval.v.u.csetval)[1] = 0;
							(yyval.v.u.csetval)[2] = 0;
							(yyval.v.u.csetval)[3] = 0;
							(yyval.v.u.lwordval)[1] = 0;
							(yyval.v.u.lwordval)[2] = 0;
							(yyval.v.u.lwordval)[3] = 0;
							
						_endif
					
					_elseif( pType == tInt16 )
					
						_if( (yyvsp[(3) - (5)].v.u.csetval)[1] >= 0x80 )
						
							(yyval.v.u.csetval)[0] = (yyvsp[(3) - (5)].v.u.csetval)[0];
							(yyval.v.u.csetval)[1] = (yyvsp[(3) - (5)].v.u.csetval)[1];
							(yyval.v.u.csetval)[2] = 0xff;
							(yyval.v.u.csetval)[3] = 0xff;
							(yyval.v.u.lwordval)[1] = 0xffffffff;
							(yyval.v.u.lwordval)[2] = 0xffffffff;
							(yyval.v.u.lwordval)[3] = 0xffffffff;
							
						_else
						
							(yyval.v.u.csetval)[0] = (yyvsp[(3) - (5)].v.u.csetval)[0];
							(yyval.v.u.csetval)[1] = (yyvsp[(3) - (5)].v.u.csetval)[1];
							(yyval.v.u.csetval)[2] = 0;
							(yyval.v.u.csetval)[3] = 0;
							(yyval.v.u.lwordval)[1] = 0;
							(yyval.v.u.lwordval)[2] = 0;
							(yyval.v.u.lwordval)[3] = 0;
							
						_endif
					

					_elseif( pType == tInt32 )
					
						_if( (yyvsp[(3) - (5)].v.u.csetval)[3] >= 0x80 )
						
							(yyval.v.u.lwordval)[0] = (yyvsp[(3) - (5)].v.u.lwordval)[0];
							(yyval.v.u.lwordval)[1] = 0xffffffff;
							(yyval.v.u.lwordval)[2] = 0xffffffff;
							(yyval.v.u.lwordval)[3] = 0xffffffff;
							
						_else
						
							(yyval.v.u.lwordval)[0] = (yyvsp[(3) - (5)].v.u.lwordval)[0];
							(yyval.v.u.lwordval)[1] = 0;
							(yyval.v.u.lwordval)[2] = 0;
							(yyval.v.u.lwordval)[3] = 0;
							
						_endif
					

					_elseif( pType == tInt64 )
					
						_if( (yyvsp[(3) - (5)].v.u.csetval)[3] >= 0x80 )
						
							(yyval.v.u.lwordval)[0] = (yyvsp[(3) - (5)].v.u.lwordval)[0];
							(yyval.v.u.lwordval)[1] = (yyvsp[(3) - (5)].v.u.lwordval)[1];
							(yyval.v.u.lwordval)[2] = 0xffffffff;
							(yyval.v.u.lwordval)[3] = 0xffffffff;
							
						_else
						
							(yyval.v.u.lwordval)[0] = (yyvsp[(3) - (5)].v.u.lwordval)[0];
							(yyval.v.u.lwordval)[1] = (yyvsp[(3) - (5)].v.u.lwordval)[1];
							(yyval.v.u.lwordval)[2] = 0;
							(yyval.v.u.lwordval)[3] = 0;
							
						_endif
						
						
					_else

						(yyval.v.u.lwordval)[0] = (yyvsp[(3) - (5)].v.u.lwordval)[0];
						(yyval.v.u.lwordval)[1] = (yyvsp[(3) - (5)].v.u.lwordval)[1];
						(yyval.v.u.lwordval)[2] = (yyvsp[(3) - (5)].v.u.lwordval)[2];
						(yyval.v.u.lwordval)[3] = (yyvsp[(3) - (5)].v.u.lwordval)[3];
							
					_endif
					

				_elseif( pType == tPointer )
			
					char adrs[16];
					
					sprintf( adrs, "%u", (yyvsp[(3) - (5)].v.u.lwordval)[0] );
					(yyval.v.u.strval) = hlastrdup2( adrs );
					(yyval.v.u.lwordval)[1] = 0;
					(yyval.v.u.lwordval)[2] = 0;
					(yyval.v.u.lwordval)[3] = 0;
						

				_else  // Not an Int object
				
					_switch( s->ObjectSize )
					
						// Note: cases 1..4 fall through to case 8.
						
						_case( 1 )
						
							(yyval.v.u.csetval)[1] = 0;
							
						_case( 2 )
						
							(yyval.v.u.csetval)[2] = 0;
							(yyval.v.u.csetval)[3] = 0;
							
						_case( 4 )
						
							(yyval.v.u.lwordval)[1] = 0;
							
						_case( 8 )
						
							(yyval.v.u.lwordval)[2] = 0;
							(yyval.v.u.lwordval)[3] = 0;
							
						_endcase
						
						_case( 10 )
						
							(yyval.v.u.csetval)[8] = 0;
							(yyval.v.u.csetval)[9] = 0;
							(yyval.v.u.lwordval)[3] = 0;
							
					_endswitch
					
				_endif
				
			_else
			
				yyerror( "Type conflict in type coercion operator" );
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				
			_endif
			_here;		
		;}
    break;

  case 1442:

/* Line 1464 of yacc.c  */
#line 65469 "hlaparse.bsn"
    {			/* $2 */
		
			// Save the InAtString flag and then set it to one
			// so that the lexer won't expand text constants.
			
			_here;
			(yyval.v.u.intval) = InAtString;
			InAtString = 1;
		;}
    break;

  case 1443:

/* Line 1464 of yacc.c  */
#line 65481 "hlaparse.bsn"
    {
			// ConstExpr better be a string value (note that TEXT
			// constants were already converted to string objects).
			
			_here;
			_if( (yyvsp[(4) - (5)].v.pType) == tString || (yyvsp[(4) - (5)].v.pType) == tZString )
			
				memcpy( &(yyval.v), &(yyvsp[(4) - (5)].v), sizeofSymNode );
				
			_elseif( (yyvsp[(4) - (5)].v.pType) == tPointer || (yyvsp[(4) - (5)].v.pType) == tProcptr )
			
				ClrConst( YYS &(yyval.v), tString, &string_ste );
				(yyval.v.u.strval) = (yyvsp[(4) - (5)].v.u.strval);		
			

			_else
			
				// For all other types, create a string that
				// is the length of the data type and just copy
				// the bits to the string as though they were characters.
				// Note that the string might actually be smaller
				// than the data type's size since there may be
				// zero bits on the interior.
				
				char *theStr = malloc2( 17 ); // Max 16 chars!
				
				ClrConst( YYS &(yyval.v), tString, &string_ste );
				(yyval.v.u.strval) = theStr;
				memcpy( theStr, &(yyvsp[(4) - (5)].v.u.lwordval)[0], 16 );
				theStr[ 17 ] = '\0';  // Make sure it's zero terminated.
				
				
			_endif
			
	
			// Restore InAtString value:
			
			InAtString = (yyvsp[(2) - (5)].v.u.intval);
			_here;	
		;}
    break;

  case 1444:

/* Line 1464 of yacc.c  */
#line 65529 "hlaparse.bsn"
    {
			yyerror( "HLA doesn't currently support the @wstring function" );
		;}
    break;

  case 1445:

/* Line 1464 of yacc.c  */
#line 65547 "hlaparse.bsn"
    {
			_here;
			SelByteFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v) 
			);
		;}
    break;

  case 1446:

/* Line 1464 of yacc.c  */
#line 65561 "hlaparse.bsn"
    {	
			_here;
			memcpy( &(yyval.v), &(yyvsp[(3) - (4)].v), sizeofSymNode );
			(yyval.v.pType) = tByte;
			(yyval.v.Type) = &byte_ste;
			(yyval.v.u.bytes)[0] = (yyvsp[(4) - (4)].v.u.bytes)[0];
			(yyval.v.u.bytes)[1] = 0;
			(yyval.v.u.words)[1] = 0;
			(yyval.v.u.dwords)[1] = 0;
			(yyval.v.u.dwords)[2] = 0;
			(yyval.v.u.dwords)[3] = 0;
			
		;}
    break;

  case 1447:

/* Line 1464 of yacc.c  */
#line 65584 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 1;
			(yyval.v.pType) = tInt8;
			(yyval.v.Type) = &int8_ste;
		;}
    break;

  case 1448:

/* Line 1464 of yacc.c  */
#line 65592 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 2;
			(yyval.v.pType) = tInt16;
			(yyval.v.Type) = &int16_ste;
		;}
    break;

  case 1449:

/* Line 1464 of yacc.c  */
#line 65600 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 4;
			(yyval.v.pType) = tInt32;
			(yyval.v.Type) = &int32_ste;
		;}
    break;

  case 1450:

/* Line 1464 of yacc.c  */
#line 65608 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 8;
			(yyval.v.pType) = tInt64;
			(yyval.v.Type) = &int64_ste;
		;}
    break;

  case 1451:

/* Line 1464 of yacc.c  */
#line 65616 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 16;
			(yyval.v.pType) = tInt128;
			(yyval.v.Type) = &int128_ste;
		;}
    break;

  case 1452:

/* Line 1464 of yacc.c  */
#line 65624 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 1;
			(yyval.v.pType) = tChar;
			(yyval.v.Type) = &char_ste;
		;}
    break;

  case 1453:

/* Line 1464 of yacc.c  */
#line 65632 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 2;
			(yyval.v.pType) = tWChar;
			(yyval.v.Type) = &wchar_ste;
		;}
    break;

  case 1454:

/* Line 1464 of yacc.c  */
#line 65640 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 4;
			(yyval.v.pType) = tReal32;
			(yyval.v.Type) = &real32_ste;
		;}
    break;

  case 1455:

/* Line 1464 of yacc.c  */
#line 65648 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 8;
			(yyval.v.pType) = tReal64;
			(yyval.v.Type) = &real64_ste;
		;}
    break;

  case 1456:

/* Line 1464 of yacc.c  */
#line 65656 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 10;
			(yyval.v.pType) = tReal80;
			(yyval.v.Type) = &real80_ste;
		;}
    break;

  case 1457:

/* Line 1464 of yacc.c  */
#line 65664 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 1;
			(yyval.v.pType) = tUns8;
			(yyval.v.Type) = &uns8_ste;
		;}
    break;

  case 1458:

/* Line 1464 of yacc.c  */
#line 65672 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 2;
			(yyval.v.pType) = tUns16;
			(yyval.v.Type) = &uns16_ste;
		;}
    break;

  case 1459:

/* Line 1464 of yacc.c  */
#line 65680 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 4;
			(yyval.v.pType) = tUns32;
			(yyval.v.Type) = &uns32_ste;
		;}
    break;

  case 1460:

/* Line 1464 of yacc.c  */
#line 65688 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 8;
			(yyval.v.pType) = tUns64;
			(yyval.v.Type) = &uns64_ste;
		;}
    break;

  case 1461:

/* Line 1464 of yacc.c  */
#line 65696 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 16;
			(yyval.v.pType) = tUns128;
			(yyval.v.Type) = &uns128_ste;
		;}
    break;

  case 1462:

/* Line 1464 of yacc.c  */
#line 65705 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 16;
			(yyval.v.pType) = tCset;
			(yyval.v.Type) = &cset_ste;
		;}
    break;

  case 1463:

/* Line 1464 of yacc.c  */
#line 65713 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 2;
			(yyval.v.pType) = tWord;
			(yyval.v.Type) = &word_ste;
		;}
    break;

  case 1464:

/* Line 1464 of yacc.c  */
#line 65721 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 4;
			(yyval.v.pType) = tDWord;
			(yyval.v.Type) = &dword_ste;
		;}
    break;

  case 1465:

/* Line 1464 of yacc.c  */
#line 65729 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 8;
			(yyval.v.pType) = tQWord;
			(yyval.v.Type) = &qword_ste;
		;}
    break;

  case 1466:

/* Line 1464 of yacc.c  */
#line 65737 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 8;
			(yyval.v.pType) = tTByte;
			(yyval.v.Type) = &tbyte_ste;
		;}
    break;

  case 1467:

/* Line 1464 of yacc.c  */
#line 65745 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 16;
			(yyval.v.pType) = tLWord;
			(yyval.v.Type) = &lword_ste;
		;}
    break;

  case 1468:

/* Line 1464 of yacc.c  */
#line 65753 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = 4;
			(yyval.v.pType) = tPointer;
			(yyval.v.Type) = &pointer_ste;  
		;}
    break;

  case 1469:

/* Line 1464 of yacc.c  */
#line 65769 "hlaparse.bsn"
    {	
				_here;
				BooleanFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1470:

/* Line 1464 of yacc.c  */
#line 65785 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tInt8,
				&int8_ste 
			);
			_here;
		;}
    break;

  case 1471:

/* Line 1464 of yacc.c  */
#line 65798 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tInt16,
				&int16_ste 
			);
			_here;
		;}
    break;

  case 1472:

/* Line 1464 of yacc.c  */
#line 65811 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tInt32,
				&int32_ste 
			);
			_here;
		;}
    break;

  case 1473:

/* Line 1464 of yacc.c  */
#line 65825 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tInt64,
				&int64_ste 
			);
			_here;
		;}
    break;

  case 1474:

/* Line 1464 of yacc.c  */
#line 65839 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tInt128,
				&int128_ste 
			);
			_here;
		;}
    break;

  case 1475:

/* Line 1464 of yacc.c  */
#line 65859 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tUns8,
				&uns8_ste 
			);
			_here;
 		;}
    break;

  case 1476:

/* Line 1464 of yacc.c  */
#line 65873 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tUns16,
				&uns16_ste 
			);
			_here;
 		;}
    break;

  case 1477:

/* Line 1464 of yacc.c  */
#line 65887 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tUns32,
				&uns32_ste 
			);
			_here;
 		;}
    break;

  case 1478:

/* Line 1464 of yacc.c  */
#line 65901 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tUns64,
				&uns64_ste 
			);
			_here;
 		;}
    break;

  case 1479:

/* Line 1464 of yacc.c  */
#line 65915 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tUns128,
				&uns128_ste 
			);
			_here;
 		;}
    break;

  case 1480:

/* Line 1464 of yacc.c  */
#line 65932 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tByte,
				&byte_ste 
			);
			_here;
		;}
    break;

  case 1481:

/* Line 1464 of yacc.c  */
#line 65946 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tWord,
				&word_ste 
			);
			_here;
		;}
    break;

  case 1482:

/* Line 1464 of yacc.c  */
#line 65960 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tDWord,
				&dword_ste 
			);
			_here;
		;}
    break;

  case 1483:

/* Line 1464 of yacc.c  */
#line 65974 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tQWord,
				&qword_ste 
			);
			_here;
		;}
    break;

  case 1484:

/* Line 1464 of yacc.c  */
#line 65988 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tTByte,
				&tbyte_ste 
			);
			_here;
		;}
    break;

  case 1485:

/* Line 1464 of yacc.c  */
#line 66002 "hlaparse.bsn"
    {
			_here;
			IntegerFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tLWord,
				&lword_ste 
			);
			_here;
		;}
    break;

  case 1486:

/* Line 1464 of yacc.c  */
#line 66023 "hlaparse.bsn"
    {
			_here;
			RealFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tReal32,
				&real32_ste 
			);
			_here;
		;}
    break;

  case 1487:

/* Line 1464 of yacc.c  */
#line 66037 "hlaparse.bsn"
    {
			_here;
			RealFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tReal64,
				&real64_ste 
			);
			_here;
		;}
    break;

  case 1488:

/* Line 1464 of yacc.c  */
#line 66052 "hlaparse.bsn"
    {
			_here;
			RealFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v),
				tReal80,
				&real80_ste 
			);
			_here;
		;}
    break;

  case 1489:

/* Line 1464 of yacc.c  */
#line 66070 "hlaparse.bsn"
    {
				_here;
				CharFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
 			;}
    break;

  case 1490:

/* Line 1464 of yacc.c  */
#line 66089 "hlaparse.bsn"
    {
				_here;
				StrFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
 			;}
    break;

  case 1491:

/* Line 1464 of yacc.c  */
#line 66108 "hlaparse.bsn"
    {
				_here;
				StrFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
 			;}
    break;

  case 1492:

/* Line 1464 of yacc.c  */
#line 66124 "hlaparse.bsn"
    {
				_here;
				CsetFunc
				( 
					&(yyval.v), 
					&(yyvsp[(3) - (4)].v) 
				);
				_here;
 			;}
    break;

  case 1493:

/* Line 1464 of yacc.c  */
#line 66154 "hlaparse.bsn"
    {
 				_here;
				
 				/*
 				** Okay, push a ")" character back on the input so
 				** we can match it when we're done with the text
 				** expansion.
 				*/
 				            
 				PushBackStr( ")" );
 				
 				/*
 				** There had better be only a string expression
 				** present.  If there is, push it back onto the
 				** input stream (in reverse order) so the ConstExpr
 				** non-terminal following this semantic action can
 				** pick up the text data.  Note that the size of the
 				** input string is limited to the maximum number of
 				** push-back characters that Flex allows (set to
 				** 32kbytes for this compile).
 				*/
 				                                                 
 				_if( (yyvsp[(3) - (4)].v.pType) == tString || (yyvsp[(3) - (4)].v.pType) == tZString )
 				
					/*
					** Note that "InsertText" will free the
					** data passed to it.
					*/

 					PushBackStr( (yyvsp[(3) - (4)].v.u.strval) );
                                                                     
 				_else                                                  
 				                                                       
 					yyerror                                            
 					(                                                  
 						"'text' only allows string operands"                           
 					);
					PushBackStr( "0" );
                                                                     
 				_endif
				_here;

			/*
			** Okay, process the text we just pushed back onto the
			** input stream and then match that ")" we pushed
			** earlier.
			*/
                                                                     
 			;}
    break;

  case 1494:

/* Line 1464 of yacc.c  */
#line 66204 "hlaparse.bsn"
    {
				/*
				** Return the value of the computed ConstExpr above
				** as the value of the text(string) function.
				*/

				_here;
				memcpy( &(yyval.v), &(yyvsp[(6) - (7)].v), sizeofSymNode );

 			;}
    break;

  case 1495:

/* Line 1464 of yacc.c  */
#line 66226 "hlaparse.bsn"
    {
				_here;
				_if( readHandle == NULL )
				
					// If the read file is not open,
					// just return EOF (false):
					
					SetConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste, 
						YYS &false_ste
					);
					
				_elseif( (yyvsp[(3) - (4)].s)->SymClass != cValue )
				
					/*
					** If it's not a value object, print an error
					** and return EOF.
					*/
					
					yyerror( "@read function requires a VAL operand" );
					SetConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste, 
						YYS &false_ste
					);
					
				
				_else
				
					// Okay, read a string from the
					// input file and store in the value object.
					
					char inputline[4096];
					char *result;
					int	 len;
					
					result = fgets( inputline, 4095, readHandle );
					_if( result == NULL )
					
						// We've hit EOF, so just return false:
						
						SetConst
						( 
							YYS &(yyval.v), 
							tBoolean, 
							&boolean_ste, 
							YYS &false_ste
						);
						
					_else
					
						union YYSTYPE v;
						int len;
					
						// We're not at EOF, so return true and
						// copy the string data to the variable:
						
						SetConst
						( 
							YYS &(yyval.v), 
							tBoolean, 
							&boolean_ste, 
							YYS &true_ste
						);
						
						len = strlen( inputline );
						_while( len > 0 )
						
							--len;
							_if( inputline[ len ] == 0xa )
							
								inputline [ len ] = 0;
								
							_elseif( inputline[ len ] == 0xd )
							
								inputline [ len ] = 0;
								
							_else
							
								break;
								
							_endif
							
						_endwhile

						v.v.u.strval = hlastrdup2( inputline );
						SetSym
						( 
							(yyvsp[(3) - (4)].s), 
							&string_ste,
							tString, 
							0,
							NULL,
							0, 
							YYS &v,
							4,
							0,
							NULL,
							NULL,
							NULL,
							0,
							NULL,
							0 
						);
						
					_endif
				
				_endif
				_here;
			;}
    break;

  case 1496:

/* Line 1464 of yacc.c  */
#line 66348 "hlaparse.bsn"
    {
				_here;
				_if( readHandle == NULL )
				
					// If the read file is not open,
					// just return EOF (false):
					
					SetConst
					( 
						YYS &(yyval.v), 
						tBoolean, 
						&boolean_ste, 
						YYS &false_ste
					);
					
				_else
				
					// Okay, read a string from the
					// input file and store in the value object.
					
					char inputline[4096];
					char *result;
					
					result = fgets( inputline, 4095, readHandle );
					_if( result == NULL )
					
						// We've hit EOF, so just return false:
						
						SetConst
						( 
							YYS &(yyval.v), 
							tBoolean, 
							&boolean_ste, 
							YYS &false_ste
						);
						
					_else
					
						union YYSTYPE v;
						int len;
					
						// We're not at EOF, so return true and
						// copy the string data to the variable:
						
						SetConst
						( 
							YYS &(yyval.v), 
							tBoolean, 
							&boolean_ste, 
							YYS &true_ste
						);

						len = strlen( inputline );
						_while( len > 0 )
						
							--len;
							_if( inputline[ len ] == 0xa )
							
								inputline [ len ] = 0;
								
							_elseif( inputline[ len ] == 0xd )
							
								inputline [ len ] = 0;
								
							_else
							
								break;
								
							_endif
							
						_endwhile
						
						v.v.u.strval = hlastrdup2( inputline );
						InsertSym
						( 
							(yyvsp[(3) - (4)].idStr), 
							&string_ste,
							tString, 
							cValue, 
							0,
							NULL,
							0, 
							YYS &v,
							4,
							0,
							NULL,
							NULL,
							NULL,
							0 
						);
						
						
					_endif
				
				_endif
				_here;
			;}
    break;

  case 1497:

/* Line 1464 of yacc.c  */
#line 66476 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
		;}
    break;

  case 1498:

/* Line 1464 of yacc.c  */
#line 66485 "hlaparse.bsn"
    {
				_here;
				AbsFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1499:

/* Line 1464 of yacc.c  */
#line 66497 "hlaparse.bsn"
    {

				yyerror( "Error in @ABS function [abs(number)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);
			;}
    break;

  case 1500:

/* Line 1464 of yacc.c  */
#line 66515 "hlaparse.bsn"
    {
				_here;
				CeilFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1501:

/* Line 1464 of yacc.c  */
#line 66527 "hlaparse.bsn"
    {

				yyerror( "Error in @ceil function [@ceil(f)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);
			;}
    break;

  case 1502:

/* Line 1464 of yacc.c  */
#line 66545 "hlaparse.bsn"
    {
				_here;
				CosFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1503:

/* Line 1464 of yacc.c  */
#line 66557 "hlaparse.bsn"
    {

				yyerror( "Error in @cos function [@cos(f)]" );
				ClrConst
				( 
					YYS &(yyval.v), 
					tReal80, 
					&real80_ste
				);

			;}
    break;

  case 1504:

/* Line 1464 of yacc.c  */
#line 66575 "hlaparse.bsn"
    {
				_here;
				DateFunc( YYS &(yyval.v) );
				_here;
			;}
    break;

  case 1505:

/* Line 1464 of yacc.c  */
#line 66585 "hlaparse.bsn"
    {
				_here;
				EnvFunc( YYS &(yyval.v), YYS &(yyvsp[(3) - (4)].v) );
				_here;
			;}
    break;

  case 1506:

/* Line 1464 of yacc.c  */
#line 66594 "hlaparse.bsn"
    {
				_here;
				ExpFunc( YYS &(yyval.v), YYS &(yyvsp[(3) - (4)].v) );
				_here;
			;}
    break;

  case 1507:

/* Line 1464 of yacc.c  */
#line 66602 "hlaparse.bsn"
    {
				yyerror( "Error in @exp function [@exp(f)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tReal80, 
					&real80_ste
				);

			;}
    break;

  case 1508:

/* Line 1464 of yacc.c  */
#line 66620 "hlaparse.bsn"
    {
				_here;
				ExtractFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1509:

/* Line 1464 of yacc.c  */
#line 66632 "hlaparse.bsn"
    {
				yyerror( "Error in @extract function [@extract(cs)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tChar, 
					&char_ste
				);

			;}
    break;

  case 1510:

/* Line 1464 of yacc.c  */
#line 66650 "hlaparse.bsn"
    {
				_here;
				FloorFunc( YYS &(yyval.v), YYS &(yyvsp[(3) - (4)].v) );
				_here;
			;}
    break;

  case 1511:

/* Line 1464 of yacc.c  */
#line 66658 "hlaparse.bsn"
    {

				yyerror( "Error in @floor function [@floor(f)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);

			;}
    break;

  case 1512:

/* Line 1464 of yacc.c  */
#line 66679 "hlaparse.bsn"
    {
				_here;
				FileExistsFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1513:

/* Line 1464 of yacc.c  */
#line 66691 "hlaparse.bsn"
    {
				yyerror( "Error in @fileExists function [@fileExists(s)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);

			;}
    break;

  case 1514:

/* Line 1464 of yacc.c  */
#line 66709 "hlaparse.bsn"
    {
				_here;
				FileModifiedTimeFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1515:

/* Line 1464 of yacc.c  */
#line 66721 "hlaparse.bsn"
    {
				yyerror( "Error in @fileTimeModified function [@fileTimeModified(s)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);

			;}
    break;

  case 1516:

/* Line 1464 of yacc.c  */
#line 66746 "hlaparse.bsn"
    {
				_here;
				IsAlphaFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1517:

/* Line 1464 of yacc.c  */
#line 66758 "hlaparse.bsn"
    {
				yyerror( "Error in @isalpha function [@isalpha(i)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);

			;}
    break;

  case 1518:

/* Line 1464 of yacc.c  */
#line 66776 "hlaparse.bsn"
    {
				_here;
				IsAlnumFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1519:

/* Line 1464 of yacc.c  */
#line 66788 "hlaparse.bsn"
    {
				yyerror( "Error in @isalphanum function [@isalphanum(i)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);

			;}
    break;

  case 1520:

/* Line 1464 of yacc.c  */
#line 66806 "hlaparse.bsn"
    {
				_here;
				IsDigitFunc
				(
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1521:

/* Line 1464 of yacc.c  */
#line 66818 "hlaparse.bsn"
    {
				yyerror( "Error in @isdigit function [@isdigit(i)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);

			;}
    break;

  case 1522:

/* Line 1464 of yacc.c  */
#line 66836 "hlaparse.bsn"
    {
				_here;
				IsLowerFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1523:

/* Line 1464 of yacc.c  */
#line 66848 "hlaparse.bsn"
    {
				yyerror( "Error in @islower function [@islower(i)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);

			;}
    break;

  case 1524:

/* Line 1464 of yacc.c  */
#line 66865 "hlaparse.bsn"
    {
				_here;
				IsSpaceFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1525:

/* Line 1464 of yacc.c  */
#line 66877 "hlaparse.bsn"
    {
				yyerror( "Error in @isspace function [@isspace(i)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);

			;}
    break;

  case 1526:

/* Line 1464 of yacc.c  */
#line 66895 "hlaparse.bsn"
    {
				_here;
				IsUpperFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1527:

/* Line 1464 of yacc.c  */
#line 66907 "hlaparse.bsn"
    {
				yyerror( "Error in @isupper function [@isupper(i)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);

			;}
    break;

  case 1528:

/* Line 1464 of yacc.c  */
#line 66926 "hlaparse.bsn"
    {
				_here;
				IsXdigitFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1529:

/* Line 1464 of yacc.c  */
#line 66938 "hlaparse.bsn"
    {
				yyerror( "Error in @isxdigit function [@isxdigit(i)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);

			;}
    break;

  case 1530:

/* Line 1464 of yacc.c  */
#line 66958 "hlaparse.bsn"
    {
				_here;
				LogFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1531:

/* Line 1464 of yacc.c  */
#line 66970 "hlaparse.bsn"
    {
				yyerror( "Error in @log function [@log(f)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tReal80, 
					&real80_ste
				);

			;}
    break;

  case 1532:

/* Line 1464 of yacc.c  */
#line 66990 "hlaparse.bsn"
    {
				_here;
				Log10Func
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 

				);
				_here;
			;}
    break;

  case 1533:

/* Line 1464 of yacc.c  */
#line 67003 "hlaparse.bsn"
    {
				yyerror( "Error in @log10 function [@log10(f)]" );

				ClrConst

				( 
					YYS &(yyval.v), 
					tReal80, 
					&real80_ste
				);

			;}
    break;

  case 1534:

/* Line 1464 of yacc.c  */
#line 67022 "hlaparse.bsn"
    {
				_here;
				SetConst
				( 
					YYS &(yyval.v), 
					(yyvsp[(3) - (4)].v.pType), 
					(yyvsp[(3) - (4)].v.Type),
					YYS &(yyvsp[(3) - (4)].v)
				);
				_here;
			;}
    break;

  case 1535:

/* Line 1464 of yacc.c  */
#line 67036 "hlaparse.bsn"
    {
				yyerror( "Error in @max function [@max(list)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tReal80, 
					&real80_ste
				);

			;}
    break;

  case 1536:

/* Line 1464 of yacc.c  */
#line 67053 "hlaparse.bsn"
    {
					_here;
					SetConst
					( 
						YYS &(yyval.v), 
						(yyvsp[(1) - (1)].v.pType), 
						(yyvsp[(1) - (1)].v.Type),
						YYS &(yyvsp[(1) - (1)].v)
					);
					_here;
				;}
    break;

  case 1537:

/* Line 1464 of yacc.c  */
#line 67067 "hlaparse.bsn"
    {

					_here;
					_if
					( 
						MakeCompatible
						( 
							&(yyvsp[(1) - (3)].v), 
							&(yyvsp[(3) - (3)].v) 
						)
					)


						SetConst
						( 
							YYS &(yyval.v), 
							(yyvsp[(3) - (3)].v.pType), 
							(yyvsp[(3) - (3)].v.Type),
							YYS &(yyvsp[(3) - (3)].v)
						);
						_switch( (yyvsp[(1) - (3)].v.pType) )

							_case( tBoolean )
							_case( tEnum  )
							_case( tByte  )
							_case( tWord  )
							_case( tDWord )
							_case( tUns8  )
							_case( tUns16 )
							_case( tUns32 )
							_case( tUns64 )
							_case( tUns128 )
							_case( tQWord )
							_case( tTByte )
							_case( tLWord )
							
								bigmaxUns
								(
									&(yyval.v.u.lwordval)[0], 
									&(yyvsp[(1) - (3)].v.u.lwordval)[0], 
									&(yyvsp[(3) - (3)].v.u.lwordval)[0] 
								);
								
							_endcase


							_case( tInt8  )
							_case( tInt16 )
							_case( tInt32 )
							_case( tInt64 )
							_case( tInt128 )

								bigmaxInt
								(
									&(yyval.v.u.lwordval)[0], 
									&(yyvsp[(1) - (3)].v.u.lwordval)[0], 
									&(yyvsp[(3) - (3)].v.u.lwordval)[0] 
								);
								
							_endcase


							_case( tChar )

								(yyval.v.u.charval) = 
									max
									( 
										(yyvsp[(1) - (3)].v.u.charval), 
										(yyvsp[(3) - (3)].v.u.charval) 
									);

							_endcase


							_case( tReal32 )
							
								_if
								( 
									(yyvsp[(1) - (3)].v.u.fltval.f.f) > (yyvsp[(3) - (3)].v.u.fltval.f.f) 
								)
								
									(yyval.v.u.fltval) = (yyvsp[(1) - (3)].v.u.fltval);
								
								_else
								
									(yyval.v.u.fltval) = (yyvsp[(3) - (3)].v.u.fltval);
								
								_endif
								
							_endcase
								
								 
							_case( tReal64 )
							
								_if
								( 
									(yyvsp[(1) - (3)].v.u.fltval.f.d) > (yyvsp[(3) - (3)].v.u.fltval.f.d) 
								)
								
									(yyval.v.u.fltval) = (yyvsp[(1) - (3)].v.u.fltval);
								
								_else
								
									(yyval.v.u.fltval) = (yyvsp[(3) - (3)].v.u.fltval);
								
								_endif
								
							_endcase
								
								 
							_case( tReal80 )

								fmax80
								( 
									&(yyval.v.u.fltval),
									(yyvsp[(1) - (3)].v.u.fltval), 
									(yyvsp[(3) - (3)].v.u.fltval) 
								);

							_endcase

							_case( tString )
							_case( tZString )

								_if
								( 
									_strge
									( 
										(yyvsp[(1) - (3)].v.u.strval), 
										(yyvsp[(3) - (3)].v.u.strval) 
									)
								) 

									(yyval.v.u.strval) = (yyvsp[(1) - (3)].v.u.strval);
									free2( vss (yyvsp[(3) - (3)].v.u.strval) );

								_else

									(yyval.v.u.strval) = (yyvsp[(3) - (3)].v.u.strval);
									free2( vss (yyvsp[(1) - (3)].v.u.strval) );

								_endif

							_endcase

							_default

								yyerror
								( 
									"Max doesn't allow that operand type"
								);
								ClrConst
								( 
									YYS &(yyval.v), 
									tUns32, 
									&uns32_ste
								);


						_endswitch

					_else

						yyerror( "Type mismatch in operands" );
						ClrConst
						( 
							YYS &(yyval.v), 
							tUns32, 
							&uns32_ste
						);


					_endif
					_here;
				;}
    break;

  case 1538:

/* Line 1464 of yacc.c  */
#line 67250 "hlaparse.bsn"
    {
				_here;
				SetConst
				( 
					YYS &(yyval.v), 
					(yyvsp[(3) - (4)].v.pType), 
					(yyvsp[(3) - (4)].v.Type),
					YYS &(yyvsp[(3) - (4)].v)
				);
				_here;
			;}
    break;

  case 1539:

/* Line 1464 of yacc.c  */
#line 67264 "hlaparse.bsn"
    {

				yyerror( "Error in @min function [@min(list)]" );

				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tUns32, 
					&uns32_ste
				);
				_here;

			;}
    break;

  case 1540:

/* Line 1464 of yacc.c  */
#line 67286 "hlaparse.bsn"
    {
					_here;
					SetConst
					( 
						YYS &(yyval.v), 
						(yyvsp[(1) - (1)].v.pType), 
						(yyvsp[(1) - (1)].v.Type),
						YYS &(yyvsp[(1) - (1)].v)
					);
					_here;
				;}
    break;

  case 1541:

/* Line 1464 of yacc.c  */
#line 67299 "hlaparse.bsn"
    {
					_here;
					_if( MakeCompatible( &(yyvsp[(1) - (3)].v), &(yyvsp[(3) - (3)].v) ))


						SetConst
						( 
							YYS &(yyval.v), 
							(yyvsp[(3) - (3)].v.pType), 
							(yyvsp[(3) - (3)].v.Type),
							YYS &(yyvsp[(3) - (3)].v)
						);
						_switch( (yyvsp[(1) - (3)].v.pType) )

							_case( tBoolean )
							_case( tEnum  )
							_case( tChar  )
							_case( tWChar )
							_case( tByte  )
							_case( tWord  )
							_case( tDWord )
							_case( tQWord )
							_case( tTByte )
							_case( tLWord )
							_case( tUns8  )
							_case( tUns16 )
							_case( tUns32 )
							_case( tUns64 )
							_case( tUns128 )

								bigminUns
								( 
									&(yyval.v.u.lwordval)[0],
									&(yyvsp[(1) - (3)].v.u.lwordval)[0],
									&(yyvsp[(3) - (3)].v.u.lwordval)[0]
								);

							_endcase


							_case( tInt8  )
							_case( tInt16 )
							_case( tInt32 )
							_case( tInt64 )
							_case( tInt128 )

								bigminInt
								( 
									&(yyval.v.u.lwordval)[0],
									&(yyvsp[(1) - (3)].v.u.lwordval)[0],
									&(yyvsp[(3) - (3)].v.u.lwordval)[0]
								);

							_endcase


							_case( tReal32 )  
							
								_if
								( 
									(yyvsp[(1) - (3)].v.u.fltval.f.f) < (yyvsp[(3) - (3)].v.u.fltval.f.f) 
								)
								
									(yyval.v.u.fltval) = (yyvsp[(1) - (3)].v.u.fltval);
								
								_else
								
									(yyval.v.u.fltval) = (yyvsp[(3) - (3)].v.u.fltval);
								
								_endif
								
							_endcase


							_case( tReal64 )
							
								_if
								( 
									(yyvsp[(1) - (3)].v.u.fltval.f.d) < (yyvsp[(3) - (3)].v.u.fltval.f.d) 
								)
								
									(yyval.v.u.fltval) = (yyvsp[(1) - (3)].v.u.fltval);
								
								_else
								
									(yyval.v.u.fltval) = (yyvsp[(3) - (3)].v.u.fltval);
								
								_endif
								
							_endcase


							_case( tReal80 )

								fmin80
								(
									&(yyval.v.u.fltval),
									(yyvsp[(1) - (3)].v.u.fltval),
									(yyvsp[(3) - (3)].v.u.fltval)
								);
								

							_endcase

							_case( tString )
							_case( tZString )

								_if
								( 
									_strle
									( 
										(yyvsp[(1) - (3)].v.u.strval), 
										(yyvsp[(3) - (3)].v.u.strval) 
									)
								) 

									(yyval.v.u.strval) = (yyvsp[(1) - (3)].v.u.strval);
									free2( vss (yyvsp[(3) - (3)].v.u.strval) );

								_else

									(yyval.v.u.strval) = (yyvsp[(3) - (3)].v.u.strval);
									free2( vss (yyvsp[(1) - (3)].v.u.strval) );

								_endif

							_endcase

							_default

								yyerror
								( 
									"Min doesn't allow that operand type"
								);
								ClrConst
								( 
									YYS &(yyval.v), 
									tUns32, 
									&uns32_ste
								);


						_endswitch

					_else

						yyerror( "Type mismatch in operands" );
						ClrConst
						( 
							YYS &(yyval.v), 
							tUns32, 
							&uns32_ste
						);

					_endif
					_here;
				;}
    break;

  case 1542:

/* Line 1464 of yacc.c  */
#line 67463 "hlaparse.bsn"
    {
				_here;
				(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
			;}
    break;

  case 1543:

/* Line 1464 of yacc.c  */
#line 67469 "hlaparse.bsn"
    {
				_here;
				(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
				(yyval.adrs.Sym) = NULL;
			;}
    break;

  case 1544:

/* Line 1464 of yacc.c  */
#line 67482 "hlaparse.bsn"
    {
				unsigned		modRM;
				unsigned		hasSib;
				unsigned		sib;
				unsigned		dispType;
				int				disp;
				char			sibStr[32];
				char			dispLabel[256];
				char			dispStr[ 512];
				char			rsltStr[1024];
				union	YYSTYPE value;
				
				_here;
				_if( !checkSmallInt( YYS &(yyvsp[(3) - (6)].v) ) || (yyvsp[(3) - (6)].v.u.unsval) > 7 )

					yyerror( "First operand must be in the range 0..7" );
					strcpy( rsltStr, "" );

				_else
				
					EncodeHLAAdrs
					(
						&(yyvsp[(5) - (6)].adrs),
						&modRM,
						&hasSib,
						&sib,
						&dispType,
						&disp,
						dispLabel
					);
					_if( hasSib )
					
						sprintf( sibStr, " byte $%x;\n", sib );
						
					_else
					
						strcpy( sibStr, "" );
						
					_endif
					_switch( dispType )
					
						_case( 0 )
						
							strcpy( dispStr, "" );
							
						_endcase
						
						_case( 1 )
						
							sprintf( dispStr, " byte %d;\n", disp );
							
						_endcase
						
						_case( 2 )
						
							sprintf( dispStr, " dword %d;\n", disp );
							
						_endcase
						
						_case( 3 )
						
							sprintf( dispStr, " dword %s;\n", dispLabel );
							
						_endcase
						
						_default
						
							yyerror
							( 
								"Bad EncodeAdrs dispType (internal HLA error)" 
							);
							strcpy( dispStr, "" );
							
					_endswitch
					sprintf
					(
						rsltStr,
						" byte $%x;\n"		// mod-reg-r/m
						"%s"				// sib
						"%s",				// disp
						modRM,
						sibStr,
						dispStr
					);
					
				_endif
				value.v.u.strval = hlastrdup2( rsltStr );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);				
				_here;
			;}
    break;

  case 1545:

/* Line 1464 of yacc.c  */
#line 67587 "hlaparse.bsn"
    {
				_here;
				OddFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1546:

/* Line 1464 of yacc.c  */
#line 67599 "hlaparse.bsn"
    {

				yyerror( "Error in @odd function [@odd(i)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);

			;}
    break;

  case 1547:

/* Line 1464 of yacc.c  */
#line 67623 "hlaparse.bsn"
    {
			_here;
			RandFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v) 
			);
			_here;

		;}
    break;

  case 1548:

/* Line 1464 of yacc.c  */
#line 67640 "hlaparse.bsn"
    {
			yyerror( "Error in @random function [@random(i)]" );

			ClrConst
			( 
				YYS &(yyval.v), 
				tInt32, 
				&int32_ste
			);
		;}
    break;

  case 1549:

/* Line 1464 of yacc.c  */
#line 67661 "hlaparse.bsn"
    {
			_here;
			RandomizeFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v) 
			);
			_here;
		;}
    break;

  case 1550:

/* Line 1464 of yacc.c  */
#line 67677 "hlaparse.bsn"
    {
			yyerror( "Error in @randomize function [@randomize(i)]" );

			ClrConst
			( 
				YYS &(yyval.v), 
				tInt32, 
				&int32_ste
			);

		;}
    break;

  case 1551:

/* Line 1464 of yacc.c  */
#line 67699 "hlaparse.bsn"
    {
			_here;
			SinFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v) 
			);
			_here;
		;}
    break;

  case 1552:

/* Line 1464 of yacc.c  */
#line 67717 "hlaparse.bsn"
    {
			yyerror( "Error in @sin function [@sin(f)]" );

			ClrConst
			( 
				YYS &(yyval.v), 
				tReal80, 
				&real80_ste
			);
		;}
    break;

  case 1553:

/* Line 1464 of yacc.c  */
#line 67747 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (12)].v.pType) != tArray )
				
				yyerror( "Expected an array as the first @sort parameter\n" );
				
			_elseif( !IsSmallNumber( (yyvsp[(5) - (12)].v.pType) ))
			
				yyerror
				( 
					"Expected a small array element count value as the second\n"
					"@sort parameter.\n"
				);
				
			_elseif( (yyvsp[(5) - (12)].v.u.unsval) > (yyvsp[(3) - (12)].v.NumElements) )
			
				yyerror
				(
					"Second parameter of @sort is greater than the number of\n"
					"elements in the array specified by parameter #1 (or the\n"
					"value is negative).\n"
				);
				
			_elseif( (yyvsp[(7) - (12)].cls.sym) == NULL || (yyvsp[(9) - (12)].cls.sym) == NULL )
			
				yyerror
				(
					"The third and fourth parameters of @sort must be the\n"
					"names of VAL objects declared in your source file.\n"
				);
				
			_elseif
			( 
					(yyvsp[(7) - (12)].cls.sym)->SymClass != cValue 
				||	(yyvsp[(9) - (12)].cls.sym)->SymClass != cValue 
			)
			
				yyerror
				(
					"The third and fourth parameters of @sort must be the\n"
					"names of VAL objects declared in your source file.\n"
				);
				
			_elseif( (yyvsp[(11) - (12)].v.pType) != tString && (yyvsp[(11) - (12)].v.pType) != tZString )
			
				yyerror
				(
					"The fifth parameter of @sort must be a string holding\n"
					"the name of a macro that will compare the values in the\n"
					"VAL objects specified by the third and fourth \n"
					"parameters.\n"
				);
				
			_else
				
				SortArray
				( 
					YYS &(yyvsp[(3) - (12)].v),
					0, 
					(yyvsp[(5) - (12)].v.u.unsval)-1, 
					(yyvsp[(7) - (12)].cls.sym), 
					(yyvsp[(9) - (12)].cls.sym),
					(yyvsp[(11) - (12)].v.u.strval)
				);
			
			_endif
			(yyval.v) = (yyvsp[(3) - (12)].v);				// Return result array (hopefully sorted)
			FreeValue( YYS &(yyvsp[(5) - (12)].v) );	// In case there was an error.
			FreeValue( YYS &(yyvsp[(11) - (12)].v) );	// Free up macro name string.
			_here;
		;}
    break;

  case 1554:

/* Line 1464 of yacc.c  */
#line 67828 "hlaparse.bsn"
    {
			_here;
			SqrtFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v) 
			);
			_here;
		;}
    break;

  case 1555:

/* Line 1464 of yacc.c  */
#line 67844 "hlaparse.bsn"
    {
			yyerror( "Error in @sqrt function [@sqrt(f)]" );

			ClrConst
			( 
				YYS &(yyval.v), 
				tReal80, 
				&real80_ste
			);

		;}
    break;

  case 1556:

/* Line 1464 of yacc.c  */
#line 67865 "hlaparse.bsn"
    {
				_here;
				SystemFunc( YYS &(yyval.v), YYS &(yyvsp[(3) - (4)].v) );
				_here;
			;}
    break;

  case 1557:

/* Line 1464 of yacc.c  */
#line 67879 "hlaparse.bsn"
    {
				_here;
				System2Func( YYS &(yyval.v), YYS &(yyvsp[(3) - (4)].v) );
				_here;
			;}
    break;

  case 1558:

/* Line 1464 of yacc.c  */
#line 67895 "hlaparse.bsn"
    {
			_here;
			TanFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v) 
			);
			_here;
		;}
    break;

  case 1559:

/* Line 1464 of yacc.c  */
#line 67911 "hlaparse.bsn"
    {
			yyerror( "Error in @tan function [@tan(f)]" );

			ClrConst
			( 
				YYS &(yyval.v), 
				tReal80, 
				&real80_ste
			);
		;}
    break;

  case 1560:

/* Line 1464 of yacc.c  */
#line 67930 "hlaparse.bsn"
    {
			_here;
			TimeFunc( YYS &(yyval.v) );
			_here;
		;}
    break;

  case 1561:

/* Line 1464 of yacc.c  */
#line 67941 "hlaparse.bsn"
    {
			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			v.v.u.unsval = threadSafe;
			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v
			);
			_here;
		;}
    break;

  case 1562:

/* Line 1464 of yacc.c  */
#line 68000 "hlaparse.bsn"
    {				/* $9 */

				_here;
				DeleteFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (8)].v), 
					YYS &(yyvsp[(5) - (8)].v), 
					YYS &(yyvsp[(7) - (8)].v) 
				);
				_here;
			;}
    break;

  case 1563:

/* Line 1464 of yacc.c  */
#line 68015 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror( "Error in DELETE function [delete(s,i,i)]" );

				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);
			;}
    break;

  case 1564:

/* Line 1464 of yacc.c  */
#line 68046 "hlaparse.bsn"
    {
			_here;
			IndexFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v) 
			);
			_here;
		;}
    break;

  case 1565:

/* Line 1464 of yacc.c  */
#line 68060 "hlaparse.bsn"
    {
				yyerror( "Error in INDEX function [index(s,i,s)]" );

				/*
				** Return -1 to indicate that we did not find the string
				*/

				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);

			;}
    break;

  case 1566:

/* Line 1464 of yacc.c  */
#line 68088 "hlaparse.bsn"
    {
				_here;
				InsertFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (8)].v), 
					YYS &(yyvsp[(5) - (8)].v), 
					YYS &(yyvsp[(7) - (8)].v) 
				);
				_here;
			;}
    break;

  case 1567:

/* Line 1464 of yacc.c  */
#line 68103 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror( "Error in INSERT function [insert(s,i,s)]" );

				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);
			;}
    break;

  case 1568:

/* Line 1464 of yacc.c  */
#line 68125 "hlaparse.bsn"
    {
				_here;
				LengthFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (4)].v) 
				);
				_here;
			;}
    break;

  case 1569:

/* Line 1464 of yacc.c  */
#line 68137 "hlaparse.bsn"
    {

				yyerror( "Error in LENGTH function [length(s)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);

			;}
    break;

  case 1570:

/* Line 1464 of yacc.c  */
#line 68155 "hlaparse.bsn"
    {
				_here;
				LowerFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (6)].v), 
					YYS &(yyvsp[(5) - (6)].v) 
				);
				_here;
			;}
    break;

  case 1571:

/* Line 1464 of yacc.c  */
#line 68170 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror( "Error in LOWERCASE function [lowercase(s,i)]" );

				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);
			;}
    break;

  case 1572:

/* Line 1464 of yacc.c  */
#line 68201 "hlaparse.bsn"
    {
			_here;
			ReplaceFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v) 
			);
			_here;
		;}
    break;

  case 1573:

/* Line 1464 of yacc.c  */
#line 68221 "hlaparse.bsn"
    {
			_here;
			ReplaceFunc2
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v) 
			);
			_here;
		;}
    break;

  case 1574:

/* Line 1464 of yacc.c  */
#line 68242 "hlaparse.bsn"
    {
			_here;
			RIndexFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v) 
			);
			_here;
		;}
    break;

  case 1575:

/* Line 1464 of yacc.c  */
#line 68256 "hlaparse.bsn"
    {

				yyerror( "Error in RINDEX function [rindex(s,i,s)]" );

				/*
				** Return -1 to indicate that we did not find the string
				*/

				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);

			;}
    break;

  case 1576:

/* Line 1464 of yacc.c  */
#line 68286 "hlaparse.bsn"
    {				/* $9								*/

				_here;
				strbrkFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (8)].v), 
					YYS &(yyvsp[(5) - (8)].v), 
					YYS &(yyvsp[(7) - (8)].v) 
				);
				_here;
			;}
    break;

  case 1577:

/* Line 1464 of yacc.c  */
#line 68301 "hlaparse.bsn"
    {
				yyerror( "Error in STRBRK function [strbrk(s,i,cs)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);

			;}
    break;

  case 1578:

/* Line 1464 of yacc.c  */
#line 68331 "hlaparse.bsn"
    {				/* $7								*/
				_here;
				strsetFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (6)].v), 
					YYS &(yyvsp[(5) - (6)].v) 
				);
				_here;
			;}
    break;

  case 1579:

/* Line 1464 of yacc.c  */
#line 68344 "hlaparse.bsn"
    {
				union	YYSTYPE	value;

				yyerror( "Error in STRSET function [strset(c,i)]" );

				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);

			;}
    break;

  case 1580:

/* Line 1464 of yacc.c  */
#line 68378 "hlaparse.bsn"
    {				/* $9								*/

				_here;
				strspanFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (8)].v), 
					YYS &(yyvsp[(5) - (8)].v), 
					YYS &(yyvsp[(7) - (8)].v) 
				);
				_here;
			;}
    break;

  case 1581:

/* Line 1464 of yacc.c  */
#line 68393 "hlaparse.bsn"
    {
				yyerror( "Error in STRSPAN function [strspan(s,i,cs)]" );

				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);

			;}
    break;

  case 1582:

/* Line 1464 of yacc.c  */
#line 68424 "hlaparse.bsn"
    {
			_here;
			SubstrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v) 
			);
			_here;
		;}
    break;

  case 1583:

/* Line 1464 of yacc.c  */
#line 68439 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror( "Error in SUBSTR function [@substr(s,i,i)]" );

				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);
			;}
    break;

  case 1584:

/* Line 1464 of yacc.c  */
#line 68462 "hlaparse.bsn"
    {
			_here;
			LeftFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v) 
			);
			_here;
		;}
    break;

  case 1585:

/* Line 1464 of yacc.c  */
#line 68476 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror( "Error in LEFT function [@left(s,i)]" );

				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);
			;}
    break;

  case 1586:

/* Line 1464 of yacc.c  */
#line 68499 "hlaparse.bsn"
    {
			_here;
			LeftDelFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v) 
			);
			_here;
		;}
    break;

  case 1587:

/* Line 1464 of yacc.c  */
#line 68513 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror( "Error in LEFTDEL function [@leftdel(s,i)]" );

				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);
			;}
    break;

  case 1588:

/* Line 1464 of yacc.c  */
#line 68540 "hlaparse.bsn"
    {
			_here;
			RightFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v) 
			);
			_here;
		;}
    break;

  case 1589:

/* Line 1464 of yacc.c  */
#line 68554 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror( "Error in RIGHT function [@right(s,i)]" );

				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);
			;}
    break;

  case 1590:

/* Line 1464 of yacc.c  */
#line 68577 "hlaparse.bsn"
    {
			_here;
			RightDelFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v) 
			);
			_here;
		;}
    break;

  case 1591:

/* Line 1464 of yacc.c  */
#line 68591 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror( "Error in RIGHTDEL function [@rightdel(s,i)]" );

				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);
			;}
    break;

  case 1592:

/* Line 1464 of yacc.c  */
#line 68622 "hlaparse.bsn"
    {				/* $11							*/

				_here;
				TokenizeFunc
				( 
					YYS &(yyval.v), 
					YYS &(yyvsp[(3) - (10)].v), 
					YYS &(yyvsp[(5) - (10)].v), 
					YYS &(yyvsp[(7) - (10)].v), 
					YYS &(yyvsp[(9) - (10)].v) 
				);
				_here;
			;}
    break;

  case 1593:

/* Line 1464 of yacc.c  */
#line 68639 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror
				( 
					"Error in @TOKENIZE function [tokenize(s,i,cs,cs)]" 
				);

				/*
				** Create a dummy array of strings with a single
				** element containing an empty string.
				*/

				(yyval.v.pType) = tArray;
				(yyval.v.Type) = &string_ste;
				(yyval.v.SymClass) = cConstant;
				(yyval.v.ObjectSize) = 4;
				(yyval.v.StaticName) = NULL;
				(yyval.v.LexLevel) = 1;
				(yyval.v.IsExternal) = 0;
				(yyval.v.IsReferenced) = NULL;
				(yyval.v.Arity) = 1;
				(yyval.v.NumElements) = 1;
				(yyval.v.Dimensions) = malloc2( sizeofInt );
				*(yyval.v.Dimensions) = 1;
				(yyval.v.Fields) = NULL;
				(yyval.v.Base) = NULL;
				(yyval.v.FieldCnt) = 0;
				(yyval.v.u.ArrayOfValues) = malloc2( sizeofSymNode);
				
				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS (yyval.v.u.ArrayOfValues), 
					tString, 
					&string_ste,
					YYS &value
				);


			;}
    break;

  case 1594:

/* Line 1464 of yacc.c  */
#line 68696 "hlaparse.bsn"
    {
			_here;
			TrimFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v) 
			);
			_here;
		;}
    break;

  case 1595:

/* Line 1464 of yacc.c  */
#line 68716 "hlaparse.bsn"
    {
			_here;
			DelSpacesFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v) 
			);
			_here;
		;}
    break;

  case 1596:

/* Line 1464 of yacc.c  */
#line 68730 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror( "Error in @TRIM function [trim(s,i)]" );
				exit( 1 );

			;}
    break;

  case 1597:

/* Line 1464 of yacc.c  */
#line 68754 "hlaparse.bsn"
    {
			_here;
			UpperFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v) 
			);
			_here;
		;}
    break;

  case 1598:

/* Line 1464 of yacc.c  */
#line 68768 "hlaparse.bsn"
    {
				union	YYSTYPE value;

				yyerror( "Error in @UPPERCASE function [uppercase(s,i)]" );

				value.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &value
				);
			;}
    break;

  case 1599:

/* Line 1464 of yacc.c  */
#line 68815 "hlaparse.bsn"
    {				/* $7						*/
			_here;
			peekCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1600:

/* Line 1464 of yacc.c  */
#line 68836 "hlaparse.bsn"
    {				/* $9						*/
			_here;
			peekCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1601:

/* Line 1464 of yacc.c  */
#line 68859 "hlaparse.bsn"
    {				/* $11						*/
			_here;
			peekCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1602:

/* Line 1464 of yacc.c  */
#line 68894 "hlaparse.bsn"
    {				/* $7						*/
			_here;
			oneCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1603:

/* Line 1464 of yacc.c  */
#line 68915 "hlaparse.bsn"
    {				/* $9						*/
			_here;
			oneCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1604:

/* Line 1464 of yacc.c  */
#line 68938 "hlaparse.bsn"
    {				/* $11						*/
			_here;
			oneCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1605:

/* Line 1464 of yacc.c  */
#line 68979 "hlaparse.bsn"
    {				/* $7						*/
			_here;
			uptoCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1606:

/* Line 1464 of yacc.c  */
#line 69000 "hlaparse.bsn"
    {				/* $9						*/
			_here;
			uptoCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1607:

/* Line 1464 of yacc.c  */
#line 69023 "hlaparse.bsn"
    {				/* $11						*/
			_here;
			uptoCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1608:

/* Line 1464 of yacc.c  */
#line 69059 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			zeroOrOneCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1609:

/* Line 1464 of yacc.c  */
#line 69080 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			zeroOrOneCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1610:

/* Line 1464 of yacc.c  */
#line 69103 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			zeroOrOneCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1611:

/* Line 1464 of yacc.c  */
#line 69138 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			zeroOrMoreCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1612:

/* Line 1464 of yacc.c  */
#line 69159 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			zeroOrMoreCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1613:

/* Line 1464 of yacc.c  */
#line 69182 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			zeroOrMoreCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1614:

/* Line 1464 of yacc.c  */
#line 69218 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			oneOrMoreCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1615:

/* Line 1464 of yacc.c  */
#line 69239 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			oneOrMoreCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1616:

/* Line 1464 of yacc.c  */
#line 69262 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			oneOrMoreCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1617:

/* Line 1464 of yacc.c  */
#line 69304 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			exactlynCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1618:

/* Line 1464 of yacc.c  */
#line 69328 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			exactlynCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1619:

/* Line 1464 of yacc.c  */
#line 69354 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			exactlynCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1620:

/* Line 1464 of yacc.c  */
#line 69396 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			firstnCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1621:

/* Line 1464 of yacc.c  */
#line 69420 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			firstnCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1622:

/* Line 1464 of yacc.c  */
#line 69446 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			firstnCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1623:

/* Line 1464 of yacc.c  */
#line 69490 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			norlessCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1624:

/* Line 1464 of yacc.c  */
#line 69514 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			norlessCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1625:

/* Line 1464 of yacc.c  */
#line 69540 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			norlessCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1626:

/* Line 1464 of yacc.c  */
#line 69582 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			normoreCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1627:

/* Line 1464 of yacc.c  */
#line 69606 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			normoreCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1628:

/* Line 1464 of yacc.c  */
#line 69632 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			normoreCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1629:

/* Line 1464 of yacc.c  */
#line 69679 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			ntomCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				YYS &(yyvsp[(9) - (10)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1630:

/* Line 1464 of yacc.c  */
#line 69706 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			ntomCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				YYS &(yyvsp[(9) - (12)].v), 
				(yyvsp[(11) - (12)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1631:

/* Line 1464 of yacc.c  */
#line 69735 "hlaparse.bsn"
    {					/* $15						*/
			_here;
			ntomCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (14)].v), 
				YYS &(yyvsp[(5) - (14)].v), 
				YYS &(yyvsp[(7) - (14)].v), 
				YYS &(yyvsp[(9) - (14)].v), 
				(yyvsp[(11) - (14)].s), 
				(yyvsp[(13) - (14)].s) 
			);
			_here;
		;}
    break;

  case 1632:

/* Line 1464 of yacc.c  */
#line 69783 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			exactlyntomCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				YYS &(yyvsp[(9) - (10)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1633:

/* Line 1464 of yacc.c  */
#line 69811 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			exactlyntomCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				YYS &(yyvsp[(9) - (12)].v), 
				(yyvsp[(11) - (12)].s),
				NULL 
			);
			_here;
		;}
    break;

  case 1634:

/* Line 1464 of yacc.c  */
#line 69840 "hlaparse.bsn"
    {					/* $15						*/
			_here;
			exactlyntomCsetFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (14)].v), 
				YYS &(yyvsp[(5) - (14)].v), 
				YYS &(yyvsp[(7) - (14)].v), 
				YYS &(yyvsp[(9) - (14)].v), 
				(yyvsp[(11) - (14)].s),
				(yyvsp[(13) - (14)].s) 
			);
			_here;
		;}
    break;

  case 1635:

/* Line 1464 of yacc.c  */
#line 69885 "hlaparse.bsn"
    {				/* $7						*/
			_here;
			peekCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1636:

/* Line 1464 of yacc.c  */
#line 69906 "hlaparse.bsn"
    {				/* $9						*/
			_here;
			peekCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1637:

/* Line 1464 of yacc.c  */
#line 69929 "hlaparse.bsn"
    {				/* $11						*/
			_here;
			peekCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1638:

/* Line 1464 of yacc.c  */
#line 69957 "hlaparse.bsn"
    {				/* $7						*/
			_here;
			peekiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1639:

/* Line 1464 of yacc.c  */
#line 69978 "hlaparse.bsn"
    {				/* $9						*/
			_here;
			peekiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1640:

/* Line 1464 of yacc.c  */
#line 70001 "hlaparse.bsn"
    {				/* $11						*/
			_here;
			peekiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1641:

/* Line 1464 of yacc.c  */
#line 70043 "hlaparse.bsn"
    {				/* $7						*/
			_here;
			oneCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v),
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1642:

/* Line 1464 of yacc.c  */
#line 70064 "hlaparse.bsn"
    {				/* $9						*/
			_here;
			oneCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1643:

/* Line 1464 of yacc.c  */
#line 70087 "hlaparse.bsn"
    {				/* $11						*/
			_here;
			oneCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1644:

/* Line 1464 of yacc.c  */
#line 70115 "hlaparse.bsn"
    {				/* $7						*/
			_here;
			oneiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1645:

/* Line 1464 of yacc.c  */
#line 70136 "hlaparse.bsn"
    {				/* $9						*/
			_here;
			oneiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1646:

/* Line 1464 of yacc.c  */
#line 70159 "hlaparse.bsn"
    {				/* $11						*/
			_here;
			oneiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1647:

/* Line 1464 of yacc.c  */
#line 70203 "hlaparse.bsn"
    {				/* $7						*/
			_here;
			uptoCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1648:

/* Line 1464 of yacc.c  */
#line 70224 "hlaparse.bsn"
    {				/* $9						*/
			_here;
			uptoCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1649:

/* Line 1464 of yacc.c  */
#line 70247 "hlaparse.bsn"
    {				/* $11						*/
			_here;
			uptoCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1650:

/* Line 1464 of yacc.c  */
#line 70275 "hlaparse.bsn"
    {				/* $7						*/
			_here;
			uptoiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1651:

/* Line 1464 of yacc.c  */
#line 70296 "hlaparse.bsn"
    {				/* $9						*/
			_here;
			uptoiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1652:

/* Line 1464 of yacc.c  */
#line 70319 "hlaparse.bsn"
    {				/* $11						*/
			_here;
			uptoiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1653:

/* Line 1464 of yacc.c  */
#line 70358 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			zerooroneCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1654:

/* Line 1464 of yacc.c  */
#line 70379 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			zerooroneCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1655:

/* Line 1464 of yacc.c  */
#line 70402 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			zerooroneCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1656:

/* Line 1464 of yacc.c  */
#line 70430 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			zerooroneiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1657:

/* Line 1464 of yacc.c  */
#line 70451 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			zerooroneiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1658:

/* Line 1464 of yacc.c  */
#line 70474 "hlaparse.bsn"
    {					/* $11						*/

			_here;
			zerooroneiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1659:

/* Line 1464 of yacc.c  */
#line 70512 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			zeroormoreCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1660:

/* Line 1464 of yacc.c  */
#line 70533 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			zeroormoreCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1661:

/* Line 1464 of yacc.c  */
#line 70556 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			zeroormoreCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1662:

/* Line 1464 of yacc.c  */
#line 70584 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			zeroormoreiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1663:

/* Line 1464 of yacc.c  */
#line 70605 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			zeroormoreiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1664:

/* Line 1464 of yacc.c  */
#line 70628 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			zeroormoreiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1665:

/* Line 1464 of yacc.c  */
#line 70667 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			oneormoreCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1666:

/* Line 1464 of yacc.c  */
#line 70688 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			oneormoreCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1667:

/* Line 1464 of yacc.c  */
#line 70711 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			oneormoreCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1668:

/* Line 1464 of yacc.c  */
#line 70739 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			oneormoreiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1669:

/* Line 1464 of yacc.c  */
#line 70760 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			oneormoreiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1670:

/* Line 1464 of yacc.c  */
#line 70783 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			oneormoreiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s), 
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1671:

/* Line 1464 of yacc.c  */
#line 70824 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			exactlynCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1672:

/* Line 1464 of yacc.c  */
#line 70848 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			exactlynCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1673:

/* Line 1464 of yacc.c  */
#line 70874 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			exactlynCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
		;}
    break;

  case 1674:

/* Line 1464 of yacc.c  */
#line 70902 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			exactlyniCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1675:

/* Line 1464 of yacc.c  */
#line 70926 "hlaparse.bsn"
    {					/* $10						*/
			_here;
			exactlyniCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1676:

/* Line 1464 of yacc.c  */
#line 70952 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			exactlyniCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1677:

/* Line 1464 of yacc.c  */
#line 70994 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			firstnCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1678:

/* Line 1464 of yacc.c  */
#line 71018 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			firstnCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1679:

/* Line 1464 of yacc.c  */
#line 71044 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			firstnCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1680:

/* Line 1464 of yacc.c  */
#line 71073 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			firstniCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1681:

/* Line 1464 of yacc.c  */
#line 71097 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			firstniCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1682:

/* Line 1464 of yacc.c  */
#line 71123 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			firstniCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1683:

/* Line 1464 of yacc.c  */
#line 71165 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			norlessCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1684:

/* Line 1464 of yacc.c  */
#line 71189 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			norlessCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1685:

/* Line 1464 of yacc.c  */
#line 71215 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			norlessCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1686:

/* Line 1464 of yacc.c  */
#line 71244 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			norlessiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1687:

/* Line 1464 of yacc.c  */
#line 71268 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			norlessiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1688:

/* Line 1464 of yacc.c  */
#line 71294 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			norlessiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1689:

/* Line 1464 of yacc.c  */
#line 71336 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			normoreCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1690:

/* Line 1464 of yacc.c  */
#line 71360 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			normoreCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1691:

/* Line 1464 of yacc.c  */
#line 71386 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			normoreCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1692:

/* Line 1464 of yacc.c  */
#line 71415 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			normoreiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				YYS &(yyvsp[(7) - (8)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1693:

/* Line 1464 of yacc.c  */
#line 71439 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			normoreiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				(yyvsp[(9) - (10)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1694:

/* Line 1464 of yacc.c  */
#line 71465 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			normoreiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				(yyvsp[(9) - (12)].s), 
				(yyvsp[(11) - (12)].s) 
			);
			_here;
		;}
    break;

  case 1695:

/* Line 1464 of yacc.c  */
#line 71511 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			ntomCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				YYS &(yyvsp[(9) - (10)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1696:

/* Line 1464 of yacc.c  */
#line 71538 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			ntomCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
			    YYS &(yyvsp[(9) - (12)].v), 
				(yyvsp[(11) - (12)].s),
				NULL
			);
			_here;
		;}
    break;

  case 1697:

/* Line 1464 of yacc.c  */
#line 71567 "hlaparse.bsn"
    {					/* $15						*/
			_here;
			ntomCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (14)].v), 
				YYS &(yyvsp[(5) - (14)].v), 
				YYS &(yyvsp[(7) - (14)].v), 
				YYS &(yyvsp[(9) - (14)].v), 
				(yyvsp[(11) - (14)].s),
				(yyvsp[(13) - (14)].s)
			);
			_here;
		;}
    break;

  case 1698:

/* Line 1464 of yacc.c  */
#line 71599 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			ntomiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				YYS &(yyvsp[(9) - (10)].v), 
				NULL, 
				NULL 
			);
			_here;
		;}
    break;

  case 1699:

/* Line 1464 of yacc.c  */
#line 71626 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			ntomiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				YYS &(yyvsp[(9) - (12)].v), 
				(yyvsp[(11) - (12)].s),
				NULL
			);
			_here;
		;}
    break;

  case 1700:

/* Line 1464 of yacc.c  */
#line 71655 "hlaparse.bsn"
    {					/* $15						*/
			_here;
			ntomiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (14)].v), 
				YYS &(yyvsp[(5) - (14)].v), 
				YYS &(yyvsp[(7) - (14)].v), 
				YYS &(yyvsp[(9) - (14)].v), 
				(yyvsp[(11) - (14)].s),
				(yyvsp[(13) - (14)].s)
			);
			_here;
		;}
    break;

  case 1701:

/* Line 1464 of yacc.c  */
#line 71702 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			exactlyntomCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				YYS &(yyvsp[(9) - (10)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1702:

/* Line 1464 of yacc.c  */
#line 71729 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			exactlyntomCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				YYS &(yyvsp[(9) - (12)].v), 
				(yyvsp[(11) - (12)].s),
				NULL 
			);
			_here;
		;}
    break;

  case 1703:

/* Line 1464 of yacc.c  */
#line 71758 "hlaparse.bsn"
    {					/* $15						*/
			_here;
			exactlyntomCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (14)].v), 
				YYS &(yyvsp[(5) - (14)].v), 
				YYS &(yyvsp[(7) - (14)].v), 
				YYS &(yyvsp[(9) - (14)].v), 
				(yyvsp[(11) - (14)].s),
				(yyvsp[(13) - (14)].s) 
			);
			_here;
		;}
    break;

  case 1704:

/* Line 1464 of yacc.c  */
#line 71790 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			exactlyntomiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				YYS &(yyvsp[(7) - (10)].v), 
				YYS &(yyvsp[(9) - (10)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1705:

/* Line 1464 of yacc.c  */
#line 71817 "hlaparse.bsn"
    {					/* $13						*/
			_here;
			exactlyntomiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (12)].v), 
				YYS &(yyvsp[(5) - (12)].v), 
				YYS &(yyvsp[(7) - (12)].v), 
				YYS &(yyvsp[(9) - (12)].v), 
				(yyvsp[(11) - (12)].s),
				NULL 
			);
			_here;
		;}
    break;

  case 1706:

/* Line 1464 of yacc.c  */
#line 71846 "hlaparse.bsn"
    {					/* $15						*/
			_here;
			exactlyntomiCharFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (14)].v), 
				YYS &(yyvsp[(5) - (14)].v), 
				YYS &(yyvsp[(7) - (14)].v), 
				YYS &(yyvsp[(9) - (14)].v), 
				(yyvsp[(11) - (14)].s),
				(yyvsp[(13) - (14)].s) 
			);
			_here;
		;}
    break;

  case 1707:

/* Line 1464 of yacc.c  */
#line 71878 "hlaparse.bsn"
    {					/* $8						*/

			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/
			
			_here;
			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);

			// Only allow a string operand:
			
			_if( (yyvsp[(3) - (6)].v.pType) != tString )
			
				yyerror
				( 
					"Type mismatch, @match requires a string operand "
					"as the first operand"
				);
				
			_else
			
				(yyval.v.u.boolval) = 
					matchRegex
					( 
						(yyvsp[(3) - (6)].v.u.strval), 
						(yyvsp[(5) - (6)].v.u.rx),
						NULL,
						NULL,
						NULL 
					) != NULL;
			
			_endif
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			//FreeValue( YYS &$<v>5 );
			_here;
		;}
    break;

  case 1708:

/* Line 1464 of yacc.c  */
#line 71930 "hlaparse.bsn"
    {					/* $9						*/
		
			int 			result = 0;
			union	YYSTYPE	value;
			
			// Note: DefinedID, for better or for worse, returns
			// a pointer to the "true" symbol table entry if there
			// was an undefined symbol error. This creates some problems
			// in the following code, which the following macro fixes
			
			#define dID(x) (_ifx( (x)==&true_ste, NULL, (x)))

			_here;
			// Only allow a string operand:
			
			_if( (yyvsp[(3) - (8)].v.pType) != tString )
			
				yyerror
				( 
					"Type mismatch, @match requires a string operand "
					"as the first operand"
				);
				
			_else
			
				result = 
					matchRegex
					( 
						(yyvsp[(3) - (8)].v.u.strval), 
						(yyvsp[(5) - (8)].v.u.rx),
						NULL,
						NULL,
						dID( (yyvsp[(7) - (8)].s) ) 
					) != NULL;
			
			_endif
			_if( result )
			
				_if
				(		
						(
								(yyvsp[(7) - (8)].s)->pType == tString 
							||	(yyvsp[(7) - (8)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (8)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (8)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (8)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (8)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (8)].s)->u.strval = value.v.u.strval;
				
			_endif
			
			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);
			(yyval.v.u.boolval) = result;
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			//FreeValue( YYS &$<v>5 );
			_here;
		;}
    break;

  case 1709:

/* Line 1464 of yacc.c  */
#line 72032 "hlaparse.bsn"
    {					/* $11						*/
		
			int 			result = 0;
			union	YYSTYPE	value;

			_here;
			
			// Only allow a string operand:
			
			_if( (yyvsp[(3) - (10)].v.pType) != tString )
			
				yyerror
				( 
					"Type mismatch, @match requires a string operand "
					"as the first operand"
				);
				
			_else
			
				result = 
					matchRegex
					( 
						(yyvsp[(3) - (10)].v.u.strval), 
						(yyvsp[(5) - (10)].v.u.rx),
						dID( (yyvsp[(9) - (10)].s) ),
						NULL,
						dID( (yyvsp[(7) - (10)].s) ) 
					) != NULL;
			
			_endif
			_if( result )
			
				_if
				(		
						(
								(yyvsp[(7) - (10)].s)->pType == tString 
							||	(yyvsp[(7) - (10)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (10)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (10)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (10)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (10)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (10)].s)->u.strval = value.v.u.strval;
				
			_endif
			
			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);
			(yyval.v.u.boolval) = result;
			FreeValue( YYS &(yyvsp[(3) - (10)].v) );
			//FreeValue( YYS &$<v>5 );
			_here;
		;}
    break;

  case 1710:

/* Line 1464 of yacc.c  */
#line 72130 "hlaparse.bsn"
    {					/* $13						*/
		
			int 			result = 0;
			union	YYSTYPE	value;			
				
			_here;
			
			// Only allow a string operand:
			
			_if( (yyvsp[(3) - (12)].v.pType) != tString )
			
				yyerror
				( 
					"Type mismatch, @match requires a string operand "
					"as the first operand"
				);
				
			_else
			
				result = 
					matchRegex
					( 
						(yyvsp[(3) - (12)].v.u.strval), 
						(yyvsp[(5) - (12)].v.u.rx),
						dID( (yyvsp[(9) - (12)].s) ),
						dID( (yyvsp[(11) - (12)].s) ),
						dID( (yyvsp[(7) - (12)].s) ) 
					) != NULL;
			
			_endif
			_if( result )
			
				_if
				(		
						(
								(yyvsp[(7) - (12)].s)->pType == tString 
							||	(yyvsp[(7) - (12)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (12)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (12)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						//FreeValue( &value );
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (12)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (12)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (12)].s)->u.strval = value.v.u.strval;
				
			_endif
			
			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);
			(yyval.v.u.boolval) = result;
			FreeValue( YYS &(yyvsp[(3) - (12)].v) );
			//FreeValue( YYS &$<v>5 );
			_here;
		;}
    break;

  case 1711:

/* Line 1464 of yacc.c  */
#line 72226 "hlaparse.bsn"
    {					/* $8						*/

			_here;
			
			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);

			// Only allow a string operand:
			
			_if( (yyvsp[(3) - (6)].v.pType) != tString )
			
				yyerror
				( 
					"Type mismatch, @match requires a string operand "
					"as the first operand"
				);
				
			_else
			
				(yyval.v.u.boolval) = 
					matchRegex2
					( 
						(yyvsp[(3) - (6)].v.u.strval), 
						(yyvsp[(5) - (6)].v.u.rx),
						NULL,
						NULL,
						NULL 
					) != NULL;
			
			_endif
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			//FreeValue( YYS &$<v>5 );
			_here;
		;}
    break;

  case 1712:

/* Line 1464 of yacc.c  */
#line 72279 "hlaparse.bsn"
    {					/* $9						*/
		
			int 			result = 0;
			union	YYSTYPE	value;

			_here;
			
			// Only allow a string operand:
			
			_if( (yyvsp[(3) - (8)].v.pType) != tString )
			
				yyerror
				( 
					"Type mismatch, @match requires a string operand "
					"as the first operand"
				);
				
			_else
			
				result = 
					matchRegex2
					( 
						(yyvsp[(3) - (8)].v.u.strval), 
						(yyvsp[(5) - (8)].v.u.rx),
						NULL,
						NULL,
						dID( (yyvsp[(7) - (8)].s) ) 
					) != NULL;
			
			_endif
			_if( result )
			
				_if
				(		
						(
								(yyvsp[(7) - (8)].s)->pType == tString 
							||	(yyvsp[(7) - (8)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (8)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (8)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (8)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (8)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (8)].s)->u.strval = value.v.u.strval;
				
			_endif
			
			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);
			(yyval.v.u.boolval) = result;
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			//FreeValue( YYS &$<v>5 );
			_here;
		;}
    break;

  case 1713:

/* Line 1464 of yacc.c  */
#line 72375 "hlaparse.bsn"
    {					/* $11						*/
		
			int 			result = 0;
			union	YYSTYPE	value;

			_here;
			
			// Only allow a string operand:
			
			_if( (yyvsp[(3) - (10)].v.pType) != tString )
			
				yyerror
				( 
					"Type mismatch, @match requires a string operand "
					"as the first operand"
				);
				
			_else
			
				result = 
					matchRegex2
					( 
						(yyvsp[(3) - (10)].v.u.strval), 
						(yyvsp[(5) - (10)].v.u.rx),
						dID( (yyvsp[(9) - (10)].s) ),
						NULL,
						dID( (yyvsp[(7) - (10)].s) ) 
					) != NULL;
			
			_endif
			_if( result )
			
				_if
				(		
						(
								(yyvsp[(7) - (10)].s)->pType == tString 
							||	(yyvsp[(7) - (10)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (10)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (10)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (10)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (10)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (10)].s)->u.strval = value.v.u.strval;
				
			_endif
			
			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);
			(yyval.v.u.boolval) = result;
			FreeValue( YYS &(yyvsp[(3) - (10)].v) );
			//FreeValue( YYS &$<v>5 );
			_here;
		;}
    break;

  case 1714:

/* Line 1464 of yacc.c  */
#line 72473 "hlaparse.bsn"
    {					/* $13						*/
		
			int 			result = 0;
			union	YYSTYPE	value;

			_here;
			
			// Only allow a string operand:
			
			_if( (yyvsp[(3) - (12)].v.pType) != tString )
			
				yyerror
				( 
					"Type mismatch, @match requires a string operand "
					"as the first operand"
				);
				
			_else
			
				result = 
					matchRegex2
					( 
						(yyvsp[(3) - (12)].v.u.strval), 
						(yyvsp[(5) - (12)].v.u.rx),
						dID( (yyvsp[(9) - (12)].s) ),
						dID( (yyvsp[(11) - (12)].s) ),
						dID( (yyvsp[(7) - (12)].s) ) 
					) != NULL;
			
			_endif
			_if( result )
			
				_if
				(		
						(
								(yyvsp[(7) - (12)].s)->pType == tString 
							||	(yyvsp[(7) - (12)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (12)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (12)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (12)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (12)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (12)].s)->u.strval = value.v.u.strval;
				
			_endif
			
			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);
			(yyval.v.u.boolval) = result;
			FreeValue( YYS &(yyvsp[(3) - (12)].v) );
			//FreeValue( YYS &$<v>5 );
			
			_here;
		;}
    break;

  case 1715:

/* Line 1464 of yacc.c  */
#line 72571 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
		;}
    break;

  case 1716:

/* Line 1464 of yacc.c  */
#line 72577 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
		;}
    break;

  case 1717:

/* Line 1464 of yacc.c  */
#line 72593 "hlaparse.bsn"
    {					/* $8						*/

			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			_here;
			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);

			// The LocalOrNonLocalID above had better be a regular expression
			// identifier or this is an error.
			
			_if( (yyvsp[(5) - (6)].s)->pType != tRegex )
			
				yyerror
				( 
					"@match requires a regular expression as the second operand" 
				);
				
			_else
				

				// Only allow a string operand:
				
				_if( (yyvsp[(3) - (6)].v.pType) != tString )
				
					yyerror
					( 
						"Type mismatch, @match requires a string operand "
						"as the first operand"
					);
					
				_else
				
					(yyval.v.u.boolval) = 
						matchRegex
						( 
							(yyvsp[(3) - (6)].v.u.strval), 
							(yyvsp[(5) - (6)].s)->u.rx,
							NULL,
							NULL,
							NULL 
						) != NULL;
				
				_endif
				
			_endif
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			_here;
		;}
    break;

  case 1718:

/* Line 1464 of yacc.c  */
#line 72658 "hlaparse.bsn"
    {					/* $10						*/

			union	YYSTYPE	value;

			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			_here;
			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);

			// The LocalOrNonLocalID above had better be a regular expression
			// identifier or this is an error.
			
			_if( (yyvsp[(5) - (8)].s)->pType != tRegex )
			
				yyerror
				( 
					"@match requires a regular expression as the second operand" 
				);
				
			_else
				

				// Only allow a string operand:
				
				_if( (yyvsp[(3) - (8)].v.pType) != tString )
				
					yyerror
					( 
						"Type mismatch, @match requires a string operand "
						"as the first operand"
					);
					
				_else
				
					(yyval.v.u.boolval) = 
						matchRegex
						( 
							(yyvsp[(3) - (8)].v.u.strval), 
							(yyvsp[(5) - (8)].s)->u.rx,
							NULL,
							NULL, 
							dID( (yyvsp[(7) - (8)].s) )
						) != NULL;
				
				_endif
				
			_endif
			_if( (yyval.v.u.boolval) )
			
				_if
				(		
						(
								(yyvsp[(7) - (8)].s)->pType == tString 
							||	(yyvsp[(7) - (8)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (8)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (8)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (8)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (8)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (8)].s)->u.strval = value.v.u.strval;
				
			_endif
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			_here;
		;}
    break;

  case 1719:

/* Line 1464 of yacc.c  */
#line 72764 "hlaparse.bsn"
    {					/* $12						*/

			union	YYSTYPE	value;

			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			_here;
			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);

			// The LocalOrNonLocalID above had better be a regular expression
			// identifier or this is an error.
			
			_if( (yyvsp[(5) - (10)].s)->pType != tRegex )
			
				yyerror
				( 
					"@match requires a regular expression as the second operand" 
				);
				
			_else
				

				// Only allow a string operand:
				
				_if( (yyvsp[(3) - (10)].v.pType) != tString )
				
					yyerror
					( 
						"Type mismatch, @match requires a string operand "
						"as the first operand"
					);
					
				_else
				
					(yyval.v.u.boolval) = 
						matchRegex
						( 
							(yyvsp[(3) - (10)].v.u.strval), 
							(yyvsp[(5) - (10)].s)->u.rx,
							dID( (yyvsp[(9) - (10)].s) ),
							NULL,
							dID( (yyvsp[(7) - (10)].s) ) 
						) != NULL;
				
				_endif
				
			_endif
			_if( (yyval.v.u.boolval) )
			
				_if
				(		
						(
								(yyvsp[(7) - (10)].s)->pType == tString 
							||	(yyvsp[(7) - (10)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (10)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (10)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (10)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (10)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (10)].s)->u.strval = value.v.u.strval;
				
			_endif
			FreeValue( YYS &(yyvsp[(3) - (10)].v) );
			_here;
		;}
    break;

  case 1720:

/* Line 1464 of yacc.c  */
#line 72872 "hlaparse.bsn"
    {					/* $13						*/

			union	YYSTYPE	value;

			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			_here;
			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);

			// The LocalOrNonLocalID above had better be a regular expression
			// identifier or this is an error.
			
			_if( (yyvsp[(5) - (12)].s)->pType != tRegex )
			
				yyerror
				( 
					"@match requires a regular expression as the second operand" 
				);
				
			_else
				

				// Only allow a string operand:
				
				_if( (yyvsp[(3) - (12)].v.pType) != tString )
				
					yyerror
					( 
						"Type mismatch, @match requires a string operand "
						"as the first operand"
					);
					
				_else
				
					(yyval.v.u.boolval) = 
						matchRegex
						( 
							(yyvsp[(3) - (12)].v.u.strval), 
							(yyvsp[(5) - (12)].s)->u.rx,
							dID( (yyvsp[(9) - (12)].s) ),
							dID( (yyvsp[(11) - (12)].s) ),
							dID( (yyvsp[(7) - (12)].s) ) 
						) != NULL;
				
				_endif
				
			_endif
			_if( (yyval.v.u.boolval) )
			
				_if
				(		
						(
								(yyvsp[(7) - (12)].s)->pType == tString 
							||	(yyvsp[(7) - (12)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (12)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (12)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (12)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (12)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (12)].s)->u.strval = value.v.u.strval;
				
			_endif
			FreeValue( YYS &(yyvsp[(3) - (12)].v) );
			_here;
		;}
    break;

  case 1721:

/* Line 1464 of yacc.c  */
#line 72979 "hlaparse.bsn"
    {					/* $8						*/

			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			_here;
			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);

			// The LocalOrNonLocalID above had better be a regular expression
			// identifier or this is an error.
			
			_if( (yyvsp[(5) - (6)].s)->pType != tRegex )
			
				yyerror
				( 
					"@match requires a regular expression as the second operand" 
				);
				
			_else
				

				// Only allow a string operand:
				
				_if( (yyvsp[(3) - (6)].v.pType) != tString )
				
					yyerror
					( 
						"Type mismatch, @match requires a string operand "
						"as the first operand"
					);
					
				_else
				
					(yyval.v.u.boolval) = 
						matchRegex2
						( 
							(yyvsp[(3) - (6)].v.u.strval), 
							(yyvsp[(5) - (6)].s)->u.rx,
							NULL,
							NULL,
							NULL 
						) != NULL;
				
				_endif
				
			_endif
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			_here;
		;}
    break;

  case 1722:

/* Line 1464 of yacc.c  */
#line 73044 "hlaparse.bsn"
    {					/* $10						*/

			union	YYSTYPE	value;

			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			_here;
			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);

			// The LocalOrNonLocalID above had better be a regular expression
			// identifier or this is an error.
			
			_if( (yyvsp[(5) - (8)].s)->pType != tRegex )
			
				yyerror
				( 
					"@match requires a regular expression as the second operand" 
				);
				
			_else
				

				// Only allow a string operand:
				
				_if( (yyvsp[(3) - (8)].v.pType) != tString )
				
					yyerror
					( 
						"Type mismatch, @match requires a string operand "
						"as the first operand"
					);
					
				_else
				
					(yyval.v.u.boolval) = 
						matchRegex2
						( 
							(yyvsp[(3) - (8)].v.u.strval), 
							(yyvsp[(5) - (8)].s)->u.rx,
							NULL,
							NULL, 
							dID( (yyvsp[(7) - (8)].s) )
						) != NULL;
				
				_endif
				
			_endif
			_if( (yyval.v.u.boolval) )
			
				_if
				(		
						(
								(yyvsp[(7) - (8)].s)->pType == tString 
							||	(yyvsp[(7) - (8)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (8)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (8)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (8)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (8)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (8)].s)->u.strval = value.v.u.strval;
				
			_endif
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			_here;
		;}
    break;

  case 1723:

/* Line 1464 of yacc.c  */
#line 73150 "hlaparse.bsn"
    {					/* $12						*/

			union	YYSTYPE	value;

			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			_here;
			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);

			// The LocalOrNonLocalID above had better be a regular expression
			// identifier or this is an error.
			
			_if( (yyvsp[(5) - (10)].s)->pType != tRegex )
			
				yyerror
				( 
					"@match requires a regular expression as the second operand" 
				);
				
			_else
				

				// Only allow a string operand:
				
				_if( (yyvsp[(3) - (10)].v.pType) != tString )
				
					yyerror
					( 
						"Type mismatch, @match requires a string operand "
						"as the first operand"
					);
					
				_else
				
					(yyval.v.u.boolval) = 
						matchRegex2
						( 
							(yyvsp[(3) - (10)].v.u.strval), 
							(yyvsp[(5) - (10)].s)->u.rx,
							dID( (yyvsp[(9) - (10)].s) ),
							NULL,
							dID( (yyvsp[(7) - (10)].s) ) 
						) != NULL;
				
				_endif
				
			_endif
			_if( (yyval.v.u.boolval) )
			
				_if
				(		
						(
								(yyvsp[(7) - (10)].s)->pType == tString 
							||	(yyvsp[(7) - (10)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (10)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (10)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (10)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (10)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (10)].s)->u.strval = value.v.u.strval;
				
			_endif
			FreeValue( YYS &(yyvsp[(3) - (10)].v) );
			_here;
		;}
    break;

  case 1724:

/* Line 1464 of yacc.c  */
#line 73258 "hlaparse.bsn"
    {					/* $13						*/

			union	YYSTYPE	value;

			/*
			** Initialize the fields of the return result.
			** Type is always boolean, default to false...
			*/

			_here;
			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);

			// The LocalOrNonLocalID above had better be a regular expression
			// identifier or this is an error.
			
			_if( (yyvsp[(5) - (12)].s)->pType != tRegex )
			
				yyerror
				( 
					"@match requires a regular expression as the second operand" 
				);
				
			_else
				

				// Only allow a string operand:
				
				_if( (yyvsp[(3) - (12)].v.pType) != tString )
				
					yyerror
					( 
						"Type mismatch, @match requires a string operand "
						"as the first operand"
					);
					
				_else
				
					(yyval.v.u.boolval) = 
						matchRegex2
						( 
							(yyvsp[(3) - (12)].v.u.strval), 
							(yyvsp[(5) - (12)].s)->u.rx,
							dID( (yyvsp[(9) - (12)].s) ),
							dID( (yyvsp[(11) - (12)].s) ),
							dID( (yyvsp[(7) - (12)].s) ) 
						) != NULL;
				
				_endif
				
			_endif
			_if( (yyval.v.u.boolval) )
			
				_if
				(		
						(
								(yyvsp[(7) - (12)].s)->pType == tString 
							||	(yyvsp[(7) - (12)].s)->pType == tText
						)
					&&	(yyvsp[(7) - (12)].s)->u.strval != NULL 
				)
				
					
					parseExpression( (yyvsp[(7) - (12)].s)->u.strval, &value );
					_if( value.v.pType != tString )
					
						yyerror
						( 
							"Expected a string result for 'returns' operand" 
						);
						FreeValue( &value );
						value.v.pType =tString;
						value.v.Type = &string_ste;
						value.v.u.strval = hlastrdup( "" );
						
					_endif
								
					
				_endif

				_if( (yyvsp[(7) - (12)].s)->u.strval != NULL )
				
					free2( vss (yyvsp[(7) - (12)].s)->u.strval );
					
				_endif
				(yyvsp[(7) - (12)].s)->u.strval = value.v.u.strval;
				
			_endif
			FreeValue( YYS &(yyvsp[(3) - (12)].v) );
			_here;
		;}
    break;

  case 1725:

/* Line 1464 of yacc.c  */
#line 73377 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1726:

/* Line 1464 of yacc.c  */
#line 73398 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s),
				NULL 
			);
			_here;
		;}
    break;

  case 1727:

/* Line 1464 of yacc.c  */
#line 73421 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			matchStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s),
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1728:

/* Line 1464 of yacc.c  */
#line 73456 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchiStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1729:

/* Line 1464 of yacc.c  */
#line 73477 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchiStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s),
				NULL 
			);
			_here;
		;}
    break;

  case 1730:

/* Line 1464 of yacc.c  */
#line 73500 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			matchiStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s),
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1731:

/* Line 1464 of yacc.c  */
#line 73533 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			uptoStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1732:

/* Line 1464 of yacc.c  */
#line 73554 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			uptoStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s),
				NULL 
			);
			_here;
		;}
    break;

  case 1733:

/* Line 1464 of yacc.c  */
#line 73577 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			uptoStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s),
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1734:

/* Line 1464 of yacc.c  */
#line 73606 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			uptoiStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1735:

/* Line 1464 of yacc.c  */
#line 73627 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			uptoiStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s),
				NULL 
			);
			_here;
		;}
    break;

  case 1736:

/* Line 1464 of yacc.c  */
#line 73650 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			uptoiStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s),
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1737:

/* Line 1464 of yacc.c  */
#line 73684 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchtoStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1738:

/* Line 1464 of yacc.c  */
#line 73705 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchtoStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s),
				NULL 
			);
			_here;
		;}
    break;

  case 1739:

/* Line 1464 of yacc.c  */
#line 73728 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			matchtoStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s),
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1740:

/* Line 1464 of yacc.c  */
#line 73757 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchtoiStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				YYS &(yyvsp[(5) - (6)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1741:

/* Line 1464 of yacc.c  */
#line 73778 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchtoiStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				YYS &(yyvsp[(5) - (8)].v), 
				(yyvsp[(7) - (8)].s),
				NULL 
			);
			_here;
		;}
    break;

  case 1742:

/* Line 1464 of yacc.c  */
#line 73801 "hlaparse.bsn"
    {					/* $11						*/
			_here;
			matchtoiStrFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (10)].v), 
				YYS &(yyvsp[(5) - (10)].v), 
				(yyvsp[(7) - (10)].s),
				(yyvsp[(9) - (10)].s) 
			);
			_here;
		;}
    break;

  case 1743:

/* Line 1464 of yacc.c  */
#line 73835 "hlaparse.bsn"
    {					/* $5						*/
			_here;
			zeroOrMoreWSFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL 
			);
			_here;
		;}
    break;

  case 1744:

/* Line 1464 of yacc.c  */
#line 73852 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			zeroOrMoreWSFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s) 
			);
			_here;
		;}
    break;

  case 1745:

/* Line 1464 of yacc.c  */
#line 73881 "hlaparse.bsn"
    {					/* $5						*/
			_here;
			oneOrMoreWSFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL 
			);
			_here;
		;}
    break;

  case 1746:

/* Line 1464 of yacc.c  */
#line 73898 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			oneOrMoreWSFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s) 
			);
			_here;
		;}
    break;

  case 1747:

/* Line 1464 of yacc.c  */
#line 73928 "hlaparse.bsn"
    {					/* $5						*/
			_here;
			WSorEOSFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL 
			);
			_here;
		;}
    break;

  case 1748:

/* Line 1464 of yacc.c  */
#line 73945 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			WSorEOSFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s) 
			);
			_here;
		;}
    break;

  case 1749:

/* Line 1464 of yacc.c  */
#line 73973 "hlaparse.bsn"
    {					/* $5						*/
			_here;
			WSthenEOSFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL 
			);
			_here;
		;}
    break;

  case 1750:

/* Line 1464 of yacc.c  */
#line 73990 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			WSthenEOSFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s) 
			);
			_here;
		;}
    break;

  case 1751:

/* Line 1464 of yacc.c  */
#line 74018 "hlaparse.bsn"
    {					/* $5						*/
			_here;
			peekWSFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL 
			);
			_here;
		;}
    break;

  case 1752:

/* Line 1464 of yacc.c  */
#line 74035 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			peekWSFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s) 
			);
			_here;
		;}
    break;

  case 1753:

/* Line 1464 of yacc.c  */
#line 74061 "hlaparse.bsn"
    {					/* $5						*/
			_here;
			eosFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL 
			);
			_here;
		;}
    break;

  case 1754:

/* Line 1464 of yacc.c  */
#line 74078 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			eosFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s) 
			);
			_here;
		;}
    break;

  case 1755:

/* Line 1464 of yacc.c  */
#line 74110 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchIDFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1756:

/* Line 1464 of yacc.c  */
#line 74128 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchIDFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1757:

/* Line 1464 of yacc.c  */
#line 74148 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchIDFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				(yyvsp[(5) - (8)].s),
				(yyvsp[(7) - (8)].s) 
			);
			_here;
		;}
    break;

  case 1758:

/* Line 1464 of yacc.c  */
#line 74185 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchIntConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1759:

/* Line 1464 of yacc.c  */
#line 74203 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchIntConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1760:

/* Line 1464 of yacc.c  */
#line 74223 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchIntConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				(yyvsp[(5) - (8)].s),
				(yyvsp[(7) - (8)].s) 
			);
			_here;
		;}
    break;

  case 1761:

/* Line 1464 of yacc.c  */
#line 74257 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchRealConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1762:

/* Line 1464 of yacc.c  */
#line 74275 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchRealConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1763:

/* Line 1464 of yacc.c  */
#line 74295 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchRealConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				(yyvsp[(5) - (8)].s),
				(yyvsp[(7) - (8)].s) 
			);
			_here;
		;}
    break;

  case 1764:

/* Line 1464 of yacc.c  */
#line 74332 "hlaparse.bsn"
    {						/* $7						*/
			_here;
			matchNumericConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1765:

/* Line 1464 of yacc.c  */
#line 74350 "hlaparse.bsn"
    {						/* $7						*/
			_here;
			matchNumericConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1766:

/* Line 1464 of yacc.c  */
#line 74370 "hlaparse.bsn"
    {						/* $9						*/
			_here;
			matchNumericConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				(yyvsp[(5) - (8)].s),
				(yyvsp[(7) - (8)].s) 
			);
			_here;
		;}
    break;

  case 1767:

/* Line 1464 of yacc.c  */
#line 74409 "hlaparse.bsn"
    {						/* $7						*/
			_here;
			matchStrConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1768:

/* Line 1464 of yacc.c  */
#line 74427 "hlaparse.bsn"
    {						/* $7						*/
			_here;
			matchStrConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1769:

/* Line 1464 of yacc.c  */
#line 74447 "hlaparse.bsn"
    {						/* $9						*/
			_here;
			matchStrConstFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				(yyvsp[(5) - (8)].s),
				(yyvsp[(7) - (8)].s) 
			);
			_here;
		;}
    break;

  case 1770:

/* Line 1464 of yacc.c  */
#line 74478 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchRegFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1771:

/* Line 1464 of yacc.c  */
#line 74496 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchRegFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1772:

/* Line 1464 of yacc.c  */
#line 74516 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchRegFunc
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				(yyvsp[(5) - (8)].s),
				(yyvsp[(7) - (8)].s) 
			);
			_here;
		;}
    break;

  case 1773:

/* Line 1464 of yacc.c  */
#line 74547 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchReg8Func
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1774:

/* Line 1464 of yacc.c  */
#line 74565 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchReg8Func
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1775:

/* Line 1464 of yacc.c  */
#line 74585 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchReg8Func
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				(yyvsp[(5) - (8)].s),
				(yyvsp[(7) - (8)].s) 
			);
			_here;
		;}
    break;

  case 1776:

/* Line 1464 of yacc.c  */
#line 74618 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchReg16Func
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1777:

/* Line 1464 of yacc.c  */
#line 74636 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchReg16Func
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1778:

/* Line 1464 of yacc.c  */
#line 74656 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchReg16Func
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				(yyvsp[(5) - (8)].s),
				(yyvsp[(7) - (8)].s) 
			);
			_here;
		;}
    break;

  case 1779:

/* Line 1464 of yacc.c  */
#line 74688 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchReg32Func
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (4)].v), 
				NULL,
				NULL 
			);
			_here;
		;}
    break;

  case 1780:

/* Line 1464 of yacc.c  */
#line 74706 "hlaparse.bsn"
    {					/* $7						*/
			_here;
			matchReg32Func
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (6)].v), 
				(yyvsp[(5) - (6)].s), 
				NULL 
			);
			_here;
		;}
    break;

  case 1781:

/* Line 1464 of yacc.c  */
#line 74726 "hlaparse.bsn"
    {					/* $9						*/
			_here;
			matchReg32Func
			( 
				YYS &(yyval.v), 
				YYS &(yyvsp[(3) - (8)].v), 
				(yyvsp[(5) - (8)].s),
				(yyvsp[(7) - (8)].s) 
			);
			_here;
		;}
    break;

  case 1782:

/* Line 1464 of yacc.c  */
#line 74762 "hlaparse.bsn"
    {
				int index;
				
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tUns32, 
					&uns32_ste
				);
				_if( !checkSmallUns( YYS &(yyvsp[(3) - (4)].v) ) )

					yyerror( "Type mismatch in operands" );
					ClrConst
					( 
						YYS &(yyval.v), 
						tUns32, 
						&uns32_ste
					);
					

				_else
					
					index = 
						_ifx( (yyvsp[(3) - (4)].v.u.unsval) > BufSP, BufSP, (yyvsp[(3) - (4)].v.u.unsval));
					
					index = BufSP - index;
					_if( index == BufSP )
					
						(yyval.v.u.unsval) = LineCnt;
					
					_else
						
						(yyval.v.u.unsval) = BufferStack[ index ].LineCnt;
							
					_endif

				_endif
				_here;

			;}
    break;

  case 1783:

/* Line 1464 of yacc.c  */
#line 74808 "hlaparse.bsn"
    {
				int index;
				
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste
				);
				_if( !checkSmallUns( YYS &(yyvsp[(3) - (4)].v) ) )

					yyerror( "Type mismatch in operands" );
					ClrConst
					( 
						YYS &(yyval.v), 
						tString, 
						&string_ste
					);
					(yyval.v.u.strval) = hlastrdup2( "" );
					

				_else
					
					index = 
						_ifx( (yyvsp[(3) - (4)].v.u.unsval) > BufSP, BufSP, (yyvsp[(3) - (4)].v.u.unsval));
					
					index = BufSP - index;
					_if( index == BufSP )
					
						(yyval.v.u.strval) = FileName;
					
					_else
						
						(yyval.v.u.strval) = 
							hlastrdup2( BufferStack[ index ].FileName );
							
					_endif

				_endif
				_here;

			;}
    break;

  case 1784:

/* Line 1464 of yacc.c  */
#line 74853 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tUns32, 
					&uns32_ste
				);
				(yyval.v.u.unsval) = LineCnt;
			;}
    break;

  case 1785:

/* Line 1464 of yacc.c  */
#line 74868 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste
				);
				(yyval.v.u.strval) = hlastrdup2( FileName );
			;}
    break;

  case 1786:

/* Line 1464 of yacc.c  */
#line 74883 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste
				);
				_if( errorPrefixMsg == NULL )
				
					(yyval.v.u.strval) = hlastrdup2( "" );
					
				_else
				
					(yyval.v.u.strval) = hlastrdup2( errorPrefixMsg );
					
				_endif
			;}
    break;

  case 1787:

/* Line 1464 of yacc.c  */
#line 74906 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);
				(yyval.v.u.intval) = CurLexLevel;
			;}
    break;

  case 1788:

/* Line 1464 of yacc.c  */
#line 74919 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);
				(yyval.v.u.intval) = CurOffset;
			;}
    break;

  case 1789:

/* Line 1464 of yacc.c  */
#line 74933 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);
				(yyval.v.u.intval) = CurOffsetDir;
			;}
    break;

  case 1790:

/* Line 1464 of yacc.c  */
#line 74947 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = AddOffset1st;
			;}
    break;

  case 1791:

/* Line 1464 of yacc.c  */
#line 74962 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);
				(yyval.v.u.intval) = StartParmOffs;
			;}
    break;

  case 1792:

/* Line 1464 of yacc.c  */
#line 74976 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);
				(yyval.v.u.intval) = StartLclOffs;
			;}
    break;

  case 1793:

/* Line 1464 of yacc.c  */
#line 74990 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);
				(yyval.v.u.intval) = EnumSize;
			;}
    break;

  case 1794:

/* Line 1464 of yacc.c  */
#line 75004 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tInt32, 
					&int32_ste
				);
				(yyval.v.u.intval) = LblCntr;
			;}
    break;

  case 1795:

/* Line 1464 of yacc.c  */
#line 75018 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = TraceFlag;
			;}
    break;

  case 1796:

/* Line 1464 of yacc.c  */
#line 75032 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = FullExceptions;
			;}
    break;

  case 1797:

/* Line 1464 of yacc.c  */
#line 75046 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = OptimizeStrings;
			;}
    break;

  case 1798:

/* Line 1464 of yacc.c  */
#line 75060 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = CompileBound;
			;}
    break;

  case 1799:

/* Line 1464 of yacc.c  */
#line 75076 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = CompileInto;
			;}
    break;

  case 1800:

/* Line 1464 of yacc.c  */
#line 75092 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = !FrameDefault;
			;}
    break;

  case 1801:

/* Line 1464 of yacc.c  */
#line 75108 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = FrameDefault;
			;}
    break;

  case 1802:

/* Line 1464 of yacc.c  */
#line 75125 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = !DisplayDefault;
			;}
    break;

  case 1803:

/* Line 1464 of yacc.c  */
#line 75141 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = DisplayDefault;
			;}
    break;

  case 1804:

/* Line 1464 of yacc.c  */
#line 75159 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = !AlignStackDefault;
			;}
    break;

  case 1805:

/* Line 1464 of yacc.c  */
#line 75175 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = AlignStackDefault;
			;}
    break;

  case 1806:

/* Line 1464 of yacc.c  */
#line 75193 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = !EnterDefault;
			;}
    break;

  case 1807:

/* Line 1464 of yacc.c  */
#line 75209 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = EnterDefault;
			;}
    break;

  case 1808:

/* Line 1464 of yacc.c  */
#line 75226 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = !LeaveDefault;
			;}
    break;

  case 1809:

/* Line 1464 of yacc.c  */
#line 75242 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tBoolean, 
					&boolean_ste
				);
				(yyval.v.u.boolval) = LeaveDefault;
			;}
    break;

  case 1810:

/* Line 1464 of yacc.c  */
#line 75258 "hlaparse.bsn"
    {
				_here;
				ClrConst
				( 
					YYS &(yyval.v), 
					tUns32, 
					&uns32_ste
				);
				(yyval.v.u.unsval) = !AlignDefault;
			;}
    break;

  case 1811:

/* Line 1464 of yacc.c  */
#line 75274 "hlaparse.bsn"
    {
				union YYSTYPE v;

				_here;
				_if
				( 
						LastMacroObject != NULL 
					&&	LastMacroObject->TrueName != NULL 
				)
				
					v.v.u.strval = hlastrdup2( LastMacroObject->TrueName );
					
				_else
				
					v.v.u.strval = hlastrdup2( "" );
					
				_endif
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &v
				);
				_here;
			;}
    break;

  case 1812:

/* Line 1464 of yacc.c  */
#line 75304 "hlaparse.bsn"
    {
				union YYSTYPE v;

				_here;
				v.v.u.strval = hlastrdup2( CurBaseReg );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &v
				);
			;}
    break;

  case 1813:

/* Line 1464 of yacc.c  */
#line 75330 "hlaparse.bsn"
    {
				union YYSTYPE v;

				_here;
				_if
				( 
						LastRefdObject != NULL 
					&&	LastRefdObject->TrueName != NULL 
				)

					v.v.u.strval = hlastrdup2( LastRefdObject->TrueName );
					
				_else
				
					v.v.u.strval = hlastrdup2( "" );
					
				_endif
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &v
				);
				_here;
			;}
    break;

  case 1814:

/* Line 1464 of yacc.c  */
#line 75369 "hlaparse.bsn"
    {
				union YYSTYPE v;

				_here;
				_if( CurVar != NULL )

					v.v.u.strval = hlastrdup2( CurVar );
					
				_else
				
					v.v.u.strval = hlastrdup2( "" );
					
				_endif
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &v
				);
				_here;
			;}
    break;

  case 1815:

/* Line 1464 of yacc.c  */
#line 75438 "hlaparse.bsn"
    {				/* $2 */


			union YYSTYPE v;
			#define b(val,ofs) ((val & 1) << ofs )

			_here;
			v.v.u.unsval =
					b( inRegex, 29 )
				+	b( inNamespace, 28 )
				+	b( inClass, 27 )
				+	b( inUnion, 26 )
				+	b( inRecord, 25 )
				+	b( inProgram, 24 )
				+	b( inUnit, 23 )
				
				+	b( inThunk, 19 )
				+	b( inCTL, 18 )
				/*+	b( inKeyword, 17 )*/
				/*+	b( inMacro, 16 )  */
				+	b( inIterator, 15 )
				+	b( inMethod, 14 )
				+	b( inProcedure, 13 )
				+	b( inMain, 12 )

				+	b( inStorage, 6 )
				+	b( inReadonly, 5 )
				+	b( inStatic, 4 )
				+	b( inVar, 3 )
				+	b( inType, 2 )
				+	b( inVal, 1 )
				+	( inConst & 1 );

			SetConst
			( 
				YYS &(yyval.v), 
				tDWord, 
				&dword_ste,
				YYS &v
			);
			(yyval.v.u.lwordval)[1] = 0;
			(yyval.v.u.lwordval)[2] = 0;
			(yyval.v.u.lwordval)[3] = 0;
			_here;
		;}
    break;

  case 1816:

/* Line 1464 of yacc.c  */
#line 75503 "hlaparse.bsn"
    {
				_here;
				memcpy( &(yyval.v), &(yyvsp[(1) - (1)].v), sizeofSymNode );
			;}
    break;

  case 1817:

/* Line 1464 of yacc.c  */
#line 75524 "hlaparse.bsn"
    {				/* $5 */


			union YYSTYPE v;

			_here;
			_if( (yyvsp[(3) - (4)].cls.cls) & cfy_SingleID )

				v.v.u.unsval = ( (yyvsp[(3) - (4)].cls.cls) & cfy_Undefined ) == 0;

			_else

				yyerror( "Expected a single identifier" );
				v.v.u.unsval = 0;

			_endif
			ClrConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste
			);
			(yyval.v.u.unsval) = v.v.u.unsval;
			_here;
		;}
    break;

  case 1818:

/* Line 1464 of yacc.c  */
#line 75565 "hlaparse.bsn"
    {				/* $5 */


			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tString, 
				&string_ste
			);

			_if( (yyvsp[(3) - (4)].cls.sym) != NULL )

				v.v.u.strval = hlastrdup2( (yyvsp[(3) - (4)].cls.sym)->TrueName );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &v
				);

			_else

				v.v.u.strval = hlastrdup2( "" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &v
				);


			_endif
			_here;
		;}
    break;

  case 1819:

/* Line 1464 of yacc.c  */
#line 75621 "hlaparse.bsn"
    {				/* $5 */

			int			i;
			int			j;
			int			localCnt;
			int			fieldCnt;
			union		YYSTYPE	v;
			SymNode_t 	*s;
			SymNode_t 	*curField;
			SymNode_t 	*curLcl;			
			

			_here;
			s = (yyvsp[(3) - (4)].cls.sym);
			ClrConst
			( 
				YYS &v, 
				tString, 
				&string_ste
			);
			_if( s != NULL )
			
				// Handle enums, classes, records, and unions here:
				
				_if
				( 
						s->pType == tRecord
					||	s->pType == tUnion
					||	s->pType == tReal128
					||	s->pType == tClass
					||	s->pType == tEnum
				)
				
					/*
					** Construct the $<v>$ object for the parser.
					** Begin by clearing out unimportant fields.
					*/

					SetConst
					( 
						YYS &(yyval.v), 
						tString, 
						&string_ste,
						YYS &v
					);


					(yyval.v.TrueName) = hlastrdup2( "" );
					(yyval.v.StaticName) = NULL;
					(yyval.v.Offset) = 0;
					(yyval.v.Base) = NULL;
					(yyval.v.Fields) = NULL;
					(yyval.v.FieldCnt) = 0; 
					
					
					/*
					** Count the number of actual fields
					** in the structure (we don't count
					** Anon Record entries).
					*/
					
					fieldCnt = 0;
					curField = s->Fields;
					_for( i=s->FieldCnt-1, i >= 0 , --i )
					
						assert( curField != NULL );
						_if( curField->pType != tAnonRec )
						
							++fieldCnt;
							
						_endif
						curField = curField->Next;
					
					_endfor
					
					/*
					** Here are the important assignments.
					*/

					(yyval.v.pType) = tArray;
					(yyval.v.SymClass) = cConstant;
					(yyval.v.Type) = &string_ste;
					(yyval.v.Arity) = 1;
					(yyval.v.Dimensions) = malloc2( sizeofInt );
					(yyval.v.Dimensions)[0] = fieldCnt;
					(yyval.v.NumElements) = fieldCnt;

					(yyval.v.u.ArrayOfValues) = 
						malloc2( fieldCnt * sizeofSymNode );
						
					(yyval.v.ObjectSize) = fieldCnt * sizeofCharPtr;

					/*
					** Okay, fill in the array elements here:
					*/
					
					curField = s->Fields;
					i = fieldCnt-1;
					_for( j=s->FieldCnt-1, j >= 0 , --j )

						assert( curField != NULL );
						_if( curField->pType != tAnonRec )
						
							(yyval.v.u.ArrayOfValues)[i].Name = hlastrdup2( "" );
							(yyval.v.u.ArrayOfValues)[i].TrueName = hlastrdup2( "" );
							(yyval.v.u.ArrayOfValues)[i].SymClass = cConstant;
							(yyval.v.u.ArrayOfValues)[i].StaticName = NULL;
							(yyval.v.u.ArrayOfValues)[i].Base = NULL;
							(yyval.v.u.ArrayOfValues)[i].Fields = NULL;
							(yyval.v.u.ArrayOfValues)[i].FieldCnt = 0;
							(yyval.v.u.ArrayOfValues)[i].pType = tString;
							(yyval.v.u.ArrayOfValues)[i].Type = &string_ste;
							(yyval.v.u.ArrayOfValues)[i].Arity = 0;
							(yyval.v.u.ArrayOfValues)[i].Dimensions = NULL;
							(yyval.v.u.ArrayOfValues)[i].NumElements = 0;

							(yyval.v.u.ArrayOfValues)[i].u.strval = curField->TrueName;
							--i;
							
						_endif
						curField = curField->Next;

					_endfor
					
				
				
				
				// Handle classes here:
				
				_elseif( s->pType == tNamespace )
				
					/*
					** Construct the $<v>$ object for the parser.
					** Begin by clearing out unimportant fields.
					*/

					SetConst
					( 
						YYS &(yyval.v), 
						tString, 
						&string_ste,
						YYS &v
					);


					(yyval.v.TrueName) = hlastrdup2( "" );
					(yyval.v.StaticName) = NULL;
					(yyval.v.Offset) = 0;
					(yyval.v.Base) = NULL;
					(yyval.v.Fields) = NULL;
					(yyval.v.FieldCnt) = 0; 
					
					
					/*
					** Count the number of actual fields
					** in the structure (we don't count
					** Anon Record entries).
					*/
					
					fieldCnt = 0;
					curField = s->Fields;
					_while( curField != NULL )
					
						_if( curField->pType != tAnonRec )
						
							++fieldCnt;
							
						_endif
						curField = curField->Next;
					
					_endwhile
					
					/*
					** Here are the important assignments.
					*/

					(yyval.v.pType) = tArray;
					(yyval.v.SymClass) = cConstant;
					(yyval.v.Type) = &string_ste;
					(yyval.v.Arity) = 1;
					(yyval.v.Dimensions) = malloc2( sizeofInt );
					(yyval.v.Dimensions)[0] = fieldCnt;
					(yyval.v.NumElements) = fieldCnt;

					(yyval.v.u.ArrayOfValues) = 
						malloc2( fieldCnt * sizeofSymNode );
						
					(yyval.v.ObjectSize) = fieldCnt * sizeofCharPtr;

					/*
					** Okay, fill in the array elements here:
					*/
					
					curField = s->Fields;
					i = fieldCnt-1;
					_while( curField != NULL )

						_if( curField->pType != tAnonRec )
						
							(yyval.v.u.ArrayOfValues)[i].Name = hlastrdup2( "" );
							(yyval.v.u.ArrayOfValues)[i].TrueName = hlastrdup2( "" );
							(yyval.v.u.ArrayOfValues)[i].SymClass = cConstant;
							(yyval.v.u.ArrayOfValues)[i].StaticName = NULL;
							(yyval.v.u.ArrayOfValues)[i].Base = NULL;
							(yyval.v.u.ArrayOfValues)[i].Fields = NULL;
							(yyval.v.u.ArrayOfValues)[i].FieldCnt = 0;
							(yyval.v.u.ArrayOfValues)[i].pType = tString;
							(yyval.v.u.ArrayOfValues)[i].Type = &string_ste;
							(yyval.v.u.ArrayOfValues)[i].Arity = 0;
							(yyval.v.u.ArrayOfValues)[i].Dimensions = NULL;
							(yyval.v.u.ArrayOfValues)[i].NumElements = 0;

							(yyval.v.u.ArrayOfValues)[i].u.strval = curField->TrueName;
							--i;
							
						_endif
						curField = curField->Next;

					_endwhile
					
				
				
				
				// Handle procedures, methods, and iterators here:
				
				_elseif
				( 
						s->pType == tProc 
					||	s->pType == tMethod
					||	s->pType == tClassProc 
					||	s->pType == tClassIter 
					||	s->pType == tIterator
				)
				
					/*
					** Construct the $<v>$ object for the parser.
					** Begin by clearing out unimportant fields.
					*/

					SetConst
					( 
						YYS &(yyval.v), 
						tString, 
						&string_ste,
						YYS &v
					);


					(yyval.v.TrueName) = hlastrdup2( "" );
					(yyval.v.StaticName) = NULL;
					(yyval.v.Offset) = 0;
					(yyval.v.Base) = NULL;
					(yyval.v.Fields) = NULL;
					(yyval.v.FieldCnt) = 0; 
					
					
					/*
					** We need to count the number of local symbols
					** here:
					*/
					
					curLcl = s->u.proc.Locals;
					localCnt = 0;
					_while( curLcl != s && curLcl != NULL )
						
						++localCnt;
						curLcl = curLcl->Next;
						
					_endwhile;
					
					/*
					** Here are the important assignments.
					*/

					(yyval.v.pType) = tArray;
					(yyval.v.SymClass) = cConstant;
					(yyval.v.Type) = &string_ste;
					(yyval.v.Arity) = 1;
					(yyval.v.Dimensions) = malloc2( sizeofInt );
					(yyval.v.Dimensions)[0] = localCnt;
					(yyval.v.NumElements) = localCnt;
					
					(yyval.v.u.ArrayOfValues) = 
						malloc2( localCnt * sizeofSymNode );
						
					(yyval.v.ObjectSize) = localCnt * sizeofCharPtr;

					/*
					** Okay, fill in the array elements here:
					*/
					
					curLcl = s->u.proc.Locals;
					_for( i=0, i < localCnt, ++i )

						(yyval.v.u.ArrayOfValues)[i].Name = hlastrdup2( "" );
						(yyval.v.u.ArrayOfValues)[i].TrueName = hlastrdup2( "" );
						(yyval.v.u.ArrayOfValues)[i].SymClass = cConstant;
						(yyval.v.u.ArrayOfValues)[i].StaticName = NULL;
						(yyval.v.u.ArrayOfValues)[i].Base = NULL;
						(yyval.v.u.ArrayOfValues)[i].Fields = NULL;
						(yyval.v.u.ArrayOfValues)[i].FieldCnt = 0;
						(yyval.v.u.ArrayOfValues)[i].pType = tString;
						(yyval.v.u.ArrayOfValues)[i].Type = &string_ste;
						(yyval.v.u.ArrayOfValues)[i].Arity = 0;
						(yyval.v.u.ArrayOfValues)[i].Dimensions = NULL;
						(yyval.v.u.ArrayOfValues)[i].NumElements = 0;

						assert( curLcl != NULL );
						(yyval.v.u.ArrayOfValues)[i].u.strval = curLcl->TrueName;
						curLcl = curLcl->Next;

					_endfor
					
				
				_elseif( s->pType == tProgram )
				
					yyerror
					(
						"@localsyms argument cannot be a program/unit ID!"
					);
					
					// Dummy string to keep the rest of the system happy.
					
					v.v.u.strval = hlastrdup2( "@localsyms" );
					SetConst
					( 
						YYS &(yyval.v), 
						tString, 
						&string_ste,
						YYS &v
					);
					
					
				_else
				
					yyerror
					( 
						"@localsyms argument doesn't have any local symbols" 
					);
					v.v.u.strval = hlastrdup2( "@localsyms" );
					SetConst
					( 
						YYS &(yyval.v), 
						tString, 
						&string_ste,
						YYS &v
					);
					
				_endif				

			_else

				yyerror( "Expected an identifier as @localsyms parameter" );
				v.v.u.strval = hlastrdup2( "@localsyms" );
				SetConst
				( 
					YYS &(yyval.v), 
					tString, 
					&string_ste,
					YYS &v
				);


			_endif
			_here;
		;}
    break;

  case 1820:

/* Line 1464 of yacc.c  */
#line 76006 "hlaparse.bsn"
    {				/* $5 */

			int				i;
			int				j;
			int				localCnt;
			int				fieldCnt;
			union YYSTYPE	v;
			SymNode_t 		*s;
			SymNode_t 		*curField;
			SymNode_t 		*curLcl;			
			
			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);
			s = (yyvsp[(3) - (4)].cls.sym);
			_if( s != NULL )
			
				// Handle records and unions here:
				
				
				// Handle procedures, methods, and iterators here:
				
				_if
				( 
						s->pType == tProc 
					||	s->pType == tMethod
					||	s->pType == tClassProc 
					||	s->pType == tClassIter 
					||	s->pType == tIterator
					||	s->pType == tProcptr
				)
				


					/*
					** Construct the $<v>$ object for the parser.
					** Begin by clearing out unimportant fields.
					*/

					v.v.u.unsval = s->u.proc.ParmSize;
					SetConst
					( 
						YYS &(yyval.v), 
						tUns32, 
						&uns32_ste,
						YYS &v
					);


					(yyval.v.TrueName) = hlastrdup2( "" );
					(yyval.v.StaticName) = NULL;
					(yyval.v.Offset) = 0;
					(yyval.v.Base) = NULL;
					(yyval.v.Fields) = NULL;
					(yyval.v.FieldCnt) = 0;
				
				_else
				
					yyerror
					( 
						"@parms: argument must be a procedure, method, "
						"or iterator" 
					);
					ClrConst
					( 
						YYS &(yyval.v), 
						tUns32, 
						&uns32_ste
					);
					
				_endif				

			_else

				yyerror( "Expected an identifier as @parms argument" );
				ClrConst
				( 
					YYS &(yyval.v), 
					tUns32, 
					&uns32_ste
				);


			_endif
			_here;
		;}
    break;

  case 1821:

/* Line 1464 of yacc.c  */
#line 76114 "hlaparse.bsn"
    {				/* $5 */


			union	YYSTYPE	v;
					char	*TypeName;
					int		HashVal;

			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);

			/*
			** This is truly digusting code.  It hashes the
			** type name to try to produce a unique ID (that
			** is consistent across compiles).  No guarantee
			** that the values are truly unique, but there
			** is a pretty good chance it will happen.
			*/

			_if( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg8 ) != 0 )

				(yyvsp[(3) - (4)].cls.type) = &byte_ste;

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg16 ) != 0 )

				(yyvsp[(3) - (4)].cls.type) = &word_ste;

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg32 ) != 0 )

				(yyvsp[(3) - (4)].cls.type) = &dword_ste;

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_fpReg ) != 0 )

				(yyvsp[(3) - (4)].cls.type) = &real80_ste;

			_endif

			_if( (yyvsp[(3) - (4)].cls.type) == NULL )

				/*
				** Unknown expression type. Just return zero.
				*/

				v.v.u.unsval = 0;

			_else

				_if( (yyvsp[(3) - (4)].cls.sym) != NULL && (yyvsp[(3) - (4)].cls.sym)->SymClass == cType )
				
					/*
					** If this is a type name, just return
					** the address of the symbol.
					*/
					
					TypeName = (yyvsp[(3) - (4)].cls.sym)->TrueName;
					
				_else
				
					assert( (yyvsp[(3) - (4)].cls.type) != NULL );
					TypeName = (yyvsp[(3) - (4)].cls.type)->TrueName;
					
				_endif
				HashVal = 0;
				TypeName = _ifx( TypeName == NULL, "", TypeName );
				_while( *TypeName != '\0' )
				
					/*
					** Hash function is effectively a ROL xor new char
					** plus a summing of the H.O. two bits.
					*/
					
					HashVal = (( HashVal << 2 ) ^ *TypeName ) +
								( HashVal >> 30 );
					++TypeName;
					
				_endwhile
				v.v.u.unsval = HashVal;

			_endif
			SetConst
			( 
				YYS &(yyval.v), 
				tDWord, 
				&dword_ste,
				YYS &v
			);
			_here;
		;}
    break;

  case 1822:

/* Line 1464 of yacc.c  */
#line 76222 "hlaparse.bsn"
    {				/* $5 */


			union YYSTYPE	v;
			char			*TypeName;
			char			ptrName[256];

			/*
			** If we've got a register, return "byte", "word",
			** or "dword" as appropriate.
			*/

			_here;
			_if( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg8 ) != 0 )

				TypeName = "byte";

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg16 ) != 0 )

				TypeName = "word";

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg32 ) != 0 )

				TypeName = "dword";

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_fpReg ) != 0 )

				TypeName = "real80";


			// Note: for cls objects, sym==type if you have a type dcl.

			_elseif( (yyvsp[(3) - (4)].cls.type) != NULL && (yyvsp[(3) - (4)].cls.sym) != (yyvsp[(3) - (4)].cls.type) )
 
				_if( (yyvsp[(3) - (4)].cls.cls) & cfy_IsPointer )
				
					_if( (yyvsp[(3) - (4)].cls.sym)->Base != NULL )
					
						
						strcpy( ptrName, "pointer to " );
						strncpy
						( 
							&ptrName[11],
							(yyvsp[(3) - (4)].cls.sym)->Base->TrueName,
							244
						);
						ptrName[255] = '\0';  
						TypeName = ptrName;
											
					_else
					
						// Pointer to ????
						
						TypeName = (yyvsp[(3) - (4)].cls.type)->TrueName;
						
					_endif
						
				
				_else
				
					TypeName = (yyvsp[(3) - (4)].cls.type)->TrueName;
					
				_endif


			_elseif( (yyvsp[(3) - (4)].cls.sym) != NULL && (yyvsp[(3) - (4)].cls.sym)->SymClass == cType )
				
				/*
				** If this is a type name and it's base type is NULL,
				** just return the address of the symbol.  If the base
				** type is not NULL, then return the base type.
				*/
				
				_if( (yyvsp[(3) - (4)].cls.sym)->Type == NULL )

					TypeName = (yyvsp[(3) - (4)].cls.sym)->TrueName;

				_else

					// If it's a pointer, emit "pointer to <type>"
					
					_if( (yyvsp[(3) - (4)].cls.cls) & cfy_IsPointer )
					
						_if( (yyvsp[(3) - (4)].cls.sym)->Base != NULL )
						
							strcpy( ptrName, "pointer to " );
							strncpy
							( 
								&ptrName[11],
								(yyvsp[(3) - (4)].cls.sym)->Base->TrueName,
								244
							);
							ptrName[255] = '\0';  
							TypeName = ptrName;

						
						_else
						
							// Pointer to ????
							
							TypeName = (yyvsp[(3) - (4)].cls.sym)->Type->TrueName;
							
						_endif
							
					
					_else
					
						TypeName = (yyvsp[(3) - (4)].cls.sym)->Type->TrueName;
						
					_endif

				_endif
							
			_else

				/*
				** Unknown expression type. Just return the empty string.
				*/

				TypeName = "";

			_endif
			v.v.u.strval = hlastrdup2( TypeName );
			SetConst
			( 
				YYS &(yyval.v), 
				tString, 
				&string_ste,
				YYS &v
			);
			_here;
		;}
    break;

  case 1823:

/* Line 1464 of yacc.c  */
#line 76371 "hlaparse.bsn"
    {					/* $5 */


			union YYSTYPE	v;
			char			*TypeName;
			char			ptrName[256];

			/*
			** If we've got a register, return "byte", "word",
			** or "dword" as appropriate.
			*/

			_here;
			_if( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg8 ) != 0 )

				TypeName = "byte";

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg16 ) != 0 )

				TypeName = "word";

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg32 ) != 0 )

				TypeName = "dword";

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_fpReg ) != 0 )

				TypeName = "real80";


			_else
			
				_if( (yyvsp[(3) - (4)].cls.type) != NULL )

					_if( (yyvsp[(3) - (4)].cls.type)->Base != NULL )

						TypeName = (yyvsp[(3) - (4)].cls.type)->Base->TrueName;

					_elseif( (yyvsp[(3) - (4)].cls.type)->Type != NULL )

						TypeName = (yyvsp[(3) - (4)].cls.type)->Type->TrueName;

					_else

						TypeName = (yyvsp[(3) - (4)].cls.type)->TrueName;

					_endif

				_elseif( (yyvsp[(3) - (4)].cls.sym)->Base != NULL )

					TypeName = (yyvsp[(3) - (4)].cls.sym)->Base->TrueName;

				_elseif( (yyvsp[(3) - (4)].cls.sym)->Type != NULL )

					_if( (yyvsp[(3) - (4)].cls.sym)->Type->Base != NULL )

						TypeName = (yyvsp[(3) - (4)].cls.sym)->Type->Base->TrueName;

					_elseif( (yyvsp[(3) - (4)].cls.sym)->Type->Type != NULL )

						TypeName = (yyvsp[(3) - (4)].cls.sym)->Type->Type->TrueName;

					_else

						TypeName = (yyvsp[(3) - (4)].cls.sym)->Type->TrueName;

					_endif

				_else

					TypeName = (yyvsp[(3) - (4)].cls.sym)->TrueName;

				_endif;
				assert( TypeName != NULL );
							
			_endif
			v.v.u.strval = hlastrdup2( TypeName );
			SetConst
			( 
				YYS &(yyval.v), 
				tString, 
				&string_ste,
				YYS &v
			);
			_here;
		;}
    break;

  case 1824:

/* Line 1464 of yacc.c  */
#line 76473 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);

			/*
			** Because we have to allow for undefined IDs,
			** the following code bumps the actual pType value
			** up by one (undefined IDs have a pType of zero).
			*/
			
			_here;
			_if( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg8 ) != 0 )

				_if( (yyvsp[(3) - (4)].cls.type) != NULL )

					v.v.u.unsval = (yyvsp[(3) - (4)].cls.type)->pType + 1;

				_else

					v.v.u.unsval = tByte + 1;

				_endif

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg16 ) != 0 )

				_if( (yyvsp[(3) - (4)].cls.type) != NULL )

					v.v.u.unsval = (yyvsp[(3) - (4)].cls.type)->pType + 1;

				_else

					v.v.u.unsval = tWord + 1;

				_endif

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg32 ) != 0 )

				_if( (yyvsp[(3) - (4)].cls.type) != NULL )

					v.v.u.unsval = (yyvsp[(3) - (4)].cls.type)->pType + 1;

				_else

					v.v.u.unsval = tDWord + 1;

				_endif

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_fpReg ) != 0 )

				v.v.u.unsval = tReal80 + 1;


			_elseif( (yyvsp[(3) - (4)].cls.sym) != NULL )

				_if( (yyvsp[(3) - (4)].cls.sym)->Type == NULL )
				
					v.v.u.unsval = (yyvsp[(3) - (4)].cls.sym)->pType + 1;
					
				_else
				
					v.v.u.unsval = (yyvsp[(3) - (4)].cls.sym)->Type->pType + 1;
					
				_endif

			_elseif( (yyvsp[(3) - (4)].cls.type) != NULL )

				v.v.u.unsval = (yyvsp[(3) - (4)].cls.type)->pType + 1;

			_else

				v.v.u.unsval = 0;

			_endif
			SetConst
			( 
				YYS &(yyval.v), 
				tUns32, 
				&uns32_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1825:

/* Line 1464 of yacc.c  */
#line 76581 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE	v;
			SymNode_t		*t;

			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);

			// $<cls.type>3 should be the type of the expression.
			// But if it is invalid, then use the base symbol's type.

			t = (yyvsp[(3) - (4)].cls.type);
			_if( t == NULL )

				t = _ifx( (yyvsp[(3) - (4)].cls.sym) != NULL, (yyvsp[(3) - (4)].cls.sym)->Type, NULL );

			_endif
				

			/*
			** Because we have to allow for undefined IDs,
			** the following code bumps the actual pType value
			** up by one (undefined IDs have a pType of zero).
			*/
			
			_here;
			_if( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg8 ) != 0 )

				v.v.u.unsval = _ifx( t != NULL, t->pType + 1, tByte + 1 );

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg16 ) != 0 )

				v.v.u.unsval = _ifx( t != NULL, t->pType + 1, tWord + 1 );

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg32 ) != 0 )

				v.v.u.unsval = _ifx( t != NULL, t->pType + 1, tDWord + 1 );

			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_fpReg ) != 0 )
					   
				v.v.u.unsval = tReal80 + 1;


			_elseif( t != NULL )
			
				_if( t->pType == tArray )

					unArray( YYS &(yyvsp[(3) - (4)].cls) );
					v.v.u.unsval = (yyvsp[(3) - (4)].cls.sym)->pType+1;

				_elseif( t->pType == tPointer )

					_if( t->Base != NULL )

						v.v.u.unsval = t->Base->pType+1;

					_elseif( t->Type != NULL )

						_if( t->Type->Base != NULL )

							v.v.u.unsval = t->Type->Base->pType+1;

						_else

							v.v.u.unsval = t->Type->pType+1;

						_endif

					_else

						v.v.u.unsval = tPointer+1;

					_endif

				_else

					v.v.u.unsval = t->pType+1;
					
				_endif
					
			_else
			
				v.v.u.unsval = 0;

			_endif
			SetConst
			( 
				YYS &(yyval.v), 
				tUns32, 
				&uns32_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1826:

/* Line 1464 of yacc.c  */
#line 76697 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);

			/*
			** Because we have to allow for undefined IDs,
			** the following code bumps the actual pType value
			** up by one (undefined IDs have a pType of zero).
			*/
			
			_here;
			_if( (yyvsp[(3) - (4)].cls.sym) == NULL )

				v.v.u.unsval = 0;

			_else

				v.v.u.unsval = (yyvsp[(3) - (4)].cls.sym)->SymClass + 1;

			_endif
			SetConst
			( 
				YYS &(yyval.v), 
				tUns32, 
				&uns32_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1827:

/* Line 1464 of yacc.c  */
#line 76750 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			/*
			** Because we have to allow for undefined
			** IDs (which will have a default pClass of zero),
			** the following code bumps the true pClass up by
			** one when returning the value to the user.
			*/

			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);
			_if
			( 
					(( (yyvsp[(3) - (4)].cls.cls) & cfy_SingleID ) == 0 )
				||	(yyvsp[(3) - (4)].cls.sym) == NULL 
			)

				v.v.u.unsval = 0;

			_else

				v.v.u.unsval = (yyvsp[(3) - (4)].cls.sym)->pClass + 1;

			_endif
			SetConst
			( 
				YYS &(yyval.v), 
				tUns32, 
				&uns32_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1828:

/* Line 1464 of yacc.c  */
#line 76806 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			/*
			** Return the size of the operand.  If we cannot
			** determine the size of the operand, force an
			** error and return one.
			*/
			
			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);
			_if( (yyvsp[(3) - (4)].cls.cls) & cfy_Undefined )
			
				yyerror( "Undefined symbol in @SIZE function" );
				
			_else
			
				v.v.u.unsval = (yyvsp[(3) - (4)].cls.ObjectSize);
				SetConst
				( 
					YYS &(yyval.v), 
					tUns32, 
					&uns32_ste,
					YYS &v 
				);
				
			_endif
			_here;
		;}
    break;

  case 1829:

/* Line 1464 of yacc.c  */
#line 76855 "hlaparse.bsn"
    {					/* $5 */

			union YYSTYPE v;

			/*
			** Because we have to allow for undefined IDs,
			** the following code bumps the actual pType value
			** up by one (undefined IDs have a pType of zero).
			*/
			
			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);
			_if( (yyvsp[(3) - (4)].cls.arity) == 0 || (yyvsp[(3) - (4)].cls.type) == NULL )

				yyerror( "Expected an array identifier/expression" );
				v.v.u.unsval =  0;

			_else

				v.v.u.unsval = (yyvsp[(3) - (4)].cls.type)->ObjectSize;

			_endif
			SetConst
			( 
				YYS &(yyval.v), 
				tUns32, 
				&uns32_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1830:

/* Line 1464 of yacc.c  */
#line 76906 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			/*
			** Undefined symbols will have an offset of zero.
			*/

			_here;
			ClrConst
			( 
				YYS &v, 
				tInt32, 
				&int32_ste
			);
			_if(( (yyvsp[(3) - (4)].cls.cls) & cfy_SingleID ) == 0 )

				yyerror( "@offset requires a single ID as a parameter" );
				v.v.u.unsval = 0;
				
				 
			_elseif( ( (yyvsp[(3) - (4)].cls.cls) & cfy_Undefined) || (yyvsp[(3) - (4)].cls.sym) == NULL )
			
				yyerror
				(
					"The symbol supplied as @offset argument is undefined"
				);
				v.v.u.unsval = 0;

			_else
			
				v.v.u.unsval = (yyvsp[(3) - (4)].cls.sym)->Offset;
				_if
				(
						(yyvsp[(3) - (4)].cls.sym)->SymClass != cVar
					&&	(yyvsp[(3) - (4)].cls.sym)->SymClass != cParm
					&&	(yyvsp[(3) - (4)].cls.sym)->SymClass != cClassIter
					&&	(yyvsp[(3) - (4)].cls.sym)->SymClass != cMethod
				)

					yyerror( "Expected VAR, Parm, class iterator, or method" );
					v.v.u.unsval = 0;

				_endif

			_endif
			SetConst
			( 
				YYS &(yyval.v), 
				tInt32, 
				&int32_ste,
				YYS &v
			);
			_here;
		;}
    break;

  case 1831:

/* Line 1464 of yacc.c  */
#line 76977 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;


			/*
			** If the symbol is undefined, or if there is no
			** static name for this object, return an empty string,
			** otherwise return the static name.
			*/

			_here;
			_if(( (yyvsp[(3) - (4)].cls.cls) & cfy_SingleID ) == 0 )

				yyerror( "@StaticName requires a single ID as a parameter" );

			_elseif( (yyvsp[(3) - (4)].cls.sym) == NULL || (yyvsp[(3) - (4)].cls.sym)->StaticName == NULL )

				v.v.u.strval = hlastrdup2( "" );

			_else

				v.v.u.strval = hlastrdup2( (yyvsp[(3) - (4)].cls.sym)->StaticName );

			_endif
			SetConst
			( 
				YYS &(yyval.v), 
				tString, 
				&string_ste,
				YYS &v
			);
			_here;
		;}
    break;

  case 1832:

/* Line 1464 of yacc.c  */
#line 77027 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;


			/*
			** @lex requires a single, defined, identifier as
			** a parameter.
			*/

			_here;
			ClrConst
			( 
				YYS &v, 
				tInt32, 
				&int32_ste
			);
			_if(( (yyvsp[(3) - (4)].cls.cls) & cfy_SingleID ) == 0 )

				yyerror( "@lex requires a single ID as a parameter" );

			_elseif
			( 
					(yyvsp[(3) - (4)].cls.sym) == NULL 
				||	((yyvsp[(3) - (4)].cls.cls) & cfy_Undefined) != 0
			)

				yyerror( "@lex requires a single (defined) ID parameter" );
				v.v.u.unsval = 0;

			_else

				v.v.u.unsval = (yyvsp[(3) - (4)].cls.sym)->LexLevel;

			_endif

			SetConst
			( 
				YYS &(yyval.v), 
				tInt32, 
				&int32_ste,
				YYS &v
			);
			_here;
		;}
    break;

  case 1833:

/* Line 1464 of yacc.c  */
#line 77087 "hlaparse.bsn"
    {					/* $6 */

			union YYSTYPE v;


			/*
			** @IsExternal requires a single, defined, identifier as
			** a parameter.
			*/

			_here;
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			_if(( (yyvsp[(3) - (4)].cls.cls) & cfy_SingleID ) == 0 )

				yyerror( "@IsExternal requires a single ID as a parameter" );

			_elseif
			( 
					(yyvsp[(3) - (4)].cls.sym) == NULL 
				||	((yyvsp[(3) - (4)].cls.cls) & cfy_Undefined) != 0
			)

				yyerror
				( 
					"@IsExternal requires a single (defined) ID parameter" 
				);
				v.v.u.unsval = 0;

			_else

				v.v.u.unsval = (yyvsp[(3) - (4)].cls.sym)->IsExternal;

			_endif

			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v
			);
			_here;
		;}
    break;

  case 1834:

/* Line 1464 of yacc.c  */
#line 77151 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;


			/*
			** Undefined objects have arity zero.
			*/

			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);
			_if
			( 
					(yyvsp[(3) - (4)].cls.sym) != NULL 
				&&	((yyvsp[(3) - (4)].cls.cls) & cfy_Undefined) == 0
			)

				v.v.u.unsval = (yyvsp[(3) - (4)].cls.sym)->Arity;

			_elseif( (yyvsp[(3) - (4)].cls.type) != NULL )

				v.v.u.unsval = (yyvsp[(3) - (4)].cls.type)->Arity;

			_else

				v.v.u.unsval = 0;

			_endif

			SetConst
			( 
				YYS &(yyval.v), 
				tUns32, 
				&uns32_ste,
				YYS &v
			);
			_here;
		;}
    break;

  case 1835:

/* Line 1464 of yacc.c  */
#line 77209 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);

			/*
			** Set up some common synthesized attribute return values.
			*/


			/*
			** Undefined symbols will have a dimension array
			** containing a single zero element.
			*/

			_if
			( 
					(yyvsp[(3) - (4)].cls.sym) != NULL 
				&&	( (yyvsp[(3) - (4)].cls.cls) & cfy_Undefined ) == 0 
				&&	(yyvsp[(3) - (4)].cls.sym)->pType == tArray 
			)
									 
				(yyval.v.Name) = "";
				(yyval.v.TrueName) = "";
				(yyval.v.SymClass) = cConstant;
				(yyval.v.pType) = tArray;
				(yyval.v.Type) = &uns32_ste;
				(yyval.v.ObjectSize) = 0;
				(yyval.v.Offset) = 0;
				(yyval.v.StaticName) = NULL;
				(yyval.v.LexLevel) = CurLexLevel;
				(yyval.v.Arity) = 1;
				(yyval.v.Dimensions) = malloc2( sizeofInt );
				*(yyval.v.Dimensions) = (yyvsp[(3) - (4)].cls.sym)->Arity;
				(yyval.v.NumElements) = (yyvsp[(3) - (4)].cls.sym)->Arity;
				(yyval.v.Base) = NULL;
				(yyval.v.Fields) = NULL;
				(yyval.v.FieldCnt) = 0;

				(yyval.v.u.ArrayOfValues) = 
					malloc2
					( 
						(yyvsp[(3) - (4)].cls.sym)->Arity * sizeofSymNode
					);
				
				_for( int i=0, i < (yyvsp[(3) - (4)].cls.sym)->Arity, ++i )

					v.v.u.unsval = (yyvsp[(3) - (4)].cls.sym)->Dimensions[i];
					SetConst
					( 
						YYS &(yyval.v.u.ArrayOfValues)[i], 
						tUns32, 
						&uns32_ste,
						YYS &v
					);

				_endfor

			_elseif
			( 
					(yyvsp[(3) - (4)].cls.type) != NULL 
				&&	(yyvsp[(3) - (4)].cls.type)->pType == tArray 
			)
									 
				(yyval.v.Name) = "";
				(yyval.v.TrueName) = "";
				(yyval.v.SymClass) = cConstant;
				(yyval.v.pType) = tArray;
				(yyval.v.Type) = &uns32_ste;
				(yyval.v.ObjectSize) = 0;
				(yyval.v.Offset) = 0;
				(yyval.v.StaticName) = NULL;
				(yyval.v.LexLevel) = CurLexLevel;
				(yyval.v.Arity) = 1;
				(yyval.v.Dimensions) = malloc2( sizeofInt );
				*(yyval.v.Dimensions) = (yyvsp[(3) - (4)].cls.type)->Arity;
				(yyval.v.NumElements) = (yyvsp[(3) - (4)].cls.type)->Arity;
				(yyval.v.Base) = NULL;
				(yyval.v.Fields) = NULL;
				(yyval.v.FieldCnt) = 0;

				(yyval.v.u.ArrayOfValues) = 
					malloc2
					( 
						(yyvsp[(3) - (4)].cls.type)->Arity * sizeofSymNode
					);
				
				assert( (yyval.v.u.ArrayOfValues) != NULL );
				_for( int i=0, i < (yyvsp[(3) - (4)].cls.type)->Arity, ++i )

					v.v.u.unsval = (yyvsp[(3) - (4)].cls.type)->Dimensions[i];
					SetConst
					( 
						YYS &(yyval.v.u.ArrayOfValues)[i], 
						tUns32, 
						&uns32_ste,
						YYS &v
					);

				_endfor


			_else
									 
				(yyval.v.Name) = "";
				(yyval.v.TrueName) = "";
				(yyval.v.SymClass) = cConstant;
				(yyval.v.pType) = tArray;
				(yyval.v.Type) = &uns32_ste;
				(yyval.v.ObjectSize) = 0;
				(yyval.v.Offset) = 0;
				(yyval.v.StaticName) = NULL;
				(yyval.v.LexLevel) = CurLexLevel;
				(yyval.v.Arity) = 1;
				(yyval.v.Dimensions) = malloc2( sizeofInt );
				*(yyval.v.Dimensions) = 1;
				(yyval.v.NumElements) = 1;
				(yyval.v.Base) = NULL;
				(yyval.v.Fields) = NULL;
				(yyval.v.FieldCnt) = 0;

				(yyval.v.u.ArrayOfValues) = malloc2( sizeofSymNode);

				(yyval.v.u.ArrayOfValues)->SymClass = cConstant;
				(yyval.v.u.ArrayOfValues)->pType = tUns32;
				(yyval.v.u.ArrayOfValues)->Type = &uns32_ste;
				(yyval.v.u.ArrayOfValues)->ObjectSize = 4;
				(yyval.v.u.ArrayOfValues)->Arity = 0;
				(yyval.v.u.ArrayOfValues)->Dimensions = NULL;
				(yyval.v.u.ArrayOfValues)->NumElements = 0;
				(yyval.v.u.ArrayOfValues)->Base = NULL;
				(yyval.v.u.ArrayOfValues)->Fields = NULL;
				(yyval.v.u.ArrayOfValues)->FieldCnt = 0;
				(yyval.v.u.ArrayOfValues)->u.unsval = 0;

			_endif
			_here;
		;}
    break;

  case 1836:

/* Line 1464 of yacc.c  */
#line 77371 "hlaparse.bsn"
    {					/* $8 */

			SymNode_t *s;

			/*
			** Set up some common synthesized attribute return values.
			*/


			/*
			** Undefined symbols will return zero.
			*/

			_here;
			ClrConst
			( 
				YYS &(yyval.v), 
				tUns32, 
				&uns32_ste
			);
			_if
			( 
					( (yyvsp[(3) - (7)].cls.cls) & cfy_Undefined ) == 0
				&&	(yyvsp[(3) - (7)].cls.sym) != NULL 
				&&	(yyvsp[(3) - (7)].cls.sym)->pType == tArray 
			)

				s = (yyvsp[(3) - (7)].cls.sym);

			_elseif
			( 
					(yyvsp[(3) - (7)].cls.type) != NULL 
				&&	(yyvsp[(3) - (7)].cls.type)->pType == tArray 
			)
				s = (yyvsp[(3) - (7)].cls.type);

			_else

				s = NULL;
			
			_endif


			_if( !IsNumber( (yyvsp[(6) - (7)].v.pType)  ) || numBits( YYS &(yyvsp[(6) - (7)].v) ) > 32 )

				yyerror( "Type mismatch in array index expression" );

			_else


				_if( s == NULL )
										 
					(yyval.v.Name) = "";
					(yyval.v.TrueName) = "";
					(yyval.v.SymClass) = cConstant;
					(yyval.v.pType) = tUns32;
					(yyval.v.Type) = &uns32_ste;
					(yyval.v.ObjectSize) = 0;
					(yyval.v.Offset) = 0;
					(yyval.v.StaticName) = NULL;
					(yyval.v.LexLevel) = CurLexLevel;
					(yyval.v.Arity) = 0;
					(yyval.v.Dimensions) = NULL;
					(yyval.v.NumElements) = 0;
					(yyval.v.Base) = NULL;
					(yyval.v.Fields) = NULL;
					(yyval.v.FieldCnt) = 0;

					(yyval.v.u.unsval) = 0;

				_elseif( (yyvsp[(6) - (7)].v.u.unsval) > s->Arity )

					yyerror( "Array index value is out of range" );

					(yyval.v.Name) = "";
					(yyval.v.TrueName) = "";
					(yyval.v.SymClass) = cConstant;
					(yyval.v.pType) = tUns32;
					(yyval.v.Type) = &uns32_ste;
					(yyval.v.ObjectSize) = 0;
					(yyval.v.Offset) = 0;
					(yyval.v.StaticName) = NULL;
					(yyval.v.LexLevel) = CurLexLevel;
					(yyval.v.Arity) = 0;
					(yyval.v.Dimensions) = NULL;
					(yyval.v.NumElements) = 0;
					(yyval.v.Base) = NULL;
					(yyval.v.Fields) = NULL;
					(yyval.v.FieldCnt) = 0;

					(yyval.v.u.unsval) = 0;

				_else

					(yyval.v.Name) = "";
					(yyval.v.TrueName) = "";
					(yyval.v.SymClass) = cConstant;
					(yyval.v.pType) = tUns32;
					(yyval.v.Type) = &uns32_ste;
					(yyval.v.ObjectSize) = 0;
					(yyval.v.Offset) = 0;
					(yyval.v.StaticName) = NULL;
					(yyval.v.LexLevel) = CurLexLevel;
					(yyval.v.Arity) = 0;
					(yyval.v.Dimensions) = NULL;
					(yyval.v.NumElements) = 0;
					(yyval.v.Base) = NULL;
					(yyval.v.Fields) = NULL;
					(yyval.v.FieldCnt) = 0;

					(yyval.v.u.unsval) = s->Dimensions[ (yyvsp[(6) - (7)].v.u.unsval) ];
					
				_endif

			_endif
			_here;
		;}
    break;

  case 1837:

/* Line 1464 of yacc.c  */
#line 77504 "hlaparse.bsn"
    {					/* $5 */

			union	YYSTYPE	v;
			SymNode_t 		*s;

			/*
			** Because we have to allow for undefined IDs,
			** the following code bumps the actual pType value
			** up by one (undefined IDs have a pType of zero).
			*/
			
			_here;
			ClrConst
			( 
				YYS &v, 
				tUns32, 
				&uns32_ste
			);
			_if
			( 
					( (yyvsp[(3) - (4)].cls.cls) & cfy_Undefined ) == 0
				&&	(yyvsp[(3) - (4)].cls.sym) != NULL 
				&&	(yyvsp[(3) - (4)].cls.sym)->pType == tArray 
			)

				s = (yyvsp[(3) - (4)].cls.sym);

			_elseif
			( 
					(yyvsp[(3) - (4)].cls.type) != NULL 
				&&	(yyvsp[(3) - (4)].cls.type)->pType == tArray 
			)
				s = (yyvsp[(3) - (4)].cls.type);

			_else

				s = NULL;
			
			_endif


			_if
			( 
					(yyvsp[(3) - (4)].cls.arity) == 0 
				||	s == NULL
			)

				yyerror( "Expected an array expression" );
				v.v.u.unsval =  0;

			_else

				v.v.u.unsval = s->NumElements;

			_endif
			SetConst
			( 

				YYS &(yyval.v), 
				tUns32, 
				&uns32_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1838:

/* Line 1464 of yacc.c  */
#line 77587 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			v.v.u.unsval = ( (yyvsp[(3) - (4)].cls.cls) & cfy_ConstExpr ) != 0;
			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1839:

/* Line 1464 of yacc.c  */
#line 77634 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			v.v.u.unsval = ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg) != 0;
			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1840:

/* Line 1464 of yacc.c  */
#line 77666 "hlaparse.bsn"
    {				/* $5 */


			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			v.v.u.unsval = ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg8) != 0;
			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1841:

/* Line 1464 of yacc.c  */
#line 77699 "hlaparse.bsn"
    {				/* $5 */


			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			v.v.u.unsval = ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg16) != 0;
			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1842:

/* Line 1464 of yacc.c  */
#line 77732 "hlaparse.bsn"
    {				/* $5 */


			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			v.v.u.unsval = ( (yyvsp[(3) - (4)].cls.cls) & cfy_Reg32) != 0;
			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1843:

/* Line 1464 of yacc.c  */
#line 77764 "hlaparse.bsn"
    {				/* $5 */


			union YYSTYPE v;

			_here;
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			v.v.u.unsval = ( (yyvsp[(3) - (4)].cls.cls) & cfy_fpReg) != 0;
			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1844:

/* Line 1464 of yacc.c  */
#line 77804 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			/*
			** If it's undefined or not a class, return false.
			** If its not an identifier, print an error.
			*/
				
			_here;		
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			_if( ( (yyvsp[(3) - (4)].cls.cls) & cfy_SingleID ) != 0 )

				v.v.u.unsval = 
						( (yyvsp[(3) - (4)].cls.cls) & cfy_Undefined ) == 0
					&&	( (yyvsp[(3) - (4)].cls.cls) & cfy_SingleID ) != 0
					&&	(yyvsp[(3) - (4)].cls.sym) != NULL
					&&	(yyvsp[(3) - (4)].cls.sym)->pType == tClass;
				
			_else
			
				v.v.u.unsval = 0;
					
			_endif

			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1845:

/* Line 1464 of yacc.c  */
#line 77866 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			/*
			** If it's a memory operand, return true.
			*/

			_here;			
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			v.v.u.unsval = ( (yyvsp[(3) - (4)].cls.cls) & cfy_MemoryExpr ) != 0;
			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1846:

/* Line 1464 of yacc.c  */
#line 77902 "hlaparse.bsn"
    {				/* $5 */

			union YYSTYPE v;

			/*
			** If it's a Type ID, return true.
			*/
			
			_here;				
			ClrConst
			( 
				YYS &v, 
				tBoolean, 
				&boolean_ste
			);
			_if(( (yyvsp[(3) - (4)].cls.cls) & cfy_SingleID ) == 0 )		

				yyerror( "@IsType requires a single ID parameter" );

			_else

				v.v.u.unsval =
						(yyvsp[(3) - (4)].cls.sym) != NULL
					&&	(yyvsp[(3) - (4)].cls.sym)->SymClass == cType;

			_endif
			SetConst
			( 
				YYS &(yyval.v), 
				tBoolean, 
				&boolean_ste,
				YYS &v 
			);
			_here;
		;}
    break;

  case 1847:

/* Line 1464 of yacc.c  */
#line 77949 "hlaparse.bsn"
    {
			_here;
			(yyval.dotName.Sym) = (yyvsp[(-1) - (0)].s);
			(yyval.dotName.Disp) = 0;
			(yyval.dotName.StaticName) =
				_ifx( (yyvsp[(-1) - (0)].s) == NULL, NULL, (yyvsp[(-1) - (0)].s)->StaticName );
		;}
    break;

  case 1848:

/* Line 1464 of yacc.c  */
#line 77970 "hlaparse.bsn"
    {
			_here;
			(yyval.dotName) = (yyvsp[(1) - (1)].dotName);
			_here;
		;}
    break;

  case 1849:

/* Line 1464 of yacc.c  */
#line 77988 "hlaparse.bsn"
    {					/* $6 */
			char *name;

			_here;

			assert( (yyvsp[(5) - (5)].dotName.FullName) != NULL );
			assert( (yyvsp[(3) - (5)].idStr) != NULL );
			_if( (yyvsp[(1) - (5)].s) == NULL || (yyvsp[(5) - (5)].dotName.Sym) == NULL )

				/*
				** If the symbol to the left of ArbID
				** is undefined, then the whole thing
				** is undefined.  Likewise, if any symbols appearing
				** to the right of ArbID are undefined, then
				** the whole thing is undefined.  Handle that here.
				*/


				name =	malloc2
						( 
								strlen( (yyvsp[(3) - (5)].idStr) ) 
							+	strlen( (yyvsp[(5) - (5)].dotName.FullName) )
							+	2 
						);

				name[0] = '.';
				strcpy( name+1, (yyvsp[(3) - (5)].idStr) );
				strcat( name+1, (yyvsp[(5) - (5)].dotName.FullName) );

				(yyval.dotName.Sym) = NULL;
				(yyval.dotName.Disp) = 0;
				(yyval.dotName.StaticName) = NULL;
				(yyval.dotName.FullName) = name;

			_else /* Names to the left and right of simpleID are defined */

				_if( (yyvsp[(4) - (5)].dotName.Sym) != NULL )

					/*
					** Now we know that the name in the middle is defined.
					** This is somewhat of a bogus test since the stuff
					** to the right of ArbID cannot be defined if ArbID
					** is not defined.
					*/

					(yyval.dotName.Sym) = (yyvsp[(5) - (5)].dotName.Sym);
					(yyval.dotName.FullName) = 
						malloc2
						( 
								strlen( (yyvsp[(5) - (5)].dotName.FullName) )
							+	strlen( (yyvsp[(3) - (5)].idStr) ) 
							+	2 
						);

					(yyval.dotName.FullName)[0] = '.';
					strcpy(	(yyval.dotName.FullName)+1, (yyvsp[(3) - (5)].idStr) );
					strcat( (yyval.dotName.FullName)+1, (yyvsp[(5) - (5)].dotName.FullName) );

					// Check to see if the identifier in the middle is a
					// class name.  If so, change curClass to that.
					
					_if( (yyvsp[(4) - (5)].dotName.Sym)->pType == tClass )
					
						CurObject =  (yyvsp[(4) - (5)].dotName.Sym);
					
					_endif
					
					/*
					** If the stuff to the right of ArbID has a static
					** name, then this becomes the static name and we
					** also inherit the Disp field from the right hand stuff.  
					**
					** If the stuff to the right of ArbID does not have
					** a static name and ArbID does, then ArbID's StaticName
					** is returned along with the right hand side's Disp
					** field.
					**
					** If neither the stuff to the right nor ArbID has a
					** valid StaticName field, return NULL for StaticName
					** and return the sum of their displacements.
					*/

					_if
					( 
							(yyvsp[(5) - (5)].dotName.StaticName) != NULL 
					)

						(yyval.dotName.StaticName) = (yyvsp[(5) - (5)].dotName.StaticName);
						(yyval.dotName.Disp) = (yyvsp[(5) - (5)].dotName.Disp);

					_elseif
					( 
							(yyvsp[(4) - (5)].dotName.StaticName) != NULL 
					)

						(yyval.dotName.StaticName) = (yyvsp[(4) - (5)].dotName.StaticName);
						(yyval.dotName.Disp) = (yyvsp[(5) - (5)].dotName.Disp);

					_else

						(yyval.dotName.StaticName) = NULL;
						(yyval.dotName.Disp) = 
							(yyvsp[(4) - (5)].dotName.Disp) + (yyvsp[(5) - (5)].dotName.Disp);

					_endif

				_else	/* Never happens, but just in case of weirdness */

					assert( 0 );

				_endif

			_endif

			free2( vss (yyvsp[(3) - (5)].idStr) );
			free2( vss (yyvsp[(5) - (5)].dotName.FullName) );
			_here;
		;}
    break;

  case 1850:

/* Line 1464 of yacc.c  */
#line 78118 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (3)].s) == NULL )

				/*
				** If the symbol to the left of the "."
				** is undefined, then the whole thing
				** is undefined.  Handle that here.
				*/

				(yyval.dotName.Sym) = NULL;
				(yyval.dotName.FullName) = hlastrdup2( (yyvsp[(3) - (3)].idStr) );

				(yyval.dotName.StaticName) = NULL;
				(yyval.dotName.Disp) = 0;

			_else

				(yyval.dotName.Sym) = lookupin( (yyvsp[(3) - (3)].idStr), (yyvsp[(1) - (3)].s) );
				_if( (yyval.dotName.Sym) != NULL )

					/*
					** So far, so good.  The symbols on either side of
					** the "." are both defined.  Set the return
					** value as the union of these two items.
					*/									   

					(yyval.dotName.FullName) = malloc2( strlen( (yyvsp[(3) - (3)].idStr) ) + 2 );
					(yyval.dotName.FullName)[0] = '.';
					strcpy(	&(yyval.dotName.FullName)[1], (yyvsp[(3) - (3)].idStr) );

					/*
					** If the ArbID has a static name, that's the
					** static name we return.  Otherwise, we just 
					** return ArbID's displacement.
					*/

					_if( IsStaticClass( (yyval.dotName.Sym)->SymClass ))

						(yyval.dotName.Disp) = 0;
						(yyval.dotName.StaticName) = (yyval.dotName.Sym)->StaticName;

					_else
					
						(yyval.dotName.Disp) = (yyval.dotName.Sym)->Offset;
						(yyval.dotName.StaticName) = NULL;

					_endif

				_else

					/*
					** If the symbol on the right of the "." is undefined,
					** then the whole symbol is undefined.  Handle that here.
					*/

					(yyval.dotName.Sym) = NULL;
					(yyval.dotName.FullName) = hlastrdup2( (yyvsp[(3) - (3)].idStr) );
					(yyval.dotName.StaticName) = NULL;
					(yyval.dotName.Disp) = 0;

				_endif

			_endif
			free2( vss (yyvsp[(3) - (3)].idStr) );
			_here;
		;}
    break;

  case 1851:

/* Line 1464 of yacc.c  */
#line 78198 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(0) - (0)].dotName.Sym) == NULL )

				(yyval.s) = NULL;

			_elseif( (yyvsp[(0) - (0)].dotName.Sym)->pType == tPointer )

				assert( (yyvsp[(0) - (0)].dotName.Sym)->Base != NULL );
				(yyval.s) = (yyvsp[(0) - (0)].dotName.Sym)->Base->Fields;
				
			_else

				(yyval.s) = 
					_ifx
					(
						(yyvsp[(0) - (0)].dotName.Sym)->Type != NULL,
						(yyvsp[(0) - (0)].dotName.Sym)->Type->Fields, 
						(yyvsp[(0) - (0)].dotName.Sym)->Fields
					);

			_endif
			_here;
		;}
    break;

  case 1852:

/* Line 1464 of yacc.c  */
#line 78236 "hlaparse.bsn"
    {
			_here;
			(yyval.dotName.Sym) = 
				lookupin
				( 
					(yyvsp[(0) - (0)].idStr), 
					(yyvsp[(-2) - (0)].s) 
				);

			_if( (yyval.dotName.Sym) != NULL )

				(yyval.dotName.StaticName) = (yyval.dotName.Sym)->StaticName;
				_if( (yyval.dotName.StaticName) == NULL )

					(yyval.dotName.Disp) = (yyval.dotName.Sym)->Offset;

				_else

					(yyval.dotName.Disp) = 0;

				_endif

			_else

				(yyval.dotName.StaticName) = NULL;
				(yyval.dotName.Disp) = 0;

			_endif
			(yyval.dotName.FullName) = (yyvsp[(0) - (0)].idStr);
			_here;
		;}
    break;

  case 1854:

/* Line 1464 of yacc.c  */
#line 78312 "hlaparse.bsn"
    { 
			_here;
			_if( (yyvsp[(3) - (3)].returns) != NULL )
			 
				free2( vss (yyvsp[(3) - (3)].returns) ); 

			_endif
			_here; 
		;}
    break;

  case 1855:

/* Line 1464 of yacc.c  */
#line 78332 "hlaparse.bsn"
    { 					/* $3 */
			_here;
			(yyval.s) = (yyvsp[(2) - (2)].s); 
			_here;
		;}
    break;

  case 1856:

/* Line 1464 of yacc.c  */
#line 78339 "hlaparse.bsn"
    {					/* $6 */
			_here;
			(yyval.returns) = NULL;
			(void) (yyvsp[(3) - (5)].s);	// shut up bison
			_here;
		;}
    break;

  case 1858:

/* Line 1464 of yacc.c  */
#line 78355 "hlaparse.bsn"
    {
			char msg[256];

			_here;
			sprintf
			( 
				msg,
				"Expected ':', encountered '%s'\n"
				"(Possible undefined ID '%s')",
				yytext,
				(yyvsp[(0) - (2)].idStr)
			);
			yyerror( msg );
			_here;
		;}
    break;

  case 1859:

/* Line 1464 of yacc.c  */
#line 78384 "hlaparse.bsn"
    {
			char 					*StaticName;
			char 					*sn;
			struct FwdRefLabelType	*flist;
			struct FwdRefLabelType	**ptr;
			struct StaticListType	*sList;

			assert( (yyvsp[(2) - (3)].idStr) != NULL );

			/*
			** First, let's see if there is already a reference
			** to this particular identifier so we can use the
			** existing StaticName.  Don't use predefined labels
			** at a lower lex level in this check!
			*/

			_here;
			flist = FwdLabelsList;
			ptr = &FwdLabelsList;
			_while( flist != NULL && flist->lexLevel >= CurLexLevel )

				_breakif( _streq( (yyvsp[(2) - (3)].idStr), flist->label ));
				ptr = &flist->Next;
				flist = flist->Next;

			_endwhile

			_if( flist != NULL )

				/*
				** It's defined here, so may as well set the
				** referenced flag
				*/
				
				flist->referenced = 1;
				
				/*
				** Okay, we've found a forward referenced
				** label, so use its StaticName entry.
				*/

				sn = flist->StaticName;

				/*
				** If the label was declared external, emit
				** a public declaration for the label.
				*/
				
				_if( flist->isExternal )
				
					EmitPublic( sn );
					
				_endif
				

				/*
				** Remove the label from the forward
				** reference list.
				*/

				*ptr = flist->Next;
				free2( vss flist->label );
				free2( vss flist );

			_else
			
				// See if this symbol is in the static list:
				
				sList = searchStatic( (yyvsp[(2) - (3)].idStr) );
				_if( sList != NULL )
			
					sn = hlastrdup( sList->StaticName );
					
					// As we are emitting the label at this point,
					// "fix" this symbol.
					
					sList->Fixed = 1;
			
				_else
					
					// This is the first occurrence of this label,
					// so create a new StaticName for it.
					
					StaticName = malloc2( strlen( (yyvsp[(2) - (3)].idStr) ) + 16);
					sprintf( StaticName, "%s" sympost "%d", (yyvsp[(2) - (3)].idStr), LblCntr++ );
					sn = hlastrdup2( StaticName );

				_endif

			_endif
			InsertSym
			( 
				(yyvsp[(2) - (3)].idStr), 
				NULL,
				tLabel, 
				cLabel, 
				0,					/* Arity 		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				0,					/* ObjectSize	*/
				0,					/* Offset		*/
				sn,					/* Static Name	*/
				NULL,				/* Base			*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);

			/*
			** Set the Type field to non-NULL to indicate
			** that it's already defined.
			*/

			SymbolTable->Type = SymbolTable;
			NewLn();
			EmitStmtLbl( sn );
				
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 1860:

/* Line 1464 of yacc.c  */
#line 78517 "hlaparse.bsn"
    {
			char 					*StaticName;
			char 					*sn;
			struct FwdRefLabelType	*flist;
			struct FwdRefLabelType	**ptr;
			struct StaticListType	*sList;
			SymNode_t				*saveST;
			SymNode_t				*link;

			assert( (yyvsp[(2) - (3)].idStr) != NULL );

			/*
			** First, let's see if there is already a reference
			** to this particular identifier so we can use the
			** existing StaticName.
			*/

			_here;
			flist = FwdLabelsList;
			ptr = &FwdLabelsList;
			_while( flist != NULL )

				_breakif( _streq( (yyvsp[(2) - (3)].idStr), flist->label ));
				ptr = &flist->Next;
				flist = flist->Next;

			_endwhile

			_if( flist != NULL )

				flist->referenced = 1;	// Defined here, so set referenced.
				
				/*
				** Okay, we've found a forward referenced
				** label, so use its StaticName entry.
				*/

				sn = flist->StaticName;
				
				/*
				** If the label was declared external, emit
				** a public declaration for the label.
				*/
				
				_if( flist->isExternal )
				
					EmitPublic( sn );
					
				_endif
				

				/*
				** Remove the label from the forward
				** reference list.
				*/

				*ptr = flist->Next;
				free2( vss flist->label );
				free2( vss flist );

			_else
			
				// See if this symbol is in the static list:
				
				sList = searchStatic( (yyvsp[(2) - (3)].idStr) );
				_if( sList != NULL )
			
					sn = hlastrdup( sList->StaticName );
					sList->Fixed = 1;	// Because we're defining the symbol.
			
				_else
					
					// This is the first occurrence of this label,
					// so create a new StaticName for it.
					
					StaticName = malloc2( strlen( (yyvsp[(2) - (3)].idStr) ) + 16);
					sprintf( StaticName, "%s" sympost "%d", (yyvsp[(2) - (3)].idStr), LblCntr++ );
					sn = hlastrdup2( StaticName );
					
				_endif

			_endif
			
			// We need to insert this symbol at lex level zero because it's
			// a global symbol. The easiest way to do this is to link it into
			// the symbol table at the point where "true" and "false" are
			// defined.
			
			saveST = SymbolTable;
			SymbolTable = false_ste.Next;
			
			InsertSym
			( 
				(yyvsp[(2) - (3)].idStr), 
				NULL,
				tLabel, 
				cLabel, 
				0,					/* Arity 		*/
				NULL,				/* Dimensions	*/
				0, 					/* NumElements	*/
				NULL,				/* Value		*/
				0,					/* ObjectSize	*/
				0,					/* Offset		*/
				sn,					/* Static Name	*/
				NULL,				/* Base			*/
				NULL,				/* Fields		*/
				0					/* FieldCnt		*/
			);
			
			false_ste.Next = SymbolTable;

			/*
			** Set the Type field to non-NULL to indicate
			** that it's already defined..
			*/

			SymbolTable->Type = SymbolTable;
			NewLn();
			EmitGlobalStmtLbl( sn );
			

			SymbolTable = saveST;
			
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 1861:

/* Line 1464 of yacc.c  */
#line 78658 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(2) - (3)].s)->Type != NULL )

				char msg[256];

				sprintf
				( 
					msg,
					"Duplicate Label Definition (%s)", 
					(yyvsp[(2) - (3)].s)->TrueName 
				);
				yyerror( msg );

			_else

				/*
				** If we just defined it, set the Type field
				** to a non-NULL value to indicate this.
				*/

				(yyvsp[(2) - (3)].s)->Type = (yyvsp[(2) - (3)].s);
				_if( (yyvsp[(2) - (3)].s)->IsExternal )
				
					EmitPublic( (yyvsp[(2) - (3)].s)->StaticName );
					NewLn();
					EmitGlobalStmtLbl( (yyvsp[(2) - (3)].s)->StaticName );
					
				_endif
				(yyvsp[(2) - (3)].s)->IsExternal = 0;

			_endif
			(yyval.returns) = NULL;
			_here;
			
		;}
    break;

  case 1862:

/* Line 1464 of yacc.c  */
#line 78706 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(2) - (3)].s)->Type != NULL )

				char msg[256];

				sprintf
				( 
					msg,
					"Duplicate Label Definition (%s)", 
					(yyvsp[(2) - (3)].s)->TrueName 
				);
				yyerror( msg );

			_else

				/*
				** If we just defined it, set the Type field
				** to a non-NULL value to indicate this.
				*/

				(yyvsp[(2) - (3)].s)->Type = (yyvsp[(2) - (3)].s);
				_if( (yyvsp[(2) - (3)].s)->IsExternal )
				
					EmitPublic( (yyvsp[(2) - (3)].s)->StaticName );
					NewLn();
					EmitStmtLbl( (yyvsp[(2) - (3)].s)->StaticName );
					
				_endif
				(yyvsp[(2) - (3)].s)->IsExternal = 0;

			_endif
			(yyval.returns) = NULL;
			_here;
			
		;}
    break;

  case 1863:

/* Line 1464 of yacc.c  */
#line 78752 "hlaparse.bsn"
    {						/* $3 */
			_here;
			cseg_prefix();
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 1864:

/* Line 1464 of yacc.c  */
#line 78763 "hlaparse.bsn"
    {						/* $3 */
			_here;
			dseg_prefix();
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 1865:

/* Line 1464 of yacc.c  */
#line 78774 "hlaparse.bsn"
    {						/* $3 */
			_here;
			eseg_prefix();
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 1866:

/* Line 1464 of yacc.c  */
#line 78785 "hlaparse.bsn"
    {						/* $3 */
			_here;
			fseg_prefix();
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 1867:

/* Line 1464 of yacc.c  */
#line 78796 "hlaparse.bsn"
    {						/* $3 */
			_here;
			gseg_prefix();
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 1868:

/* Line 1464 of yacc.c  */
#line 78807 "hlaparse.bsn"
    {						/* $3 */
			_here;
			sseg_prefix();
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 1869:

/* Line 1464 of yacc.c  */
#line 78825 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = NULL;
		;}
    break;

  case 1870:

/* Line 1464 of yacc.c  */
#line 78835 "hlaparse.bsn"
    { 			/* $4 */
			_here;
			(yyval.returns) = (yyvsp[(2) - (3)].returns); 
			_here;
		;}
    break;

  case 1871:

/* Line 1464 of yacc.c  */
#line 78844 "hlaparse.bsn"
    {
			_here;
			StartOfStmt = asmBuf->offset;
		;}
    break;

  case 1872:

/* Line 1464 of yacc.c  */
#line 78860 "hlaparse.bsn"
    {
			int		fnLength;
			int		fIndex;
			char	sn[ 256 ];
			char	*fName;
			static struct _fileList
			{
				struct _fileList *next;
				char *filename;
			}
				*fileList = NULL,
				*cursor;
			
			extern char *IncFileNameStack[];
			extern int IncSP;
			
				
			_here;
			_if( TraceFlag )
			
				static unsigned char EmittedTrace = 0;
			
				
				_if( BufSP >= 0 )
				
					fName = BufferStack[ BufSP ].FileName;
					
				_else
				
					fName = FileName;
					
				_endif
				
				cursor = fileList; 
				fIndex = 0;
				_while( cursor != NULL )
				
					_breakif( _streq( fName, cursor->filename ));
					cursor = cursor->next;
					++fIndex;
					
				_endwhile
				sprintf( sn, "filename_%d" sympost, fIndex );
				_if( cursor == NULL )
				
					cursor = malloc2( sizeof_fileList );
					cursor->next = fileList;
					cursor->filename = hlastrdup2( fName );
					fileList = cursor;
					EmitLabelledString( fName, sn );
					
				_endif
				PushStaticAdrs( sn );
				Pushd( LineCnt );
				_if( !EmittedTrace )
				
					EmitImmExtern( "_traceLine_", tLabel ); 
					
				_endif
				EmitCallLabel( "_traceLine_" );
//				Emit1L( "call", "_traceLine_" );
					
								
			_endif
			_here;
		;}
    break;

  case 1873:

/* Line 1464 of yacc.c  */
#line 78940 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1874:

/* Line 1464 of yacc.c  */
#line 78948 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (3)].returns) != NULL )

				free2( vss (yyvsp[(1) - (3)].returns) );

			_endif
			(yyval.returns) = (yyvsp[(3) - (3)].returns);
			_here;
		;}
    break;

  case 1875:

/* Line 1464 of yacc.c  */
#line 78974 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (1)].returns) != NULL )
			
				_if( *(yyvsp[(1) - (1)].returns) != '\0' )
			
					delayCollect = 1;
					PushBackStr( "\xDD" );	// Don't capture this text!
					PushBackStr( (yyvsp[(1) - (1)].returns) );
				
				_endif
				free2( vss (yyvsp[(1) - (1)].returns) );

			_endif
			_here;
		;}
    break;

  case 1876:

/* Line 1464 of yacc.c  */
#line 79010 "hlaparse.bsn"
    {
			_here;
			(yyval.reg.encoding) = 0; // Default to EAX
			(yyval.reg.Size) = 8;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tQWord;
			(yyval.reg.Type) = &qword_ste;
		;}
    break;

  case 1877:

/* Line 1464 of yacc.c  */
#line 79021 "hlaparse.bsn"
    {
			_here;
			(yyval.reg.encoding) = 0; // Default to EAX
			(yyval.reg.Size) = 8;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tQWord;
			(yyval.reg.Type) = &qword_ste;
		;}
    break;

  case 1878:

/* Line 1464 of yacc.c  */
#line 79033 "hlaparse.bsn"
    {
			_here;
			(yyval.reg.encoding) = 0; // Default to EAX
			(yyval.reg.Size) = 4;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tDWord;
			(yyval.reg.Type) = &dword_ste;
		;}
    break;

  case 1879:

/* Line 1464 of yacc.c  */
#line 79044 "hlaparse.bsn"
    {
			_here;
			(yyval.reg.encoding) = 0; // Default to EAX
			(yyval.reg.Size) = 4;
			(yyval.reg.IsSigned) = 0;
			(yyval.reg.pType) = tDWord;
			(yyval.reg.Type) = &dword_ste;
		;}
    break;

  case 1880:

/* Line 1464 of yacc.c  */
#line 79057 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
		;}
    break;

  case 1881:

/* Line 1464 of yacc.c  */
#line 79064 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(2) - (2)].adrs);
		;}
    break;

  case 1882:

/* Line 1464 of yacc.c  */
#line 79073 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
		;}
    break;

  case 1883:

/* Line 1464 of yacc.c  */
#line 79080 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(2) - (2)].adrs);
		;}
    break;

  case 1884:

/* Line 1464 of yacc.c  */
#line 79088 "hlaparse.bsn"
    {
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
		;}
    break;

  case 1885:

/* Line 1464 of yacc.c  */
#line 79094 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(2) - (2)].adrs);
		;}
    break;

  case 1886:

/* Line 1464 of yacc.c  */
#line 79102 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
		;}
    break;

  case 1887:

/* Line 1464 of yacc.c  */
#line 79108 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
			(yyval.adrs.Size) = 0;
			(yyval.adrs.Type) = &byte_ste;
			(yyval.adrs.pType) = tByte;
			(yyval.adrs.Sym)->Type = &byte_ste;
			(yyval.adrs.Sym)->pType = tByte;
		;}
    break;

  case 1888:

/* Line 1464 of yacc.c  */
#line 79121 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
		;}
    break;

  case 1889:

/* Line 1464 of yacc.c  */
#line 79127 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
			(yyval.adrs.Size) = 0;
			(yyval.adrs.Type) = &byte_ste;
			(yyval.adrs.pType) = tByte;
			(yyval.adrs.Sym)->Type = &byte_ste;
			(yyval.adrs.Sym)->pType = tByte;
		;}
    break;

  case 1890:

/* Line 1464 of yacc.c  */
#line 79143 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (1)].adrs.Size) != 2 )
			
				yyerror( "Expected a word memory operand" );
				(yyval.adrs.Size) = 2;
				
			_endif
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
		;}
    break;

  case 1891:

/* Line 1464 of yacc.c  */
#line 79154 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
			(yyval.adrs.Size) = 2;
			(yyval.adrs.pType) = tWord;
			(yyval.adrs.Type) = &word_ste;
			(yyval.adrs.Sym)->Type = &word_ste;
			(yyval.adrs.Sym)->pType = tWord;
		;}
    break;

  case 1892:

/* Line 1464 of yacc.c  */
#line 79167 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (1)].adrs.Size) != 4 )
			
				yyerror( "Expected a dword memory operand" );
				(yyval.adrs.Size) = 4;
				
			_endif
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
		;}
    break;

  case 1893:

/* Line 1464 of yacc.c  */
#line 79178 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
			(yyval.adrs.Size) = 4;
			(yyval.adrs.pType) = tDWord;
			(yyval.adrs.Type) = &dword_ste;
			(yyval.adrs.Sym)->Type = &dword_ste;
			(yyval.adrs.Sym)->pType = tDWord;
		;}
    break;

  case 1894:

/* Line 1464 of yacc.c  */
#line 79192 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (1)].adrs.Size) != 8 )
			
				yyerror( "Expected a qword memory operand" );
				(yyval.adrs.Size) = 8;
				
			_endif
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
		;}
    break;

  case 1895:

/* Line 1464 of yacc.c  */
#line 79203 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
			(yyval.adrs.Size) = 8;
			(yyval.adrs.pType) = tQWord;
			(yyval.adrs.Type) = &qword_ste;
			(yyval.adrs.Sym)->Type = &qword_ste;
			(yyval.adrs.Sym)->pType = tQWord;
		;}
    break;

  case 1896:

/* Line 1464 of yacc.c  */
#line 79219 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (1)].adrs.Size) != 16 )
			
				yyerror( "Expected an lword memory operand" );
				(yyval.adrs.Size) = 16;
				
			_endif
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
		;}
    break;

  case 1897:

/* Line 1464 of yacc.c  */
#line 79230 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
			(yyval.adrs.Size) = 16;
			(yyval.adrs.pType) = tLWord;
			(yyval.adrs.Type) = &lword_ste;
			(yyval.adrs.Sym)->Type = &lword_ste;
			(yyval.adrs.Sym)->pType = tLWord;
		;}
    break;

  case 1898:

/* Line 1464 of yacc.c  */
#line 79243 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (1)].adrs.Size) != 16 && (yyvsp[(1) - (1)].adrs.Size) != 8  )
			
				yyerror( "Expected an lword or qword memory operand" );
				(yyval.adrs.Size) = 16;
				
			_endif
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
		;}
    break;

  case 1899:

/* Line 1464 of yacc.c  */
#line 79254 "hlaparse.bsn"
    {
			_here;
			(yyval.adrs) = (yyvsp[(1) - (1)].adrs);
			(yyval.adrs.Size) = 16;
			(yyval.adrs.pType) = tLWord;
			(yyval.adrs.Type) = &lword_ste;
			(yyval.adrs.Sym)->Type = &lword_ste;
			(yyval.adrs.Sym)->pType = tLWord;
		;}
    break;

  case 1900:

/* Line 1464 of yacc.c  */
#line 79280 "hlaparse.bsn"
    {
			_here;
			(yyval.v) = (yyvsp[(1) - (1)].v);
		;}
    break;

  case 1901:

/* Line 1464 of yacc.c  */
#line 79287 "hlaparse.bsn"
    {
			_here;
			(yyval.v) = (yyvsp[(2) - (2)].v);
		;}
    break;

  case 1902:

/* Line 1464 of yacc.c  */
#line 79296 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(1) - (1)].idStr);
		;}
    break;

  case 1903:

/* Line 1464 of yacc.c  */
#line 79303 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(2) - (2)].idStr);
		;}
    break;

  case 1904:

/* Line 1464 of yacc.c  */
#line 79322 "hlaparse.bsn"
    {
			_here;
			(yyval.rr.l) = (yyvsp[(2) - (5)].u);
			(yyval.rr.r) = (yyvsp[(4) - (5)].u);
		;}
    break;

  case 1905:

/* Line 1464 of yacc.c  */
#line 79334 "hlaparse.bsn"
    {
			_here;
			(yyval.rr.l) = (yyvsp[(1) - (3)].u);
			(yyval.rr.r) = (yyvsp[(3) - (3)].u);
		;}
    break;

  case 1906:

/* Line 1464 of yacc.c  */
#line 79347 "hlaparse.bsn"
    {
			_here;
			(yyval.rr.l) = (yyvsp[(2) - (5)].u);
			(yyval.rr.r) = (yyvsp[(4) - (5)].u);
		;}
    break;

  case 1907:

/* Line 1464 of yacc.c  */
#line 79360 "hlaparse.bsn"
    {
			_here;
			(yyval.mr.r) = (yyvsp[(4) - (5)].u);
			(yyval.mr.m) = (yyvsp[(2) - (5)].adrs);
			(yyval.mr.m.forcedSize) = 0;
		;}
    break;

  case 1908:

/* Line 1464 of yacc.c  */
#line 79374 "hlaparse.bsn"
    {
			_here;
			(yyval.rm.r) = (yyvsp[(2) - (5)].u);
			(yyval.rm.m) = (yyvsp[(4) - (5)].adrs);
			(yyval.rm.m.forcedSize) = 0;
		;}
    break;

  case 1909:

/* Line 1464 of yacc.c  */
#line 79404 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(7) - (8)].v.pType) != tString && (yyvsp[(7) - (8)].v.pType) != tZString )

				yyerror
				( 
					"RETURNS expected a string constant for the RETURNS value"
				);
				FreeValue( YYS &(yyvsp[(7) - (8)].v) );
				(yyval.returns) = NULL;

			_else

				(yyval.returns) = (yyvsp[(7) - (8)].v.u.strval);
			
			_endif
		;}
    break;

  case 1910:

/* Line 1464 of yacc.c  */
#line 79443 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = NULL;
		;}
    break;

  case 1911:

/* Line 1464 of yacc.c  */
#line 79455 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = NULL;
		;}
    break;

  case 1912:

/* Line 1464 of yacc.c  */
#line 79467 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = NULL;
		;}
    break;

  case 1913:

/* Line 1464 of yacc.c  */
#line 79478 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = NULL;
		;}
    break;

  case 1914:

/* Line 1464 of yacc.c  */
#line 79497 "hlaparse.bsn"
    {			/* $5 */

			_here;
			_if( checkSmallUns( YYS &(yyvsp[(3) - (4)].v) ) )
			
				EmitAlign( (yyvsp[(3) - (4)].v.u.unsval) );
				
			_else
			
				yyerror
				( 
					"Align directive requires a 32-bit positive constant" 
				);
				
			_endif
			FreeValue( YYS &(yyvsp[(3) - (4)].v) );
			(yyval.returns) = NULL;
		;}
    break;

  case 1915:

/* Line 1464 of yacc.c  */
#line 79538 "hlaparse.bsn"
    {					/* $6 */
			char		*pbStmt;
			SymNode_t	*sig;
			
			_here;
			LastRefdObject = (yyvsp[(3) - (5)].s);
			(yyval.returns) = NULL;
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level procedure calls are illegal in low and machine\n"
					"level language mode."
				);
				
			_endif
			
			// Search for the matching signature:
			
			sig =	matchSignature
					( 
						(yyvsp[(1) - (5)].s), 
						(yyvsp[(4) - (5)].collectedParms.parmCnt), 
						(yyvsp[(4) - (5)].collectedParms.types), 
						(yyvsp[(4) - (5)].collectedParms.pForms) 
					);
					
			_if( sig == NULL )
			
				yyerror
				( 
					"No matching signature/parameter list for overloaded call."
				);
				
			_else	// We matched a signature
			
				// Emit the code to call the associated function:
				
				pbStmt = 	malloc2
							( 
								strlen( sig->u.ovld.procName ) +
								strlen( (yyvsp[(4) - (5)].collectedParms.parms) )
								+256
							);
							
				sprintf
				(
					pbStmt,
					"%s( %s )",
					sig->u.ovld.procName,
					(yyvsp[(4) - (5)].collectedParms.parms)
				);
				PushBackStr( pbStmt );
				(yyval.returns) = pbStmt;
				
			_endif
			_if( (yyvsp[(4) - (5)].collectedParms.parms) != NULL )
			
				free( (yyvsp[(4) - (5)].collectedParms.parms) );
				
			_endif
			_if( (yyvsp[(4) - (5)].collectedParms.types) != NULL )
			
				free( (yyvsp[(4) - (5)].collectedParms.types) );
				
			_endif
			_here; 
		;}
    break;

  case 1916:

/* Line 1464 of yacc.c  */
#line 79611 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(7) - (7)].returns);
			_if( (yyvsp[(6) - (7)].returns) != NULL )
			
				free( (yyvsp[(6) - (7)].returns) ); 
				
			_endif
		;}
    break;

  case 1917:

/* Line 1464 of yacc.c  */
#line 79625 "hlaparse.bsn"
    {
			_here;
			doCollect = 1;
			collectIndex = 0;
			delayCollect = 0;
			collectBuf[0] = '\0';
			(yyval.s) = LastRefdObject;
		;}
    break;

  case 1918:

/* Line 1464 of yacc.c  */
#line 79637 "hlaparse.bsn"
    {
			char	*parms;
			int		i;
			int		j;
			
			_here;
			
			// Note: Lookahead has grabbed an extra token,
			// so subtract the size of that lexeme in order
			// to remove the lookahead symbol.
			
			collectIndex -= yyleng;
			collectBuf[ collectIndex ] = '\0';
			doCollect = 0;
			i = collectBuf[0] == '(';
			_while( isspace( collectBuf[i] ) )
			
				++i;
				
			_endwhile
			j = collectIndex - 1;
			_while( j > 0 &&  isspace(collectBuf[j])  )
			
				--j;
				
			_endwhile
			collectBuf[ j+1 ] = '\0';	
			parms = hlastrdup2( &collectBuf[i] );
			(yyval.collectedParms) = (yyvsp[(1) - (1)].collectedParms);
			(yyval.collectedParms.parms) = parms;
			_here;
		;}
    break;

  case 1919:

/* Line 1464 of yacc.c  */
#line 79673 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms.parmCnt) 	= 0;
			(yyval.collectedParms.types) 	= NULL;
			(yyval.collectedParms.pForms) 	= NULL;
			(yyval.collectedParms.parms) 	= NULL;	// Filled in later
		;}
    break;

  case 1920:

/* Line 1464 of yacc.c  */
#line 79682 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms) = (yyvsp[(1) - (1)].collectedParms);
		;}
    break;

  case 1921:

/* Line 1464 of yacc.c  */
#line 79691 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms) = (yyvsp[(1) - (1)].collectedParms);
		;}
    break;

  case 1922:

/* Line 1464 of yacc.c  */
#line 79699 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms.parmCnt) = 
				(yyvsp[(1) - (3)].collectedParms.parmCnt) + (yyvsp[(3) - (3)].collectedParms.parmCnt);
				
			(yyval.collectedParms.types) = 
				malloc2
				( 
					(yyval.collectedParms.parmCnt) * sizeofSymNodePtr
				);
				
			(yyval.collectedParms.types)[0] = (yyvsp[(1) - (3)].collectedParms.types)[0];	
			memcpy
			( 
				&(yyval.collectedParms.types)[1],
				(yyvsp[(3) - (3)].collectedParms.types),
				(yyvsp[(3) - (3)].collectedParms.parmCnt) * sizeofSymNodePtr
			);
			free( (yyvsp[(3) - (3)].collectedParms.types) );
				
			(yyval.collectedParms.pForms) = 
				malloc2
				( 
					(yyval.collectedParms.parmCnt) * sizeofParmForm
				);
				
			(yyval.collectedParms.pForms)[0] = (yyvsp[(1) - (3)].collectedParms.pForms)[0];	
			memcpy
			( 
				&(yyval.collectedParms.pForms)[1],
				(yyvsp[(3) - (3)].collectedParms.pForms),
				(yyvsp[(3) - (3)].collectedParms.parmCnt) * sizeofParmForm
			);
			free( (yyvsp[(3) - (3)].collectedParms.pForms) );
			(yyval.collectedParms.parms) = NULL;	// Filled in later
			_here; 
		;}
    break;

  case 1923:

/* Line 1464 of yacc.c  */
#line 79742 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms.pForms) = malloc2( sizeofParmForm);
			(yyval.collectedParms.pForms)[0] = parm_constant;
			(yyval.collectedParms.parmCnt) = 1;
			(yyval.collectedParms.types) = malloc2( sizeofSymNodePtr );
			(yyval.collectedParms.types)[0] = (yyvsp[(1) - (1)].v.Type);
			_here; 
		;}
    break;

  case 1924:

/* Line 1464 of yacc.c  */
#line 79771 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms.pForms) = malloc2( sizeofParmForm);
			(yyval.collectedParms.pForms)[0] = parm_register;
			(yyval.collectedParms.parmCnt) = 1;
			(yyval.collectedParms.types) = malloc2( sizeofSymNodePtr);
			(yyval.collectedParms.types)[0] = (yyvsp[(1) - (1)].reg.Type);
			(yyval.collectedParms.parms) = NULL;	// Filled in later
			_here; 
		;}
    break;

  case 1925:

/* Line 1464 of yacc.c  */
#line 79786 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms.pForms) = malloc2( sizeofParmForm);
			(yyval.collectedParms.pForms)[0] = parm_register;
			(yyval.collectedParms.parmCnt) = 1;
			(yyval.collectedParms.types) = malloc2( sizeofSymNodePtr);
			(yyval.collectedParms.types)[0] = &qword_ste;
			_here;
		;}
    break;

  case 1926:

/* Line 1464 of yacc.c  */
#line 79802 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms.pForms) = malloc2( sizeofParmForm);
			(yyval.collectedParms.pForms)[0] = parm_register;
			(yyval.collectedParms.parmCnt) = 1;
			(yyval.collectedParms.types) = malloc2( sizeofSymNodePtr);
			(yyval.collectedParms.types)[0] = &dword_ste;
			_here;
		;}
    break;

  case 1927:

/* Line 1464 of yacc.c  */
#line 79821 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms.pForms) = malloc2( sizeofParmForm);
			(yyval.collectedParms.pForms)[0] = parm_register;
			(yyval.collectedParms.parmCnt) = 1;
			(yyval.collectedParms.types) = malloc2( sizeofSymNodePtr);
			(yyval.collectedParms.types)[0] = (yyvsp[(2) - (2)].reg.Type);
			(yyval.collectedParms.parms) = NULL;	// Filled in later
			_here; 
		;}
    break;

  case 1928:

/* Line 1464 of yacc.c  */
#line 79846 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms.pForms) = malloc2( sizeofParmForm);
			(yyval.collectedParms.pForms)[0] = parm_memory;
			(yyval.collectedParms.parmCnt) = 1;
			(yyval.collectedParms.types) = malloc2( sizeofSymNodePtr);
			(yyval.collectedParms.types)[0] = (yyvsp[(1) - (1)].adrs.Type);
			FreeAdrs( &(yyvsp[(1) - (1)].adrs) );
			_here;
		;}
    break;

  case 1929:

/* Line 1464 of yacc.c  */
#line 79866 "hlaparse.bsn"
    {
			_here;
			(yyval.collectedParms.pForms) = malloc2( sizeofParmForm);
			(yyval.collectedParms.pForms)[0] = parm_memory;
			(yyval.collectedParms.parmCnt) = 1;
			(yyval.collectedParms.types) = malloc2( sizeofSymNodePtr);
			(yyval.collectedParms.types)[0] = (yyvsp[(2) - (2)].adrs.Type);
			FreeAdrs( &(yyvsp[(2) - (2)].adrs) );
			_here;
		;}
    break;

  case 1930:

/* Line 1464 of yacc.c  */
#line 79895 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1931:

/* Line 1464 of yacc.c  */
#line 79901 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1932:

/* Line 1464 of yacc.c  */
#line 79907 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1933:

/* Line 1464 of yacc.c  */
#line 79913 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1934:

/* Line 1464 of yacc.c  */
#line 79919 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1935:

/* Line 1464 of yacc.c  */
#line 79925 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1936:

/* Line 1464 of yacc.c  */
#line 79931 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1937:

/* Line 1464 of yacc.c  */
#line 79947 "hlaparse.bsn"
    {
			_here;
			call_proc( (yyvsp[(1) - (2)].s) );
			SetReferenced( (yyvsp[(1) - (2)].s) );
			(yyval.returns) = hlastrdup2( (yyvsp[(1) - (2)].s)->u.proc.returns );
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level procedure calls are illegal in low and machine\n"
					"level language mode."
				);
				
			_endif
		;}
    break;

  case 1938:

/* Line 1464 of yacc.c  */
#line 79972 "hlaparse.bsn"
    {
			_here;
			call_proc( (yyvsp[(1) - (2)].s) );
			SetReferenced( (yyvsp[(1) - (2)].s) );
			(yyval.returns) = hlastrdup2( (yyvsp[(1) - (2)].s)->u.proc.returns );
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level procedure calls are illegal in low- and\n"
					"machine-level language mode."
				);
				
			_endif
		;}
    break;

  case 1939:

/* Line 1464 of yacc.c  */
#line 79997 "hlaparse.bsn"
    {

			/*
			** This invocation uses a class name (rather than
			** an object name), so load esi (this) zero (NULL)
			** before making the call.
			*/

			_here;
			SetReferenced( (yyvsp[(1) - (2)].s) );
			
			// Must initialize ESI with NULL before class proc call:
			
			EmitGeneric_r_r( xor_instr, reg_esi, reg_esi );
			
			call_proc( (yyvsp[(1) - (2)].s) );
			(yyval.returns) = hlastrdup2( (yyvsp[(1) - (2)].s)->u.proc.returns );
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level class procedure calls are illegal in low- and\n"
					"machine-level language mode."
				);
				
			_endif
		;}
    break;

  case 1940:

/* Line 1464 of yacc.c  */
#line 80029 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1941:

/* Line 1464 of yacc.c  */
#line 80037 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1942:

/* Line 1464 of yacc.c  */
#line 80046 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1943:

/* Line 1464 of yacc.c  */
#line 80055 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1944:

/* Line 1464 of yacc.c  */
#line 80064 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1945:

/* Line 1464 of yacc.c  */
#line 80073 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1946:

/* Line 1464 of yacc.c  */
#line 80082 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = (yyvsp[(1) - (1)].returns);
		;}
    break;

  case 1947:

/* Line 1464 of yacc.c  */
#line 80096 "hlaparse.bsn"
    {
			char 		StaticName[ 256 ];
			char 		*sn;
			SymNode_t	*saveNS;
			SymNode_t	*s;

			
			// Create a dummy symbol table entry:
			
			_here;

			sprintf
			( 
				StaticName, 
				" (reg %d indirect %d) ", 
				(yyvsp[(4) - (5)].reg.encoding), 
				LblCntr++ 
			);
			sn = hlastrdup2( StaticName );
			InsertSym
			( 
				sn,
				(yyvsp[(3) - (5)].s),			/* GetBaseType( $<s>3 ), */
				(yyvsp[(3) - (5)].s)->pType, 
				cStatic, 
				0,
				NULL,
				0, 
				NULL,
				4,
				0,
				sn,
				NULL,
				NULL,
				0
			);
			_if( (yyvsp[(3) - (5)].s)->pType == tProcptr )
			
				// Copy parameter info if a proc ptr.
				
				memcpy
				( 
					&SymbolTable->u, 
					&(yyvsp[(3) - (5)].s)->u, 
					sizeofValuesSize
				);
				
			_endif

			s = SymbolTable;

			
			// Create an address to return in order to make this
			// indirect call.
			
			(yyval.adrs.ObjectSize) = 4;
			(yyval.adrs.forcedSize) = 4;
			(yyval.adrs.StaticName) = NULL;
			(yyval.adrs.regnum) = (yyvsp[(4) - (5)].reg.encoding);
			(yyval.adrs.BaseReg) = NULL;
			(yyval.adrs.IndexReg) = NULL;
			(yyval.adrs.Scale) = 0;
			(yyval.adrs.Disp) = 0;
			(yyval.adrs.Sym) = s;
			(yyval.adrs.Type) = (yyvsp[(3) - (5)].s);
			(yyval.adrs.pType) = (yyvsp[(3) - (5)].s)->pType;
			(yyval.adrs.pClass) = (yyvsp[(3) - (5)].s)->pClass;
			(yyval.adrs.SymClass) = (yyvsp[(3) - (5)].s)->SymClass;
		
		;}
    break;

  case 1948:

/* Line 1464 of yacc.c  */
#line 80187 "hlaparse.bsn"
    {
			char returns[ 256 ];

			_here;
			returns[0] = '\0';
			_if( (yyvsp[(1) - (3)].adrs.SymClass) == cParm )

				_if
				(
						(yyvsp[(1) - (3)].adrs.pClass) == name_pc
					||	(yyvsp[(1) - (3)].adrs.pClass) == lazy_pc
				)

					call_thunk( &(yyvsp[(1) - (3)].adrs) );

					/*
					** Note: the user can specify a return value
					** as a pseudo-parameter to the "name" or
					** "lazy" keyword.  If such a parameter has
					** been specified, return the associated string
					** as the "returns" value.
					*/

					_if( (yyvsp[(1) - (3)].adrs.Sym)->u.proc.returns != NULL )
					
						strcpy( returns, (yyvsp[(1) - (3)].adrs.Sym)->u.proc.returns );
						
					_endif


				_elseif( (yyvsp[(1) - (3)].adrs.pClass) == valp_pc )

					_if
					(
							(yyvsp[(1) - (3)].adrs.pType) == tThunk
						||	(
									(yyvsp[(1) - (3)].adrs.pType) == tArray
								&&	GetBaseType( (yyvsp[(1) - (3)].adrs.Type) )->pType 
												== tThunk
							)
					)

						call_thunk( &(yyvsp[(1) - (3)].adrs) );

					_elseif
					( 
							(yyvsp[(1) - (3)].adrs.pType) == tProcptr 
						||	(
									(yyvsp[(1) - (3)].adrs.pType) == tArray
								&&	GetBaseType( (yyvsp[(1) - (3)].adrs.Type) )->pType 
												== tProcptr
							)
					)

						EmitCall_m( &(yyvsp[(1) - (3)].adrs) );

						/*
						** Look up the "returns" value for this
						** procedure parameter.  Note: a "returns"
						** value can only exist if this procedure
						** pointer is of some user-defined type.
						*/

						_if
						( 
								(yyvsp[(1) - (3)].adrs.Sym)->Type != NULL
							&&	(yyvsp[(1) - (3)].adrs.Sym)->Type->u.proc.returns != NULL 
						)

							strcpy
							(
								returns,
								(yyvsp[(1) - (3)].adrs.Sym)->Type->u.proc.returns
							);

						_endif

							

					_else

						yyerror
						( 
							"Illegal use of value parameter\n"
							"(Expected thunk or procedure parameter)"
						);

					_endif


				_else

					yyerror
					(
						"Cannot call code except via pass by name,\n"
						"pass by lazy evaluation, or pass by value"
					);

				_endif

			/*
			** If it's not a parameter, see if it's a thunk here.
			*/

			_elseif
			(
					(yyvsp[(1) - (3)].adrs.pType) == tThunk
				||	(
							(yyvsp[(1) - (3)].adrs.pType) == tArray
						&&	GetBaseType( (yyvsp[(1) - (3)].adrs.Type) )->pType == tThunk
					)

			)

				call_thunk( &(yyvsp[(1) - (3)].adrs) );


			/*
			** If it's not a thunk or a parameter, see if it's a
			** procedure variable.
			*/

			_elseif
			( 
					(yyvsp[(1) - (3)].adrs.pType) == tProcptr 
				||	(
							(yyvsp[(1) - (3)].adrs.pType) == tArray
						&&	GetBaseType( (yyvsp[(1) - (3)].adrs.Type) )->pType == tProcptr
					)
			)


				EmitCall_m( &(yyvsp[(1) - (3)].adrs) );
						
				/*
				** Look up the "returns" value for this
				** procedure parameter.
				*/

				_if( (yyvsp[(1) - (3)].adrs.Sym) != NULL )

					_if
					( 
							(yyvsp[(1) - (3)].adrs.Sym)->Type != NULL 
						&&	(yyvsp[(1) - (3)].adrs.Sym)->Type->u.proc.returns != NULL 
					)

						strcpy
						(
							returns,
							(yyvsp[(1) - (3)].adrs.Sym)->Type->u.proc.returns
						);

					_elseif( (yyvsp[(1) - (3)].adrs.Sym)->u.proc.returns != NULL ) 
 
						strcpy
						(
							returns,
							(yyvsp[(1) - (3)].adrs.Sym)->u.proc.returns
						);

					_endif

				_endif

			_else

				yyerror( "Variable must point at a procedure or method" );

			_endif
			FreeAdrs( &(yyvsp[(1) - (3)].adrs) );
			(yyval.returns) = hlastrdup2( returns );
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level indirect procedure calls are illegal in low- and\n"
					"machine-level language mode."
				);
				
			_endif
			_here;
 		;}
    break;

  case 1949:

/* Line 1464 of yacc.c  */
#line 80376 "hlaparse.bsn"
    {
			char returns[ 256 ];

			_here;
			returns[0] = '\0';
			/*
			** If it's not a thunk or a parameter, see if it's a
			** procedure variable.
			*/

			_if
			( 
					(yyvsp[(1) - (3)].adrs.pType) == tProcptr 
				||	(
							(yyvsp[(1) - (3)].adrs.pType) == tArray
						&&	GetBaseType( (yyvsp[(1) - (3)].adrs.Type) )->pType == tProcptr
					)
			)


				EmitCall_r( (yyvsp[(1) - (3)].adrs.regnum) );
						
				/*
				** Look up the "returns" value for this
				** procedure parameter.
				*/

				_if( (yyvsp[(1) - (3)].adrs.Sym) != NULL )

					_if
					( 
							(yyvsp[(1) - (3)].adrs.Sym)->Type != NULL 
						&&	(yyvsp[(1) - (3)].adrs.Sym)->Type->u.proc.returns != NULL 
					)

						strcpy
						(
							returns,
							(yyvsp[(1) - (3)].adrs.Sym)->Type->u.proc.returns
						);

					_elseif( (yyvsp[(1) - (3)].adrs.Sym)->u.proc.returns != NULL ) 
 
						strcpy
						(
							returns,
							(yyvsp[(1) - (3)].adrs.Sym)->u.proc.returns
						);

					_endif

				_endif

			_else

				yyerror( "Variable must point at a procedure or method" );

			_endif
			FreeAdrs( &(yyvsp[(1) - (3)].adrs) );
			(yyval.returns) = hlastrdup2( returns );
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level indirect procedure calls are illegal in low- and\n"
					"machine-level language mode."
				);
				
			_endif
			_here;
 		;}
    break;

  case 1950:

/* Line 1464 of yacc.c  */
#line 80454 "hlaparse.bsn"
    {
			char returns[ 256 ];

			_here;
			returns[ 0 ] = '\0';

			/*
			** Merge the base name with the index to get the
			** name plus the adjusted offsets.
			*/

			CombineAddresses( &(yyvsp[(1) - (4)].adrs), &(yyvsp[(2) - (4)].adrs) );

			_if( (yyvsp[(1) - (4)].adrs.SymClass) == cParm )

				_if
				(
						(yyvsp[(1) - (4)].adrs.pClass) == name_pc
					||	(yyvsp[(1) - (4)].adrs.pClass) == lazy_pc
				)

					call_thunk( &(yyvsp[(1) - (4)].adrs) );
					_if( (yyvsp[(1) - (4)].adrs.Sym)->u.proc.returns != NULL )
					
						strcpy( returns, (yyvsp[(1) - (4)].adrs.Sym)->u.proc.returns );
						
					_endif


				_elseif( (yyvsp[(1) - (4)].adrs.pClass) == valp_pc )

					_if
					(
							(yyvsp[(1) - (4)].adrs.pType) == tThunk
						||	(
									(yyvsp[(1) - (4)].adrs.pType) == tArray
								&&	GetBaseType( (yyvsp[(1) - (4)].adrs.Type) )->pType 
												== tThunk
							)
					)

						call_thunk( &(yyvsp[(1) - (4)].adrs) );

					_elseif
					( 
							(yyvsp[(1) - (4)].adrs.pType) == tProcptr 
						||	(
									(yyvsp[(1) - (4)].adrs.pType) == tArray
								&&	GetBaseType( (yyvsp[(1) - (4)].adrs.Type) )->pType 
												== tProcptr
							)
					)

						EmitCall_m( &(yyvsp[(1) - (4)].adrs) );

						/*
						** Look up the "returns" value for this
						** procedure parameter.  Note: a "returns"
						** value can only exist if this procedure
						** pointer is of some user-defined type.
						*/

						_if( (yyvsp[(1) - (4)].adrs.Sym) != NULL )

							_if
							( 
									(yyvsp[(1) - (4)].adrs.Sym)->Type != NULL 
								&&	(yyvsp[(1) - (4)].adrs.Sym)->Type->u.proc.returns != NULL 
							)

								strcpy
								(
									returns,
									(yyvsp[(1) - (4)].adrs.Sym)->Type->u.proc.returns
								);

							_endif

						_endif

					_else

						yyerror
						( 
							"Illegal use of value parameter\n"
							"(Expected thunk or procedure parameter)"
						);

					_endif


				_else

					yyerror
					(
						"Cannot call code except via pass by name,\n"
						"pass by lazy evaluation, or pass by value"
					);

				_endif

			/*
			** If it's not a parameter, see if it's a thunk here.
			*/

			_elseif
			(
					(yyvsp[(1) - (4)].adrs.pType) == tThunk
				||	(
							(yyvsp[(1) - (4)].adrs.pType) == tArray
						&&	GetBaseType( (yyvsp[(1) - (4)].adrs.Type) )->pType == tThunk
					)

			)

				call_thunk( &(yyvsp[(1) - (4)].adrs) );


			/*
			** If it's not a thunk or a parameter, see if it's a
			** procedure variable.
			*/

			_elseif
			( 
					(yyvsp[(1) - (4)].adrs.pType) == tProcptr 
				||	(
							(yyvsp[(1) - (4)].adrs.pType) == tArray
						&&	GetBaseType( (yyvsp[(1) - (4)].adrs.Type) )->pType == tProcptr
					)
			)

				EmitCall_m( &(yyvsp[(1) - (4)].adrs) );

				/*
				** Look up the "returns" value for this
				** procedure parameter.  Note: a "returns"
				** value can only exist if this procedure
				** pointer is of some user-defined type.
				*/

				_if( (yyvsp[(1) - (4)].adrs.Sym) != NULL )

					_if
					( 
							(yyvsp[(1) - (4)].adrs.Sym)->Type != NULL 
						&&	(yyvsp[(1) - (4)].adrs.Sym)->Type->u.proc.returns != NULL 
					)

						strcpy
						(
							returns,
							(yyvsp[(1) - (4)].adrs.Sym)->Type->u.proc.returns
						);

					_endif

				_endif

			_else

				yyerror( "Variable must point at a procedure or method" );

			_endif
			SetReferenced( (yyvsp[(1) - (4)].adrs.Sym) );
			FreeAdrs( &(yyvsp[(2) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(1) - (4)].adrs) );
			(yyval.returns) = hlastrdup2( returns );
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level indirect procedure calls are illegal in low- and\n"
					"machine-level language mode."
				);
				
			_endif
			_here;
 		;}
    break;

  case 1951:

/* Line 1464 of yacc.c  */
#line 80644 "hlaparse.bsn"
    {
			char returns[ 256 ];

			_here;
			returns[ 0 ] = '\0';

			/*
			** Merge the base name with the index to get the
			** name plus the adjusted offsets.
			*/

			CombineAddresses( &(yyvsp[(1) - (4)].adrs), &(yyvsp[(2) - (4)].adrs) );

			/*
			** If it's not a thunk or a parameter, see if it's a
			** procedure variable.
			*/

			_if
			( 
					(yyvsp[(1) - (4)].adrs.pType) == tProcptr 
				||	(
							(yyvsp[(1) - (4)].adrs.pType) == tArray
						&&	GetBaseType( (yyvsp[(1) - (4)].adrs.Type) )->pType == tProcptr
					)
			)

				EmitCall_r( (yyvsp[(1) - (4)].adrs.regnum) );

				/*
				** Look up the "returns" value for this
				** procedure parameter.  Note: a "returns"
				** value can only exist if this procedure
				** pointer is of some user-defined type.
				*/

				_if( (yyvsp[(1) - (4)].adrs.Sym) != NULL )

					_if
					( 
							(yyvsp[(1) - (4)].adrs.Sym)->Type != NULL 
						&&	(yyvsp[(1) - (4)].adrs.Sym)->Type->u.proc.returns != NULL 
					)

						strcpy
						(
							returns,
							(yyvsp[(1) - (4)].adrs.Sym)->Type->u.proc.returns
						);

					_endif

				_endif

			_else

				yyerror( "Variable must point at a procedure or method" );

			_endif
			SetReferenced( (yyvsp[(1) - (4)].adrs.Sym) );
			FreeAdrs( &(yyvsp[(2) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(1) - (4)].adrs) );
			(yyval.returns) = hlastrdup2( returns );
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level indirect procedure calls are illegal in low- and\n"
					"machine-level language mode."
				);
				
			_endif
			_here;
 		;}
    break;

  case 1952:

/* Line 1464 of yacc.c  */
#line 80734 "hlaparse.bsn"
    {

			// Next, check to see if we have an overridden
			// class symbol here:
			
			_here;
			_if( (yyvsp[(0) - (1)].adrs.Sym)->pType == tOverloads )
			
				// This only happens from IndirectCall3:
				//
				// Bison's lookahead has already consumed the
				// next symbol, push it back:
				
				PushBackStr( "\xde" );
				
			_else
			
				PushBackStr( "(" );
				
			_endif
		;}
    break;

  case 1953:

/* Line 1464 of yacc.c  */
#line 80766 "hlaparse.bsn"
    {						/* $8 */
			char		*pbStmt;
			SymNode_t	*sig;
			
			_here;
			LastRefdObject = (yyvsp[(5) - (7)].s);
			(yyval.returns) = NULL;
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level procedure calls are illegal in low and machine\n"
					"level language mode."
				);
				
			_endif
			
			// Search for the matching signature:
			
			sig =	matchSignature
					( 
						(yyvsp[(2) - (7)].adrs.Sym), 
						(yyvsp[(6) - (7)].collectedParms.parmCnt), 
						(yyvsp[(6) - (7)].collectedParms.types), 
						(yyvsp[(6) - (7)].collectedParms.pForms) 
					);
					
			_if( sig == NULL )
			
				yyerror
				( 
					"No matching signature/parameter list for overloaded call."
				);
				
			_else	// We matched a signature
			
				// Emit the code to call the associated function:
				
				pbStmt = 	malloc2
							( 
								strlen( sig->u.ovld.procName ) +
								strlen( (yyvsp[(6) - (7)].collectedParms.parms) )
								+256
							);
							
				sprintf
				(
					pbStmt,
					"%s( %s )",
					sig->u.ovld.procName,
					(yyvsp[(6) - (7)].collectedParms.parms)
				);
				PushBackStr( pbStmt );
				(yyval.returns) = pbStmt;
				
			_endif
			_if( (yyvsp[(6) - (7)].collectedParms.parms) != NULL )
			
				free( (yyvsp[(6) - (7)].collectedParms.parms) );
				
			_endif
			_if( (yyvsp[(6) - (7)].collectedParms.types) != NULL )
			
				free( (yyvsp[(6) - (7)].collectedParms.types) );
				
			_endif
			_here; 
		;}
    break;

  case 1954:

/* Line 1464 of yacc.c  */
#line 80839 "hlaparse.bsn"
    {
			(yyval.returns) = (yyvsp[(9) - (9)].returns);
			_if( (yyvsp[(8) - (9)].returns) != NULL )
			
				free( (yyvsp[(8) - (9)].returns) ); 
				
			_endif
		;}
    break;

  case 1955:

/* Line 1464 of yacc.c  */
#line 80857 "hlaparse.bsn"
    {						/* $6 */

			int  			useLEA    = 1;
			int  			useOffset = 1;
			int  			isPointer = 0;
			enum ClassType	SymClass;
			SymNode_t		*classPtr;
			SymNode_t		*typ;
			SymNode_t		*s;
			SymNode_t		*super;
			char			name[ 256 ];
			char 			returns[ 256 ];

			_here;
			returns[ 0 ] = '\0';

			// Handle classes specially because we get to use the
			// ESI and EDI registers for class invocations.
			//
			// Note: $<adrs.Sym>1->Type is usually equal to $<adrs.Type>1
			// They are different for parameters passed by address. In that
			// case, $<adrs.Type>1 will be a tPointer type and $<adrs.Sym>1->Type
			// is the base type.  Note that $<adrs.pType>1 will contain tPointer
			// for a parameter passed by address. In such a case, this code has
			// to use the (base) type of $<adrs.Sym>1->Type as the object pointed at.
			//
			// It shouldn't possible for $<adrs.Sym>1->Type to be NULL. This used
			// to denote a procedure pointer object that was directly declared (rather
			// than creating a user-defined procedure type and using that to declare
			// the object). This should have been corrected everywhere by now (dummy
			// types should be created), but just in case some old code is laying around,
			// the assert below was added to catch these.
			//
			// In no case should $<adrs.Sym>1 be NULL.  Even for anonymous
			// memory objects, the Sym field is set to something legitimate.
			
			_if( (yyvsp[(1) - (5)].adrs.Sym)->Type == NULL )
			
				typ = 
					GetCallType
					( 
						(yyvsp[(1) - (5)].adrs.Sym), 
						(yyvsp[(2) - (5)].adrs.Type), 
						(yyvsp[(1) - (5)].adrs.pType), 
						&isPointer 
					);
			
			_else
			
				typ = 
					GetCallType
					( 
						(yyvsp[(1) - (5)].adrs.Sym), 
						(yyvsp[(1) - (5)].adrs.Type), 
						(yyvsp[(1) - (5)].adrs.pType), 
						&isPointer 
					);
					
			_endif			
			
			classPtr = NULL;
			_if( typ->pType == tClass )
			
				classPtr = typ;
				
				/*
				** If we've referenced a class object, we need to set
				** the IsReferenced field of the _VMT_ field for this class.
				*/
				
				s = lookupin( "_VMT_", classPtr->Fields );
				assert( s != NULL );
				_if( s->IsReferenced != NULL )
				
					SetReferenced( s );
					
				_endif

				/*
				** The assumption to this point is that we have
				** a class variable.  Check to see if what we've
				** really got is a pointer to a class object.  The
				** only difference in the code generation is "lea"
				** (for class vars) vs. "mov" (for class pointers).
				*/


				_if
				( 
						(yyvsp[(2) - (5)].adrs.Sym)->pType == tMethod
					||	(yyvsp[(2) - (5)].adrs.Sym)->pType == tClassProc
					||	(yyvsp[(2) - (5)].adrs.Sym)->pType == tClassIter
				)
				
					s = lookupin( (yyvsp[(2) - (5)].adrs.Sym)->TrueName, classPtr->Fields );
					_if( s == NULL ) 
					
						yyerror( "Must manually reference nested class object" );
						
					_endif
					
				_endif
				_if( isPointer )

					useLEA = 0;
					useOffset = 0;
					_if
					( 
							(yyvsp[(1) - (5)].adrs.SymClass) == cParm 
						&&	(yyvsp[(1) - (5)].adrs.pClass) == refp_pc 
					)
						yyerror
						( 
							"Cannot pass a pointer by reference here"
						);

					_endif

				_elseif
				(
						IsStaticClass( (yyvsp[(1) - (5)].adrs.SymClass) ) 
					&&	(yyvsp[(1) - (5)].adrs.StaticName) != NULL 
					&&	*(yyvsp[(1) - (5)].adrs.StaticName) != '\0'
					&&	(yyvsp[(2) - (5)].adrs.BaseReg) == NULL
					&&	(yyvsp[(2) - (5)].adrs.IndexReg) == NULL
				)

					useLEA = 0;
					useOffset = 1;

				_endif

				/*
				** Emit the code that moves the address of the
				** object into the ESI register (this).
				** Note that the address of the object is
				** the SimpleMemoryVar, not the FieldStuff value.
				*/

				_if
				( 
						(yyvsp[(1) - (5)].adrs.SymClass) == cVar
					|| 	(yyvsp[(1) - (5)].adrs.SymClass) == cStatic
				)

					_if( useLEA )
					
						(yyvsp[(1) - (5)].adrs.forcedSize) = 0;
						EmitLea_m_r2( &(yyvsp[(1) - (5)].adrs), reg_esi );
						
					_elseif( useOffset ) 
					
						EmitMov_o_r
						( 
							(yyvsp[(1) - (5)].adrs.StaticName), 
							(yyvsp[(1) - (5)].adrs.Disp), 
							reg_esi 
						);
						
					_else
					
						EmitMov_m_r( &(yyvsp[(1) - (5)].adrs), reg_esi, 4 ); 
						
					_endif

				_elseif( (yyvsp[(1) - (5)].adrs.SymClass) == cParm )

					/*
					** Handle pass by value of the object here.
					*/
					_if( (yyvsp[(1) - (5)].adrs.pClass) == valp_pc )

						_if( useLEA )
						
							(yyvsp[(1) - (5)].adrs.forcedSize) = 0;
							EmitLea_m_r2( &(yyvsp[(1) - (5)].adrs), reg_esi );
							
						_elseif( useOffset ) 
						
							EmitMov_o_r
							( 
								(yyvsp[(1) - (5)].adrs.StaticName), 
								(yyvsp[(1) - (5)].adrs.Disp), 
								reg_esi 
							);
							
						_else
						
							(yyvsp[(1) - (5)].adrs.forcedSize) = 0;
							EmitMov_m_r( &(yyvsp[(1) - (5)].adrs), reg_esi, 4 ); 
							
						_endif

					/*
					** Handle pass by reference of the object
					** here.
					*/

					_elseif( (yyvsp[(1) - (5)].adrs.pClass) == refp_pc )

						struct adrsYYS adrs;
						
						(yyvsp[(1) - (5)].adrs.forcedSize) = 0;
						EmitMov_m_r( &(yyvsp[(1) - (5)].adrs), reg_esi, 4 );
						initAdrs1( &adrs, reg_esi, 0 ); 
						EmitMov_m_r( &adrs, reg_esi, 4 );

					/*
					** Don't allow the other parameter passing methods.
					*/

					_else

						yyerror
						(
							"Object pointer must be passed by "
							"value or reference"
						);

					_endif

				_else

					yyerror( "Expected class object" );

				_endif


				/*
				** If the field is a class procedure, issue the
				** call here.
				*/

				_if( (yyvsp[(2) - (5)].adrs.SymClass) == cClassProc )

					/*
					** Since this is a procedure, the following
					** should always have some sort of value
					** (besides NULL).
					*/
					
					assert( (yyvsp[(2) - (5)].adrs.Sym)->StaticName != NULL );

					/*
					** This is just a class procedure.
					** Call it directly.
					*/

					call_proc( (yyvsp[(2) - (5)].adrs.Sym) );
					_if( (yyvsp[(2) - (5)].adrs.Sym)->u.proc.returns != NULL )
					
						strcpy( returns, (yyvsp[(2) - (5)].adrs.Sym)->u.proc.returns );
						
					_endif

				
				
				/*
				** If the field is a class method, issue the
				** call here.
				*/

				_elseif( (yyvsp[(2) - (5)].adrs.SymClass) == cMethod )

					struct adrsYYS adrs;

					/*
					** First, get the address of the virtual
					** method table into EDI (VMT is always at
					** offset zero within the object and ESI is
					** currently pointing at the object).
					*/

					_if( superPrefix )
					
						assert( ThisPtr != NULL );
						_if( ThisPtr->Base == NULL )
						
							super = ThisPtr;
							
						_else
						
							super = ThisPtr->Base;
							
						_endif
						assert( super->StaticName != NULL );
						
						// The pointer to the super's VMT is at
						// the current VMT[-4]:
						 
						initAdrs2( &adrs, super->StaticName, -1, -1, 0, 0 );
						extLookup
						( 
							super, 				  // sym,
							super->StaticName, 	  // theLabel, 
							super->pType, 		  // theType, 
							0, 					  // IsPublic,
							1, 					  // ForceRef,
							1 					  // isVMT 
						);
						 
						//SetReferenced( super );
						EmitLea_m_r2( &adrs, reg_edi );
						superPrefix = 0;	// Stop using super prefix.
					
					_else
					
						// Just use the current VMT:
						
						initAdrs1( &adrs, reg_esi, 0 );
						EmitMov_m_r( &adrs, reg_edi, 4 );
						
					_endif

					initAdrs1( &adrs, reg_edi, (yyvsp[(2) - (5)].adrs.Sym)->Offset );
					EmitCall_m( &adrs );
					_if( (yyvsp[(2) - (5)].adrs.Sym)->u.proc.returns != NULL )
					
						strcpy( returns, (yyvsp[(2) - (5)].adrs.Sym)->u.proc.returns );
						
					_endif

				/*
				** If the field is a pointer to a procedure, issue
				** the indirect call here.
				*/
				
				_elseif
				( 
						(yyvsp[(2) - (5)].adrs.pType) == tProcptr 
					||	(
								(yyvsp[(2) - (5)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType == tProcptr
						)
				)

					struct adrsYYS adrs;
					
					_if( (yyvsp[(2) - (5)].adrs.SymClass) == cStatic )
					
						EmitCall_m( &(yyvsp[(2) - (5)].adrs) );
						
					_else

						BuildAdrs
						( 
							&adrs, 
							4, 			// Size
							4, 			// ObjectSize
							NULL, 		// StaticName
							"esi", 		// BaseReg
							NULL, 		// IndexReg
							0, 			// Scale
							(yyvsp[(2) - (5)].adrs.Disp), 	// Disp (was $<adrs.Sym>2->Offset
							NULL,		// Sym
							&dword_ste,	// Type
							tDWord,		// pType
							cNone,		// SymClass
							none_pc,	// pClass
							NULL		// BaseType
						);
						EmitCall_m( &adrs );
						
					_endif

				/*
				** If the field is a thunk, invoke the thunk here.
				*/

				_elseif 
				( 
						(yyvsp[(2) - (5)].adrs.pType) == tThunk 
					||	(
								(yyvsp[(2) - (5)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType == tThunk
						)
				)

					struct adrsYYS adrs;

					BuildAdrs
					( 
						&adrs, 
						4, 			// Size
						4, 			// ObjectSize
						NULL, 		// StaticName
						"esi", 		// BaseReg
						NULL, 		// IndexReg
						0, 			// Scale
						(yyvsp[(2) - (5)].adrs.Sym)->Offset, 	// Disp
						NULL,		// Sym
						&dword_ste,	// Type
						tDWord,		// pType
						cNone,		// SymClass
						none_pc,	// pClass
						NULL		// BaseType
					);

					push_mem( &adrs, 4 );
					adrs.Disp += 4;
					EmitCall_m( &adrs );
				
				
				/*
				** If the field is neither a method nor a procedure,
				** then this is an illegal call.
				*/

				_else

					yyerror( "Object member is not method or procedure" );

				_endif


			/*
			** If it wasn't a class variable, see if it is a procedure
			** pointer variable or a thunk.
			*/

			_elseif( (yyvsp[(1) - (5)].adrs.pType) != tPointer )
			
				/*
				** If this is a parameter, be sure it's a value, name,
				** or lazy parameter (the only parameter types that allow
				** indirect calls).
				*/

				_if( (yyvsp[(2) - (5)].adrs.SymClass) == cParm )

					_if( (yyvsp[(2) - (5)].adrs.pClass) == valp_pc )

						_if
						(
								(yyvsp[(2) - (5)].adrs.pType) == tThunk
							||	(
										(yyvsp[(2) - (5)].adrs.pType) == tArray
									&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType
													== tThunk
								)
						)

							setForcedSize( (yyvsp[(2) - (5)].adrs), 4 );
							call_thunk( &(yyvsp[(2) - (5)].adrs) );

						_elseif
						( 
								(yyvsp[(2) - (5)].adrs.pType) == tProcptr 
							||	(
										(yyvsp[(2) - (5)].adrs.pType) == tArray
									&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType 
													== tProcptr
								)
						)

							setForcedSize( (yyvsp[(2) - (5)].adrs), 4 );
							EmitCall_m( &(yyvsp[(2) - (5)].adrs) );

							/*
							** Look up the "returns" value for this
							** procedure parameter.  Note: a "returns"
							** value can only exist if this procedure
							** pointer is of some user-defined type.
							*/

							_if( (yyvsp[(2) - (5)].adrs.Sym) != NULL )

								_if
								( 
										(yyvsp[(2) - (5)].adrs.Sym)->Type != NULL 
									&&	(yyvsp[(2) - (5)].adrs.Sym)->Type->u.proc.returns 
											!= NULL 
								)

									strcpy
									(
										returns,
										(yyvsp[(2) - (5)].adrs.Sym)->Type->u.proc.returns
									);

								_endif

							_endif

						_else

							yyerror
							( 
								"Illegal use of value parameter\n"
								"(Expected thunk or procedure parameter)"
							);

						_endif


					_else

						yyerror
						(
							"Cannot call code except via pass by value"
						);

					_endif

				/*
				** If it's not a parameter, see if it's a thunk here.
				*/

				_elseif
				(
						(yyvsp[(2) - (5)].adrs.pType) == tThunk
					||	(
								(yyvsp[(2) - (5)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType == tThunk
						)

				)

					setForcedSize( (yyvsp[(2) - (5)].adrs), 4 );
					call_thunk( &(yyvsp[(2) - (5)].adrs) );


				/*
				** If it's not a thunk or a parameter, see if it's a
				** procedure variable.
				*/

				_elseif
				( 
						(yyvsp[(2) - (5)].adrs.pType) == tProcptr 
					||	(
								(yyvsp[(2) - (5)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType == tProcptr
						)
				)

					setForcedSize( (yyvsp[(2) - (5)].adrs), 4 );
					EmitCall_m( &(yyvsp[(2) - (5)].adrs) );
						
					/*
					** Look up the "returns" value for this
					** procedure parameter.  Note: a "returns"
					** value can only exist if this procedure
					** pointer is of some user-defined type.
					*/

					_if( (yyvsp[(2) - (5)].adrs.Sym) != NULL )

						_if
						( 
								(yyvsp[(2) - (5)].adrs.Sym)->Type != NULL 
							&&	(yyvsp[(2) - (5)].adrs.Sym)->Type->u.proc.returns != NULL 
						)

							strcpy
							(
								returns,
								(yyvsp[(2) - (5)].adrs.Sym)->Type->u.proc.returns
							);

						_endif

					_endif


				_else

					yyerror( "Variable must point at a procedure or method" );

				_endif
				
			_else

				yyerror( "Illegal use of pointer variable (must dereference)" );

			_endif

			SetReferenced( (yyvsp[(2) - (5)].adrs.Sym) );
			FreeAdrs( &(yyvsp[(1) - (5)].adrs) );
			FreeAdrs( &(yyvsp[(2) - (5)].adrs) );
			(yyval.returns) = hlastrdup2( returns );

			_here;
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level indirect procedure calls are illegal in low- and\n"
					"machine-level language mode."
				);
				
			_endif
		;}
    break;

  case 1956:

/* Line 1464 of yacc.c  */
#line 81466 "hlaparse.bsn"
    {						/* $6 */

			SymNode_t	*super;
			int	 		useLEA = 1;
			int	 		useOffset = 1;
			int	 		hasBase;
			char 		returns[ 256 ];

			_here;
			returns[ 0 ] = '\0';

			/*
			** Note whether or not there was an index register in the
			** IndexAdrsMode.
			*/
			
			hasBase =
				(
						(yyvsp[(3) - (5)].adrs).BaseReg != NULL 
					||	(yyvsp[(3) - (5)].adrs).IndexReg != NULL
				);

			/*
			** Combine the index information with the base information
			** so we can use the code from the previous production.
			*/

			CombineAddresses( &(yyvsp[(1) - (5)].adrs), &(yyvsp[(3) - (5)].adrs) );

			/*
			** Handle classes specially because we get to use the
			** ESI and EDI registers for class invocations.
			*/

			_if
			( 
					(yyvsp[(1) - (5)].adrs.pType) == tClass

				||	(
							(yyvsp[(1) - (5)].adrs.pType) == tArray
						&&	GetBaseType( (yyvsp[(1) - (5)].adrs.Type) )->pType == tClass
					)

				||	(
							(
									(yyvsp[(1) - (5)].adrs.pType) == tPointer
								||	(
											(yyvsp[(1) - (5)].adrs.pType) == tArray
										&&	GetBaseType( (yyvsp[(1) - (5)].adrs.Sym) )->pType
														== tPointer
									)
							)
						&&	(yyvsp[(1) - (5)].adrs.Sym)->Base->pType == tClass
					)
			)

				/*
				** The assumption to this point is that we have
				** a class variable.  Check to see if what we've
				** really got is a pointer to a class object.  The
				** only difference in the code generation is "lea"
				** (for class vars) vs. "mov" (for class pointers).
				*/

				_if
				( 
						(yyvsp[(1) - (5)].adrs.pType) == tPointer
					||	(
								(yyvsp[(1) - (5)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(1) - (5)].adrs.Type) )->pType == tPointer
						)
				)

					useLEA = 0;
					useOffset = 0;
					_if
					( 
							(yyvsp[(1) - (5)].adrs.SymClass) == cParm 
						&&	(yyvsp[(1) - (5)].adrs.pClass) == refp_pc 
					)
						yyerror
						( 
							"Cannot pass a pointer by reference here"
						);

					_endif

				_elseif
				( 
						IsStaticClass( (yyvsp[(1) - (5)].adrs.SymClass) )
					&&	(yyvsp[(1) - (5)].adrs.StaticName) != NULL 
					&&	*(yyvsp[(1) - (5)].adrs.StaticName) != '\0'
					&&	(yyvsp[(2) - (5)].adrs.BaseReg) == NULL
					&&	(yyvsp[(2) - (5)].adrs.IndexReg) == NULL
				)

					useLEA = 0;

				_endif
				
				/*
				** At this point, we may incorrectly think that we
				** can use "mov offset...".  If the index includes
				** a register, we must use LEA, not MOV offset.
				*/

				_if( hasBase &&	useOffset == 1 )
				
					useLEA = 1;
					useOffset = 0;
					
				_endif
				

				/*
				** Emit the code that moves the address of the
				** object into the ESI register (this).
				*/

				_if
				(
						(yyvsp[(1) - (5)].adrs.SymClass) == cVar 
					||	(yyvsp[(1) - (5)].adrs.SymClass) == cStatic
				)

					_if( useLEA )
					
						(yyvsp[(1) - (5)].adrs.forcedSize) = 0;
						EmitLea_m_r2( &(yyvsp[(1) - (5)].adrs), reg_esi );
						
					_elseif( useOffset ) 
					
						EmitMov_o_r
						( 
							(yyvsp[(1) - (5)].adrs.StaticName), 
							(yyvsp[(1) - (5)].adrs.Disp), 
							reg_esi 
						);
						
					_else
					
						(yyvsp[(1) - (5)].adrs.forcedSize) = 0;
						EmitMov_m_r( &(yyvsp[(1) - (5)].adrs), reg_esi, 4 ); 
						
					_endif

				_elseif( (yyvsp[(1) - (5)].adrs.SymClass) == cParm )

					/*
					** Handle pass by value of the object here.
					*/

					_if( (yyvsp[(1) - (5)].adrs.pClass) == valp_pc  )

						_if( useLEA )
						
							(yyvsp[(1) - (5)].adrs.forcedSize) = 0;
							EmitLea_m_r2( &(yyvsp[(1) - (5)].adrs), reg_esi );
							
						_elseif( useOffset ) 
						
							EmitMov_o_r
							( 
								(yyvsp[(1) - (5)].adrs.StaticName), 
								(yyvsp[(1) - (5)].adrs.Disp), 
								reg_esi 
							);
							
						_else
						
							(yyvsp[(1) - (5)].adrs.forcedSize) = 0;
							EmitMov_m_r( &(yyvsp[(1) - (5)].adrs), reg_esi, 4 ); 
							
						_endif

					/*
					** Handle pass by reference of the object
					** here.
					*/

					_elseif( (yyvsp[(1) - (5)].adrs.pClass) == refp_pc )

						struct adrsYYS adrs;

						EmitMov_m_r( &(yyvsp[(1) - (5)].adrs), reg_esi, 4 );
						initAdrs1( &adrs, reg_esi, 0 );
						EmitMov_m_r( &adrs, reg_esi, 4 );  


					/*
					** Don't allow the other parameter passing methods.
					*/

					_else

						yyerror
						(
							"Object pointer must be passed by "
							"value or reference"
						);

					_endif

				_else

					yyerror( "Expected class object" );

				_endif
				
				


				/*
				** If the field is a class procedure, issue the
				** call here.
				*/

				_if( (yyvsp[(2) - (5)].adrs.SymClass) == cClassProc )


					/*
					** Since this is a procedure, the following
					** should always have some sort of value
					** (besides NULL).
					*/
					
					assert( (yyvsp[(2) - (5)].adrs.Sym)->StaticName != NULL );

					/*
					** This is just a class procedure.
					** Call it directly.
					*/

					call_proc( (yyvsp[(2) - (5)].adrs.Sym) );
					_if( (yyvsp[(2) - (5)].adrs.Sym)->u.proc.returns != NULL )
					
						strcpy( returns, (yyvsp[(2) - (5)].adrs.Sym)->u.proc.returns );
						
					_endif
				
				/*
				** If the field is a class method, issue the
				** call here.
				*/

				_elseif( (yyvsp[(2) - (5)].adrs.SymClass) == cMethod )

					struct adrsYYS adrs;

					/*
					** First, get the address of the virtual
					** method table into EDI (VMT is always at
					** offset zero within the object and ESI is
					** currently pointing at the object).
					*/

					_if( superPrefix )
					
						assert( ThisPtr != NULL );
						_if( ThisPtr->Base == NULL )
						
							super = ThisPtr;
							
						_else
						
							super = ThisPtr->Base;
							
						_endif
						assert( super->StaticName != NULL );
						
						// Load EDI with the address of the parent's
						// VMT:
						 
						initAdrs2( &adrs, super->StaticName, -1, -1, 0, 0 ); 
						SetReferenced( super );
						EmitLea_m_r2( &adrs, reg_edi );
						superPrefix = 0;	// Stop using super prefix.
					
					_else
					
						// Just use the current VMT:
						
						initAdrs1( &adrs, reg_esi, 0 );
						EmitMov_m_r( &adrs, reg_edi, 4 );
						
					_endif

					initAdrs1( &adrs, reg_edi, (yyvsp[(2) - (5)].adrs.Sym)->Offset );
					EmitCall_m( &adrs );
					_if( (yyvsp[(2) - (5)].adrs.Sym)->u.proc.returns != NULL )
					
						strcpy( returns, (yyvsp[(2) - (5)].adrs.Sym)->u.proc.returns );
						
					_endif


				/*
				** If the field is a pointer to a procedure, issue
				** the indirect call here.
				*/
				
				_elseif
				( 
						(yyvsp[(2) - (5)].adrs.pType) == tProcptr 
					||	(
								(yyvsp[(2) - (5)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType == tProcptr

						)
				)

					struct adrsYYS adrs;
					
					_if( (yyvsp[(2) - (5)].adrs.SymClass) == cStatic )
					
						EmitCall_m( &(yyvsp[(2) - (5)].adrs) );
						
					_else

						BuildAdrs
						( 
							&adrs, 
							4, 			// Size
							4, 			// ObjectSize
							NULL, 		// StaticName
							"esi", 		// BaseReg
							NULL, 		// IndexReg
							0, 			// Scale
							(yyvsp[(2) - (5)].adrs.Sym)->Offset, 	// Disp
							NULL,		// Sym
							&dword_ste,	// Type
							tDWord,		// pType
							cNone,		// SymClass
							none_pc,	// pClass
							NULL		// BaseType
						);
						EmitCall_m( &adrs );
						
					_endif


				/*
				** If the field is a thunk, invoke the thunk here.
				*/

				_elseif 
				( 
						(yyvsp[(2) - (5)].adrs.pType) == tThunk 
					||	(
								(yyvsp[(2) - (5)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType == tThunk
						)
				)
					struct adrsYYS adrs;

					
					_if( (yyvsp[(2) - (5)].adrs.SymClass) == cStatic )
					
						call_thunk( &(yyvsp[(2) - (5)].adrs) );
						
					_else

						BuildAdrs
						( 
							&adrs, 
							4, 			// Size
							4, 			// ObjectSize
							NULL, 		// StaticName
							"esi", 		// BaseReg
							NULL, 		// IndexReg
							0, 			// Scale
							(yyvsp[(2) - (5)].adrs.Sym)->Offset, 	// Disp
							NULL,		// Sym
							&dword_ste,	// Type
							tDWord,		// pType
							cNone,		// SymClass
							none_pc,	// pClass
							NULL		// BaseType
						);

						push_mem( &adrs, 4 );
						adrs.Disp += 4;
						EmitCall_m( &adrs );
						
					_endif
				
				
				/*
				** If the field is neither a method nor a procedure,
				** then this is an illegal call.
				*/

				_else

					yyerror( "Object member is not method or procedure" );

				_endif


			/*
			** If it wasn't a class variable, see if it is a procedure
			** pointer variable or a thunk.
			*/

			_elseif( (yyvsp[(1) - (5)].adrs.pType) != tPointer )

				/*
				** Merge the base name with the fields to get the
				** full name plus the adjusted offsets, base, and
				** index registers.
				*/
				

				CombineAddresses( &(yyvsp[(2) - (5)].adrs), &(yyvsp[(1) - (5)].adrs) );

				/*
				** If this is a parameter, be sure it's a value, name,
				** or lazy parameter (the only parameter types that allow
				** indirect calls).
				*/

				_if( (yyvsp[(1) - (5)].adrs.SymClass) == cParm )

					_if( (yyvsp[(1) - (5)].adrs.pClass) == valp_pc )

						_if
						(
								(yyvsp[(2) - (5)].adrs.pType) == tThunk
							||	(
										(yyvsp[(2) - (5)].adrs.pType) == tArray
									&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType 
													== tThunk
								)
						)

							call_thunk( &(yyvsp[(2) - (5)].adrs) );

						_elseif
						( 
								(yyvsp[(2) - (5)].adrs.pType) == tProcptr 
							||	(
										(yyvsp[(2) - (5)].adrs.pType) == tArray
									&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType 
													== tProcptr
								)
						)

							EmitCall_m( &(yyvsp[(2) - (5)].adrs) );

							/*
							** Look up the "returns" value for this
							** procedure parameter.  Note: a "returns"
							** value can only exist if this procedure
							** pointer is of some user-defined type.
							*/

							_if( (yyvsp[(2) - (5)].adrs.Sym) != NULL )
							
								_if
								( 
										(yyvsp[(2) - (5)].adrs.Sym)->Type != NULL 
									&&	(yyvsp[(2) - (5)].adrs.Sym)->Type->u.proc.returns 
											!= NULL
								)

									strcpy
									(
										returns,
										(yyvsp[(2) - (5)].adrs.Sym)->Type->u.proc.returns
									);

								_endif
							
							_endif

						_else

							yyerror
							( 
								"Illegal use of value parameter\n"
								"(Expected thunk or procedure parameter)"
							);

						_endif


					_else

						yyerror
						(
							"Cannot call code except via pass by value"
						);

					_endif

				/*
				** If it's not a parameter, see if it's a thunk here.
				*/

				_elseif
				(
						(yyvsp[(2) - (5)].adrs.pType) == tThunk
					||	(
								(yyvsp[(2) - (5)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType == tThunk
						)

				)

					call_thunk( &(yyvsp[(2) - (5)].adrs) );


				/*
				** If it's not a thunk or a parameter, see if it's a
				** procedure variable.
				*/

				_elseif
				( 
						(yyvsp[(2) - (5)].adrs.pType) == tProcptr 
					||	(
								(yyvsp[(2) - (5)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(2) - (5)].adrs.Type) )->pType == tProcptr
						)
				)

					EmitCall_m( &(yyvsp[(2) - (5)].adrs) );
						
					/*
					** Look up the "returns" value for this
					** procedure parameter.  Note: a "returns"
					** value can only exist if this procedure
					** pointer is of some user-defined type.
					*/

					_if( (yyvsp[(2) - (5)].adrs.Sym) != NULL )

						_if
						( 
								(yyvsp[(2) - (5)].adrs.Sym)->Type != NULL 
							&&	(yyvsp[(2) - (5)].adrs.Sym)->Type->u.proc.returns != NULL 
						)

							strcpy
							(
								returns,
								(yyvsp[(2) - (5)].adrs.Sym)->Type->u.proc.returns
							);

						_endif

					_endif

				_else

					yyerror( "Variable must point at a procedure or method" );

				_endif

			_else
			
				yyerror( "Must dereference pointer variable for call" );

			_endif


			SetReferenced( (yyvsp[(2) - (5)].adrs.Sym) );
			SetReferenced( (yyvsp[(3) - (5)].adrs.Sym) );
			FreeAdrs( &(yyvsp[(1) - (5)].adrs) );
			FreeAdrs( &(yyvsp[(2) - (5)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (5)].adrs) );
			(yyval.returns) = hlastrdup2( returns );
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level indirect procedure calls are illegal in low- and\n"
					"machine-level language mode."
				);
				
			_endif
			_here;
		;}
    break;

  case 1957:

/* Line 1464 of yacc.c  */
#line 82060 "hlaparse.bsn"
    { 
			_here;
			_if( (yyvsp[(-1) - (0)].adrs.Sym) == NULL )
			
				(yyval.s) = (yyvsp[(-1) - (0)].adrs.Type); 

			_else
			
				(yyval.s) = (yyvsp[(-1) - (0)].adrs.Sym); 

			_endif
		;}
    break;

  case 1958:

/* Line 1464 of yacc.c  */
#line 82076 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(0) - (0)].adrs.Sym) == NULL )
			
				(yyval.s) = (yyvsp[(0) - (0)].adrs.Type); 

			_else
			
				(yyval.s) = (yyvsp[(0) - (0)].adrs.Sym); 

			_endif
		;}
    break;

  case 1959:

/* Line 1464 of yacc.c  */
#line 82101 "hlaparse.bsn"
    {
			_here;
			(yyval.s) =	(yyvsp[(0) - (2)].s);
			_if( (yyval.s) == NULL )
			
				yyerror( "Undefined symbol or illegal parameter" );
				(yyval.s) = &error_ste;
				
			_endif
			_here;
		;}
    break;

  case 1960:

/* Line 1464 of yacc.c  */
#line 82114 "hlaparse.bsn"
    {
			_here;
			(void) (yyvsp[(3) - (5)].s);	// shut up bison
		;}
    break;

  case 1961:

/* Line 1464 of yacc.c  */
#line 82139 "hlaparse.bsn"
    {
			enum	PrimType	pType;
			SymNode_t			*s;
			SymNode_t			*typ;
			char				msg[256];
			char				name[32];

			_here;
			
			assert( (yyvsp[(0) - (2)].s) != NULL );			// Must have some symbol

			_if( (yyvsp[(0) - (2)].s)->pType == tOverloads  )
			
				pType = tOverloads;
				(yyval.s) = &dword_ste;

			_elseif( (yyvsp[(0) - (2)].s)->Type == NULL )
			
				// It must be some primitive type that is not
				// a function address.
				
				strncpy( name, (yyvsp[(0) - (2)].s)->TrueName, 31 );
				name[31] = 0;
				sprintf( msg, "Object cannot be called: '%s'", name );
				yyerror( msg );
				(yyval.s) = &dummyProc_ste;

			_else
			
			
				// Get the base type of the (proc) pointer object:

				typ = GetBaseType( (yyvsp[(0) - (2)].s)->Type );
				pType =	typ->pType;
				_if
				(
						pType == tProcptr	// Var is a procedure pointer
					||	pType == tThunk		//  ... a thunk
					||	pType == tProc		//  Could be a method
					||	pType == tMethod	//  ... pointer to a class?
					||	pType == tClassProc	//  ... pointer to a class?
					||	pType == tClassIter	//  ... pointer to a class?
					||	(
								(yyvsp[(0) - (2)].s)->SymClass == cParm	// name or lazy parm
							&&	(
										(yyvsp[(0) - (2)].s)->pClass == name_pc
									||	(yyvsp[(0) - (2)].s)->pClass == lazy_pc
								)
						)
				)
				
					(yyval.s) = typ;
				
				_else
				
					// It must be some primitive type that is not
					// a function address.
					
					strncpy( name, (yyvsp[(0) - (2)].s)->TrueName, 31 );
					name[31] = 0;
					sprintf( msg, "Object cannot be called: '%s'", name );
					yyerror( msg );
					(yyval.s) = &dummyProc_ste;

				_endif
				
			_endif	
			_here;
		;}
    break;

  case 1962:

/* Line 1464 of yacc.c  */
#line 82210 "hlaparse.bsn"
    {
			_here;
			(void) (yyvsp[(3) - (5)].s);	// shut up bison
		;}
    break;

  case 1963:

/* Line 1464 of yacc.c  */
#line 82221 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					(yyvsp[(0) - (1)].s)->u.proc.parms != NULL 
				&&	(yyvsp[(0) - (1)].s)->u.proc.parms->SymClass == cParm 
			)

				yyerror( "Too few actual parameters" );

			_endif
		;}
    break;

  case 1964:

/* Line 1464 of yacc.c  */
#line 82237 "hlaparse.bsn"
    {
			_here;
		;}
    break;

  case 1965:

/* Line 1464 of yacc.c  */
#line 82243 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(0) - (0)].s);
		;}
    break;

  case 1966:

/* Line 1464 of yacc.c  */
#line 82250 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(-6) - (0)].s);
		;}
    break;

  case 1967:

/* Line 1464 of yacc.c  */
#line 82257 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(0) - (0)].s)->pType == tArray )
			
				(yyval.s) = GetBaseType((yyvsp[(0) - (0)].s)->Type)->u.proc.parms;
				_if( (yyval.s) == NULL )
				
					(yyval.s) = (yyvsp[(0) - (0)].s)->Type->u.proc.parms;
					
				_endif
				
			_else
			
				(yyval.s) = (yyvsp[(0) - (0)].s)->u.proc.parms;
				
			_endif
			assert( (yyval.s) != NULL );
		;}
    break;

  case 1968:

/* Line 1464 of yacc.c  */
#line 82279 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.unsval) = asmBuf->offset;
		;}
    break;

  case 1969:

/* Line 1464 of yacc.c  */
#line 82287 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					(yyvsp[(-5) - (0)].s)->u.proc.cs == cdecl_cs 
				||	(yyvsp[(-5) - (0)].s)->u.proc.cs == stdcall_cs
			)
			
				(yyval.v.u.strval) = getFileStr( (yyvsp[(0) - (0)].v.u.unsval) );

			_else

				(yyval.v.u.strval) = hlastrdup2( "" );

			_endif
			_here;
		;}
    break;

  case 1970:

/* Line 1464 of yacc.c  */
#line 82311 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(0) - (2)].s) != NULL && (yyvsp[(0) - (2)].s)->SymClass != cParm )

				yyerror( "Too many actual parameters" );

			_elseif( (yyvsp[(0) - (2)].s) == NULL || (yyvsp[(0) - (2)].s)->Next->SymClass == cParm )

				yyerror( "Too few actual parameters" );

			_endif
		;}
    break;

  case 1971:

/* Line 1464 of yacc.c  */
#line 82328 "hlaparse.bsn"
    {					/* $4 */
			_here;
			(yyval.v.u.unsval) = (yyvsp[(1) - (3)].v.u.unsval);
		;}
    break;

  case 1972:

/* Line 1464 of yacc.c  */
#line 82334 "hlaparse.bsn"
    { 					/* $7 */

			assert( (yyvsp[(0) - (6)].s) != NULL );

			_here;
			_if( (yyvsp[(0) - (6)].s) == NULL || (yyvsp[(0) - (6)].s)->Next == NULL )

				yyerror( "Parameter error" );
				(yyval.s) = &true_ste;

			_elseif( (yyvsp[(0) - (6)].s)->Next->SymClass != cParm )

				yyerror( "Too many actual parameters" );
				(yyval.s) = (yyvsp[(0) - (6)].s);

			_else

				(yyval.s) = (yyvsp[(0) - (6)].s)->Next; 

			_endif
			assert( (yyval.s) != NULL );
			_here;
		;}
    break;

  case 1973:

/* Line 1464 of yacc.c  */
#line 82358 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(-1) - (8)].s) != NULL );
			_if
			( 
					(yyvsp[(-1) - (8)].s)->u.proc.cs == cdecl_cs 
				||	(yyvsp[(-1) - (8)].s)->u.proc.cs == stdcall_cs
			)

				asmPuts( (yyvsp[(5) - (8)].v.u.strval) );
				asmPuts( "\n" );

			_endif
			(void) (yyvsp[(4) - (8)].v.u.unsval);	// shut up bison
			(void) (yyvsp[(7) - (8)].s);	// shut up bison
			free2( vss (yyvsp[(5) - (8)].v.u.strval) );
			_here;
		;}
    break;

  case 1974:

/* Line 1464 of yacc.c  */
#line 82393 "hlaparse.bsn"
    {

			/*
			** If the actual parameter is a constant, the parameter
			** class *must* be a value parameter unless it's a tPointer
			** constant.
			*/

			_here;
			assert( (yyvsp[(-1) - (1)].s) != NULL );

			_if( (yyvsp[(-1) - (1)].s)->pClass == valp_pc )

				PassValpConst( (yyvsp[(-1) - (1)].s), YYS &(yyvsp[(1) - (1)].v) );

			/*
			** If the parameter was passed by reference, by value/result,
			** or by result, only pointer constants are legal.
			*/

			_elseif 
			( 
					ByAddress( (yyvsp[(-1) - (1)].s)->pClass )
				&&	(yyvsp[(1) - (1)].v.pType) == tPointer 
				
			)

				/*
				** Determine if we're passing this parameter
				** on the stack or in a register ($<s>1->StaticName
				** contains a pointer to a register name if we're
				** passing the parameter in a register).
				*/


				_if( (yyvsp[(-1) - (1)].s)->StaticName == NULL )

					_if( isdigit( *(yyvsp[(1) - (1)].v.u.strval)) )
					
						// Kludge!  NULL is treated like a
						// static name (whose static name is "0").
						// Let's undo that kludge here by creating
						// a numeric constant for zero and emitting that.
						
						int value = parsePtrExpr( (yyvsp[(1) - (1)].v.u.strval) ); 
						Pushd( value );
					
					_else
					
						push_offset( YYS &(yyvsp[(1) - (1)].v) );
						
					_endif
					
				_else // output is to register specified by $<s>-1->StaticName

					enum regnums rnum;
					struct adrsYYS adrs;
					
					rnum = RegStrToReg( (yyvsp[(-1) - (1)].s)->StaticName );
					_if( isdigit( *(yyvsp[(1) - (1)].v.u.strval) ) )
					
						// Kludge!  NULL is treated like a
						// static name (whose static name is "0").
						// Let's undo that kludge here by creating
						// a numeric constant for zero and emitting that.
						
						int value = parsePtrExpr((yyvsp[(1) - (1)].v.u.strval)); 
						EmitMov_c_r( value, rnum );
					
					_else
					
						EmitMov_o_r
						( 
							(yyvsp[(1) - (1)].v.u.strval), 
							0, 
							rnum 
						);
						
					_endif

				_endif


			/*
			** Currently, we will not allow constants to be passed
			** by name or by lazy evaluation.
			*/

			_else

				yyerror( "Constant is not allowed as parameter here" );

			_endif
			_here;
		;}
    break;

  case 1975:

/* Line 1464 of yacc.c  */
#line 82497 "hlaparse.bsn"
    {

			_here;
			assert( (yyvsp[(-1) - (2)].s) != NULL );

			_if
			( 
					!ByAddress( (yyvsp[(-1) - (2)].s)->pClass ) 
				&&	!((yyvsp[(-1) - (2)].s)->pClass == valp_pc && (yyvsp[(-1) - (2)].s)->pType == tString)
			)
			
				yyerror
				( 
					"VAL operator requires a VAR/VARRES/RESULT "
					"or STRING parameter"
				);
				
			/*
			** If the parameter was passed by reference, by value/result,
			** or by result, only pointer constants are legal.
			*/

			_elseif 
			( 
					(yyvsp[(2) - (2)].v.pType) == tPointer
				||	(
							IsNumber( (yyvsp[(2) - (2)].v.pType) )
						&&	numBits32( YYS &(yyvsp[(2) - (2)].v) ) <= 32
					)
				||	( 
							(yyvsp[(-1) - (2)].s)->pClass == valp_pc 
						&&	(yyvsp[(-1) - (2)].s)->pType == tString 
						&&	IsNumber( (yyvsp[(2) - (2)].v.pType) )
						&&	numBits32( YYS &(yyvsp[(2) - (2)].v) ) <= 32
					)
			)

				/*
				** Determine if we're passing this parameter
				** on the stack or in a register.
				*/
				
				_if( (yyvsp[(-1) - (2)].s)->StaticName == NULL )
				
					// Okay, we're passing it on the stack
					// If the parameter is just a number, then
					// push that immediate constant on the stack.
					// Otherwise, push the value of the memory object.
					

					_if( IsNumber( (yyvsp[(2) - (2)].v.pType) ))

						Pushd( (yyvsp[(2) - (2)].v.u.unsval) );
						
					_else
					
						push_offset( YYS &(yyvsp[(2) - (2)].v) );
						
					_endif
					
				_else // output is to register specified by $<s>-1->StaticName

					enum regnums rnum;
					struct adrsYYS adrs;
					
					rnum = RegStrToReg( (yyvsp[(-1) - (2)].s)->StaticName );
					_if( IsNumber( (yyvsp[(2) - (2)].v.pType) ))

						EmitMov_c_r( (yyvsp[(2) - (2)].v.u.unsval), rnum );
						
					_else
					
						EmitMov_o_r
						( 
							(yyvsp[(2) - (2)].v.u.strval), 
							0, 
							rnum 
						);
						
					_endif
					
				_endif


			/*
			** Currently, we will not allow constants to be passed
			** by name or by lazy evaluation.
			*/

			_else

				yyerror( "Constant is not allowed as parameter here" );

			_endif
			_here;

		;}
    break;

  case 1976:

/* Line 1464 of yacc.c  */
#line 82611 "hlaparse.bsn"
    {

			enum regnums srcreg;
			enum regnums destreg;
			struct adrsYYS adrs;
			
			_here;
			assert( (yyvsp[(-1) - (1)].s) != NULL );

			srcreg = (yyvsp[(1) - (1)].reg.encoding);

			_if( (yyvsp[(-1) - (1)].s)->ObjectSize != (yyvsp[(1) - (1)].reg.Size) )

				yyerror( "Register size does not match parameter size" );

			_endif
			_if( (yyvsp[(-1) - (1)].s)->pClass != valp_pc )

				yyerror( "Can only pass registers by value" );

			_endif

			/*
			** If the parameter is passed in a register, and
			** we're passing in a register, some quick checks
			** to see if we need to generate any code at all.
			*/

			_if( (yyvsp[(-1) - (1)].s)->StaticName != NULL )
			
				destreg = RegStrToReg( (yyvsp[(-1) - (1)].s)->StaticName );

				_if( srcreg != destreg )

					EmitMov_r_r( srcreg, destreg );

				/* _else // we're passing data in the same register */

				_endif

			_elseif( (yyvsp[(1) - (1)].reg.Size) == 1 )

				/*
				** If minimum parm size is four bytes, we need to
				** push three extra bytes before the data byte.
				** The following code accomplishes this using the
				** eax register, while preserving eax's original value.
				*/


				_if( srcreg == reg_al )

					push_r( reg_eax );

				_elseif( srcreg == reg_bl )

					push_r( reg_ebx );

				_elseif( srcreg == reg_cl )

					push_r( reg_ecx );

				_elseif( srcreg == reg_dl )

					push_r( reg_edx );

				_else

					// "xH" registers have to be moved onto the stack:
					
					EmitGeneric_c_r( sub_instr, 4, reg_esp );
					initAdrs1( &adrs, reg_esp, 0 );
					EmitMov_r_m( srcreg, &adrs, 1 );

				_endif

				
			_elseif( (yyvsp[(1) - (1)].reg.Size) == 2 )


				_if( srcreg == reg_ax )

					push_r( reg_eax );

				_elseif( srcreg == reg_bx )

					push_r( reg_ebx );

				_elseif( srcreg == reg_cx )

					push_r( reg_ecx );

				_elseif( srcreg == reg_dx )

					push_r( reg_edx );

				_elseif( srcreg == reg_si )

					push_r( reg_esi );

				_elseif( srcreg == reg_di )

					push_r( reg_edi );

				_elseif( srcreg == reg_bp )

					push_r( reg_ebp );

				_elseif( srcreg == reg_sp )

					push_r( reg_esp );

				_endif
			
			_else // Must be a 32-bit register.
			
				push_r( srcreg );
			
			_endif 
			_here;
		;}
    break;

  case 1977:

/* Line 1464 of yacc.c  */
#line 82737 "hlaparse.bsn"
    {

			
			_here;
			assert( (yyvsp[(-1) - (1)].s) != NULL );
			_if( (yyvsp[(-1) - (1)].s)->ObjectSize != 8 )

				yyerror( "Register size does not match parameter size" );

			_endif
			_if( (yyvsp[(-1) - (1)].s)->pClass != valp_pc )

				yyerror( "Can only pass registers by value" );

			_endif

			
			push_r( reg_edx );
			push_r( reg_eax );
			_here;
		;}
    break;

  case 1978:

/* Line 1464 of yacc.c  */
#line 82765 "hlaparse.bsn"
    {

			
			_here;
			assert( (yyvsp[(-1) - (1)].s) != NULL );
			_if( (yyvsp[(-1) - (1)].s)->ObjectSize != 4 )

				yyerror( "Register size does not match parameter size" );

			_endif
			_if( (yyvsp[(-1) - (1)].s)->pClass != valp_pc )

				yyerror( "Can only pass registers by value" );

			_endif

			
			push_r( reg_dx );
			push_r( reg_ax );
			_here;
		;}
    break;

  case 1979:

/* Line 1464 of yacc.c  */
#line 82796 "hlaparse.bsn"
    {
			enum regnums srcreg;
			enum regnums destreg;

			_here;
			assert( (yyvsp[(-1) - (2)].s) != NULL );

			srcreg = (yyvsp[(2) - (2)].reg.encoding);
			
			_if( (yyvsp[(2) - (2)].reg.Size) != 4 )

				yyerror( "Must be a 32-bit register with VAL prefix" );

			_elseif
			( 
					!ByAddress( (yyvsp[(-1) - (2)].s)->pClass ) 
				&&	!((yyvsp[(-1) - (2)].s)->pClass == valp_pc && (yyvsp[(-1) - (2)].s)->pType == tString)
			)

				yyerror
				( 
					"VAL prefix is only legal with "
					"VAR/RESULT/VARRES/STRING parameters" 
				);

			_else

				/*
				** If the parameter is passed in a register, and
				** we're passing in a register, some quick checks
				** to see if we need to generate any code at all.
				*/

				_if( (yyvsp[(-1) - (2)].s)->StaticName != NULL )

					_if
					( 
						_strne
						( 
							(yyvsp[(-1) - (2)].s)->StaticName, 
							regStrs[ (yyvsp[(2) - (2)].reg.encoding)]
						)
					)

						destreg = RegStrToReg( (yyvsp[(-1) - (2)].s)->StaticName );
						EmitMov_r_r( srcreg, destreg );

					/* _else // we're passing data in the same register */

					_endif

				_else // Must be a 32-bit register.
				
					push_r( srcreg );
				
				_endif 
				
			_endif
			_here;
		;}
    break;

  case 1980:

/* Line 1464 of yacc.c  */
#line 82871 "hlaparse.bsn"
    {
			_here;
			
			_if( (yyvsp[(-1) - (1)].s) != NULL && (yyvsp[(-2) - (1)].s) != NULL )
			
				OutputMemParm( (yyvsp[(-2) - (1)].s), (yyvsp[(-1) - (1)].s), &(yyvsp[(1) - (1)].adrs), 0 );
				
			_else
			
				yyerror( "Illegal parameter value" );
				
			_endif
			FreeAdrs( &(yyvsp[(1) - (1)].adrs) );
			_here;
		;}
    break;

  case 1981:

/* Line 1464 of yacc.c  */
#line 82896 "hlaparse.bsn"
    {
			_here;
			assert( (yyvsp[(-1) - (2)].s) != NULL );
			OutputMemParm( (yyvsp[(-2) - (2)].s), (yyvsp[(-1) - (2)].s), &(yyvsp[(2) - (2)].adrs), 1 );
			FreeAdrs( &(yyvsp[(2) - (2)].adrs) );
			_here;
		;}
    break;

  case 1982:

/* Line 1464 of yacc.c  */
#line 82911 "hlaparse.bsn"
    {
			int ASize0;

			_here;
			assert( (yyvsp[(-1) - (1)].s) != NULL );

			(yyvsp[(1) - (1)].adrs.Size) = 
				_ifx
				( 
					(yyvsp[(-1) - (1)].s)->Arity == 0, 
					(yyvsp[(-1) - (1)].s)->ObjectSize, 
					(yyvsp[(-1) - (1)].s)->Type->ObjectSize 
				);
			(yyvsp[(1) - (1)].adrs.ObjectSize) = (yyvsp[(-1) - (1)].s)->ObjectSize;
			(yyvsp[(1) - (1)].adrs.Type) = (yyvsp[(-1) - (1)].s)->Type;
			(yyvsp[(1) - (1)].adrs.pType) = (yyvsp[(-1) - (1)].s)->pType;
			(yyvsp[(1) - (1)].adrs.SymClass) = (yyvsp[(-1) - (1)].s)->SymClass;
			(yyvsp[(1) - (1)].adrs.forcedSize) = (yyvsp[(1) - (1)].adrs.Size);
			OutputMemParm( (yyvsp[(-2) - (1)].s), (yyvsp[(-1) - (1)].s), &(yyvsp[(1) - (1)].adrs), 0 );
			FreeAdrs( &(yyvsp[(1) - (1)].adrs) );
			_here;
		;}
    break;

  case 1983:

/* Line 1464 of yacc.c  */
#line 82941 "hlaparse.bsn"
    {
			int ASize0;

			_here;
			assert( (yyvsp[(-1) - (2)].s) != NULL );

			(yyvsp[(2) - (2)].adrs.Size) = 
				_ifx
				( 
					(yyvsp[(-1) - (2)].s)->Arity == 0, 
					(yyvsp[(-1) - (2)].s)->ObjectSize, 
					(yyvsp[(-1) - (2)].s)->Type->ObjectSize 
				);
			(yyvsp[(2) - (2)].adrs.ObjectSize) = (yyvsp[(-1) - (2)].s)->ObjectSize;
			(yyvsp[(2) - (2)].adrs.Type) = (yyvsp[(-1) - (2)].s)->Type;
			(yyvsp[(2) - (2)].adrs.pType) = (yyvsp[(-1) - (2)].s)->pType;
			(yyvsp[(2) - (2)].adrs.SymClass) = (yyvsp[(-1) - (2)].s)->SymClass;
			(yyvsp[(2) - (2)].adrs.forcedSize) = (yyvsp[(2) - (2)].adrs.Size);
			OutputMemParm( (yyvsp[(-2) - (2)].s), (yyvsp[(-1) - (2)].s), &(yyvsp[(2) - (2)].adrs), 1 );
			FreeAdrs( &(yyvsp[(2) - (2)].adrs) );
			_here;
		;}
    break;

  case 1984:

/* Line 1464 of yacc.c  */
#line 82977 "hlaparse.bsn"
    {
			char thunkname[ 256 ];

			_here;
			assert( (yyvsp[(-1) - (5)].s) != NULL );

			sprintf( thunkname, "thunk_%u" sympost, (yyvsp[(2) - (5)].v.u.unsval) );
			pop_r( reg_ebp );
			ret_instr( 4 );
			EndProc( thunkname );
			{
				char lbl[ 256 ];
				
				sprintf( lbl, "endthunk_%u" sympost, (yyvsp[(2) - (5)].v.u.unsval) );
				EmitStmtLbl( lbl );
			}

			/*
			** Okay, now that we've processed this thunk, let's
			** make sure it's legal to have a thunk here.
			*/

			_if
			( 
					(yyvsp[(-1) - (5)].s)->pClass != name_pc 
				&&	(yyvsp[(-1) - (5)].s)->pClass != lazy_pc 
				&&  !(
							(yyvsp[(-1) - (5)].s)->pClass == valp_pc
						&&	(yyvsp[(-1) - (5)].s)->pType == tThunk
					)

			)

				yyerror
				( 
					"Thunks are only allowed for pass by name\n"
					"and pass by lazy evaluation parameters"
				);

			_endif

			inThunk = (yyvsp[(1) - (5)].v.u.unsval);
			_here;
		;}
    break;

  case 1985:

/* Line 1464 of yacc.c  */
#line 83026 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.unsval) = inThunk;
			inThunk = 1;
		;}
    break;

  case 1986:

/* Line 1464 of yacc.c  */
#line 83035 "hlaparse.bsn"
    {
			int ThunkNum;
			char tempProc[ 256 ];
			char procname[ 256 ];
			struct adrsYYS adrs;

			_here;
			ThunkNum = LblCntr++;
			
			sprintf( procname, "thunk_%d" sympost, ThunkNum );
			PushStaticAdrs( procname );
			push_r( reg_ebp );

			sprintf( procname, "endthunk_%d" sympost, ThunkNum );
			EmitJmpLabel( procname );
			  
			NewLn();
			sprintf( procname, "thunk_%d" sympost, ThunkNum );
			EmitComment( "thunk begins here" );
			StartProc( procname );
			push_r( reg_ebp );
			initAdrs( &adrs, reg_esp, -1, 0, 8 ); 
			EmitMov_m_r( &adrs, reg_ebp, 4 );
			(yyval.v.u.intval) = ThunkNum;
			_here;
		;}
    break;

  case 1987:

/* Line 1464 of yacc.c  */
#line 83075 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.v.u.unsval) = StartOfStmt;
		;}
    break;

  case 1988:

/* Line 1464 of yacc.c  */
#line 83081 "hlaparse.bsn"
    {				/* $5 */
			_here;
			_if( (yyvsp[(3) - (4)].returns) != NULL )

				free2( vss (yyvsp[(3) - (4)].returns) );

			_endif
			StartOfStmt = (yyvsp[(2) - (4)].v.u.unsval);
			_here;
		;}
    break;

  case 1989:

/* Line 1464 of yacc.c  */
#line 83124 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 1990:

/* Line 1464 of yacc.c  */
#line 83132 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(2) - (2)].s);
			SetReferenced( (yyvsp[(2) - (2)].s) );
		;}
    break;

  case 1991:

/* Line 1464 of yacc.c  */
#line 83139 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 1992:

/* Line 1464 of yacc.c  */
#line 83147 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(2) - (2)].s);
			SetReferenced( (yyvsp[(2) - (2)].s) );
		;}
    break;

  case 1993:

/* Line 1464 of yacc.c  */
#line 83155 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 1994:

/* Line 1464 of yacc.c  */
#line 83163 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(2) - (2)].s);
			SetReferenced( (yyvsp[(2) - (2)].s) );
		;}
    break;

  case 1995:

/* Line 1464 of yacc.c  */
#line 83170 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );

		;}
    break;

  case 1996:

/* Line 1464 of yacc.c  */
#line 83179 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(2) - (2)].s);
			SetReferenced( (yyvsp[(2) - (2)].s) );
		;}
    break;

  case 1997:

/* Line 1464 of yacc.c  */
#line 83187 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 1998:

/* Line 1464 of yacc.c  */
#line 83195 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(2) - (2)].s);
			SetReferenced( (yyvsp[(2) - (2)].s) );
		;}
    break;

  case 1999:

/* Line 1464 of yacc.c  */
#line 83204 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2000:

/* Line 1464 of yacc.c  */
#line 83211 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2001:

/* Line 1464 of yacc.c  */
#line 83218 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2002:

/* Line 1464 of yacc.c  */
#line 83225 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2003:

/* Line 1464 of yacc.c  */
#line 83233 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2004:

/* Line 1464 of yacc.c  */
#line 83240 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2005:

/* Line 1464 of yacc.c  */
#line 83247 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2006:

/* Line 1464 of yacc.c  */
#line 83257 "hlaparse.bsn"
    {			  
			_here;
			(yyval.idStr) = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
		;}
    break;

  case 2007:

/* Line 1464 of yacc.c  */
#line 83263 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) =  hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
		;}
    break;

  case 2008:

/* Line 1464 of yacc.c  */
#line 83269 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) =  hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
		;}
    break;

  case 2009:

/* Line 1464 of yacc.c  */
#line 83275 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(1) - (1)].idStr);
		;}
    break;

  case 2010:

/* Line 1464 of yacc.c  */
#line 83281 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) =  hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
		;}
    break;

  case 2011:

/* Line 1464 of yacc.c  */
#line 83294 "hlaparse.bsn"
    {
			_here;
			callUndefSym( (yyvsp[(1) - (1)].idStr) );
			free2( vss (yyvsp[(1) - (1)].idStr) );
		;}
    break;

  case 2012:

/* Line 1464 of yacc.c  */
#line 83311 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2013:

/* Line 1464 of yacc.c  */
#line 83323 "hlaparse.bsn"
    {
			_here;
			EmitCallLabel( (yyvsp[(2) - (2)].s)->StaticName );
			SetReferenced( (yyvsp[(2) - (2)].s) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2014:

/* Line 1464 of yacc.c  */
#line 83337 "hlaparse.bsn"
    {
			_here;
			EmitCallLabel( (yyvsp[(3) - (4)].s)->StaticName );
			SetReferenced( (yyvsp[(3) - (4)].s) );
			(yyval.returns) = hlastrdup2( (yyvsp[(3) - (4)].s)->u.proc.returns );
		;}
    break;

  case 2015:

/* Line 1464 of yacc.c  */
#line 83351 "hlaparse.bsn"
    {
			char label[64];
			
			_here;
			sprintf( label, "here" sympost "%d", LblCntr++ );
			EmitStmtLbl( label );
			EmitCallLabel( label );
			PushBackStr( ";" );
			(yyval.returns) = NULL;
		;}
    break;

  case 2016:

/* Line 1464 of yacc.c  */
#line 83370 "hlaparse.bsn"
    {
			int  disp;
			char label[64];
			
			_here;
			disp = CheckOrdinalSize( YYS &(yyvsp[(4) - (5)].v), 32 );
			sprintf( label, "here" sympost "%d", LblCntr );
			EmitStmtLbl( label );
			sprintf
			( 
				label, 
				"(here" sympost "%d%s%d)" , 
				LblCntr++, 
				_ifx( disp < 0, "", "+"),
				disp 
			);
			EmitCallLabel( label );
			(yyval.returns) = NULL;
		;}
    break;

  case 2017:

/* Line 1464 of yacc.c  */
#line 83402 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) != 4 && (yyvsp[(3) - (4)].adrs.Size) != 0 )

				yyerror( "Procedure pointer must be four bytes long" );

			_else

				EmitCall_m( &(yyvsp[(3) - (4)].adrs) );

			_endif
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = NULL;

		;}
    break;

  case 2018:

/* Line 1464 of yacc.c  */
#line 83430 "hlaparse.bsn"
    {
			_here;
			EmitCall_r( (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = NULL;
		;}
    break;

  case 2020:

/* Line 1464 of yacc.c  */
#line 83467 "hlaparse.bsn"
    {
			/*
			** Note: productions following this one will expect
			** the semicolon, so put it back.
			*/

			_here;
			PushBackStr( ";" );
		;}
    break;

  case 2021:

/* Line 1464 of yacc.c  */
#line 83487 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "ax" );
			implied_instr( aaa_instr );
		;}
    break;

  case 2022:

/* Line 1464 of yacc.c  */
#line 83495 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "ax" );
			implied_instr( aad_instr );
		;}
    break;

  case 2023:

/* Line 1464 of yacc.c  */
#line 83503 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "ax" );
			implied_instr( aam_instr );
		;}
    break;

  case 2024:

/* Line 1464 of yacc.c  */
#line 83511 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "ax" );
			implied_instr( aas_instr );
		;}
    break;

  case 2025:

/* Line 1464 of yacc.c  */
#line 83520 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "ax" );
			implied_instr( cbw_instr );
		;}
    break;

  case 2026:

/* Line 1464 of yacc.c  */
#line 83529 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "eax" );
			implied_instr( cdq_instr );
		;}
    break;

  case 2027:

/* Line 1464 of yacc.c  */
#line 83538 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( clc_instr );
		;}
    break;

  case 2028:

/* Line 1464 of yacc.c  */
#line 83547 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( cld_instr );
		;}
    break;

  case 2029:

/* Line 1464 of yacc.c  */
#line 83556 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( cli_instr );
		;}
    break;

  case 2030:

/* Line 1464 of yacc.c  */
#line 83565 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( clts_instr );
		;}
    break;

  case 2031:

/* Line 1464 of yacc.c  */
#line 83574 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( cmc_instr );
		;}
    break;

  case 2032:

/* Line 1464 of yacc.c  */
#line 83583 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "ax" );
			implied_instr( cpuid_instr );
		;}
    break;

  case 2033:

/* Line 1464 of yacc.c  */
#line 83592 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "ax" );
			implied_instr( cwd_instr );
		;}
    break;

  case 2034:

/* Line 1464 of yacc.c  */
#line 83601 "hlaparse.bsn"
    { 
			_here; 	
			(yyval.returns) = hlastrdup2( "eax" );
			implied_instr( cwde_instr );
		;}
    break;

  case 2035:

/* Line 1464 of yacc.c  */
#line 83610 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "al" );
			implied_instr( daa_instr );
		;}
    break;

  case 2036:

/* Line 1464 of yacc.c  */
#line 83618 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "al" );
			implied_instr( das_instr );
		;}
    break;

  case 2037:

/* Line 1464 of yacc.c  */
#line 83626 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( hlt_instr );
		;}
    break;

  case 2038:

/* Line 1464 of yacc.c  */
#line 83634 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			_if( CompileInto )

				implied_instr( into_instr );

			_endif
		;}
    break;

  case 2039:

/* Line 1464 of yacc.c  */
#line 83646 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( invd_instr );
		;}
    break;

  case 2040:

/* Line 1464 of yacc.c  */
#line 83654 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( iret_instr );
		;}
    break;

  case 2041:

/* Line 1464 of yacc.c  */
#line 83662 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( iretd_instr );
		;}
    break;

  case 2042:

/* Line 1464 of yacc.c  */
#line 83670 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "al" );
			implied_instr( lahf_instr );
		;}
    break;

  case 2043:

/* Line 1464 of yacc.c  */
#line 83678 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( leave_instr );
		;}
    break;

  case 2044:

/* Line 1464 of yacc.c  */
#line 83686 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( nop_instr );
		;}
    break;

  case 2045:

/* Line 1464 of yacc.c  */
#line 83694 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			popad();
		;}
    break;

  case 2046:

/* Line 1464 of yacc.c  */
#line 83702 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			popaw();
		;}
    break;

  case 2047:

/* Line 1464 of yacc.c  */
#line 83710 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			popf();
		;}
    break;

  case 2048:

/* Line 1464 of yacc.c  */
#line 83718 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			popfd();
		;}
    break;

  case 2049:

/* Line 1464 of yacc.c  */
#line 83726 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( pusha_instr );
		;}
    break;

  case 2050:

/* Line 1464 of yacc.c  */
#line 83734 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( pushad_instr );
		;}
    break;

  case 2051:

/* Line 1464 of yacc.c  */
#line 83742 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			pushf();
		;}
    break;

  case 2052:

/* Line 1464 of yacc.c  */
#line 83750 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			pushfd();
		;}
    break;

  case 2053:

/* Line 1464 of yacc.c  */
#line 83758 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "edx:eax" );
			implied_instr( rdtsc_instr );
		;}
    break;

  case 2054:

/* Line 1464 of yacc.c  */
#line 83766 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = NULL;
			implied_instr( sysenter_instr );
		;}
    break;

  case 2055:

/* Line 1464 of yacc.c  */
#line 83774 "hlaparse.bsn"
    {
			_here;
			(yyval.returns) = NULL;
			implied_instr( sysexit_instr );
		;}
    break;

  case 2056:

/* Line 1464 of yacc.c  */
#line 83783 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( ud2_instr );
		;}
    break;

  case 2057:

/* Line 1464 of yacc.c  */
#line 83792 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( wbinvd_instr );
		;}
    break;

  case 2058:

/* Line 1464 of yacc.c  */
#line 83801 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( wrmsr_instr );
		;}
    break;

  case 2059:

/* Line 1464 of yacc.c  */
#line 83810 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "edx:eax" );
			implied_instr( rdmsr_instr );
		;}
    break;

  case 2060:

/* Line 1464 of yacc.c  */
#line 83818 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "edx:eax" );
			implied_instr( rdpmc_instr );
		;}
    break;

  case 2061:

/* Line 1464 of yacc.c  */
#line 83826 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( rsm_instr );
		;}
    break;

  case 2062:

/* Line 1464 of yacc.c  */
#line 83834 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "ah" );
			implied_instr( sahf_instr );
		;}
    break;

  case 2063:

/* Line 1464 of yacc.c  */
#line 83842 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( stc_instr );
		;}
    break;

  case 2064:

/* Line 1464 of yacc.c  */
#line 83850 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( std_instr );
		;}
    break;

  case 2065:

/* Line 1464 of yacc.c  */
#line 83858 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( sti_instr );
		;}
    break;

  case 2066:

/* Line 1464 of yacc.c  */
#line 83866 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( wait_instr );
		;}
    break;

  case 2067:

/* Line 1464 of yacc.c  */
#line 83874 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
			implied_instr( xlat_instr );
		;}
    break;

  case 2068:

/* Line 1464 of yacc.c  */
#line 83909 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].reg.Size) == 1 )

				yyerror( "Eight-bit register is illegal here" );

			_endif
			pop_r( (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (4)].reg.encoding) ]);
		;}
    break;

  case 2069:

/* Line 1464 of yacc.c  */
#line 83925 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].u) == reg_cseg )

				yyerror( "Cannot pop CS register" );

			_endif
			pop_sr( (yyvsp[(3) - (4)].u) );
			(yyval.returns) = hlastrdup2( segStrs[ (yyvsp[(3) - (4)].u) ]);
		;}
    break;

  case 2070:

/* Line 1464 of yacc.c  */
#line 83941 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) == 2 || (yyvsp[(3) - (4)].adrs.Size) == 4 )

				pop_mem( &(yyvsp[(3) - (4)].adrs), (yyvsp[(3) - (4)].adrs.Size) );

			_else

				yyerror( SizeMismatchStr );

			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
		;}
    break;

  case 2071:

/* Line 1464 of yacc.c  */
#line 83991 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].reg.Size) != 2 )

				yyerror( "Illegal register size" );

			_endif
			push_r( (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (4)].reg.encoding) ]);
		;}
    break;

  case 2072:

/* Line 1464 of yacc.c  */
#line 84009 "hlaparse.bsn"
    {
			char adrs[ 256 ];

			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) == 2 )

				push_mem( &(yyvsp[(3) - (4)].adrs), 2 );

			_else

				yyerror( SizeMismatchStr );

			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
		;}
    break;

  case 2073:

/* Line 1464 of yacc.c  */
#line 84034 "hlaparse.bsn"
    {
			char *Result;

			_here;
			Result = CheckOrdinal( YYS &(yyvsp[(3) - (4)].v), 16 );
			Pushw( (yyvsp[(3) - (4)].v.u.unsval) );
			(yyval.returns) = Result;
		;}
    break;

  case 2074:

/* Line 1464 of yacc.c  */
#line 84053 "hlaparse.bsn"
    {
			char adrs[ 256 ];
			char mem[ 256 ];

			_here;
			push_mem( &(yyvsp[(3) - (4)].adrs), 2 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2075:

/* Line 1464 of yacc.c  */
#line 84079 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].reg.Size) != 4 )

				yyerror( "Illegal register size" );

			_endif
			push_r( (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (4)].reg.encoding) ]);
		;}
    break;

  case 2076:

/* Line 1464 of yacc.c  */
#line 84097 "hlaparse.bsn"
    {
			char as[ 256 ];
			char mem[ 256 ];

			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) == 4 )

				push_mem( &(yyvsp[(3) - (4)].adrs), 4 );

			_else

				yyerror( SizeMismatchStr );

			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
		;}
    break;

  case 2077:

/* Line 1464 of yacc.c  */
#line 84125 "hlaparse.bsn"
    {
			char *Result;

			_here;
			_if( (yyvsp[(3) - (4)].v.pType) == tPointer )

				_if( isdigit( *(yyvsp[(3) - (4)].v.u.strval) ))
				
					int value = parsePtrExpr( (yyvsp[(3) - (4)].v.u.strval) );
					
					Result = hlastrdup2( (yyvsp[(3) - (4)].v.u.strval) );
					Pushd( value );
					
				_else
				
					push_offset( YYS &(yyvsp[(3) - (4)].v) );
					Result = hlastrdup2( "" );		// This is bogus
													// and needs to be fixed.
													
				_endif

			_else

				Result = CheckOrdinal( YYS &(yyvsp[(3) - (4)].v), 32 );
				Pushd( (yyvsp[(3) - (4)].v.u.unsval) );

			_endif
			(yyval.returns) = Result;
		;}
    break;

  case 2078:

/* Line 1464 of yacc.c  */
#line 84166 "hlaparse.bsn"
    {
			char adrs[ 256 ];
			char mem[ 256 ];

			_here;
			push_mem( &(yyvsp[(3) - (4)].adrs), 4 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2079:

/* Line 1464 of yacc.c  */
#line 84197 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].reg.Size) == 1 )

				yyerror( "Illegal register size" );

			_endif
			push_r( (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (4)].reg.encoding) ]);
		;}
    break;

  case 2080:

/* Line 1464 of yacc.c  */
#line 84218 "hlaparse.bsn"
    {
			_here;
			push_r( reg_edx );
			push_r( reg_eax );
			(yyval.returns) = hlastrdup2( "edx:eax" );
		;}
    break;

  case 2081:

/* Line 1464 of yacc.c  */
#line 84234 "hlaparse.bsn"
    {
			_here;
			push_r( reg_edx );
			push_r( reg_eax );
			(yyval.returns) = hlastrdup2( "edx:eax" );
		;}
    break;

  case 2082:

/* Line 1464 of yacc.c  */
#line 84250 "hlaparse.bsn"
    {
			_here;
			push_r( reg_dx );
			push_r( reg_ax );
			(yyval.returns) = hlastrdup2( "dx:ax" );
		;}
    break;

  case 2083:

/* Line 1464 of yacc.c  */
#line 84266 "hlaparse.bsn"
    {
			_here;
			push_r( reg_dx );
			push_r( reg_ax );
			(yyval.returns) = hlastrdup2( "dx:ax" );
		;}
    break;

  case 2084:

/* Line 1464 of yacc.c  */
#line 84283 "hlaparse.bsn"
    {
			_here;
			push_sr( (yyvsp[(3) - (4)].u) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (4)].u) ]);
		;}
    break;

  case 2085:

/* Line 1464 of yacc.c  */
#line 84299 "hlaparse.bsn"
    {
			char adrs[ 256 ];

			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) == 2 || (yyvsp[(3) - (4)].adrs.Size) == 4 )

				push_mem( &(yyvsp[(3) - (4)].adrs), (yyvsp[(3) - (4)].adrs.Size) );

			_else

				yyerror( SizeMismatchStr );

			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
		;}
    break;

  case 2086:

/* Line 1464 of yacc.c  */
#line 84338 "hlaparse.bsn"
    {
			char msg[256];

			sprintf( msg, "Undefined ID: %s", (yyvsp[(3) - (4)].idStr) );
			yyerror( msg );
			(yyval.returns) = hlastrdup2( (yyvsp[(3) - (4)].idStr) );
		;}
    break;

  case 2087:

/* Line 1464 of yacc.c  */
#line 84350 "hlaparse.bsn"
    {
			yyerror( "Must specify memory size" );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
		;}
    break;

  case 2088:

/* Line 1464 of yacc.c  */
#line 84377 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = (yyvsp[(1) - (1)].u);
		;}
    break;

  case 2089:

/* Line 1464 of yacc.c  */
#line 84383 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = (yyvsp[(1) - (1)].u);
		;}
    break;

  case 2090:

/* Line 1464 of yacc.c  */
#line 84391 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st0;
		;}
    break;

  case 2091:

/* Line 1464 of yacc.c  */
#line 84398 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st0;
		;}
    break;

  case 2092:

/* Line 1464 of yacc.c  */
#line 84406 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st1;
		;}
    break;

  case 2093:

/* Line 1464 of yacc.c  */
#line 84412 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st2;
		;}
    break;

  case 2094:

/* Line 1464 of yacc.c  */
#line 84418 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st3;
		;}
    break;

  case 2095:

/* Line 1464 of yacc.c  */
#line 84424 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st4;
		;}
    break;

  case 2096:

/* Line 1464 of yacc.c  */
#line 84430 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st5;
		;}
    break;

  case 2097:

/* Line 1464 of yacc.c  */
#line 84436 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st6;
		;}
    break;

  case 2098:

/* Line 1464 of yacc.c  */
#line 84442 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st7;
		;}
    break;

  case 2099:

/* Line 1464 of yacc.c  */
#line 84449 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st1;
		;}
    break;

  case 2100:

/* Line 1464 of yacc.c  */
#line 84456 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st2;
		;}
    break;

  case 2101:

/* Line 1464 of yacc.c  */
#line 84463 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st3;
		;}
    break;

  case 2102:

/* Line 1464 of yacc.c  */
#line 84470 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st4;
		;}
    break;

  case 2103:

/* Line 1464 of yacc.c  */
#line 84477 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st5;
		;}
    break;

  case 2104:

/* Line 1464 of yacc.c  */
#line 84484 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st6;
		;}
    break;

  case 2105:

/* Line 1464 of yacc.c  */
#line 84491 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = reg_st7;
		;}
    break;

  case 2106:

/* Line 1464 of yacc.c  */
#line 84511 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fadd_instr;
			_here;
		;}
    break;

  case 2107:

/* Line 1464 of yacc.c  */
#line 84519 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fmul_instr;
			_here;
		;}
    break;

  case 2108:

/* Line 1464 of yacc.c  */
#line 84527 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fcom_instr;
			_here;
		;}
    break;

  case 2109:

/* Line 1464 of yacc.c  */
#line 84535 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fcomp_instr;
			_here;
		;}
    break;

  case 2110:

/* Line 1464 of yacc.c  */
#line 84543 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fsubr_instr;
			_here;
		;}
    break;

  case 2111:

/* Line 1464 of yacc.c  */
#line 84551 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fsub_instr;
			_here;
		;}
    break;

  case 2112:

/* Line 1464 of yacc.c  */
#line 84559 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fdivr_instr;
			_here;
		;}
    break;

  case 2113:

/* Line 1464 of yacc.c  */
#line 84567 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fdiv_instr;
			_here;
		;}
    break;

  case 2114:

/* Line 1464 of yacc.c  */
#line 84579 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = faddp_instr;
			_here;
		;}
    break;

  case 2115:

/* Line 1464 of yacc.c  */
#line 84587 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fmulp_instr;
			_here;
		;}
    break;

  case 2116:

/* Line 1464 of yacc.c  */
#line 84595 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fcompp_instr;
			_here;
		;}
    break;

  case 2117:

/* Line 1464 of yacc.c  */
#line 84603 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fsubrp_instr;
			_here;
		;}
    break;

  case 2118:

/* Line 1464 of yacc.c  */
#line 84611 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fsubp_instr;
			_here;
		;}
    break;

  case 2119:

/* Line 1464 of yacc.c  */
#line 84619 "hlaparse.bsn"
    {			/* $4 */

			_here;
			(yyval.u) = fdivrp_instr;
			_here;
		;}
    break;

  case 2120:

/* Line 1464 of yacc.c  */
#line 84627 "hlaparse.bsn"
    {			/* $4 */

			_here;
			(yyval.u) = fdivp_instr;
			_here;
		;}
    break;

  case 2121:

/* Line 1464 of yacc.c  */
#line 84644 "hlaparse.bsn"
    {					/* $3 */

			_here;
			fp_arith_noOp_instr( (yyvsp[(1) - (2)].u) );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2122:

/* Line 1464 of yacc.c  */
#line 84659 "hlaparse.bsn"
    {					/* $3 */

			_here;

			// Must translate fXXX instruction to fXXXp instruction!
			
			fpp_arith_noOp_instr( (yyvsp[(1) - (2)].u) );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2123:

/* Line 1464 of yacc.c  */
#line 84684 "hlaparse.bsn"
    {					/* $7 */

			_here;
			
			// fcom and fcomp have reversed operand ordering.
			// The CPU doesn't support xxx( st0, sti ) instructions,
			// so don't allow that here.
			
			_if( (yyvsp[(1) - (6)].u) == fcom_instr || (yyvsp[(1) - (6)].u) == fcomp_instr )
			
				yyerror( "fcom and fcomp do not allow 'ST0, STi' operands" );
				
			_endif
			
			fp_arith_sti_st0_instr( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u) );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2124:

/* Line 1464 of yacc.c  */
#line 84716 "hlaparse.bsn"
    {					/* $7 */

			char stirtn[4] = "st0";
			_here;
			
			fp_arith_st0_sti_instr( (yyvsp[(1) - (6)].u), (yyvsp[(5) - (6)].u) );

			stirtn[2] |= ((yyvsp[(5) - (6)].u) & 0x7);
			(yyval.returns) = hlastrdup2( stirtn );
			_here;
		;}
    break;

  case 2125:

/* Line 1464 of yacc.c  */
#line 84736 "hlaparse.bsn"
    {					/* $7 */

			char stirtn[4] = "st0";
			_here;
			
			_if( (yyvsp[(1) - (6)].u) == fcompp_instr && (yyvsp[(5) - (6)].u) != reg_st1 )
			
				yyerror( "fcompp only allows '( st0, st1') operands" );
				(yyvsp[(5) - (6)].u) = reg_st1;
				
			_endif
			fpp_arith_st0_sti_instr( (yyvsp[(1) - (6)].u), (yyvsp[(5) - (6)].u) );
			stirtn[2] |= ((yyvsp[(5) - (6)].u) & 0x7);
			(yyval.returns) = hlastrdup2( stirtn );
			_here;
		;}
    break;

  case 2126:

/* Line 1464 of yacc.c  */
#line 84761 "hlaparse.bsn"
    {					/* $5 */

			char stirtn[4] = "st0";
			_here;
			
			fp_arith_st0_sti_instr( (yyvsp[(1) - (4)].u), (yyvsp[(3) - (4)].u) );
			stirtn[2] |= ((yyvsp[(3) - (4)].u) & 0x7);
			(yyval.returns) = hlastrdup2( stirtn );
			_here;
		;}
    break;

  case 2127:

/* Line 1464 of yacc.c  */
#line 84780 "hlaparse.bsn"
    {					/* $5 */

			char stirtn[4] = "st0";
			_here;
			
			// Convert from fXXX instr to fXXXp instr!
			
			fpp_arith_st0_sti_instr( fp_fpp_xlat[(yyvsp[(1) - (4)].u)], (yyvsp[(3) - (4)].u) );
			stirtn[2] |= ((yyvsp[(3) - (4)].u) & 0x7);
			(yyval.returns) = hlastrdup2( stirtn );
			_here;
		;}
    break;

  case 2128:

/* Line 1464 of yacc.c  */
#line 84805 "hlaparse.bsn"
    {					/* $5 */

			_here;
			
			fp_arith_mem_instr( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2129:

/* Line 1464 of yacc.c  */
#line 84827 "hlaparse.bsn"
    {					/* $5 */

			struct adrsYYS adrs;
			char name [ 256 ];

			_here;
			_if( IsReal( (yyvsp[(3) - (4)].v.pType) ))
				
				// Extend real32 and real64 constants to real80
				// (always compatible, so just ignore return result):
				
				IsCompatible( &real80_ste, YYS &(yyvsp[(3) - (4)].v) );

				sprintf( name, "fpconst" sympost "%d", LblCntr++ );
				startStrSeg();
				OutValue( name, &real64_ste, YYS &(yyvsp[(3) - (4)].v) );
				endStrSeg();
				
				initAdrs( &adrs, -1, -1, 0, 0 );
				adrs.StaticName = hlastrdup( name );
				adrs.Size = 8;
				fp_arith_mem_instr( (yyvsp[(1) - (4)].u), &adrs );
				FreeValue( YYS &(yyvsp[(3) - (4)].v) );
				
			_else
			
				yyerror( "FP instructions require real constant operands" );
				
			_endif
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2130:

/* Line 1464 of yacc.c  */
#line 84872 "hlaparse.bsn"
    {					/* $5 */

			_here;
			
			fpi_arith_mem_instr( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2131:

/* Line 1464 of yacc.c  */
#line 84891 "hlaparse.bsn"
    {					/* $5 */

			char			*operand;
			struct	adrsYYS adrs;
			char			label[64];
			
			_here;
			
			operand = CheckOrdinal( YYS &(yyvsp[(3) - (4)].v), 64 );
			sprintf( label, "fp_int_const" sympost "%d", LblCntr++ );
			startStrSeg();
			EmitData
			( 
				label,
				tQWord, 
				operand 
			);
			endStrSeg();
			initLbl( &adrs, label, 0 );
			adrs.Size = 8;
			fpi_arith_mem_instr( (yyvsp[(1) - (4)].u), &adrs );
			FreeValue( YYS &(yyvsp[(3) - (4)].v) );
			free2( vss operand );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2132:

/* Line 1464 of yacc.c  */
#line 84924 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fiadd_instr;
			_here;
		;}
    break;

  case 2133:

/* Line 1464 of yacc.c  */
#line 84932 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fimul_instr;
			_here;
		;}
    break;

  case 2134:

/* Line 1464 of yacc.c  */
#line 84940 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = ficom_instr;
			_here;
		;}
    break;

  case 2135:

/* Line 1464 of yacc.c  */
#line 84948 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = ficomp_instr;
			_here;
		;}
    break;

  case 2136:

/* Line 1464 of yacc.c  */
#line 84956 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fisubr_instr;
			_here;
		;}
    break;

  case 2137:

/* Line 1464 of yacc.c  */
#line 84964 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fisub_instr;
			_here;
		;}
    break;

  case 2138:

/* Line 1464 of yacc.c  */
#line 84972 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fidivr_instr;
			_here;
		;}
    break;

  case 2139:

/* Line 1464 of yacc.c  */
#line 84980 "hlaparse.bsn"
    {			/* $2 */

			_here;
			(yyval.u) = fidiv_instr;
			_here;
		;}
    break;

  case 2140:

/* Line 1464 of yacc.c  */
#line 84997 "hlaparse.bsn"
    {
			_here;
			implied_instr( fsqrt_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2141:

/* Line 1464 of yacc.c  */
#line 85013 "hlaparse.bsn"
    {
			_here;
			implied_instr( fscale_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2142:

/* Line 1464 of yacc.c  */
#line 85029 "hlaparse.bsn"
    {
			_here;
			implied_instr( fprem_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2143:

/* Line 1464 of yacc.c  */
#line 85045 "hlaparse.bsn"
    {
			_here;
			implied_instr( fprem1_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2144:

/* Line 1464 of yacc.c  */
#line 85061 "hlaparse.bsn"
    {
			_here;
			implied_instr( frndint_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2145:

/* Line 1464 of yacc.c  */
#line 85077 "hlaparse.bsn"
    {
			_here;
			implied_instr( fxtract_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2146:

/* Line 1464 of yacc.c  */
#line 85093 "hlaparse.bsn"
    {
			_here;
			implied_instr( fabs_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2147:

/* Line 1464 of yacc.c  */
#line 85109 "hlaparse.bsn"
    {
			_here;
			implied_instr( fchs_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2148:

/* Line 1464 of yacc.c  */
#line 85125 "hlaparse.bsn"
    {
			_here;
			implied_instr( ftst_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2149:

/* Line 1464 of yacc.c  */
#line 85141 "hlaparse.bsn"
    {
			_here;
			implied_instr( fxam_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2150:

/* Line 1464 of yacc.c  */
#line 85157 "hlaparse.bsn"
    {
			_here;
			implied_instr( fldz_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2151:

/* Line 1464 of yacc.c  */
#line 85173 "hlaparse.bsn"
    {
			_here;
			implied_instr( fld1_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2152:

/* Line 1464 of yacc.c  */
#line 85189 "hlaparse.bsn"
    {
			_here;
			implied_instr( fldpi_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2153:

/* Line 1464 of yacc.c  */
#line 85205 "hlaparse.bsn"
    {
			_here;
			implied_instr( fldl2t_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2154:

/* Line 1464 of yacc.c  */
#line 85221 "hlaparse.bsn"
    {
			_here;
			implied_instr( fldl2e_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2155:

/* Line 1464 of yacc.c  */
#line 85237 "hlaparse.bsn"
    {
			_here;
			implied_instr( fldlg2_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2156:

/* Line 1464 of yacc.c  */
#line 85253 "hlaparse.bsn"
    {
			_here;
			implied_instr( fldln2_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2157:

/* Line 1464 of yacc.c  */
#line 85269 "hlaparse.bsn"
    {
			_here;
			implied_instr( f2xm1_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2158:

/* Line 1464 of yacc.c  */
#line 85285 "hlaparse.bsn"
    {
			_here;
			implied_instr( fsin_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2159:

/* Line 1464 of yacc.c  */
#line 85301 "hlaparse.bsn"
    {
			_here;
			implied_instr( fcos_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2160:

/* Line 1464 of yacc.c  */
#line 85317 "hlaparse.bsn"
    {
			_here;
			implied_instr( fsincos_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2161:

/* Line 1464 of yacc.c  */
#line 85333 "hlaparse.bsn"
    {
			_here;
			implied_instr( fptan_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2162:

/* Line 1464 of yacc.c  */
#line 85349 "hlaparse.bsn"
    {
			_here;
			implied_instr( fpatan_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2163:

/* Line 1464 of yacc.c  */
#line 85365 "hlaparse.bsn"
    {
			_here;
			implied_instr( fyl2x_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2164:

/* Line 1464 of yacc.c  */
#line 85381 "hlaparse.bsn"
    {
			_here;
			implied_instr( fyl2xp1_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2165:

/* Line 1464 of yacc.c  */
#line 85397 "hlaparse.bsn"
    {
			_here;
			implied_instr( finit_instr );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2166:

/* Line 1464 of yacc.c  */
#line 85409 "hlaparse.bsn"
    {
			_here;
			implied_instr( fninit_instr );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2167:

/* Line 1464 of yacc.c  */
#line 85425 "hlaparse.bsn"
    {
			_here;
			implied_instr( fwait_instr );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2168:

/* Line 1464 of yacc.c  */
#line 85441 "hlaparse.bsn"
    {
			_here;
			implied_instr( fclex_instr );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2169:

/* Line 1464 of yacc.c  */
#line 85452 "hlaparse.bsn"
    {
			_here;
			implied_instr( fnclex_instr );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2170:

/* Line 1464 of yacc.c  */
#line 85467 "hlaparse.bsn"
    {
			_here;
			implied_instr( fincstp_instr );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2171:

/* Line 1464 of yacc.c  */
#line 85482 "hlaparse.bsn"
    {
			_here;
			implied_instr( fdecstp_instr );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2172:

/* Line 1464 of yacc.c  */
#line 85497 "hlaparse.bsn"
    {
			_here;
			implied_instr( fnop_instr );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2173:

/* Line 1464 of yacc.c  */
#line 85508 "hlaparse.bsn"
    {			/* $3 */
			_here;
			implied_instr( _fucompp_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2174:

/* Line 1464 of yacc.c  */
#line 85525 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fld_sti( (yyvsp[(3) - (4)].u) );
			(yyval.returns) = hlastrdup( uToSTi[ (yyvsp[(3) - (4)].u) ] );
			_here;
		;}
    break;

  case 2175:

/* Line 1464 of yacc.c  */
#line 85538 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fld_mem( &(yyvsp[(3) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = hlastrdup( "st0" );
			_here;
		;}
    break;

  case 2176:

/* Line 1464 of yacc.c  */
#line 85552 "hlaparse.bsn"
    {				/* $5 */
		
			struct adrsYYS adrs;
			char name [ 256 ];

			_here;
			_if( IsReal( (yyvsp[(3) - (4)].v.pType) ))
			
				// Extend real32 and real64 constants to real80
				// (always compatible, so just ignore return result):
				
				IsCompatible( &real80_ste, YYS &(yyvsp[(3) - (4)].v) );

				sprintf( name, "fpconst" sympost "%d", LblCntr++ );
				startStrSeg();
				OutValue( name, &real80_ste, YYS &(yyvsp[(3) - (4)].v) );
				endStrSeg();
				
				initAdrs( &adrs, -1, -1, 0, 0 );
				adrs.StaticName = hlastrdup( name );
				adrs.Size = 10;
				fld_mem( &adrs );

			_else

				yyerror( "Expected a floating point constant" );

			_endif
			(yyval.returns) = hlastrdup2( name );
			FreeAdrs( &adrs );
		;}
    break;

  case 2177:

/* Line 1464 of yacc.c  */
#line 85594 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fst_sti( (yyvsp[(3) - (4)].u) );
			(yyval.returns) = hlastrdup( uToSTi[ (yyvsp[(3) - (4)].u) ] );
			_here;
		;}
    break;

  case 2178:

/* Line 1464 of yacc.c  */
#line 85607 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fst_mem( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2179:

/* Line 1464 of yacc.c  */
#line 85623 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fstp_sti( (yyvsp[(3) - (4)].u) );
			(yyval.returns) = hlastrdup( uToSTi[ (yyvsp[(3) - (4)].u) ] );
			_here;
		;}
    break;

  case 2180:

/* Line 1464 of yacc.c  */
#line 85636 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fstp_mem( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2181:

/* Line 1464 of yacc.c  */
#line 85653 "hlaparse.bsn"
    {			/* $3 */

			_here;
			implied_instr( fxch_instr );
			(yyval.returns) = hlastrdup2( "st0" );
			_here;
		;}
    break;

  case 2182:

/* Line 1464 of yacc.c  */
#line 85667 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fxch_sti( (yyvsp[(3) - (4)].u) );
			(yyval.returns) = hlastrdup( "st0" );
			_here;
		;}
    break;

  case 2183:

/* Line 1464 of yacc.c  */
#line 85685 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fist_mem( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2184:

/* Line 1464 of yacc.c  */
#line 85701 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fistp_mem( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2185:

/* Line 1464 of yacc.c  */
#line 85720 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fild_mem( &(yyvsp[(3) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = hlastrdup( "st0" );
			_here;
		;}
    break;

  case 2186:

/* Line 1464 of yacc.c  */
#line 85740 "hlaparse.bsn"
    {
			// MASM6 doesn't support this instruction, so we must
			// manually encode it.

			_here;
			fisttp_mem( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
		;}
    break;

  case 2187:

/* Line 1464 of yacc.c  */
#line 85761 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fbstp_mem( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2188:

/* Line 1464 of yacc.c  */
#line 85780 "hlaparse.bsn"
    {				/* $5 */
			_here;
			fbld_mem( &(yyvsp[(3) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = hlastrdup( "st0" );
			_here;
		;}
    break;

  case 2189:

/* Line 1464 of yacc.c  */
#line 85795 "hlaparse.bsn"
    {
			_here;
			ffree_sti( (yyvsp[(3) - (4)].u) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2190:

/* Line 1464 of yacc.c  */
#line 85807 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovb_instr;
		;}
    break;

  case 2191:

/* Line 1464 of yacc.c  */
#line 85813 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovb_instr;
		;}
    break;

  case 2192:

/* Line 1464 of yacc.c  */
#line 85819 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmove_instr;
		;}
    break;

  case 2193:

/* Line 1464 of yacc.c  */
#line 85825 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovbe_instr;
		;}
    break;

  case 2194:

/* Line 1464 of yacc.c  */
#line 85831 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovbe_instr;
		;}
    break;

  case 2195:

/* Line 1464 of yacc.c  */
#line 85837 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovu_instr;
		;}
    break;

  case 2196:

/* Line 1464 of yacc.c  */
#line 85843 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovnb_instr;
		;}
    break;

  case 2197:

/* Line 1464 of yacc.c  */
#line 85849 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovnb_instr;
		;}
    break;

  case 2198:

/* Line 1464 of yacc.c  */
#line 85855 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovne_instr;
		;}
    break;

  case 2199:

/* Line 1464 of yacc.c  */
#line 85861 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovnbe_instr;
		;}
    break;

  case 2200:

/* Line 1464 of yacc.c  */
#line 85867 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovnbe_instr;
		;}
    break;

  case 2201:

/* Line 1464 of yacc.c  */
#line 85873 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcmovnu_instr;
		;}
    break;

  case 2202:

/* Line 1464 of yacc.c  */
#line 85884 "hlaparse.bsn"
    {			/* $5 */
			_here;
			fp_op1Or2_instr( (yyvsp[(1) - (4)].u), (yyvsp[(3) - (4)].u) ); 
			_here;
		;}
    break;

  case 2203:

/* Line 1464 of yacc.c  */
#line 85898 "hlaparse.bsn"
    {
			_here;
			fp_op1Or2_instr( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u) );
			(yyval.returns) = hlastrdup( "st0" ); 
			_here;
		;}
    break;

  case 2204:

/* Line 1464 of yacc.c  */
#line 85910 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fucomi_instr;
		;}
    break;

  case 2205:

/* Line 1464 of yacc.c  */
#line 85916 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcomi_instr;
		;}
    break;

  case 2206:

/* Line 1464 of yacc.c  */
#line 85922 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fucomip_instr;
		;}
    break;

  case 2207:

/* Line 1464 of yacc.c  */
#line 85928 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = fcomip_instr;
		;}
    break;

  case 2208:

/* Line 1464 of yacc.c  */
#line 85939 "hlaparse.bsn"
    {			/* $5 */
			_here;
			fp_op1Or2_instr( (yyvsp[(1) - (4)].u), (yyvsp[(3) - (4)].u) ); 
			_here;
		;}
    break;

  case 2209:

/* Line 1464 of yacc.c  */
#line 85951 "hlaparse.bsn"
    {
			_here;
			fp_op1Or2_instr( (yyvsp[(1) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup( "st0" ); 
			_here;
		;}
    break;

  case 2210:

/* Line 1464 of yacc.c  */
#line 85966 "hlaparse.bsn"
    {
			_here;
			fp_op1Or2_instr( fucomp_instr, reg_st1 ); 
			(yyval.returns) = hlastrdup( "st0" ); 
			_here;
		;}
    break;

  case 2211:

/* Line 1464 of yacc.c  */
#line 85979 "hlaparse.bsn"
    {
			_here;
			fp_op1Or2_instr( fucomp_instr, (yyvsp[(3) - (4)].u) ); 
			(yyval.returns) = hlastrdup( "st0" ); 
			_here;
		;}
    break;

  case 2212:

/* Line 1464 of yacc.c  */
#line 85994 "hlaparse.bsn"
    {
			_here;
			fp_op1Or2_instr( fucomp_instr, (yyvsp[(5) - (6)].u) ); 
			(yyval.returns) = hlastrdup( "st0" ); 
			_here;
		;}
    break;

  case 2213:

/* Line 1464 of yacc.c  */
#line 86005 "hlaparse.bsn"
    {
			_here;
			fp_op1Or2_instr( fucom_instr, reg_st1 ); 
			(yyval.returns) = hlastrdup( "st0" ); 
			_here;
		;}
    break;

  case 2214:

/* Line 1464 of yacc.c  */
#line 86018 "hlaparse.bsn"
    {
			_here;
			fp_op1Or2_instr( fucom_instr, (yyvsp[(3) - (4)].u) ); 
			(yyval.returns) = hlastrdup( "st0" ); 
			_here;
		;}
    break;

  case 2215:

/* Line 1464 of yacc.c  */
#line 86033 "hlaparse.bsn"
    {
			_here;
			fp_op1Or2_instr( fucom_instr, (yyvsp[(5) - (6)].u) ); 
			(yyval.returns) = hlastrdup( "st0" ); 
			_here;
		;}
    break;

  case 2216:

/* Line 1464 of yacc.c  */
#line 86057 "hlaparse.bsn"
    {
			_here;
			fldenv_mem( &(yyvsp[(3) - (4)].adrs) );
			_here;
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
		;}
    break;

  case 2217:

/* Line 1464 of yacc.c  */
#line 86071 "hlaparse.bsn"
    {
			_here;
			fstenv_mem( &(yyvsp[(3) - (4)].adrs), 1 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2218:

/* Line 1464 of yacc.c  */
#line 86085 "hlaparse.bsn"
    {
			_here;
			fstenv_mem( &(yyvsp[(3) - (4)].adrs), 0 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2219:

/* Line 1464 of yacc.c  */
#line 86099 "hlaparse.bsn"
    {
			_here;
			fsave_mem( &(yyvsp[(3) - (4)].adrs), 1 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2220:

/* Line 1464 of yacc.c  */
#line 86112 "hlaparse.bsn"
    {
			_here;
			fsave_mem( &(yyvsp[(3) - (4)].adrs), 0 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2221:

/* Line 1464 of yacc.c  */
#line 86126 "hlaparse.bsn"
    {
			_here;
			frstor_mem( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2222:

/* Line 1464 of yacc.c  */
#line 86144 "hlaparse.bsn"
    {
			_here;
			fxrstor_mem( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2223:

/* Line 1464 of yacc.c  */
#line 86159 "hlaparse.bsn"
    {
			_here;
			fxsave_mem( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2224:

/* Line 1464 of yacc.c  */
#line 86181 "hlaparse.bsn"
    {			/* $5 */

			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) != 2 )

				yyerror
				( 
					"Expected a word sized operand" 
				);

			_endif
			fldcw_mem( &(yyvsp[(3) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2225:

/* Line 1464 of yacc.c  */
#line 86205 "hlaparse.bsn"
    {			/* $5 */

			_here;
			fldcw_mem( &(yyvsp[(3) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2226:

/* Line 1464 of yacc.c  */
#line 86223 "hlaparse.bsn"
    {			/* $5 */

			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) != 2 )

				yyerror
				( 
					"Expected a word sized operand" 
				);

			_endif
			fstcw_mem( &(yyvsp[(3) - (4)].adrs), 1 );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2227:

/* Line 1464 of yacc.c  */
#line 86244 "hlaparse.bsn"
    {			/* $5 */

			_here;
			(yyvsp[(3) - (4)].adrs.Size) = 2;
			fstcw_mem( &(yyvsp[(3) - (4)].adrs), 1 );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2228:

/* Line 1464 of yacc.c  */
#line 86264 "hlaparse.bsn"
    {			/* $5 */

			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) != 2 )

				yyerror
				( 
					"Expected a word sized operand" 
				);

			_endif
			fstcw_mem( &(yyvsp[(3) - (4)].adrs), 0 );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2229:

/* Line 1464 of yacc.c  */
#line 86287 "hlaparse.bsn"
    {			/* $5 */

			_here;
			(yyvsp[(3) - (4)].adrs.Size) = 2;
			fstcw_mem( &(yyvsp[(3) - (4)].adrs), 0 );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2230:

/* Line 1464 of yacc.c  */
#line 86313 "hlaparse.bsn"
    {				/* $5 */

			char address[ 256 ];

			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) != 2 && (yyvsp[(3) - (4)].adrs.Size) != 0 )

				yyerror
				( 
					"Expected a word sized operand" 
				);

			_endif
			fstsw_mem( &(yyvsp[(3) - (4)].adrs), 1 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2231:

/* Line 1464 of yacc.c  */
#line 86337 "hlaparse.bsn"
    {			/* $5 */

			_here;
			fstsw_ax( 1 );
			(yyval.returns) = hlastrdup2( "ax" );
			_here;
		;}
    break;

  case 2232:

/* Line 1464 of yacc.c  */
#line 86352 "hlaparse.bsn"
    {			/* $6 */

			_here;
			fstsw_ax( 1 );
			(yyval.returns) = hlastrdup2( "ax" );
			_here;
		;}
    break;

  case 2233:

/* Line 1464 of yacc.c  */
#line 86373 "hlaparse.bsn"
    {				/* $5 */

			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) != 2 && (yyvsp[(3) - (4)].adrs.Size) != 0 )

				yyerror
				( 
					"Expected a word sized operand" 
				);

			_endif
			fstsw_mem( &(yyvsp[(3) - (4)].adrs), 0 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2234:

/* Line 1464 of yacc.c  */
#line 86395 "hlaparse.bsn"
    {			/* $5 */

			_here;
			fstsw_ax( 0 );
			(yyval.returns) = hlastrdup2( "ax" );
			_here;
		;}
    break;

  case 2235:

/* Line 1464 of yacc.c  */
#line 86410 "hlaparse.bsn"
    {			/* $6 */

			_here;
			fstsw_ax( 0 );
			(yyval.returns) = hlastrdup2( "ax" );
			_here;
		;}
    break;

  case 2236:

/* Line 1464 of yacc.c  */
#line 86443 "hlaparse.bsn"
    {
				_here; 
				implied_instr( emms_instr );                                          		
				(yyval.returns) = NULL;
				_here;                                               			
		;}
    break;

  case 2237:

/* Line 1464 of yacc.c  */
#line 86461 "hlaparse.bsn"
    {					/* $7 */
		
			enum mmxregnums mmx;
			
			_here;
			movd_m_r( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u), 0 );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );                           			
			(yyval.returns) = hlastrdup2( uToMmx[(yyvsp[(5) - (6)].u)] );
		;}
    break;

  case 2238:

/* Line 1464 of yacc.c  */
#line 86479 "hlaparse.bsn"
    {					/* $7 */
		
			enum mmxregnums mmx;
			
			_here;
			movd_r_m( (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs), 0 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
		;}
    break;

  case 2239:

/* Line 1464 of yacc.c  */
#line 86496 "hlaparse.bsn"
    {					/* $7 */
			_here;
			movd_m_r( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u), 1 );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );                           			
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
		;}
    break;

  case 2240:

/* Line 1464 of yacc.c  */
#line 86511 "hlaparse.bsn"
    {					/* $7 */
			_here;
			movd_r_m( (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs), 1 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
		;}
    break;

  case 2241:

/* Line 1464 of yacc.c  */
#line 86525 "hlaparse.bsn"
    {				/* $7 */
		
			_here;
			movd_r32_r( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].u), 0 );
			(yyval.returns) = hlastrdup2( uToMmx[(yyvsp[(5) - (6)].u)] );
		;}
    break;

  case 2242:

/* Line 1464 of yacc.c  */
#line 86540 "hlaparse.bsn"
    {				/* $7 */
		
			_here;
			movd_r_r32( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].reg.encoding), 0 );
			(yyval.returns) = hlastrdup2( regStrs[(yyvsp[(5) - (6)].reg.encoding)] );
		;}
    break;

  case 2243:

/* Line 1464 of yacc.c  */
#line 86555 "hlaparse.bsn"
    {				/* $7 */
			_here;
			movd_r32_r( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].u), 1 );
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
		;}
    break;

  case 2244:

/* Line 1464 of yacc.c  */
#line 86569 "hlaparse.bsn"
    {				/* $7 */
			_here;
			movd_r_r32( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].reg.encoding), 1 );
			(yyval.returns) = hlastrdup2( regStrs[(yyvsp[(5) - (6)].reg.encoding)] );
		;}
    break;

  case 2245:

/* Line 1464 of yacc.c  */
#line 86585 "hlaparse.bsn"
    {					/* $7 */
		
			movq_m_regmmx( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );                                          			
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );                           			
			(yyval.returns) = hlastrdup2( uToMmx[(yyvsp[(5) - (6)].u)] );
		;}
    break;

  case 2246:

/* Line 1464 of yacc.c  */
#line 86600 "hlaparse.bsn"
    {					/* $7 */
		
			movq_m_regxmm( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );                                          			
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );                           			
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
		;}
    break;

  case 2247:

/* Line 1464 of yacc.c  */
#line 86616 "hlaparse.bsn"
    {					/* $7 */
		
			_here;
			movq_regmmx_m( (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs) );                                          			
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
		;}
    break;

  case 2248:

/* Line 1464 of yacc.c  */
#line 86631 "hlaparse.bsn"
    {						/* $7 */
		
			movq_regxmm_m( (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs) );                                          			
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
		;}
    break;

  case 2249:

/* Line 1464 of yacc.c  */
#line 86641 "hlaparse.bsn"
    {				/* $3 */
		
			_here;
			movq_r_r( (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 1 );
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(2) - (2)].rr).r] );
		;}
    break;

  case 2250:

/* Line 1464 of yacc.c  */
#line 86652 "hlaparse.bsn"
    {				/* $3 */
		
			_here;
			movq_r_r( (yyvsp[(2) - (2)].rr.l), (yyvsp[(2) - (2)].rr.r), 0 );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(2) - (2)].rr.r) ] );
		;}
    break;

  case 2251:

/* Line 1464 of yacc.c  */
#line 86666 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = addps_instr;
		;}
    break;

  case 2252:

/* Line 1464 of yacc.c  */
#line 86672 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = andnps_instr;
		;}
    break;

  case 2253:

/* Line 1464 of yacc.c  */
#line 86678 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = andps_instr;
		;}
    break;

  case 2254:

/* Line 1464 of yacc.c  */
#line 86684 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = divps_instr;
		;}
    break;

  case 2255:

/* Line 1464 of yacc.c  */
#line 86690 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = maxps_instr;
		;}
    break;

  case 2256:

/* Line 1464 of yacc.c  */
#line 86697 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = minps_instr;
		;}
    break;

  case 2257:

/* Line 1464 of yacc.c  */
#line 86704 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = mulps_instr;
		;}
    break;

  case 2258:

/* Line 1464 of yacc.c  */
#line 86711 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = orps_instr;
		;}
    break;

  case 2259:

/* Line 1464 of yacc.c  */
#line 86718 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = rcpps_instr;
		;}
    break;

  case 2260:

/* Line 1464 of yacc.c  */
#line 86724 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = rsqrtps_instr;
		;}
    break;

  case 2261:

/* Line 1464 of yacc.c  */
#line 86730 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = sqrtps_instr;
		;}
    break;

  case 2262:

/* Line 1464 of yacc.c  */
#line 86736 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = subps_instr;
		;}
    break;

  case 2263:

/* Line 1464 of yacc.c  */
#line 86742 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = xorps_instr;
		;}
    break;

  case 2264:

/* Line 1464 of yacc.c  */
#line 86748 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = addss_instr;
		;}
    break;

  case 2265:

/* Line 1464 of yacc.c  */
#line 86754 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = divss_instr;
		;}
    break;

  case 2266:

/* Line 1464 of yacc.c  */
#line 86760 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = maxss_instr;
		;}
    break;

  case 2267:

/* Line 1464 of yacc.c  */
#line 86767 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = minss_instr;
		;}
    break;

  case 2268:

/* Line 1464 of yacc.c  */
#line 86774 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = mulss_instr;
		;}
    break;

  case 2269:

/* Line 1464 of yacc.c  */
#line 86781 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = rcpss_instr;
		;}
    break;

  case 2270:

/* Line 1464 of yacc.c  */
#line 86787 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = rsqrtss_instr;
		;}
    break;

  case 2271:

/* Line 1464 of yacc.c  */
#line 86793 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = sqrtss_instr;
		;}
    break;

  case 2272:

/* Line 1464 of yacc.c  */
#line 86799 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = subss_instr;
		;}
    break;

  case 2273:

/* Line 1464 of yacc.c  */
#line 86805 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = addpd_instr;
		;}
    break;

  case 2274:

/* Line 1464 of yacc.c  */
#line 86811 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = andnpd_instr;
		;}
    break;

  case 2275:

/* Line 1464 of yacc.c  */
#line 86817 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = andpd_instr;
		;}
    break;

  case 2276:

/* Line 1464 of yacc.c  */
#line 86823 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = divpd_instr;
		;}
    break;

  case 2277:

/* Line 1464 of yacc.c  */
#line 86829 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = maxpd_instr;
		;}
    break;

  case 2278:

/* Line 1464 of yacc.c  */
#line 86836 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = minpd_instr;
		;}
    break;

  case 2279:

/* Line 1464 of yacc.c  */
#line 86843 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = mulpd_instr;
		;}
    break;

  case 2280:

/* Line 1464 of yacc.c  */
#line 86850 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = orpd_instr;
		;}
    break;

  case 2281:

/* Line 1464 of yacc.c  */
#line 86857 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = sqrtpd_instr;
		;}
    break;

  case 2282:

/* Line 1464 of yacc.c  */
#line 86863 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = subpd_instr;
		;}
    break;

  case 2283:

/* Line 1464 of yacc.c  */
#line 86869 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = xorpd_instr;
		;}
    break;

  case 2284:

/* Line 1464 of yacc.c  */
#line 86875 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = addsd_instr;
		;}
    break;

  case 2285:

/* Line 1464 of yacc.c  */
#line 86881 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = divsd_instr;
		;}
    break;

  case 2286:

/* Line 1464 of yacc.c  */
#line 86887 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = maxsd_instr;
		;}
    break;

  case 2287:

/* Line 1464 of yacc.c  */
#line 86894 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = minsd_instr;
		;}
    break;

  case 2288:

/* Line 1464 of yacc.c  */
#line 86901 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = mulsd_instr;
		;}
    break;

  case 2289:

/* Line 1464 of yacc.c  */
#line 86908 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = sqrtsd_instr;
		;}
    break;

  case 2290:

/* Line 1464 of yacc.c  */
#line 86914 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = subsd_instr;
		;}
    break;

  case 2291:

/* Line 1464 of yacc.c  */
#line 86920 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = addsubpd_instr;
		;}
    break;

  case 2292:

/* Line 1464 of yacc.c  */
#line 86926 "hlaparse.bsn"
    {				/* $2 */
			_here;
			(yyval.u) = addsubps_instr;
		;}
    break;

  case 2293:

/* Line 1464 of yacc.c  */
#line 86932 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtdq2ps_instr;
		;}
    break;

  case 2294:

/* Line 1464 of yacc.c  */
#line 86938 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtpd2dq_instr;
		;}
    break;

  case 2295:

/* Line 1464 of yacc.c  */
#line 86944 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtpd2ps_instr;
		;}
    break;

  case 2296:

/* Line 1464 of yacc.c  */
#line 86950 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtps2dq_instr;
		;}
    break;

  case 2297:

/* Line 1464 of yacc.c  */
#line 86956 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvttpd2dq_instr;
		;}
    break;

  case 2298:

/* Line 1464 of yacc.c  */
#line 86962 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvttps2dq_instr;
		;}
    break;

  case 2299:

/* Line 1464 of yacc.c  */
#line 86968 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = haddps_instr;
		;}
    break;

  case 2300:

/* Line 1464 of yacc.c  */
#line 86974 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = haddpd_instr;
		;}
    break;

  case 2301:

/* Line 1464 of yacc.c  */
#line 86980 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = hsubps_instr;
		;}
    break;

  case 2302:

/* Line 1464 of yacc.c  */
#line 86986 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = hsubpd_instr;
		;}
    break;

  case 2303:

/* Line 1464 of yacc.c  */
#line 86992 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movshdup_instr;
		;}
    break;

  case 2304:

/* Line 1464 of yacc.c  */
#line 86998 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movsldup_instr;
		;}
    break;

  case 2305:

/* Line 1464 of yacc.c  */
#line 87007 "hlaparse.bsn"
    {
			_here;
			sse_instr_r_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );	
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
		;}
    break;

  case 2306:

/* Line 1464 of yacc.c  */
#line 87021 "hlaparse.bsn"
    {
			_here;
			sse_instr_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );	
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
		;}
    break;

  case 2307:

/* Line 1464 of yacc.c  */
#line 87034 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = movaps_instr;
		;}
    break;

  case 2308:

/* Line 1464 of yacc.c  */
#line 87041 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = movups_instr;
		;}
    break;

  case 2309:

/* Line 1464 of yacc.c  */
#line 87048 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = movapd_instr;
		;}
    break;

  case 2310:

/* Line 1464 of yacc.c  */
#line 87055 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = movupd_instr;
		;}
    break;

  case 2311:

/* Line 1464 of yacc.c  */
#line 87062 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = movdqa_instr;
		;}
    break;

  case 2312:

/* Line 1464 of yacc.c  */
#line 87069 "hlaparse.bsn"
    {				/* $2 */
		
			_here;
			(yyval.u) = movdqu_instr;
		;}
    break;

  case 2313:

/* Line 1464 of yacc.c  */
#line 87081 "hlaparse.bsn"
    {
			_here;
			sse_mov_instr_r_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );	
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
		;}
    break;

  case 2314:

/* Line 1464 of yacc.c  */
#line 87091 "hlaparse.bsn"
    {
			_here;
			sse_mov_instr_m_r( (yyvsp[(1) - (2)].u), &(yyvsp[(2) - (2)].mr.m), (yyvsp[(2) - (2)].mr.r) );
			FreeAdrs( &(yyvsp[(2) - (2)].mr.m) );	
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].mr.r) ] );
		;}
    break;

  case 2315:

/* Line 1464 of yacc.c  */
#line 87102 "hlaparse.bsn"
    {
			_here;
			sse_mov_instr_r_m( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rm.r), &(yyvsp[(2) - (2)].rm.m) );	
			(yyval.returns) = FreeAdrs2( &(yyvsp[(2) - (2)].rm.m) );
		;}
    break;

  case 2316:

/* Line 1464 of yacc.c  */
#line 87112 "hlaparse.bsn"
    {
			_here;
			EmitMovntp( movntpd_instr, (yyvsp[(2) - (2)].rm.r), &(yyvsp[(2) - (2)].rm.m) );	
			(yyval.returns) = FreeAdrs2( &(yyvsp[(2) - (2)].rm.m) );
		;}
    break;

  case 2317:

/* Line 1464 of yacc.c  */
#line 87122 "hlaparse.bsn"
    {
			_here;
			EmitMovntp( movntps_instr, (yyvsp[(2) - (2)].rm.r), &(yyvsp[(2) - (2)].rm.m) );	
			(yyval.returns) = FreeAdrs2( &(yyvsp[(2) - (2)].rm.m) );
		;}
    break;

  case 2318:

/* Line 1464 of yacc.c  */
#line 87148 "hlaparse.bsn"
    {
			_here;
			EmitMovsds_r_r( _movsd_instr, (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );	
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
		;}
    break;

  case 2319:

/* Line 1464 of yacc.c  */
#line 87162 "hlaparse.bsn"
    {
			_here;
			EmitMovsds_m_r( _movsd_instr, &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );	
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
		;}
    break;

  case 2320:

/* Line 1464 of yacc.c  */
#line 87177 "hlaparse.bsn"
    {
			_here;
			EmitMovsds_r_m( _movsd_instr, (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs) );	
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
		;}
    break;

  case 2321:

/* Line 1464 of yacc.c  */
#line 87191 "hlaparse.bsn"
    {
			_here;
			EmitMovsds_r_r( movss_instr, (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );	
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
		;}
    break;

  case 2322:

/* Line 1464 of yacc.c  */
#line 87205 "hlaparse.bsn"
    {
			_here;
			EmitMovsds_m_r( movss_instr, &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );	
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
		;}
    break;

  case 2323:

/* Line 1464 of yacc.c  */
#line 87220 "hlaparse.bsn"
    {
			_here;
			EmitMovsds_r_m( movss_instr, (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs) );	
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
		;}
    break;

  case 2324:

/* Line 1464 of yacc.c  */
#line 87237 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = sldt_instr;
		;}
    break;

  case 2325:

/* Line 1464 of yacc.c  */
#line 87243 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = smsw_instr;
		;}
    break;

  case 2326:

/* Line 1464 of yacc.c  */
#line 87249 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = streg_instr;
		;}
    break;

  case 2327:

/* Line 1464 of yacc.c  */
#line 87261 "hlaparse.bsn"
    {
			_here;
			(yyvsp[(3) - (4)].adrs.forcedSize) = 2;
			Emit_mw_rv_m( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) ); 
			(yyval.returns) = NULL;	
			_here;
		;}
    break;

  case 2328:

/* Line 1464 of yacc.c  */
#line 87275 "hlaparse.bsn"
    {
			_here;
			Emit_mw_rv_r( (yyvsp[(1) - (4)].u), (yyvsp[(3) - (4)].u) ); 
			(yyval.returns) = NULL;	
			_here;
		;}
    break;

  case 2329:

/* Line 1464 of yacc.c  */
#line 87292 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lldt_instr;
		;}
    break;

  case 2330:

/* Line 1464 of yacc.c  */
#line 87298 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lmsw_instr;
		;}
    break;

  case 2331:

/* Line 1464 of yacc.c  */
#line 87304 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = ltreg_instr;
		;}
    break;

  case 2332:

/* Line 1464 of yacc.c  */
#line 87310 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = verr_instr;
		;}
    break;

  case 2333:

/* Line 1464 of yacc.c  */
#line 87316 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = verw_instr;
		;}
    break;

  case 2334:

/* Line 1464 of yacc.c  */
#line 87328 "hlaparse.bsn"
    {
			_here;
			Emit_ew_m( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) ); 
			(yyval.returns) = NULL;	
			_here;
		;}
    break;

  case 2335:

/* Line 1464 of yacc.c  */
#line 87342 "hlaparse.bsn"
    {
			_here;
			Emit_ew_r( (yyvsp[(1) - (4)].u), (yyvsp[(3) - (4)].reg.encoding) ); 
			(yyval.returns) = NULL;	
			_here;
		;}
    break;

  case 2336:

/* Line 1464 of yacc.c  */
#line 87359 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = sgdt_instr;
		;}
    break;

  case 2337:

/* Line 1464 of yacc.c  */
#line 87365 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lidt_instr;
		;}
    break;

  case 2338:

/* Line 1464 of yacc.c  */
#line 87371 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lgdt_instr;
		;}
    break;

  case 2339:

/* Line 1464 of yacc.c  */
#line 87377 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = sidt_instr;
		;}
    break;

  case 2340:

/* Line 1464 of yacc.c  */
#line 87390 "hlaparse.bsn"
    {
			_here;
			Emit_ms_m( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) ); 
			(yyval.returns) = NULL;	
			_here;
		;}
    break;

  case 2341:

/* Line 1464 of yacc.c  */
#line 87404 "hlaparse.bsn"
    {
			Emit_invlpg( &(yyvsp[(3) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2342:

/* Line 1464 of yacc.c  */
#line 87414 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lar_instr;
		;}
    break;

  case 2343:

/* Line 1464 of yacc.c  */
#line 87420 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lsl_instr;
		;}
    break;

  case 2344:

/* Line 1464 of yacc.c  */
#line 87433 "hlaparse.bsn"
    {
			_here;
			Emit_Gv_Ew_r( (yyvsp[(1) - (6)].u), (yyvsp[(5) - (6)].reg.encoding), (yyvsp[(3) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ] ); 
		;}
    break;

  case 2345:

/* Line 1464 of yacc.c  */
#line 87447 "hlaparse.bsn"
    {
			_here;
			Emit_Gv_Ew_m( (yyvsp[(1) - (6)].u), &(yyvsp[(5) - (6)].adrs), (yyvsp[(3) - (6)].reg.encoding) );
			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = hlastrdup( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ] ); 
		;}
    break;

  case 2346:

/* Line 1464 of yacc.c  */
#line 87462 "hlaparse.bsn"
    {
			_here;
			Emit_Gv_Ew_r( (yyvsp[(1) - (6)].u), (yyvsp[(5) - (6)].reg.encoding), (yyvsp[(3) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ] ); 
		;}
    break;

  case 2347:

/* Line 1464 of yacc.c  */
#line 87476 "hlaparse.bsn"
    {
			_here;
			Emit_Gv_Ew_m( (yyvsp[(1) - (6)].u), &(yyvsp[(5) - (6)].adrs), (yyvsp[(3) - (6)].reg.encoding) );
			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = hlastrdup( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ] ); 
		;}
    break;

  case 2348:

/* Line 1464 of yacc.c  */
#line 87488 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movlps_instr;
		;}
    break;

  case 2349:

/* Line 1464 of yacc.c  */
#line 87494 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movhps_instr;
		;}
    break;

  case 2350:

/* Line 1464 of yacc.c  */
#line 87502 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movhlps_instr;
		;}
    break;

  case 2351:

/* Line 1464 of yacc.c  */
#line 87508 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movlhps_instr;
		;}
    break;

  case 2352:

/* Line 1464 of yacc.c  */
#line 87521 "hlaparse.bsn"
    {
			_here;
			Emit_Mq_Vps( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2353:

/* Line 1464 of yacc.c  */
#line 87537 "hlaparse.bsn"
    {
			_here;
			Emit_Vps_Mq( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2354:

/* Line 1464 of yacc.c  */
#line 87549 "hlaparse.bsn"
    {
			_here;
			Emit_Vps_VRq( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2355:

/* Line 1464 of yacc.c  */
#line 87565 "hlaparse.bsn"
    {
			_here;
			Emit_Movddup_r_r( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2356:

/* Line 1464 of yacc.c  */
#line 87582 "hlaparse.bsn"
    {
			_here;
			Emit_Movddup( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2357:

/* Line 1464 of yacc.c  */
#line 87595 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = unpcklps_instr;
		;}
    break;

  case 2358:

/* Line 1464 of yacc.c  */
#line 87601 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = unpckhps_instr;
		;}
    break;

  case 2359:

/* Line 1464 of yacc.c  */
#line 87610 "hlaparse.bsn"
    {
			_here;
			Emit_Vps_Wq_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2360:

/* Line 1464 of yacc.c  */
#line 87625 "hlaparse.bsn"
    {
			_here;
			Emit_Vps_Wq_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2361:

/* Line 1464 of yacc.c  */
#line 87638 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movlpd_instr;
		;}
    break;

  case 2362:

/* Line 1464 of yacc.c  */
#line 87644 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movhpd_instr;
		;}
    break;

  case 2363:

/* Line 1464 of yacc.c  */
#line 87657 "hlaparse.bsn"
    {
			_here;
			Emit_Mq_Vsd_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2364:

/* Line 1464 of yacc.c  */
#line 87673 "hlaparse.bsn"
    {
			_here;
			Emit_Vsd_Mq_m( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2365:

/* Line 1464 of yacc.c  */
#line 87685 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = unpcklpd_instr;
		;}
    break;

  case 2366:

/* Line 1464 of yacc.c  */
#line 87691 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = unpckhpd_instr;
		;}
    break;

  case 2367:

/* Line 1464 of yacc.c  */
#line 87697 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtdq2pd_instr;
		;}
    break;

  case 2368:

/* Line 1464 of yacc.c  */
#line 87706 "hlaparse.bsn"
    {
			_here;
			Emit_Vpd_Wq_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2369:

/* Line 1464 of yacc.c  */
#line 87721 "hlaparse.bsn"
    {
			_here;
			Emit_Vpd_Wq_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2370:

/* Line 1464 of yacc.c  */
#line 87736 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovo_instr;
		;}
    break;

  case 2371:

/* Line 1464 of yacc.c  */
#line 87742 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovno_instr;
		;}
    break;

  case 2372:

/* Line 1464 of yacc.c  */
#line 87748 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovb_instr;
		;}
    break;

  case 2373:

/* Line 1464 of yacc.c  */
#line 87754 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovnb_instr;
		;}
    break;

  case 2374:

/* Line 1464 of yacc.c  */
#line 87760 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovz_instr;
		;}
    break;

  case 2375:

/* Line 1464 of yacc.c  */
#line 87766 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovnz_instr;
		;}
    break;

  case 2376:

/* Line 1464 of yacc.c  */
#line 87772 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovbe_instr;
		;}
    break;

  case 2377:

/* Line 1464 of yacc.c  */
#line 87778 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovnbe_instr;
		;}
    break;

  case 2378:

/* Line 1464 of yacc.c  */
#line 87784 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovs_instr;
		;}
    break;

  case 2379:

/* Line 1464 of yacc.c  */
#line 87790 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovns_instr;
		;}
    break;

  case 2380:

/* Line 1464 of yacc.c  */
#line 87796 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovl_instr;
		;}
    break;

  case 2381:

/* Line 1464 of yacc.c  */
#line 87802 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovnl_instr;
		;}
    break;

  case 2382:

/* Line 1464 of yacc.c  */
#line 87808 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovle_instr;
		;}
    break;

  case 2383:

/* Line 1464 of yacc.c  */
#line 87814 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovnle_instr;
		;}
    break;

  case 2384:

/* Line 1464 of yacc.c  */
#line 87820 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovp_instr;
		;}
    break;

  case 2385:

/* Line 1464 of yacc.c  */
#line 87826 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmovnp_instr;
		;}
    break;

  case 2386:

/* Line 1464 of yacc.c  */
#line 87832 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = bsf_instr;
		;}
    break;

  case 2387:

/* Line 1464 of yacc.c  */
#line 87838 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = bsr_instr;
		;}
    break;

  case 2388:

/* Line 1464 of yacc.c  */
#line 87851 "hlaparse.bsn"
    {
			_here;
			Emit_Gv_Ev_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[(yyvsp[(5) - (6)].reg.encoding)] );
			_here;
		;}
    break;

  case 2389:

/* Line 1464 of yacc.c  */
#line 87866 "hlaparse.bsn"
    {
			_here;
			Emit_Gv_Ev_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[(yyvsp[(5) - (6)].reg.encoding)] );
			_here;
		;}
    break;

  case 2390:

/* Line 1464 of yacc.c  */
#line 87881 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					((yyvsp[(3) - (6)].adrs.Size) == 2 && ((yyvsp[(5) - (6)].u) >= reg_eax ))
				||	((yyvsp[(3) - (6)].adrs.Size) == 4 && ((yyvsp[(5) - (6)].u) < reg_eax ))
			)
				yyerror( "Operand size mismatch" );
				
			_endif;
			Emit_Gv_Ev_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( regStrs[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2391:

/* Line 1464 of yacc.c  */
#line 87901 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movmskps_instr;
		;}
    break;

  case 2392:

/* Line 1464 of yacc.c  */
#line 87907 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movmskpd_instr;
		;}
    break;

  case 2393:

/* Line 1464 of yacc.c  */
#line 87921 "hlaparse.bsn"
    {
			_here;
			Emit_Gd_VRp_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[(yyvsp[(5) - (6)].reg.encoding)] );
			_here;
		;}
    break;

  case 2394:

/* Line 1464 of yacc.c  */
#line 87936 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = packsswb_instr;
		;}
    break;

  case 2395:

/* Line 1464 of yacc.c  */
#line 87942 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pcmpgtb_instr;
		;}
    break;

  case 2396:

/* Line 1464 of yacc.c  */
#line 87948 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pcmpgtw_instr;
		;}
    break;

  case 2397:

/* Line 1464 of yacc.c  */
#line 87954 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pcmpgtd_instr;
		;}
    break;

  case 2398:

/* Line 1464 of yacc.c  */
#line 87960 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = packuswb_instr;
		;}
    break;

  case 2399:

/* Line 1464 of yacc.c  */
#line 87966 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pcmpeqb_instr;
		;}
    break;

  case 2400:

/* Line 1464 of yacc.c  */
#line 87972 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pcmpeqw_instr;
		;}
    break;

  case 2401:

/* Line 1464 of yacc.c  */
#line 87978 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pcmpeqd_instr;
		;}
    break;

  case 2402:

/* Line 1464 of yacc.c  */
#line 87984 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = paddq_instr;
		;}
    break;

  case 2403:

/* Line 1464 of yacc.c  */
#line 87990 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pmullw_instr;
		;}
    break;

  case 2404:

/* Line 1464 of yacc.c  */
#line 87996 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pavgb_instr;
		;}
    break;

  case 2405:

/* Line 1464 of yacc.c  */
#line 88002 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pavgw_instr;
		;}
    break;

  case 2406:

/* Line 1464 of yacc.c  */
#line 88008 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pmulhuw_instr;
		;}
    break;

  case 2407:

/* Line 1464 of yacc.c  */
#line 88014 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pmulhw_instr;
		;}
    break;

  case 2408:

/* Line 1464 of yacc.c  */
#line 88020 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pmuludq_instr;
		;}
    break;

  case 2409:

/* Line 1464 of yacc.c  */
#line 88026 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pmaddwd_instr;
		;}
    break;

  case 2410:

/* Line 1464 of yacc.c  */
#line 88032 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psadbw_instr;
		;}
    break;

  case 2411:

/* Line 1464 of yacc.c  */
#line 88038 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = packssdw_instr;
		;}
    break;

  case 2412:

/* Line 1464 of yacc.c  */
#line 88044 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psubusb_instr;
		;}
    break;

  case 2413:

/* Line 1464 of yacc.c  */
#line 88050 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psubusw_instr;
		;}
    break;

  case 2414:

/* Line 1464 of yacc.c  */
#line 88056 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pminub_instr;
		;}
    break;

  case 2415:

/* Line 1464 of yacc.c  */
#line 88062 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pand_instr;
		;}
    break;

  case 2416:

/* Line 1464 of yacc.c  */
#line 88068 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = paddusb_instr;
		;}
    break;

  case 2417:

/* Line 1464 of yacc.c  */
#line 88074 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = paddusw_instr;
		;}
    break;

  case 2418:

/* Line 1464 of yacc.c  */
#line 88080 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pmaxub_instr;
		;}
    break;

  case 2419:

/* Line 1464 of yacc.c  */
#line 88086 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pandn_instr;
		;}
    break;

  case 2420:

/* Line 1464 of yacc.c  */
#line 88092 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psubsb_instr;
		;}
    break;

  case 2421:

/* Line 1464 of yacc.c  */
#line 88098 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psubsw_instr;
		;}
    break;

  case 2422:

/* Line 1464 of yacc.c  */
#line 88104 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pminsw_instr;
		;}
    break;

  case 2423:

/* Line 1464 of yacc.c  */
#line 88110 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = por_instr;
		;}
    break;

  case 2424:

/* Line 1464 of yacc.c  */
#line 88116 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = paddsb_instr;
		;}
    break;

  case 2425:

/* Line 1464 of yacc.c  */
#line 88122 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = paddsw_instr;
		;}
    break;

  case 2426:

/* Line 1464 of yacc.c  */
#line 88128 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pmaxsw_instr;
		;}
    break;

  case 2427:

/* Line 1464 of yacc.c  */
#line 88134 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pxor_instr;
		;}
    break;

  case 2428:

/* Line 1464 of yacc.c  */
#line 88140 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psubb_instr;
		;}
    break;

  case 2429:

/* Line 1464 of yacc.c  */
#line 88146 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psubw_instr;
		;}
    break;

  case 2430:

/* Line 1464 of yacc.c  */
#line 88152 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psubd_instr;
		;}
    break;

  case 2431:

/* Line 1464 of yacc.c  */
#line 88158 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psubq_instr;
		;}
    break;

  case 2432:

/* Line 1464 of yacc.c  */
#line 88164 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = paddb_instr;
		;}
    break;

  case 2433:

/* Line 1464 of yacc.c  */
#line 88170 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = paddw_instr;
		;}
    break;

  case 2434:

/* Line 1464 of yacc.c  */
#line 88176 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = paddd_instr;
		;}
    break;

  case 2435:

/* Line 1464 of yacc.c  */
#line 88185 "hlaparse.bsn"
    {
			_here;
			Emit_Pq_Qq_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 0 );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2436:

/* Line 1464 of yacc.c  */
#line 88200 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].adrs.Size) == 0 )
			
				(yyvsp[(3) - (6)].adrs.Size) = 8;
				
			_endif
			_if( (yyvsp[(3) - (6)].adrs.Size) != 8 )
			
				yyerror( "Instruction expects a qword operand" );
				
			_endif
			Emit_Pq_Qq_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u), 0 );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToMmx[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2437:

/* Line 1464 of yacc.c  */
#line 88224 "hlaparse.bsn"
    {
			_here;
			Emit_Pq_Qq_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 1 );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2438:

/* Line 1464 of yacc.c  */
#line 88239 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].adrs.Size) == 0 )
			
				(yyvsp[(3) - (6)].adrs.Size) = 16;
				
			_endif
			_if( (yyvsp[(3) - (6)].adrs.Size) != 16 )
			
				yyerror( "Instruction expects an lword operand" );
				
			_endif
			Emit_Pq_Qq_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u), 1 );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2439:

/* Line 1464 of yacc.c  */
#line 88264 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = punpcklbw_instr;
		;}
    break;

  case 2440:

/* Line 1464 of yacc.c  */
#line 88269 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = punpcklwd_instr;
		;}
    break;

  case 2441:

/* Line 1464 of yacc.c  */
#line 88274 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = punpckldq_instr;
		;}
    break;

  case 2442:

/* Line 1464 of yacc.c  */
#line 88282 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = punpckhbw_instr;
		;}
    break;

  case 2443:

/* Line 1464 of yacc.c  */
#line 88287 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = punpckhwd_instr;
		;}
    break;

  case 2444:

/* Line 1464 of yacc.c  */
#line 88292 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = punpckhdq_instr;
		;}
    break;

  case 2445:

/* Line 1464 of yacc.c  */
#line 88302 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wq_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 0 );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2446:

/* Line 1464 of yacc.c  */
#line 88314 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wq_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 1 );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2447:

/* Line 1464 of yacc.c  */
#line 88328 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wd_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 0 );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2448:

/* Line 1464 of yacc.c  */
#line 88340 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wd_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 1 );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2449:

/* Line 1464 of yacc.c  */
#line 88352 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wq_r( punpcklqdq_instr, (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 1 );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2450:

/* Line 1464 of yacc.c  */
#line 88364 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wq_r( punpckhqdq_instr, (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 1 );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2451:

/* Line 1464 of yacc.c  */
#line 88379 "hlaparse.bsn"
    {
			_here;
			
			_if( (yyvsp[(3) - (6)].adrs.Size) == 0 )
				
				(yyvsp[(3) - (6)].adrs.Size) = 8;
				
			_endif
			_if( (yyvsp[(3) - (6)].adrs.Size) != 8 )
			
				yyerror( "Instruction expects a qword operand" );
				
			_endif
			Emit_Vdq_Wq_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u), 0 );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToMmx[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2452:

/* Line 1464 of yacc.c  */
#line 88406 "hlaparse.bsn"
    {
			_here;
			
			// Note: Intel claims the size should be dword.
			
			_if( (yyvsp[(3) - (6)].adrs.Size) == 0 )
				
				(yyvsp[(3) - (6)].adrs.Size) = 4;
				
			_endif
			_if( (yyvsp[(3) - (6)].adrs.Size) != 4 )
			
				yyerror( "Instruction expects a dword operand" );
				
			_endif
			Emit_Vdq_Wd_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u), 0 );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToMmx[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2453:

/* Line 1464 of yacc.c  */
#line 88435 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wq_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u), 1 );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2454:

/* Line 1464 of yacc.c  */
#line 88451 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wd_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u), 1 );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2455:

/* Line 1464 of yacc.c  */
#line 88463 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wq_m( lddqu_instr, &(yyvsp[(2) - (2)].rm.m), (yyvsp[(2) - (2)].rm.r), 1 );
			FreeAdrs( &(yyvsp[(2) - (2)].rm.m) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rm.r) ] );
			_here;
		;}
    break;

  case 2456:

/* Line 1464 of yacc.c  */
#line 88475 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wq_m( punpcklqdq_instr, &(yyvsp[(2) - (2)].mr.m), (yyvsp[(2) - (2)].mr.r), 1 );
			FreeAdrs( &(yyvsp[(2) - (2)].mr.m) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].mr.r) ] );
			_here;
		;}
    break;

  case 2457:

/* Line 1464 of yacc.c  */
#line 88487 "hlaparse.bsn"
    {
			_here;
			Emit_Vdq_Wq_m( punpckhqdq_instr, &(yyvsp[(2) - (2)].mr.m), (yyvsp[(2) - (2)].mr.r), 1 );
			FreeAdrs( &(yyvsp[(2) - (2)].mr.m) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].mr.r)] );
			_here;
		;}
    break;

  case 2458:

/* Line 1464 of yacc.c  */
#line 88499 "hlaparse.bsn"
    {
			_if
			( 
					IsNumber( (yyvsp[(1) - (1)].v.pType) )
				&&	checkSmallUns( YYS &(yyvsp[(1) - (1)].v) ) 
				&&	(yyvsp[(1) - (1)].v.u.unsval) <= 255
			)
			
				(yyval.u) = (yyvsp[(1) - (1)].v.u.unsval);
				
			_else
			
				yyerror( "Constant value is too large" );
				(yyval.u) = 0;
				
			_endif
		;}
    break;

  case 2459:

/* Line 1464 of yacc.c  */
#line 88521 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pshufhw_instr;
		;}
    break;

  case 2460:

/* Line 1464 of yacc.c  */
#line 88527 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pshufd_instr;
		;}
    break;

  case 2461:

/* Line 1464 of yacc.c  */
#line 88533 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pshuflw_instr;
		;}
    break;

  case 2462:

/* Line 1464 of yacc.c  */
#line 88549 "hlaparse.bsn"
    {
			_here;
			Emit_pshuf_r( pshufw_instr, (yyvsp[(3) - (8)].u), (yyvsp[(5) - (8)].u), (yyvsp[(7) - (8)].u) );
			(yyval.returns) = hlastrdup2( uToMmx[(yyvsp[(7) - (8)].u)] );
			_here;
		;}
    break;

  case 2463:

/* Line 1464 of yacc.c  */
#line 88567 "hlaparse.bsn"
    {
			_here;
			Emit_pshuf_m( pshufw_instr, (yyvsp[(3) - (8)].u), &(yyvsp[(5) - (8)].adrs), (yyvsp[(7) - (8)].u) );
			FreeAdrs( &(yyvsp[(5) - (8)].adrs) );
			(yyval.returns) = hlastrdup2( uToMmx[(yyvsp[(7) - (8)].u)] );
			_here;
		;}
    break;

  case 2464:

/* Line 1464 of yacc.c  */
#line 88584 "hlaparse.bsn"
    {
			_here;
			Emit_pshuf_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].rr).l, (yyvsp[(5) - (6)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].rr).r ] );
			_here;
		;}
    break;

  case 2465:

/* Line 1464 of yacc.c  */
#line 88602 "hlaparse.bsn"
    {
			_here;
			Emit_pshuf_m( (yyvsp[(1) - (8)].u), (yyvsp[(3) - (8)].u), &(yyvsp[(5) - (8)].adrs), (yyvsp[(7) - (8)].u) );
			FreeAdrs( &(yyvsp[(5) - (8)].adrs) );
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(7) - (8)].u)] );
			_here;
		;}
    break;

  case 2466:

/* Line 1464 of yacc.c  */
#line 88616 "hlaparse.bsn"
    {
			_here;		
			(yyval.u) = psrlw_instr;
		;}
    break;

  case 2467:

/* Line 1464 of yacc.c  */
#line 88622 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psraw_instr;
		;}
    break;

  case 2468:

/* Line 1464 of yacc.c  */
#line 88628 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psllw_instr;
		;}
    break;

  case 2469:

/* Line 1464 of yacc.c  */
#line 88634 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psrld_instr;
		;}
    break;

  case 2470:

/* Line 1464 of yacc.c  */
#line 88640 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psrad_instr;
		;}
    break;

  case 2471:

/* Line 1464 of yacc.c  */
#line 88646 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pslld_instr;
		;}
    break;

  case 2472:

/* Line 1464 of yacc.c  */
#line 88652 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psrlq_instr;
		;}
    break;

  case 2473:

/* Line 1464 of yacc.c  */
#line 88658 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psllq_instr;
		;}
    break;

  case 2474:

/* Line 1464 of yacc.c  */
#line 88664 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = pslldq_instr;
		;}
    break;

  case 2475:

/* Line 1464 of yacc.c  */
#line 88670 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = psrldq_instr;
		;}
    break;

  case 2476:

/* Line 1464 of yacc.c  */
#line 88684 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (6)].u) == pslldq_instr || (yyvsp[(1) - (6)].u) == psrldq_instr )
			
				yyerror( "Instruction requires XMM register operand" );
				(yyvsp[(1) - (6)].u) = psrlw_instr;
				
			_endif
			Emit_psl_psr_imm( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u), 0 );	
			(yyval.returns) = hlastrdup2( uToMmx[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2477:

/* Line 1464 of yacc.c  */
#line 88705 "hlaparse.bsn"
    {
			_here;
			Emit_psl_psr_imm( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u), 1 );	
			(yyval.returns) = hlastrdup2( uToXmm[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2478:

/* Line 1464 of yacc.c  */
#line 88717 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (2)].u) == pslldq_instr || (yyvsp[(1) - (2)].u) == psrldq_instr )
			
				yyerror( "Instruction requires XMM register and constant operands" );
				(yyvsp[(1) - (2)].u) = psrlw_instr;
				
			_endif
			Emit_psl_psr_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 0 );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2479:

/* Line 1464 of yacc.c  */
#line 88738 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].adrs.Size) != 8 )
			
				yyerror( "Instruction expects a qword operand" );
				
			_endif
			Emit_psl_psr_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u), 0 );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToMmx[(yyvsp[(5) - (6)].u)] );
			_here;
		;}
    break;

  case 2480:

/* Line 1464 of yacc.c  */
#line 88757 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (2)].u) == pslldq_instr || (yyvsp[(1) - (2)].u) == psrldq_instr )
			
				yyerror( "Instruction requires a constant operand" );
				(yyvsp[(1) - (2)].u) = psrlw_instr;
				
			_endif
			Emit_psl_psr_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r, 1 );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2481:

/* Line 1464 of yacc.c  */
#line 88778 "hlaparse.bsn"
    {
			_here;
			Emit_psl_psr_m( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u), 1 );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2482:

/* Line 1464 of yacc.c  */
#line 88790 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = seto_instr;
		;}
    break;

  case 2483:

/* Line 1464 of yacc.c  */
#line 88796 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setno_instr;
		;}
    break;

  case 2484:

/* Line 1464 of yacc.c  */
#line 88802 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setb_instr;
		;}
    break;

  case 2485:

/* Line 1464 of yacc.c  */
#line 88808 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setnb_instr;
		;}
    break;

  case 2486:

/* Line 1464 of yacc.c  */
#line 88814 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setz_instr;
		;}
    break;

  case 2487:

/* Line 1464 of yacc.c  */
#line 88820 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setnz_instr;
		;}
    break;

  case 2488:

/* Line 1464 of yacc.c  */
#line 88826 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setbe_instr;
		;}
    break;

  case 2489:

/* Line 1464 of yacc.c  */
#line 88832 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setnbe_instr;
		;}
    break;

  case 2490:

/* Line 1464 of yacc.c  */
#line 88838 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = sets_instr;
		;}
    break;

  case 2491:

/* Line 1464 of yacc.c  */
#line 88844 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setns_instr;
		;}
    break;

  case 2492:

/* Line 1464 of yacc.c  */
#line 88850 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setp_instr;
		;}
    break;

  case 2493:

/* Line 1464 of yacc.c  */
#line 88856 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setnp_instr;
		;}
    break;

  case 2494:

/* Line 1464 of yacc.c  */
#line 88862 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setl_instr;
		;}
    break;

  case 2495:

/* Line 1464 of yacc.c  */
#line 88868 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setnl_instr;
		;}
    break;

  case 2496:

/* Line 1464 of yacc.c  */
#line 88874 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setle_instr;
		;}
    break;

  case 2497:

/* Line 1464 of yacc.c  */
#line 88880 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = setnle_instr;
		;}
    break;

  case 2498:

/* Line 1464 of yacc.c  */
#line 88892 "hlaparse.bsn"
    {
			_here;
			Emit_set_Eb_r( (yyvsp[(1) - (4)].u), (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[(yyvsp[(3) - (4)].reg.encoding)] );
			_here;
		;}
    break;

  case 2499:

/* Line 1464 of yacc.c  */
#line 88905 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) != 1 )
			
				yyerror( "Instruction expects a byte operand" );
				
			_endif
			Emit_set_Eb_m( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2500:

/* Line 1464 of yacc.c  */
#line 88921 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = bt_instr;
		;}
    break;

  case 2501:

/* Line 1464 of yacc.c  */
#line 88927 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = btc_instr;
		;}
    break;

  case 2502:

/* Line 1464 of yacc.c  */
#line 88933 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = btr_instr;
		;}
    break;

  case 2503:

/* Line 1464 of yacc.c  */
#line 88939 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = bts_instr;
		;}
    break;

  case 2504:

/* Line 1464 of yacc.c  */
#line 88945 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockbtc_instr;
		;}
    break;

  case 2505:

/* Line 1464 of yacc.c  */
#line 88951 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockbtr_instr;
		;}
    break;

  case 2506:

/* Line 1464 of yacc.c  */
#line 88957 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockbts_instr;
		;}
    break;

  case 2507:

/* Line 1464 of yacc.c  */
#line 88971 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (6)].u) >= lockbts_instr )
			
				yyerror( "LOCK prefix requires a memory operand" );
				
			_endif
			_if( IsOrdinal( (yyvsp[(3) - (6)].v.pType) ) && numBits32( YYS &(yyvsp[(3) - (6)].v) ) <= 32 )
			
				_if( (yyvsp[(5) - (6)].u) >= reg_ax && (yyvsp[(5) - (6)].u) <= reg_di )
				
					_if( (yyvsp[(3) - (6)].v.u.unsval) < 16 )
				
						Emit_bt_c_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].v.u.unsval), (yyvsp[(5) - (6)].u) );
						
					_else
					
						yyerror( "Bit number must be between 0 and 15" );
					
					_endif
					
				_elseif( (yyvsp[(5) - (6)].u) >= reg_eax && (yyvsp[(5) - (6)].u) <= reg_edi )
					
				
					_if( (yyvsp[(3) - (6)].v.u.unsval) < 32 )
				
						Emit_bt_c_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].v.u.unsval), (yyvsp[(5) - (6)].u) );
						
					_else
					
						yyerror( "Bit number must be between 0 and 31" );
					
					_endif
					
				_else
					
					yyerror( "Instruction requires a 16 or 32 bit register" );
					
				_endif
				
			_else
		
				yyerror( "Expected ordinal value for bit number" );
			
			_endif
			
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].u) ]);
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			_here;		
		;}
    break;

  case 2508:

/* Line 1464 of yacc.c  */
#line 89030 "hlaparse.bsn"
    {
			int size;
			
			_here;
			_if( IsOrdinal( (yyvsp[(3) - (6)].v.pType) ) && numBits32( YYS &(yyvsp[(3) - (6)].v) ) <= 32 )
			
				_if( (yyvsp[(3) - (6)].v.u.unsval) >= 256 )
				
					yyerror( "Bit number must be between 0 and 255" );
					
				_else
				
					// This is kind of lame.
					// If the address size isn't word or dword, we
					// default to dword. Technically, we should give
					// a warning or something, but lots of code
					// checks bits in >dword objects (e.g., csets),
					// so it's best to do this quietly.
					
					size = (yyvsp[(5) - (6)].adrs.Size);
					_if( size != 2 && size != 4 )
					
						_if( size == 0 || size == 8 || size == 16 )
						
							(yyvsp[(5) - (6)].adrs.Size) = 4;
							(yyvsp[(5) - (6)].adrs.pType) = tDWord;
							(yyvsp[(5) - (6)].adrs.Type) = &dword_ste;
							(yyvsp[(5) - (6)].adrs.forcedSize) = 4;
							
						_else
					
							yyerror( "Size mismatch in operands" );
							
						_endif
						
					_endif
					Emit_bt_c_m( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].v.u.unsval), &(yyvsp[(5) - (6)].adrs) );
					
				_endif
				
			_else
		
				yyerror( "Expected ordinal value for bit number" );
			
			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			_here;
		;}
    break;

  case 2509:

/* Line 1464 of yacc.c  */
#line 89088 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (6)].u) >= lockbts_instr )
			
				yyerror( "LOCK prefix requires a memory operand" );
				
			_endif
			_if( isReg16( (yyvsp[(3) - (6)].u) ) && !isReg16( (yyvsp[(5) - (6)].u) ))
			
				yyerror( "Both registers must be the same size" );
				
			_else
			
				Emit_bt_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
				
			_endif
 			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2510:

/* Line 1464 of yacc.c  */
#line 89117 "hlaparse.bsn"
    {
			int size;
			
			_here;
			size = (yyvsp[(5) - (6)].adrs.Size);
			_if( size != 2 && size != 4 )
			
				_if( size == 0 || size == 8 || size == 16 )
				
					(yyvsp[(5) - (6)].adrs.Size) = 4;
					(yyvsp[(5) - (6)].adrs.pType) = tDWord;
					(yyvsp[(5) - (6)].adrs.Type) = &dword_ste;
					(yyvsp[(5) - (6)].adrs.forcedSize) = 4;
					
				_else
			
					yyerror( "Size mismatch in operands" );
					
				_endif
				
			_endif
			Emit_bt_r_m( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs) );
 			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
		;}
    break;

  case 2511:

/* Line 1464 of yacc.c  */
#line 89151 "hlaparse.bsn"
    {
			char sn[ 256 ];
			struct adrsYYS adrs;
		
			_here;
			_if( (yyvsp[(1) - (6)].u) >= lockbts_instr )
			
				yyerror( "LOCK prefix requires a memory operand" );
				
			_endif
			_if( (yyvsp[(5) - (6)].v.pType) != tCset )

				yyerror( "Constant must be a character set constant" );

			_endif
			
			// Create the character set constant in memory:
			
			sprintf( sn, "cset" sympost "%d", LblCntr++ );
			startStrSeg();
			OutValue( sn, &cset_ste, YYS &(yyvsp[(5) - (6)].v) );
			endStrSeg();
			initAdrs( &adrs, -1, -1, 0, 0 );
			adrs.StaticName = sn;
			Emit_bt_r_m( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), &adrs );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (6)].u) ] );
			FreeValue( YYS &(yyvsp[(5) - (6)].v) );
			_here;
		;}
    break;

  case 2512:

/* Line 1464 of yacc.c  */
#line 89186 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = shld_instr;
		;}
    break;

  case 2513:

/* Line 1464 of yacc.c  */
#line 89192 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = shrd_instr;
		;}
    break;

  case 2514:

/* Line 1464 of yacc.c  */
#line 89208 "hlaparse.bsn"
    {
			_here;
			_if( IsOrdinal( (yyvsp[(3) - (8)].v.pType) ) && numBits32( YYS &(yyvsp[(3) - (8)].v) ) <= 32 )
			
				_if( isReg16( (yyvsp[(5) - (8)].u) ))
				
					_if( (yyvsp[(3) - (8)].v.u.unsval) < 16 )
				
						Emit_shxd_c_r_r( (yyvsp[(1) - (8)].u), (yyvsp[(3) - (8)].v.u.unsval), (yyvsp[(5) - (8)].u), (yyvsp[(7) - (8)].u) );
						
					_else
					
						yyerror( "Bit number must be between 0 and 15" );
					
					_endif
					
				_else
					
				
					_if( (yyvsp[(3) - (8)].v.u.unsval) < 32 )
				
						Emit_shxd_c_r_r( (yyvsp[(1) - (8)].u), (yyvsp[(3) - (8)].v.u.unsval), (yyvsp[(5) - (8)].u), (yyvsp[(7) - (8)].u) );
						
					_else
					
						yyerror( "Bit number must be between 0 and 31" );
					
					_endif
					
				_endif
				
			_else
		
				yyerror( "Expected ordinal value for bit number" );
			
			_endif
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(7) - (8)].u) ] );
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			_here;
		;}
    break;

  case 2515:

/* Line 1464 of yacc.c  */
#line 89260 "hlaparse.bsn"
    {
			_here;
			Emit_shxd_cl_r_r( (yyvsp[(1) - (8)].u), (yyvsp[(5) - (8)].u), (yyvsp[(7) - (8)].u) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(7) - (8)].u) ] );
			_here;
		;}
    break;

  case 2516:

/* Line 1464 of yacc.c  */
#line 89279 "hlaparse.bsn"
    {
			int regSize;
			
			_here;
			regSize = _ifx( isReg16( (yyvsp[(5) - (8)].u) ), 2, 4 );
			_if( (yyvsp[(7) - (8)].adrs.Size) == 0 )
			
				(yyvsp[(7) - (8)].adrs.Size) = regSize;
			
			_endif
			_if( IsOrdinal( (yyvsp[(3) - (8)].v.pType) ) && numBits32( YYS &(yyvsp[(3) - (8)].v) ) <= 32 )
			
				_if( regSize != (yyvsp[(7) - (8)].adrs.Size) )
				
					yyerror( "Memory operand size must match register size" );
					
				_endif
				_if( regSize == 2 && (yyvsp[(3) - (8)].v.u.unsval) >= 16 )
				
					yyerror( "Bit number must be between 0 and 15" );
					
				_elseif( regSize == 4 && (yyvsp[(3) - (8)].v.u.unsval) >= 32 ) 	
				
					yyerror( "Bit number must be between 0 and 31" );
						
				_endif
				Emit_shxd_c_r_m
				( 
					(yyvsp[(1) - (8)].u), 
					(yyvsp[(3) - (8)].v.u.unsval), 
					(yyvsp[(5) - (8)].u), 
					&(yyvsp[(7) - (8)].adrs) 
				);
				
			_else
		
				yyerror( "Expected ordinal value for bit number" );
			
			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(7) - (8)].adrs) );
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			_here;
		;}
    break;

  case 2517:

/* Line 1464 of yacc.c  */
#line 89338 "hlaparse.bsn"
    {
			int regSize;
			
			_here;
			regSize = _ifx( isReg16( (yyvsp[(5) - (8)].u) ), 2, 4 );
			_if( (yyvsp[(7) - (8)].adrs.Size) == 0 )
			
				(yyvsp[(7) - (8)].adrs.Size) = regSize;
			
			_endif
			_if( (yyvsp[(7) - (8)].adrs.Size) != regSize )
			
				yyerror( "Memory operand size must match register size" );
				
			_endif
			Emit_shxd_cl_r_m
			( 
				(yyvsp[(1) - (8)].u), 
				(yyvsp[(5) - (8)].u), 
				&(yyvsp[(7) - (8)].adrs) 
			);
			(yyval.returns) = FreeAdrs2( &(yyvsp[(7) - (8)].adrs) );
			_here;
		;}
    break;

  case 2518:

/* Line 1464 of yacc.c  */
#line 89397 "hlaparse.bsn"
    {
			_here;
			EmitLea_m_r( &(yyvsp[(5) - (6)].adrs), (yyvsp[(3) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ] );  
			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2519:

/* Line 1464 of yacc.c  */
#line 89415 "hlaparse.bsn"
    {
			_here;
			EmitLea_m_r( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );  
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2520:

/* Line 1464 of yacc.c  */
#line 89428 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
		;}
    break;

  case 2521:

/* Line 1464 of yacc.c  */
#line 89434 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
		;}
    break;

  case 2522:

/* Line 1464 of yacc.c  */
#line 89440 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
		;}
    break;

  case 2523:

/* Line 1464 of yacc.c  */
#line 89446 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
		;}
    break;

  case 2524:

/* Line 1464 of yacc.c  */
#line 89452 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
		;}
    break;

  case 2525:

/* Line 1464 of yacc.c  */
#line 89466 "hlaparse.bsn"
    {
			struct adrsYYS adrs;
			
			_here;
			initAdrs2( &adrs, (yyvsp[(5) - (6)].s)->StaticName, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, (yyvsp[(3) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ] );  
			_here;
		;}
    break;

  case 2526:

/* Line 1464 of yacc.c  */
#line 89484 "hlaparse.bsn"
    {
			struct adrsYYS adrs;
			
			_here;
			initAdrs2( &adrs, (yyvsp[(3) - (6)].s)->StaticName, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );  
			_here;
		;}
    break;

  case 2527:

/* Line 1464 of yacc.c  */
#line 89503 "hlaparse.bsn"
    {
			struct adrsYYS adrs;
			
			_here;
			initAdrs2( &adrs, (yyvsp[(4) - (7)].s)->StaticName, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, (yyvsp[(6) - (7)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(6) - (7)].reg.encoding) ] );  
			_here;
		;}
    break;

  case 2528:

/* Line 1464 of yacc.c  */
#line 89522 "hlaparse.bsn"
    {
			struct adrsYYS adrs;
			
			_here;
			initAdrs2( &adrs, (yyvsp[(6) - (7)].s)->StaticName, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, (yyvsp[(3) - (7)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (7)].reg.encoding) ] );  
			_here;
		;}
    break;

  case 2529:

/* Line 1464 of yacc.c  */
#line 89542 "hlaparse.bsn"
    {			
			SymNode_t 				*sym;
			struct StaticListType	*sList;
			struct FwdRefLabelType	*temp;
			char					sn[ 256 ];
			struct adrsYYS			adrs;
			struct FwdRefLabelType *flist;

			/*
			** We're taking the address of a label that has yet to be defined
			** in this procedure (note that the label could be defined
			** outside the current procedure as anything, but we'll
			** defer judgement on this until we finish processing the
			** current procedure).
			*/

			_here;

			/*
			** First, let's see if there is already a reference
			** to this particular identifier so we can use the
			** existing StaticName.
			*/

			flist = FwdLabelsList;
			_while( flist != NULL )

				_breakif( _streq( (yyvsp[(5) - (6)].idStr), flist->label ));
				flist = flist->Next;

			_endwhile

			_if( flist != NULL )

				flist->referenced = 1;
				
				/*
				** We found the symbol in the forward reference
				** list.  So just use the StaticName field of the
				** symbol we located as the target label.
				*/
			
				initAdrs2( &adrs, flist->StaticName, -1, -1, 0, 0 );
				EmitLea_m_r( &adrs, (yyvsp[(3) - (6)].reg.encoding) );
				

			_else
			
				// See if this symbol is in the static list:
				
				sList = searchStatic( (yyvsp[(5) - (6)].idStr) );
				_if( sList != NULL )
			
					initAdrs2( &adrs, sList->Name, -1, -1, 0, 0 );
					EmitLea_m_r( &adrs, (yyvsp[(3) - (6)].reg.encoding) );
			
				_else			

					/*
					** We didn't find the symbol in the forward reference
					** list, so add it to that list.
					*/


					temp = malloc2( sizeofFwdRefLabelType );
					temp->Next = FwdLabelsList;
					temp->label = hlastrdup2( (yyvsp[(5) - (6)].idStr) );
					temp->lexLevel = CurLexLevel;
					temp->isExternal = 0;
					temp->referenced = 1;
					sprintf( sn, "%s" sympost "%d", (yyvsp[(5) - (6)].idStr), LblCntr++ );
					temp->StaticName = hlastrdup2( sn );
					FwdLabelsList = temp;
					initAdrs2( &adrs, sn, -1, -1, 0, 0 );
					EmitLea_m_r( &adrs, (yyvsp[(3) - (6)].reg.encoding) );
					
				_endif

			_endif
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ] );
			_here;  

		;}
    break;

  case 2530:

/* Line 1464 of yacc.c  */
#line 89634 "hlaparse.bsn"
    {
			SymNode_t 				*sym;
			struct adrsYYS 			adrs;
			struct StaticListType	*sList;
			struct FwdRefLabelType	*temp;
			char 					sn[ 256 ];


			/*
			** We're taking the address of a label that has yet to be defined
			** in this procedure (note that the label could be defined
			** outside the current procedure as anything, but we'll
			** defer judgement on this until we finish processing the
			** current procedure).
			*/

			struct FwdRefLabelType *flist;

			_here;
			
			/*
			** First, let's see if there is already a reference
			** to this particular identifier so we can use the
			** existing StaticName.
			*/

			flist = FwdLabelsList;
			_while( flist != NULL )

				_breakif( _streq( (yyvsp[(3) - (6)].idStr), flist->label ));
				flist = flist->Next;

			_endwhile

			_if( flist != NULL )

				flist->referenced = 1;
				
				/*
				** We found the symbol in the forward reference
				** list.  So just use the StaticName field of the
				** symbol we located as the target label.
				*/

				initAdrs2( &adrs, flist->StaticName, -1, -1, 0, 0 );
				EmitLea_m_r( &adrs, (yyvsp[(5) - (6)].reg.encoding) );

			_else

				// See if this symbol is in the static list:
				
				sList = searchStatic( (yyvsp[(3) - (6)].idStr) );
				_if( sList != NULL )
			
					initAdrs2( &adrs, sList->Name, -1, -1, 0, 0 );
					EmitLea_m_r( &adrs, (yyvsp[(5) - (6)].reg.encoding) );
			
				_else			

					/*
					** We didn't find the symbol in the forward reference
					** list, so add it to that list.
					*/


					temp = malloc2( sizeofFwdRefLabelType );
					temp->Next = FwdLabelsList;
					temp->label = hlastrdup2( (yyvsp[(3) - (6)].idStr) );
					temp->lexLevel = CurLexLevel;
					temp->isExternal = 0;
					temp->referenced = 1;
					sprintf( sn, "%s" sympost "%d", (yyvsp[(3) - (6)].idStr), LblCntr++ );
					temp->StaticName = hlastrdup2( sn );
					FwdLabelsList = temp;
					initAdrs2( &adrs, sn, -1, -1, 0, 0 );
					EmitLea_m_r( &adrs, (yyvsp[(5) - (6)].reg.encoding) );
					
				_endif

			_endif
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;  
		;}
    break;

  case 2531:

/* Line 1464 of yacc.c  */
#line 89733 "hlaparse.bsn"
    {
			struct adrsYYS	adrs;
			int				lbl;
			char 			label[256];

			_here;
			lbl = EmitString( (yyvsp[(5) - (6)].v.u.strval) );
			sprintf( label, "str" sympost "%d", lbl );
			initAdrs2( &adrs, label, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, (yyvsp[(3) - (6)].reg.encoding) );
				
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ]);
			_if( langLevel <= medium_level )
			
				yyerror
				( 
					"LEA with a string operand is illegal except in \n"
					"high-level language mode."
				);
				
			_endif
		;}
    break;

  case 2532:

/* Line 1464 of yacc.c  */
#line 89764 "hlaparse.bsn"
    {
			struct adrsYYS	adrs;
			int				lbl;
			char 			label[256];

			_here;
			lbl = EmitString( (yyvsp[(3) - (6)].v.u.strval) );
			sprintf( label, "str" sympost "%d", lbl );
			initAdrs2( &adrs, label, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, (yyvsp[(5) - (6)].reg.encoding) );
				
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ]);
			_if( langLevel <= medium_level )
			
				yyerror
				( 
					"LEA with a string operand is illegal except in \n"
					"high-level language mode."
				);
				
			_endif
		;}
    break;

  case 2533:

/* Line 1464 of yacc.c  */
#line 89796 "hlaparse.bsn"
    {
			struct adrsYYS	adrs;
			int				lbl;
			char			label[256];

			_here;
			lbl = EmitString( (yyvsp[(4) - (7)].v.u.strval) );
			sprintf( label, "str" sympost "%d", lbl );
			initAdrs2( &adrs, label, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, (yyvsp[(6) - (7)].reg.encoding) );
				
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(6) - (7)].reg.encoding) ]);
			_if( langLevel <= medium_level )
			
				yyerror
				( 
					"LEA with a string operand is illegal except in \n"
					"high-level language mode."
				);
				
			_endif
		;}
    break;

  case 2534:

/* Line 1464 of yacc.c  */
#line 89828 "hlaparse.bsn"
    {
			struct adrsYYS	adrs;
			int				lbl;
			char 			label[256];

			_here;
			lbl = EmitString( (yyvsp[(6) - (7)].v.u.strval) );
			sprintf( label, "str" sympost "%d", lbl );
			initAdrs2( &adrs, label, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, (yyvsp[(3) - (7)].reg.encoding) );
				
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (7)].reg.encoding) ]);
			_if( langLevel <= medium_level )
			
				yyerror
				( 
					"LEA with a string operand is illegal except in \n"
					"high-level language mode."
				);
				
			_endif
		;}
    break;

  case 2535:

/* Line 1464 of yacc.c  */
#line 89862 "hlaparse.bsn"
    {
			int 			lbl;
			SymNode_t		*Type;
			struct adrsYYS	adrs;
			char			label[256];

			_here;
			Type = _ifx( (yyvsp[(6) - (7)].v.Type) == NULL, &(yyvsp[(6) - (7)].v), (yyvsp[(6) - (7)].v.Type) );
			startStrSeg();
			lbl = LblCntr++;
			sprintf
			( 
				label, 
				"leaData" sympost "%d", 
				lbl
			);
			
			// Reserve at least four bytes for the constant in memory:
			
			_if( Type->ObjectSize < 4 )
			
				Type = &dword_ste;
				
			_endif
			OutValue( label, Type, YYS &(yyvsp[(6) - (7)].v) );
			endStrSeg();
			
			initAdrs2( &adrs, label, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, (yyvsp[(3) - (7)].reg.encoding) );
			FreeValue( YYS &(yyvsp[(6) - (7)].v) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (7)].reg.encoding) ]);
			_if( langLevel <= medium_level )
			
				yyerror
				( 
					"LEA with a CONST operand is illegal except in \n"
					"high-level language mode."
				);
				
			_endif
			_here;
		;}
    break;

  case 2536:

/* Line 1464 of yacc.c  */
#line 89914 "hlaparse.bsn"
    {
			int 			lbl;
			SymNode_t		*Type;
			struct adrsYYS	adrs;
			char			label[256];

			_here;
			Type = _ifx( (yyvsp[(4) - (7)].v.Type) == NULL, &(yyvsp[(4) - (7)].v), (yyvsp[(4) - (7)].v.Type) );
			startStrSeg();
			lbl = LblCntr++;
			sprintf
			( 
				label, 
				"leaData" sympost "%d", 
				lbl
			);
			
			// Reserve at least four bytes for the constant in memory:
			
			_if( Type->ObjectSize < 4 )
			
				Type = &dword_ste;
				
			_endif
			OutValue( label, Type, YYS &(yyvsp[(4) - (7)].v) );
			endStrSeg();
			initAdrs2( &adrs, label, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, (yyvsp[(6) - (7)].reg.encoding) );
			FreeValue( YYS &(yyvsp[(4) - (7)].v) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(6) - (7)].reg.encoding) ]);
			_if( langLevel <= medium_level )
			
				yyerror
				( 
					"LEA with a CONST operand is illegal except in \n"
					"high-level language mode."
				);
				
			_endif
			_here;
		;}
    break;

  case 2537:

/* Line 1464 of yacc.c  */
#line 89979 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movsx_instr;
		;}
    break;

  case 2538:

/* Line 1464 of yacc.c  */
#line 89985 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = movzx_instr;
		;}
    break;

  case 2539:

/* Line 1464 of yacc.c  */
#line 89998 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					(yyvsp[(5) - (6)].reg.Size) != (yyvsp[(3) - (6)].reg.Size)*2
				&&	(yyvsp[(5) - (6)].reg.Size) != (yyvsp[(3) - (6)].reg.Size)*4
			)

				yyerror( "Dest operand must be larger than source operand" );

			_endif
			EmitMovxx_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ]);
			_here;
		;}
    break;

  case 2540:

/* Line 1464 of yacc.c  */
#line 90022 "hlaparse.bsn"
    {
			_here;
			_if
			( 
					(yyvsp[(5) - (6)].reg.Size) != (yyvsp[(3) - (6)].adrs.Size)*2
				&&	(yyvsp[(5) - (6)].reg.Size) != (yyvsp[(3) - (6)].adrs.Size)*4
			)

				yyerror( "Dest operand must be larger than source operand" );

			_endif
			EmitMovxx_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ]);
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2541:

/* Line 1464 of yacc.c  */
#line 90053 "hlaparse.bsn"
    {
			/*
			** We could actually handle this one (must be byte),
			** but just to be safe and consistent, give an error.
			*/

			yyerror( "Must specify memory size" );
			yyerror( SizeMismatchStr );
			FreeAdrs( &(yyvsp[(2) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ]);
		;}
    break;

  case 2542:

/* Line 1464 of yacc.c  */
#line 90090 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].reg.Size) )

				yyerror( "Register size mismatch" );

			_endif
			EmitXadd_r_r( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ]);
		;}
    break;

  case 2543:

/* Line 1464 of yacc.c  */
#line 90111 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].adrs.Size) && (yyvsp[(5) - (6)].adrs.Size) != 0 )

				yyerror( "Operand size mismatch" );

			_endif
			EmitXadd_r_m( (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs), 0 );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) ); 
			_here;
		;}
    break;

  case 2544:

/* Line 1464 of yacc.c  */
#line 90131 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].adrs.Size) && (yyvsp[(5) - (6)].adrs.Size) != 0 )

				yyerror( "Operand size mismatch" );

			_endif
			EmitXadd_r_m( (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs), 0xf0 );	// Lock prefix
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) ); 
			_here;
		;}
    break;

  case 2545:

/* Line 1464 of yacc.c  */
#line 90152 "hlaparse.bsn"
    {
			_here;
			yyerror( "Destination operand must be a memory location" );
			(yyval.returns) = NULL; 
			_here;
		;}
    break;

  case 2546:

/* Line 1464 of yacc.c  */
#line 90172 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpeqss_instr;
		;}
    break;

  case 2547:

/* Line 1464 of yacc.c  */
#line 90177 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpness_instr;
		;}
    break;

  case 2548:

/* Line 1464 of yacc.c  */
#line 90182 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpltss_instr;
		;}
    break;

  case 2549:

/* Line 1464 of yacc.c  */
#line 90187 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpnltss_instr;
		;}
    break;

  case 2550:

/* Line 1464 of yacc.c  */
#line 90192 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpless_instr;
		;}
    break;

  case 2551:

/* Line 1464 of yacc.c  */
#line 90197 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpnless_instr;
		;}
    break;

  case 2552:

/* Line 1464 of yacc.c  */
#line 90202 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpordss_instr;
		;}
    break;

  case 2553:

/* Line 1464 of yacc.c  */
#line 90207 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpunordss_instr;
		;}
    break;

  case 2554:

/* Line 1464 of yacc.c  */
#line 90221 "hlaparse.bsn"
    {
			int subop = (yyvsp[(3) - (6)].v.u.unsval);
			
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (6)].v.pType) ) || subop > 7 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..7" 
				);
				subop = 0;
				
			_endif
			EmitCmpss_r_r( subop, (yyvsp[(5) - (6)].rr).l, (yyvsp[(5) - (6)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].rr).r ] );
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			_here;
		;}
    break;

  case 2555:

/* Line 1464 of yacc.c  */
#line 90246 "hlaparse.bsn"
    {
			_here;
			EmitCmpss_r_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2556:

/* Line 1464 of yacc.c  */
#line 90265 "hlaparse.bsn"
    {
			int subop = (yyvsp[(3) - (8)].v.u.unsval);
			
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || subop > 7 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..7" 
				);
				subop = 0;
				
			_endif
			EmitCmpss_m_r( subop, &(yyvsp[(5) - (8)].adrs), (yyvsp[(7) - (8)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(7) - (8)].u) ] );
			FreeAdrs( &(yyvsp[(5) - (8)].adrs) );
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			_here;
		;}
    break;

  case 2557:

/* Line 1464 of yacc.c  */
#line 90295 "hlaparse.bsn"
    {
			_here;
			EmitCmpss_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2558:

/* Line 1464 of yacc.c  */
#line 90317 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpeqsd_instr;
		;}
    break;

  case 2559:

/* Line 1464 of yacc.c  */
#line 90322 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpnesd_instr;
		;}
    break;

  case 2560:

/* Line 1464 of yacc.c  */
#line 90327 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpltsd_instr;
		;}
    break;

  case 2561:

/* Line 1464 of yacc.c  */
#line 90332 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpnltsd_instr;
		;}
    break;

  case 2562:

/* Line 1464 of yacc.c  */
#line 90337 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmplesd_instr;
		;}
    break;

  case 2563:

/* Line 1464 of yacc.c  */
#line 90342 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpnlesd_instr;
		;}
    break;

  case 2564:

/* Line 1464 of yacc.c  */
#line 90347 "hlaparse.bsn"
    {
			(yyval.u) = cmpordsd_instr;
		;}
    break;

  case 2565:

/* Line 1464 of yacc.c  */
#line 90351 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpunordsd_instr;
		;}
    break;

  case 2566:

/* Line 1464 of yacc.c  */
#line 90367 "hlaparse.bsn"
    {
			int subop = (yyvsp[(3) - (8)].v.u.unsval);
			
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || subop > 7 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..7" 
				);
				subop = 0;
				
			_endif
			EmitCmpsd_r_r( subop, (yyvsp[(5) - (8)].u), (yyvsp[(7) - (8)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(7) - (8)].u) ] );
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			_here;
		;}
    break;

  case 2567:

/* Line 1464 of yacc.c  */
#line 90396 "hlaparse.bsn"
    {
			_here;
			EmitCmpsd_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2568:

/* Line 1464 of yacc.c  */
#line 90415 "hlaparse.bsn"
    {
			int subop = (yyvsp[(3) - (8)].v.u.unsval);
			
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || subop > 7 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..7" 
				);
				subop = 0;
				
			_endif
			EmitCmpsd_m_r( subop, &(yyvsp[(5) - (8)].adrs), (yyvsp[(7) - (8)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(7) - (8)].u) ] );
			FreeAdrs( &(yyvsp[(5) - (8)].adrs) );
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			_here;
		;}
    break;

  case 2569:

/* Line 1464 of yacc.c  */
#line 90445 "hlaparse.bsn"
    {
			_here;
			EmitCmpsd_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2570:

/* Line 1464 of yacc.c  */
#line 90462 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpeqps_instr;
		;}
    break;

  case 2571:

/* Line 1464 of yacc.c  */
#line 90467 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpneps_instr;
		;}
    break;

  case 2572:

/* Line 1464 of yacc.c  */
#line 90472 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpltps_instr;
		;}
    break;

  case 2573:

/* Line 1464 of yacc.c  */
#line 90477 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpnltps_instr;
		;}
    break;

  case 2574:

/* Line 1464 of yacc.c  */
#line 90482 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpleps_instr;
		;}
    break;

  case 2575:

/* Line 1464 of yacc.c  */
#line 90487 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpnleps_instr;
		;}
    break;

  case 2576:

/* Line 1464 of yacc.c  */
#line 90492 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpordps_instr;
		;}
    break;

  case 2577:

/* Line 1464 of yacc.c  */
#line 90497 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpunordps_instr;
		;}
    break;

  case 2578:

/* Line 1464 of yacc.c  */
#line 90510 "hlaparse.bsn"
    {
			int subop = (yyvsp[(3) - (6)].v.u.unsval);
			
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (6)].v.pType) ) || subop > 7 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..7" 
				);
				subop = 0;
				
			_endif
			EmitCmpps_r_r( subop, (yyvsp[(5) - (6)].rr).l, (yyvsp[(5) - (6)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].rr).r ] );
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			_here;
		;}
    break;

  case 2579:

/* Line 1464 of yacc.c  */
#line 90535 "hlaparse.bsn"
    {
			_here;
			EmitCmpps_r_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2580:

/* Line 1464 of yacc.c  */
#line 90554 "hlaparse.bsn"
    {
			int subop = (yyvsp[(3) - (8)].v.u.unsval);
			
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || subop > 7 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..7" 
				);
				subop = 0;
				
			_endif
			EmitCmpps_m_r( subop, &(yyvsp[(5) - (8)].adrs), (yyvsp[(7) - (8)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(7) - (8)].u) ] );
			FreeAdrs( &(yyvsp[(5) - (8)].adrs) );
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			_here;
		;}
    break;

  case 2581:

/* Line 1464 of yacc.c  */
#line 90580 "hlaparse.bsn"
    {
			_here;
			EmitCmpps_m_r( (yyvsp[(1) - (2)].u), &(yyvsp[(2) - (2)].mr.m), (yyvsp[(2) - (2)].mr.r) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].mr.r) ] );
			FreeAdrs( &(yyvsp[(2) - (2)].mr.m) );
			_here;
		;}
    break;

  case 2582:

/* Line 1464 of yacc.c  */
#line 90597 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpeqpd_instr;
		;}
    break;

  case 2583:

/* Line 1464 of yacc.c  */
#line 90602 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpnepd_instr;
		;}
    break;

  case 2584:

/* Line 1464 of yacc.c  */
#line 90607 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpltpd_instr;
		;}
    break;

  case 2585:

/* Line 1464 of yacc.c  */
#line 90612 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpnltpd_instr;
		;}
    break;

  case 2586:

/* Line 1464 of yacc.c  */
#line 90617 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmplepd_instr;
		;}
    break;

  case 2587:

/* Line 1464 of yacc.c  */
#line 90622 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpnlepd_instr;
		;}
    break;

  case 2588:

/* Line 1464 of yacc.c  */
#line 90627 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpordpd_instr;
		;}
    break;

  case 2589:

/* Line 1464 of yacc.c  */
#line 90632 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cmpunordpd_instr;
		;}
    break;

  case 2590:

/* Line 1464 of yacc.c  */
#line 90645 "hlaparse.bsn"
    {
			int subop = (yyvsp[(3) - (6)].v.u.unsval);
			
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (6)].v.pType) ) || subop > 7 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..7" 
				);
				subop = 0;
				
			_endif
			EmitCmppd_r_r( subop, (yyvsp[(5) - (6)].rr).l, (yyvsp[(5) - (6)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].rr).r ] );
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			_here;
		;}
    break;

  case 2591:

/* Line 1464 of yacc.c  */
#line 90670 "hlaparse.bsn"
    {
			_here;
			EmitCmppd_r_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2592:

/* Line 1464 of yacc.c  */
#line 90689 "hlaparse.bsn"
    {
			int subop = (yyvsp[(3) - (8)].v.u.unsval);
			
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || subop > 7 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..7" 
				);
				subop = 0;
				
			_endif
			EmitCmppd_m_r( subop, &(yyvsp[(5) - (8)].adrs), (yyvsp[(7) - (8)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(7) - (8)].u) ] );
			FreeAdrs( &(yyvsp[(5) - (8)].adrs) );
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			_here;
		;}
    break;

  case 2593:

/* Line 1464 of yacc.c  */
#line 90715 "hlaparse.bsn"
    {
			_here;
			EmitCmppd_m_r( (yyvsp[(1) - (2)].u), &(yyvsp[(2) - (2)].mr.m), (yyvsp[(2) - (2)].mr.r) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].mr.r) ] );
			FreeAdrs( &(yyvsp[(2) - (2)].mr.m) );
			_here;
		;}
    break;

  case 2594:

/* Line 1464 of yacc.c  */
#line 90735 "hlaparse.bsn"
    {
			_here;
			EmitMovnti_r_m( (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2595:

/* Line 1464 of yacc.c  */
#line 90755 "hlaparse.bsn"
    {
		
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || (yyvsp[(3) - (8)].v.u.unsval) > 255 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..255" 
				);
				
			_endif
			EmitPinsrw_r_r( (yyvsp[(3) - (8)].v.u.unsval), (yyvsp[(5) - (8)].u), (yyvsp[(7) - (8)].u), 0 );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(7) - (8)].u) ] );
			_here;
			
		;}
    break;

  case 2596:

/* Line 1464 of yacc.c  */
#line 90782 "hlaparse.bsn"
    {
		
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || (yyvsp[(3) - (8)].v.u.unsval) > 255 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..255" 
				);
				
			_endif
			EmitPinsrw_r_r( (yyvsp[(3) - (8)].v.u.unsval), (yyvsp[(5) - (8)].u), (yyvsp[(7) - (8)].u), 0x66 );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(7) - (8)].u) ] );
			_here;
			
		;}
    break;

  case 2597:

/* Line 1464 of yacc.c  */
#line 90811 "hlaparse.bsn"
    {
		
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || (yyvsp[(3) - (8)].v.u.unsval) > 255 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..255" 
				);
				
			_endif
			EmitPinsrw_m_r( (yyvsp[(3) - (8)].v.u.unsval), &(yyvsp[(5) - (8)].adrs), (yyvsp[(7) - (8)].u), 0 );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(7) - (8)].u) ] );
			FreeAdrs( &(yyvsp[(5) - (8)].adrs) );
			_here;
			
		;}
    break;

  case 2598:

/* Line 1464 of yacc.c  */
#line 90839 "hlaparse.bsn"
    {
		
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || (yyvsp[(3) - (8)].v.u.unsval) > 255 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..255" 
				);
				
			_endif
			EmitPinsrw_m_r( (yyvsp[(3) - (8)].v.u.unsval), &(yyvsp[(5) - (8)].adrs), (yyvsp[(7) - (8)].u), 0x66 );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(7) - (8)].u) ] );
			FreeAdrs( &(yyvsp[(5) - (8)].adrs) );
			_here;
			
		;}
    break;

  case 2599:

/* Line 1464 of yacc.c  */
#line 90870 "hlaparse.bsn"
    {
		
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || (yyvsp[(3) - (8)].v.u.unsval) > 255 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..255" 
				);
				
			_endif
			EmitPextrw_r_r( (yyvsp[(3) - (8)].v.u.unsval), (yyvsp[(5) - (8)].u), (yyvsp[(7) - (8)].reg.encoding), 0 );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(7) - (8)].reg.encoding) ] );
			_here;
			
		;}
    break;

  case 2600:

/* Line 1464 of yacc.c  */
#line 90897 "hlaparse.bsn"
    {
		
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || (yyvsp[(3) - (8)].v.u.unsval) > 255 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..255" 
				);
				
			_endif
			EmitPextrw_r_r( (yyvsp[(3) - (8)].v.u.unsval), (yyvsp[(5) - (8)].u), (yyvsp[(7) - (8)].reg.encoding), 0x66 );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(7) - (8)].reg.encoding) ] );
			_here;
			
		;}
    break;

  case 2601:

/* Line 1464 of yacc.c  */
#line 90922 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 0;
		;}
    break;

  case 2602:

/* Line 1464 of yacc.c  */
#line 90928 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 0x66;
		;}
    break;

  case 2603:

/* Line 1464 of yacc.c  */
#line 90941 "hlaparse.bsn"
    {
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (6)].v.pType) ) || (yyvsp[(3) - (6)].v.u.unsval) > 255 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..255" 
				);
				
			_endif
			EmitShufxx_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].v.u.unsval), (yyvsp[(5) - (6)].rr).l, (yyvsp[(5) - (6)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].rr).r ] );
			_here;
		;}
    break;

  case 2604:

/* Line 1464 of yacc.c  */
#line 90968 "hlaparse.bsn"
    {
			_here;
			_if( !IsSmallNumber( (yyvsp[(3) - (8)].v.pType) ) || (yyvsp[(3) - (8)].v.u.unsval) > 255 )
			
				yyerror
				( 
					"First operand must be an integer constant in the range 0..255" 
				);
				
			_endif
			EmitShufxx_m_r( (yyvsp[(1) - (8)].u), (yyvsp[(3) - (8)].v.u.unsval), &(yyvsp[(5) - (8)].adrs), (yyvsp[(7) - (8)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(7) - (8)].u)] );
			FreeAdrs( &(yyvsp[(5) - (8)].adrs) );
			_here;
		;}
    break;

  case 2605:

/* Line 1464 of yacc.c  */
#line 90993 "hlaparse.bsn"
    {
			char adrs[ 256 ];

			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) == 8 || (yyvsp[(3) - (4)].adrs.Size) == 0 )

				EmitCmpXchg8b( &(yyvsp[(3) - (4)].adrs) );

			_else

				yyerror( SizeMismatchStr );

			_endif
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2606:

/* Line 1464 of yacc.c  */
#line 91017 "hlaparse.bsn"
    {
			yyerror( "Syntax: 'cmpxchg8b( m64 )'" );
			(yyval.returns) = NULL;
		;}
    break;

  case 2607:

/* Line 1464 of yacc.c  */
#line 91036 "hlaparse.bsn"
    {
			_here;
			EmitMovq2dq_r_r( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2608:

/* Line 1464 of yacc.c  */
#line 91057 "hlaparse.bsn"
    {
			_here;
			EmitMovdq2q_r_r( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2609:

/* Line 1464 of yacc.c  */
#line 91076 "hlaparse.bsn"
    {
			_here;
			EmitPmovmskb_r_r( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].reg.encoding), 0 );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;
		;}
    break;

  case 2610:

/* Line 1464 of yacc.c  */
#line 91092 "hlaparse.bsn"
    {
			_here;
			EmitPmovmskb_r_r( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].reg.encoding), 0x66 );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;
		;}
    break;

  case 2611:

/* Line 1464 of yacc.c  */
#line 91111 "hlaparse.bsn"
    {
			_here;
			EmitMovntq_r_m( (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) ); 
			_here;
		;}
    break;

  case 2612:

/* Line 1464 of yacc.c  */
#line 91128 "hlaparse.bsn"
    {
			_here;
			EmitMovntdq_r_m( (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) ); 
			_here;
		;}
    break;

  case 2613:

/* Line 1464 of yacc.c  */
#line 91143 "hlaparse.bsn"
    {
			_here;
			EmitMaskMovq_r_r( (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2614:

/* Line 1464 of yacc.c  */
#line 91156 "hlaparse.bsn"
    {
			_here;
			EmitMaskMovdqu_r_r( (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2615:

/* Line 1464 of yacc.c  */
#line 91171 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = ucomiss_instr;
		;}
    break;

  case 2616:

/* Line 1464 of yacc.c  */
#line 91177 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = ucomisd_instr;
		;}
    break;

  case 2617:

/* Line 1464 of yacc.c  */
#line 91183 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = comiss_instr;
		;}
    break;

  case 2618:

/* Line 1464 of yacc.c  */
#line 91189 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = comisd_instr;
		;}
    break;

  case 2619:

/* Line 1464 of yacc.c  */
#line 91199 "hlaparse.bsn"
    {
			_here;
			EmitCom_r_r( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].rr).l, (yyvsp[(2) - (2)].rr).r );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(2) - (2)].rr).r ] );
			_here;
		;}
    break;

  case 2620:

/* Line 1464 of yacc.c  */
#line 91214 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (6)].u) == ucomiss_instr || (yyvsp[(1) - (6)].u) == comiss_instr )
			
				_if( (yyvsp[(3) - (6)].adrs.Size) != 4 && (yyvsp[(3) - (6)].adrs.Size) != 0 )
				
					yyerror( "Expected a dword/real32 memory operand" );
					
				_endif
				
			_elseif( (yyvsp[(1) - (6)].u) == ucomisd_instr || (yyvsp[(1) - (6)].u) == comisd_instr )
			
				_if( (yyvsp[(3) - (6)].adrs.Size) != 8 && (yyvsp[(3) - (6)].adrs.Size) != 0  )
				
					yyerror( "Expected a qword/real64 memory operand" );
					
				_endif
				
			_endif
			EmitCom_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2621:

/* Line 1464 of yacc.c  */
#line 91249 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtpd2pi_instr;
		;}
    break;

  case 2622:

/* Line 1464 of yacc.c  */
#line 91255 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvttpd2pi_instr;
		;}
    break;

  case 2623:

/* Line 1464 of yacc.c  */
#line 91268 "hlaparse.bsn"
    {
			_here;
			EmitPd2pi_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2624:

/* Line 1464 of yacc.c  */
#line 91284 "hlaparse.bsn"
    {
			_here;
			EmitPd2pi_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(5) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2625:

/* Line 1464 of yacc.c  */
#line 91303 "hlaparse.bsn"
    {
			_here;
			EmitPssd2pdss_r_r( cvtps2pd_instr, (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2626:

/* Line 1464 of yacc.c  */
#line 91319 "hlaparse.bsn"
    {
			_here;
			EmitPssd2pdss_r_r( cvtsd2ss_instr, (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2627:

/* Line 1464 of yacc.c  */
#line 91335 "hlaparse.bsn"
    {
			_here;
			EmitPssd2pdss_m_r( cvtps2pd_instr, &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2628:

/* Line 1464 of yacc.c  */
#line 91352 "hlaparse.bsn"
    {
			_here;
			EmitPssd2pdss_m_r( cvtsd2ss_instr, &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2629:

/* Line 1464 of yacc.c  */
#line 91369 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtpi2pd_instr;
		;}
    break;

  case 2630:

/* Line 1464 of yacc.c  */
#line 91375 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtpi2ps_instr;
		;}
    break;

  case 2631:

/* Line 1464 of yacc.c  */
#line 91389 "hlaparse.bsn"
    {
			_here;
			Emitpi2pdps_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2632:

/* Line 1464 of yacc.c  */
#line 91405 "hlaparse.bsn"
    {
			_here;
			Emitpi2pdps_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2633:

/* Line 1464 of yacc.c  */
#line 91420 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtps2pi_instr;
		;}
    break;

  case 2634:

/* Line 1464 of yacc.c  */
#line 91426 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvttps2pi_instr;
		;}
    break;

  case 2635:

/* Line 1464 of yacc.c  */
#line 91439 "hlaparse.bsn"
    {
			_here;
			Emitps2pi_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(5) - (6)].u) ] );
			_here;
		;}
    break;

  case 2636:

/* Line 1464 of yacc.c  */
#line 91455 "hlaparse.bsn"
    {
			_here;
			Emitps2pi_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToMmx[ (yyvsp[(5) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2637:

/* Line 1464 of yacc.c  */
#line 91469 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtsd2si_instr;
		;}
    break;

  case 2638:

/* Line 1464 of yacc.c  */
#line 91475 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvttsd2si_instr;
		;}
    break;

  case 2639:

/* Line 1464 of yacc.c  */
#line 91488 "hlaparse.bsn"
    {
			_here;
			Emitsd2si_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;
			
		;}
    break;

  case 2640:

/* Line 1464 of yacc.c  */
#line 91507 "hlaparse.bsn"
    {
			_here;
			Emitsd2si_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2641:

/* Line 1464 of yacc.c  */
#line 91523 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtss2si_instr;
		;}
    break;

  case 2642:

/* Line 1464 of yacc.c  */
#line 91529 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvttss2si_instr;
		;}
    break;

  case 2643:

/* Line 1464 of yacc.c  */
#line 91542 "hlaparse.bsn"
    {
			_here;
			Emitss2si_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;
			
		;}
    break;

  case 2644:

/* Line 1464 of yacc.c  */
#line 91561 "hlaparse.bsn"
    {
			_here;
			Emitss2si_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2645:

/* Line 1464 of yacc.c  */
#line 91579 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtsi2sd_instr;
		;}
    break;

  case 2646:

/* Line 1464 of yacc.c  */
#line 91585 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = cvtsi2ss_instr;
		;}
    break;

  case 2647:

/* Line 1464 of yacc.c  */
#line 91598 "hlaparse.bsn"
    {
			_here;
			Emitsi2sds_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
			
		;}
    break;

  case 2648:

/* Line 1464 of yacc.c  */
#line 91617 "hlaparse.bsn"
    {
			_here;
			Emitsi2sds_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2649:

/* Line 1464 of yacc.c  */
#line 91641 "hlaparse.bsn"
    {
			_here;
			Emitss2sd_r_r( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			_here;
			
		;}
    break;

  case 2650:

/* Line 1464 of yacc.c  */
#line 91660 "hlaparse.bsn"
    {
			_here;
			Emitss2sd_m_r( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToXmm[ (yyvsp[(5) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2651:

/* Line 1464 of yacc.c  */
#line 91672 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = clflush_instr;
		;}
    break;

  case 2652:

/* Line 1464 of yacc.c  */
#line 91678 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = prefetch0_instr;
		;}
    break;

  case 2653:

/* Line 1464 of yacc.c  */
#line 91684 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = prefetch1_instr;
		;}
    break;

  case 2654:

/* Line 1464 of yacc.c  */
#line 91690 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = prefetch2_instr;
		;}
    break;

  case 2655:

/* Line 1464 of yacc.c  */
#line 91696 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = prefetchnta_instr;
		;}
    break;

  case 2656:

/* Line 1464 of yacc.c  */
#line 91707 "hlaparse.bsn"
    {
			_here;
			EmitM8Instrs( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2657:

/* Line 1464 of yacc.c  */
#line 91720 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = NULL;
			implied_instr( pause_instr );
			_here;
		;}
    break;

  case 2658:

/* Line 1464 of yacc.c  */
#line 91734 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
			fence_instr( lfence_instr );
			_here;
		;}
    break;

  case 2659:

/* Line 1464 of yacc.c  */
#line 91745 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
			fence_instr( mfence_instr );
			_here;
		;}
    break;

  case 2660:

/* Line 1464 of yacc.c  */
#line 91756 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
			fence_instr( sfence_instr );
			_here;
		;}
    break;

  case 2661:

/* Line 1464 of yacc.c  */
#line 91770 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
			EmitMonitor( monitor_instr );
			_here;
		;}
    break;

  case 2662:

/* Line 1464 of yacc.c  */
#line 91782 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
			EmitMonitor( mwait_instr );
			_here;
		;}
    break;

  case 2663:

/* Line 1464 of yacc.c  */
#line 91795 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = ldmxcsr_instr;
		;}
    break;

  case 2664:

/* Line 1464 of yacc.c  */
#line 91801 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = stmxcsr_instr;
		;}
    break;

  case 2665:

/* Line 1464 of yacc.c  */
#line 91813 "hlaparse.bsn"
    {
			_here;
			EmitMxcsr( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );	
		;}
    break;

  case 2666:

/* Line 1464 of yacc.c  */
#line 91829 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = add_instr;
		;}
    break;

  case 2667:

/* Line 1464 of yacc.c  */
#line 91835 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockadd_instr;
		;}
    break;

  case 2668:

/* Line 1464 of yacc.c  */
#line 91841 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = adc_instr;
		;}
    break;

  case 2669:

/* Line 1464 of yacc.c  */
#line 91847 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockadc_instr;
		;}
    break;

  case 2670:

/* Line 1464 of yacc.c  */
#line 91853 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = and_instr;
		;}
    break;

  case 2671:

/* Line 1464 of yacc.c  */
#line 91859 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockand_instr;
		;}
    break;

  case 2672:

/* Line 1464 of yacc.c  */
#line 91865 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = xor_instr;
		;}
    break;

  case 2673:

/* Line 1464 of yacc.c  */
#line 91871 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockxor_instr;
		;}
    break;

  case 2674:

/* Line 1464 of yacc.c  */
#line 91877 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = or_instr;
		;}
    break;

  case 2675:

/* Line 1464 of yacc.c  */
#line 91883 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockor_instr;
		;}
    break;

  case 2676:

/* Line 1464 of yacc.c  */
#line 91889 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = sbb_instr;
		;}
    break;

  case 2677:

/* Line 1464 of yacc.c  */
#line 91895 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = locksbb_instr;
		;}
    break;

  case 2678:

/* Line 1464 of yacc.c  */
#line 91901 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = sub_instr;
		;}
    break;

  case 2679:

/* Line 1464 of yacc.c  */
#line 91907 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = locksub_instr;
		;}
    break;

  case 2680:

/* Line 1464 of yacc.c  */
#line 91921 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].reg.Size) )
			
				yyerror( "Register operands must be the same size" );
				(yyvsp[(3) - (6)].reg.Size) = (yyvsp[(5) - (6)].reg.Size);
				
			_endif
			EmitGeneric_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;
		;}
    break;

  case 2681:

/* Line 1464 of yacc.c  */
#line 91943 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].adrs.Size) && (yyvsp[(5) - (6)].adrs.Size) != 0 )
			
				yyerror( "Operands must be the same size" );
				(yyvsp[(3) - (6)].reg.Size) = (yyvsp[(5) - (6)].adrs.Size);
				
			_endif
			(yyvsp[(3) - (6)].adrs.forcedSize) = 0;
			EmitGeneric_r_m( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2682:

/* Line 1464 of yacc.c  */
#line 91966 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].adrs.Size) == 0 )
			
				(yyvsp[(3) - (6)].adrs.Size) = (yyvsp[(5) - (6)].reg.Size);
				(yyvsp[(3) - (6)].adrs.forcedSize) = 0;
				
			_endif
			_if( (yyvsp[(5) - (6)].reg.Size) != (yyvsp[(3) - (6)].adrs.Size) )
			
				yyerror( "Operands must be the same size" );
				(yyvsp[(5) - (6)].reg.Size) = (yyvsp[(3) - (6)].adrs.Size);
				
			_endif
			EmitGeneric_m_r( (yyvsp[(1) - (6)].u), &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2683:

/* Line 1464 of yacc.c  */
#line 91995 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].v.pType) != tPointer || (yyvsp[(5) - (6)].reg.Size) != 4 )
			 
				_if( !IsOrdinal( (yyvsp[(3) - (6)].v.pType) ))
				
					yyerror( "Expected an ordinal type for constant operand" );
					
				_elseif( (yyvsp[(5) - (6)].reg.Size) == 1 && numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 8 )
				
					yyerror( "Expected an 8-bit ordinal type in constant expression" );
				
				_elseif( (yyvsp[(5) - (6)].reg.Size) == 2 && numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 16 )
				
					yyerror( "Expected a 16-bit ordinal type in constant expression" );
					
				_elseif( (yyvsp[(5) - (6)].reg.Size) == 4 )
				
					_if( (yyvsp[(3) - (6)].v.pType) != tPointer && numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 32 )
				
						yyerror
						( 
							"Expected a 32-bit ordinal type in constant expression" 
						);
						
					_endif
					
				_endif
				
			_endif
			EmitGeneric_i_r( (yyvsp[(1) - (6)].u), YYS &(yyvsp[(3) - (6)].v), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			_here;
		;}
    break;

  case 2684:

/* Line 1464 of yacc.c  */
#line 92040 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].v.pType) != tPointer || (yyvsp[(5) - (6)].adrs.Size) != 4 )
			 
				_if( !IsOrdinal( (yyvsp[(3) - (6)].v.pType) ))
				
					yyerror( "Expected an ordinal type for constant operand" );
					
				_elseif( (yyvsp[(5) - (6)].adrs.Size) == 1 && numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 8 )
				
					yyerror( "Expected an 8-bit ordinal type in constant expression" );
				
				_elseif( (yyvsp[(5) - (6)].adrs.Size) == 2 && numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 16 )
				
					yyerror( "Expected a 16-bit ordinal type in constant expression" );
					
				_elseif( (yyvsp[(5) - (6)].adrs.Size) == 5 && numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 32 )
				
					yyerror( "Expected a 32-bit ordinal type in constant expression" );
					
				_endif
				
			_endif
			EmitGeneric_i_m( (yyvsp[(1) - (6)].u), YYS &(yyvsp[(3) - (6)].v), &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			_here;
		;}
    break;

  case 2685:

/* Line 1464 of yacc.c  */
#line 92077 "hlaparse.bsn"
    {
			_here;
			yyerror( "Unspecified memory size" );
			(yyval.returns) = NULL;
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2686:

/* Line 1464 of yacc.c  */
#line 92099 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].reg.Size) )
			
				yyerror( "Register operands must be the same size" );
				(yyvsp[(3) - (6)].reg.Size) = (yyvsp[(5) - (6)].reg.Size);
				
			_endif
			EmitGeneric_r_r( cmp_instr, (yyvsp[(5) - (6)].reg.encoding), (yyvsp[(3) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;
		;}
    break;

  case 2687:

/* Line 1464 of yacc.c  */
#line 92121 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].adrs.Size) && (yyvsp[(5) - (6)].adrs.Size) != 0 )
			
				yyerror( "Operands must be the same size" );
				(yyvsp[(3) - (6)].reg.Size) = (yyvsp[(5) - (6)].adrs.Size);
				
			_endif
			EmitGeneric_m_r( cmp_instr, &(yyvsp[(5) - (6)].adrs), (yyvsp[(3) - (6)].reg.encoding) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2688:

/* Line 1464 of yacc.c  */
#line 92143 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].adrs.Size) == 0 )
			
				(yyvsp[(3) - (6)].adrs.Size) = (yyvsp[(5) - (6)].reg.Size);
				
			_endif
			_if( (yyvsp[(5) - (6)].reg.Size) != (yyvsp[(3) - (6)].adrs.Size) )
			
				yyerror( "Operands must be the same size" );
				(yyvsp[(5) - (6)].reg.Size) = (yyvsp[(3) - (6)].adrs.Size);
				
			_endif
			EmitGeneric_r_m( cmp_instr, (yyvsp[(5) - (6)].reg.encoding), &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2689:

/* Line 1464 of yacc.c  */
#line 92171 "hlaparse.bsn"
    {
			_here;
			(yyvsp[(3) - (6)].adrs.Size) = (yyvsp[(5) - (6)].reg.Size);
			EmitGeneric_r_m( cmp_instr, (yyvsp[(5) - (6)].reg.encoding), &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2690:

/* Line 1464 of yacc.c  */
#line 92189 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(5) - (6)].v.pType) != tPointer || (yyvsp[(3) - (6)].reg.Size) != 4 )
			 
				_if( !IsOrdinal( (yyvsp[(5) - (6)].v.pType) ))
				
					yyerror( "Expected an ordinal type for constant operand" );
					
				_elseif( (yyvsp[(3) - (6)].reg.Size) == 1 && numBits32( YYS &(yyvsp[(5) - (6)].v) ) > 8 )
				
					yyerror( "Expected an 8-bit ordinal type in constant expression" );
				
				_elseif( (yyvsp[(3) - (6)].reg.Size) == 2 && numBits32( YYS &(yyvsp[(5) - (6)].v) ) > 16 )
				
					yyerror( "Expected a 16-bit ordinal type in constant expression" );
					
				_elseif( (yyvsp[(3) - (6)].reg.Size) == 4 )
				
					_if( (yyvsp[(5) - (6)].v.pType) != tPointer && numBits32( YYS &(yyvsp[(5) - (6)].v) ) > 32 )
				
						yyerror
						( 
							"Expected a 32-bit ordinal type in constant expression" 
						);
						
					_endif
					
				_endif
				
			_endif
			EmitGeneric_i_r( cmp_instr, YYS &(yyvsp[(5) - (6)].v), (yyvsp[(3) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ] );
			FreeValue( YYS &(yyvsp[(5) - (6)].v) );
			_here;
		;}
    break;

  case 2691:

/* Line 1464 of yacc.c  */
#line 92234 "hlaparse.bsn"
    {

			_here;
			_if( (yyvsp[(5) - (6)].v.pType) != tPointer || (yyvsp[(3) - (6)].adrs.Size) != 4 )
			 
				_if( !IsOrdinal( (yyvsp[(5) - (6)].v.pType) ))
				
					yyerror( "Expected an ordinal type for constant operand" );
					
				_elseif( (yyvsp[(3) - (6)].adrs.Size) == 1 && numBits32( YYS &(yyvsp[(5) - (6)].v) ) > 8 )
				
					yyerror( "Expected an 8-bit ordinal type in constant expression" );
				
				_elseif( (yyvsp[(3) - (6)].adrs.Size) == 2 && numBits32( YYS &(yyvsp[(5) - (6)].v) ) > 16 )
				
					yyerror( "Expected a 16-bit ordinal type in constant expression" );
					
				_elseif( (yyvsp[(3) - (6)].adrs.Size) == 5 && numBits32( YYS &(yyvsp[(5) - (6)].v) ) > 32 )
				
					yyerror( "Expected a 32-bit ordinal type in constant expression" );
					
				_endif
				
			_endif
			EmitGeneric_i_m( cmp_instr, YYS &(yyvsp[(5) - (6)].v), &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (6)].adrs) );
			FreeValue( YYS &(yyvsp[(5) - (6)].v) );
			_here;
		;}
    break;

  case 2692:

/* Line 1464 of yacc.c  */
#line 92272 "hlaparse.bsn"
    {
			_here;
			yyerror( "Unspecified memory size" );
			(yyval.returns) = NULL;
			FreeValue( YYS &(yyvsp[(5) - (6)].v) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2693:

/* Line 1464 of yacc.c  */
#line 92299 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = dec_instr;
		;}
    break;

  case 2694:

/* Line 1464 of yacc.c  */
#line 92305 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = inc_instr;
		;}
    break;

  case 2695:

/* Line 1464 of yacc.c  */
#line 92311 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = neg_instr;
		;}
    break;

  case 2696:

/* Line 1464 of yacc.c  */
#line 92317 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = not_instr;
		;}
    break;

  case 2697:

/* Line 1464 of yacc.c  */
#line 92323 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockdec_instr;
		;}
    break;

  case 2698:

/* Line 1464 of yacc.c  */
#line 92329 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockinc_instr;
		;}
    break;

  case 2699:

/* Line 1464 of yacc.c  */
#line 92335 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = lockneg_instr;
		;}
    break;

  case 2700:

/* Line 1464 of yacc.c  */
#line 92341 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = locknot_instr;
		;}
    break;

  case 2701:

/* Line 1464 of yacc.c  */
#line 92353 "hlaparse.bsn"
    {
			_here;
			EmitUnary_r( (yyvsp[(1) - (4)].u), (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (4)].reg.encoding) ] );
			_here;
		;}
    break;

  case 2702:

/* Line 1464 of yacc.c  */
#line 92367 "hlaparse.bsn"
    {
			_here;
			EmitUnary_m( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (4)].adrs) );
			_here;
		;}
    break;

  case 2703:

/* Line 1464 of yacc.c  */
#line 92380 "hlaparse.bsn"
    {
			yyerror( "Unspecified destination operand size" );
			(yyval.returns) = NULL;
			FreeAdrs( &(yyvsp[(2) - (4)].adrs) );
			_here;
		;}
    break;

  case 2704:

/* Line 1464 of yacc.c  */
#line 92428 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 2;
		;}
    break;

  case 2705:

/* Line 1464 of yacc.c  */
#line 92435 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 4;
		;}
    break;

  case 2706:

/* Line 1464 of yacc.c  */
#line 92442 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 8;
		;}
    break;

  case 2707:

/* Line 1464 of yacc.c  */
#line 92450 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 2;
		;}
    break;

  case 2708:

/* Line 1464 of yacc.c  */
#line 92458 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 4;
		;}
    break;

  case 2709:

/* Line 1464 of yacc.c  */
#line 92466 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 8;
		;}
    break;

  case 2710:

/* Line 1464 of yacc.c  */
#line 92474 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = div_instr;
		;}
    break;

  case 2711:

/* Line 1464 of yacc.c  */
#line 92480 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = mod_instr;
		;}
    break;

  case 2712:

/* Line 1464 of yacc.c  */
#line 92486 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = idiv_instr;
		;}
    break;

  case 2713:

/* Line 1464 of yacc.c  */
#line 92492 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = imod_instr;
		;}
    break;

  case 2714:

/* Line 1464 of yacc.c  */
#line 92506 "hlaparse.bsn"
    {
			_here;
			EmitUnary_r( (yyvsp[(1) - (4)].u), (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = 
				_ifx
				(
					(yyvsp[(1) - (4)].u) == div_instr || (yyvsp[(1) - (4)].u) == idiv_instr,
					hlastrdup2( divRETURNS[ (yyvsp[(3) - (4)].reg.Size) ] ),
					hlastrdup2( modRETURNS[ (yyvsp[(3) - (4)].reg.Size) ] )
				);
			_here;
		;}
    break;

  case 2715:

/* Line 1464 of yacc.c  */
#line 92528 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(4) - (5)].u) / 2 != (yyvsp[(3) - (5)].reg.Size) )

				yyerror( "Illegal source register size" );

			_endif
			EmitUnary_r( (yyvsp[(1) - (5)].u), (yyvsp[(3) - (5)].reg.encoding) );
			(yyval.returns) = 
				_ifx
				(
					(yyvsp[(1) - (5)].u) == div_instr || (yyvsp[(1) - (5)].u) == idiv_instr,
					hlastrdup2( divRETURNS[ (yyvsp[(3) - (5)].reg.Size) ] ),
					hlastrdup2( modRETURNS[ (yyvsp[(3) - (5)].reg.Size) ] )
				);
		;}
    break;

  case 2716:

/* Line 1464 of yacc.c  */
#line 92555 "hlaparse.bsn"
    {			
			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) == 0 )
				
				yyerror( "Must specify operand size" );
				(yyvsp[(3) - (4)].adrs.Size) = 4;
				(yyvsp[(3) - (4)].adrs.forcedSize) = 4;
				
			_endif
			EmitUnary_m( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = 
				_ifx
				(
					(yyvsp[(1) - (4)].u) == div_instr || (yyvsp[(1) - (4)].u) == idiv_instr,
					hlastrdup2( divRETURNS[ (yyvsp[(3) - (4)].reg.Size) ] ),
					hlastrdup2( modRETURNS[ (yyvsp[(3) - (4)].reg.Size) ] )
				);
			_here;
		;}
    break;

  case 2717:

/* Line 1464 of yacc.c  */
#line 92583 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (5)].adrs.Size) == 0 )
			
				(yyvsp[(3) - (5)].adrs.Size) = (yyvsp[(4) - (5)].u) / 2;
				(yyvsp[(3) - (5)].adrs.forcedSize) = (yyvsp[(3) - (5)].adrs.Size);
				
			_endif
			_if( (yyvsp[(4) - (5)].u) / 2 != (yyvsp[(3) - (5)].adrs.Size) )

				yyerror( SizeMismatchStr );

			_endif
			EmitUnary_m( (yyvsp[(1) - (5)].u), &(yyvsp[(3) - (5)].adrs) );
			(yyval.returns) = 
				_ifx
				(
					(yyvsp[(1) - (5)].u) == div_instr || (yyvsp[(1) - (5)].u) == idiv_instr,
					hlastrdup2( divRETURNS[ (yyvsp[(3) - (5)].reg.Size) ] ),
					hlastrdup2( modRETURNS[ (yyvsp[(3) - (5)].reg.Size) ] )
				);
			_here;
		;}
    break;

  case 2718:

/* Line 1464 of yacc.c  */
#line 92617 "hlaparse.bsn"
    {
			char			*divisor;
			enum PrimType	instrSize;
			int				size;
			struct	adrsYYS adrs;
			char			label[64];

			_here;
			size = (yyvsp[(4) - (5)].u) * 4;
			_if( (yyvsp[(1) - (5)].u) == idiv_instr || (yyvsp[(1) - (5)].u) == imod_instr )

				divisor = CheckOrdinal( YYS &(yyvsp[(3) - (5)].v), size );

			_else

				divisor = CheckUnsigned( YYS &(yyvsp[(3) - (5)].v), size );

			_endif
			sprintf( label, "divisor" sympost "%d", LblCntr++ );
			startStrSeg();
			instrSize =
				_ifx
				(
					size == 8,
					tByte,
					_ifx( size == 16, tWord, tDWord )
				);
			
			EmitData
			( 
				label,
				instrSize, 
				divisor 
			);
			endStrSeg();
			initLbl( &adrs, label, 0 );
			adrs.Size = (yyvsp[(4) - (5)].u) / 2;
			_if( (yyvsp[(4) - (5)].u) == 2 )	// $<u>4 is register pair size
			
				adrs.pType = tByte;
				adrs.Type = &byte_ste;
				
			_elseif( (yyvsp[(4) - (5)].u) == 4 )
			
				adrs.pType = tWord;
				adrs.Type = &word_ste;
				
			_else
			
				adrs.pType = tDWord;
				adrs.Type = &dword_ste;
				
			_endif
			EmitUnary_m( (yyvsp[(1) - (5)].u), &adrs );
			free2( vss divisor );
			FreeValue( YYS &(yyvsp[(3) - (5)].v) );
			(yyval.returns) = 
				_ifx
				(
					(yyvsp[(1) - (5)].u) == div_instr || (yyvsp[(1) - (5)].u) == idiv_instr,
					hlastrdup2( divRETURNS[ (yyvsp[(4) - (5)].u) ] ),
					hlastrdup2( modRETURNS[ (yyvsp[(4) - (5)].u) ] )
				);
			_here;
		;}
    break;

  case 2719:

/* Line 1464 of yacc.c  */
#line 92691 "hlaparse.bsn"
    {
			yyerror
			( 
				"DIV/IDIV/MOD/IMOD requires a second register operand "
				"with a constant operand"
			);
			FreeValue( YYS &(yyvsp[(3) - (4)].v) );
			(yyval.returns) = hlastrdup2( "eax" );
		;}
    break;

  case 2720:

/* Line 1464 of yacc.c  */
#line 92735 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 1;
		;}
    break;

  case 2721:

/* Line 1464 of yacc.c  */
#line 92742 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 2;
		;}
    break;

  case 2722:

/* Line 1464 of yacc.c  */
#line 92749 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 4;
		;}
    break;

  case 2723:

/* Line 1464 of yacc.c  */
#line 92757 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 1;
		;}
    break;

  case 2724:

/* Line 1464 of yacc.c  */
#line 92765 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 2;
		;}
    break;

  case 2725:

/* Line 1464 of yacc.c  */
#line 92773 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 4;
		;}
    break;

  case 2726:

/* Line 1464 of yacc.c  */
#line 92782 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = mul_instr;
		;}
    break;

  case 2727:

/* Line 1464 of yacc.c  */
#line 92788 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = imul_instr;
		;}
    break;

  case 2728:

/* Line 1464 of yacc.c  */
#line 92801 "hlaparse.bsn"
    {
			_here;
			EmitUnary_r( (yyvsp[(1) - (4)].u),  (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = hlastrdup2( mulRETURNS[ (yyvsp[(3) - (4)].reg.Size) ] );
			_here;
		;}
    break;

  case 2729:

/* Line 1464 of yacc.c  */
#line 92819 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (5)].reg.Size) != (yyvsp[(4) - (5)].u) )

				yyerror( "Illegal mul operand sizes" );

			_endif
			EmitUnary_r( (yyvsp[(1) - (5)].u),  (yyvsp[(3) - (5)].reg.encoding) );
			(yyval.returns) = hlastrdup2( mulRETURNS[ (yyvsp[(4) - (5)].u) ] );
			_here;
		;}
    break;

  case 2730:

/* Line 1464 of yacc.c  */
#line 92840 "hlaparse.bsn"
    {			/* $5 */
			_here;
			_if( (yyvsp[(3) - (4)].adrs.Size) == 0 )
				
				yyerror( "Must specify operand size" );
				(yyvsp[(3) - (4)].adrs.Size) = 4;
				(yyvsp[(3) - (4)].adrs.forcedSize) = 4;
				
			_endif
			EmitUnary_m( (yyvsp[(1) - (4)].u), &(yyvsp[(3) - (4)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = hlastrdup2( mulRETURNS[ (yyvsp[(3) - (4)].reg.Size) ] );
			_here;
		;}
    break;

  case 2731:

/* Line 1464 of yacc.c  */
#line 92865 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (5)].adrs.Size) == 0 )
			
				(yyvsp[(3) - (5)].adrs.Size) = (yyvsp[(4) - (5)].u);
				(yyvsp[(3) - (5)].adrs.forcedSize) = (yyvsp[(4) - (5)].u);
				
			_endif
			_if( (yyvsp[(3) - (5)].adrs.Size) != (yyvsp[(4) - (5)].u) )

				yyerror( SizeMismatchStr );
				(yyval.returns) = hlastrdup2( "ax" );

			_else

				EmitUnary_m( (yyvsp[(1) - (5)].u), &(yyvsp[(3) - (5)].adrs) );

			_endif
			FreeAdrs( &(yyvsp[(3) - (5)].adrs) );
			(yyval.returns) = hlastrdup2( mulRETURNS[ (yyvsp[(3) - (5)].reg.Size) ] );
			_here;
		;}
    break;

  case 2732:

/* Line 1464 of yacc.c  */
#line 92901 "hlaparse.bsn"
    {
			char			*mplier;
			enum PrimType	instrSize;
			int				size;
			struct	adrsYYS adrs;
			char			label[64];

			_here;
			size = (yyvsp[(4) - (5)].u) * 8;
			_if( (yyvsp[(1) - (5)].u) == imul_instr )

				mplier = CheckOrdinal( YYS &(yyvsp[(3) - (5)].v), size );

			_else

				mplier = CheckUnsigned( YYS &(yyvsp[(3) - (5)].v), size );

			_endif
			sprintf( label, "mplier" sympost "%d", LblCntr++ );
			startStrSeg();
			
			instrSize =
				_ifx
				(
					size == 8,
					tByte,
					_ifx( size == 16, tWord, tDWord )
				);
			
			EmitData
			( 
				label,
				instrSize, 
				mplier 
			);
			endStrSeg();
			initLbl( &adrs, label, 0 );
			adrs.Size = (yyvsp[(4) - (5)].u);
			EmitUnary_m( (yyvsp[(1) - (5)].u), &adrs );
			free2( vss mplier );
			FreeValue( YYS &(yyvsp[(3) - (5)].v) );
			(yyval.returns) = hlastrdup2( mulRETURNS[ (yyvsp[(4) - (5)].u) ] );
			_here;
		;}
    break;

  case 2733:

/* Line 1464 of yacc.c  */
#line 92962 "hlaparse.bsn"
    {
			yyerror
			( 
				"MUL requires a second register operand "
				"with a constant operand"
			);
			FreeValue( YYS &(yyvsp[(3) - (4)].v) );
			(yyval.returns) = hlastrdup2( "eax" );
		;}
    break;

  case 2734:

/* Line 1464 of yacc.c  */
#line 92998 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) == 1 )

				yyerror( "Eight bit registers are not allowed here" );

			_endif
			_if( CompileBound )
			
				EmitBound_r_m
				( 
					(yyvsp[(3) - (6)].reg.encoding), 
					&(yyvsp[(5) - (6)].adrs), 
					(yyvsp[(3) - (6)].reg.Size) 
				);
				
			_endif
			
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ] );
			_here;
		;}
    break;

  case 2735:

/* Line 1464 of yacc.c  */
#line 93033 "hlaparse.bsn"
    {
			unsigned LBound;
			unsigned UBound;

			_here;
			_if( (yyvsp[(3) - (8)].reg.Size) == 1 )

				yyerror( "Eight bit registers are not allowed here" );

			_endif
			LBound = CheckUnsignedSize( YYS &(yyvsp[(5) - (8)].v), (yyvsp[(3) - (8)].reg.Size) * 8 );
			UBound = CheckUnsignedSize( YYS &(yyvsp[(7) - (8)].v), (yyvsp[(3) - (8)].reg.Size) * 8 );
			_if( CompileBound )
			
				EmitBound_r_c_c
				( 
					(yyvsp[(3) - (8)].reg.encoding), 
					LBound,
					UBound,
					(yyvsp[(3) - (8)].reg.Size) 
				);

			_endif
			FreeValue( YYS &(yyvsp[(5) - (8)].v) );
			FreeValue( YYS &(yyvsp[(7) - (8)].v) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (8)].reg.encoding) ]);
			_here;
		;}
    break;

  case 2736:

/* Line 1464 of yacc.c  */
#line 93072 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) == 1 )

				yyerror( "Eight bit registers are not allowed here" );

			_endif
			_if( CompileBound )

				EmitBound_r_m( (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs), (yyvsp[(3) - (6)].reg.Size) );

			_endif
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (6)].reg.encoding) ]);
			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2737:

/* Line 1464 of yacc.c  */
#line 93103 "hlaparse.bsn"
    {
			_here;
			EmitArpl_r_r( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;
		;}
    break;

  case 2738:

/* Line 1464 of yacc.c  */
#line 93118 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(5) - (6)].adrs.Size) != 2 )
			
				yyerror( "ARPL operands must be word operands" );
				
			_endif
			EmitArpl_r_m( (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) ); 
			_here;
		;}
    break;

  case 2739:

/* Line 1464 of yacc.c  */
#line 93138 "hlaparse.bsn"
    {
			_here;
			(yyvsp[(5) - (6)].adrs.Size) = 2;
			EmitArpl_r_m( (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) ); 
			_here;
		;}
    break;

  case 2740:

/* Line 1464 of yacc.c  */
#line 93152 "hlaparse.bsn"
    {
			yyerror
			( 
				"Syntax error in arpl instr. Should be 'arpl(r16,r16)' "
				"or 'arpl(r16, m16)'"
			);
			(yyval.returns) = NULL;
		;}
    break;

  case 2741:

/* Line 1464 of yacc.c  */
#line 93190 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = ja_instr;
		;}
    break;

  case 2742:

/* Line 1464 of yacc.c  */
#line 93196 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jae_instr;
		;}
    break;

  case 2743:

/* Line 1464 of yacc.c  */
#line 93202 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jb_instr;
		;}
    break;

  case 2744:

/* Line 1464 of yacc.c  */
#line 93208 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jbe_instr;
		;}
    break;

  case 2745:

/* Line 1464 of yacc.c  */
#line 93214 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jc_instr;
		;}
    break;

  case 2746:

/* Line 1464 of yacc.c  */
#line 93220 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = je_instr;
		;}
    break;

  case 2747:

/* Line 1464 of yacc.c  */
#line 93226 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jg_instr;
		;}
    break;

  case 2748:

/* Line 1464 of yacc.c  */
#line 93232 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jge_instr;
		;}
    break;

  case 2749:

/* Line 1464 of yacc.c  */
#line 93238 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jl_instr;
		;}
    break;

  case 2750:

/* Line 1464 of yacc.c  */
#line 93244 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jle_instr;
		;}
    break;

  case 2751:

/* Line 1464 of yacc.c  */
#line 93250 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jna_instr;
		;}
    break;

  case 2752:

/* Line 1464 of yacc.c  */
#line 93256 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jnae_instr;
		;}
    break;

  case 2753:

/* Line 1464 of yacc.c  */
#line 93262 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jnb_instr;
		;}
    break;

  case 2754:

/* Line 1464 of yacc.c  */
#line 93268 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jnbe_instr;
		;}
    break;

  case 2755:

/* Line 1464 of yacc.c  */
#line 93274 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jnc_instr;
		;}
    break;

  case 2756:

/* Line 1464 of yacc.c  */
#line 93280 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jne_instr;
		;}
    break;

  case 2757:

/* Line 1464 of yacc.c  */
#line 93286 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jng_instr;
		;}
    break;

  case 2758:

/* Line 1464 of yacc.c  */
#line 93292 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jnge_instr;
		;}
    break;

  case 2759:

/* Line 1464 of yacc.c  */
#line 93298 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jnl_instr;
		;}
    break;

  case 2760:

/* Line 1464 of yacc.c  */
#line 93304 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jnle_instr;
		;}
    break;

  case 2761:

/* Line 1464 of yacc.c  */
#line 93310 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jno_instr;
		;}
    break;

  case 2762:

/* Line 1464 of yacc.c  */
#line 93316 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jnp_instr;
		;}
    break;

  case 2763:

/* Line 1464 of yacc.c  */
#line 93322 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jns_instr;
		;}
    break;

  case 2764:

/* Line 1464 of yacc.c  */
#line 93328 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jnz_instr;
		;}
    break;

  case 2765:

/* Line 1464 of yacc.c  */
#line 93334 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jo_instr;
		;}
    break;

  case 2766:

/* Line 1464 of yacc.c  */
#line 93340 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jp_instr;
		;}
    break;

  case 2767:

/* Line 1464 of yacc.c  */
#line 93346 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jpe_instr;
		;}
    break;

  case 2768:

/* Line 1464 of yacc.c  */
#line 93352 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jpo_instr;
		;}
    break;

  case 2769:

/* Line 1464 of yacc.c  */
#line 93358 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = js_instr;
		;}
    break;

  case 2770:

/* Line 1464 of yacc.c  */
#line 93364 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jz_instr;
		;}
    break;

  case 2771:

/* Line 1464 of yacc.c  */
#line 93370 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jcxz_instr;
		;}
    break;

  case 2772:

/* Line 1464 of yacc.c  */
#line 93376 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = jecxz_instr;
		;}
    break;

  case 2773:

/* Line 1464 of yacc.c  */
#line 93382 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = loop_instr;
		;}
    break;

  case 2774:

/* Line 1464 of yacc.c  */
#line 93388 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = loope_instr;
		;}
    break;

  case 2775:

/* Line 1464 of yacc.c  */
#line 93394 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = loopne_instr;
		;}
    break;

  case 2776:

/* Line 1464 of yacc.c  */
#line 93400 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = loopz_instr;
		;}
    break;

  case 2777:

/* Line 1464 of yacc.c  */
#line 93406 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = loopnz_instr;
		;}
    break;

  case 2778:

/* Line 1464 of yacc.c  */
#line 93418 "hlaparse.bsn"
    {
			_here;
			processCondJump( (yyvsp[(1) - (2)].u), (yyvsp[(2) - (2)].neID.idStr), TrueLabel, FalseLabel );
			(yyval.returns) = NULL;
			_here;
			
		;}
    break;

  case 2779:

/* Line 1464 of yacc.c  */
#line 93432 "hlaparse.bsn"
    {
			_here;
			processCondJump( (yyvsp[(1) - (4)].u), (yyvsp[(3) - (4)].neID.idStr), TrueLabel, FalseLabel );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2780:

/* Line 1464 of yacc.c  */
#line 93444 "hlaparse.bsn"
    {
			char label[64];
			
			_here;
			sprintf( label, "here" sympost "%d", LblCntr++ );
			EmitStmtLbl( label );
			EmitCondJump( (yyvsp[(1) - (3)].u), label );
			PushBackStr( ";" );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2781:

/* Line 1464 of yacc.c  */
#line 93464 "hlaparse.bsn"
    {
			int  disp;
			char label[64];
			
			_here;
			disp = CheckOrdinalSize( YYS &(yyvsp[(4) - (5)].v), 32 );
			sprintf( label, "here" sympost "%d", LblCntr );
			EmitStmtLbl( label );
			sprintf
			( 
				label, 
				"(here" sympost "%d%s%d)" , 
				LblCntr++, 
				_ifx( disp < 0, "", "+"),
				disp 
			);
			EmitCondJump( (yyvsp[(1) - (5)].u), label );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2782:

/* Line 1464 of yacc.c  */
#line 93497 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].reg.Size) )
			
				yyerror( SizeMismatchStr );
				
			_endif
			EmitTest_r_r( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( "@nz" );
			_here;
		;}
    break;

  case 2783:

/* Line 1464 of yacc.c  */
#line 93517 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(5) - (6)].adrs.Size) == 0 )
			
				(yyvsp[(5) - (6)].adrs.Size) = (yyvsp[(3) - (6)].reg.Size);
				
			_endif
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].adrs.Size) )
			
				yyerror( SizeMismatchStr );
				
			_endif
			EmitTest_r_m( (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs) );
			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( "@nz" );
			_here;
		;}
    break;

  case 2784:

/* Line 1464 of yacc.c  */
#line 93544 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].adrs.Size) == 0 )
			
				(yyvsp[(3) - (6)].adrs.Size) = (yyvsp[(5) - (6)].reg.Size);
				
			_endif
			_if( (yyvsp[(5) - (6)].reg.Size) != (yyvsp[(3) - (6)].adrs.Size) )
			
				yyerror( SizeMismatchStr );
				
			_endif
			EmitTest_m_r( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].reg.encoding) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( "@nz" );
			_here;
		;}
    break;

  case 2785:

/* Line 1464 of yacc.c  */
#line 93570 "hlaparse.bsn"
    {
			_here;
			_if( !IsOrdinal( (yyvsp[(3) - (6)].v.pType) ) )

				yyerror( "Expected an ordinal type in constant expression" );
			
			_endif
			_if( (yyvsp[(5) - (6)].reg.Size) == 1 && numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 8 )
			
				yyerror( "Expected an 8-bit constant" );
				
			_elseif( (yyvsp[(5) - (6)].reg.Size) == 2 && numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 16 )
			
				yyerror( "Expected a 16-bit constant" );
				
			_elseif( numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 32 )
			
				yyerror( "Expected a 32-bit constant" );
			
			_endif
			EmitTest_c_r( YYS &(yyvsp[(3) - (6)].v), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( "@nz" );
			_here;
		;}
    break;

  case 2786:

/* Line 1464 of yacc.c  */
#line 93603 "hlaparse.bsn"
    {
			_here;
			_if( !IsOrdinal( (yyvsp[(3) - (6)].v.pType) ) )

				yyerror( "Expected an ordinal type in constant expression" );
			
			_endif
			_if( (yyvsp[(5) - (6)].adrs.Size) == 1 && numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 8 )
			
				yyerror( "Expected an 8-bit constant" );
				
			_elseif( (yyvsp[(5) - (6)].adrs.Size) == 2 && numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 16 )
			
				yyerror( "Expected a 16-bit constant" );
				
			_elseif( numBits32( YYS &(yyvsp[(3) - (6)].v) ) > 32 )
			
				yyerror( "Expected a 32-bit constant" );
			
			_endif
			EmitTest_c_m( YYS &(yyvsp[(3) - (6)].v), &(yyvsp[(5) - (6)].adrs) );
			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( "@nz" );
			_here;
		;}
    break;

  case 2787:

/* Line 1464 of yacc.c  */
#line 93639 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 0;
		;}
    break;

  case 2788:

/* Line 1464 of yacc.c  */
#line 93645 "hlaparse.bsn"
    {
			_here;
			(yyval.u) = 1;
		;}
    break;

  case 2789:

/* Line 1464 of yacc.c  */
#line 93658 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].reg.Size) )
			
				yyerror( SizeMismatchStr );
				
			_else
			
				EmitXchg_r_r( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
				
			_endif
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;
		;}
    break;

  case 2790:

/* Line 1464 of yacc.c  */
#line 93681 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(3) - (6)].adrs.Size) != (yyvsp[(5) - (6)].reg.Size) && (yyvsp[(3) - (6)].adrs.Size) != 0 )
			
				yyerror( SizeMismatchStr );
				
			_else
			
				EmitXchg_r_m( (yyvsp[(1) - (6)].u), (yyvsp[(5) - (6)].reg.encoding), &(yyvsp[(3) - (6)].adrs) );
				
			_endif
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;
		;}
    break;

  case 2791:

/* Line 1464 of yacc.c  */
#line 93704 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(5) - (6)].adrs.Size) != (yyvsp[(3) - (6)].reg.Size) && (yyvsp[(5) - (6)].adrs.Size) != 0 )
			
				yyerror( SizeMismatchStr );
				
			_else
			
				EmitXchg_r_m( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs) );
				
			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2792:

/* Line 1464 of yacc.c  */
#line 93768 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = (yyvsp[(1) - (2)].returns);
		;}
    break;

  case 2793:

/* Line 1464 of yacc.c  */
#line 93778 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "al" );
			str_instr( lodsb_instr );
		;}
    break;

  case 2794:

/* Line 1464 of yacc.c  */
#line 93785 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "eax" );
			str_instr( lodsd_instr );
		;}
    break;

  case 2795:

/* Line 1464 of yacc.c  */
#line 93792 "hlaparse.bsn"
    { 
			_here; 
			(yyval.returns) = hlastrdup2( "ax" );
			str_instr( lodsw_instr );
		;}
    break;

  case 2796:

/* Line 1464 of yacc.c  */
#line 93802 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
			str_instr( (yyvsp[(1) - (1)].u) );
		;}
    break;

  case 2797:

/* Line 1464 of yacc.c  */
#line 93818 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
			str_instr( cmpsd_instr );
			_here;
		;}
    break;

  case 2798:

/* Line 1464 of yacc.c  */
#line 93830 "hlaparse.bsn"
    {			
			_here; 
			(yyval.returns) = NULL;
			str_instr( movsd_instr );
			_here;
		;}
    break;

  case 2799:

/* Line 1464 of yacc.c  */
#line 93839 "hlaparse.bsn"
    { _here; (yyval.u) = repe_cmpsb_instr; ;}
    break;

  case 2800:

/* Line 1464 of yacc.c  */
#line 93840 "hlaparse.bsn"
    { _here; (yyval.u) = repe_cmpsw_instr; ;}
    break;

  case 2801:

/* Line 1464 of yacc.c  */
#line 93841 "hlaparse.bsn"
    { _here; (yyval.u) = repe_cmpsd_instr; ;}
    break;

  case 2802:

/* Line 1464 of yacc.c  */
#line 93843 "hlaparse.bsn"
    { _here; (yyval.u) = repe_cmpsb_instr; ;}
    break;

  case 2803:

/* Line 1464 of yacc.c  */
#line 93844 "hlaparse.bsn"
    { _here; (yyval.u) = repe_cmpsw_instr; ;}
    break;

  case 2804:

/* Line 1464 of yacc.c  */
#line 93845 "hlaparse.bsn"
    { _here; (yyval.u) = repe_cmpsd_instr; ;}
    break;

  case 2805:

/* Line 1464 of yacc.c  */
#line 93847 "hlaparse.bsn"
    { _here; (yyval.u) = repe_scasb_instr; ;}
    break;

  case 2806:

/* Line 1464 of yacc.c  */
#line 93848 "hlaparse.bsn"
    { _here; (yyval.u) = repe_scasw_instr; ;}
    break;

  case 2807:

/* Line 1464 of yacc.c  */
#line 93849 "hlaparse.bsn"
    { _here; (yyval.u) = repe_scasd_instr; ;}
    break;

  case 2808:

/* Line 1464 of yacc.c  */
#line 93851 "hlaparse.bsn"
    { _here; (yyval.u) = repe_scasb_instr; ;}
    break;

  case 2809:

/* Line 1464 of yacc.c  */
#line 93852 "hlaparse.bsn"
    { _here; (yyval.u) = repe_scasw_instr; ;}
    break;

  case 2810:

/* Line 1464 of yacc.c  */
#line 93853 "hlaparse.bsn"
    { _here; (yyval.u) = repe_scasd_instr; ;}
    break;

  case 2811:

/* Line 1464 of yacc.c  */
#line 93855 "hlaparse.bsn"
    { _here; (yyval.u) = repne_cmpsb_instr; ;}
    break;

  case 2812:

/* Line 1464 of yacc.c  */
#line 93856 "hlaparse.bsn"
    { _here; (yyval.u) = repne_cmpsw_instr; ;}
    break;

  case 2813:

/* Line 1464 of yacc.c  */
#line 93857 "hlaparse.bsn"
    { _here; (yyval.u) = repne_cmpsd_instr; ;}
    break;

  case 2814:

/* Line 1464 of yacc.c  */
#line 93859 "hlaparse.bsn"
    { _here; (yyval.u) = repne_cmpsb_instr; ;}
    break;

  case 2815:

/* Line 1464 of yacc.c  */
#line 93860 "hlaparse.bsn"
    { _here; (yyval.u) = repne_cmpsw_instr; ;}
    break;

  case 2816:

/* Line 1464 of yacc.c  */
#line 93861 "hlaparse.bsn"
    { _here; (yyval.u) = repne_cmpsd_instr; ;}
    break;

  case 2817:

/* Line 1464 of yacc.c  */
#line 93863 "hlaparse.bsn"
    { _here; (yyval.u) = repne_scasb_instr; ;}
    break;

  case 2818:

/* Line 1464 of yacc.c  */
#line 93864 "hlaparse.bsn"
    { _here; (yyval.u) = repne_scasw_instr; ;}
    break;

  case 2819:

/* Line 1464 of yacc.c  */
#line 93865 "hlaparse.bsn"
    { _here; (yyval.u) = repne_scasd_instr; ;}
    break;

  case 2820:

/* Line 1464 of yacc.c  */
#line 93867 "hlaparse.bsn"
    { _here; (yyval.u) = repe_scasb_instr; ;}
    break;

  case 2821:

/* Line 1464 of yacc.c  */
#line 93868 "hlaparse.bsn"
    { _here; (yyval.u) = repe_scasw_instr; ;}
    break;

  case 2822:

/* Line 1464 of yacc.c  */
#line 93869 "hlaparse.bsn"
    { _here; (yyval.u) = repe_scasd_instr; ;}
    break;

  case 2823:

/* Line 1464 of yacc.c  */
#line 93871 "hlaparse.bsn"
    { _here; (yyval.u) = rep_movsb_instr; ;}
    break;

  case 2824:

/* Line 1464 of yacc.c  */
#line 93872 "hlaparse.bsn"
    { _here; (yyval.u) = rep_movsw_instr; ;}
    break;

  case 2825:

/* Line 1464 of yacc.c  */
#line 93873 "hlaparse.bsn"
    { _here; (yyval.u) = rep_movsd_instr; ;}
    break;

  case 2826:

/* Line 1464 of yacc.c  */
#line 93875 "hlaparse.bsn"
    { _here; (yyval.u) = rep_stosb_instr; ;}
    break;

  case 2827:

/* Line 1464 of yacc.c  */
#line 93876 "hlaparse.bsn"
    { _here; (yyval.u) = rep_stosw_instr; ;}
    break;

  case 2828:

/* Line 1464 of yacc.c  */
#line 93877 "hlaparse.bsn"
    { _here; (yyval.u) = rep_stosd_instr; ;}
    break;

  case 2829:

/* Line 1464 of yacc.c  */
#line 93879 "hlaparse.bsn"
    { _here; (yyval.u) = rep_insb_instr; ;}
    break;

  case 2830:

/* Line 1464 of yacc.c  */
#line 93880 "hlaparse.bsn"
    { _here; (yyval.u) = rep_insw_instr; ;}
    break;

  case 2831:

/* Line 1464 of yacc.c  */
#line 93881 "hlaparse.bsn"
    { _here; (yyval.u) = rep_insd_instr; ;}
    break;

  case 2832:

/* Line 1464 of yacc.c  */
#line 93883 "hlaparse.bsn"
    { _here; (yyval.u) = rep_outsb_instr; ;}
    break;

  case 2833:

/* Line 1464 of yacc.c  */
#line 93884 "hlaparse.bsn"
    { _here; (yyval.u) = rep_outsw_instr; ;}
    break;

  case 2834:

/* Line 1464 of yacc.c  */
#line 93885 "hlaparse.bsn"
    { _here; (yyval.u) = rep_outsd_instr; ;}
    break;

  case 2835:

/* Line 1464 of yacc.c  */
#line 93887 "hlaparse.bsn"
    { _here; (yyval.u) = cmpsb_instr; ;}
    break;

  case 2836:

/* Line 1464 of yacc.c  */
#line 93888 "hlaparse.bsn"
    { _here; (yyval.u) = cmpsw_instr; ;}
    break;

  case 2837:

/* Line 1464 of yacc.c  */
#line 93890 "hlaparse.bsn"
    { _here; (yyval.u) = scasb_instr; ;}
    break;

  case 2838:

/* Line 1464 of yacc.c  */
#line 93891 "hlaparse.bsn"
    { _here; (yyval.u) = scasw_instr; ;}
    break;

  case 2839:

/* Line 1464 of yacc.c  */
#line 93892 "hlaparse.bsn"
    { _here; (yyval.u) = scasd_instr; ;}
    break;

  case 2840:

/* Line 1464 of yacc.c  */
#line 93894 "hlaparse.bsn"
    { _here; (yyval.u) = movsb_instr; ;}
    break;

  case 2841:

/* Line 1464 of yacc.c  */
#line 93895 "hlaparse.bsn"
    { _here; (yyval.u) = movsw_instr; ;}
    break;

  case 2842:

/* Line 1464 of yacc.c  */
#line 93897 "hlaparse.bsn"
    { _here; (yyval.u) = stosb_instr; ;}
    break;

  case 2843:

/* Line 1464 of yacc.c  */
#line 93898 "hlaparse.bsn"
    { _here; (yyval.u) = stosw_instr;; ;}
    break;

  case 2844:

/* Line 1464 of yacc.c  */
#line 93899 "hlaparse.bsn"
    { _here; (yyval.u) = stosd_instr; ;}
    break;

  case 2845:

/* Line 1464 of yacc.c  */
#line 93901 "hlaparse.bsn"
    { _here; (yyval.u) = insb_instr;	;}
    break;

  case 2846:

/* Line 1464 of yacc.c  */
#line 93902 "hlaparse.bsn"
    { _here; (yyval.u) = insw_instr;	;}
    break;

  case 2847:

/* Line 1464 of yacc.c  */
#line 93903 "hlaparse.bsn"
    { _here; (yyval.u) = insd_instr;	;}
    break;

  case 2848:

/* Line 1464 of yacc.c  */
#line 93905 "hlaparse.bsn"
    { _here; (yyval.u) = outsb_instr; ;}
    break;

  case 2849:

/* Line 1464 of yacc.c  */
#line 93906 "hlaparse.bsn"
    { _here; (yyval.u) = outsw_instr; ;}
    break;

  case 2850:

/* Line 1464 of yacc.c  */
#line 93907 "hlaparse.bsn"
    { _here; (yyval.u) = outsd_instr; ;}
    break;

  case 2851:

/* Line 1464 of yacc.c  */
#line 93938 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = rol_instr;
		;}
    break;

  case 2852:

/* Line 1464 of yacc.c  */
#line 93944 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = ror_instr;
		;}
    break;

  case 2853:

/* Line 1464 of yacc.c  */
#line 93950 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = rcl_instr;
		;}
    break;

  case 2854:

/* Line 1464 of yacc.c  */
#line 93956 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = rcr_instr;
		;}
    break;

  case 2855:

/* Line 1464 of yacc.c  */
#line 93962 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = shl_instr;
		;}
    break;

  case 2856:

/* Line 1464 of yacc.c  */
#line 93968 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = sal_instr;
		;}
    break;

  case 2857:

/* Line 1464 of yacc.c  */
#line 93974 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = shr_instr;
		;}
    break;

  case 2858:

/* Line 1464 of yacc.c  */
#line 93980 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = sar_instr;
		;}
    break;

  case 2861:

/* Line 1464 of yacc.c  */
#line 94003 "hlaparse.bsn"
    {
			unsigned Shift;

			_here; 
			Shift = CheckUnsignedSize( YYS &(yyvsp[(3) - (6)].v), shiftSize[ (yyvsp[(5) - (6)].reg.Size) ] );
			EmitShiftRotate_c_r
			( 
				(yyvsp[(1) - (6)].u), 
				Shift,  
				(yyvsp[(5) - (6)].reg.encoding),
				(yyvsp[(5) - (6)].reg.Size) 
			);
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ]);
			_here; 
		;}
    break;

  case 2862:

/* Line 1464 of yacc.c  */
#line 94029 "hlaparse.bsn"
    {
			unsigned Shift;

			_here; 
			Shift = CheckUnsignedSize( YYS &(yyvsp[(3) - (6)].v), shiftSize[ (yyvsp[(5) - (6)].adrs.Size) ] );
			EmitShiftRotate_c_m
			( 
				(yyvsp[(1) - (6)].u), 
				Shift,  
				&(yyvsp[(5) - (6)].adrs) 
			);
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here; 
		;}
    break;

  case 2863:

/* Line 1464 of yacc.c  */
#line 94054 "hlaparse.bsn"
    {
			_here; 
			EmitShiftRotate_cl_r
			( 
				(yyvsp[(1) - (6)].u), 
				(yyvsp[(5) - (6)].reg.encoding),
				(yyvsp[(5) - (6)].reg.Size) 
			);
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ]);
			_here; 
		;}
    break;

  case 2864:

/* Line 1464 of yacc.c  */
#line 94075 "hlaparse.bsn"
    {
			_here; 
			EmitShiftRotate_cl_m
			( 
				(yyvsp[(1) - (6)].u), 
				&(yyvsp[(5) - (6)].adrs) 
			);
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here; 
		;}
    break;

  case 2865:

/* Line 1464 of yacc.c  */
#line 94099 "hlaparse.bsn"
    {
			yyerror( "Unspecified memory size" );
			(yyval.returns) = NULL;
			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			_here;
		;}
    break;

  case 2866:

/* Line 1464 of yacc.c  */
#line 94116 "hlaparse.bsn"
    {
			_here;
			yyerror( "Unspecified memory size" );
			(yyval.returns) = NULL;
			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2867:

/* Line 1464 of yacc.c  */
#line 94137 "hlaparse.bsn"
    {
			_here; 
			_if( checkSmallUns( YYS &(yyvsp[(3) - (4)].v) ))

				_if( (yyvsp[(3) - (4)].v.u.unsval) != 0 )

					ret_instr( (yyvsp[(3) - (4)].v.u.unsval) );

				_else

					ret_instr( -1 );

				_endif

			_else
			
				yyerror( "Expected 32-bit non-negative constant" );

			_endif
			FreeValue( YYS &(yyvsp[(3) - (4)].v) );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2868:

/* Line 1464 of yacc.c  */
#line 94164 "hlaparse.bsn"
    {
			_here; 
			ret_instr( -1 );
			(yyval.returns) = NULL;
		;}
    break;

  case 2869:

/* Line 1464 of yacc.c  */
#line 94176 "hlaparse.bsn"
    {
			(yyval.u) = reg_dseg;
			_here;
		;}
    break;

  case 2870:

/* Line 1464 of yacc.c  */
#line 94182 "hlaparse.bsn"
    {
			(yyval.u) = reg_eseg;
			_here;
		;}
    break;

  case 2871:

/* Line 1464 of yacc.c  */
#line 94188 "hlaparse.bsn"
    {
			(yyval.u) = reg_fseg;
			_here;
		;}
    break;

  case 2872:

/* Line 1464 of yacc.c  */
#line 94194 "hlaparse.bsn"
    {
			(yyval.u) = reg_gseg;
			_here;
		;}
    break;

  case 2873:

/* Line 1464 of yacc.c  */
#line 94200 "hlaparse.bsn"
    {
			(yyval.u) = reg_sseg;
			_here;
		;}
    break;

  case 2874:

/* Line 1464 of yacc.c  */
#line 94213 "hlaparse.bsn"
    {
			_here; 
			EmitLxS( (yyvsp[(1) - (6)].u), (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToSeg[ (yyvsp[(1) - (6)].u) ] );
			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			_here; 
		;}
    break;

  case 2875:

/* Line 1464 of yacc.c  */
#line 94237 "hlaparse.bsn"
    {			
			_here; 
			CompatGpReg( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			EmitMov_r_r( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here; 
		;}
    break;

  case 2876:

/* Line 1464 of yacc.c  */
#line 94256 "hlaparse.bsn"
    {
			_here; 
			_if( (yyvsp[(3) - (6)].v.pType) == tPointer )
			
				_if( (yyvsp[(5) - (6)].reg.Size) == 4 )
				
					EmitMov_o_r( (yyvsp[(3) - (6)].v.u.strval), 0, (yyvsp[(5) - (6)].reg.encoding) );
					
				_else
				
					yyerror( "Pointer const requires a 32-bit register" );
					
				_endif
			
			_else
			
				CompatGpRegConst( YYS &(yyvsp[(3) - (6)].v), (yyvsp[(5) - (6)].reg.encoding) );
				EmitMov_c_r( (yyvsp[(3) - (6)].v.u.unsval), (yyvsp[(5) - (6)].reg.encoding) );
				
			_endif  
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here; 
		;}
    break;

  case 2877:

/* Line 1464 of yacc.c  */
#line 94290 "hlaparse.bsn"
    {
			_here; 
			_if( IsOrdinal( (yyvsp[(3) - (6)].v.pType) ) )
			
				_if( (yyvsp[(3) - (6)].v.u.lwordval)[2] != 0 || (yyvsp[(3) - (6)].v.u.lwordval)[3] != 0 )
				
					_if
					( 
							(yyvsp[(3) - (6)].v.u.lwordval)[2] != 0xffffffff 
						||	(yyvsp[(3) - (6)].v.u.lwordval)[3] != 0xffffffff
						||	(yyvsp[(3) - (6)].v.u.lwordval)[1] <  0x80000000
					)
					
						yyerror( "Constant value is out of range" );
						
					_endif

				_endif
				
			_else
			
				yyerror( "Expected an ordinal type as constant operand" );
				
			_endif
			EmitMov_c_r( (yyvsp[(3) - (6)].v.u.lwordval)[1], reg_edx ); 		
			EmitMov_c_r( (yyvsp[(3) - (6)].v.u.lwordval)[0], reg_eax );
			(yyval.returns) = hlastrdup2( "edx:eax" ); 		
			_here; 
		;}
    break;

  case 2878:

/* Line 1464 of yacc.c  */
#line 94331 "hlaparse.bsn"
    {
			_here; 
			_if( IsOrdinal( (yyvsp[(3) - (6)].v.pType) ) )
			
				_if
				( 
						(yyvsp[(3) - (6)].v.u.lwordval)[1] != 0 
					||	(yyvsp[(3) - (6)].v.u.lwordval)[2] != 0 
					||	(yyvsp[(3) - (6)].v.u.lwordval)[3] != 0 
				)
				
					_if
					( 
							(yyvsp[(3) - (6)].v.u.lwordval)[2] != 0xffffffff 
						||	(yyvsp[(3) - (6)].v.u.lwordval)[3] != 0xffffffff
						||	(yyvsp[(3) - (6)].v.u.lwordval)[1] != 0xffffffff
						||	(yyvsp[(3) - (6)].v.u.lwordval)[0] <  0x80000000
					)
					
						yyerror( "Constant value is out of range" );
						
					_endif

				_endif
				
			_else
			
				yyerror( "Expected an ordinal type as constant operand" );
				
			_endif
			EmitMov_c_r( ((yyvsp[(3) - (6)].v.u.lwordval)[0] >> 16) & 0xffff, reg_dx ); 		
			EmitMov_c_r( (yyvsp[(3) - (6)].v.u.lwordval)[0] & 0xffff, reg_ax );
			(yyval.returns) = hlastrdup2( "dx:ax" ); 		
			_here; 
		;}
    break;

  case 2879:

/* Line 1464 of yacc.c  */
#line 94378 "hlaparse.bsn"
    {
			_here; 
			_if( (yyvsp[(5) - (6)].adrs.Size) != 1 && (yyvsp[(5) - (6)].adrs.Size) != 2 && (yyvsp[(5) - (6)].adrs.Size) != 4 )
			
				yyerror( "Memory operand must by a byte, word, or dword" );
				
			_else
			
				_if( (yyvsp[(3) - (6)].v.pType) == tPointer )
				
					_if( (yyvsp[(5) - (6)].adrs.Size) == 4 )
					
						EmitMov_o_m( (yyvsp[(3) - (6)].v.u.strval), 0, &(yyvsp[(5) - (6)].adrs) );
						
					_else
					
						yyerror( "Pointer const requires a dword memory operand" );
						
					_endif
				
				_else
				
					CompatMemConst( YYS &(yyvsp[(3) - (6)].v), &(yyvsp[(5) - (6)].adrs) );
					EmitMov_c_m( (yyvsp[(3) - (6)].v.u.unsval), &(yyvsp[(5) - (6)].adrs) );
					
				_endif
				
			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here;			
		;}
    break;

  case 2880:

/* Line 1464 of yacc.c  */
#line 94420 "hlaparse.bsn"
    {
			_here;			
			CompatGpReg( reg_ax, (yyvsp[(5) - (6)].u) );	// Make sure GPreg is 16-bits
			EmitMov_sr_r( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			_here;			
		;}
    break;

  case 2881:

/* Line 1464 of yacc.c  */
#line 94439 "hlaparse.bsn"
    {
			_here;			
			CompatGpReg( reg_ax, (yyvsp[(3) - (6)].reg.encoding) );	// Make sure GPreg is 16-bits
			_if( (yyvsp[(5) - (6)].u) == reg_cseg )
			
				yyerror( "Destination register cannot be cseg" );
				
			_endif
			EmitMov_r_sr( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( uToSeg[ (yyvsp[(5) - (6)].u) ] );
			_here;			
		;}
    break;

  case 2882:

/* Line 1464 of yacc.c  */
#line 94462 "hlaparse.bsn"
    {
			_here; 
			_if
			( 
					(yyvsp[(5) - (6)].adrs.Size) != 2 
				&&	(yyvsp[(5) - (6)].adrs.Size) != 0 
			)
			
				yyerror( "Memory operand must be a word" );
				
			_else
			
				EmitMov_sr_m( (yyvsp[(3) - (6)].u), &(yyvsp[(5) - (6)].adrs) );
				
			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here;			
		;}
    break;

  case 2883:

/* Line 1464 of yacc.c  */
#line 94492 "hlaparse.bsn"
    {
			_here; 
			_if( (yyvsp[(5) - (6)].u) == reg_cseg )
			
				yyerror( "Destination cannot be cseg" );
				
			_endif
			_if
			( 
					(yyvsp[(3) - (6)].adrs.Size) != 2 
				&&	(yyvsp[(3) - (6)].adrs.Size) != 0 
			)
			
				yyerror( "Memory operand must be a word" );
				
			_else
			
				EmitMov_m_sr( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].u) );
				
			_endif
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( uToSeg[ (yyvsp[(5) - (6)].u) ] );
			_here;			
		;}
    break;

  case 2884:

/* Line 1464 of yacc.c  */
#line 94528 "hlaparse.bsn"
    {
			_here;
			CompatGpReg( reg_eax, (yyvsp[(5) - (6)].reg.encoding) );	// Make sure GPreg is 32 bits
			EmitMov_cr_r( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[(yyvsp[(5) - (6)].reg.encoding)] );
			_here;			
		;}
    break;

  case 2885:

/* Line 1464 of yacc.c  */
#line 94547 "hlaparse.bsn"
    {
			_here;			
			CompatGpReg( reg_eax, (yyvsp[(3) - (6)].reg.encoding) );	// Make sure GPreg is 32 bits
			EmitMov_r_cr( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( ctrlStrs[(yyvsp[(5) - (6)].u)] );			
			_here;			
		;}
    break;

  case 2886:

/* Line 1464 of yacc.c  */
#line 94568 "hlaparse.bsn"
    {
			_here;
			CompatGpReg( reg_eax, (yyvsp[(5) - (6)].reg.encoding) );	// Make sure GPreg is 32 bits
			EmitMov_dr_r( (yyvsp[(3) - (6)].u), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[(yyvsp[(5) - (6)].reg.encoding)] );
			_here;			
		;}
    break;

  case 2887:

/* Line 1464 of yacc.c  */
#line 94587 "hlaparse.bsn"
    {
			_here;			
			CompatGpReg( reg_eax, (yyvsp[(3) - (6)].reg.encoding) );	// Make sure GPreg is 32 bits
			EmitMov_r_dr( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( ctrlStrs[(yyvsp[(5) - (6)].u)] );			
			_here;			
		;}
    break;

  case 2888:

/* Line 1464 of yacc.c  */
#line 94606 "hlaparse.bsn"
    {
			// Memory sizes must agree
			// Operands must be 16 or 32 bits
			// Can't both have size 0.
			
			_here; 
			_if( (yyvsp[(3) - (6)].adrs.Size) == 0 && (yyvsp[(5) - (6)].adrs.Size) == 0 )
			
				yyerror( "Must specify at least one operand size" );
				
			_else
			
				_if( (yyvsp[(3) - (6)].adrs.Size) == 0 )
				
					(yyvsp[(3) - (6)].adrs.Size) = (yyvsp[(5) - (6)].adrs.Size);
					
				_endif
				_if( (yyvsp[(5) - (6)].adrs.Size) == 0 )
				
					(yyvsp[(5) - (6)].adrs.Size) = (yyvsp[(3) - (6)].adrs.Size);
					
				_endif
				_if( (yyvsp[(3) - (6)].adrs.Size) != (yyvsp[(5) - (6)].adrs.Size) )
				
					yyerror( "Operands must be the same size" );
					(yyvsp[(3) - (6)].adrs.Size) = 4;
					(yyvsp[(5) - (6)].adrs.Size) = 4;
					
				_endif
				_if( (yyvsp[(3) - (6)].adrs.Size) != 2 && (yyvsp[(3) - (6)].adrs.Size) != 4 )
				
					yyerror( "Memory operands must be word or dword" );
					(yyvsp[(3) - (6)].adrs.Size) = 4;
					(yyvsp[(5) - (6)].adrs.Size) = 4;
					
				_endif
				push_mem( &(yyvsp[(3) - (6)].adrs), (yyvsp[(3) - (6)].adrs.Size) );
				pop_mem( &(yyvsp[(5) - (6)].adrs), (yyvsp[(5) - (6)].adrs.Size) );
				
			_endif
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_if( langLevel <= medium_level )
			
				yyerror
				( 
					"Memory-to-memory moves are illegal except in \n"
					"high-level language mode."
				);
				
			_endif
			_here; 
			
		;}
    break;

  case 2889:

/* Line 1464 of yacc.c  */
#line 94674 "hlaparse.bsn"
    {
			int memSize;
			int regSize;
			
			_here; 
			regSize = (yyvsp[(3) - (6)].reg.Size);
			memSize = _ifx( (yyvsp[(5) - (6)].adrs.Size) == 0, regSize, (yyvsp[(5) - (6)].adrs.Size) );
			_if( memSize != 1 && memSize != 2 && memSize != 4 )
			
				yyerror( "Memory operand must by a byte, word, or dword" );
				
				
			_elseif( regSize != memSize )
			
				yyerror( "Register and memory operands must be the same size!" );
				
			_else
			
				EmitMov_r_m( (yyvsp[(3) - (6)].reg.encoding), &(yyvsp[(5) - (6)].adrs), regSize );
					
			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2890:

/* Line 1464 of yacc.c  */
#line 94712 "hlaparse.bsn"
    {
			_here; 
			_if( (yyvsp[(5) - (6)].adrs.Size) != 8  )
			
				yyerror( "Memory operand must by a qword" );
				
				
			_else
			
				EmitMov_r_m( reg_eax, &(yyvsp[(5) - (6)].adrs), 4 );
				(yyvsp[(5) - (6)].adrs.Disp) += 4;
				EmitMov_r_m( reg_edx, &(yyvsp[(5) - (6)].adrs), 4 );
				(yyvsp[(5) - (6)].adrs.Disp) -= 4;
				
					
			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 2891:

/* Line 1464 of yacc.c  */
#line 94743 "hlaparse.bsn"
    {
		
			int memSize;
			int regSize;
			
			_here; 
			regSize = (yyvsp[(5) - (6)].reg.Size);
			memSize = _ifx( (yyvsp[(3) - (6)].adrs.Size) == 0, regSize, (yyvsp[(3) - (6)].adrs.Size) );
			_if( memSize != 1 && memSize != 2 && memSize != 4 )
			
				yyerror( "Memory operand must by a byte, word, or dword" );
				
				
			_elseif( regSize != memSize )
			
				yyerror( "Register and memory operands must be the same size!" );
				
			_else
			
				EmitMov_m_r( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].reg.encoding), regSize );
			
			_endif
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ] );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2892:

/* Line 1464 of yacc.c  */
#line 94781 "hlaparse.bsn"
    {
			_here; 
		
			_if( (yyvsp[(3) - (6)].adrs.Size) != 8 )
			
				yyerror( "Memory operand must by a qword" );
				
				
			_else
			
				EmitMov_m_r( &(yyvsp[(3) - (6)].adrs), reg_eax, 4 );
				(yyvsp[(3) - (6)].adrs.Disp) += 4;
				EmitMov_m_r( &(yyvsp[(3) - (6)].adrs), reg_edx, 4 );
				(yyvsp[(3) - (6)].adrs.Disp) -= 4;
			
			_endif
			(yyval.returns) = hlastrdup2( "edx:eax" );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 2893:

/* Line 1464 of yacc.c  */
#line 94824 "hlaparse.bsn"
    { 
			_here; 
			(yyval.u) = reg_al; 
		;}
    break;

  case 2894:

/* Line 1464 of yacc.c  */
#line 94830 "hlaparse.bsn"
    { 
			_here; 
			(yyval.u) = reg_ax; 
		;}
    break;

  case 2895:

/* Line 1464 of yacc.c  */
#line 94836 "hlaparse.bsn"
    { 
			_here; 
			(yyval.u) = reg_eax; 
		;}
    break;

  case 2896:

/* Line 1464 of yacc.c  */
#line 94846 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = (yyvsp[(1) - (1)].u);
		;}
    break;

  case 2897:

/* Line 1464 of yacc.c  */
#line 94853 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = (yyvsp[(2) - (2)].u);
		;}
    break;

  case 2900:

/* Line 1464 of yacc.c  */
#line 94875 "hlaparse.bsn"
    {
			unsigned Port;

			_here; 
			Port = CheckUnsignedSize( YYS &(yyvsp[(3) - (6)].v), 8 );
			EmitInOut( in_instr, Port, (yyvsp[(5) - (6)].u) );
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].u) ] );
			_here; 
		;}
    break;

  case 2901:

/* Line 1464 of yacc.c  */
#line 94895 "hlaparse.bsn"
    {
			_here;
			EmitInOutDX( in_instr, (yyvsp[(5) - (6)].u) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].u) ] );
			_here; 
		;}
    break;

  case 2902:

/* Line 1464 of yacc.c  */
#line 94912 "hlaparse.bsn"
    {
			unsigned Port;

			_here; 
			Port = CheckUnsignedSize( YYS &(yyvsp[(5) - (6)].v), 8 );
			EmitInOut( out_instr, Port, (yyvsp[(3) - (6)].u) );
			FreeValue( YYS &(yyvsp[(5) - (6)].v) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (6)].u) ] );
			_here; 
		;}
    break;

  case 2903:

/* Line 1464 of yacc.c  */
#line 94932 "hlaparse.bsn"
    {
			_here;
			EmitInOutDX( out_instr, (yyvsp[(3) - (6)].u) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (6)].u) ] );
			_here; 
		;}
    break;

  case 2904:

/* Line 1464 of yacc.c  */
#line 94981 "hlaparse.bsn"
    {
			_here; 
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].reg.Size) )

				yyerror( "Registers must be the same size" );

			_endif
			_if( (yyvsp[(3) - (6)].reg.Size) == 1 )

				yyerror( "intmul requires 16 or 32 bit registers" );

			_endif
			EmitIntMul_r_r( (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ]);
			_here; 
		;}
    break;

  case 2905:

/* Line 1464 of yacc.c  */
#line 95007 "hlaparse.bsn"
    {
			char adrs[ 256 ];

			_here; 
			_if( (yyvsp[(5) - (6)].reg.Size) == 1 )

				yyerror( "intmul requires 16 or 32 bit registers" );

			_endif
			EmitIntMul_m_r( &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].reg.encoding) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ]);
			_here; 
		;}
    break;

  case 2906:

/* Line 1464 of yacc.c  */
#line 95036 "hlaparse.bsn"
    {
			int multiplier;

			_here; 
			_if( (yyvsp[(5) - (6)].reg.Size) == 1 )

				yyerror( "intmul requires 16 or 32 bit registers" );

			_endif
			multiplier = CheckOrdinalSize( YYS &(yyvsp[(3) - (6)].v), (yyvsp[(5) - (6)].reg.Size)*8 );
			EmitIntMul_c_r_r( multiplier, (yyvsp[(5) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(5) - (6)].reg.encoding) ]);
			_here; 
		;}
    break;

  case 2907:

/* Line 1464 of yacc.c  */
#line 95067 "hlaparse.bsn"
    {
			int multiplier;

			_here; 
			_if( (yyvsp[(5) - (8)].reg.Size) != (yyvsp[(7) - (8)].reg.Size) )

				yyerror( "Registers must be the same size" );

			_endif
			_if( (yyvsp[(7) - (8)].reg.Size) == 1 )

				yyerror( "intmul requires 16 or 32 bit registers" );

			_endif
			multiplier = CheckOrdinalSize( YYS &(yyvsp[(3) - (8)].v), (yyvsp[(7) - (8)].reg.Size)*8 );
			EmitIntMul_c_r_r( multiplier, (yyvsp[(5) - (8)].reg.encoding), (yyvsp[(7) - (8)].reg.encoding) );
			FreeValue( YYS &(yyvsp[(3) - (8)].v) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(7) - (8)].reg.encoding) ]);
			_here; 
		;}
    break;

  case 2908:

/* Line 1464 of yacc.c  */
#line 95100 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(7) - (8)].reg.Size) == 1 )

				yyerror( "intmul requires 16 or 32 bit registers" );

			_endif
			EmitIntMul_c_m_r( (yyvsp[(3) - (8)].v.u.unsval), &(yyvsp[(5) - (8)].adrs), (yyvsp[(7) - (8)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(7) - (8)].reg.encoding) ]);
			_here;
		;}
    break;

  case 2909:

/* Line 1464 of yacc.c  */
#line 95133 "hlaparse.bsn"
    {
			unsigned LocalSize;
			unsigned NestLevel;

			_here; 
			LocalSize = CheckUnsignedSize( YYS &(yyvsp[(3) - (6)].v), 16 );
			NestLevel = CheckUnsignedSize( YYS &(yyvsp[(5) - (6)].v), 8 );
			EmitEnter_c_c( LocalSize, NestLevel );
			(yyval.returns) = NULL;
			FreeValue( YYS &(yyvsp[(3) - (6)].v) );
			FreeValue( YYS &(yyvsp[(5) - (6)].v) );
			_here; 
		;}
    break;

  case 2910:

/* Line 1464 of yacc.c  */
#line 95164 "hlaparse.bsn"
    {
			unsigned IntNum;

			_here; 
			IntNum = CheckUnsignedSize( YYS &(yyvsp[(3) - (4)].v), 8 );
			EmitInt_c( IntNum );
			FreeValue( YYS &(yyvsp[(3) - (4)].v) );
			(yyval.returns) = hlastrdup( "" );
			_here; 
		;}
    break;

  case 2911:

/* Line 1464 of yacc.c  */
#line 95193 "hlaparse.bsn"
    {
			_here;
			jmpTargetID( (yyvsp[(2) - (2)].idStr) );
			free2( vss (yyvsp[(2) - (2)].idStr) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2912:

/* Line 1464 of yacc.c  */
#line 95205 "hlaparse.bsn"
    {
			_here;
			EmitJmpLabel( (yyvsp[(2) - (2)].s)->StaticName );
			SetReferenced( (yyvsp[(2) - (2)].s) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2913:

/* Line 1464 of yacc.c  */
#line 95218 "hlaparse.bsn"
    {
			char label[64];
			
			_here;
			sprintf( label, "here" sympost "%d", LblCntr++ );
			EmitStmtLbl( label );
			EmitJmpLabel( label );
			PushBackStr( ";" );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2914:

/* Line 1464 of yacc.c  */
#line 95238 "hlaparse.bsn"
    {
			int  disp;
			char label[64];
			
			_here;
			disp = CheckOrdinalSize( YYS &(yyvsp[(4) - (5)].v), 32 );
			sprintf( label, "here" sympost "%d", LblCntr );
			EmitStmtLbl( label );
			sprintf
			( 
				label, 
				"(here" sympost "%d%s%d)" , 
				LblCntr++, 
				_ifx( disp < 0, "", "+"),
				disp 
			);
			EmitJmpLabel( label );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2915:

/* Line 1464 of yacc.c  */
#line 95268 "hlaparse.bsn"
    {
			_here; 
			_if( (yyvsp[(3) - (4)].adrs.Size) != 4 && (yyvsp[(3) - (4)].adrs.Size) != 0 )

				yyerror( "Pointer must be four bytes long" );

			_else

				EmitJmp_m( &(yyvsp[(3) - (4)].adrs) );

			_endif
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2916:

/* Line 1464 of yacc.c  */
#line 95292 "hlaparse.bsn"
    {
			_here; 
			EmitJmp_r( (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2917:

/* Line 1464 of yacc.c  */
#line 95303 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2918:

/* Line 1464 of yacc.c  */
#line 95310 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2919:

/* Line 1464 of yacc.c  */
#line 95317 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2920:

/* Line 1464 of yacc.c  */
#line 95324 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2921:

/* Line 1464 of yacc.c  */
#line 95332 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2922:

/* Line 1464 of yacc.c  */
#line 95339 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2923:

/* Line 1464 of yacc.c  */
#line 95346 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2924:

/* Line 1464 of yacc.c  */
#line 95358 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2925:

/* Line 1464 of yacc.c  */
#line 95365 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2926:

/* Line 1464 of yacc.c  */
#line 95372 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2927:

/* Line 1464 of yacc.c  */
#line 95379 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(1) - (1)].idStr);
		;}
    break;

  case 2928:

/* Line 1464 of yacc.c  */
#line 95384 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 2929:

/* Line 1464 of yacc.c  */
#line 95407 "hlaparse.bsn"
    {
			_here; 
			EmitBswap_r( (yyvsp[(3) - (4)].reg.encoding) );
			(yyval.returns) = hlastrdup2( regStrs[ (yyvsp[(3) - (4)].reg.encoding) ]);
			_here; 
		;}
    break;

  case 2930:

/* Line 1464 of yacc.c  */
#line 95420 "hlaparse.bsn"
    {
			yyerror( "BSWAP requires a 32-bit register operand" );
			(yyval.returns) = NULL;
		;}
    break;

  case 2931:

/* Line 1464 of yacc.c  */
#line 95429 "hlaparse.bsn"
    {
			yyerror( "BSWAP requires a 32-bit register operand" );
			(yyval.returns) = NULL;
		;}
    break;

  case 2932:

/* Line 1464 of yacc.c  */
#line 95464 "hlaparse.bsn"
    {
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].reg.Size) )
			_here; 

				yyerror( "Registers must be the same size" );

			_endif
			EmitCmpXchg_r_r( 0, (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2933:

/* Line 1464 of yacc.c  */
#line 95484 "hlaparse.bsn"
    {
			_here; 
			_if( (yyvsp[(3) - (6)].reg.Size) != (yyvsp[(5) - (6)].reg.Size) )

				yyerror( "Registers must be the same size" );

			_endif
			EmitCmpXchg_r_r( 1, (yyvsp[(3) - (6)].reg.encoding), (yyvsp[(5) - (6)].reg.encoding) );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2934:

/* Line 1464 of yacc.c  */
#line 95506 "hlaparse.bsn"
    {
			_here;
			EmitCmpXchg_m_r( 0, &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].reg.encoding) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2935:

/* Line 1464 of yacc.c  */
#line 95522 "hlaparse.bsn"
    {
			_here;
			EmitCmpXchg_m_r( 1, &(yyvsp[(3) - (6)].adrs), (yyvsp[(5) - (6)].reg.encoding) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2936:

/* Line 1464 of yacc.c  */
#line 95557 "hlaparse.bsn"
    {				/* $9 */

			char thunkname[ 256 ];
			char adrs[ 256 ];
			char constant[ 256 ];

			_here;
			sprintf( thunkname, "thunk_%u" sympost, (yyvsp[(5) - (8)].v.u.unsval) );
			pop_r( reg_ebp );
			ret_instr( 4 );
			EndProc( thunkname );
			NewLn();
			{
				char lbl[ 256 ];
				
				sprintf( lbl, "endthunk_%u" sympost, (yyvsp[(5) - (8)].v.u.unsval) );
				EmitStmtLbl( lbl );
			}
			(yyvsp[(3) - (8)].adrs.Disp) += 4;
			EmitMov_o_m( thunkname, 0, &(yyvsp[(3) - (8)].adrs) );
			(yyvsp[(3) - (8)].adrs.Disp) -= 4;
			EmitMov_r_m( reg_ebp, &(yyvsp[(3) - (8)].adrs), 4 );

			/*
			** Okay, now that we've processed this thunk, let's
			** make sure it's legal to have a thunk here.
			*/

			_if( (yyvsp[(3) - (8)].adrs.pType) != tThunk )

				yyerror
				( 
					"Type mismatch, expected a thunk type"
				);

			_endif
			(yyval.returns) = FreeAdrs2( &(yyvsp[(3) - (8)].adrs) );

			inThunk = (yyvsp[(2) - (8)].v.u.unsval);
			_here;
		;}
    break;

  case 2937:

/* Line 1464 of yacc.c  */
#line 95601 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.unsval) = inThunk;
			inThunk = 1;
		;}
    break;

  case 2938:

/* Line 1464 of yacc.c  */
#line 95610 "hlaparse.bsn"
    {
			int ThunkNum;
			char thunkname[ 256 ];
			char endthunk[ 256 ];
			struct adrsYYS adrs;

			_here;
			ThunkNum = LblCntr++;
			sprintf( thunkname, "thunk_%d" sympost, ThunkNum );
			sprintf( endthunk, "endthunk_%d" sympost, ThunkNum );
			EmitJmpLabel( endthunk );
			NewLn();
			EmitComment( "thunk begins here" );
			StartProc( thunkname );
			push_r( reg_ebp );
			initAdrs( &adrs, reg_esp, -1, 0, 8 );
			EmitMov_m_r( &adrs, reg_ebp, 4 );

			(yyval.v.u.intval) = ThunkNum;
			_here;
		;}
    break;

  case 2939:

/* Line 1464 of yacc.c  */
#line 95650 "hlaparse.bsn"
    {
			struct adrsYYS adrs;
			char symbol[ 256 ];
			char label[ 256 ];
			char mem[256];

			_here;
			need_raise = 1;
			(yyval.v.u.intval) = EndTryLabel;	/* Save current endtry lbl	*/
			EndTryLabel = LblCntr++;	/* Label for the endtry		*/
			++LblCntr;					/* Label for the 1st excptn	*/

			sprintf( symbol, "exception" sympost "%d", EndTryLabel+1 );
			PushStaticAdrs( symbol );
			push_r( reg_ebp );

			_if( targetOS == windows_os )
			
				initAdrs( &adrs, -1, -1, 0, 0 );
				fseg_prefix();
				EmitMov_m_r( &adrs, reg_ebp, 4 );
			
			_else
			
				_if( threadSafe )
				
					EmitCallLabel( "_HLA_GET_EXCEPTIONPTREBP" );
					need_HLA_GET_EXCEPTIONPTREBP = 1;
				
				_else
				
					initLbl( &adrs, ExceptionPtr, 0 );
					EmitMov_m_r( &adrs, reg_ebp, 4 );
					need_ExceptionPtr = 1;
					
				_endif
				
			_endif
			
			initAdrs( &adrs, reg_ebp, -1, 0, 8 );
			push_mem( &adrs, 4 );
			initAdrs( &adrs, reg_esp, -1, 0, 4 );
			EmitMov_m_r( &adrs, reg_ebp, 4 ); 			
			_if( targetOS == windows_os )
						
				PushStaticAdrs( "HWexcept" sympost );
				need_raise = 1;
				fseg_prefix();
				initAdrs( &adrs, -1, -1, 0, 0 );
				push_mem( &adrs, 4 );
				fseg_prefix();
				EmitMov_r_m( reg_esp, &adrs, 4 );
				
			_else
			
				// Linux/BSD/MacOS don't have SEH frames (like Windows),
				// so we'll use the entry at ESP+4 as a
				// signature value.
				
				_if( threadSafe )
				
					Pushd( 0xe8ce972 );
					push_r( reg_eax );
					EmitCallLabel( "_HLA_PUSH_EXCEPTIONPTR" );
					push_r( reg_eax );
					initLea_m_r( reg_esp, 4, reg_eax );
					push_r( reg_eax );
					EmitCallLabel( "_HLA_SET_EXCEPTIONPTR" );
					pop_r( reg_eax );
					need_HLA_PUSH_EXCEPTIONPTR = 1;
					need_HLA_SET_EXCEPTIONPTR  = 1;
				
				_else
				
					Pushd( 0xe8ce972 );
					initLbl( &adrs, ExceptionPtr, 0 );
					push_mem( &adrs, 4 );
					EmitMov_r_m( reg_esp, &adrs, 4 );
					need_ExceptionPtr = 1;
					
				_endif 			

			_endif
			_here;
		;}
    break;

  case 2940:

/* Line 1464 of yacc.c  */
#line 95741 "hlaparse.bsn"
    {
			struct adrsYYS adrs;

			_here;
			_if( targetOS == windows_os )
			
				fseg_prefix();
				initAdrs( &adrs, -1, -1, 0, 0 );
				EmitMov_m_r( &adrs, reg_esp, 4 );
				fseg_prefix();
				pop_memInit( NULL, -1, 0, 4 );
				EmitGeneric_c_r( add_instr, 8, reg_esp ); 
				pop_r( reg_ebp );
				EmitGeneric_c_r( add_instr, 4, reg_esp );
				
			_else
			
				_if( threadSafe )
				
					EmitCallLabel( "_HLA_GET_EXCEPTIONPTREBP" );
					EmitMov_r_r( reg_ebp, reg_esp );
					EmitCallLabel( "_HLA_SET_EXCEPTIONPTR" );
					EmitGeneric_c_r( add_instr, 8, reg_esp );
					pop_r( reg_ebp );
					EmitGeneric_c_r( add_instr, 4, reg_esp );
					need_HLA_GET_EXCEPTIONPTREBP = 1;
					need_HLA_SET_EXCEPTIONPTR    = 1;
					
				_else
				
					initLbl( &adrs, ExceptionPtr, 0 );
					EmitMov_m_r( &adrs, reg_esp, 4 );
					pop_mem( &adrs, 4 );
					EmitGeneric_c_r( add_instr, 8, reg_esp );
					pop_r( reg_ebp );
					EmitGeneric_c_r( add_instr, 4, reg_esp );
					need_ExceptionPtr = 1;
					
				_endif

			_endif
			_here;
		;}
    break;

  case 2941:

/* Line 1464 of yacc.c  */
#line 95797 "hlaparse.bsn"
    {
			WarnNear
			( 
				"try..endtry block without exception handler", 
				"endtry" 
			);
			EmitBackPatchds
			( 
				"exception" sympost "%d", 
				EndTryLabel + 1, 
				"Raise" sympost 
			);
			EndTryLabel = (yyvsp[(2) - (5)].v.u.intval);
			(yyval.returns) = NULL;
		;}
    break;

  case 2942:

/* Line 1464 of yacc.c  */
#line 95826 "hlaparse.bsn"
    {					/* $8 */

			WarnNear
			( 
				"try..unprotected..endtry block without exception handler", 
				"endtry" 
			);
			EmitBackPatchds
			( 
				"exception" sympost "%d", 
				EndTryLabel+1, 
				"Raise" sympost 
			); 
			EndTryLabel = (yyvsp[(2) - (7)].v.u.intval);
			(yyval.returns) = NULL;
		;}
    break;

  case 2943:

/* Line 1464 of yacc.c  */
#line 95856 "hlaparse.bsn"
    {					/* $6 */

			char label[ 256 ];

			_here; 
			sprintf( label, "tryAlways" sympost "%d", EndTryLabel );
			EmitCallLabel( label );
			sprintf( label, "endtry" sympost "%d", EndTryLabel );
			EmitJmpLabel( label );
			
			EmitStmtLblNum( "exception" sympost "%d", EndTryLabel + 1 );
			push_r( reg_eax );
			sprintf( label, "tryAlways" sympost "%d", EndTryLabel );
			EmitCallLabel( label );
			pop_r( reg_eax );
			EmitJmpLabel( "Raise" sympost );
			need_raise = 1;
			EmitStmtLblNum( "tryAlways" sympost "%d", EndTryLabel ); 
			_here; 
		;}
    break;

  case 2944:

/* Line 1464 of yacc.c  */
#line 95879 "hlaparse.bsn"
    {					/* $9 */

			_here; 
			ret_instr( -1 );
			
			EmitStmtLblNum( "endtry" sympost "%d", EndTryLabel ); 
			EndTryLabel = (yyvsp[(2) - (8)].v.u.intval);
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2945:

/* Line 1464 of yacc.c  */
#line 95906 "hlaparse.bsn"
    {					/* $6 */

			char label[ 256 ];

			_here; 
			sprintf( label, "endtry" sympost "%d", EndTryLabel );
			EmitJmpLabel( label );
			EmitStmtLblNum( "exception" sympost "%d", EndTryLabel + 1 );
			_here; 
		;}
    break;

  case 2946:

/* Line 1464 of yacc.c  */
#line 95919 "hlaparse.bsn"
    {					/* $9 */

			_here; 
			EmitStmtLblNum( "endtry" sympost "%d", EndTryLabel ); 
			EndTryLabel = (yyvsp[(2) - (8)].v.u.intval);
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2947:

/* Line 1464 of yacc.c  */
#line 95946 "hlaparse.bsn"
    {					/* $8 */

			char label[ 256 ];

			_here; 
			sprintf( label, "endtry" sympost "%d", EndTryLabel );
			EmitJmpLabel( label );
			EmitStmtLblNum( "exception" sympost "%d", EndTryLabel + 1 );
			_here; 

		;}
    break;

  case 2948:

/* Line 1464 of yacc.c  */
#line 95960 "hlaparse.bsn"
    {					/* $11 */
			_here; 
			EmitStmtLblNum( "endtry" sympost "%d", EndTryLabel );
			EndTryLabel = (yyvsp[(2) - (10)].v.u.intval);
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2949:

/* Line 1464 of yacc.c  */
#line 95987 "hlaparse.bsn"
    {						/* $9  */

			_here; 
			(yyval.v.u.intval) = LblCntr++;	/* Target for next exception */
			_if( !IsOrdinal( (yyvsp[(6) - (8)].v.pType) ) || numBits32( YYS &(yyvsp[(6) - (8)].v) ) > 32 )
			
				ErrorNear
				( 
					"Expected a 32-bit ordinal value", 
					"exception",
					__LINE__,
					__FILE__ 
				);
				
			_else
			 
				char label[ 256 ];
				char constant[ 256 ];

				sprintf( label, "endtry" sympost "%d", EndTryLabel );
				EmitJmpLabel( label );
				EmitStmtLblNum( "exception" sympost "%d", EndTryLabel+1 );
				EmitGeneric_i_r( cmp_instr, YYS &(yyvsp[(6) - (8)].v), reg_eax );
				sprintf( label, "exception" sympost "%u", (yyval.v.u.unsval) );
				EmitCondJump( jne_instr, label );

			_endif
			_here; 
		;}
    break;

  case 2950:

/* Line 1464 of yacc.c  */
#line 96019 "hlaparse.bsn"
    {						/* $11 */

			(yyval.v.u.intval) = (yyvsp[(9) - (10)].v.u.intval);
		;}
    break;

  case 2951:

/* Line 1464 of yacc.c  */
#line 96026 "hlaparse.bsn"
    {						/* $14 */
			_here; 
			EmitBackPatchds
			( 
				"exception" sympost "%u", 
				(yyvsp[(12) - (13)].v.u.unsval), 
				"Raise" sympost 
			);
			EmitStmtLblNum( "endtry" sympost "%d", EndTryLabel );
			EndTryLabel = (yyvsp[(2) - (13)].v.u.intval);
			(void) (yyvsp[(11) - (13)].v.u.intval);	// shut up bison
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2952:

/* Line 1464 of yacc.c  */
#line 96063 "hlaparse.bsn"
    {						/* $11 */

			_here; 
			(yyval.v.u.intval) = LblCntr++;	/* Target for next exception */
			_if( !IsOrdinal( (yyvsp[(9) - (10)].v.pType) ) || numBits32( YYS &(yyvsp[(9) - (10)].v) ) > 32 )
			
				ErrorNear
				( 
					"Expected a 32-bit ordinal value", 
					"exception",
					__LINE__,
					__FILE__ 
				);
				
			_else

				char label[ 256 ];
				char constant[16];
			 
				sprintf( label, "endtry" sympost "%d", EndTryLabel );
				EmitJmpLabel( label );
				EmitStmtLblNum( "exception" sympost "%d", EndTryLabel+1 );
				EmitGeneric_i_r( cmp_instr, YYS &(yyvsp[(9) - (10)].v), reg_eax );
				sprintf( label, "exception" sympost "%u", (yyval.v.u.unsval) );
				EmitCondJump( jne_instr, label );


			_endif
			_here; 
		;}
    break;

  case 2953:

/* Line 1464 of yacc.c  */
#line 96096 "hlaparse.bsn"
    {						/* $13 */

			(yyval.v.u.intval) = (yyvsp[(11) - (12)].v.u.intval);
		;}
    break;

  case 2954:

/* Line 1464 of yacc.c  */
#line 96103 "hlaparse.bsn"
    {						/* $16 */
			_here; 
			EmitBackPatchds
			( 
				"exception" sympost "%d", 
				(yyvsp[(14) - (15)].v.u.intval), 
				"Raise" sympost 
			);
			EmitStmtLblNum( "endtry" sympost "%d", EndTryLabel );
			EndTryLabel = (yyvsp[(2) - (15)].v.u.intval);
			(yyval.returns) = NULL;
			(void) (yyvsp[(13) - (15)].v.u.intval);	// shut up bison
			_here
		;}
    break;

  case 2955:

/* Line 1464 of yacc.c  */
#line 96135 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.intval) = (yyvsp[(0) - (1)].v.u.intval);
		;}
    break;

  case 2956:

/* Line 1464 of yacc.c  */
#line 96141 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.intval) = (yyvsp[(1) - (1)].v.u.intval);
		;}
    break;

  case 2957:

/* Line 1464 of yacc.c  */
#line 96150 "hlaparse.bsn"
    {						/* $2 */
			_here; 
			(yyval.v.u.intval) = (yyvsp[(1) - (1)].v.u.intval);
		;}
    break;

  case 2958:

/* Line 1464 of yacc.c  */
#line 96157 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.intval) = (yyvsp[(2) - (2)].v.u.intval);
		;}
    break;

  case 2959:

/* Line 1464 of yacc.c  */
#line 96166 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.intval) = (yyvsp[(1) - (1)].v.u.intval);
		;}
    break;

  case 2960:

/* Line 1464 of yacc.c  */
#line 96172 "hlaparse.bsn"
    {
			char label[ 256 ];

			_here; 
			sprintf( label, "endtry" sympost "%d", EndTryLabel );
			EmitJmpLabel( label );
			EmitStmtLblNum( "exception" sympost "%d", (yyvsp[(0) - (1)].v.u.intval) );
			_here; 
		;}
    break;

  case 2961:

/* Line 1464 of yacc.c  */
#line 96182 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.intval) = LblCntr++;
			(void) (yyvsp[(2) - (3)].s);	// shut up bison
		;}
    break;

  case 2962:

/* Line 1464 of yacc.c  */
#line 96195 "hlaparse.bsn"
    {					/* $5 */

			char label[ 256 ];
			char constant[16];

			_here; 
			_if( !IsOrdinal( (yyvsp[(3) - (4)].v.pType) ) || numBits32( YYS &(yyvsp[(3) - (4)].v) ) > 32 )

				ErrorNear
				( 
					"Expected a 32-bit ordinal value", 
					"exception",
					__LINE__,
					__FILE__ 
				);

			_endif
			(yyval.v.u.intval) = LblCntr++;

			sprintf( label, "endtry" sympost "%d", EndTryLabel );
			EmitJmpLabel( label );
			EmitStmtLblNum( "exception" sympost "%d", (yyvsp[(0) - (4)].v.u.intval) );
			EmitGeneric_i_r( cmp_instr, YYS &(yyvsp[(3) - (4)].v), reg_eax );
			sprintf( label, "exception" sympost "%u", (yyval.v.u.unsval) );
			EmitCondJump( jne_instr, label );
			_here; 
		;}
    break;

  case 2963:

/* Line 1464 of yacc.c  */
#line 96223 "hlaparse.bsn"
    {					/* $7 */
			_here; 
			(yyval.v.u.intval) = (yyvsp[(5) - (6)].v.u.intval);
		;}
    break;

  case 2964:

/* Line 1464 of yacc.c  */
#line 96239 "hlaparse.bsn"
    {				/* $5 */

			struct adrsYYS	adrs;
			int				lbl;
			char 			label[256];
			char 			constant[16];

			_here; 
			_if( !IsOrdinal( (yyvsp[(3) - (4)].v.pType) ) || numBits32( YYS &(yyvsp[(3) - (4)].v) ) > 32 )

				ErrorNear
				( 
					"Expected a 32-bit ordinal constant", 
					"raise",
					__LINE__,
					__FILE__ 
				);

			_endif
			
			// Note that we will move the current address into EBX
			// (handled by the destination RAISE code).
			
			// Emit the filename as a string so we can load this into ECX:
			
			lbl = EmitString( FileName );
			sprintf( label, "str" sympost "%d", lbl );
			initAdrs2( &adrs, label, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, reg_ecx );
			
			// Reserve EDX for a user error code.
			
			// Move the line # into EDI:
			
			EmitMov_c_r( LineCnt, reg_edi );		//Line # to EDI
			
			// Put the exception # into EAX:
			 
			EmitMov_c_r( (yyvsp[(3) - (4)].v.u.unsval), reg_eax );
			EmitCallLabel( "Raise" sympost );
			need_raise = 1;
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2965:

/* Line 1464 of yacc.c  */
#line 96288 "hlaparse.bsn"
    {				/* $5 */
			struct adrsYYS	adrs;
			int				lbl;
			char 			label[256];

			_here; 
			
			// Note that we will move the current address into EBX
			// (handled by the destination RAISE code).
			
			// Emit the filename as a string so we can load this into ECX:
			
			lbl = EmitString( FileName );
			sprintf( label, "str" sympost "%d", lbl );
			initAdrs2( &adrs, label, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, reg_ecx );
			
			// Reserve EDX for a user error code.
			
			// Move the line # into EDI:
			
			EmitMov_c_r( LineCnt, reg_edi );		//Line # to EDI
			
			// Put the exception # into EAX:
			 
			_if( (yyvsp[(3) - (4)].reg.Size) != 4 )

				EmitMovxx_r_r( movzx_instr, (yyvsp[(3) - (4)].reg.encoding), reg_eax );

			_elseif( stricmp( regStrs[ (yyvsp[(3) - (4)].reg.encoding) ], "eax" ) != 0 )

				EmitMov_r_r( (yyvsp[(3) - (4)].reg.encoding), reg_eax );

			_endif
			EmitCallLabel( "Raise" sympost );
			need_raise = 1;
		    (yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2966:

/* Line 1464 of yacc.c  */
#line 96333 "hlaparse.bsn"
    {				/* $5 */
			struct adrsYYS	adrs;
			int				lbl;
			char 			label[256];

			_here; 
			
			// Note that we will move the current address into EBX
			// (handled by the destination RAISE code).
			
			// Emit the filename as a string so we can load this into ECX:
			
			lbl = EmitString( FileName );
			sprintf( label, "str" sympost "%d", lbl );
			initAdrs2( &adrs, label, -1, -1, 0, 0 );
			EmitLea_m_r( &adrs, reg_ecx );
			
			// Reserve EDX for a user error code.
			
			// Move the line # into EDI:
			
			EmitMov_c_r( LineCnt, reg_edi );		//Line # to EDI
			
			// Put the exception # into EAX:
			 
			_if( (yyvsp[(3) - (4)].adrs.Size) > 4 )

				yyerror( "Raise expression must be a 32-bit value" );

			_endif
			_if( (yyvsp[(3) - (4)].adrs.Size) == 1 || (yyvsp[(3) - (4)].adrs.Size) == 2 )

				EmitMovxx_m_r( movzx_instr, &(yyvsp[(3) - (4)].adrs), reg_eax );

			_else 

				EmitMov_m_r( &(yyvsp[(3) - (4)].adrs), reg_eax, 4 );

			_endif
			EmitCallLabel( "Raise" sympost );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			need_raise = 1;
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2967:

/* Line 1464 of yacc.c  */
#line 96388 "hlaparse.bsn"
    {				/* $5 */

			struct adrsYYS	adrs;
			int				lbl;
			char 			label[256];
			char 			constant[16];

			_here; 
			_if( !IsOrdinal( (yyvsp[(3) - (4)].v.pType) ) || numBits32( YYS &(yyvsp[(3) - (4)].v) ) > 32 )

				ErrorNear
				( 
					"Expected a 32-bit ordinal constant", 
					"raise",
					__LINE__,
					__FILE__ 
				);

			_endif
			
			// Put the exception # into EAX:
			 
			EmitMov_c_r( (yyvsp[(3) - (4)].v.u.unsval), reg_eax );
			
			// Put return address back on stack because the Raise code
			// will pop it off:
			
			push_r( reg_ebx );
			
			EmitJmpLabel( "Raise" sympost );
			need_raise = 1;
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2968:

/* Line 1464 of yacc.c  */
#line 96427 "hlaparse.bsn"
    {				/* $5 */
			struct adrsYYS	adrs;
			int				lbl;
			char 			label[256];

			_here; 
			
			// Put the exception # into EAX:
			 
			_if( (yyvsp[(3) - (4)].reg.Size) != 4 )

				EmitMovxx_r_r( movzx_instr, (yyvsp[(3) - (4)].reg.encoding), reg_eax );

			_elseif( stricmp( regStrs[ (yyvsp[(3) - (4)].reg.encoding) ], "eax" ) != 0 )

				EmitMov_r_r( (yyvsp[(3) - (4)].reg.encoding), reg_eax );

			_endif
			
			// Put return address back on stack because the Raise code
			// will pop it off:
			
			push_r( reg_ebx );
			
			EmitJmpLabel( "Raise" sympost );
			need_raise = 1;
		    (yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2969:

/* Line 1464 of yacc.c  */
#line 96462 "hlaparse.bsn"
    {				/* $5 */
			struct adrsYYS	adrs;
			int				lbl;
			char 			label[256];

			_here; 
			
			// Put the exception # into EAX:
			 
			_if( (yyvsp[(3) - (4)].adrs.Size) > 4 )

				yyerror( "Raise expression must be a 32-bit value" );

			_endif
			_if( (yyvsp[(3) - (4)].adrs.Size) == 1 || (yyvsp[(3) - (4)].adrs.Size) == 2 )

				EmitMovxx_m_r( movzx_instr, &(yyvsp[(3) - (4)].adrs), reg_eax );

			_else 

				EmitMov_m_r( &(yyvsp[(3) - (4)].adrs), reg_eax, 4 );

			_endif
			
			// Put return address back on stack because the Raise code
			// will pop it off:
			
			push_r( reg_ebx );
			
			EmitJmpLabel( "Raise" sympost );
			FreeAdrs( &(yyvsp[(3) - (4)].adrs) );
			need_raise = 1;
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 2970:

/* Line 1464 of yacc.c  */
#line 96530 "hlaparse.bsn"
    {				/* $16 */

			char tmpLabel[256];

			_here;
			EmitStmtLblNum( "continue" sympost "%d", (yyvsp[(5) - (15)].labels.l1.label1) );
			asmPuts( (yyvsp[(11) - (15)].v.u.strval) );
			asmPutc( '\n' );
			EmitStmtLblNum( "StartFor" sympost "%d", (yyvsp[(5) - (15)].labels.l1.label1) );
			sprintf( tmpLabel, "for" sympost "%d", (yyvsp[(5) - (15)].labels.l1.label1) );
			EmitBooleanExpr
			( 
				(yyvsp[(6) - (15)].opnode), 
				tmpLabel,
				1 
			);
			EmitStmtLblNum( "exitloop" sympost "%d",	(yyvsp[(5) - (15)].labels.l1.label1) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(13) - (15)].labels.l1.label1);

			free2( vss (yyvsp[(11) - (15)].v.u.strval) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2971:

/* Line 1464 of yacc.c  */
#line 96593 "hlaparse.bsn"
    {				/* $16 */

			char tmpLabel[32];
			
			_here;
			EmitStmtLblNum( "continue" sympost "%d", (yyvsp[(5) - (15)].labels.l1.label1) );
			asmPuts( (yyvsp[(11) - (15)].v.u.strval) );
			asmPutc( '\n' );
			EmitStmtLblNum( "StartFor" sympost "%d", (yyvsp[(5) - (15)].labels.l1.label1) );
			sprintf( tmpLabel, "for" sympost "%d", (yyvsp[(5) - (15)].labels.l1.label1) );
			EmitBooleanExpr
			( 
				(yyvsp[(6) - (15)].opnode), 
				tmpLabel,
				1 
			);
			_here; 
		;}
    break;

  case 2972:

/* Line 1464 of yacc.c  */
#line 96613 "hlaparse.bsn"
    {				/* $19 */
		
			_here;
			EmitStmtLblNum( "exitloop" sympost "%d",	(yyvsp[(5) - (18)].labels.l1.label1) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(13) - (18)].labels.l1.label1);

			free2( vss (yyvsp[(11) - (18)].v.u.strval) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2973:

/* Line 1464 of yacc.c  */
#line 96634 "hlaparse.bsn"
    {
			_here;
			(yyval.v.u.intval) = asmBuf->offset;
			_here;
		;}
    break;

  case 2974:

/* Line 1464 of yacc.c  */
#line 96642 "hlaparse.bsn"
    {
		
			char	*t;
			int		size;

			_here;
			size = asmBuf->offset - (yyvsp[(-2) - (0)].v.u.intval);
			t = malloc2( size + 2 );
			memcpy( t, asmBuf->base + (yyvsp[(-2) - (0)].v.u.intval), size );
			t[ size ] = '\0'; 
			(yyval.v.u.strval) = t;
			
			// Now that we've captured the "inc" statement,
			// reset the offset so we'll overwrite it with the
			// next code
			
			asmBuf->offset = (yyvsp[(-2) - (0)].v.u.intval);
			_here;
		;}
    break;

  case 2975:

/* Line 1464 of yacc.c  */
#line 96664 "hlaparse.bsn"
    {

			/*
			** Save the break/breakif label value so we can
			** restore it later.  Then set the break/breakif label
			** value to the exit value for this loop.
			*/

			(yyval.labels.l1.label1) = BreakLbl;
			BreakLbl = (yyvsp[(-7) - (0)].labels.l1.label1);
			_here;
		;}
    break;

  case 2976:

/* Line 1464 of yacc.c  */
#line 96680 "hlaparse.bsn"
    {
			char label[ 256 ];

			_here;

			/*
			** Emit the header for the FOR loop.
			*/

			(yyval.labels.l1.label1) = LblCntr++;
			NewLn();
			sprintf( label, "StartFor" sympost "%d", (yyval.labels.l1.label1) );
			EmitJmpLabel( label );
			EmitStmtLblNum( "for" sympost "%d", (yyval.labels.l1.label1) );
			StartOfStmt = asmBuf->offset; 
			_here;
		;}
    break;

  case 2977:

/* Line 1464 of yacc.c  */
#line 96724 "hlaparse.bsn"
    {				/* $10 */

			char tmpLabel[32];
			
			_here;

			/*
			** Emit the loop termination test.
			*/
			EmitStmtLblNum( "continue" sympost "%d", (yyvsp[(3) - (9)].labels.l1.label1) );
			sprintf( tmpLabel, "while" sympost "%d", (yyvsp[(3) - (9)].labels.l1.label1) );
			EmitBooleanExpr
			( 
				(yyvsp[(4) - (9)].opnode), 
				tmpLabel,
				1 
			);
			EmitStmtLblNum( "exitloop" sympost "%d", (yyvsp[(3) - (9)].labels.l1.label1) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(7) - (9)].labels.l1.label1);

			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2978:

/* Line 1464 of yacc.c  */
#line 96783 "hlaparse.bsn"
    {				/* $10 */
		
			char label[ 32 ];
			
			/*
			** Emit the loop termination test.
			** Note that if the termination test fails, the
			** code falls into the welse section.
			*/

			_here;
			EmitStmtLblNum( "continue" sympost "%d", (yyvsp[(3) - (9)].labels.l1.label1) );
			sprintf( label, "while" sympost "%d", (yyvsp[(3) - (9)].labels.l1.label1) );
			EmitBooleanExpr
			( 
				(yyvsp[(4) - (9)].opnode), 
				label,
				1 
			);

			_here;		
		;}
    break;

  case 2979:

/* Line 1464 of yacc.c  */
#line 96807 "hlaparse.bsn"
    {				/* $13 */
		
			_here;

			/*
			** Emit the target for a break statement:
			*/
						
			EmitStmtLblNum( "exitloop" sympost "%d", (yyvsp[(3) - (12)].labels.l1.label1) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(7) - (12)].labels.l1.label1);
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2980:

/* Line 1464 of yacc.c  */
#line 96831 "hlaparse.bsn"
    {
			char label[ 256 ];

			_here;

			/*
			** Allocate two labels:
			** One for the label at the beginning
			** of the while loop and one for the
			** exit location.
			*/

			(yyval.labels.l1.label1) = LblCntr++;
			(yyval.labels.l2.label2) = LblCntr++;
			sprintf( label, "continue" sympost "%d", (yyval.labels.l1.label1) );
			EmitJmpLabel( label );
			EmitStmtLblNum( "while" sympost "%d", (yyval.labels.l1.label1) );
			StartOfStmt = asmBuf->offset;
			_here;
		;}
    break;

  case 2981:

/* Line 1464 of yacc.c  */
#line 96854 "hlaparse.bsn"
    {
		
			_here;


			/*
			** Save the break/breakif label value so we can
			** restore it later.  Then set the break/breakif label
			** value to the exit value for this loop.
			*/

			(yyval.labels.l1.label1) = BreakLbl;
			BreakLbl = (yyvsp[(-3) - (0)].labels.l1.label1);
			_here;
		;}
    break;

  case 2982:

/* Line 1464 of yacc.c  */
#line 96903 "hlaparse.bsn"
    {				/* $13 */
			
			char label[ 256 ];

			/*
			** Emit the target label for SetFalseLabel.
			*/

			_here;
			sprintf( label, "while" sympost "%d", (yyvsp[(4) - (12)].labels.l1.label1) );
			EmitJmpLabel( label );
			EmitStmtLblNum( "exitloop" sympost "%d", (yyvsp[(4) - (12)].labels.l1.label1) );
			EmitStmtLblNum( "exitloop" sympost "%d", (yyvsp[(4) - (12)].labels.label4) );
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(4) - (12)].labels.l1.label1) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(10) - (12)].labels.l1.label1);
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2983:

/* Line 1464 of yacc.c  */
#line 96964 "hlaparse.bsn"
    {				/* $13 */
			
			char label[ 256 ];
			
			/*
			** Emit the code for the welse section:
			*/
			
			_here;
			sprintf( label, "while" sympost "%d", (yyvsp[(4) - (12)].labels.l1.label1) );
			EmitJmpLabel( label );
			EmitStmtLblNum( "exitloop" sympost "%d", (yyvsp[(4) - (12)].labels.l1.label1) );
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(4) - (12)].labels.l1.label1) );
			_here;
		;}
    break;

  case 2984:

/* Line 1464 of yacc.c  */
#line 96981 "hlaparse.bsn"
    {				/* $16 */
			
			/*
			** Emit the target label for SetFalseLabel.
			*/

			_here;
			EmitStmtLblNum( "exitloop" sympost "%d", (yyvsp[(4) - (15)].labels.label4) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(10) - (15)].labels.l1.label1);
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2985:

/* Line 1464 of yacc.c  */
#line 97004 "hlaparse.bsn"
    {
			_here;
			(yyval.labels.l1.label1) = LblCntr++;
			(yyval.labels.l2.label2) = TrueLabel;
			(yyval.labels.l3.label3) = FalseLabel;
			(yyval.labels.label4) = LblCntr++;
			TrueLabel = (yyval.labels.l1.label1);
			FalseLabel = (yyval.labels.l1.label1);
			NewLn();
			EmitStmtLblNum( "while" sympost "%d", (yyval.labels.l1.label1) ); 
			EmitStmtLblNum( "continue" sympost "%d", (yyval.labels.label4) );
			_here; 
		;}
    break;

  case 2986:

/* Line 1464 of yacc.c  */
#line 97021 "hlaparse.bsn"
    {
		
			_here;


			/*
			** Save the break/breakif label value so we can
			** restore it later.  Then set the break/breakif label
			** value to the exit value for this loop.
			*/

			(yyval.labels.l1.label1) = BreakLbl;
			BreakLbl = (yyvsp[(-5) - (0)].labels.label4);
			_here;
		;}
    break;

  case 2987:

/* Line 1464 of yacc.c  */
#line 97046 "hlaparse.bsn"
    {
			yyerror( "Expected 'do'" );
		;}
    break;

  case 2989:

/* Line 1464 of yacc.c  */
#line 97078 "hlaparse.bsn"
    {				/* $12 */	 
			
			char tmpLabel[32];
									 
			_here;

			/*
			** Emit the loop termination test.
			*/

			sprintf( tmpLabel, "repeat" sympost "%d", (yyvsp[(4) - (11)].v.u.intval) );
			EmitBooleanExpr
			( 
				(yyvsp[(10) - (11)].opnode), 
				tmpLabel,
				0 
			);
			EmitStmtLblNum( "exitloop" sympost "%d", (yyvsp[(4) - (11)].v.u.intval) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(5) - (11)].v.u.intval);


			/*
			** Restore true and false labels.
			*/

			FalseLabel = (yyvsp[(3) - (11)].v.u.intval);
			TrueLabel = (yyvsp[(2) - (11)].v.u.intval);


			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2990:

/* Line 1464 of yacc.c  */
#line 97119 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.intval) = TrueLabel;
		;}
    break;

  case 2991:

/* Line 1464 of yacc.c  */
#line 97126 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.intval) = FalseLabel;
		;}
    break;

  case 2992:

/* Line 1464 of yacc.c  */
#line 97133 "hlaparse.bsn"
    {

			_here;

			(yyval.v.u.intval) = LblCntr;
			FalseLabel = LblCntr++;
			TrueLabel = (yyval.v.u.intval);
			EmitStmtLblNum( "false" sympost "%d", FalseLabel );
			EmitStmtLblNum( "repeat" sympost "%d", FalseLabel );
			_here;
		;}
    break;

  case 2993:

/* Line 1464 of yacc.c  */
#line 97174 "hlaparse.bsn"
    {				/* $14 */

			_here;
			EmitStmtLblNum( "true" sympost "%d", TrueLabel );
			EmitStmtLblNum( "exitloop" sympost "%d", TrueLabel );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(5) - (13)].v.u.intval);

			/*
			** Restore true and false labels.
			*/

			FalseLabel = (yyvsp[(3) - (13)].v.u.intval);
			TrueLabel = (yyvsp[(2) - (13)].v.u.intval);

			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 2994:

/* Line 1464 of yacc.c  */
#line 97208 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.intval) = BreakLbl;
			BreakLbl = (yyvsp[(0) - (0)].v.u.intval);
		;}
    break;

  case 2995:

/* Line 1464 of yacc.c  */
#line 97217 "hlaparse.bsn"
    {
		
			_here;
			EmitStmtLblNum( "continue" sympost "%d", abs( BreakLbl ) );
			_here;
		;}
    break;

  case 2996:

/* Line 1464 of yacc.c  */
#line 97244 "hlaparse.bsn"
    {
			(yyval.returns) = NULL;
		;}
    break;

  case 2997:

/* Line 1464 of yacc.c  */
#line 97251 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
		;}
    break;

  case 2998:

/* Line 1464 of yacc.c  */
#line 97259 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
		;}
    break;

  case 2999:

/* Line 1464 of yacc.c  */
#line 97267 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
		;}
    break;

  case 3000:

/* Line 1464 of yacc.c  */
#line 97273 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
		;}
    break;

  case 3001:

/* Line 1464 of yacc.c  */
#line 97279 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
		;}
    break;

  case 3002:

/* Line 1464 of yacc.c  */
#line 97292 "hlaparse.bsn"
    {					/* $4 */

			struct adrsYYS adrs;
			char symbol[ 256 ];

			_here;
			(yyval.v.u.intval) = -( LblCntr++ );

			sprintf( symbol, "exitfor" sympost "%d", -(yyval.v.u.intval) );
			PushStaticAdrs( symbol );
			EmitCallLabel( (yyvsp[(2) - (3)].s)->StaticName );
			push_r( reg_ebp );
			initAdrs( &adrs, reg_esp, -1, 0, 8 );
			EmitMov_m_r( &adrs, reg_ebp, 4 );
			_here;
		;}
    break;

  case 3003:

/* Line 1464 of yacc.c  */
#line 97312 "hlaparse.bsn"
    {					/* $9 */
			_here;
			EmitStmtLblNum( "continue" sympost "%d", abs( BreakLbl ) );
			pop_r( reg_ebp );
			ret_instr( 4 );
			EmitStmtLblNum( "exitfor" sympost "%d", -(yyvsp[(4) - (8)].v.u.intval) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(5) - (8)].v.u.intval);


			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3004:

/* Line 1464 of yacc.c  */
#line 97341 "hlaparse.bsn"
    {					/* $7 */
			char			*pbStmt;
			SymNode_t 		*sig;
			char			msg[256];
			
			_here;
			(yyval.returns) = NULL;
			LastRefdObject = (yyvsp[(4) - (6)].s);
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level procedure calls are illegal in low and machine\n"
					"level language mode."
				);
				
			_endif
			
			// Search for the matching signature:
			
			sig =	matchSignature
					( 
						(yyvsp[(2) - (6)].s), 
						(yyvsp[(5) - (6)].collectedParms.parmCnt), 
						(yyvsp[(5) - (6)].collectedParms.types), 
						(yyvsp[(5) - (6)].collectedParms.pForms) 
					);
					
			_if( sig == NULL )
			
				yyerror
				( 
					"No matching signature/parameter list for overloaded call."
				);
				
			_else	// We matched a signature
			
				// Emit the code to call the associated function:
				
				pbStmt = 	malloc2
							( 
								strlen( sig->u.ovld.procName ) +
								strlen( (yyvsp[(5) - (6)].collectedParms.parms) )
								+256
							);
							
				sprintf
				(
					pbStmt,
					"foreach %s( %s )",
					sig->u.ovld.procName,
					(yyvsp[(5) - (6)].collectedParms.parms)
				);
				PushBackStr( pbStmt );
				(yyval.returns) = pbStmt;
				
			_endif
			_if( (yyvsp[(5) - (6)].collectedParms.parms) != NULL )
			
				free( (yyvsp[(5) - (6)].collectedParms.parms) );
				
			_endif
			_if( (yyvsp[(5) - (6)].collectedParms.types) != NULL )
			
				free( (yyvsp[(5) - (6)].collectedParms.types) );
				
			_endif
			_here; 
		;}
    break;

  case 3005:

/* Line 1464 of yacc.c  */
#line 97415 "hlaparse.bsn"
    {
			(yyval.returns) = (yyvsp[(8) - (8)].returns);
			_if( (yyvsp[(7) - (8)].returns) != NULL )
			
				free( (yyvsp[(7) - (8)].returns) ); 
				
			_endif
		;}
    break;

  case 3006:

/* Line 1464 of yacc.c  */
#line 97440 "hlaparse.bsn"
    {						/* $7 */

			int  			useLEA = 1;
			int	 			offset = 0;
			SymNode_t 		*typ;
			char 			*size;
			struct adrsYYS	yysAdrs;
			char 			address[ 256 ];
			char 			adrs[ 256 ];
			char 			name[ 256 ];

			_here;

			/*
			** Set the attribute of the endfor label value.
			*/

			(yyval.v.u.intval) = -( LblCntr++ );

			/*
			** Handle classes specially because we get to use the
			** ESI and EDI registers for class invocations.
			*/

			_if
			( 
					(yyvsp[(2) - (6)].adrs.pType) == tClass

				||	(
							(yyvsp[(2) - (6)].adrs.pType) == tArray
						&&	GetBaseType( (yyvsp[(2) - (6)].adrs.Type) )->pType == tClass
					)

				||	(
							(
									(yyvsp[(2) - (6)].adrs.pType) == tPointer
								||	(
											(yyvsp[(2) - (6)].adrs.pType) == tArray
										&&	GetBaseType( (yyvsp[(2) - (6)].adrs.Sym) )->pType 
														== tPointer
									)
							)
						&&	(yyvsp[(2) - (6)].adrs.Sym)->Base->pType == tClass
					)
			)

				/*
				** The assumption to this point is that we have
				** a class variable.  Check to see if what we've
				** really got is a pointer to a class object.  The
				** only difference in the code generation is "lea"
				** (for class vars) vs. "mov" (for class pointers).
				*/

				_if
				( 
						(yyvsp[(2) - (6)].adrs.pType) == tPointer
					||	(
								(yyvsp[(2) - (6)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(2) - (6)].adrs.Type) )->pType == tPointer
						)
				)

					useLEA = 0;
					_if
					( 
							(yyvsp[(2) - (6)].adrs.SymClass) == cParm 
						&&	(yyvsp[(2) - (6)].adrs.pClass) == refp_pc 
					)
						yyerror
						( 
							"Cannot pass a pointer by reference here"
						);

					_endif

				_elseif
				(
						IsStaticClass( (yyvsp[(2) - (6)].adrs.SymClass) ) 
					&&	(yyvsp[(2) - (6)].adrs.StaticName) != NULL 
					&&	*(yyvsp[(2) - (6)].adrs.StaticName) != '\0'
					&&	(yyvsp[(2) - (6)].adrs.BaseReg) == NULL
					&&	(yyvsp[(2) - (6)].adrs.IndexReg) == NULL
				)

					useLEA = 0;
					offset = 1;

				_endif

				/*
				** Emit the code that moves the address of the
				** object into the ESI register (this).
				** Note that the address of the object is
				** the SimpleMemoryVar, not the FieldStuff value.
				*/

				_if
				( 
						(yyvsp[(2) - (6)].adrs.SymClass) == cVar 
					||	(yyvsp[(2) - (6)].adrs.SymClass) == cStatic
				)

					_if( !useLEA )	// See if emitting MOV instr
					
						_if( offset )
						
							EmitMov_oa_r( &(yyvsp[(2) - (6)].adrs), reg_esi ); 
						
						_else
						
							EmitMov_m_r( &(yyvsp[(2) - (6)].adrs), reg_esi, 4 );
						
						_endif
					
					_else
					
						EmitLea_m_r2( &(yyvsp[(2) - (6)].adrs), reg_esi );
						
					_endif

				_elseif( (yyvsp[(2) - (6)].adrs.SymClass) == cParm )

					/*
					** Handle pass by value of the object here.
					*/

					_if( (yyvsp[(2) - (6)].adrs.pClass) == valp_pc )

						// Must always be LEA instr at this point!
						
						EmitLea_m_r2( &(yyvsp[(2) - (6)].adrs), reg_esi );

					/*
					** Handle pass by reference of the object
					** here.
					**
					**	BUG! This doesn't seem to work (parser never
					**  gets to this point).
					*/

					_elseif( (yyvsp[(2) - (6)].adrs.pClass) == refp_pc )

						EmitMov_m_r( &(yyvsp[(2) - (6)].adrs), reg_esi, 4 );
						initAdrs( &yysAdrs, reg_esi, -1, 0, 0 );
						EmitMov_m_r( &yysAdrs, reg_esi, 4 );

					/*
					** Don't allow the other parameter passing methods.
					*/

					_else

						yyerror
						(
							"Object pointer must be passed by "
							"value or reference"
						);

					_endif

				_else

					yyerror( "Expected class object" );

				_endif


				/*
				** If the field is a class iterator, issue the
				** call here.
				*/

				_if( (yyvsp[(3) - (6)].adrs.SymClass) == cClassIter )

					char symbol[ 256 ];
					char adrs[ 256 ];
					char mem[ 256 ];

					/*
					** Since this is an iterator, the following
					** should always have some sort of value
					** (besides NULL).
					*/
					
					assert( (yyvsp[(3) - (6)].adrs.Sym)->StaticName != NULL );
					assert( (yyvsp[(3) - (6)].adrs.Sym)->u.proc.returns != NULL );

					/*
					** This is just a class procedure.
					** Call it directly.
					*/

					initAdrs( &yysAdrs, reg_esi, -1, 0, 0 );
					EmitMov_m_r( &yysAdrs, reg_edi, 4 );
					sprintf( symbol, "exitfor" sympost "%d", -(yyval.v.u.intval) );
					PushStaticAdrs( symbol );
					initAdrs1( &yysAdrs, reg_edi, (yyvsp[(3) - (6)].adrs.Sym)->Offset );
					EmitCall_m( &yysAdrs );
					push_r( reg_ebp );
					initAdrs( &yysAdrs, reg_esp, -1, 0, 8 );
					EmitMov_m_r( &yysAdrs, reg_ebp, 4 );

				/*
				** If the field is neither a method nor a procedure,
				** then this is an illegal call.
				*/

				_else

					yyerror( "Expected an iterator" );

				_endif


			_else
			
				yyerror( "Expected a class iterator" );

			_endif

			FreeAdrs( &(yyvsp[(2) - (6)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 3007:

/* Line 1464 of yacc.c  */
#line 97670 "hlaparse.bsn"
    {					/* $12 */
			_here;
			EmitStmtLblNum( "continue" sympost "%d", abs( BreakLbl ) );
			pop_r( reg_ebp );
			ret_instr( 4 );
			EmitStmtLblNum( "exitfor" sympost "%d", -(yyvsp[(7) - (11)].v.u.intval) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(8) - (11)].v.u.intval);


			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3008:

/* Line 1464 of yacc.c  */
#line 97704 "hlaparse.bsn"
    {						/* $9  */
			char		*pbStmt;
			SymNode_t	*sig;
			
			_here;
			(yyval.returns) = NULL;
			LastRefdObject = (yyvsp[(6) - (8)].s);
			_if( langLevel <= low_level )
			
				yyerror
				( 
					"High-level procedure calls are illegal in low and machine\n"
					"level language mode."
				);
				
			_endif
			
			// Search for the matching signature:
			
			sig =	matchSignature
					( 
						(yyvsp[(3) - (8)].adrs.Sym), 
						(yyvsp[(7) - (8)].collectedParms.parmCnt), 
						(yyvsp[(7) - (8)].collectedParms.types), 
						(yyvsp[(7) - (8)].collectedParms.pForms) 
					);
			_if( sig == NULL )
			
				yyerror
				( 
					"No matching signature/parameter list for overloaded call."
				);
				
			_else	// We matched a signature
			
				// Emit the code to call the associated function:
				
				pbStmt = 	malloc2
							( 
								strlen( sig->u.ovld.procName ) +
								strlen( (yyvsp[(7) - (8)].collectedParms.parms) )
								+256
							);
							
				sprintf
				(
					pbStmt,
					"foreach %s( %s )",
					sig->u.ovld.procName,
					(yyvsp[(7) - (8)].collectedParms.parms)
				);
				PushBackStr( pbStmt );
				(yyval.returns) = pbStmt;
				
			_endif
			_if( (yyvsp[(7) - (8)].collectedParms.parms) != NULL )
			
				free( (yyvsp[(7) - (8)].collectedParms.parms) );
				
			_endif
			_if( (yyvsp[(7) - (8)].collectedParms.types) != NULL )
			
				free( (yyvsp[(7) - (8)].collectedParms.types) );
				
			_endif
			_here; 
		;}
    break;

  case 3009:

/* Line 1464 of yacc.c  */
#line 97776 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = (yyvsp[(10) - (10)].returns);
			_if( (yyvsp[(9) - (10)].returns) != NULL )
			
				free( (yyvsp[(9) - (10)].returns) ); 
				
			_endif
		;}
    break;

  case 3010:

/* Line 1464 of yacc.c  */
#line 97803 "hlaparse.bsn"
    {						/* $7 */

			char *size;
			char address[ 256 ];
			char name[ 256 ];
			int  useLEA = 1;
			int  offset = 0;
			struct adrsYYS yysAdrs;

			_here;

			/*
			** Combine the index information with the base information
			** so we can use the code from the previous production.
			*/

			CombineAddresses( &(yyvsp[(2) - (6)].adrs), &(yyvsp[(4) - (6)].adrs) );


			/*
			** Set the attribute of the endfor label value.
			*/


			(yyval.v.u.intval) = -( LblCntr++ );

			/*
			** Handle classes specially because we get to use the
			** ESI and EDI registers for class invocations.
			*/

			_if
			( 
					(yyvsp[(2) - (6)].adrs.pType) == tClass

				||	(
							(yyvsp[(2) - (6)].adrs.pType) == tArray
						&&	GetBaseType( (yyvsp[(2) - (6)].adrs.Type) )->pType == tClass
					)

				||	(
							(
									(yyvsp[(2) - (6)].adrs.pType) == tPointer
								||	(
											(yyvsp[(2) - (6)].adrs.pType) == tArray
										&&	GetBaseType( (yyvsp[(2) - (6)].adrs.Sym) )->pType 
														== tPointer
									)
							)
						&&	(yyvsp[(2) - (6)].adrs.Sym)->Base->pType == tClass
					)
			)

				/*
				** The assumption to this point is that we have
				** a class variable.  Check to see if what we've
				** really got is a pointer to a class object.  The
				** only difference in the code generation is "lea"
				** (for class vars) vs. "mov" (for class pointers).
				*/

				_if
				( 
						(yyvsp[(2) - (6)].adrs.pType) == tPointer
					||	(
								(yyvsp[(2) - (6)].adrs.pType) == tArray
							&&	GetBaseType( (yyvsp[(2) - (6)].adrs.Type) )->pType == tPointer
						)
				)

					useLEA = 0;
					_if
					( 
							(yyvsp[(2) - (6)].adrs.SymClass) == cParm 
						&&	(yyvsp[(2) - (6)].adrs.pClass) == refp_pc 
					)
						yyerror
						( 
							"Cannot pass a pointer by reference here"
						);

					_endif

				_elseif
				(
						IsStaticClass( (yyvsp[(2) - (6)].adrs.SymClass) ) 
					&&	(yyvsp[(2) - (6)].adrs.StaticName) != NULL 
					&&	*(yyvsp[(2) - (6)].adrs.StaticName) != '\0'
					&&	(yyvsp[(2) - (6)].adrs.BaseReg) == NULL
					&&	(yyvsp[(2) - (6)].adrs.IndexReg) == NULL
				)

					useLEA = 0;
					offset = 1;

				_endif

				/*
				** Emit the code that moves the address of the
				** object into the ESI register (this).
				** Note that the address of the object is
				** the SimpleMemoryVar, not the FieldStuff value.
				*/

				_if
				( 
						(yyvsp[(2) - (6)].adrs.SymClass) == cVar
					||	(yyvsp[(2) - (6)].adrs.SymClass) == cStatic 
				)
				
					char adrs[256];
				
				
					_if( !useLEA )	// See if emitting MOV instr
						
					
						_if( offset )
						
							
							EmitMov_oa_r( &(yyvsp[(2) - (6)].adrs), reg_esi ); 
						
						_else
						
							EmitMov_m_r( &(yyvsp[(2) - (6)].adrs), reg_esi, 4 );
						
						_endif
					
					_else
					
						EmitLea_m_r2( &(yyvsp[(2) - (6)].adrs), reg_esi );
						
					_endif

				_elseif( (yyvsp[(2) - (6)].adrs.SymClass) == cParm )

					/*
					** Handle pass by value of the object here.
					*/
					_if( (yyvsp[(2) - (6)].adrs.pClass) == valp_pc )

						// Must always be an LEA instruction at this point!
						
						EmitLea_m_r2( &(yyvsp[(2) - (6)].adrs), reg_esi );

					/*
					** Handle pass by reference of the object
					** here.
					** BUG! Does this code even get called?
					*/

					_elseif( (yyvsp[(2) - (6)].adrs.pClass) == refp_pc )

						EmitMov_m_r( &(yyvsp[(2) - (6)].adrs), reg_esi, 4 );
						initAdrs( &yysAdrs, reg_esi, -1, 0, 0 );
						EmitMov_m_r( &yysAdrs, reg_esi, 4 );

					/*
					** Don't allow the other parameter passing methods.
					*/

					_else

						yyerror
						(
							"Object pointer must be passed by "
							"value or reference"
						);

					_endif

				_else

					yyerror( "Expected class object" );

				_endif


				/*
				** If the field is a class iterator, issue the
				** call here.
				*/

				_if( (yyvsp[(3) - (6)].adrs.SymClass) == cClassIter )

					char label[ 256 ];

					/*
					** Since this is a procedure, the following
					** should always have some sort of value
					** (besides NULL).
					*/
					
					assert( (yyvsp[(3) - (6)].adrs.Sym)->StaticName != NULL );
					assert( (yyvsp[(3) - (6)].adrs.Sym)->u.proc.returns != NULL );

					/*
					** This is just a class iterator.
					** Call it directly.
					*/

					initAdrs( &yysAdrs, reg_esi, -1, 0, 0 );
					EmitMov_m_r( &yysAdrs, reg_edi, 4 );
					sprintf
					( 
						label, 
						"exitfor" sympost "%d", 
						-(yyval.v.u.intval)
					);
					PushStaticAdrs( label );
					initAdrs1( &yysAdrs, reg_edi, (yyvsp[(3) - (6)].adrs.Sym)->Offset );
					EmitCall_m( &yysAdrs );
					
					push_r( reg_ebp );
					initAdrs( &yysAdrs, reg_esp, -1, 0, 8 );
					EmitMov_m_r( &yysAdrs, reg_ebp, 4 );
					 
				/*
				** If the field is neither a method nor a procedure,

				** then this is an illegal call.
				*/

				_else

					yyerror( "Expected an iterator" );

				_endif


			/*
			** If it wasn't a class variable, see if it is a procedure
			** pointer variable or a thunk.
			*/

			_else
			
				yyerror( "Expected a class iterator" );

			_endif

			FreeAdrs( &(yyvsp[(2) - (6)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (6)].adrs) );
			_here;
		;}
    break;

  case 3011:

/* Line 1464 of yacc.c  */
#line 98052 "hlaparse.bsn"
    {					/* $11 */
			_here;
			EmitStmtLblNum( "continue" sympost "%d", abs( BreakLbl ) );
			pop_r( reg_ebp );
			ret_instr( 4 );
			EmitStmtLblNum( "exitfor" sympost "%d", -(yyvsp[(7) - (11)].v.u.intval) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(7) - (11)].v.u.intval);


			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3012:

/* Line 1464 of yacc.c  */
#line 98080 "hlaparse.bsn"
    {
			_here; 
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 3013:

/* Line 1464 of yacc.c  */
#line 98087 "hlaparse.bsn"
    {
			_here; 
			(yyval.s) = (yyvsp[(1) - (1)].s);
			SetReferenced( (yyvsp[(1) - (1)].s) );
		;}
    break;

  case 3014:

/* Line 1464 of yacc.c  */
#line 98113 "hlaparse.bsn"
    {				/* $2 */

			_here;

			/*
			** Allocate two labels:
			** One for the label at the beginning
			** of the do..until loop and one for the
			** exit location.
			*/

			(yyval.v.u.intval) = LblCntr++;
			++LblCntr;
			EmitStmtLblNum( "forever" sympost "%d", (yyval.v.u.intval) + 1 );
			EmitStmtLblNum( "continue" sympost "%d", (yyval.v.u.intval) );
			_here;
		;}
    break;

  case 3015:

/* Line 1464 of yacc.c  */
#line 98133 "hlaparse.bsn"
    {				/* $6 */

			char label[ 256 ];

			_here;
			sprintf( label, "forever" sympost "%d", (yyvsp[(2) - (5)].v.u.intval) + 1 );
			EmitJmpLabel( label );
			EmitStmtLblNum( "exitloop" sympost "%d", (yyvsp[(2) - (5)].v.u.intval) );
			NewLn();

			/*
			** Restore the original BreakLbl value.
			*/

			BreakLbl = (yyvsp[(3) - (5)].v.u.intval);


			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3016:

/* Line 1464 of yacc.c  */
#line 98166 "hlaparse.bsn"
    {				/* $4 */

			struct	contextListType *p;
			char					msg[ 256 ];

			_here;
			
			/*
			** First, check to make sure this context doesn't already exist.
			** If it does, print an appropriate error message.
			*/
			
			p = contextList;
			_while( p != NULL )
			
				_if( _streq( (yyvsp[(2) - (3)].neID.idStr), p->label ))
				
					sprintf
					(
						msg,
						"Context <<begin %s>> is already active",
						(yyvsp[(2) - (3)].neID.idStr)
					);
					yyerror( msg );
					break;
					
				_endif
				p = p->Next;
				
			_endwhile
			
			
			/*
			** Generate a MASM-compatible label for output to the
			** source file upon encountering the endcontext clause.
			*/
			
			sprintf
			(
				msg,
				"exit" sympost "%d",
				LblCntr++,
				(yyvsp[(2) - (3)].neID.idStr)
			);
			
			/*
			** Add the current context to the context list.
			*/
			
			p = malloc2( sizeofContextListType );
			p->Next = contextList;
			p->label = (yyvsp[(2) - (3)].neID.idStr);
			p->StaticName = hlastrdup2( msg );
			p->LexLevel = CurLexLevel;
			p->IsProc = 0;
			p->HasDisplay = 1;
			p->SizeParms = 0;
			contextList = p;
			(yyval.idStr) = p->StaticName;
			_here;
					
		;}
    break;

  case 3017:

/* Line 1464 of yacc.c  */
#line 98231 "hlaparse.bsn"
    {
		
			struct contextListType	*cNode;
		
			_here;
			
			/*
			** Be sure the labels after the context and endcontext
			** reserved words are the same.
			*/
			
			_if( _strne( (yyvsp[(2) - (7)].neID.idStr), (yyvsp[(7) - (7)].idStr) ))
			
				char msg[ 256 ];
				
				
				sprintf
				(
					msg,
					"Context label <<begin %s>> must match "
					"label <<end %s>>",
					(yyvsp[(2) - (7)].neID.idStr), 
					(yyvsp[(7) - (7)].idStr)
				);
				yyerror( msg );

			_else
			
				EmitStmtLbl( (yyvsp[(4) - (7)].idStr) );
				
				/*
				** This should be a redundant check, but just to be
				** sure, let's ensure the most recent context's label
				** matches the endcontext label as well.
				*/
				
				assert( _streq( (yyvsp[(4) - (7)].idStr), contextList->StaticName ));
				
				
			_endif

			/*
			** Remove the current context from the context stack.
			*/
			
			assert( contextList != NULL );
			cNode = contextList;
			contextList = cNode->Next;

			assert( _streq( cNode->label, (yyvsp[(2) - (7)].neID.idStr) ));
			free2( vss cNode->StaticName );	/* frees $<idStr>4 */
			free2( vss cNode->label );		/* frees $<neID.idStr>2 */
			
			free2( vss (yyvsp[(7) - (7)].idStr) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3018:

/* Line 1464 of yacc.c  */
#line 98299 "hlaparse.bsn"
    {			/* $3 */
		
			struct	contextListType	*cNode;
			char					msg[256];
			unsigned				AllHaveDisplays;
			
			_here;
			
			/*
			** Search for the leave ID in the context list.
			*/
	
			cNode = contextList;
			AllHaveDisplays = 1;
			_while( cNode != NULL && _strne( (yyvsp[(2) - (2)].neID.idStr), cNode->label ))
			
				AllHaveDisplays = AllHaveDisplays && cNode->HasDisplay;
				cNode = cNode->Next;
				
			_endwhile

			_if( !AllHaveDisplays )

				ErrorNear
				(
					"Attempt to exit from a set of nested procedures\n"
					"but not all the (nested) procedures have a display",
					(yyvsp[(2) - (2)].neID.idStr),
					__LINE__,
					__FILE__
				);

			_endif

			
			/*
			** cNode contains a non-NULL value if we found the
			** label in the context list.
			*/
			
			_if( cNode != NULL )
			
				_if
				( 
						cNode->IsProc == 0 
					||	(
								cNode->IsProc == 1
							&&	cNode->LexLevel == CurLexLevel
						)
				)

					EmitJmpLabel( cNode->StaticName );

						


				_elseif( cNode->IsProc == 1 )

					char mem[ 256 ];
					struct adrsYYS adrs;

					/*
					** If exiting from a non-local procedure,
					** then we've got to unwind the stack.
					** Grab the save stack frame pointer from
					** the display and use that for this purpose.
					*/

					initAdrs( &adrs, reg_ebp, -1, 0, -( cNode->LexLevel + 1 ) * 4 );
					EmitMov_m_r( &adrs, reg_esp, 4 );
					pop_r( reg_ebp );

					/*
					** Determine how many parameters to remove
					** from the stack on return.
					*/

					ret_instr( _ifx(cNode->SizeParms == 0, -1, cNode->SizeParms ));



				_elseif( cNode->IsProc == 2 )


					/*
					** Handle the main program here.
					*/

					EmitExit();

				_else

					/*
					** Catchall for unknown context IsProc values.
					*/

					assert( "Unknown context type" == NULL );

				_endif
				
			_else
				
				sprintf
				( 
					msg,								 
					"Currently not in context of <<begin %s>>..<<end %s>>\n"
					"or 'NOFRAME' option is active",
					(yyvsp[(2) - (2)].neID.idStr),
					(yyvsp[(2) - (2)].neID.idStr)
				);
				ErrorNear
				(
					msg,
					(yyvsp[(2) - (2)].neID.idStr),
					__LINE__,
					__FILE__
				);
				
			_endif
			free2( vss (yyvsp[(2) - (2)].neID.idStr) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3019:

/* Line 1464 of yacc.c  */
#line 98438 "hlaparse.bsn"
    {							/* $7 */
		
			struct	contextListType	*cNode;
			char	msg[256];
			char	mem[ 256 ];
			char	tmpLabel[32];
			struct adrsYYS yysAdrs;
			
			_here;
			
			/*
			** Search for the EXIT ID in the context list.
			*/
	
			cNode = contextList;
			_while( cNode != NULL && _strne( (yyvsp[(6) - (6)].neID.idStr), cNode->label ))
			
				cNode = cNode->Next;
				
			_endwhile
			
			/*
			** cNode contains a non-NULL value if we found the
			** label in the context list.
			*/
			
			_if( cNode != NULL )
			
				_if
				( 
						cNode->IsProc == 0 
					||	(
								CurLexLevel == cNode->LexLevel
							&&	cNode->IsProc == 1
						)
				)

					EmitBooleanExpr
					( 
						(yyvsp[(4) - (6)].opnode), 
						cNode->StaticName,
						1 
					);


				_elseif( cNode->IsProc == 1 )

					/*
					** Handle exits from a non-local procedure here.
					**
					** If exiting from a non-local procedure,
					** then we've got to unwind the stack.
					** Grab the save stack frame pointer from
					** the display and use that for this purpose.
					*/

					sprintf( tmpLabel, "exitif" sympost "%d", LblCntr );
					EmitBooleanExpr
					( 
						(yyvsp[(4) - (6)].opnode), 
						tmpLabel,
						0 
					);


					initAdrs( &yysAdrs, reg_ebp, -1, 0, -( cNode->LexLevel + 1 ) * 4 );
					EmitMov_m_r( &yysAdrs, reg_esp, 4 );
					pop_r( reg_ebp );
					ret_instr( _ifx( cNode->SizeParms > 0, cNode->SizeParms, -1 ));
					EmitStmtLblNum( "exitif" sympost "%d", LblCntr++ );


				_elseif( cNode->IsProc == 2 )

					/*
					** Handle the main program here.
					*/

					EmitExit();					
					

				_else

					/*
					** Catchall for unknown context IsProc values.
					*/

					assert( "Unknown context type" == NULL );

				_endif
				
			_else
				
				sprintf
				( 
					msg,								 
					"Currently not in context of <<begin %s>>..<<end %s>>\n"
					"or 'NOFRAME' option is active",
					(yyvsp[(6) - (6)].neID.idStr),
					(yyvsp[(6) - (6)].neID.idStr)
				);
				ErrorNear
				(
					msg,
					(yyvsp[(6) - (6)].neID.idStr),
					__LINE__,
					__FILE__
				);
				
			_endif


			(yyval.returns) = NULL;
			free2( vss (yyvsp[(6) - (6)].neID.idStr) );
			_here;
		;}
    break;

  case 3020:

/* Line 1464 of yacc.c  */
#line 98559 "hlaparse.bsn"
    {
			_here; 
			(yyval.labels.l1.label1) = LblCntr;
			(yyval.labels.l2.label2) = LblCntr;
			(yyval.labels.l3.label3) = LblCntr++;
		;}
    break;

  case 3021:

/* Line 1464 of yacc.c  */
#line 98581 "hlaparse.bsn"
    {							/* $9 */
		
			struct	contextListType	*cNode;
			char	msg[256];
			char	mem[ 256 ];
			struct adrsYYS yysAdrs;
			
			
			_here;
			
			/*
			** Search for the leave ID in the context list.
			*/
	
			cNode = contextList;
			_while( cNode != NULL && _strne( (yyvsp[(8) - (8)].neID.idStr), cNode->label ))
			
				cNode = cNode->Next;
				
			_endwhile
			
			
			/*
			** cNode contains a non-NULL value if we found the
			** label in the context list.
			*/
			
			_if( cNode != NULL )
			
				_if
				( 
						cNode->IsProc == 0 
					||	(
								CurLexLevel == cNode->LexLevel
							&&	cNode->IsProc == 1
						)
				)

					EmitStmtLblNum( "true" sympost "%d", TrueLabel );
					EmitJmpLabel( cNode->StaticName );
					EmitStmtLblNum( "false" sympost "%d", FalseLabel );

				_elseif( cNode->IsProc == 1 )

					/*
					** Handle exits from a non-local procedure here.
					**
					** If exiting from a non-local procedure,
					** then we've got to unwind the stack.
					** Grab the save stack frame pointer from
					** the display and use that for this purpose.
					*/

					EmitStmtLblNum( "true" sympost "%d", TrueLabel );
					initAdrs( &yysAdrs, reg_ebp, -1, 0, -( cNode->LexLevel + 1 ) * 4 );
					EmitMov_m_r( &yysAdrs, reg_esp, 4);
					pop_r( reg_ebp );
					ret_instr( _ifx( cNode->SizeParms > 0, cNode->SizeParms, -1 ));
					EmitStmtLblNum( "false" sympost "%d", FalseLabel );


				_elseif( cNode->IsProc == 2 )

					/*
					** Handle the main program here.
					*/

					EmitStmtLblNum( "true" sympost "%d", TrueLabel );
					EmitExit();
					EmitStmtLblNum( "false" sympost "%d", FalseLabel );


				_else

					/*
					** Catchall for unknown context IsProc values.
					*/

					assert( "Unknown context type" == NULL );

				_endif
				
			_else
				
				sprintf
				( 
					msg,								 
					"Currently not in context of <<begin %s>>..<<end %s>>\n"
					"or 'NOFRAME' option is active",
					(yyvsp[(8) - (8)].neID.idStr),
					(yyvsp[(8) - (8)].neID.idStr)
				);
				ErrorNear
				(
					msg,
					(yyvsp[(8) - (8)].neID.idStr),
					__LINE__,
					__FILE__
				);
				
			_endif
			TrueLabel = (yyvsp[(4) - (8)].labels.l1.label1);
			FalseLabel = (yyvsp[(4) - (8)].labels.l2.label2);
			(yyval.returns) = NULL;
			free2( vss (yyvsp[(8) - (8)].neID.idStr) );
			_here;
		;}
    break;

  case 3022:

/* Line 1464 of yacc.c  */
#line 98693 "hlaparse.bsn"
    {
			_here; 
			(yyval.labels.l1.label1) = TrueLabel;
			(yyval.labels.l2.label2) = FalseLabel;
			TrueLabel = LblCntr++;
			FalseLabel = TrueLabel;
		;}
    break;

  case 3023:

/* Line 1464 of yacc.c  */
#line 98710 "hlaparse.bsn"
    {
			char label[ 256 ];

			_here;
			_if( BreakLbl > 0 )


				sprintf( label, "exitloop" sympost "%d", abs( BreakLbl ) );
				EmitJmpLabel( label );

			_elseif( BreakLbl < 0 )

				/*
				** If BreakLbl is negative, then we're breaking
				** out of an iterator.  This is problematic because
				** we've got junk on the stack.  Be sure to issue
				** a warning.
				*/

				WarnNear
				(
					"Breaking out of a foreach loop leaves garbage\n"
					"on the stack",
					"break"
				);
				sprintf( label, "exitfor" sympost "%d", abs( BreakLbl ) );
				EmitJmpLabel( label );

			_else

				yyerror( "\"break\" appears outside a loop" );

			_endif
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3024:

/* Line 1464 of yacc.c  */
#line 98759 "hlaparse.bsn"
    {							/* $6 */
		
			char tmpLabel[32];
			
			_here;
			_if( BreakLbl > 0 )

				sprintf( tmpLabel, "exitloop" sympost "%d", BreakLbl );
				EmitBooleanExpr
				(
					(yyvsp[(4) - (5)].opnode),
					tmpLabel,
					1
				);

			_elseif( BreakLbl < 0 )

				/*
				** If BreakLbl is negative, then we're breaking
				** out of an iterator.  This is problematic because
				** we've got junk on the stack.  Be sure to issue
				** a warning.
				*/

				WarnNear
				(
					"Breaking out of a foreach loop leaves garbage "
					"on the stack",
					"breakif"
				);
				sprintf( tmpLabel, "exitfor" sympost "%d", abs( BreakLbl ));
				EmitBooleanExpr
				(
					(yyvsp[(4) - (5)].opnode),
					tmpLabel,
					1
				);


			_else

				yyerror( "\"breakif\" appears outside a loop" );

			_endif
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3025:

/* Line 1464 of yacc.c  */
#line 98825 "hlaparse.bsn"
    {							/* $8 */
			_here;
			_if( BreakLbl > 0 )

				EmitBackPatchddc
				(
					"true" sympost "%d",
					TrueLabel,
					"exitloop" sympost "%d",
					BreakLbl,
					"breakif"
				);
				EmitStmtLblNum( "false" sympost "%d", FalseLabel );

			_elseif( BreakLbl < 0 )

				/*
				** If BreakLbl is negative, then we're breaking
				** out of an iterator.  This is problematic because
				** we've got junk on the stack.  Be sure to issue
				** a warning.
				*/

				WarnNear
				(
					"Breaking out of a foreach loop leaves garbage "
					"on the stack",
					"breakif"
				);
				EmitBackPatchddc
				(
					"true" sympost "%d",
					TrueLabel,
					"exitloop" sympost "%d",
					abs( BreakLbl ),
					"breakif"
				);
				EmitStmtLblNum( "false" sympost "%d", FalseLabel );


			_else

				yyerror( "\"breakif\" appears outside a loop" );

			_endif
			(yyval.returns) = NULL;
			TrueLabel = (yyvsp[(4) - (7)].labels.l1.label1);
			FalseLabel = (yyvsp[(4) - (7)].labels.l2.label2);
			_here;
		;}
    break;

  case 3026:

/* Line 1464 of yacc.c  */
#line 98879 "hlaparse.bsn"
    {
			_here; 
			(yyval.labels.l1.label1) = TrueLabel;
			(yyval.labels.l2.label2) = FalseLabel;
			TrueLabel = LblCntr++;
			FalseLabel = TrueLabel;
		;}
    break;

  case 3027:

/* Line 1464 of yacc.c  */
#line 98896 "hlaparse.bsn"
    {
			char label[ 256 ];
			_here;
			_if( BreakLbl != 0 )

				sprintf( label, "continue" sympost "%d", abs( BreakLbl ) );
				EmitJmpLabel( label );

			_else

				yyerror( "\"continue\" appears outside a loop" );

			_endif
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3028:

/* Line 1464 of yacc.c  */
#line 98922 "hlaparse.bsn"
    {							/* $6 */
			char	tmpLabel[32];
			_here;
			_if( BreakLbl != 0 )

				sprintf( tmpLabel, "continue" sympost "%d", abs( BreakLbl ));
				EmitBooleanExpr
				(
					(yyvsp[(4) - (5)].opnode),
					tmpLabel,
					1
				);


			_else

				yyerror( "\"continueif\" appears outside a loop" );

			_endif
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3029:

/* Line 1464 of yacc.c  */
#line 98954 "hlaparse.bsn"
    {							/* $8 */
			_here;
			_if( BreakLbl != 0 )

				EmitBackPatchddc
				(
					"true" sympost "%d",
					TrueLabel,
					"continue" sympost "%d",
					abs( BreakLbl ),
					"continueif"
				);
				EmitStmtLblNum( "false" sympost "%d", FalseLabel );

			_else

				yyerror( "\"continueif\" appears outside a loop" );

			_endif
			TrueLabel = (yyvsp[(4) - (7)].labels.l1.label1);
			FalseLabel = (yyvsp[(4) - (7)].labels.l2.label2);
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3030:

/* Line 1464 of yacc.c  */
#line 98984 "hlaparse.bsn"
    {
			_here; 
			(yyval.labels.l1.label1) = TrueLabel;
			(yyval.labels.l2.label2) = FalseLabel;
			TrueLabel = LblCntr++;
			FalseLabel = TrueLabel;
		;}
    break;

  case 3031:

/* Line 1464 of yacc.c  */
#line 99006 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.unsval) = 0;
		;}
    break;

  case 3032:

/* Line 1464 of yacc.c  */
#line 99014 "hlaparse.bsn"
    {
			_here; 
			(yyval.v.u.unsval) = 1;
		;}
    break;

  case 3033:

/* Line 1464 of yacc.c  */
#line 99028 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
		;}
    break;

  case 3034:

/* Line 1464 of yacc.c  */
#line 99042 "hlaparse.bsn"
    {
			_here; 
			(yyval.returns) = NULL;
		;}
    break;

  case 3035:

/* Line 1464 of yacc.c  */
#line 99060 "hlaparse.bsn"
    {				/* $9  */

			SymNode_t				*sym;
			struct StaticListType	*sList;
			struct FwdRefLabelType	*temp;
			struct FwdRefLabelType	*flist;
			char 					target[ 256 ];


			_here; 
			sym = (yyvsp[(8) - (8)].neID.s);

			/*
			** See if "AnyID" ($8 above) is "true" or "false":
			*/

			_if
			(
					sym == &true_ste
			)

				/*
				** Make sure it's legal to JT to the "true" label.
				*/

				_if( (yyvsp[(4) - (8)].labels.l1.trueTarget) != -1 )

					EmitBackPatchddc
					(
						"true" sympost "%d",
						TrueLabel,
						"true"  sympost "%d",
						(yyvsp[(4) - (8)].labels.l1.trueTarget),
						"JT"
					);
					EmitStmtLblNum( "false" sympost "%d", FalseLabel ); 
					
				_else

					yyerror( "\"true\" cannot be used as a label here" );

				_endif


			_elseif
			(
					sym == &false_ste
			)

				/*
				** Make sure it's legal to JT to the "false" label.
				*/

				_if( (yyvsp[(4) - (8)].labels.l2.falseTarget) != -1 )

					EmitBackPatchddc
					(
						"true" sympost "%d",
						TrueLabel,
						"false" sympost "%d",
						(yyvsp[(4) - (8)].labels.l2.falseTarget),
						"JT"
					);
					EmitStmtLblNum( "false" sympost "%d", FalseLabel ); 


				_else

					yyerror( "\"false\" cannot be used as a label here" );

				_endif


			/*
			** Okay, AnyID is not "true" or "false", make sure it's a legal
			** statement label and emit a jump to it.
			*/

			_elseif
			(
					sym != NULL 
				&&	sym->LexLevel == CurLexLevel
				&&	sym->SymClass != cLabel
			)

				/*
				** Attempting to jump to something that is not a label.
				*/

				yyerror( "Illegal branch target" );

			_elseif
			( 
					sym != NULL 
				&&	sym->LexLevel == CurLexLevel
				&&	sym->SymClass == cLabel
			)

				/*
				** We've got a jump to a label that is already defined.
				*/

					EmitBackPatchds
					(
						"true" sympost "%d",
						TrueLabel,
						sym->StaticName
					);
					EmitStmtLblNum( "false" sympost "%d", FalseLabel ); 

			_else

				/*
				** We've got a jump to a label that has yet to be defined
				** in this procedure (note that the label could be defined
				** outside the current procedure as anything, but we'll
				** defer judgement on this until we finish processing the
				** current procedure).
				*/



				/*
				** First, let's see if there is already a reference
				** to this particular identifier so we can use the
				** existing StaticName.
				*/

				flist = FwdLabelsList;
				_while( flist != NULL )

					_breakif( _streq( (yyvsp[(8) - (8)].neID.idStr), flist->label ));
					flist = flist->Next;

				_endwhile

				_if( flist != NULL )

					flist->referenced = 1;
					
					/*
					** We found the symbol in the forward reference
					** list.  So just use the StaticName field of the
					** symbol we located as the target label.
					*/

					EmitBackPatchds
					(
						"true" sympost "%d",
						TrueLabel,
						flist->StaticName
					);
					EmitStmtLblNum( "false" sympost "%d", FalseLabel ); 

				_else

					/*
					** We didn't find the symbol in the forward reference
					** list, so add it to that list.
					*/


					temp = malloc2( sizeofFwdRefLabelType );
					temp->Next = FwdLabelsList;
					temp->label = hlastrdup2( (yyvsp[(8) - (8)].neID.idStr) );
					temp->lexLevel = CurLexLevel;
					sprintf( target, "%s" sympost "%d", (yyvsp[(8) - (8)].neID.idStr), LblCntr++ );
					temp->StaticName = hlastrdup2( target );
					temp->isExternal = 0;
					temp->referenced = 0;
					FwdLabelsList = temp;
					EmitBackPatchds
					(
						"true" sympost "%d",
						TrueLabel,
						temp->StaticName
					);
					EmitStmtLblNum( "false" sympost "%d", FalseLabel ); 

				_endif

			_endif

			TrueLabel = (yyvsp[(4) - (8)].labels.l1.trueTarget);
			FalseLabel = (yyvsp[(4) - (8)].labels.l2.falseTarget);
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 3036:

/* Line 1464 of yacc.c  */
#line 99263 "hlaparse.bsn"
    {				/* $10 */

			SymNode_t *sym;

			_here; 
			sym = lookup( (yyvsp[(8) - (8)].neID.idStr), 1 );

			/*
			** See if "AnyID" ($8 above) is "true" or "false":
			*/

			_if
			(
					sym == &true_ste
			)

				/*
				** Make sure it's legal to JF to the "true" label.
				*/

				_if( (yyvsp[(4) - (8)].labels.l1.trueTarget) != -1 )

					EmitBackPatchddc
					(
						"false" sympost "%d",
						TrueLabel,
						"true" sympost "%d",
						(yyvsp[(4) - (8)].labels.l1.trueTarget),
						"JF"
					);
					EmitStmtLblNum( "true" sympost "%d", FalseLabel ); 

				_else

					yyerror( "\"true\" cannot be used as a label here" );

				_endif


			_elseif
			(
					sym == &false_ste
			)

				/*
				** Make sure it's legal to JT to the "false" label.
				*/

				_if( (yyvsp[(4) - (8)].labels.l2.falseTarget) != -1 )

					EmitBackPatchddc
					(
						"false" sympost "%d",
						TrueLabel,
						"false" sympost "%d",
						(yyvsp[(4) - (8)].labels.l2.falseTarget),
						"JF"
					);
					EmitStmtLblNum( "true" sympost "%d", FalseLabel ); 


				_else

					yyerror( "\"false\" cannot be used as a label here" );

				_endif


			/*
			** Okay, AnyID is not "true" or "false", make sure it's a legal
			** statement label and emit a jump to it.
			*/

			_elseif
			(
					sym != NULL 
				&&	sym->LexLevel == CurLexLevel
				&&	sym->SymClass != cLabel
			)

				/*
				** Attempting to jump to something that is not a label.
				*/

				yyerror( "Illegal branch target" );

			_elseif
			( 
					sym != NULL 
				&&	sym->LexLevel == CurLexLevel
				&&	sym->SymClass == cLabel
			)

				/*
				** We've got a jump to a label that is already defined.
				*/

					EmitBackPatchds
					(
						"false" sympost "%d",
						TrueLabel,
						sym->StaticName
					);
					EmitStmtLblNum( "true" sympost "%d", FalseLabel ); 

			_else

				/*
				** We've got a jump to a label that has yet to be defined
				** in this procedure (note that the label could be defined
				** outside the current procedure as anything, but we'll
				** defer judgement on this until we finish processing the
				** current procedure).
				*/

				struct FwdRefLabelType *flist;


				/*
				** First, let's see if there is already a reference
				** to this particular identifier so we can use the
				** existing StaticName.
				*/

				flist = FwdLabelsList;
				_while( flist != NULL )

					_breakif( _streq( (yyvsp[(8) - (8)].neID.idStr), flist->label ));
					flist = flist->Next;

				_endwhile

				_if( flist != NULL )

					flist->referenced = 1;
					
					/*
					** We found the symbol in the forward reference
					** list.  So just use the StaticName field of the
					** symbol we located as the target label.
					*/

					EmitBackPatchds
					(
						"false" sympost "%d",
						TrueLabel,
						flist->StaticName
					);
					EmitStmtLblNum( "true" sympost "%d", FalseLabel ); 

				_else
				
					char target[ 256 ];

					/*
					** We didn't find the symbol in the forward reference
					** list, so add it to that list.
					*/

					struct FwdRefLabelType *temp;

					temp = malloc2( sizeofFwdRefLabelType );
					temp->Next = FwdLabelsList;
					temp->label = hlastrdup2( (yyvsp[(8) - (8)].neID.idStr) );
					temp->lexLevel = CurLexLevel;
					temp->isExternal = 0;
					temp->referenced = 1;
					sprintf( target, "%s" sympost "%d", (yyvsp[(8) - (8)].neID.idStr), LblCntr++ );
					temp->StaticName = hlastrdup2( target );
					FwdLabelsList = temp;
					EmitBackPatchds
					(
						"false" sympost "%d",
						TrueLabel,
						temp->StaticName
					);
					EmitStmtLblNum( "true" sympost "%d", FalseLabel ); 



				_endif

			_endif

			TrueLabel = (yyvsp[(4) - (8)].labels.l1.trueTarget);
			FalseLabel = (yyvsp[(4) - (8)].labels.l2.falseTarget);
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 3037:

/* Line 1464 of yacc.c  */
#line 99458 "hlaparse.bsn"
    {
			_here; 
			(yyval.labels.l1.trueTarget) = TrueLabel;
			(yyval.labels.l2.falseTarget) = FalseLabel;
			TrueLabel = LblCntr;
			FalseLabel = LblCntr++;
		;}
    break;

  case 3038:

/* Line 1464 of yacc.c  */
#line 99489 "hlaparse.bsn"
    {

			/*
			** We've got to look up the target label to see
			** if it already exists.  If not, we've got to add
			** it to the labels forward reference list.
			*/

			struct StaticListType	*sList;
			char					*jmp;
			struct FwdRefLabelType	*flist;
			struct FwdRefLabelType	*temp;
			SymNode_t				*sym;
			char					target[256];
			char					tmpLabel[32];

			assert( (yyvsp[(-1) - (0)].neID.idStr) != NULL );

			_here; 
			sym = (yyvsp[(-1) - (0)].neID.s);
			_if
			(
					sym == &true_ste
			)

				_if( TrueLabel != -1 )

					sprintf
					(
						target,
						"true" sympost "%d",
						TrueLabel
					);

				_else

					yyerror( "\"true\" cannot be used as a label here" );

				_endif


			_elseif
			(
					sym == &false_ste
			)

				_if( FalseLabel != -1 )

					sprintf
					(
						target,
						"false" sympost  "%d",
						FalseLabel
					);

				_else

					yyerror( "\"false\" cannot be used as a label here" );

				_endif


			_elseif
			(
					sym != NULL 
				&&	sym->LexLevel == CurLexLevel
				&&	sym->SymClass != cLabel
			)

				/*
				** Attempting to jump to something that is not a label.
				*/

				yyerror( "Illegal branch target" );

			_elseif
			( 
					sym != NULL 
				&&	sym->LexLevel == CurLexLevel
				&&	sym->SymClass == cLabel
			)

				/*
				** We've got a jump to a label that is already defined.
				*/

				strcpy( target, sym->StaticName );

			_else

				/*
				** We've got a jump to a label that has yet to be defined
				** in this procedure (note that the label could be defined
				** outside the current procedure as anything, but we'll
				** defer judgement on this until we finish processing the
				** current procedure).
				**
				** Also note that compiler defined labels always begin with
				** a question mark, we'll just ignore those and assume that
				** the compiler will eventually emit the label.
				*/



				/*
				** First, let's see if there is already a reference
				** to this particular identifier so we can use the
				** existing StaticName.
				*/


				flist = FwdLabelsList;
				_while( flist != NULL )

					_breakif( _streq( (yyvsp[(-1) - (0)].neID.idStr), flist->label ));
					flist = flist->Next;

				_endwhile

				_if( flist != NULL )

					flist->referenced = 1;
					
					/*
					** We found the symbol in the forward reference
					** list.  So just use the StaticName field of the
					** symbol we located as the target label.
					*/

					strcpy( target, flist->StaticName );

				_else


					// See if this symbol is in the StaticList. Use the
					// existing static name if it is:
					
					sList = searchStatic( (yyvsp[(-1) - (0)].neID.idStr) );
					_if( sList == NULL )
					
						/*
						** We didn't find the symbol in the static list,
						** so add it to the forward reference list
						*/


						temp = malloc2( sizeofFwdRefLabelType );
						temp->Next = FwdLabelsList;
						temp->label = hlastrdup2( (yyvsp[(-1) - (0)].neID.idStr) );
						temp->lexLevel = CurLexLevel;
						temp->isExternal = 0;
						temp->referenced = 1;
						sprintf
						( 
							target, 
							"%s" sympost "%d", 
							(yyvsp[(-1) - (0)].neID.idStr), 
							LblCntr++ 
						);
						temp->StaticName = hlastrdup2( target );
						FwdLabelsList = temp;
						
					_else
					
						// It was in the static list, so use the existing
						// static name:

						strcpy( target, sList->StaticName );
						
					_endif

				_endif

			_endif


			/*
			** Emit the instruction for this conditional jump instruction.
			*/

			EmitBooleanExpr
			(
				(yyvsp[(-3) - (0)].opnode),
				target,
				(yyvsp[(0) - (0)].v.u.unsval)
			);

			free2( vss (yyvsp[(-1) - (0)].neID.idStr) );
			_here; 
		;}
    break;

  case 3039:

/* Line 1464 of yacc.c  */
#line 99720 "hlaparse.bsn"
    {							/* $10 */

			/*
			** Emit the target label for the conditional jump
			** output by "EmitSkipThen" above.
			*/

			_here; 
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(7) - (9)].v.u.unsval) );
			(yyval.returns) = NULL;
		;}
    break;

  case 3040:

/* Line 1464 of yacc.c  */
#line 99745 "hlaparse.bsn"
    {
			char tmpLabel[32];
			
			_here;
			(yyval.v.u.unsval) = (yyvsp[(-3) - (0)].labels.l2.falseTarget);
			sprintf( tmpLabel, "false" sympost "%d", (yyval.v.u.unsval));
			EmitBooleanExpr
			(
				(yyvsp[(-2) - (0)].opnode),
				tmpLabel,
				0
			);
			_here;
		;}
    break;

  case 3041:

/* Line 1464 of yacc.c  */
#line 99791 "hlaparse.bsn"
    {				/* $10 */

			char label[ 256 ];

			_here; 
			sprintf( label, "endif" sympost "%d", (yyvsp[(3) - (9)].labels.l3.exitTarget) );
			EmitJmpLabel( label );
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(7) - (9)].v.u.unsval) );
			_here; 
		;}
    break;

  case 3042:

/* Line 1464 of yacc.c  */
#line 99803 "hlaparse.bsn"
    {				/* $15 */
			/*
			** Emit the target label for the conditional jump
			** output by semantic action $10, above.
			*/

			_here; 
			EmitStmtLblNum( "endif" sympost "%d", (yyvsp[(3) - (12)].labels.l3.exitTarget) );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 3043:

/* Line 1464 of yacc.c  */
#line 99851 "hlaparse.bsn"
    {				/* $12 */
			/*
			** Emit the target label for the conditional jump
			** output by "ExitIfLabel" and used by "ElseIfs" above.
			*/

			_here; 
			EmitStmtLblNum( "endif" sympost "%d", (yyvsp[(3) - (11)].labels.l3.exitTarget) );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 3044:

/* Line 1464 of yacc.c  */
#line 99866 "hlaparse.bsn"
    { 
			char label[ 256 ];

			_here; 
			(yyval.labels.l1.trueTarget) = (yyvsp[(-5) - (0)].labels.l1.trueTarget);		// true label
			(yyval.labels.l2.falseTarget) = (yyvsp[(-5) - (0)].labels.l2.falseTarget);	// false label
			(yyval.labels.l3.exitTarget) = (yyvsp[(-5) - (0)].labels.l3.exitTarget);		// exit label

			sprintf( label, "endif" sympost "%d", (yyval.labels.l3.exitTarget) );
			EmitJmpLabel( label );
		;}
    break;

  case 3045:

/* Line 1464 of yacc.c  */
#line 99931 "hlaparse.bsn"
    {				/* $14 */
			/*
			** Emit the target label for the conditional jump
			** output by "ExitIfLabel" and used by "ElseIfs" above.
			*/

			_here; 
			EmitStmtLblNum( "endif" sympost "%d", (yyvsp[(3) - (13)].labels.l3.exitTarget) );
			(yyval.returns) = NULL;
		;}
    break;

  case 3046:

/* Line 1464 of yacc.c  */
#line 99964 "hlaparse.bsn"
    {
			_here; 
			(yyval.labels.saveTrue) = TrueLabel;
			(yyval.labels.saveFalse) = FalseLabel;
			(yyval.labels.l1.trueTarget) = LblCntr;
			(yyval.labels.l2.falseTarget) = LblCntr;
			(yyval.labels.l3.exitTarget) = LblCntr;
			TrueLabel = LblCntr++;
			FalseLabel = TrueLabel;
		;}
    break;

  case 3047:

/* Line 1464 of yacc.c  */
#line 99990 "hlaparse.bsn"
    {				/* $12 */
			/*
			** Emit the target label for SetFalseLabel.
			*/

			_here; 
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(9) - (11)].labels.l2.falseTarget) );
			(yyval.returns) = NULL;
		;}
    break;

  case 3048:

/* Line 1464 of yacc.c  */
#line 100003 "hlaparse.bsn"
    {
			_here;
			EmitStmtLblNum( "true" sympost "%d", TrueLabel );


			/*
			** Do not allow further use of "true" or "false"
			** as jump target labels (at least, not the labels
			** associated with this if statement).  However,
			** we do have to save FalseLabel's value so we can
			** emit the label later.
			*/

			(yyval.labels.l1.trueTarget) = TrueLabel;
			(yyval.labels.l2.falseTarget) = FalseLabel;
			FalseLabel = (yyvsp[(-4) - (0)].labels.saveFalse);
			TrueLabel = (yyvsp[(-4) - (0)].labels.saveTrue);
		;}
    break;

  case 3049:

/* Line 1464 of yacc.c  */
#line 100056 "hlaparse.bsn"
    {				/* $12 */

			_here; 
			(yyval.labels.l2.falseTarget) = (yyvsp[(9) - (11)].labels.l2.falseTarget);
		;}
    break;

  case 3050:

/* Line 1464 of yacc.c  */
#line 100064 "hlaparse.bsn"
    {				/* $16 */
			/*
			** Emit the target label for SetFalseLabel.
			*/

			_here;
			EmitStmtLblNum( "endif" sympost "%d", (yyvsp[(13) - (15)].labels.l3.exitTarget) );
			(yyval.returns) = NULL;
			(void) (yyvsp[(12) - (15)].labels.l2.falseTarget);	// shut up bison
			_here;
		;}
    break;

  case 3051:

/* Line 1464 of yacc.c  */
#line 100115 "hlaparse.bsn"
    {				/* $14 */
			/*
			** Emit the target label for SetFalseLabel.
			*/

			_here;
			EmitStmtLblNum( "endif" sympost "%d", (yyvsp[(4) - (13)].labels.l3.exitTarget) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3052:

/* Line 1464 of yacc.c  */
#line 100130 "hlaparse.bsn"
    {
			char label[ 256 ];

			_here; 
			(yyval.labels.l2.falseTarget) = (yyvsp[(-6) - (0)].labels.l3.exitTarget);
			(yyval.labels.l3.exitTarget) = (yyvsp[(-6) - (0)].labels.l3.exitTarget);

			sprintf( label, "endif" sympost "%d", (yyval.labels.l3.exitTarget) );
			EmitJmpLabel( label );
			_here;
		;}
    break;

  case 3053:

/* Line 1464 of yacc.c  */
#line 100185 "hlaparse.bsn"
    {				/* $17 */
			/*
			** Emit the target label for SetFalseLabel.
			*/

			_here;
			EmitStmtLblNum( "endif" sympost "%d", (yyvsp[(4) - (15)].labels.l3.exitTarget) );
			(yyval.returns) = NULL;
			_here;
		;}
    break;

  case 3056:

/* Line 1464 of yacc.c  */
#line 100235 "hlaparse.bsn"
    {
			char label[ 256 ];

			_here; 
			(yyval.labels.l2.falseTarget) = (yyvsp[(-5) - (0)].labels.l2.falseTarget);
			(yyval.labels.l3.exitTarget) = (yyvsp[(-9) - (0)].labels.l3.exitTarget);
			sprintf( label, "endif" sympost "%d", (yyval.labels.l3.exitTarget) );
			EmitJmpLabel( label );
			_here; 
		;}
    break;

  case 3057:

/* Line 1464 of yacc.c  */
#line 100262 "hlaparse.bsn"
    {				/* $10 */


			/*
			** Emit the target label for the conditional jump
			** output by "EmitSkipThen" above.
			*/
			
			_here;
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(4) - (9)].labels.l2.falseTarget) );
			_here;
		;}
    break;

  case 3059:

/* Line 1464 of yacc.c  */
#line 100300 "hlaparse.bsn"
    {
			_here;
			(yyval.labels.saveTrue) = TrueLabel;
			(yyval.labels.saveFalse) = FalseLabel;
			(yyval.labels.l1.trueTarget) = LblCntr;
			(yyval.labels.l2.falseTarget) = LblCntr;
			(yyval.labels.l3.exitTarget) = (yyvsp[(-3) - (0)].labels.l3.exitTarget);
			TrueLabel = LblCntr++;
			FalseLabel = TrueLabel;
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(-3) - (0)].labels.l2.falseTarget) );
			_here;
		;}
    break;

  case 3060:

/* Line 1464 of yacc.c  */
#line 100316 "hlaparse.bsn"
    {
			char label[ 256 ];

			_here; 
			(yyval.labels.l2.falseTarget) = (yyvsp[(-6) - (0)].labels.l2.falseTarget);
			(yyval.labels.l3.exitTarget) = (yyvsp[(-10) - (0)].labels.l3.exitTarget);

			sprintf( label, "endif" sympost "%d", (yyval.labels.l3.exitTarget) );
			EmitJmpLabel( label );
			_here;
		;}
    break;

  case 3061:

/* Line 1464 of yacc.c  */
#line 100352 "hlaparse.bsn"
    {				/* $11 */


			/*
			** Emit the false label.
			*/

			_here;
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(9) - (10)].labels.l2.falseTarget) );
			_here;
		;}
    break;

  case 3063:

/* Line 1464 of yacc.c  */
#line 100415 "hlaparse.bsn"
    {				/* $12 */

			char label[ 256 ];

			_here;

			/*
			** Emit the target label for the conditional jump
			** output by "EmitSkipThen" above.
			*/

			sprintf( label, "endif" sympost "%d", (yyvsp[(0) - (9)].labels.l3.exitTarget) );
			EmitJmpLabel( label );
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(4) - (9)].labels.l2.falseTarget) );
			_here;
		;}
    break;

  case 3065:

/* Line 1464 of yacc.c  */
#line 100475 "hlaparse.bsn"
    {				/* $11 */

			char label[ 256 ];

			/*
			** Emit the false label.
			*/

			_here; 
			sprintf( label, "endif" sympost "%d", (yyvsp[(0) - (10)].labels.l3.exitTarget) );
			EmitJmpLabel( label );
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(9) - (10)].labels.l2.falseTarget) );
			_here; 
		;}
    break;

  case 3066:

/* Line 1464 of yacc.c  */
#line 100500 "hlaparse.bsn"
    {
			_here;
			EmitStmtLblNum( "true" sympost "%d", TrueLabel );

			/*
			** Do not allow further use of "true" or "false"
			** as jump target labels (at least, not the labels
			** associated with this if statement).  However,
			** we do have to save FalseLabel's value so we can
			** emit the label later.
			*/

			(yyval.labels.l1.trueTarget) = TrueLabel;
			(yyval.labels.l2.falseTarget) = FalseLabel;
			FalseLabel = (yyvsp[(-3) - (0)].labels.saveFalse);
			TrueLabel = (yyvsp[(-3) - (0)].labels.saveTrue);
			_here;
		;}
    break;

  case 3067:

/* Line 1464 of yacc.c  */
#line 100523 "hlaparse.bsn"
    {
			char label[ 256 ];

			_here;
			(yyval.labels.l3.exitTarget) = LblCntr++;

			sprintf( label, "endif" sympost "%d", (yyval.labels.l3.exitTarget) );
			EmitJmpLabel( label );
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(0) - (0)].labels.l2.falseTarget) );
			_here;
		;}
    break;

  case 3068:

/* Line 1464 of yacc.c  */
#line 100544 "hlaparse.bsn"
    {
			_here;
			EmitStmtLblNum( "false" sympost "%d", (yyvsp[(-2) - (0)].labels.l2.falseTarget) );
			_here;
		;}
    break;

  case 3069:

/* Line 1464 of yacc.c  */
#line 100556 "hlaparse.bsn"
    {
			yyerror( "Expected 'then'" );
		;}
    break;

  case 3071:

/* Line 1464 of yacc.c  */
#line 100580 "hlaparse.bsn"
    {
			int 			sorted;
			int 			temp;
			int				spread;
			int				index;
			int				maxCase;
			int				curCase;
			char			*codeForCases;
			struct adrsYYS	adrs;
			char			jmpTbl[64];
			char			jmpToEnd[64];
			char			label[64];
			char			msg[128];
			
			_here;
			
			// Sort the case table here:
			// Just use a stupid bubble sort because there are rarely more
			// than a couple dozen cases in a switch statement. 
			
			assert( (yyvsp[(6) - (9)].cases.cnt) > 0 );
			_do
			
				
				sorted = 1;
				_for( int i = 1, i < (yyvsp[(6) - (9)].cases.cnt), ++i )
				
					_if( (int) (yyvsp[(6) - (9)].cases.cases)[i-1] > (int) (yyvsp[(6) - (9)].cases.cases)[i] )
					
						sorted = 0;
						temp = (yyvsp[(6) - (9)].cases.cases)[i-1];
						(yyvsp[(6) - (9)].cases.cases)[i-1] = (yyvsp[(6) - (9)].cases.cases)[i];
						(yyvsp[(6) - (9)].cases.cases)[i] = temp;
						
						temp = (yyvsp[(6) - (9)].cases.caseLbls)[i-1];
						(yyvsp[(6) - (9)].cases.caseLbls)[i-1] = (yyvsp[(6) - (9)].cases.caseLbls)[i];
						(yyvsp[(6) - (9)].cases.caseLbls)[i] = temp;
						
					_endif
					
				_endfor
						
			_until( sorted );
			
			// Make a quick pass through the table and make sure there
			// are no duplicate entries:
			
			_for( int i = 1, i < (yyvsp[(6) - (9)].cases.cnt), ++i )
			
				_if( (yyvsp[(6) - (9)].cases.cases)[i-1] == (yyvsp[(6) - (9)].cases.cases)[i] )
				
					sprintf
					( 
						msg, 
						"Duplicate case value: %d", 
						(yyvsp[(6) - (9)].cases.cases)[i] 
					);
					yyerror( msg );
					
				_endif
				
			_endfor

			// Grab all the code emitted for the cases so
			// we can insert the indirect jump in front of it.
			
			codeForCases = getFileStr( (yyvsp[(6) - (9)].cases.startOfCases) );
			
			
			// Emit the jmp table at this point.
			// Note that this goes to the constants (strings) section,
			// not into the current code section.
			//
			// Begin by doing some sanity checks to make
			// sure the table isn't too big or too sparse:
			
			spread = (yyvsp[(6) - (9)].cases.cases)[ (yyvsp[(6) - (9)].cases.cnt) - 1 ] - (yyvsp[(6) - (9)].cases.cases)[ 0 ];
			
			// First, check to see if we're even going to emit a jump table.
			// If there are three or fewer cases, or if the count is small
			// and the spread is large, then we're going to emit a sequence
			// of cmp/Jcc instructions.
			
			_if
			( 
					(yyvsp[(6) - (9)].cases.cnt) <= 3
				||	(spread > 256 && (yyvsp[(6) - (9)].cases.cnt) < 32) 
			)
			
				// At this point, the cases don't justify the use of
				// a jump table. Just emit a sequence of cmp/je instructions.
				
				_for( int i=0, i < (yyvsp[(6) - (9)].cases.cnt), ++i )
				
					EmitGeneric_c_r
					( 
						cmp_instr, 
						(yyvsp[(6) - (9)].cases.cases)[i], 
						(yyvsp[(3) - (9)].reg.encoding) 
					);
					sprintf( label, "case" sympost "%d", (yyvsp[(6) - (9)].cases.caseLbls)[i] );
					EmitCondJump( je_instr, label );
					
				_endfor
				
				// At the end of the cmp/JE sequence, emit a jump to the
				// default case:
				
				sprintf( label, "default" sympost "%d", (yyvsp[(5) - (9)].u) );
				EmitJmpLabel( label );
			
			_elseif( spread > 16384 )
			
				yyerror( "Spread of case values is too large" );
				
			_else
			
				_if( spread > 4096 )
			
					WarnNear
					( 
						"The case table is going to be very large", 
						"switch" 
					);
					
				_endif
				_if( spread/16 > (yyvsp[(6) - (9)].cases.cnt) )
			
					WarnNear
					( 
						"The case table is very sparse", 
						"switch" 
					);
					
				_endif
				
				// Okay, emit the jmp table:
				
				startStrSeg();	// Put the jump table in the constants section.
				sprintf( jmpTbl, "jmpTbl" sympost "%d", (yyvsp[(5) - (9)].u) );
				EmitTypedLabel( jmpTbl, tDWord );
				maxCase = (yyvsp[(6) - (9)].cases.cases)[ (yyvsp[(6) - (9)].cases.cnt) - 1 ];
				curCase = (yyvsp[(6) - (9)].cases.cases)[0];
				index = 0;
				_while( curCase <= maxCase )

					_if( curCase == (yyvsp[(6) - (9)].cases.cases)[index] )
					
						sprintf
						( 
							label, 
							"case" sympost "%d", 
							(yyvsp[(6) - (9)].cases.caseLbls)[index] 
						);
						++index;
					
					_else	// Fill in default address
					
						sprintf( label, "default" sympost "%d", (yyvsp[(5) - (9)].u) );
						 
					_endif
					EmitOffset( label, 0 );
					++curCase;
				
				_endwhile 
				endStrSeg();	// Return back to the code section.
				
				// Compare the value against the minimum and maximum range
				// values and bail to the default case if it's out of range:
				//
				// Note: special case for the minimum case is zero
				
				_if( (yyvsp[(6) - (9)].cases.cases)[0] != 0 )
				
					EmitGeneric_c_r
					( 
						cmp_instr, 
						(yyvsp[(6) - (9)].cases.cases)[0], 
						(yyvsp[(3) - (9)].reg.encoding) 
					);
					sprintf( label, "default" sympost "%d", (yyvsp[(5) - (9)].u) );
					EmitCondJump( jl_instr, label );
					
				_endif
				EmitGeneric_c_r
				( 
					cmp_instr, 
					(yyvsp[(6) - (9)].cases.cases)[ (yyvsp[(6) - (9)].cases.cnt) - 1 ], 
					(yyvsp[(3) - (9)].reg.encoding) 
				);
				sprintf( label, "default" sympost "%d", (yyvsp[(5) - (9)].u) );
				EmitCondJump( jg_instr, label );
					
				// Okay, emit the indirect jump statement:
				
				initAdrs2
				( 
					&adrs,
					jmpTbl,
					-1, 
					(yyvsp[(3) - (9)].reg.encoding),
					4,
					-(yyvsp[(6) - (9)].cases.cases)[0] * 4	// minimum index into table.
				);
				EmitJmp_m( &adrs );
				
			_endif
			
			// Emit the code for all the cases after the indirect jump
			// (or sequence of cmp/Jcc instrs if we bailed on the
			// conditional jump).
			
			asmPuts( codeForCases  );
			
			// Emit the end of switch label:
			
			EmitStmtLblNum( "endswitch" sympost "%d", (yyvsp[(5) - (9)].u) );
			
			// If there was no default clause, we need to emit
			// a default label as well:
			
			_if( (yyvsp[(8) - (9)].u) )
			
				EmitStmtLblNum( "default" sympost "%d", (yyvsp[(5) - (9)].u) );
				
			_endif
			
			// Clean up:
				 
			free2( vss codeForCases );
			free2( vss (yyvsp[(6) - (9)].cases.cases) );
			free2( vss (yyvsp[(6) - (9)].cases.caseLbls) );
			(yyval.returns) = NULL;
			_here; 
		;}
    break;

  case 3072:

/* Line 1464 of yacc.c  */
#line 100821 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = 1;	// Need a default label at the end
		;}
    break;

  case 3073:

/* Line 1464 of yacc.c  */
#line 100827 "hlaparse.bsn"
    {
			char jmpToEnd[64];

			// Emit a jmp from the previous case to the
			// end of the switch statement:
			
			_here; 
			sprintf( jmpToEnd, "endswitch" sympost "%d", (yyvsp[(-2) - (1)].u) );
			EmitJmpLabel( jmpToEnd );
			
			// Emit the label for the default case:
			
			sprintf( jmpToEnd, "default" sympost "%d", (yyvsp[(-2) - (1)].u) );
			EmitGlobalStmtLbl( jmpToEnd );
			_here; 
		;}
    break;

  case 3074:

/* Line 1464 of yacc.c  */
#line 100844 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = 0;	// No default label needed.
		;}
    break;

  case 3075:

/* Line 1464 of yacc.c  */
#line 100857 "hlaparse.bsn"
    {
			_here; 
			(yyval.u) = LblCntr++;
		;}
    break;

  case 3076:

/* Line 1464 of yacc.c  */
#line 100867 "hlaparse.bsn"
    {
			_here; 
			(yyval.cases.cnt) = 0;				// Total number of cases.
			(yyval.cases.exitLbl) = (yyvsp[(0) - (0)].u);		// Where a case jumps when it's done.
			(yyval.cases.defaultLbl) = (yyvsp[(0) - (0)].u);	// The initial default case.
			
			// Save a pointer to the start of the cases code so we can
			// insert the indirect jump and the jump table before this code.
			
			(yyval.cases.startOfCases) = asmBuf->offset;
		;}
    break;

  case 3077:

/* Line 1464 of yacc.c  */
#line 100889 "hlaparse.bsn"
    {
			// Handle the first case here.
			// Note that we do not need to emit a JMP to
			// the end of the switch before this guy.
			
			// Allocate storage for, and copy all the case values to the 
			// cases.cases array.
			
			_here; 
			(yyvsp[(0) - (6)].cases.cnt) = (yyvsp[(3) - (6)].caseVals.cnt);
			(yyvsp[(0) - (6)].cases.cases) = malloc2( sizeofInt  * (yyvsp[(3) - (6)].caseVals.cnt) );
			memcpy
			( 
				(yyvsp[(0) - (6)].cases.cases), 
				(yyvsp[(3) - (6)].caseVals.cases),
				(yyvsp[(3) - (6)].caseVals.cnt) * sizeofInt 
			);
			
			// Allocate storage for, and copy the case label to the
			// caseVals.caseLbls array:
			
			(yyvsp[(0) - (6)].cases.caseLbls) = malloc2( sizeofInt  * (yyvsp[(3) - (6)].caseVals.cnt) );
			_for( int i=0, i < (yyvsp[(3) - (6)].caseVals.cnt), ++i )
			
				(yyvsp[(0) - (6)].cases.caseLbls)[i] = (yyvsp[(4) - (6)].u);
				
			_endfor
			free2( vss (yyvsp[(3) - (6)].caseVals.cases) );			 
			_here; 
		;}
    break;

  case 3078:

/* Line 1464 of yacc.c  */
#line 100922 "hlaparse.bsn"
    {					// $3
		
			char jmpToEnd[64];

			// Emit a jmp from the previous case to the
			// end of the switch statement:
			
			_here; 
			sprintf( jmpToEnd, "endswitch" sympost "%d", (yyvsp[(0) - (2)].cases.exitLbl) );
			EmitJmpLabel( jmpToEnd );

			_here; 
		;}
    break;

  case 3079:

/* Line 1464 of yacc.c  */
#line 100940 "hlaparse.bsn"
    {
			int		startCase;
			int		*newCases;
			int		*newLbls;
			int		newCnt;
			
			_here; 
			(void) (yyvsp[(3) - (8)].u);	// To shut up bison.

			// Okay, handle the current case.

			startCase = (yyvsp[(0) - (8)].cases.cnt);
			newCnt = (yyvsp[(0) - (8)].cases.cnt) + (yyvsp[(5) - (8)].caseVals.cnt);

			// Allocate storage for, and copy all the case values to the 
			// caseVals.cases array.
			
			newCases = 
				malloc2( sizeofInt  * newCnt );
				
			memcpy
			(
				newCases,
				(yyvsp[(0) - (8)].cases.cases),
				(yyvsp[(0) - (8)].cases.cnt) * sizeofInt 
			);
			memcpy
			( 
				&newCases[ startCase ], 
				(yyvsp[(5) - (8)].caseVals.cases),
				(yyvsp[(5) - (8)].caseVals.cnt) * sizeofInt 
			);
			free2( vss (yyvsp[(0) - (8)].cases.cases) );
			(yyvsp[(0) - (8)].cases.cases) = newCases;
			
			// Allocate storage for, and copy the case label to the
			// caseVals.caseLbls array:
			
			newLbls = 
				malloc2( sizeofInt  * newCnt );
				
			memcpy
			(
				newLbls,
				(yyvsp[(0) - (8)].cases.caseLbls),
				(yyvsp[(0) - (8)].cases.cnt) * sizeofInt 
			);
			_for( int i=0, i < (yyvsp[(5) - (8)].caseVals.cnt), ++i )
			
				newLbls[ startCase + i ] = (yyvsp[(6) - (8)].u);
				
			_endfor
			free2( vss (yyvsp[(0) - (8)].cases.caseLbls) );
			(yyvsp[(0) - (8)].cases.caseLbls) = newLbls;
			(yyvsp[(0) - (8)].cases.cnt) = newCnt;

			free2( vss (yyvsp[(5) - (8)].caseVals.cases) );
			_here;			 
		;}
    break;

  case 3080:

/* Line 1464 of yacc.c  */
#line 101008 "hlaparse.bsn"
    {
			char globLbl[64];
			
			_here; 
			(yyval.u) = LblCntr++;
			sprintf( globLbl, "case" sympost "%d", (yyval.u) );
			EmitGlobalStmtLbl( globLbl );
			_here; 
		;}
    break;

  case 3081:

/* Line 1464 of yacc.c  */
#line 101026 "hlaparse.bsn"
    {
				// Handle the first case (that is, the first constant
				// within the "case" clause).
				
				_here; 
				(yyval.caseVals.cnt) = 1;	// Initialize the count to one.
				
				// Allocate storage for this single element:
				
				(yyval.caseVals.cases) =
					malloc2
					( 
						sizeofInt  
					);

				// Store away this single value:
				
				*(yyval.caseVals.cases) = CheckOrdinalSize( YYS &(yyvsp[(1) - (1)].v), 32 );
				
				_here;
			;}
    break;

  case 3082:

/* Line 1464 of yacc.c  */
#line 101051 "hlaparse.bsn"
    {
				// Handle the 2nd through nth items in the case clause
				// here. We need to bump up the count, allocate storage
				// to hold everything encountered thus far, copy every
				// thing encountered thus far, and then store away
				// the current value at the end of the list.
				
				_here; 
				(yyval.caseVals.cnt) = (yyvsp[(1) - (3)].caseVals.cnt) + 1;
				(yyval.caseVals.cases) =
					malloc2
					( 
						sizeofUns * ( (yyval.caseVals.cnt) )
					);

				memcpy
				( 
					(yyval.caseVals.cases), 
					(yyvsp[(1) - (3)].caseVals.cases),
					sizeofInt  * ((yyvsp[(1) - (3)].caseVals.cnt) )
				);
				(yyval.caseVals.cases)[(yyvsp[(1) - (3)].caseVals.cnt)] = 
					CheckOrdinalSize( YYS &(yyvsp[(3) - (3)].v), 32 );
					
				free2( vss (yyvsp[(1) - (3)].caseVals.cases) );
				_here; 

			;}
    break;

  case 3083:

/* Line 1464 of yacc.c  */
#line 101105 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
				
			_here;
			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftSubexpression = (yyvsp[(1) - (3)].opnode);
			thisNode->r.rightSubexpression = (yyvsp[(3) - (3)].opnode);
			thisNode->operator = and_astop;
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3084:

/* Line 1464 of yacc.c  */
#line 101125 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
				
			_here;
			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftSubexpression = (yyvsp[(1) - (3)].opnode);
			thisNode->r.rightSubexpression = (yyvsp[(3) - (3)].opnode);
			thisNode->operator = or_astop;
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3085:

/* Line 1464 of yacc.c  */
#line 101145 "hlaparse.bsn"
    {
			_here; 
			(yyval.opnode) = (yyvsp[(2) - (3)].opnode);
		;}
    break;

  case 3086:

/* Line 1464 of yacc.c  */
#line 101157 "hlaparse.bsn"
    {

			struct opnodeYYS *thisNode;
				
			_here;
			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftSubexpression = (yyvsp[(3) - (4)].opnode);
			thisNode->r.rightSubexpression = NULL;
			thisNode->operator = not_astop;
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3087:

/* Line 1464 of yacc.c  */
#line 101179 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
				

			_here;

			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(1) - (3)].operand);
			thisNode->r.rightOperand = (yyvsp[(3) - (3)].operand);
			thisNode->operator = (yyvsp[(2) - (3)].v.u.unsval);
			ComparableNodes
			( 
				(struct operandYYS *) (yyvsp[(1) - (3)].operand), 
				(struct operandYYS *) (yyvsp[(3) - (3)].operand), 
				relop2Operators[ (yyvsp[(2) - (3)].v.u.unsval) - eq_astop ] 
			);
			_if
			(
					(yyvsp[(1) - (3)].operand)->o.reg->IsSigned
				||	(yyvsp[(3) - (3)].operand)->o.reg->IsSigned
			)

				thisNode->operator = CnvrtToSigned( (yyvsp[(2) - (3)].v.u.unsval) );

			_endif
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3088:

/* Line 1464 of yacc.c  */
#line 101217 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
				

			_here;

			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(1) - (3)].operand);
			thisNode->r.rightOperand = (yyvsp[(3) - (3)].operand);
			thisNode->operator = (yyvsp[(2) - (3)].v.u.unsval);
			ComparableNodes
			( 
				(struct operandYYS *) (yyvsp[(1) - (3)].operand), 
				(struct operandYYS *) (yyvsp[(3) - (3)].operand), 
				relop2Operators[ (yyvsp[(2) - (3)].v.u.unsval) - eq_astop ] 
			);
			_if
			(
					(yyvsp[(3) - (3)].operand)->o.reg->IsSigned
				||	IsInt( (yyvsp[(1) - (3)].operand)->o.adrs->pType )
			)

				thisNode->operator = CnvrtToSigned( (yyvsp[(2) - (3)].v.u.unsval) );

			_endif
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3089:

/* Line 1464 of yacc.c  */
#line 101256 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
				

			_here;

			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(1) - (3)].operand);
			thisNode->r.rightOperand = (yyvsp[(3) - (3)].operand);
			thisNode->operator = (yyvsp[(2) - (3)].v.u.unsval);

			// Force the sizes to agree.

			(yyvsp[(1) - (3)].operand)->o.adrs->ObjectSize = (yyvsp[(3) - (3)].operand)->o.reg->Size;
			_if( (yyvsp[(3) - (3)].operand)->o.reg->IsSigned	)

				thisNode->operator = CnvrtToSigned( (yyvsp[(2) - (3)].v.u.unsval) );

			_endif
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3090:

/* Line 1464 of yacc.c  */
#line 101289 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
				

			_here;

			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(1) - (3)].operand);
			thisNode->r.rightOperand = (yyvsp[(3) - (3)].operand);
			thisNode->operator = (yyvsp[(2) - (3)].v.u.unsval);
			ComparableNodes
			( 
				(struct operandYYS *) (yyvsp[(1) - (3)].operand), 
				(struct operandYYS *) (yyvsp[(3) - (3)].operand), 
				relop2Operators[ (yyvsp[(2) - (3)].v.u.unsval) - eq_astop ] 
			);
			_if
			(
					(yyvsp[(1) - (3)].operand)->o.reg->IsSigned
				||	IsInt( (yyvsp[(3) - (3)].operand)->o.adrs->pType )
			)

				thisNode->operator = CnvrtToSigned( (yyvsp[(2) - (3)].v.u.unsval) );

			_endif
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3091:

/* Line 1464 of yacc.c  */
#line 101330 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
				

			_here;

			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(1) - (3)].operand);
			thisNode->r.rightOperand = (yyvsp[(3) - (3)].operand);
			thisNode->operator = (yyvsp[(2) - (3)].v.u.unsval);

			// Force the sizes to agree on anon references.

			(yyvsp[(3) - (3)].operand)->o.adrs->ObjectSize = (yyvsp[(1) - (3)].operand)->o.reg->Size;
			_if( (yyvsp[(1) - (3)].operand)->o.reg->IsSigned )

				thisNode->operator = CnvrtToSigned( (yyvsp[(2) - (3)].v.u.unsval) );

			_endif
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3092:

/* Line 1464 of yacc.c  */
#line 101365 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
				

			_here;

			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(1) - (3)].operand);
			thisNode->r.rightOperand = (yyvsp[(3) - (3)].operand);
			thisNode->operator = (yyvsp[(2) - (3)].v.u.unsval);
			ComparableNodes
			( 
				(struct operandYYS *) (yyvsp[(1) - (3)].operand), 
				(struct operandYYS *) (yyvsp[(3) - (3)].operand), 
				relop2Operators[ (yyvsp[(2) - (3)].v.u.unsval) - eq_astop ] 
			);
			_if
			(
					(yyvsp[(1) - (3)].operand)->o.reg->IsSigned
				||	IsInt( (yyvsp[(3) - (3)].operand)->o.v.pType )
			)

				thisNode->operator = CnvrtToSigned( (yyvsp[(2) - (3)].v.u.unsval) );

			_endif
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3093:

/* Line 1464 of yacc.c  */
#line 101405 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
				

			_here;

			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(1) - (3)].operand);
			thisNode->r.rightOperand = (yyvsp[(3) - (3)].operand);
			thisNode->operator = (yyvsp[(2) - (3)].v.u.unsval);
			ComparableNodes
			( 
				(struct operandYYS *) (yyvsp[(1) - (3)].operand), 
				(struct operandYYS *) (yyvsp[(3) - (3)].operand), 
				relop2Operators[ (yyvsp[(2) - (3)].v.u.unsval) - eq_astop ] 
			);
			_if
			(
					IsInt( (yyvsp[(1) - (3)].operand)->o.adrs->pType )
				||	IsInt( (yyvsp[(3) - (3)].operand)->o.v.pType )
			)

				thisNode->operator = CnvrtToSigned( (yyvsp[(2) - (3)].v.u.unsval) );

			_endif
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3094:

/* Line 1464 of yacc.c  */
#line 101440 "hlaparse.bsn"
    { (yyval.v.u.unsval) = 1; ;}
    break;

  case 3095:

/* Line 1464 of yacc.c  */
#line 101441 "hlaparse.bsn"
    { (yyval.v.u.unsval) = 0; ;}
    break;

  case 3096:

/* Line 1464 of yacc.c  */
#line 101448 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
				

			_here;

			thisNode = malloc2( sizeofOpnode );

			_if( (yyvsp[(1) - (3)].operand)->o.reg->Size != 1 )

				yyerror( "Register operand must be a byte register" );

			_endif
			_if( (yyvsp[(3) - (3)].operand)->o.adrs->pType != tCset )

				yyerror( "Memory operand must be a CSET object" );

			_endif
			thisNode->l.leftOperand = (yyvsp[(1) - (3)].operand);
			thisNode->r.rightOperand = (yyvsp[(3) - (3)].operand);
			thisNode->operator = 
				_ifx( (yyvsp[(2) - (3)].v.u.unsval) == 1, in_astop, notin_astop );

			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3097:

/* Line 1464 of yacc.c  */
#line 101481 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
			struct	adrsYYS		*m;
			struct	operandYYS	*oprnd;
			char	sn[ 256 ];
				

			_here;

			thisNode = malloc2( sizeofOpnode );

			_if( (yyvsp[(1) - (3)].operand)->o.reg->Size != 1 )

				yyerror( "Register operand must be a byte register" );

			_endif
			_if( (yyvsp[(3) - (3)].v.pType) != tCset )

				yyerror( "Constant operand must be a CSET object" );

			_endif

			startStrSeg();
			sprintf( sn, "cset" sympost "%d", LblCntr++ );
			OutValue( sn, (yyvsp[(3) - (3)].v.Type), YYS &(yyvsp[(3) - (3)].v) );
			endStrSeg();

			// Free up the storage associated with the constant operand:

			FreeValue( YYS &(yyvsp[(3) - (3)].operand)->o.v );
			free2( vss (yyvsp[(3) - (3)].operand) );


			// Okay, construct the operation for this node:
			
			thisNode->l.leftOperand = (yyvsp[(1) - (3)].operand);

			// $<operand>3 is a constant, but we've converted it
			// to a memory operand.  So we have to build the r.rightOperand
			// as a memory operand.

			m = malloc2( sizeofAdrsYYS );
			m->Size = 16;
			m->ObjectSize = 16;
			m->StaticName = hlastrdup2( sn );
			m->BaseReg = NULL;
			m->IndexReg = NULL;
			m->regnum = -1;
			m->Scale = 0;
			m->Disp = 0;
			m->Sym = NULL;
			m->Type = &cset_ste;
			m->pType = tCset;
			m->SymClass = cStatic;
			m->pClass = 0;
			m->BaseType = NULL;


			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = mem_optype;
			oprnd->text = NULL;
			oprnd->o.adrs = m;

			thisNode->r.rightOperand = oprnd;
			thisNode->operator = 
				_ifx( (yyvsp[(2) - (3)].v.u.unsval) == 1, in_astop, notin_astop );

			(yyval.opnode) = thisNode;

			_here;
		;}
    break;

  case 3098:

/* Line 1464 of yacc.c  */
#line 101561 "hlaparse.bsn"
    {

			struct	opnodeYYS	*thisNode;
			struct	opnodeYYS	*reg1Node;
			struct	opnodeYYS	*reg2Node;
			struct	operandYYS	*oprnd;
				
			_here;

			// We must make a copy of the register operand because
			// it will get deleted twice later on.

			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = reg_optype;
			oprnd->text = NULL; // Don't need to copy the macro.
			oprnd->o.reg = malloc2( sizeofRegYYS );	
			oprnd->o.reg->Size = (yyvsp[(1) - (5)].operand)->o.reg->Size;
			oprnd->o.reg->IsSigned = (yyvsp[(1) - (5)].operand)->o.reg->IsSigned;
			oprnd->o.reg->Type = (yyvsp[(1) - (5)].operand)->o.reg->Type;
			oprnd->o.reg->pType = (yyvsp[(1) - (5)].operand)->o.reg->pType;
			oprnd->o.reg->encoding = (yyvsp[(1) - (5)].operand)->o.reg->encoding;

			oprnd->regname = hlastrdup2( (yyvsp[(1) - (5)].operand)->regname );

			// Build and "AND"/"OR" node out of the register and
			// the two constant operands.

			thisNode = malloc2( sizeofOpnode );
			reg1Node = malloc2( sizeofOpnode );
			reg2Node = malloc2( sizeofOpnode );

			reg1Node->operator = _ifx( (yyvsp[(2) - (5)].v.u.unsval), ae_astop, b_astop );
			reg1Node->l.leftOperand = (yyvsp[(1) - (5)].operand);
			reg1Node->r.rightOperand = (yyvsp[(3) - (5)].operand);

			reg2Node->operator = _ifx( (yyvsp[(2) - (5)].v.u.unsval), be_astop, a_astop );
			reg2Node->l.leftOperand = oprnd;
			reg2Node->r.rightOperand = (yyvsp[(5) - (5)].operand);


			_if
			(
					(yyvsp[(1) - (5)].operand)->o.reg->IsSigned
				||	IsInt( (yyvsp[(3) - (5)].operand)->o.v.pType )
				||	IsInt( (yyvsp[(5) - (5)].operand)->o.v.pType )
			)
			
				_if
				( 
						numBits32( YYS &(yyvsp[(3) - (5)].operand) ) > 32 
					||	numBits32( YYS &(yyvsp[(5) - (5)].operand) ) > 32 
				)
				
					yyerror( "Upper or lower range constant is too large" );
					
				_endif
				

				_if( (yyvsp[(3) - (5)].operand)->o.v.u.intval > (yyvsp[(5) - (5)].operand)->o.v.u.intval )
				
					yyerror
					( 
						"Lower bounds is greater than upper bounds" 
						"in expression" 
					);
					
				_endif
					
				reg1Node->operator = _ifx( (yyvsp[(2) - (5)].v.u.unsval), ge_astop, l_astop );
				reg2Node->operator = _ifx( (yyvsp[(2) - (5)].v.u.unsval), le_astop, g_astop );
				
			_elseif
			( 
					IsOrdinal( (yyvsp[(3) - (5)].operand)->o.v.pType ) 
				&&	numBits32( YYS &(yyvsp[(3) - (5)].operand) ) <= 32 
			)
			
				_if( (yyvsp[(3) - (5)].operand)->o.v.u.intval > (yyvsp[(5) - (5)].operand)->o.v.u.intval )
				
					yyerror
					( 
						"Lower bounds is greater than upper bounds "
						"in expression" 
					);
					
				_endif

			_endif

			thisNode->l.leftSubexpression = reg1Node;
			thisNode->r.rightSubexpression = reg2Node;
			thisNode->operator = _ifx( (yyvsp[(2) - (5)].v.u.unsval), and_astop, or_astop );
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3099:

/* Line 1464 of yacc.c  */
#line 101666 "hlaparse.bsn"
    {

			struct	opnodeYYS	*thisNode;
			struct	opnodeYYS	*mem1Node;
			struct	opnodeYYS	*mem2Node;
			struct	adrsYYS		*m;
			struct	operandYYS	*oprnd;
				
			_here;

			// We must make a copy of the memory operand because
			// it will get deleted twice later on.

			m = malloc2( sizeofAdrsYYS );
			memcpy( m, (yyvsp[(1) - (5)].operand)->o.adrs, sizeofAdrsYYS );
			m->StaticName = 
				_ifx
				( 
					(yyvsp[(1) - (5)].operand)->o.adrs->StaticName == NULL, 
					NULL, 
					hlastrdup2( (yyvsp[(1) - (5)].operand)->o.adrs->StaticName ) 
				);

			m->BaseReg = 
				_ifx
				( 
					(yyvsp[(1) - (5)].operand)->o.adrs->BaseReg == NULL, 
					NULL, 
					hlastrdup2( (yyvsp[(1) - (5)].operand)->o.adrs->BaseReg ) 
				);

			m->IndexReg = 
				_ifx
				( 
					(yyvsp[(1) - (5)].operand)->o.adrs->IndexReg == NULL, 
					NULL, 
					hlastrdup2( (yyvsp[(1) - (5)].operand)->o.adrs->IndexReg ) 

				);

			m->regnum = -1;
			
			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = mem_optype;
			oprnd->text = NULL; // No need to copy the macro
			oprnd->o.adrs = m;
				

			// Build an "AND"/"OR" node out of the register and
			// the two constant operands.

			thisNode = malloc2( sizeofOpnode );
			mem1Node = malloc2( sizeofOpnode );
			mem2Node = malloc2( sizeofOpnode );

			mem1Node->operator = _ifx( (yyvsp[(2) - (5)].v.u.unsval), ae_astop, b_astop );
			mem1Node->l.leftOperand = (yyvsp[(1) - (5)].operand);
			mem1Node->r.rightOperand = (yyvsp[(3) - (5)].operand);

			mem2Node->operator = _ifx( (yyvsp[(2) - (5)].v.u.unsval), be_astop, a_astop );
			mem2Node->l.leftOperand = oprnd;
			mem2Node->r.rightOperand = (yyvsp[(5) - (5)].operand);

			_if
			(
					IsInt( (yyvsp[(1) - (5)].operand)->o.adrs->pType )
				||	IsInt( (yyvsp[(3) - (5)].operand)->o.v.pType )
				||	IsInt( (yyvsp[(5) - (5)].operand)->o.v.pType )
			)

				_if
				( 
						numBits32( YYS &(yyvsp[(3) - (5)].operand) ) > 32 
					||	numBits32( YYS &(yyvsp[(5) - (5)].operand) ) > 32 
				)
				
					yyerror( "Upper or lower range constant is too large" );
					
				_endif

				_if( (yyvsp[(3) - (5)].operand)->o.v.u.intval > (yyvsp[(5) - (5)].operand)->o.v.u.intval )
				
					yyerror
					( 
						"Lower bounds is greater than upper bounds" 
						"in expression" 
					);
					
				_endif
				mem1Node->operator = _ifx( (yyvsp[(2) - (5)].v.u.unsval), ge_astop, l_astop );
				mem2Node->operator = _ifx( (yyvsp[(2) - (5)].v.u.unsval), le_astop, g_astop );

			_elseif
			( 
					IsOrdinal( (yyvsp[(3) - (5)].operand)->o.v.pType ) 
				&&	numBits32( YYS &(yyvsp[(3) - (5)].operand) ) <= 32 
			)
			
				_if( (yyvsp[(3) - (5)].operand)->o.v.u.intval > (yyvsp[(5) - (5)].operand)->o.v.u.intval )
				
					yyerror
					( 
						"Lower bounds is greater than upper bounds "
						"in expression" 
					);
					
				_endif

			_endif

			thisNode->l.leftSubexpression = mem1Node;
			thisNode->r.rightSubexpression = mem2Node;
			thisNode->operator = _ifx( (yyvsp[(2) - (5)].v.u.unsval), and_astop, or_astop );
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3100:

/* Line 1464 of yacc.c  */
#line 101787 "hlaparse.bsn"
    {			/* $2 */

			struct opnodeYYS *thisNode;

			_here;

			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(1) - (1)].operand);
			thisNode->r.rightOperand = NULL;
			thisNode->operator = ne0_astop;
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3101:

/* Line 1464 of yacc.c  */
#line 101806 "hlaparse.bsn"
    {			/* $3 */

			struct opnodeYYS *thisNode;

			_here;

			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(2) - (2)].operand);
			thisNode->r.rightOperand = NULL;
			thisNode->operator = eq0_astop;
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3102:

/* Line 1464 of yacc.c  */
#line 101824 "hlaparse.bsn"
    {			/* $2 */

			struct	opnodeYYS	*thisNode;
			_here;
			_if
			(
					  
					(yyvsp[(1) - (1)].operand)->o.adrs->pType != tBoolean
				&&	(yyvsp[(1) - (1)].operand)->o.adrs->pType != tByte 
				&&	(yyvsp[(1) - (1)].operand)->o.adrs->pType != tWord 
				&&	(yyvsp[(1) - (1)].operand)->o.adrs->pType != tDWord
			)
			
				yyerror
				( 
					"Variable in expression must be boolean, byte, word, or dword" 
				);

			_endif


			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(1) - (1)].operand);
			thisNode->r.rightOperand = NULL;
			thisNode->operator = ne0_astop;
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3103:

/* Line 1464 of yacc.c  */
#line 101858 "hlaparse.bsn"
    {			/* $3 */

			struct	opnodeYYS	*thisNode;
				
			_here;
			_if
			(
					  
					(yyvsp[(2) - (2)].operand)->o.adrs->pType != tBoolean
				&&	(yyvsp[(2) - (2)].operand)->o.adrs->pType != tByte 
				&&	(yyvsp[(2) - (2)].operand)->o.adrs->pType != tWord 
				&&	(yyvsp[(2) - (2)].operand)->o.adrs->pType != tDWord
			)
			
				yyerror
				( 
					"Variable in expression must be boolean, byte, word, or dword"
				);

			_endif


			thisNode = malloc2( sizeofOpnode );

			thisNode->l.leftOperand = (yyvsp[(2) - (2)].operand);
			thisNode->r.rightOperand = NULL;
			thisNode->operator = eq0_astop;
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3104:

/* Line 1464 of yacc.c  */
#line 101895 "hlaparse.bsn"
    {			/* $2 */

			struct opnodeYYS *thisNode;

			_here;

			thisNode = malloc2( sizeofOpnode );

			// Note: l.leftOperand cannot be NULL.

			thisNode->l.leftOperand = malloc2( sizeofOperandYYS );
			thisNode->l.leftOperand->operandType = flag_optype;
			thisNode->l.leftOperand->text = NULL;
			thisNode->r.rightOperand = NULL;
			thisNode->operator = (yyvsp[(1) - (1)].v.u.unsval);
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3105:

/* Line 1464 of yacc.c  */
#line 101916 "hlaparse.bsn"
    {			/* $3 */

			struct opnodeYYS *thisNode;
			int					CurStmt;
			int					lastChar;
			char				*text;
			char				*eoln;


			_here;

			thisNode = malloc2( sizeofOpnode );

			// Note: l.leftOperand cannot be NULL.

			thisNode->l.leftOperand = malloc2( sizeofOperandYYS );
			thisNode->l.leftOperand->operandType = flag_optype;
			thisNode->r.rightOperand = NULL;
			thisNode->operator = (yyvsp[(2) - (2)].v.u.unsval);

			// Set StartofStmt for the next operand (if any).

			text = getFileStr( StartOfStmt );
			thisNode->l.leftOperand->text = text;
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3106:

/* Line 1464 of yacc.c  */
#line 101946 "hlaparse.bsn"
    {			/* $3 */

			struct opnodeYYS *thisNode;

			_here;

			thisNode = malloc2( sizeofOpnode );

			// Note: l.leftOperand cannot be NULL.

			thisNode->l.leftOperand = malloc2( sizeofOperandYYS );
			thisNode->l.leftOperand->operandType = flag_optype;
			thisNode->r.rightOperand = NULL;
			thisNode->l.leftOperand->text = NULL;
			thisNode->operator = InvertFlag( (yyvsp[(2) - (2)].v.u.unsval) );
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3107:

/* Line 1464 of yacc.c  */
#line 101968 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS	*thisNode;
			char				*text;

			_here;

			thisNode = malloc2( sizeofOpnode );

			// Note: l.leftOperand cannot be NULL.

			thisNode->l.leftOperand = malloc2( sizeofOperandYYS );
			thisNode->l.leftOperand->operandType = flag_optype;
			thisNode->r.rightOperand = NULL;
			thisNode->operator = InvertFlag( (yyvsp[(3) - (3)].v.u.unsval) );

			// Set StartofStmt for the next operand (if any).


			text = getFileStr( StartOfStmt );
			thisNode->l.leftOperand->text = text;
			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3108:

/* Line 1464 of yacc.c  */
#line 101996 "hlaparse.bsn"
    {			/* $4 */

			struct opnodeYYS *thisNode;
			char				*text;

			_here;

			thisNode = malloc2( sizeofOpnode );

			// Note: l.leftOperand cannot be NULL.

			thisNode->l.leftOperand = malloc2( sizeofOperandYYS );
			thisNode->l.leftOperand->operandType = flag_optype;
			thisNode->r.rightOperand = NULL;
			thisNode->operator = InvertFlag( (yyvsp[(3) - (3)].v.u.unsval) );

			// Set StartofStmt for the next operand (if any).


			text = getFileStr( StartOfStmt );
			thisNode->l.leftOperand->text = text;

			(yyval.opnode) = thisNode;
			_here;
		;}
    break;

  case 3109:

/* Line 1464 of yacc.c  */
#line 102031 "hlaparse.bsn"
    {
			yyerror( "Memory to memory comparisons are illegal" );
			FreeOperand( (struct opnodeYYS *) (yyvsp[(3) - (3)].operand) );
			(yyval.operand) = (yyvsp[(1) - (3)].operand);
		;}
    break;

  case 3110:

/* Line 1464 of yacc.c  */
#line 102042 "hlaparse.bsn"
    {
			yyerror( "Memory to memory comparisons are illegal" );
			FreeOperand( (struct opnodeYYS *) (yyvsp[(3) - (3)].operand) );
			(yyval.operand) = (yyvsp[(1) - (3)].operand);
		;}
    break;

  case 3111:

/* Line 1464 of yacc.c  */
#line 102053 "hlaparse.bsn"
    {
			yyerror( "Memory to memory comparisons are illegal" );
			FreeOperand( (struct opnodeYYS *) (yyvsp[(1) - (3)].operand) );
			(yyval.operand) = (yyvsp[(3) - (3)].operand);
		;}
    break;

  case 3112:

/* Line 1464 of yacc.c  */
#line 102064 "hlaparse.bsn"
    {
			yyerror( "Must specify memory size" );
			FreeOperand( (struct opnodeYYS *) (yyvsp[(1) - (3)].operand) );
			(yyval.operand) = (yyvsp[(3) - (3)].operand);
		;}
    break;

  case 3113:

/* Line 1464 of yacc.c  */
#line 102076 "hlaparse.bsn"
    {
			yyerror( "Memory to memory comparisons are illegal" );
			FreeOperand( (struct opnodeYYS *) (yyvsp[(3) - (3)].operand) );
			(yyval.operand) = (yyvsp[(1) - (3)].operand);
		;}
    break;

  case 3114:

/* Line 1464 of yacc.c  */
#line 102094 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = eq_astop; ;}
    break;

  case 3115:

/* Line 1464 of yacc.c  */
#line 102095 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = ne_astop; ;}
    break;

  case 3116:

/* Line 1464 of yacc.c  */
#line 102096 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = b_astop; ;}
    break;

  case 3117:

/* Line 1464 of yacc.c  */
#line 102097 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = be_astop; ;}
    break;

  case 3118:

/* Line 1464 of yacc.c  */
#line 102098 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = a_astop; ;}
    break;

  case 3119:

/* Line 1464 of yacc.c  */
#line 102099 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = ae_astop; ;}
    break;

  case 3120:

/* Line 1464 of yacc.c  */
#line 102103 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = c_flag;	;}
    break;

  case 3121:

/* Line 1464 of yacc.c  */
#line 102105 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = nc_flag;	;}
    break;

  case 3122:

/* Line 1464 of yacc.c  */
#line 102106 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = s_flag;	;}
    break;

  case 3123:

/* Line 1464 of yacc.c  */
#line 102107 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = ns_flag;	;}
    break;

  case 3124:

/* Line 1464 of yacc.c  */
#line 102108 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = o_flag;	;}
    break;

  case 3125:

/* Line 1464 of yacc.c  */
#line 102109 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = no_flag;	;}
    break;

  case 3126:

/* Line 1464 of yacc.c  */
#line 102110 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = z_flag;	;}
    break;

  case 3127:

/* Line 1464 of yacc.c  */
#line 102111 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = nz_flag;	;}
    break;

  case 3128:

/* Line 1464 of yacc.c  */
#line 102112 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = a_flag;	;}
    break;

  case 3129:

/* Line 1464 of yacc.c  */
#line 102113 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = na_flag;	;}
    break;

  case 3130:

/* Line 1464 of yacc.c  */
#line 102114 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = ae_flag;	;}
    break;

  case 3131:

/* Line 1464 of yacc.c  */
#line 102115 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = nae_flag;	;}
    break;

  case 3132:

/* Line 1464 of yacc.c  */
#line 102116 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = b_flag;	;}
    break;

  case 3133:

/* Line 1464 of yacc.c  */
#line 102117 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = nb_flag;	;}
    break;

  case 3134:

/* Line 1464 of yacc.c  */
#line 102118 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = be_flag;	;}
    break;

  case 3135:

/* Line 1464 of yacc.c  */
#line 102119 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = nbe_flag;	;}
    break;

  case 3136:

/* Line 1464 of yacc.c  */
#line 102120 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = l_flag;	;}
    break;

  case 3137:

/* Line 1464 of yacc.c  */
#line 102121 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = nl_flag;	;}
    break;

  case 3138:

/* Line 1464 of yacc.c  */
#line 102122 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = le_flag;	;}
    break;

  case 3139:

/* Line 1464 of yacc.c  */
#line 102123 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = nle_flag;	;}
    break;

  case 3140:

/* Line 1464 of yacc.c  */
#line 102124 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = g_flag;	;}
    break;

  case 3141:

/* Line 1464 of yacc.c  */
#line 102125 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = ng_flag;	;}
    break;

  case 3142:

/* Line 1464 of yacc.c  */
#line 102126 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = ge_flag;	;}
    break;

  case 3143:

/* Line 1464 of yacc.c  */
#line 102127 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = nge_flag;	;}
    break;

  case 3144:

/* Line 1464 of yacc.c  */
#line 102128 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = e_flag;	;}
    break;

  case 3145:

/* Line 1464 of yacc.c  */
#line 102129 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = ne_flag;	;}
    break;

  case 3146:

/* Line 1464 of yacc.c  */
#line 102130 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = pe_flag;	;}
    break;

  case 3147:

/* Line 1464 of yacc.c  */
#line 102131 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = po_flag;	;}
    break;

  case 3148:

/* Line 1464 of yacc.c  */
#line 102132 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = p_flag;	;}
    break;

  case 3149:

/* Line 1464 of yacc.c  */
#line 102133 "hlaparse.bsn"
    { _here; (yyval.v.u.unsval) = np_flag;	;}
    break;

  case 3150:

/* Line 1464 of yacc.c  */
#line 102140 "hlaparse.bsn"
    {			/* $2 */

			struct	regYYS		*r;
			struct	operandYYS	*oprnd;
				
			_here;
			r = malloc2( sizeofRegYYS );
			*r = (yyvsp[(1) - (1)].reg);

			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = reg_optype;
			oprnd->text = NULL;
			oprnd->o.reg = r;
			oprnd->regname = hlastrdup2( regStrs[ (yyvsp[(1) - (1)].reg.encoding) ]);
			(yyval.operand) = oprnd;
			_here;
		;}
    break;

  case 3151:

/* Line 1464 of yacc.c  */
#line 102160 "hlaparse.bsn"
    {			/* $3 */

			struct	regYYS		*r;
			struct	operandYYS	*oprnd;
			char				*text;
				
			_here;
			r = malloc2( sizeofRegYYS );
			*r = (yyvsp[(2) - (2)].reg);

			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = reg_optype;
			text = getFileStr( StartOfStmt );
			oprnd->text = text;
			oprnd->o.reg = r;
			oprnd->regname = hlastrdup2( regStrs[ (yyvsp[(2) - (2)].reg.encoding) ]);

			(yyval.operand) = oprnd;
			_here;
		;}
    break;

  case 3152:

/* Line 1464 of yacc.c  */
#line 102190 "hlaparse.bsn"
    {		/* $2 */

			struct	adrsYYS		*m;
			struct	operandYYS	*oprnd;

			_here;
			m = malloc2( sizeofAdrsYYS );
			memcpy( m, &(yyvsp[(1) - (1)].adrs), sizeofAdrsYYS );

			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = mem_optype;
			oprnd->text = NULL;
			oprnd->o.adrs = m;
			(yyval.operand) = oprnd;
		;}
    break;

  case 3153:

/* Line 1464 of yacc.c  */
#line 102208 "hlaparse.bsn"
    {		/* $3 */

			struct	adrsYYS		*m;
			struct	operandYYS	*oprnd;
			char				*text;

			_here;
			m = malloc2( sizeofAdrsYYS );
			memcpy( m, &(yyvsp[(2) - (2)].adrs), sizeofAdrsYYS );

			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = mem_optype;
			oprnd->o.adrs = m;

			// Grab the text emitted by fstmt (if any).

			text = getFileStr( StartOfStmt );
			oprnd->text = text;
			(yyval.operand) = oprnd;
		;}
    break;

  case 3154:

/* Line 1464 of yacc.c  */
#line 102235 "hlaparse.bsn"
    {
			struct	adrsYYS		*m;
			struct	operandYYS	*oprnd;
			_here;
			m = malloc2( sizeofAdrsYYS );
			memcpy( m, &(yyvsp[(1) - (1)].adrs), sizeofAdrsYYS );

			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = mem_optype;
			oprnd->o.adrs = m;
			oprnd->text = NULL;
			(yyval.operand) = oprnd;
		;}
    break;

  case 3155:

/* Line 1464 of yacc.c  */
#line 102251 "hlaparse.bsn"
    {			/* $3 */

			struct	adrsYYS		*m;
			struct	operandYYS	*oprnd;
			char				*text;

			_here;
			m = malloc2( sizeofAdrsYYS );
			memcpy( m, &(yyvsp[(2) - (2)].adrs), sizeofAdrsYYS );

			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = mem_optype;
			oprnd->o.adrs = m;

			// Grab the text emitted by fstmt (if any).

			text = getFileStr( StartOfStmt );
			oprnd->text = text;
			(yyval.operand) = oprnd;
		;}
    break;

  case 3156:

/* Line 1464 of yacc.c  */
#line 102277 "hlaparse.bsn"
    {
			SymNode_t 			*v;
			struct	operandYYS	*oprnd;

			_here;
			_if
			( 
					!( IsOrdinal( (yyvsp[(1) - (1)].v.pType) ) && numBits32( YYS &(yyvsp[(1) - (1)].v) ) <= 32 ) 
				&&	(yyvsp[(1) - (1)].v.pType) != tCset
				&&	(yyvsp[(1) - (1)].v.pType) != tPointer 
			)

				yyerror( "Illegal constant type" );

				// Set up a dummy type so the following code
				// does not fail.

				FreeValue( YYS &(yyvsp[(1) - (1)].v) );
				memcpy( &(yyvsp[(1) - (1)].v), &boolean_ste, sizeofSymNode );

			_endif

			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = const_optype;
			oprnd->text = NULL;
			memcpy( &oprnd->o.v, &(yyvsp[(1) - (1)].v), sizeofSymNode );
			(yyval.operand) = oprnd;
			_here;
		;}
    break;

  case 3157:

/* Line 1464 of yacc.c  */
#line 102309 "hlaparse.bsn"
    {
			SymNode_t 			*v;
			struct	operandYYS	*oprnd;
			char				*text;

			_here;
			_if
			( 
					!( IsOrdinal( (yyvsp[(2) - (2)].v.pType) ) && numBits32( YYS &(yyvsp[(2) - (2)].v) ) <= 32 ) 
				&&	(yyvsp[(2) - (2)].v.pType) != tCset
				&&	(yyvsp[(2) - (2)].v.pType) != tPointer 
			)

				yyerror( "Illegal constant type" );

				// Set up a dummy type so the following code
				// does not fail.

				FreeValue( YYS &(yyvsp[(2) - (2)].v) );
				memcpy( &(yyvsp[(2) - (2)].v), &boolean_ste, sizeofSymNode );

			_endif

			oprnd = malloc2( sizeofOperandYYS );
			oprnd->operandType = const_optype;
			oprnd->text = NULL;
			memcpy( &oprnd->o.v, &(yyvsp[(2) - (2)].v), sizeofSymNode );

			// Grab the text emitted by fstmt (if any).

			text = getFileStr( StartOfStmt );
			oprnd->text = text;
			(yyval.operand) = oprnd;
			_here;
		;}
    break;

  case 3158:

/* Line 1464 of yacc.c  */
#line 102377 "hlaparse.bsn"
    {
			_here;

			/*
			** Since this memory operand has an index,
			** set the ObjectSize (which would be the size
			** of an array) to the Size field (which is the
			** size of an element).
			*/

			(yyvsp[(1) - (2)].adrs.ObjectSize) = (yyvsp[(1) - (2)].adrs.Size);
			_if( (yyvsp[(1) - (2)].adrs.forcedSize) != 0 )
			
				(yyvsp[(1) - (2)].adrs.forcedSize) = (yyvsp[(1) - (2)].adrs.Size);
				
			_endif
 

			/*
			** If there is an index attached to this
			** memory reference and it's an array reference,
			** return the base type as the type of this object.
			*/

			_if( (yyvsp[(1) - (2)].adrs.pType) == tArray )

				assert( (yyvsp[(1) - (2)].adrs.Type) != NULL );
				(yyvsp[(1) - (2)].adrs.Type) = GetBaseType( (yyvsp[(1) - (2)].adrs.Type) );
				(yyvsp[(1) - (2)].adrs.pType) = (yyvsp[(1) - (2)].adrs.Type)->pType;

			_endif;


 			CombineAddresses( &(yyvsp[(1) - (2)].adrs), &(yyvsp[(2) - (2)].adrs) );
			FreeAdrs( &(yyvsp[(2) - (2)].adrs) );
			memcpy( &(yyval.adrs), &(yyvsp[(1) - (2)].adrs), sizeofYYSTYPE);
			_here;
		;}
    break;

  case 3159:

/* Line 1464 of yacc.c  */
#line 102421 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.adrs), &(yyvsp[(1) - (2)].adrs), sizeofYYSTYPE );
			_here;
		;}
    break;

  case 3160:

/* Line 1464 of yacc.c  */
#line 102433 "hlaparse.bsn"
    {					/* $4 */

			char address[ 256 ];
			char name[ 256 ];
			char *size;

			/*
			** Pointer variables (to class/record/union) are only
			** legal for calls, not for memory accesses.
			*/

			_here;
			_if( (yyvsp[(1) - (3)].adrs.pType) == tPointer )

				yyerror( "Illegal use of pointer variable" );

			_endif


			/*
			** Since this memory operand has an index,
			** set the ObjectSize (which would be the size
			** of an array) to the Size field (which is the
			** size of an element).
			*/

			(yyvsp[(2) - (3)].adrs.ObjectSize) = (yyvsp[(2) - (3)].adrs.Size);
			_if( (yyvsp[(2) - (3)].adrs.forcedSize) != 0 )
			
				(yyvsp[(2) - (3)].adrs.forcedSize) = (yyvsp[(2) - (3)].adrs.Size);
				
			_endif

			/*
			** If there is an index attached to this
			** memory reference and it's an array reference,
			** return the base type as the type of this object.
			*/

			_if( (yyvsp[(2) - (3)].adrs.pType) == tArray )

				assert( (yyvsp[(2) - (3)].adrs.Type) != NULL );
				(yyvsp[(2) - (3)].adrs.Type) = GetBaseType( (yyvsp[(2) - (3)].adrs.Type) );
				(yyvsp[(2) - (3)].adrs.pType) = (yyvsp[(2) - (3)].adrs.Type)->pType;

			_endif;


			/*
			** Merge the base name with the fields to get the
			** full name plus the adjusted offsets.
			*/

			memcpy( &(yyval.adrs), &(yyvsp[(2) - (3)].adrs), sizeofYYSTYPE );

			/*
			** Merge the fully qualified name above with the index
			** information.
			*/

			CombineAddresses( &(yyval.adrs), &(yyvsp[(3) - (3)].adrs) );
			(yyval.adrs.forcedSize) = (yyval.adrs.ObjectSize);
			FreeAdrs( &(yyvsp[(1) - (3)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (3)].adrs) );

			_here;
		;}
    break;

  case 3161:

/* Line 1464 of yacc.c  */
#line 102507 "hlaparse.bsn"
    {					/* $4 */

			char address[ 256 ];
			char name[ 256 ];
			char *size;


			/*
			** Pointer variables (to class/record/union) are only
			** legal for calls, not for memory accesses.
			*/

			_here;
			_if( (yyvsp[(1) - (3)].adrs.pType) == tPointer )

				yyerror( "Illegal use of pointer variable" );

			_endif

			/*
			** Merge the base name with the fields to get the
			** full name plus the adjusted offsets.
			*/

			memcpy( &(yyval.adrs), &(yyvsp[(2) - (3)].adrs), sizeofYYSTYPE );
			(yyval.adrs.forcedSize) = (yyval.adrs.ObjectSize);
			FreeAdrs( &(yyvsp[(1) - (3)].adrs) );
		;}
    break;

  case 3162:

/* Line 1464 of yacc.c  */
#line 102550 "hlaparse.bsn"
    {
			_here;

			/*
			** Since this memory operand has an index,
			** set the ObjectSize (which would be the size
			** of an array) to the Size field (which is the
			** size of an element).
			*/

			(yyvsp[(1) - (2)].adrs.ObjectSize) = (yyvsp[(1) - (2)].adrs.Size);
			_if( (yyvsp[(1) - (2)].adrs.forcedSize) != 0 )
			
				(yyvsp[(1) - (2)].adrs.forcedSize) = (yyvsp[(1) - (2)].adrs.Size);
				
			_endif

			/*
			** If there is an index attached to this
			** memory reference and it's an array reference,
			** return the base type as the type of this object.
			*/

			_if( (yyvsp[(1) - (2)].adrs.pType) == tArray )

				assert( (yyvsp[(1) - (2)].adrs.Type) != NULL );
				(yyvsp[(1) - (2)].adrs.Type) = GetBaseType( (yyvsp[(1) - (2)].adrs.Type) );
				(yyvsp[(1) - (2)].adrs.pType) = (yyvsp[(1) - (2)].adrs.Type)->pType;

			_endif;
 			CombineAddresses( &(yyvsp[(1) - (2)].adrs), &(yyvsp[(2) - (2)].adrs) );
			memcpy( &(yyval.adrs), &(yyvsp[(1) - (2)].adrs), sizeofYYSTYPE );
			FreeAdrs( &(yyvsp[(2) - (2)].adrs) );
			_here;
		;}
    break;

  case 3163:

/* Line 1464 of yacc.c  */
#line 102591 "hlaparse.bsn"
    {
			_here;
			memcpy( &(yyval.adrs), &(yyvsp[(1) - (2)].adrs), sizeofYYSTYPE );
			_here;
		;}
    break;

  case 3164:

/* Line 1464 of yacc.c  */
#line 102603 "hlaparse.bsn"
    {					/* $4 */

			char address[ 256 ];
			char name   [ 256 ];
			char *size;

			/*
			** Pointer variables (to class/record/union) are only
			** legal for calls, not for memory accesses.
			*/

			_here;
			_if( (yyvsp[(1) - (3)].adrs.pType) == tPointer )

				yyerror( "Illegal use of pointer variable" );

			_endif

			/*
			** Since this memory operand has an index,
			** set the ObjectSize (which would be the size
			** of an array) to the Size field (which is the
			** size of an element).
			*/

			(yyvsp[(2) - (3)].adrs.ObjectSize) = (yyvsp[(2) - (3)].adrs.Size);
			_if( (yyvsp[(2) - (3)].adrs.forcedSize) != 0 )
			
				(yyvsp[(2) - (3)].adrs.forcedSize) = (yyvsp[(2) - (3)].adrs.Size);
				
			_endif

			/*
			** If there is an index attached to this
			** memory reference and it's an array reference,
			** return the base type as the type of this object.
			*/

			_if( (yyvsp[(2) - (3)].adrs.pType) == tArray )

				assert( (yyvsp[(2) - (3)].adrs.Type) != NULL );
				(yyvsp[(2) - (3)].adrs.Type) = GetBaseType( (yyvsp[(2) - (3)].adrs.Type) );
				(yyvsp[(2) - (3)].adrs.pType) = (yyvsp[(2) - (3)].adrs.Type)->pType;

			_endif;

			/*
			** Merge the base name with the fields to get the
			** full name plus the adjusted offsets.
			*/

			memcpy( &(yyval.adrs), &(yyvsp[(2) - (3)].adrs), sizeofYYSTYPE );


			/*
			** Merge the fully qualified name above with the index
			** information.
			*/

			CombineAddresses( &(yyval.adrs), &(yyvsp[(3) - (3)].adrs) );
			(yyval.adrs.forcedSize) = (yyval.adrs.ObjectSize);
			FreeAdrs( &(yyvsp[(1) - (3)].adrs) );
			FreeAdrs( &(yyvsp[(3) - (3)].adrs) );

			_here;
		;}
    break;

  case 3165:

/* Line 1464 of yacc.c  */
#line 102676 "hlaparse.bsn"
    {					/* $4 */

			char address[ 256 ];
			char name[ 256 ];
			char *size;

			/*
			** Pointer variables (to class/record/union) are only
			** legal for calls, not for memory accesses.
			*/

			_here;
			_if( (yyvsp[(1) - (3)].adrs.pType) == tPointer )

				yyerror( "Illegal use of pointer variable" );

			_endif

			/*
			** Merge the base name with the fields to get the
			** full name plus the adjusted offsets.
			*/

			memcpy( &(yyval.adrs), &(yyvsp[(2) - (3)].adrs), sizeofYYSTYPE );

			/*
			** $<adrs.Disp>1 was already factored into $<adrs>$
			** by the FieldStuff production.  Don't factor it
			** in twice.
			*/


			//CombineAddresses( &$<adrs>$, &$<adrs>1 );
			(yyval.adrs.forcedSize) = (yyval.adrs.ObjectSize);
			FreeAdrs( &(yyvsp[(1) - (3)].adrs) );
		;}
    break;

  case 3166:

/* Line 1464 of yacc.c  */
#line 102717 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Undefined identifier (dest memory operand)",
				yytext,
				__LINE__,
				__FILE__ 
			);
			exit( 1 );
		;}
    break;

  case 3167:

/* Line 1464 of yacc.c  */
#line 102732 "hlaparse.bsn"
    {
			ErrorNear
			( 
				"Expected a memory operand",
				(yyvsp[(1) - (1)].idStr),
				__LINE__,
				__FILE__ 
			);
			exit( 1 );
		;}
    break;

  case 3168:

/* Line 1464 of yacc.c  */
#line 102756 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(1) - (1)].s)->TrueName;
		;}
    break;

  case 3169:

/* Line 1464 of yacc.c  */
#line 102762 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(1) - (1)].s)->TrueName;
		;}
    break;

  case 3170:

/* Line 1464 of yacc.c  */
#line 102768 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (1)].s)->pType == tClass )
			
				ErrorNear
				( 
					"Expected appropriate field specification for "
					"Class object",
					(yyvsp[(1) - (1)].s)->TrueName,
					__LINE__,
					__FILE__
				);

			_endif
			(yyval.idStr) = (yyvsp[(1) - (1)].s)->TrueName;
		;}
    break;

  case 3171:

/* Line 1464 of yacc.c  */
#line 102786 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(1) - (1)].s)->TrueName;
		;}
    break;

  case 3172:

/* Line 1464 of yacc.c  */
#line 102792 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(1) - (1)].s)->TrueName;
		;}
    break;

  case 3173:

/* Line 1464 of yacc.c  */
#line 102798 "hlaparse.bsn"
    {
			_here;
			(yyval.idStr) = (yyvsp[(1) - (1)].s)->TrueName;
		;}
    break;

  case 3174:

/* Line 1464 of yacc.c  */
#line 102821 "hlaparse.bsn"
    {
			_here;
			(yyval.v) = (yyvsp[(2) - (2)].v);
			_if( !( IsOrdinal( (yyvsp[(2) - (2)].v.pType) ) && numBits32( YYS &(yyvsp[(2) - (2)].v) ) <= 32 ))

				yyerror( "Expected a 32-bit ordinal displacement value" );
				FreeValue( YYS &(yyvsp[(2) - (2)].v) );
				(yyval.v.u.intval) = 0;
				(yyval.v.pType) = tInt32;
				(yyval.v.Type) = &int32_ste;

			_endif
		;}
    break;

  case 3175:

/* Line 1464 of yacc.c  */
#line 102836 "hlaparse.bsn"
    {
			_here;
			PushBackStr( "0 - " );
		;}
    break;

  case 3176:

/* Line 1464 of yacc.c  */
#line 102841 "hlaparse.bsn"
    {
			_here;
			(yyval.v) = (yyvsp[(3) - (3)].v);
			_if( IsOrdinal( (yyvsp[(3) - (3)].v.pType) ) && numBits32( YYS &(yyvsp[(3) - (3)].v) ) <= 32 )

				(yyval.v.u.intval) = (yyvsp[(3) - (3)].v.u.intval);
				(yyval.v.pType) = tInt32;
				(yyval.v.Type) = &int32_ste;

			_else

				yyerror( "Expected a 32-bit ordinal displacement value" );
				FreeValue( YYS &(yyvsp[(3) - (3)].v) );
				(yyval.v.u.intval) = 0;
				(yyval.v.pType) = tInt32;
				(yyval.v.Type) = &int32_ste;

			_endif
			_here;
		;}
    break;

  case 3177:

/* Line 1464 of yacc.c  */
#line 102866 "hlaparse.bsn"
    {
			_here;
			(yyval.v) = (yyvsp[(1) - (1)].v);
			_if( !( IsOrdinal( (yyvsp[(1) - (1)].v.pType) ) && numBits32( YYS &(yyvsp[(1) - (1)].v) ) <= 32 ))

				yyerror( "Expected a 32-bit ordinal displacement value" );
				FreeValue( YYS &(yyvsp[(1) - (1)].v) );
				(yyval.v.u.intval) = 0;
				(yyval.v.pType) = tInt32;
				(yyval.v.Type) = &int32_ste;

			_endif
		;}
    break;

  case 3178:

/* Line 1464 of yacc.c  */
#line 102892 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(2) - (2)].v.u.intval) == 1 )

				(yyval.v.u.unsval) = 1;

			_elseif( (yyvsp[(2) - (2)].v.u.intval) == 2 )

				(yyval.v.u.unsval) = 2;

			_elseif( (yyvsp[(2) - (2)].v.u.intval) == 4 )

				(yyval.v.u.unsval) = 4;

			_elseif( (yyvsp[(2) - (2)].v.u.intval) == 8 )

				(yyval.v.u.unsval) = 8;

			_else

				(yyval.v.u.unsval) = 1;
				yyerror( "Illegal scaled index value" );

			_endif
		;}
    break;

  case 3179:

/* Line 1464 of yacc.c  */
#line 102929 "hlaparse.bsn"
    {
			_here;
			(yyval.mem.base)  = (yyvsp[(1) - (2)].reg.encoding);
			(yyval.mem.index) = -1;
			(yyval.mem.scale) = 0;
			(yyval.mem.disp)  = 0;

		;}
    break;

  case 3180:

/* Line 1464 of yacc.c  */
#line 102942 "hlaparse.bsn"
    {
			_here;
			(yyval.mem.base)  = (yyvsp[(1) - (4)].reg.encoding);
			(yyval.mem.index) = (yyvsp[(3) - (4)].reg.encoding);
			(yyval.mem.scale) = 0;
			(yyval.mem.disp)  = 0;
			
		;}
    break;

  case 3181:

/* Line 1464 of yacc.c  */
#line 102956 "hlaparse.bsn"
    {
			_here;
			(yyval.mem.base)  = (yyvsp[(1) - (5)].reg.encoding);
			(yyval.mem.index) = (yyvsp[(3) - (5)].reg.encoding);
			(yyval.mem.scale) = (yyvsp[(4) - (5)].v.u.unsval);
			(yyval.mem.disp)  = 0;
		;}
    break;

  case 3182:

/* Line 1464 of yacc.c  */
#line 102967 "hlaparse.bsn"
    {
			_here;
			(yyval.mem.base)  = -1;
			(yyval.mem.index) = (yyvsp[(1) - (3)].reg.encoding);
			(yyval.mem.scale) = (yyvsp[(2) - (3)].v.u.unsval);
			(yyval.mem.disp)  = 0;
		;}
    break;

  case 3183:

/* Line 1464 of yacc.c  */
#line 102979 "hlaparse.bsn"
    {
			_here;
			(yyval.mem.base)  = (yyvsp[(1) - (3)].reg.encoding);
			(yyval.mem.index) = -1;
			(yyval.mem.scale) = 0;
			(yyval.mem.disp)  = (yyvsp[(2) - (3)].v.u.unsval);
		;}
    break;

  case 3184:

/* Line 1464 of yacc.c  */
#line 102992 "hlaparse.bsn"
    {
			_here;
			(yyval.mem.base)  = (yyvsp[(1) - (5)].reg.encoding);
			(yyval.mem.index) = (yyvsp[(3) - (5)].reg.encoding);
			(yyval.mem.scale) = 0;
			(yyval.mem.disp)  = (yyvsp[(4) - (5)].v.u.unsval);
			_here;
		;}
    break;

  case 3185:

/* Line 1464 of yacc.c  */
#line 103007 "hlaparse.bsn"
    {
			_here;
			(yyval.mem.base)  = (yyvsp[(1) - (6)].reg.encoding);
			(yyval.mem.index) = (yyvsp[(3) - (6)].reg.encoding);
			(yyval.mem.scale) = (yyvsp[(4) - (6)].v.u.unsval);
			(yyval.mem.disp)  = (yyvsp[(5) - (6)].v.u.unsval);
		;}
    break;

  case 3186:

/* Line 1464 of yacc.c  */
#line 103019 "hlaparse.bsn"
    {
			_here;
			(yyval.mem.base)  = -1;
			(yyval.mem.index) = (yyvsp[(1) - (4)].reg.encoding);
			(yyval.mem.scale) = (yyvsp[(2) - (4)].v.u.unsval);
			(yyval.mem.disp)  = (yyvsp[(3) - (4)].v.u.unsval);
		;}
    break;

  case 3187:

/* Line 1464 of yacc.c  */
#line 103037 "hlaparse.bsn"
    {
			_here;
			(yyval.mem) = (yyvsp[(2) - (3)].mem);
			mergeMem( YYM &(yyval.mem), YYM &(yyvsp[(3) - (3)].mem) );
		;}
    break;

  case 3188:

/* Line 1464 of yacc.c  */
#line 103047 "hlaparse.bsn"
    {
			_here;
			(yyval.mem) = (yyvsp[(4) - (4)].mem);
			(yyval.mem.disp) += (yyvsp[(2) - (4)].v.u.unsval);
		;}
    break;

  case 3189:

/* Line 1464 of yacc.c  */
#line 103054 "hlaparse.bsn"
    {
			_here;
			(yyval.mem.base) = -1;
			(yyval.mem.index) = -1;
			(yyval.mem.scale) = 0;
			(yyval.mem.disp) = 0;
		;}
    break;

  case 3190:

/* Line 1464 of yacc.c  */
#line 103076 "hlaparse.bsn"
    {
			_here;
			_if( (yyvsp[(1) - (1)].reg.Size) != 4 )

				yyerror( "Register must be 32 bits" );

			_endif
			(yyval.reg) = (yyvsp[(1) - (1)].reg);
		;}
    break;

  case 3191:

/* Line 1464 of yacc.c  */
#line 103091 "hlaparse.bsn"
    {
			int		index;
			char	comment[256];
			
			_here;
			mergeMem( YYM &(yyvsp[(2) - (3)].mem), YYM &(yyvsp[(3) - (3)].mem) );
			
			// Check for the use of ESP as an index register:
			
			_if( (yyvsp[(2) - (3)].mem.index) == reg_esp )
			
				_if( (yyvsp[(2) - (3)].mem.base) == reg_esp || (yyvsp[(2) - (3)].mem.scale) > 1 )
				
					yyerror( "ESP cannot be used as an index register" );
					
				_endif
				
				// Swap the base and index registers to try and make
				// this legal:
				
				index = (yyvsp[(2) - (3)].mem.index);
				(yyvsp[(2) - (3)].mem.index) = (yyvsp[(2) - (3)].mem.base);
				(yyvsp[(2) - (3)].mem.base) = index;
				
			_endif	
			initAdrs
			( 
				YYA &(yyval.adrs),
				(yyvsp[(2) - (3)].mem.base),
				(yyvsp[(2) - (3)].mem.index),
				(yyvsp[(2) - (3)].mem.scale),
				(yyvsp[(2) - (3)].mem.disp)
			);
			_here;
		;}
    break;

  case 3192:

/* Line 1464 of yacc.c  */
#line 103131 "hlaparse.bsn"
    {
			_here;
			initAdrs
			( 
				YYA &(yyval.adrs),
				(yyvsp[(4) - (4)].mem.base),
				(yyvsp[(4) - (4)].mem.index),
				(yyvsp[(4) - (4)].mem.scale),
				(yyvsp[(4) - (4)].mem.disp)+(yyvsp[(2) - (4)].v.u.intval)
			);
			_here;
		;}
    break;

  case 3193:

/* Line 1464 of yacc.c  */
#line 103164 "hlaparse.bsn"
    {
			int				index;
			SymNode_t 		*s;
			
			_here;
			mergeMem( YYM &(yyvsp[(3) - (4)].mem), YYM &(yyvsp[(4) - (4)].mem) );
			
			// Check for the use of ESP as an index register:
			
			_if( (yyvsp[(3) - (4)].mem.index) == reg_esp )
			
				_if( (yyvsp[(3) - (4)].mem.base) == reg_esp || (yyvsp[(3) - (4)].mem.scale) > 1 )
				
					yyerror( "ESP cannot be used as an index register" );
					
				_endif
				
				// Swap the base and index registers to try and make
				// this legal:
				
				index = (yyvsp[(3) - (4)].mem.index);
				(yyvsp[(3) - (4)].mem.index) = (yyvsp[(3) - (4)].mem.base);
				(yyvsp[(3) - (4)].mem.base) = index;
				
			_endif	
			initAdrs
			( 
				YYA &(yyval.adrs),
				(yyvsp[(3) - (4)].mem.base),
				(yyvsp[(3) - (4)].mem.index),
				(yyvsp[(3) - (4)].mem.scale),
				(yyvsp[(3) - (4)].mem.disp)
			);
			
			// Create a dummy symbol for the <adrs.Sym> field so it is never NULL.
			
			s = SymbolTable;
			InsertSym
			( 
				" (anonsym) ", 
				&dword_ste,		/* Default is int32 object.		*/
				tDWord,
				cStatic,		/* Not really static, but...	*/ 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				0,				/* No initialization			*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				NULL,			/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);
			(yyval.adrs.Sym) = SymbolTable;
			SymbolTable = s;
			_here;
		;}
    break;

  case 3194:

/* Line 1464 of yacc.c  */
#line 103258 "hlaparse.bsn"
    {
			char *p;
			_here;
			
			// Set up CurVar for this guy:
			
			free2( vss CurVar );
			CurVar = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
			
			SetReferenced( (yyvsp[(1) - (1)].s) );			
			_if
			( 
					(yyvsp[(1) - (1)].s)->SymClass == cParm 
				&&	ByAddress( (yyvsp[(1) - (1)].s)->pClass )
			)

				(yyval.adrs.Type) = &pointer_ste;
				(yyval.adrs.pType) = tPointer;
				(yyval.adrs.Size) = 4;
				(yyval.adrs.forcedSize) = 4;

			_else

				(yyval.adrs.Type) = (yyvsp[(1) - (1)].s)->Type;
				(yyval.adrs.pType) = (yyvsp[(1) - (1)].s)->pType;

				_if( (yyvsp[(1) - (1)].s)->Arity == 0 )

					/*
					** If a scalar type, set the size to the
					** size of this object.
					*/

					(yyval.adrs.Size) = (yyvsp[(1) - (1)].s)->ObjectSize;

				_else

					/*
					** If an array type, set the size to the size
					** of the base type.
					*/

					(yyval.adrs.Size) = GetBaseType( (yyvsp[(1) - (1)].s)->Type )->ObjectSize;

				_endif

			_endif
			(yyval.adrs.ObjectSize) = (yyvsp[(1) - (1)].s)->ObjectSize;
			(yyval.adrs.Sym) = (yyvsp[(1) - (1)].s);
			(yyval.adrs.pClass) = (yyvsp[(1) - (1)].s)->pClass;
			(yyval.adrs.SymClass) = (yyvsp[(1) - (1)].s)->SymClass;
			(yyval.adrs.BaseType) = (yyvsp[(1) - (1)].s)->Base;
			(yyval.adrs.regnum) = (yyvsp[(1) - (1)].s)->regnum;
			
			_if( (yyvsp[(1) - (1)].s)->StaticName == NULL )

				(yyval.adrs.StaticName) = NULL;
				(yyval.adrs.BaseReg) = hlastrdup2( CurBaseReg );
				(yyval.adrs.IndexReg) = NULL;
				(yyval.adrs.Scale) = 0;
				(yyval.adrs.regnum) = -1;
				(yyval.adrs.Disp) = (yyvsp[(1) - (1)].s)->Offset;
				(yyval.adrs.forcedSize) = 
					_ifx( (yyval.adrs.Size) <= 4, (yyval.adrs.Size), 0 );

			_else
				
				/*
				** If we get here, we've got a parameter that
				** was passed in a register.  So we must return
				** the register name in the StaticName field
				** and clean out all the other stuff.
				*/
				(yyval.adrs.StaticName) = hlastrdup2( (yyvsp[(1) - (1)].s)->StaticName );
				(yyval.adrs.regnum) = strToReg( (yyvsp[(1) - (1)].s)->StaticName );
				(yyval.adrs.BaseReg) = NULL;
				(yyval.adrs.IndexReg) = NULL;
				(yyval.adrs.Scale) = 0;
				(yyval.adrs.Disp) = 0;
				(yyval.adrs.forcedSize) = 0;

			_endif
			_here;
		;}
    break;

  case 3195:

/* Line 1464 of yacc.c  */
#line 103351 "hlaparse.bsn"
    {
			char name[ 256 ];

			_here;
			
			// Set up CurVar for this guy:
			
			free2( vss CurVar );
			
			
			SetReferenced( (yyvsp[(1) - (1)].s) );
			sprintf
			(
				name,
				"this.%s",
				(yyvsp[(1) - (1)].s)->TrueName
			);
			CurVar = hlastrdup2( name );
			
			_if( (yyvsp[(1) - (1)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(1) - (1)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.
				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(1) - (1)].s)->Type )->ObjectSize;

			_endif
			(yyval.adrs.ObjectSize) = (yyvsp[(1) - (1)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = (yyval.adrs.Size);
			(yyval.adrs.StaticName) = NULL;
			(yyval.adrs.regnum) = (yyvsp[(1) - (1)].s)->regnum;
			(yyval.adrs.BaseReg) = hlastrdup2( "esi" );
			(yyval.adrs.IndexReg) = NULL;
			(yyval.adrs.Scale) = 0;
			(yyval.adrs.regnum) = -1;
			(yyval.adrs.Disp) = (yyvsp[(1) - (1)].s)->Offset;
			(yyval.adrs.Sym) = (yyvsp[(1) - (1)].s);
			(yyval.adrs.Type) = (yyvsp[(1) - (1)].s)->Type;
			(yyval.adrs.pType) = (yyvsp[(1) - (1)].s)->pType;
			(yyval.adrs.pClass) = (yyvsp[(1) - (1)].s)->pClass;
			(yyval.adrs.SymClass) = (yyvsp[(1) - (1)].s)->SymClass;
			_here;

		;}
    break;

  case 3196:

/* Line 1464 of yacc.c  */
#line 103410 "hlaparse.bsn"
    {
			char name[256];
			
			_here;
			assert( (yyvsp[(1) - (1)].s) != NULL );
			
			free2( vss CurVar );
			sprintf
			(
				name,
				"this.%s",
				(yyvsp[(1) - (1)].s)->TrueName
			);
			CurVar = hlastrdup2( name );
			
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_if( (yyvsp[(1) - (1)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(1) - (1)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.
				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(1) - (1)].s)->Type )->ObjectSize;

			_endif
			(yyval.adrs.ObjectSize) = (yyvsp[(1) - (1)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = 0;
			(yyval.adrs.StaticName) = hlastrdup2( (yyvsp[(1) - (1)].s)->StaticName );
			(yyval.adrs.regnum) = (yyvsp[(1) - (1)].s)->regnum;
			(yyval.adrs.BaseReg) = NULL;
			(yyval.adrs.IndexReg) = NULL;
			(yyval.adrs.Scale) = 0;
			(yyval.adrs.Disp) = (yyvsp[(1) - (1)].s)->Offset;
			(yyval.adrs.Sym) = (yyvsp[(1) - (1)].s);
			(yyval.adrs.Type) = (yyvsp[(1) - (1)].s)->Type;
			(yyval.adrs.pType) = (yyvsp[(1) - (1)].s)->pType;
			(yyval.adrs.pClass) = (yyvsp[(1) - (1)].s)->pClass;
			(yyval.adrs.SymClass) = (yyvsp[(1) - (1)].s)->SymClass;
			_here;
		;}
    break;

  case 3197:

/* Line 1464 of yacc.c  */
#line 103481 "hlaparse.bsn"
    {
			char name[ 256 ];

			_here;
			SetReferenced( (yyvsp[(3) - (3)].s) );
			_if( (yyvsp[(1) - (3)].reg.Size) != 4 )

				yyerror( "Base register must be 32-bits" );

			_endif
			sprintf
			(
				name,
				"%s:%s",
				regStrs[ (yyvsp[(1) - (3)].reg.encoding) ],
				(yyvsp[(3) - (3)].s)->TrueName
			);
			free2( vss CurVar );
			CurVar = hlastrdup2( name );
			
			
			_if
			( 
					(yyvsp[(3) - (3)].s)->SymClass == cParm 
				&&	ByAddress( (yyvsp[(3) - (3)].s)->pClass )
			)

				(yyval.adrs.Type) = &pointer_ste;
				(yyval.adrs.pType) = tPointer;
				(yyval.adrs.Size) = 4;

			_else

				(yyval.adrs.Type) = (yyvsp[(3) - (3)].s)->Type;
				(yyval.adrs.pType) = (yyvsp[(3) - (3)].s)->pType;
				_if( (yyvsp[(3) - (3)].s)->Arity == 0 )

					/*
					** If a scalar type, set the size to the
					** size of this object.
					*/

					(yyval.adrs.Size) = (yyvsp[(3) - (3)].s)->ObjectSize;

				_else

					/*
					** If an array type, set the size to the size
					** of the base type.
					*/

					(yyval.adrs.Size) = GetBaseType( (yyvsp[(3) - (3)].s)->Type )->ObjectSize;

				_endif

			_endif


			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (3)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = (yyval.adrs.Size);
			(yyval.adrs.StaticName) = NULL;
			(yyval.adrs.regnum) = -1;
			(yyval.adrs.BaseReg) = hlastrdup2( regStrs[(yyvsp[(1) - (3)].reg.encoding)] );
			(yyval.adrs.IndexReg) = NULL;
			(yyval.adrs.Scale) = 0;
			(yyval.adrs.Disp) = (yyvsp[(3) - (3)].s)->Offset;
			(yyval.adrs.Sym) = (yyvsp[(3) - (3)].s);
			(yyval.adrs.pClass) = (yyvsp[(3) - (3)].s)->pClass;
			(yyval.adrs.SymClass) = (yyvsp[(3) - (3)].s)->SymClass;
			(yyval.adrs.BaseType) = (yyvsp[(3) - (3)].s)->Base;
			_here;

		;}
    break;

  case 3198:

/* Line 1464 of yacc.c  */
#line 103565 "hlaparse.bsn"
    {
			_here;
			free2( vss CurVar );
			CurVar = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
			
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_if( (yyvsp[(1) - (1)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(1) - (1)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.
				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(1) - (1)].s)->Type )->ObjectSize;

			_endif
			(yyval.adrs.ObjectSize) = (yyvsp[(1) - (1)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = 0;
			(yyval.adrs.StaticName) = hlastrdup2( (yyvsp[(1) - (1)].s)->StaticName );
			(yyval.adrs.regnum) = -1;
			(yyval.adrs.BaseReg) = NULL;
			(yyval.adrs.IndexReg) = NULL;
			(yyval.adrs.Scale) = 0;
			(yyval.adrs.Disp) = 0;
			(yyval.adrs.Sym) = (yyvsp[(1) - (1)].s);
			(yyval.adrs.Type) = (yyvsp[(1) - (1)].s)->Type;
			(yyval.adrs.pType) = (yyvsp[(1) - (1)].s)->pType;
			(yyval.adrs.pClass) = (yyvsp[(1) - (1)].s)->pClass;
			(yyval.adrs.SymClass) = (yyvsp[(1) - (1)].s)->SymClass;
			_here;
		;}
    break;

  case 3199:

/* Line 1464 of yacc.c  */
#line 103625 "hlaparse.bsn"
    {					/* $6 */

			SymNode_t 		*s;
			char 			adrs[256];

			_here;
			
			sprintf
			(
				adrs,
				"(type %s %s)",
				(yyvsp[(3) - (5)].s)->TrueName,
				CurVar				// From SimpleMemoryVar$4 above
			);
			free2( vss CurVar );
			CurVar = hlastrdup2( adrs );
			

			/*
			** If the SymClass is cParm and the pClass is
			** not valp_pc, then change the pClass to valp_pc
			** and make other appropriate adjustments.
			*/

			_if( (yyvsp[(4) - (5)].adrs.SymClass) == cParm && (yyvsp[(4) - (5)].adrs.pClass) != valp_pc )

				(yyvsp[(4) - (5)].adrs.SymClass) = cParm;
				(yyvsp[(4) - (5)].adrs.pClass) = valp_pc;
				(yyvsp[(4) - (5)].adrs.Type) = &dword_ste;
				(yyvsp[(4) - (5)].adrs.pType) = tDWord;
	
			_endif



			_if( (yyvsp[(3) - (5)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(3) - (5)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.
				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(3) - (5)].s)->Type )->ObjectSize;

			_endif
			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (5)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = (yyvsp[(3) - (5)].s)->ObjectSize;
			(yyval.adrs.StaticName) = (yyvsp[(4) - (5)].adrs.StaticName);
			(yyval.adrs.regnum) = (yyvsp[(4) - (5)].adrs.regnum);
			(yyval.adrs.BaseReg) = (yyvsp[(4) - (5)].adrs.BaseReg);
			(yyval.adrs.IndexReg) = (yyvsp[(4) - (5)].adrs.IndexReg);
			(yyval.adrs.Scale) = (yyvsp[(4) - (5)].adrs.Scale);
			(yyval.adrs.Disp) = (yyvsp[(4) - (5)].adrs.Disp);
			(yyval.adrs.Sym) = (yyvsp[(4) - (5)].adrs.Sym);
			(yyval.adrs.SymClass) = (yyvsp[(4) - (5)].adrs.SymClass);
			(yyval.adrs.pClass) = (yyvsp[(4) - (5)].adrs.pClass);

			
			// Memory leak! We have to guarantee that Sym's type matches Type.
			// In order to do this, we have to create a new symbol table entry
			// and copy Sym's data to it (shallow copy is fine) so we can copy
			// the TYPE field to Sym's type without affecting the original
			// symbol's definition.
			
			s = (SymNode_t *) malloc2( sizeofSymNode);
			memcpy
			( 
				s, 
				(yyval.adrs.Sym), 
				sizeofSymNode - sizeofValuesSize
			);
			s->Type = (yyvsp[(3) - (5)].s);
			s->pType = (yyvsp[(3) - (5)].s)->pType;
			(yyval.adrs.Type) = (yyvsp[(3) - (5)].s);
			(yyval.adrs.pType) = (yyvsp[(3) - (5)].s)->pType;
			(yyval.adrs.Sym) = s;
			
			// Copy the parameter information from the type:
			
			memcpy( &s->u, &(yyvsp[(3) - (5)].s)->u, sizeofValuesSize);
			_here;
		;}
    break;

  case 3200:

/* Line 1464 of yacc.c  */
#line 103727 "hlaparse.bsn"
    {					/* $7 */

			SymNode_t	*s;
			char 		adrs[256];

			_here;

			sprintf
			(
				adrs,
				"(type %s %s)",
				(yyvsp[(3) - (6)].s)->TrueName,
				CurVar				// From SimpleMemoryVar$5 above
			);
			free2( vss CurVar );
			CurVar = hlastrdup2( adrs );

			/*
			** If the SymClass is cParm and the pClass is
			** not valp_pc, then change the pClass to valp_pc
			** and make other appropriate adjustments.
			*/

			_if( (yyvsp[(5) - (6)].adrs.SymClass) == cParm && (yyvsp[(5) - (6)].adrs.pClass) != valp_pc )

				(yyvsp[(5) - (6)].adrs.SymClass) = cParm;
				(yyvsp[(5) - (6)].adrs.pClass) = valp_pc;
				(yyvsp[(5) - (6)].adrs.Type) = &dword_ste;
				(yyvsp[(5) - (6)].adrs.pType) = tDWord;
	
			_endif



			_if( (yyvsp[(3) - (6)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(3) - (6)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.
				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(3) - (6)].s)->Type )->ObjectSize;

			_endif
			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (6)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = (yyvsp[(3) - (6)].s)->ObjectSize;
			(yyval.adrs.StaticName) = (yyvsp[(5) - (6)].adrs.StaticName);
			(yyval.adrs.regnum) = (yyvsp[(5) - (6)].adrs.regnum);
			(yyval.adrs.BaseReg) = (yyvsp[(5) - (6)].adrs.BaseReg);
			(yyval.adrs.IndexReg) = (yyvsp[(5) - (6)].adrs.IndexReg);
			(yyval.adrs.Scale) = (yyvsp[(5) - (6)].adrs.Scale);
			(yyval.adrs.Disp) = (yyvsp[(5) - (6)].adrs.Disp);
			(yyval.adrs.Sym) = (yyvsp[(5) - (6)].adrs.Sym);
			(yyval.adrs.SymClass) = (yyvsp[(5) - (6)].adrs.SymClass);
			(yyval.adrs.pClass) = (yyvsp[(5) - (6)].adrs.pClass);
			
			// Memory leak! We have to guarantee that Sym's type matches Type.
			// In order to do this, we have to create a new symbol table entry
			// and copy Sym's data to it (shallow copy is fine) so we can copy
			// the TYPE field to Sym's type without affecting the original
			// symbol's definition.
			
			s = (SymNode_t *) malloc2( sizeofSymNode);
			memcpy
			( 
				s, 
				(yyval.adrs.Sym), 
				sizeofSymNode - sizeofValuesSize
			);
			s->Type = (yyvsp[(3) - (6)].s);
			s->pType = (yyvsp[(3) - (6)].s)->pType;
			(yyval.adrs.Sym) = s;
			(yyval.adrs.Type) = (yyvsp[(3) - (6)].s);
			(yyval.adrs.pType) = (yyvsp[(3) - (6)].s)->pType;
			
			// Copy the parameter information from the type:
			
			memcpy( &s->u, &(yyvsp[(3) - (6)].s)->u, sizeofValuesSize);
			_here;
		;}
    break;

  case 3201:

/* Line 1464 of yacc.c  */
#line 103827 "hlaparse.bsn"
    {					/* $7 */

			SymNode_t 	*s;
			char		curVarStr[256];
			char		IndexAdrsStr[256];

			_here;

			/*
			** If the SymClass is cParm and the pClass is
			** not valp_pc, then change the pClass to valp_pc
			** and make other appropriate adjustments.
			*/

			_if( (yyvsp[(4) - (6)].adrs.SymClass) == cParm && (yyvsp[(4) - (6)].adrs.pClass) != valp_pc )

				(yyvsp[(4) - (6)].adrs.SymClass) = cParm;
				(yyvsp[(4) - (6)].adrs.pClass) = valp_pc;
				(yyvsp[(4) - (6)].adrs.Type) = &dword_ste;
				(yyvsp[(4) - (6)].adrs.pType) = tDWord;
	
			_endif

 			CombineAddresses( &(yyvsp[(4) - (6)].adrs), &(yyvsp[(5) - (6)].adrs) );
			CreateIndexStr( IndexAdrsStr, &(yyvsp[(4) - (6)].adrs) );
			sprintf
			(
				curVarStr,
				"(type %s %s %s)",
				(yyvsp[(3) - (6)].s)->TrueName,
				CurVar,				// From $4 above
				IndexAdrsStr
			);
			free2( vss CurVar );
			CurVar = hlastrdup2( curVarStr );

			_if( (yyvsp[(3) - (6)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(3) - (6)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.

				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(3) - (6)].s)->Type )->ObjectSize;

			_endif
			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (6)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = (yyvsp[(3) - (6)].s)->ObjectSize;
			(yyval.adrs.StaticName) = (yyvsp[(4) - (6)].adrs.StaticName);
			(yyval.adrs.regnum) = (yyvsp[(4) - (6)].adrs.regnum);
			(yyval.adrs.BaseReg) = (yyvsp[(4) - (6)].adrs.BaseReg);
			(yyval.adrs.IndexReg) = (yyvsp[(4) - (6)].adrs.IndexReg);
			(yyval.adrs.Scale) = (yyvsp[(4) - (6)].adrs.Scale);
			(yyval.adrs.Disp) = (yyvsp[(4) - (6)].adrs.Disp);
			(yyval.adrs.Sym) = (yyvsp[(4) - (6)].adrs.Sym);
			(yyval.adrs.SymClass) = (yyvsp[(4) - (6)].adrs.SymClass);
			(yyval.adrs.pClass) = (yyvsp[(4) - (6)].adrs.pClass);

			
			// Memory leak! We have to guarantee that Sym's type matches Type.
			// In order to do this, we have to create a new symbol table entry
			// and copy Sym's data to it (shallow copy is fine) so we can copy
			// the TYPE field to Sym's type without affecting the original
			// symbol's definition.
			
			s = (SymNode_t *) malloc2( sizeofSymNode);
			memcpy
			( 
				s, 
				(yyval.adrs.Sym), 
				sizeofSymNode - sizeofValuesSize
			);
			s->Type = (yyvsp[(3) - (6)].s);
			s->pType = (yyvsp[(3) - (6)].s)->pType;
			(yyval.adrs.Sym) = s;
			(yyval.adrs.Type) = (yyvsp[(3) - (6)].s);
			(yyval.adrs.pType) = (yyvsp[(3) - (6)].s)->pType;
			
			// Copy the parameter information from the type:
			
			memcpy( &s->u, &(yyvsp[(3) - (6)].s)->u, sizeofValuesSize);

			FreeAdrs( &(yyvsp[(5) - (6)].adrs) );
			_here;
		;}
    break;

  case 3202:

/* Line 1464 of yacc.c  */
#line 103934 "hlaparse.bsn"
    {					/* $8 */
		
			SymNode_t	*s;
			char		IndexAdrsStr[256];
			char		curVarStr[256];

			_here;

			/*
			** If the SymClass is cParm and the pClass is
			** not valp_pc, then change the pClass to valp_pc
			** and make other appropriate adjustments.
			*/

			_if( (yyvsp[(5) - (7)].adrs.SymClass) == cParm && (yyvsp[(5) - (7)].adrs.pClass) != valp_pc )

				(yyvsp[(5) - (7)].adrs.SymClass) = cParm;
				(yyvsp[(5) - (7)].adrs.pClass) = valp_pc;
				(yyvsp[(5) - (7)].adrs.Type) = &dword_ste;
				(yyvsp[(5) - (7)].adrs.pType) = tDWord;
	
			_endif

 			CombineAddresses( &(yyvsp[(5) - (7)].adrs), &(yyvsp[(6) - (7)].adrs) );
			CreateIndexStr( IndexAdrsStr, &(yyvsp[(6) - (7)].adrs) );
			sprintf
			(
				curVarStr,
				"(type %s %s %s)",
				(yyvsp[(3) - (7)].s)->TrueName,
				CurVar,				// From $4 above
				IndexAdrsStr
			);
			free2( vss CurVar );
			CurVar = hlastrdup2( curVarStr );

			_if( (yyvsp[(3) - (7)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(3) - (7)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.

				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(3) - (7)].s)->Type )->ObjectSize;

			_endif
			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (7)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = (yyvsp[(3) - (7)].s)->ObjectSize;
			(yyval.adrs.regnum) = (yyvsp[(5) - (7)].adrs.regnum);
			(yyval.adrs.StaticName) = (yyvsp[(5) - (7)].adrs.StaticName);
			(yyval.adrs.regnum) = (yyvsp[(5) - (7)].adrs.regnum);
			(yyval.adrs.BaseReg) = (yyvsp[(5) - (7)].adrs.BaseReg);
			(yyval.adrs.IndexReg) = (yyvsp[(5) - (7)].adrs.IndexReg);
			(yyval.adrs.Scale) = (yyvsp[(5) - (7)].adrs.Scale);
			(yyval.adrs.Disp) = (yyvsp[(5) - (7)].adrs.Disp);
			(yyval.adrs.Sym) = (yyvsp[(5) - (7)].adrs.Sym);
			(yyval.adrs.SymClass) = (yyvsp[(5) - (7)].adrs.SymClass);
			(yyval.adrs.pClass) = (yyvsp[(5) - (7)].adrs.pClass);

			
			// Memory leak! We have to guarantee that Sym's type matches Type.
			// In order to do this, we have to create a new symbol table entry
			// and copy Sym's data to it (shallow copy is fine) so we can copy
			// the TYPE field to Sym's type without affecting the original
			// symbol's definition.
			
			s = (SymNode_t *) malloc2( sizeofSymNode);
			memcpy
			( 
				s, 
				(yyval.adrs.Sym), 
				sizeofSymNode - sizeofValuesSize
			);
			s->Type = (yyvsp[(3) - (7)].s);
			s->pType = (yyvsp[(3) - (7)].s)->pType;
			(yyval.adrs.Sym) = s;
			(yyval.adrs.Type) = (yyvsp[(3) - (7)].s);
			(yyval.adrs.pType) = (yyvsp[(3) - (7)].s)->pType;
			
			// Copy the parameter information from the type:
			
			memcpy( &s->u, &(yyvsp[(3) - (7)].s)->u, sizeofValuesSize);

			FreeAdrs( &(yyvsp[(6) - (7)].adrs) );
			_here;
		;}
    break;

  case 3203:

/* Line 1464 of yacc.c  */
#line 104041 "hlaparse.bsn"
    {					/* $7 */
		
			char 		newVar[256];
			SymNode_t	*s;
			
			_here;
			
			sprintf( newVar, "(type %s %s)", (yyvsp[(3) - (6)].s)->TrueName, CurVar );
			free2( vss CurVar );
			CurVar = hlastrdup2( newVar );

			memcpy( &(yyval.adrs), &(yyvsp[(5) - (6)].adrs), sizeofYYSTYPE);
			_if( (yyvsp[(3) - (6)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(3) - (6)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.
				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(3) - (6)].s)->Type )->ObjectSize;

			_endif

			/*
			** Copy all the remaining fields not processed by FieldStuff.
			*/

			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (6)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = (yyvsp[(3) - (6)].s)->ObjectSize;

			
			// Memory leak! We have to guarantee that Sym's type matches Type.
			// In order to do this, we have to create a new symbol table entry
			// and copy Sym's data to it (shallow copy is fine) so we can copy
			// the TYPE field to Sym's type without affecting the original
			// symbol's definition.
			
			s = (SymNode_t *) malloc2( sizeofSymNode);
			memcpy
			( 
				s, 
				(yyval.adrs.Sym), 
				sizeofSymNode - sizeofValuesSize
			);
			s->Type = (yyvsp[(3) - (6)].s);
			s->pType = (yyvsp[(3) - (6)].s)->pType;
			(yyval.adrs.Sym) = s;
			(yyval.adrs.Type) = (yyvsp[(3) - (6)].s);
			(yyval.adrs.pType) = (yyvsp[(3) - (6)].s)->pType;
			
			// Copy the parameter information from the type:
			
			memcpy( &s->u, &(yyvsp[(3) - (6)].s)->u, sizeofValuesSize);

			FreeAdrs( &(yyvsp[(4) - (6)].adrs) );
			_here;
		;}
    break;

  case 3204:

/* Line 1464 of yacc.c  */
#line 104119 "hlaparse.bsn"
    {					/* $8 */

			char 		newVar[256];
			SymNode_t	*s;
			
			_here;
			
			sprintf( newVar, "(type %s %s)", (yyvsp[(3) - (7)].s)->TrueName, CurVar );
			free2( vss CurVar );
			CurVar = hlastrdup2( newVar );

			memcpy( &(yyval.adrs), &(yyvsp[(6) - (7)].adrs), sizeofYYSTYPE);
			_if( (yyvsp[(3) - (7)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(3) - (7)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.
				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(3) - (7)].s)->Type )->ObjectSize;

			_endif

			/*
			** Copy all the remaining fields not processed by FieldStuff.
			*/

			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (7)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = (yyvsp[(3) - (7)].s)->ObjectSize;

			
			// Memory leak! We have to guarantee that Sym's type matches Type.
			// In order to do this, we have to create a new symbol table entry
			// and copy Sym's data to it (shallow copy is fine) so we can copy
			// the TYPE field to Sym's type without affecting the original
			// symbol's definition.
			
			s = (SymNode_t *) malloc2( sizeofSymNode);
			memcpy
			( 
				s, 
				(yyval.adrs.Sym), 
				sizeofSymNode - sizeofValuesSize
			);
			s->Type = (yyvsp[(3) - (7)].s);
			s->pType = (yyvsp[(3) - (7)].s)->pType;
			(yyval.adrs.Sym) = s;
			(yyval.adrs.Type) = (yyvsp[(3) - (7)].s);
			(yyval.adrs.pType) = (yyvsp[(3) - (7)].s)->pType;
			
			// Copy the parameter information from the type:
			
			memcpy( &s->u, &(yyvsp[(3) - (7)].s)->u, sizeofValuesSize);

			
			FreeAdrs( &(yyvsp[(5) - (7)].adrs) );
			_here;
		;}
    break;

  case 3205:

/* Line 1464 of yacc.c  */
#line 104198 "hlaparse.bsn"
    {					/* $8 */

			SymNode_t *s;
			char		IndexAdrsStr[256];
			char		curVarStr[256];
			
			_here;
			memcpy( &(yyval.adrs), &(yyvsp[(5) - (7)].adrs), sizeofYYSTYPE);
			CombineAddresses( &(yyval.adrs), &(yyvsp[(6) - (7)].adrs) );
			CreateIndexStr( IndexAdrsStr, &(yyvsp[(6) - (7)].adrs) );
			sprintf
			(
				curVarStr,
				"(type %s %s %s)",
				(yyvsp[(3) - (7)].s)->TrueName,
				CurVar,				// From $4 above
				IndexAdrsStr
			);
			free2( vss CurVar );
			CurVar = hlastrdup2( curVarStr );

			_if( (yyvsp[(3) - (7)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(3) - (7)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.
				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(3) - (7)].s)->Type )->ObjectSize;

			_endif

			/*
			** Copy all the remaining fields processed by FieldStuff.
			*/

			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (7)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = (yyvsp[(3) - (7)].s)->ObjectSize;

			
			// Memory leak! We have to guarantee that Sym's type matches Type.
			// In order to do this, we have to create a new symbol table entry
			// and copy Sym's data to it (shallow copy is fine) so we can copy
			// the TYPE field to Sym's type without affecting the original
			// symbol's definition.
			
			s = (SymNode_t *) malloc2( sizeofSymNode);
			memcpy
			( 
				s, 
				(yyval.adrs.Sym), 
				sizeofSymNode - sizeofValuesSize
			);
			s->Type = (yyvsp[(3) - (7)].s);
			s->pType = (yyvsp[(3) - (7)].s)->pType;
			(yyval.adrs.Sym) = s;
			(yyval.adrs.Type) = (yyvsp[(3) - (7)].s);
			(yyval.adrs.pType) = (yyvsp[(3) - (7)].s)->pType;
			
			// Copy the parameter information from the type:
			
			memcpy( &s->u, &(yyvsp[(3) - (7)].s)->u, sizeofValuesSize);

			FreeAdrs( &(yyvsp[(4) - (7)].adrs) );
			FreeAdrs( &(yyvsp[(6) - (7)].adrs) );
			_here;
		;}
    break;

  case 3206:

/* Line 1464 of yacc.c  */
#line 104287 "hlaparse.bsn"
    {					/* $9 */

			SymNode_t *s;
			char		IndexAdrsStr[256];
			char		curVarStr[256];
			
			_here;
			memcpy( &(yyval.adrs), &(yyvsp[(6) - (8)].adrs), sizeofYYSTYPE);
			CombineAddresses( &(yyval.adrs), &(yyvsp[(7) - (8)].adrs) );
			CreateIndexStr( IndexAdrsStr, &(yyvsp[(7) - (8)].adrs) );
			sprintf
			(
				curVarStr,
				"(type %s %s %s)",
				(yyvsp[(3) - (8)].s)->TrueName,
				CurVar,				// From $4 above
				IndexAdrsStr
			);
			free2( vss CurVar );
			CurVar = hlastrdup2( curVarStr );

			_if( (yyvsp[(3) - (8)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(3) - (8)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.
				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(3) - (8)].s)->Type )->ObjectSize;

			_endif

			/*
			** Copy all the remaining fields processed by FieldStuff.
			*/

			(yyval.adrs.forcedSize) = (yyvsp[(3) - (8)].s)->ObjectSize;
			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (8)].s)->ObjectSize;

			
			// Memory leak! We have to guarantee that Sym's type matches Type.
			// In order to do this, we have to create a new symbol table entry
			// and copy Sym's data to it (shallow copy is fine) so we can copy
			// the TYPE field to Sym's type without affecting the original
			// symbol's definition.
			
			s = (SymNode_t *) malloc2( sizeofSymNode);
			memcpy
			( 
				s, 
				(yyval.adrs.Sym), 
				sizeofSymNode - sizeofValuesSize
			);
			s->Type = (yyvsp[(3) - (8)].s);
			s->pType = (yyvsp[(3) - (8)].s)->pType;
			(yyval.adrs.Sym) = s;
			(yyval.adrs.Type) = (yyvsp[(3) - (8)].s);
			(yyval.adrs.pType) = (yyvsp[(3) - (8)].s)->pType;
			
			// Copy the parameter information from the type:
			
			memcpy( &s->u, &(yyvsp[(3) - (8)].s)->u, sizeofValuesSize);

			FreeAdrs( &(yyvsp[(5) - (8)].adrs) );
			FreeAdrs( &(yyvsp[(7) - (8)].adrs) );
			_here;
		;}
    break;

  case 3207:

/* Line 1464 of yacc.c  */
#line 104380 "hlaparse.bsn"
    {
			SymNode_t *s;
			char		IndexAdrsStr[256];
			char		curVarStr[256];
			
			_here;
			CreateIndexStr( IndexAdrsStr, &(yyvsp[(4) - (5)].adrs) );
			sprintf
			(
				curVarStr,
				"(type %s %s)",
				(yyvsp[(3) - (5)].s)->TrueName,
				IndexAdrsStr
			);
			free2( vss CurVar );
			CurVar = hlastrdup2( curVarStr );

			_if( (yyvsp[(3) - (5)].s)->Arity == 0 )

				/*
				** If a scalar type, set the size to the
				** size of this object.
				*/

				(yyval.adrs.Size) = (yyvsp[(3) - (5)].s)->ObjectSize;

			_else

				/*
				** If an array type, set the size to the size
				** of the base type.
				*/

				(yyval.adrs.Size) = GetBaseType( (yyvsp[(3) - (5)].s)->Type )->ObjectSize;

			_endif

			/*
			** Note: StaticName cannot be returned as NULL because
			** that would suggest that this variable uses EBP as
			** the base register.
			*/

			(yyval.adrs.StaticName) = hlastrdup2("");
			(yyval.adrs.regnum) = -1;
			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (5)].s)->ObjectSize;
			(yyval.adrs.forcedSize) = (yyvsp[(3) - (5)].s)->ObjectSize;
			(yyval.adrs.BaseReg) = (yyvsp[(4) - (5)].adrs.BaseReg);
			(yyval.adrs.IndexReg) = (yyvsp[(4) - (5)].adrs.IndexReg);
			(yyval.adrs.Scale) = (yyvsp[(4) - (5)].adrs.Scale);
			(yyval.adrs.Disp) = (yyvsp[(4) - (5)].adrs.Disp);
			(yyval.adrs.Type) = (yyvsp[(3) - (5)].s);
			(yyval.adrs.pType) = (yyvsp[(3) - (5)].s)->pType;
			(yyval.adrs.pClass) = valp_pc;
			(yyval.adrs.SymClass) = cVar;
			(yyval.adrs.BaseType) = (yyvsp[(3) - (5)].s);
			
			// Create a dummy symbol so that the SYM field is never NULL
			
			s = SymbolTable;
			InsertSym
			( 
				" (anon sym) ", 
				(yyvsp[(3) - (5)].s),			/* Type							*/
				(yyvsp[(3) - (5)].s)->pType,
				cStatic, 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				NULL,			/* No initialization			*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				NULL,			/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);
			
			(yyval.adrs.Sym) = SymbolTable;
			SymbolTable = s;
			_here;
		;}
    break;

  case 3208:

/* Line 1464 of yacc.c  */
#line 104472 "hlaparse.bsn"
    {
			_here;
			free2( vss CurVar );
			CurVar = hlastrdup2( (yyvsp[(1) - (1)].s)->TrueName );
			
			SetReferenced( (yyvsp[(1) - (1)].s) );
			_if
			( 
					(yyvsp[(1) - (1)].s)->SymClass == cVar 
				||	(yyvsp[(1) - (1)].s)->SymClass == cParm
			)

				yyerror( "Non-local name requires a base register" );

			_endif
			(yyval.adrs.Size) = 0;
			(yyval.adrs.forcedSize) = 0;
			(yyval.adrs.ObjectSize) = 0;
			(yyval.adrs.StaticName) = NULL;
			(yyval.adrs.regnum) = -1;
			(yyval.adrs.BaseReg) = NULL;
			(yyval.adrs.IndexReg) = NULL;
			(yyval.adrs.Scale) = 0;
			(yyval.adrs.Disp) = 0;
			(yyval.adrs.Sym) = (yyvsp[(1) - (1)].s);
			(yyval.adrs.Type) = (yyvsp[(1) - (1)].s)->Type;
			(yyval.adrs.BaseType) = (yyvsp[(1) - (1)].s)->Type;
			(yyval.adrs.pType) = (yyvsp[(1) - (1)].s)->pType;
			(yyval.adrs.pClass) = (yyvsp[(1) - (1)].s)->pClass;
			(yyval.adrs.SymClass) = (yyvsp[(1) - (1)].s)->SymClass;
			_here;
		;}
    break;

  case 3209:

/* Line 1464 of yacc.c  */
#line 104511 "hlaparse.bsn"
    {
			_here;
			yyerror( "Local and Static objects do not allow base register" );
			(yyval.adrs.Size) = 0;
			(yyval.adrs.forcedSize) = 0;
			(yyval.adrs.ObjectSize) = 0;
			(yyval.adrs.StaticName) = NULL;
			(yyval.adrs.regnum) = -1;
			(yyval.adrs.BaseReg) = NULL;
			(yyval.adrs.IndexReg) = NULL;
			(yyval.adrs.Scale) = 0;
			(yyval.adrs.Disp) = 0;
			(yyval.adrs.Sym) = (yyvsp[(3) - (3)].s);
			(yyval.adrs.Type) = (yyvsp[(3) - (3)].s)->Type;
			(yyval.adrs.BaseType) = (yyvsp[(3) - (3)].s)->Type;
			(yyval.adrs.pType) = (yyvsp[(3) - (3)].s)->pType;
			(yyval.adrs.pClass) = (yyvsp[(3) - (3)].s)->pClass;
			(yyval.adrs.SymClass) = (yyvsp[(3) - (3)].s)->SymClass;
			_here;
		;}
    break;

  case 3210:

/* Line 1464 of yacc.c  */
#line 104539 "hlaparse.bsn"
    {
			SymNode_t *s;
			_here;
			yyerror( "Undefined intermediate ID" );
			(yyval.adrs.Size) = 0;
			(yyval.adrs.forcedSize) = 0;
			(yyval.adrs.ObjectSize) = 0;
			(yyval.adrs.StaticName) = NULL;
			(yyval.adrs.regnum) = -1;
			(yyval.adrs.BaseReg) = NULL;
			(yyval.adrs.IndexReg) = NULL;
			(yyval.adrs.Scale) = 0;
			(yyval.adrs.Disp) = 0;
			(yyval.adrs.Type) = &boolean_ste;
			(yyval.adrs.BaseType) = &boolean_ste;
			(yyval.adrs.pType) = tBoolean;
			(yyval.adrs.pClass) = valp_pc;
			(yyval.adrs.SymClass) = cStatic;
			
			
			// Create a dummy symbol so that the SYM field is never NULL
			
			s = SymbolTable;
			InsertSym
			( 
				" (anon sym) ", 
				(yyval.adrs.Type),	/* Type							*/
				(yyval.adrs.pType),
				cStatic, 
				0,				/* Arity						*/
				NULL,			/* Dimensions					*/
				0, 				/* NumElements					*/
				NULL,			/* No initialization			*/
				0,				/* Object size					*/
				0,				/* Offset						*/
				NULL,			/* Static Name					*/
				NULL,			/* Base							*/
				NULL,			/* Fields						*/
				0				/* FieldCnt						*/
			);
			
			(yyval.adrs.Sym) = SymbolTable;
			SymbolTable = s;
			_here;
		;}
    break;

  case 3214:

/* Line 1464 of yacc.c  */
#line 104619 "hlaparse.bsn"
    {
			(yyval.idStr) = hlastrdup2( CurVar );
		;}
    break;

  case 3215:

/* Line 1464 of yacc.c  */
#line 104625 "hlaparse.bsn"
    {
			(yyval.adrs) = (yyvsp[(-1) - (0)].adrs);
		;}
    break;

  case 3216:

/* Line 1464 of yacc.c  */
#line 104634 "hlaparse.bsn"
    {
			char varName[256];
			
			/*
			** Merge the <adrs> fields of $1 with the <adrs> fields
			** of $0 and return the combined values as $<adrs>$.
			*/

			_here;
			strcpy( varName, (yyvsp[(1) - (3)].idStr) );
			strcat( varName, CurVar );
			free2( vss CurVar );
			free2( vss (yyvsp[(1) - (3)].idStr) );
			CurVar = hlastrdup2( varName );
			 
			(yyval.adrs.Size) = (yyvsp[(3) - (3)].adrs.Size);
			(yyval.adrs.forcedSize) = 0;
			(yyval.adrs.ObjectSize) = (yyvsp[(3) - (3)].adrs.Size);
			_if
			( 
					IsStaticClass( (yyvsp[(3) - (3)].adrs.SymClass) )
				&&	(yyvsp[(3) - (3)].adrs.StaticName) != NULL 
				&&	*(yyvsp[(3) - (3)].adrs.StaticName) != '\0'
			)

				(yyval.adrs.StaticName) = hlastrdup2( (yyvsp[(3) - (3)].adrs.StaticName) );
				(yyval.adrs.regnum) = (yyvsp[(3) - (3)].adrs.regnum);
				(yyval.adrs.BaseReg) = NULL;
				(yyval.adrs.IndexReg) = NULL;
				(yyval.adrs.Scale) = 0;
				(yyval.adrs.Disp) = (yyvsp[(3) - (3)].adrs.Disp);

			_else

				(yyval.adrs.StaticName) = hlastrdup2( (yyvsp[(0) - (3)].adrs.StaticName) );
				(yyval.adrs.regnum) = (yyvsp[(0) - (3)].adrs.regnum);
				(yyval.adrs.BaseReg) = hlastrdup2( (yyvsp[(0) - (3)].adrs.BaseReg) );
				(yyval.adrs.IndexReg) = hlastrdup2( (yyvsp[(0) - (3)].adrs.IndexReg) );
				(yyval.adrs.Scale) = (yyvsp[(0) - (3)].adrs.Scale);
				(yyval.adrs.Disp) = (yyvsp[(0) - (3)].adrs.Disp) + (yyvsp[(3) - (3)].adrs.Disp);

			_endif
			(yyval.adrs.Sym) = (yyvsp[(3) - (3)].adrs.Sym);
			(yyval.adrs.Type) = (yyvsp[(3) - (3)].adrs.Type);
			(yyval.adrs.pType) = (yyvsp[(3) - (3)].adrs.pType);

			/*
			** Determining the resulting class is tricky.
			** If the recFieldStuff is static, then the
			** whole thing is static.  If the recFieldStuff
			** is not static and $0 is a parameter, then
			** we go with the $0 class info.  If the two
			** conditions above are false, then we just go
			** with the recFieldStuff class information.
			*/

			_if( IsStaticClass( (yyvsp[(3) - (3)].adrs.SymClass) ))

				(yyval.adrs.SymClass) = (yyvsp[(3) - (3)].adrs.SymClass);
				(yyval.adrs.pClass) = (yyvsp[(3) - (3)].adrs.pClass);

			_elseif( IsStaticClass( (yyvsp[(0) - (3)].adrs.SymClass) ))
	   			
				(yyval.adrs.SymClass) = (yyvsp[(0) - (3)].adrs.SymClass);
				(yyval.adrs.pClass) = (yyvsp[(0) - (3)].adrs.pClass);

			_elseif
			(
					( 
							(yyvsp[(0) - (3)].adrs.SymClass) == cParm 
						&&	NotStaticClass( (yyvsp[(3) - (3)].adrs.SymClass) )
					)
				||	IsStaticClass( (yyvsp[(0) - (3)].adrs.SymClass) )
			)

				(yyval.adrs.SymClass) = (yyvsp[(0) - (3)].adrs.SymClass);
				(yyval.adrs.pClass) = (yyvsp[(0) - (3)].adrs.pClass);


			_else

				(yyval.adrs.SymClass) = (yyvsp[(3) - (3)].adrs.SymClass);
				(yyval.adrs.pClass) = (yyvsp[(3) - (3)].adrs.pClass);

			_endif
			FreeAdrs( &(yyvsp[(3) - (3)].adrs) );
			_here;

		;}
    break;

  case 3217:

/* Line 1464 of yacc.c  */
#line 104737 "hlaparse.bsn"
    {				/* $6 */

			char newVar[256];
			
			SymNode_t	*sym;
			SymNode_t	*type0;
			SymNode_t	*type5;

			_here;
			
			sprintf( newVar, ".%s.%s", (yyvsp[(3) - (5)].idStr), CurVar );
			free2( vss CurVar );
			CurVar = hlastrdup2( newVar );
			
			// The following adrs fields are the same no matter
			// what else happens, so deal with them here.
			

			(yyval.adrs.Scale) = 0;
			(yyval.adrs.BaseReg) = NULL;
			(yyval.adrs.IndexReg) = NULL;

			// For memory objects of the form "(type xxx yyy)" the
			// symbol passed in could be returned as a type ID (xxx),
			// so handle that here.
			
			type0 = (yyvsp[(0) - (5)].adrs.Type);
			_if( type0 == NULL )
			
				type0 = (yyvsp[(0) - (5)].adrs.Sym);
				
			_endif
			assert( type0 != NULL );
			
			// SymbolTable is NULL if there was an error along the
			// fieldname list leading up to this point.  If this
			// is the case, don't do any processing since we don't
			// know the validity of any of the pointers.
			

			_if( (yyvsp[(1) - (5)].s) == NULL )

				// Okay, there is no "Fields" pointer for the
				// previous symbol.  We don't have to print an
				// error message because doing so would be redundant.
				// The previous production will print an appropriate
				// error message since LookUpSym in this production
				// will pass NULL on through to any other names appearing
				// in the field list (which eventually passes NULL as
				// $<s>0 to the production above).
				

				(yyval.adrs.Size) = 1;
				(yyval.adrs.forcedSize) = 0;
				(yyval.adrs.StaticName) = NULL;
				(yyval.adrs.regnum) = (yyvsp[(0) - (5)].adrs.regnum);
				(yyval.adrs.Disp) = 0;
				(yyval.adrs.Sym) = (yyvsp[(0) - (5)].adrs.Sym);
				(yyval.adrs.Type) = type0;
				(yyval.adrs.pType) = (yyvsp[(0) - (5)].adrs.pType);
				(yyval.adrs.pClass) = (yyvsp[(0) - (5)].adrs.pClass);
				(yyval.adrs.SymClass) = (yyvsp[(0) - (5)].adrs.SymClass);

			_else /* SymbolTable is non-NULL, so no error (yet) */

				/*
				** Okay, lookup the current symbol in the previous
				** symbol's "Fields" symbol table.
				*/

				sym = (yyvsp[(4) - (5)].adrs.Sym);
				_if( sym != NULL )

					type5 = (yyvsp[(5) - (5)].adrs.Type);
					_if( type5 == NULL )
					
						type5 = (yyvsp[(5) - (5)].adrs.Sym);
						
					_endif
					assert( type5 != NULL );
					
					(yyval.adrs.Size) = type5->ObjectSize;
					(yyval.adrs.forcedSize) = 0;
					(yyval.adrs.ObjectSize) = (yyval.adrs.Size);
					_if
					( 
							NotStaticClass( (yyvsp[(5) - (5)].adrs.SymClass) )
						||	(yyvsp[(5) - (5)].adrs.StaticName) == NULL 
					)

						_if
						( 
								IsStaticClass( sym->SymClass )
							&&	sym->StaticName != NULL 
						)

							/*
							** If FieldStuff's ($5) static name is NULL
							** but AnyID's ($4) is not, then return
							** the static ID of AnyID and the Disp value
							** for FieldStuff.
							*/

							(yyval.adrs.Disp) = (yyvsp[(5) - (5)].adrs.Disp);
							(yyval.adrs.StaticName) = hlastrdup2( sym->StaticName );

						_else

							/*
							** If AnyID's static name is NULL and so
							** is FieldStuff's static name, then just
							** return the displacement of these two
							** items.
							*/

							(yyval.adrs.StaticName) = NULL;
							(yyval.adrs.Disp) = sym->Offset + (yyvsp[(5) - (5)].adrs.Disp);

						_endif

					_else

						/*
						** If FieldStuff's ($5) StaticName field is non-NULL,
						** then return it's static name and displacement.
						*/

						(yyval.adrs.Disp) = sym->Offset + (yyvsp[(5) - (5)].adrs.Disp);
						(yyval.adrs.StaticName) = (yyvsp[(5) - (5)].adrs.StaticName);

						/*
						** Clear $5's StaticName field so FreeAdrs won't
						** deallocate it later.
						*/

						(yyvsp[(5) - (5)].adrs.StaticName) = NULL;

					_endif
					(yyval.adrs.Sym) = (yyvsp[(5) - (5)].adrs.Sym);
					(yyval.adrs.Type) = type5;
					(yyval.adrs.pType) = (yyvsp[(5) - (5)].adrs.pType);
					(yyval.adrs.pClass) = (yyvsp[(5) - (5)].adrs.pClass);
					(yyval.adrs.regnum) = (yyvsp[(5) - (5)].adrs.regnum);

					_if( IsStaticClass( (yyvsp[(5) - (5)].adrs.SymClass) ))

						(yyval.adrs.SymClass) = (yyvsp[(5) - (5)].adrs.SymClass);

					_else

						(yyval.adrs.SymClass) = sym->SymClass;

					_endif

				_else

					/*
					** If the field name doesn't appear in the current
					** symbol table (field list), this section prints
					** an appropriate error message.
					*/

					char msg[ 256 ];

					sprintf( msg, "Undefined field name <<%s>>", (yyvsp[(3) - (5)].neID.idStr) );
					yyerror( msg );
					(yyval.adrs.Size) = 1;
					(yyval.adrs.forcedSize) = 0;
					(yyval.adrs.ObjectSize) = 1;
					(yyval.adrs.StaticName) = NULL;
					(yyval.adrs.regnum) = -1;
					(yyval.adrs.Disp) = 0;
					(yyval.adrs.Sym) = (yyvsp[(0) - (5)].adrs.Sym);
					(yyval.adrs.Type) = type0;
					(yyval.adrs.pType) = (yyvsp[(0) - (5)].adrs.pType);
					(yyval.adrs.pClass) = (yyvsp[(0) - (5)].adrs.pClass);
					(yyval.adrs.SymClass) = (yyvsp[(0) - (5)].adrs.SymClass);

				_endif

			_endif
			_if
			( 
					IsStaticClass( (yyvsp[(0) - (5)].adrs.SymClass) ) 
				&&	NotStaticClass( (yyval.adrs.SymClass) )
			)

				(yyval.adrs.SymClass) = (yyvsp[(0) - (5)].adrs.SymClass);

			_endif
 
			free2( vss (yyvsp[(3) - (5)].neID.idStr) );
			FreeAdrs( &(yyvsp[(5) - (5)].adrs) );
			_here;
		;}
    break;

  case 3218:

/* Line 1464 of yacc.c  */
#line 104944 "hlaparse.bsn"
    {				/* $4 */

			char		newVar[256];
			SymNode_t	*sym;
			SymNode_t	*type0;

			_here;

			sprintf( newVar, ".%s", (yyvsp[(3) - (3)].idStr) );
			free2( vss CurVar );
			CurVar = hlastrdup2( newVar );

			SymbolTable = (yyvsp[(2) - (3)].s);

			type0 = (yyvsp[(0) - (3)].adrs.Type);
			_if( type0 == NULL )
			
				type0 = (yyvsp[(0) - (3)].adrs.Sym);
				
			_endif
			assert( type0 != NULL );
			
			// $<s>1 (PointAtFields) is NULL if there was an error along the
			// fieldname list leading up to this point.  If this
			// is the case, don't do any processing since we don't
			// know the validity of any of the pointers.
			

			_if( (yyvsp[(1) - (3)].s) == NULL )
			
				_here;

				/*
				** Okay, there is no "Fields" pointer for the
				** previous symbol.  This is definitely an
				** error so we should display the error message
				** and quit.  Also, return some fake information
				** to keep the calling code happy.
				*/

				yyerror( "Expected Class, Record, or Union type" );
				
				(yyval.adrs.Size) = 1;
				(yyval.adrs.forcedSize) = 0;
				(yyval.adrs.ObjectSize) = 1;
				(yyval.adrs.StaticName) = NULL;
				(yyval.adrs.regnum) = -1;
				(yyval.adrs.BaseReg) = NULL;
				(yyval.adrs.IndexReg) = NULL;
				(yyval.adrs.Scale) = 0;
				(yyval.adrs.Disp) = 0;
				(yyval.adrs.Sym) = (yyvsp[(0) - (3)].adrs.Sym);
				(yyval.adrs.Type) = type0;					
				(yyval.adrs.pType) = (yyvsp[(0) - (3)].adrs.pType);
				(yyval.adrs.pClass) = (yyvsp[(0) - (3)].adrs.pClass);
				(yyval.adrs.SymClass) = (yyvsp[(0) - (3)].adrs.SymClass);

			_else /* SymbolTable is non-NULL, so no error (yet) */

				_here;

				
				// Okay, lookup the current symbol in the previous
				// symbol's "Fields" symbol table.
				
				sym = lookupin( (yyvsp[(3) - (3)].neID.idStr), (yyvsp[(1) - (3)].s) );
				_if( sym != NULL )

					
					// The symbol exists.  This is good!
					// Now fill in the adrs fields with the
					// data gleened from this symbol.
					//
					//	Begin by computing the object's size.
					//	If it's an array, we want the size of
					//	an element, not the size of the whole array.
					
					_here;
					_if( sym->Arity == 0 )

						/*
						** If a scalar type, set the size to the
						** size of this object.
						*/

						(yyval.adrs.Size) = sym->ObjectSize;
						(yyval.adrs.ObjectSize) = (yyval.adrs.Size);

					_else

						
						// If an array type, set the size to the size
						// of the base type.
						

						(yyval.adrs.Size) = sym->Type->ObjectSize;
						(yyval.adrs.ObjectSize) = sym->ObjectSize;

					_endif
					(yyval.adrs.forcedSize) = 0;

					/*
					** If this object is static, pass back it's
					** static name and a displacement of zero.
					** If it's not static, just pass back the
					** symbol's Offset as the displacement.
					*/

					_here;
					_if( IsStaticClass( sym->SymClass ))

						(yyval.adrs.StaticName) = hlastrdup2( sym->StaticName );
						(yyval.adrs.Disp) = 0;
				
					_else

						(yyval.adrs.Disp) = sym->Offset;
						(yyval.adrs.StaticName) = NULL;

					_endif
					(yyval.adrs.BaseReg) = NULL;
					(yyval.adrs.IndexReg) = NULL;
					(yyval.adrs.Scale) = 0;
					(yyval.adrs.regnum) = -1;
					(yyval.adrs.Sym) = sym;
					(yyval.adrs.pType) = sym->pType;
					(yyval.adrs.regnum) = sym->regnum;
					_here;
					_if( sym->pType == tProcptr )

						(yyval.adrs.Type) = &proctype_ste;

					_else

						(yyval.adrs.Type) = 
							_ifx( sym->Type == NULL, sym, sym->Type );

					_endif
					(yyval.adrs.pClass) = sym->pClass;
					(yyval.adrs.SymClass) = sym->SymClass;
					_here;
					_if
					( 
							IsStaticClass( (yyvsp[(0) - (3)].adrs.SymClass) )
						&&	NotStaticClass( sym->SymClass )
					)

						(yyval.adrs.SymClass) = (yyvsp[(0) - (3)].adrs.SymClass);

					_endif

				_else

					
					// If the field name doesn't appear in the current
					// symbol table (field list), this section prints
					// an appropriate error message and sets up the
					// return values to indicate an undefined variable.
					

					char msg[ 256 ];

					sprintf( msg, "Undefined field name <<%s>>", (yyvsp[(3) - (3)].neID.idStr) );
					yyerror( msg );
					(yyval.adrs.Size) = 1;
					(yyval.adrs.forcedSize) = 0;
					(yyval.adrs.ObjectSize) = 1;
					(yyval.adrs.StaticName) = NULL;
					(yyval.adrs.regnum) = (yyvsp[(0) - (3)].adrs.regnum);
					(yyval.adrs.BaseReg) = NULL;
					(yyval.adrs.IndexReg) = NULL;
					(yyval.adrs.Scale) = 0;
					(yyval.adrs.Disp) = 0;
					(yyval.adrs.Sym) = (yyvsp[(0) - (3)].adrs.Sym);
					(yyval.adrs.Type) = 
						_ifx
						( 
							(yyvsp[(0) - (3)].adrs.Type) == NULL, 
							(yyvsp[(0) - (3)].adrs.Sym), 
							(yyvsp[(0) - (3)].adrs.Type) 
						);
					
					(yyval.adrs.pType) = (yyvsp[(0) - (3)].adrs.pType);
					(yyval.adrs.pClass) = (yyvsp[(0) - (3)].adrs.pClass);
					(yyval.adrs.SymClass) = (yyvsp[(0) - (3)].adrs.SymClass);

				_endif

			_endif
			free2( vss (yyvsp[(3) - (3)].neID.idStr) );
			_here;
		;}
    break;

  case 3219:

/* Line 1464 of yacc.c  */
#line 105141 "hlaparse.bsn"
    {
			_here;
			(yyval.s) = SymbolTable;
			SymbolTable = &dummy_ste;
		;}
    break;

  case 3220:

/* Line 1464 of yacc.c  */
#line 105171 "hlaparse.bsn"
    {
			SymNode_t *sym;

			/*
			** Restore saved SymbolTable value from
			** "PeriodAndSaveST".
			*/

			_here;
			SymbolTable = (yyvsp[(-1) - (0)].s);

			/*
			** If there is an outstanding error, don't bother with
			** this operation since we can guarantee its consistency.
			*/

			_if( (yyvsp[(-2) - (0)].s) != NULL )	/* PointAtFields value */

				/*
				** Okay, no error so far, look up the symbol in the
				** current field list (pointed at by SymbolTable).
				** Since LookupSym is called from the FieldStuff
				** production that handles interior names in the
				** field list, the name we are looking up must be
				** a record, union, or class type (since those are
				** the only names that allow periods on both sides
				** of the name).
				*/

				sym = lookupin( (yyvsp[(0) - (0)].idStr), (yyvsp[(-2) - (0)].s) );

				_if( sym != NULL )

					_if
					( 
							sym->pType == tRecord 
						||	sym->pType == tUnion
						||	sym->pType == tReal128
						||	sym->pType == tClass 
					)

						(yyval.adrs.Sym) = sym;
						(yyval.adrs.Type) = sym->Type;

					_elseif
					(
							sym->pType == tArray
						&&	sym->Type != NULL
						&&	(
									sym->Type->pType == tRecord 
								||	sym->Type->pType == tUnion
								||	sym->Type->pType == tReal128
								||	sym->Type->pType == tClass
							)
					)
					 
						(yyval.adrs.Sym) = sym;
						(yyval.adrs.Type) = sym->Type;

					_else

						yyerror( "Illegal field specification" );
						exit( 1 );

					_endif

				_else

					char msg[ 256 ];

					sprintf( msg, "Undefined field name <<%s>>", (yyvsp[(0) - (0)].idStr) );
					yyerror( msg );
					exit( 1 );

				_endif

			_endif
			_here;
		;}
    break;

  case 3221:

/* Line 1464 of yacc.c  */
#line 105262 "hlaparse.bsn"
    {
			SymNode_t *s;
			_here;
			_if( (yyvsp[(0) - (0)].adrs.Type) != NULL )

				_if( (yyvsp[(0) - (0)].adrs.Type)->pType == tPointer )

					_if( (yyvsp[(0) - (0)].adrs.Sym) != NULL )

						/*
						** If it's a variable, link off the Sym field.
						*/

						_if( (yyvsp[(0) - (0)].adrs.Sym)->Base == NULL )

								yyerror
								( 
									"Dot operator applied to ID w/o fields" 
								);
								exit( 1 );
							
						_else

							(yyval.s) = (yyvsp[(0) - (0)].adrs.Sym)->Base->Fields;

						_endif

					_else

						/*
						** If adrs.Sym is NULL then index off the
						** Type field rather than the sym field.
						*/

						_if( (yyvsp[(0) - (0)].adrs.Type)->Base == NULL )

								yyerror
								( 
									"Dot operator applied to ID w/o fields" 
								);
								exit( 1 );
							
						_else

							(yyval.s) = (yyvsp[(0) - (0)].adrs.Type)->Base->Fields;

						_endif

					_endif

				_elseif( (yyvsp[(0) - (0)].adrs.Type)->pType == tArray )
				
					assert( (yyvsp[(0) - (0)].adrs.Type)->Type != NULL );
					(yyval.s) = (yyvsp[(0) - (0)].adrs.Type)->Type->Fields;
				
					
				_else

					(yyval.s) = (yyvsp[(0) - (0)].adrs.Type)->Fields;

				_endif

				
			_elseif( (yyvsp[(0) - (0)].adrs.Sym) != NULL )
 
				_if( (yyvsp[(0) - (0)].adrs.Sym)->pType == tPointer )

					assert( (yyvsp[(0) - (0)].adrs.Sym)->Base != NULL );
					(yyval.s) = (yyvsp[(0) - (0)].adrs.Sym)->Base->Fields;

				_elseif
				( 
						(yyvsp[(0) - (0)].adrs.Sym)->pType == tArray 
					&&	GetBaseType( (yyvsp[(0) - (0)].adrs.Sym) )->pType == tPointer
				)

					assert( (yyvsp[(0) - (0)].adrs.Sym)->Base != NULL );
					(yyval.s) = (yyvsp[(0) - (0)].adrs.Sym)->Base->Fields;

				_else

					(yyval.s) = (yyvsp[(0) - (0)].adrs.Sym)->Fields;

				_endif

			_else

				(yyval.s) = NULL;

			_endif
			_here;
		;}
    break;

  case 3230:

/* Line 1464 of yacc.c  */
#line 105410 "hlaparse.bsn"
    {				/* $4 */

			_here;
			(yyval.cls.cls) = (yyvsp[(2) - (3)].cls.cls);
			(yyval.cls.sym) = (yyvsp[(2) - (3)].cls.sym);
			(yyval.cls.arity) = (yyvsp[(2) - (3)].cls.arity);
			(yyval.cls.type) = (yyvsp[(2) - (3)].cls.type);
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (3)].cls.ObjectSize);
			_here;
		;}
    break;

  case 3231:

/* Line 1464 of yacc.c  */
#line 105426 "hlaparse.bsn"
    {				/* $5 */

			_here;
			(yyval.cls.cls) = (yyvsp[(3) - (4)].cls.cls);
			(yyval.cls.sym) = (yyvsp[(3) - (4)].cls.sym);
			(yyval.cls.arity) = (yyvsp[(3) - (4)].cls.arity);
			(yyval.cls.type) = (yyvsp[(3) - (4)].cls.type);
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (4)].cls.ObjectSize);
			_here;
		;}
    break;

  case 3232:

/* Line 1464 of yacc.c  */
#line 105441 "hlaparse.bsn"
    {				/* $4 */

			_here;
			(yyval.cls.cls) = (yyvsp[(2) - (3)].cls.cls) & ~cfy_SingleID;
			(yyval.cls.sym) = (yyvsp[(2) - (3)].cls.sym);
			(yyval.cls.arity) = (yyvsp[(2) - (3)].cls.arity);
			(yyval.cls.type) = (yyvsp[(2) - (3)].cls.type);
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (3)].cls.ObjectSize);
			_here;
		;}
    break;

  case 3233:

/* Line 1464 of yacc.c  */
#line 105456 "hlaparse.bsn"
    {				/* $5 */

			_here;
			(yyval.cls.cls) = (yyvsp[(3) - (4)].cls.cls) & ~cfy_SingleID;
			(yyval.cls.sym) = (yyvsp[(3) - (4)].cls.sym);
			(yyval.cls.arity) = (yyvsp[(3) - (4)].cls.arity);
			(yyval.cls.type) = (yyvsp[(3) - (4)].cls.type);
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (4)].cls.ObjectSize);
			_here;
		;}
    break;

  case 3234:

/* Line 1464 of yacc.c  */
#line 105470 "hlaparse.bsn"
    {				/* $4 */

			_here;
			(yyval.cls.cls) = (yyvsp[(2) - (3)].cls.cls) & ~cfy_SingleID;
			(yyval.cls.sym) = (yyvsp[(2) - (3)].cls.sym);
			(yyval.cls.arity) = (yyvsp[(2) - (3)].cls.arity);
			(yyval.cls.type) = (yyvsp[(2) - (3)].cls.type);
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (3)].cls.ObjectSize);
			_here;
		;}
    break;

  case 3235:

/* Line 1464 of yacc.c  */
#line 105485 "hlaparse.bsn"
    {				/* $5 */

			_here;
			(yyval.cls.cls) = (yyvsp[(3) - (4)].cls.cls) & ~cfy_SingleID;
			(yyval.cls.sym) = (yyvsp[(3) - (4)].cls.sym);
			(yyval.cls.arity) = (yyvsp[(3) - (4)].cls.arity);
			(yyval.cls.type) = (yyvsp[(3) - (4)].cls.type);
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (4)].cls.ObjectSize);
			_here;
		;}
    break;

  case 3236:

/* Line 1464 of yacc.c  */
#line 105499 "hlaparse.bsn"
    {				/* $4 */

			_here;
			(yyval.cls.cls) = cfy_Reg8 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= NULL;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 1;
			_here;
		;}
    break;

  case 3237:

/* Line 1464 of yacc.c  */
#line 105514 "hlaparse.bsn"
    {				

			_here;
			(yyval.cls.cls) = cfy_Reg8 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= NULL;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 1;
			_here;
		;}
    break;

  case 3238:

/* Line 1464 of yacc.c  */
#line 105532 "hlaparse.bsn"
    {				/* $8 */

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(4) - (7)].idStr), SymbolTable );
			_if( s == NULL || s->SymClass != cType )

				yyerror( "Expected a type identifier" );
				s = &byte_ste;

			_elseif( s->ObjectSize != 1 )

				yyerror( "Coercion type's size must be one byte" );
				s = &byte_ste;

			_endif
			(yyval.cls.cls) = cfy_Reg8 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= s;
			(yyval.cls.ObjectSize) = s->ObjectSize;
			(yyval.cls.arity) = 0;
			free2( vss (yyvsp[(4) - (7)].idStr) );
			_here;
		;}
    break;

  case 3239:

/* Line 1464 of yacc.c  */
#line 105568 "hlaparse.bsn"
    {				/* $9 */

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(5) - (8)].idStr), SymbolTable );
			_if( s == NULL || s->SymClass != cType )

				yyerror( "Expected a type identifier" );
				s = &byte_ste;

			_elseif( s->ObjectSize != 1 )

				yyerror( "Coercion type's size must be one byte" );
				s = &byte_ste;

			_endif
			(yyval.cls.cls) = cfy_Reg8 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= s;
			(yyval.cls.ObjectSize) = s->ObjectSize;
			(yyval.cls.arity) = 0;
			free2( vss (yyvsp[(5) - (8)].idStr) );
			_here;
		;}
    break;

  case 3240:

/* Line 1464 of yacc.c  */
#line 105598 "hlaparse.bsn"
    {				/* $4 */

			_here;
			(yyval.cls.cls) = cfy_Reg16 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= NULL;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 2;
			_here;
		;}
    break;

  case 3241:

/* Line 1464 of yacc.c  */
#line 105613 "hlaparse.bsn"
    {				

			_here;
			(yyval.cls.cls) = cfy_Reg16 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= NULL;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 2;
			_here;
		;}
    break;

  case 3242:

/* Line 1464 of yacc.c  */
#line 105631 "hlaparse.bsn"
    {				/* $8 */

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(4) - (7)].idStr), SymbolTable );
			_if( s == NULL || s->SymClass != cType )

				yyerror( "Expected a type identifier" );
				s = &word_ste;

			_elseif( s->ObjectSize != 2 )

				yyerror( "Coercion type's size must be two bytes" );
				s = &word_ste;

			_endif
			(yyval.cls.cls) = cfy_Reg16 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= s;
			(yyval.cls.ObjectSize) = s->ObjectSize;
			(yyval.cls.arity) = 0;
			free2( vss (yyvsp[(4) - (7)].idStr) );
			_here;
		;}
    break;

  case 3243:

/* Line 1464 of yacc.c  */
#line 105666 "hlaparse.bsn"
    {				

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(5) - (8)].idStr), SymbolTable );
			_if( s == NULL || s->SymClass != cType )

				yyerror( "Expected a type identifier" );
				s = &word_ste;

			_elseif( s->ObjectSize != 2 )

				yyerror( "Coercion type's size must be two bytes" );
				s = &word_ste;

			_endif
			(yyval.cls.cls) = cfy_Reg16 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= s;
			(yyval.cls.ObjectSize) = s->ObjectSize;
			(yyval.cls.arity) = 0;
			free2( vss (yyvsp[(5) - (8)].idStr) );
			_here;
		;}
    break;

  case 3244:

/* Line 1464 of yacc.c  */
#line 105696 "hlaparse.bsn"
    {				/* $4 */

			_here;
			(yyval.cls.cls) = cfy_Reg32 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= NULL;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 4;
			_here;
		;}
    break;

  case 3245:

/* Line 1464 of yacc.c  */
#line 105711 "hlaparse.bsn"
    {				

			_here;
			(yyval.cls.cls) = cfy_Reg32 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= NULL;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 4;
			_here;
		;}
    break;

  case 3246:

/* Line 1464 of yacc.c  */
#line 105729 "hlaparse.bsn"
    {				/* $8 */

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(4) - (7)].idStr), SymbolTable );
			_if( s == NULL || s->SymClass != cType )

				yyerror( "Expected a type identifier" );
				s = &dword_ste;

			_elseif( s->ObjectSize != 4 )

				yyerror( "Coercion type's size must be four bytes" );
				s = &dword_ste;

			_endif
			(yyval.cls.cls) = cfy_Reg32 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= s;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = s->ObjectSize;
			free2( vss (yyvsp[(4) - (7)].idStr) );
			_here;
		;}
    break;

  case 3247:

/* Line 1464 of yacc.c  */
#line 105764 "hlaparse.bsn"
    {				

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(5) - (8)].idStr), SymbolTable );
			_if( s == NULL || s->SymClass != cType )

				yyerror( "Expected a type identifier" );
				s = &dword_ste;

			_elseif( s->ObjectSize != 4 )

				yyerror( "Coercion type's size must be four bytes" );
				s = &dword_ste;

			_endif
			(yyval.cls.cls) = cfy_Reg32 | cfy_Reg | cfy_BooleanExpr;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= s;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = s->ObjectSize;
			free2( vss (yyvsp[(5) - (8)].idStr) );
			_here;
		;}
    break;

  case 3248:

/* Line 1464 of yacc.c  */
#line 105794 "hlaparse.bsn"
    {				/* $4 */

			_here;
			(yyval.cls.cls) = cfy_fpReg;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= NULL;
			(yyval.cls.ObjectSize) = 10;
			(yyval.cls.arity) = 0;
			_here;
		;}
    break;

  case 3249:

/* Line 1464 of yacc.c  */
#line 105809 "hlaparse.bsn"
    {				/* $5 */

			_here;
			(yyval.cls.cls) = cfy_fpReg;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= NULL;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 10;
			_here;
		;}
    break;

  case 3250:

/* Line 1464 of yacc.c  */
#line 105823 "hlaparse.bsn"
    {				/* $4 */

			_here;
			(yyval.cls.cls) = cfy_mmxReg;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= NULL;
			(yyval.cls.ObjectSize) = 8;
			(yyval.cls.arity) = 0;
			_here;
		;}
    break;

  case 3251:

/* Line 1464 of yacc.c  */
#line 105838 "hlaparse.bsn"
    {				/* $5 */

			_here;
			(yyval.cls.cls) = cfy_mmxReg;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type)= NULL;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 8;
			_here;
		;}
    break;

  case 3252:

/* Line 1464 of yacc.c  */
#line 105864 "hlaparse.bsn"
    {
			_here;
			startUnprocessedID();
			_here;
		;}
    break;

  case 3253:

/* Line 1464 of yacc.c  */
#line 105878 "hlaparse.bsn"
    {
			_here;
			Begin0();
			_here;
		;}
    break;

  case 3254:

/* Line 1464 of yacc.c  */
#line 105898 "hlaparse.bsn"
    {				/* $3 */

			_here;
			setMemoryClassification( YYS &(yyval.cls), (yyvsp[(1) - (2)].idStr) );
			free2( vss (yyvsp[(1) - (2)].idStr) );
			_here;
		;}
    break;

  case 3255:

/* Line 1464 of yacc.c  */
#line 105908 "hlaparse.bsn"
    {				/* $3 */

			_here;
			setMemoryClassification( YYS &(yyval.cls), (yyvsp[(1) - (2)].idStr) );
			free2( vss (yyvsp[(1) - (2)].idStr) );
			_here;
		;}
    break;

  case 3256:

/* Line 1464 of yacc.c  */
#line 105919 "hlaparse.bsn"
    {				/* $4 */

			_here;
			setMemoryClassification( YYS &(yyval.cls), (yyvsp[(1) - (3)].idStr) );
			free2( vss (yyvsp[(1) - (3)].idStr) );
			_here;
		;}
    break;

  case 3257:

/* Line 1464 of yacc.c  */
#line 105929 "hlaparse.bsn"
    {				/* $3 */

			_here;
			setMemoryClassification( YYS &(yyval.cls), (yyvsp[(1) - (2)].idStr) );
			free2( vss (yyvsp[(1) - (2)].idStr) );
			_here;
		;}
    break;

  case 3258:

/* Line 1464 of yacc.c  */
#line 105938 "hlaparse.bsn"
    {

			_here;
			(yyval.cls.cls) = cfy_MemoryExpr | cfy_AnonMem;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = NULL;
			(yyval.cls.ObjectSize) = 1;
			(yyval.cls.arity) = 0;
			_here;
		;}
    break;

  case 3259:

/* Line 1464 of yacc.c  */
#line 105958 "hlaparse.bsn"
    {

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(3) - (6)].idStr), SymbolTable );
			_if( s == NULL )

				yyerror( "Undefined data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (6)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (6)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (6)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->SymClass != cType )

				yyerror( "Expected a data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (6)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (6)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (6)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_else

				(yyval.cls.cls) = (yyvsp[(4) - (6)].cls.cls);
				(yyval.cls.type) = s;
				(yyval.cls.arity) = s->Arity;
				(yyval.cls.sym) = (yyvsp[(4) - (6)].cls.sym);
				(yyval.cls.ObjectSize) = s->ObjectSize;
				_if
				( 
						s->pType == tBoolean 
					||	s->pType == tByte
					||	s->pType == tWord
					||	s->pType == tDWord
				)

					(yyval.cls.cls) |= cfy_BooleanExpr;

				_endif

			_endif
			_here;
		;}
    break;

  case 3260:

/* Line 1464 of yacc.c  */
#line 106012 "hlaparse.bsn"
    {

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(3) - (6)].idStr), SymbolTable );
			_if( s == NULL )

				yyerror( "Undefined data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (6)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (6)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (6)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->SymClass != cType )

				yyerror( "Expected a data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (6)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (6)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (6)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_else

				(yyval.cls.cls) = (yyvsp[(4) - (6)].cls.cls);
				(yyval.cls.type) = s;
				(yyval.cls.arity) = s->Arity;
				(yyval.cls.sym) = (yyvsp[(4) - (6)].cls.sym);
				(yyval.cls.ObjectSize) = s->ObjectSize;
				_if
				( 
						s->pType == tBoolean 
					||	s->pType == tByte
					||	s->pType == tWord
					||	s->pType == tDWord
				)

					(yyval.cls.cls) |= cfy_BooleanExpr;

				_endif

			_endif
			_here;
		;}
    break;

  case 3261:

/* Line 1464 of yacc.c  */
#line 106068 "hlaparse.bsn"
    {

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(3) - (8)].idStr), SymbolTable );
			_if( s == NULL )

				yyerror( "Undefined data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (8)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (8)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (8)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->SymClass != cType )

				yyerror( "Expected a data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (8)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (8)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (8)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->Fields == NULL )
			
				yyerror
				( 
					"Expected a class, record, or union type in coercion operator" 
				);
				(yyval.cls.cls) = (yyvsp[(4) - (8)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (8)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (8)].cls.sym);
				(yyval.cls.ObjectSize) = 1;
		
			_else
			
				SymNode_t *t;

				t = ClassifyLookup( (yyvsp[(7) - (8)].idStr), s->Fields );
				setMemoryClassification_sym( YYS &(yyval.cls), t );
				
				_if
				( 
						s->pType == tBoolean 
					||	s->pType == tByte
					||	s->pType == tWord
					||	s->pType == tDWord
				)

					(yyval.cls.cls) |= cfy_BooleanExpr;

				_endif

			_endif
			_here;
		;}
    break;

  case 3262:

/* Line 1464 of yacc.c  */
#line 106136 "hlaparse.bsn"
    {

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(3) - (8)].idStr), SymbolTable );
			_if( s == NULL )

				yyerror( "Undefined data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (8)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (8)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (8)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->SymClass != cType )

				yyerror( "Expected a data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (8)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (8)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (8)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->Fields == NULL )
			
				yyerror
				( 
					"Expected a class, record, or union type in coercion operator" 
				);
				(yyval.cls.cls) = (yyvsp[(4) - (8)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (8)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (8)].cls.sym);
				(yyval.cls.ObjectSize) = 1;
		
			_else
			
				SymNode_t *t;

				t = ClassifyLookup( (yyvsp[(7) - (8)].idStr), s->Fields );
				setMemoryClassification_sym( YYS &(yyval.cls), t );
				
				_if
				( 
						s->pType == tBoolean 
					||	s->pType == tByte
					||	s->pType == tWord
					||	s->pType == tDWord
				)

					(yyval.cls.cls) |= cfy_BooleanExpr;

				_endif

			_endif
			_here;
		;}
    break;

  case 3263:

/* Line 1464 of yacc.c  */
#line 106202 "hlaparse.bsn"
    {

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(3) - (6)].idStr), SymbolTable );
			_if( s == NULL )

				yyerror( "Undefined data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (6)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (6)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (6)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->SymClass != cType )

				yyerror( "Expected a data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (6)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (6)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (6)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_elseif(( (yyvsp[(4) - (6)].cls.cls) & cfy_MemoryExpr ) == 0 )

				yyerror( "Expected a memory operand" );
				(yyval.cls.cls) = ((yyvsp[(4) - (6)].cls.cls) | cfy_MemoryExpr ) & ~cfy_ConstExpr;
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (6)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (6)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_else

				(yyval.cls.cls) = (yyvsp[(4) - (6)].cls.cls);
				(yyval.cls.type) = s;
				(yyval.cls.arity) = s->Arity;
				(yyval.cls.sym) = (yyvsp[(4) - (6)].cls.sym);
				(yyval.cls.ObjectSize) = s->ObjectSize;
				_if
				( 
						s->pType == tBoolean 
					||	s->pType == tByte
					||	s->pType == tWord
					||	s->pType == tDWord
				)

					(yyval.cls.cls) |= cfy_BooleanExpr;

				_endif

			_endif
			_here;
		;}
    break;

  case 3264:

/* Line 1464 of yacc.c  */
#line 106266 "hlaparse.bsn"
    {

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(3) - (8)].idStr), SymbolTable );
			_if( s == NULL )

				yyerror( "Undefined data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (8)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (8)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (8)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->SymClass != cType )

				yyerror( "Expected a data type in coercion operator" );
				(yyval.cls.cls) = (yyvsp[(4) - (8)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (8)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (8)].cls.sym);
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->Fields == NULL )
			
				yyerror
				( 
					"Expected a class, record, or union type in coercion operator" 
				);
				(yyval.cls.cls) = (yyvsp[(4) - (8)].cls.cls);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = (yyvsp[(4) - (8)].cls.arity);
				(yyval.cls.sym) = (yyvsp[(4) - (8)].cls.sym);
				(yyval.cls.ObjectSize) = 1;
		
			_else
			
				SymNode_t *t;

				t = ClassifyLookup( (yyvsp[(7) - (8)].idStr), s->Fields );
				setMemoryClassification_sym( YYS &(yyval.cls), t );

				_if
				( 
						s->pType == tBoolean 
					||	s->pType == tByte
					||	s->pType == tWord
					||	s->pType == tDWord
				)

					(yyval.cls.cls) |= cfy_BooleanExpr;

				_endif

			_endif
			_here;
		;}
    break;

  case 3268:

/* Line 1464 of yacc.c  */
#line 106355 "hlaparse.bsn"
    {				/* $2 */

			_here;
		;}
    break;

  case 3269:

/* Line 1464 of yacc.c  */
#line 106366 "hlaparse.bsn"
    {				/* $3 */

			_here;
		;}
    break;

  case 3270:

/* Line 1464 of yacc.c  */
#line 106377 "hlaparse.bsn"
    {				/* $3 */

			_here;
		;}
    break;

  case 3271:

/* Line 1464 of yacc.c  */
#line 106388 "hlaparse.bsn"
    {				/* $3 */

			_here;
		;}
    break;

  case 3272:

/* Line 1464 of yacc.c  */
#line 106400 "hlaparse.bsn"
    {				/* $4 */

			_here;
		;}
    break;

  case 3273:

/* Line 1464 of yacc.c  */
#line 106412 "hlaparse.bsn"
    {				/* $4 */

			_here;
		;}
    break;

  case 3274:

/* Line 1464 of yacc.c  */
#line 106424 "hlaparse.bsn"
    {				/* $4 */
			_here;
		;}
    break;

  case 3275:

/* Line 1464 of yacc.c  */
#line 106435 "hlaparse.bsn"
    {				/* $6 */

			int index = (yyvsp[(4) - (5)].v.u.unsval);

			_here;
			_if
			( 
					numBits32( YYS &(yyvsp[(4) - (5)].v) ) > 32
				||	(
							index != 1 
						&&	index != 2
						&&	index != 4
						&&	index != 8
					)
			)

				yyerror( "Illegal scaled index value" );

			_endif
			_here;
		;}
    break;

  case 3276:

/* Line 1464 of yacc.c  */
#line 106466 "hlaparse.bsn"
    {				/* $8 */

			int index = (yyvsp[(4) - (7)].v.u.unsval);

			_here;
			_if
			( 
					numBits32( YYS &(yyvsp[(4) - (7)].v) ) > 32
				||	(
							index != 1 
						&&	index != 2
						&&	index != 4
						&&	index != 8
					)
			)

				yyerror( "Illegal scaled index value" );

			_endif
			_if( ( (yyvsp[(6) - (7)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected a constant expression" );

			_endif
			_here;

		;}
    break;

  case 3277:

/* Line 1464 of yacc.c  */
#line 106503 "hlaparse.bsn"
    {				/* $8 */

			int index = (yyvsp[(4) - (7)].v.u.unsval);

			_here;
			_if
			( 
					numBits32( YYS &(yyvsp[(4) - (7)].v) ) > 32
				||	(
							index != 1 
						&&	index != 2
						&&	index != 4
						&&	index != 8
					)
			)

				yyerror( "Illegal scaled index value" );

			_endif
			_if( ( (yyvsp[(6) - (7)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected a constant expression" );

			_endif
			_here;
		;}
    break;

  case 3278:

/* Line 1464 of yacc.c  */
#line 106545 "hlaparse.bsn"
    {				/* $4 */

			_here;
		;}
    break;

  case 3279:

/* Line 1464 of yacc.c  */
#line 106555 "hlaparse.bsn"
    {				/* $6 */

			_here;
			_if( ( (yyvsp[(4) - (5)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected a constant expression" );

			_endif
		;}
    break;

  case 3280:

/* Line 1464 of yacc.c  */
#line 106570 "hlaparse.bsn"
    {				/* $6 */

			_here;
			_if( ( (yyvsp[(4) - (5)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected a constant expression" );

			_endif
		;}
    break;

  case 3281:

/* Line 1464 of yacc.c  */
#line 106587 "hlaparse.bsn"
    {				/* $8 */
			_here;
		;}
    break;

  case 3283:

/* Line 1464 of yacc.c  */
#line 106597 "hlaparse.bsn"
    {				/* $3 */

			int index = (yyvsp[(2) - (2)].v.u.unsval);

			_here;
			_if
			( 
					numBits32( YYS &(yyvsp[(2) - (2)].v) ) > 32
				||	(
							index != 1 
						&&	index != 2
						&&	index != 4
						&&	index != 8
					)
			)

				yyerror( "Illegal scaled index value" );

			_endif
			_here;
		;}
    break;

  case 3285:

/* Line 1464 of yacc.c  */
#line 106625 "hlaparse.bsn"
    {				/* $3 */

			_here;
			_if( ( (yyvsp[(2) - (2)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected a constant expression" );

			_endif

		;}
    break;

  case 3286:

/* Line 1464 of yacc.c  */
#line 106638 "hlaparse.bsn"
    {				/* $3 */

			_here;
			_if( ( (yyvsp[(2) - (2)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected a constant expression" );

			_endif

		;}
    break;

  case 3287:

/* Line 1464 of yacc.c  */
#line 106657 "hlaparse.bsn"
    {				/* $4 */

			_here;
			_if( ( (yyvsp[(2) - (3)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected a constant expression" );

			_endif
		;}
    break;

  case 3288:

/* Line 1464 of yacc.c  */
#line 106691 "hlaparse.bsn"
    {				/* $5 */

			SymNode_t *s;

			_here;
			setClassification( YYS &(yyval.cls), (yyvsp[(1) - (4)].idStr) );
			_if( ( (yyvsp[(3) - (4)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected a constant expression" );

			_endif
			_if( (yyval.cls.cls) & cfy_IsArray )

				_if( (yyval.cls.cls) & cfy_ConstExpr )

					/*
					** Okay, it's a constant and it's an array.
					** We've got to look this symbol up in order
					** to determine it's arity.  This will tell
					** us whether applying an index to it still
					** produces an array.
					*/
						
					_if(( (yyval.cls.sym) == NULL ) || ( (yyval.cls.sym)->Arity <= 1 ))					

						unArray( YYS &(yyval.cls) );
						(yyval.cls.arity) = (yyval.cls.arity) - 1;

					_endif

				_else

					/*
					** It's probably a memory object.  Regardless, it's
					** not a constant so drop the array classification.
					*/

					unArray( YYS &(yyval.cls) );
					(yyval.cls.arity) = 0;

				_endif

			_endif

			/*
			** This isn't a single ID, so clear that bit if set.
			*/

			(yyval.cls.cls) &= ~cfy_SingleID;
			free2( vss (yyvsp[(1) - (4)].idStr) );
			_here;
		;}
    break;

  case 3289:

/* Line 1464 of yacc.c  */
#line 106753 "hlaparse.bsn"
    {				/* $6 */

			SymNode_t *s;

			_here;
			setClassification( YYS &(yyval.cls), (yyvsp[(1) - (5)].idStr) );
			_if( ( (yyvsp[(3) - (5)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected a constant expression" );

			_endif
			_if( (yyval.cls.cls) & cfy_IsArray )

				_if( (yyval.cls.cls) & cfy_ConstExpr )

					/*
					** Okay, it's a constant and it's an array.
					** We've got to look this symbol up in order
					** to determine it's arity.  This will tell
					** us whether applying an index to it still
					** produces an array.
					*/
						
					_if
					(
							( (yyval.cls.sym) == NULL ) 
						||	( (yyval.cls.sym)->Arity <= ((yyvsp[(4) - (5)].cls.arity) + 1) ))					

						unArray( YYS &(yyval.cls) );
						(yyval.cls.arity) = (yyval.cls.arity) - (yyvsp[(4) - (5)].cls.arity) - 1;

					_endif

				_else

					/*
					** It's probably a memory object.  Regardless, it's
					** not a constant so drop the array classification.
					*/

					unArray( YYS &(yyval.cls) );
					(yyval.cls.arity) = 0;

				_endif

			_endif

			/*
			** This isn't a single ID, so clear that bit if set.
			*/

			(yyval.cls.cls) &= ~cfy_SingleID;
			free2( vss (yyvsp[(1) - (5)].idStr) );
			_here;
		;}
    break;

  case 3290:

/* Line 1464 of yacc.c  */
#line 106814 "hlaparse.bsn"
    {					/* $3 */

			_here;
			_if(( (yyvsp[(2) - (2)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Array index/element must be a constant expression" );

			_endif
			(yyval.cls.cls) = (yyvsp[(2) - (2)].cls.cls);
			(yyval.cls.sym) = (yyvsp[(2) - (2)].cls.sym);
			(yyval.cls.arity) = 1;
			(yyval.cls.ObjectSize) = 1;
		;}
    break;

  case 3291:

/* Line 1464 of yacc.c  */
#line 106831 "hlaparse.bsn"
    {
			_here;
			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(2) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_if(( (yyvsp[(2) - (3)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Array index/element must be a constant expression" );

			_endif
			(yyval.cls.arity) = (yyvsp[(3) - (3)].cls.arity) + 1;
		;}
    break;

  case 3292:

/* Line 1464 of yacc.c  */
#line 106849 "hlaparse.bsn"
    {

			_here;

			setClassification( YYS &(yyval.cls), (yyvsp[(1) - (1)].idStr) );
			(yyval.cls.cls) |= cfy_SingleID;
			_if
			(
					(yyval.cls.sym) != NULL
				&&	(
							(yyval.cls.sym)->pType == tBoolean 
						||	(yyval.cls.sym)->pType == tByte
						||	(yyval.cls.sym)->pType == tWord
						||	(yyval.cls.sym)->pType == tDWord
					)
			)

				(yyval.cls.cls) |= cfy_BooleanExpr;

			_endif
			
			/*
			** Should free $<idStr>1 here, but somebody else
			** seems to be doing it and doing so here crashes
			** the system.  A memory leak is better than a
			** crash, so I removed the following call (could
			** not trace down the cause of this problem).
			**
			** free2( $<idStr>1 );
			*/

			_here;
		;}
    break;

  case 3293:

/* Line 1464 of yacc.c  */
#line 106888 "hlaparse.bsn"
    {				/* $4 */
			_here;
			_if(( (yyvsp[(2) - (3)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected a constant expression" );

			_endif
			(yyval.cls.cls) = (yyvsp[(2) - (3)].cls.cls) & ~cfy_SingleID;
			(yyval.cls.sym) = (yyvsp[(2) - (3)].cls.sym);
			(yyval.cls.type) = (yyvsp[(2) - (3)].cls.type);
			(yyval.cls.arity) = (yyvsp[(2) - (3)].cls.arity);
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (3)].cls.ObjectSize);
			_here; 
		;}
    break;

  case 3294:

/* Line 1464 of yacc.c  */
#line 106907 "hlaparse.bsn"
    {				/* $3 */

			SymNode_t *s;

			_here;
			setClassification( YYS &(yyval.cls), (yyvsp[(2) - (2)].idStr) );
			(yyval.cls.type) = &pointer_ste;
			(yyval.cls.ObjectSize) = 4;
			(yyval.cls.arity) = 0;
			_if(( (yyval.cls.cls) & cfy_Undefined )  == 0 )

				assert( (yyval.cls.sym) != NULL );

				_if( !CanBePtrConst( (yyval.cls.sym)->SymClass ) ) 

					yyerror
					(
						"'&' operator must be followed by a static object" 
					);

				_else

					_if( StaticProc( (yyval.cls.sym)->SymClass ))

						(yyval.cls.cls) |= cfy_IsProcPtr;

					_endif

				_endif

			_endif
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst | cfy_IsPointer;
			free2( vss (yyvsp[(2) - (2)].idStr) );
			_here;
		;}
    break;

  case 3295:

/* Line 1464 of yacc.c  */
#line 106946 "hlaparse.bsn"
    {
			_here;
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = (yyvsp[(1) - (1)].v.Type);
			(yyval.cls.ObjectSize) = (yyvsp[(1) - (1)].v.ObjectSize);
			(yyval.cls.arity) = 0;
			_here;
		;}
    break;

  case 3296:

/* Line 1464 of yacc.c  */
#line 106959 "hlaparse.bsn"
    {				/* $2 */

			_here;
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = (yyvsp[(1) - (1)].v.Type);
			(yyval.cls.ObjectSize) = (yyvsp[(1) - (1)].v.ObjectSize);
			(yyval.cls.arity) = 0;
			_here;
		;}
    break;

  case 3297:

/* Line 1464 of yacc.c  */
#line 106974 "hlaparse.bsn"
    {				/* $2 */

			_here;
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = (yyvsp[(1) - (1)].v.Type);
			(yyval.cls.ObjectSize) = (yyvsp[(1) - (1)].v.ObjectSize);
			(yyval.cls.arity) = 0;
			_here;
		;}
    break;

  case 3298:

/* Line 1464 of yacc.c  */
#line 106988 "hlaparse.bsn"
    {				/* $2 */

			_here;
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = (yyvsp[(1) - (1)].v.Type);
			(yyval.cls.ObjectSize) = (yyvsp[(1) - (1)].v.ObjectSize);
			(yyval.cls.arity) = 0;
			_here;
		;}
    break;

  case 3299:

/* Line 1464 of yacc.c  */
#line 107003 "hlaparse.bsn"
    {				/* $2 */

			_here;
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = &char_ste;
			(yyval.cls.ObjectSize) = 1;
			(yyval.cls.arity) = 0;
			_here;
		;}
    break;

  case 3300:

/* Line 1464 of yacc.c  */
#line 107018 "hlaparse.bsn"
    {				/* $2 */

			_here;
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = &wchar_ste;
			(yyval.cls.ObjectSize) = 2;
			(yyval.cls.arity) = 0;
			_here;
		;}
    break;

  case 3301:

/* Line 1464 of yacc.c  */
#line 107033 "hlaparse.bsn"
    {				/* $2 */

			_here;
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = &string_ste;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 4;
			FreeValue( YYS &(yyvsp[(1) - (1)].v) );
			_here;
		;}
    break;

  case 3302:

/* Line 1464 of yacc.c  */
#line 107049 "hlaparse.bsn"
    {				/* $2 */

			_here;
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = &wstring_ste;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 4;
			FreeValue( YYS &(yyvsp[(1) - (1)].v) );
			_here;
		;}
    break;

  case 3303:

/* Line 1464 of yacc.c  */
#line 107065 "hlaparse.bsn"
    {				/* $2 */

			_here;
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = &pointer_ste;
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = 4;
			_here;
		;}
    break;

  case 3304:

/* Line 1464 of yacc.c  */
#line 107086 "hlaparse.bsn"
    {				/* $8 */

			_here;
			memcpy( &GlobalCset, &(yyvsp[(2) - (7)].v.u.csetval), CSetSizeInBytes );
			(yyval.cls.cls) = cfy_ConstExpr | cfy_LiteralConst;
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = &cset_ste;
			(yyval.cls.ObjectSize) = CSetSizeInBytes;
			(yyval.cls.arity) = 0;
			_here;
		;}
    break;

  case 3305:

/* Line 1464 of yacc.c  */
#line 107104 "hlaparse.bsn"
    {				/* $4 */

			_here;
			_if(( (yyvsp[(2) - (3)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected constant expression as array element" );

			_endif
			(yyval.cls.sym) = NULL;
			(yyval.cls.type) = (yyvsp[(2) - (3)].cls.type);
			(yyval.cls.arity) = 1;		
			(yyval.cls.ObjectSize) = 4;
			(yyval.cls.cls) = 
					cfy_Undefined	
				|	cfy_LiteralConst
				|	cfy_ConstExpr	
				|	cfy_IsArray;

			_here;
		;}
    break;

  case 3306:

/* Line 1464 of yacc.c  */
#line 107132 "hlaparse.bsn"
    {				/* $5 */

			_here;
			_if(( (yyvsp[(2) - (4)].cls.cls) & cfy_ConstExpr ) == 0 )

				yyerror( "Expected constant expression as array element" );

			_endif
			(yyval.cls.sym) = NULL;		
			(yyval.cls.type) = MakeAnyCompat( YYS &(yyvsp[(2) - (4)].cls), YYS &(yyvsp[(3) - (4)].cls) );
			(yyval.cls.arity) = 1;		
			(yyval.cls.ObjectSize) = 
				_ifx
				( 
					(yyvsp[(2) - (4)].cls.ObjectSize) > (yyvsp[(3) - (4)].cls.ObjectSize),
					(yyvsp[(2) - (4)].cls.ObjectSize),
					(yyvsp[(3) - (4)].cls.ObjectSize)
				);

			(yyval.cls.cls) = 
					cfy_Undefined	
				|	cfy_LiteralConst
				|	cfy_ConstExpr	
				|	cfy_IsArray;

			_here;
		;}
    break;

  case 3307:

/* Line 1464 of yacc.c  */
#line 107169 "hlaparse.bsn"
    {				/* $7 */

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(1) - (6)].idStr), SymbolTable );
			_if( s == NULL || s->pType != tRecord || s->SymClass != cType )

				yyerror( "Expected record type name" );
				(yyval.cls.cls) = cfy_Undefined | cfy_ConstExpr | cfy_IsRecord;
				(yyval.cls.sym) = NULL;
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = 0;
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->FieldCnt !=	( (yyvsp[(5) - (6)].cls.arity) + 1) )

				yyerror( "Fields do not agree with record type" );
				(yyval.cls.cls) = cfy_ConstExpr | cfy_IsRecord;
				(yyval.cls.sym) = s;
				(yyval.cls.type) = s->Type;
				(yyval.cls.arity) = 0;
				(yyval.cls.ObjectSize) = 1;

			_else

				(yyval.cls.sym) = s;
				(yyval.cls.type) = s->Type;
				(yyval.cls.ObjectSize) = s->ObjectSize;
				(yyval.cls.arity) = 0;
				(yyval.cls.cls) = cfy_ConstExpr | cfy_IsRecord | cfy_LiteralConst;

			_endif
			_here;
		;}
    break;

  case 3308:

/* Line 1464 of yacc.c  */
#line 107213 "hlaparse.bsn"
    {				/* $7 */

			SymNode_t *s;

			_here;
			s = ClassifyLookup( (yyvsp[(1) - (5)].idStr), SymbolTable );
			_if( s == NULL || s->pType != tRecord || s->SymClass != cType )

				yyerror( "Expected record type name" );
				(yyval.cls.cls) = cfy_Undefined | cfy_ConstExpr | cfy_IsRecord;
				(yyval.cls.sym) = NULL;
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = 0;
				(yyval.cls.ObjectSize) = 1;

			_elseif( s->FieldCnt !=	1 )

				yyerror( "Fields do not agree with record type" );
				(yyval.cls.cls) = cfy_ConstExpr | cfy_IsRecord;
				(yyval.cls.sym) = s;
				(yyval.cls.type) = s->Type;
				(yyval.cls.arity) = 0;
				(yyval.cls.ObjectSize) = 1;

			_else

				(yyval.cls.sym) = s;
				(yyval.cls.cls) = cfy_ConstExpr | cfy_IsRecord | cfy_LiteralConst;
				(yyval.cls.type) = s->Type;
				(yyval.cls.arity) = 0;
				(yyval.cls.ObjectSize) = s->ObjectSize;

			_endif
			_here;
		;}
    break;

  case 3309:

/* Line 1464 of yacc.c  */
#line 107253 "hlaparse.bsn"
    {

			_here;
			(yyval.cls.cls) = (yyvsp[(2) - (2)].cls.cls);
			_if(( (yyvsp[(2) - (2)].cls.cls) & cfy_ConstExpr ) == 0 ) 

				yyerror( "Constant expressions require constant operands" );
				(yyval.cls.cls) &= ~(cfy_MemoryExpr | cfy_AnonMem);
				(yyval.cls.cls) |= cfy_ConstExpr;

			_endif
			(yyval.cls.sym) = (yyvsp[(2) - (2)].cls.sym);
			assert( (yyvsp[(2) - (2)].cls.type) != NULL );
			_switch( (yyvsp[(2) - (2)].cls.type)->pType )

				_case( tInt8 )

					(yyval.cls.type) = &uns8_ste;

				_endcase


				_case( tInt16 )

					(yyval.cls.type) = &uns16_ste;

				_endcase


				_case( tInt32 )

					(yyval.cls.type) = &uns32_ste;

				_endcase


				_case( tInt64 )

					(yyval.cls.type) = &uns64_ste;

				_endcase


				_case( tInt128 )

					(yyval.cls.type) = &uns128_ste;

				_endcase





				_case( tUns8 )

					(yyval.cls.type) = &int8_ste;

				_endcase


				_case( tUns16 )

					(yyval.cls.type) = &int16_ste;

				_endcase


				_case( tUns32 )

					(yyval.cls.type) = &int32_ste;

				_endcase


				_case( tUns64 )

					(yyval.cls.type) = &int64_ste;

				_endcase


				_case( tUns128 )

					(yyval.cls.type) = &int128_ste;

				_endcase




				_default
					(yyval.cls.type) = (yyvsp[(2) - (2)].cls.type);

			_endswitch
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (2)].cls.ObjectSize);
			_here;
		;}
    break;

  case 3310:

/* Line 1464 of yacc.c  */
#line 107357 "hlaparse.bsn"
    {

			_here;
			(yyval.cls.cls) = (yyvsp[(2) - (2)].cls.cls);
			_if( ((yyvsp[(2) - (2)].cls.cls) & cfy_ConstExpr ) == 0 ) 

				yyerror( "Constant expressions require constant operands" );
				(yyval.cls.cls) &= ~(cfy_MemoryExpr | cfy_AnonMem);
				(yyval.cls.cls) |= cfy_ConstExpr;

			_endif
			(yyval.cls.sym) = (yyvsp[(2) - (2)].cls.sym);			
			(yyval.cls.type) = (yyvsp[(2) - (2)].cls.type);
			(yyval.cls.arity) = 0;
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (2)].cls.ObjectSize);
		;}
    break;

  case 3311:

/* Line 1464 of yacc.c  */
#line 107380 "hlaparse.bsn"
    {

			_here;
			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_here;
		;}
    break;

  case 3312:

/* Line 1464 of yacc.c  */
#line 107393 "hlaparse.bsn"
    {

			_here;
			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_here;
		;}
    break;

  case 3313:

/* Line 1464 of yacc.c  */
#line 107406 "hlaparse.bsn"
    {

			_here;
			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_here;
		;}
    break;

  case 3314:

/* Line 1464 of yacc.c  */
#line 107419 "hlaparse.bsn"
    {

			_here;
			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_here;
		;}
    break;

  case 3315:

/* Line 1464 of yacc.c  */
#line 107432 "hlaparse.bsn"
    {

			_here;
			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_here;
		;}
    break;

  case 3316:

/* Line 1464 of yacc.c  */
#line 107445 "hlaparse.bsn"
    {

			_here;
			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_here;
		;}
    break;

  case 3317:

/* Line 1464 of yacc.c  */
#line 107458 "hlaparse.bsn"
    {

			_here;
			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_here;
		;}
    break;

  case 3318:

/* Line 1464 of yacc.c  */
#line 107472 "hlaparse.bsn"
    {

			_here;
			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_here;
		;}
    break;

  case 3319:

/* Line 1464 of yacc.c  */
#line 107485 "hlaparse.bsn"
    {

			_here;
			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_here;
		;}
    break;

  case 3320:

/* Line 1464 of yacc.c  */
#line 107498 "hlaparse.bsn"
    {

			_here;

			CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );
			_here;
		;}
    break;

  case 3321:

/* Line 1464 of yacc.c  */
#line 107513 "hlaparse.bsn"
    {				/* $4 */

			_here;
			_if(( (yyvsp[(1) - (3)].cls.cls) & cfy_ConstExpr ) != 0 )

				CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );

			_else

				_if
				(
						( (yyvsp[(1) - (3)].cls.cls) & cfy_MemoryExpr ) != 0 
					&&	( (yyvsp[(3) - (3)].cls.cls) & cfy_ConstExpr ) != 0
				)

					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_else

					yyerror( "Illegal boolean expression syntax" );
					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_endif

			_endif
			(yyval.cls.ObjectSize) = 1;
			_here;
		;}
    break;

  case 3322:

/* Line 1464 of yacc.c  */
#line 107556 "hlaparse.bsn"
    {

			_here;
			_if(( (yyvsp[(1) - (3)].cls.cls) & cfy_ConstExpr ) != 0 )

				CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );

			_else

				_if
				(
						( (yyvsp[(1) - (3)].cls.cls) & cfy_MemoryExpr ) != 0 
					&&	( (yyvsp[(3) - (3)].cls.cls) & cfy_ConstExpr ) != 0
				)

					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_else

					yyerror( "Illegal boolean expression syntax" );
					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_endif

			_endif
			(yyval.cls.ObjectSize) = 1;
			_here;
		;}
    break;

  case 3323:

/* Line 1464 of yacc.c  */
#line 107599 "hlaparse.bsn"
    {

			_here;
			_if(( (yyvsp[(1) - (3)].cls.cls) & cfy_ConstExpr ) != 0 )

				CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );

			_else

				_if
				(
						( (yyvsp[(1) - (3)].cls.cls) & cfy_MemoryExpr ) != 0 
					&&	( (yyvsp[(3) - (3)].cls.cls) & cfy_ConstExpr ) != 0
				)

					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_else

					yyerror( "Illegal boolean expression syntax" );
					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_endif

			_endif
			(yyval.cls.ObjectSize) = 1;
			_here;
		;}
    break;

  case 3324:

/* Line 1464 of yacc.c  */
#line 107640 "hlaparse.bsn"
    {

			_here;
			_if(( (yyvsp[(1) - (3)].cls.cls) & cfy_ConstExpr ) != 0 )

				CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );

			_else

				_if
				(
						( (yyvsp[(1) - (3)].cls.cls) & cfy_MemoryExpr ) != 0 
					&&	( (yyvsp[(3) - (3)].cls.cls) & cfy_ConstExpr ) != 0
				)

					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_else

					yyerror( "Illegal boolean expression syntax" );
					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_endif

			_endif
			(yyval.cls.ObjectSize) = 1;
			_here;
		;}
    break;

  case 3325:

/* Line 1464 of yacc.c  */
#line 107681 "hlaparse.bsn"
    {

			_here;
			_if(( (yyvsp[(1) - (3)].cls.cls) & cfy_ConstExpr ) != 0 )

				CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );

			_else

				_if
				(
						( (yyvsp[(1) - (3)].cls.cls) & cfy_MemoryExpr ) != 0 
					&&	( (yyvsp[(3) - (3)].cls.cls) & cfy_ConstExpr ) != 0
				)

					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_else

					yyerror( "Illegal boolean expression syntax" );
					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_endif

			_endif
			(yyval.cls.ObjectSize) = 1;
			_here;
		;}
    break;

  case 3326:

/* Line 1464 of yacc.c  */
#line 107722 "hlaparse.bsn"
    {

			_here;
			_if(( (yyvsp[(1) - (3)].cls.cls) & cfy_ConstExpr ) != 0 )

				CombineAttrs( YYS &(yyval.cls), YYS &(yyvsp[(1) - (3)].cls), YYS &(yyvsp[(3) - (3)].cls) );

			_else

				_if
				(
						( (yyvsp[(1) - (3)].cls.cls) & cfy_MemoryExpr ) != 0 
					&&	( (yyvsp[(3) - (3)].cls.cls) & cfy_ConstExpr ) != 0
				)

					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_else

					yyerror( "Illegal boolean expression syntax" );
					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_endif

			_endif
			(yyval.cls.ObjectSize) = 1;
			_here;
		;}
    break;

  case 3327:

/* Line 1464 of yacc.c  */
#line 107764 "hlaparse.bsn"
    {

			_here;
			_if(( (yyvsp[(1) - (3)].cls.cls) & cfy_ConstExpr ) != 0 )

				(yyval.cls.cls) = (yyvsp[(1) - (3)].cls.cls);
				(yyval.cls.sym) = (yyvsp[(1) - (3)].cls.sym);
				(yyval.cls.type) = &boolean_ste;
				(yyval.cls.arity) = 0;

			_else

				_if
				(
						( (yyvsp[(1) - (3)].cls.cls) & cfy_MemoryExpr ) != 0 
					&&	( (yyvsp[(3) - (3)].cls.cls) & cfy_ConstExpr ) != 0
				)

					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_else

					yyerror( "Illegal boolean expression syntax" );
					(yyval.cls.cls) = cfy_BooleanExpr;
					(yyval.cls.sym) = NULL;
					(yyval.cls.type) = NULL;
					(yyval.cls.arity) = 0;

				_endif

			_endif
			(yyval.cls.ObjectSize) = 1;
			_here;
		;}
    break;

  case 3328:

/* Line 1464 of yacc.c  */
#line 107814 "hlaparse.bsn"
    {				/* $5 */

			_if
			(
					_strne( (yyvsp[(1) - (4)].idStr), "boolean" )

				&&	_strne( (yyvsp[(1) - (4)].idStr), "uns8" )
				&&	_strne( (yyvsp[(1) - (4)].idStr), "uns16" )
				&&	_strne( (yyvsp[(1) - (4)].idStr), "uns32" )

				&&	_strne( (yyvsp[(1) - (4)].idStr), "byte" )
				&&	_strne( (yyvsp[(1) - (4)].idStr), "word" )
				&&	_strne( (yyvsp[(1) - (4)].idStr), "dword" )

				&&	_strne( (yyvsp[(1) - (4)].idStr), "int8" )
				&&	_strne( (yyvsp[(1) - (4)].idStr), "int16" )
				&&	_strne( (yyvsp[(1) - (4)].idStr), "int32" )

				&&	_strne( (yyvsp[(1) - (4)].idStr), "real32" )
				&&	_strne( (yyvsp[(1) - (4)].idStr), "real64" )
				&&	_strne( (yyvsp[(1) - (4)].idStr), "real80" )

				&&	_strne( (yyvsp[(1) - (4)].idStr), "char" )
				&&	_strne( (yyvsp[(1) - (4)].idStr), "string" )
				&&	_strne( (yyvsp[(1) - (4)].idStr), "cset" )
			)

				yyerror
				( 
					"Constant type coercion operation must have\n"
					"a primitive type name (e.g., 'byte')"
				);
				(yyval.cls.cls) = (yyvsp[(3) - (4)].cls.cls);
				(yyval.cls.sym) = (yyvsp[(3) - (4)].cls.sym);
				(yyval.cls.type) = NULL;
				(yyval.cls.arity) = 0;
				(yyval.cls.ObjectSize) = 1;

			_else

				(yyval.cls.cls) = (yyvsp[(3) - (4)].cls.cls);
				(yyval.cls.sym) = (yyvsp[(3) - (4)].cls.sym);
				(yyval.cls.type) = lookup( (yyvsp[(1) - (4)].idStr), 1 );
				(yyval.cls.arity) = 0;
				(yyval.cls.ObjectSize) = (yyval.cls.type)->ObjectSize;

			_endif

		;}
    break;

  case 3329:

/* Line 1464 of yacc.c  */
#line 107871 "hlaparse.bsn"
    {

			_here;
			(yyval.cls.sym) = NULL;
			(yyval.cls.cls) = cfy_ConstExpr;
			(yyval.cls.arity) = 0;
			_if( (yyvsp[(2) - (3)].v.pType) == tArray )

				(yyval.cls.cls) |= cfy_IsArray;
				(yyval.cls.arity) = (yyvsp[(2) - (3)].v.Arity);

			_elseif( (yyvsp[(2) - (3)].v.pType) == tRecord )

				(yyval.cls.cls) |= cfy_IsRecord;

			_endif
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (3)].v.Type)->ObjectSize;
			FreeValue( YYS &(yyvsp[(2) - (3)].v) );
			_here;
		;}
    break;

  case 3330:

/* Line 1464 of yacc.c  */
#line 107901 "hlaparse.bsn"
    {

			_here;
			(yyval.cls.sym) = NULL;
			(yyval.cls.cls) = cfy_ConstExpr;
			(yyval.cls.arity) = 0;
			(yyval.cls.type) = (yyvsp[(2) - (6)].v.Type);
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (6)].v.Type)->ObjectSize;
			FreeValue( YYS &(yyvsp[(4) - (6)].v) );
			_here;
		;}
    break;

  case 3331:

/* Line 1464 of yacc.c  */
#line 107919 "hlaparse.bsn"
    {

			_here;
			(yyval.cls.sym) = NULL;
			(yyval.cls.cls) = cfy_ConstExpr;
			(yyval.cls.arity) = 0;
			_if( (yyvsp[(2) - (3)].v.pType) == tArray )

				(yyval.cls.cls) |= cfy_IsArray;
				(yyval.cls.arity) = (yyvsp[(2) - (3)].v.Arity);

			_elseif( (yyvsp[(2) - (3)].v.pType) == tRecord )

				(yyval.cls.cls) |= cfy_IsRecord;

			_endif
			(yyval.cls.ObjectSize) = (yyvsp[(2) - (3)].v.Type)->ObjectSize;
			FreeValue( YYS &(yyvsp[(2) - (3)].v) );
			_here;
		;}
    break;



/* Line 1464 of yacc.c  */
#line 134744 "hlaparse.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 107945 "hlaparse.bsn"





static void
ExpectedOrdinalConst( void )
_begin( ExpectedOrdinalConst )

	yyerror( "Expected an ordinal constant" );

_end( ExpectedOrdinalConst )



void
ConstTooBig( void )
_begin( ConstTooBig )

	yyerror( "Constant expression is out of range for specified operand" );

_end( ConstTooBig )


void
SizeMismatch( void )
_begin( SizeMismatch )

	yyerror( "Operand size mismatch" );

_end( SizeMismatch )



static void
PressReturnToContinue(void)
_begin( PressReturnToContinue )

	char dummy[16];
	_if( MsgOut == stderr )
	
		fprintf( MsgOut, "\nPress the enter key to continue:" );
		fgets( dummy, 8, stdin );
		fprintf( MsgOut, "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n" );

	_endif
	
_end( PressReturnToContinue )


static void
Usage( void )
_begin( Usage )

	fprintf
	(
		MsgOut,
		"Usage: hlaparse options filename\n"
		"\n"
		"HLA (High Level Assembler)\n"
		"%s\n"
		"\n"
		" options:\n"
		"  -license Display license information\n"
		"  -@       Do not create linker response file.\n"
		"  -@@      Force creation of new linker response file.\n"
		"  -dXXXX   Defines XXXX as \"?XXXX:boolean := true;\"\n"
		"  -dxx=yy  Defines XX as \"?XX:string:=YY;\"\n"
		"  -pXXXX   Output path for .asm/.inc/.link files "
		"  -sh      Produce pseudo-HLA ASM output file.\n"
		"  -sg      Produce GAS compatible ASM output file.\n"
		"  -sx      Produce Mac OSX GAS compatible ASM output file.\n"
		"  -st      Produce TASM compatible ASM output file.\n"
		"  -sm      Produce MASM compatible ASM output file.\n"
		"  -sf      Produce FASM compatible ASM output file.\n"
		"  -sn      Produce NASM compatible ASM output file.\n"
		"  -source  Produce instruction translation (rather than hex output)\n"
		"  -obj:XX  Output path for coff/elf object files.\n"
		"  -win32   Generate COFF file for Win32 OS.\n"
		"  -linux   Generate ELF file for Linux OS.\n"
		"  -freebsd Generate ELF file for freeBSD OS.\n"
		"  -macos   Generate Mach-o file for Mac OSX.\n"
		"  -sym     Dump symbol table after compile.\n"
		"  -test    Send diagnostic info to stdout rather than stderr\n"
		"  -v       Verbose compile.\n"
		"  -?       Display this help message.\n\n"
		"  -level=high     Full HLA language (default)\n"
		"  -level=medium   Disables HLL control constructs\n"
		"  -level=low      Disables HL-like procedure calls\n"
		"  -level=machine  Disable exception handling constructs\n"
		"  -main:xxxx      Names the main program 'xxxx' (default='start')",
		VersionInformation
	);

_end( Usage )


static void
License( void )
_begin( License )

	fprintf
	(
		MsgOut,
		"\n\n\n"
		"*******************************************************\n"
		"*                                                     *\n"
		"*              HLA License Information                *\n"
		"*                                                     *\n"
		"*******************************************************\n"
		"\n"
		"The HLA shell program ('HLA.EXE' under Windows, 'hla'\n"
		"under other operating systems) is open source and public\n"
		"domain. You may do anything you like with this code,\n"
		"without restriction. Here is the official license code\n"
		"for HLA public domain components:\n"
		"\n"

"I, Randall Hyde, hereby agree to waive all claim of copyright (economic \n"
"and moral) in all content contributed by me, the user, and immediately	 \n"
"place any and all contributions by me into the public domain; I grant	 \n"
"anyone the right to use my work for any purpose, without any			 \n"
"conditions, to be changed or destroyed in any manner whatsoever		 \n"
"without any attribution or notice to the creator.  I also absolve myself\n"
"of any responsibility for the use of this code, the user assumes all	 \n"
"responsibilities for using this software in an appropriate manner.		 \n"
"																		 \n"
"Notice of declaration of public domain, 3/2/2007, by Randall Hyde		 \n"
"\n"
		"You can assume that all HLA sample programs written by\n"
		"Randall Hyde and distributed as part of the HLA system\n"
		"are public domain (governed by the public domain \n"
		"declaration given earlier). You are free to use those\n"
		"sample programs in part or in whole as you desire.\n"
		"The HLA Standard Library source code is also public\n"
		"domain and you may use that code in any manner you\n"
		"see fit.\n"
	);
		
_end( License )



void
SetSeg( char* src, char* dest, char* defaultStr )
_begin( SetSeg )

	_here;
	_if( strlen( src ) == 0 || *src == '.' )

		strcpy( dest, defaultStr );

	_elseif( stricmp( src, "_text" ) == 0 )

		strcpy( dest, ".text" );

	_elseif( stricmp(src, "_data" ) == 0 )
	
		strcpy( dest, ".data" );
		
	_elseif( stricmp( src, "_bss" ) == 0 )
	
		strcpy( dest, ".bss" );
		
	_elseif( stricmp( src, "CONST" ) == 0 )
	
		strcpy( dest, ".text" );
		
	_else
	
		strcpy( dest, src );
		
	_endif 

_end( SetSeg )



// A cheesy "file exists" function

int
fexists( char *filename )
_begin( fexists )

	FILE *f;
	
	f = fopen( filename, "r" );
	_if( f != NULL )
	
		fclose( f );
		
	_endif
	_return f != NULL;

_end( fexists )



int
main( int argc, char *argv[] )
_begin( main )

	int				ResponseFile = 1;	// Generate linker response file.
	FILE			*linkOut;			// ".link" output file pointer.
	struct segmentList_t *s;			// Used when creating the ".link" file.
	struct	timeb	CompileTimeStart;	// Measure the compile time.
	char 			option[256];		// Hold a command-line argument string.

	CurVar = hlastrdup2( "" );			// Must be allocated on heap to be freed.
	
	MsgOut = stderr;
	RecordValues = malloc2( sizeofSymNode );

	assert( sizeofSymNode == sizeofYYSTYPE );

	/*
	** Initialize the reserved array so that HLA treats all the
	** reserved words as though they *were* reserved words.
	*/
	
	memset( ReservedWords, 1, sizeof( ReservedWords ));
	

	/*
	** Symbol Table initialization
	*/

	initSymbolTable();

	/*
	** Get the environment variables this program uses
	** (if they are present).
	*/

	hlainc = (char *) getenv( "hlainc" );
	hlaauxinc = (char *) getenv( "hlaauxinc" );
	_if( hlaauxinc == NULL )
	
		hlaauxinc = "";
		
	_endif
	outPath = (char *) getenv( "hlatmp" );
	_if( outPath == NULL )
	
		outPath = "";
		
	_endif
	outPath = hlastrdup( outPath );

	/*
	** Better have at least one command line argument!
	*/

	_if( argc < 2 )
	
		Usage();
		_return 1;

	_endif
	_here;
	

	/*
	** Grab all the command line arguments from the command line
	** and pick up all the filenames, too.
	**
	** Here are the command line arguments we process:
	**
	**	-@				Don't create a linker response file.
	**	-@@				Force creation of new linker response file.
	**	-source			Source code (instructions) output rather than hex values.
	**	-thread			Create thread-safe code and set @thread to true.
	**	-sh				Source output in pseudo-HLA format.
	**	-sm				Source output in MASM format.
	**	-st				Source output in TASM format.
	**  -sf				Source output in FASM format.
	**  -sn				Source output in NASM format.
	**	-sg				Source output in GAS format.
	**	-sx				Source output in Mac OSX GAS format.
	**	-win32			Generate COFF code for Win32 OS.
	**	-linux			Generate ELF code for Linux OS.
	**	-freebsd		Generate ELF code for freeBSD OS.
	**	-macos			Generate Mach-o code for Mac OSX.
	**	-d<sym>			Define a symbol.
	**	-sym			Dump the symbol table.
	**	-v				Verbose output
	**  -p<path>    	Path for temporary files (must have trailing backslash)
	**	-obj<path>		Path for object file output (internal HLA back engine).
	**  -level=high		Enable full HLA language (default)
	**	-level=medium	Medium-level assembly (no HLL control constructs)
	**	-level=low		Low-level assembly (no HL procedure calls/code gen)
	**	-level=machine	Machine instrs only (no exception HLL constructs)
	**  -main:<name>	Name of main program in HLA code.
	**  -license        Display license information
	**	-test			Send output to stdout rather than stderr.
	**	-?				Help
	*/
	
	// First, scan through the arguments for a targetOS specification
	// because that has to be processed before handling any other
	// command-line options.
	
	_for( CurArg = 1, CurArg < argc, ++CurArg )
	
		_if( argv[ CurArg ][0] == '-' )
		
			strcpy( option, argv[ CurArg ] );
			strupr( option );
			_if( _streq( option, "-WIN32" ))
			
				targetOS = windows_os;
				assembler = hlabe;
				useHLABE = 1;
				_break;
				
			_elseif( _streq( option, "-LINUX" ))
			
				targetOS = linux_os;
				assembler = hlabe;
				useHLABE = 1;
				_break;
				
			_elseif( _streq( option, "-FREEBSD" ))
			
				targetOS = freeBSD_os;
				assembler = hlabe;
				useHLABE = 1;
				_break;
				
			_elseif( _streq( option, "-MACOS" ))
			
				targetOS = macOS_os;
				assembler = hlabe;
				useHLABE = 1;
				_break;
				
			_endif
			
		_endif
		
	_endfor
	_here;

	CurArg = 1;
	langLevel = high_level;
	_while( CurArg < argc )

		_if( argv[ CurArg ][ 0 ] == '-' )

			char *s = argv[ CurArg ];

			// Copy the argument and convert it to upper case
			// for comparison purposes.  Also replace any leading
			// "/" character with a "-".

			strcpy( option, s );
			strupr( option );

			// Check for option to disable linker response file:

			_if( _streq( option, "-@" ))

				ResponseFile = 0;


			// Check for option to force creation of new linker response file:

			_elseif( _streq( option, "-@@" ))

				ResponseFile = 2;


			// Check for the -Dxxxx option:

			_elseif( option[1] == 'D' )

				char *NewSymbol;
				char *strValue;
				union YYSTYPE dummy;

				NewSymbol = hlastrdup2(&argv[ CurArg ][2 ] );
				strValue = strchr( NewSymbol, '=');
				_if( strValue == NULL )
				 
					/*
					** Create a boolean symbol with the specified name
					** and initialize it to true.
					*/

					_here;
					ClrConst
					(
						YYS &dummy,
						tBoolean,
						&boolean_ste
					);
					dummy.v.u.boolval = 1;
					InsertSym
					( 
						NewSymbol, 
						&boolean_ste,	/* This is a BOOLEAN object.	*/
						tBoolean,
						cValue, 
						0,				/* Arity						*/
						NULL,			/* Dimensions					*/
						0, 				/* NumElements					*/
						YYS &dummy,		/* Set to TRUE					*/
						1,				/* Object size					*/
						0,				/* Offset						*/
						NULL,			/* Static Name					*/
						NULL,			/* Base							*/
						NULL,			/* Fields						*/
						0				/* FieldCnt						*/
					);
					
				_else // we have -Dsymbol=string

					/*
					** Create a string symbol with the specified name
					** and initialize it to the remainder of the argument
					** following the "=".
					*/

					_here;
					ClrConst
					(
						YYS &dummy,
						tString,
						&string_ste
					);
					dummy.v.u.strval = strValue+1;
					*strValue = '\0';
					InsertSym
					( 
						NewSymbol, 
						&string_ste,	/* This is a STRING object.		*/
						tString,
						cValue, 
						0,				/* Arity						*/
						NULL,			/* Dimensions					*/
						0, 				/* NumElements					*/
						YYS &dummy,		/* Set to TRUE					*/
						1,				/* Object size					*/
						0,				/* Offset						*/
						NULL,			/* Static Name					*/
						NULL,			/* Base							*/
						NULL,			/* Fields						*/
						0				/* FieldCnt						*/
					);
					
				
				_endif


			// Check for the -Pxxxx option:

			_elseif( option[1] == 'P' )

				 outPath = hlastrdup(&argv[ CurArg ][ 2 ] );

			// Check for assembly output options:
			
			_elseif( _streq( option, "-SOURCE" ) )
			
				sourceOutput = 1;

			// Check for thread-safe compilation:
			
			_elseif( _streq( option, "-THREAD" ) )
			
				threadSafe = 1;

			_elseif( _streq( option, "-S" ) )

				// Default, assembler is MASM

				assembler 	= masm;
				useHLABE	= 0;

			_elseif( _streq( option, "-SM" ) )

				// Explicit, assembler is MASM

				assembler 	= masm;
				useHLABE	= 0;

			_elseif( _streq( option, "-SH" ) )

				// Explicit, assembler is pseudo-HLA

				assembler	= hla;
				useHLABE	= 0;

			_elseif( _streq( option, "-ST" ) )

				// Explicit, assembler is TASM

				assembler 	= tasm;
				useHLABE	= 0;


			_elseif( _streq( option, "-SN" ) )

				// Explicit, assembler is NASM

				assembler 	= nasm;
				useHLABE	= 0;


			_elseif( _streq( option, "-SF" ) )

				// Explicit, assembler is FASM

				assembler 	= fasm;				
				useHLABE	= 0;
				


			_elseif( _streq( option, "-SG" ) )

				// Explicit, assembler is Gas

				assembler 	= gas;
				gasSyntax 	= stdGas;
				useHLABE	= 0;
				
			_elseif( _streq( option, "-SX" ) )

				// Explicit, assembler is Gas for Mac OSX

				assembler 	= gas;
				gasSyntax 	= macGas;				
				useHLABE	= 0;
				
			_elseif( _streq( option, "-HLABE" ))
			
				assembler = hlabe;
				useHLABE = 0;		// We want source output
				testMode = 0;
				sourceOutput = 0;


			
			// check for "-main:<name>" here:
			
			_elseif( strncmp( option, "-MAIN:", 6) == 0 )

				mainName = hlastrdup2( &argv[ CurArg ][6] );

			// check for "-obj:<path>" here:
			
			_elseif( strncmp( option, "-OBJ:", 5) == 0 )

				objPath = hlastrdup2( &argv[ CurArg ][5] );

			_elseif( strncmp( option, "-B:", 3) == 0 )

				binName = hlastrdup2( &argv[ CurArg ][3] );

			// Check for symbol table dump option:

			_elseif( _streq( option, "-SYM" ) )

				DumpSymbols = 1;

			// Check for TEST output option:

			_elseif( _streq( option, "-TEST" ) )

				MsgOut 		= stdout;
				testMode 	= 1;
				testMode2 	= 1;

			// Check for LEVEL options

			_elseif( _streq( option, "-LEVEL=HIGH" ) )

				langLevel = high_level;

			_elseif( _streq( option, "-LEVEL=MEDIUM" ) )

				langLevel = medium_level;

			_elseif( _streq( option, "-LEVEL=LOW" ) )

				langLevel = low_level;
				
			_elseif( _streq( option, "-LEVEL=MACHINE" ) )

				langLevel = machine_level;

			// Check for VERBOSE option

			_elseif( _streq( option, "-V" ))

				Verbose = 1;

			// Check for license option:

			_elseif( _streq( option, "-LICENSE" ) )

				License();
				_return 1;
			

			// Check for HELP option:

			_elseif( _streq( option, "-?" ) )

				Usage();
				_return 1;
			
			_elseif
			(
					_streq( option, "-WIN32" )
				||	_streq( option, "-LINUX" )
				||	_streq( option, "-FREEBSD" )
				||	_streq( option, "-MACOS" )
			)
			
				// Already handled these options, ignore them.
				
			_else
			
				fprintf
				(
					MsgOut,
					"Illegal command line option (%s)\n",
					argv[ CurArg ]
				);
				Usage();
				_return 1;
				
			_endif



		/*
		** If the current command line argument doesn't begin with "-" or "/"
		** then assume it is some sort of file name.  Filenames should take
		** one of two different forms:
		**
		**	name		HLA source file with default ".HLA" suffix.
		**	name.hla	HLA source file.
		**
		** Any other suffix is assumed to be a special case of the first
		** case above where "name" just happens to contain one or more
		** periods.
		*/

		_else

			char *name;
			int	 namelen;

			name = hlastrdup( argv[ CurArg ] );
			assert( name != NULL );
			strlwr( name );
			namelen = strlen( name );
			_if( SourceFile != NULL )
			
				yyerror( "Too many filenames supplied on command line" );

			_elseif
			(
					namelen < 4
				||	_strne( name + namelen - 4, ".hla" )
			)

				/*
				** At this point, the filename doesn't end with
				** ".hla", so append ".hla" to it.
				*/

				SourceFile = malloc2( namelen + 5 );
				strcpy( SourceFile, argv[ CurArg ] );
				strcat( SourceFile, ".hla" );

			_else /* we found a good suffix */

				SourceFile = hlastrdup( argv[ CurArg ] );
				assert( SourceFile != NULL );

			_endif
		 
		_endif
		++CurArg;

	_endwhile
	_if( assembler == hlabe )
	
		// Force source output and testMode to false if
		// using the HLA back-end.
		
		sourceOutput = 0;
		testMode = 0;
		
	_endif
	_here;
	
	
	/*
	** Make sure outPath has a trailing directory separator character.
	*/
	
	
	_begin( fixOutPath )
	
		int len;
		char *newPath;
		
		len = strlen( outPath );
		_if( len > 0 && outPath[len-1] != DIR_SEP_CHAR )
		
			newPath = malloc2( len + 2 );
			strcpy( newPath, outPath );
			newPath[len] = DIR_SEP_CHAR;
			newPath[len+1] = '\0';
			free2( vss outPath );
			outPath = newPath;
			
		_endif
		
	_end( fixOutPath )

	/*
	** If verbose mode was specified, echo all the command line
	** values (primarily to test the command line argument processor).
	*/

	_if( Verbose )

		fprintf
		(
			MsgOut,
			"HLA (High Level Assembler) Parser\n"
			"use '-license' to view license information\n"
			"%s\n"
			"%s"
			"%s"
			"File: %s\n"
			"Output Path: \"%s\"\n"
			"hlainc Path: \"%s\"\n"
			"hlaauxinc Path: \"%s\"\n"
			"Compiler generating code for %s OS\n"
			"Back-end assembler: %s%s\n"
			"Language Level: %s\n"
			"\n",
			VersionInformation,
			_ifx( DumpSymbols, "-sym active\n", "" ),
			_ifx( MsgOut == stdout, "-test active\n", "" ),
			SourceFile,
			outPath,
			hlainc,
			hlaauxinc,
			OSChoiceStrs[ targetOS ],
			_ifx( assembler == gas && gasSyntax == macGas, "Mac OSX ", "" ),
			ASMChoiceStrs[assembler],
			_ifx
			(
				langLevel == high_level, "high",
				_ifx
				(
					langLevel == medium_level, "medium",
					_ifx
					(
						langLevel == low_level, "low",
						"machine"
					)
				)
			)
		);


	_endif


	/*
	** If the user didn't specify any filenames, quit at this point.
	*/

	_if( SourceFile == NULL)

		fprintf
		(
			MsgOut,
			"Nothing more to do!\n"
		);
		Usage();
		_return 1;

	_endif
	
	
	/*
	** Set up the ID array based on the language level
	*/
	
	_switch( langLevel )
	
		_case( machine_level )
		
			ReservedWords[ tryTkn  ] = 0;
			ReservedWords[ unprotectedTkn  ] = 0;
			ReservedWords[ exceptionTkn  ] = 0;
			ReservedWords[ anyexceptionTkn  ] = 0;
			ReservedWords[ endtryTkn  ] = 0;
			ReservedWords[ raiseTkn  ] = 0;
				
		_case( low_level )
		
			// Disable medium-level control structures
			// (and high-level procedure calls, which is
			// handled elsewhere).

			ReservedWords[ jfTkn  ] = 0;
			ReservedWords[ jtTkn  ] = 0;
			
			// Disable automatic stack frame generation
			// at low-level and below:
			
			AlignStackDefault = 0;
			FrameDefault = 0;
			DisplayDefault = 0;
			AlignDefault = 0;
			LeaveDefault = 1;
			EnterDefault = 1;
			
		_case( medium_level )
		
			// Disable HLL-like control structures
			// (except exception handling).
		
			ReservedWords[ downtoTkn  ] = 0;
			ReservedWords[ ifTkn  ] = 0;
			ReservedWords[ thenTkn  ] = 0;
			ReservedWords[ elseifTkn  ] = 0;
			ReservedWords[ elseTkn  ] = 0;
			ReservedWords[ endifTkn  ] = 0;

			ReservedWords[ whileTkn  ] = 0;
			ReservedWords[ doTkn  ] = 0;
			ReservedWords[ endwhileTkn  ] = 0;
			ReservedWords[ welseTkn  ] = 0;

			ReservedWords[ repeatTkn  ] = 0;
			ReservedWords[ untilTkn  ] = 0;

			ReservedWords[ forTkn  ] = 0;
			ReservedWords[ foreverTkn  ] = 0;
			ReservedWords[ foreachTkn  ] = 0;
			ReservedWords[ endforTkn  ] = 0;
			ReservedWords[ felseTkn  ] = 0;

			ReservedWords[ breakTkn  ] = 0;
			ReservedWords[ breakifTkn  ] = 0;
			ReservedWords[ continueTkn  ] = 0;
			ReservedWords[ continueifTkn  ] = 0;

			ReservedWords[ exitTkn  ] = 0;
			ReservedWords[ exitifTkn  ] = 0;



		_case( high_level )
		
			// Don't disable anything
			
		_endcase
		
	_endswitch
		
	_here;



	/*
	** Okay, run the HLA compiler on the ".HLA" file.
	*/


	// First, begin by allocating storage to hold the
	// intermediate file data:
	
	
	preambleBuf.size = 16*1024;	// 16K initial allocation.
	preambleBuf.base = malloc2( preambleBuf.size );
	preambleBuf.offset = 0;
	asmBuf = &preambleBuf;
	
	
	codeBuf.size = 4*1024*1024;	// 4MB initial allocation.
	codeBuf.base = malloc2( codeBuf.size );
	codeBuf.offset = 0;
		
	dataBuf.size = 1*1024*1024;	// 1MB initial allocation.
	dataBuf.base = malloc2( dataBuf.size );
	dataBuf.offset = 0;
		
	extBuf.size = 1*1024*1024;	// 1MB initial allocation.
	extBuf.base = malloc2( extBuf.size );
	extBuf.offset = 0;
		
	constBuf.size = 1*1024*1024;	// 1MB initial allocation.
	constBuf.base = malloc2( constBuf.size );
	constBuf.offset = 0;
		
	bssBuf.size = 512*1024;	// 1/2MB initial allocation.
	bssBuf.base = malloc2( bssBuf.size );
	bssBuf.offset = 0;
		
	roBuf.size = 512*1024;	// 1/2MB initial allocation.
	roBuf.base = malloc2( roBuf.size );
	roBuf.offset = 0;
		


	FileName = SourceFile;
	Suffix = strlen( FileName ) - 4;

	_here;
	yyin = fopen( FileName, "r" );
	_if( yyin == NULL )

		fprintf( MsgOut, "Could not open %s\n", SourceFile );
		_return 1;

	_endif
	{
		char *pPathPosn;
		char name[ MAX_PATH+1 ];
		char path[ MAX_PATH+1 ];
		char tempName[ MAX_PATH+1 ];
		char *baseName;
		char *targetName;
		
		// Get the base name of the source file (without the path prefix):
		
		strcpy( tempName, SourceFile );
		_if( (baseName = strrchr( tempName, DIR_SEP_CHAR ))  == NULL )
		
			baseName = tempName-1;
			
		_endif
		++baseName;
		
		// Get a copy of the path prefix:
		
		path[0] = '\0';
		_if( baseName != tempName )
		
			memcpy( path, tempName, baseName-tempName );
			path[ baseName - tempName ] = '\0';
			
		_endif
		
		// Remove the ".hla" suffix:
		
		baseName[ strlen( baseName ) - 4 ] = '\0';
		
		_if( useHLABE )
		
			// If the "-obj:path" option was specified, then
			// write the object file to the specified path:
			
			_if( objPath != NULL )
			
				int len;
			
				len = strlen( objPath );
				_if
				( 
						len != 0 
					&&	objPath[ len-1 ] != DIR_SEP_CHAR
				)
				
					objPath[ len ] = DIR_SEP_CHAR;
					++len;
					objPath[ len ] = '\0';
					
				_endif
				strcpy( name, objPath );
				_if( binName != NULL )	// Use supplied "-b:name" output filename.
				
					strcpy( name+len, binName );
					
				_else	// no -b:name option, so use file's base name:
				
					strcpy( name+len, baseName );
					
				_endif
				
			_else
			
				// If no "-obj:path" option was specified,
				// just use the base file name as the output
				// file.
				
				strcpy( name, path );
				_if( binName != NULL )	// Use supplied "-b:name" output filename.
				
					strcat( name, binName );

				_else	// no -b:name option, so use file's base name:

					strcat( name, baseName );
					
				_endif
				
			_endif
			
			// When using the internal HLA back engine, we're really creating
			// an .obj file, but the common code that follows expects the output
			// filename in the AsmName variable:
			
			strcpy( AsmName, name );

			// As we're generating an object file (using internal HLABE)
			// rather than a ".asm" file, put the appropriate suffix on
			// the "AsmName":
			
			_if( binName == NULL ) 	// -b:name option assumes suffix is present
			
				_switch( targetOS )
				
					_case( windows_os )

						strcat( AsmName, ".obj" );
						
					_endcase
					
					_case( macOS_os )
					_case( freeBSD_os )
					_case( linux_os )
					
						strcat( AsmName, ".o" );
						
					_endcase
					
					_default

						yyerror( "Target OS doesn't support the use of HLABE" );
						strcat( AsmName, ".o" );
						
				_endswitch
				
			_endif
		
			// Okay, the .link file needs to go in the temporary directory,
			// not in the objPath directory:
			
			_if( *outPath != '\0' )
			
				strcpy( LinkName, outPath );		// Start with output path
				
			_else // outPath is the empty string
			
				// If no outPath, then use the path prefix
				// of the original filename.
				
				strcpy( LinkName, path );
				
			_endif
			
			// The .link file also goes in the outPath directory:
			
			strcat( LinkName, baseName );
			strcat( LinkName , ".link" );
			
		_else
		
			// If we're not using the internal HLA back engine, then
			// we're creating an ".asm" file as output and we need to
			// put it in the temp (outPath) directory, if one was specified.
			
			_if( *outPath != '\0' )
			
				strcpy( name, outPath );		// Start with output path
				
			_else // outPath is the empty string
			
				// If no outPath, then use the path prefix
				// of the original filename.
				
				strcpy( name, path );
				
			_endif
			strcat( name, baseName );		// Append the filename.
			strcpy( AsmName, name );
			strcat( AsmName, ".asm" );
			
			// The .link file also goes in the outPath directory:
			
			strcpy( LinkName, name );
			strcat( LinkName , ".link" );
			
		_endif
	}



	_if( Verbose )

		fprintf
		(
			MsgOut,
			"Assembling \"%s\" to \"%s\"\n",
			FileName,
			AsmName
		);
		#if defined( windows_c ) || defined( linux_c )
		
			ftime( &CompileTimeStart );
		
		#endif

	_endif



	/*
	** Okay, process the source file
	*/
	
	_here;
	yyparse();
	_here;
	
	_if( yyerrCount != 0 )
	
		fprintf
		(
			MsgOut,
			"HLAPARSE assembly failed with %d errors\n",
			yyerrCount
		);
		_return yyerrCount;
	
	_endif
	
	
	_if( Verbose )
	
		struct timeb	CompileTime;
		double			milliseconds;
		double			LinesPerSecond;
		
		fprintf
		(
			MsgOut,
			"HLAPARSE assembly complete, %d lines",
			TotalLines
		);
		#if defined( windows_c ) || defined( linux_c )
		
			ftime( &CompileTime );
			milliseconds = 
					CompileTime.millitm - CompileTimeStart.millitm
				+	(CompileTime.time - CompileTimeStart.time) * 1000.0
				+	0.1; // To prevent a division by zero.
				
			LinesPerSecond = (double)((TotalLines * 1000.0)/milliseconds);
			fprintf
			(
				MsgOut,
				", %7.3f seconds, %7.0f lines/second",
				milliseconds/1000.0, 
				LinesPerSecond
			);
			
		#endif
		fprintf( MsgOut, "\n" );
	
	_endif
	

	// Guarantee that source files end with a newline:

	_here;
	asmPuts( "\n" );
	
	
	// If it's a CTL program, no further processing is needed
	
	_if( !wasCTL )
	


		/*
		** Create a linker response file here:
		*/

		_if( ResponseFile >= 2 )
		
			// If we're forcing the creation of a new link file,
			// begin by deleting the old one if it exists.
			
			unlink( LinkName );
			
		_endif
		
		
		_if
		( 
				ResponseFile 
			&&	( wasProgram || (ResponseFile >= 2) ) 
			&& 	(targetOS == windows_os || includeLibList != NULL ))
		
			_if( ResponseFile == 2 || !fexists( LinkName ))

				linkOut = fopen( LinkName, "w" );
				_if( linkOut == NULL )
				
					char msg[256];
					
					sprintf( msg, "Could not create file '%s'", LinkName );
					yyerror( msg );
					exit( 1 );
					
				_endif
				SetSeg( CsegName, csname, ".text" );
				SetSeg( DsegName, dataname, ".data" );
				SetSeg( BssSegName, bssname, ".bss" );
				SetSeg( ROsegName, roname, ".text" );
				SetSeg( StrSegName, constname, ".text" );
				_if( targetOS == windows_os )
				
					fprintf
					(
						linkOut,
						"-heap:0x1000000,0x1000000\n"
						"-stack:0x1000000,0x1000000\n"
						"-base:0x4000000\n"
						"-entry:HLAMain\n"
						"-section:%s,ER\n" 
						"-section:%s,RW\n"
						"-section:%s,RW\n",
						csname,
						dataname,
						bssname
					);
				
					

					// We don't support segments anymore, so the 
					// following is a waste of time:
					
					s = SegmentList;
					assert( s == NULL );
					fprintf
					(
						linkOut,
						"kernel32.lib\n"
						"user32.lib\n"
						"gdi32.lib\n"
					);
					
				_endif
				
				// The following is done for all OSes. Note that
				// for Linux, FreeBSD, and MacOS, the HLA program
				// simply copies the following text to the linker's
				// command line.
				
				_while( includeLibList != NULL )
				
					fprintf
					(
						linkOut,
						"%s\n",
						includeLibList->lib
					);
					includeLibList = includeLibList->next;
					
				_endwhile

				fclose( linkOut );
				
			_endif

		_endif
			

		_here;
		
		// Copy all the data to one buffer (mainly for HLA Back Engine
		// compilation):
		
		
		_begin( outputBuffer )
		
			outputBuf	buffer;
			
			_here;
			extPubIterator( &extBuf );
			_here;
			
			buffer.offset = 0;
			buffer.size =
					preambleBuf.offset
				+	extBuf.offset
				+	codeBuf.offset
				+	dataBuf.offset
				+	roBuf.offset
				+	bssBuf.offset
				+	constBuf.offset
				+	16384;		// For the extra stuff we're going to tack on.

			_here;
			buffer.base = malloc2( buffer.size );
			asmBuf = &buffer;
			
			asmCpy( preambleBuf.base, preambleBuf.offset );
			asmCpy( extBuf.base, extBuf.offset );
			
			EmitSegments( &buffer );
			
			_if( assembler == masm || assembler == tasm )
			
				asmPrintf( "\t\tend\n" );
				
			_elseif( assembler == hlabe )
			
				asmPuts( "\n" hlabe_end "\n" );
					
			_endif
			asmPrintf( "\n" );	

			_if( !useHLABE )
			
				fOut = fopen( AsmName, "w+" );
				_if( fOut == NULL )

					fprintf
					( 
						MsgOut, 
						"Could not open output file '%s'\n%s\n", 
						AsmName,
						strerror( errno )
					);
					_return 1;

				_endif
				fwrite( buffer.base, buffer.offset, 1,  fOut );
				fclose( fOut );
				
			_else
			
				
			
				_if( targetOS == windows_os )
				 
					hlabe_compile
					(
						FileName,
						AsmName, 
						buffer.base, 
						buffer.base + buffer.offset,
						objt_pecoff_c,
						Verbose 
					);
					
				_elseif( targetOS == linux_os )
				 
					hlabe_compile
					(
						FileName,
						AsmName, 
						buffer.base, 
						buffer.base + buffer.offset,
						objt_elfLinux_c,
						Verbose 
					);
					
				
				_elseif( targetOS == freeBSD_os )
				 
					hlabe_compile
					(
						FileName,
						AsmName, 
						buffer.base, 
						buffer.base + buffer.offset,
						objt_elfFreeBSD_c,
						Verbose 
					);
					
				
				_elseif( targetOS == macOS_os )
				
					hlabe_compile
					(
						FileName,
						AsmName, 
						buffer.base, 
						buffer.base + buffer.offset,
						objt_macho_c,
						Verbose 
					);

				_else
				
					fprintf
					( 
						MsgOut, 
						"Unknown target OS (internal HLAPARSE error)\n" 
					);
					_return 1;
					
				_endif
					
			
			_endif
			free2( vss buffer.base );
			free2( vss preambleBuf.base );
			free2( vss codeBuf.base );
			free2( vss dataBuf.base );
			free2( vss roBuf.base );
			free2( vss bssBuf.base );
			free2( vss constBuf.base );
		
		_end( outputBuffer )
		
	_endif // !wasCTL
	fclose( yyin );
	
	_here;

	/*
	** Print the symbol table when we're done.
	*/

	_if( DumpSymbols )
	
		fprintf( MsgOut, "\n\nSymbol Table:\n\n" );
		DumpSym( SymbolTable, 0 );

	_endif


	_here;
	_return yyerrCount;

_end( main )

